<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"Tip: hold down CTRL to select multiple categories" => "Tipp: Strg halten um mehrere Kategorien auszuwählen",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Tipp: Die Checkbox oben deaktivieren um die Kategorien dieser Seite/dieses Objekts zu entfernen",
"from\r\nthe mapfile:" => "aus\r\nder Kartendatei:",
"reply to" => "Antwort an",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\r\nwill not work with old library and conversely" => "WARNUNG: Alte und Neue Tracker können nicht parallel existieren. Tracker die mit der neuen Bibliothek erstellt wurden funktionieren nicht mit der alten Bibliothek und andersherum.",
"Field is public? (for use thru trackerlist plugin)" => "Feld öffentlich? (für Nutzung über das TrackerList-PlugIn)",
"use ...page... to separate pages" => "Benutze ...page... um Seiten in mehrere zu untergliedern",
"cms" => "Artikel",
"Your message has been queued for approval, the message will be posted after\r\na moderator approves it." => "Ihre Nachricht wurde zur Freigabe überreicht. Sie wird angezeigt, sobald sie ein Moderator freigegeben hat.",
"comm" => "Schnittstellen",
"community" => "Community",
"content templates" => "Inhaltsvorlagen",
"drawings" => "Zeichnungen",
"freetags" => "Freetags",
"html pages" => "HTML-Seiten",
"image galleries" => "Bildergalerien",
"maps" => "Karten",
"messu" => "Nachrichten",
"newsletters" => "Rundbriefe",
"sheet" => "Tiki Sheets",
"shoutbox" => "Shoutbox",
"tiki" => "Tiki",
"support" => "Online-Support",
"surveys" => "Umfragen",
"workflow" => "Workflow",
"webmail" => "Webmail",
"Removed version" => "Version gelöscht",
"Renamed" => "Umbenannt",
"Updated" => "Aktualisiert",
"Viewed" => "Angesehen",
"Posted" => "Eingestellt",
"Downloaded" => "Heruntergeladen",
"Admin Mods" => "Mods verwalten",
"File %s uploaded successfully." => "Datei %s erfolgreich hochgeladen.",
"usernames separated with ;" => "Benutzernamen, getrennt mit Semikolon (;)",
"uploaded by" => "hochgeladen von",
"not specified" => "nicht definiert",
"The file you are trying to upload is too big." => "Die Datei, die du hochladen mouml;chtest ist zu groß.",
"Invalid remote file on url %s" => "Ungültige Datei unter %s",
"%A %d of %B, %Y" => "%A %d im %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d im %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d im %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d im %b, %Y[%H:%M %Z]",
"delete" => "löschen",
"post" => "Eintrag",
"stop monitoring this blog" => "diesen Blog nicht mehr beobachten",
"posts" => "Einträge",
"visits" => "Besuche",
"show categories" => "Kategorien zeigen",
"author" => "Autor",
"user level" => "Benutzerlevel",
"send email to user" => "eMail an Benutzer schicken",
"score" => "Bewertung",
"delete selected" => "markierte löschen",
"move" => "verschieben",
"Posted messages" => "gepostete Beiträge",
"set" => "Ok",
"replies" => "Antworten",
"new reply" => "neue Antwort",
"cancel" => "abbrechen",
"up" => "rauf",
"down" => "runter",
"add" => "hinzufügen",
"stop monitoring this map" => "diese Karte nicht mehr beobachten",
"create" => "hinzufügen",
"save" => "Speichern",
"send" => "verschicken",
"Hide module contents" => "Modul auf-/zuklappen",
"Last visitors" => "Letzte Besucher",
"register" => "Registrieren",
"standard" => "Standard",
"secure" => "sicher",
"stay in ssl mode" => "In SSL-Modus bleiben",
"go" => "los",
"cache" => "Cache",
"use" => "benutzen",
"cached" => "gecached",
"refresh" => "aktualisieren",
"print" => "drucken",
"create pdf" => "PDF erstellen",
"monitor this page" => "diese Seite beobachten",
"stop monitoring this page" => "diese Seite nicht mehr beobachten",
"backlinks" => "Verweise",
"rename" => "umbenennen",
"unlock" => "entsperren",
"lock" => "sperren",
"perms" => "Berecht.",
"history" => "Historie",
"similar" => "ähnlich",
"undo" => "rückgängig",
"slides" => "Dias",
"export" => "exportieren",
"discuss" => "diskutieren",
"add comment" => "kommentieren",
"attach file" => "Datei anhängen",
"translation" => "Übersetzung",
"last modification" => "letzte Änderung",
"attachments" => "Anhänge",
"stats" => "Statistiken",
"last changes" => "zuletzt geändert",
"list pages" => "Seiten auflisten",
"back to homepage" => "Zurück zur Startseite",
"cancel edit" => "Bearbeitung verwerfen",
"No attachments for this page" => "Keine Anhänge für diese Seite",
"view blog" => "Blog betrachten",
"list blogs" => "Blogs auflisten",
"save and exit" => "Speichern und verlassen",
"reads" => "Zugriffe",
"view comments" => "Kommentare ansehen",
"Click here to create it" => "Zum Anlegen hier klicken",
"wiki help" => "Wiki Hilfe",
"General preferences" => "Allgemeine Einstellungen",
"Other preferences" => "Sonstige Einstellungen",
"flag" => "Kennzeichen",
"Change information" => "Einstellungen übernehmen",
"ok" => "OK",
"Best language" => "Beste Sprache",
"PodCast directory (must be web accessable):" => "PodCast Verzeichnis (muß per Browser erreichbar sein):",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload filed in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird muß ein vom Webserver lesbares Verzeichnis benutzt werden (am besten außerhalb des Webspace). Dorthin müssen die Dateien dann mit scp, ftp o.ä. übertragen werden.",
"Enable cache images to all galleries" => "Bildercache für alle Galerien aktivieren",
"Images cache directory" => "Bildercache-Verzeichnis",
"images" => "Bilder",
"Report PHP errors only for admin" => "Alle PHP Fehler nur für Admin ausgeben",
"Server name (for absolute URIs)" => "Servername (für absolute URIs)",
"Automatic (uses HTTPS variable)" => "Automatisch (benutzt HTTPS Variable)",
"Wiki_Tiki_Title" => "Wiki_Tiki_Titel",
"path" => "Pfad",
"Admin->Features" => "Admin->Funktionen",
"must be turned on and notification is sent to the admin's" => "muß aktiviert sein, Nachrichten an Admin geht an seine",
"inter-user message inbox" => "Tiki Mailbox",
"Validate email address (may not work)" => "eMail-Adresse überprüfen (funktioniert evtl. nicht)",
"Require HTTP Basic authentication" => "HTTP-Basic-Authentication notwendig",
"HTTP server name" => "HTTP-Servername",
"HTTP URL prefix" => "HTTP-URL-Präfix",
"HTTPS server name" => "HTTPS-Servername",
"HTTPS URL prefix" => "HTTPS-URL-Präfix",
"Only for users" => "Nur für Benutzer",
"Users and admins" => "Benutzer und Admins",
"Full Text Search" => "Volltextsuche",
"Database independant search or Tiki search" => "Unabhängige Datenbanksuche oder Tiki Suche",
"Don't forget: to use feature you will need to enable it on" => "Hinweis: Um dieses Feature zu nutzen, aktivieren Sie es unter",
"Custom Code" => "Angepasster Code",
"Site breadcrumbs" => "Site Breadcrumbs",
"Site search bar" => "Balken für Site Suche",
"Site logo" => "Site-Logo",
"Site logo source" => "Site Logo Quelle",
"Site ads and banners" => "Site Werbung und Banner",
"Site Menu" => "Site Menü",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Hinweis: Um dieses Feature verwenden zu können, müssen PHPLayer unter Admin->Funkionen",
"Manage attachment preferences" => "Einstellungen für Anhänge verwalten",
"HTML in Wiki Pages" => "HTML in Wiki Seiten",
"Wiki syntax used when a page contains HTML" => "Wiki Syntax benutzen wenn Seite HTML enthält",
"full" => "voll",
"partial" => "teilweise",
"Enable Feature" => "Funktion einschalten",
"loc" => "Ort",
"participants" => "Teilnehmer",
"cat" => "Kateg.",
"lang" => "Sprache",
"prio" => "Prio",
"subscription" => "Abonnement",
"permissions" => "Berechtigungen",
"admin categories" => "Kategorien verwalten",
"create new" => "erstelle neu",
"edit chart" => "Hitliste bearbeiten",
"update" => "aktualisieren",
"admin content templates" => "Inhaltsvorlagen verwalten",
"use in cms" => "Im CMS benutzen",
"use in wiki" => "In Wikis benutzen",
"use in newsletters" => "In Rundbrief benutzen",
"use in HTML pages" => "In HTML-Seiten benutzen",
"last modif" => "letzte Änderung",
"sections" => "Bereiche",
"admin FortuneCookie" => "Sprüche verwalten",
"upload" => "Hochladen",
"dsn" => "DSN",
"Edit existing forums" => "Vorhandene Foren bearbeiten",
"topics" => "Themen",
"coms" => "Kommentare",
"age" => "Alter",
"ppd" => "PPT",
"last post" => "Neuester Eintrag",
"admin hotwords" => "Hotwords verwalten",
"list repositories" => "Repositories auflisten",
"new repository" => "Neues Repository",
"view repository" => "Repository anschauen",
"view this repository" => "Repository ansehen",
"new rule" => "neue Regeln",
"admin featured links" => "Linktips verwalten",
"position" => "Position",
"admin Webmail" => "Webmail verwalten",
"section" => "Bereich",
"sorted section" => "Sortierter Bereich",
"options" => "Optionen",
"admin modules" => "Module verwalten",
"assign module" => "Modul zuweisen",
"left modules" => "Module links",
"right modules" => "Module rechts",
"edit/create" => "hinzufügen/bearbeiten",
"clear cache" => "Cache leeren",
"assign" => "zuweisen",
"left" => "links",
"right" => "rechts",
"order" => "Reihenfolge",
"parameters" => "Parameter",
"create/edit" => "hinzufügen/bearbeiten",
"use poll" => "Abstimmung benutzen",
"use gallery" => "Galerie benutzen",
"use dynamic  content" => "Dynamischen Inhaltsblock benutzen",
"use rss module" => "RSS-Modul benutzen",
"use menu" => "Menü benutzen",
"use phplayermenu" => "PHPLayerMenü benutzen",
"use banner zone" => "Bannerzone benutzen",
"list newsletters" => "Rundbriefe auflisten",
"admin newsletters" => "Rundbriefe verwalten",
"send newsletters" => "Rundbrief versenden",
"editions" => "Ausgaben",
"last sent" => "zuletzt gesendet",
"send newsletter" => "Rundbrief versenden",
"admin Email Notifications" => "eMail-Benachrichtigungen verwalten",
"use admin email" => "Admin eMail benutzen",
"event" => "Termin",
"admin polls" => "Abstimmungen verwalten",
"admin QuickTags" => "QuickTags verwalten",
"label" => "Beschriftung",
"admin RSS Modules" => "RSS-Module verwalten",
"admin shoutbox words" => "Shoutbox Words Verwaltung",
"export pages" => "Seiten exportieren",
"dump tree" => "Baum ausgeben",
"create webhelp" => "Web-Hilfe erstellen",
"tree" => "Baum",
"create new structure" => "neue Struktur anlegen",
"survey stats" => "Umfragen-Statistik",
"edit this survey" => "Diese Umfrage bearbeiten",
"admin surveys" => "Umfragen verwalten",
"list surveys" => "Umfragen auflisten",
"questions" => "Fragen",
"files" => "Dateien",
"advanced feature" => "Fortgeschrittene Funktion",
"Edit fields for tracker" => "Felder bearbeiten von Tracker",
"items" => "Einträge",
"The tracker needs a text field named Subject" => "Der Tracker muß ein Eingabefeld 'Subject' besitzen (auch für RSS Feed nötig)",
"version" => "Version",
"admin groups" => "Gruppen verwalten",
"assign permissions" => "Berechtigungen vergeben",
"admin" => "Verwalten",
"admin users" => "Benutzer verwalten",
"more criteria" => "Erweiterte Suchoptionen",
"assign to groups" => "zu Gruppen hinzufügen",
"all" => "alle",
"Assign user" => "Benutzer zuweisen",
"Available groups" => "Verfügbare Gruppen",
"assign perms to this group" => "dieser Gruppe Rechte zuweisen",
"admin backups" => "Backups verwalten",
"List of available backups" => "Liste der verfügbaren Backups",
"Restoring a backup" => "Einen Backup wiederherstellen",
"Warning!" => "Warnung!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Das Wiederherstellen eines Backups zertört alle bisherigen Daten in Ihrer Tiki Datenbank. Die Information in allen Tabellen wird durch das Backup ersetzt.",
"Click here to confirm restoring" => "Hier klicken, um den Start der Wiederherstellung zu bestätigen",
"Create new backup" => "Neues Backup anlegen",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Das Erstellen von Backups kann lange Zeit dauern. Falls der Prozess nicht abgeschlossen werden kann werden Sie einen blanken Bildschirm sehen. Falls dies der Fall ist müssen Sie den Parameter 'maximum script execution time' in Ihrer php.ini Datei erhöhen",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Sollten Anhänge aus dem Forum im Verzeichnis gespeichert sein, müssen diese per FTP oder SCP gesichert werden.",
"Upload a backup" => "Ein Backup hochladen",
"Upload backup" => "Backup hochladen",
"remove file extension from image name" => "Dateiendung im Namensfeld entfernen",
"convert sub directories to sub galleries" => "Unterverzeichnisse in Unter-Galerien konvertieren",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "z.B. wird bei \"misc/screenshots/digicam0001.jpg\" das Bild in die Galerie screenshots gesteckt",
"use sub directory names as description" => "Namen von Unterverzeichnissen als Beschreibung verwenden",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "z.B. wird von \"misc/screenshots/digicam0001.jpg\" der Text misc/screenshots als Beschreibung benutzt",
"admin category" => "Kategorien verwalten",
"list galleries" => "Galerien auflisten",
"edit gallery" => "Galerie bearbeiten",
"rebuild thumbnails" => "Thumbnails neu erzeugen",
"upload image" => "Bild hochladen",
"list gallery" => "Galerie als Liste zeigen",
"hit" => "Treffer",
"original size" => "Originalgröße",
"return to gallery" => "zurück zur Galerie",
"edit image" => "Bild bearbeiten",
"smaller" => "kleiner",
"bigger" => "größer",
"prev image" => "vorh. Bild",
"popup window" => "Popup-Fenster",
"next image" => "näch. Bild",
"slideshow forward" => "Diaschau vorwärts",
"stop" => "Anhalten",
"imagescale" => "Bildskalierung",
"add item" => "Eintrag hinzufügen",
"Subscription List" => "Empfängerliste",
"or create a new category" => "oder neue Kategorie anlegen",
"or create a new location" => "oder neuen Ort eintragen",
"comma separated usernames" => "Usernamen durch Komma getrennt",
"comma separated username:role" => "Komma getrennte Liste 'Teilnehmer:Rolle'",
"with roles" => "mit den Rollen",
"Chair" => "Leiter",
"save_to" => "in",
"permission" => "Berechtigung",
"remove from this category &amp; all its children" => "von dieser und allen Unterkategorien entfernen",
"remove from this category only" => "nur von dieser Kategorie entfernen",
"remove page" => "Seite entf.",
"browse" => "im Verzeichnis stöbern",
"related" => "verwandt",
"validate" => "überprüfen",
"add a site" => "Link hinzufügen",
"add a category" => "Kategorie hinzufügen",
"search" => "Suche",
"list articles" => "Beiträge auflisten",
"view articles" => "Beiträge ansehen",
"create zone" => "Zone hinzufügen",
"save the banner" => "das Banner speichern",
"Allow trackback pings" => "Trackback-Pings erlauben",
"try" => "ausprobieren",
"display" => "anzeigen",
"admin quicktags" => "Quicktags verwalten",
"create new block" => "Neuen Block erzeugen",
"list quizzes" => "Quiz auflisten",
"quiz stats" => "Quiz-Statistik",
"edit this quiz" => "Dieses Quiz bearbeiten",
"admin quizzes" => "Quiz verwalten",
"results" => "Ergebnisse",
"create page" => "Seite erstellen",
"list submissions" => "Einreichungen auflisten",
"save only in the theme:" => "Nur für diesen Style speichern:",
"add to the set" => "zur Liste hinzufügen",
"Search " => "Suche",
"replace" => "ersetzen",
"Admin ephemerides" => "Terminkalender verwalten",
"All ephemerides" => "Alle Termine",
"new question" => "Neue Frage",
"approve" => "akzeptieren",
"configure listing" => "Liste konfigurieren",
"create new file gallery" => "neues Dateiarchiv anlegen",
"topic" => "Thema",
"save and approve" => "speichern und freigeben",
"new topic" => "neues Thema",
"accept" => "akzeptieren",
"refuse" => "ablehnen",
"add new" => "Neu hinzufügen",
"add role" => "Rolle hinzufügen",
"admin processes" => "Prozesse verwalten",
"admin activities" => "Aktivitäten verwalten",
"admin roles" => "Rollen verwalten",
"edit this process" => "Prozess bearbeiten",
"monitor" => "Überwachen",
"create new gallery" => "neue Galerie anlegen",
"result" => "Ergebnis",
"reload" => "Aktualisieren",
"edit repository" => "Repository bearbeiten",
"source" => "Quellcode",
"edit new article" => "neuen Artikel erstellen",
"admin Banners" => "Banner verwalten",
"create new blog" => "Neuen Blog anlegen",
"admin cache" => "Cache verwalten",
"upload file" => "Datei hochladen",
"Edit a file using this form" => "Datei über dieses Formular bearbeiten",
"delete selected files" => "markierte Dateien löschen",
"browse gallery" => "Galerie anzeigen",
"Flash binary (.sqf or .dcr)" => "Flash Binary (.sqf oder .dcr)",
"edit blog" => "Blog bearbeiten",
"edit new submission" => "neue Einreichung bearbeiten",
"actions" => "Aktionen",
"set as operator" => "Als Operator hinzufügen",
"add topic" => "Thema hinzufügen",
"install" => "installieren",
"back" => "zurück",
"Assign permissions to page" => "Berechtigungen für Seite vergeben",
"These permissions override any global permissions affecting this object. To edit global permissions " => "Diese Berechtigungen überschreiben alle globalen Berechtigungen, die auf dieses Objekt wirken. Zum Ändern der globalen Berechtigungen ",
"Current permissions for this page" => "Aktuelle Berechtigungen für diese Seite",
"remove from this page" => "aus dieser Seite entfernen",
"remove from this structure" => "aus dieser Struktur entfernen",
"No individual permissions; category or global permissions apply" => "Keine individuellen Berechtigungen; Kategorie oder globale Berechtigungen vergeben",
"this page" => "diese Seite",
"this structure" => "diese Struktur",
"Current permissions for categories that this page belongs to" => "Diese Seite gehört zu den Kategorien mit folgenden Berechtigungen",
"Send email notifications when this page changes to" => "eMail-Benachrichtigung bei Seitenänderung verschicken an",
"add email" => "eMail hinzufügen",
"Notifications" => "Benachrichtigungen",
"clear stats" => "Statistiken zurücksetzen",
"Edit received page" => "Empfangene Seite bearbeiten",
"last" => "letzte",
"send me my password" => "Mein Paßwort senden",
"searched" => "gesucht",
"galleries" => "Galerien",
"blog posts" => "Blog-Einträge",
"wiki pages" => "Wiki-Seiten",
"site" => "Site",
"clear" => "zurücksetzen",
"add article" => "Artikel hinzufügen",
"admin Tiki Shoutbox" => "Tiki-Shoutbox verwalten",
"list view" => "Listenansicht",
"send answers" => "Antworten senden",
"move to right column" => "in die rechte Spalte verschieben",
"unassign" => "Zuordnung aufheben",
"move to left column" => "in die linke Spalte verschieben",
"remove folder" => "Ordner löschen",
"refresh cache" => "Cache aktualisieren",
"use google map locator" => "Google Map Locator benutzen",
"admin mode" => "Verwaltungsmodus",
"trash" => "in Papierkorb",
"empty trash" => "Papierkorb löschen",
"remove from trash" => "aus dem Papierkorb",
"use start date and time" => "Startdatum/-zeit benutzen",
"use end date and time" => "Endedatum/-zeit benutzen",
"no comments" => "keine Kommentare",
"edit items" => "Einträge bearbeiten",
"list charts" => "Hitlisten anzeigen",
"last chart" => "neueste Hitliste",
"item" => "Eintrag",
"view faq" => "FAQ anzeigen",
"add suggestion" => "Vorschlag hinzufügen",
"monitor this forum" => "Dieses Forum beobachten",
"stop monitoring this forum" => "Beobachten dieses Forums beenden",
"delete selected topics" => "Ausgewählte Themen löschen",
"stop monitoring this topic" => "Beobachtung dieses Themas beenden",
"Comments below your current threshold" => "Kommentar unterhalb Ihres aktuellen Schwellenwerts",
"list attachments" => "Anhänge auflisten",
"add contacts" => "Kontakte hinzufügen",
"DATE-of" => "im",
"You cannot edit this page because it is a user personal page" => "Sie können diese Seite nicht bearbeiten, da es sich um eine persönliche Benutzer-Seite handelt.",
"Permission denied you cannot assign permissions for this page" => "Zugriff verweigert. Sie können dieser Seite keine Berechtigungen zuweisen",
"You do not have permission to edit messages" => "Sie haben keine Berechtigung, diese Nachrichten zu bearbeiten",
"Cannot read file" => "Kann Datei nicht lesen",
"Permission denied you cannot upload files" => "Berechtigung zum Hochladen von Dateien nicht vorhanden",
"cannot process upload" => "Kann Upload nicht verarbeiten",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Ihre Mail-Adresse wurde von der Liste der Adressen, die diesen Tracker überwachen entfernt",
"Your email address has been added to the list of addresses monitoring this tracker" => "Ihre Mail-Adresse wurde zu der Liste der Adressen, die diesen Tracker überwachen hinzugefügt",
"Cancel monitoring" => "Überwachung beenden",
"Your email address has been removed from the list of addresses monitoring this item" => "Ihre Adresse wurde aus der Liste derer entfernt, die diesen Eintrag beobachten",
"Your email address has been added to the list of addresses monitoring this item" => "Ihre Adresse wurde zu denen hinzugefügt, die diesen Eintrag beobachten",
"new image uploaded by" => "neue Bilder hochgeladen von",
"new subscriptions" => "neue Abonnenten",
"new item in tracker" => "Neuer Eintrag im Tracker",
"show" => "zeigen",
"hide" => "verstecken",
"message" => "Nachricht",
"Include an article" => "Artikel einbinden",
"select all" => "alle auswählen",
"filter" => "filtern",
"no such file" => "Datei nicht gefunden",
"downloads" => "Downloads",
"attach" => "anhängen",
"monitor this blog" => "diesen Blog beobachten",
"hide categories" => "Kategorien verbergen",
"Admin categories" => "Kategorien verwalten",
"browse category" => "Kategorien durchstöbern",
"reply" => "antworten",
"monitor this topic" => "Thema beobachten",
"with checked" => "markierte",
"move selected files" => "markierte Dateien verschieben",
"Thank you for you registration. You may log in now." => "Vielen Dank für die Registrierung. Sie können sich jetzt anmelden.",
"compare" => "vergleichen",
"diff" => "Diff",
"sender" => "Absender",
"subject" => "Betreff",
"date" => "Datum",
"flagged" => "gekennzeichnet",
"mark" => "setzen",
"find replied message" => "suche beantwortete Nachricht",
"Click the :: options in the Menu for more options." => "",
"Please, also see" => "Bitte auch",
"for more setup details." => "für weitere Konfigurationsdetails anschauen.",
"Note 1:" => "Hinweis 1:",
"You can remove this module in" => "Entfernen dieses Moduls über",
"as well as assign or edit many others." => "wo auch andere Module zugewiesen oder erstellt werden können.",
"Note 2:" => "Hinweis 2:",
"The menu module installed by default is named" => "Das Modul mit den Standard Menüs heißt",
"it is a \"custom module\" which includes menu ID " => "es ist ein \"editierbares Modul\", es enthält das Menü mit der ID ",
"That menu is stored in database and it can be edited from " => "Das Menü ist in der Datenbank gespeichert und kann geändert werden über ",
"Do not mix this with the original <em>application_menu</em> module" => "Bitte nicht verwechseln mit dem <em>application_menu</em> Modul",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Letzteres kann an eigene Styles etc. angepaßt werden, dafür muß aber die Datei mod-application_menu.tpl von Hand geändert werden.",
"del" => "löschen",
"Create pdf" => "PDF erstellen",
"pdf" => "PDF",
"1 file attached" => "1 angehängte Datei",
"Click" => "Klick",
"categories" => "Kategorien",
"List pages where I am a creator" => "Seiten auflisten, die ich erstellt habe",
"by creator" => "nach Ersteller",
"by modificator" => "nach Bearbeiter",
"at tracker" => "Bei Tracker",
"posted by" => "eingetragen von",
"email this post" => "Diesen Beitrag verschicken",
"calendar view" => "Kalenderansicht",
"check / uncheck all" => "alle (ent)markieren",
"Mandatory category in the category tree" => "Pflichtkategorie im Kategorieverzeichnis",
"Tiki sections and features" => "Tiki-Bereiche und Funktionen",
"tikiwiki.org help" => "tikiwiki.org Hilfe",
"Site Logo and Identity" => "Site-Logo und Identität",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Quote PlugIn statt festes &ldquo;>&rdquo; beim Quoten verwenden",
"Storing files in a directory" => "Speichern von Dateien in einem Verzeichnis",
"please read" => "Bitte lesen! (klick mich)",
"yes" => "ja",
"Click here for more details." => "Für weitere Details hier klicken.",
"Best Language" => "Beste Sprache",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "Die Tiki Einstellungen beschränken die max. Zeichenlänge standardmäßig auf 250. Die trifft auch auf angepassten Code zu. Um mehr Zeichen zuzulassen, setzen Sie hier den Haken (Erstellen Sie vorher ein Backup Ihrer Datenbank!).",
"Users &amp; groups" => "Benutzer &amp; Gruppen",
"private" => "privat",
"<b>Item</b>" => "<b>Eintrag</b>",
"<b>Value</b>" => "<b>Wert</b>",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki erstellt und exportiert werden. Zum Einlesen/Importieren von RSS Feeds \"RSS Module\" im Menü wählen oder",
"<b>Feed</b>" => "<strong>Feed</strong>",
"<b>enable/disable</b>" => "<strong>ein/aus</strong>",
"<b>Max number of items</b>" => "<strong>Max. Anzahl<br>Einträge</strong>",
"Feed for Articles" => "Feed für Artikel",
"Feed for Weblogs" => "Feed für Blogs",
"Feed for Image Galleries" => "Feed für Bildergalerien",
"Feed for File Galleries" => "Feed für Dateiarchive",
"Feed for the Wiki" => "Feed für Wiki-Seiten",
"Feed for individual Image Galleries" => "Feed für einzelne Bildergalerie",
"Feed for individual File Galleries" => "Feed für einzelnes Dateiarchiv",
"Feed for individual weblogs" => "Feed für einzelnen Blog",
"Feed for individual forums" => "Feed für einzelnes Forum",
"Feed for mapfiles" => "Feed für Kartendateien",
"Feed for directories" => "Feed für Verzeichnisse",
"Feed for individual tracker items" => "Feed für einzelne Tracker-Einträge",
"Feed for tracker items" => "Feed für Tracker-Einträge",
"Feed for upcoming calendar events" => "Feed für zukünftige Events",
"Caching time :" => "RSS Daten im Cache halten",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Caching sollte nur für Inhalte aktiviert werden, die vollständig freigegeben sind, es könnten sonst private Dokumente verteilt werden. Bei Nutzung des Cache greifen die Rechteabfragen nicht.",
"Prefix breadcrumbs with 'Location:' label?" => "Präfixe Breadcrumbs mit 'Position:'?",
"Site Search" => "Site Suche",
"Change style only" => "nur Style ändern",
"Tag name" => "Tag Name",
"Anonymous editors must input anti-bot code" => "Anonyme Autoren müssen Anti-Robot Code eingeben",
"PDF generation" => "PDF-Erstellung",
"Edit idle timeout" => "Bearbeiten Idle-Timeout",
"Use page description" => "Seitenbeschreibung benutzen",
"Show page title" => "Seitentitel anzeigen",
"Show page ID" => "Seiten-ID anzeigen",
"Users can lock pages (if perm)" => "Benutzer kann Seiten sperren (falls berechtigt)",
"Use WikiWords" => "WikiWords benutzen",
"Use Wiki paragraph formatting" => "Wiki Absatzformatierung benutzen",
"Use external link icons" => "Symbole für externe Links benutzen",
"User's Page" => "Benutzerseite 'UserPageNAME'",
"UserPage prefix" => "UserPage Prefix",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Beim betrachten einer Seite, welche nicht existiert aber eine ähnliche existiert, automatisch dahin umleiten",
"Show/hide heading icon displayed before the heading" => "Zeige/Verberge Überschriftsicon vor der Überschrift",
"Print Page" => "Seite ausdrucken",
"Maximum number of versions for history" => "Maximale Anzahl der Versionen in Historie",
"Never delete versions younger than days" => "Niemals löschen: Versionen jünger als",
"IP not displayed in history" => "IP nicht in der History anzeigen",
"Diff style" => "Vergleichs-Typ",
"Statistic" => "Statistik",
"Use in CMS" => "Im CMS benutzen",
"Use in Wiki" => "In Wikis benutzen",
"Use in newsletters" => "In Rundbriefen benutzen",
"Use in HTML pages" => "In HTML-Seiten benutzen",
"Edit Existing Forums" => "Vorhandene Foren bearbeiten",
"Refresh rate (if dynamic) [secs]" => "Aktualisierungsrate (falls dynamisch) [Sek.]",
"configure repositories" => "Repositories konfigurieren",
"configure this repository" => "dieses Repository konfigurieren",
"copy rules" => "Regeln kopieren",
"Create/edit newsletters" => "Rundbriefe hinzufügen/bearbeiten",
"subscriptions" => "Abonnements",
"archives" => "Archive",
"Use Admin Email" => "Admin eMail benutzen",
"Edit or add poll options" => "Abstimmungsoptionen hinzufügen/bearbeiten",
"Create/edit Polls" => "Abstimmungen hinzufügen/bearbeiten",
"Rss channels" => "RSS Kanäle",
"show pubdate" => "Datum anzeigen",
"activate" => "Aktivieren",
"Admin tracker" => "Tracker verwalten",
"Edit this tracker" => "Diesen Tracker bearbeiten",
"View this tracker items" => "Einträge dieses Trackers ansehen",
"Edit tracker fields" => "Tracker-Felder bearbeiten",
"Import/export trackers fields" => "Tracker-Felder importieren/exportieren",
"Create trackers" => "Tracker anlegen",
"Import/export" => "Import/Export",
"fields" => "Felder",
"Create/edit trackers" => "Tracker hinzufügen/bearbeiten",
"filename" => "Dateiname",
"filesize" => "Dateigröße",
"filetype" => "Dateityp",
"longdesc" => "Beschreibung",
"Add a new group" => "Eine neue Gruppe hinzufügen",
"Edit item" => "Punkt bearbeiten",
"List all members" => "Alle Mitglieder auflisten",
"Add a new user" => "Neuen Benutzer hinzufügen",
"manage group assignments" => "Gruppenzuordnungen bearbeiten",
"set default groups" => "Standardgruppen setzen",
"watch only this category" => "Nur diese Kategorie beobachten",
"watch this category and their descendants" => "Diese Kategorien und deren Nachfolger beobachten",
"stop watching only this category" => "Nur diese Kategorie nicht mehr beobachten",
"stop watching this category and their descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Popup Window" => "Popup-Fenster",
"details" => "Details",
"zoom" => "Zoomen",
"change focus" => "hierher wechseln",
"quarter" => "Vierteljahr",
"semester" => "Halbjahr",
"No individual permissions global permissions apply" => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Welcome to the Tiki Chat Rooms" => "Willkommen bei den Tiki Chaträumen",
"Please select a chat channel" => "Bitte einen Chatraum auswählen",
"enter chat room" => "Chatraum betreten",
"There are no channels setup, please contact a site admin" => "Es sind keine Chaträume eingerichtet, bitte den Admin kontaktieren.",
"Chatroom" => "Chatraum",
"Active Channels" => "Aktive ",
"Users in this channel" => "Benutzer in diesem Kanal",
"Channel Information" => "Channel-Informationen",
"Use :nickname:message for private messages" => "Benutzen Sie :nickname:Nachricht für private Nachrichten",
"Use [URL|description] or [URL] for links" => "Benutzen Sie [URL|Beschreibung] oder [URL] für Links",
"Use (:smileyname:) for smileys" => "(:smileyname:) für Smileys",
"Create PDF" => "PDF erstellen",
"PDF Settings" => "PDF Einstellungen",
"Keep screen pixel/point ratio" => "Pixel und Punkt Verhältnis nicht ändern",
"Render images" => "Bilder rendern",
"Render hyperlinks" => "Hyperlinks rendern",
"Left Margin (mm)" => "Linker Abstand (mm)",
"Right Margin (mm)" => "Rechter Abstand (mm)",
"Top Margin (mm)" => "Oberer Abstand (mm)",
"Bottom Margin (mm)" => "Unterer Abstand (mm)",
"Show page border" => "Seitenrand anzeigen",
"PDF compatilbility level" => "PDF Kompatibilität",
"Select Wiki Pages" => "Wiki-Seiten auswählen",
"Remove Page" => "Seite entf.",
"click here to send us an email" => "Hier klicken um uns eine eMail zu schicken",
"Add or edit a site" => "Link hinzufügen/bearbeiten",
"sites" => "Links",
"cool sites" => "Coole Links",
"Use ...page... to separate pages in a multi-page article" => "Benutze ...page... um Seiten in einen mehrseitigen Artikel aufzuteilen",
"Create Zone" => "Zone hinzufügen",
"browse image" => "Bild betrachten",
"translate" => "übersetzen",
"Create or edit content" => "Inhalt hinzufügen/bearbeiten",
"this quiz stats" => "Statistik für dieses Quiz",
"answer" => "Antwort",
"Edit Translation:" => "Übersetzungs-Einstellungen:",
"Set of Translations" => "Vorhandene Übersetzungen",
"Select the article for which the current article is the translation." => "Artikel auswählen, vom dem dieser hier die Übersetzung ist",
"Translation of:" => "Übersetzung von:",
"Add to the Set" => "Zur Liste hinzufügen",
"graph" => "Graph",
"Edit FAQ questions" => "FAQ-Fragen bearbeiten",
"Edit this file gallery:" => "Dieses Dateiarchiv bearbeiten:",
"icon" => "Symbol",
"Other users can upload files to this gallery" => "Andere Benutzer können Dateien hochladen",
"Available File Galleries" => "Verfügbare Dateiarchive",
"start" => "Beginn",
"end" => "Ende",
"roles" => "Rollen",
"Add role" => "Rolle hinzufügen",
"active process" => "aktiver Prozess",
"invalid" => "ungültig",
"invalid process" => "ungültiger Prozess",
"valid process" => "gültiger Prozess",
"activities" => "Aktivitäten",
"aborted" => "abgebrochen",
"value" => "Wert",
"proc" => "Prozesse",
"exceptions" => "Fehler",
"rollback" => "Rollback",
"Create or edit content block" => "Content-Block hinzufügen/bearbeiten",
"Old vers" => "Alte Version",
"Listing Gallery" => "Liste Galerie auf",
"Gallery Files" => "Archiv-Dateien",
"Last ver" => "letzte Ver.",
"Com" => "Kommentar",
"Vers" => "Ver.",
"Add or edit event" => "Termin hinzufügen/bearbeiten",
"Subscribe to newsletter" => "Rundbrief abonnieren",
"Add or edit a news server" => "Newsserver hinzufügen/bearbeiten",
"merge selected notes into" => "Notizen verschmelzen mit",
"Print Wiki Pages" => "Wiki-Seiten drucken",
"add page" => "Seite hinzufügen",
"entire site" => "Ganze Site",
"click to navigate" => "zum Navigieren anklicken",
"Total threads" => "Threads gesamt",
"Average threads per topic" => "Durchschn. Threads pro Thema",
"Faq Stats" => "FAQ-Statistik",
"clean" => "löschen",
"You can include the file in an HTML/Tiki page using" => "Sie können die Datei in eine HTML-/Tiki-Seite einfügen mit",
"Now enter the file URL" => "Nun Datei-URL eingeben",
" or upload a local file from your disk" => " oder Datei von lokaler Disk hochladen",
"Add or edit folder" => "Ordner hinzufügen/bearbeiten",
"Add or edit a URL" => "URL hinzufügen/bearbeiten",
"received" => "erhalten",
"submitted" => "zugewiesen",
"shared" => "geteilt",
"move into trash" => "in den Papierkorb",
"waiting / not started" => "wartend / noch nicht begonnen",
"waiting" => "wartend",
"shared for group" => "wird geteilt von Gruppe",
"accepted by user" => "akzeptiert von Benutzer",
"no / rejected" => "nein / zurückgewiesen",
"accepted by creator" => "vom Ersteller akzeptiert",
"priority" => "Priorität",
"select one" => "Status",
"undo trash" => "aus Papierkorb",
"show:" => "anzeigen:",
"all shared tasks" => "alle geteilten Aufgaben",
"previous chart" => "vorherige Hitliste",
"next chart" => "nächste Hitliste",
"pos" => "Position",
"pre" => "letzte",
"avg" => "Durchschnitt",
"post new comment" => "Neuen Kommentar posten",
"Post New Comment" => "Neuen Kommentar posten",
"HTML tags are not allowed inside comments" => "HTML-Tags innerhalb von Kommentaren nicht erlaubt",
"moderator actions" => "Moderator-Aktionen",
"move selected topics" => "Ausgewählte Themen verschieben",
"unlock selected topics" => "Ausgewählte Themen entsperren",
"lock selected topics" => "Ausgewählte Themen sperren",
"merge" => "zusammenführen",
"merge selected topics" => "Ausgewählte Themen zusammenführen",
"reported messages:" => "Gemeldete Nachrichten:",
"queued messages:" => "Aufgelaufene Nachrichten:",
"emot" => "emot",
"Edit fields" => "Felder bearbeiten",
"View item" => "Eintrag ansehen",
"Add a comment" => "Kommentar hinzufügen",
"settings" => "Einstellungen",
"mailbox" => "Mailbox",
"compose" => "Erstellen",
"contacts" => "Kontakte",
"account" => "Account",
"pop" => "POP",
"back to mailbox" => "Zurück zum Briefkasten",
"full headers" => "Alle Header",
"normal headers" => "Normale Header",
"reply all" => "allen antworten",
"forward" => "weiterleiten",
"select from address book" => "Aus Adressbuch auswählen",
"cc" => "CC",
"Projects" => "Projekte",
"Projects configuration" => "Projekte Einstellungen",
"Site Identity features" => "Site Identitäts Features",
"Click here to delete this category" => "Zum Löschen der Kategorie hier klicken",
"Group doesnt exist" => "Gruppe existiert nicht",
"User doesnt exist" => "Benutzer existiert nicht",
"Event without Name" => "Ereignis ohne Name",
"Invalid old password" => "Ungültiges altes Paßwort",
"No channel indicated" => "Kein Kanal angegeben",
"No nickname indicated" => "Kein Nickname angegeben",
"No permission to view the page" => "Keine Berechtigung zum Betrachten dieser Seite",
"Please create a directory named \$map_path to hold your map files." => "Bitte ein Verzeichnis \$map_path für die Kartendaten anlegen.",
"Permision denied" => "Zugriff verweigert",
"Technology" => "Technisches Brimborium",
"Content Related" => "Inhaltsbezogen",
"Feature documentation links" => "Doku-Links zu Komponenten",
"Help System (Feature documentation links)" => "Hilfesystem (Doku-Links zu Komponenten)",
"Technical Features" => "Technisches Brimborium",
"Checkbox options: put 1 if you need that next field is on the same row." => "Auswahlfeld-Optionen: 1 eintragen, falls das nächste Feld in derselben Spalte sein soll",
"new sites" => "Neue Links",
"Paramaters" => "Parameter",
"database queries used" => "durchgeführte Datenbankabfragen",
"{\$atts_cnt} files attached" => "{\$atts_cnt} angehängte Dateien",
"pass" => "Paßwort",
"Page generated in" => "Seite erzeugt in",
"sent" => "Gesendet",
"Homework" => "Hausaufgaben",
"Assignments" => "Aufgaben",
"Favorites" => "Favoriten",
"Member list" => "Mitgliederliste",
"Back to Homepage" => "Zurück zur Startseite",
"Edit Summary" => "Zusammenfassung bearbeiten",
"Minor" => "geringfügig",
"Content Features" => "Inhalts-Einstellungen",
"Contact Us (Anonymous)" => "Kontaktiere uns (anonym)",
"Prevent automatic/robot registration" => "Batch-Registrierung (z.B. per Script) unterbinden",
"Create/edit Calendars" => "Kalender hinzufügen/bearbeiten",
"charts" => "Hitlisten",
"Chat Administration" => "Chat-Verwaltung",
"Chat Admin" => "Chat verwalten",
"Create/edit channel" => "Chatraum hinzufügen/bearbeiten",
"Half a second" => "halbe Sekunde",
"second" => "Sekunde",
"Chat channels" => "Chaträume",
"Admin DSN" => "DSN verwalten",
"Admin Featured Links" => "Linktips verwalten",
"Admin Webmail" => "Webmail verwalten",
"Assign Module" => "Modul zuweisen",
"subscribed" => "abonniert",
"Score System" => "Bewertungs-System",
"Edit survey questions" => "Umfrage bearbeiten",
"Admin Tracker" => "Tracker verwalten",
"Again" => "Wiederholung",
"Assign permissions to group" => "Gruppenberechtigungen vergeben",
"Browsing Gallery" => "Galerie ansehen",
"Admin Directory Related" => "Verwandte Kategorien verwalten",
"Admin Directory Sites" => "Links verwalten",
"Validate Sites" => "Links überprüfen",
"Edit Article" => "Artikel erstellen/bearbeiten",
"Show Plugins Help" => "Zeige PlugIn Hilfe",
"Show Text Formatting Rules" => "Zeige Textformatierungs-Regeln",
"Program dynamic content for block" => "Dynamischen Inhalt für den Block programmieren",
"Admin quizzes" => "Quiz verwalten",
"EditTemplates" => "Vorlagen bearbeiten",
"Message queue for" => "Nachrichten-Liste für",
"back to forum" => "zur&uum;ck zum Forum",
"Reported messages for" => "Gemeldete Beiträge für",
"Admin Cache" => "Cache verwalten",
"back to admin" => "zurück zur Verwaltung",
"Subscribe to This Newsletter" => "Rundbrief abonnieren",
"Stats for quiz" => "Statistik für das Quiz",
"Received Articles" => "Erhaltene Artikel",
"Rename page" => "Seite umbenennen",
"to_version" => "zu_Version",
"Stats for survey" => "Statistik für Umfrage",
"Theme Control Center: categories" => "Theme Kontrollcenter: Kategorien",
"ThemeControl" => "Theme-Konfiguration",
"ThemeControl Objects" => "Objekte Theme-Konfiguration",
"Theme Control Center: sections" => "Theme Kontrollcenter: Bereiche",
"Upload big files (e.g. PodCast files) here:" => "Große Dateien (z.B. PodCasts) hier hochladen:",
"File Title" => "Dateititel",
"User Assigned Modules" => "Vom Benutzer zugewiesene Module",
"IRC log" => "IRC Log",
"Add new mail account" => "Neuen eMail-Account hinzufügen",
"User accounts" => "Benutzer-Accounts",
"View All" => "Alle ansehen",
"Msg" => "Nachricht",
"Can't parse remote HTML page" => "Kann externe HTML-Seite nicht verarbeiten",
"Permission denied you cannot remove pages" => "Berechtigung zum Entfernen von Seiten nicht vorhanden",
"Cannot write to this file" => "Kann diese Datei nicht schreiben",
"Missing title or body when trying to post a comment" => "Fehlender Titel oder Textkörper beim Posten eines Kommentars",
"\\n for rows" => "\\n für Spalten",
"Consider we are in always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber prüfe nicht nach",
"Newsletter subscription information at " => "Rundbrief-Abonnement Infos auf ",
"Changes" => "Änderungen",
"Hold down CTRL to select multiple categories" => "Zum Markieren mehrerer Kategorien STRG gedrückt halten",
"categorize this object" => "Dieses Objekt kategorisieren",
"Uncheck the above checkbox to uncategorize this page/object" => "Die Checkboxmarkierung löschen um die Kategorien von dieser Seite/diesem Objekt zu entfernen",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst möglich bearbeitet.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Neuer Artikel erschienen: {\$mail_title} von {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"Syntax highlighting" => "Syntax-Highlighting",
"MyTiki Home" => "Mein Tiki-Startseite",
"My Files" => "Meine Dateien",
"Mini calendar" => "Mini-Kalender",
"User list" => "Benutzerliste",
"Dump" => "Datenbankabzug",
"Send Pages" => "Seiten verschicken",
"Received pages" => "Erhaltene Seiten",
"New Article" => "Neuer Artikel",
"Admin Posts" => "Einträge verwalten",
"Submit a New Link" => "Neuen Link eintragen",
"Browse directory" => "Verzeichnis durchstöbern",
"Admin Directory" => "Linkverzeichnis verwalten",
"Layer Management" => "Layer Management",
"List quizzes" => "Quiz auflisten",
"List trackers" => "Tracker auflisten",
"Ephemerides Admin" => "Terminkalender verwalten",
"Charts Admin" => "Hitlisten verwalten",
"Debugger console" => "Debug-Konsole",
"I forgot my pass" => "Ich habe mein Paßwort vergessen",
"Send trackback pings to:" => "Trackback pings senden an:",
"(comma separated list of URIs)" => "(kommagetrennte URI-Liste)",
"This is" => "Dies ist",
"by the" => "von der",
"Tiki community" => "Tiki Community",
"User identity features" => "Benutzeridentitäts-Einstellungen",
"Tikiwiki version" => "Tikiwiki Version",
"Use URI as Home Page" => "URI als Home-Seite benutzen",
"OS" => "Betriebssystem",
"Enable Smarty Security (e.g. do not allow php code in smarty templates)" => "Smarty Sicherheit aktivieren (z.B. keinen PHP-Code in Smarty Templates erlauben)",
"Log Mail in Tiki Logs:" => "eMails im Log protokollieren:",
"Log SQL:" => "SQL protokollieren:",
"Default charset for sending mail:" => "Standard-Kodierung ausgehender eMails:",
"Mail end of line:" => "Zeilenende in eMails:",
"Disallow access to the site (except for those with permission)" => "Zugriff auf den Server verbieten (außer für Personen mit Berechtigung)",
"Message to display when site is closed" => "Angezeigte Meldung, wenn der Server geschlossen ist",
"Disallow access when load is above the threshold (except for those with permission)" => "Zugriff auf den Server bei Überschreiben der eingestellten Maximallast verbieten (außer für Personen mit Berechtigung)",
"Max average server load threshold in the last minute" => "Höchste Durchschnittslast in der letzten Minute",
"Message to display when server is too busy" => "Angezeigte Meldung, wenn der Server überlastet ist",
"Use cache for external images" => "Cache für externe Bilder benutzen",
"Use gzipped output" => "Ausgabe durch gzip",
"output compression is active." => "Ausgabe-Komprimierung ist aktiv.",
"compression is handled by" => "Komprimierung erfolgt durch",
"Sender Email" => "eMail-Absender",
"Allow anonymous users to \"Contact Us\"" => "\"Kontaktiere uns\" Feature für Anonym erlauben",
"contact feature disabled" => "Kontakt-Funktion deaktiviert",
"Session lifetime in minutes" => "Session-Lebenszeit in Minuten",
"Proxy Host" => "Proxy Server",
"Please expect not found help-pages with the default-URL." => "Teilweise fehlen die Hilfeseiten noch.",
"Any help with the documentation is welcome." => "Hilfe bei der Dokumentation ist willkommen.",
"Release check" => "Auf neue Version prüfen",
"Release checks are made when you browse admin main page only" => "Die Überprüfung wird beim Aufruf der Admin-Hauptseite durchgeführt",
"Force immediate check" => "Jetzt prüfen",
"When possible, show the real user name instead of login:" => "Zeige vollen Namen statt Benutzerkennen (sofern vorhanden):",
"Locations separator" => "Trennzeichen zwischen Locations",
"Choices separator" => "Auswahl Abgrenzer",
"User registration and login" => "Benutzerregistrierung und -login",
"Use WebServer authentication for Tiki" => "Webserver-Authentifizierung für Tiki benutzen",
"... but need admin validation" => "... benötigen aber Bestätigung durch den Admin",
"Create a group for each user <br />(with the same name as the user)" => "Für jeden Benutzer eine eigene<br />Gruppe anlegen (Gruppenname = Benutzername)",
"Use tracker for more user information" => "Tracker für weitere Benutzer-Informationen benutzen",
"Use tracker for more group information" => "Tracker für weitere Gruppen-Informationen benutzen",
"Request passcode to register" => "Passcode zur Registrierung abfragen",
"Php GD library required" => "Php GD Bibliothek erforderlich",
"Use login as email" => "Login als eMail-Adresse benutzen",
"Validate users by email" => "Benutzer per eMail validieren",
"Validate user email server" => "Mailserver des Benutzers validieren",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Paßworterinnerungen per eMail (wenn \"Paßwörter im Klartext speichern\" aktiviert ist.) Sonst, Paßwörter per eMail zurücksetzen",
"Store plaintext passwords" => "Speichere Klartext-Paßwörter",
"Crypt passwords method" => "Paßwort-Verschlüsselung",
"Reg users can change password" => "Reg. Benutzer können Paßwort ändern",
"Reg users can change language" => "Reg. Benutzer können Sprache ändern",
"Restrict available languages" => "Verfügbare Sprachen einschränken",
"Available languages:" => "Verfügbare Sprachen:",
"Minimum username length" => "Minimallänge Benutzername",
"Maximum username length" => "Maximallänge Benutzername",
"Force lowercase username" => "Nur Kleinbuchstaben im Benutzernamen",
"Force to use chars and nums in passwords" => "Erzwinge Benutzung von Buchstaben und Zahlen in Paßwörtern",
"Minimum password length" => "Minimale Paßwortlänge",
"Password invalid after days" => "Tage bis zur Ungültigkeit des Paßwortes",
"-1 for never" => "-1 für niemals",
"Re-validate user by email after days" => "Tage bis der Benutzer erneut per eMail validiert wird",
"Re-validate user by email after unsuccessful logins" => "Fehlgeschlagene Anmeldungen, nach denen der Benutzer erneut per eMail validiert wird",
"Generate a password option" => "Option zum automatischen Passwort-Erstellen anzeigen",
"Remember me feature" => "Erkenne mich-Funktion",
"Remember me name" => "Erkenne mich-Name",
"Remember me domain" => "Erkenne mich-Domain",
"Remember me path" => "Erkenne mich-Pfad",
"Protect against CSRF with a confirmation step" => "Durch Bestätigungs-Schritt gegen CSRF schützen",
"Highlight Group" => "Gruppe hervorheben",
"User can choose beyond these groups at registration time" => "Benutzer kann beim Registrieren zwischen diesen Gruppen wählen",
"Specify the fields that will be asked in admin->groups" => "Definiere die zusätzlicen Felder in Admin->Gruppen",
"Displays user's contribution in the user information page" => "Zeigt die Nutzeraktivität auf der Benutzer-Infoseite an",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Zeige diese UserTracker-Infos auf der Benutzerseite an. Format: trackerId, fieldId1, fieldId2, ...",
"Deactivate login autocomplete (do not remember login and password)" => "Automatisches Vervollständigen beim Login abschalten (Kennung und Passwort nicht merken)",
"On permission denied, display login box for anonymous:" => "Bei Zugriffsfehlermeldung für anonyme Benutzer die Loginbox anzeigen:",
"On permission denied, send to this url:" => "Bei Zugriffsfehlermeldung auf diese Seite springen:",
"Create user if not in Tiki?" => "Benutzer anlegen falls im Tiki nicht vorhanden?",
"Create user if not in Auth?" => "Benutzer anlegen falls in Auth nicht vorhanden?",
"Just use Tiki auth for admin?" => "Nur Tiki-Authentifizierung für Administrator?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(wenn gesetzt werden Host und Port (s.u.) nicht benutzt)",
"LDAP User DN" => "LDAP Benutzer DN",
"LDAP User Attribute" => "LDAP Benutzer Attribut",
"LDAP User OC" => "LDAP Benutzer OC",
"LDAP Group DN" => "LDAP Gruppen DN",
"LDAP Group Attribute" => "LDAP Gruppen Attribut",
"LDAP Group OC" => "LDAP Gruppen OC",
"LDAP Member Attribute" => "LDAP Member Attribut",
"LDAP Admin User" => "LDAP Admin Benutzername",
"LDAP Admin Pwd" => "LDAP Admin Passwort",
"CAS server hostname" => "CAS Server Hostname",
"CAS server port" => "CAS Server Port",
"CAS server path" => "CAS Server Pfad",
"Change CAS preferences" => "Einstellungen übernehmen",
"Valid Affiliations (separated by commas)" => "Gültige Zugehörigkeiten (kommagetrennt)",
"Create with default group?" => "Standardgruppe erstellen?",
"Default group: " => "Standardgruppe: ",
"Change Shibboleth preferences" => "Einstellungen übernehmen",
"Users Defaults" => "Users Defaults",
"Change users defaults" => "Ändere Benutzerstandard",
"Meta Keywords" => "Schlüsselwörter",
"Meta Description" => "Beschreibung",
"Meta Author" => "Autor",
"meta robots" => "Meta Robots",
"revisit after" => "erneut besuchen nach",
"Allow Smileys" => "Smileys erlauben",
"Use File Galleries for images inclusion" => "Bildergalerien für Bildeinbindung in Seiten erlauben",
"Hotwords in New Windows" => "Hotwords in neuem Fenster",
"Trackers attachments preferences" => "Einstellungen für Tracker Anhänge",
"Trackers attachments" => "Tracker Anhänge",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Zum einfachen Erstellen/Bearbeiten von Wikiseiten das Modul quick_edit hinzufügen über Menüpunkt \"Module\" im Seitenbalken oder",
"Create a Tag for the Current Wiki" => "Tag für die aktuelle Wikiseite erstellen",
"Restore the Wiki" => "Wikiseiter wiederherstellen",
"restore" => "wiederherstellen",
"Remove a Tag" => "Tag entfernen",
"Wiki Comments Settings" => "Einstellungen für Wiki-Kommentare",
"Wiki Home Page" => "Wiki-Home-Page",
"Wiki Discussion" => "Wiki Diskussion",
"Wiki Link Format" => "Wiki Link Erkennung",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Definiert, welche <i>((Strings))</i> in Wiki Links umgewandelt werden",
"Wiki Page List Configuration" => "Einstellungen für Wikiliste",
"Wiki Features" => "Wiki-Funktionen",
"Print Page:" => "Seite drucken:",
"Show page version:" => "Seitenversion anzeigen:",
"Regex search and replace:" => "Regex Suchen und Ersetzen:",
"Wiki History" => "Wiki Historie",
"Wiki Watch" => "Wiki Beobachtung",
"Enable watches on comments:" => "Beobachtungspunkte auf Kommentaren aktivieren:",
"Watch minor:" => "Geringfügige Änderungen beobachten:",
"More Links" => "Weitere Links",
"Admin Charts" => "Hitlisten verwalten",
"Add new rule" => "Neue Regel hinzufügen",
"EMail notifications" => "eMail-Benachrichtigungen",
"Edit this RSS module:" => "Dieses RSS-Modul bearbeiten:",
"Create new RSS module" => "Neues RSS-Modul erstellen",
"Tikiwiki settings" => "Tiki Einstellungen",
"Create/edit questions for survey" => "Fragen für Umfrage erstellen/bearbeiten",
"Active?" => "Aktiv?",
"Create Trackers" => "Tracker anlegen",
"Create/Edit Trackers" => "Tracker hinzufügen/bearbeiten",
"Assign to Groups" => "Zu Gruppen hinzufügen",
"show help" => "Hilfe zeigen",
"Delete this type" => "Diesen Typ löschen (nur wenn keine Artikel dieses Typs vorhanden sind)",
"level configuration" => "Levelkonfiguration",
"Browse gallery" => "Galerie durchsehen",
"Upload from disk" => "Hochladen von Disk",
"Browse file gallery" => "Dateiarchiv durchsehen",
"Directory batch" => "Aus Verzeichnis einlesen",
"Browsing Image" => "Bild ansehen",
"Zoom" => "Zoomen",
"Again please" => "Bitte nochmal",
"Admin category relationships" => "Beziehungen zwischen Kategorien verwalten",
"Validate links" => "Links überprüfen",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Dateien mit angehängtem -{\$user} sind editierbar, andere sind schreibgeschützt, aber als Vorlage verwendbar.",
"Im- Export Languages" => "Sprachen im/exportieren",
"Create a file gallery" => "Dateiarchiv anlegen",
"Support tickets" => "Support-Ticket",
"Return to HomePage" => "Zurück zur Hauptseite",
"Stats for this survey Questions " => "Statistik für diese Umfrage-Frage ",
"Batch upload" => "Batch hochladen",
"1 suggestion" => "1 Vorschlag",
"suggestions" => "Vorschläge",
"Minor Edit" => "geringfügig",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "Das \"Snarf Wikiplugin\" ist installiert. Es kann verwendet werden um Seiten aus dem lokalen Netzwerk via RegEx in HTML ausdrücken.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "Das \"Regex Wikiplugin\" ist installiert. Es kann verwendet werden um HTML Code durch RegEx zu ersetzen.",
"You can not download files" => "Sie dürfen keine Dateien herunterladen",
"Please wait 2 minutes between posts" => "Bitte zwei Minuten zwischen Posts warten",
"The text in RED is" => "Der Text in ROT ist",
"Show Categories" => "Kategorien zeigen",
"Hide Categories" => "Kategorien verbergen",
"Wiki page %s changed" => "Die Wiki Seite %s wurde geändert",
"Blog features" => "Blog-Funktionen",
"Blog level comments" => "Kommentare auf Blog-Ebene",
"Post level comments" => "Kommentare auf Blogeintrag-Ebene",
"Post level trackback pings" => "Trackback Pings auf Blogeintrag-Ebene",
"Spellchecking" => "Rechtschreibprüfung",
"Default ordering for blog listing" => "Standardsortierung für Blog-Listen",
"Blog listing configuration (when listing available blogs)" => "Einstellungen Blog-Liste (für Liste der verfügbaren Blogs)",
"Last modification time" => "Änderungszeit",
"Blog comments settings" => "Blog-Kommentareinstellungen",
"Group calendar sticky popup" => "Sticky PopUp für Gruppenkalender",
"Group calendar item view tab" => "Elementanzeigespalte für Gruppenkalender",
"Calendar manual selection of time/date" => "manuelle Auswahl von Zeit/Datum im Kalender",
"Show Category Path" => "Kategorie-Pfad zeigen",
"Show Category Objects" => "Kategorie-Objekte anzeigen",
"CMS features" => "Artikel-Funktionen",
"Use templates" => "Vorlagen benutzen",
"Print article" => "Artikel drucken",
"Settings for page articles home" => "Einstellungen für die Artikel-Startseite",
"Maximum number of articles in home" => "Maximale Anzahl von Artikeln auf der Artikel-Startseite",
"Article comments settings" => "Artikelkommentareinstellungen",
"Fields to display on page" => "Folgende Felder anzeigen auf der Seite",
"Expire Date" => "Ablaufdatum",
"License Page" => "Lizenzseite",
"Submit Notice" => "Nachricht einstellen",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Dateiarchive hinzufügen/löschen über Menüpunkt 'Dateiarchive' im Menü im Seitenbalken oder",
"Uploaded filenames cannot match regex" => "Hochgeladene Dateinamen dürfen dieser RegEx nicht entsprechen",
"File galleries comments settings" => "Dateiarchiv-Kommentareinstellungen",
"File galleries search indexing" => "Dateiarchiv Suchindex",
"Leave command blank to delete handler" => "'Systembefehl' leer lassen, damit keine Aktion ausgeführt wird.",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Platzhalter %1 benutzen, wo der Dateiname eingesetzt werden soll (Beispiel: 'strings %1' benutzen um das Dokument über den Unix-Befehl strings in reinen Text zu konvertieren.)",
"Enable auto indexing on file upload or change" => "Indizierung bei Dateiupload oder Änderung automatisch aktivieren",
"System command" => "Systembefehl",
"Home Forum" => "Hauptforum",
"Forums features" => "Foren-Einstellungen",
"Forum quick jumps" => "Foren Schnellsprünge",
"Ordering for forums in the forum listing" => "Sortierung der Foren in Forenliste",
"Forum listing configuration" => "Konfiguration Forenliste",
"I18n setup" => "I18n Konfiguration (Mehrsprachigkeit)",
"Show Babelfish Translation URLs" => "Babelfish Übersetzungslink zeigen",
"Show Babelfish Translation Logo" => "Babelfish Übersetzungs-Logo zeigen",
"Show Module Controls" => "Modul-Verschiebebuttons zeigen",
"Users can Configure Modules" => "Benutzer können Module konfigurieren",
"Users can Shade Modules" => "Benutzer kann Module minimieren",
"module decides" => "Modul entscheidet",
"Allow Anonymous Poll Voting" => "Anonyme Teilnehmer bei Umfragen erlauben",
"seconds (0 = cache inactive)" => "Sekunden (0 = Cache deaktiviert)",
"Performance issues" => "Performance-Einstellungen",
"Search features" => "Suche Einstellungen",
"SearchStats" => "Such-Statistik",
"Settings for searching content" => "Einstellung für die Suche in Inhalten",
"Search refresh rate" => "Suche Refreshrate",
"0 for no refresh" => "0 für nicht aktualisieren",
"this survey stats" => "Statistik dieser Umfrage",
"bold" => "fett",
"italic" => "kursiv",
"underline" => "unterstreichen",
"unread private messages" => "ungelesene persönliche Nachrichten",
"you or someone registered this email address at" => "Sie oder jemand anderes hat Ihre eMail-Adresse bei",
"Your Tiki information registration" => "Ihre Tiki Registrierungsinformationen",
"Your registration" => "Ihre Tiki Registrierungsinformationen",
"left/right" => "links/rechts",
"Unassign module" => "Modul wegnehmen",
"home" => "Hauptseite",
"chat" => "Chat",
"contact us" => "Kontaktiere uns",
"debugger console" => "Debug-Konsole",
"MyMenu" => "Mein Menü",
"User menu" => "Benutzer-Menü",
"dump" => "Datenbankabzug",
"rankings" => "Bewertungen",
"orphan pages" => "Verwaiste Seiten",
"sandbox" => "Sandbox",
"received pages" => "Empfangene Seiten",
"structures" => "Strukturen",
"Articles Home" => "Artikel Hauptseite",
"Send articles" => "Artikel senden",
"Create/Edit Blog" => "Blog hinzufügen/bearbeiten",
"Browse Directory" => "Verzeichnis durchstöbern",
"Admin FAQs" => "FAQs verwalten",
"Edit mapfiles" => "Kartendateien bearbeiten",
"Admin quiz" => "Quiz verwalten",
"Admin trackers" => "Tracker verwalten",
"Send newsletters" => "Rundbrief versenden",
"Ephemerides" => "Terminkalender",
"Admin home" => "Verwaltung Hauptseite",
"Edit languages" => "Sprachen bearbeiten",
"External wikis" => "Externe Wikis",
"Mods Admin" => "MODs verwalten",
"UsrMenu" => "Benutzer-Menü",
"Click here to manage your personal menu" => "Klicken Sie hier zum Ädern ihres persönlichen Menüs",
"Quick edit a Wiki page" => "Schnellbearbeitung einer Wiki-Seite",
"Language: " => "Sprache: ",
"Sort posts by:" => "Einträge sortieren nach:",
"read more" => "mehr lesen",
"Pass" => "Paßwort",
"HTTPS login" => "HTTPS-Login",
"System Admin" => "System Verwaltung",
"some text" => "Ein Text",
"Creates a box with the data" => "Erzeugt eine Box mit den Daten",
"creates a title bar" => "erzeugt einen Titelbalken",
"creates a table" => "erzeugt eine Tabelle",
"makes a horizontal rule" => "erzeugt einen horizontalen Balken",
"page|desc" => "Seite|Beschr.",
"displays an image" => "zeigt ein Bild an",
"Non cacheable images" => "Ungecachte Bilder",
"height width desc link and align are optional" => "height width desc link und align sind optional",
"Wiki File Attachments" => "Wiki Dateianhänge",
"displays rss feed with id=n maximum=m items" => "RSS-Feed mit id=n maximum=m Einträgen",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Wird mit dem tatsächlichen Wert des dynamischen Inhaltsblocks mit id=n ersetzt",
"Misc" => "Verschiedenes",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Bevor sie ihre Tiki Installation aktualisieren, lesen sie bitte die <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade-Anweisungen</a>",
"any file" => "beliebige Dateien",
"podcast (audio)" => "PodCast (Audio)",
"podcast (video)" => "PodCast (Video)",
"Listing configuration" => "Listen-Konfiguration",
"Number of columns per page when listing categories" => "Spalten pro Seite in Kategorienliste",
"No tabs" => "Tabs abschalten",
"Main" => "Aktivierung der Hauptkomponenten",
"Global Features" => "Übergreifende Einstellungen",
"More Functionality" => "Aktivierung weiterer Komponenten",
"UI Enhancements" => "Darstellungsoptimierungen",
"Member of the default group of creator can modify items?" => "Mitglieder aus der Standardgruppe des Erstellers dürfen Einträge ändern?",
"Parent category" => "Übergeordnete Kategorie",
"Most visited sub-categories" => "Meistbesuchte Unterkategorien",
"Category description" => "Kategorie-Beschreibung",
"Random sub-categories" => "Zufällige Unterkategorien",
"Allow sites in this category" => "Links in dieser Kategorie erlauben",
"Show number of sites in this category" => "Anzahl der Links in dieser Kategorie anzeigen",
"Subcategories" => "Unterkategorien",
"Admin related categories" => "Verwandte Kategorien verwalten",
"Add a related category" => "Verwandte Kategorie hinzufügen",
"Related categories" => "Verwandte Kategorien",
"Add a Category" => "Kategorie hinzufügen",
"in current category" => "in der ausgewählten Kategorie",
"Total categories" => "Themen gesamt",
"Click to Navigate" => "Zum Navigieren anklicken",
"Focus:" => "Fokus:",
"Note: Maximum image size is limited to" => "Hinweis: Die Uploadgrösse ist beschränkt auf",
"Daily report from" => "Tägliche Zusammenfassung vom",
"Monthly report from" => "Monatliche Zusammenfassung vom",
"Weekly report from" => "Wöchentliche Zusammenfassung vom",
"added the file" => "fügte die Datei",
"added the image" => "fügte das Bild",
"added the article" => "fügte den Artikel",
"added the wiki page" => "fügte die Wikiseite",
"to the category" => "zur folgenden Kategorie hinzu:",
"removed the image" => "entfernte das Bild",
"removed the wiki page" => "entfernte die Wikiseite",
"from the category" => "von der Kategorie",
"Importer log" => "Importer-Log",
"Welcome to the Tiki installation and upgrade script" => "Willkommen zur Tiki Installations- und Upgrade-Seite",
"Select your language" => "Wählen Sie Ihre Sprache",
"Tiki is software distributed under the LGPL license" => "Tiki ist unter der LGPL Lizenz vertriebene Software",
"This installer will perform some basic checks automatically" => "Dieser Installer wird einige Prüfungen automatisch ausführen",
"Tiki has not detected your PHP memory_limit" => "Tiki hat Ihr PHP memory_limit nicht erkannt",
"This probably means you have no set limit (all is well)" => "Das heißt wahrscheinlich, dass Sie überhaupt kein Limit gesetzt haben (dann ist alles in Ordnung)",
"Tiki has detected your PHP memory limit at" => "Tiki hat Ihr PHP Speicher-Limit erkannt mit",
"Tiki has detected your PHP memory_limit at" => "Tiki hat Ihr PHP Speicher-Limit erkannt mit",
"Test email" => "Test eMail",
"Email address to send test to" => "E-Mail Adresse, an die die Test-Mail gesandt wird",
"Review your mail log for details" => "Prüfen Sie Ihr E-Mail-Log für Details",
"Tiki detected" => "Tiki erkannte",
"Tiki was not able to detect the GD library" => "Tiki konnte die GD Bibliothek finden",
"This is normal for a new installation" => "Dies ist normal für eine neue Installation",
"Database type" => "Datenbank-Typ",
"Host name" => "Hostname",
"Database name" => "Datenbank-Name",
"For Oracle" => "Für Oracle",
"User name" => "Benutzername",
"Admin email" => "Admin eMail",
"Adding a new host" => "Einen neuen Host hinzufügen",
"Ok" => "Ok",
"/" => "/",
"Fatal error: cannot execute automatic activity \$activityId" => "Fataler Fehler: Kann automatische Aktivitä \$activityId nicht ausführen",
"Fatal error: setting next activity to an unexisting activity" => "Fataler Fehler: Folgeaktivität wurde auf einen ungültigen Eintrag gesetzt",
"Fatal error: trying to send an instance to an activity but no transition found" => "Fataler Fehler: Versuch, eine Instanz an eine Aktivität zu schicken, jedoch ist kein Übergang definiert",
"Process does not have a start activity" => "Prozess besitzt keine Start-Aktivität",
"Process does not have exactly one end activity" => "Prozess besitzt nicht genau eine End-Aktivität",
"End activity is not reachable from start activity" => "End-Aktivitä von der Start-Aktivität aus nicht erreichbar",
"is interactive but has no role assigned" => "ist interaktiv, besitzt aber keine zugeordnete Rolle",
"is standalone but has transitions" => "ist standalone, besitzt aber Übergänge",
"Role" => "Rolle",
"Process %d has been activated" => "Prozess %d wurde aktiviert",
"Process %d has been deactivated" => "Prozess %d wurde deaktiviert",
"Process %s %s imported" => "Prozess %s %s importiert",
"Process %s removed" => "Prozess %s entfernt",
"Process %s has been updated" => "Prozess %s wurde aktualisiert",
"Process %s has been created" => "Prozess %s wurde erstellt",
"<return> for rows" => "\\n für Spalten",
"Any 2 versions" => "zwei beliebige Versionen",
"english" => "englisch",
"Report all errors except notices" => "Alle Fehler außer Hinweisen ausgeben",
"1 day" => "1 Tag",
"1 week" => "1 Woche",
"1 month" => "1 Monat",
"Just Tiki" => "Nur über Tiki",
"Tiki and PEAR::Auth" => "Tiki und PEAR::Auth",
"choose a group ..." => "Gruppe auswählen ...",
"%s enabled" => "%s aktiviert",
"%s disabled" => "%s deaktiviert",
"Charts" => "Hitlisten",
"Forums last topics" => "Neueste Forenthemen",
"games" => "Spiele",
"drawing not found" => "Zeichnung nicht gefunden",
"heads and cells separated by ~|~" => "Kopfzellen und sonstige Felder werden getrennt durch ~|~",
"Quicktags" => "Quicktags",
"best regards" => "Gruss",
"your Tikiwiki" => "Ihr Tiki",
"Tiki User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"Tiki email notification" => "Tiki eMail-Benachrichtigung",
"Your Tiki account information for %s" => "Ihre Tiki-Accountinformationen für %s",
"TikiWiki Assistant" => "Tiki Assistent",
"Recently visited pages" => "Zuletzt besuchte Seiten",
"Last `\$module_rows` Sites" => "Die letzten `\$module_rows` Links",
"Last Sites" => "Neueste Links",
"Directory Stats" => "Verzeichnis-Statistik",
"Sites to validate" => "Zu überprüfende Links",
"Visited links" => "Besuchte Links",
"Top \$module_rows Sites" => "Die \$module_rows Top-Links",
"Top Sites" => "Beliebteste Links",
"file galleries" => "Dateiarchive",
"Last `\$module_rows` forum posts" => "`\$module_rows` neueste Forenbeiträge",
"Last `\$module_rows` forum topics" => "Die letzten `\$module_rows` Forenthemen",
"Last `\$module_rows` actions" => "Letzte `\$module_rows` Aktionen",
"Last `\$module_rows` articles" => "Die letzten `\$module_rows` Artikel",
"Last articles" => "Neueste Beiträge",
"Last `\$module_rows` blog posts" => "Die letzten `\$module_rows` Blog-Einträge",
"Last `\$module_rows` Created blogs" => "Die letzten `\$module_rows` angelegten Blogs",
"Last `\$module_rows` Created FAQs" => "Die letzten `\$module_rows` angelegten FAQs",
"Last `\$module_rows` Created Quizzes" => "Die letzten `\$module_rows` angelegte Quiz",
"Last `\$module_rows` modified file galleries" => "Die letzten `\$module_rows` geänderten Dateiarchive",
"Last `\$module_rows` Files" => "Die letzten `\$module_rows` Dateien",
"Last `\$module_rows` galleries" => "Die letzten `\$module_rows` Galerien",
"Last galleries" => "Neueste Galerien",
"Last `\$module_rows` changes" => "Die letzten `\$module_rows` Änderungen",
"Last `\$module_rows` Modified Items" => "Die letzten `\$module_rows` geänderten Einträge",
"Last `\$module_rows` Modified blogs" => "Die letzten `\$module_rows` geänderten Blogs",
"Last `\$module_rows` submissions" => "Die letzten `\$module_rows` Einreichungen",
"Last `\$module_rows` Items" => "Die letzten `\$module_rows` Einträge",
"Menu" => "Menü",
"New Messages" => "Neue Nachrichten",
"New Message" => "Neue Nachricht",
"Top `\$module_rows` articles" => "Die `\$module_rows` Top-Artikel",
"Top `\$module_rows` File Galleries" => "Die `\$module_rows` Top-Dateiarchive",
"Top `\$module_rows` files" => "Die `\$module_rows` Top-Dateien",
"Top `\$module_rows` games" => "Die `\$module_rows` Top-Spiele",
"Top games" => "Top-Spiele",
"Top `\$module_rows` galleries" => "Die `\$module_rows` Top-Galerien",
"Top `\$module_rows` Images" => "Die `\$module_rows` Top-Bilder",
"Top `\$module_rows` Pages" => "Die `\$module_rows` Top-Seiten",
"Top `\$module_rows` Quizzes" => "Die `\$module_rows` Top-Quiz",
"Most `\$module_rows` visited blogs" => "Die `\$module_rows` meistbesuchten Blogs",
"Top `\$module_rows` Visited FAQs" => "Die `\$module_rows` meistbesuchten FAQs",
"Translations that need improvement" => "Verbesserungswürdige Übersetzungen",
"Whats related" => "Verwandte Objekte",
"Last `\$module_rows` wiki comments" => "Die letzten `\$module_rows` Wiki-Kommentare",
"show structures" => "Strukturen anzeigen",
"hide structures" => "Strukturen ausblenden",
"Creation date" => "Erstelldatum",
"My workflow" => "Mein Workflow",
"enable cool sites" => "'Coole Links' aktivieren",
"Main Features" => "Hauptkomponenten",
"Action log setting" => "Action Log Einstellungen",
"Copyright System" => "Copyrightsystem",
"Copyright system" => "Copyrightsystem",
"User interface enhancement features" => "Darstellungsoptimierungen",
"JavaScript popup date selector" => "JavaScript-Aufwahlbox für Datum",
"PhpLayers Dynamic menus" => "Dynamische PHPLayer Menüs",
"Allow users to activate fullscreen mode" => "Benutzer darf Fullscreen-Anzeige aktivieren",
"Experimental Features" => "Experimentelles",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML Purifier (Inhalte werden beim Speichern auf XHTML 1.1 gesäubert)",
"Drawings" => "Zeichnungen",
"Friendship" => "Freundschaft",
"Games" => "Spiele",
"Administration Features" => "Administrative Einstellungen",
"Banning System" => "Benutzer-Sperrsystem",
"Tiki action calendar" => "Tiki-Aktionskalender",
"User Features" => "Benutzer-Einstellungen",
"Workflow engine" => "Workflow Engine",
"Unknown/Other" => "unbekannt/anderes",
"(some Unix MTA)" => "(Unix)",
"PHP error reporting level:" => "PHP Fehler Ausgabelevel:",
"Tikiwiki.org help" => "Tikiwiki.org Hilfe",
"Store session data in database" => "Session-Daten in Datenbank speichern",
"Default timezone" => "Standard Zeitzone",
"Long date format" => "Langes Datumsformat",
"Short date format" => "Kurzes Datumsformat",
"Long time format" => "Langes Zeitformat",
"Short time format" => "Kurzes Zeitformat",
"Fields display order" => "Darstellungsreihenfolge der Felder",
"New password" => "Neues Paßwort",
"HTTP port" => "HTTP-Port",
"HTTPS port" => "HTTPS-Port",
"PAM service" => "PAM Dienst",
"CAS server version" => "CAS Serverversion",
"Reg users can change theme" => "Reg. Benutzer können Theme ändern",
"Slideshows theme" => "Diaschau-Theme",
"Site logo background color" => "Logo-Hintergrundfarbe",
"Site logo title (on mouse over)" => "Mouseover-Titel des Logos",
"at top of page" => "am Seitenanfang",
"at top of center column" => "am Anfang der Mittelspalte",
"entire location" => "komplette Position",
"page name" => "Seitenname",
"installed" => "installiert",
"Default RDF version" => "Welchs Protokoll benutzen",
"hits" => "Zugriffe",
"Individual cache" => "Individuelle Cache",
"Assign permissions automatically" => "Berechtigungen automatisch vergeben",
"recommended for best performance" => "empfohlen für beste Performance",
"image gal" => "Bildergalerie",
"file gal" => "Dateiarchiv",
"Admin chart items" => "Einträge in Hitlisten verwalten",
"Edit Chart" => "Hitliste bearbeiten",
"Chart items" => "Einträge in Hitlisten",
"No items defined yet" => "Noch keine Einträge vorhanden",
"Add or edit a chart" => "Hitliste hinzufügen/bearbeiten",
"Users can vote for only one item from this chart per period" => "Benutzer können nur für einen Eintrag pro Abstimmungszeitraum stimmen",
"Prevent users from voting for the same item more than once" => "Benutzer können nur einmal überhaupt pro Hitliste abstimmen",
"Users can suggest new items" => "Benutzer können neue Einträge vorschlagen",
"Auto validate user suggestions" => "Vorschläge der Benutzer automatisch validieren",
"Ranking shows" => "Rangliste zeigt",
"All items" => "Alle Einträge",
"Top 10 items" => "Top 10 Einträge",
"Top 20 items" => "Top 20 Einträge",
"Top 40 items" => "Top 40 Einträge",
"Top 50 items" => "Top 50 Einträge",
"Top 100 items" => "Top 100 Einträge",
"Top 250 items" => "Top 250 Einträge",
"Voting system" => "Wahlsystem",
"Vote items" => "Einträge wählen",
"Rank 1..5" => "Rang 1..5 vergeben",
"Rank 1..10" => "Rang 1..10 vergeben",
"Ranking frequency" => "Wahlhäufigkeit",
"Realtime" => "Echtzeit",
"Each 5 minutes" => "alle 5 Minuten",
"Show Average" => "Zeige Durchschnitt",
"Show Votes" => "Zeige Stimmen",
"Use Cookies for unregistered users" => "Bei nicht angemeldeten Benutzern Cookies verwenden",
"Users can vote again after" => "Benutzer können erneut abstimmen nach",
"Anytime" => "jederzeit",
"Ranks" => "Ränge",
"No charts defined yet" => "Noch keine Hitlisten definiert",
"Admin drawings" => "Zeichnungen verwalten",
"Available drawings" => "Verfügbare Zeichnungen",
"no display" => "keine Anzeige",
"Available polls" => "Verfügbare Abstimmungen",
"Random image from" => "Zufälliges Bild aus",
"Dynamic content blocks" => "Dynamische Inhaltsblöcke",
"phpLayersMenus" => "phpLayerMenüs",
"Banner zones" => "Bannerzonen",
"Admin Quicktags" => "Quicktags verwalten",
"Create/Edit QuickTags" => "QuickTags hinzufügen/bearbeiten",
"Insert (use 'text' for figuring the selection)" => "Einfügen ('text' um die Auswahl zu markieren)",
"Path to the tag icon" => "Icon-Pfad",
"Admin RSS Modules" => "RSS-Module verwalten",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Auf dieser Seite werden die RSS Feeds konfiguriert, die von Tiki gelesen und importiert werden. Zum generieren/exportieren von RSS Feeds \"RSS Feeds\" im Menü wählen oder",
"show feed title" => "Feed-Titel anzeigen",
"show publish date" => "Veröffentlichungsdatum anzeigen",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Bemerkung: Sicherheitsdaten werden nur über den Installationsvorgang importiert (<a href=\"tiki-install.php\">tiki-install.php</a>). Importieren Sie die *secdb* Update Dateien in Ihre Datenbank.",
"Templates compiler" => "Template Compiler",
"Compile" => "Kompilieren",
"Group Homepage" => "Gruppen-Homepage",
"Members List" => "Mitgliederliste",
"Rejected users" => "Abgelehnte Benutzer",
"Set the default group of the selected users to" => "Setzt die Standardgruppe der markierten Benutzer auf",
"Default Group" => "Standardgruppe",
"available files" => "verfügbare Dateien",
"Old password" => "Altes Paßwort",
"creates the editable drawing foo" => "erzeugt die bearbeitbare Zeichnung foo",
"table" => "Tabelle",
"external link" => "externen Verweis",
"heading1" => "Überschrift1",
"title bar" => "Titelbalken",
"box" => "Box",
"rss feed" => "RSS-Feed",
"dynamic content" => "Dynamischer Inhalt",
"tagline" => "Tagline",
"center text" => "Text zentrieren",
"colored text" => "Farbiger Text",
"dynamic variable" => "dynamische Variable",
"special chars" => "Sonderzeichen",
"special characters" => "Sonderzeichen",
"Questions per page" => "Fragen pro Seite",
"Activity completed" => "Aktivität erfolgreich beendet",
"Admin process activities" => "Prozessaktivitäten verwalten",
"Add or edit an activity" => "Aktivität hinzufügen/bearbeiten",
"activity" => "Aktivität",
"interactive" => "interaktiv",
"Years" => "Jahre",
"Months" => "Monate",
"Minutes" => "Minuten",
"Add transitions" => "Übergänge hinzufügen",
"Add transition from:" => "Übergang hinzufügen von:",
"Add transition to:" => "Übergang hinzufügen nach:",
"No roles associated to this activity" => "Keine Rollen mit dieser Aktivität verbunden",
"Add Role" => "Rolle hinzufügen",
"Add New" => "Neu hinzufügen",
"Process activities" => "Prozessaktivitäten",
"Interactive" => "Interaktiv",
"Automatic" => "Automatisch",
"Manual" => "Manuell",
"inter" => "Interaktiv",
"(no roles)" => "(keine Rollen)",
"No activities defined yet" => "Noch keine Aktivitäten definiert",
"Process Transitions" => "Prozessübergänge",
"List of transitions" => "Übergangsliste",
"No transitions defined yet" => "Keine Übergänge definiert",
"Add a transition" => "Übergang hinzufügen",
"This process is invalid" => "Dieser Prozess ist ungültig",
"List of processes" => "Prozessliste",
"Inactive" => "inaktiv",
"val" => "aktiv",
"Active Process" => "Aktiver Prozess",
"Invalid Process" => "Ungültiger Prozess",
"Valid Process" => "Gültiger Prozess",
"Activities" => "Aktivitäten",
"No processes defined yet" => "Noch keine Prozesse definiert.",
"Admin instance" => "Instanzen verwalten",
"Process:" => "Prozess:",
"Instance" => "Instanz",
"exception" => "Fehler",
"completed" => "erledigt",
"Don't move" => "Nicht verschieben",
"Act status" => "Act Status",
"Ended" => "Beendet",
"Property" => "Property",
"run instance" => "Instanz starten",
"Admin processes" => "Prozesse verwalten",
"Add or edit a process" => "Prozess hinzufügen/bearbeiten",
"Process Name" => "Prozessname",
"ver:" => "Version:",
"is active?" => "ist aktiv?",
"Or upload a process using this form" => "Oder Prozess über dieses Formular hochladen",
"Admin process roles" => "Prozess-Rollen verwalten",
"Add or edit a role" => "Rolle hinzufügen/bearbeiten",
"Process roles" => "Prozess-Rollen",
"No roles defined yet" => "Keine Rollen definiert",
"Map users to roles" => "User zu Rollen zuordnen",
"map" => "zuordnen",
"Map groups to roles" => "Gruppen zu Rollen zuordnen",
"No roles are defined yet so no roles can be mapped" => "Keine Rollen definiert, daher keine Zuordnungen möglich",
"List of mappings" => "Zuordnungen",
"No mappings defined yet" => "Keine Zuordnungen definiert",
"Admin process sources" => "Prozess-Quellcode verwalten",
"select source" => "Quellcode auswählen",
"Set next user" => "Setze nächsten Benutzer",
"Map process roles" => "Prozess-Rollen zuordnen",
"Admin Processes" => "Prozesse verwalten",
"Admin Activities" => "Aktivitäten verwalten",
"Admin Roles" => "Rollen verwalten",
"Edit this Process" => "Prozess bearbeiten",
"Monitor Activities" => "Aktivitäten überwachen",
"List of activities" => "Aktivitätsliste",
"Proc" => "Prozesse",
"auto" => "Automatisch",
"int" => "Interaktiv",
"routing" => "Routing",
"Instances" => "Instanzen",
"run" => "starten",
"run activity" => "Aktivität starten",
"monitor processes" => "Prozesse überwachen",
"monitor activities" => "Aktivitäten überwachen",
"monitor instances" => "Instanzen überwachen",
"monitor workitems" => "Workitems überwachen",
"Monitor Instances" => "Instanzen überwachen",
"List of instances" => "Instanzliste",
"No instances created yet" => "noch keine Instanzen erstellt",
"Monitor Processes" => "Prozesse überwachen",
"processes" => "Prozesse",
"being run" => "ausgeführt",
"Exceptions" => "Fehler",
"instance" => "Instanz",
"My activities" => "Meine Aktivitäten",
"Current Activity" => "Aktuelle Aktivität",
"Assigned To" => "Zugewiesen zu Benutzer",
"abort instance" => "Instanz abbrechen",
"release instance" => "Instanz freigeben",
"No activities found" => "Keine Aktivitäten gefunden",
"My instances" => "Meine Instanzen",
"No instances found" => "Keine Instanzen gefunden",
"User Activities" => "Benutzeraktivitäten",
"process" => "Prozess",
"user processes" => "Benutzer-Prozesse",
"user activities" => "Benutzer-Aktivitäten",
"user instances" => "Benutzer-Instanzen",
"User Instances" => "Benutzer-Instanzen",
"No instances defined yet" => "Noch keine Instanzen definiert.",
"User Processes" => "Benutzer-Prozesse",
"Install &amp; Update Profile" => "Installiere &amp; Update Profil",
"Bare-bones default install" => "Schlanke Standard-Installation",
"Personal Blog and Profile" => "Persönliches Blog und Profil",
"Company Intranet" => "Firmen-Intranet",
"Use cache for external pages" => "Cache für externe Seiten benutzen",
"All games are from" => "Alle Spiele von",
"visit the site for more games and fun" => "Besuchen Sie die Site für weitere Spiele und Unterhaltung.",
"Upload a game" => "Ein Spiel hochladen",
"Upload a new game" => "Ein neues Spiel hochladen",
"Flash binary (.swf or .dcr)" => "Flash-Binary (.swf oder .dcr)",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Thumbnail (Wenn das Spiel foo.swf heißt, muss der Thumbnail foo.swf.gif, foo.swf.png oder foo.swf.jpg heißen)",
"Edit game" => "Spiel bearbeiten",
"Played" => "Gespielt",
"If you can't see the game then you need a flash plugin for your browser" => "Wenn Sie das Spiel nicht sehen können, benötigen Sie ein Flash-Plugin für Ihren Browser.",
"Accepted requests" => "Bearbeitete Anfragen",
"since" => "seit",
"Assigned items" => "Zugewiesene Einträge",
"Select news group" => "Newsgroup auswählen",
"Back to servers" => "Zurück zur Serverübersicht",
"Msgs" => "Nachrichten",
"Back to groups" => "Zurück zu Gruppen",
"Save position" => "Position speichern",
"Reading article from" => "Artikel lesen aus",
"Back to list of articles" => "Zurück zur Artikelübersicht",
"Configure news servers" => "Newsserver-Konfiguration",
"Configure Newsreader" => "Newsreader konfigurieren",
"Select a news server to browse" => "Auswahl des Newsservers",
"server" => "Server",
"News server" => "Newsserver",
"Current permissions for this object" => "Aktuelle Berechtigungen für dieses Objekt",
"No category permissions; global permissions apply" => "Keine Kategorieberechtigungen vergeben; Globale Berechtigungen greifen",
"Tiki Shoutbox" => "Tiki-Shoutbox",
"big grin" => "grinsend",
"cry" => "weinend",
"eek" => "erschrocken",
"evil" => "böse",
"lol" => "lachend",
"smile" => "lächelnd",
"surprised" => "überrascht",
"arrow" => "Pfeil",
"Current folder" => "Aktueller Ordner",
"This user is your friend" => "Dieser Benutzer ist Ihr Freund",
"Your personal Wiki Page" => "Ihre persönliche Wiki-Seite",
"Confirm new password" => "Paßwort bestätigen",
"Current password (required)" => "aktuelles Paßwort (erforderlich)",
"Edit Items" => "Einträge bearbeiten",
"List Charts" => "Hitlisten anzeigen",
"Last Chart" => "Neueste Hitliste",
"Previous Chart" => "Vorherige Hitliste",
"Chart created" => "Hitliste erstellt",
"Next Chart" => "Nächste Hitliste",
"chg" => "Änderung",
"Avg" => "Durchschnitt",
"Next chart will be generated on" => "Nächste Hitliste wird erstellt am",
"View or vote items not listed in the chart" => "Einträge anzeigen oder für welche stimmen, die nicht in dieser Hitliste vorhanden sind",
"Select something to vote on" => "Etwas auswählen, für das Sie stimmen wollen",
"Item information" => "Info über Eintrag",
"Dif" => "Diff",
"Best Position" => "Beste Position",
"Vote this item" => "Für diesen Eintrag stimmen",
"Highest" => "Höchste",
"RSS settings" => "RSS-Feed Einstellungen",
"No chart indicated" => "Keine Hitliste angegeben",
"No category indicated" => "Keine Kategorie angegeben",
"No process indicated" => "Kein Prozess angegeben",
"Activity name already exists" => "Aktivität mit diesem Namen existiert bereits",
"indicates if the process is active. Invalid processes cant be active" => "zeigt an ob der Prozess aktiv ist. Ungültige Prozesse können nicht aktiviert werden",
"No instance indicated" => "Keine Instanz angegeben",
"No activity indicated" => "Keine Aktivität angegeben",
"The process name already exists" => "Dieser Prozessname ist bereits vergeben",
"Process already exists" => "Dieser Prozess existiert schon",
"You cant execute this activity" => "Sie können diese Aktivität nicht ausführen",
"No title indicated" => "Kein Titel angegeben",
"No comment indicated" => "Kein Kommentar angegeben",
"No date indicated" => "Kein Datum angegeben",
"The thumbnail name must be" => "Der Thumbnail-Name muss sein",
"No server indicated" => "Kein Server angegeben",
"Cannot connect to" => "Konnte Verbindung nicht herstellen zu",
"Missing information to read news (server,port,username,password,group) required" => "Zum Lesen von News fehlen Daten (Server,Port,Username,Paßwort,Gruppe)",
"Cannot get messages" => "Kann keine Nachrichten abholen",
"A password and your IP address reminder email has been sent " => "Eine Erinnerungsnachricht mit dem Passwort (und Ihrer IP Adresse) wurde verschickt ",
"Select the installation profile to use. This profile will populate the database." => "Wählen Sie ein Installations-Profil. Das Profil definiert, wie die Datenbank bestückt wird.",
"Profiles can be used to pre-configure your site with specific features and settings." => "Je nach Profil wird Tiki unterschiedlich, mit mehr oder weniger aktivieren Funktionen installiert.",
"Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information." => "Weitere Informationen dazu finden sich auf <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a>.",
"Validate and Continue" => "Prüfen und weiter",
"Create a new database (clean install) with profile:" => "Neue Datenbank über Profil anlegen (nur bei Neuinstallation):",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles." => "Siehe auch Dokumentation unter <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Beschreibung der Profile\">Beschreibung der Profile.",
"Tiki Calendar" => "Tiki Kalender",
"Admin Menu" => "Menü verwalten",
"RSS Modules" => "RSS-Module",
"Import PHPWiki Dump" => "PHPWiki Dump importieren",
"Current events" => "Aktuelle Termine",
"User informations" => "Benutzer-Infos",
"Group informations" => "Gruppen-Infos",
"Email This Post" => "Diesen Beitrag verschicken",
"RSS feeds" => "RSS-Feeds",
"Use titles in blog posts" => "Überschriften in Blog-Einträgen verwenden",
"Send blog post" => "Sende Blog-Eintrag",
"A link to this post was sent to the following addresses:" => "Ein Link auf diesen Eintrag wurde an folgende Adressen verschickt:",
"Send post to this addresses" => "Eintrag an diese Adressen verschicken",
"List of email addresses separated by commas" => "Liste der eMail-Adressen (kommagetrennt)",
"Compose Message" => "Nachricht erstellen",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> erfolgreich gelöscht.",
"database queries used in" => "Datenbank-Aufrufe in",
"Dynamic content" => "Dynamische Inhalte",
"View submissions" => "Einreichungen ansehen",
"Tiki version" => "Tiki-Version",
"List Forums" => "Foren auflisten",
"Submit a new link" => "Neuen Link einreichen",
"preference name" => "Einstellungsname",
"Your preferred language" => "Meine bevorzugte Sprache",
"Annoncieren" => "Ankündigung",
"Description text is wiki-parsed" => "Wiki-Parser auch für Beschreibung benutzen",
"Prevent flooding" => "Flooding verhindern",
"Minimum time between posts" => "Minimale Zeit zwischen zwei Beiträgen",
"Moderator user" => "Moderator",
"Moderator group" => "Moderatoren-Gruppe",
"Only allow replies to the first message (flat forum)" => "Nur Anworten auf den ersten Beitrag erlauben (flaches Forum)",
"Send this forums posts to this email" => "Beiträge in diesem Forum an eMail-Adresse weiterleiten",
"Prune unreplied messages after" => "Nicht beantwortete Nachrichten löschen nach",
"Prune old messages after" => "Alte Nachrichten löschen nach",
"POP3 server" => "POP3 Server",
"Max attachment size (bytes)" => "Maximale Größe (Bytes)",
"Default ordering for topics" => "Standardsortierung für Themen",
"Topics per page" => "Themen pro Seite",
"Default ordering for threads" => "Standardsortierung für Threads",
"Tiki was unable to retrieve login data from the database " => "TikiWiki konnte keine Login-Daten aus der Datenbank abrufen. ",
"The following error message was returned" => "Es wurde folgende Fehlermeldung zurückgegeben:",
"Things to check" => "Zu Überprüfendes",
"Are your database login credentials correct" => "Sind Ihre Datenbank-Zugangsdaten korrekt ?",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Haben Sie die<a href='tiki-install.php' >TikiWiki Installion abgeschlossen ?",
"Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Bitte sehen Sie in der  <a href=\"http:doc.tikiwiki.org/\">Dokumentation</a> nach weiteren Informationen.",
"Your post has not been posted" => "Dein Beitrag wurde nicht gepostet",
"PHP version" => "PHP Version",
"This instance of activity is already complete" => "Diese Aktivität ist bereits abgeschlossen",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Fatal error: nextActivity passt zu keiner autorouting switch activity",
"Fatal error: non-deterministic decision for autorouting activity" => "Fatal error: nicht-deterministische Entscheidung für autorouting activity",
"Cannot add transition only split activities can have more than one outbound transition" => "Kann keinen Übergang hinzufügen. Nur gesplittete Aktivitäten können mehr als einen Übergang haben.",
"Circular reference found some activity has a transition leading to itself" => "Zirkuläre Referenz. Eine Aktivität hat einen Übergang zu sich selbst.",
" is non-interactive and non-autorouted but has no role assigned" => " ist nicht interaktiv und nicht autorouted, aber hat keine festgelegte Aufgabe.",
" is not mapped" => " is not mapped",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "Activität '.\$res['name'].' ist standalone and benutzt \$instance object",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "Activität '.\$res['name'].' ist interaktiv. Du musst die \$instance->complete() Methode verwenden.",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "Activity '.\$res['name'].' ist nicht-interactiv. Du kannst die \$instance->complete() Methode NICHT verwenden.",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "Activity '.\$res['name'].' ist switch. Du musst die \$instance->setNextActivity(\$actname) Methode verwenden.",
"Cannot write to this file: " => "Kann Datei nicht beschreiben: ",
"Use this thread to discuss the %s page." => "Benutze diesen Thread um die %s Seite zu diskutieren.",
"There was a problem with your upload." => "Es gab ein Problem mit dem Upload.",
"The file you are trying to upload was only partially uploaded." => "The file you are trying to upload was only partially uploaded.",
"You must select a file for upload." => "Du musst eine Datei zum Upload auswählen",
"%s is an empty archive file" => "%s ist eine leere Archiv-Datei",
"Project Group for " => "Projektgruppe für ",
"Project Admin Group for " => "Projekt-Admin-Gruppe für ",
"tikiwiki logo" => "Tikiwiki logo",
"cannot be found" => "kann nicht gefunden werden",
"An error occured in a database query!" => "Es ist ein Fehler in einer Datenbankabfrage aufgetreten.",
"Altering database table failed" => "Das Umstellen der Datenbank-Tabelle ist fehlgeschlagen.",
"__WARNING__: No such module \$plugin! " => "__WARNUNG__: Kein derartiges Modul vorhanden: \$plugin! ",
"Table Of Contents" => "Inhaltsverzeichnis",
"(unchanged)" => "(unverändert)",
"field is not numeric" => "Feld ist nicht numerisch",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Text Optionen:1,Größe,Vorstehendes,Nachstehendes,max Größe in Zeichen, Vorangestelltes wird vor dem Feld, Nachstehendes direkt hinter dem Feld angezeigt, max ist die maximale Anzahl an Zeichen, die gespeichert werden kann und eine führende 1 setzt das nächste Textfeld oder Checkbox in die gleiche Reihe. Wenn Sie nur eine 1 angeben, wird das nächste Feld in der gleichen Reihe dargestellt.",
"Textarea options: quicktags,width,height,max,listmax - Use Quicktags is 1 or 0, widthis indicated in chars, height is indicated in lines, max is the maximum number of characters that can be saved, listmax isthe maximum number of characters that are displayed in list mode. " => "Textbereich Optionen: quicktags,Breite,Höhe,max,listmax -Use Quicktags ist 1 oder 0, die Länge wird in Zeichen angegeben, die Höhe in Zeilen. Max ist die maximale Anzahl an Zeichen, die gespeichert werden können, listmax ist die maximale Anzahl an Zeichen die im List-Modus dargestellt werden können.",
"Numeric options: 1,size,prepend,append with size in chars,prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Numerische Optionen: 1,Größe,Vorangestelltes,Nachgestelltes mit Größe in Zeichen, Vorangestelltes wird vor dem Feld, Nachstehendes direkt hinter dem Feld angezeigt, und eine führende 1 setzt das nächste Textfeld oder Checkbox in die gleiche Reihe. Wenn Sie nur eine 1 angeben, wird das nächste Feld in der gleichen Reihe dargestellt.",
"Dropdown options: list of items separated with commas." => "Dropdown Optionen: Aufzählungen in der Liste mit Kommas trennen.",
"Radio buttons options: list of items separated with commas." => "Radio buttons Optionen: Aufzählungen in der Liste mit Kommas trennen.",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "Benutzer auswählen: Benutzen Sie die Optionen für das automatische Füllen der Felder:  1 für den Autor-Login oder 2 für den Modifikator-Login.",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Gruppen auswählen: Benutzen Sie die Optionen für das automatische Füllen der Felder: 1 für die Gruppe der Erstellung und 2 für die Gruppe in der die Modifikationen vorgenommen werden. Es muss eine Standardgruppe gestzt werden oder die erste Gruppe wird für einen Benutzer ausgewählt oder die Standardgruppe wird als Registriert gesetzt.",
"Country Selector options: 1|2 where 1 show only country name and 2 show only country flag. By default show both country name and flag" => "Optionen für die Länderauswahl: 1|2, dabei zeigt 1 nur den Ländernamen und 2 nur die Flagge. Als Standard ist die Anzeige des Namens und der Flagge gesetzt.",
"Image options: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale indicated in pixels." => "Bildoptionen: xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale angegeben in Pixeln.",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Aktion Optionen: Label,post,tiki-index.php,page:fieldname,highlight=test",
"Category options: parentId,radio|checkbox(default)" => "Kategorie Optionen: parentId,radio|checkbox(Standard)",
"Item Link options: trackerId,fieldId,linkToItem links to item from trackerId which fieldId matches the content of that field. linkToItem 1|0 to create a link to the item in view mode and listing" => "Item Link Optionen: trackerId,fieldId,linkToItem links vom item zur trackerId deren fieldId mit dem Inhalt des Feldes überein stimmt.linkToItem 1|0 erzeugt einen Link zu einem Item im Lesemodus",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere. linkToItems 1|0 to create a link to items in view mode and listing" => "Items Liste Optionen: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere, linkToItems zeigt eine Liste von items in einem Tracker trackerId in dem fieldIdThere mit fieldIdHere überein stimmt. linkToItems 1|0 erzeugt einen Link zu Items im Lesemodus.",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "E-Mail-Adress-Optionen: 0|1|2 wobei 0 die Adresse im plain text darstellt, 1 erzeugt einen hex mailto link (schwieriger für web spider zu erfassen und hilfreich gegen Spam) 2 erzeugt einen normalen href mailto_Link.",
"Remaining:" => "Übrig bleiben:",
"Old:" => "Alt:",
"New:" => "Neu:",
"Include all post in a blog" => "Umfasst alle Beiträge in einem Blog",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName,type=>type,categId=>Category parent ID,sort=>columnName_asc|columnName_desc)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>topicName,type=>type,categId=>Category parent ID,sort=>columnName_asc|columnName_desc)}{ARTICLES} Fügt Artikel auf einer Wiki-Seite ein.",
"no such attachment on this page" => "Kein anhang zu dieser Seite vorhanden.",
"0" => "\r\n \t\tname => Zeigt den Namen der angehängten Datei zum Verlinken.\r\n \t\tfile => Ebenso wie Name\r\n \t\tpage => Gibt den Namen der Seite an, an die die Datei angehängt ist. Auf die entsprechende Datei wird verlinkt. Funktioniert nur bei Wiki-Seiten.\r\n \t\tshowdesc => zeigt die Beschreibung als Linktext anstelle des Dateinamens \r\n\t\tbullets => Macht aus einer Liste der Anhänge eine Liste mit Gliederungspunkten. \r\n \t\timage => Besagt, dass die Datei eine Bilddatei ist und in einem im img tag verwendet werden sollte.\r\n \t\tinline => setzt alles zwischen den {ATTACH} tags als Linktext anstelle des Dateinamens oder der Beschreibung.\r\n \t\tall => Zeigt alle Anhänge des gesamten Wikis.\r\n \t\tnum => \r\n \t\tname => Zeigt den Namen der angehängten Datei zum Verlinken.\r\n \t\tfile => Ebenso wie Name\r\n \t\tpage => Gibt den Namen der Seite an, an die die Datei angehängt ist. Auf die entsprechende Datei wird verlinkt. Funktioniert nur bei Wiki-Seiten.\r\n \t\tshowdesc => zeigt die Beschreibung als Linktext anstelle des Dateinamens \r\n\t\tbullets => Macht aus einer Liste der Anhänge eine Liste mit Gliederungspunkten. \r\n \t\timage => Besagt, dass die Datei eine Bilddatei ist und in einem im img tag verwendet werden sollte.\r\n \t\tinline => setzt alles zwischen den {ATTACH} tags als Linktext anstelle des Dateinamens oder der Beschreibung.\r\n \t\tall => Zeigt alle Anhänge des gesamten Wikis.\r\n \t\tnum =>Zeigt die Nummer des Anhangs auf den verlinkt wird in der Anhangliste \r\n \t\tid => Zeigt die tatsächliche ID des Anhangs auf den verlinkt wird. Es ist nicht sinnvoll das zu verwenden.\r\n \t\tdls => Zeigt die anzahl der Downloads im alt comment an.\r\n \t\ticon => Zeigt ein Datei Icon\r\n    ",
"Insert a division block on wiki page" => "Fügt einen Trennblocl auf einer Wiki-Seite ein.",
"Formula" => "Formel",
"No formula specified." => "Keine Formel ausgewählt.",
"Impossible to render the graphic." => "Graphik kann nicht gerendert werden.",
"View graphic" => "Graphik ansehen",
"Displays an miniquiz" => "zeigt ein Miniquiz.",
" wrote:" => " wrote:",
"~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} Fügt die Ausgabe eines RSS Feeds auf einer Wiki-Seite ein.",
"All fileds must be from the same tracker" => "Alle Felder müssen aus ein und demselben Tracker stammen.",
"missing tracker ID for plugin TRACKER" => "Fehlende Tracker ID für das Plugin TRACKER",
"missing fields list" => "Fehlende Feldliste",
"A wildcard pattern of originating pages to be ignored.<br />" => "A wildcard pattern of originating pages to be ignored<br />",
"The character, by which ignored patterns are separated.<br />" => "The character, by which ignored patterns are separated.<br />",
"Whether to include external wikis in the list.<br />" => "Fügt externe Wikis in die Liste ein.<br />",
"Collect either originating or wanted pages in a cell and display them in the second column.<br />" => "Sammelt entweder die original Seiten oder die gesuchten Seiten in einer Zelle und stellt sie in einer zweiten Spalte dar.<br />",
"Switch-on debug output with details about the items.<br />" => "Einschaltbare debug Ausgabe mit Details zu den Items.<br />",
"Multiple collected items are separated in distinct table rows, or by comma or line break in one cell.<br />" => "Mehrfach gesammelte Items werden in unterschiedlichen Tabellenreihen einzeln aufgeführt oder durch Kommata oder Zeilenumbrüchen in einer Zelle.<br />",
"Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex.<br />" => "Filtert die Liste der gesuchten Wiki-Seiten mittels page_regex oder individuellem Filter. DEr Standardwert ist der __aktuelle__ page_regex der Site.<br />",
"A custom filter for wanted pages to be listed (only used when level=>custom).<br />" => "Ein individueller Filter um gesuchte Seiten aufzulisten (nur benutzbar wenn der Level=>individuell).<br />",
"list topics with links to the articles" => "listet die Überschriften als Links zu den Artikeln",
"move %s in %s" => "verschiebe %s nach %s",
"Please provide an Id" => "Bitte geben Sie eine Id an",
"This module requires parameters trackerId and name set" => "Dieses Modul erfordert die Parameter trackerID und name set",
"Workspace not selected" => "Workspace nicht ausgewählt",
"Resource type not selected" => "Resourcentyp nicht ausgewählt.",
"Owner not set" => "Eigentümer nicht angegeben",
"Permission denied you cannot create new resources" => "Keine Berechtigung um neue Resourcen zu erzeugen.",
"Name requiered" => "Name erforderlich",
"Permission denied, you cannot admin the workspace" => "Keine Berechtigung um den Workspace zu verwalten.",
"group not found" => "Gruppe nicht gefunden",
"group already exist" => "Gruppe besteht bereits",
"user not found" => "Benutzer nicht gefunden.",
"the main workspace group cant be removed" => "Die Hauptgruppde des Workspace kann nicht gelöscht werden.",
"Page not found\".\" \".\$page));\r\n\t}\r\n}elseif (!\$exit_module){\r\n\t\$smarty->assign('error_msg', tra(\"Param name not found" => "Seite nicht gefunden\".\" \".\$page));\r\n\t}\r\n}elseif (!\$exit_module){\r\n\t\$smarty->assign('error_msg', tra(\"Param Name nicht gefunden",
"Param name not found" => "Param Name nicht gefunden",
"download" => "download",
"Perhaps you were looking for:" => "Suchen Sie vielleicht das hier ?",
"Last update from CVS" => "Letztes Update von CVS",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "Schließen Sie die Tags in Leerzeichen ein. Für Tags, die aus mehr als einem Wort bestehen, lassen Sie bitte keine Leerzeichen zwischen den Wörtern, sondern ziehen Sie sie zu einem zusammen.",
"Your Tiki account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "Ihre TikiWiki Registrierungsanfrage für {\$mail_site} wurde von einem Admin geprüft und Ihr Zugang ist nun freigeschaltet.",
"Tiki User Account Activated" => "Ihr TikiWiki Benutzerzugang ist jetzt freigeschaltet",
"Someone coming from IP Address" => "Jemand mit der IP Adresse",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\r\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\r\n\r\nDone! You should be logged in." => "Bitte klicken Sie auf den folgenden Link um zu bestätigen, dass Sie das Passwort zurücksetzen möchten und gehen Sie zu der Maske in der Sie ein neues \"permanentes\" Passwort eingeben müssen. Bitte wählen Sie ein Passwort, das nur Sie kennen und teilen Sie es niemandem mit.\r\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\r\n\r\n Fertig! Sie können sich jetzt einloggen.",
"New article post at %s" => "Neuer Artikel gepostet am %s",
"Zoom out x4" => "Vierfach vergrößern",
"Zoom out x3" => "Dreifach vergrößern",
"Zoom in x3" => "Dreifach verkleinern",
"Zoom in x4" => "Vierfach verkleinern",
"older version" => "ältere Version",
"Message Broadcast" => "Nachricht senden",
"If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Wenn Sie möchten, dass andere Ihnen antworten können, müssen Sie die <a href='tiki-user_preferences.php'> überprüfen. Erlauben Sie Nachrichten von anderen Benutzern</a>",
"WfMenu" => "WfMenü",
"FriendsMenu" => "FreundeMenü",
"WikiMenu" => "WikiMenü",
"GalMenu" => "GalMenü",
"ForMenu" => "ForMenü",
"DirMenu" => "DirMenü",
"FileGalMenu" => "FileGalMenü",
"QuizMenu" => "QuizMenü",
"ShtMenu" => "ShtMenü",
"TrkMenu" => "TrkMenü",
"SrvMenu" => "SrvMenü",
"Send events" => "Sende Termine",
"Admin events" => "Verwalte Termine",
"EphMenu" => "EphMenü",
"ChartMenu" => "ChartMenü",
"AdmMenu" => "AdmMenü",
"Last `\$module_rows` blog comments" => "Neueste `\$module_rows` Blogkommentare",
"Last blog comments" => "Neueste Blogkommentare",
" on blogpost " => " zu Blogeintrag ",
"Top `\$module_rows` topics" => "Top `\$module_rows` Themen",
"Folksonomy" => "Folksonomy",
"My prefered tags" => "Meine bevorzugten Tags",
"Last `\$module_rows` Images" => "Neueste `\$module_rows` Bilder",
"Last `\$module_rows` modified events" => "Neueste `\$module_rows` Terminänderungen",
"Last `\$module_rows` Page Changes" => "Neueste `\$module_rows` Seitenänderungen",
"Last Page Changes" => "Neueste Seitenänderungen",
"Last `\$module_rows` Modified Comments" => "Neueste `\$module_rows` Kommentare",
"Last Modified Comments" => "Neueste Kommentare",
"Last `\$module_rows` visitors" => "Zuletzt anwesende`\$module_rows` Besucher",
"Random Images" => "Zufällige Bilder",
"RSS Feeds" => "RSS Feeds",
"Top `\$module_rows` Forum Posters" => "Top `\$module_rows` Forum Poster",
"Top `\$module_rows` Objects" => "Top `\$module_rows` Objekte",
"Upcoming `\$module_rows` events" => "Bevorstehende `\$module_rows` Termine",
"You need to activate user and/or group trackers" => "Sie müssen die Benutzer - und/oder Gruppentracker aktivieren.",
" on page " => " auf Seite ",
"AulaWiki Assistant" => "AulaWiki Assistent",
"Welcome to AulaWiki" => "Willkommen zu AulaWiki",
"First configuration steps" => "Erste Konfigurationsschritte",
"module" => "Modul",
"to the users that you want to use AulaWiki workspaces" => "die Benutze, die die AulaWiki Workspaces benutzen sollen.",
"Change theme" => "Theme ändern",
"to workspaces.css" => "nach workspaces.css",
"Define the <a class='link' href=\"./tiki-workspaces_roles.php\">workspace roles</a> and permission levels." => "Definieren Sie die <a class='link' href=\"./tiki-workspaces_roles.php\">workspace Rollen</a> und Rechte Level.",
"Define the <a class='link' href=\"./tiki-workspaces_types.php\">workspace types</a> , use MenuID 100 or <a class='link' href=\"./tiki-admin_menus.php\">define your own menu</a>. Assign <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> default resources and <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> desktop modules." => "Definieren Sie die <a class='link' href=\"./tiki-workspaces_types.php\">Workspace-Typen</a> , indem Sie die MenuID 100 benutzen oder <a class='link' href=\"./tiki-admin_menus.php\">definieren Sie Ihr eigenes Menü</a>. Weisen Sie <img src='img/icons/change.gif' border='0' alt='Workspace type resources' title='Workspace type resources' /> die Standardresourcen und <img src='img/icons/mo.png' border='0' alt='Assigned modules' title='Assigned modules' /> Desktop Module zu.",
"Create a workspace" => "Erstellen Sie einen Workspace",
"of the previosly defined type" => "vom zuvor definierten Typ",
"Assign workspace users and groups" => "Weisen Sie Workspace Benutzer und Gruppen zu",
"Admin the workspace resources" => "Verwalten Sie die Workspace-Resourcen",
"View the workspace desktop" => "View the workspace desktop",
"Break module" => "Break module",
"Workspace Calendar" => "Workspace Kalender",
"List events" => "Liste Termine",
"Child Workspaces" => "Child Workspaces",
"Inactive workspace" => "Inaktiver Workspace",
"Clipboard" => "Clipboard",
"Empty clipboard" => "Leeres clipboard",
"Workspace History" => "Workspace History",
"\$title" => "\$title",
"prev posts" => "vorherige Beiträge",
"next posts" => "nächste Beiträge",
"prev files" => "vorherige Dateien",
"next files" => "nächste Dateien",
"prev images" => "vorherige Bilder",
"next images" => "nächste Bilder",
"My Workspaces" => "Meine Workspaces",
"Current workspace:" => "Aktueller Workspace:",
"Active workspace" => "Aktiver Workspace",
"My workspaces:" => "Meine Workspaces:",
"Resources" => "Resourcen",
"Object type:" => "Objekttyp:",
"are you sure to remove object " => "Sind Sie sicher, dass Sie dieses Objekt löschen wollen ? ",
"UserGroups" => "Benutzergruppen",
"Group Name:" => "Gruppenname:",
"are you sure to remove group " => "Sind Sie sicher, dass Sie diese Gruppe löschen wollen ?",
"are you sure to remove user from group " => "Sind Sie sicher, dass Sie diesen Benutzer aus der Gruppe löschen wollen ?",
"View Structure" => "Betrachte Struktur",
"Workspace Members" => "Workspace Mitglieder",
"offline users" => "offline Benutzer",
"Click to see the ratings" => "Klicken Sie um die Bewertung zu sehen",
"error" => "Fehler",
"Are you sure you want to remove this module?" => "Sind Sie sicher, dass Sie dieses Modul löschen wollen ?",
"last modification:" => "Letzte Änderung:",
"logout" => "Ausloggen",
"List pages where I am a modificator" => "Liste die Seiten auf, die von mir geändert wurden",
"Skip to navigation" => "Springe zur Navigation",
"RSS Trackers" => "RSS Tracker",
"Note: if you want to use images please save the post first and you\r\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\r\n\tor use the image URL to include images using the WYSIWYG editor. " => "Hinweis: Wenn Sie Bilder einfügen möchten, speichern Sie bitte zuerst Ihren Beitrag, damit und \r\n\t Sie Bilder bearbeiten oder hinzufügen können. Nutzen Sie den &lt;img&gt; Schnipsel um die hochgeladenen Bilder im Texteditor zu bearbeiten \r\n\t oder verwenden Sie die URL des Bildes um es im WYSIWYG Editor einzufügen. ",
"Translate in" => "Übersetze nach",
"babelfish it" => "babelfish it",
"Welcome to" => "Willkommen in",
"Personal portfolio" => "Persönliches Portfolio",
"UserPreferences tpl" => "Benutzereinstellungen tpl",
"Your personal tracker information" => "Ihre persönliche Tracker Information",
"Edit information" => "Bearbeite Information",
"Site Calendar" => "Site Kalender",
"Featured Help" => "Empfohlene Hilfe",
"Template Viewing" => "Template-Ansicht",
"Tracbacks Pings" => "Tracbacks Pings",
"Workspaces" => "Workspaces",
"System Features" => "System Funktionen",
"Signal System" => "Signal System",
"Freetags rock!" => "Freetags rock!",
"Freetag Browsing" => "Freetag Browsing",
"Show Tag Cloud" => "Zeige Tag Wolke",
"Number of Tags to show in Cloud" => "Anzahl der Tags in der Wolke",
"Freetag 3D Browser Configuration" => "Freetag 3D Browser Konfiguration",
"(standard)" => "(Standard)",
"HTTPS Server" => "HTTPS Server",
"Google Map setup" => "Google Map Setup",
"You need to request a Google Maps Schlüssel für diese Website. Sie können einen Schlüssel für Ihre Domain generieren unter:" => "Sie müssen einen Google Maps Schlüssel für diese Website anfordern. Hier können Sie einen Schlüssel generieren:",
"Google Map Key" => "Google Map Schlüssel",
"Intertiki exchange feature" => "Intertiki exchange Funktion",
" - Php GD library required" => " - Php GD Bibliothek erforderlich",
"Geourl" => "Geourl",
"Editor" => "Editor",
"Webmaster" => "Webmaster",
"Search may show forbidden results. Much better performance though." => "Suche kann verbotene Ergebnisse anzeigen. Bietet aber höhere Effizienz.",
"Wiki Administration" => "Wiki Administration",
"latin" => "Latein",
"Wiki attachments preferences" => "Wiki Einstellungen für Anhänge",
"Admin Action Log" => "Admin Action Log",
"edit contribution" => "Bearbeite contribution",
"Edit action" => "Bearbeite Aktion",
"Help on Banning System" => "Hilfe Banning System",
"admin banning tpl" => "Verwalte banning tpl",
"perso" => "perso",
"admin categories tpl" => "Verwalte Kategorien tpl",
"browse the category system" => "Kategoriensystem durchsuchen",
"Perms inherited from closest parent if possible or from global perms" => "Rechte von den nächsten Eltern erben, falls möglich oder von den globalen Rechten.",
"admin charts template" => "Verwalte charts template",
"Chat Admin tpl" => "Chat Admin tpl",
"admin content templates template" => "Verwalte Inhaltstemplates template",
"use in events" => "Benutze in Terminen",
"admin FortuneCookie tpl" => "Verwalte FortuneCookie tpl",
"Help on Drawings" => "Hilfe für Zeichnungen",
"admin Drawings tpl" => "Verwalte Zeichnungen tpl",
"To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link." => "Um eine Zeichnung auf einer Wiki-Seite zu erstellen, nutzen Sie {literal}{draw name=foo}{/literal}, wobei foo für den Namen der Zeichnung steht. Nachdem dem Speichern klicken Sie auf den Link zu der Zeichnung.",
"admin External Wikis" => "Verwalte externe Wikis",
"admin forums template" => "Verwalte Forentemplate",
"Assign Permissions (Active)" => " Berechtigungen zuweisen(Aktiv)",
"Click here to delete this forum" => "Klicken Sie hier um dieses Forum zu löschen.",
"admin hotwords template" => "Verwalte Hotwordstemplate",
"admin HTML page dynamic zones" => "Verwalte HTML page dynamic zones",
"admin Html Pages" => "Verwalte HTML Seiten",
"admin Html Pages template" => "Verwalte HTML-Seiten-Template",
"Use {literal}{/literal}ed id=name} or {literal}{/literal}ted id=name} to insert dynamic zones" => "Benutzen Sie {literal}{/literal}ed id=name} oder {literal}{/literal}ted id=name} um dynamische Zonen einzufügen",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http:')" => "Pfad zum repository (lokales Dateisystem: relatives/absolutes Wurzelverzeichnis, remote: vorangestellt 'http:')",
"admin featured links template" => "Verwalte featured links template",
"To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> module</a>." => "Um diese Links zu verwenden müssen Sie das <a class=\"rbox-link\" href=\"tiki-admin_modules.php\"> featured-links-Modul</a> zuweisen.",
"admin mailin template" => "Verwalte Mailin-Template",
"admin menu builder" => "Verwalte Menü-Builder",
"admin menus template" => "Verwalte Menü-Template",
"To use menus in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu. To use <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "Um Menüs in einem<a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Site identity</a> oder einem Template zu verwenden, nutzen Sie {literal}{menu id=x}{/literal}, wobei x die ID des Menüs ist. Um <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:phplayersmenu.sourceforge.net/\">phplayersmenu</a> zu verwenden, können Sie eine der drei folgenden Schreibweisen benutzen:",
"This will work well (or not!) depending on your theme. To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:themes.tikiwiki.org\">themes</a>" => "Ob das funktioniert oder nicht ist abhängig von Ihrem gewählten Theme. Um mehr über <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:themes.tikiwiki.org\">Themes</a>",
"admin modules template" => "Verwalte Modul-Template",
"\r\n<b>Note 1</b>: if you allow your users to configure modules then assigned\r\nmodules won't be reflected in the screen until you configure them\r\nfrom MyTiki->modules.<br />\r\n<b>Note 2</b>: If you assign modules to groups make sure that you\r\nhave turned off the option 'display modules to all groups always'\r\nfrom Admin->General\r\n" => "\r\n<b>Hinweis 1</b>: Wenn Sie Ihren Benutzern gestatten Module zu konfigurieren dann erscheinen zugewiesene\r\n Module solange nicht auf dem Bildschirm bis Sie sie konfiguriert haben.<br />\r\n<b>Hinweis 2</b>: Wenn Sie Gruppen Module zuweisen, dann stellen Sie sicher, dass\r\n Sie die Option 'Module immer für alle Gruppen anzeigen' von Admin auf General umgestellt haben.\r\n",
"structure" => "Struktur",
"Group users" => "Gruppenbenutzer",
"admin newsletters template" => "Verwalte Newsletter-Template",
"Allow customized text message" => "Eralube individuelle Textnachricht",
"drafts" => "Entwurf",
"admin notifications template" => "Verwalte NotifikationsTemplate",
"admin polls template" => "Verwalte Umfragentemplate",
"configure polls" => "Konfiguriere Umfragen",
"tiki admin quicktags template" => "tiki admin quicktags template",
"admin RSSmodules template" => "Verwalte RSSFeed-Template",
"To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed." => "Um einen RSS-Feed in einem Textbereich (Wiki-Seite, etc), einem <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a> oder einem Template zu nutzen, verwenden Sie {literal}{rss id=x}{/literal}, wobei x die ID des RSS-Feeds ist.",
"security admin" => "security admin",
"security admin tpl" => "security admin tpl",
"edit tpl" => "Bearbeite tpl",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:security.tikiwiki.org/tiki-contact.php\">report any security issues</a>." => "Für<a class=\"rbox-link\" target=\"tikihelp\" href=\"http:security.tikiwiki.org/tiki-contact.php\">Sicherheitsbelange</a>.",
"admin shoutbox words template" => "Verwalte shoutbox-words-Template",
"admin structures template" => "Verwalte Struktur-Template",
"view webhelp" => "Betrachte Webhelp",
"administer surveys template" => "administer surveys template",
"active perms" => "Aktive Rechte",
"system admin" => "Systemadministrator",
"system admin tpl" => "System admin tpl",
"If your Tiki is acting weird, 1st thing to try it to clear your cache below. Also very important to clear your cache after an upgrade (by FTP/SSH if need be)." => "Wenn sich Ihr Tiki irgendwie seltsam verhält, sollten Sie zunächst den Cache leeren. Außerdem ist es sehr wichtig, dass Sie den Cache nach einem Upgrade leeren. (gegebenenfalls per FTP/SSH ).",
"admin topics template" => "Verwalte Topic-Template",
"visible by admin only" => "nur für den Admin sichtbar",
"admin Trackers tpl" => "Verwalte Tracker-Template",
"Edit tracker" => "Bearbeite Tracker",
"active permissions" => "Aktive Rechte",
"tracker name must be unique, field names must be unique \r\nfor a tracker and they must be valid in SQL" => "Trackername muss eindeutig sein, Feldname muss eindeutig sein \r\nfür einen Tracker und sie müssen SQL-gültig sein",
"Import/Export CSV Data" => "Importiere/Exportiere CSV Daten",
"Download CVS export" => "Download CVS Export",
"File: " => "Datei: ",
"Import file" => "Importiere Datei",
"admin groups template" => "Verwalte Gruppentemplate",
"Create item" => "Erstelle Item",
"remove from group" => "Lösche aus Gruppe",
"admin users template" => "Verwalte UserTemplates",
"Warning: since this tiki site is in slave mode, all user information you enter manually will be automatically overriden by other site's data, including users permissions" => "Warnung: Solange diese Site im Slave-Modus läuft, werden alle Benutzerinformationen, die Sie manuell eingeben, automatisch durch die Daten anderen Sites überschrieben, einschliesslich der Benutzerberechtigungen",
"Updated users" => "Aktualisierte Benutzer",
"edit account settings" => "Bearbeite Zugangseinstellungen",
"edit included group" => "bearbeite eingeschlossene Gruppe",
"remove users and their userpages" => "Lösche Benutzer und ihre Benutzerseiten",
"Tip: hold down CTRL to select multiple" => "Tipp: drücken Sie CTRL für Mehrfachauswahl",
"Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master" => "Warnung: das Ändern eines Benutzernamens erfordert das Ändern des Passwortes durch den Benutzer und führt zu Schwierigkeiten mit Intertiki-Seiten im Slave-Modus, die diese Seite als Master benutzen.",
"Warning: changing the username will require the user to change his password" => "Warnung: Das Ändern des Benutzernamens erfordert das Ändern des Passwortes durch den Benutzer.",
"Batch upload (CSV file<a {popup text='login,password,email,groups<br />user1,password1,email1,&quot;group1,group2&quot;<br />user2, password2,email2'}><img src=\"pics/icons/help.png\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help" => "Batch Upload (CSV Datei<a {popup text='login,password,email,groups<br />user1,password1,email1,&quot;group1,group2&quot;<br />user2, password2,email2'}><img src=\"pics/icons/help.png\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help",
"Article Types tpl" => "Artikeltypen-Template",
"edit article tpl" => "Bearbeite Artikel-Template",
"admin admin tpl" => "Bearbeite Admin-Template",
"Use of this feature is NOT recommended. Please use phpMyAdmin or mysqldump instead." => "Die Verwendung dieser Funktion ist NICHT empfohlen. Bitte nutzen Sie stattdessen phpMyAdmin oder mysqldump.",
"Your image gallery storage is set to \"{\$prefs['gal_use_dir']}\", you will need to backup this using FTP or SCP." => "Ihr Bildergaleriespeicher wurde auf\"{\$prefs['gal_use_dir']}\"gesetzt, Sie müssen einen Backup per FTP oder SCP machen.",
"Your file gallery storage is set to \"{\$prefs['fgal_use_dir']}\", you will need to backup this using FTP or SCP." => "Ihr Dateiarchivspeicher wurde auf\"{\$prefs['fgal_use_dir']}\"gesetzt, Sie müssen einen Backup per FTP oder SCP machen.",
"Note: if you want to use images please save the post first and you\r\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\r\nor use the image URL to include images using the WYSIWYG editor. " => "Hinweis: Wenn Sie Bilder einfügen möchten, speichern Sie bitte zuerst Ihren Beitrag, damit und \r\n\t Sie Bilder bearbeiten oder hinzufügen können. Nutzen Sie den &lt;img&gt; Schnipsel um die hochgeladenen Bilder im Texteditor zu bearbeiten \r\n\t oder verwenden Sie die URL des Bildes um es im WYSIWYG Editor einzufügen. ",
"admin the category system" => "Verwalte das Kategorie-SYstem",
"Browse related users" => "Durchsuchen Sie verwandte Benutzer",
"Network of Users related to" => "Netzwerk verwandter Benutzer",
"Format: mm/dd/yyyy hh:mm<br />..." => "Format: mm/dd/yyyy hh:mm<br />...",
"See strtotime php function" => "Siehe strtotime php function",
"Format: mm/dd/yyy hh:mm<br />..." => "Format: mm/dd/yyy hh:mm<br />...",
"(NOT supported by PDFLIB!)" => "(wird nicht von  PDFLIB unterstützt!)",
"admin directory tpl" => "Verwalte Verzeichnis-Template",
"admin directory categories tpl" => "Verwalte Verzeichniskategorie-Template",
"directory admin related tpl" => "directory admin related tpl",
"directory validate sites tpl" => "directory validate sites tpl",
"edit blog tpl" => "Bearbeite Blog-Template",
"For more information, please see <a href=\"{\$helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "Für weitere Informationen lesen Sie bitte <a href=\"{\$helpurl}Wiki Page Editor\">Wiki-Seiten-Editor</a>",
"underscores" => "Unterstrich",
"colons" => "Doppelpunkt",
"equals" => "Gleichheitszeichen",
"One carat" => "Zirkumflex",
"Will display using the indicated HTML color or color name" => "Zeigt die angegebene HTML-Farbe oder den Farbnamen",
"make headings" => "Überschriften",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache]  (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "Verwenden Sie eckige Klammern für externe Links: [URL] oder [URL|link_Beschreibung] or [URL|Beschreibung|nocache]  (die letzte Schreibweise verhindert, dass Wiki die Seiten im Cache zwischenspeichert; empfohlen für grosse Seiten!).",
"Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Erstellt einen Link zur genannten Datei. Falls die Seite nicht vorhanden ist, muss die Datei an die aktuelle Seite angehängt werden. Falls keine Beschreibung vorhanden ist, wird der Dateiname als Linktext genutzt. Falls Bild=1 gesetzt ist, wird der Anhang als Bild behandelt und direkt auf der Seite angezeigt; es wird kein Link erzeugt.",
"\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ data ~/pp~\" zeigt vorformatierten Text/Code an. In diesen Abschnitten wird kein Wiki-Prozess ausgeführt und Leerzeichen werden fixiert (kein Word-Wrapping)  \"~pre~ data ~/pre~\" zeigt ebenfalls vorformatieten Text mit fixierten Leerzeichen an, aber Wiki-Prozesse werden ausgeführt.",
"\"~tc~ Tiki Comment ~/tc~\" makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  \"~hc~ HTML Comment ~/hc~\" makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "\"~tc~ Tiki Comment ~/tc~\" erstellt einen Tiki-Kommentar. Er wird komplett vom Bildschirm gelöscht, aber in der Datei als zukünftige Referenz gespeichert.  \"~hc~ HTML Comment ~/hc~\" erstellt einen HTML-Kommentar. Er wird als Kommentar in die HTML-Ausgabe eingefügt; solche Kommentar werden normalerweise nicht im Browser angezeigt, sondern können nur in der Quellcodeansicht gelesen werden.",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" erstellt ein Inhaltsverzeichnis für die aktuelle Seite basierend auf der Struktur oder den Überschriften.",
"table new" => "Neue Tabelle",
"wiki link'" => "Wiki-Link'",
"New wms Metadata" => "Neue wms Metadaten",
"New Class" => "Neue Klasse",
"New Projection" => "Neue Projektion",
"New Query" => "Neue Abfrage",
"New Scalebar" => "Neuer Scalebar",
"New Layer" => "Neuer Layer",
"New Label" => "Neuer Label",
"New Reference" => "Neue Referenz",
"New Legend" => "Neue Legende",
"New Web" => "Neues Web",
"New Outputformat" => "Neues Ausgabeformat",
"New Mapfile" => "New Mapfile",
"toggle interactive translation" => "auf interaktive Übersetzung umschalten",
"admin quizzes tpl" => "Verwalte Quiz-Template",
"edit quiz questions" => "Bearbeite Quizfragen",
"edit quiz questions tpl" => "Bearbeite Quizfragen-Template",
"Help on Articles" => "Hilfe für Artikel",
"edit submissions tpl" => "Bearbeite Submission-Template",
"EditTemplates tpl" => "Bearbeite Templates tpl",
"edit translations" => "Bearbeite Übersetzungen",
"edit translations template" => "Bearbeite Übersetzungstemplate",
"Use this section to set the language of the version you are currently working on." => "Stellen Sie in diesem Bereich die Sprache der aktuellen Version, die Sie gerade nutzen ein.",
"Enter the name of the page for which the current page is the translation." => "Geben Sie den Namen der Seite ein, für die die aktuelle Seite eine Übersetzung ist.",
"Draft writen on" => "Entwurf verfasst",
"disable" => "deaktivieren",
"save draft" => "speichere Entwurf",
"admin Ephemerides tpl" => "Verwalte Ephemerides tpl",
"list sheets" => "Liste Blätter auf",
"configure forum" => "Konfiguriere Forum",
"friends tpl" => "Freunde tpl",
"To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:workflow.tikiwiki.org\">Galaxia workflow engine</a>" => "Erfahren Sie mehr über die <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:workflow.tikiwiki.org\">Galaxia workflow engine</a>",
"Expiration Time" => "Ablaufdatum",
"Process Graph" => "Prozessgraph",
"Galaxia Admin Graph" => "Galaxia Admin Graph",
"Galaxia Admin Graph tpl" => "Galaxia Admin Graph tpl",
"Process Graph for" => "Prozess Graph für",
"No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http:www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "Kein Prozessgraph vorhanden. Entweder enthält der Prozess noch Fehler und der Graph wurde noch nicht generiert oder <a href=\"http:www.research.att.com/sw/tools/graphviz/\">GraphViz</a> er wurde nicht ordnungsgemäss installiert.",
"Not Defined" => "Nicht definiert",
"Not Interactive" => "Nicht interaktiv",
"Not Ended" => "Nicht beendet",
"Executed" => "Ausgeführt",
"erase" => "lösche",
"Galaxia Admin Processes" => "Galaxia Admin Prozesse",
"Galaxia Admin Processes tpl" => "Galaxia Admin Prozess tpl",
"Galaxia Monitor Activities" => "Galaxia Monitor Aktivitäten",
"Galaxia Monitor Activities tpl" => "Galaxia Monitor Ativitäten tpl",
"Enter the name of this instance" => "Geben Sie den Namen der Instanz ein",
"The name is not valid. Please, enter the name again" => "Der Name ist ungültig. Bitte geben Sie einen neuen Namen ein.",
"Galaxia Monitor Instances" => "Galaxia Monitor Instanzen",
"Galaxia Monitor Instances tpl" => "Galaxia Monitor Instanzen tpl",
"Not ended" => "Nicht beendet",
"Galaxia Monitor Processes" => "Galaxia Monitor Prozesse",
"Galaxia Monitor Processes tpl" => "Galaxia Monitor Prozesse tpl",
"Instance Id" => "Instanz Id",
"Instance Name" => "Instanz Name",
"Instance Status" => "Instanz Status",
"Elapsed time" => "Verstrichene Zeit",
"Galaxia User Activities" => "Galaxia User Aktivitäten",
"Galaxia User Activities tpl" => "Galaxia User Aktivitäten tpl",
"No processes defined or activated yet" => "Keine Prozesse definiert oder aktiviert bislang",
"Galaxia User Instances" => "Galaxia User Instanzen",
"Galaxia User Instances tpl" => "Galaxia User Instanzen tpl",
"Not defined" => "Nicht definiert",
"Galaxia User Processes" => "Galaxia User Prozesse",
"Galaxia User Processes tpl" => "Galaxia User Prozesse tpl",
"galleries tpl" => "Galerie tpl",
"rebuild cache" => "Cache erneuern",
"Reset view to site-wide default" => "Setze die Ansicht auf den Seitenstandard zurück",
"ImportingPagesPhpWikiPageAdmin" => "ImportingPagesPhpWikiPageAdmin",
"tiki-import_phpwiki tpl" => "tiki-import_phpwiki tpl",
"Closing the window will reload your main browser" => "Wenn Sie dieses Fenster schließen wird Ihr Browser neu geladen",
"list articles tpl" => "Liste Artikel tpl",
"admin Banners tpl" => "Verwalte Banner tpl",
"admin cache tpl" => "Verwalte Cache tpl",
"Help on Dynamic Content" => "Hilfe zu dynamischem Inhalt",
"admin DynamicContent tpl" => "Verwalte DynamicContent tpl",
"list faqs tpl" => "Liste faqs tpl",
"monitor this gallery" => "Überwache diese Galerie",
"stop monitoring this gallery" => "Überwachen dieser Galerie beenden",
"games tpl" => "Spiele tpl",
"list posts tpl" => "Liste posts tpl",
"list quizzes tpl" => "Liste quizzes tpl",
"edit quiz stats tpl" => "Bearbeite quiz stats tpl",
"take survey" => "Nimm an Umfrage teil",
"list trackers tpl" => "Liste trackers tpl",
"admin live support tpl" => "Verwalte live support tpl",
"User Calendar" => "Benutzerkalender",
"User Calendar Doc tpl" => "Benutzerkalender Doc tpl",
"User Calendar Doc" => "Benutzerkalender Doc",
"User Calendar Preferences Doc tpl" => "Benutzerkalendereinstellungen Doc tpl",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:mods.tikiwiki.org\">mods</a>." => "Erfahren Sie mehr über <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:mods.tikiwiki.org\">mods</a>.",
"Apache has the right to write in your file tree, which enables the installation, removal or \r\nupgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \r\n\"./setup.sh\" for example)." => "Apache besitzt das Recht in den Verzeichnisbaum zu schreiben, um die Installation, das Löschen oder ein Upgrade zu veranlassen. Wenn Sie die gewünschten Operationen ausgeführten haben, sollten Sie die Berechtigungen wieder auf einen sicheren Status einstellen.(zum Beispiel mit \r\n\"./setup.sh\" ).",
"To install, remove or upgrade packages you need to give the apache user the right\r\nto write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that\r\npermission (using \"./setup.sh\")." => "Zum Installieren, Löschen oder Upgraden der Pakete müssen Sie Apache das Recht\r\nDateien in Ihrem Verzeichnisbaum zu beschreiben einräumen. (Sie können \"./setup.sh open\" zum Einstellen nutzen.). Nach der Installation sollten Sie dieses\r\nRecht wieder löschen (Nutzen Sie \"./setup.sh\").",
"my tiki tpl" => "Mein Tiki tpl",
"subscribe" => "eintragen",
"Sent edition" => "Gesendete Edition",
"News from" => "Neuigkeiten von",
"configure newsreader server tpl" => "Konfiguriere Newsreader-Server tpl",
"Read the news" => "Neuigkeiten lesen",
"Preview of version" => "Vorschau der Version",
"rollback to this version" => "Zurück zu dieser Version",
"Source of version" => "Quelle der Version",
"Number of voices" => "Anzahl der Stimmen",
"add structure" => "Struktur hinzufügen",
"clear page list" => "Lösche Seitenliste",
"P" => "P",
"F" => "F",
"received articles tpl" => "eingegangene Artikel tpl",
"Help on Communication Center" => "Hilfe für das Kommunikationscenter",
"received pages tpl" => "eingegangene Setien tpl",
"admin Referer stats" => "Verwalte Referer Statistiken",
"admin Referer stats tpl" => "Verwalte Referer stats tpl",
"lowercase only" => "nur Kleinbuschstaben",
"NOTE: Make sure to whitelist this domain to prevent<br />registration emails being canned by your spam filter!" => "Notiz: Stellen Sie sicher, dass diese Domain auf einer Whitelist steht, damit die <br />Registrierungsemail nicht durch den Spamfilter abgefangen wird.",
"Replicate" => "Wiederholen",
"Slave" => "Slave",
"Master" => "Master",
"Operations" => "Operationen",
"Operations Log" => "Operationen Log",
"search stats tpl" => "Suchstatistiken tpl",
"Data HTML" => "Daten HTML",
"Data Txt" => "Daten Txt",
"Save as draft" => "Als Entwurf speichern",
"admin send objects tpl" => "Verwalte gesendete Objekte tpl",
"sheets tpl" => "Blatt tpl",
"create new sheet" => "Erstelle ein neues Blatt",
"admin Tiki Shoutbox tpl" => "VerwalteTiki Shoutbox tpl",
"quater" => "Viertel",
"first" => "erster",
"mr green" => "mr green",
"razz" => "razz",
"redface" => "redface",
"rolleyes" => "rolleyes",
"twisted" => "twisted",
"santa" => "santa",
"SysLog" => "SysLog",
"system logs" => "system logs",
"system logs tpl" => "system logs tpl",
"ThemeControl tpl" => "ThemeControl tpl",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:themes.tikiwiki.org\">themes</a>." => "Erfahren Sie mehr über <a class=\"rbox-link\" target=\"tikihelp\" href=\"http:themes.tikiwiki.org\">Themes</a>.",
"theme control objects tpl" => "theme control objects tpl",
"theme control sections tpl" => "theme control sections tpl",
"You have to \r\ncreate a gallery first!" => "Sie müssen zuerst eine Galerie erzeugen!",
"Image Gallery tpl" => "Bildergalerie tpl",
"User Assigned Modules tpl" => "Benutzer zugewiesene Module tpl",
"User Bookmarks tpl" => "Benutzer Lesezeichen tpl",
"User Tasks tpl" => "Benutzraufgaben tpl",
"accepted by task user and creator" => "angenommen durch den Benutzer der Aufgabe und Ersteller",
"accepted user and creator" => "anerkannter Benutzer und Ersteller",
"not accepted by one user" => "von einem Benutzer nicht akzeptiert",
"not accepted user" => "nicht anerkannter Benutzer",
"waiting for me" => "warten auf mich",
"waiting for other user" => "auf einen anderen User warten",
"red" => "rot",
"User Watches tpl" => "Benutzerbeobachtung tpl",
"edit user files" => "Bearbeite Benutzerdateien",
"permanency" => "permanent",
"view faq tpl" => "Betrachte FAQ tpl",
"admin menus tpl" => "Verwalte Menü tpl",
"You have {\$unread} unread private messages" => "Sie haben {\$unread} ungelesen private Nachrichten",
" item found" => " item gefunden",
" items found" => " items gefunden",
"fields marked with a * are mandatory" => "Mit '*' gekennzeichnete Felder sind zwingend erforderlich",
"remove image" => "Bild löschen",
"Webmail Doc" => "Webmail Doc",
"Webmail Doc template" => "Webmail Doc template",
"Edit mail account" => "Bearbeite E-Mail-Postfach",
"clip" => "clip",
"Workspaces Administration" => "Workspaces Administration",
"Workspace type" => "Workspacetyp",
"Hide workspace" => " Verstecke workspace",
"Hide workspace on the list of user assigned workspaces" => "Verstecke Workspace auf der Liste der benutzerzugewiesenen Workspaces",
"Personal workspace" => "Persönlicher Workspace",
"Assigned modules" => "Zugewiesene Module",
"Users/Groups" => "Benutzer/Gruppen",
"Desktop" => "Desktop",
"Save Zone" => "Speichere Zone",
"Title Style" => "Titelstil",
"Data Style" => "Datenstil",
"Module params" => "Modulparameter",
"Remove zone" => "Lösche Zone",
"Create zone" => "Erstelle Zone",
"No zones defined, please create a first zone to start" => "Keine Zonen definiert, bitte erstellen Sie zuerst eine Zone um zu beginnen.",
"No modules assigned to the zone, please assign a first module" => "Dieser Zone sind keine Module zugewiesen, bitte weisen Sie erst die Module zu.",
"Workspace path:" => "Workspace Pfad:",
"Admin resource" => "Verwalte Resource",
"Roles Administration" => "Rollenadministration",
"Permission group" => "Berechtigungsgruppe",
"Premissions" => "Rechte",
"Workspace Types Administration" => "Workspacetypadministration",
"MenuID" => "MenuID",
"Allow private user zone" => "Zone für private Benutzer zulassen",
"Workspace type roles" => "Workspacetyprollen",
"Workspace type resources" => "Workspacetypresourcen",
"Workspace Types Resources" => "Workspacetypenresourcen",
"Workspace type name" => "Workspacetypname",
"Resource name" => "Resourcenname",
"Resource description" => "Resourcenbeschreibung",
"Resource type" => "Resourcentyp",
"Workspace Type Roles" => "Workspacetyperollen",
"Role name" => "rollenname",
"Role description" => "Rollenbeschreibung",
"Permission Group" => "Berechtigungsgruppe",
"Admin: DSN" => "Verwalte: DSN",
"Admin: External Wikis" => "Verwalte: Externe Wikis",
"Admin: Forums" => "Verwalte: Foren",
"Admin: Hotwords" => "Verwalte: Hotwords",
"Admin: Modules" => "Verwalte: Module",
"The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory." => "Das \"Lsdir Wikiplugin\" ist installiert. Es kann von Wikieditoren genutzt werden um die Inhalte aller Verzeichnisse zu sehen.",
"The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts." => "Das \"Bloglist Wikiplugin\" ist installiert. Es kann von Wikieditoren verwendet werden um private Blogeinträge bekanntzugeben.",
" or " => " oder ",
"Admin: Security" => "Verwalte: Sicherheit",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> zugewiesen an %s <b>%s</b>.",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> gelöscht von %s <b>%s</b>.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "Gruppe <b>%s</b> als Standardusergruppe gesetzt <b>%s</b>.",
"Permission denied; you cannot assign permissions for this category" => "Keine Berechtigung; Sie können dieser Kategorie keine Rechte zuweisen",
"ERROR: you must include a subject or a message at least" => "FEHLER: Sie müssen einen Betreff oder eine Nachricht eingeben",
"Last sites of directory \".\$rc[\"name\"].\" ." => "Letzte Sites des Verzeichnis \".\$rc[\"name\"].\" .",
"I have refused your friendship request!" => "Ich habe deine Freundschaftsanfrage abgelehnt",
"Role name cannot be empty" => "Rollenname kann nicht leer sein",
"Activity name cannot be empty" => "Aktivität kann nicht leer sein",
"A start activity requires a name for the instance" => "Eine Startaktivität erfordert einen Namen für die Instanz",
"You couldn't abort a instance" => "Sie können eine Instanz nicht abbrechen",
"You couldn't exception a instance" => "You couldn't exception a instance",
"The game file must have .swf or .dcr extension" => "Die Spieledatei muss eine .swf oder .dcr -Endung haben",
"Please supply both files" => "Bitte stellen Sie beide Dateien bereit",
"mail adress" => "E-Mail-Adresse",
"A new (and temporary) password and your IP address has been sent " => "Ein neues (und vorläufiges) Passwort und Ihre IP Adresse wurden versendet ",
"changed '%s' from '%s' to '%s'" => "geändert '%s' von '%s' nach '%s'",
"Invalid variable value : " => "Ungültiger Variablenwert : ",
"Invalid password.  Your current password is required to change administrative information" => "Ungültiges Passwort. Ihr aktuelles Passwort ist erforderlich um administrative Änderungen vorzunehmen.",
"Permission denied you cannot remove trackbacks" => "Keine Berechtigung; Sie dürfen keine trackbacks löschen",
"Code in use, please select a different code" => "Code wird verwendet, bitte wählen Sie einen anderen Code.",
"Code not selected" => "Code nicht ausgewählt",
"Workspace not found" => "Workspace nicht gefunden",
"Closed Workspace" => "Geschlossener Workspace",
"Resource name not selected" => "Resourcenname nicht gefunden",
"Resource not found" => "Resource nicht gefunden",
"\"));\r\n\$exit = false;\r\n\r\nif (isset (\$_REQUEST[\"send\"])) {\r\n\r\n\tif (!isset(\$_REQUEST[\"name\"]) || \$_REQUEST[\"name\"]==\"" => "\"));\r\n\$exit = false;\r\n\r\nif (isset (\$_REQUEST[\"send\"])) {\r\n\r\n\tif (!isset(\$_REQUEST[\"name\"]) || \$_REQUEST[\"name\"]==\"",
"Role name not selected" => "Rollenname nicht ausgewählt",
"Role name in use, please select a different name" => "Rollenname wird bereits verwendet, bitte wählen Sie einen anderen",
"Workspace type not found" => "Workspacetyp nicht gefunden",
"Workspace type not selected" => "Workspacetyp nicht ausgewählt",
"Module not set" => "Modul nicht gesetzt",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"Backups" => "Backups",
"QuickTags" => "QuickTags",
"Chat" => "Chat",
"Newsreader" => "Newsreader",
"Workflow" => "Workflow",
"Tiki Logo" => "Tiki Logo",
"switch" => "switch",
"HomePage" => "HomePage",
"UTC" => "UTC",
"JsCalendar" => "JsCalendar",
"Tiki Sheet" => "Tiki Sheet",
"Unix" => "Unix",
"Windows" => "Windows",
"PEAR::Auth" => "PEAR::Auth",
"LDAP Host" => "LDAP Host",
"LDAP Port" => "LDAP Port",
"LDAP Scope" => "LDAP Scope",
"LDAP Base DN" => "LDAP Base DN",
"LDAP Member Is DN" => "LDAP Member Is DN",
"Site Breadcrumbs" => "Site Breadcrumbs",
"Site Logo" => "Site Logo",
"Copyright Management" => "Copyright Management",
"Ver" => "Ver",
"extwiki" => "extwiki",
"online" => "online",
"Optional" => "Optional",
"Channel" => "Channel",
"Ratio" => "Ratio",
"Admin Directory Sites tpl" => "Admin Directory Sites tpl",
"hr" => "hr",
"reject" => "ablehnen",
"split" => "splitten",
"join" => "beitreten",
"standalone" => "standalone",
"auto routed" => "auto routed",
"Int" => "Int",
"Routing" => "Routing",
"Auto routed" => "Auto routed",
"route" => "route",
"Origin" => "Origin",
"new minor" => "new minor",
"new major" => "new major",
"Workitems" => "Workitems",
"Send all to" => "Alles senden an",
"Add property" => "Add property",
"Operation" => "Operation",
"Shared code" => "Shared code",
"Get property" => "Get property",
"Set property" => "Set property",
"Process form" => "Process form",
"Set Next act" => "Set Next act",
"If:SetNextact" => "If:SetNextact",
"Switch construct" => "Switch construct",
"Monitor workitems" => "Monitor workitems",
"List of workitems" => "Liste der workitems",
"exception instance" => "exception instance",
"exceptions instance" => "exceptions instance",
"send instance" => "send instance",
"grab instance" => "grab instance",
"Inst Status" => "Inst Status",
"Browsing Workitem" => "Browsing Workitem",
"Workitem information" => "Workitem information",
"hist" => "hist",
"Dls" => "Dls",
"adm" => "adm",
"Newsgroup" => "Newsgroup",
"wiki create" => "Wiki erstellen",
"wiki overwrite" => "Wiki überschreiben",
"info/vote" => "info/wählen",
"Permanency" => "Permanency",
"A" => "A",
"Post recommendation at" => "Post recommendation at",
"usernames separated with ," => "Benutzernamen mit , trennen",
"You have mistyped the anti-bot verification code; please try again" => "Sie haben den Anti-Bot-Verifizierungscode falsch eingegeben. Bitte versuchen Sie es noch einmal.",
"Select a Wiki page to link to" => "Wählen Sie eine Wiki Seite zum Verlinken aus",
"Cannot open this file" => "Datei kann nicht geöffnet werden.",
"No file was uploaded" => "Keine Datei hochgeladen",
"Missing a temporary folder" => "Temporärer Ordner fehlt",
"Failed to write file to disk" => "Datei konnte nicht auf die Disk geschrieben werden",
"Default: 10" => "Standard: 10",
"This poll is closed" => "Diese Umfrage ist geschlossen",
"Allow users to change the language of the menus and labels" => "Erlaubt Benutzern die Sprache der Menüs und Labels zu ändern",
"Allow anonymous visitors to use the \"Contact Us\" feature" => "Erlaubt anonymen Benutzern die Verwendung der \"Kontaktiere Uns\" Funktion",
"Experimental. This feature is still under development" => "Experimental. Diese Funktion ist noch in der Entwicklung",
"layer" => "Schicht",
"Record" => "Datensatz",
"Enables searching for content on the website" => "Ermöglicht das Suchen nach Inhalten auf der Website",
"Experimental. This feature is not actively maintained" => "Experimental. Diese Funktion wird nicht aktiv unterstützt.",
"Display the internal page ID when viewing the page" => "Zeige interne Seiten-Id beim Betrachten der Seite",
"Css Menus (suckerfish)" => "Css Menüs (Suckerfish)",
"Includes" => "Beinhaltet",
"Assign Perms to this Group" => "Dieser Gruppe Rechte zuweisen",
"Assign permissions to category" => "Berechtigungen zuweisen für Kategorie",
"Current permissions for this category" => "Aktuelle Berechtigungen für diese Kategorie",
"Remove from this Category Only" => "Nur von dieser Kategorie entfernen",
"Remove from this Category &amp; all its Children" => "Von dieser und allen Unterkategorien entfernen",
"Assign permissions" => "Berechtigungen vergeben",
"to group" => "zu Gruppe",
"this category &amp; all its children" => "diese und alle Unterkategorien",
"this category only" => "nur für diese Kategorie",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "für beste Performance werden Berechtigungen für <b>diese und alle Unterkategorien</b> empfohlen",
"Permission denied you cannot view this page" => "Zugriff verweigert. Sie können diese Seite nicht betrachten.",
"Your registration code:" => "Ihr Registrierungscode:",
"Registration code" => "Registrierungscode",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Your message has been queued for approval and will be posted after a moderator approves it" => "Your message has been queued for approval and will be posted after a moderator approves it",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "The quota has been reached in" => "The quota has been reached in",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transfered to the database" => "Number of files transfered to the database",
// "Number of files transfered to the file system" => "Number of files transfered to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "File upload stopped by extension" => "File upload stopped by extension",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Contributions" => "Contributions",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "Show only the content" => "Show only the content",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Only display the module if in one of the listed perspectives. Semi-colon separated" => "Only display the module if in one of the listed perspectives. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Blogues" => "Blogues",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Exclude these categories" => "Exclude these categories",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Enable cool sites" => "Enable cool sites",
// "'),\n\t\t\t'type' => 'flag" => "'),\n\t\t\t'type' => 'flag",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "'),\n\t\t\t'type' => 'text" => "'),\n\t\t\t'type' => 'text",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "Faqs" => "Faqs",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page title" => "Display page title",
// "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header" => "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "This enable HTPMPurifier on outputs to filter remaining security problems like XSS" => "This enable HTPMPurifier on outputs to filter remaining security problems like XSS",
// "Shadowbox" => "Shadowbox",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "Print Indexed" => "Print Indexed",
// "SpreadSheet" => "SpreadSheet",
// "Ajax auto-save" => "Ajax auto-save",
// "Save draft" => "Save draft",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Action calendar" => "Action calendar",
// "Redirect to a similar wiki page if an exact match is not found" => "Redirect to a similar wiki page if an exact match is not found",
// "TikiTests" => "TikiTests",
// "Use Minified Scripts" => "Use Minified Scripts",
// "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions" => "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "External link icon" => "External link icon",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Category path" => "Category path",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Screencasts" => "Screencasts",
// "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share" => "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share",
// "Screencasts upload location" => "Screencasts upload location",
// "Local path or webdav path to the file upload location" => "Local path or webdav path to the file upload location",
// "Trailing slash required" => "Trailing slash required",
// "Screencasts HTTP prefix" => "Screencasts HTTP prefix",
// "Prefix to use for the files when generating a link to it" => "Prefix to use for the files when generating a link to it",
// "Screencast upload type" => "Screencast upload type",
// "Mode used to upload files. WebDav is used to upload to remote servers" => "Mode used to upload files. WebDav is used to upload to remote servers",
// "Webdav" => "Webdav",
// "Screencasts authentication user" => "Screencasts authentication user",
// "When using webdav to upload files, used as the username of the authentication credentials" => "When using webdav to upload files, used as the username of the authentication credentials",
// "Screencasts authentication password" => "Screencasts authentication password",
// "When using webdav to upload files, used as the password of the authentication credentials" => "When using webdav to upload files, used as the password of the authentication credentials",
// "Screencasts max file size" => "Screencasts max file size",
// "Maximum file size used for screencasts" => "Maximum file size used for screencasts",
// "Value provided in bytes" => "Value provided in bytes",
// "Page List" => "Page List",
// "The pagelist feature allows to maintain lists of pages and their associated score and priority" => "The pagelist feature allows to maintain lists of pages and their associated score and priority",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Blog-level" => "Blog-level",
// "Batch uploading" => "Batch uploading",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Forum name search" => "Forum name search",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Admins can search for features in the admin panels" => "Admins can search for features in the admin panels",
// "Encryption method" => "Encryption method",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "Podcast directory" => "Podcast directory",
// "The server must be able to read/write the directory" => "The server must be able to read/write the directory",
// "Required for podcasts" => "Required for podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "The directory can be outside the web space" => "The directory can be outside the web space",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for illimitted)" => "(0 for illimitted)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Description length" => "Description length",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Default ordering" => "Default ordering",
// "Creation Date (asc)" => "Creation Date (asc)",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "The default help system may not be complete. You can help with the TikiWiki documentation" => "The default help system may not be complete. You can help with the TikiWiki documentation",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Url to go when clicking on a username" => "Url to go when clicking on a username",
// "Default: " => "Default: ",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Verify for available translations in the database" => "Verify for available translations in the database",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache flags" => "Memcache flags",
// "Configuration switches for memcache connection" => "Configuration switches for memcache connection",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Default path for the icons" => "Default path for the icons",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID" => "One domain per line. Comma separated with perspective ID",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Neither" => "Neither",
// "Show categories" => "Show categories",
// "Show objects" => "Show objects",
// "Host" => "Host",
// "Proxy host" => "Proxy host",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Parse the results" => "Parse the results",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Minify javascript" => "Minify javascript",
// "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared" => "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared",
// "Use Jquery autocomplete user selector for better performance when number of users exceed" => "Use Jquery autocomplete user selector for better performance when number of users exceed",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Module decides" => "Module decides",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Character set used when detecting wiki links within pages" => "Character set used when detecting wiki links within pages",
// "Latin" => "Latin",
// "Display by default only pages in current language" => "Display by default only pages in current language",
// "In Wiki page lists, display by default only pages in current language" => "In Wiki page lists, display by default only pages in current language",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Both" => "Both",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per page" => "Allow comments per page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Disable" => "Disable",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Enable plugin %0" => "Enable plugin %0",
// "Inline plugin %0 (hide plugin edit icon)" => "Inline plugin %0 (hide plugin edit icon)",
// "When inlined, the plugin edit icon will not appear" => "When inlined, the plugin edit icon will not appear",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "... and is displayed by default" => "... and is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Default" => "Default",
// "Office 2003" => "Office 2003",
// "Silver" => "Silver",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Yesterday" => "Yesterday",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "Feed provided by %s. Click to visit" => "Feed provided by %s. Click to visit",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
// "Simple" => "Simple",
// "Advanced" => "Advanced",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "tip" => "tip",
// "warning" => "warning",
// "note" => "note",
// "errors" => "errors",
// "information" => "information",
// "Tab View" => "Tab View",
// "If you want the saved version instead of this autosaved one" => "If you want the saved version instead of this autosaved one",
// "AutoSave" => "AutoSave",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "Your edit session has expired" => "Your edit session has expired",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Help page" => "Help page",
// "Edit Template" => "Edit Template",
// "Admin Feature" => "Admin Feature",
// "Preference name not specified" => "Preference name not specified",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Invert Sort" => "Invert Sort",
// "No rows found" => "No rows found",
// "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "sec" => "sec",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Foo" => "Foo",
// "Sample plugin" => "Sample plugin",
// "Face" => "Face",
// "Font family to use" => "Font family to use",
// "As defined by CSS" => "As defined by CSS",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "Help link" => "Help link",
// "Edit Plugin" => "Edit Plugin",
// "Edit Section" => "Edit Section",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Flash player not available" => "Flash player not available",
// "__WARNING__: Plugin disabled \$plugin" => "__WARNING__: Plugin disabled \$plugin",
// "__WARNING__: No such module \$plugin" => "__WARNING__: No such module \$plugin",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed" => "Non-parsed",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif" => "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif",
// "Block Quote" => "Block Quote",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "Unordered List" => "Unordered List",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif" => "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "Background Color" => "Background Color",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "External Link" => "External Link",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "Table Builder" => "Table Builder",
// "pics/icons/find.png" => "pics/icons/find.png",
// "Find Text" => "Find Text",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full Screen Edit" => "Full Screen Edit",
// "pics/icons/arrow_in.png" => "pics/icons/arrow_in.png",
// "pics/icons/arrow_out.png" => "pics/icons/arrow_out.png",
// "Choose or upload images" => "Choose or upload images",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Admin Toolbars" => "Admin Toolbars",
// "Upload was not successful. Duplicate file content " => "Upload was not successful. Duplicate file content ",
// "Field is not numeric" => "Field is not numeric",
// "Field is not a link to mp3 in the gallery" => "Field is not a link to mp3 in the gallery",
// "Field is not a link to FLV in the gallery" => "Field is not a link to FLV in the gallery",
// "Field is not a link to FLV or MP3 in the gallery" => "Field is not a link to FLV or MP3 in the gallery",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "multimedia" => "multimedia",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Personal Phone" => "Personal Phone",
// "Personal Mobile" => "Personal Mobile",
// "Personal Fax" => "Personal Fax",
// "Work Phone" => "Work Phone",
// "Work Mobile" => "Work Mobile",
// "Work Fax" => "Work Fax",
// "Company" => "Company",
// "Organization" => "Organization",
// "Department" => "Department",
// "Division" => "Division",
// "Job Title" => "Job Title",
// "Street Address" => "Street Address",
// "City" => "City",
// "Zip Code" => "Zip Code",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "User-Agent Info" => "User-Agent Info",
// "Displays various information about the client" => "Displays various information about the client",
// "Info required - IP|SVRSW|BROWSER" => "Info required - IP|SVRSW|BROWSER",
// "Anchor Link" => "Anchor Link",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor" => "The name of the wiki page containing the anchor",
// "Anchor Name" => "Anchor Name",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "The name of the anchor" => "The name of the anchor",
// "Image Annotation" => "Image Annotation",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tikiwiki root" => "Absolute URL to the image or relative path from tikiwiki root",
// "Width" => "Width",
// "Image width" => "Image width",
// "Height" => "Height",
// "Image height" => "Image height",
// "Alignment" => "Alignment",
// "Image alignment. Possible values: left, right, center" => "Image alignment. Possible values: left, right, center",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "Creates an annotation block for an image" => "Creates an annotation block for an image",
// "Displays an image and enables users to define zones to highlight information on the image" => "Displays an image and enables users to define zones to highlight information on the image",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "Article List" => "Article List",
// "Inserts a list of articles in the page" => "Inserts a list of articles in the page",
// "Articles displayed" => "Articles displayed",
// "The number of articles to display in the list" => "The number of articles to display in the list",
// "Topics expression" => "Topics expression",
// "Topic ID expression" => "Topic ID expression",
// "Type expression" => "Type expression",
// "Category ID" => "Category ID",
// "The ID of the category to list from" => "The ID of the category to list from",
// "The article language to list" => "The article language to list",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles" => "Whether to not report when there are no articles",
// "Title only" => "Title only",
// "Whether to only show the title of the articles" => "Whether to only show the title of the articles",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Start date" => "Start date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "Bullets" => "Bullets",
// "Inline" => "Inline",
// "Number" => "Number",
// "Show icon" => "Show icon",
// "No such attachment on this page" => "No such attachment on this page",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "The wiki page the avatar will link to" => "The wiki page the avatar will link to",
// "Float" => "Float",
// "left|right" => "left|right",
// "Displays a link that allows to go back in the browser history" => "Displays a link that allows to go back in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed information" => "Displayed information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "1|0" => "1|0",
// "No Header" => "No Header",
// "Banner" => "Banner",
// "Insert a banner" => "Insert a banner",
// "Target" => "Target",
// "missing parameter" => "missing parameter",
// "Blog List" => "Blog List",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "Numeric value" => "Numeric value",
// "Maximum number of entries to list" => "Maximum number of entries to list",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Box" => "Box",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Float Position" => "Float Position",
// "for box with width less than 100%, make text wrap around the box" => "for box with width less than 100%, make text wrap around the box",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar filter" => "Calendar filter",
// "If set to a calendar identifier, restricts the events displayed to those in the specified calendar" => "If set to a calendar identifier, restricts the events displayed to those in the specified calendar",
// "View type" => "View type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "View the navigation bar" => "View the navigation bar",
// "Decide or not to show the navigation bar" => "Decide or not to show the navigation bar",
// "Includes a calendar" => "Includes a calendar",
// "~np~{CALENDAR(calendarId=>1)}{CALENDAR}" => "~np~{CALENDAR(calendarId=>1)}{CALENDAR}",
// "Id is optional. If not given, all calendars viewable by default are used" => "Id is optional. If not given, all calendars viewable by default are used",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
// "Sort Order" => "Sort Order",
// "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle",
// "Split" => "Split",
// "And" => "And",
// "With sub-categories" => "With sub-categories",
// "Show object name" => "Show object name",
// "Show type" => "Show type",
// "Incorrect param" => "Incorrect param",
// "Category Orphans" => "Category Orphans",
// "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
// "Category Path" => "Category Path",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display top category" => "Display top category",
// "yes|no, default to no" => "yes|no, default to no",
// "Center" => "Center",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels" => "Labels",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Enable word wrapping on the code to avoid breaking the layout",
// "Colors" => "Colors",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Line numbers" => "Line numbers",
// "0|1, may not be used with colors" => "0|1, may not be used with colors",
// "Wiki syntax" => "Wiki syntax",
// "0|1, parse wiki syntax within the code snippet" => "0|1, parse wiki syntax within the code snippet",
// "Right to left" => "Right to left",
// "0|1, switch the text display from left to right to right to left" => "0|1, switch the text display from left to right to right to left",
// "Content is HTML" => "Content is HTML",
// "0|1, display the content as is instead of escaping HTML special chars" => "0|1, display the content as is instead of escaping HTML special chars",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Also known as fortune cookies or taglines" => "Also known as fortune cookies or taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "on|off" => "on|off",
// "Items to show" => "Items to show",
// "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "left|right|center|justify" => "left|right|center|justify",
// "Justify" => "Justify",
// "Float position" => "Float position",
// "left|right, for box with width less than 100%, make text wrap around the box" => "left|right, for box with width less than 100%, make text wrap around the box",
// "Determine how other elements can wrap around the element" => "Determine how other elements can wrap around the element",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Creates a fancy-looking list" => "Creates a fancy-looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading row" => "Heading row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS class" => "Heading CSS class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header horizontal align" => "Header horizontal align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header vertical align" => "Header vertical align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column sort" => "Column sort",
// "Pre-sorted columns" => "Pre-sorted columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column widths" => "Column widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell horizontal align" => "Cell horizontal align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell vertical align" => "Cell vertical align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "heads and cells separated by |" => "heads and cells separated by |",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows ID" => "Shows ID",
// "Shows Icon" => "Shows Icon",
// "Shows Name" => "Shows Name",
// "Shows Filename" => "Shows Filename",
// "Shows Size" => "Shows Size",
// "Shows Description" => "Shows Description",
// "Shows Creation Date" => "Shows Creation Date",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Modification Date" => "Shows Modification Date",
// "Shows Author" => "Shows Author",
// "Shows Creator" => "Shows Creator",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Movie URL" => "Movie URL",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "Default width: 425" => "Default width: 425",
// "Default height: 350" => "Default height: 350",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "file name" => "file name",
// "Ftp Server Name" => "Ftp Server Name",
// "Ftp User name" => "Ftp User name",
// "Ftp password" => "Ftp password",
// "Download button label" => "Download button label",
// "Connection failed" => "Connection failed",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "current value (REQUIRED)" => "current value (REQUIRED)",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "Missing parameter" => "Missing parameter",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "GroupMailCore" => "GroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "operator Field Id" => "operator Field Id",
// "subject Field Id" => "subject Field Id",
// "message Field Id" => "message Field Id",
// "content Field Id" => "content Field Id",
// "account Field Id" => "account Field Id",
// "datetime Field Id" => "datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "Groups separated by " => "Groups separated by ",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Displays some stat about group belonging" => "Displays some stat about group belonging",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "Iframe" => "Iframe",
// "Frame title" => "Frame title",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 5.0)" => " (experimental - possible successor to img in 5.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)" => "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required" => "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery images when thumbnail is clicked" => "Download dialog box will appear for file gallery images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class" => "CSS class",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load" => "Alternate text that displays when image does not load",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin)" => "Default configuration settings (usually set by admin)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin)" => "Mandatory configuration settings (usually set by admin)",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, attId, id, or src.''",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Invite" => "Invite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including group" => "Including group",
// "Default group" => "Default group",
// "Group from the item group selector / creator field" => "Group from the item group selector / creator field",
// "Jabber" => "Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Kaltura video" => "Kaltura video",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry Id" => "Kaltura Entry Id",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Number of results displayed in the list" => "Number of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Progress" => "List Progress",
// "Indicates the internationalization progress of the page list" => "Indicates the internationalization progress of the page list",
// "List Name" => "List Name",
// "Name of the list as configured in the page list admin panel" => "Name of the list as configured in the page list admin panel",
// "Limit" => "Limit",
// "Maximum amount of results to display" => "Maximum amount of results to display",
// "Filter to apply to the page list" => "Filter to apply to the page list",
// "Score Limit" => "Score Limit",
// "Value used as the denominator for the score" => "Value used as the denominator for the score",
// "List Directory" => "List Directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%" => "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Member List" => "Member List",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by UI" => "Displays a module inline in a wiki page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font" => "Font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Background color of the popup" => "Background color of the popup",
// "'),\n\t\t\t\t'filter' => 'striptags" => "'),\n\t\t\t\t'filter' => 'striptags",
// "Text color in the popup" => "Text color in the popup",
// "Sticky" => "Sticky",
// "Padding" => "Padding",
// "Effect" => "Effect",
// "Effect speed" => "Effect speed",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "List pages part of a named list" => "List pages part of a named list",
// "Offset" => "Offset",
// "Pagination start element" => "Pagination start element",
// "list parameter missing or doesn\\'t exist" => "list parameter missing or doesn\\'t exist",
// "% of page hits" => "% of page hits",
// "Page Hits" => "Page Hits",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Poll ID" => "Poll ID",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "wrote" => "wrote",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Exclude" => "Exclude",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "y|n Show close button (default y)" => "y|n Show close button (default y)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Number of results displayed" => "Number of results displayed",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect" => "RSS Id incorrect",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "Screencast" => "Screencast",
// "Display a screencast uploaded on the page" => "Display a screencast uploaded on the page",
// "Label to use as a replacement to the default text" => "Label to use as a replacement to the default text",
// "ID as provided automatically during the upload" => "ID as provided automatically during the upload",
// "Insert Screencast" => "Insert Screencast",
// "Screencast ID wasn't specified or doesn't exist" => "Screencast ID wasn't specified or doesn't exist",
// "Watch a video of these instructions" => "Watch a video of these instructions",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Stat" => "Stat",
// "Displays some stats" => "Displays some stats",
// "separated by " => "separated by ",
// "Parent Id" => "Parent Id",
// "Added last hour" => "Added last hour",
// "Added last 24 hours" => "Added last 24 hours",
// "Added since the beginning of the day" => "Added since the beginning of the day",
// "Added(a) or viewed(v) since the beginning of the day" => "Added(a) or viewed(v) since the beginning of the day",
// "Added last 7 days" => "Added last 7 days",
// "Added(a) or viewed(v) last 7 days" => "Added(a) or viewed(v) last 7 days",
// "Added since the beginning of the week" => "Added since the beginning of the week",
// "Added(a) or viewed(v) since the beginning of the week" => "Added(a) or viewed(v) since the beginning of the week",
// "Added last month" => "Added last month",
// "Added(a) or viewed(v) last month" => "Added(a) or viewed(v) last month",
// "Added since the beginning of the month" => "Added since the beginning of the month",
// "Added(a) or viewed(v) since the beginning of the month" => "Added(a) or viewed(v) since the beginning of the month",
// "Added last year" => "Added last year",
// "Added(a) or viewed(v) last year" => "Added(a) or viewed(v) last year",
// "Added since the beginning of the year" => "Added since the beginning of the year",
// "Added(a) or viewed(v) since the beginning of the year" => "Added(a) or viewed(v) since the beginning of the year",
// "Subscript" => "Subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Show subscribe box" => "Show subscribe box",
// "Show default setting and buttons" => "Show default setting and buttons",
// "Show group description" => "Show group description",
// "Colon separated list of groups" => "Colon separated list of groups",
// "After changing default" => "After changing default",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Tabs" => "Tabs",
// "Provides tabs built using the smarty tabset block" => "Provides tabs built using the smarty tabset block",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset name" => "Tabset name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab titles" => "Tab titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Tag Name" => "Tag Name",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited" => "Maximum number of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "URL used for the field links" => "URL used for the field links",
// "Url target" => "Url target",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Filters" => "Filters",
// "Display List" => "Display List",
// "Line" => "Line",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "Wiki text" => "Wiki text",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Test" => "Test",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Notice" => "Notice",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Show Item Rank" => "Show Item Rank",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Maximum number of items" => "Maximum number of items",
// "Show pagination" => "Show pagination",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More" => "More",
// "More URL" => "More URL",
// "More Url" => "More Url",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Show nothing if no items" => "Show nothing if no items",
// "incorrect filterfield" => "incorrect filterfield",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Group name" => "Group name",
// "Display the user\\'s real name instead of login name" => "Display the user\\'s real name instead of login name",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Level" => "Level",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "URL to the Youtube video" => "URL to the Youtube video",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "rollback version " => "rollback version ",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "Category filter" => "Category filter",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Not set by default" => "Not set by default",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values" => "Example values",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "No date" => "No date",
// "If set to \"y\", the date at which comments were posted is not displayed in the module box" => "If set to \"y\", the date at which comments were posted is not displayed in the module box",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum length" => "Maximum length",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Example value" => "Example value",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Freetags editor" => "Freetags editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Similar freetags" => "Similar freetags",
// "Shows wiki pages with similar freetags" => "Shows wiki pages with similar freetags",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Number of characters to display" => "Number of characters to display",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Search Box" => "Search Box",
// "Advanced search (for wiki, articles, blogs etc)" => "Advanced search (for wiki, articles, blogs etc)",
// "Search Box (new)" => "Search Box (new)",
// "Search Wiki Page" => "Search Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Search Wiki Page (new)" => "Search Wiki Page (new)",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Please wait.." => "Please wait..",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Since your last visit.." => "Since your last visit..",
// "updated tracker items" => "updated tracker items",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Page translation" => "Page translation",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "Subject Field Id" => "Subject Field Id",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "Message Field Id" => "Message Field Id",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "Content Field Id" => "Content Field Id",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "Account Field Id" => "Account Field Id",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "Operator Field Id" => "Operator Field Id",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Wiki Page" => "Wiki Page",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "Cookie not found" => "Cookie not found",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin the cms" => "Can admin the cms",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submited links are valid" => "Submited links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submited links" => "Can validate submited links",
// "Can use the directory" => "Can use the directory",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Can admin users" => "Can admin users",
// "Can access site when closed" => "Can access site when closed",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referer stats" => "Can view referer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can create file galleries" => "Can create file galleries",
// "Can download files" => "Can download files",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can list file galleries" => "Can list file galleries",
// "Can upload files" => "Can upload files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can view file galleries" => "Can view file galleries",
// "Can admin forums" => "Can admin forums",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can admin freetags" => "Can admin freetags",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload images" => "Can upload images",
// "Can browse freetags" => "Can browse freetags",
// "Can view image galleries" => "Can view image galleries",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change tracker pending items" => "Can change tracker pending items",
// "Can change tracker closed items" => "Can change tracker closed items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view trackers closed items" => "Can view trackers closed items",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit pages" => "Can edit pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view page/pages" => "Can view page/pages",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments to wiki pages" => "Can admin attachments to wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view wiki history" => "Can view wiki history",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can delete comments" => "Can delete comments",
// "Can vote comments" => "Can vote comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can list registered users" => "Can list registered users",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can invite user in groups" => "Can invite user in groups",
// "Can delete his own account" => "Can delete his own account",
// "Can use the Tiki Importer" => "Can use the Tiki Importer",
// "Can admin categories" => "Can admin categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories on the object" => "Can change the categories on the object",
// "Can add objects in the category" => "Can add objects in the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can upload screencasts to wiki pages" => "Can upload screencasts to wiki pages",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki dft list pages lang to current" => "wiki dft list pages lang to current",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "feature pagelist" => "feature pagelist",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin listprogress" => "wikiplugin listprogress",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin pagelist" => "wikiplugin pagelist",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin screencast" => "wikiplugin screencast",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline listprogress" => "wikiplugininline listprogress",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline pagelist" => "wikiplugininline pagelist",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline screencast" => "wikiplugininline screencast",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "tracker jquery user selector threshold" => "tracker jquery user selector threshold",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature search preferences" => "feature search preferences",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "title rss forums" => "title rss forums",
// "title rss forum" => "title rss forum",
// "title rss directories" => "title rss directories",
// "title rss articles" => "title rss articles",
// "title rss blogs" => "title rss blogs",
// "title rss image galleries" => "title rss image galleries",
// "title rss file galleries" => "title rss file galleries",
// "title rss wiki" => "title rss wiki",
// "title rss image gallery" => "title rss image gallery",
// "title rss file gallery" => "title rss file gallery",
// "title rss blog" => "title rss blog",
// "title rss tracker" => "title rss tracker",
// "title rss trackers" => "title rss trackers",
// "title rss calendar" => "title rss calendar",
// "title rss mapfiles" => "title rss mapfiles",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom html head content" => "feature custom html head content",
// "users prefs theme" => "users prefs theme",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature wiki screencasts" => "feature wiki screencasts",
// "feature wiki screencasts base" => "feature wiki screencasts base",
// "feature wiki screencasts httpbase" => "feature wiki screencasts httpbase",
// "feature wiki screencasts upload type" => "feature wiki screencasts upload type",
// "feature wiki screencasts user" => "feature wiki screencasts user",
// "feature wiki screencasts pass" => "feature wiki screencasts pass",
// "feature wiki screencasts max size" => "feature wiki screencasts max size",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache flags" => "memcache flags",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "feature use minified scripts" => "feature use minified scripts",
// "tiki minify javascript" => "tiki minify javascript",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "Select/deselect all categories" => "Select/deselect all categories",
// "Group Monitor" => "Group Monitor",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "File gallery" => "File gallery",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Quota" => "Quota",
// "Used" => "Used",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Display Properties" => "Display Properties",
// "Descending" => "Descending",
// "Ascending" => "Ascending",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Go to Login Page" => "Go to Login Page",
// "Go to" => "Go to",
// "Private Gallery" => "Private Gallery",
// "Archives" => "Archives",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Show as a column" => "Show as a column",
// "Show in popup box" => "Show in popup box",
// "Show an icon in a column" => "Show an icon in a column",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "any type" => "any type",
// "all topic" => "all topic",
// "any language" => "any language",
// "not in" => "not in",
// "any category" => "any category",
// "Clear Filter" => "Clear Filter",
// "Show php error messages" => "Show php error messages",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Tags" => "Tags",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "A new topic was posted to forum" => "A new topic was posted to forum",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "Assign to a group" => "Assign to a group",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "Someone" => "Someone",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "removed" => "removed",
// "Old" => "Old",
// "updated" => "updated",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Thank you for your registration. You may log in now" => "Thank you for your registration. You may log in now",
// "Zoom out" => "Zoom out",
// "Zoom in" => "Zoom in",
// "from the mapfile" => "from the mapfile",
// "Older Version" => "Older Version",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
// "More.." => "More..",
// "To configure your Tiki" => "To configure your Tiki",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "Add event" => "Add event",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "List everything tagged" => "List everything tagged",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "No records to display" => "No records to display",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "more" => "more",
// "No avatar" => "No avatar",
// "You" => "You",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "CapsLock is on" => "CapsLock is on",
// "OpenID Login" => "OpenID Login",
// "What is OpenID" => "What is OpenID",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Better translations" => "Better translations",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Equivalent translations" => "Equivalent translations",
// "update it" => "update it",
// "Group information" => "Group information",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "User does not accept messages" => "User does not accept messages",
// "More Videos" => "More Videos",
// "Changes that need to be reproduced are highlighted below" => "Changes that need to be reproduced are highlighted below",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "Requires" => "Requires",
// "You need to set" => "You need to set",
// "Insert/Edit an internal wiki link" => "Insert/Edit an internal wiki link",
// "Wiki Link insert" => "Wiki Link insert",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "Insert an image" => "Insert an image",
// "Tiki Image - Insert an image" => "Tiki Image - Insert an image",
// "Switch to normal (wiki) editor" => "Switch to normal (wiki) editor",
// "By" => "By",
// "Read more" => "Read more",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User resistration, remember me cookie settings and authentication methods" => "User resistration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Profiles" => "Profiles",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look & Feel" => "Look & Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Connect" => "Connect",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "?" => "?",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Kaltura video configuration" => "Kaltura video configuration",
// "Create a blog" => "Create a blog",
// "Requires a separate download" => "Requires a separate download",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "First day of the week" => "First day of the week",
// "Depends user language" => "Depends user language",
// "Split hours in periods of" => "Split hours in periods of",
// "1 minute" => "1 minute",
// "10 minutes" => "10 minutes",
// "15 minutes" => "15 minutes",
// "30 minutes" => "30 minutes",
// "Manual selection of time/date" => "Manual selection of time/date",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Browse categories" => "Browse categories",
// "Administer categories" => "Administer categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "Title of articles home page" => "Title of articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "Batch upload (CSV file)" => "Batch upload (CSV file)",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "User features" => "User features",
// "Highlight group" => "Highlight group",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Real name" => "Real name",
// "Feature is disabled" => "Feature is disabled",
// "Enable now" => "Enable now",
// "Default user preferences" => "Default user preferences",
// "Character set for mail" => "Character set for mail",
// "User messages" => "User messages",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "Score ascending" => "Score ascending",
// "Score descending" => "Score descending",
// "Name ascending" => "Name ascending",
// "Name descending" => "Name descending",
// "Login ascending" => "Login ascending",
// "Login descending" => "Login descending",
// "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to TikiWiki.org" => "To submit your site to TikiWiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright allows to determine a copyright for all the objects of tikiwiki",
// "Enable copyright management for" => "Enable copyright management for",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Need polish" => "Need polish",
// "These features are generally known to have issues, and/or need admin help and/or user patience to work" => "These features are generally known to have issues, and/or need admin help and/or user patience to work",
// "Feedbacks" => "Feedbacks",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Create a Gallery" => "Create a Gallery",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Score is disabled" => "Score is disabled",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Search Indexing" => "Search Indexing",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "Create a forum" => "Create a forum",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "When listing forums" => "When listing forums",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser" => "3D Tag Browser",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Graph appearance" => "Graph appearance",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "No Gallery exists" => "No Gallery exists",
// "Display image informations in a mouseover box" => "Display image informations in a mouseover box",
// "yes, and don't display those informations under the image" => "yes, and don't display those informations under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "Mail" => "Mail",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "SMTP Server" => "SMTP Server",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Logging and Reporting" => "Logging and Reporting",
// "MultiDomain" => "MultiDomain",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Miscellaneous" => "Miscellaneous",
// "Redirects" => "Redirects",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details",
// "Google Maps API Key" => "Google Maps API Key",
// "Defaults" => "Defaults",
// "Edit or export/import Languages" => "Edit or export/import Languages",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "Kaltura Registration" => "Kaltura Registration",
// "If you don't have a Kaltura Partner Id, " => "If you don't have a Kaltura Partner Id, ",
// "to register" => "to register",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Partner Id" => "Partner Id",
// "User Secret" => "User Secret",
// "Admin Secret" => "Admin Secret",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "KDP UI Configuration Id" => "KDP UI Configuration Id",
// "KDP Widget Id" => "KDP Widget Id",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "KCW UI Configuration Id" => "KCW UI Configuration Id",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Kaltura Simple Editor UI Configuration Id" => "Kaltura Simple Editor UI Configuration Id",
// "Kaltura Advance Editor UI Configuration Id" => "Kaltura Advance Editor UI Configuration Id",
// "Wysiwyg" => "Wysiwyg",
// "Validate by email" => "Validate by email",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Url a user is redirected after account validation" => "Url a user is redirected after account validation",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "LDAP Bind settings" => "LDAP Bind settings",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: userattr=username,UserDN,BaseDN" => "Default: userattr=username,UserDN,BaseDN",
// "userattr=username,BaseDN" => "userattr=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Synchronize user attributes to tiki everytime the user logs in" => "Synchronize user attributes to tiki everytime the user logs in",
// "LDAP Group" => "LDAP Group",
// "Synchronize group attributes to tiki everytime the user logs in" => "Synchronize group attributes to tiki everytime the user logs in",
// "Note: this enables the usage of LDAP groups" => "Note: this enables the usage of LDAP groups",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "Group attribute in group entry" => "Group attribute in group entry",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "Themes" => "Themes",
// "Theme options" => "Theme options",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "Each group can have its theme" => "Each group can have its theme",
// "Slideshow theme" => "Slideshow theme",
// "View Templates" => "View Templates",
// "Custom HTML &lt;head&gt; Content" => "Custom HTML &lt;head&gt; Content",
// "Custom Site Header" => "Custom Site Header",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users",
// "Site Logo and Title" => "Site Logo and Title",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Site title" => "Site title",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar" => "Top Bar",
// "Requires CSS Menus or PHPLayers" => "Requires CSS Menus or PHPLayers",
// "Menu ID" => "Menu ID",
// "Display current Tiki version" => "Display current Tiki version",
// "Custom Center Column Header" => "Custom Center Column Header",
// "only if module" => "only if module",
// "Prefix breadcrumbs with &quot;Location : &quot" => "Prefix breadcrumbs with &quot;Location : &quot",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom Site Footer" => "Custom Site Footer",
// "Custom End of &lt;body&gt; Code" => "Custom End of &lt;body&gt; Code",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave <strong>blank</strong> to use the default sender email" => "Leave <strong>blank</strong> to use the default sender email",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "UI Effects" => "UI Effects",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "Tooltips" => "Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "Autocomplete" => "Autocomplete",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "Superfish" => "Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "Reflection" => "Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery UI Theme" => "JQuery UI Theme",
// "JQuery UI Theme: Themes for look and feel of JQuery UI widgets" => "JQuery UI Theme: Themes for look and feel of JQuery UI widgets",
// "For future use" => "For future use",
// "Cycle" => "Cycle",
// "slideshow" => "slideshow",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules" => "Effect for modules",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Main JQuery effect" => "Main JQuery effect",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (&nbsp;,&nbsp;)" => "Separate multiple elements with a comma (&nbsp;,&nbsp;)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Separators" => "Separators",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "Save Preferences" => "Save Preferences",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Sending" => "Sending",
// "TikiWiki Profiles" => "TikiWiki Profiles",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Profile tester" => "Profile tester",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feed for articles" => "Feed for articles",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "The indexation is always updated" => "The indexation is always updated",
// "Tiki search" => "Tiki search",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "Plugins" => "Plugins",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Switch storage" => "Switch storage",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on" => "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Allow override per page" => "Allow override per page",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Manage attachments" => "Manage attachments",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Remove a tag" => "Remove a tag",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "Polls are disabled" => "Polls are disabled",
// "like pages" => "like pages",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "Wiki watch" => "Wiki watch",
// "Watch minor edits" => "Watch minor edits",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Page Listings" => "Page Listings",
// "Pages not in structure" => "Pages not in structure",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Categories path" => "Categories path",
// "Camera settings" => "Camera settings",
// "Upload Type" => "Upload Type",
// "Data location" => "Data location",
// "HTTP Prefix" => "HTTP Prefix",
// "WebDav username" => "WebDav username",
// "WebDav password" => "WebDav password",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Development Notice" => "Development Notice",
// "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default" => "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
// "disabled" => "disabled",
// "enabled" => "enabled",
// "TikiCache/System" => "TikiCache/System",
// "Edit Languages" => "Edit Languages",
// "Please select some actions to view" => "Please select some actions to view",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "Perso" => "Perso",
// "View Calendar" => "View Calendar",
// "Add Event" => "Add Event",
// "Create / Edit Calendar" => "Create / Edit Calendar",
// "Create/Edit Calendars" => "Create/Edit Calendars",
// "Custom URL" => "Custom URL",
// "Start of day" => "Start of day",
// "End of day" => "End of day",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Red" => "Red",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Let me select my own colors" => "Let me select my own colors",
// "Custom foreground color" => "Custom foreground color",
// "Ex" => "Ex",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
// "Current Category ID" => "Current Category ID",
// "Remove from this Category" => "Remove from this Category",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Admin External Wikis" => "Admin External Wikis",
// "ExtWiki" => "ExtWiki",
// ".." => "..",
// "Online" => "Online",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "Duplicate" => "Duplicate",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Use Ctrl+Click to select multiple groups" => "Use Ctrl+Click to select multiple groups",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "section level 0" => "section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
// "sorted section level 0" => "sorted section level 0",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Active Permissions" => "Active Permissions",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "assign_name\">Module Name" => "assign_name\">Module Name",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Use Wiki Structure" => "Use Wiki Structure",
// "Edit Newsletter" => "Edit Newsletter",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Admin page lists" => "Admin page lists",
// "Current lists" => "Current lists",
// "Edit this list" => "Edit this list",
// "Remove this list" => "Remove this list",
// "Edit list" => "Edit list",
// "Add list" => "Add list",
// "Seed with pages from a category" => "Seed with pages from a category",
// "Add page" => "Add page",
// "Page priority" => "Page priority",
// "Page score" => "Page score",
// "Edit {\$list.name|escape}" => "Edit {\$list.name|escape}",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "Add poll to pages" => "Add poll to pages",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Lock the pages" => "Lock the pages",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "View structure" => "View structure",
// "PDF" => "PDF",
// "View WebHelp" => "View WebHelp",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)",
// "Exterminator of cached content" => "Exterminator of cached content",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "New tracker field" => "New tracker field",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Multilingual content" => "Multilingual content",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Error message" => "Error message",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit This Tracker's Fields" => "Edit This Tracker's Fields",
// "with" => "with",
// "Edit Tracker" => "Edit Tracker",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Format if not the default short one" => "Format if not the default short one",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "LastModif" => "LastModif",
// "ItemId" => "ItemId",
// "and display last comment user/date" => "and display last comment user/date",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Manage permissions" => "Manage permissions",
// "Inherits Permissions from" => "Inherits Permissions from",
// "User Choice" => "User Choice",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Selected groups only. Use Ctrl+Click to select more than one" => "Selected groups only. Use Ctrl+Click to select more than one",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Remove from Group" => "Remove from Group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "Feedback" => "Feedback",
// "Edit Account Settings" => "Edit Account Settings",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Invalid email" => "Invalid email",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Tip: Hold down CTRL to select multiple" => "Tip: Hold down CTRL to select multiple",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Lowercase only" => "Lowercase only",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2" => "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "Actions on this article type" => "Actions on this article type",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Report to Webmaster" => "Report to Webmaster",
// "The TikiWiki Community" => "The TikiWiki Community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "Last update from SVN" => "Last update from SVN",
// "Admin the Category System" => "Admin the Category System",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "\$feature_label" => "\$feature_label",
// "All Images" => "All Images",
// "Monitor this Gallery" => "Monitor this Gallery",
// "Stop Monitoring this Gallery" => "Stop Monitoring this Gallery",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using one of these lines" => "You can include the gallery's image in an HTML page using one of these lines",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Browsing Video" => "Browsing Video",
// "Edit Video" => "Edit Video",
// "First Video" => "First Video",
// "Prev Video" => "Prev Video",
// "Next Video" => "Next Video",
// "Last Video" => "Last Video",
// "Video Title" => "Video Title",
// "Move video" => "Move video",
// "You can view this video in your browser using" => "You can view this video in your browser using",
// "You can include the video in a tiki page using one of these lines" => "You can include the video in a tiki page using one of these lines",
// "Admin Calendar" => "Admin Calendar",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Visible Calendars" => "Visible Calendars",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Edit event" => "Edit event",
// "Delete event" => "Delete event",
// "View event" => "View event",
// "All-Day" => "All-Day",
// "Website" => "Website",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Calendar Item" => "Calendar Item",
// "Edit Calendar" => "Edit Calendar",
// "New event" => "New event",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Send another message" => "Send another message",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "Perform action with selected" => "Perform action with selected",
// "in current directory category" => "in current directory category",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "The file will be saved in" => "The file will be saved in",
// "Wiki Syntax" => "Wiki Syntax",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Also available here" => "Also available here",
// "Plugins help" => "Plugins help",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "to separate pages" => "to separate pages",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Im-Export Languages" => "Im-Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Edit quiz results" => "Edit quiz results",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Move in this structure" => "Move in this structure",
// "Move to another structure" => "Move to another structure",
// "at the beginning" => "at the beginning",
// "at the end" => "at the end",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Article" => "View Article",
// "Language of newly translated page" => "Language of newly translated page",
// "Unspecified" => "Unspecified",
// "Name of newly translated page" => "Name of newly translated page",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Or" => "Or",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Manage existing translations of this page" => "Manage existing translations of this page",
// "Change language for this page" => "Change language for this page",
// "Select from available options.." => "Select from available options..",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Edit Video Information" => "Edit Video Information",
// "Browse Videos" => "Browse Videos",
// "The following video was successfully edited" => "The following video was successfully edited",
// "You can include the video in an HTML page using one of these lines" => "You can include the video in an HTML page using one of these lines",
// "Preview your changes" => "Preview your changes",
// "Save the page" => "Save the page",
// "Cancel the edit, you will lose your changes" => "Cancel the edit, you will lose your changes",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Edit wiki page" => "Edit wiki page",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Monitor this page" => "Monitor this page",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Allow comments on this page" => "Allow comments on this page",
// "Upload Screencast" => "Upload Screencast",
// "Incorrect file extension was used for your flash screencast, expecting .swf or .flv" => "Incorrect file extension was used for your flash screencast, expecting .swf or .flv",
// "An unexpected error occurred while uploading your flash screencast" => "An unexpected error occurred while uploading your flash screencast",
// "Incorrect file extension was used for your Ogg screencast, expecting .ogg" => "Incorrect file extension was used for your Ogg screencast, expecting .ogg",
// "A flash screencast is mandatory" => "A flash screencast is mandatory",
// "An unexpected error occurred while uploading your Ogg screencast" => "An unexpected error occurred while uploading your Ogg screencast",
// "Preview not possible" => "Preview not possible",
// "Flash video (required)" => "Flash video (required)",
// "Ogg video (optional)" => "Ogg video (optional)",
// "Add another screencast" => "Add another screencast",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
// "or use" => "or use",
// "Translation request" => "Translation request",
// "Send urgent translation request" => "Send urgent translation request",
// "List Sheets" => "List Sheets",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "File Archive" => "File Archive",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
// "Configure Forum" => "Configure Forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Cancel friendship request" => "Cancel friendship request",
// "Global default" => "Global default",
// "Google Map Locator" => "Google Map Locator",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Reset view to default" => "Reset view to default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "A new install will populate the database" => "A new install will populate the database",
// "This will destroy your current database" => "This will destroy your current database",
// "Reinstall" => "Reinstall",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them" => "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please login with your admin password to continue" => "Please login with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Login" => "Secure Login",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "The installation is complete" => "The installation is complete",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "TikiWiki Project Web Site" => "TikiWiki Project Web Site",
// "TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware Project",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Upload to Kaltura" => "Upload to Kaltura",
// "List Entries" => "List Entries",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Views" => "Views",
// "Plays" => "Plays",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Create content block" => "Create content block",
// "Keep gallery window open" => "Keep gallery window open",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Media Entries" => "Media Entries",
// "Mix Entries" => "Mix Entries",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "Browse Entries" => "Browse Entries",
// "Additional Info" => "Additional Info",
// "Media Type" => "Media Type",
// "No entries" => "No entries",
// "No media entries found. " => "No media entries found. ",
// "Click here " => "Click here ",
// "to upload" => "to upload",
// "No mix entries found. " => "No mix entries found. ",
// "to create a new mix" => "to create a new mix",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "If an object is not in the special section, then only the default perms are on" => "If an object is not in the special section, then only the default perms are on",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Page aliases found" => "Page aliases found",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "Xml Zip" => "Xml Zip",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "licence" => "licence",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Records" => "Records",
// "User Articles" => "User Articles",
// "User Items" => "User Items",
// "User forum topics" => "User forum topics",
// "User forum replies" => "User forum replies",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "Contacts Preferences" => "Contacts Preferences",
// "Sent Edition" => "Sent Edition",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Wiki Create" => "Wiki Create",
// "Wiki Overwrite" => "Wiki Overwrite",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "Edit Permissions" => "Edit Permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign global permissions" => "Assign global permissions",
// "Reset to Global Perms" => "Reset to Global Perms",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "These permissions override any global permissions or category permissions affecting this object" => "These permissions override any global permissions or category permissions affecting this object",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>" => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Rollback to this version" => "Rollback to this version",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Items found" => "Items found",
// "Rank" => "Rank",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Plugin" => "Plugin",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Add Pages" => "Add Pages",
// "No pages" => "No pages",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Add Structure Pages" => "Add Structure Pages",
// "No pages selected" => "No pages selected",
// "Passed" => "Passed",
// "star" => "star",
// "half star" => "half star",
// "Send a link" => "Send a link",
// "Received Pages" => "Received Pages",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Back to page" => "Back to page",
// "to version" => "to version",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "Calendar Items" => "Calendar Items",
// "octets" => "octets",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send a structure" => "Send a structure",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Create New Sheet" => "Create New Sheet",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "TOC" => "TOC",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "page: %0/%1" => "page: %0/%1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Tiki Logs" => "Tiki Logs",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Advanced mode" => "Advanced mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "Author, if different from the Creator" => "Author, if different from the Creator",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Add File" => "Add File",
// "Maximum file size is around" => "Maximum file size is around",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "For image files" => "For image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "No gallery available" => "No gallery available",
// "You have to create a gallery first" => "You have to create a gallery first",
// "The column is disabled" => "The column is disabled",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Default view" => "Default view",
// "Manage Fields" => "Manage Fields",
// "User Icon" => "User Icon",
// "(non public)" => "(non public)",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Additional Information" => "Additional Information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Forum comments" => "Forum comments",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
// "Select language.." => "Select language..",
// "My level" => "My level",
// "Are you really sure you want to delete your account " => "Are you really sure you want to delete your account ",
// "Accepted by Task User and Creator" => "Accepted by Task User and Creator",
// "Accepted User and Creator" => "Accepted User and Creator",
// "Not Accepted by One User" => "Not Accepted by One User",
// "Not Accepted User" => "Not Accepted User",
// "Waiting for Me" => "Waiting for Me",
// "Waiting for Other User" => "Waiting for Other User",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Hot" => "Hot",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "Show archived posts" => "Show archived posts",
// "Archived" => "Archived",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "Stop Monitor" => "Stop Monitor",
// "Tracker Items" => "Tracker Items",
// "Pending" => "Pending",
// "Tracker Item" => "Tracker Item",
// "Edit/Delete" => "Edit/Delete",
// "Items list" => "Items list",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Part" => "Part",
// "View edit icons" => "View edit icons",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Fullscreen" => "Fullscreen",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Leave" => "Leave",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Last Month" => "Last Month",
// "Last Year" => "Last Year",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
// "Save the page as a draft" => "Save the page as a draft",
// "Save Draft" => "Save Draft",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new major release branch is available" => "A new major release branch is available",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Feeds settings" => "Feeds settings",
// "Freetags settings" => "Freetags settings",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Text area" => "Text area",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Kaltura settings" => "Kaltura settings",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Object doesn't exists" => "Object doesn't exists",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "You must specify a directory" => "You must specify a directory",
// "Test Image" => "Test Image",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The list name must be specified" => "The list name must be specified",
// "Sorry, your list could not be added. Please check that it doesn\\'t already exist" => "Sorry, your list could not be added. Please check that it doesn\\'t already exist",
// "Sorry, your list could not be updated. Please check that it already exists" => "Sorry, your list could not be updated. Please check that it already exists",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Permission denied. You cannot view this page" => "Permission denied. You cannot view this page",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "JavaScript is required for this page" => "JavaScript is required for this page",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "Group name can not be empty" => "Group name can not be empty",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "User login contains invalid characters" => "User login contains invalid characters",
// "Deleted account %s" => "Deleted account %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "Upload was successful" => "Upload was successful",
// "Last modifications to the blog" => "Last modifications to the blog",
// "You must clear your browser cache" => "You must clear your browser cache",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Calendar event : " => "Calendar event : ",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "Su" => "Su",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl" => "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "The file you selected is too large to upload" => "The file you selected is too large to upload",
// "Incorrect file extension was used for your 0gg screencast, expecting .ogg" => "Incorrect file extension was used for your 0gg screencast, expecting .ogg",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Back to item" => "Back to item",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "Page saved (version %d)" => "Page saved (version %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "Permission denied: You cannot upload videos" => "Permission denied: You cannot upload videos",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Permission denied: You cannot remix videos" => "Permission denied: You cannot remix videos",
// "Permission denied: You cannot change video version" => "Permission denied: You cannot change video version",
// "Permission denied: You cannot delete kaltura video" => "Permission denied: You cannot delete kaltura video",
// "Permission denied: You cannot download kaltura video" => "Permission denied: You cannot download kaltura video",
// "Permission denied: You cannot edit video information" => "Permission denied: You cannot edit video information",
// "Permission denied: You cannot view video" => "Permission denied: You cannot view video",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "Permission denied: You cannot view this page" => "Permission denied: You cannot view this page",
// "Invalid action" => "Invalid action",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "map edit" => "map edit",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Note not found" => "Note not found",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "You are already logged in" => "You are already logged in",
// "You must choose a group" => "You must choose a group",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "invalid email" => "invalid email",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Clean the sql logs" => "Clean the sql logs",
// "Report to the webmaster" => "Report to the webmaster",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Incorrect file extension" => "Incorrect file extension",
// "Your screencast has been uploaded successfully" => "Your screencast has been uploaded successfully",
// "Your screencasts have been uploaded successfully" => "Your screencasts have been uploaded successfully",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "There are a problem connecting to that account" => "There are a problem connecting to that account",
// "There are a problem deleting that mail" => "There are a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There are a problem deleting mails" => "There are a problem deleting mails",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"ID" => "ID",
"Name" => "Name",
"Explorer" => "Explorer",
"Slideshow" => "Slideshow",
"Afghanistan" => "Afghanistan",
"Andorra" => "Andorra",
"Angola" => "Angola",
"Anguilla" => "Anguilla",
"Antigua" => "Antigua",
"Aruba" => "Aruba",
"Bahamas" => "Bahamas",
"Bahrain" => "Bahrain",
"Barbados" => "Barbados",
"Belize" => "Belize",
"Benin" => "Benin",
"Bermuda" => "Bermuda",
"Bhutan" => "Bhutan",
"Botswana" => "Botswana",
"Bouvet Island" => "Bouvet Island",
"British Indian Ocean Territory" => "British Indian Ocean Territory",
"British Virgin Islands" => "British Virgin Islands",
"Brunei" => "Brunei",
"Burkina Faso" => "Burkina Faso",
"Burundi" => "Burundi",
"Cambodia" => "Cambodia",
"Catalan Countries" => "Catalan Countries",
"Chile" => "Chile",
"China" => "China",
"Comoros" => "Comoros",
"Costa Rica" => "Costa Rica",
"Dominica" => "Dominica",
"Ecuador" => "Ecuador",
"El Salvador" => "El Salvador",
"Eritrea" => "Eritrea",
"Gabon" => "Gabon",
"Gambia" => "Gambia",
"Ghana" => "Ghana",
"Gibraltar" => "Gibraltar",
"Grenada" => "Grenada",
"Guadeloupe" => "Guadeloupe",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Guernsey" => "Guernsey",
"Guinea" => "Guinea",
"Guinea Bissau" => "Guinea Bissau",
"Guyana" => "Guyana",
"Haiti" => "Haiti",
"Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
"Honduras" => "Honduras",
"Hong Kong" => "Hong Kong",
"Iran" => "Iran",
"Isle of Man" => "Isle of Man",
"Israel" => "Israel",
"Japan" => "Japan",
"Jersey" => "Jersey",
"Jordan" => "Jordan",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Laos" => "Laos",
"Lesotho" => "Lesotho",
"Liberia" => "Liberia",
"Liechtenstein" => "Liechtenstein",
"Luxemburg" => "Luxemburg",
"Macao" => "Macao",
"Malawi" => "Malawi",
"Malaysia" => "Malaysia",
"Mali" => "Mali",
"Malta" => "Malta",
"Martinique" => "Martinique",
"Mauritius" => "Mauritius",
"Mayotte" => "Mayotte",
"Monaco" => "Monaco",
"Montenegro" => "Montenegro",
"Montserrat" => "Montserrat",
"Myanmar" => "Myanmar",
"Namibia" => "Namibia",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Nicaragua" => "Nicaragua",
"Niger" => "Niger",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
"Oman" => "Oman",
"Pakistan" => "Pakistan",
"Palau" => "Palau",
"Panama" => "Panama",
"Paraguay" => "Paraguay",
"Peru" => "Peru",
"Pitcairn" => "Pitcairn",
"Portugal" => "Portugal",
"Puerto Rico" => "Puerto Rico",
"Quatar" => "Quatar",
"Reunion" => "Reunion",
"Samoa" => "Samoa",
"San Marino" => "San Marino",
"Sao Tome and Principe" => "Sao Tome and Principe",
"Senegal" => "Senegal",
"Sierra Leone" => "Sierra Leone",
"Somalia" => "Somalia",
"Sri Lanka" => "Sri Lanka",
"Sudan" => "Sudan",
"Surinam" => "Surinam",
"Taiwan" => "Taiwan",
"Thailand" => "Thailand",
"Timor-Leste" => "Timor-Leste",
"Togo" => "Togo",
"Tokelau" => "Tokelau",
"Tonga" => "Tonga",
"Turkmenistan" => "Turkmenistan",
"Tuvalu" => "Tuvalu",
"Uganda" => "Uganda",
"Ukraine" => "Ukraine",
"United States Minor Outlying Islands" => "United States Minor Outlying Islands",
"Uruguay" => "Uruguay",
"Vanuatu" => "Vanuatu",
"Venezuela" => "Venezuela",
"Wales" => "Wales",
"MySQL classic (mysql)" => "MySQL classic (mysql)",
"PostgreSQL" => "PostgreSQL",
"Farsi" => "Farsi",
"Fijian" => "Fijian",
"Pijin Solomon" => "Pijin Solomon",
"Serbian Latin" => "Serbian Latin",
"Tuvaluan" => "Tuvaluan",
"Administration:" => "Administration:",
"All Day" => "All Day",
"in" => "in",
"Wiki" => "Wiki",
"Blogs" => "Blogs",
"FAQs" => "FAQs",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"Link" => "Link",
"Blog" => "Blog",
"Theme" => "Theme",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"Shibboleth" => "Shibboleth",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"6" => "6",
"Freetags" => "Freetags",
"Contribution" => "Contribution",
"FAQ" => "FAQ",
"Copyright" => "Copyright",
"Multimedia" => "Multimedia",
"Shoutbox" => "Shoutbox",
"Google Maps" => "Google Maps",
"HTML Purifier" => "HTML Purifier",
"Ajax" => "Ajax",
"Webmail" => "Webmail",
"Intertiki" => "Intertiki",
"Mail-in" => "Mail-in",
"Mindmap" => "Mindmap",
"Kaltura" => "Kaltura",
"Integrator" => "Integrator",
"Smileys" => "Smileys",
"Threaded" => "Threaded",
"Map Zone" => "Map Zone",
"Port" => "Port",
"Top" => "Top",
"Downloads" => "Downloads",
"Forum" => "Forum",
"Tracker item" => "Tracker item",
"Tracker" => "Tracker",
"Trackeritem" => "Trackeritem",
"km" => "km",
"cool" => "cool",
"View the tracker item at:" => "View the tracker item at:",
"max" => "max",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
"Avatar" => "Avatar",
"Backlinks" => "Backlinks",
"Cookie" => "Cookie",
"URL" => "URL",
"Start" => "Start",
"Text" => "Text",
"%" => "%",
"Status" => "Status",
"Information" => "Information",
"Quote:" => "Quote:",
"Pop-up" => "Pop-up",
"TikiSheet" => "TikiSheet",
"This data is put in a CODE caption." => "This data is put in a CODE caption.",
"row1col1" => "row1col1",
"row1col2" => "row1col2",
"row2col1" => "row2col1",
"row2col2" => "row2col2",
"Id" => "Id",
"Original" => "Original",
"Custom-Level-Regex" => "Custom-Level-Regex",
"empty string" => "empty string",
", " => ", ",
"dash-WikiWord" => "dash-WikiWord",
"WikiWord" => "WikiWord",
"not in level" => "not in level",
"Top Objects" => "Top Objects",
"Version" => "Version",
"optional" => "optional",
"Copyrights" => "Copyrights",
"Syntax" => "Syntax",
"System" => "System",
"in:" => "in:",
"Folksonomy Tags" => "Folksonomy Tags",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"RSS Maps" => "RSS Maps",
"Use the subject to indicate the operation to apply:" => "Use the subject to indicate the operation to apply:",
"Newsletter:" => "Newsletter:",
"Mapfile History" => "Mapfile History",
"Version:" => "Version:",
"c=compare" => "c=compare",
"d=diff" => "d=diff",
"Diff" => "Diff",
"OK" => "OK",
"Unflag" => "Unflag",
"eMail" => "eMail",
"Standard" => "Standard",
"Cache" => "Cache",
"[-]" => "[-]",
"Permalink" => "Permalink",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"Tip" => "Tip",
"Community" => "Community",
"i18n" => "i18n",
"InterTiki" => "InterTiki",
"Semester" => "Semester",
"MIME Type" => "MIME Type",
"Exterminator" => "Exterminator",
"Server" => "Server",
"InterTiki Server" => "InterTiki Server",
"IP" => "IP",
"LDAP" => "LDAP",
"URL:" => "URL:",
"PAM" => "PAM",
"Shibboleth Authentication " => "Shibboleth Authentication ",
"Version 1.0" => "Version 1.0",
"Version 2.0" => "Version 2.0",
"Horizontal" => "Horizontal",
"Robots" => "Robots",
"Hotwords" => "Hotwords",
"Sandbox" => "Sandbox",
"Links" => "Links",
"Shoutbox Words" => "Shoutbox Words",
"SysLogs" => "SysLogs",
"Mods" => "Mods",
"Cookies" => "Cookies",
"DSN" => "DSN",
"kb" => "kb",
"mns" => "mns",
"Prio" => "Prio",
"h" => "h",
"tiki admin external wikis template" => "tiki admin external wikis template",
"Name:" => "Name:",
"Are files from repository can be cached" => "Are files from repository can be cached",
"Regex" => "Regex",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
"Regex modifiers" => "Regex modifiers",
"Case" => "Case",
"Position" => "Position",
"Account" => "Account",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"mn" => "mn",
"Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
"Batch e-mail subscribe" => "Batch e-mail subscribe",
"Subscribe group" => "Subscribe group",
"XML Zip" => "XML Zip",
"Alias" => "Alias",
"Charset encoding" => "Charset encoding",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"Charset encoding:" => "Charset encoding:",
"Powered by" => "Powered by",
"Wiki RSS" => "Wiki RSS",
"Blogs RSS" => "Blogs RSS",
"RSS" => "RSS",
"Details" => "Details",
"+" => "+",
"April" => "April",
"August" => "August",
"September" => "September",
"November" => "November",
"Nickname" => "Nickname",
"relate" => "relate",
"Mutual" => "Mutual",
"Text box" => "Text box",
"col" => "col",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that.",
"Option" => "Option",
"Quiz" => "Quiz",
"<b>*</b>=optional" => "<b>*</b>=optional",
"Graph" => "Graph",
"Format" => "Format",
"Autodetect" => "Autodetect",
"normal" => "normal",
"neutral" => "neutral",
"Multibar" => "Multibar",
"Portrait" => "Portrait",
"Release Notes" => "Release Notes",
"Upgrade" => "Upgrade",
"Administrator" => "Administrator",
"Installation" => "Installation",
"DB OK" => "DB OK",
"MultiTiki" => "MultiTiki",
"Powered by TikiWiki" => "Powered by TikiWiki",
"v" => "v",
"SlideShow" => "SlideShow",
"Operator" => "Operator",
"offline" => "offline",
"Operator:" => "Operator:",
"P/F" => "P/F",
"Top 10" => "Top 10",
"Top 20" => "Top 20",
"Top 50" => "Top 50",
"Top 100" => "Top 100",
"tikiwiki.org" => "tikiwiki.org",
"Location : " => "Location : ",
"Parent page" => "Parent page",
"#" => "#",
"Start:" => "Start:",
"Status:" => "Status:",
"Cc" => "Cc",
"CC" => "CC",
"BCC" => "BCC",
"Administration" => "Administration",
"SQL injection" => "SQL injection",
"PHP command injection" => "PHP command injection",
"TOP" => "TOP",
"%H:%M %Z" => "%H:%M %Z",
"Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
"tiki-mobile.php" => "tiki-mobile.php",
"merged note:" => "merged note:",
"Tracker item:" => "Tracker item:",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Diese Funktion ist deaktiviert",
"Permission denied. You cannot view pages" => "Zugriff verweigert. Sie können keine Seiten ansehen",
"For you to vote, cookies must be allowed" => "Um abstimmen zu können, müssen Sie Cookies zulassen.",
"Re:" => "Aw:",
"This forum is flat and doesn't allow replies to other replies" => "Dieses Forum lässt keine Antworten auf andere Antworten zu.",
"This script cannot be called directly" => "Dieses Script kann nicht direkt aufgerufen werden",
"The copyright management feature is not enabled." => "Das Copyright Management ist nicht aktiviert.",
"Copyright management" => "Copyright Management",
"No page indicated" => "Keine Seite angegeben",
"You must supply all the information, including title and year." => "Sie müssen alle Daten angeben, inkl. Titel und Jahr.",
"You do not have permission to use this feature" => "Sie haben keine Berechtigung, diese Funktion zu nutzen",
"This feature is for admins only" => "Zugriff nur für Admin möglich",
"Type" => "Typ",
"Description" => "Beschreibung",
"Size" => "Größe",
"Created" => "Erstellt",
"Uploaded" => "Hochgeladen",
"Last Modified" => "Zuletzt modifiziert",
"Creator" => "Ersteller",
"Author" => "Autor",
"Last editor" => "Letzter Bearbeiter",
"Comment" => "Kommentar",
"Files" => "Dateien",
"Hits" => "Zugriffe",
"Locked by" => "Gesperrt von",
"Path" => "Pfad",
"Default View" => "Standardansicht",
"Aland Islands" => "Aland Inseln",
"Albania" => "Albanien",
"Algeria" => "Algerien",
"American Samoa" => "Amerikanisch Samoa",
"Argentina" => "Argentien",
"Armenia" => "Armenien",
"Australia" => "Australien",
"Austria" => "Österreich",
"Azerbaijan" => "Aserbaidschan",
"Bangladesh" => "Bangladesch",
"Belarus" => "Weissrussland",
"Belgium" => "Belgien",
"Bolivia" => "Bolivien",
"Bosnia and Herzegovina" => "Bosnien-Herzegowina",
"Brazil" => "Brasilien",
"Bulgaria" => "Bulgarien",
"Cameroon" => "Kamerun",
"Canada" => "Kanada",
"Cape Verde" => "Kap Verden",
"Cayman Islands" => "Cayman Inseln",
"Central African Republic" => "Zentralafrikanische Republik",
"Chad" => "Tschad",
"Christmas Island" => "Christmas Inseln",
"Cocos Islands" => "Cocos Inseln",
"Colombia" => "Kolumbien",
"Congo" => "Kongo",
"Congo Democratic" => "Demokratische Republik Kongo",
"Cook Islands" => "Cook Inseln",
"Croatia" => "Kroatien",
"Cuba" => "Kuba",
"Cyprus" => "Zypern",
"Czech Republic" => "Tschechische Republik",
"Denmark" => "Dänemark",
"Djibouti" => "Dschibouti",
"Dominican Republic" => "Dominikanische Republik",
"Egypt" => "Ägypten",
"Equatorial Guinea" => "Äquatorial Guinea",
"Estonia" => "Estland",
"Ethiopia" => "Äthiopien",
"Europe" => "Europa",
"Falkland Islands" => "Falkland Inseln",
"Faroe Islands" => "Faroer Inseln",
"Federated States of Micronesia" => "Mikronesien",
"Fiji" => "Fidschi",
"Finland" => "Finnland",
"France" => "Frankreich",
"French Guiana" => "Französisch Guyana",
"French Polynesia" => "Französisch Polynesien",
"French Southern Territories" => "Französische S&uum;d Territorien",
"Georgia" => "Georgien",
"Germany" => "Deutschland",
"Greece" => "Griechenland",
"Greenland" => "Grönland",
"Hungary" => "Ungarn",
"Iceland" => "Island",
"India" => "Indien",
"Indonesia" => "Indonesien",
"Iraq" => "Irak",
"Ireland" => "Irland",
"Italy" => "Italien",
"Ivory Coast" => "Elfenbeinküste",
"Jamaica" => "Jamaika",
"Kazakstan" => "Kasachstan",
"Kenya" => "Kenia",
"Kyrgyzstan" => "Kirgistan",
"Latvia" => "Lettland",
"Lebanon" => "Libanon",
"Libya" => "Libyen",
"Lithuania" => "Litauen",
"Macedonia" => "Macedonien",
"Madagascar" => "Madagaskar",
"Maldives" => "Maldiven",
"Marshall Islands" => "Marshall Inseln",
"Mauritania" => "Mauritanien",
"Mexico" => "Mexiko",
"Moldova" => "Moldawien",
"Mongolia" => "Mongolei",
"Morocco" => "Marokko",
"Mozambique" => "Mosambique",
"Netherlands" => "Niederlande",
"Netherlands Antilles" => "Niederändische Antillen",
"New Caledonia" => "Neu Kaledonien",
"New Zealand" => "Neuseeland",
"None" => "Keine",
"Norfolk Island" => "Norfolk Inseln",
"Northern Mariana Islands" => "Nördliche Marianen-Inseln",
"North Korea" => "Nord-Korea",
"Norway" => "Norwegen",
"Other" => "Sonstige",
"Palestine" => "Palästina",
"Papua New Guinea" => "Papua Neu Guinea",
"Philippines" => "Philippinen",
"Poland" => "Polen",
"Republic of Macedonia" => "Republik of Mazedonien",
"Romania" => "Rumänien",
"Russia" => "Russland",
"Rwanda" => "Ruanda",
"Saint Helena" => "Sankt Helena",
"Saint Kitts and Nevis" => "Sankt Kitts and Nevis",
"Saint Lucia" => "Sankt Lucia",
"Saint Pierre and Miquelon" => "Sankt Pierre and Miquelon",
"Saudi Arabia" => "Saudi Arabien",
"Serbia" => "Serbien",
"Seychelles" => "Seychellen",
"Singapore" => "Singapur",
"Slovakia" => "Slowakei",
"Slovenia" => "Slowenien",
"Solomon Islands" => "Salomon Inseln",
"South Africa" => "Südafrika",
"South Georgia and South Sandwich Islands" => "Sü Georgien and Südliche Sandwich Inseln",
"South Korea" => "Südkorea",
"Spain" => "Spanien",
"St Vincent Grenadines" => "St. Vincent und die Grenadinen",
"Svalbard and Jan Mayen" => "Svalbard und Jan Mayen",
"Swaziland" => "Swasiland",
"Sweden" => "Schweden",
"Switzerland" => "Schweiz",
"Syria" => "Syrien",
"Tajikistan" => "Tadchikistan",
"Tanzania" => "Tansania",
"Trinidad Tobago" => "Trinidad und Tobago",
"Tunisia" => "Tunesien",
"Turkey" => "Türkei",
"Turks and Caicos Islands" => "Turks und Caicos Inseln",
"United Arab Emirates" => "Vereinigte Arabische Emirate",
"United Kingdom" => "Grossbritannien",
"United Nations Organization" => "Vereinigte Nationen",
"United States" => "Vereinigte Staaten",
"US Virgin Islands" => "US Jungferninseln",
"Uzbekistan" => "Usbekistan",
"Vatican" => "Vatikan",
"Viet Nam" => "Vietnam",
"Wallis and Futuna" => "Wallis und Futuna",
"Western Sahara" => "West Sahara",
"World" => "Welt",
"Yemen" => "Jemen",
"Yugoslavia" => "Jugoslawien",
"Zambia" => "Sambia",
"Zimbabwe" => "Simbabwe",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Erfordert MySQL 4.1+",
"Email address not valid, test mail not sent" => "Ungültige E-Mail-Adresse; Test-Mail konnte nicht verschickt werden.",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "E-Mail-Adresse leer and \"copy\" checkbox nicht gesetzt; Test-Mail konnte nicht verschickt werden.",
"Test mail from Tiki installer " => "Test-Mail von Ihrem TikiWiki Installionsprogramm ",
"Congratulations!\n\nYour server can send emails.\n\n" => "Herzlichen Glückwunsch!\n\nIhr Server kann E-Mails verschicken.\n\n",
"Slovene" => "Slowenisch",
"Arabic" => "Arabisch",
"Catalan" => "Katalanisch",
"Simplified Chinese" => "Chinesisch (vereinfacht)",
"Chinese" => "Chinesisch",
"Czech" => "Tschechisch",
"Danish" => "Dänisch",
"German" => "Deutsch",
"English" => "Englisch",
"English British" => "Englisch (Britisch)",
"Spanish" => "Spanisch",
"Greek" => "Griechisch",
"Finnish" => "Finnisch",
"French" => "Französisch",
"Galician" => "Galizisch",
"Hebrew" => "Hebräisch",
"Croatian" => "Kroatisch",
"Italian" => "Italienisch",
"Japanese" => "Japanisch",
"Korean" => "Koreanisch",
"Hungarian" => "Ungarisch",
"Dutch" => "Hollädnisch",
"Norwegian" => "Norwegisch",
"Polish" => "Polnisch",
"Português" => "Portugiesisch",
"Brazilian Portuguese" => "Brasilianisches Portugiesisch",
"Russian" => "Russisch",
"Slovak" => "Slowakisch",
"Serbian" => "Serbisch",
"Swedish" => "Schwedisch",
"Traditional Chinese" => "Traditionelles Chinesisch",
"Ukrainian" => "Ukrainisch",
"Permission denied" => "Zugriff verweigert",
"Template %s not registered" => "Template %s nicht vorhanden",
"The file is not a CSV file or has not a correct syntax" => "Diese Datei ist keine CSV Datei oder hat nicht die erforderliche Syntax",
"Error line: %d" => "Fehler Zeile: %d",
"locked" => "gesperrt",
"locked by" => "gesperrt von",
"continued" => "weiter",
"New Image Uploaded by" => "Neue Bilder hochgeladen von",
"New Subscriptions" => "Neue Abonnenten",
"New Item in Tracker" => "Neuer Eintrag im Tracker",
"tracker" => "Tracker",
"by" => "von",
"Image Gallery" => "Bildergalerie",
"Articles" => "Artikel",
"Forums" => "Foren",
"Directory" => "Linkverzeichnis",
"File Gallery" => "Dateiarchiv",
"Quizzes" => "Quizze",
"Trackers" => "Tracker",
"Survey" => "Umfrage",
"Newsletter" => "Rundbrief",
"article" => "Artikel",
"blog" => "Blog",
"directory" => "Linkverzeichnis",
"faq" => "FAQ",
"file gallery" => "Dateiarchiv",
"forum" => "Forum",
"image gallery" => "Bildergalerie",
"newsletter" => "Rundbrief",
"poll" => "Abstimmung",
"quiz" => "Quiz",
"survey" => "Umfrage",
"wiki page" => "Wiki-Seite",
"image" => "Bild",
"calendar" => "Kalender",
"Invalid filename (using filters for filenames)" => "Ungültiger Dateiname (verwende Filter)",
"Cannot upload this file - maximum upload size exceeded" => "Datei überschreitet maximale Größ für das Hochladen",
"(not registered)" => "(nicht registriert)",
"Anonymous" => "Unbekannt",
"You have mistyped the anti-bot verification code; please try again." => "Sie haben den Anti-Bot Verifizierungscode falsch eingegeben; bitte versuchen Sie es später noch einmal",
"Please wait %d seconds between posts" => "Bitte warten Sie %d Sekunden zwischen zwei Einträgen.",
"Wrong password. Cannot post comment" => "Falsches Passwort. Kommentar kann nicht gespeichert werden",
"A contribution is mandatory" => "Die Art der Beteiligung muß angegeben werden",
"You have to enter a title and text" => "Sie müssen Titel und Text eingeben",
"Invalid Email" => "Ungültige E-Mail",
"This forum is locked" => "Dieses Forum ist geschlossen.",
"This thread is locked" => "Dieser Thread ist geschlossen.",
"Those comments are locked" => "Diese Kommentare sind gesperrt.",
"WikiDiff::_check: failed" => "WikiDiff::_check: fehlgeschlagen",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: Berarbeitungssequenz ist nicht optimal",
"Line:" => "Zeile:",
"Lines:" => "Zeilen:",
"Tiki Link - Insert internal link" => "TikiWiki Link - Einf&uumlgen eines internen Links.",
"Find" => "Suchen",
"find" => "Suchen",
"prev" => "vorh.",
"Page" => "Seite",
"next" => "nächstes",
"Page name" => "Seitenname",
"File Galleries" => "Dateiarchive",
"The global quota has been reached" => "Die globale Vorgabe ist erreicht.",
"This is the value of your server's PHP '%s' setting" => "Das ist der Wert Ihrer Server PHP '%s' Einstellung",
"Wiki Home" => "Wiki-Home",
"Home" => "Startseite",
"previous page" => "vorherige Seite",
"next page" => "nächste Seite",
"posted on" => "aufgegeben am",
"Continue" => "Weiter",
"By:" => "Von:",
"Read" => "Lesen",
"List articles" => "Artikel auflisten",
"Last post" => "Neuester Eintrag",
"Invalid imagename (using filters for filenames)" => "Ungültiger Dateiname (using filters for filenames)",
"Errors detected" => "Fehler entdeckt",
"Upload was not successful" => "Hochladen war nicht erfolgreich",
"No image yet, sorry." => "Leider noch keine Bilder vorhanden.",
"Invalid file mime type" => "Ungütiger MIME Typ",
"Query point:" => "Abfragepunkt:",
"layer:" => "Schicht:",
"Record:" => "Datensatz:",
"No valid ogr2ogr executable" => "Kein gültiges ogr2ogr ausführbar",
"Could not create \$tdo.mif in data directory" => "Kann keine \$tdo.mif im Datenverzeichnis erstellen",
"Could not create \$tdo.mid in data directory" => "Kann keine \$tdo.mid im Datenverzeichnis erstellen",
"unknown" => "unbekannt",
"User Map Generated in:" => "User Map generiert in:",
"Image Map Generated in:" => "Image Map generiert in:",
"menu" => "Menü",
"NONE" => "KEINES",
"File %s not found" => "Datei %s nicht gefunden",
"File %s is not a valid archive" => "Datei %s ist kein gültiges Archiv",
"Impossible to open %s : %s" => "Kann nicht geöffnet werden %s : %s",
"%s impossible to remove" => "%s kann nicht verschoben werden",
"Description not available" => "Beschreibung nicht verfügbar",
"Module Title" => "Modul Titel",
"No box" => "Keine Box",
"Decorations" => "Dekorationen",
"Perspective" => "Perspektive",
"Language" => "Sprache",
"Section" => "Bereich",
"No Page" => "Keine Seite",
"Rows" => "Zeilen",
"section edit" => "Abschnitt editieren",
"This poll is closed." => "Diese Umfrage ist geschlossen.",
"Users accept internal messages by default" => "Standardmässig interne Nachrichten empfangen",
"Users can opt-out internal messages" => "Benutzer können Empfang interne Nachrichten deaktivieren",
"Title" => "Titel",
"Title length" => "Titellänge",
"Topic" => "Thema",
"Publication date" => "Erscheinungsdatum",
"Expiration date" => "Verfallsdatum",
"Visible" => "Sichtbar",
"Rating" => "Wertung",
"Reads" => "Zugriffe",
"Images" => "Bilder",
"Default number per page" => "Standardanzahl pro Seite",
"Default Ordering" => "Standardreihenfolge",
"Newest first" => "Neueste zuerst",
"Oldest first" => "Älteste zuerst",
"Points" => "Punkte",
"Authentication method" => "Authentifizierungsmethode",
"Tiki" => "TikiWiki",
"Tiki and OpenID" => "Tiki und OpenID",
"Tiki and PAM" => "Tiki und PAM",
"Tiki and LDAP" => "Tiki und LDAP",
"Web Server" => "Webserver",
"Available languages" => "Verfügbare Sprachen",
"Creation date (desc)" => "Erstellungsdatum (abst.)",
"Last modification date (desc)" => "Datum letzte Änderung (abst.)",
"Blog title (asc)" => "Blog-Titel (aufst.)",
"Number of posts (desc)" => "Anzahl Posts (abst.)",
"Visits (desc)" => "Besuchszahlen (abst.)",
"Activity (desc)" => "Aktivität (abst.)",
"Disabled" => "deaktiviert",
"Plain text" => "Nur Text",
"Link to user information" => "Link auf Benutzer-Informationen",
"User avatar" => "Benutzer Avatar",
"Users can change site language" => "Benutzer können die Sprache der Site verändern.",
"Spell checking" => "Rechtschreibprüfung",
"Contact user" => "Kontaktperson",
"Count admin pageviews" => "Seitenaufrufe durch Admin mitzählen",
"Default charset for sending mail" => "Zeichensatz in eMails",
"default mapfile" => "Standard-Kartendatei",
"Show Country Flag" => "Zeige Landesfahne",
"Show the country flag" => "Zeige Landesfahne",
"Validate URLs" => "URLs überprüfen",
"Links per page" => "Links pro Seite",
"Method to open directory links" => "Art und Weise Links zu öffnen",
"replace current window" => "Fenster ersetzen",
"new window" => "neues Fenster",
"inline frame" => "Frame innerhalb der Seite",
"PHP errors visible to admin only" => "PHP Fehlermeldungen nur für Admin sichtbar",
"No error reporting" => "Keine Fehlerausgabe",
"Report all PHP errors except strict" => "Alle PHP-Fehler außer STRICT ausgeben",
"Report all PHP errors" => "Alle PHP Fehler ausgeben",
"Report all PHP errors except notices" => "Alle PHP-Fehler außer Hinweisen (NOTICES) ausgeben",
"Default number of comments per page" => "Standardanzahl von Kommentaren pro Seite",
"Comments default ordering" => "Standardsortierung für Kommentare",
"Machine Translation (by Google Translate)" => "Automatisierte Übersetzung (durch Google Translate)",
"Polls" => "Abstimmungen",
"Newsletters" => "Rundbriefe",
"Calendar" => "Kalender",
"Banners" => "Banner",
"Category" => "Kategorie",
"Score" => "Bewertung",
"Search" => "Suche",
"Action Log" => "Aktionslog",
"Multilingual" => "Mehrsprachig",
"Frequently asked questions and answers" => "H&auum;ufige gestellte Fragen und Antworten",
"Surveys" => "Umfragen",
"Quizzes " => "Quizze",
"Featured links" => "Linktips",
"The applet is designed to read MP3 or FLV file" => "Diese Anwendung kann MP3 oder FLV Dateien lesen.",
"Maps" => "Karten",
"Requires mapserver" => "Erfordert Mapserver",
"Interactive use of Google Maps" => "Interaktive Benutzung von Google Maps",
"Live support system" => "Onlinesupport-System",
"Tell a Friend" => "Erzähle dies weiter",
"HTML pages" => "HTML-Seiten",
"Static and dynamic HTML content" => "Statischer und dynamischer HTML Inhalt",
"Contact Us" => "Kontaktiere uns",
"Comments Moderation " => "Kommentar Moderation ",
"An admin must validate a comment before it is visible" => "Ein Kommentar wird erst sichtbar, wenn er von einem Admin freigegeben wurde",
"Comments Locking" => "Sperren von Kommentaren",
"Comments can be closed (no new comments)" => "Kommentare können geschlossen werden (keine neuen Kommentare)",
"Allow posting of comments as Anonymous" => "Unbekannte Benutzer dürfen kommentieren",
"Permit anonymous visitors to add a comment without needing to create an account" => "Erlaube anonymen Besuchern einen Kommentar hinzuzufügen, ohne einen Account anzulegen.",
"Display page description" => "Zeige Seitenbeschreibung",
"Display page ID" => "Zeige Seiten-ID",
"Individual wiki cache" => "Individueller Wiki Cache",
"JS Calendar" => "JS Kalender",
"PHPLayers" => "PHPLayer",
"Output should be HTMLPurified" => "Ausgabe sollte HTML-bereinigt sein",
"Full Screen" => "Vollbildschirm",
"Css Menus" => "Css Menüs",
"Mobile" => "Tiki Mobil",
"Morcego 3D browser" => "Morcego-3D-Browser",
"Search engine friendly url" => "Suchmaschinen-freundliche URLs",
"Wysiwyg editor" => "WYSIWYG Editor",
"Requires AJAX (experimental)" => "Erfordert AJAX (experimental)",
"Friendship Network" => "Freundschafts-Netzwerk",
"Banning system" => "Benutzer-Sperrsystem",
"Stats" => "Statistiken",
"Referer Stats" => "Referer-Statistik",
"Redirect On Error" => "Bei Fehler wiederverbinden",
"Communications (send/receive objects)" => "Kommunikation (Objekte senden/empfangen)",
"Custom Home" => "Angepasstes Home",
"Mini Calendar" => "Mini-Kalender",
"User Preferences Screen" => "Benutzer-Einstellungsseite",
"User Notepad" => "Benutzer-Notizblock",
"User Bookmarks" => "Benutzer-Lesezeichen",
"User Contacts" => "Benutzerkontakte",
"User Watches" => "Benutzer Beobachtungspunkte",
"Group Watches" => "Gruppen Beobachtungspunkte",
"Daily Reports for User Watches" => "Tägliche Berichte für Benutzer-Beobachtungspunkte",
"User Watches Translations" => "Beobachtungspunkte beobachten auch Übersetzungen",
"User Menu" => "Benutzer-Menü",
"User Tasks" => "Benutzer-Aufgaben",
"User Messages" => "Benutzer-Nachrichten",
"User Files" => "Benutzer-Dateien",
"User Levels" => "Benutzerlevel",
"Group Alert" => "Gruppen Benachrichtigungen",
"XMLRPC API" => "XMLRPC-API",
"Debugger Console" => "Debug-Konsole",
"Check for updates automatically" => "Automatisch nach neuer Version suchen",
"TikiWiki will check for updates when you access the main Administration page" => "TikiWiki prüft auf neue Version, wenn Sie die Admin Hauptseite aufrufen",
"Protect against CSRF with a ticket" => "Durch Ticket gegen CSRF schützen",
"Detect browser language" => "Sprache des Clients abfragen",
"Help System" => "Hilfe-System",
"Dynamic Content System" => "Dynamischer Inhalt",
"Semantic links" => "Semantische Links",
"Display menus as folders" => "Menüs als Ordner darstellen",
"Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonyme Editoren müssen Anti-Robot Code (CAPTCHA) eingeben",
"Protect email against spam" => "eMail-Adressen vor Spam schützen",
"Activate" => "Aktivieren",
"Comments" => "Kommentare",
"Search and replace" => "Suchen und ersetzen",
"Submissions" => "Einreichungen",
"Rankings" => "Bewertungen",
"Content templates" => "Inhaltsvorlagen",
"Print" => "Drucken",
"Ignore category viewing restrictions" => "Kategorie-Sichteinschränkungen ignorieren",
"Local" => "Lokal",
"List pages" => "Seiten auflisten",
"Last changes" => "Neueste Änderungen",
"Orphan pages" => "Verwaiste Seiten",
"Database search" => "Datenbanksuche",
"Referer Search Highlighting" => "Hervorhebung der Suchbegriffe auf den gefundenen Seiten",
"Search stats" => "Such-Statistik",
"Ignore individual object permissions" => "Individuelle Objekt-Berechtigungen ignorieren",
"Visits" => "Besuche",
"Object type" => "Objekttyp",
"Accept wiki syntax" => "Wiki-Syntax erlauben",
"tikihash (old)" => "tikihash (alt)",
"Display 'MyTiki' in the application menu" => "'MeinTiki' im Anwendungsmenü anzeigen",
"Prevent download if score becomes negative" => "Downloads bei negativer Bewertung verbieten",
"Allow download limit per file" => "Dateiweise Download-Begrenzung erlauben",
"Allow same file to be uploaded more than once" => "Selbe Datei darf mehrfach hochgeladen werden",
"Never" => "Nie",
"Mb" => "MB",
"Uploaded filenames must match regex" => "Hochgeladene Dateinamen müssen diese RegEx erfüllen",
"Plain" => "flach",
"Headers Only" => "nur Köpfe",
"Title (desc)" => "Titel (abst.)",
"Title (asc)" => "Titel (aufst.)",
"Topics" => "Themen",
"Posts" => "Einträge",
"Posts per day" => "Einträge pro Tag",
"Creation Date (desc)" => "Erstellungsdatum (abst.)",
"Topics (desc)" => "Themen (abst.)",
"Threads (desc)" => "Threads (abst.)",
"Last post (desc)" => "Neueste Einträge (abst.)",
"Name (desc)" => "Name (abst.)",
"Name (asc)" => "Name (aufst.)",
"Browser title" => "Browsertitel",
"Home page" => "Startseite",
"Use group homepages" => "Gruppen-Homepages benutzen",
"Go to group homepage only if login from default homepage" => "Sprung zur Gruppen-Homepage nur bei Login über die Default-Homepage",
"Default language" => "Standard-Sprache",
"Temporary directory" => "Temporärverzeichnis",
"Help URL" => "Hilfe URL",
"Open external links in new window" => "Externe Links in neuem Fenster öffnen",
"Full path to gdaltindex" => "Kompletter Pfad zu gdaltindex",
"Full path to ogr2ogr" => "Kompletter Pfad zu ogr2ogr",
"Display modules to all groups always" => "Module immer in allen Gruppen anzeigen",
"Hide anonymous-only modules from registered users" => "Module für Anonym bei registrierten Benutzern verstecken",
"Content" => "Inhalt",
"Use database for translation" => "für Übersetzung Datenbank benutzen",
"Log mail in Tiki logs" => "Mails in Tiki Logs protokollieren",
"Log SQL" => "SQL-Abfragen protkollieren",
"Mail end of line" => "Zeilenumbruch in eMails",
"full path to mapfiles" => "Kompletter Pfad zu Kartendateien",
"Wiki Page for Help" => "Wikiseite für Hilfe",
"Wiki Page for Comments" => "Wikiseite für Kommentare",
"Memcache" => "Speichercaching",
"Allow users to define icons for menus entries" => "Benutzer dürfen eigene Symbole für Menuüeinträge definieren",
"Maximum mailbox size (messages, 0=unlimited)" => "Mailbox-Größe (in Nachrichten, 0=unbegrenzt)",
"Maximum mail archive size (messages, 0=unlimited)" => "Mailboxarchiv-Größe (in Nachrichten, 0=unbegrenzt)",
"Maximum sent box size (messages, 0=unlimited)" => "Ausgangsordner-Größe (in Nachrichten, 0=unbegrenzt)",
"geo.position" => "Geo Position",
"geo.region" => "Geo Region",
"geo.placename" => "Geo Ort",
"Bottom" => "Unteres Ende",
"Proxy port" => "Proxy Port",
"Record untranslated strings" => "Eintrag nicht übersetzt",
"Normal" => "normal",
"Refresh rate" => "Refresh-Rate",
"Minimum length of search word" => "Mindestlänge des Suchwortes",
"Max. number of words containing a syllable" => "Maximalzahl einsilbiger Wörter",
"Max. age in hours of syllable search cache" => "Maximales Alter in Stunden im Cache für Silbensuche",
"LRU list purging rate" => "Löschrate der LRU Liste",
"LRU list length" => "Länge der LRU Liste",
"Sender email" => "eMail-Absender",
"Session storage location" => "Speicherort für Sitzungsdaten",
"Default (from php.ini)" => "Standard (aus php.ini)",
"Database" => "Datenbank",
"Session lifetime" => "Lebenszeit von Sitzungdaten",
"Value provided in minutes" => "Wert ist in Minuten anzugeben",
"After" => "nach",
"Before" => "vor",
"Browser title display mode" => "Browser-Titel Anzeigemodus",
"Most specific first" => "Genauestes Element zuerst",
"Least specific first (site)" => "Allgemeinstes Element zuerst",
"Current only" => "Nur aktuelles Element",
"Publish" => "Veröffentlichen",
"Check frequency" => "Prüfhäufigkeit",
"Each day" => "täglich",
"Each week" => "wöchentlich",
"Each month" => "monatlich",
"Use proxy" => "Proxy benutzen",
"Always" => "Immer",
"Allow viewing HTML mails?" => "Anzeigen von HTML Mails erlauben?",
"Maximum size for each attachment" => "Maximale Größe pro Anlage",
"Unlimited" => "unbegrenzt",
"Wiki link format" => "Wikilink-Format",
"Complete" => "komplett",
"Business style" => "geschäftlich",
"Collaborative style" => "kollaborativ",
"Page last modified on" => "Seite zuletzt geändert am",
"Cache wiki pages (global)" => "Wikiseiten cachen (global)",
"no cache" => "kein Cache",
"minute" => "Minute",
"minutes" => "Minuten",
"hour" => "Stunde",
"hours" => "Stunden",
"Enable wiki 3D browser" => "Wiki 3D Browser aktivieren",
"Load page on navigation" => "Seite beim navigieren laden",
"Browser height" => "Browser-Breite",
"Navigation depth" => "Navigationstiefe",
"Node size" => "Knotengrösse",
"Text size" => "Textgrösse",
"Spring (connection) size" => "Quellengrösse (Verbindung)",
"Existing page node color" => "Farbe existierender Knoten",
"Missing page node color" => "Farbe fehlender Knoten",
"Camera distance adjusted relative to nearest node" => "Kamera Entfernung einstellen, relativ zum nahsten Knoten",
"Camera distance" => "Kamera Entfernung",
"Field of view" => "Sichtbares Feld",
"Feed animation interval (milisecs)" => "Feed Animationsintervall (Millisek.)",
"Friction constant" => "Reibungskostante",
"Elastic constant" => "Elastizitätskonstante",
"Eletrostatic constant" => "Elektrostatischekonstante",
"Node mass" => "Knotengewicht",
"Node charge" => "Knotenladung",
"Wiki top pages" => "Wiki-Top-Seiten",
"Most relevant pages" => "Relevanteste Seiten",
"Relevance" => "Relevanz",
"Wiki last pages" => "Neueste Wiki-Seiten",
"Modified" => "Geändert",
"Forums last posts" => "Letzte Beiträge im Forum",
"Topic date" => "Themendatum",
"Forums most read topics" => "Foren mit den meistgelesenen Themen",
"Forums best topics" => "Foren mit den beliebtesten Themen",
"Forums most visited forums" => "Meistbesuchte Foren",
"Forums with most posts" => "Foren mit den meisten Beiträgen",
"Wiki top galleries" => "Wiki Top Galerien",
"Wiki top file galleries" => "Wiki Top Dateiarchive",
"Wiki top images" => "Wiki Top Bilder",
"Wiki top files" => "Wiki Top Dateien",
"Wiki last images" => "Wiki neueste Bilder",
"Upload date" => "Hochlade-Datum",
"Wiki last files" => "Wiki neueste Dateien",
"Wiki top articles" => "Meistgelesene Artikel",
"Most visited blogs" => "Meistbesuchte Blogs",
"Most active blogs" => "Aktivste Blogs",
"Activity" => "Aktivität",
"Blogs last posts" => "Neueste Blog-Einträge",
"Post date" => "Eintragsdatum",
"Wiki top authors" => "Wiki Top Autoren",
"Pages" => "Seiten",
"Top article authors" => "Top Artikel-Autoren",
"The passwords do not match" => "Die Passwörter stimmen nicht überein.",
"User already exists" => "Benutzer existiert bereits",
"Wrong registration code" => "Falscher Registrierungscode",
"Invalid username" => "Benutzername ungültig",
"Username is too long" => "Benutzername zu lang",
"Username cannot contain whitespace" => "Benutzername darf keine Leerzeichen enthalten",
"Wrong passcode. You need to know the passcode to register at this site" => "Falscher Passcode. Sie müssen Ihren Passcode kennen, um sich an dieser Site zu registrieren",
"Invalid email address. You must enter a valid email address" => "eMail-Adresse ungültig. Eine gültige Adresse ist zwingend",
"The registration mail can't be sent. Contact the administrator" => "Die E_Mail für die Registrierung kann nicht versendet werden. Bitte kontaktieren Sie den Administrator dieser Site.",
"uploaded the file" => "lud die Datei",
"change" => "Aenderung",
"changes" => "Aenderungen",
"No changes" => "Keine Aenderungen",
"Today" => "Heute",
"and" => "und",
"more changes of the same type..." => "weitere Aenderungen der selben Art...",
"changed the picture gallery" => "aenderte die Bildergalerie",
"uploaded the picture" => "lud das Bild",
"onto" => "nach",
"removed the picture" => "entfernte das Bild",
"from" => "von",
"edited the wikipage" => "aenderte die Seite",
"this history" => "diese Aenderung",
"all history" => "alle Aenderungen",
"edited the file gallery" => "aenderte das Dateiarchiv",
"removed the file" => "entfernte die Datei",
"created the subcategory" => "erstellte die Unterkategorie",
"removed the subcategory" => "entfernte die Unterkategorie",
"edited the category" => "aenderte die Kategorie",
"removed the article" => "verschob den Artikel",
"created the article" => "erstellte den Artikel",
"edited the article" => "aenderte den Artikel",
"replied to the blog" => "antwortete auf den Blog",
"created the topic" => "erstellte das Thema",
"at forum" => "im Forum",
"replied" => "antwortete",
"to the topic" => "auf das Thema",
"Nothing has happened." => "Es wurde nichts gaendert",
"Login" => "Anmeldung",
"See other users' profiles" => "Profil eines anderen Benutzers ansehen",
"Have your profile seen" => "Benutzer sieht sich Ihr Profil an",
"Make friends" => "Freundschaft schließen",
"Receive message" => "Nachricht empfangen",
"Send message" => "Nachricht schicken",
"Read an article" => "Artikel lesen",
"Publish an article" => "Artikel veröffentlichen",
"Have your article read" => "Benutzer liest Ihren Artikel",
"Create new file gallery" => "Neues Dateiarchiv anlegen",
"Upload new file to gallery" => "Datei in Archiv hochladen",
"Download other user's file" => "Datei eines anderen Benutzers herunterladen",
"Have your file downloaded" => "Benutzer läd eine Ihrer Dateien herunter",
"Create a new image gallery" => "Neue Bildgalerie anlegen",
"Upload new image to gallery" => "Bild in Galerie hochladen",
"See other users' galleries" => "Galerie eines anderen Benutzers anschauen",
"See other users' images" => "Bild eines anderen Benutzers betrachten",
"Have your gallery seen by other users" => "Benutzer betrachtet Ihre Galerie",
"Have your image seen" => "Benutzer betrachtet eines Ihrer Bilder",
"Create new blog" => "Neuen Blog erstellen",
"Post in a blog" => "Eintrag in Blog vornehmen",
"Read other users' blogs" => "Blog eines anderen Benutzers lesen",
"Have your blog read" => "Benutzer liest Ihren Blog",
"Create a new wiki page" => "Neue Wiki-Seite erstellen",
"Edit an existing page" => "Vorhandene Wiki-Seite bearbeiten",
"Attach file" => "Datei anhängen",
"Gallery" => "Galerie",
"Image" => "Bild",
"Article" => "Artikel",
"Blog post" => "Blog-Eintrag",
"Unknown" => "Unbekannt",
"Directory category" => "Verzeichniskategorie",
"Prev" => "Vorher.",
"Next" => "Nächst.",
"comment" => "Kommentar",
"No Tabs" => "Tabs ausschalten",
"Click Here" => "Hier klicken",
"Hide" => "Verbergen",
"help" => "Hilfe",
"All" => "Alle",
"The text is" => "Der Text ist",
"character(s) too long - please edit it." => "Zeichen zu lang. Bitte anpassen.",
"Date Selector" => "Datum auswählen",
"phplayers are not available on this site" => "Keine phplayer auf dieser Site vorhanden.",
"Select All" => "Alle auswählen",
"days" => "Tage",
"day" => "Tag",
"mins" => "Min.",
"min" => "Min.",
"secs" => "Sek.",
"done" => "fertig",
"Text cut here" => "Text hier abgeschnitten",
"Task" => "Aufgabe",
"for" => "für",
"Priority" => "Priorität",
"Start date:" => "Anfangsdatum",
"End date:" => "Enddatum",
"Friend" => "Freund",
"Last seen on" => "Zuletzt online am",
"(idle for %s seconds)" => "(untätig für %s Sekunden)",
"User information - Click for more info" => "Benutzer Information - Klick für weitere Details",
"More info about \$other_user" => "Mehr Info über \$other_user",
"(idle for \$idletime seconds)" => "(nicht am Rechner seit \$idletime Sekunden)",
"Yes" => "Ja",
"No" => "Nein",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "1",
"Use this tree to copy the structure" => "Diesen Baum benutzen zum Erstellen der Struktur",
"created from structure" => "aus Struktur erstellt",
"Table of contents" => "Inhaltsverzeichnis",
"text" => "Text",
"unknown error" => "Unbekannter Fehler",
"You are not logged in" => "Sie sind nicht angemeldet",
"Page cannot be found" => "Seite nicht gefunden",
"Permission denied. You cannot view this section" => "Zugriff verweigert. Sie können diesen Bereich nicht betrachten",
"Help" => "Hilfe",
"You are banned from" => "Sie wurden verbannt von",
"wiki" => "Wiki",
"img-g" => "Bildergalerien",
"file-g" => "Dateiarchive",
"faqs" => "FAQs",
"quizzes" => "Quiz",
"arts" => "Artikel",
"blogs" => "Blogs",
"forums" => "Foren",
"Click to edit dynamic variable" => "Klicken zum Bearbeiten der dynamischen Variable",
"Update variables" => "Variablen aktualisieren",
"index" => "Index",
"Show" => "Zeigen",
"sad" => "traurig",
"confused" => "verwirrt",
"mad" => "sauer",
"%d points" => "%d Punkte",
"Removed" => "Verschoben",
"at" => "um",
"new" => "neu",
"Create page:" => "Seite erstellen:",
"Unknown language" => "unbekannte Sprache",
"Click here to confirm your action" => "Zur Bestätigung hier klicken",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) entdeckt. Ausführung geblockt.",
"Heading" => "Aufmacher",
"Reduce area height" => "Höhe verringern",
"Enlarge area height" => "Höhe vergrößern",
"Wiki Help" => "Wiki Hilfe",
"Item Modification" => "Item Modifikation",
"Item" => "Eintrag",
"Item creation" => "Item ERstellung",
"Subject" => "Betreff",
"Tracker was modified at " => "Tracker wurde verändert auf ",
"text field" => "Eingabefeld",
"half column" => "halbe Spalte",
"size" => "Größe",
"prepend" => "vorangestellt",
"append" => "angehängt",
"textarea" => "Textbereich",
"checkbox" => "Schalter",
"numeric field" => "Zahl",
"drop down" => "Auswahlliste",
"radio buttons" => "Radio buttons",
"user selector" => "Nutzerauswahl",
"group selector" => "Gruppenauswahl",
"country selector" => "Land auswählen",
"date and time" => "Datum und Zeit",
"jscalendar" => "JSKalender",
"action" => "Aktion",
"header" => "Überschrift einfügen",
"category" => "Kategorie",
"item link" => "item Link",
"items list" => "items Liste",
"email" => "eMail",
"url" => "URL",
"system" => "System",
"attachment" => "Anhang",
"open" => "offen",
"pending" => "anstehend",
"closed" => "geschlossen",
"Message" => "Nachricht",
"No extra information for that attached file. " => "Keine Zusatzinformation für die angehängte Datei. ",
"child categories" => "Unterkategorien",
"objects in category" => "Objekte in Kategorie",
"Password should be at least" => "Paßwort sollte mindestens",
"characters long" => "Zeichen lang sein",
"Password must contain both letters and numbers" => "Paßwort muss sowohl Buchstaben als auch Zahlen enthalten",
"State" => "Status",
"Country" => "Land",
"No subject" => "Kein Betreff vorhanden",
"Info" => "Information",
"Displays browser client info" => "Zeigt Browser Informationen an.",
"Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Erzeugt einen Link zu einem Anker in einer Wiki-Seite. Benutzt in Verbindung mit dem ANAME Plugin, das den Ort und den Namen des Anker angibt.",
"linktext" => "Linktext",
"Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Erzeugt einen Anker in einer Wiki-Seite. Benutzt in Verbindung mit dem ALINK Plugin, das den Link zu dem Anker angibt.",
"Location" => "Ort",
"Field" => "Feld",
"Attachment" => "Anhang",
"File" => "Datei",
"Show description" => "Beschreibung zeigen",
"Displays an attachment or a list of them" => "Zeigt einen Anhang oder eine Liste der Anhänge.",
"Displays the user Avatar" => "Zeigt den Benutzer-Avatar an.",
"username" => "Benutzername",
"Back" => "Zurück",
"List all pages that link to specific pages" => "Zeigt alle Seiten die auf spezielle Seiten verlinken.",
"No pages links to" => "Keine Seitenverweise auf",
"One page links to" => "Ein Seitenverweis auf",
"pages link to" => "Seitenverweise auf",
"Zone" => "Bereich",
"Items" => "Einträge",
"Insert theme-styled box on wiki page" => "Box im Theme-Layout in Wiki-Seite einfügen",
"Insert list of items with the current/given category in the wiki page" => "Alle Einträge der aktuellen/angegebenen Kategorie in die Wiki-Seite einfügen",
"Categories are disabled" => "Kategorien sind nicht aktiviert",
"Display Tiki objects that have not been categorized" => "Noch nicht kategorisierte Tiki-Objekte anzeigen",
"Objects" => "Objekte",
"Insert the full category path for each category that this wiki page belongs to" => "Fügt den Kategorienbaum für jede Kategorie an, zu der diese Seite gehört",
"Centers the plugin content in the wiki page" => "Zentriert den PlugIn-Inhalt innerhalb der Wiki-Seite.",
"Chart" => "Hitliste",
"title" => "Titel",
"Chart as PDF" => "Chart als PDF",
"Chart as PostScript" => "Chart als PostScript",
"Code" => "Quellcode",
"Displays a snippet of code" => "Zeigt einen Quellcode-Ausschnitt an",
"code" => "Quellcode",
"note: colors and ln are exclusive" => "Hinweis: Farben sind ausgeschlossen.",
"Dynamic Content" => "Dynamischer Inhalt",
"Insert copyright notices" => "Fügt Copyright-Notizen ein.",
"Example" => "Beispiel",
"seconds" => "Sekunden",
"Pre" => "Letzte",
"Right" => "Rechts",
"Left" => "Links",
"Clear" => "Zurücksetzen",
"Creates a definition list" => "Legt eine Definitionsliste an",
"term" => "Term",
"definition" => "Definition",
"one definition per line" => "eine Definition pro Zeile",
"Events" => "Ereignisse",
"Desc" => "Beschreibung",
"Upcoming events" => "nächste Termine",
"Label" => "Beschriftung",
"Displays the data using the Tikiwiki odd/even table style" => "Daten im Tiki gerade/ungerade Stil anzeigen",
"cells" => "Zellen",
"sort" => "sortieren",
"Displays a Flash (.swf) file in the wiki page" => " Zeigt eine Flash-Datei (.swf) auf einer Wiki-Seite.",
"missing parameters" => "Fehlende Parameter",
"failed" => "fehlgeschlagen",
"description" => "Beschreibung",
"Value" => "Wert",
"Displays a graphical GAUGE" => "Zeigt einen grafischen GAUGE",
"type" => "Typ",
"Group" => "Gruppe",
"Display wiki text if user is in one of listed groups" => "Zeigt den Wiki-Text, falls der User einer der aufgeführten Gruppen angehört.",
"groups" => "Gruppen",
"HTML code" => "HTML-Code",
"name" => "Name",
"Image ID" => "Bild-ID",
"Image size" => "Bildgrösse",
"Thumbnail" => "Vorschau",
"Browse" => "Ansehen",
"Download" => "Herunterladen",
"Include" => "Aufnehmen",
"Stop" => "Anhalten",
"Include a page" => "Eine Seite einbinden",
"Following mandatory fields are missing" => "Folgende notwendige Felder sind nicht ausgefüllt.",
"Email address" => "eMail-Adresse",
"Runs a Java applet to access a local Jabber service" => "Start ein Java Applet um auf einen lokalen Jabber Service zuzugreifen.",
"Displays the text only if the language matchs" => "Zeigt den Text nur dann wenn die Sprachen übereinstimmen.",
"Last Modification" => "Letzte Änderung",
"List Pages" => "Seiten auflisten",
"Sort" => "Sortieren",
"or" => "oder",
"Filter" => "Filtern",
"complete" => "vollständig",
"articles" => "Artikel",
"Lists files in a directory" => "Listet alle Dateien eines Verzeichnisses auf",
"could not be opened because it doesn't exist or permission was denied" => "Kann nicht geöffnet werden, weil nicht existent oder keine Zugriffsrechte vorhanden.",
"Map" => "Karte",
"Displays a map" => "Zeigt eine Karte",
"Feature disabled" => "Funktion deaktiviert",
"Template" => "Vorlage",
"Style" => "Stil",
"Groups" => "Gruppen",
"Module Name" => "Modulname",
"Please choose a module" => "Bitte ein Modul wählen",
"to be used as argument" => "als Argument zu verwenden",
"Displays a module inline in a wiki page" => "Zeigt ein Modul innerhalb einer Wiki-Seite an.",
"Sorry, no such module" => "Kein solches Modul vorhanden",
"Displays the data using a monospace font" => "Zeigt den PlugIn-Inhalt in einer MonoSpace-Schrift an",
"data" => "Daten",
"Object" => "Objekt",
"Days" => "Tage",
"Displays object hit info by object and days" => "Zeigt Informationen über die Hits eines Objekts nach Objekt oder Tagen.",
"Picture" => "Bild",
"picture not found" => "Bild nicht gefunden",
"Displays a list of plugins available in this wiki." => "Zeigt eine Liste der verfügbaren Plugins für dieses Wiki.",
"No version indicated" => "Keine Version angegeben",
"No arguments indicated" => "Es wurden keine Argumente angegeben",
"Poll" => "Abstimmung",
"Displays the output of a poll, fields are indicated with numeric ids." => "Zeigt die Ausgabe einer Umfrage, Felder werden mit numerischen IDs angegeben.",
"missing poll ID for plugin POLL" => "Fehlende Umfrage ID für das Plugin POLL",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Zitattext wird mit einer Box umgeben, wie bei [QUOTE] im BBCode",
"Preferences" => "Einstellungen",
"User Information" => "Benutzer-Information",
"one data per line" => "ein Eintrag pro Zeile",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Erkennt REGEX Ausdrücke und parst den Inhalt zwischen den REGEX TAGS und ersetzt den Text.",
"Icon" => "Symbol",
"Close" => "Schließen",
"Date" => "Datum",
"Automatically creates a link to the appropriate SourceForge object" => "Erstellt automatisch einen Link zum passenden SourceForge Objekt",
"Sheet Heading" => "Blatt Überschrift",
"Edit Sheet" => "Bearbeite Blatt",
"List wiki pages" => "Wiki-Seiten auflisten",
"Display" => "Anzeigen",
"Last modified by" => "Zuletzt bearbeitet von",
"Clickable Skype link" => "Anklickbarer Skype Link.",
"Action" => "Aktion",
"The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "Das SNARF Plugin ersetzt sich selbst durch den HTML body einer URL.  Arbitrary regex Ersetzungen können für diesen Inhalt mit regex und regexres ausgeführt werden, letzteres wird als zweites Argument gesetzt bei preg_replace.",
"Missing url parameter for SNARF plugin." => "Fehlender URL Parameter für SNARF Plugin.",
"Sorts the plugin content in the wiki page" => "Sortiert den PlugIn-Inhalt innerhalb einer Wiki-Seite",
"Order" => "Reihenfolge",
"Split a page into rows and columns" => "Seite in Spalten und Zeilen aufteilen",
"First" => "Erste",
"Edit" => "Bearbeiten",
"Run a sql query" => "SQL-Abfrage ausführen",
"sql query" => "SQL-Abfrage",
"Missing db param" => "Datenbank-Parameter fehlt",
"Displays text in subscript." => "Zeigt Text in subscript.",
"Subscribe" => "Abonnieren",
"Url" => "URL",
"Displays text between HTML tags" => "Zeigt Text zwischen HTML tags",
"Displays the thumbnail for an image" => "Zeigt Thumbnails (Vorschaubilder) für ein Bild.",
"Search the titles of all pages in this wiki" => "Sucht die Titel aller Seiten in diesem Wiki",
"No pages found for title search" => "Titelsuche hat keine Seiten gefunden",
"One page found for title search" => "Titelsuche hat eine Seite gefunden",
"pages found for title search" => "Seiten bei Titelsuche gefunden",
"Structure ID" => "Struktur-ID",
"Public" => "Öffentlich",
"List top-scoring users" => "Zeigt die User mit den meisten Punkten",
"Translate" => "übersetzen",
"Fields" => "Felder",
"Email" => "eMail",
"to" => "bis",
"template" => "Vorlage",
"Preview" => "Vorschau",
"preview" => "Vorschau",
"Reset" => "Zurücksetzen",
"View" => "Betrachten",
"Error" => "Fehler",
"Following fields are incorrect" => "Folgende Felder sind nicht korrekt.",
"Displays an input form for tracker submit" => "Zeigt das Eingabeformular für einen Tracker",
"You do not have permission to insert an item" => "Sie haben nicht die Berechtigung ein Item hinzuzufügen.",
"Fields marked with a * are mandatory." => "Mit einem * markierte Felder müssen ausgefüllt werden.",
"tracker field type not processed yet" => "Tracker Feldtyp wird bisher nicht unterstützt.",
"Filters the items of a tracker, fields are indicated with numeric ids." => "Filtert die Items eines tracker, Felder werden mit numerischen IDs angegeben.",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Zeigt die Ausgabe des Trackerinhalts,Felder werden mit numerischen IDs angegeben.",
"Mode" => "Modus",
"Delete" => "Löschen",
"Error in tracker ID" => "Fehler in tracker ID",
"No field indicated" => "Kein Feld angegeben",
"Start Date" => "Startdatum",
"End Date" => "Enddatum",
"Links to a translated content" => "Verweist auf einen übersetzten Inhalt",
"Flag" => "Kennzeichen",
"Displays the number of registered users" => "zeigt die Anzahl der registrierten User.",
"User List" => "Benutzerliste",
"Displays a list of registered users" => "Zeigt eine Liste der registrierten User",
"Real Name" => "Tatsächlicher Name",
"users" => "Benutzer",
"Versions" => "Versionen",
"Split the text in parts visible only under some conditions" => "Teilt den Text in Teile auf die nur unter bestimmten Voraussetzungen sichtbar sind.",
"Vote" => "Stimme",
"Table" => "Tabelle",
"Lists ''wanted'' Wiki pages: " => "Liste ''wanted'' Wiki-Seite: ",
"Page-Pattern" => "Seiten-Muster",
"^Parameters: key=>value,...\n" => "^Parameter: Schlüssel=>Wert,...\n",
"__key__ | __default__ | __comments__\n" => "__Schlüssel__ | __Standard__ | __Kommentar__\n",
"(refer to PHP function fnmatch() for details)\n" => "(siehe PHP Funktion fnmatch() für weitere Details)\n",
"possible values: characters\n" => "Mögliche Werte: Zeichen\n",
"possible values: " => "Mögliche Werte: ",
"a valid regex-expression (PCRE)" => "ein gültiger regex-Ausdruck (PCRE)",
"non-valid custom regex" => "ungültiger individueller regex",
"ignored" => "ignoriert",
"External Wiki" => "Externes Wiki",
"valid" => "gültig",
"End of debug output." => "Ende der Debug Ausgabe.",
"Wanted Page" => "Gesuchte Seite",
"Referenced By Page" => "Referenziert durch Seite",
"width" => "Breite",
"height" => "Höhe",
"Removed version \$version" => "Gelöschte Version \$version",
"Changed actual version to \$version" => "Aktuelle Version geändert auf \$version",
"Removed last version" => "Verschobene letzte Version",
"ERROR: Either the subject or body must be non-empty" => "FEHLER: Text und Betreff dürfen nicht leer sein.",
"ERROR: No valid users to send the message" => "FEHLER: Keine gültigen Benutzer zum Verschicken der Nachricht.",
"Invalid user" => "Ungueltiger Benutzer",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "Ausgangsordner ist voll. Bitte ein paar verschickte Nachrichten archivieren oder löschen, damit weitere verschickt werden können.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Sie müssen Mails empfangen können um selbst welche zu verschicken. Aktivieren Sie in Ihren Benutzer-Einstellungen 'Erlaube Nachrichten von anderen Benutzern'",
"User %s can not receive messages, mailbox is full" => "Benutzer %s kann keine Nachrichten empfangen, Briefkasten ist voll.",
"User %s can not receive messages" => "Benutzer %s kann keine Nachrichten empfangen.",
"Invalid user: %s" => "Ungültiger Benutzer: %s.",
"Message will be sent to: " => "Die Nachricht wird versandt an: ",
"Archive is full. Delete some messages from archive first." => "Archiv ist voll! Bitte erst ein paar Nachrichten aus dem Archiv löschen.",
"No more messages" => "Keine weiteren Nachrichten",
"Article Topics" => "Artikel Überschriften",
"Categories" => "Kategorien",
"Categorize" => "Kategorisieren",
"Unassign" => "Zuordnung aufheben",
"Assign" => "Zuweisen",
"Received objects" => "Empfangene Objekte",
"File galleries" => "Dateiarchive",
"Last forum posts" => "Neueste Forenbeiträge",
"Topics only" => "nur Themen",
"Most commented forums" => "Meistkommentierte Foren",
"Most read topics" => "Meistgelesene Themen",
"Most visited forums" => "Meistbesuchte Foren",
"Most popular tags" => "Beliebteste Tags",
"Google Search" => "Google-Suche",
"Last actions" => "Letzte Aktionen",
"Last blog posts" => "Neueste Blog-Einträge",
"no object here yet" => "kein Objekt bisher hier vorhanden",
"Last Created blogs" => "Neueste Blogs",
"Last Created FAQs" => "Neueste FAQs",
"Last Created Quizzes" => "Neueste Quiz",
"Last modified file galleries" => "Zuletzt modifizierte Dateiarchive",
"Last Files" => "Neueste Dateien",
"Last Images" => "Neueste Bilder",
"Last modified events" => "Neueste Termine",
"Last Modified blogs" => "Zuletzt geänderte Blogs",
"Last submissions" => "Neueste Einreichungen",
"Last Items" => "Neueste Einträge",
"Last Modified Items" => "Zuletzt geänderte Einträge",
"Last Visitors" => "Letzte Besucher",
"Live support" => "Onlinesupport",
"Messages" => "Nachrichten",
"Waiting Submissions" => "Wartende Einreichungen",
"Old articles" => "Alte Artikel",
"Create/Edit" => "Hinzufügen/bearbeiten",
"Quick Edit a Wiki Page" => "Schnellbearbeitung einer Wiki-Seite",
"Random Pages" => "Zufällige Seiten",
"New user registration" => "Neue User-Anmeldung",
"Post" => "Eintrag",
"Since your last visit" => "Was ist neu?",
"Changes since" => "Änderungen seit",
"new comments" => "Neue Kommentare",
"new posts" => "Neue Beiträge",
"wiki pages changed" => "Wiki-Seiten geändert",
"new articles" => "neue Artikel",
"new FAQs" => "Neue FAQs",
"new blogs" => "Neue Blogs",
"new blog posts" => "Neue Blogeinträge",
"new image galleries" => "Neue Bildergalerien",
"new images" => "Neue Bilder",
"new file galleries" => "Neue Dateiarchive",
"new files" => "Neue Dateien",
"new polls" => "Neue Umfragen",
"new users" => "Neue Benutzer",
"new tracker items" => "Neue Tracker Items",
"Most Active blogs" => "Aktivste Blogs",
"Top articles" => "Top Artikel",
"Top File Galleries" => "Top-Dateiarchive",
"Top files" => "Top-Dateien",
"Top Forum Posters" => "Top Forum Poster",
"Top Images" => "Top-Bilder",
"Top Pages" => "Top-Seiten",
"Top Quizzes" => "Top-Quiz",
"Top Visited FAQs" => "Meistbesuchte FAQs",
"User Blogs" => "Benutzer-Blogs",
"My blogs" => "Meine Blogs",
"User bookmarks" => "Benutzer-Lesezeichen",
"My galleries" => "Meine Galerien",
"User Pages" => "Benutzer-Seiten",
"My Pages" => "Meine Seiten",
"User tasks" => "Benutzer-Aufgaben",
"The task title must have at least 3 characters" => "Der Tasktitel muss mindestens aus 3 Zeichen bestehen",
"Public tasks" => "öffentliche Aufgaben",
"Top users" => "Top User",
"Online users" => "Benutzer online",
"Last wiki comments" => "Die letzten Wiki-Kommentare",
"Invalid server key" => "Ungültiger Serverschlüssel",
"Invalid username or password" => "Ungültiger Benutzername oder Paßwort",
"smarty notice reporting" => "Smarty 'notice' Berichterstattung",
"lib spellcheck" => "Bibliotheks-Rechtschreibprüfung",
"wiki spellcheck" => "Wiki Rechtschreibprüfung",
"blog spellcheck" => "Blog Rechtschreibprüfung",
"allowMsgs" => "Nachrichten erlauben",
"country" => "Land",
"diff versions" => "Versionen vergleichen",
"display timezone" => "Zeitzone zeigen",
"email is public" => "eMail ist öffentlich",
"homePage" => "Startseite",
"realName" => "realer Name",
"gender" => "Geschlecht",
"show mouseover user info" => "zeige mouseover Benutzer-Infos",
"theme" => "Theme",
"Anti-Bot verification code" => "Anti-Bot Prüf-Code",
"Random Image" => "Zufälliges Bild",
"Enter the code you see above" => "Geben Sie den Code, den Sie oben sehen, ein",
"List of attached files" => "Liste aller angehängten Dateien",
"id" => "ID",
"desc" => "Beschreibung",
"uploaded" => "hochgeladen",
"Remove" => "Verschieben",
"Upload file" => "Datei hochladen",
"Attach" => "Anhängen",
"Attach a file to this item" => "Datei an diesen Eintrag anhängen",
"Attachments" => "Anhänge",
"more info" => "mehr Infos",
"No attachments for this item" => "Keine Anhänge für diesen Eintrag",
"debug" => "Debug",
"Fatal error" => "Fataler Fehler",
"Created by" => "Erstellt von",
"on" => "am",
"Activity=" => "Aktivität=",
"Actions" => "Aktionen",
"Properties" => "Eigenschaften",
"No records found" => "Keine Datensätze gefunden",
"Select Categories" => "Kategorien auswählen",
"Admin Categories" => "Kategorien verwalten",
"No categories defined" => "Keine Kategorien definiert",
"Browse Category" => "Kategorien durchstöbern",
"posts:" => "Beiträge:",
"stars" => "Sterne",
"User Level" => "Benutzerlevel",
"private message" => "private Nachricht",
"Send eMail to User" => "eMail an Benutzer schicken",
"user online" => "Benutzer online",
"user offline" => "Benutzer offline",
"top of page" => "Anfang der Seite",
"Reply" => "Antwort",
"Approve" => "Freigeben",
"Reject" => "Ablehnen",
"Report this post" => "Diesen Beitrag melden",
"Save to notepad" => "Im Notizblock speichern",
"Monitor this Topic" => "Thema beobachten",
"Stop Monitoring this Topic" => "Beobachtung dieses Themas beenden",
"Watched by categories" => "Beobachtet durch die Kategorien",
"Errors" => "Fehler",
"Moderator actions" => "Moderator-Aktionen",
"reported:" => "gemeldet:",
"queued:" => "aufgelaufen:",
"Move to topic:" => "Verschiebe zu Thema:",
"Move" => "Verschieben",
"Delete Selected" => "Markierte löschen",
"Comments Locked" => "Beiträge gesperrt",
"Unlock" => "Entsperren",
"Lock" => "Sperren",
"Threshold" => "Schwellenwert",
"Set" => "Ok",
"Replies" => "Antworten",
"below your current threshold" => "unterhalb Ihres aktuellen Schwellenwerts",
"Comments are locked" => "Kommentare sind geschlossen",
"Note" => "Hinweis",
"New Reply" => "Neue Antwort",
"Editing reply" => "Antwort bearbeiten",
"Reply to the selected post" => "Auf den ausgewählten Beitrag antworten",
"Post new message" => "Neuen Beitrag erstellen",
"Editing comment" => "Bearbeitungskommentar",
"Comment on the selected post" => "Diesen Beitrag kommentieren",
"Post new comment" => "Neuen Kommentar posten",
"required" => "erforderlich",
"Toolbars" => "Schnell-Tags",
"Enter your name" => "Geben Sie Ihren Namen ein",
"Reply to parent post" => "Auf Vaterpost antworten",
"Post new reply" => "Neue Anwort schreiben",
"Post as Anonymous" => "Anonym posten",
"Cancel" => "Abbrechen",
"Posting replies" => "Post-Antworten",
"Posting comments" => "Posting-Kommentare",
"Add Comment" => "Kommentieren",
"1 comment" => "1 Kommentar",
"Go back" => "zurück",
"Return to home page" => "Zur Home-Seite zurückkehren",
"Type of contribution:" => "Typ der Contribution:",
"Contributors" => "Beitragende",
"Year" => "Jahr",
"Authors" => "Autoren",
"Add" => "Hinzufügen",
"Tiki Debugger Console" => "Tiki Debug-Konsole",
"Current URL" => "Aktuelle URL",
"Command" => "Befehle",
"exec" => "Ausführen",
"Type <code>help</code> to get list of available commands" => "<code>help</code> für eine Befehlsübersicht eingeben",
"Page generation debugging log" => "Debug-Log der Seitengenerierung",
"Features state" => "Status der Funktion",
"Total" => "Gesamt",
"features matched" => "Features gefunden",
"Watchlist" => "Beobachtungsliste",
"Duplicate File Gallery" => "Dateiarchiv duplizieren",
"Duplicate categories" => "Kategorien duplizieren",
"duplicate" => "Kopie",
"There are individual permissions set for this file gallery" => "Für dieses Dateiarchiv sind individuelle Berechtigungen gesetzt",
"Save" => "Speichern",
"Use" => "Benutze",
"unlimited" => "unbegrenzt",
"none" => "nichts",
"Parent gallery" => "Mutter-Galerie",
"Owner of the gallery" => "Besitzer der Gallerie",
"Allows to select each user for small groups" => "Bei kleinen Gruppen können alle Mitglieder ausgewählt werden",
"Default sort order" => "Standard-Sortierreihenfolge",
"Max description display size" => "Maximale Anzeigebreite der Beschreibung",
"Please login" => "Bitte anmelden",
"Perhaps you are looking for:" => "Vielleicht suchen Sie das hier ?",
"There are no wiki pages similar to '{\$page}'" => "Es bit keine ähnlichen Seiten zu '{\$page}'",
"Create this page" => "Diese Seite anlegen",
"(page will be orphaned)" => "(Seite verwaist)",
"Close Window" => "Fenster schließen",
"Active Perms" => "Active Rechte",
"Perms" => "Berecht.",
"Replace" => "Ersetzen",
"List" => "Liste",
"Name-filename" => "Name-Dateiname",
"Filename only" => "nur Dateiname",
"Exact&nbsp;match" => "nur&nbsp;genaue&nbsp;Treffer",
"Number of displayed rows" => "Angezeigte Spaltenanzahl",
"Go" => "Los",
"RSS Articles" => "RSS Artikel",
"RSS Image Galleries" => "RSS Bildergalerien",
"RSS File Galleries" => "RSS Dateigalerien",
"RSS Forums" => "RSS Foren",
"RSS Directories" => "RSS Verzeichnisse",
"RSS Calendars" => "RSS Kalender",
"Perform action with checked:" => "Aktion auf alle markierten ausführen",
"Move Selected Files" => "Markierte Dateien verschieben",
"Download the zip" => "zip-komprimiert herunterladen",
"Assign Permissions" => "Berechtigungen vergeben",
"Move to" => "Verschieben nach",
"Filename" => "Dateiname",
"Other Sorts" => "Andere Sortierungen",
"No Additionnal Sort" => "Keine weitere Sortierung",
"No information" => "Keine Information",
"Hi {\$mail_user} has sent you this link:" => "Hallo, {\$mail_user} hat Ihnen diesen Link zugesandt:",
"Blog post:" => "Blog-Eintrag:",
"at:" => "auf:",
"Somebody or you tried to subscribe this email address at our site:" => "Sie oder jemand anders hat versucht, diese eMail-Adresse einzutragen bei:",
"To the newsletter:" => "Zum Rundbrief:",
"Description:" => "Beschreibung:",
"In order to confirm your subscription you must access the following URL:" => "Zur Bestätigung des Rundbrief-Abonnements müssen Sie diesem Link folgen:",
"User:" => "Benutzer:",
"A new message was posted to forum" => "Ein neuer Beitrag wurde gepostet ins Forum",
"New topic:" => "Neues Thema:",
"Topic:" => "Thema:",
"You sent a request with the subject:" => "Sie haben eine Anfrage gesendet mit dem Betreff:",
"GET:WikiName to get a wiki page" => "GET:WikiName um eine Wiki-Seite anzufordern",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName um eine Wiki-Seite zu erstellen oder zu aktualisieren (Nutzen Sie den body für die Seitendaten)",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName um Daten an eine Wiki-Seite anzuhängen (Nutzen Sie den for um Daten hinzuzufügen)",
"PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName um Daten am Anfang hinzuzufügen",
"Tiki mail-in instructions" => "Tiki Mail-in Anweisungen",
"Tiki mail-in auto-reply." => "Automatisierte Antwort auf einen TikiWiki Mail-Eingang.",
"Page not found:" => "Seite nicht gefunden:",
"Hi," => "Hallo,",
"A new message was posted to you at {\$mail_machine}" => "Eine neue Nachricht für Sie auf {\$mail_machine}",
"From" => "Von",
"New message arrived from %s" => "Neue Nachricht von %s",
"Hi" => "Hallo",
"To login with your username and password, please follow this link:" => "Um sich mit Ihrem Benutzernamen und Ihrem Passwort einzuloggen, folgen Sie bitte diesem Link:",
"Enjoy the site!" => "Viel Spass auf der Site!",
"has requested an account on" => "hat einen Zugang beantragt für",
"Group:" => "Gruppe",
"To validate that account, please follow the link:" => "Zum Bestätigen des Account-Antrags den folgenden Link klicken:",
"User Registration Request" => "Anfrage Tiki Benutzerregistrierung",
"Go to your friendship network to accept or refuse this request" => "Sie können diese Anfrage in Ihrem Freunde-Netzwerk akzeptieren oder ablehnen.",
"You're invited to join my network of friends!" => "Sie wurden eingeladen meinem Freunde-Netzwerk beizutreten!",
"The user" => "Der Benutzer",
"registered at your site" => "hat sich auf Ihrer Tiki-Site registriert",
"Bye bye!" => "Auf Wiedersehen!",
"This email address has been removed to the list of subscriptors of:" => "Diese eMail-Adresse wurde in die Abonnentenliste verschoben von:",
"Bye bye from %s at %s" => "Auf Wiedersehen von %s auf %s",
"You can unsubscribe from this newsletter following this link" => "Abbestellen dieses Rundbriefs durch Klick auf den Link möglich",
"Welcome to our newsletter!" => "Willkommen zu diesem Rundbrief!",
"This email address has been added to the list of subscriptors of:" => "Diese eMail-Adresse wurde in die Liste der Adressaten aufgenommen von:",
"You can always cancel your subscription using:" => "Sie können das Rundbrief-Abonnement jederzeit rückgängig machen über:",
"Welcome to %s at %s" => "Willkommen zu %s auf %s",
"Email notification" => "Tiki eMail-Benachrichtigung",
"requested a reminder of the password for your account" => "forderte eine Passworterinnerung für Ihren Account an.",
"requested password reset for your account" => "möchte das Passwort für Ihren Account zurücksetzen",
"Since this is your registered email address we inform that the password for this account is" => "Da dies Ihre registrierte eMail-Adresse ist, informieren wir Sie darüber, dass das Passwort für diesen Account wie folgt lautet:",
"Important: Username & password are CaSe SenSitiVe" => "Wichtig: Benutzername & Passwort sind CaSe SenSitiVe, d.h. Gross- und Kleinschreibung wird unterschieden.",
"Important: The old password remains active if you don't click the link above." => "Wichtig: Das alte Passwort bleibt bestehen, wenn Sie nicht auf den obigen Link klicken.",
"Your account information for %s" => "Ihre Tiki-Accountinformationen für %s",
"Report for" => "Bericht für",
"Last Report sent on" => "Letzter Bericht verschickt am",
"Changes in detail:" => "Aenderungen im Detail:",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Es wurde ein neuer Artikel von {\$mail_user} auf {\$mail_site} um {\$mail_date|tiki_short_datetime} erstellt",
"You can edit the submission following this link:" => "Sie können diesen Beitrag bearbeiten, wenn Sie hier klicken:",
"Title:" => "Titel:",
"Heading:" => "Kopfbereich:",
"Body:" => "Hauptteil:",
"New article submitted at %s" => "Neuer Artikel eingereicht unter %s",
"Tracker was modified at" => "Tracker wurde verändert in",
"You or someone registered this email address at" => "Sie oder jemand anderes hat Ihre eMail-Adresse bei",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Falls Sie sich für diese Site registrieren möchten, müssen Sie sich für das erste Login über diesen Link anmelden:",
"Your registration confirmation" => "Ihre Tiki Registrierungsinformationen",
"You will receive an email with information to login for the first time into this site" => "Sie erhalten in Kürze eine Mail, die Informationen enthalten, wie Sie sich zum ersten mal anmelden.",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Die Anfrage wurde gespeichert und wird vom Administrator schnellst möglich bearbeitet.",
"View the article at:" => "Klicken Sie hier um zu dem Artikel zu gelangen:",
"If you don't want to receive these notifications follow this link:" => "Falls Sie diese Benachrichtigungen nicht mehr bekommen m�chten, klicken sie hier:",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "Neuer Blog-Eintrag: {\$mail_title}, \"{\$mail_post_title}\", von {\$mail_user|username} am {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "Zeige den Blog auf:",
"New blog post at %s" => "Neuer Blog-Eintrag: %s",
"changed" => "geändert",
"A new category was created in" => "Eine neue Kategorie wurde erstellt in",
"created" => "erstellt",
"A category was removed in" => "Eine Kategorie wurde verschoben in",
"Removed by" => "Verschoben von",
"A category was updated" => "Eine Kategorie wurde aktualisiert",
"Updated by" => "Aktualisiert von",
"New" => "Neu",
"File Gallery %s changed" => "Dateiarchiv %s geändert",
"A file was removed from the file gallery" => "Eine Datei wurde aus dem Dateiarchiv gelöscht",
"File Name" => "Dateiname",
"A new file was posted to file gallery" => "Eine neue Datei wurde in das Dateiarchiv gestellt",
"Posted by" => "Eingestellt von",
"File Description" => "Dateibeschreibung",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Karte {\$mail_page} wurde geändert von {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Sie können die aktuelle Karte unter diesem Link sehen:",
"You can edit the map following this link:" => "Sie können die Karte unter diesem Link bearbeiten:",
"An object was added to category" => "Ein Objekt wurde hinzugefügt zur Kategorie",
"Added by" => "Hinzugefügt durch",
"An object was removed from category" => "Ein Objekt wurde verschoben aus der Kategorie",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Seite {\$mail_page} wurde erstellt von {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Seite {\$mail_page} wurde von {\$mail_user} um {\$mail_date|tiki_short_datetime} geändert",
"Comment:" => "Kommentar:",
"You can view the page by following this link:" => "Sie können die Seite betrachten in dem Sie diesem Link folgen:",
"You can view a diff back to the previous version by following this link:" => "Sie können einen Blick auf die vorherige Version werfen, indem Sie diesem Link folgen:",
"The changes in this version follow below, followed after by the current full page text." => "Die Änderungen dieser Version folgen unten, gefolgt von dem aktuellen komplette Seiteninhalt.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Zeilen: {\$oldd} geändert zu +Zeilen: {\$newd}",
"The new page content follows below." => "Der neue Seiteninhalt folgt unten.",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Die Seite {\$mail_page} wurde kommentiert {\$mail_user} am {\$mail_date|tiki_short_datetime}",
"Wiki page renamed" => "Wiki-Seite umbenannt",
"Old name" => "Alter Name",
"New name" => "Neuer Name",
"click on the map to zoom or pan, do not drag" => "Klicken Sie auf die Karte um sie zu vergrößern oder zu drehen. Sie können die Karte nicht ziehen.",
"Query Results" => "Ergebnisse der Abfrage",
"Querying" => "Abfragen",
"Scroll Up" => "Nach oben scrollen",
"Scroll Down" => "Nach unten scrollen",
"Scale" => "Skalieren",
"Query" => "Abfrage",
"Pan" => "Drehen",
"Redraw" => "Neu zeichnen",
"select zoom/pan/query and image size" => "Wählen Sie Zoom/Drehen/Abfrage und Bildgrösse",
"View the Map Only" => "Karte nur betrachten",
"Reset Map" => "Karte zurücksetzen",
"Click on the map or click redraw" => "Karte oder 'Neu zeichnen' anklicken",
"Last modification date" => "Datum der letzten Modifikation",
"Overview" => "Übersicht",
"Legend" => "Legende",
"Layer Manager" => "Layer-Manager",
"Layer" => "Schicht",
"On" => "Am",
"Download Layer" => "Layer herunterladen",
"This layer has been set by the maps administrator to not be downloadable" => "Diese Schicht wurde Administrator als nicht downloadbar eingerichtet.",
"you have requested to download the layer:" => "Sie haben das Herunterladen des Layers angefordert:",
"Here are the files to download, do not forget to rename them:" => "Heie sind die herunterladbaren Dateien, bitte nicht vergessen, sie umzubenennen:",
"Mapfiles" => "Kartendateien",
"Mapfile" => "Kartendatei",
"Available mapfiles" => "Verfügbare Kartendateien",
"hits last 7 days" => "Hits der letzten 7 Tage",
"monitor this map" => "diese Karte beobachten",
"Stop Monitoring this Map" => "Diese Karte nicht mehr beobachten",
"Create a new mapfile" => "Neue Kartendatei anlegen",
"Create" => "Erstellen",
"Mapfile listing" => "Liste Kartendateien",
"Reload" => "Aktualisieren",
"History" => "Historie",
"You can view this map in your browser using" => "Sie können diese Karte in Ihrem Browser betrachten",
"Zoom out x2" => "Doppelt vergrößern",
"Zoom in x2" => "Doppelt verkleinern",
"of" => "von",
"Compare" => "Vergleichen",
"Comparing version {\$old.version} with version {\$new.version}" => "Vergleiche Version {\$old.version} mit Version {\$new.version}",
"Current" => "Aktuell",
"Versions are identical" => "Versionen sind identisch",
"Legend:" => "Legende:",
"v=view" => "v=betrachten",
"Full side-by-side diff" => "Kompletter Side-By-Side Vergleich",
"Unified diff" => "Einheitlicher Vergleich",
"Side-by-side view" => "Side-By-Side Ansicht",
"User" => "Benutzer",
"Ip" => "IP",
"Directories" => "Links",
"back to" => "Zurück zu",
"Upload From Disk:" => "Von Platte hochladen:",
"Upload Files" => "Dateien hochladen",
"Bytes maximum" => "Bytes maximal",
"Create Directory:" => "Verzeichnis anlegen:",
"index file (.shp):" => "Index-Datei (.shp):",
"files to index (regexp):" => "zu indizierende Dateien (regexp):",
"Message Archive" => "Nachrichten-Archiv",
"messages" => "Nachrichten",
"Archive is full!" => "Archiv ist voll!",
"Unread" => "Ungelesen",
"Flagged" => "Gekennzeichnet",
"Unflagged" => "Nicht gekennzeichnet",
"Containing" => "die enthalten",
"Sender" => "Absender",
"No messages to display" => "Keine Nachrichten anzuzeigen",
"Broadcast message" => "Nachricht an Verteiler",
"All users" => "Alle Benutzer",
"Lowest" => "sehr niedrig",
"Low" => "niedrig",
"High" => "hoch",
"Very High" => "sehr hoch",
"Send" => "Verschicken",
"Compose message" => "Nachricht erstellen",
"Invalid" => "Ungültig",
"No messages to download" => "Keine Nachrichten zum Downloaden.",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "Mailbox ist voll! Bitte ein paar Nachrichten archivieren oder löschen, damit weitere empfangen werden können.",
"is reply to" => "ist Antwort auf",
"Find replied message" => "suche beantwortete Nachricht",
"Archive" => "Archiv",
"Mark as read" => "auf gelesen ...",
"Mark as unread" => "auf ungelesen ...",
"Mark as flagged" => "Kennzeichnung nicht ...",
"Mark as unflagged" => "Kennzeichnung ...",
"Mark" => "setzen",
"Mailbox" => "Briefkasten",
"Compose" => "Erstellen",
"Broadcast" => "Verteiler",
"Sent" => "Ausgang",
"Auto-archive age for read messages:" => "Mindestalter gelesener Nachrichten für Auto-Archivierung:",
"Read message" => "Nachricht lesen",
"Return to mailbox" => "zurück zum Briefkasten",
"replyall" => "allen antworten",
"Flag this message" => "Nachricht kennzeichnen",
"From:" => "Von:",
"Return to archive" => "Zurück zum Archiv",
"Return to outbox" => "Zurück zum Ausgang",
"Sent Messages" => "Ausgegangene Nachrichten",
"Replied" => "Beantwortet",
"Not replied" => "Nicht beantwortet",
"move to archive" => "archivieren",
"receiver" => "Empfänger",
"'name' parameter for tikimodule missed" => "Parameter 'Name' für das TikiWiki-Modul fehlt.",
"Move module up" => "Modul nach oben verschieben",
"Up" => "Rauf",
"Move module down" => "Modul nach unten verschieben",
"Down" => "Runter",
"Move module to opposite side" => "Modul zur anderen Seite verschieben",
"opp side" => "gegenüberliegende Seite",
"Unassign this module" => "Zuweisung dieses Moduls aufheben",
"Are you sure you want to unassign this module?" => "Sind Sie sicher, dass Sie die Zuweisung dieses Moduls aufheben wollen?",
"Display type unknown, you have to enter the banner type" => "Darstellungstyp unbekannt. Sie müssen einen Bannertypen eingeben",
"You forgot your Google ad_client number !" => "Es wurde keine Google ad_client Nummer angegeben!",
"Thank you for installing Tikiwiki" => "Vielen Dank für die Nutzung von Tiki",
"Select" => "Auswählen",
"Admin" => "Verwalten",
"Admin Modules" => "Module verwalten",
"Modules" => "Module",
"Admin Menus" => "Menüs verwalten",
"Menus" => "Menüs",
"login" => "Anmeldung",
"Apply" => "Übernehmen",
"Pages:" => "Seiten:",
"Categories:" => "Kategorien:",
"Register" => "Registrieren",
"Open operator console" => "Operatorkonsole öffnen",
"Logged in as" => "Angemeldet als",
"Logout" => "Abmelden",
"Switch User" => "Benutzer wechseln",
"Switch" => "Wechseln",
"Switch user" => "Benutzer wechseln",
"Login through CAS" => "Einloggen mit CAS",
"Login as admin" => "Als Admin anmelden",
"Login through Shibboleth" => "Einloggen mit Shibboleth",
"Login as" => "Anmelden als",
"Password" => "Paßwort",
"Remember me" => "Merken",
"week" => "Woche",
"month" => "Monat",
"year" => "Jahr",
"Click here to register" => "Klicken Sie hier um sich zu registrieren",
"Click here if you've forgotten your password" => "Passwort vergessen ?",
"I forgot my password" => "Ich habe mein Paßwort vergessen",
"Click here to login using the default security protocol" => "Klicken Sie hier um sich mit dem Standard-Sicherheitsprotokoll einzuloggen",
"Click here to login using a secure protocol" => "Klicken Sie hier um sich mit einem sicheren Protokoll einzuloggen ",
"Secure" => "Sicher",
"Stay in ssl Mode" => "In SSL-Modus bleiben",
"local account" => "Lokaler Zugang",
"You have" => "Sie haben",
"new messages" => "neue Nachrichten",
"new message" => "neue Nachricht",
"You have 0 new messages" => "Sie haben keine neuen Nachrichten",
"We have" => "Wir haben",
"submissions waiting to be examined" => "Einreichungen, die auf Sichtung warten",
"Image Galleries" => "Bildergalerien",
"Calendars" => "Kalender",
"Entire Site" => "Ganze Site",
"Wiki Pages" => "Wiki-Seiten",
"Image Gals" => "Bildergalerien",
"Blog Posts" => "Blog-Einträge",
"Search Wiki PageName" => "Suche Wiki-Seitennamen",
"Read More" => "Weiterlesen",
"Since your last visit on" => "Letzter Besuch",
"New Images" => "Neue Bilder",
"Wiki Pages Changed" => "Wiki-Seiten geändert",
"New Files" => "Neue Dateien",
"New Comments" => "Neue Kommentare",
"New Users" => "Neue Benutzer",
"click to edit" => "Bearbeiten mit Klick",
"Nothing has changed" => "Keine Änderungen",
"Site Language:" => "Site-Sprache:",
"Site default" => "Site-Default",
"TikiTests Menu" => "TikiTests Menü",
"List Tests" => "Tests auflisten",
"Create Test" => "Test erstellen",
"Top galleries" => "Top Galerien",
"view" => "betrachten",
"Set your preferred languages." => "Bevorzuge Sprachen einstellen.",
"preferred languages" => "Bevorzugte Sprachen",
"click to view" => "Klicken für Ansicht",
"Bookmarks" => "Lesezeichen",
"Done" => "fertig",
"Del" => "Löschen",
"select" => "Auswahl",
"Refresh" => "Aktualisieren",
"online users" => "Benutzer online",
"online user" => "Benutzer online",
"on host" => "auf Host",
"Send a message to" => "Schicke eine Nachricht an",
"Send a message" => "Nachricht verschicken",
"vote" => "Abstimmen",
"Warning" => "Warnung",
"Users" => "Benutzer",
"Send Newsletter" => "Rundbrief versenden",
"RSS feed" => "RSS Feed",
"Edit blog" => "Blog bearbeiten",
"Monitor this Blog" => "Diesen Blog beobachten",
"Stop Monitoring this Blog" => "Diesen Blog nicht mehr beobachten",
"Find:" => "Suche:",
"pages" => "Seiten",
"To edit the copyright notices" => "Zum Editieren der Copyright-Hinweise",
"The content on this page is licensed under the terms of the" => "Der Inhalt dieser Seite unterliegt folgenden Lizenzbestimmungen:",
"comments" => "Kommentare",
"First page" => "Erste Seite",
"Previous page" => "Vorherige Seite",
"page" => "Seite",
"Next page" => "Nächste Seite",
"Last page" => "Letzte Seite",
"referenced by" => "Referenzen",
"references" => "Verweise",
"View Comments" => "Kommentare ansehen",
"Blog name" => "Blog Name",
"Calendar View" => "Kalenderansicht",
"List View" => "Listenansicht",
"Tools Calendars" => "Kalendereinträge",
"Check / Uncheck All" => "Alle (ent)markieren",
"Cancel Edit" => "Bearbeitung verwerfen",
"Change preferences" => "Einstellungen übernehmen",
"Site Ads and Banners" => "Site Werbung und Banner",
"General" => "Allgemein",
"Features" => "Funktionen",
"Editing and Plugins" => "Bearbeiten und PlugIns",
"Module" => "Modul",
"Meta Tags" => "Meta-Tags",
"Security" => "Sicherheit",
"User files" => "Benutzer-Dateien",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Blogs hinzufügen/verschieben über Menüpunkt 'Blogs' im Menü im Seitenbalken oder",
"General Settings" => "Verschiedene Einstellungen II",
"Home Blog (main blog)" => "Home-Blog (Haupt-Blog)",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Um Kalender hinzuzufügen oder zu löschen, suchen Sie nach \"Kalender\" unter \"Admin\" im Anwendermenü, oder",
"Change settings" => "Einstellungen übernehmen",
"Default view mode" => "Standardansicht",
"Day" => "Tag",
"Week" => "Woche",
"Month" => "Monat",
"Quarter" => "Viertel",
"Saturday" => "Samstag",
"Sunday" => "Sonntag",
"Monday" => "Montag",
"5 minutes" => "5 Minuten",
"Permissions" => "Berechtigungen",
"Look under \"Articles\" on the application menu for links to" => "Unter Menüpunkt 'Artikel' im Seitenbalken kann man",
"Import CSV file" => "CSV-Datei importieren",
"Import" => "Importieren",
"Admin Groups" => "Gruppen verwalten",
"Admin Users" => "Benutzer verwalten",
"Gender" => "Geschlecht",
"avatar" => "Avatar",
"Number of friends" => "Anzahl der Freunde",
"E-mail" => "eMail",
"Last login" => "Letzte Anmeldung",
"Distance" => "Distanz",
"Users Default Preferences" => "Benutzer-Standardeinstellungen",
"default" => "standard",
"Number of visited pages to remember" => "Anzahl besuchter Seiten zum Vorhalten",
"Displayed time zone" => "Angezeigte Zeitzone",
"Detect user timezone if browser allows, otherwise site default" => "Versuche Zeitzone zu erkennen, ansonsten Site-Default benutzen",
"User information" => "Benutzerangaben",
"Private" => "privat",
"public" => "öffentlich",
"Use double-click to edit pages" => "Doppelklick zum Ändern von Seiten benutzen",
"Show user's info on mouseover" => "Benutzer-Info bei Mouseover anzeigen",
"Tasks per page" => "Aufgaben pro Seite",
"Messages per page" => "Nachrichten pro Seite",
"Allow messages from other users" => "Nachrichten von anderen Anwendern erlauben",
"Send me an email for messages with priority equal or greater than" => "Schicke mir eine eMail beim Eintreffen von Nachrichten mit Priorität größer gleich",
"Auto-archive read messages after x days" => "Gelesene Nachrichten nach x Tagen automatisch archivieren",
"never" => "niemals",
"My Tiki" => "Mein Tiki",
"My pages" => "Meine Seiten",
"My messages" => "Meine Nachrichten",
"My tasks" => "Meine Aufgaben",
"My forum topics" => "Meine Foren-Themen",
"My forum replies" => "Meine Foren-Antworten",
"My items" => "Meine Einträge",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Verzeichnisse konfigurieren über Menü 'Verzeichnisse verwalten' unter 'Linkverzeichnis' im Seitenbalken oder",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "FAQs hinzufügen/löschen über Menüpunkt 'FAQs auflisten' unter 'FAQs' im Menü im Seitenbalken oder",
"Settings" => "Einstellungen",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site." => "Bitte die <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>Bewertung der Funktionen</a> auf der Tiki Dokumentationsseite beachten.",
"Global features" => "Globale Funktionen",
"Watches" => "Beobachtungspunkte",
"Programmer" => "Entwickler",
"Experimental" => "Experimentell",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Wenn Dateien in einem Verzeichnis (statt in der Datenbank) gespeichert werden sollen, sollte das Verzeichnis nicht direkt zugreifbar sein.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Dafür gibt es zwei Möglichkeiten:<br /><ul><li>Das Verzeichnis liegt außerhalb des Document-Roots. Achtung: evtl. muß es dann noch für PHP lesbar gemacht werden.</li><li>Das Verzeichnis liegt im Document-Root. Achtung: es sollte dann über eine .htaccess Datei geschützt werden.</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Das Verzeichnis sollte in Unix-Notation angegeben werden, z.B. files/ oder c:/foo/files oder /www/files/",
"Home Gallery (main gallery)" => "Home-Galerie (Hauptgalerie)",
"Reindex all files for search" => "Dateien für Suche neu indizieren",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Foren hinzufügen/verschieben über Menüpunkt 'Foren verwalten' im Menü im Seitenbalken oder",
"Home Forum (main forum)" => "Home-Forum (Hauptforum)",
"Searches" => "Suchanfragen",
"Enable freetags 3D browser" => "Aktiviere freetags 3D browser",
"Browser width" => "Browser-Höhe",
"Node color" => "Knotenfarbe",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Bildgalerien hinzufügen/löschen über Menüpunkt 'Bildgalerien' im Menü im Seitenbalken oder",
"You can upload images of a size of " => "Maximale Grösse zum uploaden von Bildern: ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Ändern Sie in der php.ini die Parameter file_uploads, upload_max_filesize, post_max_size und die Datenbankparameter (max_allowed_packet für MySQL) um diesen Grösse zu ändern",
"Home Gallery" => "Hauptarchiv",
"Galleries features" => "Galerieeigenschaften",
"Uses Slideshow" => "Diaschau verwenden",
"Use database to store images" => "Datanbank zum Speichern von Bildern benutzen",
"Use a directory to store images" => "Ein Verzeichnis zum Speichern von Bildern benutzen",
"Directory path" => "Verzeichnis",
"Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below." => "Hinweis: wenn das Verzeichnis geändert wird, muß auch der Inhalt im Filesystem entsprechend manuell verschoben werden. Oder Sie können die Dateien in die Datenbank verlagern (s.u.)",
"Library to use for processing images" => "Bibliothek zur Bildbearbeitung",
"Uploaded image names must match regex" => "Hochgeladene Bildnamen müssen diese RegEx erfüllen",
"Uploaded image names cannot match regex" => "Hochgeladene Bildnamen dürfen dieser RegEx nicht entsprechen",
"Directory Batch Loading" => "Aus Verzeichnis einlesen",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Wenn 'Batch-Upload aus Verzeichnis' aktiviert wird muß ein vom Webserver lesbares Verzeichnis benutzt werden (am besten außerhalb des Webspace). Dorthin müssen die Bilder dann mit scp, ftp o.ä. übertragen werden.",
"Enable directory batch loading" => "Batch-Upload aus Verzeichnis erlauben",
"Batch loading directory" => "Batch-Upload Verzeichnis",
"Max Rows per page" => "Max. Zeilen pro Seite",
"Images per row" => "Bilder pro Zeile",
"Thumbnails size X" => "Thumbnails Breite",
"Thumbnails size Y" => "Thumbnails Höhe",
"pixels" => "Pixel",
"Set features" => "Einstellungen übernehmen",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Bilder aus der Systemgalerie entfernen, die nicht auf Wiki-Seiten, in Artikeln oder Blog-Einträgen genutzt werden",
"Mover" => "Dateien verlagern",
"Move images from database storage to filesystem storage" => "Verschiebe Bilder vom Datenbankspeicher zum Dateisystemspeicher",
"Move images from filesystem storage to database storage" => "Verschiebe alle Bilder aus dem Dateisystem in die Datenbank",
"All galleries" => "Alle Galerien",
"System Gallery" => "Systemgalerie",
"Move images from old filesystem store to new directory" => "Verschiebe Bilder vom alten Dateisystemspeicher in neues Verzeichnis",
"Moved" => "Verschoben",
"Gallery listing configuration" => "Einstellungen Galerie-Liste",
"Parent" => "Oberkategorie",
"Last modified" => "Zuletzt modifiziert",
"Change configuration" => "Einstellungen übernehmen",
"Image galleries comments settings" => "Bildergalerie-Kommentareinstellungen",
"General Preferences" => "Verschiedene Einstellungen I",
"Release Check" => "Suchen nach neuer Version",
"Reset or upgrade your database" => "Datenbank neu aufsetzen oder aktualisieren",
"Check for updates now" => "Jetzt nach neuer Version suchen",
"Site Identity" => "Site Identität",
"Mail Sender" => "Mailversand über",
"Authentication" => "Authentifizierung",
"Username" => "Benutzername",
"Visible to admin only" => "Nur für Admin sichtbar",
"Include Smarty notices" => "auch Smarty Hinweise anzeigen",
"Spam protection" => "Spam Schutz",
"Session" => "Sitzungsdaten",
"Changing this feature will immediately log you out when you save this preference." => "Ändern und Speichern dieses Werts hat ein LogOut zur Folge.",
"Contact" => "Kontakt",
"Home Page" => "Startseite",
"Use TikiWiki feature as homepage:" => "Dieses Tiki-Feature als Startseite nutzen:",
"Custom home" => "Angepasstes Home",
"Use different URL as home page" => "Andere URL als Startseite benutzen",
"Site Access" => "Zugriff auf die Site",
"Date and Time Formats" => "Datums- und Zeitformate",
"Date and Time Format Help" => "Hilfe zum Datums- und Zeitformat",
"Change admin password" => "Admin-Paßwort ändern",
"Change password" => "Paßwort ändern",
"Default x for map center" => "Standard x-Wert für Kartenmitte",
"Default y from map center" => "Standard y-Wert für Kartenmitte",
"Default zoom level" => "Standardzoomlevel",
"whole earth" => "gesamte Erde",
"country size" => "Ländergröße",
"city size" => "Stadtgröße",
"max zoom" => "maximaler Zoom",
"Internationalization" => "Internationalisierung",
"Syntax error" => "Syntax Fehler",
"Intertiki client" => "Intertiki Client",
"Tiki Unique key" => "Eindeutiger Tiki Schlüssel",
"InterTiki Slave mode" => "InterTiki Slave Modus",
"Warning: overrides manually registered local users" => "Warnung: Überschreibt Nutzer die sich manuell registriert haben",
"as master" => "als Master",
"Import user preferences" => "Importiere Usereinstellungen",
"Import user groups" => "Importiere Usergruppen",
"Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Grenze Gruppenimport (durch Kommata getrennte Liste der importierten Gruppen, wenn Sie keine Limitierung setzen möchten lassen Sie das Feld leer.)",
"host" => "Host",
"port" => "Port",
"Add new server" => "Neuen Server hinzufügen",
"Intertiki server" => "Intertiki Server",
"Intertiki Server enabled" => "Intertiki Server aktiviert",
"Access Log file" => "Verbindungs-Log-Datei",
"Errors Log file" => "Fehler Log File",
"Known hosts" => "Bekannte Hosts",
"Key" => "Schlüssel",
"click here" => "hier klicken",
"Enable/disable Tiki features in " => "Tiki-Features ein/ausschalten in ",
", but configure them elsewhere" => ", konfiguriert werden sie dann an anderen Stellen.",
"Tiki and HTTP Auth" => "Tiki und HTTP Auth",
"Registration" => "Registrierung",
"Users can register" => "Benutzer können sich registrieren",
"You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "Die <a href=\"tiki-admin.php?page=general\">Sendeadresse</a> muß gesetzt sein",
"Account validated successfully." => "Account erfolgreich bestätigt.",
"Use challenge/response authentication" => "Benutze Challenge-/Response-Authentifizierung",
"Allow secure (https) login" => "Erlaube sicheren Login (https)",
"Encourage secure (https) login" => "Schlage sicheren Login (https) vor",
"Consider we are always in HTTPS, but do not check" => "Gehe von HTTPS aus, aber prüfe nicht nach",
"Require secure (https) login" => "Sicherer Login (https) notwendig",
"Users can choose to stay in SSL mode after an HTTPS login" => "Benutzer darf nach HTTPS Login wahlweise mit SSL fortfahren",
"Users can switch between secured or standard mode at login" => "Benutzer darf zwischen HTTPS und normalem Login wählen",
"User's choice" => "Benutzer-Wahl",
"Duration:" => "Dauer:",
"Currently unused" => "momentan unbenutzt",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "<a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> muß zuvor nach lib/phpcas/ installiert werden.",
"Users can change theme" => "Reg. Benutzer können Theme ändern",
"Restrict available themes" => "Verfügbare Themes einschränken",
"Available styles:" => "Verfügbare Styles:",
"Edit CSS" => "CSS bearbeiten",
"Theme Control" => "Theme-Konfiguration",
"Tiki Template Viewing" => "Tiki Templates betrachten",
"Edit Templates" => "Vorlagen bearbeiten",
"General Layout options" => "Allgemeine Layout-Einstellungen",
"logged as" => "angemeldet",
"Examples" => "Beispiele",
"Alt. description (e.g. for text browsers)" => "Logo ALT-Text",
"Subtitle" => "Untertitel",
"Site menu bar" => "Balken für Site Menü",
"Custom code" => "Angepasster Code",
"Left column" => "Linke Spalte",
"always" => "immer",
"user decides" => "Benutzer entscheidet",
"Users can Flip Columns" => "Benutzer darf Spalten kippen",
"Right column" => "Rechte Spalte",
"Site location bar" => "Position des Breadcrumb Balkens",
"Larger font for" => "Größere Schrift für",
"Use page description:" => "Seitenbeschreibung benutzen:",
"Bottom bar" => "Unterer Balken",
"Bottom bar icons" => "Icons im unteren Balken anzeigen",
"Bottom bar debug" => "Server-Info im unteren Balken anzeigen",
"Email this page" => "Diese Seite verschicken",
"Maximum number of records in listings" => "Maximale Anzahl der Datensätze in Listen",
"Use direct pagination links" => "Seitennavigation über Seitenzahlen",
"Direction" => "Schreibrichtung",
"Vertical" => "Vertikal",
"Use Tabs" => "Tabs benutzen",
"Layout per section" => "Layout pro Bereich",
"Admin layout per section" => "Layout pro Bereich verwalten",
"Favicon icon file name:" => "Favicon Dateiname:",
"Favicon icon MIME type:" => "Favicon MIME-Type:",
"image/png" => "Bild/png",
"image/bmp" => "Bild/bmp",
"image/x-icon" => "Bild/x-icon",
"Generate User Map" => "Benutzerkarte erstellen",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Umfragen hinzufügen/löschen über Menüpunkt 'Abstimmungen' unter 'Admin' im Menü im Seitenbalken oder",
"Waiting" => "Wartend",
"The following list of changes has been applied:" => "Folgende Änderungen wurden übernommen:",
"Last update" => "Letzte Aktualisierung",
"Image galleries" => "Bildergalerien",
"Feed for forums" => "Feed für Foren",
"Specification" => "Spezifikation",
"You can see users rank by score in the module users_rank, for that go to" => "Den Benutzerrang nach Bewertung kann man dem Modul user_rank entnehmen, einschaltbar unter",
"Admin modules" => "Module",
"Expiration" => "Verfallszeit",
"Refresh wiki search index now" => "Wiki Suchindex jetzt aktualisieren",
"Automonospaced text" => "Blockschrift durch Einrücken",
"Tables syntax" => "Tabellensyntax",
"|| for rows" => "|| für Spalten",
"AutoLinks" => "URLs in Links verwandeln",
"Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Quote-PlugIn statt &ldquo;&gt;&rdquo; Zitierung verwenden",
"rows" => "Zeilen",
"Required" => "Erforderlich",
"Parameters" => "Parameter",
"Encoding" => "Formatierung",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Tracker konfigurieren über Menüpunkt 'Tracker verwalten' unter 'Tracker' im Seitenbalken oder",
"Use database to store files" => "Datenbank zum Speichern von Dateien benutzen",
"Use a directory to store files" => "Ein Verzeichnis zur Dateiablage benutzen",
"dls" => "DLs",
"Storage" => "Speicher",
"No records" => "Keine Einträge",
"Change all to db" => "Alle auf Datenbank umstellen",
"Change all to file" => "Alle auf Datei umstellen",
"Trackers with mirror tables" => "Tracker mit Mirror Tabellen",
"Use trackers with mirror tables" => "Tracker mit Mirror Tabellen benutzen",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Die Werte für jeden Tracker werden in der separaten Tabelle gespeichert, diese können ausserhalb von Tiki angepasst werden.",
"Validate choice" => "Auswahl überprüfen",
"Quota (Mb)" => "Quota (MB)",
"Use database to store userfiles" => "Benutzer-Dateien in Datenbank speichern",
"Use a directory to store userfiles" => "Benutzer-Daten in Verzeichnis ablegen",
"Create New" => "Erstelle neu",
"Output" => "Ausgabe",
"List authors" => "Autoren aufzählen",
"Not Installed" => "Nicht installiert",
"Warn on edit conflict" => "Bei Bearbeiten-Konflikt warnen",
"Undo" => "Rückgängig",
"Footnotes" => "Fußnoten",
"Permission" => "Berechtigung",
"Allow HTML" => "HTML erlauben",
"Dumps" => "Datenbankabzüge",
"Generate dump" => "Datenbankabzug erzeugen",
"Download last dump" => "Letzten Datenbankabzug downloaden",
"Pictures" => "Bilder",
"Remove unused pictures" => "Entferne unbenutzte Bilder",
"Export" => "Exportieren",
"Export Wiki Pages" => "Exportiere Wiki-Seiten",
"Accept dashes and underscores in WikiWords" => "Binde- und Unterstriche in WikiWords erlauben",
"Link plural WikiWords to their singular forms" => "Mehrzahl-WikiWords auf ihre Einzahl-Variante verlinken",
"Only with last version" => "nur mit letzter Version",
"Side-by-side diff" => "Side-By-Side Vergleich",
"Side-by-side diff by characters" => "Side-By-Side Vergleich nach Zeichen",
"Inline diff" => "Zeilenvergleich",
"Inline diff by characters" => "Zeilenvergleich nach Zeichen",
"Full side-by-side diff by characters" => "Kompletter Side-By-Side Vergleich nach Zeichen",
"Full inline diff" => "Kompletter Zeilenvergleich",
"Full inline diff by characters" => "Kompletter Zeilenvergleich nach Zeichen",
"Discuss pages on forums" => "Seiten im Forum diskutieren",
"View source" => "Quelltext ansehen",
"Similar" => "ähnlich",
"Structures" => "Strukturen",
"Open page as structure" => "Seite als Struktur öffnen",
"Import HTML" => "HTML importieren",
"Page creators are admin of their pages" => "Ersteller sind auch Verwalter ihrer Seiten",
"MultiPrint" => "Mehrfachdruck",
"Create watch for author on page creation" => "Beobachtungspunkt für Seite beim Erstellen setzen",
"Enable watch events when I am the editor" => "Beobachtungspunkt für Seite beim Ändern setzen",
"Enable watches on comments" => "Beobachtungspunkte auf Kommentare aktivieren",
"Wiki 3D Browser Configuration" => "Wiki 3D Browser Konfiguration",
"Maximum size" => "Maximale Größe",
"Wiki attachments" => "Wiki-Anhänge",
"Change" => "Ändern",
"preference" => "Einstellung",
"Crosslinks to other features and settings" => "Querverweise zu anderen Einstellungen",
"Other sections" => "Andere Bereiche",
"Spreadsheet" => "Arbeitsblatt",
"Live Support" => "Onlinesupport",
"Contact us" => "Kontaktiere uns",
"Administration features" => "Grundlegende Konfiguration",
"phpinfo" => "PHPInfo",
"Banning" => "Benutzer aussperren",
"Transversal features" => "Übergeordnete Einstellungen",
"which apply to more than one section" => "die sich auf mehr als einen Bereich auswirken",
"Mail Notifications" => "eMail-Benachrichtigungen",
"Navigation features" => "Navigation",
"Look & feel" => "Look & Feel",
"themes" => "Themes",
"Text area features" => "Einstellungen für Inhalte",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "Einstellungen, die für Wikiseiten, Blogs, Artikeln, Foren etc. gelten",
"External Pages Cache" => "Cache für externe Seiten",
"Content Templates" => "Inhaltsvorlagen",
"External Wikis" => "Externe Wiki-Seiten",
"Stats &amp; banners" => "Statistiken &amp; Banner",
"Search Stats" => "Suchstatistik",
"Report" => "Bericht",
"Category:" => "Kategorie",
"bytes" => "Bytes",
"contribution" => "Mitwirkung",
"Save Action" => "Speicher Aktion",
"Statistics" => "Statistiken",
"connection time" => "Verbindungsdauer",
"connection seconds" => "Verbindungsdauer in Sekunden",
"Weeks" => "Wochen",
"Setting" => "Einstellung",
"recorded" => "gespeichert",
"viewed" => "angesehen",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki-Aktionen außer 'hat angesehen' werden immer gespeichert, gehen aber nicht in Berichte ein",
"Add or edit a rule" => "Regel hinzufügen/bearbeiten",
"Rule title" => "Regelbezeichnung",
"Username regex matching" => "Benutzername-basiert (regex)",
"IP regex matching" => "IP-basiert (regex)",
"Banned from sections" => "Aus diesen Bereichen bannen",
"Rule activated by dates" => "Sperrung über Zeitraum",
"Rule active from" => "Regel gültig von",
"Rule active until" => "Regel gültig bis",
"Custom message to the user" => "Spezielle Nachricht für den Benutzer",
"Rules" => "Regeln",
"x" => "X",
"User/IP" => "Benutzername/IP",
"Sections" => "Bereiche",
"Admin Calendars" => "Kalender verwalten",
"List of Calendars" => "Liste der Kalender",
"Loc" => "Ort",
"Participants" => "Teilnehmer",
"Cat" => "Kateg.",
"Lang" => "Sprache",
"Subscription" => "Abonnement",
"Custom Locations" => "Persönliche Örtlichkeiten",
"Custom Participants" => "Persönliche Teinehmer",
"Custom Categories" => "Persönliche Kategorien",
"Custom Languages" => "Persönliche Sprache",
"Custom Subscription List" => "Persönliche Abo-Liste",
"Custom Priorities" => "Persönliche Prioritäten",
"Personal Calendar" => "Persönlicher Kalender",
"Current category" => "Aktuelle Kategorie",
"Child categories" => "Unterkategorien",
"Edit permissions for this category" => "Berechtigungen dieser Kategorie ändern",
"Edit this category:" => "Diese Kategorie bearbeiten:",
"Add new category" => "Neue Kategorie hinzufügen",
"Objects in category" => "Objekte in Kategorie",
"No records found." => "Keine Einträge gefunden.",
"Add objects to category" => "Objekte zu Kategorie hinzufügen",
"Admin templates" => "Vorlagen verwalten",
"Edit this template:" => "Dieses Template bearbeiten:",
"Create new template" => "Neue Vorlage erstellen",
"Use wysiwyg editor" => "WYSIWYG Editor benutzen",
"Use normal editor" => "Standardeditor benutzen",
"CMS" => "Artikel",
"HTML Pages" => "HTML-Seiten",
"Templates" => "Vorlagen",
"Admin Contributions" => "Beteiligungslisten verwalten",
"Edit the contribution:" => "Bearbeite contribution:",
"Contributions are mandatory in wiki pages" => "Auswahl bei Wikiseiten verbindlich",
"Contributions are mandatory in forums" => "Auswahl bei Foreneinträgen verbindlich",
"Contributions are mandatory in comments" => "Auswahl bei Kommentaren verbindlich",
"Contributions are mandatory in blogs" => "Auswahl bei Blogeinträgen verbindlich",
"Contributions are displayed in the comment/post" => "Beteiligung wird in Kommentar/Beitrag angezeigt",
"Create a new contribution" => "Neue Beteiligungsliste erstellen",
"List of contributions" => "Übersicht der Beteiligungslisten",
"Admin cookies" => "Cookies verwalten",
"To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}." => "Um ein Cookie in einem Textbereich (Wiki-Seite, etc.), einem <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a> oder einem Template einzusetzen, nutzen Sie {literal}{cookie}{/literal}.",
"Create/edit cookies" => "Cookies hinzufügen/bearbeiten",
"Upload Cookies from textfile" => "Cookies aus Textdatei hochladen",
"Upload from disk:" => "Hochladen von Disk:",
"Upload" => "Hochladen",
"Remove all cookies" => "Alle Cookies löschen",
"cookie" => "Cookie",
"Admin dsn" => "DSN verwalten",
"Use Admin DSN to define the database to be used by the SQL plugin." => "Benutze Admin DSN, um eine Datenbank festzulegen, die vom SQL Plugin verwendet werden soll.",
"Create/edit dsn" => "DSN hinzufügen/bearbeiten",
"Admin external wikis" => "Externe Wikis verwalten",
"View template" => "Vorlage betrachten",
"Edit template" => "Vorlage bearbeiten",
"Create/Edit External Wiki" => "Externes Wiki erstellen/bearbeiten",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (\$page benutzen und mit dem Wiki Seitennamen ersetzen, z.B.: http://qum74.mms-dresden.telekom.de/tiki/tiki-index.php?page=\$page)",
"Admin Forums" => "Foren verwalten",
"Create new forum" => "Neues Forum anlegen",
"Duplicate forum" => "Forum duplizieren",
"View this forum" => "Forum ansehen",
"Import forums" => "Foren importieren",
"List forums" => "Foren auflisten",
"Coms" => "Kommentare",
"Age" => "Alter",
"PPD" => "PPT",
"Create/Edit Forums" => "Foren hinzufügen/bearbeiten",
"Edit this Forum:" => "Dieses Forum bearbeiten:",
"Create New Forum" => "Neues Forum erstellen",
"There are individual permissions set for this forum" => "Für dieses Forum sind individuelle Rechte gesetzt",
"Create new" => "Erstelle neu",
"Password protected" => "mit Passwort gesichert",
"Forum password" => "Foren-Passwort",
"Topic list configuration" => "Einstellungen Themenliste",
"Posts can be rated" => "Einträge dürfen bewertet werden",
"Display last post titles" => "Neueste Beitragstitel anzeigen",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Nachrichten in dieses Forum an die angegebene eMail-Adresse weiterleiten in einem Format, das Rückantworten ins Forum erlaubt",
"Send mails even when the post is generated by inbound mail" => "Nachrichten auch schicken, wenn das Posting per eMail getätigt wurde",
"Append a reply link to outbound mails" => "Antwort-Link an ausgehende Nachrichten anhängen",
"Originating e-mail address for mails from this forum" => "Absenderadresse für Nachrichten aus diesem Forum",
"Add messages from this email to the forum" => "Nachrichten von dieser eMail-Adresse in das Forum weiterleiten",
"Use topic smileys" => "Smilies für Themen benutzen",
"Show topic summary" => "Themenzusammenfassung anzeigen",
"User information display" => "Benutzer-Informationen anzeigen",
"Approval type" => "Bestätigung nötig für",
"Store attachments in:" => "Anhänge speichern in:",
"Set topics preferences" => "Themen-Einstellungen festlegen",
"Show topics preferences" => "Themen-Einstellungen anzeigen",
"hide topics preferences" => "Themen-Einstellungen verbergen",
"Duplicate perms" => "Berechtigungen duplizieren",
"Admin Hotwords" => "Hotwords verwalten",
"Add Hotword" => "Hotword hinzufügen",
"Word" => "Wort",
"Admin HTML pages" => "HTML-Seiten verwalten",
"Edit this page" => "Ändere diese Seite",
"View page" => "Seite anzeigen",
"Edit zone" => "Bereiche bearbeiten",
"Dynamic zones" => "Dynamische Bereiche",
"zone" => "Bereich",
"content" => "Inhalt",
"Mass update" => "Massenaktualisierung",
"Create new HTML page" => "Neue HTML-Seite erstellen",
"Edit this HTML page:" => "Diese HTML-Seite bearbeiten:",
"Apply template" => "Vorlage anwenden",
"Dynamic" => "Dynamisch",
"Static" => "Statisch",
"Last Modif" => "Letzte Änderung",
"An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature." => "Ein einfacherer Weg um Inhalte von anderen Seiten in Tiki einzufügen ist mittels eines iframe-Links der TikiWikis <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> Funktion verwendet.",
"Edit Repository:" => "Repository bearbeiten:",
"Create New Repository" => "Neues Repository erstellen",
"List Repositories" => "Repositories auflisten",
"New Repository" => "Neues Repository",
"View Repository" => "Repository anschauen",
"Human readable repository name" => "Menschlich lesbarer Repository-Name",
"File name of start page" => "Dateiname der Startseite",
"Start page" => "Startseite",
"CSS file to load when browse this repository" => "CSS Datei, die geladen wird, wenn das Repository durchsucht wird",
"CSS file" => "CSS-Datei",
"Is repository visible to users" => "Ist das Repository für Benutzer sichtbar",
"Can files from repository be cached" => "Können Dateien aus dem Repository im Cache gespeichert werden",
"Cacheable" => "cachebar",
"Clear all cached pages of this repository" => "Lösche alle gechacheten Seiten aus diesem Repository",
"Clear cache" => "Cache leeren",
"Seconds count 'till cached page will be expired" => "Sekunden zählen bis die gecachete Seite abläuft",
"Cache expiration" => "Cache Verfallszeit",
"Human readable text description of repository" => "Menschlich lesbare Textbeschreibung des Repository",
"Available Repositories" => "Vorhandene Repositories",
"CSS File" => "CSS-Datei",
"Edit rules" => "Regeln bearbeiten",
"Edit Rules for Repository:" => "Regeln ändern für Repository:",
"Configure Repositories" => "Repositories konfigurieren",
"Configure this Repository" => "Dieses Repository konfigurieren",
"View this Repository" => "Repository ansehen",
"New Rule" => "Neue Regeln",
"Copy Rules" => "Regeln kopieren",
"view/hide copy rules dialog" => "Zeige/Verstecke Dialog für Kopierregeln",
"Source repository" => "Quellrepository",
"Copy" => "Kopieren",
"According this order rules will be applied ('0' or empty = auto)" => "Regeln werden gemäß dieser Anforderung gesetzt ('0' or empty = auto)",
"Rule order" => "Reihenfolge der Regeln",
"Text to search for" => "Zu suchender Text",
"Text to replace" => "Zu ersetzender Text",
"Is this regular expression or simple search/replacer" => "Ist das ein regulärer Ausdruck oder eine einfache Suche/Ersetzen",
"Is case sensitive (for simple replacer)" => "Groß- und Kleinschreibung beachten (für einfaches Ersetzen)",
"Case sensitive" => "Groß- und Kleinschreibung beachten",
"Human readable text description of rule" => "Menschlich lesbare Textbeschreibung der Regel",
"Check to enable this rule" => "Markieren um diese Regel zu aktivieren",
"Enabled" => "Aktiviert",
"Preview options" => "Vorschau-Einstellungen",
"Apply all rules or just this to generate preview" => "Setze alle Regeln oder nur diese um eine Vorschau zu generieren",
"Apply all rules" => "Alle Regeln anwenden",
"View source code after rules applied" => "Zeige Quellcode nach dem Setzen der Regeln",
"Code preview" => "Code-Vorschau",
"Generate HTML preview" => "HTML-Vorschau erstellen",
"HTML preview" => "HTML-Vorschau",
"Test file from repository to generate preview for (empty = configured start page)" => "Testdatei für Repository um eine Vorschau zu generieren (leer = konfigurierte Startseite)",
"Preview Results" => "Vorschau der Ergebnisse",
"Rules List" => "Regelliste",
"Configure/Options" => "Konfiguration/Optionen",
"Admin layout" => "Layout verwalten",
"Theme control" => "Theme-Konfiguration",
"layout options" => "Layout Optionen",
"Top bar" => "Oberer Balken",
"Generate positions by hits" => "Positionen nach Zugriffen vergeben",
"List of featured links" => "Liste vorhandener Linktips",
"Add Featured Link" => "Linktip hinzufügen",
"Edit this Featured Link:" => "Diesen Linktip bearbeiten:",
"Create new Featured Link" => "Neuen Linktip anlegen",
"disables the link" => "deaktiviert den Link",
"Link type" => "Linktyp",
"replace current page" => "Aktuelle Seite ersetzen",
"framed" => "umrahmt",
"open new window" => "Neues Fenster öffnen",
"Mail-in accounts" => "Mail-in Accounts",
"Add new Mail-in account" => "Mail-in Account erstellen",
"Edit Mail-in account" => "Mail-in Account bearbeiten",
"Account name" => "Account-Name",
"POP server" => "POP-Server",
"SMTP server" => "SMTP-Server",
"SMTP requires authentication" => "SMTP benötigt Authentifizierung",
"wiki-append" => "Wiki-Anhang",
"Article Topic" => "Artikel-Thema",
"Admin Topics" => "Themen verwalten",
"Article Type" => "Artikel-Typ",
"Admin Types" => "Typen verwalten",
"Active" => "aktiv",
"Allow anonymous acces" => "Anonymen Zugriff erlauben",
"Allow attachments" => "Anhänge erlauben",
"Discard to the end from" => "Ablegen am Ende von",
"Check Mail-in accounts" => "Mail-in Accounts überprüfen",
"Check automatically" => "Automatisch überprüfen",
"Frequency" => "Frequenz",
"List menus" => "Menüs auflisten",
"Edit this menu" => "Dieses Menü bearbeiten",
"Edit menu options" => "Menüoptionen bearbeiten",
"Show Quick Urls" => "Quick URLs anzeigen",
"Some useful URLs" => "Einige nützliche URLs",
"Hide Quick Urls" => "Quick URLs verstecken",
"option" => "Option",
"separator" => "Trennlinie",
"Choose" => "Auswählen",
"Home Blog" => "Home-Blog",
"Home Image Gal" => "Home-BilderGal",
"Home Image Gallery" => "Home-Bildergalerie",
"Home File Gal" => "Home-Dateiarchiv",
"Home File Gallery" => "Home-Dateiarchiv",
"User preferences" => "Benutzereinstellungen",
"User prefs" => "Benutzereinstellungen",
"List galleries" => "Galerien auflisten",
"List image galleries" => "Bildergalerien auflisten",
"Upload image" => "Bild hochladen",
"Gallery Rankings" => "Galerie-Bewertungen",
"Browse a gallery" => "Galerie ansehen",
"Articles home" => "Artikel-Home",
"All articles" => "Alle Artikel",
"Submit" => "Abschicken",
"List Blogs" => "Blogs auflisten",
"Create blog" => "Blog erstellen",
"View a forum" => "Forum ansehen",
"View a thread" => "Thread ansehen",
"View a FAQ" => "Eine FAQ ansehen",
"Take a quiz" => "Ein Quiz durchführen",
"Quiz stats" => "Quiz-Statistik",
"Stats for a Quiz" => "Statistik für ein Quiz",
"Preview menu" => "Vorschau des Menüs",
"Menu options" => "Menüoptionen",
"Options" => "Optionen",
"Edit this Menu:" => "Dieses Menü bearbeiten:",
"Create new Menu" => "Neues Menü erstellen",
"dynamic collapsed" => "Dynamisch eingeklappt",
"dynamic extended" => "Dynamisch ausgeklappt",
"fixed" => "fest",
"Clear Cache" => "Cache leeren",
"Assigned Modules" => "Zugewiesene Module",
"Left Modules" => "Module links",
"Move to Right Column" => "In die rechte Spalte verschieben",
"Right Modules" => "Module rechts",
"Move to Left Column" => "In die linke Spalte verschieben",
"Assign new module" => "Neues Modul hinzufügen",
"Edit this assigned module:" => "Dieses zugewiesene Modul bearbeiten:",
"Cache Time" => "Cache-Zeit",
"Visibility" => "Sichtbarkeit",
"Displayed now for all eligible users even with personal assigned modules" => "Sichtbar für alle Benutzer, auch die mit persönlicher Modul-Konfiguration",
"Displayed for the eligible users with no personal assigned modules" => "Sichtbar für Benutzer ohne persönliche Modul-Konfiguration",
"Displayed now, can't be unassigned" => "Immer anzeigen, kann nicht wegkonfiguriert werden",
"Not displayed until a user chooses it" => "Nicht anzeigen bis der Benutzer es hinzukonfiguriert",
"User Modules" => "Benutzer-Module",
"Create new user module" => "Neues Benutzer-Modul erstellen",
"Edit this user module:" => "Dieses Benutzer-Modul bearbeiten:",
"Must be wiki parsed" => "Wiki Parser anwenden",
"Objects that can be included" => "Objekte, die eingebunden werden können",
"Random active poll" => "Zufällige aktive Umfrage",
"Random current poll" => "Zufällige aktuelle Umfrage",
"Use Poll" => "Abstimmung benutzen",
"Use Gallery" => "Galerie benutzen",
"Use Dynamic Content" => "Dynamischen Inhaltsblock benutzen",
"Use RSS Module" => "RSS-Modul benutzen",
"Use Menu" => "Menü benutzen",
"Use phplayermenu" => "PHPLayerMenü benutzen",
"Use Banner Zone" => "Bannerzone benutzen",
"Structures:" => "Strukturen:",
"Data" => "Daten",
"Admin newsletter subscriptions" => "Rundbrief-Abonnenten verwalten",
"List Newsletters" => "Rundbriefe auflisten",
"Admin Newsletters" => "Rundbriefe verwalten",
"Send Newsletters" => "Rundbrief versenden",
"Add a subscription newsletters" => "Abo für Rundbrief hinzufügen",
"Email:" => "eMail:",
"You can add several email addresses by separating them with commas." => "Es können durch Komma getrennt mehrere eMail-Addressen angegeben werden.",
"Add email:" => "eMail hinzufügen:",
"Add user:" => "Benutzer hinzufügen:",
"Don't send confirmation mail" => "Keine Bestätigungsmail versendet",
"The user email will be refreshed at each newsletter sending" => "Die Benutzer-Email wird nach jedem Newsletterversand aktualisiert",
"txt file, one e-mail per line" => "txt Datei, eine e-mail pro Zeile",
"Included group, group users and emails will be refreshed at each newsletter sending" => "Eingeschlossene Gruppen, Gruppenbenutzer und Emails werden nach jedem Newsletterversand aktualisiert.",
"Subscriptions" => "Registrierungen",
"Valid" => "Gültig",
"Subscribed" => "abonniert",
"Admin newsletters" => "Rundbriefe verwalten",
"Create Newsletter" => "Rundbrief hinzufügen",
"Editions" => "Ausgaben",
"Drafts" => "Entwürfe",
"Last Sent" => "Zuletzt gesendet",
"Create/Edit Newsletters" => "Rundbrief hinzufügen/bearbeiten",
"There are individual permissions set for this newsletter" => "Es existieren individuelle Berechtigungen für diesen Rundbrief",
"Users can subscribe/unsubscribe to this list" => "Benutzer können sich für diese Liste an/abmelden",
"Users can subscribe any email address" => "Benutzer können beliebige eMail-Adressen eintragen",
"Add unsubscribe instructions to each newsletter" => "Hinweise zur Abmeldung von der Liste an jeden Rundbrief anhängen",
"Validate email addresses" => "eMail-Adressen überprüfen",
"Allow customized text message to be sent with the html version" => "Angepaßte Textversion mit der HTML-Version verschicken",
"Add notification" => "Benachrichtigung hinzufügen",
"Event" => "Ereignis",
"edit" => "bearbeiten",
"remove" => "entfernen",
"Update" => "Aktualisieren",
"List polls" => "Abstimmungen auflisten",
"Edit this poll" => "Diese Abstimmung bearbeiten",
"Preview poll" => "Vorschau der Abstimmung",
"Poll options" => "Abstimmungs-Optionen",
"Votes" => "Stimmen",
"Admin Polls" => "Abstimmungen verwalten",
"Set last poll as current" => "Letzte Abstimmung als aktuelle Abstimmung setzen",
"Close all polls but last" => "Alle bis auf die letzte Abstimmung schließen",
"Activate all polls" => "Alle Abstimmungen aktivieren",
"active" => "aktiv",
"current" => "aktuell",
"object" => "Objekt",
"PublishDate" => "DatumVeröff.",
"Results" => "Ergebnisse",
"Wiki pages" => "Wiki-Seiten",
"Content for the feed" => "Inhalt für den Feed",
"Security Admin" => "Sicherheit",
"PHP settings" => "PHP Einstellungen",
"PHP variable" => "PHP Variable",
"Risk Factor" => "Risikofaktor",
"Explanation" => "Erklärung",
"Tiki variable" => "Tiki Variable",
"Check all tiki files" => "Alle Tiki-Dateien überprüfen",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Achtung, dies kann viel Zeit in Anspruch nehmen. Der Parameter max_execution_time setting in der php.ini sollte entsprechend hoch sein, damit das Script nicht abbricht.",
"File checks" => "Datei-Checks",
"user" => "Benutzer",
"group" => "Gruppe",
"sticky" => "festgeheftet",
"Admin Shoutbox Words" => "Shoutbox Words Verwaltung",
"Add Banned Word" => "Füge gebanntes Wort hinzu",
"Are you sure you want to delete this word?" => "Soll das Wort wirklich gelöscht werden?",
"Destroy the structure leaving the wiki pages" => "Nur Struktur entfernen",
"Destroy the structure and remove the pages" => "Struktur und Seiten entfernen",
"Export Pages" => "Seiten exportieren",
"Dump Tree" => "Baum ausgeben",
"Create WebHelp" => "Erstelle WebHelp",
"Create new structure" => "Neue Struktur anlegen",
"Tree" => "Baum",
"Use single spaces to indent structure levels" => "Strukturelevel durch Einrücken (einzelne Leerzeichen) definieren",
"Create New Structure" => "Neue Struktur anlegen",
"List surveys" => "Umfragen auflisten",
"Survey Stats" => "Umfragen-Statistik",
"Edit this Survey" => "Diese Umfrage bearbeiten",
"Admin Surveys" => "Umfragen verwalten",
"Question" => "Frage",
"One choice" => "Eine Auswahl",
"Multiple choices" => "Multiple Auswahlen",
"Short text" => "Kurzbeschreibung",
"Rate (1..5)" => "Bewerte (1..5)",
"Rate (1..10)" => "Bewerte (1..10)",
"Rate" => "Bewerten",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Bei Fragen mit mehreren möglichen Antworten diese im folgenden Feld kommagetrennt eingeben",
"Options (if apply)" => "Optionen (falls nötig)",
"Questions" => "Fragen",
"Admin surveys" => "Umfragen verwalten",
"List Surveys" => "Umfragen auflisten",
"Create/Edit Surveys" => "Umfragen hinzufügen/bearbeiten",
"Edit this Survey:" => "Diese Umfrage bearbeiten:",
"Create New Survey" => "Neue Unfrage erstellen",
"There are individual permissions set for this survey" => "Für diese Umfrage sind individuelle Berechtigungen gesetzt",
"Open" => "Offen",
"Closed" => "Geschlossen",
"Empty" => "Leeren",
"Advanced feature" => "Funktion für Fortgeschrittene",
"Fix UTF-8 Errors in Tables" => "UTF-8 Fehler in Tabellen korrigieren",
"Warning: Make a backup of your Database before using this function!" => "Warnung: Erstellen Sie ein Datenbank Backup bevor Sie diese Funktion benutzen!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Warnung: Wenn Sie grosse Tabellen konvertieren wollen, erhöhen Sie die maximum execution time in Ihrer php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Diese Funktion konvertiert ISO-8859-1 codierte Strings in UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Notwendig, wenn Sie mit Tiki &lt; v1.8.4 und ISO-8859-1 Codierung gearbeitet haben.",
"UTF-8 Errors fixed" => "UTF-8 Fehler behoben",
"Investigate" => "Untersuchen",
"Fix it" => "Korrigieren",
"Create a new topic" => "Neues Thema erstellen",
"Topic Name" => "Themenname",
"Upload Image" => "Bild hochladen",
"List of topics" => "Themenliste",
"Articles (subs)" => "Artikel (eingereicht)",
"topic image" => "Themenlogo",
"Deactivate" => "Deaktivieren",
"Remove with articles" => "Typ und zugehörige Artikel löschen",
"List Trackers" => "Tracker auflisten",
"Admin Trackers" => "Tracker verwalten",
"Edit This Tracker" => "Diesen Tracker bearbeiten",
"View This Tracker's Items" => "Einträge dieses Trackers ansehen",
"Tracker fields" => "Tracker-Felder",
"Mandatory" => "Pflicht",
"Is column visible when listing tracker items?" => "Ist Spalte beim Auflisten von Tracker-Einträgen sichtbar?",
"Tbl vis" => "in Liste",
"Column links to edit/view item?" => "Links in Spalten zum Editiere/Betrachten von Einträgen?",
"isMain" => "Hauptfeld",
"Searchable" => "Durchsuchbar",
"Hidden" => "Versteckt",
"Edit tracker field" => "Tracker-Felder bearbeiten",
"Field is mandatory?" => "Pflichtfeld?",
"Column is searchable?" => "Spalte durchsuchbar?",
"Field is hidden?" => "Feld versteckt?",
"not hidden" => "nicht versteckt",
"visible to admin only" => "nur für Admin sichtbar",
"editable by admin only" => "nur durch Admin beschreibbar",
"Import/Export Trackers Fields" => "Tracker-Felder importieren/exportieren",
"Found" => "Fand",
"trackers" => "Tracker",
"Create Tracker" => "Tracker anlegen",
"Create/Edit Tracker" => "Tracker hinzufügen/bearbeiten",
"There are individual permissions set for this tracker" => "Für diesen Tracker sind individuelle Berechtigungen gesetzt",
"No individual permissions. Global permissions apply." => "Keine individuellen Berechtigungen, globale Berechtigungen gelten",
"Auto create corresponding categories" => "Automatisch passende Kategorien anlegen",
"Use \"explicit\" names in the mirror table" => "Nutzen Sie \"explizite \" Namen in der Spiegeltabelle",
"Show status" => "Zeige Status",
"Default status displayed in list mode" => "Stati, die in der Listenanzeige ausgegeben werden sollen",
"Show status to tracker admin only" => "Status nur dem Tracker-Admin zeigen",
"Send copies of all activity in this tracker to this e-mail address" => "Kopien aller Aktivitäten dieses Trackers an diese eMail-Adresse schicken",
"Use simplified e-mail format" => "Vereinfachtes eMail-Format benutzen",
"New items are created with status" => "Status neuer Einträge",
"Authoritative status for modified items" => "Authoritiver Status des Trackers wird beim Ändern des Trackers gesetzt auf",
"No change" => "keine Änderung",
"Item creator can modify his items?" => "Ersteller kann Einträge ändern",
"The tracker needs a user field with the option 1" => "Der Tracker muß ein Benutzerfeld mit der Option 1 besitzen",
"User can take ownership of item created by anonymous" => "Benutzer kann Objekt-Besitz von 'Anonymous' übernehmen",
"Only one item per user or IP" => "Nur ein Eintrag pro Benutzer oder IP-Adresse",
"The tracker needs a user or IP field with the option 1" => "Der Tracker muß ein Benutzer- oder IP-Feldmit der Option 1 besitzen",
"Member of the creator group can modify items?" => "Mitglied der Erstellergruppe kann Einträge ändern",
"The tracker needs a group field with the option 1" => "Der Tracker muß ein Gruppenfeld mit der Option 1 besitzen",
"Show creation date when listing tracker items?" => "Erstellungsdatum beim Auflisten von Tracker-Einträgen anzeigen",
"Show creation date when viewing tracker item?" => "Erstellungsdatum beim Betrachten von Einträgen anzeigen",
"Show lastModif date when listing tracker items?" => "Änderungsdatum beim Auflisten von Tracker-Einträgen anzeigen",
"Show lastModif date when viewing tracker item?" => "Änderungsdatum beim Betrachten von Einträgen anzeigen",
"What field is used for default sort?" => "Standardfeld für Sortierung",
"What is default sort order in list?" => "Standardsortierung",
"ascending" => "aufsteigend",
"descending" => "absteigend",
"Tracker items allow ratings?" => "Bewertung von Tracker-Einträgen erlauben",
"with values" => "mit den Werten",
"and display rating results in listing?" => "und Bewertungsergebnisse in Liste anzeigen",
"Tracker items allow comments?" => "Kommentare zu Tracker-Einträgen zulassen",
"and display comments in listing?" => "und Kommentare in Liste anzeigen",
"Tracker items allow attachments?" => "Anlagen zu Tracker-Einträgen zulassen",
"and display attachments in listing?" => "und Anhänge in Liste anzeigen",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Darstellungsoptionen für Anhänge (Nummern zur Sortierung eintragen, 0 versteckt Felder, bei negativen Einträgen erscheinen Popups)",
"Filesize" => "Dateigröße",
"Filetype" => "Dateityp",
"LongDesc" => "Beschreibung",
"Items can be created only during a certain time" => "Einträge sind nur in einem bestimmten Zeitraum möglich",
"Do not show empty fields in item view?" => "Leere Felder beim Betrachten von Einträgen ausblenden",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items?" => "Diese Felder (kommagetrennte IDs) als Popup auf Eintragslinks in der Listenansicht anzeigen",
"Group of users alerted when tracker is modified" => "Gruppe von Benutzern bei Tracker-Änderung benachrichtigen",
"Import/Export" => "Importieren/Exportieren",
"Import/export trackers" => "Tracker im-/exportieren",
"Duplicate Tracker" => "Tracker duplizieren",
"Admin groups" => "Gruppen verwalten",
"Admin users" => "Benutzer verwalten",
"Add new group" => "Neue Gruppe hinzufügen",
"List of existing groups" => "Liste vorhandener Gruppen",
"Edit group" => "Bearbeite Gruppe",
"Add a New Group" => "Eine neue Gruppe hinzufügen",
"Use wiki page name or full URL" => "Wiki-Seitennamen oder volle URL benutzen",
"Group Information Tracker" => "Gruppen-Informationstracker",
"choose a group tracker ..." => "Wählen Sie einen Gruppentracker ...",
"choose a field ..." => "Wählen Sie ein Feld ...",
"Users Information Tracker" => "Benutzer-Informationstracker",
"choose a users tracker ..." => "Wählen Sie einen Benutzertracker ...",
"Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Felder der Benutzer-Informationstracker die bei der Registrierung erfragt werden<br />(FelderIDs trennen mit :)",
"Group tracker item : {\$groupitemid}" => "Gruppentracker-Item : {\$groupitemid}",
"Edit Item" => "Punkt bearbeiten",
"Group tracker item not found" => "Gruppentracker-Item nicht gefunden",
"Members" => "Mitglieder",
"users in group" => "Benutzer in Gruppe",
"CSV File" => "CSV Datei",
"Add a New User" => "Neuen Benutzer hinzufügen",
"Reason" => "Grund",
"More Criteria" => "Erweiterte Suchoptionen",
"Group (direct)" => "Gruppe (direkt)",
"Registered" => "Registriert",
"to groups" => "zu Gruppen",
"Manage Group Assignments" => "Gruppenzuordnungen bearbeiten",
"Set Default Groups" => "Standardgruppen setzen",
"Assign selected to" => "Markierte hinzufügen zu",
"Remove selected from" => "Markierte löschen aus",
"the following groups:" => "den folgenden Gruppen:",
"bcc" => "BCC",
"Edit user" => "Benutzerdaten bearbeiten",
"Generate a password" => "Paßwort vorschlagen",
"User tracker item : {\$usersitemid}" => "Benutzertracker-Item : {\$usersitemid}",
"Overwrite" => "Überschreiben",
"Overwrite but keep the previous login if the login exists in another case" => "Überschreibe, aber behalte den vorhergehenden Login wenn der Login in anderer Schreibweise bereits existiert",
"Don't overwrite" => "Nicht überschreiben",
"Overwrite groups:" => "Gruppen überschreiben:",
"Loading..." => "Laden...",
"Source" => "Quelle",
"Admin Article Types" => "Artikeltypen verwalten",
"List of types" => "Liste vorhandener Typen",
"Shows up in the drop down list of article types" => "In der Auswahlliste der Typen anzeigen",
"Allow ratings by the author" => "Bewertungen des Autors erlauben",
"Show before publish date" => "Vor dem Veröffentlichungsdatum anzeigen",
"non-admins can view before the publish date" => "Nicht-Admins sehen den Artikel vor dem Veröffentlichungsdatum",
"Show after expire date" => "Nach dem Auslaufdatum anzeigen",
"non-admins can view after the expire date" => "Nicht-Admins sehen den Artikel nach dem Ablaufdatum",
"Heading only" => "nur Kopfteil",
"No article body, heading only" => "Nur den Header ohne den Artikelbody anzeigen",
"Allow comments for this type" => "Kommentare für diesen Typ erlauben",
"Comment Can Rate Article" => "Kommentar darf Artikel bewerten",
"Allow comments to include a rating value" => "Kommentare inklusive Bewertung erlauben",
"Show image" => "Zeige Bild",
"Show topic or own image" => "Thema oder eigenes Bild anzeigen",
"Show avatar" => "Zeige Avatar",
"Show author's avatar" => "Avatar des Autors anzeigen",
"Show author" => "Zeige Autor",
"Show author name" => "Namen des Autors anzeigen",
"Show publish date" => "Zeige Veröffentlichungsdatum",
"Show expire date" => "Zeige Ablaufdatum",
"Show reads" => "Zeige Zugriffe",
"Show the number of times the article was read" => "Anzeigen wie oft der Artikel gelesen wurde",
"Show size" => "Zeige Größe",
"Show the size of the article" => "Größe des Artikels anzeigen",
"Show topline" => "Introzeile anzeigen",
"Show a small title over the title" => "Kleine Introzeile über der Überschrift anzeigen",
"Show subtitle" => "Untertitel anzeigen",
"Show the subtitle" => "Untertitel anzeigen",
"Show source" => "Zeige Quelle",
"Show link to source after article body" => "Zeige Link zur Quell nach dem Artikelbody",
"Show Image Caption" => "Bildbeschreibung anzeigen",
"Show a legend under the image" => "Legende unter dem Bild anzeigen",
"Show Language" => "Zeige Sprache",
"Show the language" => "Sprache anzeigen",
"Creator can edit" => "Ersteller kann bearbeiten",
"The person who submits an article of this type can edit it" => "Einreicher dieses Artikeltyps dürfen diese Artikel ändern",
"Show lang" => "Sprache anzeigen",
"Review" => "Rezension",
"Classified" => "Vertraulich",
"Create a new type" => "Neuen Typ anlegen",
"Group Information" => "Gruppeninformationen",
"level" => "Stufe",
"inherited from" => "geeerbt von",
"inherited" => "geerbt",
"Create level" => "Neue Berechtigungsstufe",
"all permissions in level" => "alle Rechte auf Stufe",
"backlinks to" => "Backlinks zu",
"No backlinks to this page" => "Keine Backlinks auf diese Seite",
"Directory batch upload" => "Aus Verzeichnis einlesen",
"Browse Gallery" => "Galerie anzeigen",
"Upload From Disk" => "Hochladen von Disk",
"available images" => "Bilder vorhanden",
"Remove File Extension from Image Name" => "Dateiendung im Namensfeld entfernen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "z.B. wird von \"digicam0001.jpg\" der Name digicam0001 im Namensfeld benutzt",
"Select a Gallery" => "Ziel-Galerie auswählen",
"Process" => "Prozess",
"Browse File Gallery" => "Dateiarchiv durchsehen",
"Please do not use this feature to upload data into the database." => "Mit dieser Funktion bitte keine Daten in die Datenbank laden.",
"Available Files" => "verfügbare Dateien",
"Select a File Gallery" => "Dateiarchiv auswählen",
"Process files" => "Dateien verarbeiten",
"Edit Post" => "Eintrag bearbeiten",
"View Blog" => "Blog betrachten",
"If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "Falls Sie Bilder benutzen möchten speichern Sie bitte den Beitrag und hängen Sie dann erst Bilder an. Benutzen Sie das &lt;img&gt; Schnipsel um hochgeladene Bilder einzubinden oder benutzen Sie die Bilder-URL im WYSIWYG-Editor. ",
"Use ...page... to separate pages in a multi-page post" => "Benutze ...page... um den Eintrag in mehrere Seiten zu untergliedern",
"Body" => "Text",
"Upload image for this post" => "Bild für diesen Beitrag hochladen",
"Trash" => "Müll",
"Mark entry as private:" => "Eintrag als privat kennzeichnen:",
"Spellcheck" => "Rechtschreibprüfung",
"Save and Exit" => "Speichern und verlassen",
"Made with" => "Erstellt mit",
"powered by" => "Powered by",
"Articles RSS" => "Artikel RSS",
"Image Galleries RSS" => "Bilder-Galerien RSS",
"File Galleries RSS" => "Datei-Archive RSS",
"Forums RSS" => "Foren RSS",
"Maps RSS" => "Karten RSS",
"Execution time" => "Ausführungszeit",
"Memory usage" => "Speicherverbrauch",
"database queries used in " => "Datenbank-Aufrufe ausgeführt in",
"Server load" => "Serverlast",
"Watch Only This Category" => "Nur diese Kategorie beobachten",
"Watch This Category and Their Descendants" => "Diese Kategorien und deren Nachfolger beobachten",
"Stop Watching Only This Category" => "Nur diese Kategorie nicht mehr beobachten",
"Stop Watching This Category and Their Descendants" => "Diese Kategorie und deren Nachfolger nicht mehr beobachten",
"Admin Category" => "Kategorien verwalten",
"Browse in" => "Stöbern in",
"Trackers Items" => "Tracker Items",
"Sheets" => "Blätter",
"in the current category - and its subcategories: " => "in der aktuellen Kategorie - und in allen Unterkategorien: ",
"Hide subcategories objects" => "Einträge von Unterkategorien verstecken",
"Show subcategories objects" => "Einträge von Unterkategorien anzeigen",
"Upper level" => "Oberer Level",
"Browse related tags" => "Durchsuche verwandte Tags",
"Network of Tags related to" => "Netzwerk verwandter Tags",
"results found" => "Gefundene Ergebnisse",
"List Galleries" => "Galerien auflisten",
"Edit Gallery" => "Galerie bearbeiten",
"Rebuild Thumbnails" => "Thumbnails neu erzeugen",
"Directory Batch" => "Aus Verzeichnis einlesen",
"List Gallery" => "Galerie als Liste zeigen",
"Sort Images by" => "Bilder sortieren nach",
"subgallery" => "Unter-Galerie",
"Subgallery" => "Unter-Galerie",
"Hit" => "Treffer",
"Original Size" => "Originalgröße",
"rotate right" => "rechts drehen",
"rotate" => "drehen",
"popup" => "Popup",
"You can include the image in a tiki page using one of these lines" => "Das Bild kann mit den folgenden Zeilen in eine Wikiseite eingebunden werden",
"Return to Gallery" => "Zurück zur Galerie",
"Edit Image" => "Bild bearbeiten",
"First Image" => "Erstes Bild",
"Prev Image" => "Vorh. Bild",
"Smaller" => "Kleiner",
"Bigger" => "Größer",
"Popup window" => "Popup-Fenser",
"Next Image" => "Näch. Bild",
"Slideshow Forward" => "Diaschau vorwärts",
"Last Image" => "Neuestes Bild",
"Cyclic" => "Zyklisch",
"Click to zoom" => "Klicken Sie, um zu zoomem",
"Image Name" => "Bildname",
"Image Scale" => "Bildskalierung",
"Latitude (WGS84/decimal degrees)" => "Breitengrad (WGS84/Grad)",
"Longitude (WGS84/decimal degrees)" => "Längengrad (WGS84/Grad)",
"Move image" => "Bild verschieben",
"Stop Monitoring this Page" => "Diese Seite nicht mehr beobachten",
"Monitor this Page" => "Diese Seite beobachten",
"Group Calendars" => "Gruppenkalender",
"Tentative" => "Unter Vorbehalt",
"Confirmed" => "Zugesagt",
"Cancelled" => "Abgelehnt",
"Change Focus" => "Hierher wechseln",
"Edit Calendar Item" => "Kalendereintrag bearbeiten",
"New Calendar Item" => "Neuer Kalender-Eintrag",
"Tuesday" => "Dienstag",
"Wednesday" => "Mittwoch",
"Thursday" => "Donnerstag",
"Friday" => "Freitag",
"January" => "Januar",
"February" => "Februar",
"March" => "März",
"May" => "Mai",
"June" => "Juni",
"July" => "Juli",
"October" => "Oktober",
"December" => "Dezember",
"times" => "mal",
"End" => "Ende",
"Duration" => "Dauer",
"Organized by" => "Organisiert von",
"Roles" => "Rollen",
"Calendar import" => "Kalender importieren",
"Calendar has been updated" => "Kalender wurde aktualisiert",
"import" => "Import",
"%m/%d" => "%d.%m.",
"Change password enforced" => "Paßwortwechsel erzwungen",
"Change your password" => "Ändern Sie Ihr Paßwort",
"Send a message to us" => "Schick uns eine Nachricht",
"Contact us by email" => "Kontaktiere uns per eMail",
"Click here to send us an email" => "Hier klicken um uns eine eMail zu schicken",
"Contacts" => "Kontakte",
"Create/edit contacts" => "Kontakte hinzufügen/bearbeiten",
"First Name" => "Vorname",
"Last Name" => "Nachname",
"You can browse the generated WebHelp here" => "Sie können die generierte WebHilfe hier durchsuchen",
"Structure" => "Struktur",
"Top page" => "Top-Seite",
"Add a new site" => "Füge neuen Link hinzu",
"You cannot add sites until Directory Categories are setup." => "Links können erst hinzugefügt werden, wenn Kategorien dafür eingerichtet wurden.",
"Please contact the Site Administrator" => "Bitte kontaktieren sie den Administrator der Site.",
"Site added" => "Link hinzugefügt",
"Directory Administration" => "Linkverzeichnis verwalten",
"There are" => "Es gibt",
"invalid sites" => "ungültige Links",
"valid sites" => "gültige Links",
"Directory Categories" => "Verzeichniskategorien",
"Users have visited" => "Benutzer besuchten",
"sites from the directory" => "Links aus dem Verzeichnis",
"Users have searched" => "Benutzer suchten",
"times from the directory" => "mal im Linkverzeichnis",
"Related" => "Verwandt",
"Sites" => "Links",
"Validate" => "überprüfen",
"Admin directory categories" => "Verzeichniskategorien verwalten",
"Parent directory category" => "Übergeordnete Verzeichniskategorie",
"Add a directory category" => "Verzeichniskategorie hinzufügen",
"Edit this directory category" => "Diese Verzeichniskategorie bearbeiten",
"Children type" => "Kind-Typ",
"Maximum number of children to show" => "Maximalzahl der angezeigten Kinder",
"Allow sites in this directory category" => "Sites in dieser Verzeichniskategorie erlauben",
"Show number of sites in this directory category" => "Anzahl der Sites in dieser Verzeichniskategorie zeigen",
"Editor group" => "Editor-Gruppe",
"Directory Subcategories" => "Verzeichnis-Unterkategorien",
"cType" => "Kindtyp",
"allow" => "Sites erlaubt",
"count" => "Anzahl",
"editor" => "Ersteller",
"Admin sites" => "Links verwalten",
"Is valid" => "Ist gültig",
"New Sites" => "Neue Links",
"Cool Sites" => "Coole Links",
"Add a Site" => "Link hinzufügen",
"Add a Directory Category" => "Verzeichniskategorie hinzufügen",
"any" => "irgendeines",
"in entire directory" => "im gesamten Linkverzeichnis",
"Sort by" => "Sortiere nach",
"name (desc)" => "Name (abst.)",
"name (asc)" => "Name (aufst.)",
"hits (desc)" => "Zugriffen (abst.)",
"hits (asc)" => "Zugriffen (aufst.)",
"creation date (desc)" => "Erstelldatum (abst.)",
"creation date (asc)" => "Erstelldatum (aufst.)",
"last updated (desc)" => "letzte Änderung (abst.)",
"last updated (asc)" => "letzte Änderung (aufst.)",
"Added" => "Hinzugefügt",
"Last updated" => "Zuletzt aktualisiert",
"Total directory categories" => "Verzeichniskategorien gesamt",
"Total links" => "Links gesamt",
"Links to validate" => "Zu überprüfende Links",
"Searches performed" => "Durchgeführte Suchaufträge",
"Total links visited" => "Besuchte Links gesamt",
"Directory ranking" => "Rang im Verzeichnis",
"Search results" => "Suchergebnisse",
"Validate sites" => "Links überprüfen",
"Edit article" => "Artikel erstellen/bearbeiten",
"List Articles" => "Artikel auflisten",
"View Articles" => "Beiträge ansehen",
"One of the email addresses you typed is invalid" => "Eine der angegebenen E-Mail-Adressen ist ungültig",
"Topline" => "Introzeile",
"Author Name" => "Autor",
"Own Image" => "Eigenes Bild",
"Article image" => "Artikellogo",
"Use own image" => "Eigenes Bild benutzen",
"Float text around image" => "Text fließt um Bilder herum",
"Own image size x" => "Eigene Bildbreite",
"Own image size y" => "Eigene Bildhöhe",
"Image caption" => "Bildbeschreibung",
"Publish Date" => "Veröffentlichungsdatum",
"Expiration Date" => "Ablaufdatum",
"Edit or create banners" => "Banner hinzufügen/bearbeiten",
"List banners" => "Banner anzeigen",
"URL to link the banner" => "URL, die mit dem Banner verknüpft wird",
"Client" => "Agent",
"Max impressions" => "Max. Aufrufe",
"Show the banner only between these dates" => "Banner nur während dieser Tage zeigen",
"From date" => "Von Datum",
"To date" => "Bis Datum",
"Use dates" => "Datum benutzen",
"Show the banner only in this hours" => "Banner nur während dieser Stunden zeigen",
"Show the banner only on" => "Zeige das Banner nur auf",
"Mon" => "Mo",
"Tue" => "Di",
"Wed" => "Mi",
"Thu" => "Do",
"Fri" => "Fr",
"Sat" => "Sa",
"Sun" => "So",
"Select ONE method for the banner" => "EINE Methode für das Banner auswählen",
"Use HTML" => "HTML benutzen",
"Use image" => "Bild benutzen",
"Image:" => "Bild:",
"Current Image" => "Aktuelles Bild",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Bild benutzen, das durch die URL erzeugt wird (das Bild wird bei jedem Aufruf der URL angefordert)",
"Use text" => "Text benutzen",
"Save the Banner" => "Das Banner speichern",
"Remove Zones (you lose entered info for the banner)" => "Lösche Zonen (Sie verlieren die eingegebenen Bannerinformationen)",
"Create Blog" => "Blog erstellen",
"A category is mandatory" => "Eine Kategorie ist zwingend erforderlich",
"Current heading" => "Aktueller Kopfbereich",
"There are individual permissions set for this blog" => "Es gibt individuelle Berechtigungen für dieses Blog",
"Number of posts to show" => "Anzahl der anzuzeigenden Einträge",
"Allow other user to post in this blog" => "Anderer Benutzer darf in dieses Blog eintragen",
"Allow search" => "Suchen erlauben",
"Allow comments" => "Kommentare erlauben",
"Show user avatar" => "Zeige Benutzer-Avatar",
"Blog heading" => "Blog Kopfbereich",
"Edit Style Sheet" => "Stylesheet bearbeiten",
"Style Sheet" => "Stylesheet",
"choose a stylesheet" => "Stylesheet auswählen",
"Try" => "Ausprobieren",
"Bold text" => "Fett",
"Italic text" => "Kursiv",
"single quotes" => "Einfache Anführungszeichen",
"Underlined text" => "unterstrichen",
"Colored text" => "Farbiger Text",
"Headings" => "Überschriften",
"Show/Hide" => "Ein-/Ausblenden",
"show/hide heading section. + (shown) or - (hidden) by default" => "Zeige/Verstecke Überschriftsbereich + (zeige) or - (Verstecke) als Standard",
"Horizontal rule" => "Waagrechte Linie",
"Box content" => "Box-Inhalt",
"Centered text" => "Zentrierter Text",
"Dynamic variables" => "Dynamische Variablen",
"Inserts an editable variable" => "Fügt eine beschreibbare Variable ein",
"External links" => "Externe Links",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Um ein externes Wiki einzubinden, verwenden Sie:SeitenName oder ((Name des externen Wikis: Seitenname))",
"Square Brackets" => "Eckige Klammern",
"Use [[foo] to show [foo]." => "[[foo] benutzen, damit [foo] ausgegeben wird.",
"Wiki References" => "Wiki-Referenzen",
"JoinCapitalizedWords or use" => "ZusammenGrossKleinSchreibung oder benutzen Sie",
"page|description" => "Seite|Beschr.",
"for wiki references" => "für Wiki-Referenzen",
"SomeName" => "EinName",
"prevents referencing" => "verhindert Referenzierung",
"Lists" => "Listen",
"for bullet lists" => "für einfache Listen",
"for numbered lists" => "für numerierte Listen",
"for definiton lists" => "für Definitionslisten",
"Tables" => "Tabellen",
"row" => "Reihe",
"Title bar" => "Titelbalken",
"Line break" => "Zeilenumbruch",
"(very useful especially in tables)" => "(besonders nützlich in Tabellen)",
"Multi-page pages" => "Mehrseitige Seiten",
"Non parsed sections" => "Nicht geparste Bereiche",
"Prevents wiki parsing of the enclosed data." => "Verhindert, dass Wiki die eingefügten Daten parst.",
"Preformated sections" => "Vorformatierte Bereiche",
"Block Preformatting" => "Block Vorformatierung",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Weil die Wikiabsatzformatierungsfunktion eingeschaltet ist, werden alle Zeilen, die nicht Leerzeilen sind, zu einem Absatz zusammengefasst. Die Zeilen können von beliebiger Länge sein und werden mit der nächsten Zeile gebündelt. Absätze werden durch Leerzeilen getrennt.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Weil die Wikiabsatzformatierungsfunktion ausgeschaltet ist, wird jede Zeile so dargestellt wie Sie sie eingeben. Das heißt, wenn Sie einen Absatz gestalten möchten, sollten Sie den gesamten Text in einer Zeile eingeben.",
"No description available" => "Keine Beschreibung vorhanden.",
"Browse Images" => "Bild betrachten",
"Edit successful!" => "Bearbeitung erfolgreich!",
"The following image was successfully edited" => "Das folgende Bild wurde erfolgreich bearbeitet",
"Image Description" => "Bildbeschreibung",
"You can view this image in your browser using" => "Sie können dieses Bild in Ihrem Browser betrachten",
"You can include the image in an HTML page using one of these lines" => "Das Bild kann wie folgt in eine HTML-Seite eingebunden werden",
"Edit or ex/import Languages" => "Sprachen erstellen oder im/exportieren",
"Edit and create Languages" => "Sprachen erstellen/bearbeiten",
"Edit and create languages" => "Sprachen erstellen/bearbeiten",
"Create Language" => "Sprache erstellen",
"Shortname" => "Kurzname",
"like" => "wie",
"Longname" => "Voller Name",
"Select the language to edit" => "Zu bearbeitende Sprache auswählen",
"Add a translation" => "Übersetzung hinzufügen",
"Edit translations" => "Übersetzungen bearbeiten",
"Translate recorded" => "Aufgezeichnetes übersetzen",
"Translation" => "Übersetzung",
"reset table" => "Tabelle zurücksetzen",
"Create New Block" => "Neuen Block erzeugen",
"Return to block listing" => "Zurück zur Block-Auflistung",
"Block description: " => "Blockbeschreibung: ",
"You are editing block:" => "Sie bearbeiten Block:",
"Publishing date" => "Veröffentlichungszeitpunkt",
"Publishing Date" => "Veröffentlichungszeitpunkt",
"Edit question options" => "Bearbeite Frageoptionen",
"List Quizzes" => "Quiz auflisten",
"Quiz Stats" => "Quiz-Statistik",
"This Quiz Stats" => "Statistik für dieses Quiz",
"Edit this Quiz" => "Dieses Quiz bearbeiten",
"Admin Quizzes" => "Quiz verwalten",
"Create/edit options for question" => "Optionen für Frage erstellen/bearbeiten",
"points" => "Bewertung",
"canRepeat" => "wiederholbar",
"timeLimit" => "ZeitLimit",
"Create/edit quizzes" => "Quiz hinzufügen/bearbeiten",
"There are individual permissions set for this quiz" => "Für dieses Quiz gibt es individuelle Berechtigungen",
"Quiz can be repeated" => "Quiz kann wiederholt werden",
"Store quiz results" => "Quiz-Ergebnisse abspeichern",
"Immediate feedback" => "Sofortiges Feedback",
"Show correct answers" => "Korrekte Antworten zeigen",
"Shuffle questions" => "Fragen durcheinanderwürfeln",
"Shuffle answers" => "Antworten durcheinanderwürfeln",
"Quiz is time limited" => "Ratezeit ist limitiert",
"Maximum time" => "Maximale Zeit",
"Passing Percentage" => "Erfolgreich bei mindestens %",
"Edit quiz questions" => "Quiz-Fragen bearbeiten",
"Create/edit questions for quiz" => "Fragen für Quiz erstellen/bearbeiten",
"Question Type" => "Fragentyp",
"Import questions from text" => "Importiere Fragen aus Text",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Anweisung: Tippe oder füge deine Multiple-Choice-Fragen unten ein. Eine Zeile für die Frage, danach die Antwortmöglichkeiten in die nachfolgenden Zeilen. Trenne weitere Fragen mit einer Leerzeile. gib die richtige Anntwort an, indem du ihr ein \"*\" (ohne Anführungszeichen)  voranstellst.",
"Input" => "Eingabe",
"maxScore" => "maxPunktzahl",
"From Points" => "von Punkten",
"To Points" => "zu Punkten",
"Answer" => "Antwort",
"Modify Structure" => "Struktur verändern",
"You will remove" => "Sie löschen",
"and its subpages from the structure, now you have two options:" => "und seine Unterseiten aus der Struktur; sie haben nun zwei Optionen:",
"Remove only from structure" => "Nur aus Struktur entfernen",
"Remove from structure and remove page too" => "Aus Struktur und von Seite entfernen",
"Structure Layout" => "Struktur Layout",
"Promote" => "Vorwärts",
"Demote" => "Zurück",
"Previous" => "Vorherige",
"Current Node" => "Aktueller Knoten",
"Page alias" => "Seitenalias",
"Add pages to current node" => "Seiten zu aktuellem Knoten hinzufügen",
"After page" => "Nach Seite",
"Create Page" => "Seite erstellen",
"Use pre-existing page" => "Vorhandene Seite verwenden",
"Submit article" => "Artikel einreichen",
"List Submissions" => "Einreichungen auflisten",
"<b>Topline</b>=small line above Title" => "<b>Topline</b>=kleine Linie über dem Titel",
"<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=kleine Linie unter dem Titel",
"<b>Source</b>=URL to article source" => "<b>Source</b>=URL zur Artikelquelle",
"Allow HTML:" => "HTML erlauben:",
"Submit Article" => "Artikel einreichen",
"Auto-Approve Article" => "Artikel automatisch freigeben",
"Edit templates" => "Vorlagen bearbeiten",
"Template listing" => "Vorlagenliste",
"Available templates" => "Verfügbare Templates",
"Save Only in the Theme:" => "Nur für diesen Style speichern:",
"Delete the copy in the theme:" => "Lösche die Kopie im Theme:",
"Edit a topic" => "Thema bearbeiten",
"View Page" => "Betrachte Seite",
"You must specify the object language" => "Sie müssen die Sprache des Objekts angeben",
"The object doesn't exist" => "Objekt existiert nicht",
"The object doesn't have a language" => "TObjekt hat keine Sprache",
"The object has already a translation for this language" => "Es existiert bereits eine Übersetzung für die Sprache des Objekts",
"The object is already in the set of translations" => "Das Objekt ist bereits als Übersetzung gespeichert",
"detach" => "entfernen",
"Edit Section:" => "Bearbeite Abschnitt:",
"View object" => "Betrachte Objekt",
"Warning: new versions of this page have been made after this draft" => "Warnung: new versions of this page have been made after this draft",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "Die SandBox ist eine Seite, an der Sie Ihre Editierfähigkeiten üben können. Benutzen Sie die Vorschau-Funktion, um sich das Resultat Ihrer Seite anzusehen. Keine Version dieser Seite wird gespeichert.",
"Edit page" => "Seite bearbeiten",
"Edit Comment" => "Bearbeitungs-Kommentar",
"Upload picture" => "Bild hochladen",
"Add another image" => "weiteres Bild anhängen",
"Tools" => "Werkzeuge",
"Admin Content Templates" => "Inhaltsvorlagen verwalten",
"Lock this page" => "Diese Seite sperren:",
"Regex search " => "Suche mit regulären Ausdrücken ",
"Replace with" => "Ersetzen durch",
"Case Insensitivity" => "Groß- und Kleinschreibung nicht beachten",
"Try to convert HTML to wiki" => "Versuche HTML in Wiki zu konvertieren",
"Import page" => "Seite importieren",
"export all versions" => "alle Versionen exportieren",
"Year:" => "Jahr:",
"Authors:" => "Autoren:",
"Manage structures" => "Strukturen verwalten",
"License" => "Lizenz",
"Important" => "Wichtig",
"My Footnotes" => "Fußnoten",
"Use rating" => "Bewertung erlauben",
"There is no available poll template." => "Kein Bewertungstemplate vorhanden.",
"You should ask an admin to create them." => "Sie sollten den Admin bitten, eines anzulegen",
"an existing poll" => "eine bestehende Umfrage",
"votes" => "Stimmen",
"Export to file" => "Exportiere nach Datei",
"status" => "Status",
"lastModif" => "Änderung",
"Admin FAQ" => "FAQ verwalten",
"List FAQs" => "FAQs auflisten",
"View FAQ" => "FAQ anzeigen",
"Edit this FAQ" => "Diese FAQ bearbeiten",
"New Question" => "Neue Frage",
"Use a question from another FAQ" => "Eine Frage aus einer anderen FAQ benutzen",
"FAQ questions" => "FAQ-Fragen",
"Suggested questions" => "Vorgeschlagene Fragen",
"No suggested questions" => "Keine vorgeschlagenen Fragen",
"Upload File" => "Datei hochladen",
"View tpl" => "Betrachte tpl",
"File Galleries tpl" => "Bildergalerie tpl",
"Create New File Gallery" => "Neues Dateiarchiv anlegen",
"You can access the file gallery using the following URL" => "Sie können das Dateiarchiv unter der folgenden URL erreichen",
"Admin forums" => "Foren verwalten",
"Edit queued message" => "Nachrichten-Liste bearbeiten",
"make this a thread of" => "Hieraus einen Thread machen von",
"None, this is a thread message" => "nichts, dies ist eine Thread-Nachricht",
"summary" => "Zusammenfassung",
"announce" => "Ankündigung",
"hot" => "heißes Thema",
"no feeling" => "gleichgültig",
"frown" => "verdutzt",
"exclaim" => "ausrufend",
"idea" => "Idee",
"question" => "Frage",
"happy" => "fröhlich",
"wink" => "winkend",
"Save and Approve" => "Speichern und freigeben",
"convert to topic" => "in Thema konvertieren",
"List of messages" => "Nachrichtenliste",
"New Topic" => "Neues Thema",
"no summary" => "keine Zusammenfassung",
"No messages queued yet" => "Es stehen keine Nachrichten an",
"Last Post" => "Neuester Eintrag",
"Reported by" => "Gemeldet von",
"Pending requests" => "Unerledigte Anfragen",
"Request Time" => "Anfrage vom",
"Accept" => "Annehmen",
"Refuse" => "Ablehnen",
"Waiting requests" => "Laufende Anfragen",
"Your friends" => "Ihre Freunde",
"break friendship" => "Freundschaft beenden",
"Galleries" => "Galerien",
"Create New Gallery" => "Neue Galerie anlegen",
"Create a gallery" => "Neue Galerie anlegen",
"Edit this gallery:" => "Diese Galerie bearbeiten:",
"There are individual permissions set for this gallery" => "Für diese Galerie gibt es individuelle Berechtigungen",
"Gallery is visible to non-admin users?" => "Galerie sichtbar für Nicht-Admins?",
"Geographic" => "Geographisch",
"Fields to show during browsing the gallery" => "Angezeigte Felder beim Durchstöbern der Galerie",
"Creation Date" => "Erstelldatum",
"XY-Size" => "XY-Grösse",
"Gallery Image" => "Galerie Logo",
"Available scales" => "Verfügbare Skalierungen",
"Bounding box" => "Zeichenbox",
"default scale" => "Standard-Skala",
"No scales available" => "Keine Skalierungen verfügbar",
"Original image is default scale" => "Originalbild ist die Standard-Skalierung",
"Add scaled images with bounding box of square size" => "Skalierte Bilder in Box anzeigen, Kantenlänge",
"Other users can upload images to this gallery" => "Andere Benutzer können Bilder in diese Galerie hochladen",
"You can access the gallery using the following URL" => "Sie können die Galerie über folgende URL erreichen",
"Available Galleries" => "Verfügbare Galerien",
"Choose a filter" => "Filter wählen",
"Imgs" => "Bilder",
"Make Map" => "Erstelle Karte",
"Save clicked point" => "Speichere markierten Punkt",
"Save current view as default" => "Speichere die aktuelle Ansicht als Standard",
"Users Map" => "Benutzerkarte",
"Select Graphic Type" => "Wähle Graphentyp",
"Pie Chart" => "Kreisdiagramm",
"Multiline" => "Multilinie",
"Bar Stack" => "Leistenblock",
"Landscape" => "Gestalten",
"Independant Scale" => "Unabhängige Skalierung",
"Horizontal Scale" => "Horizontale Skalierung",
"Vertical Scale" => "Vertikale Skalierung",
"Series" => "Serien",
"Wiki plug-in" => "Wiki Plug-in",
"Ical import / Export" => "Ical Import / Export",
"Select The calendar to export" => "Wähle den zu exporiterenden Kalender",
"To" => "An",
"Calendar Import" => "Kalender Import",
"ICal File" => "ICal Datei",
"Im- Export languages" => "Sprachen im/exportieren",
"Select the language to Import" => "Sprache für Import wählen",
"Select the language to Export" => "Sprache für Export wählen",
"Modify String in Source Language" => "Ändere String in Quellsprache",
"Original String" => "Originaler String",
"New String" => "Neuer String",
"Import From File" => "Aus Datei Importieren",
"Grab Wiki Tables" => "Wiki Tabellen wählen",
"Import pages from a Structured Text Dump" => "Seiten aus einem strukturierten Text-Dump importieren",
"Name of the dump file (it has to be in dump/)" => "Name der Dump-Datei (sie muss in dump/ sein)",
"Overwrite existing pages if the name is the same" => "Überschreibe vorhandene Seiten, falls der Name gleich ist",
"Previously remove existing page versions" => "Zuvor vorhandene Seitenversionen entfernen",
"excerpt" => "Auszug",
"Result" => "Ergebnis",
"body" => "Inhalt",
"pages imported from a total of" => "Seiten importiert aus einer Gesamtzahl von",
"You can see the list of wiki pages in your site" => "Sie können die Liste von Wiki-Seiten auf ihrer Seite sehen",
"here" => "hier",
"Errors:" => "Fehler:",
"Locked" => "Gesperrt",
"Tiki installer" => "Tiki-Installer",
"Welcome" => "Willkommen",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Benutzen Sie diese Seite zum Installieren einer neuen oder zum Aktualisieren einer schon vorhandenen Datenbank für Release",
"For the latest information about this release, please read the" => "Für aktuelle Informationen zu diesem Release lesen Sie bitte die",
"For complete documentation, please visit" => "Für eine vollständige Dokumentation besuchen Sie bitte",
"For more information about Tiki, please visit" => "Für mehr Information über Tiki besuchen Sie bitte",
"Read the License" => "Lesen Sie die Lizenz",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Hier gibt es eine besser verständliche Zusammenfassung sowie diverse Übersetzungen.</a>",
"Review the System Requirements" => "Prüfen Sie die System-Voraussetzungen",
"Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements." => "Lesen Sie vor der Installation bitte die <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">Seite über die Voraussetzungen</a> und stellen Sie sicher, dass die Mindestanforderungen erfüllt werden.",
"Memory" => "Speicher",
"Success" => "Erfolgreich",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages." => "Tiki benutzt die PHP <strong>mail</strong> Funktion um Nachrichten zu verschicken.",
"To test your system configuration, Tiki will attempt to send a test message to you." => "Zum Testen der korrekten Mail-Konfiguration können Sie hier eine Testnachricht verschicken.",
"Copy test mail to " => "Test-Mail in Kopie an ",
"Send Test Message" => "Test-Nachricht senden",
"Tiki was able to send a test message to" => "Tiki konnte eine Test-Nachricht abschicken an",
"Image Processing" => "Bild-Bearbeitung",
"Tiki was not able to detect the GD library." => "Tiki konnt die GD-Bibliothek nicht finden.",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support." => "Tiki benutzt die GD-Bibliothek zur Verarbeitung von Bildern sowie für die CAPTCHA-Unterstützung.",
"Set the Database Connection" => "Datenbank-Verbindung einrichten",
"Tiki requires an active database connection." => "Tiki benötigt eine aktive Datenbank-Verbindung.",
"You must create the database and user <em>before</em> completing this page." => "Bitte defininieren Sie eine, <em>bevor</em> Sie fortfahren.",
"Tiki cannot find a database connection." => "Tiki kann keine Datenbank-Konfiguration finden.",
"Use Existing Connection" => "Verwende vorhandene Verbindung",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>." => "Definieren Sie die Einstellungen auf dieser Seite oder erledigen Sie das <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"Manuelle Installation\">manuell</a>.",
"Database information" => "Datenbank-Information",
"Enter your database connection information." => "Tragen Sie die Datenbank-Konfiguration ein.",
"Host name:" => "Rechnername:",
"Enter the host name or IP for your database." => "Name oder IP-Adresse der Maschine, auf der die Datenbank läuft.",
"Enter the name of the database that Tiki will use." => "Name der Datenbank / des Datenbank-Schemas",
"Database user" => "Datenbank Benutzer",
"Enter a database user with administrator permission for the Database." => "Name des Benutzers, der Zugriff auf die Datenbank hat:",
"User name:" => "Benutzername:",
"Install" => "Installieren",
"Reinstall the database" => "Datenbank neu installieren",
"Review the Installation" => "Einstellungen prüfen",
"Configure General Settings" => "Verschiedene Einstellungen II",
"Enter Your Tiki" => "Tiki aufrufen",
"No DB" => "Keine DB",
"Database Connection" => "Verbindung zur Datenbank",
"Reset the Database Connection" => "Einrichten der Datenbank-Verbindung",
"Install Profile" => "Profil installieren",
"Configure the General Settings" => "Allgemeine Einstellungen vornehmen",
"Tiki Icon" => "Tiki-Icon",
"Documentation" => "Dokumentation",
"Support Forums" => "Support Foren",
"Clear cached version and refresh cache" => "Cache aktualisieren",
"configure rules" => "Regeln konfigurieren",
"Edit Repository" => "Repository bearbeiten",
"Interactive translator" => "Interaktiver Übersetzer",
"has been updated" => "wurde aktualisiert",
"Close this window" => "Dieses Fenster schließen",
"Go Back" => "Zurück",
"Last Changes" => "Neueste Änderungen",
"Last 2 days" => "Letzten 2 Tage",
"Last 3 days" => "Letzten 3 Tage",
"Last 5 days" => "Letzten 5 Tage",
"Last week" => "Letzte Woche",
"Last 2 weeks" => "Letzten 2 Wochen",
"Last month" => "Letzten Monat",
"Search by Date" => "Suche nach Datum",
"LastChanges" => "LetzteÄnderungen",
"Rollback" => "Zurückgerollt",
"Pages like" => "Ähnliche Seiten",
"No pages found" => "Keine Seiten gefunden",
"Edit New Article" => "Neuen Artikel erstellen",
"View Submissions" => "Einreichungen ansehen",
"ExpireDate" => "Ablaufdatum",
"AuthorName" => "Autor",
"Img" => "Bild",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Wenn Sie einen Banner in einem <class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a> oder einem Template verwenden möchten, nutzen Sie {literal}{banner zone=ABC}{/literal}, wobei ABC der Name der Zone ist.",
"Create banner" => "Banner erstellen",
"Method" => "Methode",
"Use Dates?" => "Datum benutzen?",
"Max Impressions" => "Max Aufrufe",
"Impressions" => "Aufrufe",
"Max Clicks" => "Max Klicks",
"Clicks" => "Klicks",
"Create New Blog" => "Neuen Blog anlegen",
"Rejected" => "Abgelehnt",
"Dynamic content system" => "Dynamischer Inhalt",
"To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block." => "Wenn Sie Inhaltsblöcke in einem Textbereich (Wiki-Seite etc.), einem <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Modul</a> oder einem Template verwenden möchten, nutzen Sie {literal}{content id=x}{/literal}, wobei x die ID des Inhaltsblocks ist.",
"Edit content block" => "Inhalts-Block bearbeiten",
"Available content blocks" => "Verfügbare Inhaltsblöcke",
"Current Value" => "Aktueller Wert",
"Current ver" => "Aktuelle Ver.",
"Next ver" => "Nächste Ver.",
"Future vers" => "Zukünftige Version",
"Program" => "Programm",
"Available FAQs" => "Verfügbare FAQs",
"Edit/Create" => "hinzufügen/bearbeiten",
"Edit this FAQ:" => "Diese FAQ bearbeiten:",
"Create new FAQ" => "Neue FAQ erstellen",
"Create New FAQ:" => "Neue FAQ erstellen:",
"Users can suggest questions" => "Benutzer können Fragen vorschlagen",
"Create a File Gallery" => "Dateiarchiv anlegen",
"Your comment" => "Ihr Kommentar",
"Gallery Images" => "Galerie-Bilder",
"Special" => "Spezial",
"Edit Blog" => "Blog bearbeiten",
"Blog Title" => "Blog-Titel",
"Edit New Submission" => "Neue Einreichung bearbeiten",
"Survey stats" => "Umfragen-Statistik",
"Take Survey" => "An Umfrage teilnehmen",
"users registered" => "registrierte Benutzer",
"Distance (km)" => "Entfernung (km)",
"List Movies" => "Filme auflisten",
"Choose a movie" => "Film auswählen",
"Last mod" => "letzte Mod.",
"Last modification" => "Letzte Änderung",
"Page creator" => "Seiten-Ersteller",
"Last author" => "Letzter Autor",
"Last version" => "Neueste Version",
"Page size" => "Seiten-Größe",
"unlocked" => "entsperrt",
"Perform action with checked" => "Aktion auf markierte Objekte anwenden",
"Open client window" => "Clientfenster öffnen",
"Generate HTML" => "",
"Transcripts" => "Logbücher",
"Online operators" => "Operatoren online",
"transcripts" => "Logs",
"Offline operators" => "Abwesende Operatoren",
"Add an operator to the system" => "Neuen Operator hinzufügen",
"Operators must be tiki users" => "Operatoren müssen Tiki Benutzer sein",
"Set as Operator" => "Als Operator hinzufügen",
"Chat started" => "Chat begonnen",
"Live support:User window" => "Online-Support: Benutzerfenster",
"Request live support" => "Live Support-Anfrage stellen",
"Request support" => "Supportanfrage stellen",
"Open a support ticket instead" => "Stattdessen ein Support-Ticket erstellen",
"Your request is being processed" => "Ihre Anfrage wird bearbeitet",
"cancel request and exit" => "Anfrage abbrechen und verlassen",
"cancel request and leave a message" => "Anfrage abbrechen und Nachricht hinterlassen",
"Live support:Console" => "Live Support: Konsole",
"be online" => "online gehen",
"be offline" => "offline gehen",
"Support requests" => "Support-Anfragen",
"Requested" => "Angefragt",
"Join" => "Beitreten",
"Support chat transcripts" => "Support Chat-Logbücher",
"Back to admin" => "Zurück zur Administration",
"operator" => "Operator",
"started" => "gestartet",
"reason" => "Grund",
"msgs" => "Nachrichten",
"Transcript" => "Logbuch",
"Mail-in feature" => "Mail-in Funktion",
"Prefs" => "Konfig.",
"Daily" => "täglich",
"Weekly" => "wöchentlich",
"Remove old events" => "Alte Termine löschen",
"duration" => "Dauer",
"Mini Calendar: Preferences" => "Mini-Kalender: Einstellungen",
"Calendar Interval in daily view" => "Kalender Intervall in Tagesansicht",
"Start hour for days" => "Tag beginnt um",
"End hour for days" => "Tag endet um",
"Reminders" => "Erinnerungen",
"no reminders" => "keine Erinnerungen",
"Or enter path or URL" => "Oder Pfad oder URL eingeben",
"Add Topic" => "Thema hinzufügen",
"Tikiwiki Mods" => "Tiki Mods",
"Mods Configuration" => "Mod Konfiguration",
"Update remote index" => "Remote Index aktualisieren",
"Rebuild local list" => "Lokale Liste aktualisieren",
"Republish all" => "alle wiederveröffentlichen",
"Publish all" => "alle veröffentlichen",
"Unpublish all" => "alle nicht veröffentlichen",
"Attention" => "Achtung",
"all types" => "alle Typen",
"Display only this type" => "Nur diesen Typen anzeigen",
"Unpublish" => "Nicht veröffentlichen",
"Republish" => "Wieder veröffentlichen",
"Tikiwiki Mods Configuration" => "Tiki Mod Konfiguration",
"Enable Mods providing" => "Mod Verteilung aktivieren",
"Mods local directory" => "Lokales Mod Verzeichnis",
"Mods remote server" => "Mod Remote Server",
"Package Config" => "Paket Konfiguration",
"y" => "j",
"User Galleries" => "Benutzer-Galerien",
"My Articles" => "Meine Artikel",
"My User Items" => "Meine Benutzer-Objekte",
"Unread Messages" => "Ungelesene Nachrichten",
"Tasks" => "Aufgaben",
"Forum topics" => "Foren-Themen",
"Date of post" => "Beitrags-Datum",
"Forum replies" => "Foren-Antworten",
"MyTiki" => "Mein Tiki",
"MyInfo" => "Über mich",
"Notepad" => "Notizblock",
"MyFiles" => "MeineDateien",
"My Watches" => "Meine Beobachtungspunkte",
"Sent editions" => "Gesendete Ausgaben",
"HTML version" => "HTML Version",
"Text version" => "Text Version",
"The newsletter was sent to {\$sent} email addresses" => "Der Rundbrief wurde an {\$sent} eMail-Adressen verschickt",
"Delete errors" => "Lösche Fehler",
"Not sent" => "Nicht gesendet",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Vielen Dank für Ihr Abonnenment. Sie werden in Kürze eine eMail zur Bestätigung Ihres Abonnements erhalten. Vor einer Bestätigung Ihres Abonnements wird Ihnen kein Rundbrief zugesandt.",
"Your email address was removed from the list of subscriptors." => "Ihre Mail-Adresse wurde von der Liste der Abonnementen entfernt.",
"Subscription confirmed!" => "Abonnement bestätigt!",
"Subscribe to Newsletter" => "Rundbrief abonnieren",
"Subscribe to this Newsletter" => "Abonnieren",
"Available Newsletters" => "Verfügbare Rundbriefe",
"Notes" => "Notizen",
"Write a note" => "Notiz schreiben",
"quota" => "Quota",
"No notes yet" => "Noch keine Notizen vorhanden.",
"Merge selected notes into" => "Notizen verschmelzen mit",
"Reading note:" => "Lese Notiz:",
"List notes" => "Notizen auflisten",
"Write note" => "Notiz schreiben",
"Added:" => "Hinzugefügt:",
"Removed:" => "Entfernt:",
"Assign permissions to " => "Berechtigungen vergeben für ",
"Assign permissions to this object" => "Diesem Objekt Berechtigungen zuweisen",
"Published" => "Veröffentlicht",
"Passcode to register (not your user password)" => "Passcode zum Registrieren (nicht Ihr Benutzerpaßwort)",
"Orphan Pages" => "Verwaiste Seiten",
"Browser not supported" => "Browser wird nicht unterstützt",
"Rename" => "Umbenennen",
"Make Structure" => "Struktur erstellen",
"Slides" => "Dias",
"Discuss" => "Diskutieren",
"Attach File" => "Datei anhängen",
"1 File Attached" => "1 angehängte Datei",
"{\$atts|@count} files attached" => "{\$atts|@count} Dateien angehängt",
"(current)" => "(aktuell)",
"s=source" => "s=Quellcode",
"b=rollback" => "b=Rollback",
"Pick your avatar" => "Wählen Sie Ihren Avatar",
"User Preferences" => "Benutzer-Einstellungen",
"Your current avatar" => "Ihr momentaner Avatar",
"no avatar" => "keinen Avatar benutzen",
"reset" => "zurücksetzen",
"Pick avatar from the library" => "Wähle Avatar aus der Bibliothek",
"Pick user Avatar" => "Nutzer-Avatar auswählen",
"Hide all" => "Alles verbergen",
"icons" => "Icons",
"Show all" => "Zeige alles",
"Avatar Image" => "Avatar Bild",
"random" => "zufällig",
"Upload your own avatar" => "Eigenen Avatar hochladen",
"Insert" => "Einfügen",
"Any" => "alle",
"atts" => "Anhänge",
"List Attachments" => "Anhänge auflisten",
"Average" => "Durchschnitt",
"View Results" => "Ergebnisse anschauen",
"Vote poll" => "Wähle Umfrage",
"Other Polls" => "Andere Abstimmungen",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Hinweis: Dies ist nur eine Vorschau und wurde noch nicht gespeichert!",
"on:" => "Am:",
"Topic image" => "Themenlogo",
"Viewing blog post" => "Betrachte Blog-Eintrag",
"Return to blog" => "Zurück zum Blog",
"The original document is available at" => "Das Originaldokument ist zu finden unter",
"Print multiple pages" => "Mehrere Seiten drucken",
"Add Page" => "Seite hinzufügen",
"Selected Pages" => "Ausgewählte Seiten",
"Edit quiz" => "Bearbeite Quiz",
"Current Version" => "Aktuelle Version",
"General Options" => "Allgemeine Optionen",
"Publication Date" => "Veröffentlichungsdatum",
"at " => "am ",
"Use " => "Benutze ",
"randomly selected questions." => "zufällig ausgewählte Fragen",
"Test-time Options" => "Testzeitoptionen",
"Limit questions displayed per page to " => "Begrenze die Anzahl der Fragen pro Seite auf ",
"&nbsp question(s)." => "&nbsp Frage(n).",
"Impose a time limit of " => "Setzen Sie ein Zeitlimit von",
"Allow students to store partial results and return to quiz." => "Erlauben Sie den Teilnehmern Zwischenergebnisse zu speichern und später zum Quiz zurückzukehren.",
"Allow students to retake this quiz " => "Erlauben Sie den Teilnehmen erneut am Quiz teilzunehmen. ",
"Grading and Feedback" => "Benotung und Feedback",
"Grading method " => "Benotungsmethode ",
"Show students their score " => "Zeige den Teilnehmer ihre Auswertung",
"Show students the correct answers " => "Zeige richtige Antworten ",
"Publish statistics " => "Statistiken veröffentlichen ",
"Extra Options" => "Zusatzoptionen",
"Solicit additional questions from students" => "Bitten Sie die Teilnehmer um zusätzliche Fragen.",
"Link quiz to forum named: " => "Verlinken Sie das Quiz zum Forum: ",
"Prologue:" => "Prolog:",
"Epilogue:" => "Epilog:",
"Quiz result stats" => "Quiz-Ergebnis-Statistik",
"Time" => "Zeit",
"User answers" => "Benutzerantworten",
"Stats for quizzes" => "Statistik für die Quiz",
"taken" => "teilgenommen",
"Av score" => "durchschn. Bewertung",
"Av time" => "durchschn. Zeit",
"Clear Stats" => "Statistiken zurücksetzen",
"time taken" => "benötigte Zeit",
"Stats for this quiz Questions " => "Statistik für die Fragen in diesem Quiz ",
"Received articles" => "Empfangene Artikel",
"Edit received article" => "Empfangenen Artikel bearbeiten",
"Use Image" => "Bild benutzen",
"Image x size" => "Bildbreite",
"Image y size" => "Bildhöhe",
"Image name" => "Bildname",
"Accept Article" => "Artikel annehmen",
"Site" => "Link",
"Referer stats" => "Referer-Statistik",
"Last" => "letzte",
"Your email could not be validated; make sure you email is correct and click register below." => "Ihre E-Mail-Adresse konnte nicht verifiziert werden. Stellen Sie sicher, dass Ihre Eingabe korrekt ist und klicken Sie unten auf 'Registrieren'.",
"Register as a new user" => "Als neuer Benutzer registrieren",
"Repeat password" => "Paßwort wiederholen",
"A valid email is mandatory to register" => "Zum Registrieren ist eine gültige eMail-Adresse nötig.",
"Select your group" => "Wählen Sie Ihre Gruppe",
"Tiki site registered" => "Tiki Site registriert",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Folgende Site wurde hinzugefügt. Der Link erscheint erst nach Überprüfung des Administrators in der Liste",
"You don't have permission to use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion vorhanden.",
"Please register." => "Bitte registrieren Sie sich",
"Register this site at tikiwiki.org" => "Diese Site auf tikiwiki.org registrieren",
"Read this first!" => "Bitte lesen!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "Hier können Sie Ihre Site bei tikiwiki.org bekanntmachen. Dort wird sie in die Liste der bekannten Tiki-Sites eingetragen.",
"Registering is voluntary." => "Die Registrierung ist freiwillig.",
"Registering does not give you any benefits except one more link to your site." => "Eine Registrierung bringt keine Vorteile außer einen zusätzlichen Link auf die Site.",
"You don't get any emails, we don't sell the data about your site." => "Sie bekommen keine eMails und wir verkaufen auch keine Daten. :)",
"Registering is just for us to get an overview of Tiki's usage." => "Die Registrierung hilft uns einen kleinen Überblick über die Nutzung von Tiki zu gewinnen.",
"If your site is private or inside your intranet, you should not register!" => "Wenn ihre Tiki Site rein privat oder nur in ihrem Intranet zu erreichen ist, tragen sie ihre Site bitte nicht ein!",
"Information about your site" => "Informationen zu Ihrer Site",
"Send me my Password" => "Mein Paßwort senden",
"Remove page" => "Seite entfernen",
"Last Version" => "Neueste Version",
"You are about to remove the page" => "Sie dabei, die Seite zu entfernen",
"permanently" => "permanent",
"Remove all versions of this page" => "Alle Versionen dieser Seite entfernen",
"Rollback page" => "Rollback-Seite",
"Searched" => "Gesucht",
"Search in" => "Suche in",
"Simple search" => "Einfache Suche",
"No pages matched the search criteria" => "Keine passenden Seiten zum Suchkriterium",
"This newsletter will be sent to {\$subscribers} email addresses." => "Der Rundbrief wird an {\$subscribers} eMail-Adressen verschickt.",
"Prepare a newsletter to be sent" => "Rundbrief für Versand vorbereiten",
"Apply content template" => "Inhaltstemplate anwenden",
"Send objects" => "Objekte senden",
"Transmission results" => "Übertragungsergebnisse",
"Send Wiki Pages" => "Wiki-Seiten senden",
"Send Articles" => "Artikel senden",
"Add Article" => "Artikel hinzufügen",
"Send objects to this site" => "Objekte an diese Site senden",
"Create a sheet" => "Erstelle ein Blatt",
"Edit this sheet:" => "Bearbeite dieses Blatt:",
"There are individual permissions set for this sheet" => "Für dieses Blatt sind individuelle Berechtigungen eingerichtet",
"Class Name" => "Klassenname",
"Header Rows" => "Kopfzeilen",
"Footer Rows" => "Fusszeilen",
"Create new Sheet" => "Neues Blatt erstellen",
"You can access the sheet using the following URL" => "Sie erreichen dieses Blatt unter folgender URL",
"Available Sheets" => "Vorhandene Blätter",
"Change shoutbox general settings" => "Shoutbox-Einstellungen ändern",
"auto-link urls" => "autom. URLs in Links wandeln",
"Post or edit a message" => "Eine Nachricht posten oder bearbeiten",
"Child" => "neue Sub-Seite",
"Last edited by" => "Zuletzt bearbeitet von",
"based on work by" => "basiert auf der arbeit von",
"Contributors to this page" => "Zu dieser Seite haben beigesteuert",
"Page last modified on %0 by %1" => "Seite zuletzt geändert: %0 von %1",
"Clean" => "Löschen",
"Params" => "Parameter",
"Most viewed objects" => "Meist besuchte Objekte (gesamt)",
"Most viewed objects in the last 7 days" => "Meist besuchte Objekte der letzten 7 Tage",
"Site Stats" => "Site-Statistik",
"Started" => "Gestartet",
"Days online" => "Tage online",
"Total pageviews" => "Besuche gesamt",
"Average pageviews per day" => "Durchschn. Besuche pro Tag",
"pvs" => "Besuche",
"Best day" => "Bester Tag",
"Worst day" => "Schlechtester Tag",
"Wiki Stats" => "Wiki-Statistik",
"Size of Wiki Pages" => "Grösse der Wiki-Seiten",
"Average page length" => "Durchschn. Seitenlänge",
"Average versions per page" => "Durchschn. Versionen pro Seite",
"Visits to wiki pages" => "Besuche auf Wiki-Seiten",
"Average links per page" => "Durchschn. Links pro Seite",
"Image galleries Stats" => "Bildergalerie-Statistik",
"Average images per gallery" => "Durchschn. Bilder pro Galerie",
"Total size of images" => "Größe der Bilder gesamt",
"Average image size" => "Durchschn. Bildgröße",
"Visits to image galleries" => "Besuche in Bildergalerien",
"File galleries Stats" => "Dateiarchiv-Statistik",
"Average files per gallery" => "Durchschn. Dateien pro Archiv",
"Total size of files" => "Größe der Dateien gesamt",
"Average file size" => "Durchschn. Dategröße",
"Visits to file galleries" => "Besuche in Dateiarchiven",
"CMS Stats" => "CMS-Statistik",
"Total reads" => "Zugriffe insgesamt",
"Average reads per article" => "Durchschn. Zugriffe pro Artikel",
"Total articles size" => "Artikel Größe gesamt",
"Average article size" => "Durchschn. Artikelgröße",
"Forum Stats" => "Foren-Statistik",
"Total topics" => "Themen gesamt",
"Average topics per forums" => "Durchschn. Themen pro Forum",
"Visits to forums" => "Besuche in Foren",
"Blog Stats" => "Blog-Statistik",
"Weblogs" => "Blogs",
"Total posts" => "Posts gesamt",
"Average posts per weblog" => "Durchschn. Einträge pro Blog",
"Total size of blog posts" => "Gesamtgröße der Blog-Posts",
"Average posts size" => "Durchschn. Post Größe",
"Visits to weblogs" => "Besuche auf Blogs",
"Poll Stats" => "Abstimmungs-Statistik",
"Total votes" => "Stimmen gesamt",
"Average votes per poll" => "Durchschn. Stimmen pro Abstimmung",
"Total questions" => "Fragen gesamt",
"Average questions per FAQ" => "Durchschn. Fragen pro FAQ",
"User Stats" => "Benutzer-Statistik",
"Average bookmarks per user" => "Durchschn. Lesezeichen pro Benutzer",
"Average questions per quiz" => "Durchschn. Fragen pro Quiz",
"Quizzes taken" => "Quiz durchgeführt",
"Average quiz score" => "Durchschn. Quiz-Punktzahl",
"Average time per quiz" => "Durchschn. Zeit pro Quiz",
"Usage chart" => "Benutzungsdiagramm",
"Usage chart image" => "Grafik der Nutzungsstatistik",
"Daily Usage" => "Zugriffe / Tag",
"Stats for surveys" => "Statistik für Umfrage",
"Last taken" => "Zuletzt teilgenommen",
"Clean logs older than" => "Lösche Logs die älter sind als",
"months" => "Monate",
"Time Left" => "Zeit übrig",
"Send Answers" => "Antworten senden",
"Thank you for your submission" => "Vielen Dank für Ihren Beitrag",
"Your email was sent" => "Ihre eMail wurde verschickt",
"Theme is selected as follows" => "Die Theme wird folgendermaßen gewählt",
"If a theme is assigned to the individual object that theme is used." => "Wenn eine Theme einem individuellem Objekt zugewiesen ist, wird diese verwendet",
"If not then if a theme is assigned to the object's category that theme is used" => "Wenn nicht, dann wird die Theme, die der Kategorie des Objekts zugewiesen ist gewählt",
"If not then a theme for the section is used" => "Wenn nicht, dann wird die Theme des Bereichs gewählt",
"If none of the above was selected the user theme is used" => "Wenn nicht, dann wird die Theme des Benutzers gewählt",
"Finally if the user didn't select a theme the default theme is used" => "Trifft keiner der obenstehenden Punkte zu, dann wird die Default-Theme benutzt",
"Control by Objects" => "Kontrolle anhand der Objekte",
"Control by Sections" => "Theme Bereiche",
"Assign themes to categories" => "Kategorien Themes zuweisen",
"Assigned categories" => "Zugeordnete Kategorien",
"Theme Control Center: Objects" => "Theme Kontrollcenter: Objekte",
"Control by Categories" => "Theme Kategorien",
"Assign themes to objects" => "Objekten Themen zuordnen",
"Assigned objects" => "Zugeordnete Objekte",
"Assign themes to sections" => "Bereichen Themen zuweisen",
"Assigned sections" => "Zugeordnete Bereiche",
"Edit File:" => "Datei bearbeiten:",
"The following file was successfully uploaded" => "Folgende Datei erfolgreich hochgeladen",
"You can download this file using" => "Sie können diese Datei herunterladen mit",
"required field for podcasts" => "bei PodCasts erforderlich",
"Batch Upload Results" => "Ergebnis Batchupload",
"Upload successful!" => "Upload erfolgreich!",
"The following image was successfully uploaded" => "Das folgende Bild wurde erfolgreich hochgeladen",
"Image ID thumb" => "Bild ID (klein)",
"You can include the image in an Wiki page using" => "Sie können ein Bild auf einer Wiki-Seite einfügen, dem Sie folgendes benutzen:",
"or use filename" => "oder Dateinamen verwenden",
"Now enter the image URL" => "Nun Bild-URL eingeben",
"or upload a local image from your disk" => "oder lokales Bild von Ihrer Disk hochladen",
"Batch Upload" => "Batch hochladen",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Thumbnail (optional, überschreibt automatische Thumbnail-Erzeugung)",
"User assigned modules" => "Vom Benutzer zugewiesene Module",
"Restore defaults" => "Standardeinstellungen wiederherstellen",
"act" => "Aktion",
"Assign module" => "Modul zuweisen",
"Column" => "Spalte",
"top" => "Top",
"Folders" => "Ordner",
"Folder in" => "Ordner in",
"Remove Folder" => "Ordner löschen",
"Refresh Cache" => "Cache aktualisieren",
"Admin folders and bookmarks" => "Ordner und Lesezeichen verwalten",
"a folder" => "eines Ordners",
"a bookmark" => "eines Bookmarks",
"Send me a message" => "Schick mir eine Nachricht",
"Basic Data" => "Allgemeine Daten",
"Assign Group" => "Gruppe zuweisen",
"Change user preferences" => "Ändere Benutzereinstellungen",
"Homepage" => "Startseite",
"Users HomePage" => "Benutzer Homepage",
"Personal Wiki Page" => "Private Wiki-Seite",
"Create page" => "Seite erstellen",
"Request friendship from this user" => "Diesen Benutzer um Freundschaft bitten",
"Toggle" => "Aufklappen",
"Toggle options" => "Optionen aufklappen",
"Personal Information" => "Persönliche Informationen",
"Male" => "männlich",
"Female" => "weiblich",
"Use Google Map locator" => "Google Map Locator benutzen",
"View extra information" => "Betrachte Zusatzinformation",
"Is email public? (uses scrambling to prevent spam)" => "eMail-Adresse öffentlich? (es wird Verschlüsselung gegen Spam benutzt)",
"Unavailable - please set your e-mail below" => "Nicht verfügbar - bitte zuerst eMail-Adresse eingeben",
"Does your mail reader need a special charset" => "Benötigt der Mailreader einen speziellen Zeichensatz?",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Bei MouseOver über Benutzername: Infofenster zu Benutzer anzeigen (sofern dieser das erlaubt)",
"Notify sender when reading his mail" => "Lesebestätigung an den Autor einer Nachricht übermitteln",
"My user items" => "Meine Benutzer-Objekte",
"Account Information" => "Kontoinformationen",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Felder \"Neues Paßwort\" und \"Paßwort bestätigen\" frei lassen um das alte Paßwort zu behalten",
"Change administrative info" => "Einstellungen übernehmen",
"Account Deletion" => "Konto löschen",
"Check this box if you really want to delete your account" => "Hier aktivieren falls das Konto wirklich gelöscht werden soll",
"Delete my account" => "Mein Konto löschen",
"New task" => "Neue Aufgabe",
"Task list" => "Aufgaben-Übersicht",
"Admin mode off" => "Verwaltungsmodus aus",
"Admin mode on" => "Verwaltungsmodus an",
"Task help" => "Hilfe",
"Empty Trash" => "Papierkorb löschen",
"Received task" => "Eingegangene Aufgaben",
"You received this task, please read and execute it" => "Sie haben eine Aufgabe erhalten. Bitte lesen Sie sie und bearbeiten Sie sie.",
"Send task" => "Versende Aufgabe",
"You send this task to a other user" => "Sie versendeten diese Aufgabe an einen anderen Benutzer",
"Shared task" => "Geteilte Aufgabe",
"This task is public to a special group" => "Diese Aufgabe ist innerhalb einer Spezialgruppe öffentlich",
"Task is accepted by user and creator" => "Diese Aufgabe ist angenommen von einem Benutzer und Ersteller",
"Task is rejected by one user" => "Aufgabe von einem Benutzer abgelehnt",
"Task is not accepted by you, read the task and accept or reject it" => "Diese Aufgabewurde von Ihnen noch nicht akzeptiert, bitte lesen Sie sie und nehmen Sie sie an oder lehnen Sie sie ab.",
"Task is not accepted/rejected by other user" => "Aufgabe ist von einem anderen Benutzer nicht angenommen/abgelehnt worden",
"Admin Mode" => "Verwaltungsmodus",
"Edit task" => "Aufgabe bearbeiten",
"NOT accept" => "NICHT annehmen",
"Remove from Trash" => "Aus dem Papierkorb",
"Move into Trash" => "In den Papierkorb",
"Task saved" => "Aufgabe gespeichert",
"Edit Task" => "Aufgabe bearbeiten",
"View Task" => "Aufgabe ansehen",
"Open a new task" => "Neue Aufgabe hinzufügen",
"taskId" => "Aufgaben-Nummer",
"Task user" => "ist zu bearbeiten von",
"Only the creator can delete this task" => "Nur Ersteller kann die Aufgabe löschen",
"Use start date and time" => "Startdatum/-zeit benutzen",
"Use end date and time" => "Endedatum/-zeit benutzen",
"Open / In Process" => "Offen / in Bearbeitung",
"Waiting / Not Started" => "Wartend / noch nicht begonnen",
"Percentage completed" => "Prozent erledigt",
"Shared for Group" => "Wird geteilt von Gruppe",
"Accepted by User" => "Akzeptiert von Benutzer",
"No / Rejected" => "Nein / zurückgewiesen",
"Accepted by Creator" => "Vom Ersteller akzeptiert",
"This message will be send to users if you are makeing changes of assigned tasks" => "Diese Nachricht wird an die Benutzer verschickt, wenn Sie Anderungen an der zugewiesenen Aufgabe vornehmen.",
"Send message with changes" => "Nachricht mit Änderungen verschicken",
"Modified by" => "Geändert von",
"Marked as deleted" => "Als gelöscht markiert",
"Inform task user by email" => "Bearbeiter per eMail informieren",
"You can only view this task" => "Sie können diesen Task nur ansehen",
"Completed" => "Erledigt",
"%m/%d/%Y [%H:%M]" => "%d.%m.%Y [%H:%M]",
"No tasks entered" => "Keine Aufgaben vorhanden",
"Select One" => "Status",
"Undo Trash" => "Aus Papierkorb",
"Show:" => "Anzeigen:",
"Received" => "Erhalten",
"Submitted" => "Zugewiesen",
"Shared" => "Geteilt",
"All Shared Tasks" => "Alle geteilten Aufgaben",
"End:" => "Ende:",
"completed (100%)" => "erledigt (100%)",
"Created by:" => "Erstellt von:",
"User Watches and preferences" => "Benutzer-Beobachtungspunkte und Einstellungen",
"Report Preferences" => "Berichte Einstellungen",
"Use reports to summarise notifications about objects you are watching." => "Nutze Berichte um Benachrichtigungen in einer eMail zusammenzufassen.",
"Use reports" => "Berichte nutzen",
"Interval in witch you want to get the reports" => "Intervall in dem Ihnen Berichte gesendet werden sollen",
"Monthly" => "monatlich",
"Short report" => "Kurzer Bericht",
"Detailed report" => "Detaillierter Bericht",
"HTML-Email" => "HTML-eMail",
"Send me an email also if nothing happened" => "Schicke mir eine eMail, auch wenn nichts passiert ist",
"Reports are disabled, only standard reporting is available" => "Berichte sind ausgeschaltet, nur Standart-Reporting ist verfügbar",
"Sites you are watching" => "Seiten, die Sie beobachten",
"Add Watch" => "Beobachtungspunkt hinzufügen",
"Select event type" => "Ereignis auswählen",
"All watched events" => "Alle beobachteten Ereignisse",
"A user submits an article" => "Ein Benutzer reicht einen Artikel ein",
"A user submits a blog post" => "Ein Benutzer reicht einen Blogbeitrag ein",
"A user posts a forum thread" => "Ein Benutzer postet einen Thread im Forum",
"A user posts a forum topic" => "Ein User erstellt ein neues Thema im Forum",
"A user edited a wiki page" => "Jemand hat eine Wikiseite bearbeitet",
"A user edits an article" => "Benutzer bearbeitet einen Artikel",
"A user deletes an article" => "Benutzer löscht einen Artikel",
"May need to refresh twice to see changes" => "Evtl. zweimal Refresh nötig, damit die Änderungen sichtbar werden",
"Add top level bookmarks to menu" => "Lesezeichen der obersten Ebene ins Menü übernehmen",
"Add or edit an item" => "Eintrag hinzufügen/bearbeiten",
"New Window" => "Neues Fenster",
"replace window" => "Fenster ersetzen",
"Pos" => "Position",
"User_versions_for" => "Benutzer_Versionen_für",
"This page is being edited by" => "Diese Seite wird gerade bearbeitet von",
"Proceed at your own peril" => "Weiter auf eigene Gefahr",
"Insert Row" => "Zeile einfügen",
"Insert Column" => "Spalte einfügen",
"Remove Row" => "Zeile löschen",
"Remove Column" => "Spalte löschen",
"Merge Cells" => "Zellen verbinden",
"Restore Cells" => "Zellen teilen",
"Copy Calculation" => "Kalkulation kopieren",
"Format Cell" => "Zelle formatieren",
"expires:" => "läuft aus:",
"Banner stats" => "Banner-Statistik",
"Create new banner" => "Neues Banner erzeugen",
"Banner Information" => "Banner-Information",
"Click ratio" => "Click-Ratio",
"Hours" => "Stunden",
"Weekdays" => "Wochentage",
"mon" => "Mo",
"tue" => "Di",
"wed" => "Mi",
"thu" => "Do",
"fri" => "Fr",
"sat" => "Sa",
"sun" => "So",
"Banner raw data" => "Banner Rohdaten",
"Cached" => "gecached",
"This is a cached version of the page." => "Dies ist eine gecachte Version der Seite.",
"Click here to view the Google cache of the page instead." => "Zum Betrachten der Seite im Google-Cache hier klicken.",
"Answers" => "Antworten",
"Add Suggestion" => "Vorschlag hinzufügen",
"Forum List" => "Forenliste",
"Edit Forum" => "Forum Bearbeiten",
"Editing" => "In Bearbeitung",
"Post New" => "Neuen Beitrag erstellen",
"Summary" => "Zusammenfassung",
"Watch for replies" => "Antworten beobachten",
"Send me an e-mail when someone replies to my topic" => "Antworten per eMail an mich verschicken",
"Don't send me any e-mails" => "keine eMails an mich verschicken",
"Editing posts" => "Beiträge bearbeiten",
"for links" => "für Links",
"HTML tags are not allowed inside posts" => "HTML-Tags sind in Posts nicht erlaubt",
"Moderator Actions" => "Moderator-Aktionen",
"Move Selected Topics" => "Ausgewählte Themen verschieben",
"Unlock Selected Topics" => "Ausgewählte Themen entsperren",
"Lock Selected Topics" => "Ausgewählte Themen sperren",
"Delete Selected Topics" => "Ausgewählte Themen löschen",
"Merge" => "Zusammenführen",
"Merge Selected Topics" => "Ausgewählte Themen zusammenführen",
"Reported Messages:" => "Gemeldete Nachrichten:",
"Queued Messages:" => "Aufgelaufene Nachrichten:",
"Merge into topic" => "Zusammenführen mit Thema",
"Emot" => "Stimmung",
"pts" => "Punkte",
"Announce" => "Ankündigen",
"No topics yet" => "Noch keine Themen",
"posts in this forum" => "Beiträge in diesem Forum",
"Filter Posts" => "Beiträge filtern",
"Jump to forum" => "Sprung in Forum",
"Posts Filtering" => "Beitrags-Filter",
"Last post date" => "Beitrags-Alter",
"All posts" => "alle Beiträge",
"Last hour" => "Letzte Stunde",
"Last 24 hours" => "Letzte 24 Stunden",
"Last 48 hours" => "Letzte 48 Stunden",
"Containing posts by" => "Beiträge von",
"Me" => "meine Beiträge",
"Posts with no replies" => "ohne Antworten",
"Topic List" => "Themenliste",
"prev topic" => "vorheriges Thema",
"next topic" => "nächstes Thema",
"Show posts" => "Zeige Beiträge",
"Monitor" => "Überwachen",
"Insert New Item" => "Neuen Eintrag hinzufügen",
"Edit Fields" => "Felder bearbeiten",
"View inserted item" => "eingefügten Eintrag anschauen",
"Insert new item" => "Neuen Eintrag hinzufügen",
"View Item" => "Eintrag ansehen",
"Filter Tracker Items" => "Tracker-Einträge filtern",
"Add a Comment" => "Kommentar hinzufügen",
"Special Operations" => "Spezielle Operationen",
"close" => "schließ",
"Show All" => "Zeige alle",
"Back To Mailbox" => "Zurück zum Briefkasten",
"Full Headers" => "Alle Header",
"Normal Headers" => "Normale Header",
"Reply To All" => "allen antworten",
"Forward" => "weiterleiten",
"Select from address book" => "Aus Adressbuch auswählen",
"Use HTML mail" => "HTML-Mail verwenden",
"The following addresses are not in your address book" => "Die folgenden Adressen sind nicht in Ihrem Adressbuch",
"Add Contacts" => "Kontakte hinzufügen",
"Attachment 1" => "Anlage 1",
"Attachment 2" => "Anlage 2",
"Attachment 3" => "Anlage 3",
"Address book" => "Adressbuch",
"page id" => "Seiten-ID",
"3d browser" => "3D-Browser",
"Show/Hide Left Column" => "Linke Menüs an/aus",
"Show/Hide Right Column" => "Rechte Menüs an/aus",
"Use this thread to discuss the page:" => "Benutzen Sie diesen Thread um die Seite zu diskutieren:",
"as Creator &amp; Last Editor" => "als Ersteller &amp; letzter Bearbeiter",
"no (disabled)" => "keine (deaktiviert)",
"Save Minor Edit" => "geringfügig",
"Enable/disable Tiki features here, but configure them elsewhere" => "Tiki-Features hier ein/ausschalten, konfiguriert werden sie dann an anderen Stellen.",
"General preferences and settings" => "Allgemeine Einstellungen",
"User registration, login and authentication" => "Benutzer-Registrierung, Login und Authentifizierung",
"Wiki settings" => "Wiki-Einstellungen",
"Wiki Attachments" => "Wiki Anhänge",
"Article/CMS settings" => "Artikel Konfiguration",
"Poll comments settings" => "Einstellungen Abstimmungskommentare",
"Configuration options for all blogs on your site" => "Globale Blog-Einstellungen",
"Forums settings" => "Foreneinstellungen",
"FAQ comments settings" => "FAQ Kommentar-Einstellungen",
"Trackers settings" => "Tracker Konfiguration",
"Directory settings" => "Linkverzeichnis Konfiguration",
"Maps configuration" => "Karten Konfiguration",
"Meta Tags settings" => "Meta-Tag Konfiguration",
"Search settings" => "Suche-Einstellungen",
"Score settings" => "Bewertung Konfiguration",
"Community settings" => "Community Einstellungen",
"Calendar settings" => "Kalender Einstellungen",
"Intertiki settings" => "Intertiki Einstellungen",
"Help on \$admintitle Config" => "Hilfe für \$admintitle Konfiguration",
"Must specify actionId" => "Sie müssen eine actionID angeben",
"Category can`t be parent of itself" => "Kategorie kann nicht sich selbst übergeordnet werden.",
"Upload failed" => "Hochladen fehlgeschlagen",
"All posted" => "keine Nachricht",
"Queue anonymous posts" => "anonyme Nachrichten",
"Queue all posts" => "alle Nachrichten",
"No attachments" => "keine Anhänge",
"Everybody can attach" => "jeder darf Dateien anhängen",
"Only users with attach permission" => "nur Benutzer mit Anhangserlaubnis",
"Moderators and admin can attach" => "nur Moderatoren und Admins",
"No display" => "keine",
"Date (desc)" => "Datum (abst.)",
"Date (asc)" => "Datum (aufst.)",
"Score (desc)" => "Bewertung (abst.)",
"Replies (desc)" => "Antworten (abst.)",
"Reads (desc)" => "Zugriffe (abst.)",
"You have to provide a hotword and a URL" => "Sie müssen ein Hotword und eine URL angeben",
"Owner" => "Besitzer",
"moved %d images, %d errors occured." => " %d Bilder verschoben, %d Fehler aufgetreten.",
"a timeout occured. Hit the reload button to move the rest" => "Timeout aufgetreten. Drücken Sie den Reload-Button um den Rest zu verschieben",
"Detected, Version:" => "Gefunden, Version:",
"Not detected." => "Nicht gefunden.",
"Your admin password has been changed" => "Das Administrator-Paßwort wurde geändert",
"You cannot have a blank password" => "Sie dürfen kein leeres Passwort verwenden",
"All Fields except gdaltindex must be filled" => "Alle Felder außer gdaltindex müssen ausgefüllt werden",
"No valid gdaltindex executable" => "Kein gültiger gdaltindex ausführbar",
"You cannot mix old and new trackers" => "Sie können nicht alte und neue Tracker vermischen",
"Tag already exists" => "Marke existiert bereits",
"Tag not found" => "Marke nicht gefunden",
"Repository name can't be an empty" => "Repository-Name muß angegeben werden",
"Requested action is not supported on repository" => "Gewünschte Aktion wird von diesem Repository nicht unterstützt.",
"No repository" => "Kein Repository",
"Search is mandatory field" => "Suche ist ein erforderliches Feld",
"File not found " => "Datei nicht gefunden ",
"Requested action in not supported on repository" => "Gewünschte Aktion wird von diesem Repository nicht unterstützt.",
"Non-existent link" => "Nicht existierender Link",
"Mail-in account %s incorrect" => "Mail-in Zugang%s nicht korrekt",
"Mail-in account %s saved" => "Mail-in Zugang %s gespeichert",
"Frequency should be a positive integer!" => "Frequenz muss ein positiver Integer sein!",
"Mail-in accounts set to be checked every %s minutes" => "Mail-in Zugänge werden alle %s Minuten überprüft",
"Automatic Mail-in accounts checking disabled" => "Automatische Mail-in Zugangsüberprüfung deaktiviert",
"No menu indicated" => "Kein Menü angegeben",
"Cannot create or update module: You need to specify a name to the module" => "Kann Modul nicht erstellen oder aktualisieren: Sie müssen den Namen des Moduls angeben",
"Cannot create or update module: You cannot leave the data field empty" => "Kann Modul nicht erstellen oder aktualisieren: Sie dürfen das Datenfeld nicht leer lassen",
"No newsletter indicated" => "Kein Rundbrief angegeben",
"Error opening uploaded file" => "Fehler beim öffnen der Datei",
"A user registers" => "Ein Benutzer registriert sich",
"Any wiki page is changed" => "Eine Wiki-Seite hat sich geändert",
"Any wiki page is changed, even minor changes" => "Eine Wiki-Seite hat sich geändert, auch kleine Änderungen",
"A comment in a wiki page is posted or edited" => "Kommentar zu einer Wikiseite wird erstellt oder geändert",
"PHP error" => "PHP Fehler",
"No poll indicated" => "Keine Abstimmung angegeben",
"unsafe" => "unsicher",
"register_globals should be off by default. See the php manual for details." => "register_globals sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"safe" => "sicher",
"risky" => "gefährlich",
"off" => "aus",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid sollte ausgeschaltet sein. Details bitte der PHP Anleitung entnehmen.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir liegt vermutlich innerhalb des Tiki Verzeichnisses. Es besteht das Risiko, dass jemand dorthin Dateien läd und versucht, sie dort auszuführen.",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "Kann nicht überprüfen, ob upload_tmp_dir per Browser lesbar ist. Bitte die Webservereinstellungen überprüfen.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "Setzen der xbithack Option ist unsicher. Abhängig vom Dateihandling des Webservers und der Tiki-Einstellungen ist es unter Umständen möglich, dass jemand Scripte ins Dateiarchiv hochläd und dort ausführt.",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen kann benutzt werden um schadhafte Skripts zu uploaden. Wenn Sie die Blog Funktion nicht benutzen, kann es deaktiviert werden.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "Der Pfad des Dateiarchivs sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "Der Pfad der Bildergalerien sollte außerhalb des Tiki-Verzeichnisses liegen.",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "Die Funktion \"Vorlagen bearbeiten\" ist aktiviert. Diese Funktion sollte von keinem nicht-Administrator benutzt werden. Sie kann verwendet werden um schadhaften Code einzuschleusen.",
"Path disclosure" => "Pfadauskunft",
"Path disclosure through error message" => "Pfadauskunft durch Fehlermeldung",
"SQL injection by authenticated user" => "SQL injection durch authenifizierten Benutzer",
"SQL injection by authenticated user with special privileges" => "SQL injection durch authenifizierten Benutzer mit speziellen Einstellungen",
"SQL injection without authentication" => "SQL injection ohne Authenifizierung",
"PHP command injection by authenticated user" => "PHP command injection durch authenifizierten Benutzer",
"PHP command injection by authenticated user with special privileges" => "PHP command injection durch authenifizierten Benutzer mit speziellen Einstellungen",
"PHP command injection without authentication" => "PHP command injection ohne Authenifizierung",
"File upload" => "Datei hochgeladen",
"File is not readable. Unable to check." => "Diese Datei ist lesegeschützt und konnte nicht überprüft werden.",
"This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "Dies ist keine TikiWiki-Datei. Prüfen Sie ob diese Datei hochgeladen wurde und eine Sicherheitsgefahr darstellt.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Dies ist eine modifizierte Datei. Die Version kann nicht überprüft werden. Überprüfen Sie ob eine Sicherheitsgefahr besteht.",
"This file is from another Tikiwiki version: " => "Diese Datei stammt aus einer anderen TikiWiki-Version: ",
"You have to provide a word" => "Es muß ein Wort angegeben werden",
"Permission denied you cannot edit this page" => "Zugriff verweigert. Sie können diese Seite nicht bearbeiten",
"You must specify a page name, it will be created if it doesn't exist." => "Ein Seitenname muß angegeben werden. Die Seite wird neu angelegt, wenn sie noch nicht vorhanden ist",
"page not added (Exists)" => "Seite nicht hinzugefügt (existiert schon)",
"No survey indicated" => "Keine Umfrage angegeben",
"You don't have permission to use this feature" => "Keine Berechtigung zur Nutzung dieses Features",
"No Errors detected" => "Keine Fehler gefunden",
"Error:" => "Fejhler:",
"No tracker indicated" => "Kein Tracker angegeben",
"Group already exists" => "Gruppe existiert bereits",
"User doesn't exist" => "Benutzer existiert nicht",
"No records were found. Check the file please!" => "Keine Einträge gefunden. Bitte die Datei überprüfen!",
"User login is required" => "Benutzerlogin ist erforderlich",
"Password is required" => "Passwort ist erforderlich",
"Email is required" => "eMail ist erforderlich",
"User is duplicated" => "Benutzer ist erforderlich",
"Created account %s <%s>" => "Account %s <%s> angelegt",
"Assigned %s in group %s" => "%s zu Gruppe %s hinzugefügt",
"User %s already exists" => "Benutzer %s schon vorhanden",
"New %s created with %s %s." => "%s neu erstellt mit %s %s.",
"Impossible to create new %s with %s %s." => "Erstellen neuer %s mit %s %s nicht möglich.",
"%s %s successfully deleted." => "%s %s erfolgreich gelöscht.",
"%s %s removed from %s %s." => "%s %s wurde aus %s %s entfernt.",
"%s changed from %s to %s" => "%s geändert von %s to %s",
"Impossible to change %s from %s to %s" => "Ändern von %s von %s nach %s nicht möglich",
"%s modified successfully." => "%s erfolgreich geändert.",
"password" => "Paßwort",
"%s modification failed." => "%s Änderung fehlgeschlagen.",
"rss feed disabled" => "RSS Feed nicht aktiv",
"Tiki RSS feed for articles" => "Tiki RSS Artikel Feed",
"Last articles." => "Neueste Artikel.",
"Unknown group" => "Unbekannte Gruppe",
"Group doesn't exist" => "Gruppe existiert nicht",
"You have to indicate a group" => "Sie müssen eine Gruppe angeben",
"This group is invalid" => "Gruppe ist ungültig",
"Permission denied you cannot view backlinks for this page" => "Sie haben keine Berechtigung die Backlinks auf dieser Seite zu sehen",
"The page cannot be found" => "Die Seite kann nicht gefunden werden",
"Image Galleries Admin Panel" => "Bildergalerien-Adminseite",
"Could not read image %s." => "Konnte Bilddatei %s nicht lesen.",
"Image %s upload failed." => "Bild %s : Upload fehlgeschlagen.",
"Image %s uploaded successfully." => "Bild %s: Upload erfolgreich.",
"Image %s removed from Batch directory." => "Bild %s aus dem Batchverzeichnis gelöscht.",
"Impossible to remove image %s from Batch directory." => " Bild %s kann nicht aus dem Batchverzeichnis gelöscht werden.",
"Permission denied you cannot use the batch directory loading" => "Sie haben keine Berechtigung das Batchverzeichnis zu laden",
"Incorrect directory chosen for batch upload of images." => "Kein gültiges Bilder-Uploadverzeichnis ausgewählt.",
"Please setup that dir on " => "Bitte dieses Verzeichnis einstellen auf der ",
"Please contact the website administrator." => "Bitte kontaktieren Sie den Website Administrator.",
"Invalid directory name" => "Ungültiger Verzeichnisname",
"File Galleries Admin Panel" => "Dateiarchiv-Adminseite",
"Could not read file %s." => "Konnte Datei %s nicht lesen.",
"Could not write to file %s." => "Konnte die Datei %s nicht schreiben.",
"File %s upload failed." => "Hochladen der Datei %s fehlgeschalgen.",
"File %s removed from Batch directory." => "Datei %s wurde aus dem Batchupload-Verzeichnis gelöscht.",
"Impossible to remove file %s from Batch directory." => "Konnt Datei %s nicht aus dem Batchupload-Verzeichnis löschen.",
"Incorrect directory chosen for batch upload of files." => "Kein gültiges Datei-Uploadverzeichnis ausgewählt.",
"It isn't possible to post in any blog. You may need to create a blog first." => "Sie können in keinen Blog eintragen. Möglicherweise müssen Sie zuerst ein Blog anlegen.",
"Permission denied you cannot post" => "Zugriff verweigert. Sie können nicht posten",
"Permission denied you cannot edit this post" => "Zugriff verweigert. Sie können diesen Eintrag nicht bearbeiten",
"Top visited blogs" => "Meistbesuchte Blogs",
"Last posts" => "neueste Beiträge",
"Top active blogs" => "aktivste Blogs",
"Tiki RSS feed for blog: " => "Tiki RSS Feed von Weblog: ",
"No blogId specified" => "Keine blogId angegeben",
"Tiki RSS feed for weblogs" => "Tiki RSS Weblog Feed",
"Last posts to weblogs." => "Neueste Weblog-Einträge.",
"Nothing tagged yet" => "bisher nicht getaggt",
"Permission denied you cannot access this gallery" => "Zugriff verweigert. Sie können auf diese Galerie nicht zugreifen.",
"No gallery indicated" => "Keine Galerie angegeben",
"Permission denied you can not view this section" => "Zugriff verweigert. Sie können diesen Bereich nicht betrachten",
"Permission denied you cannot remove images from this gallery" => "Zugriff verweigert. Sie können keine Bilder aus dieser Galerie entfernen",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Neuerstellung der Thumbnails in dieser Galerie nicht gestattet",
"Permission denied you cannot rotate images in this gallery" => "Rotation der Bilder in dieser Galerie nicht gestattet",
"No image indicated" => "Kein Bild angegeben",
"Permission denied you cannot move images from this gallery" => "Zugriff verweigert. Sie können keine Bilder dieser Galerie verschieben",
"Permission denied you cannot view the calendar" => "Berechtigung für den Zugriff auf den Kalender nicht vorhanden",
"event without name" => "Ereignis ohne Name",
"Access Denied" => "Zugriff verweigert",
"Tiki RSS feed for calendars" => "Tiki RSS feed für Kalender",
"Upcoming events." => "Anstehende Termine.",
"Invalid username or activation code. Maybe this code has already been used." => "Ungültiger Benutzername oder Aktivierungscode. Möglicherweise wurde der Code bereits benutzt.",
"You can not use the same password again" => "Dasselbe Paßwort noch einmal ist nicht erlaubt",
"Top authors" => "Top Autoren",
"Message sent to" => "Nachricht gesandt an",
"You need to change chmod 'whelp' manually to 777" => "Sie müssen chmod 'whelp' manuell auf 777 setzen",
"This feature has been disabled" => "Diese Funktion wurde deaktiviert",
"Tiki RSS feed for directory sites" => "Tiki RSS Feed von Linkverzeichnis",
"Last sites." => "Neueste Sites.",
"Must enter a name to add a site. " => "Ein Seitenname muß angegeben werden. ",
"Must enter a url to add a site. " => "Eine URL muß angegeben werden. ",
"URL already added to the directory. Duplicate site? " => "URL schon im Verzeichnis vorhanden. Doppelter Eintrag? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden. ",
"Must select a category. " => "Eine Kategorie muß ausgewählt werden. ",
"Must enter a name to add a site" => "Zum Hinzufügen mu&szlig der Name der Site angegeben werden",
"Must enter a url to add a site" => "Die URL der Site muß angegeben werden",
"URL already added to the directory. Duplicate site?" => "URL im Verzeichnis schon vorhanden. Doppelter Eintrag?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "Auf die URL kann nicht zugegriffen werden: fehlerhafte URL oder die Site ist nicht verfügbar und kann daher nicht zum Linkverzeichnis hinzugefügt werden",
"Must select a category" => "Eine Kategorie muß ausgewählt werden",
"No site indicated" => "Kein Site angegeben",
"No parent specified" => "Keine Eltern angegeben",
"Article not found" => "Artikel nicht gefunden",
"Permission denied you cannot edit this article" => "Zugriff verweigert. Sie können diesen Artikel nicht bearbeiten",
"The language can't be changed as its set of translations has already this language" => "Die Sprache kann nicht geändert werden.",
"You do not have permissions to edit banners" => "Sie haben keine Berechtigung, Banner zu bearbeiten",
"Banner not found" => "Banner nicht gefunden",
"You do not have permission to edit this banner" => "Sie haben keine Berechtigung dieses Banner zu bearbeiten",
"Permission denied you cannot create or edit blogs" => "Zugriff verweigert. Sie können Blogs nicht erstellen oder bearbeiten",
"Permission denied you cannot edit this blog" => "Zugriff verweigert. Sie können dieses Blog nicht bearbeiten",
"You do not have permission to write the style sheet" => "Berechtigung zum Verändern des Stylesheets nicht vorhanden",
"Invalid request to edit an image" => "Ungültige Anforderung zur Bearbeitung eines Bildes",
"Permission denied you cannot edit images" => "Zugriff verweigert. Sie können keine Bilder bearbeiten",
"Permission denied you can edit images but not in this gallery" => "Zugriff verweigert. Sie können Bilder bearbeiten, jedoch nicht in dieser Galerie",
"Failed to edit the image" => "Bearbeitung des Bildes fehlgeschlagen",
"Permission denied to use this feature" => "Keine Berechtigung zur Nutzung dieser Funktion",
"Shortname must be 2 Characters" => "Kurzname muß zwei Zeichen lang sein",
"You must provide a longname" => "Langer Name muß angegeben werden",
"Language created" => "Sprache erstellt",
"No content id indicated" => "Keine Inhalts-ID angegeben",
"No question indicated" => "Keine Frage angegeben",
"No quiz indicated" => "Kein Quiz angegeben",
"No structure indicated" => "Keine Struktur angegeben",
"Invalid structure_id or page_ref_id" => "Ungültige Structure_id oder page_ref_id",
"Permission denied you cannot send submissions" => "Zugriff verweigert. Sie können Einreichungen nicht senden",
"Permission denied you cannot edit submissions" => "Zugriff verweigert. Sie können Einreichungen nicht bearbeiten",
"You have to create a topic first" => "Sie müssen zuerst ein Thema erstellen",
"You do not have permission to do that" => "Sie haben nicht die Berechtigung, das zu tun",
"You do not have permission to write the template:" => "Sie haben nicht die Berechtigung dieses Template zu beschreiben:",
"You do not have permission to read the template" => "Sie haben keine Berechtigung, die Vorlage zu lesen",
"No topic id specified" => "Keine Themen-ID angegeben",
"Invalid topic id specified" => "Ungültige Themen-ID angegeben",
"No object indicated" => "Kein Objekt angegeben",
"No type indicated" => "Kein Typ angegeben",
"Not enable for this type of object" => "Nicht aktiviert für diesen Objekttypen",
"page imported" => "Seite importiert",
"created from import" => "aus Import erstellt",
"Can't import remote HTML page" => "Kann externe HTML-Seite nicht importieren",
"The SandBox is disabled" => "Die SandBox ist deaktiviert",
"Cannot edit page because it is locked" => "Seite kann wegen Sperrung nicht bearbeitet werden",
"No questions group indicated" => "Keine Fragengruppe angegeben",
"Permission denied you cannot edit this file" => "Berechtigung zum Bearbeiten dieser Datei nicht vorhanden",
"Permission denied you cannot remove files from this gallery" => "Zugriff Verweigert. Sie können keine Dateien aus dieser Galerie entfernen",
"Top visited file galleries" => "Meistbesuchte Dateiarchive",
"Most downloaded files" => "Häufigste Downloads",
"Last files" => "Neueste Dateien",
"Tiki RSS feed for file galleries" => "Tiki RSS Dateiarchiv Feed",
"Last files uploaded to the file galleries." => "Neueste Dateien in den Dateiarchiven.",
"No galleryId specified" => "Keine galleryId angegeben.",
"Tiki RSS feed for the file gallery: " => "Tiki RSS Feed von Dateiarchiv: ",
"No forum indicated" => "Kein Forum angegeben",
"Last forum topics" => "Neueste Forenthemen",
"Top topics" => "Top Themen",
"Forum posts" => "Zahl der Einträge",
"No forumId specified" => "Keine forumId angegeben",
"Tiki RSS feed for forum: " => "Tiki RSS Feed von Forum: ",
"Tiki RSS feed for forums" => "Tiki RSS Foren Feed",
"Last topics in forums." => "Neueste Forenthemen.",
"Accepted friendship request from %s" => "Angenommene Freundschaftsanfrage von %s",
"Refused friendship request from %s" => "Abgelehnte Freundschaftsanfrage von %s",
"Broke friendship with %s" => "Freundschaft mit %s beenden",
"I have broken our friendship!" => "Ich habe unsere Freundschaft beendet!",
"You must be logged in to use this feature" => "Sie müssen sich einloggen um diese Funktion nutzen zu können",
"Friendship request sent to %s" => "Freundschaftsanfrage gesendet an %s",
"You're already friend of %s" => "Du bist bereits ein Freund von %s",
"I have accepted your friendship request!" => "Ich habe deine Freundschaftsanfrage angenommen",
"first uploaded image" => "erstes hochgeladenes Bild",
"last uploaded image" => "neustes Bild",
"first image" => "erstes Bild",
"last image" => "neuestes Bild",
"random image" => "zufälliges Bild",
"Permission denied you cannot create galleries and so you cant edit them" => "Zugriff verweigert. Sie können Galerien nicht erzeugen, also auch nicht bearbeiten",
"Permission denied you cannot edit this gallery" => "Zugriff verweigert. Sie können diese Galerie nicht bearbeiten",
"Permission denied you cannot remove this gallery" => "Zugriff verweigert. Sie können diese Galerie nicht löschen",
"Permission denied you cannot make the map of this gallery" => "Keine Berechtigung; Sie können in dieser Galerie keine Karte erstellen",
"Top images" => "Top Bilder",
"Last images" => "Neueste Bilder",
"Back to preferences" => "Zurück zu Präferenzen",
"No valid renderer found. GD or PDFLib required." => "Kein gültiger Renderer gefunden. GD or PDFLib erforderlich.",
"No sheet specified." => "Kein Blatt angegeben.",
"You must select a renderer." => "Sie müssen einen Renderer angeben.",
"Invalid Series for current graphic." => "Ungültige Serie für den aktuellen Graphen",
"Tiki RSS feed for image galleries" => "Tiki RSS Feed von Bildergalerien",
"Last images uploaded to the image galleries." => "Neueste Bilder, die in die Bildergalerie eingefügt wurden.",
"Tiki RSS feed for the image gallery: " => "Tiki RSS Feed von Bildergalerie: ",
"overwriting old page" => "überschreibe alte Seite",
"updated from structured text import" => "aktualisiert durch strukturierten Textimport",
"page created" => "Seite erstellt",
"created from structured text import" => "erstellt durch strukturierten Textimport",
"No name indicated for wiki page" => "Kein Name für die Wiki-Seite angegeben",
"No repository given" => "Kein Repository angegeben",
"Error writing in the databse: \$query" => "Fehler beim Beschreiben der Datenbank: \$query",
"Permission denied. You cannot view pages like this page" => "Zugriff verweigert. Sie können Seiten wie diese nicht ansehen",
"Permission denied you cannot remove articles" => "Zugriff verweigert. Sie können Artikel nicht entfernen",
"Permission denied you cannot remove banners" => "Zugriff verweigert. Sie können keine Banner entfernen",
"Permission denied you cannot remove this blog" => "Zugriff verweigert. Sie können dieses Blog nicht entfernen",
"Non-existent gallery" => "Nicht existierende Galerie",
"Permission denied you can upload files but not to this file gallery" => "Zugriff verweigert. Sie können Dateien hochladen, jedoch nicht in dieses Archiv",
"Could not upload the file" => "Konntr Datei nicht hochladen",
"Could not find the file requested" => "Konnte die angegebene Datei nicht finden",
"File update was successful" => "Datei erfolgreich aktualisiert",
"Permission denied you can't upload files so you can't edit them" => "Berechtigung zum Hochladen und damit auch zum Ändern nicht vorhanden",
"This gallery does not exist" => "Diese Galerie existiertt nicht",
"You cannot admin blogs" => "Sie können Blogs nicht administrieren",
"Permission denied you cannot remove submissions" => "Zugriff verweigert. Sie können Einreichungen nicht entfernen",
"Permission denied you cannot approve submissions" => "Zugriff verweigert. Sie können Einreichungen nicht freigeben",
"You have to enable cookies to be able to login to this site" => "Aktivieren Sie 'Cookies akzeptieren' um sich einloggen zu können",
"Unable to contact remote server." => "Kann den Remote Server nicht erreichen.",
"XMLRPC Error: " => "XMLRPC Fehler: ",
"Invalid password" => "Ungültiges Passwort",
"Account disabled" => "Account deaktiviert",
"You must use the right case for your user name" => "Sie müssen die Groß-und Kleinschreibung beachten",
"Sorry, you can't use this feature." => "Keine Berechtigung zur Nutzung dieser Funktion",
"invalid mapfile name" => "ungültiger Mapfile Name",
"You do not have permissions to view the maps" => "Keine Berechtigung zum Betrachten von Karten",
"Maps feature is not correctly setup : Maps path is missing." => "Kartenfunktion ist nicht korrekt eingerichtet : Kartenpfad fehlt.",
"mapfile name incorrect" => "Name der Kartendatei nicht korrekt",
"This mapfile already exists" => "Diese Kartendatei existiert schon",
"You do not have permission to write to the mapfile" => "Keine Berechtigung zum Schreiben von Kartendateien",
"You do not have permission to delete the mapfile" => "Keine Berechtigung zum Löschen der Kartendatei",
"I could not make a copy" => "Es konnte keine Kopie erstellt werden",
"You do not have permission to read the mapfile" => "Keine Berechtigung zum Lesen der Kartendatei",
"You dont have permission to do that" => "Keine Berechtigung vorhanden",
"Tiki RSS feed for maps" => "Tiki RSS Karten Feed",
"List of maps available." => "Neueste Karten.",
"You do not have permissions to view the layers" => "Keine Berechtigung zum Betrachten der Layer",
"You do not have permissions to delete a file" => "Keine Berechtigung zum Löschen einer Datei",
"File not found" => "Datei nicht gefunden",
"You do not have permissions to create a directory" => "Keine Berechtigung zum Erstellen eines Verzeichnisses",
"The Directory is not empty" => "Das Verzeichnis ist nicht leer",
"You do not have permissions to delete a directory" => "Keine Berechtigung zum Löschen eines Verzeichnisses",
"You do not have permissions to create an index file" => "Keine Berechtigung zum Anlegen einer Indexdatei",
"Invalid file name" => "Ungültiger Dateiname",
"Invalid files to index" => "Üngültige Seiten, die indiziert werden sollen",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Ich weiß nich wo der gdaltindex ist. Stellen Sie die Kartenfunktion korrekt ein.",
"I could not create the index file" => "Indexdatei konnte nicht angelegt werden",
"Must be logged to use this feature" => "Für diese Funktion müssen Sie angemeldet sein",
"Welcome at Hawiki" => "Willkommen bei Hawiki",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Diese TikiWiki-Seite ist für viele mobile Treiber zugänglich, z.Bsp.: WAP phones, PDA's, i-mode Treiber und viele mehr.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Sie können diese Site mit Ihrem mobilen Endgerät besuchen unter folgender URL:",
"About" => "Über",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Sie müssen Setup starten:<br />./setup.sh \$APACHEUSER all<br />Übliche Apache Benutzer sind www-data, apache oder nobody",
"Your PHP installation does not have zlib enabled." => "Die PHP Installation enthält keine zlib Bibliothek.",
"You must log in to use this feature" => "Sie müssen sich anmelden, um diese Funktion zu nutzen",
"You do not have permission to view other users data" => "Sie haben keine Berechtigung, die Daten anderer Benutzer einzusehen",
"You must be logged in to subscribe to newsletters" => "Sie müssen eingeloggt sein, um Rundbriefe abonnieren zu können",
"No note indicated" => "Keine Notiz angegeben",
"File is too big" => "Datei ist zu groß",
"No item indicated" => "Kein Objekt angegeben",
"created from notepad" => "Aus dem Notitzblock erstellt",
"Page already exists" => "Seite existiert schon",
"Not enough information to display this page" => "Nicht genug Informationen, um diese Seite anzuzeigen",
"Permission denied you cannot browse this page history" => "Zugriff verweigert. Sie können diese Seitenhistorie nicht ansehen",
"Permission denied you cannot view the source of this page" => "Keine Berechtigung; Sie können den Quellcode dieser Site nicht sehen",
"No article indicated" => "Kein Artikel angegeben",
"Article is not published yet" => "Artikel ist noch nicht veröffentlicht",
"No post indicated" => "Kein Posting angegeben",
"Blog not found" => "Blog nicht gefunden",
"No pages indicated" => "Keine Seiten angegeben",
"Pageviews" => "Seitenansichten",
"You don't have permission to edit quizzes." => "Sie haben nicht die Berechtigung Quizze zu bearbeiten",
"No result indicated" => "Kein Ergebnis angegeben",
"This is not a valid mail adress" => "Dies ist keine gültige E-Mail-Adresse",
"The passwords don't match" => "Die Passwörter stimmen nicht überein",
"Username cannot contain uppercase letters" => "Benutzername darf keine Großbuchstaben enthalten",
"Username must be at least" => "Benutzername muss mindestens",
"Username cannot contain more than" => "Benutzername darf nicht länger sein als",
"characters" => "Zeichen",
"Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Bitte geben Sie einen gültigen %s ein.  Keine Leerzeichen, mehr als %d Zeichen und enthält %s",
"Invalid or unknown username" => "Ungültiger oder unbekannter Benutzername",
"Unable to send mail. User has not configured email" => "Mail kann nicht versendet werden. Benutzer hat keine E-mail konfiguriert.",
"to the registered email address for" => "an die registrierte eMail-Adresse für",
"last version" => "neueste Version",
"Permission denied you cannot remove versions from this page" => "Zugriff verweigert. Sie können Versionen dieser Seite nicht entfernen",
"Permission denied you cannot rename this page" => "Keine Berechtigung; Sie können diese Seite nicht umbenennen",
"Cannot rename page because the new name begins with reserved prefix" => "Sie können diese Seite nicht umbenennen, weil der neue Name mit einem reservierten Präfix beginnt",
"Cannot rename page maybe new page already exists" => "Kann die Seite nicht umbenennen, evtl. existiert der Name schon",
"Non-existent version" => "Nicht existierende Version",
"Permission denied you cannot rollback this page" => "Zugriff verweigert. Rollback für diese Seite nicht erlaubt.",
"Error Message" => "Fehlermeldung",
"Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Fehlermeldung: \$errmsg",
"No newsletters available." => "Keine Rundbriefe vorhanden.",
"successfully sent" => "erfolgreich verschickt",
"not sent" => "nicht verschickt",
"Error: " => "Fehler: ",
"Permission denied you cannot remove this sheet" => "Keine Berechtigung; Sie können dieses Blatt nicht verschieben",
"Page must be defined inside a structure to use this feature" => "Für diese Funktion muß die Seite innerhalb einer Struktur angelegt werden",
"You cannot take this quiz twice" => "Sie können dieses Quiz nicht zweimal durchführen",
"Quiz time limit exceeded quiz cannot be computed" => "Quizzeit überschritten. Quiz kann nicht gewertet werden",
"You cannot take this survey twice" => "Sie können nicht zweimal an dieser Umfrage teilnehmen",
"Please create a category first" => "Bitte erst eine Kategorie anlegen",
"empty" => "leer",
"No trackerId specified" => "Keine trackerId angegeben",
"Tiki RSS feed for individual trackers: " => "Tiki RSS Feed von Tracker: ",
"No permission to upload zipped file packages" => "Berechtigung zum Hochladen gepackter Dateien nicht vorhanden",
"Error processing zipped image package" => "Fehler beim Verarbeiten der gepackten Bilddateien",
"No permission to upload zipped image packages" => "Berechtigung zum Hochladen gepackter Bildarchive nicht vorhanden",
"The uploaded file ist not recognized as a image" => "Die hochgeladene Datei konnte nicht als Bild identifiziert werden",
"Permission denied you cannot upload images" => "Zugriff verweigert. Sie können keine Bilder hochladen",
"Permission denied you can upload images but not to this gallery" => "Zugriff verweigert. Sie können Bilder hochladen, aber nicht in diese Galerie",
"Cannot get image from URL" => "Kann Bild nicht von URL beziehen",
"That is not an image (or you have php < 4.0.5)" => "Dies ist kein Bild (Oder die PHP Version ist kleiner als 4.0.5)",
"Usage" => "Zugriffe",
"No url indicated" => "Keine URL angegeben",
"Unknown user" => "Unbekannter Benutzer",
"You are not logged in and no user indicated" => "Sie sind nicht eingeloggt und es wurde auch kein Benutzer angegeben",
"The user has chosen to make his information private" => "Der Benutzer hat diese Information als privat deklariert",
"Email is set to %s" => "eMail-Adresse ist jetzt %s",
"The passwords did not match" => "Die Paßwörter stimmen nicht überein",
"no" => "nein",
"unicode" => "Unicode",
"was moved into trash" => "in den Papierkorb verschoben",
"trashed by" => "gelöscht von",
"open / in process" => "offen / in Bearbeitung",
"Public for group" => "öffentlich für die Gruppe",
"Rights by creator" => "Rechte beim Ersteller",
"END" => "ENDE",
"Percentage" => "Prozent",
"Task accepted by creator" => "Aufgabe durch den Ersteller akzeptiert",
"Task accepted by task user" => "Aufgabe durch den Aufgabenbenutzer akzeptiert",
"Task NOT accepted by creator" => "Aufgabe vom Ersteller NICHT akzeptiert",
"Task NOT accepted by task user" => "Aufgabe vom Aufgabenbenutzer NICHT akzeptiert",
"Sorry this task does not exist or you have no rights to view this task" => "Sorry, diese Aufgabe existiert nicht oder Sie haben nicht die Berechtigung diese Aufgabe zu sehen",
"Task entries:" => "Aufgabeneingänge:",
"Changes:" => "Änderungen:",
"Info message" => "Benachrichtigung",
"NEW Task" => "Neue Aufgabe",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Sorry, Sie dürfen keine Aufgaben an andere User verschicken oder der User darf keine Aufgaben empfangen!",
"Changes on Task" => "Änderungen an Aufgabe",
"You received a new task" => "Neue Aufgabe erhalten",
"The priority is" => "Die Priorität ist",
"very low" => "sehr niedrig",
"low" => "niedrig",
"high" => "hoch",
"very high" => "sehr hoch",
"You've to start your work at least on" => "Sie müssen mit Ihrer Aufgabe spätestens beginnen am",
"You've to finish your work on" => "Sie müssen Ihre Aufgabe beenden spätestens am ",
"Login and click the link below" => "Loggen Sie sich ein und klicken Sie untenstehenden Link an",
"Please read the task and work on it!" => "Bitte lesen Sie die Aufgabe und bearbeiten Sie sie!",
"Sorry, there was an error while trying to write data into the database" => "Sorry, es ist ein Fehler aufgetreten beim Versuch die Daten in die Datenbank zu schrieben.",
"A new page is created in a language" => "Eine neue Seite (Übersetzung) wird erstellt",
"Cannot upload this file not enough quota" => "Hochladen würde Quota überschreiten",
"No user indicated" => "Kein Benutzer angegeben",
"Non-existent user" => "Nicht existierender Benutzer",
"No banner indicated" => "Kein Banner angegeben",
"No blog indicated" => "Kein Blog angegeben",
"Permission denied you cannot remove the post" => "Zugriff verweigert. Sie können den Eintrag nicht entfernen",
"No cache information available" => "Keine Cache-Informationen verfügbar",
"No faq indicated" => "Keine FAQ angegeben",
"You are not permitted to remove someone else\\'s post!" => "Keine Erlaubnis zum Löschen von Beiträgen anderer Benutzer!",
"No thread indicated" => "Kein Thread angegeben",
"A SheetId is required." => "Eine SheetId muß angegeben werden.",
"That tracker don't use extras." => "Dieser Tracker benutzt keine Extras.",
"Aborted" => "Abgebrochen",
"Top pages" => "Top-Seiten",
"Last pages" => "Letzte Seiten",
"Tiki RSS feed for the wiki pages" => "Tiki RSS Wiki Feed",
"Last modifications to the Wiki." => "Zuletzt geänderte Wikiseiten.",
"###end###"=>"###end###");
