<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"Batch upload (CSV file<a {popup text='login,password,email'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}help" => "Subida en lote (archivo CSV<a {popup text='usuario,clave,correo'}><img src=\"img/icons/help.gif\" border=\"0\" height=\"16\" width=\"16\" alt='{tr}ayuda",
"slideshow_p" => "slideshow_p",
"slideshow backward" => "presentación atras",
"slideshow_n" => "slideshow_n",
"Project Object Created Successfully" => "Objeto de Proyecto Creado Exitosamente",
"Project Name:" => "Nombre de Proyecto:",
"Project Description:" => "Descripción del Proyecto:",
"Project Active" => "Proyecto Activo",
"Current Objects:" => "Objetos Actuales:",
"Add a File Gallery" => "Añadir Galería de Archivos",
"Project Admin" => "Admin del Proyecto",
"Project Members" => "Miembros del Proyecto",
"Not Set" => "No configurado",
"Number Members" => "Número de Miembros",
"Number Admins" => "Número de Admins",
"No projects found" => "No se encontraron proyectos",
"Project Created:" => "Proyecto Creado:",
"Project Info" => "Proyecto Info",
"Project Admins:" => "Admins Proyecto:",
"Project Members:" => "Miembros Proyecto:",
"Edit Project" => "Editar Proyecto",
"Add Blog" => "Añadir Blog",
"Add Articles" => "Añadir Artículos",
"Add Calendar" => "Añadir Calendario",
"Add FAQ" => "Añadir FAQ",
"Add File Gallery" => "Añadir Galería de Archivos",
"Add Forum" => "Añadir Foro",
"Add Image Gallery" => "Añadir Galería de Imágenes",
"Add Newsletter" => "Añadir Boletín",
"Add URL" => "Añadir URL",
"Project Registration" => "Registración de Proyecto",
"Your project was successfully submitted.  It may be subject\nto approval. Once available, you can create/link your project objects\nto your project page." => "Su proyecto fue enviado exitosamente. Puede ser sujeto a aprobación.\n Una vez disponible, puede crear/enlazar sus objetos de proyecto\na su página de proyecto.",
"List all projects" => "Listar todos los proyectos",
"Take care when you register your project, the project name\ncannot be changed afterwards. Please also provide an accurate \nproject description. If you havent worked out these details please\ndo so before your register the project." => "Take care when you register your project, the project name\ncannot be changed afterwards. Please also provide an accurate \nproject description. If you havent worked out these details please\ndo so before your register the project.",
"Please choose your project categories carefully. You can\nhowever change this later on your project admin panel." => "Please choose your project categories carefully. You can\nhowever change this later on your project admin panel.",
"All project names are converted to lowercase." => "Todos los nombres de proyecto son convertidos a minúsculas.",
"Not rated yet" => "No calificado aún",
"Jukebox preference" => "Preferencias de Jukebox",
"This is not a Tikiwiki File. Check if this file was uploaded and if it is dangerous." => "Este no es un archivo de Tikiwiki. Chequee si este archivo fue subido y es peligroso.",
"This file is modified." => "Este archivo fue modificado.",
"Removed %s from group %s" => "Borrado %s de grupo %s",
"The passwords didn't match" => "Las contraseñas no coinciden",
"Invalid username or activation code" => "Nombre de usuario o código de activacion no válidos",
"Tiki RSS feed for the tracker: " => "Tiki RSS feed para el tracker: ",
"Error: No" => "Error: No",
"HomeworkMenu" => "HomeworkMenu",
"log in" => "log in",
"Jukebox" => "Jukebox",
"TikiTabs" => "TikiTabs",
"tbheight" => "tbheight",
"creates an editable drawing named foo" => "creates an editable drawing named foo",
"Ins" => "Ins",
"You do not have permission to use this feature." => "No tiene permiso para usar esta característica.",
" line " => " línea ",
"permission." => "permiso.",
"Error: Invalid" => "Error: No válido ",
"Error: Call to hw_page_fetch_by_id failed!" => "Error: Falló invocación de hw_page_fetch_by_id!",
"no description" => "sin descripción",
"Updated" => "Actualizado",
"Textarea options: options,width,height,max with option is 1 or 0, rest is size indicated in chars and lines, max is the maximum number of characters that can be saved." => "Opciones de área de texto: opciones,ancho,alto,max con opcion valiendo 0 o 1, el resto es tamaño indicado en caracteres y líneas, max es el máximo número de caracteres que será guardado",
"Image options: xSize,ySize indicated in pixels." => "Opciones de imagen: Tamx,Tamy indicados en pixels.",
"Category options: parentId" => "Opciones de Categoría: parentId",
"Item Link options: trackerId,fieldId links to item from trackerId which fieldId matches the content of that field." => "Opciones de enlace a ítem: trackerId,campoId enlaza a ítem desde trackerId donde campoId corresponde con el contenido de ese campo.",
"Items list options: trackerId,fieldIdThere, fieldIdHere, displayFieldIdThere displays the list of displayFieldIdThere from item in tracker trackerId where fieldIdThere matches fieldIdHere." => "Opciones de lista de ítems: trackerId,CampoIdAlla, CampoIdAca, MostrarCampoIdAlla muestra la lista de MosrtarCampoIdAlla desde ítem en el tracker trackerId donde CampoIdAlla corresponde con CampoIdAca.",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} Inserta artículos en una página wiki",
"num is optional and is the order number of the attachment in the list. If not provided, a list of all attachments is displayed.  Inline makes the comment be the text of the link." => "num es opcional y es el numero ordinal del archivo asociado en la lista. Si no es dado, una lista de todos los archivos asociados es desplegada. Inline hace el comentario que sea el texto del enlace.",
"You need to supply information for : " => "Debe suplir la información para : ",
"missing tracker ID for plugin TRACKER" => "ID de tracker faltante para el plugin TRACKER",
"Tip: hold down CTRL to select multiple categories" => "Consejo: mantenga apretado CTRL para elegir múltiple categorías",
"Tip: uncheck the above checkbox to uncategorize this page/object" => "Consejo: deseleccione el checkbox de arriba para descategorizar esta página/objeto",
"someone coming from IP Address" => "alguien viniendo desde direccion IP",
"requested a reminder of the password for the" => "pidió un recordatorio de la contraseña para",
"requested a reset of the password for the" => "pidió una reinicializacion de la clave para el",
"The old password remains active until you activate the new one by following this link:" => "La vieja clave se mantiene activa hasta que active la nueva siguiendo este enlace:",
"This is only a temporary password. After you logged in with it, you will get to the 'change password' dialog." => "Esta es sólo una contraseña temporaral. Después de entrar con ella, obtendrá el diálogo de 'cambiar contraseña'.",
"Information:" => "Información:",
"New blog post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nuevo post en blog: {\$mail_title} por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"If you people want to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Si sus conocidos quieren ser capaces de responderle a usted, tiene que marcar <a href='tiki-user_preferences.php'>Permitir mensajes desde otros usuarios</a>",
"reply to" => "responder a",
"List Courses" => "Listar Cursos",
"Please" => "Por favor",
"to access full functionalities" => "para acceder a funcionalidades completas",
"Site Calendar" => "Calendario del Sitio",
"Friendship network" => "Círculo de Amistad",
"Allow permissions for friendship network" => "Permitir Permisos para círculos de amistad",
"Max friendship distance" => "Max distancia de amistad",
"Use Quote plugin for quoting" => "Use el plugin Quote para citar",
"Jukebox settings" => "Configuracion Jukebox",
"Jukebox tracks location" => "Jukebox ubicación de pistas",
"Jukebox features" => "Jukebox funciones",
"Default ordering for album listing" => "Orden por defecto para listado de álbumes",
"Album title (asc)" => "Título de Album (asc)",
"Number of tracks (desc)" => "Número de pistas (desc)",
"In album listing show user as" => "En listado de albums mostrar usuario como",
"Jukebox listing configuration (when listing available albums)" => "Configuración de listados del Jukebox (cuando se listen albums disponibles)",
"Tracks" => "Pistas",
"Genre" => "Género",
"Hide disabled sections" => "Ocultar secciones desactivadas",
"Show disabled sections" => "Mostrar secciones desactivadas",
"Create a group for each user <br />(with the same\nname as the user)" => "Crear un grupo por cada usuario <br />(con el mismo\nnombre que el usuario)",
"Remind passwords by email" => "Recordar passwords por correo",
"Users choose project categories" => "Usuarios pueden elegir categorías de proyecto",
"Prefix for Project Admin groups" => "Prefijo para grupos de Admin de Proyecto",
"Prefix for Project groups" => "Prefijo para grupos de Proyecto",
"Prefix for Wiki project home page" => "Prefijo para página inicio de proyecto Wiki",
"Prefix for File Galleries" => "Prefijo para Galería de Archivo",
"Project Admins group template" => "Plantilla de grupo Admins de Proyecto",
"Create New Group" => "Crear Nuevo GrupoCreate New Group",
"Project Members group template" => "Plantilla de grupo de Miembros de Proyecto",
"Like pages" => "Páginas similares",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Use {literal}{{/literal}ed id=nombre} o {literal}{{/literal}ted id=nombre} para insertar zonas dinámicas",
"Category: wiki, tracker, etc." => "Categoría: wiki, tracker, etc.",
"Field is public? (for use thru trackerlist plugin)" => "¿Campo es público? (para usar con el plugin trackerlist)",
"Field is hidden? (visible by admin only)" => "Campo es oculto? (visible solo por admin)",
"Added users" => "Usuarios añadidos",
"Note: if you want to use images please save the post first and you\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\nor use the image URL to include images using the WYSIWYG editor" => "Nota: si no quiere usar imágenes por favor salve el post primero y\npodrá editar editar/poner imágenes. Use el  código &lt;img&gt; para incluir imágenes subidas en el editor del area de texto\n o use la URL de la imagen para incluirla usando el editor WYSIWYG",
"search category" => "buscar categoría",
"deep" => "profundidad",
"Textheight" => "Altura de texto",
"Height of top Heading" => "Altura del encabezado superior",
"Height of mid Heading" => "Altura del encabezado medio",
"Height of inner Heading" => "Altura del encabezado interno",
"Automatic Page Breaks" => "Saltos automáticos de página",
"For more information, please see <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>" => "Para mas información, vea <a href=\"{\$helpurl}WikiSyntax\">WikiSyntax</a>",
"Emphasis" => "Énfasis",
"italics" => "itálicas",
"both" => "ambos",
"use ...page... to separate pages" => "use ...page... para separar páginas",
"make_headings" => "hace títulos",
"underlines text" => "subraya texto",
"Simple box" => "Caja simple",
"Will display using the indicated HTML color" => "Se mostrará usando el color HTML indicado",
"Will display the text centered" => "Muestra el texto centrado",
"Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done)." => "Muestra código/texto preformateado; no se hace procesamiento Wiki dentro de esas secciones (como con np) y el espacioado es fijo (no se hace justificacion de palabras).",
"Insert Module Output" => "Inserta salida del Módulo",
"{literal}{MODULE(module=>some_module)}text{MODULE}{/literal}  can be used to insert the output of module \"some_module\" into your Wiki page. See <a href=\"{\$helpurl}PluginModule\">PluginModule</a> for more information. " => "{literal}{MODULE(module=>algún_módulo)}text{MODULE}{/literal}  puede ser usado para insertar la salida del módulo \"algún_módulo\" dentro de su página Wiki. Vea <a href=\"{\$helpurl}PluginModule\">PluginModule</a> para más información. ",
"Rendering Program Code" => "Muestra Código de Programa",
"{literal}{CODE()}some code{CODE} {/literal} will render \"some code\" as program code. This plugin has other options; see <a href=\"{\$helpurl}PluginCode\">PluginCode</a>." => "{literal}{CODE()}algún código{CODE} {/literal} va a mostrar \"algún código\" como código de programa. Este plugin tiene otras opciones; vea <a href=\"{\$helpurl}PluginCode\">PluginCode</a>.",
"Activs" => "Activos",
"time" => "tiempo",
"Wiki quick help" => "Ayuda rápida Wiki",
"Quicklinks" => "Enlaces rápidos",
"Last Edit:" => "Ultima Edicion:",
"Grade Paper" => "Trabajo de Grado",
"Due Date:" => "Fecha de Entrega:",
"Comparing versions" => "Comparando versiones",
"Actual_version" => "Versión actual",
"Diff to version" => "Diff a versión",
"Assignments List" => "Lista de deberes",
"My Work" => "Mi trabajo",
"Assignment" => "Tarea",
"Due Date" => "Fecha de entrega",
"Grading Queue " => "Cola de Graduación ",
"paper" => "trabajo",
"papers" => "trabajos",
"Edit Assignment" => "Editar Tarea",
"list assignments" => "listar tareas",
"Due" => "Vencimiento",
"create assignment" => "crear asignación",
"topics in this forum" => "tema de este foro",
"The passwords dont match" => "Las contraseñas no coinciden",
"You do not have permission to write the template" => "No tiene permiso para escribir la plantilla",
"Go to your <a href=\"tiki-friends.php\">friendship network</a> to accept or refuse this request" => "Vaya a su <a href=\"tiki-friends.php\">círculo de amistades</a> para aceptar o rehusar este pedido",
"You must be a student to edit homework pages." => "Debe ser estudiante para editar páginas de deberes.",
"No assignment indicated" => "No se indicó tarea",
"Error: Invalid id for hw_pages table." => "Error: id no válido para tabla hw_pages.",
"Error: This page is being edited by another user." => "Error: Esta página esta siendo editada por otro usuario.",
"Permission denied: Students may only view or edit their own work." => "Permiso denegado: Los estudiantes pueden solo ver o editar su propio trabajo.",
"Error: Assignment not found." => "Error: Tarea no encontrada.",
"Permission denied: Students may NOT edit their work after the due date." => "Permiso denegado: Los estudiantes NO pueden editar su trabajo después de la fecha de entrega.",
"Permission denied: The teacher must wait until the due date to edit students' work." => "Permiso denegado: el profesor debe esperar hasta la fecha de entrega para editar el trabajo de los estudiantes.",
"No entries available yet!" => "No hay entradas disponibles aún!",
"Permission denied: you must be a teacher to access this page." => "Permiso denegado: debe de ser profesor para acceder a esta página.",
"Error: No assignment indicated." => "Error: No se indicó tarea.",
"Error: assignment not found." => "Error: tarea no encontrada.",
"You must be a student to view this page." => "Debe ser estudiante para ver esta página.",
" is not a student." => " no es un estudiante.",
"specified." => "especificado.",
"Assignment not found" => "Tarea no encontrada",
"Anonymous Grader" => "Calificador anónimo",
"Anonymous Peer Reviewer" => "Evaluador Anónimo",
"No homework page indicated!" => "No se indicó página de deberes!",
"Error: Could not fetch page" => "Error: No puedo obtener página",
"You must be a student to view this page!" => "Debe ser un estudiante para ver esta página!",
"Students may only view their own work!" => "Los estudiantes solo pueden ver su propio trabajo!",
"This function is deprecated in favor of the improved quizzes outside of the Homework feature." => "Esta función está obsoleta en favor de los cuestionarios mejorados fuera de la función de Deberes.",
"Permission denied: You cannot rollback this page." => "Permiso denegado: no puede volver atras esta página.",
"No hw page indicated" => "No se indicó página de hw ",
"Error: nonexistant version specified." => "Error: versión no existente especificada.",
"Error: Could not fetch assignment " => "Error: No puedo obtener tarea ",
"You must be a student to view homework assignments." => "Debe de ser estudiante para ver las tareas de deberes.",
"Permission denied you must be a student to view assignments." => "Permiso denegado debe ser un estudiante para ver deberes.",
"You must be a teacher or grader to access this page." => "Debe ser un maestro o un calificador para acceder esta página.",
"Permission denied: You must be a teacher to edit assignments." => "Permiso denegado: Debe ser un profesor para editar deberes.",
" error: Can not find assignment " => " error: no puedo encontrar tarea ",
"A new password and your IP address has been sent " => "Una nueva clave y su direccion IP han sido enviados ",
"Invalid variable value : " => "Valor no válido de variable : ",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"post" => "post",
"posts" => "mensajes",
"standard" => "standard",
"cache" => "cache",
"backlinks" => "backlinks",
"perms" => "permisos",
"similar" => "similar",
"undo" => "undo",
"slides" => "slides",
"flag" => "flag",
"ok" => "ok",
"admin banning tpl" => "admin banning tpl",
"cat" => "cat",
"prio" => "prio",
"perso" => "perso",
"admin FortuneCookie" => "admin FortuneCookie",
"admin FortuneCookie tpl" => "admin FortuneCookie tpl",
"dsn" => "dsn",
"extwiki" => "extwiki",
"coms" => "coms",
"ppd" => "ppd",
"admin Webmail" => "admin Webmail",
"admin QuickTags" => "admin QuickTags",
"admin Trackers tpl" => "admin Trackers tpl",
"items" => "items",
"admin" => "admin",
"admin admin tpl" => "admin admin tpl",
"imagescale" => "imagescale",
"Chair" => "Chair",
"save_to" => "save_to",
"admin quicktags" => "admin quicktags",
"admin roles" => "admin roles",
"monitor" => "suscribirse",
"admin Banners" => "admin Banners",
"admin Banners tpl" => "admin Banners tpl",
"admin cache" => "admin cache",
"admin cache tpl" => "admin cache tpl",
"admin DynamicContent tpl" => "admin DynamicContent tpl",
"adm" => "adm",
"blog posts" => "blog posts",
"admin Tiki Shoutbox" => "admin Tiki Shoutbox",
"admin Tiki Shoutbox tpl" => "admin Tiki Shoutbox tpl",
"item" => "item",
"uploaded by" => "subida por",
"not specified" => "no especificada",
"There was a problem with your upload." => "Hubo un problema con su subida.",
"The file you are trying to upload is too big." => "El archivo que intenta subir es demasiado grande.",
"The file you are trying to upload was only partially uploaded." => "El archivo que intenta subir fue solo parcialmente subido.",
"You must select a file for upload." => "Debe elegir un archivo para subir.",
"%s is an empty archive file" => "%s es un fichero de archivo vacío",
"Invalid remote file on url %s" => "Fichero remoto no válido en %s",
"Project Group for " => "Grupo de Proyecto para ",
"Project Admin Group for " => "Grupo Administrador de Proyecto para ",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d de %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d de %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d de %b, %Y[%H:%M %Z]",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "Selector de usuario: use opciónes para alimentación automática de campo: puede usar 1 para el login del autor o 2 para el login del modificador.",
"~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId,max=>3,date=>1,body=>1)}{RSS} Inserta la salida de un feed rss en una página wiki",
"delete" => "eliminar",
"stop monitoring this blog" => "abandonar suscripción a este blog",
"visits" => "visitas",
"show categories" => "mostrar categorías",
"author" => "autor",
"user level" => "nivel de usuario",
"send email to user" => "enviar correo a usuario",
"score" => "puntos",
"delete selected" => "borrar seleccionados",
"move" => "mover",
"Posted messages" => "Mensajes",
"set" => "poner",
"replies" => "respuestas",
"new reply" => "nueva respuesta",
"cancel" => "cancelar",
"up" => "subir",
"down" => "bajar",
"add" => "añadir",
"stop monitoring this map" => "abandonar suscripción a este mapa",
"create" => "crear",
"save" => "guardar",
"send" => "enviar",
"Hide module contents" => "Ocultar contenidos de módulo",
"Last visitors" => "Últimos visitantes",
"register" => "registrarse",
"secure" => "seguro",
"stay in ssl mode" => "permanecer en modo ssl",
"go" => "ir",
"use" => "usar",
"cached" => "cacheada",
"refresh" => "refresco",
"print" => "imprimir",
"create pdf" => "crear pdf",
"monitor this page" => "suscribirse a esta página",
"stop monitoring this page" => "abandonar suscripción a esta página",
"rename" => "renombrar",
"unlock" => "desbloquear",
"lock" => "bloquear",
"history" => "historial",
"export" => "exportar",
"discuss" => "discutir",
"add comment" => "añadir comentario",
"attach file" => "adjuntar archivo",
"translation" => "traducción",
"last modification" => "última modificación",
"attachments" => "adjuntos",
"stats" => "estadísticas",
"last changes" => "cambios recientes",
"list pages" => "listar páginas",
"back to homepage" => "volver a inicio",
"cancel edit" => "cancelar edición",
"No attachments for this page" => "No hay adjuntos",
"Skip to navigation" => "Saltar a navegación",
"switch" => "cambiar",
"view blog" => "ver blog",
"list blogs" => "listar blogs",
"save and exit" => "guardar y salir",
"reads" => "lecturas",
"view comments" => "ver comentarios",
"Click here to create it" => "Pulse aquí para crearlo",
"wiki help" => "wiki ayuda",
"General preferences" => "Preferencias generales",
"Other preferences" => "Otras preferencias",
"HomePage" => "PáginaInicio",
"Edit information" => "Editar información",
"Change information" => "Cambiar información",
"Best language" => "Lenguaje preferido",
"Enable cache images to all galleries" => "Activar cacheo de imágenes en todas las galerías",
"Images cache directory" => "Directorio de cache de imágenes",
"images" => "imágenes",
"PHP error reporting level for non-admin:" => "Nivel de reporte de error de PHP para no admin:",
"Report PHP errors only for admin" => "Reportar errores de PHP sólo para admin",
"Server name (for absolute URIs)" => "Nombre del servidor (para URLs absolutas)",
"HTTPS Server" => "Servidor HTTPS",
"Automatic (uses HTTPS variable)" => "Automático (usa variable HTTPS)",
"Wiki_Tiki_Title" => "Título del Wiki",
"path" => "camino",
"Admin->Features" => "Admin->Características",
"Validate email address (may not work)" => "Validar dirección de correo (puede no funcionar)",
"Require HTTP Basic authentication" => "Requiere autenticación HTTP",
"HTTP server name" => "Servidor HTTP",
"HTTP URL prefix" => "Prefijo para URLs HTTP",
"HTTPS server name" => "Servidor HTTPs",
"HTTPS URL prefix" => "Prefijo para URLs HTTPs",
"Only for users" => "Sólo usuarios",
"Users and admins" => "Usuarios y admins",
"Full Text Search" => "Búsqueda Full Text",
"Don't forget: to use feature you will need to enable it on" => "No se olvide: para usar esta característica debe activarla",
"Custom Code" => "Código Configurable",
"Site breadcrumbs" => "breadcrumbs del sitio",
"Site search bar" => "Barra de búsqueda del sitio",
"Site logo" => "Logo del sitio",
"Site logo source" => "Origen del logo del sitio",
"Site ads and banners" => "Publicidad y banners del Sitio",
"Site Menu" => "Menú del Sitio",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Nota: esta característica también requiere que phplayers sea activado en Admin->Características",
"Manage attachment preferences" => "Administrar preferencias de adjuntos",
"HTML in Wiki Pages" => "HTML en Páginas Wiki",
"Wiki syntax used when a page contains HTML" => "Sintáxis Wiki usada cuando una página contiene HTML",
"full" => "completo",
"partial" => "parcial",
"Enable Feature" => "Activar Función",
"Wiki attachments preferences" => "Preferencias de archivos asociados a Wiki",
"loc" => "ubi",
"participants" => "participantes",
"lang" => "leng",
"subscription" => "subscripción",
"permissions" => "permisos",
"admin categories" => "admin categorías",
"admin categories tpl" => "admin categorías tpl",
"create new" => "crear nueva",
"edit chart" => "editar chart",
"update" => "actualizar",
"admin charts template" => "plantilla admin charts",
"admin content templates" => "admin plantillas de contenido",
"admin content templates template" => "admin plantilla de plantillas de contenido",
"use in cms" => "usar en cms",
"use in wiki" => "usar en wiki",
"use in newsletters" => "usar en boletines",
"use in events" => "usar en eventos",
"use in HTML pages" => "usar en páginas HTML",
"last modif" => "últ modif",
"sections" => "secciones",
"upload" => "subir",
"admin Drawings tpl" => "admin Ilustraciones tpl",
"admin External Wikis" => "Admin Wikis Externos",
"admin forums template" => "admin plantilla de foro",
"Edit existing forums" => "Editar foros existentes",
"online" => "en línea",
"topics" => "temas",
"age" => "edad",
"last post" => "último mensaje",
"Assign Permissions (Active)" => "Asignar Permisos (Activo)",
"Click here to delete this forum" => "Cliquee aquí para borrar este foro",
"admin hotwords" => "admin palabras clave",
"admin hotwords template" => "plantilla admin hotwords",
"admin HTML page dynamic zones" => "admin zonas dinámicas de páginas HTML",
"admin Html Pages" => "Administrar páginas Html",
"admin Html Pages template" => "admin plantilla de páginas Html",
"list repositories" => "listar repositorios",
"new repository" => "nuevo repositorio",
"view repository" => "ver repositorio",
"view this repository" => "ver este repositorio",
"new rule" => "nueva regla",
"admin featured links" => "admin enlaces destacados",
"admin featured links template" => "admin plantilla enlaces destacados",
"position" => "posición",
"admin mailin template" => "plantilla admin mailin ",
"section" => "sección",
"sorted section" => "sección ordenada",
"admin menu builder" => "admin constructor de menús",
"admin menus template" => "plantilla admin menus",
"options" => "opciones",
"admin modules" => "admin módulos",
"admin modules template" => "admin plantilla de módulos",
"assign module" => "asignar módulo",
"left modules" => "módulos a izquierda",
"right modules" => "módulos a derecha",
"edit/create" => "editar/crear",
"clear cache" => "limpiar cache",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Nota 1</b>: si permite que sus usuarios configuren módulos entonces los módulos asignados\n no serán reflejados en la pantalla hasta que configure ellos \ndesde MiTiki->Módulos.<br />\n<b>Nota 2</b>: Si asigna módulos a grupos asegúrese que\nhaya apagado la opción 'mostrar módulos a todos los grupos siempre'\nen Admin->General\n",
"assign" => "asignar",
"left" => "izquierda",
"right" => "derecha",
"order" => "orden",
"create/edit" => "crear/editar",
"use poll" => "usar votación",
"use gallery" => "usar galería",
"use dynamic  content" => "usar contenido dinámico",
"use rss module" => "usar módulo RSS",
"use menu" => "usar menú",
"use phplayermenu" => "usar phplayermenu",
"use banner zone" => "usar zona de banners",
"list newsletters" => "listar boletines",
"admin newsletters" => "admin boletines",
"send newsletters" => "enviar boletines",
"admin newsletters template" => "admin plantilla de boletines",
"editions" => "ediciones",
"last sent" => "última edición",
"send newsletter" => "enviar boletín",
"admin Email Notifications" => "admin Notificaciones por Correo",
"admin notifications template" => "administrar plantilla de notificaciones",
"use admin email" => "usar correo de admin",
"event" => "evento",
"admin polls" => "admin votaciones",
"admin polls template" => "plantilla admin votaciones",
"label" => "etiqueta",
"admin RSS Modules" => "admin módulos RSS",
"admin RSSmodules template" => "admin plantilla de módulos RSS",
"admin shoutbox words" => "admin palabras de shoutbox",
"admin shoutbox words template" => "admin plantilla palabras de shoutbox",
"admin structures template" => "plantilla admin estructuras",
"export pages" => "exportar páginas",
"dump tree" => "volcar árbol",
"create webhelp" => "crear webhelp",
"view webhelp" => "ver webhelp",
"tree" => "árbol",
"create new structure" => "crear nueva estructura",
"survey stats" => "estadísticas de encuestas",
"edit this survey" => "editar encuesta",
"admin surveys" => "admin encuestas",
"list surveys" => "listar encuestas",
"questions" => "preguntas",
"files" => "archivos",
"admin topics template" => "plantilla admin temas",
"Edit fields for tracker" => "Editar campos para tracker",
"The tracker needs a text field named Subject" => "El tracker necesita un campo de texto llamado Subject",
"version" => "versión",
"admin groups" => "admin grupos",
"admin groups template" => "admin plantilla de grupos",
"assign permissions" => "asignar permisos",
"admin users" => "admin usuarios",
"admin users template" => "plantilla admin usuarios",
"edit account settings" => "editar opciones de cuenta",
"assign to groups" => "asignar a grupos",
"edit article tpl" => "editar artículo tpl",
"all" => "todos",
"Assign user" => "Asignar usuario",
"Available groups" => "Grupos disponibles",
"assign perms to this group" => "asignar permisos a este grupo",
"admin backups" => "admin respaldos",
"List of available backups" => "Lista de respaldos disponibles",
"Restoring a backup" => "Recuperar respaldo",
"Warning!" => "¡Cuidado!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Recuperar un respaldo destruye todos los datos de su base Tiki. Todas sus tablas seran reemplazadas con la información del respaldo.",
"Click here to confirm restoring" => "Click aquí para confirmar recuperación del respaldo",
"Create new backup" => "Crear nuevo respaldo",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Crear respaldos puede tomar mucho tiempo. Si el proceso no es completado usted verá una pantalla en blanco. Si pasa eso necesita incrementar el tiempo de ejecución máximo de scripts en su archivo php.ini",
"Your image gallery storage is set to \"{\$gal_use_dir}\", you will need to backup this using FTP or SCP." => "Su almacenamiento de galería de imágenes esta configurado como \"{\$gal_use_dir}\", deberá respaldarlo usando FTP o SCP.",
"Your file gallery storage is set to \"{\$fgal_use_dir}\", you will need to backup this using FTP or SCP." => "Su almacenamiento de galería de archivos esta configurado como \"{\$fgal_use_dir}\", deberá respaldarlo usando FTP o SCP.",
"If any of your forums have attachments stored in the directory you will need to backup these using FTP or SCP." => "Si alguno de sus foros tiene archivos asociados guardados en el directorio deberá respaldarlos usando FTP o SCP.",
"Upload a backup" => "Subir un respaldo",
"Upload backup" => "Subir respaldo",
"remove file extension from image name" => "borre la extensión del archivo del nombre de la imagen",
"convert sub directories to sub galleries" => "convertir subdirectorios a subgalerias",
"eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named screenshots will be created" => "ej de \"misc/screenshots/digicam0001.jpg\" se creará una galería llamada screenshots",
"use sub directory names as description" => "use nombres de subdirectorios como descripción",
"eg. from \"misc/screenshots/digicam0001.jpg\" a description misc/screenshots will be created" => "ej de \"misc/screenshots/digicam0001.jpg\" será creada una descripciona description misc/screenshots",
"admin the category system" => "admin el sistema de categorías",
"admin category" => "admin categoría",
"list galleries" => "listar galerías",
"edit gallery" => "editar galería",
"rebuild thumbnails" => "reconstruir miniaturas",
"upload image" => "subir imagen",
"list gallery" => "listar galería",
"hit" => "impacto",
"original size" => "tamaño original",
"return to gallery" => "volver a la galería",
"edit image" => "editar ilustración",
"smaller" => "menor",
"bigger" => "mayor",
"prev image" => "imagen previa",
"popup window" => "ventana popup",
"next image" => "próxima imagen",
"slideshow forward" => "presentación adelante",
"stop" => "detener",
"add item" => "agregar ítem",
"Subscription List" => "Listado de Subscripciones",
"or create a new category" => "o cree una nueva categoría",
"or create a new location" => "o cree una nueva ubicación",
"comma separated usernames" => "usuarios separados por coma",
"comma separated username:role" => "usuario:rol separados por coma",
"with roles" => "con roles",
"Optional" => "Opcional",
"Format: mm/dd/yyyy hh:mm<br />..." => "Formato: mm/dd/yyyy hh:mm<br />...",
"See strtotime php function" => "Ver función php strtotime",
"Format: mm/dd/yyy hh:mm<br />..." => "Formato: mm/dd/yyy hh:mm<br />...",
"permission" => "permiso",
"remove from this category &amp; all its children" => "borrar esta categoría y todos sus hijos",
"remove from this category only" => "borrar sólo de esta categoría",
"remove page" => "eliminar página",
"admin directory tpl" => "admin directorio tpl",
"edit tpl" => "editar tpl",
"browse" => "navegar",
"related" => "relacionados",
"validate" => "validar",
"admin directory categories tpl" => "admin categorías de directorio tpl",
"add a site" => "añadir un sitio",
"add a category" => "agregar categoría",
"search" => "buscar",
"edit template" => "editar plantilla",
"list articles" => "listar artículos",
"view articles" => "ver artículos",
"create zone" => "crear zona",
"save the banner" => "guardar el banner",
"edit blog tpl" => "editar blog tpl",
"try" => "probar",
"display" => "desplegar",
"create new block" => "crear nuevo bloque",
"list quizzes" => "listar cuestionarios",
"quiz stats" => "estadísticas de cuestionarios",
"edit this quiz" => "editar este cuestionario",
"admin quizzes" => "admin cuestionarios",
"admin quizzes tpl" => "admin cuestionarios tpl",
"results" => "resultados",
"edit quiz questions" => "editar preguntas del cuestionario",
"edit quiz questions tpl" => "editar preguntas de cuestionario tpl",
"create page" => "crear página",
"edit submissions tpl" => "editar colaboración tpl",
"list submissions" => "listar colaboraciones",
"edit translations" => "editar traducciones",
"edit translations template" => "editar traducciones plantilla",
"add to the set" => "agregar al conjunto",
"Admin ephemerides" => "Admin efemérides",
"admin Ephemerides tpl" => "admin Efemérides tpl",
"All ephemerides" => "Todas las efemérides",
"new question" => "nueva pregunta",
"approve" => "aprobar",
"configure listing" => "configurar listado",
"topic" => "tema",
"save and approve" => "salve y apruebe",
"new topic" => "nuevo tema",
"reject" => "rechazar",
"accept" => "aceptar",
"refuse" => "rechazar",
"add new" => "añadir nuevo",
"add role" => "añadir rol",
"new minor" => "nuevo menor",
"new major" => "nuevo mayor",
"admin processes" => "admin procesos",
"admin activities" => "admin actividades",
"edit this process" => "Editar este proceso",
"send instance" => "enviar instancia",
"create new gallery" => "crear nueva galería",
"rebuild cache" => "rehacer cache",
"result" => "resultado",
"reload" => "recargar",
"edit repository" => "editar repositorio",
"source" => "fuente",
"list articles tpl" => "listar artículos tpl",
"edit new article" => "editar nuevo artículo",
"create new blog" => "crear nuevo blog",
"list faqs tpl" => "listar faqs tpl",
"upload file" => "subir archivo",
"Edit a file using this form" => "Edite un archivo usando este formulario",
"monitor this gallery" => "suscribirse a esta galería",
"stop monitoring this gallery" => "abandonar suscripción a esta galería",
"delete selected files" => "borrar archivos seleccionados",
"browse gallery" => "visitar galería",
"Flash binary (.sqf or .dcr)" => "Archivo Flash (.sqf o .dcr)",
"list posts tpl" => "listar posts tpl",
"edit blog" => "editar blog",
"list quizzes tpl" => "listar cuestionarios tpl",
"edit new submission" => "editar nueva colaboración",
"edit quiz stats tpl" => "editar estadísticas del cuestionario tpl",
"actions" => "acciones",
"take survey" => "tomar encuesta",
"list trackers tpl" => "listar trackers tpl",
"admin live support tpl" => "admin soporte live tpl",
"set as operator" => "poner como operador",
"add topic" => "añadir tema",
"install" => "instalar",
"wiki create" => "crear wiki",
"wiki overwrite" => "sobrescribir wiki",
"back" => "atrás",
"Assign permissions to page" => "Asignar permisos a página",
"Current permissions for this page" => "Permisos actuales para esta página",
"remove from this page" => "borrar de ésta página",
"remove from this structure" => "borrar de ésta estructura",
"No individual permissions; category or global permissions apply" => "No se aplican permios individuales, de categoría o globales",
"this page" => "esta página",
"this structure" => "esta estructura",
"Current permissions for categories that this page belongs to" => "Permisos actuales para las categorías a las que pertenece esta página",
"Send email notifications when this page changes to" => "Enviar notificación de correo cuando esta página cambie a",
"add email" => "añadir correo",
"Notifications" => "Notificaciones",
"clear stats" => "borrar estadísticas",
"Edit received page" => "Editar página recibida",
"admin Referer stats" => "admin estadísticas de Referer",
"admin Referer stats tpl" => "admin estadísticas de Referer tpl",
"last" => "última",
"send me my password" => "enviar mi contraseña",
"searched" => "buscado",
"galleries" => "galerías",
"wiki pages" => "páginas del wiki",
"admin send objects tpl" => "admin enviar objetos tpl",
"site" => "sitio",
"clear" => "limpiar",
"add article" => "añadir artículo",
"create new sheet" => "crear nueva planilla",
"list view" => "ver lista",
"first" => "primero",
"send answers" => "enviar respuestas",
"move to right column" => "mover a columna derecha",
"unassign" => "inhabilitar",
"move to left column" => "mover a columna izquierda",
"remove folder" => "borrar carpeta",
"refresh cache" => "refrescar caché",
"admin mode" => "modo admin",
"trash" => "papelera",
"empty trash" => "vaciar papelera",
"remove from trash" => "sacar de papelera",
"use start date and time" => "usar fecha y hora de comienzo",
"use end date and time" => "usar fecha y hora de fin",
"edit user files" => "editar archivos de usuario",
"no comments" => "sin comentarios",
"edit items" => "editar items",
"list charts" => "listar charts",
"last chart" => "último chart",
"view faq" => "ver faq",
"view faq tpl" => "ver faq tpl",
"admin menus tpl" => "admin menús tpl",
"add suggestion" => "agregar sugerencia",
"monitor this forum" => "suscribirse a los mensajes iniciales de este foro",
"stop monitoring this forum" => "abandonar la suscripción a los mensajes iniciales de este foro",
"delete selected topics" => "borrar temas seleccionados",
"stop monitoring this topic" => "abandonar suscripción a este tema",
"Comments below your current threshold" => "Comentarios por debajo de su umbral actual",
"list attachments" => "listar archivos asociados",
"add contacts" => "Añadir contactos",
"DATE-of" => "de",
"You cannot edit this page because it is a user personal page" => "No puede editar esta página por ser la página personal de un usuario",
"Permission denied you cannot assign permissions for this page" => "No tiene autorización para asignar permisos a esta página",
"You do not have permission to edit messages" => "No tiene permiso para editar mensajes",
"Cannot read file" => "No puedo leer archivo",
"Permission denied you cannot upload files" => "Permiso denegado no puede subir archivos",
"cannot process upload" => "no se pudo procesar subida",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Su dirección de correo ha sido borrada de la lista de direcciones que están suscritas a este tracker",
"Your email address has been added to the list of addresses monitoring this tracker" => "Su dirección de correo ha sido añadida de la lista de direcciones que están suscritas a este tracker",
"Cancel monitoring" => "Cancelar suscripción",
"Your email address has been removed from the list of addresses monitoring this item" => "Su dirección de correo ha sido borrada de la lista de direcciones que están suscritas a este item",
"Your email address has been added to the list of addresses monitoring this item" => "Su dirección de correo ha sido añadida a la lista de direcciones que están suscritas a este item",
"Dls" => "Dls",
"diff" => "diff",
"del" => "del",
"pdf" => "pdf",
"UTC" => "UTC",
"<b>Feed</b>" => "<b>Feed</b>",
"Admin tracker" => "Admin tracker",
"zoom" => "zoom",
"quater" => "quater",
"roles" => "roles",
"proc" => "proc",
"rollback" => "confirmar restablecimiento de página",
"Com" => "Com",
"Vers" => "Vers",
"P" => "P",
"F" => "F",
"next chart" => "next chart",
"pos" => "pos",
"pre" => "pre",
"emot" => "emot",
"pop" => "pop",
"Russian Federation" => "Rusia",
"new image uploaded by" => "nueva imagen subida por",
"new subscriptions" => "nueva suscripción",
"new item in tracker" => "nuevo item en tracker",
"tikiwiki logo" => "logo tikiwiki",
"show" => "mostrar",
"hide" => "ocultar",
"message" => "mensaje",
"Include all post in a blog" => "Incluye todos los posts en un blog",
"Include an article" => "Incluye un artículo",
"no such attachment on this page" => "no está ese archivo asociado a esta página",
"select all" => "elegir todo",
"filter" => "filtrar",
"missing fields list" => "lista de campos faltante",
"move %s in %s" => "mover %s en %s",
"no such file" => "no existe archivo",
"downloads" => "descargas",
"download" => "bajar",
"attach" => "adjuntar",
"monitor this blog" => "suscribirse a este blog",
"hide categories" => "ocultar categorías",
"Admin categories" => "Administrar categorías",
"browse category" => "navegar categoría",
"reply" => "responder",
"monitor this topic" => "suscribirse a este tema",
"active perms" => "permisos activos",
"with checked" => "con marcados",
"move selected files" => "mover archivos seleccionados",
"Thank you for you registration. You may log in now." => "Gracias por su registro. Puede loguearse ahora.",
"Zoom out x4" => "Alejar x4",
"Zoom out x3" => "Alejar x3",
"Zoom in x3" => "Acercar x3",
"Zoom in x4" => "Acercar x4",
"from\nthe mapfile:" => "desde\nel archivo de mapa:",
"compare" => "comparar",
"older version" => "versión mas vieja",
"Click the :: options in the Menu for more options." => "Cliquee las :: opciones en el Menú para más opciones.",
"Please, also see" => "Mire también",
"for more setup details." => "para mas detalles de configuración.",
"Note 1:" => "Nota 1:",
"You can remove this module in" => "Puede eliminar este módulo en",
"as well as assign or edit many others." => "como asignar o editar muchos otros",
"Note 2:" => "Nota 2:",
"The menu module installed by default is named" => "El módulo de menú instalado por defecto se llama",
"it is a \"custom module\" which includes menu ID " => "es un \"módulo personalizado\" que incluye menu ID ",
"That menu is stored in database and it can be edited from " => "Ese menú esta guardado en base de datos y puede ser editado desde ",
"Do not mix this with the original <em>application_menu</em> module" => "No lo mezcle a éste con el módulo original <em>application_menu</em>",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Ese puede ser muy personalizado para hacer corresponder con el tema usado pero puede ser sólo hecho editando el archivo mod-application_menu.tpl \"manualmente\"",
"Create pdf" => "Crear pdf",
"1 file attached" => "1 archivo adjuntado",
"categories" => "categorías",
"List pages where I am a creator" => "Listar páginas donde soy el creador",
"by creator" => "por creador",
"List pages where I am a modificator" => "Listar páginas donde soy el modificador",
"by modificator" => "por modificador",
"at tracker" => "en tracker",
"calendar view" => "vista de calendario",
"check / uncheck all" => "marcar / desmarcar todos",
"Tiki sections and features" => "Secciones y caracteristicas del Tiki",
"tikiwiki.org help" => "Ayuda tikiwiki.org",
"Site Logo and Identity" => "Logo de Sitio e Identidad",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Use el plugin Quote en vez de &ldquo;>&rdquo; para citar",
"Storing files in a directory" => "Guardar archivos en un directorio",
"please read" => "por favor lea",
"yes" => "sí",
"Click here for more details." => "Cliquee aquí para mas detalles.",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "El campo de valor de preferencias en db esta colocado al maximo, 250 caracteres por defecto hasta ahora. Eso sirve para el contenido de el código configurable tambien. Chequee este campo si quiere actualizar su tabla de base de datos de preferencia para permitir mas que 250 caracteres (si bien fue probado y funciona bien en mysql, es recomendado que respalde sus datos manualmente antes de cualquier actualizacion de la base de datos)",
"Users &amp; groups" => "Usuarios &amp; grupos",
"private" => "privado",
"<b>Item</b>" => "<b>ítem</b>",
"<b>Value</b>" => "<b>Valor</b>",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Esta página es para configurar opciones de los feeds RSS generados/exportados por Tiki. Para leer/importar feeds RSS, busque en \"módulos RSS\" en el menú de aplicación, o",
"<b>enable/disable</b>" => "<b>habilitar/deshabilitar</b>",
"<b>Max number of items</b>" => "<b>Cantidad máxima de items</b>",
"Feed for Articles" => "Feed de artículos",
"Feed for Weblogs" => "Feed de weblogs",
"Feed for Image Galleries" => "Feed de galerías de imágenes",
"Feed for File Galleries" => "Feed de galerías de archivos",
"Feed for the Wiki" => "Feed del Wiki",
"Feed for individual Image Galleries" => "Feed para una galería de imágenes en particular",
"Feed for individual File Galleries" => "Feed para una galería de archivos en particular",
"Feed for individual weblogs" => "Feed para un weblog",
"Feed for individual forums" => "Feed de foros individuales",
"Feed for mapfiles" => "Feed para archivos de mapa",
"Feed for directories" => "Feed para directorios",
"Feed for tracker items" => "Feed para ítems de tracker",
"Prefix breadcrumbs with 'Location:' label?" => "Preceder breadcrumbs con la etiqueta 'Location:'?",
"Site Search" => "Búsqueda en Sitio",
"Change style only" => "Sólo cambiar estilo",
"PDF generation" => "Generación de PDF",
"Use in CMS" => "Usar en cms",
"Use in Wiki" => "Usar en wiki",
"Use in newsletters" => "Usar en boletines",
"Use in events" => "Usar en eventos",
"Use in HTML pages" => "Usar en páginas HTML",
"Edit Existing Forums" => "Editar Foros Existentes",
"Refresh rate (if dynamic) [secs]" => "Tiempo de refresco (si es dinámica) [segs]",
"configure repositories" => "configurar repositorios",
"configure this repository" => "configure este repositorio",
"copy rules" => "copiar reglas",
"Create/edit newsletters" => "Crear/editar boletín",
"subscriptions" => "suscripciones",
"archives" => "archivos",
"Use Admin Email" => "Usar correo de admin",
"Edit or add poll options" => "Editar o añadir opciones",
"configure polls" => "configurar votaciones",
"Create/edit Polls" => "Crear o editar votaciones",
"Rss channels" => "Canales rss",
"show pubdate" => "mostrar fechapub",
"activate" => "activar",
"Edit this tracker" => "Editar tracker",
"View this tracker items" => "Ver elementos del tracker",
"Edit tracker fields" => "Editar campos del tracker ",
"Import/export trackers fields" => "Importar/exportar campos de trackers",
"Edit tracker" => "Editar tracker",
"Create trackers" => "Crear trackers",
"Import/export" => "Importar/exportar",
"fields" => "campos",
"active permissions" => "activar permisos",
"Create/edit trackers" => "Crear/editar trackers",
"filename" => "nombre de archivo",
"filesize" => "tamaño de archivo",
"filetype" => "tipo de archivo",
"longdesc" => "descarga",
"Add a new group" => "Agregar nuevo grupo",
"Edit item" => "Editar item",
"List all members" => "Listar todos los miembros",
"Add a new user" => "Añadir un nuevo usuario",
"manage group assignments" => "manejar asignación de grupo",
"set default groups" => "poner grupos por defecto",
"Popup Window" => "Ventana popup",
"details" => "detalles",
"change focus" => "cambiar foco",
"quarter" => "trimestre",
"semester" => "semestre",
"No individual permissions global permissions apply" => "No hay permisos individuales, aplican los permisos globales",
"Welcome to the Tiki Chat Rooms" => "Bienvenido a los Chat Rooms de Tiki",
"Please select a chat channel" => "Elija un canal de chat",
"enter chat room" => "ingresar al salon de chat",
"There are no channels setup, please contact a site admin" => "No hay canales configurados, contacte con el admin del sistema",
"Chatroom" => "Salón de chat",
"Active Channels" => "Canales activos",
"Users in this channel" => "Usuarios en este canal",
"Channel Information" => "Información del canal",
"Channel" => "Canal",
"Ratio" => "Razón",
"Use :nickname:message for private messages" => "Usar :apodo:mensaje para mensajes privados",
"Use [URL|description] or [URL] for links" => "Usar [URL|descripción] o [URL] para enlaces",
"Use (:smileyname:) for smileys" => "Use (:nombreemoticon:) para emoticones",
"Create PDF" => "Crear PDF",
"PDF Settings" => "Configuración de PDF",
"Select Wiki Pages" => "Elija Páginas Wiki",
"Remove Page" => "Eliminar página",
"click here to send us an email" => "cliquee aquí para enviarnos un correo",
"Add or edit a site" => "Añadir o editar un sitio",
"sites" => "sitios",
"cool sites" => "sitios cool",
"Use ...page... to separate pages in a multi-page article" => "Usa ...page.. para separar páginas en un artículo de múltiples páginas",
"Create Zone" => "Crear zona",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache]  (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "usar paréntesis rectos para un enlace externo: [URL] o [URL|link_descripción] o [URL|descripción|nocache]  (ésta última forma previene que el wiki local de cachear la página, ¡use esa forma para páginas grandes!).",
"browse image" => "ver imagen",
"translate" => "traducir",
"Create or edit content" => "Crear o editar contenido",
"this quiz stats" => "estadísticas de este cuestionario",
"answer" => "respuesta",
"Edit Translation:" => "Editar Traducción:",
"Use this section to set the language of the version you are currently working on." => "Use esta sección para poner el lenguaje de la versión en la cual está trabajando.",
"Set of Translations" => "Conjunto de Traducciones",
"Select the article for which the current article is the translation." => "Elija el artículo para el cual el artículo actual es la traducción.",
"Translation of:" => "Traducción de:",
"Enter the name of the page for which the current page is the translation." => "Entre el nombre de la página para el cual la página actual es la traducción.",
"Add to the Set" => "Agregar al conjunto",
"graph" => "grafo",
"Edit FAQ questions" => "Editar preguntas",
"Edit this file gallery:" => "Editar esta galería de archivos:",
"icon" => "ícono",
"Other users can upload files to this gallery" => "Otros usuarios pueden subir archivos a esta galería",
"Available File Galleries" => "Galerías de archivos disponibles",
"configure forum" => "configurar foro",
"start" => "comenzar",
"end" => "fin",
"Add role" => "Añadir rol",
"active process" => "procesos activos",
"invalid" => "no válido",
"invalid process" => "proceso no válido",
"valid process" => "proceso válido",
"activities" => "actividades",
"aborted" => "abortado",
"value" => "valor",
"exceptions" => "excepciones",
"Create or edit content block" => "Crear o editar bloque de contenido",
"Listing Gallery" => "Contenido de la galería",
"Gallery Files" => "Archivos de Galería",
"Last ver" => "Últ ver",
"subscribe" => "subscribir",
"Sent edition" => "Edicion enviada",
"Subscribe to newsletter" => "Suscribirse al boletín",
"Add or edit a news server" => "Añadir o editar un servidor de grupos de noticias",
"rollback to this version" => "revertir a esta versión",
"Print Wiki Pages" => "Imprimir páginas del Wiki",
"add page" => "añadir página",
"entire site" => "todo el sitio",
"click to navigate" => "cliquear para navegar",
"Total threads" => "Cantidad de mensajes",
"Average threads per topic" => "Promedio de mensajes por tema",
"You can include the file in an HTML/Tiki page using" => "Puede incluir un enlace para bajar el archivo usando",
"Now enter the file URL" => "Ingrese el URL del archivo",
" or upload a local file from your disk" => "o suba un archivo desde su disco local",
"Add or edit folder" => "Añadir o editar carpeta",
"Add or edit a URL" => "Añadir o editar URL",
"received" => "recibido",
"submitted" => "enviado",
"shared" => "compartida",
"accepted by task user and creator" => "aceptada por usuario de tarea y creador",
"accepted user and creator" => "aceptado usuario y creador",
"not accepted by one user" => "no aceptada por un usuario",
"not accepted user" => "usuario no aceptado",
"waiting for me" => "esperando por mí",
"waiting for other user" => "esperando por otro usuario",
"red" => "rojo",
"move into trash" => "poner en papelera",
"waiting / not started" => "esperando / no empezada",
"waiting" => "esperando",
"shared for group" => "compartida para grupo",
"accepted by user" => "aceptada por usuario",
"no / rejected" => "no / rechazada",
"accepted by creator" => "aceptada por creador",
"priority" => "prioridad",
"select one" => "seleccione una",
"undo trash" => "deshacer papelera",
"show:" => "mostrar:",
"all shared tasks" => "todas las tareas compartidas",
"previous chart" => "chart anterior",
"permanency" => "permanencia",
"avg" => "prom",
"post new comment" => "escribir nuevo mensaje",
"Post New Comment" => "Postear nuevo mensaje",
"HTML tags are not allowed inside comments" => "No se admite HTML en los comentarios",
"moderator actions" => "acciones de moderador",
"move selected topics" => "mover temas seleccionados",
"unlock selected topics" => "desbloquear temas seleccionados",
"lock selected topics" => "bloquear temas seleccionados",
"merge" => "combinar",
"merge selected topics" => "combinar temas seleccionados",
"reported messages:" => "mensajes reportados:",
"queued messages:" => "mensajes en cola:",
"Edit fields" => "Editar campos",
"View item" => "Ver item",
"Add a comment" => "Añadir comentario",
"account" => "cuenta",
"Projects" => "Proyectos",
"Projects configuration" => "Configuracion de Proyectos",
"Site Identity features" => "Características de Identidad de Sitio",
"Click here to delete this category" => "Cliquee aquí para borrar esta categoría",
"Group doesnt exist" => "El grupo no existe",
"User doesnt exist" => "El usuario no existe",
"Event without Name" => "Evento sin nombre",
"Invalid old password" => "La contraseña ingresada no es válida",
"No channel indicated" => "No se indica canal",
"No nickname indicated" => "No se indica un apodo",
"No permission to view the page" => "No tiene permiso para ver la página",
"I have refused your friendship request!" => "¡Rechacé su pedido de amistad!",
"Please create a directory named \$map_path to hold your map files." => "Por favor cree un directorio llamado \$map_path para guardar sus archivos de mapa.",
"Permision denied" => "Permiso denegado",
"Click" => "Click",
"Use WikiWords" => "Use WikiWords",
"Webmail Doc" => "Webmail Doc",
"mailbox" => "mailbox",
"clip" => "clip",
"cc" => "cc",
"Phillippines" => "Filipinas",
"sender" => "enviado por",
"subject" => "tema",
"date" => "fecha",
"flagged" => "marcado",
"mark" => "marcar",
"find replied message" => "buscar mensaje respondido",
"posted by" => "posteado por",
"email this post" => "mandar mensaje con este post",
"Tag name" => "Nombre etiqueta",
"Anonymous editors must input anti-bot code" => "Editores anónimos deben entrar código anti-bot",
"Edit idle timeout" => "Tiempo límite de espera de edición",
"Use page description" => "Usar descripciones",
"Show page title" => "Mostrar título de la página",
"Show page ID" => "Mostrar ID de página",
"Users can lock pages (if perm)" => "Usuarios con permiso pueden bloquear páginas",
"Use Wiki paragraph formatting" => "Usar formateo de parágrafos Wiki",
"Use external link icons" => "Usar íconos de enlaces externos",
"User's Page" => "Página de Usuario",
"UserPage prefix" => "Prefijo de Página de Usuario",
"Maximum number of versions for history" => "Cantidad máxima de versiones en el historial",
"Never delete versions younger than days" => "Nunca eliminar versiones con edad menor a días",
"Diff style" => "Estilo de Diff",
"Old vers" => "Versiones viejas",
"Add or edit event" => "Añadir o editar evento",
"merge selected notes into" => "unir notas seleccionadas en",
"Faq Stats" => "Estadísticas de FAQs",
"Edit User Files" => "Editar archivos de usuario",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "Su mensaje ha quedado en cola para aprobación, el mensaje será publicado después que\n un moderador lo apruebe.",
"Webmail Doc template" => "Plantilla de Doc de Webmail",
"settings" => "configuración",
"compose" => "redactar",
"contacts" => "contactos",
"back to mailbox" => "volver a buzón de correo",
"full headers" => "ver cabeceras",
"normal headers" => "cabeceras normales",
"reply all" => "responder a todos",
"forward" => "enviar",
"select from address book" => "elegir desde libreta de direcciones",
"Category: wiki, trackers, etc." => "Categoría: wiki, trackers, etc.",
"I did not understand what you said, please try again." => "No comprendo lo que tu dices. Por favor, intenta otra vez.",
"Jan" => "Ene",
"Apr" => "Abr",
"Aug" => "Ago",
"Dec" => "Dic",
"Ivory_Coast" => "Ivory_Coast",
"Costa_Rica" => "Costa_Rica",
"Sri_Lanka" => "Sri_Lanka",
"Puerto_Rico" => "Puerto_Rico",
"El_Salvador" => "El_Salvador",
"Trinidad_Tobago" => "Trinidad_Tobago",
"St_Vincent_Grenadines" => "St_Vincent_Grenadines",
"United_Arab_Emirates" => "Emiratos_Arabes_Unidos",
"American_Samoa" => "Samoa_Americana",
"Catalan_Countries" => "Países Catalanes",
"Cook_Islands" => "Islas_Cook",
"Czech_Republic" => "República_Checa",
"Dominican_Republic" => "República_Dominicana",
"Federated_States_of_Micronesia" => "Estados_Federados_de_Micronesia",
"United_Kingdom" => "Reino_Unido",
"South_Korea" => "Corea_del_Sur",
"Cayman_Islands" => "Islas_Cayman",
"Marshall_Islands" => "Islas_Marshall",
"New_Caledonia" => "Nueva_Caledonia",
"New_Zealand" => "Nueva_Zelanda",
"French_Polynesia" => "Polinesia_Francesa",
"Papua_New_Guinea" => "Papúa_Nueva_Guinea",
"Saudi_Arabia" => "Arabia_Saudita",
"Solomon_Islands" => "Islas_Salomón",
"United_States" => "Estados_Unidos",
"South_Africa" => "Sudáfrica",
"logout" => "desconéctate",
"Apache has the right to write in your file tree, which enables the installation, removal or \nupgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \n\"./fixperms.sh fix\" for example)." => "Apache tiene el derecho a escribir en su sistema de archivos, que permite la instalación, borrado o actualización de paquetes. Cuando termine esas operaciones, piense en arreglar esos permisos de nuevo a un estado seguro (usando ./fixperms.sh fix, p/ej)",
"To install, remove or upgrade packages you need to give the apache user the right\nto write files in your web tree (you can use \"./fixperms.sh open\" to set it up). After installation you need to remove that\npermission (using \"./fixperms.sh fix\")." => "Para instalar, borrar o actualizar paquetes necesita darle al usuario del apache el derecho a escribir archivos en su arbol web (puede usar \"./fixperms.sh open\" para dejarlo asi)). Después de la instalacion debe borrar esos permisos (usando \"./fixperms.sh fix\").",
"add structure" => "añadir estructura",
"monitor this forum topic and thread" => "suscribirse completamente a este foro",
"stop monitoring this forum topic and thread" => "abandonar la suscripción completa a este foro",
"A new (and temporary) password and your IP address has been sent " => "Se han enviado una contraseña (temporal) nueva y su dirección de IP",
"Admin banning tpl" => "Admin banning tpl",
"charts" => "charts",
"Chat Admin" => "Chat Admin",
"Chat Admin tpl" => "Chat Admin tpl",
"Admin DSN" => "Admin DSN",
"tiki-admin_dsn tpl" => "tiki-admin_dsn tpl",
"Admin Webmail" => "Admin Webmail",
"ImportingPagesPhpWikiPageAdmin" => "ImportingPagesPhpWikiPageAdmin",
"tiki-import_phpwiki tpl" => "tiki-import_phpwiki tpl",
"hist" => "hist",
"UserPreferences tpl" => "UserPreferences tpl",
"IRC log" => "IRC log",
"Msg" => "Msg",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opciones de texto: 1, tamaño, prefijar, sufijar, max con tamaño en caracteres, prefijar será desplegado antes del campo, sufijar será mostrado justo después, max es el número máximo de caracteres que pueden ser guardados, y el 1 inicial para hacer que el siguiente campo de texto o checkbox esté en la misma fila. Si indica sólo 1 significa que el siguiente campo estará en la misma fila tambien..",
"Checkbox options: put 1 if you need that next field is on the same row." => "Opciones de Checkbox: ponga 1 si necesita que el siguiente campo esté en la misma fila.",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opciones numéricas: 1,tamaño,prefijar,sufijar con tamaño en caracteres, prefijar será desplegado antes del campo, sufijar será desplegado justo después, y el 1 inicial para hacer que el siguiente campo de texto o checkbox esté en la misma línea. Si indica sólo 1 indica que el siguiente campo estará en la misma fila tambien.",
"Dropdown options: list of items separated with commas." => "Opciones de Dropdown: lista de ítems separadas por comas.",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Selector de Grupo: use opciones para alimentación automática del campo: puede usar 1 para el grupo de creación o 2 para el grupo de donde viene la modificación. El grupo por defecto debe de configurarse, o el primer grupo que viene es elegido del usuario, o el grupo por defecto es Registrados.",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Opciones de Acción: etiqueta, enviar,tiki-index.php,page:nombredecampo,highlight=test",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "Opciones de dirección de correo:: 0|1|2 donde 0 pone la dirección en texto plano, 1 pone la codificación hexadecimal del enlace mailto (más dificil para indexadores para reconocerlo y enviar spam) y 2 hace el href mailto normal.",
"new sites" => "nuevos sitios",
"Message Broadcast" => "Emitir Mensaje",
"Are you sure you want to remove this module?" => "Está seguro que quiere borrar este módulo?",
"database queries used" => "consultas a la base de datos usadas",
"{\$atts_cnt} files attached" => "{\$atts_cnt} archivos adjuntados",
"pass" => "contraseña",
"Page generated in" => "Página generada en",
"sent" => "enviado",
"Homework" => "Deberes",
"Assignments" => "Tareas",
"Favorites" => "Favoritos",
"Member list" => "Lista de miembros",
"Back to Homepage" => "Volver a inicio",
"Minor" => "Menor",
"Last update from CVS" => "Última actualizacion de CVS",
"Translate in" => "Traducir en",
"babelfish it" => "babelfish eso",
"Welcome to" => "Bienvenido a",
"Content Features" => "Funciones de Contenido",
"Contact Us (Anonymous)" => "Contáctenos (Anónimo)",
"Prevent automatic/robot registration" => "Prevenir registro automático/robots",
"Site Logo" => "Logo del Sitio",
"Admin Groups Template" => "Admin plantilla de grupos",
"Help on Banning System" => "Ayuda respecto al Sistema de Bans",
"Create/edit Calendars" => "Crear/editar Calendarios",
"Admin Categories tpl" => "Admin categorias tpl",
"Admin Charts Template" => "Plantilla admin charts",
"Chat Administration" => "Administración Chat",
"Create/edit channel" => "Crear o editar canal",
"Half a second" => "Medio segundo",
"second" => "segundo",
"Chat channels" => "Canales de Chat ",
"Admin Content Templates Template" => "Admin plantilla de plantillas de contenido",
"Help on Drawings" => "Ayuda en Dibujos",
"Admin Forums Template" => "Admin plantilla de foro",
"Admin Hotwords Template" => "Plantilla admin hotwords",
"Admin Featured Links" => "Admin enlaces destacados",
"Admin Featured Links Template" => "Admin plantilla enlaces destacados",
"Admin Mailing Template" => "Plantilla admin mailin ",
"Admin Menu Builder" => "Admin constructor de menús",
"Admin Menus Template" => "Plantilla admin menus",
"Admin Modules Template" => "Admin plantilla de módulos",
"Assign Module" => "Asignar módulo",
"subscribed" => "suscrito",
"Admin Newsletters Template" => "Admin plantilla de boletines",
"Admin Notifications Template" => "Administrar plantilla de notificaciones",
"Admin Polls Template" => "Plantilla admin polls",
"Configure Polls" => "Configurar encuestas",
"tiki admin quicktags template" => "tiki admin plantilla de quicktags",
"Score System" => "Sistema de Puntuación",
"security admin" => "admin seguridad",
"security admin tpl" => "admin seguridad tpl",
"Admin Shoutbox Words Template" => "Admin plantilla palabras de shoutbox",
"Edit survey questions" => "Editar preguntas de encuestas",
"administer surveys template" => "administrar plantilla de encuestas",
"system admin" => "admin de sistema",
"system admin tpl" => "admin de sistema tpl",
"Admin Topics Template" => "Plantilla admin tópicos",
"Admin Tracker" => "Admin tracker",
"Admin Users Template" => "Plantilla admin usuarios",
"Again" => "Otra vez",
"Article Types tpl" => "Tipos de Artículo tpl",
"Assign permissions to group" => "Asignar permisos al grupo",
"Edit Article Tpl" => "Editar artículo tpl",
"Browsing Gallery" => "Visitando Galería",
"Admin Directory tpl" => "Admin directorio tpl",
"Admin Directory Categories tpl" => "Admin categorías de directorio tpl",
"Admin Directory Related" => "Admin Directorio Relacionados",
"directory admin related tpl" => "directorio admin relacionados tpl",
"Admin Directory Sites" => "Admin Sitios de Directorio",
"Admin Directory Sites tpl" => "Admin Sitios de Directorio tpl",
"Validate Sites" => "Validar Sitios",
"directory validate sites tpl" => "validación de sitios de directorio tpl",
"Edit Article" => "Editar Artículo",
"Edit Blog Tpl" => "Editar blog tpl",
"Show Plugins Help" => "Ver Ayuda de Plugins",
"Show Text Formatting Rules" => "Ver Reglas de Formateo de Texto",
"Program dynamic content for block" => "Programar contenido dinámico para el bloque",
"Admin quizzes" => "Admin cuestionarios",
"Admin Quizzes tpl" => "Admin cuestionarios tpl",
"Edit Quiz Questions" => "Editar preguntas del cuestionario",
"Edit Quiz Questions Tpl" => "Editar preguntas de cuestionario tpl",
"Help on Articles" => "Ayuda en Artículos",
"Edit Submissions Tpl" => "Editar colaboración tpl",
"EditTemplates" => "EditarPlantillas",
"EditTemplates tpl" => "EditarPlantillas tpl",
"Edit Translations" => "Editar traducciones",
"Edit Translations Template" => "Editar traducciones plantilla",
"Message queue for" => "Cola de mensajes para",
"back to forum" => "volver a foro",
"Reported messages for" => "Mensajes reportados para",
"friends tpl" => "amigos tpl",
"galleries tpl" => "galerías tpl",
"List Articles Tpl" => "Listar artículos tpl",
"Admin Cache" => "Admin cache",
"Admin Cache tpl" => "Admin cache tpl",
"Help on Dynamic Content" => "Ayuda en Contenido Dinamico",
"List FAQs Tpl" => "Listar faqs tpl",
"games tpl" => "juegos tpl",
"List Posts Tpl" => "Listar posts tpl",
"List Quizzes Tpl" => "Listar cuestionarios tpl",
"Edit Quiz Stats Tpl" => "Editar estadísticas del cuestionario tpl",
"List Trackers Tpl" => "Listar trackers tpl",
"Admin Live Support tpl" => "Admin soporte live tpl",
"back to admin" => "volver a admin",
"User Calendar" => "Calendario de Usuario",
"User Calendar Doc tpl" => "Calendario de Usuario Doc tpl",
"User Calendar Doc" => "Calendario de Usuario Doc",
"User Calendar Preferences Doc tpl" => "Preferencia Calendario de Usuario Doc tpl",
"my tiki tpl" => "mi tiki tpl",
"Subscribe to This Newsletter" => "Suscribir",
"Stats for quiz" => "Estadísticas para cuestionario",
"Received Articles" => "Artículos recibidos",
"received articles tpl" => "artículos recibidos tpl",
"Help on Communication Center" => "Ayuda en Centro de Comunicaciones",
"received pages tpl" => "páginas recibidas tpl",
"Rename page" => "Renombrar página",
"to_version" => "a la versión",
"search stats tpl" => "estadísticas de búsqueda tpl",
"Admin Send Objects tpl" => "Admin enviar objetos tpl",
"sheets tpl" => "planillas tpl",
"Stats for survey" => "Estadísticas de encuesta",
"system logs" => "log del sistema",
"system logs tpl" => "log del sistema tpl",
"Theme Control Center: categories" => "Centro de Control de Temas: Categorías",
"ThemeControl" => "ControlDeTemas",
"ThemeControl tpl" => "ControlDeTemas tpl",
"ThemeControl Objects" => "ControlDeTemas Objetos",
"theme control objects tpl" => "control de temas objetos tpl",
"Theme Control Center: sections" => "Centro de Control de Temas: Secciones",
"theme control sections tpl" => "secciones de control de temas tpl",
"File Title" => "Título del archivo",
"Image Gallery tpl" => "Galería de Imágenes tpl",
"User Assigned Modules" => "Módulos asignados por usuario",
"User Assigned Modules tpl" => "Módulos asignados por usuario tpl",
"User Bookmarks tpl" => "Marcadores de Usuario tpl",
"User Tasks tpl" => "Tareas de Usuario tpl",
"User Watches tpl" => "Watches de Usuario tpl",
"View FAQ Tpl" => "Ver faq tpl",
"Admin Menus tpl" => "Admin menús tpl",
"Edit mail account" => "Editar cuenta de correo",
"Add new mail account" => "Añadir cuenta de correo",
"User accounts" => "Cuentas de correo",
"View All" => "Ver todos",
"Can't parse remote HTML page" => "No puedo parsear página HTML page",
"Permission denied you cannot remove pages" => "Permiso denegado no puede borrar páginas",
"FriendsMenu" => "FriendsMenu",
"Admin Posts" => "Admin Posts",
"ShtMenu" => "ShtMenu",
"Charts Admin" => "Charts Admin",
"OS" => "OS",
"LDAP Base DN" => "LDAP Base DN",
"LDAP User DN" => "LDAP User DN",
"LDAP User Attribute" => "LDAP User Attribute",
"LDAP User OC" => "LDAP User OC",
"LDAP Group DN" => "LDAP Group DN",
"LDAP Group Attribute" => "LDAP Group Attribute",
"LDAP Group OC" => "LDAP Group OC",
"LDAP Member Attribute" => "LDAP Member Attribute",
"LDAP Member Is DN" => "LDAP Member Is DN",
"LDAP Admin User" => "LDAP Admin User",
"LDAP Admin Pwd" => "LDAP Admin Pwd",
"Geourl" => "Geourl",
"meta robots" => "meta robots",
"Wiki Watch" => "Wiki Watch",
"Admin Charts" => "Admin Charts",
"Directory batch" => "Directory batch",
"Zoom" => "Zoom",
"SysLog" => "SysLog",
"Cannot write to this file" => "No puedo escribir en este archivo",
"Missing title or body when trying to post a comment" => "Falta el título o el texto",
"\\n for rows" => "\\n para filas",
"Use this thread to discuss the %s page." => "Use este hilo para discutir la página %s.",
"Newsletter subscription information at " => "Información de suscripción a boletín en ",
"Changes" => "Cambios",
"categorize this object" => "categorizar este objeto",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Su pedido de cuenta fue almacenado y será activado por el administrador lo mas pronto posible.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nuevo artículo enviado: {\$mail_title} por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"New article post at %s" => "Nuevo artículo enviado en %s",
"Syntax highlighting" => "Destacado de sintaxis",
"MyTiki Home" => "MiTiki inicio",
"My Files" => "Mis archivos",
"Mini calendar" => "Calendario",
"User list" => "Lista de usuarios",
"Dump" => "Volcado",
"Send Pages" => "Enviar páginas",
"Received pages" => "Páginas recibidas",
"Submit a New Link" => "Enviar nuevo enlace",
"Browse directory" => "Navegar directorio",
"Admin Directory" => "Admin directorio",
"Layer Management" => "Manejo de capas",
"List quizzes" => "Listar cuestionarios",
"List trackers" => "Listar trackers",
"Ephemerides Admin" => "Admin Efemérides",
"Debugger console" => "Consola de depuración",
"I forgot my pass" => "Olvidé mi contraseña",
"Click to see the ratings" => "Cliquee para ver las calificaciones",
"Send trackback pings to:" => "Enviar pings de trackback pings a:",
"(comma separated list of URIs)" => "(lista separada por comas de  URIs)",
"This is" => "Esto es",
"by the" => "por el",
"Tiki community" => "Comunidad Tiki",
"User identity features" => "Características de Identidad de Usuario",
"Use URI as Home Page" => "Usar URI como PáginaInicio",
"Default charset for sending mail:" => "Charset por defecto para enviar correo:",
"Mail end of line:" => "Fin de línea para correo:",
"Disallow access to the site (except for those with permission)" => "Desactivar acceso al sitio (excepto para aquellos con permiso)",
"Message to display when site is closed" => "Mensaje a desplegar cuando el sitio está cerrado",
"Disallow access when load is above the threshold (except for those with permission)" => "Desactivar acceso cuando la carga esté por encima del límite (excepto para aquellos con permiso)",
"Max average server load threshold in the last minute" => "Carga promedio límite del servidor en el último minuto",
"Message to display when server is too busy" => "Mensaje a desplegar cuando el servidor esta muy ocupado",
"Use cache for external images" => "Usar cache para páginas internas",
"Use gzipped output" => "Enviar contenido zipeado al navegador",
"output compression is active." => "compresión de salida activa.",
"compression is handled by" => "compresión es manejada por",
"Sender Email" => "Correo del que envía",
"Allow anonymous users to \"Contact Us\"" => "Permitir usuarios anónimos a \"Contactarnos\"",
"contact feature disabled" => "No está habilitado",
"Session lifetime in minutes" => "Tiempo de vida de la sesión en minutos",
"Proxy Host" => "Servidor Proxy",
"Locations separator" => "Separador de ubicaciones",
"User registration and login" => "Registro de usuarios y login",
"Use WebServer authentication for Tiki" => "Usar autenticación del servidor web para Tiki",
"... but need admin validation" => "... pero necesita validación de admin",
"Use tracker for more user information" => "Usar tracker para más información de usuarios",
"Use tracker for more group information" => "Usar tracker para más información de grupos",
"Request passcode to register" => "Solicitar código para registrarse",
"Php GD library required" => "biblioteca Php GD requerida",
"Validate users by email" => "Validar usuarios por correo",
"Store plaintext passwords" => "Guardar contraseñas en texto plano",
"Reg users can change password" => "Usuarios registrados pueden cambiar password",
"Reg users can change language" => "Usuarios registrados pueden cambiar lenguaje",
"Restrict available languages" => "Restringir lenguajes disponibles",
"Available languages:" => "Lenguajes disponibles:",
"Force to use chars and nums in passwords" => "Obligar a usar letras y números en contraseñas",
"Minimum password length" => "Longitud mínima de contraseñas",
"Password invalid after days" => "Invalidar contraseñas después de días",
"Remember me feature" => "Recordarme",
"Remember me name" => "Recordar mi nombre",
"Remember me domain" => "Dominio para Recordarme",
"Remember me path" => "Camino para Recordarme",
"Protect against CSRF with a confirmation step" => "Proteger contra CSRF con un paso de confirmación",
"Highlight Group" => "Destacar Grupo",
"Create user if not in Tiki?" => "Crear usuario si no está en Tiki?",
"Create user if not in Auth?" => "Crear usuario si no está en Auth?",
"Just use Tiki auth for admin?" => "Solo use Tiki auth para admin?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "URL de LDAP<br />(si puesta, se ignoraran servidor y puerto que siguen)",
"LDAP Host" => "Servidor LDAP",
"LDAP Port" => "Puerto LDAP",
"LDAP Scope" => "Scope LDAP",
"CAS server hostname" => "Nombre de servidor CAS",
"CAS server port" => "Puerto de servidor CAS",
"CAS server path" => "Camino de servidor CAS",
"Change CAS preferences" => "Cambiar preferencias CAS",
"Meta Keywords" => "Meta Palabras clave",
"Meta Description" => "Meta Descripción",
"Meta Author" => "Meta Autor",
"revisit after" => "revisitar después ",
"Allow Smileys" => "Permitir Emoticones",
"Hotwords in New Windows" => "Palabras clave en Nuevas Ventanas",
"Trackers attachments preferences" => "Preferencias de archivos asociados a trackers",
"Trackers attachments" => "Archivos asociados a trackers",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Para agregar/editar páginas wiki facilmente, agregue el módulo quick_edit via \"Módulos\" en el menú de aplicación, o",
"Create a Tag for the Current Wiki" => "Crear una Etiqueta para el wiki actual",
"Restore the Wiki" => "Recuperar el Wiki",
"restore" => "recuperar",
"Remove a Tag" => "Quitar Etiqueta",
"Wiki Comments Settings" => "Configuraciones para Comentarios del Wiki",
"Wiki Administration" => "Administración Wiki",
"Wiki Home Page" => "Wiki Inicio",
"Wiki Discussion" => "Discusión Wiki",
"Wiki Link Format" => "Formato de Enlace Wiki",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Controla el reconocimiento de enlaces Wiki usando la sintaxis de enlaces wiki de dos paréntesis <i>((nombre página))</i>.",
"Wiki Page List Configuration" => "Configuración de Listado de Páginas Wiki",
"Wiki Features" => "Características Wiki",
"Wiki History" => "Historial",
"browse the category system" => "recorrer el sistema de categorías",
"Add new rule" => "Añadir nueva regla",
"EMail notifications" => "Notificaciones por correo",
"Edit this RSS module:" => "Editar éste módulo RSS:",
"Create new RSS module" => "Crear nuevo módulo RSS",
"Tikiwiki settings" => "Configuraciones para el Tikiwiki",
"Create/edit questions for survey" => "Crear/editar preguntas para encuesta",
"Active?" => "¿Activo?",
"Create Trackers" => "Crear trackers",
"Create/Edit Trackers" => "Crear/editar trackers",
"Create item" => "Crear ítem",
"Assign to Groups" => "Asignar a grupos",
"Delete this type" => "Borrar este tipo",
"Browse gallery" => "Recorrer galería",
"Upload from disk" => "Subir desde disco local",
"Browsing Image" => "Visitando imagen",
"Again please" => "Repetir por favor",
"Admin category relationships" => "Admin relaciones entre categorías",
"Validate links" => "Validar enlaces",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Los archivos con nombres añadidos por -{\$user} son modificables, otros son solo duplicables y serán usados como modelo.",
"Im- Export Languages" => "Im- Exportar Lenguajes",
"disable" => "Deshabilitar",
"Create a file gallery" => "Crear galería de archivos",
"Support tickets" => "Soportar tickets",
"Return to HomePage" => "Regresar al inicio",
"Stats for this survey Questions " => "Estadísticas para preguntas de esta encuesta",
"Batch upload" => "Subida batch",
"1 suggestion" => "1 sugerencia",
"suggestions" => "sugerencias",
"Minor Edit" => "Menor",
"You can not download files" => "No puede bajar archivos",
"cannot be found" => "no puede encontrarse",
"Invalid password.  Your current password is required to change administrative information" => "Contraseña no válida. Su contraseña actual es requerida para cambiar información administrativa",
"Please wait 2 minutes between posts" => "Por favor espere 2 minutos entre mensajes",
"hr" => "hr",
"The text in RED is" => "El texto en ROJO es",
"Show Categories" => "Mostrar categorías",
"Hide Categories" => "Ocultar categorías",
"Wiki page %s changed" => "Página Wiki %s cambió",
"Blog features" => "Características Blogs",
"Blog level comments" => "Comentarios para blogs",
"Post level comments" => "Comentarios para posts",
"Spellchecking" => "Chequeo ortográfico",
"Default ordering for blog listing" => "Orden por defecto para listado de blogs",
"Blog listing configuration (when listing available blogs)" => "Configuración de listado de blog (cuando liste blogs disponibles)",
"Last modification time" => "Última fecha de modificación",
"Blog comments settings" => "Configuración de comentarios en blogs",
"Group calendar sticky popup" => "Calendario de grupo sticky popup",
"Group calendar item view tab" => "Calendario de grupo tab de ver ítem",
"Show Category Path" => "Mostrar camino de categoría",
"Show Category Objects" => "Mostrar Objetos de categoría",
"Search may show forbidden results. Much better performance though." => "La búsqueda puede devolver resultados inaccesibles. Pero mucha mejor performance.",
"CMS features" => "Características del CMS",
"Use templates" => "Usar plantilla",
"Settings for page articles home" => "Opciones para página de inicio de articulos",
"Maximum number of articles in home" => "Cantidad máxima de artículos en inicio",
"Article comments settings" => "Configuraciones para comentarios de artículos",
"Fields to display on page" => "Campos a mostrar en la página",
"Expire Date" => "Fecha de expiración",
"Copyright Management" => "Administrar Copyright",
"License Page" => "Página de Licencia",
"Submit Notice" => "Enviar Aviso",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Para agregar/borrar galerías de archivos, vaya a \"Galerías de Archivos\" en el menú de aplicación, o",
"Uploaded filenames cannot match regex" => "Archivos subidos no deben matchear esta regex",
"File galleries comments settings" => "Configuración de comentarios para galerías de archivos",
"File galleries search indexing" => "Indexado para búsqueda de Galeria de Archivos",
"Leave command blank to delete handler" => "Deje el comando en blanco para borrar manejador",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Use %1 para donde el nombre interno debe ser sustituido (ejemplo: \"strings %1\" para convertir el documento a texto usando el comando de unix strings)",
"Enable auto indexing on file upload or change" => "Activar auto-indexado en caso de subida o cambio de archivo",
"System command" => "Comando de sistema",
"Home Forum" => "Foro Inicial",
"Forums features" => "Característica de Foros",
"Forum quick jumps" => "Accesos rápidos de foros",
"Ordering for forums in the forum listing" => "Orden de los foros en la lista de foros",
"Forum listing configuration" => "Configuración de listado de Foros",
"Show Babelfish Translation URLs" => "Mostrar URL de traducción con Babelfish",
"Show Babelfish Translation Logo" => "Mostrar Logo de Traducción con Babelfish",
"Show Module Controls" => "Mostrar Controles de Módulo",
"Users can Configure Modules" => "Usuarios pueden configurar Módulos",
"Users can Shade Modules" => "Usuarios pueden Sombrear Módulos",
"module decides" => "módulo decide",
"Allow Anonymous Poll Voting" => "Permitir Voto Anónimo en Votaciones",
"Performance issues" => "Temas de performance",
"Search features" => "Funciones de Búsqueda",
"SearchStats" => "EstadistBúsqueda",
"Settings for searching content" => "Configuración para buscar contenido",
"Search refresh rate" => "Ritmo de refresco de búsqueda",
"this survey stats" => "estadísticas de esta encuesta",
"bold" => "negrita",
"italic" => "itálica",
"underline" => "subrayado",
"Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"./setup.sh\" for example)." => "Apache tiene el derecho a escribir en su sistema de archivos, que permite la instalación, borrado o actualización de paquetes. Cuando termine esas operaciones, piense en arreglar esos permission de nuevo a un estado seguro (usando ./setup.sh, p/ej)",
"To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"./setup.sh open\" to set it up). After installation you need to remove that permission (using \"./setup.sh\")." => "Para instalar, borrar o actualizar paquetes necesita darle al usuario del apache el derecho t¡a escribir archivos en su arbol web (puede usar \"./setup.sh open\" para dejarlo asi)). Luego de la instalacion debe borrare esos permisos (usando \"./setup.sh\").",
"You have {\$unread} unread private messages" => "Tiene {\$unread} mensajes privados no leídos",
"unread private messages" => "mensajes privados sin leer",
"chat" => "chat",
"WfMenu" => "WfMenu",
"WikiMenu" => "WikiMenu",
"rankings" => "rankings",
"sandbox" => "sandbox",
"GalMenu" => "GalMenu",
"ForMenu" => "ForMenu",
"DirMenu" => "DirMenu",
"FileGalMenu" => "FileGalMenu",
"QuizMenu" => "QuizMenu",
"TrkMenu" => "TrkMenu",
"Admin trackers" => "Admin trackers",
"SrvMenu" => "SrvMenu",
"EphMenu" => "EphMenu",
"ChartMenu" => "ChartMenu",
"AdmMenu" => "AdmMenu",
"UsrMenu" => "UsrMenu",
"Pass" => "Pass",
"This module requires parameters trackerId and name set" => "Este módulo requiere parámetros trackerId y nombre llenados",
"you or someone registered this email address at" => "usted o alguien regitró esta dirección de correo en",
"Your Tiki information registration" => "Su información de registro en Tiki",
"Your registration" => "Su registro",
"left/right" => "izquierda/derecha",
"Unassign module" => "Inhabilitar módulo",
"home" => "inicio",
"contact us" => "Contáctenos",
"debugger console" => "consola de depurador",
"MyMenu" => "MiMenú",
"User menu" => "Mi Menú",
"dump" => "volcado",
"orphan pages" => "páginas huerfanas",
"received pages" => "páginas recibidas",
"structures" => "estructuras",
"Articles Home" => "Inicio Artículos",
"Send articles" => "Enviar artículos",
"Create/Edit Blog" => "Crear/Editar Blog",
"Browse Directory" => "Navegar Directorio",
"Admin FAQs" => "Administrar FAQs",
"Edit mapfiles" => "Editar archivos de mapa",
"Admin quiz" => "Admin cuestionario",
"Send newsletters" => "Enviar boletín",
"Send events" => "Enviar eventos",
"Admin events" => "Admin eventos",
"Ephemerides" => "Efemérides",
"Admin home" => "Admin inicio",
"Backups" => "Respaldos",
"Edit languages" => "Editar lenguajes",
"External wikis" => "Wikis externos",
"Mods Admin" => "Admin Mods",
"Click here to manage your personal menu" => "Click aquí para manejar su menú personal",
"Quick edit a Wiki page" => "Crea/Edita una página wiki",
"Language: " => "Lenguaje: ",
"Sort posts by:" => "Ordenar posts por:",
"read more" => "leer más",
"Welcome to the Tiki installation and upgrade script" => "Bienvenido al script de instalación y actualización de Tiki",
"Select your language" => "Seleccione su lenguaje",
"Tiki is software distributed under the LGPL license" => "Tiki es un software distribuído bajo la licencia LGPL",
"Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Antes de instalar Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">revise la documentación</a> y confirme que su sistema cumple con los requisitos mínimos",
"This installer will perform some basic checks automatically" => "Este instalador realizará algunas comprobaciones básicas",
"Tiki has not detected your PHP memory_limit" => "Tiki no ha podido detectar su límite de memoria PHP (memory_limit)",
"This probably means you have no set limit (all is well)" => "Esto probablemente signifique que usted no ha especificado in límite (perfecto!)",
"Tiki has detected your PHP memory limit at" => "Tiki ha detectado que su límite de memoria PHP (memory limit) es",
"Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki necesita <strong>como mínimo</strong> 32MB de memoria PHP para la ejecución de scripts",
"Allocating too little memory will cause Tiki to display blank pages" => "Asignar poca memoria causará que Tiki muestre páginas en blanco",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "Para cambiar su límite de memoria, modifique la variable <strong>memory_limit</strong> en su fichero <strong>php.ini </strong>(por ejemplo: memory_limit = 32M) y reinicie su servidor web",
"Tiki has detected your PHP memory_limit at" => "Tiki ha detectado que su límite de memoria PHP (memory limit) es",
"Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki utiliza la función de PHP <strong>mail</strong> para enviar notificaciones y mensajes por email",
"To test your system configuration, Tiki will attempt to send a test message to you" => "Para probar la configuración de su sistema, Tiki intentará enviarte un mensaje de prueba",
"Tiki was able to send a test message to info@tikiwiki.org" => "Tiki consiguió enviar un mensaje de prueba a info@tikiwiki.org",
"Tiki was not able to send a test message" => "Tiki no pudo enviar el mensaje de prueba",
"Review your mail log for details" => "Revise sus logs del mail para más detalles",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Revise las configuración de mail en su fichero <strong>php.ini</strong> (por ejemplo: confirme que <strong>sendmail_path</strong> es correcto)",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Si su servidor requiere de autenticación por SMTP, puede que necesite realizar alguna configuración adicional",
"Tiki detected" => "Tiki detectó",
"Tiki was not able to detect the GD library" => "Tiki no pudo detectar la librería GD",
"Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki utiliza la librería GD para procesar las imágenes en las Galerías de Imágenes y para el soporte de CAPTCHA",
"Tiki requires an active database connection" => "Tiki necesita una conexión activa a una base de datos",
"You must create the database and user <em>before</em> completing this page" => "Usted debe crear una base de datos y un usuario <em>antes</em> de completar este paso de la instalación",
"Tiki cannot find a database connection" => "Tiki no puede encontrar una conexión a la base de datos",
"This is normal for a new installation" => "Esto es lo normal en una nueva instalación",
"Tiki found an existing database connection in your local.php file" => "Tiki encontró una conexión existente a la base de datos en su fichero local.php file",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" title=\"manual installation\">manual installation process</a>" => "Utilizar esta página para crear una nueva conexión con la base de datos, o realizar una <a href=\"http://doc.tikiwiki.org/Manual+Installation\" title=\"manual installation\">instalación manual</a>",
"Enter your database connection information" => "Introduzca la información de su conexión con la base de datos",
"Database type" => "Tipo de base de datos",
"Select the type of database to use with Tiki" => "Seleccione el tipo de base de datos para utilizar con Tiki",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Únicamente las bases de datos soportadas por su instalación de PHP son listadas aquí. Si su base de datos no está en la lista, intente instalar la extensión de PHP apropiada",
"Host name" => "Nombre del Servidor",
"Enter the host name or IP for your database" => "Introduzca el nombre del servidor o la dirección IP para su base de datos",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Utilize <strong>localhost</strong> si la base de datos se encuentra en el mismo servidor que Tiki",
"For SQLite, enter the path and filename to your database file" => "Para SQLite, introduzca la ruta y el nombre de fichero de la base de datos",
"Database name" => "Nombre de la Base de datos",
"Enter the name of the database that Tiki will use" => "Introduzca el nombre de la base de datos que utilizará Tiki",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "La base de datos debe ya existir. Usted puede crear la base de datos utilizando mysqladmin, PHPMyAdmin, cPanel, o preguntando a su proveedor de alojamiento.  Normalmente las tablas de Tiki no provocarán conflicto alguno con otras aplicaciones",
"For Oracle" => "Para Oracle",
"Enter your TNS Name here and leave Host empty" => "Introduzca su Nombre TNS aquí y deje vacío el campo Host",
"Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Anule tnsnames.ora y escriba su SID aquí e introduzca su hostname:port en el campo Host",
"Enter a database user with administrator permission for the Database" => "Introduzca el nombre de usuario de la base datos con permisos de administración en la misma",
"User name" => "Nombre de usuario",
"Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Seleccione el perfil de instalación (o actualización) a utilizar. Este perfil rellenará (o actualizará) la base de datos",
"Select the installation profile to use. This profile will populate the database" => "Seleccione el perfil de instalación a utilizar. Este perfil rellenará la base de datos",
"Profiles can be used to pre-configure your site with specific features and settings" => "Los Perfiles pueden ser utilizados para pre-configurar su sitio Tiki con una configuración y unas características específicas",
"Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information" => "Visite <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> para más información",
"This will destroy your current database" => "Esto destruirá su actual base de datos",
"Create a new database (clean install) with profile" => "Crear una nueva base de datos (instalación limpia) con el perfil",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "Consulte la documentación para <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">las descripciones de los perfiles disponibles",
"The installer could not connect to the Profiles repository" => "El instalador no pudo conectar con el repositorio de perfiles",
"The default installation profile will be used" => "Se utilizará el perfil de instalación por defecto",
"This site has an admin account configured" => "Este sitio tiene una cuenta de administración configurada",
"Please login with your admin password to continue" => "Por favor, regístrese con su contraseña de administración para continuar",
"Your database has been configured and Tiki is ready to run" => "Su base de datos ha sido configurada y Tiki está listo para ser ejecutado",
"If this is your first install, your admin password is <strong>admin</strong>" => "Si esta es su primera instalación, su contraseña de administrador es <strong>admin</strong>",
"You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "Usted puede ahora entrar en Tiki como usuario <strong>admin</strong> y comenzar a configurar la aplicación",
"Upgrade operations executed successfully" => "Operaciones de actualización completadas con éxito",
"Installation operations executed successfully" => "Operaciones de instalación ejecutadas con éxito",
"SQL queries" => "consultas SQL",
"Database was left unchanged" => "La Base de datos no fue modificada",
"Operations failed" => "Las operaciones fallaron",
"Display details" => "Mostrar detalles",
"During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "Durante una actualización, es normal obtener fallos SQL que provocan mensajes de <strong>Table already exists</strong>",
"To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "Para habilitar este fichero, simplemente renombre el fichero <strong>_htaccess</strong> (situado en el directorio principal de su instalación de Tiki) por <strong>.htaccess</strong>",
"Complete these fields to configure common, general settings for your site" => "Rellene estos campos para realizar unas configuraciones generales de su sitio",
"The information you enter here can be changed later" => "La información que introduzca aquí podrá ser modificada después",
"Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Consulte la  <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentación</a> para una completa información sobre estas y otras configuraciones",
"This will appear in the browser title bar" => "Esto aparecerá en la barra de título del navegador",
"Email sent by your site will use this address" => "Los correos-e enviados por su sitio utilizarán esta dirección",
"HTTPS login" => "Registro HTTPS",
"Admin email" => "Correo-e del Administrador",
"This is the email address for your administrator account" => "Éste es el correo-e para la cuenta de administración",
"The installation is complete" => "¡La instalación ha sido completada",
"Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki es un proyecto de software libre / de fuentes abiertas, <em>tu mismo</em> puedes <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>unirte a la comunidad</a> y ayudar <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>a desarrollar Tiki</a>",
"If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "Si esta es una nueva instalación de Tiki, ve a <strong>tiki-admin.php</strong> después de registrarte para comenzar a configurar la aplicación",
"If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "Si esto es una actualización, limpia las memorias caché de Tiki manualmente (el directorio <strong>templates_c</strong>) o utilizando la opción  <strong>Admin &gt; System</strong> desde el menú de Administración",
"System Admin" => "Admin de Sistema",
"Misc" => "Misc",
"Customer Extranet" => "Customer Extranet",
"Displays an miniquiz" => "Muestra un minicuestionario",
"some text" => "algún texto",
"Creates a box with the data" => "Crea un caja con los datos",
"creates a title bar" => "crea una barra de título",
"creates a table" => "crea una tabla",
"makes a horizontal rule" => "hace una línea horizontal",
"page|desc" => "página|desc",
"displays an image" => "muestra una imagen",
"Non cacheable images" => "Imágenes no cacheables",
"height width desc link and align are optional" => "alto ancho desc enlace y alineación son opcionales",
"Wiki File Attachments" => "Adjuntos al Wiki",
"Creates a link to the named file.  If page is not given, the file must be attached to the current page.  If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text.  If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Crea un enlace al archivo nombrado. Si la página no es dada, el archivo debe estar adjunto a la página actual. Si no se da desc, el nombre de archivo es usado para el texto del enlace, a menos que showdesc sea usado, que hace que se use la descripción del archivo como texto del enlace. Si se da image=1, el adjunto es tomado como una imagen y desplegado directamente en la página, no se genera enlace.",
"displays rss feed with id=n maximum=m items" => "muestra el feed rss con id=n y cantidad máxima de items=m",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Será reemplazado por el valor actual del bloque de contenido dinámico con id=n",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" imprime una tabla de contenidos para la página actual basado en estructuras  (toc) o cabezales ! (maketoc)",
"Test email" => "Correo-e para la prueba",
"Email address to send test to" => "Dirección de correo-e a la que enviar la prueba",
"Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Usa esta página para crear una conexión nueva a base de datos, o usa el <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">proceso de instalación manual</a>",
"Adding a new host" => "Añadir un nuevo tiki virtual",
"Are you upgrading an existing Tiki site" => "Estás actualizando un sitio Tiki existente",
"Go directly to the <strong>Install/Upgrade</strong> step" => "Ve directamente al paso de <strong>Instalación / Actualización</strong>",
"Restart the installer" => "Reinicia el instalador",
"If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "Si quieres actualizar desde una versión previa de Tiki, asegúrate de haber leído y entendido las <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">instrucciones de Actualización</a>",
"Tiki is unable to connect to the database " => "Tiki no puede conectarse a la base de datos",
"Tiki was unable to retrieve login data from the database " => "Tiki no pudo recuperar desde la base de datos la información de login",
"The following error message was returned" => "El siguiente mensaje de error fue devuelto",
"Things to check" => "Cosas a revisar",
"Is your database up and running" => "Está su base de datos activa y ejecutándose",
"Are your database login credentials correct" => "Son sus credenciales para conectarse a la base de datos correctas",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Finalizó el <a href='tiki-install.php' >Instalador de Tiki",
"Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Por favor lea <a href=\"http://doc.tikiwiki.org/\">la documentación </a> para más información",
"Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter" => "Las librerías Text_Wiki necesitan ser instaladas. Por favor, consulte http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter",
"PostgeSQL 7.2+" => "PostgeSQL 7.2+",
"Oracle" => "Oracle",
"Sybase" => "Sybase",
"SQLLite" => "SQLLite",
"MSSQL" => "MSSQL",
"Tiki version" => "Versión de Tiki",
"PHP version" => "Versión de PHP",
"newest" => "más nuevo",
"oldest" => "más antiguo",
"on left side" => "a la izquierda",
"on center" => "en el centro",
"on right side" => "a la derecha",
"1 hour" => "1 hora",
"2 hours" => "2 horas",
"10 hours" => "10 horas",
"20 hours" => "20 horas",
"1 year" => "1 año",
"crypt-md5" => "crypt-md5",
"crypt-des" => "crypt-des",
"OpenID and Tiki" => "OpenID y Tiki",
"Admins" => "Administradores",
"Never use transition css" => "Nunca utilizar css de transición",
"Use @version:x.x specified in theme css or none if not specified" => "Utilizar la @version:x.x especificada en el tema css o ninguna si no está especificada",
"Use @version:x.x specified in theme css or 1.9 if not specified" => "Utilizar la @version:x.x especificada en el tema css o 1a 1.9 si no está especificada",
"Use @version:x.x specified in theme css or 2.0 if not specified" => "Utilizar la @version:x.x especificada en el tema css o 1a 2.0 si no está especificada",
"No forums" => "No hay foros",
"\$feature is turned on" => "\$feature está activado/a",
"\$feature is turned off" => "\$feature está desactivado/a",
"Your message has been queued for approval and will be posted after a moderator approves it" => "Su mensaje está pendiente de aprobación, el mensaje será publicado cuando un moderador lo apruebe",
"Sample plugin" => "Plugin de muestra",
"Font family to use" => "Fuente a utilizar",
"As defined by CSS" => "Tal como se define en CSS",
"Select a Wiki page to link to" => "Seleccionar una página Wiki a enlazar",
"Cannot open this file" => "No es posible abrir este fichero",
"This is an approximation based on your server memory limit" => "Esta es una aproximación basada el límite de memoria de su servidor",
"Query point" => "Consulta el punto",
"layer" => "capa",
"Record" => "Grabar",
"You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "Solo puede utilizar optionId = 0 para crear una nueva opción u optionId igual a un id que ya pertenezca al menú en el que va a actualizarlo",
"This poll is closed" => "Esta encuesta está cerrada",
"Feed provided by %s. Click to visit" => "Feed ofrecido por %s. Haga click para visitarlo",
"You need either JQuery or MooTools enabled for this feature" => "Necesita habilitar o JQuery o MooTools para esta característica",
"Help page" => "Página de ayuda",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using TikiWiki with an incorrect database version usually causes errors" => "Su base de datos necesita ser actualizada a la nueva versión de Tikiwiki. Por favor, ejecute  <a href=\"tiki-install.php\">el instalador</a>. Utilizar Tiki con una base de datos incorrecta normalmente provoca errores",
"You are not allowed to upload this type of file" => "No está autorizado a subir este tipo de ficheros",
"The file you are trying upload was only partially uploaded" => "El fichero que estaba intentando subir fue subido parcialmente",
"You must select a file" => "Debe seleccionar un fichero",
"Flash player not available" => "Reproductor Flash no disponible",
"__WARNING__: Plugin disabled \$plugin" => "__ATENCIÓN__: Plugin deshabilitado \$plugin",
"Upload was not successful. Duplicate file content " => "La subida no tuvo éxito. Duplicado del contenido de un archivo ",
"The administrator has not yet validated your account. Please wait" => "El administrador todavía no ha validado su cuenta. Por favor, espere",
"Displays various information about the client" => "Muestra diversas informaciones sobre el cliente",
"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Crea un enlace a una marca en una página. Las marcas pueden ser creadas utilizando el plugin ANAME",
"Anchor link label" => "Etiqueta del enlace a la marca",
"The anchor name as defined in the ANAME plugin" => "El nombre de la marca definido como en el plugin ANAME",
"The name of the wiki page containing the anchor" => "El nombre de la página wiki que contiene la marca",
"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserta una marca en la página wiki. Las marcas pueden ser enlazadas utilizando en plugin ALINK",
"The name of the anchor" => "Nombre de la marca",
"Autogenerated content. Leave blank initially" => "Contenido Autogenerado. Déjelo en blanco inicialmente",
"Absolute URL to the image or relative path from tikiwiki root" => "URL absoluta de la imagen o ruta relativa desde la raíz de tikiwiki",
"Image alignment. Possible values: left, right, center" => "Alineado de la imagen. Posibles valores: izquierda, derecha, centro",
"Image annotations changed" => "Las anotaciones de la imagen cambiaron",
"Creates an annotation block for an image" => "Crea un bloque de anotación para una imagen",
"Displays an image and enables users to define zones to highlight information on the image" => "Muestra una imagen y permite a los usuarios definir zonas donde resaltar información en la imagen",
"Includes an article\\'s content within the page" => "Incluye el contenido de una artículo dentro de la página",
"The article field to display. Default field is Heading" => "Campo del artículo a mostrar. El título es el campo por defecto",
"The article to display. If no value is provided, most recent article will be used" => "Artículo a mostrar. Si no se define ningún valor, se utilizará el artículo más reciente",
"Id is optional. If not given, last article is used. Default field is heading" => "El Id es opcional. Si no se proporciona, el último artículo será utilizado. El campo por defecto es el titular",
"Inserts a list of articles in the page" => "Incluye una lista de los artículos dentro de la página",
"The number of articles to display in the list" => "La cantidad de artículos a mostrar en la lista",
"The ID of the category to list from" => "El ID de la categoría desde la que se va a listar",
"The article language to list" => "El idioma del artículo a listar",
"The column and order of the sort in columnName_asc or columnName_desc format" => "La columna y el tipo de ordenación en formato columnName_asc o columnName_desc",
"Whether to not report when there are no articles" => "No informar cuando no hay artículos",
"Whether to only show the title of the articles" => "Solo mostrar el título de los artículos",
"The wiki page the avatar will link to" => "La página wiki a la que el ávatar enlaza",
"List all pages linking to the specified page" => "Lista todas las páginas wikis que enlazan a la página especificada",
"The page links will point to. Default value is the current page" => "Hacia dónde apuntarán los enlaces de la página. EL valor por defecto es la página actual",
"Use BLOGLIST to include posts from a blog" => "Utilice BLOGLIST para incluir los posts de un blog",
"Maximum number of entries to list" => "Máxima cantidad de entradas en la lista",
"As defined by CSS, name or Hex code" => "Igual que el definido en la CSS, nombre o código hexadecimal",
"In pixels or percentage. Default value is 100%" => "En píxeles o como porcentaje. Valor por defecto: 100",
"for box with width less than 100%, make text wrap around the box" => "para caja con ancho menor que el 100%, hacer que el texto se ajuste a la caja",
"Apply custom CSS class to the box" => "Aplicar una CSS adecuada a la caja",
"List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "Lista de categorías separadas por IDs y el signo +. Ejemplo: 1+2+3. Por defecto se utilizará la categoría de la página actual",
"String used to separate the categories in the path. Default character is >" => "Caracter utilizado para separar categorías en la ruta. Por defecto se utiliza el caracter >",
"Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Muestra un gráfico a partir de TikiSheet. Este plugin puede ser generado por la herramienta chart de TikiSheet",
"Chart caption" => "Título del gráfico",
"List of colors to use" => "Lista de colores a utilizar",
"List of styles to use" => "Lista de estilos a utilizar",
"Labels for the series or values in the legend" => "Etiquetas para las series o los valores en la leyenda",
"Code snippet label" => "Trozo de código para la etiqueta",
"0|1, may not be used with colors" => "0|1, no puede utlizarse con colores",
"0|1, parse wiki syntax within the code snippet" => "0|1, parsear sintasis wiki dentro de trozo de código",
"latin" => "latin",
"Charts" => "Charts",
"Quicktags" => "Quicktags",
"QuickTags" => "QuickTags",
"Top Sites" => "Top Sites",
"Featured Help" => "Featured Help",
"JsCalendar" => "JsCalendar",
"Workflow" => "Workflow",
"Unix" => "Unix",
"Windows" => "Windows",
"(standard)" => "(standard)",
"PEAR::Auth" => "PEAR::Auth",
"Editor" => "Editor",
"Webmaster" => "Webmaster",
"hits" => "hits",
"Top 10 items" => "Top 10 items",
"Top 20 items" => "Top 20 items",
"Top 40 items" => "Top 40 items",
"Top 50 items" => "Top 50 items",
"Top 100 items" => "Top 100 items",
"Top 250 items" => "Top 250 items",
"Rank 1..5" => "Rank 1..5",
"Rank 1..10" => "Rank 1..10",
"Ranks" => "Ranks",
"Ver" => "Ver",
"phpLayersMenus" => "phpLayersMenus",
"Admin Quicktags" => "Admin Quicktags",
"rss feed" => "rss feed",
"tagline" => "tagline",
"Int" => "Int",
"Manual" => "Manual",
"inter" => "inter",
"val" => "val",
"Workitems" => "Workitems",
"ver:" => "ver:",
"If:SetNextact" => "If:SetNextact",
"Switch construct" => "Switch construct",
"Proc" => "Proc",
"auto" => "auto",
"int" => "int",
"Personal Blog and Profile" => "Personal Blog and Profile",
"Small Organization Web Presence" => "Small Organization Web Presence",
"Company Intranet" => "Company Intranet",
"Collaborative community" => "Collaborative community",
"/" => "/",
"Tiki Shoutbox" => "Tiki Shoutbox",
"eek" => "eek",
"lol" => "lol",
"mr green" => "mr green",
"razz" => "razz",
"rolleyes" => "rolleyes",
"twisted" => "twisted",
"santa" => "santa",
"info/vote" => "info/vote",
"Dif" => "Dif",
"This instance of activity is already complete" => "Esta instancia de actividad ya está completada",
"Fatal error: cannot execute automatic activity \$activityId" => "Error fatal: no puedo ejecutar actividad automática \$activityId",
"Fatal error: setting next activity to an unexisting activity" => "Error fatal: poner siguiente actividad a una actividad inexistente",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Error fatal: nextActivity no se corresponde con ningún candidato en cambio de actividad autoruteada",
"Fatal error: non-deterministic decision for autorouting activity" => "Error fatal: decisión no determinista para actividad de autoruteo",
"Fatal error: trying to send an instance to an activity but no transition found" => "Error fatal: intentando enviar una instancia a una actividad pero no se encontró transición",
"Cannot add transition only split activities can have more than one outbound transition" => "No puedo añadir transición sólo actividades divididas pueden tener mas que una transición saliente",
"Circular reference found some activity has a transition leading to itself" => "Referencia circular encontrada, alguna actividad tiene una transición que lleva a si misma",
"Process does not have a start activity" => "El proceso no tiene ninguna actividad inicial",
"Process does not have exactly one end activity" => "El proceso no tiene exactamente una actividad final",
"End activity is not reachable from start activity" => "La actividad final no es alcanzable desde la actividad inicial",
"is interactive but has no role assigned" => "es interactiva pero no tiene rol asignado",
"is non-interactive and non-autorouted but has no role assigned" => "es no interactiva y no autoruteada pero no tiene rol asignado",
"is standalone but has transitions" => "es independiente pero tiene transiciones",
"Role" => "Rol",
"is not mapped" => "no está mapeada",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "La actividad '.\$res['name'].' es independiente y usa el objeto \$instance",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "La actividad '.\$res['name'].' es interactiva por lo que tiene que usar el método \$instance->complete()",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "La actividad '.\$res['name'].' es no-interactiva por lo que no debe usar el método \$instance->complete()",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "La actividad '.\$res['name'].' es cambio por lo que debe usar el método \$instance->setNextActivity(\$actname)",
"Process %d has been activated" => "El proceso %d fue activado",
"Process %d has been deactivated" => "El proceso %d fue desactivado",
"Process %s %s imported" => "Proceso %s %s importado",
"Process %s removed" => "El proceso %s ha sido eliminado",
"Process %s has been updated" => "El proceso %s ha sido actualizado",
"Process %s has been created" => "El proceso %s ha sido creado",
"<return> for rows" => "\\n para filas",
"Any 2 versions" => "2 versiones cualquiera",
"english" => "inglés",
"Report all errors except notices" => "Reportar todos los errores excepto notificaciones",
"1 day" => "1 dia",
"1 week" => "1 semana",
"1 month" => "1 mes",
"Just Tiki" => "Sólo Tiki",
"Tiki and PEAR::Auth" => "Tiki y PEAR::Auth",
"choose a group ..." => "elija un grupo ...",
"%s enabled" => "%s activado",
"%s disabled" => "%s desactivado",
"Forums last topics" => "Foros últimos temas",
"An error occured in a database query!" => "Ocurrió un error en una consulta a la base de datos!",
"games" => "juegos",
"Altering database table failed" => "Alterar la tabla de la base de datos fallo",
"Insert a division block on wiki page" => "Inserta un bloque divisor en una página wiki",
"drawing not found" => "dibujo no encontrado",
"heads and cells separated by ~|~" => "cabezales y celdas separados por ~|~",
"Please provide an Id" => "Por favor ingrese un Id",
"Listing configuration" => "Configuración de listado",
"best regards" => "de nuestra mayor consideración",
"your Tikiwiki" => "su Tikiwiki",
"Tiki User Registration Request" => "Tiki Pedido de Registro de Usuario",
"Tiki email notification" => "Tiki correo de notificación",
"Your Tiki account information for %s" => "Su información de cuenta Tiki para %s",
"TikiWiki Assistant" => "Asistente Tikiwiki",
"Recently visited pages" => "Páginas recientemente visitadas",
"Last `\$module_rows` Sites" => "Últimos `\$module_rows` Sitios",
"Last Sites" => "Últimos Sitios",
"Directory Stats" => "Estadísticas de Directorio",
"Sites to validate" => "Sitios a validar",
"Visited links" => "Enlaces visitados",
"Top \$module_rows Sites" => "\$module_rows principales sitios",
"Top `\$module_rows` topics" => "`\$module_rows` principales temas",
"Last `\$module_rows` forum posts" => "Últimos `\$module_rows` mensajes en foro",
"Last `\$module_rows` forum topics" => "Últimos `\$module_rows` temas en foros",
"Last `\$module_rows` actions" => "Últimas `\$module_rows` acciones",
"Last `\$module_rows` articles" => "Últimos `\$module_rows` artículos",
"Last articles" => "Últimos artículos",
"Last `\$module_rows` blog posts" => "Últimos `\$module_rows` blog posts",
"Last `\$module_rows` Created blogs" => "Últimos `\$module_rows` blogs creados",
"Last `\$module_rows` Created FAQs" => "Últimas `\$module_rows` FAQs creadas",
"Last `\$module_rows` Created Quizzes" => "Últimos `\$module_rows` Cuestionarios Creados",
"Last `\$module_rows` modified file galleries" => "Últimas `\$module_rows` galerías de archivos modificadas",
"Last `\$module_rows` Files" => "Últimos `\$module_rows` Archivos",
"Last `\$module_rows` galleries" => "Últimas `\$module_rows` galerías",
"Last galleries" => "Últimas galerías",
"Last `\$module_rows` Images" => "Últimas `\$module_rows` Imágenes",
"Last `\$module_rows` modified events" => "Últimos `\$module_rows` eventos modificados",
"Last `\$module_rows` changes" => "Últimos `\$module_rows` cambios",
"Last `\$module_rows` Modified Items" => "Últimos `\$module_rows` Items Modificados",
"Last `\$module_rows` Modified blogs" => "Últimos `\$module_rows` blogs modificados",
"Last `\$module_rows` submissions" => "Últimas `\$module_rows` colaboraciones",
"Last `\$module_rows` Items" => "Últimos `\$module_rows` Ítems",
"Menu" => "Menú",
"New Messages" => "Nuevos mensajes",
"New Message" => "Nuevo mensaje",
"Random Images" => "Imágenes aleatorias",
"Top `\$module_rows` articles" => "Últimos `\$module_rows` artículos",
"Top `\$module_rows` File Galleries" => "`\$module_rows` principales Galerías de Archivos",
"Top `\$module_rows` files" => "`\$module_rows` principales archivos",
"Top `\$module_rows` Forum Posters" => "Principales `\$module_rows` participantes en Foros",
"Top `\$module_rows` games" => "`\$module_rows` principales juegos",
"Top games" => "Top juegos",
"Top `\$module_rows` galleries" => "`\$module_rows` principales galerías",
"Top `\$module_rows` Images" => "`\$module_rows` principales imágenes",
"Top `\$module_rows` Pages" => "`\$module_rows` principales Páginas",
"Top `\$module_rows` Quizzes" => "`\$module_rows` principales Cuestionarios",
"Most `\$module_rows` visited blogs" => "`\$module_rows` blogs más visitados",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` FAQs mas visitadas",
"Whats related" => "Qué está relacionado",
"Last `\$module_rows` wiki comments" => "Últimos `\$module_rows` comentarios wiki",
"on page" => "en página",
"show structures" => "mostrar estructuras",
"hide structures" => "ocultar estructuras",
"Creation date" => "Fecha de creación",
"My workflow" => "Mi workflow",
"Feature" => "Característica",
"Number of columns per page when listing categories" => "Número de columnas por página cuando se listan categorías",
"enable cool sites" => "activar sitios interesantes",
"PhpLayers Dynamic menus" => "PhpLayers Menús dinámicos",
"Tiki Sheet" => "Planilla Tiki",
"Drawings" => "Ilustraciones",
"Games" => "Juegos",
"Administration Features" => "Funciones de Administración",
"Banning System" => "Sistema de Baneo",
"User Features" => "Funciones de Usuario",
"Newsreader" => "Noticias",
"Workflow engine" => "Engine de Workflow",
"Unknown/Other" => "Otro",
"(some Unix MTA)" => "(algun MTA de Unix)",
"Tikiwiki.org help" => "Ayuda Tikiwiki.org",
"Store session data in database" => "Guardar datos de la sesión en la base de datos",
"Long date format" => "Formato de fechas largas",
"Short date format" => "Formato de fechas cortas",
"Long time format" => "Formato largo para horas",
"Short time format" => "Formato corto para horas",
"New password" => "Nueva contraseña ",
"HTTP port" => "puerto HTTP",
"HTTPS port" => "puerto HTTPS",
"PAM service" => "Servicio PAM",
"CAS server version" => "Versión de servidor CAS",
"Reg users can change theme" => "Usuarios registrados pueden cambiar tema",
"Slideshows theme" => "Tema para diapositivas",
"Template Viewing" => "Vista de Plantillas",
"Site logo background color" => "Color de fondo de logo del sitio",
"Site logo title (on mouse over)" => "Título del logo del sitio (para mouse over)",
"Site Breadcrumbs" => "Breadcrumbs del sitio",
"at top of page" => "al tope de la página",
"at top of center column" => "al tope de la columna central",
"entire location" => "toda la ubicación",
"page name" => "nombre de página",
"Default RDF version" => "Versión por defecto de RDF",
"Individual cache" => "Caché individual",
"Perms inherited from closest parent if possible or from global perms" => "Permisos heredados de los parientes mas cercanos de ser posible o de permisos globales",
"Assign permissions automatically" => "Asignar permisos automáticamente",
"recommended for best performance" => "recomendado para mejor performance",
"image gal" => "gal imágenes",
"file gal" => "gal archivos",
"Admin chart items" => "Admin items de charts",
"Edit Chart" => "Editar chart",
"Chart items" => "Items de Chart",
"No items defined yet" => "No hay items definidos aún",
"Add or edit a chart" => "Añadir o editar un chart",
"Users can vote for only one item from this chart per period" => "Los usuarios pueden votar por sólo un item de este chart por período",
"Prevent users from voting for the same item more than once" => "Prevenir usuarios de votar por el mismo ítem mas de una vez",
"Users can suggest new items" => "Usuarios pueden sugerir nuevos items",
"Auto validate user suggestions" => "Autovalidar sugerencias de usuarios",
"Ranking shows" => "Ranking muestra",
"All items" => "Todos los items",
"Voting system" => "Sistema de votaciones",
"Vote items" => "Votar items",
"Ranking frequency" => "Ranking frecuencia",
"Realtime" => "Tiempo real",
"Each 5 minutes" => "Cada 5 minutos",
"Show Average" => "Mostrar promedio",
"Show Votes" => "Mostrar votos",
"Use Cookies for unregistered users" => "Usar Cookies para usuarios no registrados",
"Users can vote again after" => "Los usuarios pueden votar en contra después de",
"Anytime" => "En cualquier momento",
"No charts defined yet" => "No se definieron charts aún",
"Admin drawings" => "Admin ilustraciones",
"Available drawings" => "Ilustraciones disponibles",
"no display" => "no mostrar",
"Available polls" => "Votaciones disponibles",
"Random image from" => "Imagen aletoria de",
"Dynamic content blocks" => "Bloques de contenido dinámico",
"Banner zones" => "Zonas de banners",
"Group users" => "Agrupar usuarios",
"Create/Edit QuickTags" => "Crear/Editar QuickTags",
"Insert (use 'text' for figuring the selection)" => "Insertar (use 'texto' para simbolizar la selección)",
"Path to the tag icon" => "Camino al icono del tag",
"Admin RSS Modules" => "Admin módulos RSS",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Esta página es para configurar preferencias de feeds RSS leídos/importados por Tiki. Para generar/exportar RSS feeds, busque \"RSS feeds\" en el panel de admin, o",
"show feed title" => "mostrar título del feed",
"show publish date" => "mostrar fecha de publicación",
"Templates compiler" => "Compilador de plantillas",
"Compile" => "Compilar",
"Member of the default group of creator can modify items?" => "¿Miembros del grupo por defecto del creador pueden modificar ítems?",
"Group Homepage" => "Página inicio de Grupo",
"Members List" => "Lista de Miembros",
"Rejected users" => "Usuarios rechazados",
"Edit Account Settings" => "Editar opciones de cuenta",
"Set the default group of the selected users to" => "Ponga el grupo por defecto de los usuarios seleccionados en",
"Default Group" => "Grupo por Defecto",
"Old password" => "Contraseña actual",
"Parent category" => "Categoría superior",
"Most visited sub-categories" => "Sub-categorías mas visitadas",
"Category description" => "Descripción de categoría",
"Random sub-categories" => "Sub-categorias aletorias",
"Allow sites in this category" => "Permitir sitios en esta categoría",
"Show number of sites in this category" => "Mostrar número de sitios en esta categoría",
"Subcategories" => "Subcategorías",
"Admin related categories" => "Admin categorías relacionadas",
"Add a related category" => "Añadir categoría relacionada",
"Related categories" => "Categorías relacionadas",
"Add a Category" => "Agregar categoría",
"in current category" => "en la categoría actual",
"Total categories" => "Total categorías",
"creates the editable drawing foo" => "crea el dibujo editable foo",
"table" => "tabla",
"table new" => "nueva tabla",
"external link" => "enlaces externos",
"wiki link'" => "enlace wiki'",
"heading1" => "encabezado1",
"title bar" => "barra de título",
"box" => "caja",
"dynamic content" => "contenido dinámico",
"center text" => "centrar texto",
"colored text" => "texto en colores",
"dynamic variable" => "variables dinámicas",
"New wms Metadata" => "Nuevo metadato wms",
"New Class" => "Nueva Clase",
"New Projection" => "Nueva Proyección",
"New Query" => "Nueva Consulta",
"New Scalebar" => "Nueva barra de escala",
"New Layer" => "Nueva Capa",
"New Label" => "Nueva etiqueta",
"New Reference" => "Nueva Referencia",
"New Legend" => "Nueva Leyenda",
"New Web" => "Nueva Web",
"New Outputformat" => "Nuevo formato de salida",
"New Mapfile" => "Nuevo archivo de mapa",
"special chars" => "caracteres especiales",
"special characters" => "caracteres especiales",
"Questions per page" => "Preguntas por página",
"Activity completed" => "Actividad completada",
"Admin process activities" => "Admin actividades de proceso",
"Add or edit an activity" => "Añadir o editar una actividad",
"activity" => "actividad",
"split" => "dividir",
"join" => "unir",
"standalone" => "autónomo",
"interactive" => "interactivo",
"auto routed" => "auto ruteado",
"Expiration Time" => "Tiempo de Expiracion",
"Years" => "Años",
"Months" => "Meses",
"Minutes" => "Minutos",
"Add transitions" => "Añadir transición",
"Add transition from:" => "Añadir transición desde:",
"Add transition to:" => "Añadir transición a:",
"No roles associated to this activity" => "No hay roles asociados a esta actividad",
"Add Role" => "Añadir rol",
"Add New" => "Añadir nuevo",
"Process activities" => "Actividades de proceso",
"Routing" => "Ruteos",
"Interactive" => "Interactivo",
"Automatic" => "Automatico",
"Auto routed" => "Auto ruteado",
"route" => "ruta",
"(no roles)" => "(sin roles)",
"No activities defined yet" => "No hay actividades definidas aún",
"Process Transitions" => "Procesar Transiciones",
"List of transitions" => "Lista de transiciones",
"Origin" => "Origen",
"No transitions defined yet" => "No hay transiciones definidas aún",
"Add a transition" => "Añadir transición",
"Process Graph" => "Procesar Grafo",
"Galaxia Admin Graph" => "Galaxia Admin Grafo",
"Galaxia Admin Graph tpl" => "Galaxia Admin Grafo tpl",
"Edit Tpl" => "Editar tpl",
"This process is invalid" => "Este proceso no es válido",
"Process Graph for" => "Procesar Grafo para",
"No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed." => "No hay grafo de proceso disponible. O el proceso aún contiene errores, el grafo no está generado aun o <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> no está apropiadamente instalado.",
"List of processes" => "Lista de procesos",
"Inactive" => "Inactivo",
"Active Process" => "Procesos activos",
"Invalid Process" => "Proceso inválido",
"Valid Process" => "Proceso válido",
"Activities" => "Actividades",
"New Minor" => "Nuevo menor",
"New Major" => "Nuevo mayor",
"No processes defined yet" => "No hay procesos definidos aún",
"Admin instance" => "Admin instancia",
"Process:" => "Proceso:",
"Instance" => "Instancia",
"exception" => "excepción",
"completed" => "completada",
"Send all to" => "Enviar todo a ",
"Don't move" => "No mover",
"Act status" => "Act estado",
"Ended" => "Terminada",
"Not Defined" => "No Definido",
"Not Interactive" => "No Interactivo",
"Not Ended" => "No terminada",
"Property" => "Propiedad",
"Add property" => "Añadir propiedad",
"run instance" => "ejecutar instancia",
"Executed" => "Ejecutada",
"erase" => "borrar",
"Admin processes" => "Admin procesos",
"Galaxia Admin Processes" => "Galaxia Admin Procesos",
"Galaxia Admin Processes tpl" => "Galaxia Admin Procesos tpl",
"Add or edit a process" => "Añadir o editar proceso",
"Process Name" => "Nombre de proceso",
"is active?" => "¿es activo?",
"Or upload a process using this form" => "O suba un proceso usando este formulario",
"Admin process roles" => "Admin roles de proceso",
"Add or edit a role" => "Añadir o editar un rol",
"Process roles" => "Procesar roles",
"No roles defined yet" => "No hay roles definidos aún",
"Map users to roles" => "Mapear usuarios a roles",
"map" => "mapear",
"Map groups to roles" => "Mapear grupos a roles",
"Operation" => "Operación",
"No roles are defined yet so no roles can be mapped" => "No se definieron roles aún por lo que no hay roles a mapear",
"List of mappings" => "Listado de mapeos",
"No mappings defined yet" => "No se definieron mapeos aún",
"Admin process sources" => "Admin fuentes de procesos",
"select source" => "seleccionar fuente",
"Shared code" => "Código compartido",
"Set next user" => "Configurar siguiente usuario",
"Get property" => "Obtener propiedad",
"Set property" => "Configurar propiedad",
"Process form" => "Formulario de proceso",
"Set Next act" => "Configurar siguiente acto",
"Map process roles" => "Mapear roles de proceso",
"Admin Processes" => "Admin procesos",
"Admin Activities" => "Admin activitidades",
"Admin Roles" => "Admin roles",
"Edit this Process" => "Editar este proceso",
"Monitor Activities" => "Suscribirse a actividades",
"Galaxia Monitor Activities" => "Galaxia Monitor Actividades",
"Galaxia Monitor Activities tpl" => "Galaxia Monitor Actividades tpl",
"List of activities" => "Listado de actividades",
"routing" => "ruteos",
"Instances" => "Instancias",
"run" => "ejecutar",
"run activity" => "ejecutar actividad",
"Enter the name of this instance" => "Ingrese el nombre de esta instancia",
"The name is not valid. Please, enter the name again" => "El nombre no es válido, ingréselo nuevamente",
"monitor processes" => "suscribirse a procesos",
"monitor activities" => "suscribirse a actividades",
"monitor instances" => "suscribirse a instancias",
"monitor workitems" => "suscribirse a workitems",
"Monitor Instances" => "Suscribirse a instancias",
"Galaxia Monitor Instances" => "Galaxia Monitor Instancias",
"Galaxia Monitor Instances tpl" => "Galaxia Monitor Instancias tpl",
"List of instances" => "Lista de instancias",
"Not ended" => "No terminada",
"No instances created yet" => "No se crearon instancias aún",
"Monitor Processes" => "Suscribirse a procesos",
"Galaxia Monitor Processes" => "Galaxia Monitor Procesos",
"Galaxia Monitor Processes tpl" => "Galaxia Monitor Procesos tpl",
"processes" => "procesos",
"being run" => "siendo ejecutado",
"Exceptions" => "Excepciones",
"Monitor workitems" => "Suscribirse a workitems",
"List of workitems" => "Listado de workitems",
"instance" => "instancia",
"My activities" => "Mis actividades",
"Current Activity" => "Actividad actual",
"Assigned To" => "Asignado a",
"exception instance" => "instancia de excepcion",
"exceptions instance" => "instancia de excepciones",
"Send Instance" => "Enviar instancia",
"abort instance" => "abortar instancia",
"grab instance" => "obtener instancia",
"release instance" => "liberar instancia",
"No activities found" => "No se encontraron actividades",
"My instances" => "Mis instancias",
"No instances found" => "No se encontraron instancias",
"User Activities" => "Actividades de usuario",
"Galaxia User Activities" => "Galaxia Actividades de Usuario",
"Galaxia User Activities tpl" => "Galaxia Actividades de Usuario tpl",
"process" => "proceso",
"user processes" => "procesos de usuario",
"user activities" => "actividades de usuario",
"user instances" => "instancias de usuarios",
"User Instances" => "Instancias de usuario",
"Galaxia User Instances" => "Galaxia Instancias de Usuario",
"Galaxia User Instances tpl" => "Galaxia Instancias de Usuario tpl",
"Inst Status" => "Inst Estado",
"Not defined" => "No definido",
"No instances defined yet" => "No hay instancias definidas aún",
"User Processes" => "Procesos de usuario",
"Galaxia User Processes" => "Galaxia Procesos de Usuario",
"Galaxia User Processes tpl" => "Galaxia Procesos de Usuario tpl",
"Browsing Workitem" => "Navegando Workitem",
"Workitem information" => "Información Workitem",
"Install &amp; Update Profile" => "Instalar &amp; Actualizar Perfil",
"Bare-bones default install" => "Bare-bones instalación por defecto",
"Use cache for external pages" => "Usar cache para páginas externas",
"All games are from" => "Todos los juegos son de",
"visit the site for more games and fun" => "visite el sitio para mas información o juegos",
"Upload a game" => "Subir un juego",
"Upload a new game" => "Subir un nuevo juego",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Miniatura (si el juego se llama foo.swf la imagen debe ser foo.swf.gif o foo.swf.jpg o foo.swf.png)",
"Edit game" => "Editar juego",
"Played" => "Jugado",
"If you can't see the game then you need a flash plugin for your browser" => "Si no puede ver el juego necesita un plugin de Flash para su navegador",
"Accepted requests" => "Aceptar pedidos",
"since" => "desde",
"Assigned items" => "Items asignados",
"Select news group" => "Seleccione grupo de noticias",
"Back to servers" => "Volver a servidores",
"Msgs" => "Msjs",
"News from" => "Grupos de noticias desde",
"Back to groups" => "Volver a grupos",
"Save position" => "Salvar posición",
"Reading article from" => "Leer artículo desde",
"Back to list of articles" => "Volver a lista de artículos",
"Newsgroup" => "Grupo de noticias",
"Configure news servers" => "Configurar servidores de grupos de noticias",
"Configure Newsreader" => "Configurar lector de grupos de noticias",
"configure newsreader server tpl" => "configurar servidor lector de noticias tpl",
"Select a news server to browse" => "Seleccionar un servidor de grupos de noticias para recorrer",
"server" => "servidor",
"Read the news" => "Leer las noticias",
"News server" => "Servidor de Grupos de noticias",
"Current permissions for this object" => "Permisos actuales para este objeto",
"No category permissions; global permissions apply" => "No hay permisos de categoría, se aplican permisos globales",
"Preview of version" => "Previsualización de la versión",
"Source of version" => "Fuente de versión",
"Replicate" => "Replicar",
"Slave" => "Esclavo",
"Master" => "Maestro",
"Operations" => "Operaciones",
"Operations Log" => "Log de Operaciones",
"Click to Navigate" => "Cliquear para navegar",
"Focus:" => "Foco:",
"big grin" => "gran sonrisa",
"cry" => "llorar",
"evil" => "malvado",
"redface" => "ruborizado",
"smile" => "sonrisa",
"surprised" => "sorprendido",
"arrow" => "flecha",
"Note: Maximum image size is limited to" => "Nota: Tamaño máximo de archivo es limitado por",
"Current folder" => "Carpeta actual",
"This user is your friend" => "Este usuario es su amigo",
"Your personal Wiki Page" => "Su página personal en el Wiki",
"Your personal tracker information" => "Su tracker de información personal",
"Confirm new password" => "Confirmar nueva contraseña",
"Current password (required)" => "Contraseña actual (requerido)",
"Edit Items" => "Editar items",
"List Charts" => "Listar charts",
"Last Chart" => "último chart",
"Previous Chart" => "Chart anterior",
"Chart created" => "Chart creado",
"Next Chart" => "Next chart",
"Permanency" => "Permanencia",
"chg" => "camb",
"Avg" => "Prom",
"Next chart will be generated on" => "El siguiente chart será generado en",
"View or vote items not listed in the chart" => "Ver o votar ítems que no están listados en el chart",
"Select something to vote on" => "Seleccionar algo sobre que votar",
"Item information" => "Información de item",
"Best Position" => "Mejor Posición",
"Vote this item" => "Votar este item",
"Highest" => "Superior",
"Number of voices" => "Número de voces",
"RSS settings" => "Configuracion RSS",
"No chart indicated" => "No se indicó chart",
"No category indicated" => "No se indicó categoría",
"Permission denied; you cannot assign permissions for this category" => "Permiso denegado; no puede asignar permisos para esta categoría",
"Last sites of directory \".\$rc[\"name\"].\" ." => "Últimos sitios en directorio \".\$rc[\"name\"].\" .",
"No process indicated" => "No se indicó proceso",
"Activity name already exists" => "Ya existe ese nombre de actividad",
"indicates if the process is active. Invalid processes cant be active" => "indica si el proceso es activo. Procesos no válidos no pueden estar activos",
"No instance indicated" => "No se indicaron instancias",
"No activity indicated" => "No se indicó actividad",
"The process name already exists" => "El nombre de proceso ya existe",
"Process already exists" => "El proceso ya existe",
"You cant execute this activity" => "No puede ejecutar esta actividad",
"You couldn't abort a instance" => "No puede abortar una instancia",
"You couldn't exception a instance" => "No puede hacer una excepcion en una instancia",
"No title indicated" => "No se indicó título",
"No comment indicated" => "No se indicó comentario",
"No date indicated" => "No se indicó fecha",
"The game file must have .swf or .dcr extension" => "El juego debe tener una extensión .swf o .dcr",
"The thumbnail name must be" => "La miniatura debe ser",
"Please supply both files" => "Por favor supla ambos archivos",
"No server indicated" => "No se indicó servidor",
"Cannot connect to" => "No puedo conectarme a",
"Missing information to read news (server,port,username,password,group) required" => "Información faltante para leer grupos de noticias (servidor,puerto,usuario,contraseña,grupo) requerida",
"Cannot get messages" => "No puedo obtener mensajes",
"A password and your IP address reminder email has been sent " => "Un correo recordatorio de su contraseña y dirección IP ha sido enviado ",
"changed '%s' from '%s' to '%s'" => "cambiado '%s' de '%s' a '%s'",
"Chat" => "Chat",
"RSS feeds" => "RSS feeds",
"Tiki Calendar" => "Calendario Tiki",
"Admin Menu" => "Menú admin",
"RSS Modules" => "módulos RSS",
"Import PHPWiki Dump" => "Importar Volcado PHPWiki",
"Last `\$module_rows` visitors" => "Últimos `\$module_rows` visitantes",
"Tiki Logo" => "Logo Tiki",
"User informations" => "Información de Usuario",
"Group informations" => "Información de Grupo",
"Email This Post" => "mandar mensaje con este post",
"Use titles in blog posts" => "Usar títulos en posts de blogs",
"Send blog post" => "Enviar post de blog",
"A link to this post was sent to the following addresses:" => "Un enlace a este post fue enviado a las siguientes direcciones:",
"Send post to this addresses" => "Enviar post a esta dirección",
"List of email addresses separated by commas" => "Lista de direcciones de correo separadas por comas",
"Compose Message" => "Componer Mensaje",
"If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Si sus conocidos quieren ser capaces de responderle a usted, tiene que marcar <a href='tiki-user_preferences.php'>Permitir mensajes desde otros usuarios</a>",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> borrado exitosamente.",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> asignado a %s <b>%s</b>.",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> borrado de %s <b>%s</b>.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "grupo <b>%s</b> puesto como grupo por defecto de usuario <b>%s</b>.",
"Post recommendation at" => "Enviar recomendación en",
"Prevent flooding" => "Prevenir flooding",
"Minimum time between posts" => "Tiempo mínimo entre mensajes",
"Moderator user" => "Usuario moderador",
"Moderator group" => "Grupo moderador",
"Send this forums posts to this email" => "Enviar mensajes de este foro a este correo",
"Prune unreplied messages after" => "Eliminar mensajes sin respuestas después de",
"Prune old messages after" => "Eliminar viejos mensajes después de",
"POP3 server" => "Servidor POP3",
"Max attachment size (bytes)" => "Tamaño máximo del adjunto (bytes)",
"Default ordering for topics" => "Orden por defecto para temas",
"Topics per page" => "Temas por página",
"Default ordering for threads" => "Orden por defecto para mensajes",
"Includes" => "Incluye",
"Assign Perms to this Group" => "Asignar perms a este grupo",
"Assign permissions to category" => "Asignar permisos a categoría",
"Current permissions for this category" => "Permisos actuales para esta categoría",
"Remove from this Category Only" => "Borrar sólo de esta categoría",
"Remove from this Category &amp; all its Children" => "Borrar esta categoría y todos sus hijos",
"Assign permissions" => "Asignar permisos",
"to group" => "a grupo",
"this category &amp; all its children" => "esta categoría y todos sus hijos",
"this category only" => "sólo esta categoría",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Asignar permisos para <b>todos los hijos</b> es recomendado para un mejor rendimiento.",
"ERROR: you must include a subject or a message at least" => "ERROR: debe incluir un tema o un mensaje al menos",
"Your registration code:" => "Su código de registro:",
"Registration code" => "Código de registro",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Albania" => "Albania",
// "Andorra" => "Andorra",
// "Anguilla" => "Anguilla",
// "Aruba" => "Aruba",
// "Azerbaijan" => "Azerbaijan",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bhutan" => "Bhutan",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "Burkina Faso" => "Burkina Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
// "Cape Verde" => "Cape Verde",
// "Catalan Countries" => "Catalan Countries",
// "Central African Republic" => "Central African Republic",
// "Chad" => "Chad",
// "Christmas Island" => "Christmas Island",
// "Cocos Islands" => "Cocos Islands",
// "Comoros" => "Comoros",
// "Congo" => "Congo",
// "Congo Democratic" => "Congo Democratic",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Eritrea" => "Eritrea",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Faroe Islands" => "Faroe Islands",
// "French Guiana" => "French Guiana",
// "French Southern Territories" => "French Southern Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greenland" => "Greenland",
// "Guadeloupe" => "Guadeloupe",
// "Guernsey" => "Guernsey",
// "Guinea" => "Guinea",
// "Guinea Bissau" => "Guinea Bissau",
// "Guyana" => "Guyana",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Hong Kong" => "Hong Kong",
// "Isle of Man" => "Isle of Man",
// "Jersey" => "Jersey",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mayotte" => "Mayotte",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Netherlands Antilles" => "Netherlands Antilles",
// "Niger" => "Niger",
// "Norfolk Island" => "Norfolk Island",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "North Korea" => "North Korea",
// "Oman" => "Oman",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Reunion" => "Reunion",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "San Marino" => "San Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "Sudan" => "Sudan",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Swaziland" => "Swaziland",
// "Syria" => "Syria",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tunisia" => "Tunisia",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Uganda" => "Uganda",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "US Virgin Islands" => "US Virgin Islands",
// "Uzbekistan" => "Uzbekistan",
// "Vatican" => "Vatican",
// "Viet Nam" => "Viet Nam",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Western Sahara" => "Western Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
// "PostgreSQL" => "PostgreSQL",
// "Slovene" => "Slovene",
// "The global quota has been reached" => "The global quota has been reached",
// "The quota has been reached in" => "The quota has been reached in",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transfered to the database" => "Number of files transfered to the database",
// "Number of files transfered to the file system" => "Number of files transfered to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No box" => "No box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Perspective" => "Perspective",
// "Only display the module if in one of the listed perspectives. Semi-colon separated" => "Only display the module if in one of the listed perspectives. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "Title length" => "Title length",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Default number per page" => "Default number per page",
// "Default Ordering" => "Default Ordering",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and LDAP" => "Tiki and LDAP",
// "Available languages" => "Available languages",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Blogues" => "Blogues",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Exclude these categories" => "Exclude these categories",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Spell checking" => "Spell checking",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "Default charset for sending mail" => "Default charset for sending mail",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Show Country Flag" => "Show Country Flag",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "'),\n\t\t\t'type' => 'flag" => "'),\n\t\t\t'type' => 'flag",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "'),\n\t\t\t'type' => 'text" => "'),\n\t\t\t'type' => 'text",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Faqs" => "Faqs",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Enables searching for content on the website" => "Enables searching for content on the website",
// "Freetags" => "Freetags",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Action Log" => "Action Log",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Quizzes " => "Quizzes ",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Multimedia" => "Multimedia",
// "The applet is designed to read MP3 or FLV file" => "The applet is designed to read MP3 or FLV file",
// "Experimental. This feature is not actively maintained" => "Experimental. This feature is not actively maintained",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Tell a Friend" => "Tell a Friend",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation " => "Comments Moderation ",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow posting of comments as Anonymous" => "Allow posting of comments as Anonymous",
// "Permit anonymous visitors to add a comment without needing to create an account" => "Permit anonymous visitors to add a comment without needing to create an account",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page title" => "Display page title",
// "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header" => "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector" => "JavaScript popup date selector",
// "Output should be HTMLPurified" => "Output should be HTMLPurified",
// "This enable HTPMPurifier on outputs to filter remaining security problems like XSS" => "This enable HTPMPurifier on outputs to filter remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "Allow users to activate fullscreen mode" => "Allow users to activate fullscreen mode",
// "Css Menus" => "Css Menus",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Shadowbox" => "Shadowbox",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "HTML Purifier" => "HTML Purifier",
// "Ajax" => "Ajax",
// "Mobile" => "Mobile",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Intertiki" => "Intertiki",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "Search engine friendly url" => "Search engine friendly url",
// "SpreadSheet" => "SpreadSheet",
// "Ajax auto-save" => "Ajax auto-save",
// "Save draft" => "Save draft",
// "Requires AJAX (experimental)" => "Requires AJAX (experimental)",
// "Kaltura" => "Kaltura",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Action calendar" => "Action calendar",
// "Redirect On Error" => "Redirect On Error",
// "Redirect to a similar wiki page if an exact match is not found" => "Redirect to a similar wiki page if an exact match is not found",
// "User Contacts" => "User Contacts",
// "Group Watches" => "Group Watches",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
// "User Levels" => "User Levels",
// "Group Alert" => "Group Alert",
// "TikiTests" => "TikiTests",
// "Use Minified Scripts" => "Use Minified Scripts",
// "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions" => "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions",
// "Check for updates automatically" => "Check for updates automatically",
// "TikiWiki will check for updates when you access the main Administration page" => "TikiWiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "External link icon" => "External link icon",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Category path" => "Category path",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Screencasts" => "Screencasts",
// "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share" => "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share",
// "Screencasts upload location" => "Screencasts upload location",
// "Local path or webdav path to the file upload location" => "Local path or webdav path to the file upload location",
// "Trailing slash required" => "Trailing slash required",
// "Screencasts HTTP prefix" => "Screencasts HTTP prefix",
// "Prefix to use for the files when generating a link to it" => "Prefix to use for the files when generating a link to it",
// "Screencast upload type" => "Screencast upload type",
// "Mode used to upload files. WebDav is used to upload to remote servers" => "Mode used to upload files. WebDav is used to upload to remote servers",
// "Webdav" => "Webdav",
// "Screencasts authentication user" => "Screencasts authentication user",
// "When using webdav to upload files, used as the username of the authentication credentials" => "When using webdav to upload files, used as the username of the authentication credentials",
// "Screencasts authentication password" => "Screencasts authentication password",
// "When using webdav to upload files, used as the password of the authentication credentials" => "When using webdav to upload files, used as the password of the authentication credentials",
// "Screencasts max file size" => "Screencasts max file size",
// "Maximum file size used for screencasts" => "Maximum file size used for screencasts",
// "Value provided in bytes" => "Value provided in bytes",
// "Page List" => "Page List",
// "The pagelist feature allows to maintain lists of pages and their associated score and priority" => "The pagelist feature allows to maintain lists of pages and their associated score and priority",
// "Database search" => "Database search",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
// "Last modified date" => "Last modified date",
// "Blog-level" => "Blog-level",
// "Batch uploading" => "Batch uploading",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Forum name search" => "Forum name search",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Admins can search for features in the admin panels" => "Admins can search for features in the admin panels",
// "Encryption method" => "Encryption method",
// "Display 'MyTiki' in the application menu" => "Display 'MyTiki' in the application menu",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "Podcast directory" => "Podcast directory",
// "The server must be able to read/write the directory" => "The server must be able to read/write the directory",
// "Required for podcasts" => "Required for podcasts",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "The directory can be outside the web space" => "The directory can be outside the web space",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Allow download limit per file" => "Allow download limit per file",
// "Yes, even in the same gallery" => "Yes, even in the same gallery",
// "Only in different galleries" => "Only in different galleries",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for illimitted)" => "(0 for illimitted)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Description length" => "Description length",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Default ordering" => "Default ordering",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "The default help system may not be complete. You can help with the TikiWiki documentation" => "The default help system may not be complete. You can help with the TikiWiki documentation",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Url to go when clicking on a username" => "Url to go when clicking on a username",
// "Default: " => "Default: ",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Verify for available translations in the database" => "Verify for available translations in the database",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Log SQL" => "Log SQL",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Mail end of line" => "Mail end of line",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache flags" => "Memcache flags",
// "Configuration switches for memcache connection" => "Configuration switches for memcache connection",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Allow users to define icons for menus entries" => "Allow users to define icons for menus entries",
// "Default path for the icons" => "Default path for the icons",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID" => "One domain per line. Comma separated with perspective ID",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "Show categories" => "Show categories",
// "Show objects" => "Show objects",
// "Host" => "Host",
// "Proxy host" => "Proxy host",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Parse the results" => "Parse the results",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes" => "Value provided in minutes",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Check frequency" => "Check frequency",
// "Minify javascript" => "Minify javascript",
// "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared" => "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared",
// "Use Jquery autocomplete user selector for better performance when number of users exceed" => "Use Jquery autocomplete user selector for better performance when number of users exceed",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Always" => "Always",
// "Module decides" => "Module decides",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Wiki link format" => "Wiki link format",
// "Character set used when detecting wiki links within pages" => "Character set used when detecting wiki links within pages",
// "Latin" => "Latin",
// "Display by default only pages in current language" => "Display by default only pages in current language",
// "In Wiki page lists, display by default only pages in current language" => "In Wiki page lists, display by default only pages in current language",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Both" => "Both",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per page" => "Allow comments per page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Disable" => "Disable",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Load page on navigation" => "Load page on navigation",
// "Node size" => "Node size",
// "Text size" => "Text size",
// "Spring (connection) size" => "Spring (connection) size",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Camera distance" => "Camera distance",
// "Field of view" => "Field of view",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Eletrostatic constant" => "Eletrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Enable plugin %0" => "Enable plugin %0",
// "Inline plugin %0 (hide plugin edit icon)" => "Inline plugin %0 (hide plugin edit icon)",
// "When inlined, the plugin edit icon will not appear" => "When inlined, the plugin edit icon will not appear",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "... and is displayed by default" => "... and is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Default" => "Default",
// "Office 2003" => "Office 2003",
// "Silver" => "Silver",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "User %0 was added to %1" => "User %0 was added to %1",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "uploaded the file" => "uploaded the file",
// "changes" => "changes",
// "No changes" => "No changes",
// "Yesterday" => "Yesterday",
// "more changes of the same type.." => "more changes of the same type..",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "onto" => "onto",
// "removed the picture" => "removed the picture",
// "edited the wikipage" => "edited the wikipage",
// "this history" => "this history",
// "all history" => "all history",
// "edited the file gallery" => "edited the file gallery",
// "removed the file" => "removed the file",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
// "edited the category" => "edited the category",
// "removed the article" => "removed the article",
// "created the article" => "created the article",
// "edited the article" => "edited the article",
// "replied to the blog" => "replied to the blog",
// "created the topic" => "created the topic",
// "at forum" => "at forum",
// "to the topic" => "to the topic",
// "Nothing has happened" => "Nothing has happened",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "tip" => "tip",
// "warning" => "warning",
// "note" => "note",
// "errors" => "errors",
// "information" => "information",
// "Tab View" => "Tab View",
// "No Tabs" => "No Tabs",
// "If you want the saved version instead of this autosaved one" => "If you want the saved version instead of this autosaved one",
// "AutoSave" => "AutoSave",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "Your edit session has expired" => "Your edit session has expired",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Preference name not specified" => "Preference name not specified",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "No rows found" => "No rows found",
// "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed" => "Non-parsed",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif" => "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif",
// "Block Quote" => "Block Quote",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "Unordered List" => "Unordered List",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif" => "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "Background Color" => "Background Color",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "External Link" => "External Link",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "Table Builder" => "Table Builder",
// "pics/icons/find.png" => "pics/icons/find.png",
// "Find Text" => "Find Text",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full Screen Edit" => "Full Screen Edit",
// "pics/icons/arrow_in.png" => "pics/icons/arrow_in.png",
// "pics/icons/arrow_out.png" => "pics/icons/arrow_out.png",
// "Choose or upload images" => "Choose or upload images",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Admin Toolbars" => "Admin Toolbars",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "country selector" => "country selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "multimedia" => "multimedia",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Topics expression" => "Topics expression",
// "Topic ID expression" => "Topic ID expression",
// "Type expression" => "Type expression",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Start date" => "Start date",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "End date" => "End date",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar filter" => "Calendar filter",
// "If set to a calendar identifier, restricts the events displayed to those in the specified calendar" => "If set to a calendar identifier, restricts the events displayed to those in the specified calendar",
// "View type" => "View type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "View the navigation bar" => "View the navigation bar",
// "Decide or not to show the navigation bar" => "Decide or not to show the navigation bar",
// "Includes a calendar" => "Includes a calendar",
// "~np~{CALENDAR(calendarId=>1)}{CALENDAR}" => "~np~{CALENDAR(calendarId=>1)}{CALENDAR}",
// "Id is optional. If not given, all calendars viewable by default are used" => "Id is optional. If not given, all calendars viewable by default are used",
// "With sub-categories" => "With sub-categories",
// "Show object name" => "Show object name",
// "Show type" => "Show type",
// "Incorrect param" => "Incorrect param",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "Word Wrap" => "Word Wrap",
// "0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Enable word wrapping on the code to avoid breaking the layout",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Also known as fortune cookies or taglines" => "Also known as fortune cookies or taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "on|off" => "on|off",
// "Items to show" => "Items to show",
// "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "left|right|center|justify" => "left|right|center|justify",
// "Right" => "Right",
// "Justify" => "Justify",
// "Float position" => "Float position",
// "left|right, for box with width less than 100%, make text wrap around the box" => "left|right, for box with width less than 100%, make text wrap around the box",
// "Left" => "Left",
// "Determine how other elements can wrap around the element" => "Determine how other elements can wrap around the element",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Creates a fancy-looking list" => "Creates a fancy-looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading row" => "Heading row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS class" => "Heading CSS class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header horizontal align" => "Header horizontal align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header vertical align" => "Header vertical align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column sort" => "Column sort",
// "Pre-sorted columns" => "Pre-sorted columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column widths" => "Column widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell horizontal align" => "Cell horizontal align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell vertical align" => "Cell vertical align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "heads and cells separated by |" => "heads and cells separated by |",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows ID" => "Shows ID",
// "Shows Icon" => "Shows Icon",
// "Shows Name" => "Shows Name",
// "Shows Filename" => "Shows Filename",
// "Shows Size" => "Shows Size",
// "Shows Description" => "Shows Description",
// "Shows Creation Date" => "Shows Creation Date",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Modification Date" => "Shows Modification Date",
// "Shows Author" => "Shows Author",
// "Shows Creator" => "Shows Creator",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Movie URL" => "Movie URL",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "Default width: 425" => "Default width: 425",
// "Default height: 350" => "Default height: 350",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "file name" => "file name",
// "Ftp Server Name" => "Ftp Server Name",
// "Ftp User name" => "Ftp User name",
// "Ftp password" => "Ftp password",
// "Download button label" => "Download button label",
// "missing parameters" => "missing parameters",
// "Connection failed" => "Connection failed",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "current value (REQUIRED)" => "current value (REQUIRED)",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "Missing parameter" => "Missing parameter",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "GroupMailCore" => "GroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "operator Field Id" => "operator Field Id",
// "subject Field Id" => "subject Field Id",
// "message Field Id" => "message Field Id",
// "content Field Id" => "content Field Id",
// "account Field Id" => "account Field Id",
// "datetime Field Id" => "datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "Groups separated by " => "Groups separated by ",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Displays some stat about group belonging" => "Displays some stat about group belonging",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "Iframe" => "Iframe",
// "Frame title" => "Frame title",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 5.0)" => " (experimental - possible successor to img in 5.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)" => "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required" => "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery images when thumbnail is clicked" => "Download dialog box will appear for file gallery images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class" => "CSS class",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load" => "Alternate text that displays when image does not load",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin)" => "Default configuration settings (usually set by admin)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin)" => "Mandatory configuration settings (usually set by admin)",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, attId, id, or src.''",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Invite" => "Invite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including group" => "Including group",
// "Default group" => "Default group",
// "Group from the item group selector / creator field" => "Group from the item group selector / creator field",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Jabber" => "Jabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Kaltura video" => "Kaltura video",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry Id" => "Kaltura Entry Id",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Number of results displayed in the list" => "Number of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Progress" => "List Progress",
// "Indicates the internationalization progress of the page list" => "Indicates the internationalization progress of the page list",
// "List Name" => "List Name",
// "Name of the list as configured in the page list admin panel" => "Name of the list as configured in the page list admin panel",
// "Limit" => "Limit",
// "Maximum amount of results to display" => "Maximum amount of results to display",
// "Filter to apply to the page list" => "Filter to apply to the page list",
// "Score Limit" => "Score Limit",
// "Value used as the denominator for the score" => "Value used as the denominator for the score",
// "List Directory" => "List Directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "Displays a map" => "Displays a map",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%" => "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Member List" => "Member List",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by UI" => "Displays a module inline in a wiki page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Background color of the popup" => "Background color of the popup",
// "'),\n\t\t\t\t'filter' => 'striptags" => "'),\n\t\t\t\t'filter' => 'striptags",
// "Text color in the popup" => "Text color in the popup",
// "Padding" => "Padding",
// "Effect" => "Effect",
// "Effect speed" => "Effect speed",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "List pages part of a named list" => "List pages part of a named list",
// "Offset" => "Offset",
// "Pagination start element" => "Pagination start element",
// "list parameter missing or doesn\\'t exist" => "list parameter missing or doesn\\'t exist",
// "% of page hits" => "% of page hits",
// "Page Hits" => "Page Hits",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Poll ID" => "Poll ID",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Exclude" => "Exclude",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "y|n Show close button (default y)" => "y|n Show close button (default y)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Number of results displayed" => "Number of results displayed",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect" => "RSS Id incorrect",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "Screencast" => "Screencast",
// "Display a screencast uploaded on the page" => "Display a screencast uploaded on the page",
// "Label to use as a replacement to the default text" => "Label to use as a replacement to the default text",
// "ID as provided automatically during the upload" => "ID as provided automatically during the upload",
// "Insert Screencast" => "Insert Screencast",
// "Screencast ID wasn't specified or doesn't exist" => "Screencast ID wasn't specified or doesn't exist",
// "Watch a video of these instructions" => "Watch a video of these instructions",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Stat" => "Stat",
// "Displays some stats" => "Displays some stats",
// "separated by " => "separated by ",
// "Parent Id" => "Parent Id",
// "Added last hour" => "Added last hour",
// "Added last 24 hours" => "Added last 24 hours",
// "Added since the beginning of the day" => "Added since the beginning of the day",
// "Added(a) or viewed(v) since the beginning of the day" => "Added(a) or viewed(v) since the beginning of the day",
// "Added last 7 days" => "Added last 7 days",
// "Added(a) or viewed(v) last 7 days" => "Added(a) or viewed(v) last 7 days",
// "Added since the beginning of the week" => "Added since the beginning of the week",
// "Added(a) or viewed(v) since the beginning of the week" => "Added(a) or viewed(v) since the beginning of the week",
// "Added last month" => "Added last month",
// "Added(a) or viewed(v) last month" => "Added(a) or viewed(v) last month",
// "Added since the beginning of the month" => "Added since the beginning of the month",
// "Added(a) or viewed(v) since the beginning of the month" => "Added(a) or viewed(v) since the beginning of the month",
// "Added last year" => "Added last year",
// "Added(a) or viewed(v) last year" => "Added(a) or viewed(v) last year",
// "Added since the beginning of the year" => "Added since the beginning of the year",
// "Added(a) or viewed(v) since the beginning of the year" => "Added(a) or viewed(v) since the beginning of the year",
// "Subscript" => "Subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Show subscribe box" => "Show subscribe box",
// "Show default setting and buttons" => "Show default setting and buttons",
// "Show group description" => "Show group description",
// "Colon separated list of groups" => "Colon separated list of groups",
// "After changing default" => "After changing default",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Tabs" => "Tabs",
// "Provides tabs built using the smarty tabset block" => "Provides tabs built using the smarty tabset block",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset name" => "Tabset name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab titles" => "Tab titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Tag Name" => "Tag Name",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Displays text between HTML tags" => "Displays text between HTML tags",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited" => "Maximum number of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "URL used for the field links" => "URL used for the field links",
// "Url target" => "Url target",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "Reset" => "Reset",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Filters" => "Filters",
// "Display List" => "Display List",
// "Line" => "Line",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "Wiki text" => "Wiki text",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Test" => "Test",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Notice" => "Notice",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Show Item Rank" => "Show Item Rank",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Maximum number of items" => "Maximum number of items",
// "Show pagination" => "Show pagination",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More" => "More",
// "More URL" => "More URL",
// "More Url" => "More Url",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Show nothing if no items" => "Show nothing if no items",
// "incorrect filterfield" => "incorrect filterfield",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Start Date" => "Start Date",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "End Date" => "End Date",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Group name" => "Group name",
// "Displays a list of registered users" => "Displays a list of registered users",
// "Display the user\\'s real name instead of login name" => "Display the user\\'s real name instead of login name",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Level" => "Level",
// "Lists ''wanted'' Wiki pages: " => "Lists ''wanted'' Wiki pages: ",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
// "empty string" => "empty string",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "URL to the Youtube video" => "URL to the Youtube video",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Removed version \$version" => "Removed version \$version",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Removed last version" => "Removed last version",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "Category filter" => "Category filter",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Not set by default" => "Not set by default",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values" => "Example values",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "No date" => "No date",
// "If set to \"y\", the date at which comments were posted is not displayed in the module box" => "If set to \"y\", the date at which comments were posted is not displayed in the module box",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum length" => "Maximum length",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Example value" => "Example value",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Freetags editor" => "Freetags editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Similar freetags" => "Similar freetags",
// "Shows wiki pages with similar freetags" => "Shows wiki pages with similar freetags",
// "Similar pages" => "Similar pages",
// "Most popular tags" => "Most popular tags",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Number of characters to display" => "Number of characters to display",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Search Box" => "Search Box",
// "Advanced search (for wiki, articles, blogs etc)" => "Advanced search (for wiki, articles, blogs etc)",
// "Search Box (new)" => "Search Box (new)",
// "Search Wiki Page" => "Search Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Search Wiki Page (new)" => "Search Wiki Page (new)",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Please wait.." => "Please wait..",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Since your last visit.." => "Since your last visit..",
// "new posts" => "new posts",
// "new tracker items" => "new tracker items",
// "updated tracker items" => "updated tracker items",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Top Objects" => "Top Objects",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Page translation" => "Page translation",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "Subject Field Id" => "Subject Field Id",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "Message Field Id" => "Message Field Id",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "Content Field Id" => "Content Field Id",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "Account Field Id" => "Account Field Id",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "Operator Field Id" => "Operator Field Id",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Wiki Page" => "Wiki Page",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin the cms" => "Can admin the cms",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submited links are valid" => "Submited links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submited links" => "Can validate submited links",
// "Can use the directory" => "Can use the directory",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Can admin users" => "Can admin users",
// "Can access site when closed" => "Can access site when closed",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referer stats" => "Can view referer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can create file galleries" => "Can create file galleries",
// "Can download files" => "Can download files",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can list file galleries" => "Can list file galleries",
// "Can upload files" => "Can upload files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can view file galleries" => "Can view file galleries",
// "Can admin forums" => "Can admin forums",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can admin freetags" => "Can admin freetags",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload images" => "Can upload images",
// "Can browse freetags" => "Can browse freetags",
// "Can view image galleries" => "Can view image galleries",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change tracker pending items" => "Can change tracker pending items",
// "Can change tracker closed items" => "Can change tracker closed items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view trackers closed items" => "Can view trackers closed items",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit pages" => "Can edit pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view page/pages" => "Can view page/pages",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments to wiki pages" => "Can admin attachments to wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view wiki history" => "Can view wiki history",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can delete comments" => "Can delete comments",
// "Can vote comments" => "Can vote comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can list registered users" => "Can list registered users",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can invite user in groups" => "Can invite user in groups",
// "Can delete his own account" => "Can delete his own account",
// "Can use the Tiki Importer" => "Can use the Tiki Importer",
// "Can admin categories" => "Can admin categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories on the object" => "Can change the categories on the object",
// "Can add objects in the category" => "Can add objects in the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can upload screencasts to wiki pages" => "Can upload screencasts to wiki pages",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki dft list pages lang to current" => "wiki dft list pages lang to current",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "feature pagelist" => "feature pagelist",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin listprogress" => "wikiplugin listprogress",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin pagelist" => "wikiplugin pagelist",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin screencast" => "wikiplugin screencast",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline listprogress" => "wikiplugininline listprogress",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline pagelist" => "wikiplugininline pagelist",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline screencast" => "wikiplugininline screencast",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "tracker jquery user selector threshold" => "tracker jquery user selector threshold",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature search preferences" => "feature search preferences",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "title rss forums" => "title rss forums",
// "title rss forum" => "title rss forum",
// "title rss directories" => "title rss directories",
// "title rss articles" => "title rss articles",
// "title rss blogs" => "title rss blogs",
// "title rss image galleries" => "title rss image galleries",
// "title rss file galleries" => "title rss file galleries",
// "title rss wiki" => "title rss wiki",
// "title rss image gallery" => "title rss image gallery",
// "title rss file gallery" => "title rss file gallery",
// "title rss blog" => "title rss blog",
// "title rss tracker" => "title rss tracker",
// "title rss trackers" => "title rss trackers",
// "title rss calendar" => "title rss calendar",
// "title rss mapfiles" => "title rss mapfiles",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom html head content" => "feature custom html head content",
// "users prefs theme" => "users prefs theme",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty notice reporting" => "smarty notice reporting",
// "smarty security" => "smarty security",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature wiki screencasts" => "feature wiki screencasts",
// "feature wiki screencasts base" => "feature wiki screencasts base",
// "feature wiki screencasts httpbase" => "feature wiki screencasts httpbase",
// "feature wiki screencasts upload type" => "feature wiki screencasts upload type",
// "feature wiki screencasts user" => "feature wiki screencasts user",
// "feature wiki screencasts pass" => "feature wiki screencasts pass",
// "feature wiki screencasts max size" => "feature wiki screencasts max size",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache flags" => "memcache flags",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "feature use minified scripts" => "feature use minified scripts",
// "tiki minify javascript" => "tiki minify javascript",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "Select Categories" => "Select Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
// "top of page" => "top of page",
// "Report this post" => "Report this post",
// "Group Monitor" => "Group Monitor",
// "Watched by categories" => "Watched by categories",
// "Errors" => "Errors",
// "Comments Locked" => "Comments Locked",
// "Set" => "Set",
// "Comments are locked" => "Comments are locked",
// "Note" => "Note",
// "Post new message" => "Post new message",
// "required" => "required",
// "Maximum size" => "Maximum size",
// "Enter your name" => "Enter your name",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Post as Anonymous" => "Post as Anonymous",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "Type of contribution" => "Type of contribution",
// "Contributors" => "Contributors",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Duplicate File Gallery" => "Duplicate File Gallery",
// "File gallery" => "File gallery",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "System" => "System",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Owner of the gallery" => "Owner of the gallery",
// "Quota" => "Quota",
// "Used" => "Used",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Display Properties" => "Display Properties",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Perhaps you are looking for" => "Perhaps you are looking for",
// "Go to Login Page" => "Go to Login Page",
// "Go to" => "Go to",
// "Private Gallery" => "Private Gallery",
// "Archives" => "Archives",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Show as a column" => "Show as a column",
// "Show in popup box" => "Show in popup box",
// "Show an icon in a column" => "Show an icon in a column",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "any type" => "any type",
// "all topic" => "all topic",
// "any language" => "any language",
// "not in" => "not in",
// "any category" => "any category",
// "Clear Filter" => "Clear Filter",
// "Show php error messages" => "Show php error messages",
// "Folksonomy Tags" => "Folksonomy Tags",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Tags" => "Tags",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "Download the zip" => "Download the zip",
// "Other Sorts" => "Other Sorts",
// "No Additionnal Sort" => "No Additionnal Sort",
// "No information" => "No information",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "A new topic was posted to forum" => "A new topic was posted to forum",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "Assign to a group" => "Assign to a group",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Report for" => "Report for",
// "Last Report sent on" => "Last Report sent on",
// "Changes in detail" => "Changes in detail",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Tracker was modified at" => "Tracker was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "New" => "New",
// "updated" => "updated",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Wiki page renamed" => "Wiki page renamed",
// "Old name" => "Old name",
// "Thank you for your registration. You may log in now" => "Thank you for your registration. You may log in now",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Zoom out" => "Zoom out",
// "Zoom in" => "Zoom in",
// "from the mapfile" => "from the mapfile",
// "hits last 7 days" => "hits last 7 days",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "is reply to" => "is reply to",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "More.." => "More..",
// "To configure your Tiki" => "To configure your Tiki",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "Add event" => "Add event",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Apply" => "Apply",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "List everything tagged" => "List everything tagged",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "No records to display" => "No records to display",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "more" => "more",
// "No avatar" => "No avatar",
// "You" => "You",
// "Logged in as" => "Logged in as",
// "Switch User" => "Switch User",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Switch user" => "Switch user",
// "Login through Shibboleth" => "Login through Shibboleth",
// "Login as" => "Login as",
// "CapsLock is on" => "CapsLock is on",
// "local account" => "local account",
// "OpenID Login" => "OpenID Login",
// "What is OpenID" => "What is OpenID",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "New Tracker Items" => "New Tracker Items",
// "New Calendar Events" => "New Calendar Events",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Site Language" => "Site Language",
// "Site default" => "Site default",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Better translations" => "Better translations",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Set your preferred languages" => "Set your preferred languages",
// "preferred languages" => "preferred languages",
// "Equivalent translations" => "Equivalent translations",
// "Translations that need improvement" => "Translations that need improvement",
// "update it" => "update it",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "on host" => "on host",
// "User does not accept messages" => "User does not accept messages",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "Changes that need to be reproduced are highlighted below" => "Changes that need to be reproduced are highlighted below",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "Requires" => "Requires",
// "You need to set" => "You need to set",
// "Insert/Edit an internal wiki link" => "Insert/Edit an internal wiki link",
// "Wiki Link insert" => "Wiki Link insert",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "Insert an image" => "Insert an image",
// "Tiki Image - Insert an image" => "Tiki Image - Insert an image",
// "Switch to normal (wiki) editor" => "Switch to normal (wiki) editor",
// "By" => "By",
// "Read more" => "Read more",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User resistration, remember me cookie settings and authentication methods" => "User resistration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Profiles" => "Profiles",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look & Feel" => "Look & Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Editing and Plugins" => "Editing and Plugins",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Security" => "Security",
// "Site security settings" => "Site security settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Connect" => "Connect",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "?" => "?",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Kaltura video configuration" => "Kaltura video configuration",
// "Create a blog" => "Create a blog",
// "Requires a separate download" => "Requires a separate download",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "Default view mode" => "Default view mode",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "First day of the week" => "First day of the week",
// "Split hours in periods of" => "Split hours in periods of",
// "1 minute" => "1 minute",
// "10 minutes" => "10 minutes",
// "Manual selection of time/date" => "Manual selection of time/date",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Browse categories" => "Browse categories",
// "Administer categories" => "Administer categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "Title of articles home page" => "Title of articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "Batch upload (CSV file)" => "Batch upload (CSV file)",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "User features" => "User features",
// "Highlight group" => "Highlight group",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Real name" => "Real name",
// "Feature is disabled" => "Feature is disabled",
// "Enable now" => "Enable now",
// "Default user preferences" => "Default user preferences",
// "Users Default Preferences" => "Users Default Preferences",
// "Character set for mail" => "Character set for mail",
// "Detect user timezone if browser allows, otherwise site default" => "Detect user timezone if browser allows, otherwise site default",
// "User messages" => "User messages",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "My forum topics" => "My forum topics",
// "My forum replies" => "My forum replies",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to TikiWiki.org" => "To submit your site to TikiWiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright allows to determine a copyright for all the objects of tikiwiki",
// "Enable copyright management for" => "Enable copyright management for",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Programmer" => "Programmer",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Experimental" => "Experimental",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Need polish" => "Need polish",
// "These features are generally known to have issues, and/or need admin help and/or user patience to work" => "These features are generally known to have issues, and/or need admin help and/or user patience to work",
// "Feedbacks" => "Feedbacks",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Create a Gallery" => "Create a Gallery",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Score is disabled" => "Score is disabled",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Search Indexing" => "Search Indexing",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "Create a forum" => "Create a forum",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "When listing forums" => "When listing forums",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser" => "3D Tag Browser",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Graph appearance" => "Graph appearance",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "No Gallery exists" => "No Gallery exists",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Display image informations in a mouseover box" => "Display image informations in a mouseover box",
// "yes, and don't display those informations under the image" => "yes, and don't display those informations under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Mover" => "Mover",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
// "Release Check" => "Release Check",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Check for updates now" => "Check for updates now",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "SMTP Server" => "SMTP Server",
// "Authentication" => "Authentication",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Logging and Reporting" => "Logging and Reporting",
// "Visible to admin only" => "Visible to admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Spam protection" => "Spam protection",
// "MultiDomain" => "MultiDomain",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Contact" => "Contact",
// "Miscellaneous" => "Miscellaneous",
// "Use TikiWiki feature as homepage" => "Use TikiWiki feature as homepage",
// "Use different URL as home page" => "Use different URL as home page",
// "Redirects" => "Redirects",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Site Access" => "Site Access",
// "Default timezone" => "Default timezone",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Fields display order" => "Fields display order",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details",
// "Google Maps API Key" => "Google Maps API Key",
// "Defaults" => "Defaults",
// "Default x for map center" => "Default x for map center",
// "Default y from map center" => "Default y from map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "max zoom" => "max zoom",
// "Internationalization" => "Internationalization",
// "Edit or export/import Languages" => "Edit or export/import Languages",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// "as master" => "as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
// "Kaltura Registration" => "Kaltura Registration",
// "If you don't have a Kaltura Partner Id, " => "If you don't have a Kaltura Partner Id, ",
// "to register" => "to register",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Partner Id" => "Partner Id",
// "User Secret" => "User Secret",
// "Admin Secret" => "Admin Secret",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "KDP UI Configuration Id" => "KDP UI Configuration Id",
// "KDP Widget Id" => "KDP Widget Id",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "KCW UI Configuration Id" => "KCW UI Configuration Id",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Kaltura Simple Editor UI Configuration Id" => "Kaltura Simple Editor UI Configuration Id",
// "Kaltura Advance Editor UI Configuration Id" => "Kaltura Advance Editor UI Configuration Id",
// "Wysiwyg" => "Wysiwyg",
// "Validate by email" => "Validate by email",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Url a user is redirected after account validation" => "Url a user is redirected after account validation",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "User's choice" => "User's choice",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "LDAP Bind settings" => "LDAP Bind settings",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: userattr=username,UserDN,BaseDN" => "Default: userattr=username,UserDN,BaseDN",
// "userattr=username,BaseDN" => "userattr=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Synchronize user attributes to tiki everytime the user logs in" => "Synchronize user attributes to tiki everytime the user logs in",
// "LDAP Group" => "LDAP Group",
// "Synchronize group attributes to tiki everytime the user logs in" => "Synchronize group attributes to tiki everytime the user logs in",
// "Note: this enables the usage of LDAP groups" => "Note: this enables the usage of LDAP groups",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "Group attribute in group entry" => "Group attribute in group entry",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/" => "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "Themes" => "Themes",
// "Theme options" => "Theme options",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "Each group can have its theme" => "Each group can have its theme",
// "Slideshow theme" => "Slideshow theme",
// "View Templates" => "View Templates",
// "Custom HTML &lt;head&gt; Content" => "Custom HTML &lt;head&gt; Content",
// "Custom Site Header" => "Custom Site Header",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users",
// "Site Logo and Title" => "Site Logo and Title",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Examples" => "Examples",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Site title" => "Site title",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar" => "Top Bar",
// "Requires CSS Menus or PHPLayers" => "Requires CSS Menus or PHPLayers",
// "Menu ID" => "Menu ID",
// "Display current Tiki version" => "Display current Tiki version",
// "Custom Center Column Header" => "Custom Center Column Header",
// "only if module" => "only if module",
// "Prefix breadcrumbs with &quot;Location : &quot" => "Prefix breadcrumbs with &quot;Location : &quot",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom Site Footer" => "Custom Site Footer",
// "Custom End of &lt;body&gt; Code" => "Custom End of &lt;body&gt; Code",
// "Bottom bar icons" => "Bottom bar icons",
// "Bottom bar debug" => "Bottom bar debug",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave <strong>blank</strong> to use the default sender email" => "Leave <strong>blank</strong> to use the default sender email",
// "Email this page" => "Email this page",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "UI Effects" => "UI Effects",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "Tooltips" => "Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "Autocomplete" => "Autocomplete",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "Superfish" => "Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "Reflection" => "Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery UI Theme" => "JQuery UI Theme",
// "JQuery UI Theme: Themes for look and feel of JQuery UI widgets" => "JQuery UI Theme: Themes for look and feel of JQuery UI widgets",
// "For future use" => "For future use",
// "Cycle" => "Cycle",
// "slideshow" => "slideshow",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules" => "Effect for modules",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Main JQuery effect" => "Main JQuery effect",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (&nbsp;,&nbsp;)" => "Separate multiple elements with a comma (&nbsp;,&nbsp;)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Separators" => "Separators",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "Save Preferences" => "Save Preferences",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Sending" => "Sending",
// "The following list of changes has been applied" => "The following list of changes has been applied",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Profile tester" => "Profile tester",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feed for articles" => "Feed for articles",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "The indexation is always updated" => "The indexation is always updated",
// "Tiki search" => "Tiki search",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh wiki search index now" => "Refresh wiki search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "Plugins" => "Plugins",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Switch storage" => "Switch storage",
// "No records" => "No records",
// "Trackers with mirror tables" => "Trackers with mirror tables",
// "Use trackers with mirror tables" => "Use trackers with mirror tables",
// "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on" => "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on",
// "Validate choice" => "Validate choice",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Allow override per page" => "Allow override per page",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Manage attachments" => "Manage attachments",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Remove a tag" => "Remove a tag",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "View source" => "View source",
// "Polls are disabled" => "Polls are disabled",
// "Similar" => "Similar",
// "like pages" => "like pages",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "Wiki watch" => "Wiki watch",
// "Watch minor edits" => "Watch minor edits",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Page Listings" => "Page Listings",
// "Pages not in structure" => "Pages not in structure",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Categories path" => "Categories path",
// "Camera settings" => "Camera settings",
// "Upload Type" => "Upload Type",
// "Data location" => "Data location",
// "HTTP Prefix" => "HTTP Prefix",
// "WebDav username" => "WebDav username",
// "WebDav password" => "WebDav password",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Development Notice" => "Development Notice",
// "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default" => "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
// "disabled" => "disabled",
// "enabled" => "enabled",
// "preference" => "preference",
// "preference name" => "preference name",
// "Crosslinks to other features and settings" => "Crosslinks to other features and settings",
// "Other sections" => "Other sections",
// "Spreadsheet" => "Spreadsheet",
// "Administration features" => "Administration features",
// "TikiCache/System" => "TikiCache/System",
// "SysLogs" => "SysLogs",
// "Mods" => "Mods",
// "Edit Languages" => "Edit Languages",
// "Transversal features" => "Transversal features",
// "which apply to more than one section" => "which apply to more than one section",
// "Navigation features" => "Navigation features",
// "Look & feel" => "Look & feel",
// "themes" => "themes",
// "Text area features" => "Text area features",
// "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "features you can use in all text areas, like wiki pages, blogs, articles, forums, etc",
// "External Pages Cache" => "External Pages Cache",
// "Content Templates" => "Content Templates",
// "External Wikis" => "External Wikis",
// "Stats &amp; banners" => "Stats &amp; banners",
// "Report" => "Report",
// "Please select some actions to view" => "Please select some actions to view",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "recorded" => "recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "View Calendar" => "View Calendar",
// "Add Event" => "Add Event",
// "Create / Edit Calendar" => "Create / Edit Calendar",
// "Create/Edit Calendars" => "Create/Edit Calendars",
// "Custom URL" => "Custom URL",
// "Start of day" => "Start of day",
// "End of day" => "End of day",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Let me select my own colors" => "Let me select my own colors",
// "Custom foreground color" => "Custom foreground color",
// "Ex" => "Ex",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
// "Current Category ID" => "Current Category ID",
// "Remove from this Category" => "Remove from this Category",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Admin External Wikis" => "Admin External Wikis",
// "Duplicate forum" => "Duplicate forum",
// "View this forum" => "View this forum",
// "Import forums" => "Import forums",
// ".." => "..",
// "Create/Edit Forums" => "Create/Edit Forums",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "Duplicate perms" => "Duplicate perms",
// "Duplicate" => "Duplicate",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "mn" => "mn",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Use Ctrl+Click to select multiple groups" => "Use Ctrl+Click to select multiple groups",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "section level 0" => "section level 0",
// "section level 1" => "section level 1",
// "section level 2" => "section level 2",
// "section level 3" => "section level 3",
// "sorted section level 0" => "sorted section level 0",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "assign_name\">Module Name" => "assign_name\">Module Name",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Use Wiki Structure" => "Use Wiki Structure",
// "Edit Newsletter" => "Edit Newsletter",
// "You can add several email addresses by separating them with commas" => "You can add several email addresses by separating them with commas",
// "Batch e-mail subscribe" => "Batch e-mail subscribe",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Create Newsletter" => "Create Newsletter",
// "Drafts" => "Drafts",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Admin page lists" => "Admin page lists",
// "Current lists" => "Current lists",
// "Edit this list" => "Edit this list",
// "Remove this list" => "Remove this list",
// "Edit list" => "Edit list",
// "Add list" => "Add list",
// "Seed with pages from a category" => "Seed with pages from a category",
// "Add page" => "Add page",
// "Page priority" => "Page priority",
// "Page score" => "Page score",
// "Edit {\$list.name|escape}" => "Edit {\$list.name|escape}",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "Add poll to pages" => "Add poll to pages",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Lock the pages" => "Lock the pages",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "View structure" => "View structure",
// "PDF" => "PDF",
// "XML Zip" => "XML Zip",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Create/Edit Surveys" => "Create/Edit Surveys",
// "Closed" => "Closed",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)",
// "Exterminator of cached content" => "Exterminator of cached content",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "Advanced feature" => "Advanced feature",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "New tracker field" => "New tracker field",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Multilingual content" => "Multilingual content",
// "Field is hidden" => "Field is hidden",
// "not hidden" => "not hidden",
// "visible to admin only" => "visible to admin only",
// "editable by admin only" => "editable by admin only",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Error message" => "Error message",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit This Tracker's Fields" => "Edit This Tracker's Fields",
// "trackers" => "trackers",
// "with" => "with",
// "Create Tracker" => "Create Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Auto create corresponding categories" => "Auto create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "Use \"explicit\" names in the mirror table" => "Use \"explicit\" names in the mirror table",
// "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP field with the option 1" => "The tracker needs a user or IP field with the option 1",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "Format if not the default short one" => "Format if not the default short one",
// "Show creation date when viewing tracker item" => "Show creation date when viewing tracker item",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Show lastModif date when viewing tracker item" => "Show lastModif date when viewing tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "ItemId" => "ItemId",
// "and display last comment user/date" => "and display last comment user/date",
// "Items can be created only during a certain time" => "Items can be created only during a certain time",
// "Do not show empty fields in item view" => "Do not show empty fields in item view",
// "Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Show these fields (ID comma separated) in a popup on item link when listing tracker items",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Charset encoding" => "Charset encoding",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Manage permissions" => "Manage permissions",
// "Inherits Permissions from" => "Inherits Permissions from",
// "User Choice" => "User Choice",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Selected groups only. Use Ctrl+Click to select more than one" => "Selected groups only. Use Ctrl+Click to select more than one",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Remove from Group" => "Remove from Group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "Feedback" => "Feedback",
// "Updated users" => "Updated users",
// "More Criteria" => "More Criteria",
// "Group (direct)" => "Group (direct)",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Included Group" => "Edit Included Group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Invalid email" => "Invalid email",
// "Remove Users and their Userpages" => "Remove Users and their Userpages",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Tip: Hold down CTRL to select multiple" => "Tip: Hold down CTRL to select multiple",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Use the email as username" => "Use the email as username",
// "Lowercase only" => "Lowercase only",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2" => "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2",
// "Overwrite but keep the previous login if the login exists in another case" => "Overwrite but keep the previous login if the login exists in another case",
// "Don't overwrite" => "Don't overwrite",
// "Overwrite groups" => "Overwrite groups",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "Loading.." => "Loading..",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "Actions on this article type" => "Actions on this article type",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "inherited from" => "inherited from",
// "inherited" => "inherited",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. ",
// "Report to Webmaster" => "Report to Webmaster",
// "The TikiWiki Community" => "The TikiWiki Community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "database queries used in " => "database queries used in ",
// "Last update from SVN" => "Last update from SVN",
// "Watch Only This Category" => "Watch Only This Category",
// "Watch This Category and Their Descendants" => "Watch This Category and Their Descendants",
// "Stop Watching Only This Category" => "Stop Watching Only This Category",
// "Stop Watching This Category and Their Descendants" => "Stop Watching This Category and Their Descendants",
// "Trackers Items" => "Trackers Items",
// "in the current category - and its subcategories: " => "in the current category - and its subcategories: ",
// "Browse related tags" => "Browse related tags",
// "Network of Tags related to" => "Network of Tags related to",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "\$feature_label" => "\$feature_label",
// "results found" => "results found",
// "All Images" => "All Images",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using one of these lines" => "You can include the gallery's image in an HTML page using one of these lines",
// "Cyclic" => "Cyclic",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Browsing Video" => "Browsing Video",
// "Edit Video" => "Edit Video",
// "First Video" => "First Video",
// "Prev Video" => "Prev Video",
// "Next Video" => "Next Video",
// "Last Video" => "Last Video",
// "Video Title" => "Video Title",
// "Move video" => "Move video",
// "You can view this video in your browser using" => "You can view this video in your browser using",
// "You can include the video in a tiki page using one of these lines" => "You can include the video in a tiki page using one of these lines",
// "Admin Calendar" => "Admin Calendar",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Visible Calendars" => "Visible Calendars",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Edit event" => "Edit event",
// "Delete event" => "Delete event",
// "View event" => "View event",
// "All-Day" => "All-Day",
// "Website" => "Website",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Calendar Item" => "Calendar Item",
// "Edit Calendar" => "Edit Calendar",
// "New event" => "New event",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "%d/%m" => "%d/%m",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Send another message" => "Send another message",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "Directory Categories" => "Directory Categories",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Parent directory category" => "Parent directory category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "Perform action with selected" => "Perform action with selected",
// "Add a Directory Category" => "Add a Directory Category",
// "in current directory category" => "in current directory category",
// "Total directory categories" => "Total directory categories",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "A category is mandatory" => "A category is mandatory",
// "The file will be saved in" => "The file will be saved in",
// "Wiki Syntax" => "Wiki Syntax",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Also available here" => "Also available here",
// "Plugins help" => "Plugins help",
// "Bold text" => "Bold text",
// "Italic text" => "Italic text",
// "single quotes" => "single quotes",
// "Underlined text" => "Underlined text",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Horizontal rule" => "Horizontal rule",
// "Text box" => "Text box",
// "Centered text" => "Centered text",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "row" => "row",
// "col" => "col",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "Line break" => "Line break",
// "(very useful especially in tables)" => "(very useful especially in tables)",
// "to separate pages" => "to separate pages",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Im-Export Languages" => "Im-Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Edit quiz results" => "Edit quiz results",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Move in this structure" => "Move in this structure",
// "Move to another structure" => "Move to another structure",
// "at the beginning" => "at the beginning",
// "at the end" => "at the end",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "Submit Article" => "Submit Article",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
// "Language of newly translated page" => "Language of newly translated page",
// "Unspecified" => "Unspecified",
// "Name of newly translated page" => "Name of newly translated page",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Or" => "Or",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Manage existing translations of this page" => "Manage existing translations of this page",
// "Change language for this page" => "Change language for this page",
// "Select from available options.." => "Select from available options..",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Edit Video Information" => "Edit Video Information",
// "Browse Videos" => "Browse Videos",
// "The following video was successfully edited" => "The following video was successfully edited",
// "You can include the video in an HTML page using one of these lines" => "You can include the video in an HTML page using one of these lines",
// "View object" => "View object",
// "Preview your changes" => "Preview your changes",
// "Save the page" => "Save the page",
// "Cancel the edit, you will lose your changes" => "Cancel the edit, you will lose your changes",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "Edit wiki page" => "Edit wiki page",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Edit page" => "Edit page",
// "Edit Comment" => "Edit Comment",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Monitor this page" => "Monitor this page",
// "Add another image" => "Add another image",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Tools" => "Tools",
// "Lock this page" => "Lock this page",
// "Allow comments on this page" => "Allow comments on this page",
// "Regex search " => "Regex search ",
// "Replace with" => "Replace with",
// "Case Insensitivity" => "Case Insensitivity",
// "Upload Screencast" => "Upload Screencast",
// "Incorrect file extension was used for your flash screencast, expecting .swf or .flv" => "Incorrect file extension was used for your flash screencast, expecting .swf or .flv",
// "An unexpected error occurred while uploading your flash screencast" => "An unexpected error occurred while uploading your flash screencast",
// "Incorrect file extension was used for your Ogg screencast, expecting .ogg" => "Incorrect file extension was used for your Ogg screencast, expecting .ogg",
// "A flash screencast is mandatory" => "A flash screencast is mandatory",
// "An unexpected error occurred while uploading your Ogg screencast" => "An unexpected error occurred while uploading your Ogg screencast",
// "Preview not possible" => "Preview not possible",
// "Flash video (required)" => "Flash video (required)",
// "Ogg video (optional)" => "Ogg video (optional)",
// "Add another screencast" => "Add another screencast",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
// "or use" => "or use",
// "Translation request" => "Translation request",
// "Send urgent translation request" => "Send urgent translation request",
// "List Sheets" => "List Sheets",
// "Graph" => "Graph",
// "Export to file" => "Export to file",
// "Format" => "Format",
// "Autodetect" => "Autodetect",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "File Archive" => "File Archive",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Create New File Gallery" => "Create New File Gallery",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Cancel friendship request" => "Cancel friendship request",
// "Global default" => "Global default",
// "Google Map Locator" => "Google Map Locator",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "here" => "here",
// "Importer log" => "Importer log",
// "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "A new install will populate the database" => "A new install will populate the database",
// "Reinstall" => "Reinstall",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them" => "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Tiki Icon" => "Tiki Icon",
// "Interactive translator" => "Interactive translator",
// "has been updated" => "has been updated",
// "Close this window" => "Close this window",
// "Go Back" => "Go Back",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Upload to Kaltura" => "Upload to Kaltura",
// "List Entries" => "List Entries",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Views" => "Views",
// "Plays" => "Plays",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "Max Clicks" => "Max Clicks",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "Rejected" => "Rejected",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Current Value" => "Current Value",
// "SlideShow" => "SlideShow",
// "Keep gallery window open" => "Keep gallery window open",
// "Your comment" => "Your comment",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Media Entries" => "Media Entries",
// "Mix Entries" => "Mix Entries",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "Browse Entries" => "Browse Entries",
// "Additional Info" => "Additional Info",
// "Media Type" => "Media Type",
// "No entries" => "No entries",
// "No media entries found. " => "No media entries found. ",
// "Click here " => "Click here ",
// "to upload" => "to upload",
// "No mix entries found. " => "No mix entries found. ",
// "to create a new mix" => "to create a new mix",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "If an object is not in the special section, then only the default perms are on" => "If an object is not in the special section, then only the default perms are on",
// "Special" => "Special",
// "users registered" => "users registered",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Page aliases found" => "Page aliases found",
// "Last modification" => "Last modification",
// "Page creator" => "Page creator",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "Perform action with checked" => "Perform action with checked",
// "Xml Zip" => "Xml Zip",
// "offline" => "offline",
// "Back to admin" => "Back to admin",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Mods Configuration" => "Mods Configuration",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "licence" => "licence",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "y" => "y",
// "Records" => "Records",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
// "User forum topics" => "User forum topics",
// "Forum topics" => "Forum topics",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
// "Forum replies" => "Forum replies",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "MyInfo" => "MyInfo",
// "Contacts Preferences" => "Contacts Preferences",
// "Sent Edition" => "Sent Edition",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "Edit Permissions" => "Edit Permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign global permissions" => "Assign global permissions",
// "Reset to Global Perms" => "Reset to Global Perms",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "These permissions override any global permissions or category permissions affecting this object" => "These permissions override any global permissions or category permissions affecting this object",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>" => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Make Structure" => "Make Structure",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Any" => "Any",
// "Items found" => "Items found",
// "Rank" => "Rank",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Plugin" => "Plugin",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Add Pages" => "Add Pages",
// "No pages" => "No pages",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Add Structure Pages" => "Add Structure Pages",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "star" => "star",
// "half star" => "half star",
// "Send a link" => "Send a link",
// "Received Pages" => "Received Pages",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "Select your group" => "Select your group",
// "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Back to page" => "Back to page",
// "to version" => "to version",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "Calendar Items" => "Calendar Items",
// "octets" => "octets",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send a structure" => "Send a structure",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "TOC" => "TOC",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "page: %0/%1" => "page: %0/%1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Clean" => "Clean",
// "Params" => "Params",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Usage chart" => "Usage chart",
// "Usage chart image" => "Usage chart image",
// "Daily Usage" => "Daily Usage",
// "Tiki Logs" => "Tiki Logs",
// "Clean logs older than" => "Clean logs older than",
// "months" => "months",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Advanced mode" => "Advanced mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "required field for podcasts" => "required field for podcasts",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "Author, if different from the Creator" => "Author, if different from the Creator",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Add File" => "Add File",
// "Maximum file size is around" => "Maximum file size is around",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "For image files" => "For image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "No gallery available" => "No gallery available",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Default view" => "Default view",
// "Manage Fields" => "Manage Fields",
// "Basic Data" => "Basic Data",
// "User Icon" => "User Icon",
// "(non public)" => "(non public)",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Additional Information" => "Additional Information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Forum comments" => "Forum comments",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Toggle" => "Toggle",
// "Male" => "Male",
// "Female" => "Female",
// "Use Google Map locator" => "Use Google Map locator",
// "Your preferred language" => "Your preferred language",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
// "Select language.." => "Select language..",
// "Display info tooltip on mouseover for every user who allows his/her information to be public" => "Display info tooltip on mouseover for every user who allows his/her information to be public",
// "My user items" => "My user items",
// "My level" => "My level",
// "Account Deletion" => "Account Deletion",
// "Are you really sure you want to delete your account " => "Are you really sure you want to delete your account ",
// "Check this box if you really want to delete your account" => "Check this box if you really want to delete your account",
// "Delete my account" => "Delete my account",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in witch you want to get the reports" => "Interval in witch you want to get the reports",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "Reports are disabled, only standard reporting is available" => "Reports are disabled, only standard reporting is available",
// "Sites you are watching" => "Sites you are watching",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Editing" => "Editing",
// "Post New" => "Post New",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Editing posts" => "Editing posts",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Archived" => "Archived",
// "Topic List" => "Topic List",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "Stop Monitor" => "Stop Monitor",
// "Tracker Items" => "Tracker Items",
// "Pending" => "Pending",
// "Edit/Delete" => "Edit/Delete",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Part" => "Part",
// "View edit icons" => "View edit icons",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Fullscreen" => "Fullscreen",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Leave" => "Leave",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Last Month" => "Last Month",
// "Last Year" => "Last Year",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
// "Save the page as a draft" => "Save the page as a draft",
// "Save Draft" => "Save Draft",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Administration" => "Administration",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new major release branch is available" => "A new major release branch is available",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Feeds settings" => "Feeds settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Text area" => "Text area",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Kaltura settings" => "Kaltura settings",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Object doesn't exists" => "Object doesn't exists",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "No display" => "No display",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "You cannot have a blank password" => "You cannot have a blank password",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "You cannot mix old and new trackers" => "You cannot mix old and new trackers",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Error opening uploaded file" => "Error opening uploaded file",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The list name must be specified" => "The list name must be specified",
// "Sorry, your list could not be added. Please check that it doesn\\'t already exist" => "Sorry, your list could not be added. Please check that it doesn\\'t already exist",
// "Sorry, your list could not be updated. Please check that it already exists" => "Sorry, your list could not be updated. Please check that it already exists",
// "risky" => "risky",
// "off" => "off",
// "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "JavaScript is required for this page" => "JavaScript is required for this page",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "Group name can not be empty" => "Group name can not be empty",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "User login contains invalid characters" => "User login contains invalid characters",
// "Deleted account %s" => "Deleted account %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Last modifications to the blog" => "Last modifications to the blog",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Calendar event : " => "Calendar event : ",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl" => "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "The file you selected is too large to upload" => "The file you selected is too large to upload",
// "Incorrect file extension was used for your 0gg screencast, expecting .ogg" => "Incorrect file extension was used for your 0gg screencast, expecting .ogg",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Back to preferences" => "Back to preferences",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "Page saved (version %d)" => "Page saved (version %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Permission denied: You cannot upload videos" => "Permission denied: You cannot upload videos",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Permission denied: You cannot remix videos" => "Permission denied: You cannot remix videos",
// "Permission denied: You cannot change video version" => "Permission denied: You cannot change video version",
// "Permission denied: You cannot delete kaltura video" => "Permission denied: You cannot delete kaltura video",
// "Permission denied: You cannot download kaltura video" => "Permission denied: You cannot download kaltura video",
// "Permission denied: You cannot edit video information" => "Permission denied: You cannot edit video information",
// "Permission denied: You cannot view video" => "Permission denied: You cannot view video",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "This gallery does not exist" => "This gallery does not exist",
// "Permission denied: You cannot view this page" => "Permission denied: You cannot view this page",
// "Invalid action" => "Invalid action",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Invalid password" => "Invalid password",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "map edit" => "map edit",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Note not found" => "Note not found",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "You are already logged in" => "You are already logged in",
// "You must choose a group" => "You must choose a group",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "A password reminder email has been sent " => "A password reminder email has been sent ",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "invalid email" => "invalid email",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Clean the sql logs" => "Clean the sql logs",
// "Report to the webmaster" => "Report to the webmaster",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Incorrect file extension" => "Incorrect file extension",
// "Your screencast has been uploaded successfully" => "Your screencast has been uploaded successfully",
// "Your screencasts have been uploaded successfully" => "Your screencasts have been uploaded successfully",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "A new page is created in a language" => "A new page is created in a language",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "There are a problem connecting to that account" => "There are a problem connecting to that account",
// "There are a problem deleting that mail" => "There are a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There are a problem deleting mails" => "There are a problem deleting mails",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"ID" => "ID",
"Hits" => "Hits",
"Slideshow" => "Slideshow",
"Algeria" => "Algeria",
"Angola" => "Angola",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Armenia" => "Armenia",
"Australia" => "Australia",
"Austria" => "Austria",
"Bahamas" => "Bahamas",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Belarus" => "Belarus",
"Bermuda" => "Bermuda",
"Bolivia" => "Bolivia",
"Brunei" => "Brunei",
"Bulgaria" => "Bulgaria",
"Chile" => "Chile",
"China" => "China",
"Colombia" => "Colombia",
"Cuba" => "Cuba",
"Ecuador" => "Ecuador",
"Estonia" => "Estonia",
"Fiji" => "Fiji",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Honduras" => "Honduras",
"India" => "India",
"Indonesia" => "Indonesia",
"Iran" => "Iran",
"Iraq" => "Iraq",
"Israel" => "Israel",
"Jamaica" => "Jamaica",
"Kazakstan" => "Kazakstan",
"Kiribati" => "Kiribati",
"Kuwait" => "Kuwait",
"Latvia" => "Latvia",
"Luxemburg" => "Luxemburg",
"Malawi" => "Malawi",
"Malta" => "Malta",
"Mozambique" => "Mozambique",
"Nauru" => "Nauru",
"Nepal" => "Nepal",
"Nicaragua" => "Nicaragua",
"Nigeria" => "Nigeria",
"Niue" => "Niue",
"Pakistan" => "Pakistan",
"Paraguay" => "Paraguay",
"Portugal" => "Portugal",
"Quatar" => "Quatar",
"Samoa" => "Samoa",
"Somalia" => "Somalia",
"Surinam" => "Surinam",
"Taiwan" => "Taiwan",
"Tonga" => "Tonga",
"Tuvalu" => "Tuvalu",
"Uruguay" => "Uruguay",
"Vanuatu" => "Vanuatu",
"Venezuela" => "Venezuela",
"Yugoslavia" => "Yugoslavia",
"Zambia" => "Zambia",
"Zimbabwe" => "Zimbabwe",
"Arabic" => "Arabic",
"Catalan" => "Catalan",
"Pijin Solomon" => "Pijin Solomon",
"Tuvaluan" => "Tuvaluan",
"tracker" => "tracker",
"Wiki" => "Wiki",
"Blogs" => "Blogs",
"FAQs" => "FAQs",
"Trackers" => "Trackers",
"blog" => "blog",
"faq" => "faq",
"poll" => "poll",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"Blog" => "Blog",
"Visible" => "Visible",
"Shibboleth" => "Shibboleth",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Banners" => "Banners",
"Multilingual" => "Multilingual",
"FAQ" => "FAQ",
"Copyright" => "Copyright",
"Shoutbox" => "Shoutbox",
"PHPLayers" => "PHPLayers",
"Webmail" => "Webmail",
"Mail-in" => "Mail-in",
"Integrator" => "Integrator",
"XMLRPC API" => "XMLRPC API",
"Rankings" => "Rankings",
"Local" => "Local",
"tikihash (old)" => "tikihash (old)",
"Mb" => "Mb",
"Normal" => "Normal",
"Top" => "Top",
"Blog post" => "Blog post",
"Tracker" => "Tracker",
"Trackeritem" => "Trackeritem",
"Simple" => "Simple",
"min" => "min",
"sec" => "sec",
"km" => "km",
"No" => "No",
"Foo" => "Foo",
"wiki" => "wiki",
"img-g" => "img-g",
"file-g" => "file-g",
"faqs" => "faqs",
"arts" => "arts",
"blogs" => "blogs",
"cool" => "cool",
"Item" => "Item",
"max" => "max",
"textarea" => "textarea",
"checkbox" => "checkbox",
"drop down" => "drop down",
"jscalendar" => "jscalendar",
"url" => "url",
"Info" => "Info",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
"Avatar" => "Avatar",
"Backlinks" => "Backlinks",
"1|0" => "1|0",
"Banner" => "Banner",
"Blog ID" => "Blog ID",
"Items" => "Items",
"wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
"Chart" => "Chart",
"Sheet ID" => "Sheet ID",
"Data sheet ID" => "Data sheet ID",
"BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
"Cookie" => "Cookie",
"Pre" => "Pre",
"Desc" => "Desc",
"URL" => "URL",
"Sticky" => "Sticky",
"%" => "%",
"Poll" => "Poll",
"Pop-up" => "Pop-up",
"TikiSheet" => "TikiSheet",
"Url" => "Url",
"Id" => "Id",
"Original" => "Original",
"Error" => "Error",
"Flag" => "Flag",
"id" => "id",
"Copyrights" => "Copyrights",
"Total" => "Total",
"Watchlist" => "Watchlist",
"Use" => "Use",
"Perms" => "Perms",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"Blog post:" => "Blog post:",
"d=diff" => "d=diff",
"Ip" => "Ip",
"Diff" => "Diff",
"Archive" => "Archive",
"Mailbox" => "Mailbox",
"Broadcast" => "Broadcast",
"Admin" => "Admin",
"Standard" => "Standard",
"Blog Posts" => "Blog Posts",
"Cache" => "Cache",
"Del" => "Del",
"[-]" => "[-]",
"RSS feed" => "RSS feed",
"Permalink" => "Permalink",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"General" => "General",
"Meta Tags" => "Meta Tags",
"avatar" => "avatar",
"Watches" => "Watches",
"pixels" => "pixels",
"IP" => "IP",
"LDAP" => "LDAP",
"URL:" => "URL:",
"PAM" => "PAM",
"image/png" => "image/png",
"image/bmp" => "image/bmp",
"image/x-icon" => "image/x-icon",
"Robots" => "Robots",
"AutoLinks" => "AutoLinks",
"Quota (Mb)" => "Quota (Mb)",
"Undo" => "Undo",
"Sandbox" => "Sandbox",
"phpinfo" => "phpinfo",
"Banning" => "Banning",
"Cookies" => "Cookies",
"DSN" => "DSN",
"bytes" => "bytes",
"x" => "x",
"Cat" => "Cat",
"Prio" => "Prio",
"Perso" => "Perso",
"h" => "h",
"CMS" => "CMS",
"cookie" => "cookie",
"Admin dsn" => "Admin dsn",
"Coms" => "Coms",
"Cacheable" => "Cacheable",
"Regex" => "Regex",
"Case" => "Case",
"article-put" => "article-put",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Data" => "Data",
"Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
"PHP variable" => "PHP variable",
"Tiki variable" => "Tiki variable",
"sticky" => "sticky",
"Alias" => "Alias",
"bcc" => "bcc",
"Wiki RSS" => "Wiki RSS",
"Blogs RSS" => "Blogs RSS",
"RSS" => "RSS",
"popup" => "popup",
"+" => "+",
"Roles" => "Roles",
"D" => "D",
"M" => "M",
"%m/%d" => "%m/%d",
"cType" => "cType",
"editor" => "editor",
"Mutual" => "Mutual",
"hits (desc)" => "hits (desc)",
"hits (asc)" => "hits (asc)",
"Admin FAQ" => "Admin FAQ",
"normal" => "normal",
"hot" => "hot",
"idea" => "idea",
"neutral" => "neutral",
"XY-Size" => "XY-Size",
"Bounding box" => "Bounding box",
"Imgs" => "Imgs",
"MultiTiki" => "MultiTiki",
"v" => "v",
"Rollback" => "Rollback",
"Img" => "Img",
"Clicks" => "Clicks",
"Prefs" => "Prefs",
"Tikiwiki Mods" => "Tikiwiki Mods",
"quota" => "quota",
"Slides" => "Slides",
"Use " => "Use ",
"Top 10" => "Top 10",
"Top 20" => "Top 20",
"Top 50" => "Top 50",
"Top 100" => "Top 100",
"tikiwiki.org" => "tikiwiki.org",
"pvs" => "pvs",
"#" => "#",
"act" => "act",
"top" => "top",
"Task is not accepted by you, read the task and accept or reject it" => "Task is not accepted by you, read the task and accept or reject it",
"taskId" => "taskId",
"Pos" => "Pos",
"Click ratio" => "Click ratio",
"Emot" => "Emot",
"pts" => "pts",
"Hot" => "Hot",
"Cc" => "Cc",
"CC" => "CC",
"BCC" => "BCC",
"PHP error" => "PHP error",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
"TOP" => "TOP",
"%H:%M %Z" => "%H:%M %Z",
"Sa" => "Sa",
"tiki-mobile.php" => "tiki-mobile.php",
"Pageviews" => "Pageviews",
"Error: " => "Error: ",
"no" => "no",
"unicode" => "unicode",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Esta característica está deshabilitada",
"Permission denied. You cannot view pages" => "No tiene permiso para ver páginas",
"For you to vote, cookies must be allowed" => "Las Cookies deben estar habilitadas para poder votar",
"This forum is flat and doesn't allow replies to other replies" => "Este foro es plano y no permite respuestas a otras respuestas",
"This script cannot be called directly" => "Este script no puede ser llamado directamente",
"The copyright management feature is not enabled." => "La característica de manejo de copyright no está activada.",
"Copyright management" => "Gestión del Copyright",
"No page indicated" => "No se indica una página",
"You must supply all the information, including title and year." => "Debe dar toda la información, incluyendo título y año.",
"You do not have permission to use this feature" => "No tiene permiso para usar esta función",
"This feature is for admins only" => "Esta función es sólo para admins",
"Type" => "Tipo",
"Name" => "Nombre",
"Description" => "Descripción",
"Size" => "Tamaño",
"Created" => "Creada",
"Uploaded" => "Subido",
"Last Modified" => "Modificado",
"Creator" => "Creador",
"Author" => "Autor",
"Last editor" => "Último editor",
"Comment" => "Comentario",
"Files" => "Archivos",
"Locked by" => "Bloqueado por",
"Explorer" => "Explorador",
"Path" => "Camino",
"Default View" => "Vista por defecto",
"American Samoa" => "Samoa_Americana",
"Bahrain" => "Bahrein",
"Belgium" => "Bélgica",
"Brazil" => "Brasil",
"Canada" => "Canadá",
"Cayman Islands" => "Islas_Cayman",
"Cook Islands" => "Islas_Cook",
"Costa Rica" => "Costa_Rica",
"Croatia" => "Croacia",
"Cyprus" => "Chipre",
"Czech Republic" => "República_Checa",
"Denmark" => "Dinamarca",
"Dominican Republic" => "República_Dominicana",
"Egypt" => "Egipto",
"El Salvador" => "El_Salvador",
"Federated States of Micronesia" => "Estados_Federados_de_Micronesia",
"Finland" => "Finlandia",
"France" => "Francia",
"French Polynesia" => "Polinesa_Francesa",
"Germany" => "Alemania",
"Greece" => "Grecia",
"Grenada" => "Granada",
"Haiti" => "Haití",
"Hungary" => "Hungría",
"Iceland" => "Islandia",
"Ireland" => "Irlanda",
"Italy" => "Italia",
"Ivory Coast" => "Ivory_Coast",
"Japan" => "Japón",
"Jordan" => "Jordania",
"Kenya" => "Kenia",
"Lebanon" => "Líbano",
"Lithuania" => "Lituania",
"Malaysia" => "Malasia",
"Marshall Islands" => "Islas_Marshall",
"Mauritius" => "Mauricio",
"Mexico" => "México",
"Morocco" => "Marruecos",
"Netherlands" => "Holanda",
"New Caledonia" => "Nueva_Caledonia",
"New Zealand" => "Nueva_Zelanda",
"None" => "Ninguno",
"Norway" => "Noruega",
"Other" => "Otro",
"Panama" => "Panamá",
"Papua New Guinea" => "Papua_Nueva_Guinea",
"Peru" => "Perú",
"Poland" => "Polonia",
"Puerto Rico" => "Puerto_Rico",
"Romania" => "Rumanía",
"Russia" => "Rusia",
"Saudi Arabia" => "Arabia_Saudita",
"Singapore" => "Singapur",
"Slovakia" => "Eslovaquia",
"Slovenia" => "Eslovenia",
"Solomon Islands" => "Islas_Salomón",
"South Africa" => "Sudafrica",
"South Korea" => "Corea_del_Sur",
"Spain" => "España",
"Sri Lanka" => "Sri_Lanka",
"St Vincent Grenadines" => "St_Vincent_Grenadines",
"Sweden" => "Suecia",
"Switzerland" => "Suiza",
"Thailand" => "Tailandia",
"Trinidad Tobago" => "Trinidad_Tobago",
"Turkey" => "Turquía",
"Ukraine" => "Ucrania",
"United Arab Emirates" => "Emiratos_Arabes_Unidos",
"United Kingdom" => "Reino_Unido",
"United States" => "Estados_Unidos",
"Wales" => "Gales",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Mejorado - MySQL Improved (mysqli). Necesita MySQL 4.1+",
"MySQL classic (mysql)" => "MySQL Clásico (mysql)",
"Email address not valid, test mail not sent" => "Dirección email no válida, el email de prueba no fue enviado",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Dirección de email vacía y casilla \"copia\" no marcada, el email de prueba no fue enviado",
"Test mail from Tiki installer " => "Email de prueba desde el instalador de Tiki ",
"Congratulations!\n\nYour server can send emails.\n\n" => "Genial!\n\nSu servidor puede enviar emails.\n\n",
"Simplified Chinese" => "Chino Simplificado",
"Chinese" => "Chino",
"Czech" => "Checoslovaco",
"Danish" => "Danés",
"German" => "Alemán",
"English" => "Inglés",
"English British" => "Inglés Británico",
"Spanish" => "Español",
"Greek" => "Griego",
"Farsi" => "Persa",
"Finnish" => "Finlandés",
"Fijian" => "Fiyiano",
"French" => "Francés",
"Galician" => "Gallego",
"Hebrew" => "Hebreo",
"Croatian" => "Croata",
"Italian" => "Italiano",
"Japanese" => "Japonés",
"Korean" => "Koreano",
"Hungarian" => "Hungaro",
"Dutch" => "Holandés",
"Norwegian" => "Noruego",
"Polish" => "Polaco",
"Português" => "Portugués",
"Brazilian Portuguese" => "Portugués Brasileño",
"Russian" => "Ruso",
"Slovak" => "Eslovaco",
"Serbian" => "Serbio",
"Serbian Latin" => "Serbio Latin",
"Swedish" => "Sueco",
"Traditional Chinese" => "Chino Tradicional",
"Ukrainian" => "Ucraniano",
"Permission denied" => "Permiso denegado",
"Template %s not registered" => "Plantilla %s no registrada",
"The file is not a CSV file or has not a correct syntax" => "El archivo no es un archivo CSV o no tiene la sintaxis correcta",
"Error line: %d" => "Error en la línea: %d",
"locked" => "bloqueado",
"locked by" => "bloqueado por",
"Administration:" => "Administración:",
"All Day" => "Todo el Día",
"in" => "en",
"continued" => "continuado",
"New Image Uploaded by" => "Nueva imágen subida por",
"New Subscriptions" => "Nueva suscripción",
"New Item in Tracker" => "Nuevo item en tracker",
"by" => "por",
"Image Gallery" => "Galería de imágenes",
"Articles" => "Artículos",
"Forums" => "Foros",
"Directory" => "Directorio",
"File Gallery" => "Galería de archivos",
"Quizzes" => "Cuestionarios",
"Survey" => "Encuesta",
"Newsletter" => "Boletín",
"article" => "artículo",
"directory" => "directorio",
"file gallery" => "galería de archivos",
"forum" => "foro",
"image gallery" => "galería de imágenes",
"newsletter" => "boletín",
"quiz" => "cuestionario",
"survey" => "encuesta",
"wiki page" => "página wiki",
"image" => "imagen",
"calendar" => "calendario",
"Invalid filename (using filters for filenames)" => "Nombre de archivo no válido (usando filtros para nombres de archivo)",
"Cannot upload this file - maximum upload size exceeded" => "No puede subir este archivo tamaño máximo de subida excedido",
"(not registered)" => "(no registrado)",
"Anonymous" => "Anónimo",
"You have mistyped the anti-bot verification code; please try again." => "Ha tecleado mal el código de verificacion anti-bot; intentelo nuevamente.",
"Please wait %d seconds between posts" => "Por favor, espere %d segundos entre posts",
"Wrong password. Cannot post comment" => "Contraseña incorrecta. No puede escribir comentario",
"A contribution is mandatory" => "Una contribución es obligatoria",
"You have to enter a title and text" => "Debe entrar un título y texto",
"Invalid Email" => "Email Inválido",
"This forum is locked" => "Este foro está cerrado",
"This thread is locked" => "Este hilo está cerrado",
"Those comments are locked" => "Estos comentarios están cerrados",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::aplicar: cuenta de líneas no coincide: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_chequeo: fallo",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_chequeo: secuencia de edición es no óptima",
"Line:" => "Línea:",
"Lines:" => "Líneas:",
"Newsletter subscription information at" => "Subscripción al boletín de información en",
"Tiki Link - Insert internal link" => "Enlace Tiki - Insertar enlace interno",
"Find" => "Buscar",
"find" => "encontrar",
"prev" => "ant",
"Page" => "Página",
"next" => "prox",
"Link" => "Enlace",
"Page name" => "Nombre de página",
"File Galleries" => "Galerías de archivos",
"This is the value of your server's PHP '%s' setting" => "Este es el valor de la configuración PHP '%s' de su servidor",
"You are alerted by the server " => "Usted es alertado por el servidor ",
"You can check the modifications at : " => "Puede comprobar las modificaciones en : ",
"You are alerted of a change on " => "Usted es alertado de un cambio en ",
"Wiki Home" => "Inicio Wiki",
"Home" => "Inicio",
"previous page" => "página anterior",
"next page" => "página siguiente",
"posted on" => "escrito en",
"Continue" => "Continúa",
"By:" => "Por:",
"Read" => "Leer",
"List articles" => "Listar artículos",
"Last post" => "Último post",
"Invalid imagename (using filters for filenames)" => "Nombre de imagen no válido (usando filtros para nombres de archivos)",
"Errors detected" => "Errores detectados",
"Upload was not successful" => "La subida no fue exitosa",
"No image yet, sorry." => "Sin imagen aún, lo siento.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "directorio de destino desconocido. Por favor, configurelo en <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "fallo al deshacer el enlace",
"Contributions" => "Contribuciones",
"No valid ogr2ogr executable" => "Ejecutable ogr2ogr no válido",
"Could not create \$tdo.mif in data directory" => "No puedo crear \$tdo.mif en directorio de datos",
"Could not create \$tdo.mid in data directory" => "No puedo crear \$tdo.mid en directorio de datos",
"unknown" => "desconocido",
"User Map Generated in:" => "Mapa de Usuario Generado en:",
"Image Map Generated in:" => "Imagen de Mapa Generado en:",
"menu" => "menú",
"NONE" => "NINGUN",
"File %s not found" => "Fichero %s no encontrado",
"File %s is not a valid archive" => "Fichero %s no es un archivo válido",
"Impossible to open %s : %s" => "Imposible abrir  %s : %s",
"The content retrieved at %s is not a list of mods" => "El contenido devuelto en %s no es una lista de mods",
"Can't chdir to '%s'" => "No es posible hacer chdir a '%s'",
"%s impossible to remove" => "imposible borrar %s",
"Language" => "Lenguaje",
"Section" => "Sección",
"Theme" => "Tema",
"Rows" => "Filas",
"section edit" => "sección de edición",
"Users accept internal messages by default" => "Los usuarios aceptan mensajes internos por defecto",
"Users can opt-out internal messages" => "Los usuarios pueden enviar mensajes internos",
"Title" => "Título",
"Topic" => "Tema",
"Rating" => "Calificación",
"Reads" => "Lecturas",
"Images" => "Imágenes",
"Newest first" => "Más nuevos primero",
"Oldest first" => "Más viejos primero",
"Points" => "Puntos",
"Authentication method" => "Método de autenticacion",
"Tiki and PAM" => "Tiki y PAM",
"CAS (Central Authentication Service)" => "CAS (Servicio de Autenticación Central)",
"Web Server" => "Servidor Web",
"Creation date (desc)" => "Fecha de creación (desc)",
"Last modification date (desc)" => "Fecha de última modificación (desc)",
"Blog title (asc)" => "Título del blog (asc)",
"Number of posts (desc)" => "Número de posts (desc)",
"Visits (desc)" => "Visitas (desc)",
"Activity (desc)" => "Actividad (desc)",
"Disabled" => "Deshabilitado",
"Plain text" => "Texto plano",
"Link to user information" => "Enlace a información de usuario",
"User avatar" => "Avatar de usuario",
"Contact user" => "Contactar usuario",
"Count admin pageviews" => "Contar pageviews de admin",
"default mapfile" => "archivo de mapa por defecto",
"Validate URLs" => "Validar URLs",
"Links per page" => "Enlaces por página",
"Method to open directory links" => "Método para abrir enlaces del directorio",
"replace current window" => "reemplazar ventana actual",
"new window" => "nueva ventana",
"inline frame" => "marco embebido",
"No error reporting" => "Sin reporte de errores",
"Report all PHP errors" => "Reportar todos los errores de PHP",
"Default number of comments per page" => "Cantidad por defecto de comentarios por página",
"Comments default ordering" => "Orden por defecto para comentarios",
"Q and A" => "Preguntas y Respuesta",
"Question ID" => "ID de la Pregunta",
"Polls" => "Votaciones",
"Newsletters" => "Boletines",
"Calendar" => "Calendario",
"Category" => "Categoría",
"Score" => "Puntuación",
"Search" => "Buscar",
"Surveys" => "Encuestas",
"Featured links" => "Enlaces destacados",
"Maps" => "Mapas",
"Live support system" => "Sistema de soporte Live",
"Contact Us" => "Contáctenos",
"Wysiwyg editor" => "Editor wysiwyg",
"Friendship Network" => "Círculo de Amistad",
"Banning system" => "Sistema de Banning",
"Stats" => "Estadísticas",
"Referer Stats" => "Estadísticas de referers",
"Communications (send/receive objects)" => "Comunicaciones (enviar/recibir objetos)",
"Custom Home" => "Inicio Configurable",
"Mini Calendar" => "Mini Calendario",
"User Preferences Screen" => "Pantalla de Preferencias de Usuario",
"User Notepad" => "Cuaderno de notas",
"User Bookmarks" => "Marcadores del usuario",
"User Watches" => "Suscripciones de Usuario",
"User Watches Translations" => "Suscripciones de Usuario de Traducciones",
"User Menu" => "Menú de Usuario",
"User Tasks" => "Tareas del usuario",
"User Messages" => "Mensajes",
"User Files" => "Archivos de usuario",
"Debugger Console" => "Consola del Depurador",
"Protect against CSRF with a ticket" => "Proteger contra CSRF con un ticket",
"Detect browser language" => "Detectar lenguaje del navegador",
"Help System" => "Sistema de Ayuda",
"Smileys" => "Emoticones",
"Dynamic Content System" => "Systema de Contenido Dinámico",
"Display menus as folders" => "Desplegar menús como carpetas",
"Activate" => "Activar",
"Comments" => "Comentarios",
"Submissions" => "Colaboraciones",
"Content templates" => "Plantillas de contenido",
"Print" => "Imprimir",
"Ignore category viewing restrictions" => "Ignorar restricciones de visualización de categoría",
"List pages" => "Listar páginas",
"Last changes" => "Últimas modificaciones",
"Orphan pages" => "Páginas huérfanas",
"Referer Search Highlighting" => "Destacar Búsqueda",
"Search stats" => "Estadísticas de búsquedas",
"Ignore individual object permissions" => "Ignorar permisos individuales de objetos",
"Visits" => "Visitas",
"Accept wiki syntax" => "Aceptar sintaxis wiki",
"Allow same file to be uploaded more than once" => "Permitir el mismo archivo ser subido mas de una vez",
"Never" => "Nunca",
"Uploaded filenames must match regex" => "Archivos subidos deben matchear esta regex",
"Plain" => "Plano",
"Threaded" => "Hilado",
"Headers Only" => "Sólo Cabezales",
"Title (desc)" => "Título (desc)",
"Title (asc)" => "Título (asc)",
"Topics" => "Temas",
"Posts" => "Mensajes",
"Posts per day" => "Mensajes por día",
"Creation Date (asc)" => "Fecha de Creación (asc)",
"Creation Date (desc)" => "Fecha de creación (desc)",
"Topics (desc)" => "Temas (desc)",
"Threads (desc)" => "Mensajes (desc)",
"Last post (desc)" => "Último mensaje (desc)",
"Name (desc)" => "Nombre (desc)",
"Name (asc)" => "Nombre (asc)",
"Browser title" => "Título (ventana del navegador)",
"Home page" => "Página inicio",
"Use group homepages" => "Usar páginas inicio de grupo",
"Go to group homepage only if login from default homepage" => "Ir a página inicial de grupo sólo si se identifica desde la página inicio por defecto",
"Temporary directory" => "Directorio temporal",
"Help URL" => "URL de Ayuda",
"Open external links in new window" => "Abrir enlaces externos en una ventana nueva",
"Full path to gdaltindex" => "Camino completo a gdaltindex",
"Full path to ogr2ogr" => "Camino completo a ogr2ogr",
"Map Zone" => "Zona de Mapa",
"Display modules to all groups always" => "Mostrar siempre módulos a todos los grupos",
"Hide anonymous-only modules from registered users" => "Ocultar módulos solo para usuarios anónimos a los usuarios registrados",
"Content" => "Contenido",
"Use database for translation" => "Usar la base para traducciones",
"CRLF (standard)" => "CRLF-nueva línea (estándar)",
"LF (some Unix MTA)" => "LF-salto de línea (algunos Agentes de Transferencia de Correo (MTA) Unix)",
"full path to mapfiles" => "camino completo a archivos de mapa",
"Wiki Page for Help" => "Página Wiki para Ayuda",
"Wiki Page for Comments" => "Página Wiki para comentarios",
"Maximum mailbox size (messages, 0=unlimited)" => "Tamaño máximo de casilla (mensajes, 0=ilimitado)",
"Maximum mail archive size (messages, 0=unlimited)" => "Tamaño máximo de archivo de mails (mensajes, 0=ilimitado)",
"Maximum sent box size (messages, 0=unlimited)" => "Tamaño máximo de carpeta de enviados (mensajes, 0=ilimitado)",
"geo.position" => "geo.posición",
"geo.region" => "geo.región",
"geo.placename" => "geo.nombrelugar",
"Port" => "Puerto",
"Proxy port" => "Puerto Proxy",
"Record untranslated strings" => "Registrar cadenas no traducidos",
"Refresh rate" => "Tiempo de refresco",
"Minimum length of search word" => "Tamaño mínimo de palabra a buscar",
"Max. number of words containing a syllable" => "Número máximo de palabras conteniendo una sílaba",
"Max. age in hours of syllable search cache" => "Edad máxima en horas de cache de búsqueda de sílabas",
"LRU list purging rate" => "Ritmo de limpieza de lista LRU",
"LRU list length" => "Largo de la lista LRU",
"Sender email" => "Correo-e del enviador",
"Database" => "Base de datos",
"After" => "Después",
"Before" => "Antes",
"Publish" => "Publicar",
"Each day" => "Cada día",
"Each week" => "Cada semana",
"Each month" => "Cada mes",
"Use proxy" => "Usar proxy",
"Allow viewing HTML mails?" => "¿Permitir ver correos HTML?",
"Maximum size for each attachment" => "Tamaño máximo de archivos adjuntos",
"Unlimited" => "Ilimitado",
"Complete" => "Completo",
"Business style" => "Estilo de negocios",
"Collaborative style" => "Estilo colaborativo",
"Page last modified on" => "Página última modificacion en",
"Cache wiki pages (global)" => "Cachear páginas wiki (global)",
"no cache" => "no cachear",
"minute" => "minuto",
"minutes" => "minutos",
"hour" => "hora",
"hours" => "horas",
"Enable wiki 3D browser" => "Activar navegador wiki 3D",
"Browser height" => "Altura del navegador",
"Navigation depth" => "Profundidad de navegación",
"Existing page node color" => "Color de nodo de página existente",
"Missing page node color" => "Color de nodo de página no existente",
"Feed animation interval (milisecs)" => "Intervalo de animación del feed  (milisegs)",
"Created by profile installer" => "Creado por el instalador de perfiles",
"Page updated by profile installer" => "Página actualizada por el instalador de perfiles",
"Wiki top pages" => "Wiki páginas top",
"Most relevant pages" => "Páginas más relevantes",
"Relevance" => "Relevancia",
"Wiki last pages" => "Wiki últimas páginas",
"Modified" => "Modificado",
"Forums last posts" => "Últimos mensajes en foros",
"Topic date" => "Fecha del tema",
"Forums most read topics" => "Foros temas más leídos",
"Forums best topics" => "Foros mejores temas",
"Forums most visited forums" => "Foros más visitados",
"Forums with most posts" => "Foros con más mensajes",
"Wiki top galleries" => "Wiki principales galerías",
"Wiki top file galleries" => "Wiki principales galerías de archivos",
"Wiki top images" => "Wiki principales imágenes",
"Wiki top files" => "Wiki principales archivos",
"Downloads" => "Descargas",
"Wiki last images" => "Wiki últimas imágenes",
"Upload date" => "Fecha de subida",
"Wiki last files" => "Wiki últimos archivos",
"Wiki top articles" => "Wiki principales artículos",
"Most visited blogs" => "Blogs más visitados",
"Most active blogs" => "Blogs más activos",
"Activity" => "Actividad",
"Blogs last posts" => "Blogs últimos posts",
"Post date" => "Fecha post",
"Wiki top authors" => "Wiki principales autores",
"Pages" => "Páginas",
"Top article authors" => "Artículos principales autores",
"The passwords do not match" => "Las contraseñas no coinciden",
"User already exists" => "El usuario ya existe",
"Wrong registration code" => "Código de registro erróneo",
"Invalid username" => "Nombre de usuario no válido",
"Username is too long" => "El nombre del usuario es demasiado largo",
"Username cannot contain whitespace" => "El nombre del usuario no puede tener espacios",
"Wrong passcode. You need to know the passcode to register at this site" => "Código de registro no válido, necesita un código de registro válido",
"Invalid email address. You must enter a valid email address" => "Dirección de correo no válida. Debe entrar una dirección válida de correo",
"The registration mail can't be sent. Contact the administrator" => "El correo de registro no puede ser enviado. Contacte con el administrador",
"change" => "cambiar",
"Today" => "Hoy",
"and" => "y",
"from" => "desde",
"replied" => "respondido",
"Login" => "Conéctate",
"See other users' profiles" => "Ver perfil de otro usuario",
"Have your profile seen" => "Tiene su perfil visto",
"Make friends" => "Hacer amigos",
"Receive message" => "Recibir mensaje",
"Send message" => "Enviar mensaje",
"Read an article" => "Leer un artículo",
"Publish an article" => "Publicar un artículo",
"Have your article read" => "Tiene su artículo leído",
"Create new file gallery" => "Crear nueva galería de archivos",
"Upload new file to gallery" => "Subir nuevo archivo a la galería",
"Download other user's file" => "Bajar otros archivos del usuario",
"Have your file downloaded" => "Tenga su archivo bajado",
"Create a new image gallery" => "Crear nueva galería de imágenes",
"Upload new image to gallery" => "Subir nueva imagen a la galería",
"See other users' galleries" => "Ver la galería de otro usuario",
"See other users' images" => "Ver la imagen de otro usuario",
"Have your gallery seen by other users" => "Tenga su imagen vista por otro usuario",
"Have your image seen" => "Tenga su imagen vista",
"Create new blog" => "Crear nuevo blog",
"Post in a blog" => "Postear en un blog",
"Read other users' blogs" => "Leer el blog de otro usuario",
"Have your blog read" => "Tenga su blog leído",
"Create a new wiki page" => "Crear nueva página wiki",
"Edit an existing page" => "Editar una página existente",
"Attach file" => "Adjuntar archivo",
"Wiki Comment" => "Comentario Wiki",
"Calendar item" => "Elemento del calendario",
"Gallery" => "Galería",
"Image" => "Imagen",
"Forum" => "Foro",
"Article" => "Artículo",
"Tracker item" => "Elemento del tracker",
"Unknown" => "Desconocido",
"Directory category" => "Categoría de directorio",
"Advanced" => "Avanzado",
"_HOMEPAGE_CONTENT_" => "{GROUP(groups=Admins)}\n! Gracias por instalar Tiki.\n\nLa Comunidad de Tiki en conjunto quisiera darte las gracias y ayudarte con tu introducción a Tiki.\n\n! Cómo empezar\nTiki tiene más de 1000 funcionalidades y ajustes.\n\nEsto te permite crear sitios web desde muy simples hasta muy complejos.\n\nEntendemos que un software con tantas características puede parecer abrumador al principio. Esta es la razón por la que te ofrecemos dos maneras diferentes para __Ponerte en marcha__ con Tiki.\n\n{DIV(width=\"48%\",float=\"right\")}\n-= Configuración Manual utilizando el Panel de Administración =-\n! [tiki-admin.php|Ponte en marcha utilizando el Panel de Administración]\n__Quien debería emplear esto__\n* Estás familiarizado con paneles de administración de programas\n* Te gusta explorar y jugar con muchas opciones\n* Ya conoces Tiki\n\n\n{DIV}{DIV(width=\"48%\",float=\"left\")}\n-= Ajuste fácil empleando Perfiles =-\n!! [tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|Ponte en marcha usando Perfiles]\n__Quién debería emplear esto__\n* Quieres empezar rápidamente\n* No tienes ganas de aprender el Panel de Administración inmediatamente\n* Quieres probar de forma rápida algunas funcionalidades de Tiki\n\n!! Perfiles destacados\n\n__Comunidad Colaborativa__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instala el perfil ahora])\nConfiguración para ayudar a entusiastas y expertos en sus materias a trabajar conjuntamente para construir una Base de Conocimiento\n* Edición de Wiki\n* Espacios personales para los miembros\n* Foros\n* Bitácoras (Blogs)\n\n__Bitácora (Blog) y perfil personal__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instala el perfil ahora])\nConfiguración con muchas funcionalidades guays para ayudarte a ser parte de la Web Social y establecer una presencia notable en la Blogosfera\n* Bitácora (Conjunto completo de características relacionadas con la bitácora)\n* Galería de Imágenes\n* Calendario\n* Integración RSS\n* Registro de vídeos\n\n__Intranet de Empresa__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instala el perfil ahora])\nConfiguración para una intranet de Empresa de un negocio típico de tamaño mediano (PYME).\n* Artículos de Noticias de la Empresa\n* Bloque Ejecutivo\n* Gestión de archivos y repositorios\n* Wiki colaborativo\n\n__Presencia Web de una Organización Pequeña__ ([tiki-admin.php?profile=&category=Featured+profiles&repository=http%3a%2f%2fprofiles.tikiwiki.org%2fprofiles&preloadlist=y&page=profiles&list=List#profile-results|instala el perfil ahora])\nConfiguración para la presencia web de una entidad sin ánimo de lucro, ONG o pequeña empresa típica.\n* Noticias de la entidad y actualizaciones\n* Destacar los Productos y Servicios de la entidad\n* Galería de archivos (ideal para un kit para los medios de comunicación)\n* Formulario de Contacto{DIV}\n\n{ELSE}\n\n! Felicidades\nEsta es la página inicial por omisión para tu Tiki. Si ves esta página, tu instalación se ha realizado correctamente.\n\nPuedes cambiar esta página después de conectarte. Por favor, revisa la [http://doc.tikiwiki.org/wiki+syntax|sintaxis wiki] para los detalles de edición.\n\n!!{img src=pics/icons/star.png alt=\"Star\"} Ponte en marcha.\n\nPara empezar la configuración de tu sitio:\n{FANCYLIST()}\n1) Inicia la sesión como usuario __admin__ con contraseña __admin__.\n2) Cambia la contraseña de administrador.\n3) Habilita funcionalidades específicas de Tiki.\n4) Configura las funcionalidades.\n{FANCYLIST}\n\n\n!! {img src=pics/icons/help.png alt=\"Help\"} ¿Necesitas ayuda?\nPara más información:\n* [http://info.tikiwiki.org/Learn+More|Más información sobre TikiWiki].\n* [http://info.tikiwiki.org/Help+Others|Obtener ayuda], incluidos la [http://doc.tikiwiki.org|documentación oficial] y los [http://www.tikiwiki.org/forums|foros de ayuda].\n* [http://info.tikiwiki.org/Join+the+community|Únete a la comunidad TikiWiki].\n{GROUP}",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin desactivado: feature_jquery off -->",
"Fast Next" => "Siguiente Rápido",
"Fast Prev" => "Anterior Rápido",
"Prev" => "Anterior",
"Next" => "Próximo",
"First {\$params['itemname']}" => "Primer {\$params['itemname']}",
"Last {\$params['itemname']}" => "Último {\$params['itemname']}",
"Next {\$params['itemname']}" => "Siguiente {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Anterior {\$params['itemname']}",
"comment" => "comentario",
"Click Here" => "Haga click acá",
"Edit Template" => "Editar plantilla",
"Admin Feature" => "Administrar Característica",
"Hide" => "Ocultar",
"help" => "ayuda",
"All" => "Todos",
"The text is" => "El texto es",
"character(s) too long - please edit it." => "caracter(es) demasiado largo - por favor edítelo.",
"Date Selector" => "Selector de Fecha",
"phplayers are not available on this site" => "phplayers no están disponibles en este sitio",
"Select All" => "Elegir todo",
"Invert Sort" => "Ordenar Invertido",
"days" => "días",
"day" => "día",
"mins" => "minutos",
"secs" => "segs",
"done" => "listo",
"Text cut here" => "Texto corte aquí",
"Task" => "Tarea",
"for" => "para",
"Priority" => "Prioridad",
"Start date:" => "Fecha inicial:",
"End date:" => "Fecha final:",
"Friend" => "Amigo",
"Last seen on" => "Visto por última vez en",
"(idle for %s seconds)" => "(inactivo por %s segundos)",
"User information - Click for more info" => "Información de Usuario - Cliquee para mas info",
"More info about \$other_user" => "Más info acerca de \$other_user",
"(idle for \$idletime seconds)" => "(inactivo por \$idletime segundos)",
"Yes" => "Sí",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "Primer día de la semana: Domingo (su ID es 0) - ¡traductores necesitan localizar esta cadena!",
"Use this tree to copy the structure" => "Use este árbol para copiar la estructura",
"created from structure" => "crear desde estructura",
"Table of contents" => "Tabla de contenidos",
"You have to make %d choice(s) for the question" => "Tiene que elegir %d opción/opciones para la pregunta",
"You have to make at least %d choice(s) for the question" => "Tiene que elegir al menos %d opción/opciones para la pregunta",
"You have to make less than %d choice(s) for the question" => "Tiene que elegir menos de %d opción/opciones para la pregunta",
"You have to choose at least %d choice(s) for the question" => "Tiene que elegir al menos %d opción/opciones para la pregunta",
"text" => "texto",
"Face" => "Apariencia",
"unknown error" => "error desconocido",
"You are not logged in" => "No estás conectado",
"Page cannot be found" => "La página no pudo ser encontrada",
"Page '%0' cannot be found" => "Página '%0' no puede ser encontrada",
"Permission denied. You cannot view this section" => "Permiso denegado para acceder a esta sección",
"For the security of your password direct access to the feed is only available via https" => "Para la seguridad de su contraseña el acceso directo al feed está disponible solo a través de https",
"Help link" => "Enlace de ayuda",
"Help" => "Ayuda",
"You are banned from" => "Está baneado de",
"quizzes" => "cuestionarios",
"forums" => "foros",
"Edit Plugin" => "Editar Plugin",
"Click to edit dynamic variable" => "Clic para editar variable dinámica",
"Update variables" => "Actualizar variables",
"Edit Section" => "Editar Sección",
"index" => "índice",
"Show" => "Mostrar",
"sad" => "triste",
"confused" => "confundido",
"mad" => "loco",
"%d points" => "%d puntos",
"Removed" => "Eliminado",
"__WARNING__: No such module \$plugin!" => "__ADVERTENCIA__: No existe módulo \$plugin!",
"at" => "en",
"new" => "nuevo",
"Create page:" => "Crear página:",
"Unknown language" => "Lenguaje desconocido",
"Click here to confirm your action" => "Cliquee aquí para confirmar su acción",
"Sea Surfing (CSRF) detected. Operation blocked." => "Sea Surfing (CSRF) detectado. Operación bloqueada.",
"Heading" => "Encabezado",
"Reduce area height" => "Reducir altura del área",
"Enlarge area height" => "Ampliar altura del área",
"Wiki Help" => "Wiki ayuda",
"Item Modification" => "Modificación de ítem",
"Item creation" => "Creación de ítem",
"Subject" => "Tema",
"Tracker was modified at " => "Tracker fue modificado en ",
"View the tracker item at:" => "Ver el ítem de tracker en:",
"Field is not numeric" => "El campo no es numérico",
"Field is not a link to mp3 in the gallery" => "El campo no en un enlace a un mp3 en la galería",
"Field is not a link to FLV in the gallery" => "El campo no es un enlace a un FLV en la galería",
"Field is not a link to FLV or MP3 in the gallery" => "El campo no es un enlace a un FLV o MP3 en la galería",
"text field" => "texto",
"half column" => "media columna",
"size" => "tamaño",
"prepend" => "anteponer",
"append" => "agregar",
"numeric field" => "campo numérico",
"user selector" => "selector de usuario",
"group selector" => "selector de grupo",
"date and time" => "fecha y hora",
"action" => "acción",
"header" => "cabezal",
"category" => "categoría",
"item link" => "enlace a ítem",
"items list" => "lista de ítems",
"email" => "correo",
"system" => "sistema",
"attachment" => "adjunto",
"open" => "abierta",
"pending" => "pendiente",
"closed" => "cerrado",
"Message" => "Mensaje",
"No extra information for that attached file. " => "No hay información extra para ese archivo asociado. ",
"child categories" => "subcategorías",
"objects in category" => "objectos en la categoría",
"(AT)" => "(EN)",
"(DOT)" => "(PUNTO)",
"You must validate your account first. An email has been sent to you" => "Debe validar su cuenta primero. Un email le ha sido enviado",
"Password should be at least" => "La contraseña debe tener al menos",
"characters long" => "caracteres de longitud",
"Password must contain both letters and numbers" => "La contraseña debe tener letras y números",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "El email de registro no puede ser enviado porque no se establecido la dirección del servidor de correo, y esta característica está deshabilitada",
"The user email confirmation can't be sent. Contact the administrator" => "La confirmación del email del usuario no pudo ser enviada. Contacte con el administrador",
"Personal Phone" => "Teléfono Personal",
"Personal Mobile" => "Móvil Personal",
"Personal Fax" => "Fax Personal",
"Work Phone" => "Teléfono del Trabajo",
"Work Mobile" => "Móvil del Trabajo",
"Work Fax" => "Fax del Trabajo",
"Company" => "Compañía",
"Organization" => "Organización",
"Department" => "Departamento",
"Division" => "División",
"Job Title" => "Puesto de Trabajo",
"Street Address" => "Calle",
"City" => "Ciudad",
"State" => "Estado",
"Zip Code" => "Código Postal",
"Country" => "País",
"No subject" => "Sin tema",
"User-Agent Info" => "Información del Agente de usuario",
"Info required - IP|SVRSW|BROWSER" => "Información requerida - IP|SVRSW|BROWSER",
"Displays browser client info" => "Muestra información del navegador del cliente",
"Anchor Link" => "Enlace a Marca",
"Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Pone un enlace a una posición en una página wiki. Úsese en conjunción con el plugin ANAME que pone la ubicación y nombre para la posición.",
"linktext" => "textoenlace",
"Anchor Name" => "Nombre de la Marca",
"Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Pone una posición dentro de una página wiki. Úsese en conjunción con el plugin ALINK, que pone enlaces a la posición",
"Image Annotation" => "Anotación de la imagen",
"Location" => "Ubicación",
"Width" => "Ancho",
"Height" => "Alto",
"Alignment" => "Alineado",
"Save changes to annotations" => "Guardar cambios en anotaciones",
"Field" => "Campo",
"Article ID" => "ID del Artículo",
"Includes an article" => "Incluye un artículo",
"Article List" => "Lista de Artículos",
"Articles displayed" => "Artículos mostrados",
"Category ID" => "ID de la Categoría",
"Sort order" => "Tipo de ordenación",
"Quiet" => "Silencioso",
"Title only" => "Solo el título",
"Includes articles listing into a wiki page" => "Incluir lista de ariculos en la página wiki",
"Attachment" => "Adjunto",
"File" => "Archivo",
"Show description" => "Ver descripción",
"Bullets" => "Puntos",
"Inline" => "En línea",
"Number" => "Número",
"Show icon" => "Mostrar icono",
"No such attachment on this page" => "No esta ese archivo asociado a esta página",
"Displays an attachment or a list of them" => "Muestra un archivo asociado o una lista de ellos",
"Gives the name of the attached file to link to" => "Proporcione el nombre del fichero adjunto que va a enlazar",
"Same as name" => "Igual que el nombre",
"Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "De el nombre de otra página en la que esté el archivo adjunto. El archivo de esa página será enlazado. Sólo funciona con páginas wiki",
"Shows the description as the link text instead of the file name" => "Muestra la descripción como el texto del enlace en lugar del nombre del fichero",
"Makes the list of attachments a bulleted list" => "Hace la lista de adjuntos un lista de puntos",
"Says that this file is an image, and should be displayed inline using the img tag" => "Indica que el fichero es una imagen y que por lo tanto debería ser mostrada en la línea utilizando la etiqueta img (img tag)",
"Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Coloca las cosas entre las etiquetas {ATTACH} tags como el texto del enlace en lugar del nombre del fichero o la descripción",
"Shows all attachments from the whole wiki" => "Muestra todos los adjuntos de toda la wiki",
"Gives the number, in the list of attachments, of the attachment to link to" => "Da el número, referido a la lista de adjuntos, del fichero a enlazar",
"Gives the actual id of the attachment to link in. You probably should never use this" => "Da el id real del adunto a enlazar. Probablemente no debería utilizar nunca esta opción",
"Puts the number of downloads in the alt comment" => "Escribe el número de descargas en el comentario alt",
"Shows a file icon" => "Muestra el icono del fichero",
"Displays the user Avatar" => "Mostrar Avatar del usuario",
"username" => "usuario",
"Float" => "Flotante",
"left|right" => "izquierda|derecha",
"Back" => "Atrás",
"Displays a link that allows to go back in the browser history" => "Muestra un enlace que permite ir hacia atrás in en historial de búsqueda",
"Insert back link on wiki page" => "Inserta una línea en blanco en la página wiki",
"Displayed information" => "Información mostrada",
"Pipe separated list of fields to display. ex: hits|user" => "Muestra la lista de campos separados con |. Por ejemplo: hits|user",
"Excluded pages" => "Páginas excluidas",
"Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Muestra las páginas excluidas del listado separadas con |. Por ejemplo: HomePage|Sandbox",
"Include Self" => "Incluir en la lista la página a las que las otras enlazan",
"No Header" => "Sin Cabecera",
"List all pages that link to specific pages" => "Muestra todas las páginas que enlazan a páginas específicas",
"No pages links to" => "Ninguna página tiene enlace a",
"One page links to" => "Una página tiene enlace a",
"pages link to" => "páginas tienen enlace a",
"Insert a banner" => "Insertar un banner",
"Zone" => "Zona",
"Target" => "Objetivo",
"missing parameter" => "falta un parámetro",
"Blog List" => "Lista de Blogs",
"Numeric value" => "Valor numérico",
"Use BLOGLIST to include posts from a blog. Syntax is" => "Utilice BLOGLIST para incluir post desde un blog. La sintaxis es",
"where Id is the blog Id and Items is the max number of posts to display" => "Donde Id es el Id del blog e Items es el número máximo de posts a mostrar",
"Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ejemplo: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
"Box" => "Caja",
"Insert theme-styled box on wiki page" => "Inserta un cuadro con el estilo del tema en una página wiki",
"Box title" => "Título de la caja",
"Displayed above the content" => "Mostrar el contenido encima",
"Background color" => "Color de fondo",
"Box width" => "Ancho de la caja",
"Text Alignment" => "Alineado del Texto",
"Float Position" => "Posición Flotante",
"CSS Class" => "Clase CSS",
"Category IDs" => "IDs de las Categorías",
"Types" => "Tipos",
"List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "Lista de tipos de objetos a incluir separados por el signo + en la lista. Ejemplo: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
"Sort Order" => "Orden de ordenación",
"fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, campos válidos: type, created, name, hits, shuffle",
"Split" => "Separar",
"And" => "Y",
"Insert list of items with the current/given category in the wiki page" => "Insertar lista de items para la actual/ingresadas categorías en página wiki",
"Categories are disabled" => "Las categorías están desactivadas",
"Category Orphans" => "Categorías Huérfanas",
"Display Tiki objects that have not been categorized" => "Muestra objectos Tiki que no han sido categorizados",
"Objects" => "Objetos",
"Category Path" => "Ruta de la Categoría",
"Separator" => "Separador",
"Display top category" => "Mostar la categoría superior (top)",
"yes|no, default to no" => "si|no, por defecto es no",
"Insert the full category path for each category that this wiki page belongs to" => "Inserte el camino completo de categoría para cada categoría a la cual pertenece esta página wiki",
"Center" => "Centrar",
"Centers the plugin content in the wiki page" => "Centra el contenido del plugin en la página wiki",
"Chart Type" => "Tipo de gráfico",
"Chart Width" => "Ancho del gráfico",
"Chart Height" => "Alto del gráfico",
"Value series" => "Series de valores",
"Required for pie charts" => "Requerido por los gráficos de sectores",
"Independant series" => "Series independientes",
"Required for types other than pie chart" => "Requeridos por otros tipos de gráficos diferentes al de sectores",
"Dependant series" => "Series dependientes",
"Styles" => "Estilos",
"Labels" => "Etiquetas",
"title" => "título",
"Chart as PDF" => "Gráfico como PDF",
"Chart as PostScript" => "Gráfico como PostScript",
"Code" => "Código",
"Displays a snippet of code" => "Muestra una porción de código",
"code" => "código",
"Caption" => "Título",
"Colors" => "Colores",
"Line numbers" => "Números de línea",
"Wiki syntax" => "Sintaxis wiki",
"Right to left" => "De derecha a izquierda",
"0|1, switch the text display from left to right to right to left" => "0|1, cambia a mostrar el texto de derecha a izquierda",
"Content is HTML" => "El contenido es HTML",
"0|1, display the content as is instead of escaping HTML special chars" => "0|1, muestra el contenido tal como es en lugar de no mostrar los caracteres especiales de HTML",
"note: colors and ln are exclusive" => "nota: colores y ln son exclusivo",
"Dynamic Content" => "Contenido dinámico",
"Insert copyright notices" => "Inserta aviso de copyright",
"Example" => "Ejemplo",
"seconds" => "segundos",
"Clear" => "Limpiar",
"Creates a definition list" => "Crea lista de definiciones",
"term" => "término",
"definition" => "definición",
"one definition per line" => "una definición por línea",
"Events" => "Eventos",
"Upcoming events" => "Próximos eventos",
"Label" => "Etiqueta",
"Displays the data using the Tikiwiki odd/even table style" => "Muestra los datos usando el estilo de tabla par/impar de Tikiwiki",
"cells" => "celdas",
"sort" => "ordenar",
"Displays a Flash (.swf) file in the wiki page" => "Muestra un SWF en la página wiki",
"failed" => "fallo",
"description" => "descripción",
"Value" => "Valor",
"Displays a graphical GAUGE" => "Despliega un GAUGE gráfico",
"type" => "tipo",
"Group" => "Grupo",
"groups" => "grupos",
"HTML code" => "código HTML",
"name" => "nombre",
"Image ID" => "ID de imagen",
"Image size" => "Tamaño de la imagen",
"Image height" => "Alto de la imagen",
"Image width" => "Ancho de la imagen",
"Thumbnail" => "Miniatura",
"Browse" => "Visitar",
"Download" => "Bajar",
"Include" => "Incluir",
"Start" => "Comienzo",
"Stop" => "Detener",
"Include a page" => "Incluir una página",
"Email address" => "Dirección de correo",
"Displays the text only if the language matchs" => "Despliega el texto sólo si el lenguaje coincide",
"Last Modification" => "última modificación",
"List Pages" => "Listar páginas",
"Sort" => "Ordenar",
"or" => "o",
"Filter" => "Filtrar",
"complete" => "completo",
"articles" => "artículos",
"Lists files in a directory" => "Lista archivos en un directorio",
"could not be opened because it doesn't exist or permission was denied" => "no puede abrirse porque no existe o el permiso fue denegado",
"Map" => "Mapear",
"Feature disabled" => "Opción deshabilitada",
"Template" => "Plantilla",
"Style" => "Estilo",
"Groups" => "Grupos",
"Module Name" => "Nombre de módulo",
"Please choose a module" => "Por favor elija un módulo",
"to be used as argument" => "para ser usado como argumento",
"Displays a module inline in a wiki page" => "Despliega un módulo embebido en la página",
"Sorry, no such module" => "Lo siento no existe módulo",
"Font" => "Fuente",
"Displays the data using a monospace font" => "Muestra los datos usando fuente monoespaciada",
"Text" => "Texto",
"data" => "datos",
"Object" => "Objeto",
"Days" => "Días",
"Status" => "Estado",
"Picture" => "Imagen",
"picture not found" => "dibujo no encontrado",
"Information" => "Información",
"Displays a list of plugins available in this wiki." => "Provee una lista de plugins en este wiki.",
"No version indicated" => "No se indica una versión",
"No arguments indicated" => "No se indicaron argumentos",
"Displays the output of a poll, fields are indicated with numeric ids." => "Muestra la salida de una votación, campos son indicados con ids numéricos.",
"missing poll ID for plugin POLL" => "no se encuentra ID de votación para el plugin POLL",
"wrote:" => "escribió:",
"Quote:" => "Cita:",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Cita texto rodeándolo con una caja, como el comando [QUOTE] de BBCode",
"Preferences" => "Preferencias",
"User Information" => "Información del usuario",
"one data per line" => "un dato por línea",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Toma expresiones regex y parsea el contenido entre las marcas REGEX y reemplaza el texto.",
"Icon" => "Icono",
"Close" => "Cerrar",
"Date" => "Fecha",
"Automatically creates a link to the appropriate SourceForge object" => "Automáticamente crea un enlace al objeto de Sourceforge apropiado",
"Sheet Heading" => "Cabecera de la Planilla",
"Edit Sheet" => "Editar Hoja",
"List wiki pages" => "Lista páginas wiki",
"Display" => "Mostrar",
"Last modified by" => "Ultima modificación por",
"Action" => "Acción",
"The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "El plugin SNARF se reemplaza a si mismo con el cuerpo BODY de una URL. Reemplazos arbitrarios de regex pueden ser hechos en este contenido usando regex y regexres, el ultimo es usado como segundo argumento a preg_replace.",
"This data is put in a CODE caption." => "Este dato es puesto en una leyenda CODE.",
"Missing url parameter for SNARF plugin." => "Parámetro faltante para el plugin SNARF.",
"Sorts the plugin content in the wiki page" => "Ordena el contenido del plugin en la página wiki",
"Order" => "Orden",
"Split a page into rows and columns" => "Separa una página en filas y columnas",
"First" => "Primero",
"Edit" => "Editar",
"row1col1" => "fila1col1",
"row1col2" => "fila1col2",
"row2col1" => "fila2col1",
"row2col2" => "fila2col2",
"Run a sql query" => "Ejecuta una consulta sql",
"sql query" => "consulta sql",
"Missing db param" => "Falta parámetro de db",
"Displays text in subscript." => "Despliega texto como subíndice.",
"Subscribe" => "Suscribir",
"Displays the thumbnail for an image" => "Muestra la miniatura para una imagen",
"Search the titles of all pages in this wiki" => "Buscar los títulos de todas las páginas en este wiki",
"No pages found for title search" => "No se encontraron páginas en la búsqueda por título",
"One page found for title search" => "Se encontró una página en la búsqueda por título",
"pages found for title search" => "páginas encontradas en la búsqueda por título",
"Structure ID" => "ID de Estructura",
"Public" => "Público",
"Translate" => "Traducir",
"Fields" => "Campos",
"Email" => "Correo",
"to" => "a",
"template" => "plantilla",
"Preview" => "Vista previa",
"preview" => "vista previa",
"View" => "Ver",
"Displays an input form for tracker submit" => "Muestra formulario de entrada para enviar al tracker",
"Fields marked with a * are mandatory." => "Campos marcados con un * son obligatorios.",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Muestra la salida del contenido de un tracker, campos son indicado con ids numéricos.",
"Mode" => "Modo",
"Delete" => "Borrar",
"Error in tracker ID" => "Error en ID de tracker",
"No field indicated" => "No se indicó campo",
"Links to a translated content" => "Enlaza a contenido traducido",
"Displays the number of registered users" => "Muestra el número de usuarios registrados",
"User List" => "Lista de Usuarios",
"Real Name" => "Nombre real",
"users" => "usuarios",
"Versions" => "Versiones",
"Split the text in parts visible only under some conditions" => "Divide el texto en partes visible solo bajo algunas condiciones",
"Vote" => "Votar",
"Table" => "Tabla",
"External Wiki" => "Wiki Externo",
"valid" => "válido",
"width" => "ancho",
"Width in pixels" => "Ancho en pixels",
"height" => "altura",
"Height in pixels" => "Alto pixels",
"ERROR: Either the subject or body must be non-empty" => "ERROR: Tanto el tema o el cuerpo no deben estar vacíos",
"ERROR: No valid users to send the message" => "ERROR: Sin usuarios válidos para enviarles el mensaje",
"Invalid user" => "Usuario no válido",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "La carpeta de enviados esta llena. Archive o borre algunos mensajes enviados si quiere enviar mas mensajes.",
"User %s can not receive messages, mailbox is full" => "El usuario %s no puede recibir mensajes, casilla de correo llena",
"User %s can not receive messages" => "El usuario %s no puede recibir mensajes",
"Invalid user: %s" => "Usuario no válido: %s",
"Message will be sent to: " => "El mensaje será enviado a: ",
"Archive is full. Delete some messages from archive first." => "Archivo lleno, borre algunos mensajes del archivo primero.",
"No more messages" => "No hay más mensajes",
"Categories" => "Categorías",
"Categorize" => "Categorizar",
"Unassign" => "Inhabilitar",
"Assign" => "Asignar",
"Received objects" => "Objetos recibidos",
"File galleries" => "Galerías de archivos",
"Last forum posts" => "Últimos mensajes en foro",
"Topics only" => "Sólo temas",
"Most commented forums" => "Foros con mas mensajes",
"Most read topics" => "Temas mas leídos",
"Most visited forums" => "Foros mas visitados",
"Google Search" => "Buscar en Google",
"Last actions" => "Últimas acciones",
"Last blog posts" => "Últimos posts en blogs",
"no object here yet" => "no hay objetos aquí aún",
"Last Created blogs" => "Últimos blogs creados",
"Last Created FAQs" => "Últimos FAQs creadas",
"Last Created Quizzes" => "Últimos Cuestionarios",
"Last modified file galleries" => "Galerías de archivos modificadas recientemente",
"Last Files" => "Últimos archivos",
"Last Images" => "Últimas Imágenes",
"Last modified events" => "Últimos eventos modificados",
"Last Modified blogs" => "Blogs recientemente modificados",
"Last submissions" => "Últimas colaboraciones",
"Last Items" => "Últimos ítems",
"Last Modified Items" => "Items recientemente modificados",
"Last Visitors" => "Últimos visitantes",
"Live support" => "Soporte Live",
"Messages" => "Mensajes",
"Waiting Submissions" => "Colaboraciones en espera",
"Old articles" => "Artículos viejos",
"Create/Edit" => "Crear/editar",
"Quick Edit a Wiki Page" => "Editar una página del wiki",
"Random Pages" => "Páginas aleatorias",
"New user registration" => "Registro de nuevo usuario",
"Post" => "Postear",
"Since your last visit" => "Desde su última visita",
"Changes since" => "Cambios desde",
"new comments" => "comentarios",
"wiki pages changed" => "páginas wiki modificadas",
"new articles" => "nuevos artículos",
"new FAQs" => "nuevas FAQs",
"new blogs" => "nuevos blogs",
"new blog posts" => "nuevos posts en blogs",
"new image galleries" => "nuevas galerías de imágenes",
"new images" => "imágenes nuevas",
"new file galleries" => "nuevas galerías de archivos",
"new files" => "nuevos archivos",
"new polls" => "nuevas votaciones",
"new users" => "nuevos usuarios",
"Most Active blogs" => "Blogs más activos",
"Top articles" => "Artículos más leídos",
"Top File Galleries" => "Galerías de archivos Top",
"Top files" => "Top archivos",
"Top Forum Posters" => "Principales Participantes en Foros",
"Top Images" => "Imágenes Top",
"Top Pages" => "Páginas Top",
"Top Quizzes" => "Top Cuestionarios",
"Top Visited FAQs" => "FAQs mas visitadas",
"User Blogs" => "Blogs del usuario",
"My blogs" => "Mis blogs",
"User bookmarks" => "Marcadores del usuario",
"My galleries" => "Mis galerías",
"User Pages" => "Páginas del usuario",
"My Pages" => "Mis páginas",
"User tasks" => "Tareas de Usuario",
"The task title must have at least 3 characters" => "El título de la tarea debe tener al menos 3 caracteres",
"Public tasks" => "Tareas públicas",
"Top users" => "Principales usuarios",
"Online users" => "Usuarios en línea",
"Last wiki comments" => "Últimos comentarios wiki",
"Invalid username or password" => "Usuario o contraseña no válidos",
"sender email" => "correo-e del enviador",
"country" => "país",
"theme" => "tema",
"Anti-Bot verification code" => "Código de verificación anti-bot",
"Random Image" => "Imagen aletoria",
"Enter the code you see above" => "Entre el código que ve arriba",
"List of attached files" => "Lista de archivos adjuntos",
"desc" => "descripción",
"uploaded" => "subida",
"Remove" => "Eliminar",
"Upload file" => "Subir archivo",
"Attach" => "Adjuntar",
"Attach a file to this item" => "Adjuntar archivo al item",
"Version" => "Versión",
"Attachments" => "Archivos adjuntos",
"more info" => "más info",
"No attachments for this item" => "No hay archivos adjuntos",
"debug" => "depurar",
"Fatal error" => "Error fatal",
"Created by" => "Creado por",
"on" => "en",
"Activity=" => "Actividad=",
"Actions" => "Acciones",
"Properties" => "Propiedades",
"No records found" => "No se encontraron registros",
"Admin Categories" => "Admin categorías",
"No categories defined" => "No se definieron categorías",
"Browse Category" => "Navegar categoría",
"posts:" => "mensajes:",
"stars" => "estrellas",
"User Level" => "Nivel de usuario",
"private message" => "mensaje privado",
"Send eMail to User" => "Enviar correo a usuario",
"user online" => "usuario en línea",
"user offline" => "usuario fuera de línea",
"Reply" => "Responder",
"Approve" => "Aprobar",
"Reject" => "Rechazar",
"Save to notepad" => "Salvar a bloc de notas",
"Monitor this Topic" => "Monitorizar este tópico",
"Stop Monitoring this Topic" => "Dejar de monitorizar este tópico",
"Moderator actions" => "Acciones de moderador",
"reported:" => "reportado:",
"queued:" => "en cola:",
"Move to topic:" => "Mover al tema:",
"Move" => "Mover",
"Delete Selected" => "Borrar seleccionados",
"Unlock" => "Desbloquear",
"Lock" => "Desbloquear",
"Threshold" => "Puntuación mínima",
"Replies" => "Respuestas",
"below your current threshold" => "por debajo de su umbral actual",
"New Reply" => "Nueva respuesta",
"Editing reply" => "Editar respuesta",
"Reply to the selected post" => "Responder al mensaje elegido",
"Editing comment" => "Editando mensaje",
"Comment on the selected post" => "Comentar en el post elegido",
"Post new comment" => "Escribir comentario",
"Toolbars" => "Quicktags",
"optional" => "opcional",
"Reply to parent post" => "Responder al mensaje padre",
"Post new reply" => "Escribir nueva respuesta",
"Cancel" => "Cancelar",
"Posting replies" => "Escribir respuestas",
"Posting comments" => "Escribir comentarios",
"Add Comment" => "Añadir comentario",
"1 comment" => "1 comentario",
"Go back" => "Atrás",
"Return to home page" => "Volver al inicio",
"Year" => "Año",
"Authors" => "Autores",
"Add" => "Añadir",
"Tiki Debugger Console" => "Tiki Consola del Depurador",
"Current URL" => "URL actual",
"Command" => "Comando",
"exec" => "ejecutar",
"Type <code>help</code> to get list of available commands" => "Ponga <code>help</code> para obtener la lista de comandos disponibles",
"Syntax" => "Sintaxis",
"Page generation debugging log" => "Registro de depuración de generación de página",
"Features state" => "Estado de características",
"features matched" => "características coincidentes",
"duplicate" => "duplicado",
"There are individual permissions set for this file gallery" => "Hay permisos individuales configurados para esta galería de archivos",
"Save" => "Guardar",
"unlimited" => "ilimitado",
"none" => "ning",
"Parent gallery" => "Galería superior",
"Default sort order" => "Orden por defecto",
"Descending" => "Descendente",
"Ascending" => "Ascendente",
"Max description display size" => "Tamaño máximo de descripción",
"Please login" => "Por favor conéctese",
"There are no wiki pages similar to '{\$page}'" => "No hay páginas wiki similares a '{\$page}'",
"Create this page" => "Crear ésta página",
"(page will be orphaned)" => "(la página quedará huérfana)",
"Close Window" => "Cerrar Ventana",
"Active Perms" => "Perms activos",
"Replace" => "Reemplazar",
"List" => "Listar",
"Name-filename" => "Nombre-Nombre de archivo",
"Filename only" => "Solo nombre de archivo",
"Exact&nbsp;match" => "Correspondencia&nbsp;exacta",
"Number of displayed rows" => "Número de filas mostradas",
"in:" => "en:",
"Go" => "Ir",
"RSS Articles" => "RSS Artículos",
"RSS Image Galleries" => "RSS Galerías de Imágenes",
"RSS File Galleries" => "RSS Galerías de Archivos",
"RSS Forums" => "RSS Foros",
"RSS Maps" => "RSS Mapas",
"RSS Directories" => "RSS Directorios",
"RSS Calendars" => "RSS Calendarios",
"Perform action with checked:" => "Ejecutar acción con los marcados:",
"Move Selected Files" => "Mover archivos seleccionados",
"Assign Permissions" => "Asignar Permisos",
"Move to" => "Mover a",
"Filename" => "Nombre de archivo",
"Hi {\$mail_user} has sent you this link:" => "Hola {\$mail_user} le envió este enlace:",
"at:" => "en:",
"Somebody or you tried to subscribe this email address at our site:" => "Alguien o usted intentaron suscribir esta dirección de correo en nuestro sitio:",
"To the newsletter:" => "Al boletín:",
"Description:" => "Descripción:",
"In order to confirm your subscription you must access the following URL:" => "Para confirmar su suscripción debe acceder a la siguiente URL:",
"User:" => "Usuario:",
"A new message was posted to forum" => "Un nuevo mensaje en el foro",
"New topic:" => "Nuevo tema:",
"Topic:" => "Tema:",
"You sent a request with the subject:" => "Envió un pedido con el tema:",
"Use the subject to indicate the operation to apply:" => "Use el tema para indicar la operación a usar:",
"GET:WikiName to get a wiki page" => "GET:WikiName para obtener una página wiki page",
"PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName para actualizar/crear una página wiki (use el cuerpo para el contenido de la página",
"APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName para agregar datos a una página Wiki (use el cuerpo para el contenido a agregar",
"PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName a agregar contenido al principio",
"Tiki mail-in instructions" => "Instrucciones del mail-in de Tiki",
"Tiki mail-in auto-reply." => "Tiki mail-in auto-respuesta.",
"Page not found:" => "Página no encontrada:",
"Hi," => "Hola,",
"A new message was posted to you at {\$mail_machine}" => "Un nuevo mensaje te fue enviado en {\$mail_machine}",
"From" => "Desde",
"New message arrived from %s" => "Nuevo mensaje recibido desde %s",
"Hi" => "Hola",
"Enjoy the site!" => "¡Disfrute el sitio!",
"has requested an account on" => "ha pedido una cuenta en",
"To validate that account, please follow the link:" => "Para validar esa cuenta, siga el enlace:",
"User Registration Request" => "Tiki Pedido de Registro de Usuario",
"You're invited to join my network of friends!" => "¡Está invitado a unirse a mi círculo de amigos!",
"The user" => "El usuario",
"registered at your site" => "se registró en su sitio",
"Bye bye!" => "¡Adiós!",
"This email address has been removed to the list of subscriptors of:" => "Esta dirección de correo ha sido borrada de la lista de los suscriptores de:",
"Newsletter:" => "Boletín:",
"Bye bye from %s at %s" => "Adiós desde  %s en %s",
"You can unsubscribe from this newsletter following this link" => "Puede desuscribirse de este boletín siguiendo este enlace",
"Welcome to our newsletter!" => "Bienvenido a nuestro boletín!",
"This email address has been added to the list of subscriptors of:" => "Esta dirección de correo fue añadida a la lista de suscriptores de:",
"You can always cancel your subscription using:" => "Siempre puede cancelar su suscripción usando:",
"Welcome to %s at %s" => "Bienvenido a %s en %s",
"Email notification" => "Tiki correo de notificación",
"Since this is your registered email address we inform that the password for this account is" => "Ya que esta es su dirección de correo registrada le informamos que la clave para esta cuenta es",
"Important: Username & password are CaSe SenSitiVe" => "Importante: el nombre de usuario y la contraseña son SensIbLes a MayúsCulaS",
"Your account information for %s" => "Su información de cuenta Tiki para %s",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Un nuevo artículo fue enviado por {\$mail_user} a {\$mail_site} en {\$mail_date|tiki_short_datetime}",
"You can edit the submission following this link:" => "Puede editar el envío siguiendo este enlace:",
"Title:" => "Titulo:",
"Heading:" => "Encabezado:",
"Body:" => "Cuerpo:",
"New article submitted at %s" => "Nuevo artículo enviado en %s",
"You or someone registered this email address at" => "usted o alguien regitró esta dirección de correo en",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Si desea ser un usuario registrado en este sitio debe seguir el siguiente enlace para loguearse por primera vez:",
"Your registration confirmation" => "Su información de registro en Tiki",
"You will receive an email with information to login for the first time into this site" => "Recibirá un correo con información para loguearse por primera vez en este sitio",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Su pedido de cuenta fue almacenado y será activado por el administrador lo mas pronto posible.",
"View the article at:" => "Ver el artículo en:",
"If you don't want to receive these notifications follow this link:" => "Si no desea recibir estas notificaciones siga este enlace:",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "Nuevo post en blog: {\$mail_title}, \"{\$mail_post_title}\", por {\$mail_user|username} en {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "Ver el blog en:",
"New blog post at %s" => "Nuevo post en blog en %s",
"changed" => "modificado",
"created" => "creado",
"Removed by" => "Borrado por",
"File Gallery %s changed" => "Galería de Archivos %s cambiada",
"A file was removed from the file gallery" => "Un archivo fue borrado de la galería de archivos",
"File Name" => "Nombre de Archivo",
"A new file was posted to file gallery" => "Un nuevo archivo ha sido subido en la galería de archivos",
"Posted by" => "Enviado por",
"File Description" => "Descripción del archivo",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "El mapa {\$mail_page} fue cambiado por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Puede ver el mapa actualizado siguiendo este enlace:",
"You can edit the map following this link:" => "Puede editar el mapa siguiendo este enlace:",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La página {\$mail_page} fue creada por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La página {\$mail_page} fue cambiada por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"Comment:" => "Comentario:",
"You can view the page by following this link:" => "Puede ver la página siguiendo este enlace:",
"You can view a diff back to the previous version by following this link:" => "Puede ver un diferencial con las versiones previas siguiendo el siguiente enlace:",
"The changes in this version follow below, followed after by the current full page text." => "Los cambios en esta version siguen debajo, seguido por del texto completo actual.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Líneas: {\$oldd} cambiadas a +Líneas: {\$newd}",
"The new page content follows below." => "El nuevo contenido de la página sigue debajo.",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "La página {\$mail_page} fue comentada por {\$mail_user} en {\$mail_date|tiki_short_datetime}",
"New name" => "Nuevo nombre",
"click on the map to zoom or pan, do not drag" => "cliquee en el mapa para ampliar o panorámica, no arrastre",
"Scale" => "Escale",
"Query" => "Consulta",
"Pan" => "Panorámica",
"Redraw" => "Redibujar",
"select zoom/pan/query and image size" => "elija zoom/pan/consulta y tamaño de imagen",
"View the Map Only" => "Ver Sólo el Mapa",
"Reset Map" => "Reiniciar Mapa",
"Click on the map or click redraw" => "Cliquee en el mapa o cliquee redibujar",
"Last modification date" => "Fecha de última modificación",
"Overview" => "Resumen",
"Legend" => "Leyenda",
"Layer Manager" => "Manejador de Capas",
"Layer" => "Capa",
"On" => "En",
"Download Layer" => "Bajar Capa",
"This layer has been set by the maps administrator to not be downloadable" => "Esta capa fue configurada por el administrador de mapas como no descargable",
"you have requested to download the layer:" => "solicitó bajar la capa:",
"Here are the files to download, do not forget to rename them:" => "Aquí están los archivos a bajar, no olvide renombrarlos:",
"Mapfiles" => "Archivos de mapas",
"Mapfile" => "Archivo de mapa",
"Available mapfiles" => "Archivos de mapas disponibles",
"monitor this map" => "suscribirse a este mapa",
"Stop Monitoring this Map" => "Dejar de monitorizar este mapa",
"Create a new mapfile" => "Crear nuevo archivo de mapa",
"Create" => "Crear",
"Mapfile listing" => "Listado de archivos de mapa",
"Reload" => "Recargar",
"History" => "Historial",
"You can view this map in your browser using" => "Puede ver este mapa en su navegador usando",
"Zoom out x2" => "Alejar x2",
"Zoom in x2" => "Acercar x2",
"Mapfile History" => "Historia del Archivo de Mapa",
"of" => "de",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparar versión {\$old.version} con versión {\$new.version}",
"Version:" => "Versión:",
"Current" => "Actual",
"Versions are identical" => "Las versiones son idénticas",
"Legend:" => "Leyenda:",
"v=view" => "v=ver",
"c=compare" => "c=comparar",
"Full side-by-side diff" => "diff lado a lado completo",
"Unified diff" => "diff unificado",
"Side-by-side view" => "Vista lado a lado",
"User" => "Usuario",
"Older Version" => "Versión mas vieja",
"Directories" => "Directorios",
"back to" => "volver a",
"Upload From Disk:" => "Subir desde disco:",
"Upload Files" => "Subir Archivos",
"Bytes maximum" => "Máximo de bytes",
"Create Directory:" => "Crear Directorio:",
"index file (.shp):" => "archivo índice (.shp):",
"files to index (regexp):" => "archivos a indexar (regexp):",
"Message Archive" => "Archivo de Mensaje",
"messages" => "mensajes",
"Archive is full!" => "¡El archivo esta lleno!",
"Unread" => "No leídos",
"Flagged" => "Marcados",
"Unflagged" => "Desmarcado",
"Containing" => "Conteniendo",
"Sender" => "enviado por",
"No messages to display" => "Sin mensajes para mostrar",
"Broadcast message" => "Broadcast mensaje",
"OK" => "Ok",
"All users" => "Todos los usuarios",
"Lowest" => "Mínimo",
"Low" => "Bajo",
"High" => "Alto",
"Very High" => "Superior",
"Send" => "Enviar",
"Compose message" => "Componer mensaje",
"Invalid" => "No válido",
"No messages to download" => "Sin mensajes para bajar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "¡Casilla llena! Borre o archive algunos mensajes si desea recibir mas mensajes.",
"Find replied message" => "buscar mensaje respondido",
"Mark as read" => "Marcar como leído",
"Mark as unread" => "Marcar como no leído",
"Mark as flagged" => "Poner como marcado",
"Mark as unflagged" => "Desmarcar",
"Mark" => "marcar",
"Compose" => "Componer",
"Sent" => "Enviado",
"Auto-archive age for read messages:" => "Edad de autoarchivado para mensajes leídos:",
"Read message" => "Leer mensaje",
"Return to mailbox" => "Volver al mailbox",
"replyall" => "respondertodos",
"Unflag" => "Desmarcar",
"Flag this message" => "Marcar este mensaje",
"From:" => "Desde:",
"Return to archive" => "Volver al archivo",
"Return to outbox" => "Volver a la casilla",
"Sent Messages" => "Enviar Mensajes",
"Replied" => "Respondidos",
"Not replied" => "No respondidos",
"move to archive" => "mover a archivo",
"receiver" => "receptor",
"'name' parameter for tikimodule missed" => "parámetro 'name' para tikimodule no encontrado",
"Move module up" => "Mover módulo arriba",
"Up" => "Subir",
"Move module down" => "Mover módulo abajo",
"Down" => "Bajar",
"Move module to opposite side" => "Mover módulo al lado opuesto",
"opp side" => "lado op",
"Unassign this module" => "Inhabilitar este módulo",
"Are you sure you want to unassign this module?" => "¿Está seguro que quiere inhabilitar este módulo?",
"Thank you for installing Tikiwiki" => "Gracias por instalar Tikiwiki",
"Select" => "Seleccionar",
"Admin Modules" => "Admin Módulos",
"Modules" => "Módulos",
"Admin Menus" => "Admin Menús",
"Menus" => "Menús",
"login" => "conéctate",
"Pages:" => "Páginas:",
"Categories:" => "Categorías:",
"Register" => "Registrarse",
"Open operator console" => "Abrir consola de operador",
"Logout" => "Desconéctate",
"Switch" => "Cambiar",
"Login through CAS" => "Entrada con CAS",
"Login as admin" => "Entrada como admin",
"eMail" => "Correo",
"Password" => "Clave",
"Remember me" => "Recordarme",
"week" => "semana",
"month" => "mes",
"year" => "año",
"Click here to register" => "Cliquee aquí para registrarse",
"Click here if you've forgotten your password" => "Cliquee aquí si se olvidó su contraseña",
"I forgot my password" => "Olvidé mi contraseña",
"Click here to login using the default security protocol" => "Cliquee aquí para loguearse usando el protocolo por defecto de seguridad",
"Click here to login using a secure protocol" => "Cliquee aquí para loguearse usando un protocolo seguro",
"Secure" => "Seguro",
"Stay in ssl Mode" => "Permanecer en modo ssl",
"You have" => "Tiene",
"new messages" => "nuevos mensajes",
"new message" => "nuevo mensaje",
"You have 0 new messages" => "Tiene 0 mensajes nuevos",
"We have" => "Tenemos",
"submissions waiting to be examined" => "colaboraciones esperando ser examinadas",
"Image Galleries" => "Galerías de imágenes",
"Calendars" => "Calendarios",
"Entire Site" => "Sitio completo",
"Wiki Pages" => "Páginas del wiki",
"Image Gals" => "Gals de Imágenes",
"Search Wiki PageName" => "Buscar Nombre Página Wiki",
"Read More" => "Leer más",
"Since your last visit on" => "Desde su última visita el",
"New Images" => "Imágenes nuevas",
"Wiki Pages Changed" => "Páginas wiki modificadas",
"New Files" => "Nuevos archivos",
"New Comments" => "Comentarios",
"New Users" => "Nuevos usuarios",
"click to edit" => "clic para editar",
"Nothing has changed" => "Nada ha cambiado",
"Top galleries" => "Galerías Top",
"view" => "ver",
"click to view" => "cliquear para ver",
"Bookmarks" => "Marcadores",
"Done" => "listo",
"select" => "seleccionar",
"Refresh" => "Refrescar",
"online users" => "usuarios en línea",
"online user" => "usuario en línea",
"Send a message to" => "Enviar un mensaje a",
"vote" => "votar",
"Warning" => "Cuidado",
"Users" => "Usuarios",
"Send Newsletter" => "Enviar boletín",
"Edit blog" => "Editar blog",
"Monitor this Blog" => "Monitorizar este blog",
"Stop Monitoring this Blog" => "Dejar de monitorizar este blog",
"Find:" => "Encontrar:",
"pages" => "páginas",
"To edit the copyright notices" => "Para editar los avisos de copyright",
"The content on this page is licensed under the terms of the" => "El contenido de esta página esta licenciado bajo los términos del",
"comments" => "comentarios",
"First page" => "Primer página",
"Previous page" => "Página anterior",
"page" => "página",
"Next page" => "Siguiente página",
"Last page" => "Última página",
"referenced by" => "referenciado por",
"references" => "referencias",
"View Comments" => "Ver comentarios",
"Blog name" => "Nombre Blog",
"Calendar View" => "Vista de calendario",
"List View" => "Ver lista",
"Tools Calendars" => "Herramientas de Calendarios",
"Check / Uncheck All" => "Marcar / desmarcar todos",
"Tip" => "Consejo",
"Cancel Edit" => "Cancelar edición",
"Change preferences" => "Cambiar preferencias",
"Site Ads and Banners" => "Publicidad y Banners del Sitio",
"Features" => "Características",
"Community" => "Comunidad",
"Module" => "Módulo",
"User files" => "Mis Archivos",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Para agregar/borrar globs, vaya a \"Crear/Editar\" blogs bajo \"Blogs\" en el menú de aplicación, o ",
"General Settings" => "Configuraciones Generales",
"Home Blog (main blog)" => "Blog principal",
"Change settings" => "Cambiar configuración",
"Day" => "Día",
"Week" => "Semana",
"Month" => "Mes",
"Quarter" => "Cuatrimestre",
"Semester" => "Semestre",
"Saturday" => "Sábado",
"Sunday" => "Domingo",
"Monday" => "Lunes",
"Depends user language" => "Depende del idioma del usuario",
"5 minutes" => "5 minutos",
"15 minutes" => "15 minutos",
"30 minutes" => "30 minutos",
"Permissions" => "Permisos",
"Look under \"Articles\" on the application menu for links to" => "Busque bajo \"Artículos\" en el menú de aplicación para enlaces a",
"Import CSV file" => "Importar archivo CSV",
"Import" => "Importar",
"Admin Groups" => "Admin grupos",
"Admin Users" => "Admin usuarios",
"Gender" => "Género",
"Number of friends" => "Número de amigos",
"E-mail" => "Correo",
"Last login" => "Última conexión",
"Distance" => "Distancia",
"default" => "por defecto",
"Number of visited pages to remember" => "Cantidad de páginas visitadas a recordar",
"Displayed time zone" => "Zona horaria a mostrar",
"User information" => "Información de usuario",
"Private" => "Privado",
"public" => "público",
"Use double-click to edit pages" => "Usar doble-clic para editar páginas",
"Show user's info on mouseover" => "Mostrar info de usuario on mouseover",
"Tasks per page" => "Tareas por página",
"Messages per page" => "Mensajes por página",
"Allow messages from other users" => "Permitir mensajes de otros usuarios",
"Send me an email for messages with priority equal or greater than" => "Envíeme un correo por mensajes con prioridad mayor o igual a",
"Auto-archive read messages after x days" => "Auto-archivar mensajes leídos después de x días",
"never" => "nunca",
"My Tiki" => "Mi Tiki",
"My pages" => "Mis páginas",
"My messages" => "Mis mensajes",
"My tasks" => "Mis tareas",
"My items" => "Mis items",
"Score ascending" => "Puntuación ascendente",
"Score descending" => "Puntuación descendente",
"Name ascending" => "Nombre ascendente",
"Name descending" => "Nombre descendente",
"Login ascending" => "Login ascendente",
"Login descending" => "Login descendente",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Para configurar su directorio, busque \"Admin directorio\" bajo \"Directorio\" en el menú de aplicación, o",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Para agregar/borrar FAQs, busque \"Admin FAQs\" bajo \"FAQs\" en el menú de aplicación, o",
"Settings" => "Opciones",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Si decide guardar archivos en un directorio debe asegurarse que el usuario no puede acceder directamente al directorio.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Tiene 2 opciones para lograr esto:<br /><ul><li>Usar un directorio fuera del document root, asegurandose que su script en php puede leer y escribir en ese directorio</li><li>Usar un directorio dentro del document root y usar  .htaccess para evitar que los usuarios listen el contenido del directorio</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Para configurar el camino al directorio use caminos similares a los de UNIX, p/ej archivos/ o c:/foo/archivos o /www/archivos/",
"Home Gallery (main gallery)" => "Galería principal",
"MIME Type" => "Tipo MIME",
"Reindex all files for search" => "Reindexar todos los archivos para búsqueda",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Para agregar/borrar foros, busque por \"Admin foros\" bajo \"Foros\" en el menú de aplicación, o",
"Home Forum (main forum)" => "Foro principal",
"Searches" => "Busquedas",
"Browser width" => "Ancho del navegador",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Para agregar/borrar galerías de imágenes, vaya a \"Galerías de Imágenes\" en el menú de aplicación, o",
"You can upload images of a size of " => "Puede subir imágenes de un tamaño de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Modifique las variables del php.ini file_uploads, upload_max_filesize, post_max_size y variables de la base de datos  (max_allowed_packet para mysql) para cambiar este valor",
"Home Gallery" => "Galería Inicial",
"Galleries features" => "Preferencias de galerías",
"Uses Slideshow" => "Usa Diapositivas",
"Use database to store images" => "Usar base de datos para guardar imágenes",
"Use a directory to store images" => "Usar directorio para guardar imágenes",
"Directory path" => "Directorio",
"Library to use for processing images" => "Libreria a usar para procesar imágenes",
"Uploaded image names must match regex" => "Nombres de imágenes deben matchear esta regex",
"Uploaded image names cannot match regex" => "Nombres de imágenes no deben matchear esta regex",
"Directory Batch Loading" => "Carga en lote de Directorio",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Si activa Carga en lote de Directorio, debe configurar un directorio legible desde el servidor (fuera del espacio de páginas es preferible). Después configure una forma de subir imágenes en ese directorio, ya sea por scp, ftp u otros protocolos",
"Enable directory batch loading" => "Activar subida en lote por directorio",
"Batch loading directory" => "Directorio de subida en lote",
"Max Rows per page" => "Cantidad máxima de filas por página",
"Images per row" => "Imágenes por fila",
"Thumbnails size X" => "Tamaño X para miniaturas",
"Thumbnails size Y" => "Tamaño Y para miniaturas",
"Set features" => "Establecer características",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Quitar imágenes en la galería del sistema que no son usadas",
"All galleries" => "Todas las galerías",
"System Gallery" => "Galería del sistema",
"Gallery listing configuration" => "Configuración del listado de galerías",
"Parent" => "Superior",
"Last modified" => "Última modificación",
"Change configuration" => "Cambiar configuración",
"Image galleries comments settings" => "Configuración para los comentarios en galerías de imágenes",
"General Preferences" => "Preferencias Generales",
"Site Identity" => "Identidad del Sitio",
"Mail" => "Correo",
"Username" => "Usuario",
"Server" => "Servidor",
"Home Page" => "Página Inicial",
"Custom home" => "Inicio propio",
"Date and Time Formats" => "Formatos de Fecha y Hora",
"Date and Time Format Help" => "Ayuda de Formatos de Fecha y Hora",
"Change admin password" => "Cambiar contraseña de administrador",
"Change password" => "Cambiar contraseña",
"Syntax error" => "Error de sintaxis",
"port" => "puerto",
"click here" => "haga click aquí",
"Enable/disable Tiki features in " => "Activar/desactivar características de Tiki en ",
", but configure them elsewhere" => ", pero configúrelas en otro lado",
"Tiki and HTTP Auth" => "Tiki y HTTP Auth",
"Registration" => "Registro",
"Users can register" => "Usuarios pueden registrarse",
"Account validated successfully." => "Cuenta validada exitosamente.",
"Use challenge/response authentication" => "Autenticación por challenge/response",
"Allow secure (https) login" => "Permitir login seguro (https)",
"Encourage secure (https) login" => "Intentar acceso seguro (https)",
"Consider we are always in HTTPS, but do not check" => "Considere que siempre trabajamos con HTTPS, pero no comprobar ",
"Require secure (https) login" => "Requerir login seguro (https)",
"Duration:" => "Duración:",
"Currently unused" => "Actualmente no usado",
"Version 1.0" => "Versión 1.0",
"Version 2.0" => "Versión 2.0",
"Users can change theme" => "Usuarios registrados pueden cambiar tema",
"Restrict available themes" => "Restringir temas disponibles",
"Available styles:" => "Estilos disponibles:",
"Edit CSS" => "Editar CSS",
"Theme Control" => "Control de temas",
"Tiki Template Viewing" => "Vista de Plantilla de Tiki",
"Edit Templates" => "Editar plantillas",
"General Layout options" => "Opciones generales de diseño",
"logged as" => "conectado como",
"Alt. description (e.g. for text browsers)" => "Descripción alt. (p/ej para browsers de texto)",
"Subtitle" => "Subtítulo",
"Site menu bar" => "Barra de menú del sitio",
"Custom code" => "Código configurable",
"Left column" => "Columna izquierda",
"always" => "siempre",
"user decides" => "usuario decide",
"Users can Flip Columns" => "Usuarios pueden cambiar columnas",
"Right column" => "Columna derecha",
"Site location bar" => "Barra de ubicación del sitio",
"Larger font for" => "Fuente mas grande para",
"Use page description:" => "Usar descripción de página:",
"Bottom bar" => "Barra al pie",
"Maximum number of records in listings" => "Cantidad máxima de registros en listados",
"Use direct pagination links" => "Usar enlaces de paginación directa",
"Direction" => "Dirección",
"Use Tabs" => "Usar Tabs",
"Layout per section" => "Diseño por sección",
"Admin layout per section" => "Administrar diseño por sección",
"Favicon icon file name:" => "Nombre de archivo de icono Favicon:",
"Favicon icon MIME type:" => "Tipo MIME del icono Favicon:",
"Generate User Map" => "Generar Mapa de Usuarios",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Para agregar/quitar votaciones, busque \"Votaciones\" bajo \"Admin\" en el menú de aplicación, o",
"Waiting" => "Esperando",
"TikiWiki Profiles" => "Perfiles de TikiWiki",
"Profile" => "Perfil",
"Last update" => "Última actualización",
"Image galleries" => "Galerías de imágenes",
"Feed for forums" => "Feed de foros",
"Specification" => "Especificación",
"You can see users rank by score in the module users_rank, for that go to" => "Puede ver calificación de usuarios por puntuación en el módulousers_rank, para eso vaya a ",
"Admin modules" => "Admin módulos",
"Expiration" => "Expiración",
"Automonospaced text" => "Texto Automonoespaciado",
"Tables syntax" => "Sintaxis de tablas",
"|| for rows" => "|| para filas",
"Hotwords" => "Palabras clave",
"rows" => "líneas",
"Required" => "Requerido",
"Parameters" => "Parámetros",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "para configurar sus trackers, busque en \"Admin trackers\" bajo \"Trackers\" en el menú de aplicación, o",
"Use database to store files" => "Usar base de datos para guardar archivos",
"Use a directory to store files" => "Usar un directorio para almacenar archivos",
"dls" => "bjds",
"Storage" => "Almacenamiento",
"Change all to db" => "Cambiar todo a bd",
"Change all to file" => "Cambiar todo a archivos",
"Use database to store userfiles" => "Usar base de datos para guardar archivos de usuario",
"Use a directory to store userfiles" => "Usar directorio para guardar archivos de usuario",
"Create New" => "Crear nueva",
"List authors" => "Listar autores",
"Not Installed" => "No Instalado",
"Warn on edit conflict" => "Advertir en conflictos de edición",
"Footnotes" => "Notas al pie",
"Permission" => "Permiso",
"Allow HTML" => "Permitir HTML",
"Dumps" => "Volcados",
"Generate dump" => "Generar volcado",
"Download last dump" => "Descargar último volcado",
"Pictures" => "Imágenes",
"Remove unused pictures" => "Quitar imágenes no usadas",
"Export" => "Exportar",
"Export Wiki Pages" => "Exportar páginas wiki",
"Accept dashes and underscores in WikiWords" => "Aceptar guiones y subrayado en WikiWords",
"Link plural WikiWords to their singular forms" => "Enlaza WikiWords en plural con su forma singular",
"Only with last version" => "Sólo con ultima versión",
"Side-by-side diff" => "diff lado a lado",
"Discuss pages on forums" => "Discutir páginas en foro",
"Structures" => "Estructuras",
"Open page as structure" => "Abrir página como estructura",
"Import HTML" => "Importar HTML",
"Page creators are admin of their pages" => "Creadores de páginas son administradores para sus páginas",
"MultiPrint" => "PrintMultiple",
"Create watch for author on page creation" => "Crear watch por autor en creación de página",
"Enable watch events when I am the editor" => "Activar eventos de watch cuando soy el editor",
"Enable watches on comments" => "Activar watches en comentarios",
"Links" => "Enlaces",
"Wiki 3D Browser Configuration" => "Configuración del Navegador Wiki 3D ",
"Wiki attachments" => "Adjuntos al Wiki",
"Change" => "Cambiar",
"Shoutbox Words" => "Palabras de Shoutbox",
"Live Support" => "Soporte Live",
"Contact us" => "Contactarnos",
"Mail Notifications" => "Notificaciones por correo",
"Search Stats" => "Estadísticas de Búsqueda",
"Statistics" => "Estadísticas",
"Weeks" => "Semanas",
"Setting" => "Opción",
"viewed" => "visto",
"Add or edit a rule" => "Añadir o editar regla",
"Rule title" => "Título de regla",
"Username regex matching" => "Regex matching de usuario",
"IP regex matching" => "Regex matching de IP",
"Banned from sections" => "Banneado de secciones",
"Rule activated by dates" => "Activación de reglas por fechas",
"Rule active from" => "Regla activa desde",
"Rule active until" => "Regla activa hasta",
"Custom message to the user" => "Mensaje personalizado al usuario",
"Rules" => "Reglas",
"User/IP" => "Usuario/IP",
"Sections" => "Secciones",
"Admin Calendars" => "Admin Calendarios",
"List of Calendars" => "Lista de Calendarios",
"Loc" => "Ubi",
"Participants" => "Participantes",
"Lang" => "Leng",
"Subscription" => "Subscripción",
"Custom Locations" => "Ubicaciones personalizadas",
"Custom Participants" => "Participantes Personalizables",
"Custom Categories" => "Categorías personalizadas",
"Custom Languages" => "Lenguajes personalizados",
"Custom Subscription List" => "Lista de subscripción personalizable",
"Custom Priorities" => "Prioridades personalizadas",
"Personal Calendar" => "Calendario Personal",
"Red" => "Rojo",
"Current category" => "Categoría actual",
"Child categories" => "Subcategorías",
"Edit permissions for this category" => "Editar permisos para esta categoría",
"Edit this category:" => "Editar esta categoría:",
"Add new category" => "Añadir nueva categoría",
"Objects in category" => "Objectos en la categoría",
"No records found." => "No se encontraron registros",
"Add objects to category" => "Añadir objetos a la categoría",
"Admin templates" => "Admin plantillas",
"Edit this template:" => "Editar esta plantilla:",
"Create new template" => "Crear nueva plantilla",
"Use wysiwyg editor" => "Usar editor wysiwyg",
"Use normal editor" => "Usar editor normal",
"HTML Pages" => "Páginas HTML",
"Templates" => "Plantillas",
"Admin cookies" => "Administrar cookies",
"Create/edit cookies" => "Crear/editar cookies",
"Upload Cookies from textfile" => "Subir cookies desde un archivo de texto",
"Upload from disk:" => "Subir desde el disco:",
"Upload" => "Subir",
"Remove all cookies" => "Borrar todas las cookies",
"Create/edit dsn" => "Crear/editar dsn",
"Admin external wikis" => "Admin wikis externos",
"View template" => "Ver plantilla",
"tiki admin external wikis template" => "tiki admin plantilla de wikis externos",
"Edit template" => "Editar plantilla",
"Create/Edit External Wiki" => "Crear/Editar Wiki Externo",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (use \$page para ser reemplazado por el nombre de página en la URL ejemplo: http://www.ejemplo.com/tiki-index.php?page=\$page)",
"ExtWiki" => "Extwiki",
"Admin Forums" => "Admin Foros",
"Create new forum" => "Crear nuevo foro",
"List forums" => "Listar foros",
"Age" => "Edad",
"PPD" => "Ppd",
"Edit this Forum:" => "Editar este Foro:",
"Create New Forum" => "Crear Nuevo Foro",
"There are individual permissions set for this forum" => "Existen permisos individuales para este foro",
"Name:" => "Nombre:",
"Create new" => "Crear nuevo",
"Password protected" => "Protegido por contraseña",
"Forum password" => "Contraseña de foro",
"Topic list configuration" => "Configuración de listado de temas",
"Posts can be rated" => "Mensajes pueden ser calificados",
"Display last post titles" => "Desplegar últimos títulos de mensajes",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Reenviar mensajes a este foro a esta direcde correo, en un formato que puede ser usado para enviar para retornar a la dirección entrante de correo del foro",
"Send mails even when the post is generated by inbound mail" => "Enviar correos aun cuando el envío es generado por un mensaje entrante",
"Append a reply link to outbound mails" => "Agregar un enlace a la respuesta de mensajes salientes",
"Originating e-mail address for mails from this forum" => "Dirección origen de correo para correos de este foro",
"Add messages from this email to the forum" => "Añadir mensajes para este correo a el foro",
"Use topic smileys" => "Usar emoticones del tema",
"Show topic summary" => "Mostrar sumario del tema",
"User information display" => "Desplegar información de usuario",
"Online" => "En línea",
"Approval type" => "Tipo de aprobación",
"Store attachments in:" => "Guardar adjuntos en:",
"Admin Hotwords" => "Admin Palabras clave",
"Add Hotword" => "Añadir Palabra clave",
"Word" => "Palabra",
"Admin HTML pages" => "Administrar páginas HTML",
"Edit this page" => "Editar esta página",
"View page" => "Ver página",
"Edit zone" => "Editar sección",
"Dynamic zones" => "Secciones dinámicas",
"zone" => "sección",
"content" => "contenido",
"Mass update" => "Actualización masiva",
"Create new HTML page" => "Crear nueva página HTML",
"Edit this HTML page:" => "Editar esta página HTML:",
"Apply template" => "Aplicar plantilla",
"Dynamic" => "Dinámica",
"Static" => "Estática",
"Last Modif" => "últ modif",
"Edit Repository:" => "Editar Repositorio:",
"Create New Repository" => "Crear Nuevo Repositorio",
"List Repositories" => "Listar repositorios",
"New Repository" => "Nuevo repositorio",
"View Repository" => "Ver repositorio",
"Human readable repository name" => "Descripción legible del repositorio",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Camino al repositorio (filesystem local: relativo/absoluto respecto a raíz de web, remoto: prefijado con 'http://')",
"File name of start page" => "Archivo de la página inicial",
"Start page" => "Página inicial",
"CSS file to load when browse this repository" => "Archivo CSS a cargar cuando se navegue este repositorio",
"CSS file" => "Archivo CSS",
"Is repository visible to users" => "Es el repositorio visible para usuarios",
"Can files from repository be cached" => "Pueden ser cacheados archivos del repositorio",
"Are files from repository can be cached" => "Los archivos del repositorio pueden ser cacheados",
"Clear all cached pages of this repository" => "Borrar todas las páginas cacheadas del repositorio",
"Clear cache" => "Borrar cache",
"Seconds count 'till cached page will be expired" => "Cuenta de segundos hasta que expiren las páginas cacheadas",
"Cache expiration" => "Expiración de cache",
"Human readable text description of repository" => "Descripción legible del repositorio",
"Available Repositories" => "Repositorios disponibles",
"CSS File" => "Archivo CSS",
"Edit rules" => "Editar reglas",
"Edit Rules for Repository:" => "Editar Reglas para Repositorio:",
"Configure Repositories" => "Configurar repositorios",
"Configure this Repository" => "Configure este repositorio",
"View this Repository" => "Ver este repositorio",
"New Rule" => "Nueva regla",
"Copy Rules" => "Copiar reglas",
"view/hide copy rules dialog" => "ver/ocultar diálogo de copia de reglas",
"Source repository" => "Repositorio origen",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "De acuerdo a este órden las reglas serán aplicadas ('0' o vacío = auto)",
"Rule order" => "Órden de reglas",
"Text to search for" => "Texto a buscar",
"Text to replace" => "Texto a reemplazar",
"Is this regular expression or simple search/replacer" => "Es ésta una expresión regular o una simple búsqueda/substitución",
"Is case sensitive (for simple replacer)" => "Es sensible a mayúsc/minúsc (para reemplazo simple)",
"Case sensitive" => "Mayúsc/Minúsc",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunto de caracteres: imsxeADSXUu, que son modificadores de regex",
"Regex modifiers" => "Modificadores de Regex ",
"Human readable text description of rule" => "Descripción legible de la regla",
"Check to enable this rule" => "Chequee para habilitar esta regla",
"Enabled" => "Activado",
"Preview options" => "Previsualizar opciones",
"Apply all rules or just this to generate preview" => "Aplicar todas las reglas o sólo ésta para generar la previsualización",
"Apply all rules" => "Aplicar todas las reglas",
"View source code after rules applied" => "Ver código fuente después de que las reglas sean aplicadas",
"Code preview" => "Vista previa de código",
"Generate HTML preview" => "Generar vista previa HTML",
"HTML preview" => "HTML vista previa",
"Test file from repository to generate preview for (empty = configured start page)" => "Archivo de prueba del repositorio para la cual generar vista previa (vacío = página inicial configurada)",
"Preview Results" => "Resultados de vista previa",
"Rules List" => "Lista de Reglas",
"Configure/Options" => "Configurar/Opciones",
"Admin layout" => "Admin diseño",
"Theme control" => "Control de temas",
"layout options" => "opciones de diseño",
"Top bar" => "Barra de encabezado",
"Generate positions by hits" => "Ordenar automáticamente por hits",
"List of featured links" => "Lista de enlaces destacados",
"Position" => "Posición",
"Add Featured Link" => "Añadir un enlace",
"Edit this Featured Link:" => "Editar este enlace destacado:",
"Create new Featured Link" => "Crear nuevo enlace destacado",
"disables the link" => "deshabilita el enlace",
"Link type" => "Tipo de enlace",
"replace current page" => "reemplazar la página actual",
"framed" => "en un marco",
"open new window" => "abrir nueva ventana",
"Mail-in accounts" => "Cuentas Mail-in",
"Account" => "Cuenta",
"Add new Mail-in account" => "Añada una nueva cuenta Mail-in",
"Edit Mail-in account" => "Editar cuenta Mail-in",
"Account name" => "Nombre de cuenta",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "SMTP requiere autenticación",
"Article Topic" => "Tema de Artículo",
"Admin Topics" => "Administrar temas",
"Article Type" => "Tipo de Artículo",
"Admin Types" => "Admin tipos",
"Active" => "Activo",
"Allow anonymous acces" => "Permitir usuarios anónimos",
"Allow attachments" => "Permitir archivos asociados",
"Discard to the end from" => "Descartar hasta el fin desde",
"Check Mail-in accounts" => "Chequear cuentas Mail-in",
"Check automatically" => "Chequear automáticamente",
"Frequency" => "Frecuencia",
"List menus" => "Listar menús",
"Edit this menu" => "Editar menú",
"Edit menu options" => "Editar opciones del menú",
"Show Quick Urls" => "Mostrar URLs Rápidas",
"Some useful URLs" => "Algunas URLs útiles",
"Hide Quick Urls" => "Ocultar URLs Rápidas",
"option" => "opción",
"separator" => "separador",
"Choose" => "Elegir",
"Home Blog" => "Blog principal",
"Home Image Gal" => "Galería de imgs ppal",
"Home Image Gallery" => "Galería de imgs ppal",
"Home File Gal" => "Galería de archivos ppal",
"Home File Gallery" => "Galería de archivos ppal",
"User preferences" => "Preferencias del usuario",
"User prefs" => "Prefs del usuario",
"List galleries" => "Listar galerías",
"List image galleries" => "Listar galerías de imágenes",
"Upload image" => "Subir imagen",
"Gallery Rankings" => "Rankings de galerías",
"Browse a gallery" => "Visitar una galería",
"Articles home" => "Inicio de artículos",
"All articles" => "Listado de artículos",
"Submit" => "Enviar",
"List Blogs" => "Listar Blogs",
"Create blog" => "Crear blog",
"View a forum" => "Ver foro",
"View a thread" => "Ver mensaje",
"View a FAQ" => "Ver FAQ",
"Take a quiz" => "Tomar cuestionario",
"Quiz stats" => "Estadísticas de Cuestionario",
"Stats for a Quiz" => "Estadistícas del Cuestionario ",
"Preview menu" => "Previsualizar menú",
"Menu options" => "Opciones de menú",
"Options" => "Opciones",
"Active Permissions" => "Activar permisos",
"Edit this Menu:" => "Editar este Menú:",
"Create new Menu" => "Crear nuevo Menú",
"dynamic collapsed" => "dinámico colapsado",
"dynamic extended" => "dinámico expandido",
"fixed" => "estático",
"Clear Cache" => "Limpiar cache",
"Assigned Modules" => "Módulos Asignados",
"Left Modules" => "Módulos Izquierda",
"Move to Right Column" => "Mover a columna derecha",
"Right Modules" => "Módulos Derecha",
"Move to Left Column" => "Mover a columna izquierda",
"Assign new module" => "Asignar nuevo módulo",
"Edit this assigned module:" => "Editar el módulo asignado:",
"Cache Time" => "Tiempo en cache",
"Visibility" => "Visibilidad",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrado para todos los usuarios elegibles aún con módulos personales asignados",
"Displayed for the eligible users with no personal assigned modules" => "Mostrado para los usuarios elegibles sin módulos personales asignados",
"Displayed now, can't be unassigned" => "Mostrado ahora, no puede ser desasignado",
"Not displayed until a user chooses it" => "No mostrado hasta que el usuario lo elije",
"User Modules" => "Módulos de usuario",
"Create new user module" => "Crear nuevo módulo de usuario",
"Edit this user module:" => "Editar este módulo de usuario:",
"Must be wiki parsed" => "Debe ser parseado por wiki",
"Objects that can be included" => "Objetos que pueden incluirse",
"Random active poll" => "Votación activa aletoria",
"Random current poll" => "Votación actual aletoria",
"Use Poll" => "Usar votación",
"Use Gallery" => "Usar galería",
"Use Dynamic Content" => "Usar contenido dinámico",
"Use RSS Module" => "Usar módulo RSS",
"Use Menu" => "Usar menú",
"Use phplayermenu" => "Usar phplayermenu",
"Use Banner Zone" => "Usar zona de banners",
"Structures:" => "Estructuras:",
"Admin newsletter subscriptions" => "Admin suscripciones al boletín",
"List Newsletters" => "Listar boletines",
"Admin Newsletters" => "Admin boletines",
"Send Newsletters" => "Enviar Boletines",
"Add a subscription newsletters" => "Añadir suscripción",
"Email:" => "Correo:",
"Add email:" => "Añadir correo:",
"Add user:" => "Añadir usuario:",
"Group subscription also subscribes included groups" => "Subscripción de grupo también subscribe grupos incluídos",
"Don't send confirmation mail" => "No enviar correo de confirmación",
"The user email will be refreshed at each newsletter sending" => "El correo de usuario será refrescado ante cada envío de boletín",
"Subscribe group" => "Subscribir grupo",
"Subscriptions" => "Suscripciones",
"Valid" => "Válido",
"Subscribed" => "suscrito",
"Admin newsletters" => "Admin boletines",
"Editions" => "Ediciones",
"Last Sent" => "última edición",
"Create/Edit Newsletters" => "Crear/editar boletín",
"There are individual permissions set for this newsletter" => "Existen permisos individuales para este boletín",
"Users can subscribe/unsubscribe to this list" => "Usuarios pueden suscribirse/desuscribirse a esta lista",
"Users can subscribe any email address" => "Usuarios pueden suscribir cualquier dirección de correo",
"Add unsubscribe instructions to each newsletter" => "Añadir instrucciones de desuscripción a cada boletín",
"Validate email addresses" => "Validar dirección de correo",
"Add notification" => "Añadir notificación",
"Event" => "Evento",
"edit" => "editar",
"remove" => "eliminar",
"Update" => "Actualizar",
"List polls" => "Listar votaciones",
"Edit this poll" => "Editar votación",
"Preview poll" => "Previsualizar votación",
"Poll options" => "Opciones de votaciones",
"Votes" => "Votos",
"Admin Polls" => "Admin Votaciones",
"Set last poll as current" => "Poner última votación como actual",
"Close all polls but last" => "Cerrar todas las votaciones menos la última",
"Activate all polls" => "Activar todas las votaciones",
"active" => "activo",
"current" => "actual",
"object" => "objeto",
"PublishDate" => "Fecha publicación",
"Results" => "Resultados",
"Wiki pages" => "páginas wiki",
"Content for the feed" => "Contenido del feed",
"Security Admin" => "Admin Seguridad",
"PHP settings" => "Configuración de PHP",
"Risk Factor" => "Factor de Riesgo",
"Explanation" => "Explicación",
"Check all tiki files" => "Chequear todos los archivos tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Note que esto puede tomar un tiempo muy largo. Deberia chequear el valor de max_execution_time en php.ini.",
"File checks" => "Chequeo de archivos",
"user" => "usuario",
"group" => "grupo",
"Admin Shoutbox Words" => "Admin Palabras de Shoutbox",
"Add Banned Word" => "Agregar Palabra Prohibida",
"Are you sure you want to delete this word?" => "Está seguro que quiere borrar esta palabra?",
"Destroy the structure leaving the wiki pages" => "Destruir la estructura dejando las páginas wiki",
"Destroy the structure and remove the pages" => "Destruir la estructura y borrar las páginas",
"Export Pages" => "Exportar páginas",
"Dump Tree" => "Volcar árbol",
"Create WebHelp" => "Crear WebHelp",
"View WebHelp" => "Ver webhelp",
"Create new structure" => "Crear nueva estructura",
"Tree" => "árbol",
"Use single spaces to indent structure levels" => "Usar espacios simples para indentar niveles de estructura",
"Create New Structure" => "Crear nueva estructura",
"List surveys" => "Listar encuestas",
"Survey Stats" => "Estadisticas",
"Edit this Survey" => "Editar encuesta",
"Admin Surveys" => "Admin encuestas",
"Question" => "Pregunta",
"One choice" => "Una opción",
"Multiple choices" => "Múltiples opciones",
"Short text" => "Texto breve",
"Rate (1..5)" => "Calificar (1..5)",
"Rate (1..10)" => "Calificar (1..10)",
"Rate" => "Calificación",
"Options (if apply)" => "Opciones (si aplica)",
"Questions" => "Preguntas",
"Admin surveys" => "Admin encuestas",
"List Surveys" => "Listar Encuestas",
"Edit this Survey:" => "Editar esta encuesta:",
"Create New Survey" => "Crear nueva encuesta",
"There are individual permissions set for this survey" => "Existen permisos individuales para esta encuesta",
"Open" => "Abierta",
"Empty" => "Vaciar",
"Fix UTF-8 Errors in Tables" => "Arreglar Errores UTF-8 en Tablas",
"Warning: Make a backup of your Database before using this function!" => "¡Atención: Haga un respaldo de su base de datos antes de usar esta función!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "¡Atención: Si intenta convertir tablas grandes, aumente el tiempo máximo de ejecución en el php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Esta función convierte textos codificados en ISO-8859-1 en sus tablas a UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Esto puede ser necesario si creó contenido con tiki &lt; 1.8.4 y la opcion Default Charset de apache en ISO-8859-1",
"UTF-8 Errors fixed" => "Errores UTF-8 arreglados",
"Investigate" => "Investigar",
"Fix it" => "Arreglar",
"Create a new topic" => "Crear nuevo tema",
"Topic Name" => "Nombre de tema",
"Upload Image" => "Subir imagen",
"List of topics" => "Lista de temas",
"Articles (subs)" => "Artículos (colabs)",
"topic image" => "imagen de tema",
"Deactivate" => "Desactivar",
"Remove with articles" => "Borrar con artículos",
"List Trackers" => "Listar Trackers",
"Admin Trackers" => "Admin trackers",
"Edit This Tracker" => "Editar tracker",
"View This Tracker's Items" => "Ver elementos del tracker",
"Tracker fields" => "Campos",
"Mandatory" => "Obligatorio",
"Is column visible when listing tracker items?" => "¿Columna visible cuando se listan items?",
"Tbl vis" => "visible en listados",
"Column links to edit/view item?" => "¿Enlaces en columna para editar/ver el item?",
"isMain" => "es principal",
"Searchable" => "Buscable",
"Hidden" => "Oculto",
"Edit tracker field" => "Editar campos del tracker ",
"Field is mandatory?" => "¿Campo es obligatorio?",
"Column is searchable?" => "¿Columna es buscable?",
"Import/Export Trackers Fields" => "Importar/exportar campos de trackers",
"Found" => "Encontado",
"Edit Tracker" => "Editar tracker",
"There are individual permissions set for this tracker" => "Hay permisos individuales configurados para este tracker",
"No individual permissions. Global permissions apply." => "No hay permisos individuales, aplican los permisos globales",
"Show status" => "Mostrar estado",
"Default status displayed in list mode" => "Estado por defecto mostrado en modalidad de lista",
"Show status to tracker admin only" => "Mostrar estado sólo al admin del tracker",
"Send copies of all activity in this tracker to this e-mail address" => "Enviar copias de toda actividad en este tracker a esta dirección de correo",
"Use simplified e-mail format" => "Usar formato simplificado de correo",
"New items are created with status" => "Nuevos ítems son creados con estado",
"Authoritative status for modified items" => "Estado autoritativo para los ítems modificados",
"No change" => "No cambiar",
"Item creator can modify his items?" => "¿Creador de ítems puede moficar sus ítems?",
"The tracker needs a user field with the option 1" => "El tracker necesita un campo de usuario con la opción 1",
"The tracker needs a group field with the option 1" => "El tracker necesita un campo de grupo con la opción 1",
"Show creation date when listing tracker items?" => "¿Mostrar fecha de creación cuando se listan ítems?",
"Show lastModif date when listing tracker items?" => "¿Mostrar fecha de última modificación cuando se listan ítems?",
"What field is used for default sort?" => "¿Qué campo es usado para la ordenación por defecto?",
"LastModif" => "Última modificación",
"What is default sort order in list?" => "¿Cual es la ordenación por defecto en listado?",
"ascending" => "ascendente",
"descending" => "descendente",
"Tracker items allow ratings?" => "¿Los ítems del tracker permiten calificaciones?",
"with values" => "con valores",
"and display rating results in listing?" => "¿y mostrar resultado de calificaciones en listado?",
"Tracker items allow comments?" => "¿Se permiten comentarios por ítem?",
"and display comments in listing?" => "¿y mostrar comentarios en listado?",
"Tracker items allow attachments?" => "¿Se permiten adjuntos?",
"and display attachments in listing?" => "¿y mostrar archivos asociados en listado?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Opciones de mostrado de archivos asociados (Use números para ordenar ítems, 0 no será mostrado, y números negativos se mostrarán en popups)",
"Filesize" => "Tamaño de archivo",
"Filetype" => "Tipo de archivo",
"LongDesc" => "Desclarga",
"Import/Export" => "Importar/exportar",
"Import/export trackers" => "Importar/exportar trackers",
"Admin groups" => "Admin grupos",
"Admin users" => "Admin usuarios",
"Add new group" => "Añadir nuevo grupo",
"List of existing groups" => "Lista de grupos existentes",
"Edit group" => "Editar grupo",
"Add a New Group" => "Agregar nuevo grupo",
"Use wiki page name or full URL" => "Use página wiki o URL completa",
"Group Information Tracker" => "Tracker de Información de Grupo",
"choose a group tracker ..." => "elija un tracker de grupo ...",
"choose a field ..." => "elija un campo ...",
"Users Information Tracker" => "Tracker de Información de Usuarios",
"choose a users tracker ..." => "elija un tracker de usuarios ...",
"Group tracker item : {\$groupitemid}" => "Item de tracker de grupo : {\$groupitemid}",
"Edit Item" => "Editar item",
"Group tracker item not found" => "Item de tracker de grupo no encontrado",
"Members" => "Miembros",
"users in group" => "usuarios en grupo",
"CSV File" => "Archivo CSV",
"Add a New User" => "Añadir un nuevo usuario",
"Reason" => "Razón",
"Registered" => "Registrado",
"to groups" => "a los grupos",
"Manage Group Assignments" => "Manejar asignación de grupo",
"Set Default Groups" => "Poner grupos por defecto",
"Assign selected to" => "Asignar elegidos a",
"Remove selected from" => "Borrar seleccionado de",
"the following groups:" => "los siguientes grupos:",
"Edit user" => "Editar usuario",
"Generate a password" => "Generar una contraseña",
"User tracker item : {\$usersitemid}" => "Usar ítem de tracker : {\$usersitemid}",
"Overwrite" => "Sobrescribir",
"Source" => "Fuente",
"Admin Article Types" => "Admin Tipos de Artículo",
"List of types" => "Lista de tipos",
"Shows up in the drop down list of article types" => "Muestra en la lista descolgable de tipos de artículo",
"Allow ratings by the author" => "Permite calificación por autor",
"Show before publish date" => "Mostrar antes de la fecha de publicación",
"non-admins can view before the publish date" => "no-admins pueden ver antes de la fecha de publicación",
"Show after expire date" => "Mostrar después de la fecha de expiración",
"non-admins can view after the expire date" => "no-admins pueden ver después de la fecha de expiración",
"Heading only" => "Sólo encabezado",
"No article body, heading only" => "Sin cuerpo de artículo, sólo cabecera",
"Allow comments for this type" => "Permite comentarios para este tipo",
"Comment Can Rate Article" => "Comentario puede calificar artículo",
"Allow comments to include a rating value" => "Permitir comentarios para incluir un valor de calificación",
"Show image" => "Mostrar imagen",
"Show topic or own image" => "Mostrar tema o imagen propia",
"Show avatar" => "Mostrar avatar",
"Show author's avatar" => "Mostrar avatar del autor",
"Show author" => "Mostrar autor",
"Show author name" => "Muestra nombre del autor",
"Show publish date" => "Mostrar fecha de publicación",
"Show expire date" => "Mostrar fecha de expiración",
"Show reads" => "Mostrar lecturas",
"Show the number of times the article was read" => "Muestra el número de veces que el artículo fue leído",
"Show size" => "Mostrar tamaño",
"Show the size of the article" => "Muestra el tamaño del artículo",
"Show topline" => "Muestra línea superior",
"Show a small title over the title" => "Muestra un pequeño título sobre el título",
"Show subtitle" => "Muestra subtítulo",
"Show the subtitle" => "Muestra el subtítulo",
"Show source" => "Muestra fuente",
"Show link to source after article body" => "Muestra enlace a fuente después del cuerpo del artículo",
"Show Image Caption" => "Muestra título de imagen",
"Show a legend under the image" => "Muestra una leyenda bajo la imagen",
"Show Language" => "Muestra Lenguaje",
"Show the language" => "Muestra el lenguaje",
"Creator can edit" => "Creador puede editar",
"The person who submits an article of this type can edit it" => "La persona que envía un artículo de este tipo puede editarlo",
"Show lang" => "Mostrar idioma",
"Review" => "Revisión",
"Classified" => "Clasificado",
"Create a new type" => "Crear nuevo tipo",
"Group Information" => "Información del grupo",
"level" => "nivel",
"Create level" => "Crear nivel",
"all permissions in level" => "todos los  permisos en nivel",
"backlinks to" => "backlinks hacia",
"No backlinks to this page" => "No hay backlinks hacia esta página",
"Directory batch upload" => "Subida en lote de directorio",
"Browse Gallery" => "Visitar galería",
"Upload From Disk" => "Subir desde disco local",
"available images" => "imágenes disponibles",
"Remove File Extension from Image Name" => "Borre la extensión del archivo del nombre de la imágen",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "ej de \"digicam0001.jpg\" el nombre digicam0001 será usado para el campo nombre",
"Select a Gallery" => "Seleccione una Galería",
"Process" => "Proceso",
"Edit Post" => "Editar Post",
"View Blog" => "Ver blog",
"Use ...page... to separate pages in a multi-page post" => "Usa ...page... para separar páginas en un post multi-página",
"Body" => "Cuerpo",
"Upload image for this post" => "Subir imagen para este post",
"Trash" => "Basura",
"Mark entry as private:" => "Marcar entrada como privada:",
"Spellcheck" => "Chequeo ortográfico",
"Save and Exit" => "Guardar y salir",
"Powered by" => "Basado en",
"Made with" => "Hecho con",
"powered by" => "basado en",
"Articles RSS" => "Artículos RSS",
"Image Galleries RSS" => "Galerías de Imágenes RSS",
"File Galleries RSS" => "Galerías de Archivos RSS",
"Forums RSS" => "Foros RSS",
"Maps RSS" => "Mapas RSS",
"Execution time" => "Tiempo de ejecución",
"Memory usage" => "Uso de memoria",
"Server load" => "Carga del servidor",
"Admin Category" => "Admin categoría",
"Admin the Category System" => "Admin el sistema de categorías",
"Browse in" => "Navegar en",
"Sheets" => "Planillas",
"Hide subcategories objects" => "Ocultar objetos de subcategorías",
"Show subcategories objects" => "Mostrar objetos de subcategorías",
"Upper level" => "Nivel superior",
"List Galleries" => "Listar galerías",
"Edit Gallery" => "Editar galería",
"Rebuild Thumbnails" => "Reconstruir miniaturas",
"Directory Batch" => "Directory batch",
"List Gallery" => "Listar galería",
"Monitor this Gallery" => "Monitorizar esta galería",
"Stop Monitoring this Gallery" => "Dejar de monitorizar esta galería",
"Sort Images by" => "Ordenar imágenes por",
"subgallery" => "subgalería",
"Subgallery" => "Subgalería",
"Hit" => "Impacto",
"Original Size" => "Tamaño original",
"rotate right" => "rotar derecha",
"rotate" => "rotar",
"Details" => "Detalles",
"You can include the image in a tiki page using one of these lines" => "Puede incluir la imagen en una página tiki usando una de estas líneas",
"Return to Gallery" => "Volver a la galería",
"Edit Image" => "Editar imagen",
"First Image" => "Primer imágen",
"Prev Image" => "Imágen previa",
"Smaller" => "Menor",
"Bigger" => "Mayor",
"Popup window" => "Ventana popup ",
"Next Image" => "Próxima imágen",
"Slideshow Forward" => "Presentación adelante",
"Last Image" => "última imágen",
"Click to zoom" => "Clic para agrandar",
"Image Name" => "Nombre de la imagen",
"Image Scale" => "Imagescale",
"Latitude (WGS84/decimal degrees)" => "Latitud (WGS84/grados decimales)",
"Longitude (WGS84/decimal degrees)" => "Longitud (WGS84/grados decimales)",
"Move image" => "Mover imagen",
"Stop Monitoring this Page" => "Dejar de monitorizar esta página",
"Monitor this Page" => "Monitorizar esta página",
"Group Calendars" => "Calendarios Grupales",
"Tentative" => "Tentativo",
"Confirmed" => "Confirmado",
"Cancelled" => "Cancelado",
"Change Focus" => "Cambiar foco",
"Edit Calendar Item" => "Editar Item de Calendario",
"New Calendar Item" => "Nuevo ítem de calendario",
"Tuesday" => "Martes",
"Wednesday" => "Miércoles",
"Thursday" => "Jueves",
"Friday" => "Viernes",
"January" => "Enero",
"February" => "Febrero",
"March" => "Marzo",
"April" => "Abril",
"May" => "Mayo",
"June" => "Junio",
"July" => "Julio",
"August" => "Agosto",
"September" => "Septiembre",
"October" => "Octubre",
"November" => "Noviembre",
"December" => "Diciembre",
"times" => "veces",
"End" => "Fin",
"Duration" => "Duración",
"Organized by" => "Organizado por",
"Calendar import" => "Importar calendario",
"Calendar has been updated" => "El calendario fue actualizado",
"import" => "importar",
"W" => "S",
"Change password enforced" => "Cambio de contraseña forzoso",
"Change your password" => "Cambia tu contraseña",
"Send a message to us" => "Enviarnos mensaje",
"Contact us by email" => "Contactarnos por correo",
"Click here to send us an email" => "Cliquee aquí para enviarnos un correo",
"Contacts" => "Contactos",
"Create/edit contacts" => "Crear/editar contactos",
"First Name" => "Nombre",
"Last Name" => "Apellido",
"Nickname" => "Apodo",
"You can browse the generated WebHelp here" => "Puede navegar el WebHelp generado aquí",
"Structure" => "Estuctura",
"Top page" => "Página principal",
"Add a new site" => "Añadir nuevo sitio",
"You cannot add sites until Directory Categories are setup." => "No puede añadir sitios hasta que las Categorias de Directorio esten configuradas.",
"Please contact the Site Administrator" => "Por favor contacte el Administrador del Sitio",
"Site added" => "Sitio añadido",
"Directory Administration" => "Administración de Directorio",
"There are" => "Hay",
"invalid sites" => "sitios no válidos",
"valid sites" => "sitios válidos",
"Users have visited" => "Usuarios visitaron",
"sites from the directory" => "sitios desde el directorio",
"Users have searched" => "Usuarios buscaron",
"times from the directory" => "veces desde el directorio",
"Related" => "Relacionados",
"Sites" => "Sitios",
"Validate" => "Validar",
"Admin directory categories" => "Admin categorías de directorio",
"Add a directory category" => "Añadir una categoría de directorio",
"Edit this directory category" => "Editar esta categoría de directorio",
"Children type" => "Tipo de descendiente",
"Maximum number of children to show" => "Número máximo de hijos a mostrar",
"Editor group" => "Grupo editor",
"allow" => "permitir",
"count" => "cuenta",
"relate" => "relacionada",
"Admin sites" => "Admin sitios",
"Is valid" => "es válida",
"New Sites" => "Nuevos sitios",
"Cool Sites" => "Sitios cool",
"Add a Site" => "Añadir un sitio",
"any" => "todos",
"in entire directory" => "en todo el directorio",
"Sort by" => "Ordernar por",
"name (desc)" => "nombre (desc)",
"name (asc)" => "nombre (asc)",
"creation date (desc)" => "fecha creación (desc)",
"creation date (asc)" => "fecha creación (asc)",
"last updated (desc)" => "última actualización (desc)",
"last updated (asc)" => "última actualización (asc)",
"Added" => "Añadida",
"Last updated" => "Modificado",
"Total links" => "Total enlaces",
"Links to validate" => "Enlaces a validar",
"Searches performed" => "Búsquedas hechas",
"Total links visited" => "Total enlaces visitados",
"Directory ranking" => "Ranking de directorios",
"Search results" => "Resultados de la búsqueda",
"Validate sites" => "Validar sitios",
"Edit article" => "Editar artículo",
"List Articles" => "Listar Artículos",
"View Articles" => "Ver artículos",
"Topline" => "LineaTope",
"Author Name" => "Nombre del autor",
"Own Image" => "Imagen propia",
"Article image" => "Imagen de Artículo",
"Use own image" => "Usar imagen propia",
"Float text around image" => "Texto flotante alrededor de la imagen",
"Own image size x" => "Imagen propia tamaño x",
"Own image size y" => "Imagen propia tamaño y",
"Image caption" => "Título de imagen",
"Publish Date" => "Fecha publicación",
"Expiration Date" => "Fecha Expiración",
"Edit or create banners" => "Editar o crear banners",
"List banners" => "Listar banners",
"URL to link the banner" => "URL a dónde enlaza el banner",
"Client" => "Cliente",
"Max impressions" => "Impresiones máximas",
"Show the banner only between these dates" => "Mostrar el banner solo entre estas fechas",
"From date" => "Desde fecha",
"To date" => "Hasta fecha",
"Use dates" => "Usar fechas",
"Show the banner only in this hours" => "Mostrar el banner solo en este horario",
"Show the banner only on" => "Mostrar el banner solo en",
"Mon" => "Lun",
"Tue" => "Mar",
"Wed" => "Mié",
"Thu" => "Jue",
"Fri" => "Vie",
"Sat" => "Sáb",
"Sun" => "Dom",
"Select ONE method for the banner" => "Seleccione UN método para el banner",
"Use HTML" => "Usar HTML",
"Use image" => "Usar imagen",
"Image:" => "Imagen:",
"Current Image" => "Imagen actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Usar contenido desde una URL (el contenido será descargado por cada impresión desde la URL indicada)",
"Use text" => "Usar texto",
"Save the Banner" => "Guardar el banner",
"Remove Zones (you lose entered info for the banner)" => "Borrar Zonas (perderá información ingresada para el banner)",
"Create Blog" => "Crear Blog",
"Current heading" => "Encabezado actual",
"There are individual permissions set for this blog" => "Hay permisios individuales configurados para este blog",
"Number of posts to show" => "Posts a mostrar",
"Allow other user to post in this blog" => "Permitir a otros usuarios postear en este blog",
"Allow search" => "Permitir busqueda",
"Allow comments" => "Permitir comentarios",
"Show user avatar" => "Mostrar avatar de usuario",
"Blog heading" => "Encabezado del Blog",
"Edit Style Sheet" => "Editar Hoja de Estilo",
"Style Sheet" => "Hoja de Estilo",
"choose a stylesheet" => "elija una hoja de estilo",
"Try" => "Probar",
"Colored text" => "Texto en colores",
"Headings" => "Encabezados",
"Show/Hide" => "Mostrar/Ocultar",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostrar/ocultar sección de encabezados. + (mostrar) o - (ocultar) por defecto",
"Box content" => "Contenido de la caja",
"Dynamic variables" => "Variables dinámicas",
"Inserts an editable variable" => "Inserta una variable editable",
"External links" => "Enlaces externos",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Para un Wiki externo, use NombreExternoWiki:NombrePagina o ((Nombre Externo Wiki: Nombre Pagina))",
"Square Brackets" => "Paréntesis rectos",
"Use [[foo] to show [foo]." => "Usar [[foo] para mostrar [foo].",
"Wiki References" => "Referencias Wiki",
"JoinCapitalizedWords or use" => "JuntarPalabrasEnMayusculas o usar",
"page|description" => "página|desc",
"for wiki references" => "para referencias en el wiki",
"SomeName" => "AlgúnNombre",
"prevents referencing" => "impide referenciar",
"Lists" => "Listas",
"for bullet lists" => "para listas de bullets",
"for numbered lists" => "para listas numeradas",
"for definiton lists" => "para listas de definiciones",
"Tables" => "Tablas",
"Title bar" => "Barra de título",
"Multi-page pages" => "Páginas multi-página",
"Non parsed sections" => "Secciones no parseadas",
"Prevents wiki parsing of the enclosed data." => "Previene el parseo del wiki de los datos encerrados.",
"Preformated sections" => "Secciones preformateadas",
"Block Preformatting" => "Preformateo de Bloque",
"Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that." => "Indente texto con un número de espacios para convertirlo en un bloque monoespaciado que sigue otras instrucciones de formateo de Wiki. Será indentado con el mismo número de espacios que use. Note que este modo no preserva espaciado exacto y saltos de línea, use ~pp~...~/pp~ para eso.",
"No description available" => "Sin descripción disponible",
"Browse Images" => "Ver imágen",
"Edit successful!" => "Editado exitosamente",
"The following image was successfully edited" => "La siguiente imagen fue editada exitosamente",
"Image Description" => "Descripción",
"You can view this image in your browser using" => "Puede visualizar esta imagen en su navegador usando",
"You can include the image in an HTML page using one of these lines" => "Puede incluir la imagen en una página HTML usando una de estas líneas",
"Edit or ex/import Languages" => "Editar o ex/importar Lenguajes",
"Edit and create Languages" => "Editar y crear Lenguajes",
"Edit and create languages" => "Editar y crear lenguajes",
"Create Language" => "Crear Lenguaje",
"Shortname" => "Nombre corto",
"like" => "como",
"Longname" => "Nombre largo",
"Select the language to edit" => "Elija lenguaje a editar",
"Add a translation" => "Añadir traducción",
"Edit translations" => "Editar traducción",
"Translate recorded" => "Traducción grabada",
"Translation" => "Traducción",
"reset table" => "reiniciar tabla",
"Create New Block" => "Crear nuevo bloque",
"Return to block listing" => "Volver a la lista de bloques",
"Block description: " => "Descripción del bloque: ",
"You are editing block:" => "Está editando el bloque:",
"Publishing date" => "Fecha de publicación",
"Publishing Date" => "Fecha de Publicación",
"Edit question options" => "Editar opciones de pregunta",
"List Quizzes" => "Listar Cuestionarios",
"Quiz Stats" => "Estadísticas de Cuestionarios",
"This Quiz Stats" => "Estadísticas de este cuestionario",
"Edit this Quiz" => "Editar este cuestionario",
"Admin Quizzes" => "Admin cuestionarios",
"Create/edit options for question" => "Crear/editar opciones para pregunta",
"Option" => "Opción",
"points" => "puntos",
"Quiz" => "Cuestionario",
"canRepeat" => "puedeRepetir",
"timeLimit" => "tiempoLimite",
"Create/edit quizzes" => "Crear/editar cuestionarios",
"There are individual permissions set for this quiz" => "Existen permisos individuales para este cuestionario",
"Quiz can be repeated" => "El cuestionario puede repetirse",
"Store quiz results" => "Guardar resultados de este cuestionario",
"Immediate feedback" => "Respuesta inmediata",
"Show correct answers" => "Ver respuestas correctas",
"Shuffle questions" => "Revolver preguntas",
"Shuffle answers" => "Revolver respuestas",
"Quiz is time limited" => "El cuestionario tiene un tiempo límite",
"Maximum time" => "Tiempo máximo",
"Passing Percentage" => "Por ciento de pasado",
"Edit quiz questions" => "Editar preguntas de cuestionario",
"Create/edit questions for quiz" => "Crear/editar preguntas para cuestionario",
"Question Type" => "Tipo de Pregunta",
"Import questions from text" => "Importar preguntas desde texto",
"Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instrucciones: Escriba o pegue sus preguntas de múltiple opcion debajo. Una línea para la pregunta, después comienzan las opciones de respuesta en las líneas subsiguientes. Separe preguntas adicionales con líneas en blanco. Indique respuestas correctas comenzándolas con un carácter \"*\" (sin las comillas).",
"Input" => "Entrada",
"maxScore" => "Puntuación máxima",
"From Points" => "Desde puntos",
"To Points" => "Hasta puntos",
"Answer" => "Respuesta",
"Modify Structure" => "Modificar Estructura",
"You will remove" => "Usted borrará",
"and its subpages from the structure, now you have two options:" => "y sus subpáginas de la estructura, ahora tiene dos opciones:",
"Remove only from structure" => "Borrar solo de la estructura",
"Remove from structure and remove page too" => "Borrar de la estructura y también la página",
"Structure Layout" => "Diseño de la Estructura",
"Promote" => "Promover",
"Demote" => "Degradar",
"Previous" => "Previo",
"Current Node" => "Nodo Actual",
"Page alias" => "Alias de página",
"Add pages to current node" => "Añadir páginas a nodo actual",
"After page" => "Después de página",
"Create Page" => "Crear página",
"Use pre-existing page" => "Use página preexistente",
"Submit article" => "Enviar artículo",
"List Submissions" => "Listar colaboraciones",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Topline</b>=pequeña línea sobre el Título",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítulo</b>=pequeña línea debajo de Título",
"<b>Source</b>=URL to article source" => "<b>Origen</b>=URL del artículo fuente",
"Edit templates" => "Editar plantillas",
"Template listing" => "Lista de plantillas",
"Available templates" => "Plantillas disponibles",
"Edit a topic" => "Editar tema",
"You must specify the object language" => "Debe especificar el lenguaje del objeto",
"The object doesn't exist" => "El objeto no existe",
"The object doesn't have a language" => "El objeto no tiene un lenguaje",
"The object has already a translation for this language" => "El objeto ya tiene una traducción para este lenguaje",
"The object is already in the set of translations" => "El conjunto ya está en el conjunto de traducciones",
"detach" => "separar",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "El SandBox es una página de donde puede practicar su edición, use la vista previa para ver la apariencia de la página, no seran guardaran versiones para esta página.",
"Upload picture" => "Subir imagen",
"Admin Content Templates" => "Admin plantillas de contenido",
"Try to convert HTML to wiki" => "Intentar convertir HTML a wiki",
"Import page" => "Importar página",
"export all versions" => "exportar todas las versiones",
"Year:" => "Año:",
"Authors:" => "Autores:",
"Manage structures" => "Manejar estructuras",
"License" => "Licencia",
"Important" => "Importante",
"My Footnotes" => "Notas al pie",
"Use rating" => "Usar calificaciones",
"There is no available poll template." => "No hay plantilla disponible de votación.",
"You should ask an admin to create them." => "Debe pedirle al administrador que las cree.",
"an existing poll" => "votación existente",
"votes" => "votos",
"status" => "estado",
"lastModif" => "última modificación",
"List FAQs" => "Listar FAQs",
"View FAQ" => "Ver FAQ",
"Edit this FAQ" => "Editar esta FAQ",
"New Question" => "Nueva pregunta",
"Use a question from another FAQ" => "Usar pregunta de otra FAQ",
"FAQ questions" => "Preguntas frecuentes",
"Suggested questions" => "Preguntas sugeridas",
"No suggested questions" => "No hay preguntas sugeridas",
"Upload File" => "Subir archivo",
"View tpl" => "Ver tpl",
"File Galleries tpl" => "Galerías de Archivos tpl",
"You can access the file gallery using the following URL" => "Puede acceder a la galería usando esta URL",
"Admin forums" => "Admin foros",
"Edit queued message" => "Editar mensajes en cola",
"make this a thread of" => "hacer de ésto un hilo",
"None, this is a thread message" => "Ninguno, éste es un mensaje de un hilo",
"summary" => "sumario",
"announce" => "anuncio",
"no feeling" => "sin emoción",
"frown" => "ceño",
"exclaim" => "exclamar",
"question" => "pregunta",
"happy" => "contento",
"wink" => "guiño",
"Save and Approve" => "Salve y apruebe",
"convert to topic" => "convertir a tema",
"List of messages" => "Lista de mensajes",
"New Topic" => "Nuevo tópico",
"no summary" => "sin sumario",
"No messages queued yet" => "Sin mensajes en cola aún",
"Last Post" => "último mensaje",
"Configure Forum" => "Configurar foro",
"Reported by" => "Reportado por",
"Pending requests" => "Pedidos pendientes",
"Request Time" => "Hora de pedido",
"Accept" => "Aceptado",
"Refuse" => "Rechazar",
"Waiting requests" => "Pedidos en espera",
"Your friends" => "Sus amigos",
"break friendship" => "romper amistad",
"Galleries" => "Galerías",
"Create New Gallery" => "Crear nueva galería",
"Create a gallery" => "Crear una galería",
"Edit this gallery:" => "Editar esta galería:",
"There are individual permissions set for this gallery" => "Hay permisos individuales configurados para esta galería",
"Gallery is visible to non-admin users?" => "¿Galería visible para usuarios no-admin?",
"Geographic" => "Geográfico",
"Fields to show during browsing the gallery" => "Campos a mostrar mientras se recorre la galería",
"Creation Date" => "Fecha de Creación",
"Gallery Image" => "Imagen de Galería",
"Available scales" => "Escalas disponibles",
"default scale" => "escala por defecto",
"No scales available" => "No hay escalas disponibles",
"Original image is default scale" => "Imagen original es la escala por defecto",
"Add scaled images with bounding box of square size" => "Agregar imágenes escaladas con cajas vinculadores de tamaño cuadrado",
"Other users can upload images to this gallery" => "Permitir a otros usuarios añadir imágenes en esta galería",
"You can access the gallery using the following URL" => "Puede acceder a la galería usando la URL",
"Available Galleries" => "Galerías disponibles",
"Choose a filter" => "Elija un filtro",
"Make Map" => "Hacer Mapa",
"To" => "A",
"Im- Export languages" => "Im- Exportar lenguajes",
"Select the language to Import" => "Elija el lenguaje a importar",
"Select the language to Export" => "Elija el lenguaje a exportar",
"Import From File" => "Importar Desde Archivo",
"Grab Wiki Tables" => "Obtener Tablas Wiki",
"Import pages from a Structured Text Dump" => "Importar páginas desde Volcado de Texto Estructurado",
"Name of the dump file (it has to be in dump/)" => "Nombre del archivo de volcado (tiene que estar en dump/)",
"Overwrite existing pages if the name is the same" => "Sobrescribir páginas si el nombre coincide",
"Previously remove existing page versions" => "Borrar versiones de páginas existentes previamente",
"excerpt" => "desc",
"Result" => "Resultado",
"body" => "cuerpo",
"Locked" => "Bloqueado",
"Tiki installer" => "Instalador de Tiki",
"Welcome" => "Bienvenido",
"Use this script to install a new Tiki database or upgrade your existing database to release" => "Utilice este script para instalar una nueva base de datos Tiki o para actualizar su base de datos actual a la versión",
"For the latest information about this release, please read the" => "Para la última información sobre esta versión, por favor consulte las",
"Release Notes" => "Notas de la Versión",
"For complete documentation, please visit" => "Para una documentación más completa, por favor visite",
"For more information about Tiki, please visit" => "Para más información sobre Tiki, por favor visite",
"Read the License" => "Leer la Licencia",
" <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Aquí hay un resumen más comprensible de la licencia que se muestra abajo, incluyendo varias traducciones.</a>",
"Review the System Requirements" => "Revisar los Requisitos del Sistema",
"Memory" => "Memoria",
"Success" => "Éxito",
"Copy test mail to " => "¿Copia el mensaje de prueba a ",
"Send Test Message" => "Enviar Mensaje de Prueba",
"Tiki was able to send a test message to" => "Tiki ha podido enviar el mensaje de prueba a",
"Image Processing" => "Procesado de Imágenes",
"Set the Database Connection" => "Configurar Conexión con la Base de Datos",
"Use Existing Connection" => "Utilizar Conexión Existente",
"Database information" => "Información de la Base de Datos",
"Database user" => "Usuario de la base de datos",
"Install" => "Instalar",
"Reinstall the database" => "Reinstalar la base de datos",
"Upgrade" => "Actualizar",
"Automatically upgrade your existing database to v" => "Actualiza automáticamente tu base de datos existente a la v",
"Review the Upgrade" => "Revisar la Actualización",
"Review the Installation" => "Revisar la Instalación",
"Upgrade complete" => "Actualización completada",
"Installation complete" => "Instalación completada",
"Failed" => "Falló",
".htaccess File" => "Fichero .htaccess",
"We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "Recomendamos habilitar el fichero <strong>.htaccess</strong> para su Tiki",
"This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "Esto le permitirá utilizar SEFURLs (search engine friendly URLs) y ayudará a mejorar la seguridad de su sitio",
"Configure General Settings" => "Configuraciones Generales",
"Secure Login" => "Registro Seguro",
"Administrator" => "Administrador",
"Enter Your Tiki" => "Entre en Tiki",
"Installation" => "Instalación",
"Enter Tiki and Lock Installer" => "Entrar en Tiki y Bloquear el Instalador",
"Recommended" => "Recomendado",
"Enter Tiki Without Locking Installer" => "Entrar en Tiki sin Bloquear el Instalador",
"MultiTiki Setup" => "Instalación MultiTiki",
"Default Installation" => "Instalación por omisión",
"DB OK" => "BD OK",
"No DB" => "Sin BD",
"Install/Upgrade" => "Instalación / Actualización",
"Database Connection" => "Conexión a la base de datos",
"Reset the Database Connection" => "Configurar la Conexión con la Base de datos",
"Install Profile" => "Instalar Perfil",
"Configure the General Settings" => "Configuraciones Generales",
"TikiWiki Project Web Site" => "Sitio Web del proyecto TikiWiki",
"Documentation" => "Documentación",
"Support Forums" => "Foros de Ayuda",
"TikiWiki CMS/Groupware Project" => "Proyecto TikiWiki CMS/Groupware",
"Powered by TikiWiki" => "Potenciado por TikiWiki",
"Clear cached version and refresh cache" => "Limpiar versión en caché y refrescar",
"configure rules" => "configurar reglas",
"Edit Repository" => "Editar repositorio",
"Last Changes" => "Últimas modificaciones",
"Last 2 days" => "Últimos 2 días",
"Last 3 days" => "Últimos 3 días",
"Last 5 days" => "Últimos 5 días",
"Last week" => "Última semana",
"Last 2 weeks" => "Últimas 2 semanas",
"Last month" => "Último mes",
"Search by Date" => "Buscar por fecha",
"LastChanges" => "ÚltimosCambios",
"Pages like" => "Páginas similares",
"No pages found" => "No se encontraron páginas",
"Edit New Article" => "Editar nuevo artículo",
"View Submissions" => "Ver colaboraciones",
"ExpireDate" => "FechaExpiración",
"AuthorName" => "Autor",
"Create banner" => "Crear banner",
"Method" => "Método",
"Use Dates?" => "¿Usar Fechas?",
"Max Impressions" => "Máximo de Impresiones",
"Impressions" => "Impresiones",
"Create New Blog" => "Crear nuevo blog",
"Dynamic content system" => "Sistema de contenido dinámico",
"Available content blocks" => "Bloques disponibles",
"Current ver" => "Versión actual",
"Next ver" => "Próxima versión",
"Future vers" => "Versiones futuras",
"Program" => "Programar",
"Available FAQs" => "FAQs disponibles",
"Edit/Create" => "Editar/Crear",
"Edit this FAQ:" => "Editar este FAQ:",
"Create new FAQ" => "Crear nueva FAQ",
"Create New FAQ:" => "Crear Nueva FAQ:",
"Users can suggest questions" => "Los usuarios pueden sugerir preguntas",
"Create a File Gallery" => "Crear galería de archivos",
"Gallery Images" => "Imágenes de Galería",
"Edit Blog" => "Editar Blog",
"Blog Title" => "Título Blog",
"Edit New Submission" => "Editar nueva colaboración",
"Survey stats" => "Estadísticas de encuesta",
"Take Survey" => "Tomar encuesta",
"Distance (km)" => "Distancia (km)",
"List Movies" => "Lista Películas",
"Choose a movie" => "Elija una película",
"Last mod" => "Últ mod",
"Last author" => "Último autor",
"Last version" => "Última versión",
"unlocked" => "desbloqueada",
"Open client window" => "Abrir ventana cliente",
"Generate HTML" => "Generar HTML",
"Transcripts" => "Transcripciones",
"Online operators" => "Operadores en línea",
"Operator" => "Operador",
"transcripts" => "transcripciones",
"Offline operators" => "Operadores fuera de línea",
"Add an operator to the system" => "Añadir un operador al sistema",
"Operators must be tiki users" => "Los operadores deben ser usuarios del tiki",
"Set as Operator" => "Poner como operador",
"Chat started" => "Charla comenzada",
"Operator:" => "Operador:",
"Live support:User window" => "Soporte Live:ventana de usuario",
"Request live support" => "Pedir soporte live",
"Request support" => "Pedir soporte",
"Open a support ticket instead" => "Abrir un ticket de soporte en su lugar",
"Your request is being processed" => "Su pedido está siendo procesado",
"cancel request and exit" => "cancelar pedido y salir",
"cancel request and leave a message" => "cancelar pedido y dejar mensaje",
"Live support:Console" => "Soporte Live:Consola",
"be online" => "quedar en línea",
"be offline" => "quedar fuera de línea",
"Support requests" => "Pedidos de soporte",
"Requested" => "Pedido",
"Join" => "Unir",
"Support chat transcripts" => "Soporte de transcripciones de charla",
"operator" => "operador",
"started" => "comenzado",
"reason" => "razón",
"msgs" => "msjs",
"Transcript" => "Transcripción",
"Mail-in feature" => "Función Mail-in",
"Daily" => "Diario",
"Weekly" => "Semanal",
"Remove old events" => "Borrar eventos viejos",
"duration" => "duración",
"Mini Calendar: Preferences" => "Mini Calendario: Preferencias",
"Calendar Interval in daily view" => "Intervalo de calendario en vista diaria",
"Start hour for days" => "Hora de inicio para días",
"End hour for days" => "Hora final para días",
"Reminders" => "Recordatorios",
"no reminders" => "sin recordatorios",
"Or enter path or URL" => "O entre camino o URL",
"Add Topic" => "Añadir tópico",
"Update remote index" => "Actualizar índice remoto",
"Rebuild local list" => "Reconstruir lista local",
"Republish all" => "Republicar todo",
"Publish all" => "Publicar todo",
"Unpublish all" => "Despublicar todo",
"Attention" => "Atención",
"all types" => "todos los tipos",
"Display only this type" => "Mostrar solo este tipo",
"Unpublish" => "Despublicar",
"Republish" => "Republicar",
"Tikiwiki Mods Configuration" => "Configuración Tikiwiki Mods",
"Enable Mods providing" => "Activar proveer Mods",
"Mods local directory" => "Directorio local de Mods",
"Mods remote server" => "Servidor remoto de Mods",
"Package Config" => "Config de Paquete",
"User Galleries" => "Galerías de usuario",
"Unread Messages" => "Mensajes no leídos",
"Tasks" => "Tareas",
"MyTiki" => "MiTiki",
"Notepad" => "Bloc de notas",
"MyFiles" => "MisArchivos",
"My Watches" => "Mis suscripciones",
"Sent editions" => "Ediciones enviadas",
"The newsletter was sent to {\$sent} email addresses" => "El boletín fue enviado a {\$sent} direcciones de correo",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Gracias por subscribirse. Pronto recibirá un correo para confirmar su suscripción. No se enviarán boletines hasta que la subscripción sea confirmada.",
"Your email address was removed from the list of subscriptors." => "Su dirección de correo ha sido borrada de la lista de suscriptores.",
"Subscription confirmed!" => "¡Suscripción confirmada!",
"Subscribe to Newsletter" => "Suscribirse al boletín",
"Subscribe to this Newsletter" => "Suscribir",
"Available Newsletters" => "Boletines Disponibles",
"Notes" => "Notas",
"Write a note" => "Escribir una nota",
"No notes yet" => "Sin notas aún",
"Merge selected notes into" => "unir notas seleccionadas en",
"Reading note:" => "Leyendo nota:",
"List notes" => "Listar notas",
"Write note" => "Escribir nota",
"Wiki Create" => "Crear wiki",
"Wiki Overwrite" => "Sobrescribir wiki",
"Assign permissions to " => "Asignar permisos a ",
"Assign permissions to this object" => "Asignar permisos al objeto",
"Published" => "Publicada",
"Passcode to register (not your user password)" => "Código para registrarse (no su contraseña de usuario)",
"Orphan Pages" => "Páginas huérfanas",
"Browser not supported" => "Navegador no soportado",
"Rename" => "Renombrar",
"Discuss" => "Discustir",
"Attach File" => "Adjuntar archivo",
"1 File Attached" => "1 archivo adjuntado",
"(current)" => "(actual)",
"Rollback to this version" => "Revertir a esta versión",
"s=source" => "s=fuente",
"b=rollback" => "b=revertir",
"Pick your avatar" => "Elegir avatar",
"User Preferences" => "Preferencias del usuario",
"Your current avatar" => "Su avatar actual",
"no avatar" => "sin avatar",
"reset" => "reiniciar",
"Pick avatar from the library" => "Elija avatar de la biblioteca",
"Pick user Avatar" => "Elegir avatar",
"Hide all" => "Ocultar todo",
"icons" => "iconos",
"Show all" => "Mostrar todo",
"Avatar Image" => "Imagen de Avatar",
"random" => "aletorio",
"Upload your own avatar" => "Subir avatar o foto",
"View Details" => "Ver Detalles",
"Insert" => "Insertar",
"atts" => "adjuntos",
"List Attachments" => "Listar Archivos asociados",
"Average" => "Promedio",
"View Results" => "Ver Resultados",
"Vote poll" => "Votar",
"Other Polls" => "Otras votaciones",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Nota: ¡Recuerde que esto es sólo una previsualización, no ha sido salvado aún!",
"on:" => "en:",
"Topic image" => "Imagen de tema",
"Viewing blog post" => "Leyendo post de blog",
"Return to blog" => "Volver al blog",
"The original document is available at" => "El documento original está disponible en",
"Print multiple pages" => "Imprimir múltiples páginas",
"Add Page" => "Añadir Página",
"Edit quiz" => "Editar cuestionario",
"Current Version" => "Versión Actual",
"General Options" => "Opciones Generales",
"Publication Date" => "Fecha de Publicación",
"at " => "en ",
"randomly selected questions." => "preguntas seleccionadas aletoriamente.",
"Test-time Options" => "Opciones durante el test",
"Limit questions displayed per page to " => "Limitar preguntas desplegadas por página a ",
"&nbsp question(s)." => "&nbsp pregunta(s).",
"Impose a time limit of " => "Imponga un límite de tiempo de ",
"Allow students to store partial results and return to quiz." => "Permitir a estudiantes guardar resultados parciales y volver al cuestionario.",
"Allow students to retake this quiz " => "Permitir a estudiantes retomar cuestionarios ",
"Grading and Feedback" => "Calificación y Respuesta",
"Grading method " => "Método de calificación ",
"Show students their score " => "Mostrar puntuación a estudiantes ",
"Show students the correct answers " => "Mostrar las respuestas correctas a estudiantes ",
"Publish statistics " => "Publicar estadísticas ",
"Extra Options" => "Opciones Extra",
"Solicit additional questions from students" => "Pedir preguntas adicionales de estudiantes",
"Link quiz to forum named: " => "Enlazar cuestionario a foro llamado: ",
"Prologue:" => "Prólogo:",
"Epilogue:" => "Epílogo:",
"Quiz result stats" => "Estadísticas de resultados de cuestionarios",
"Time" => "Tiempo",
"User answers" => "Respuestas de usuario",
"Stats for quizzes" => "Estadisticas de cuestionarios",
"taken" => "tomado",
"Av score" => "Puntuación promedio",
"Av time" => "Tiempo promedio",
"Clear Stats" => "Borrar estadísticas",
"time taken" => "tiempo tomado",
"Stats for this quiz Questions " => "Estadísticas para las preguntas de este cuestionario ",
"Received articles" => "Artículos recibidos",
"Edit received article" => "Editar artículo recibido",
"Use Image" => "Usar imagen",
"Image x size" => "Tamaño x de la imagen",
"Image y size" => "Tamaño y de la imagen",
"Image name" => "Nombre de la imagen",
"Accept Article" => "Aceptar Artículo",
"Site" => "Sitio",
"Referer stats" => "Estadísticas de referers",
"Last" => "Último",
"Your email could not be validated; make sure you email is correct and click register below." => "Su correo no puede ser validado; asegúrese que su correo es correcto y pulse en registrarse.",
"Register as a new user" => "Registarse como un nuevo usuario",
"Repeat password" => "Repetir contraseña",
"A valid email is mandatory to register" => "Un correo válido es obligatorio para registrarse",
"Tiki site registered" => "Sitio Tiki registrado",
"The following site was added and validation by admin may be needed before appearing on the lists" => "El siguiente sitio fue añadido aunque una validación por el administrador puede requerirse antes de aparecer en las listas",
"You don't have permission to use this feature." => "No tiene permiso para usar esta función.",
"Please register." => "Por favor regístrese.",
"Register this site at tikiwiki.org" => "Registre este sitio en tikiwiki.org",
"Read this first!" => "¡Lea esto primero!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "En esta página puede hacer que su sitio sea conocido para tikiwiki.org. Será mostrado en una lista de sitios tiki conocidos.",
"Registering is voluntary." => "Registrarse es voluntario.",
"Registering does not give you any benefits except one more link to your site." => "Registrarse no le dara ningún beneficio excepto un enlace más a su sitio.",
"You don't get any emails, we don't sell the data about your site." => "No recibirá correos, no venderemos los datos acerca de su sitio.",
"Registering is just for us to get an overview of Tiki's usage." => "Registrarse es sólo para que nosotros tengamos una idea acerca del uso de Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Si su sitio es privado o dentro de una intranet, ¡no debería registrarse!",
"Information about your site" => "Información acerca de su sitio",
"Send me my Password" => "Enviar mi contraseña",
"Remove page" => "Eliminar página",
"Last Version" => "última versión",
"You are about to remove the page" => "Esta a punto de eliminar la página",
"permanently" => "permanentemente",
"Remove all versions of this page" => "Eliminar todas las versiones de esta página",
"Rollback page" => "Restablecer versión",
"Searched" => "Buscado",
"Search in" => "Buscar en",
"Simple search" => "Búsqueda simple",
"No pages matched the search criteria" => "No se encontraron páginas para el criterio de búsqueda",
"This newsletter will be sent to {\$subscribers} email addresses." => "Este boletín será enviando a {\$subscribers} direcciones de correo.",
"Prepare a newsletter to be sent" => "Preparar boletín para ser enviado",
"Apply content template" => "Aplicar plantilla de contenido",
"Send objects" => "Enviar objetos",
"Transmission results" => "Resultados de la transmisión",
"Send Wiki Pages" => "Enviar páginas Wiki",
"Send Articles" => "Enviar artículos",
"Add Article" => "Añadir artículo",
"Send objects to this site" => "Enviar objetos a este sitio",
"Create a sheet" => "Crear una planilla",
"Edit this sheet:" => "Editar esta planilla:",
"Create New Sheet" => "Crear nueva planilla",
"There are individual permissions set for this sheet" => "Hay permisos individuales configurados para esta planilla",
"Class Name" => "Nombre de Clase",
"Header Rows" => "Filas de Cabecera",
"Footer Rows" => "Filas de Pie",
"Create new Sheet" => "Crear nueva Planilla",
"You can access the sheet using the following URL" => "Puede acceder a la planilla usando la siguiente URL",
"Available Sheets" => "Planillas Disponibles",
"Change shoutbox general settings" => "Cambiar opciones general del shoutbox",
"auto-link urls" => "auto-linkear urls",
"Post or edit a message" => "Escribir o editar mensaje",
"Location : " => "Ubicación : ",
"Parent page" => "Página superior",
"Child" => "Hijo",
"Last edited by" => "Ultima edición por",
"based on work by" => "basado en trabajo de",
"Contributors to this page" => "Contribuyentes a esta página",
"Site Stats" => "Estadísticas del sitio",
"Started" => "Fecha de comienzo",
"Days online" => "Días en línea",
"Total pageviews" => "Páginas vistas en total",
"Average pageviews per day" => "Promedio de Páginas vistas por día",
"Best day" => "Mejor día",
"Worst day" => "Peor día",
"Wiki Stats" => "Estadísticas del Wiki",
"Size of Wiki Pages" => "Tamaño de las páginas",
"Average page length" => "Tamaño promedio",
"Average versions per page" => "Versiones promedio por página",
"Visits to wiki pages" => "Visitas a páginas del wiki",
"Average links per page" => "Cantidad promedio de enlaces por página",
"Image galleries Stats" => "Estadísticas de galerías de imágenes",
"Average images per gallery" => "Promedio de imágenes por galería",
"Total size of images" => "Tamaño total de imágenes",
"Average image size" => "Tamaño promedio de imagen",
"Visits to image galleries" => "Visitas a galerías de imágenes",
"File galleries Stats" => "Estadísticas de galerías de archivos",
"Average files per gallery" => "Promedio de archivos por galería",
"Total size of files" => "Cantidad total de archivos",
"Average file size" => "Tamaño promedio de archivo",
"Visits to file galleries" => "Cantidad de visitas a galerías de archivos",
"CMS Stats" => "Estadísticas del CMS",
"Total reads" => "Cantidad de notas leídas",
"Average reads per article" => "Lecturas promedio por artículo",
"Total articles size" => "Tamaño total de artículos",
"Average article size" => "Tamaño promedio de un artículo",
"Forum Stats" => "Estadísticas de foros",
"Total topics" => "Cantidad de temas",
"Average topics per forums" => "Cantidad promedio de temas por foro",
"Visits to forums" => "Visitas a los foros",
"Blog Stats" => "Estadísticas de Weblogs",
"Weblogs" => "Cantidad de weblogs",
"Total posts" => "Cantidad de posts en total",
"Average posts per weblog" => "Posts promedio por weblog",
"Total size of blog posts" => "Tamaño total de los posts",
"Average posts size" => "Tamaño promedio de un post",
"Visits to weblogs" => "Visitas a los weblogs",
"Poll Stats" => "Estadísticas de votaciones",
"Total votes" => "Cantidad total de votos",
"Average votes per poll" => "Promedio de votos por votación",
"Total questions" => "Preguntas en total",
"Average questions per FAQ" => "Promedio de preguntas por FAQ",
"User Stats" => "Estadísticas de usuarios",
"Average bookmarks per user" => "Cantidad de marcadores por usuario",
"Average questions per quiz" => "Preguntas promedio por cuestionario",
"Quizzes taken" => "Cuestionarios tomados",
"Average quiz score" => "Puntuación promedio",
"Average time per quiz" => "Tiempo promedio",
"Stats for surveys" => "Estadisticas de encuestas",
"Last taken" => "Última respuesta",
"Time Left" => "Tiempo",
"Send Answers" => "Enviar respuestas",
"Thank you for your submission" => "Gracias por su envío",
"Your email was sent" => "Su correo ha sido enviado",
"Theme is selected as follows" => "El tema fue seleccionado como sigue",
"If a theme is assigned to the individual object that theme is used." => "Si un tema esta asignado a un objeto individual ese tema es usado.",
"If not then if a theme is assigned to the object's category that theme is used" => "Si no entonces si un tema es asignado a la categoría del objeto ese tema es usado",
"If not then a theme for the section is used" => "Si no entonces el tema para la sección es usado",
"If none of the above was selected the user theme is used" => "Si nada de lo anterior fue seleccionado se usara el tema del usuario",
"Finally if the user didn't select a theme the default theme is used" => "Finalmente si el usuario no eligio un tema el tema por defecto será usado",
"Control by Objects" => "Control por Objetos",
"Control by Sections" => "Control por Secciones",
"Assign themes to categories" => "Asignar temas a categorías",
"Assigned categories" => "Categorías asignadas",
"Theme Control Center: Objects" => "Centro de Control de Temas: Objectos",
"Control by Categories" => "Control por Categorías",
"Assign themes to objects" => "Asignar temas a objetos",
"Assigned objects" => "Objetos asignados",
"Assign themes to sections" => "Asignar temas a secciones",
"Assigned sections" => "Secciones asignadas",
"Edit File:" => "Editar Archivo:",
"The following file was successfully uploaded" => "El siguiente archivo ha sido subido exitosamente",
"You can download this file using" => "Puede bajar el archivo usando",
"Batch Upload Results" => "Resultados de la Subida en Lote",
"Upload successful!" => "¡Imagen recibida correctamente!",
"The following image was successfully uploaded" => "La siguiente imagen ha sido recibida con éxito",
"Image ID thumb" => "Miniatura ID de imagen",
"You can include the image in an Wiki page using" => "Puede incluir la imagen en una página wiki usando",
"or use filename" => "o use nombre de archivo",
"Now enter the image URL" => "Ingrese la URL de la imagen",
"or upload a local image from your disk" => "o suba una imagen desde su disco local",
"Batch Upload" => "Subida batch",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatura (opcional, impide que se genere automaticamente)",
"You have to create a gallery first!" => "Debe crear una galería primero!",
"User assigned modules" => "Módulos asignados por el usuario",
"Restore defaults" => "Recuperar valores por defecto",
"Assign module" => "Asignar módulo",
"Column" => "Columna",
"Folders" => "Carpetas",
"Folder in" => "Carpeta entrada",
"Remove Folder" => "Borrar carpeta",
"Refresh Cache" => "Refrescar cache",
"Admin folders and bookmarks" => "Admin carpetas y marcadores",
"Send me a message" => "Enviarme un mensaje",
"Assign Group" => "Asignar Grupo",
"Change user preferences" => "Cambiar preferencias de usuarios",
"Homepage" => "Inicio",
"Users HomePage" => "Página Inicio de Usuarios",
"Personal Wiki Page" => "Página Personal Wiki",
"Create page" => "Crear página",
"Request friendship from this user" => "Solicitar amistad de este usuario",
"Toggle options" => "Cambiar opciones",
"Personal Information" => "Información Personal",
"View extra information" => "Ver información extra",
"Is email public? (uses scrambling to prevent spam)" => "¿Es el correo público? (usa cifrado para prevenir spam)",
"Unavailable - please set your e-mail below" => "No disponible - configure su correo debajo",
"Does your mail reader need a special charset" => "Su lector de correo requiere un conjunto de caracteres especial",
"Notify sender when reading his mail" => "Notifique al autor cuando lea su correo",
"Account Information" => "Información de cuenta",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deje los campos \"Nueva contraseña\" y \"Confirmar contraseña\" en blanco para conservar la contraseña actual",
"Change administrative info" => "Cambiar información administrativa",
"New task" => "Nueva tarea",
"Task list" => "Lista de tareas",
"Admin mode off" => "Modo admin activado",
"Admin mode on" => "Modo admin desactivado",
"Task help" => "Ayuda de tareas",
"Empty Trash" => "Vaciar papelera",
"Received task" => "Tarea recibida",
"You received this task, please read and execute it" => "Recibió esta tarea, por favor léala y ejecútela",
"Send task" => "Enviar tarea",
"You send this task to a other user" => "Puede enviar esta tarea a otro usuario",
"Shared task" => "Tarea compartida",
"This task is public to a special group" => "Esta tarea es pública para un grupo especial",
"Accepted by Task User and Creator" => "Aceptada por usuario de tarea y creador",
"Accepted User and Creator" => "Aceptado usuario y creador",
"Task is accepted by user and creator" => "Tarea aceptada por usuario y creador",
"Not Accepted by One User" => "No aceptada por un usuario",
"Not Accepted User" => "Usuario no aceptado",
"Task is rejected by one user" => "Tarea es rechazada por un usuario",
"Waiting for Me" => "Esperando por mi",
"Waiting for Other User" => "Esperando por otro usuario",
"Task is not accepted/rejected by other user" => "Tarea no es aceptada/rechazada por otro usuario",
"Admin Mode" => "Modo admin",
"Edit task" => "Editar tarea",
"NOT accept" => "NO acepta",
"Remove from Trash" => "Sacar de papelera",
"Move into Trash" => "Poner en papelera",
"Task saved" => "Tarea guardada",
"Edit Task" => "Editar Tarea",
"View Task" => "Ver Tarea",
"Open a new task" => "Abrir nueva tarea",
"Task user" => "Usuario de tarea",
"Only the creator can delete this task" => "Solo el creador puede borrar esta tarea",
"Use start date and time" => "Usar fecha y hora de comienzo",
"Use end date and time" => "Usar fecha y hora de fin",
"Open / In Process" => "Abierta / en proceso",
"Waiting / Not Started" => "Esperando / no empezada",
"Percentage completed" => "Porcentaje de completada",
"Shared for Group" => "Compartida para grupo",
"Accepted by User" => "Aceptada por usuario",
"No / Rejected" => "No / rechazada",
"Accepted by Creator" => "Aceptada por creado",
"This message will be send to users if you are makeing changes of assigned tasks" => "Este mensaje será enviado a usuarios si está haciendo cambios a tareas asignadas",
"Send message with changes" => "Enviar mensaje con cambios",
"Modified by" => "Modificado por",
"Marked as deleted" => "Marcado como borrado",
"Inform task user by email" => "Informar usuario de tarea por correo",
"You can only view this task" => "Solo puede ver esta tarea",
"Completed" => "Completada",
"%m/%d/%Y [%H:%M]" => "%d/%m/%Y [%H:%M]",
"No tasks entered" => "No se entraron tareas",
"Select One" => "Seleccione una",
"Undo Trash" => "Deshacer papelera",
"Show:" => "Mostrar:",
"Received" => "Recivido",
"Submitted" => "Enviado",
"Shared" => "Compartida",
"All Shared Tasks" => "Todas las tareas compartidas",
"completed (100%)" => "completada (100%)",
"Monthly" => "Mensual",
"Add Watch" => "Añadir Watch",
"A user submits an article" => "Un usuario envía una colaboración",
"A user submits a blog post" => "Un usuario envía un post de blog",
"A user posts a forum thread" => "Un usario escribe un mensaje en un foro",
"A user posts a forum topic" => "Un usuario inicia un tema en un foro",
"A user edited a wiki page" => "Un usuario editó una página wiki",
"May need to refresh twice to see changes" => "Puede tener que refrescar 2 veces para ver cambios",
"Add top level bookmarks to menu" => "Añadir marcadores del nivel principal al menú",
"Add or edit an item" => "Añadir o editar un item",
"New Window" => "Nueva ventana",
"replace window" => "reemplazar ventana",
"User_versions_for" => "Versiones del usuario para",
"This page is being edited by" => "Esta página esta siendo editada por",
"Proceed at your own peril" => "Proceda a su propio riesgo",
"Insert Row" => "Insertar Fila",
"Insert Column" => "Insertar Columna",
"Remove Row" => "Borrar Fila",
"Remove Column" => "Borrar Columna",
"Merge Cells" => "Unir Celdas",
"Restore Cells" => "Restaurar Celdas",
"Copy Calculation" => "Copiar Cálculo",
"Format Cell" => "Formatear Celda",
"expires:" => "expira:",
"Banner stats" => "Estadisticas de Banner",
"Create new banner" => "Crear nuevo banner",
"Banner Information" => "Información de Banner",
"Hours" => "Horas",
"Weekdays" => "Días de semana",
"mon" => "lun",
"tue" => "mar",
"wed" => "mié",
"thu" => "jue",
"fri" => "vie",
"sat" => "sáb",
"sun" => "dom",
"Banner raw data" => "Datos crudos del banner",
"Cached" => "Cacheado",
"This is a cached version of the page." => "Esta es la versión cacheada de la página.",
"Click here to view the Google cache of the page instead." => "Click aquí para ver el cache de Google de la página.",
"Answers" => "Respuestas",
"Add Suggestion" => "Agregar sugerencia",
"Forum List" => "Lista de foros",
"Edit Forum" => "Editar Foro",
"Summary" => "Sumario",
"for links" => "para enlaces",
"HTML tags are not allowed inside posts" => "Etiquetas HTML no estan permitidos dentro de mensajes",
"Moderator Actions" => "Acciones de moderador",
"Move Selected Topics" => "Mover tópicos seleccionados",
"Unlock Selected Topics" => "Desbloquear tópicos seleccionados",
"Lock Selected Topics" => "Bloquear tópicos seleccionados",
"Delete Selected Topics" => "Borrar tópicos seleccionados",
"Merge" => "Combinar",
"Merge Selected Topics" => "Combinar tópicos seleccionados",
"Reported Messages:" => "Mensajes reportados:",
"Queued Messages:" => "Mensajes en cola:",
"Merge into topic" => "Combinar en tema",
"Announce" => "Anuncio",
"No topics yet" => "Sin tema aún",
"Jump to forum" => "Saltar a foro",
"All posts" => "Todos los mensajes",
"Last hour" => "Última hora",
"Last 24 hours" => "Últimas 24 horas",
"Last 48 hours" => "Últimas 48 horas",
"prev topic" => "tema ant",
"next topic" => "tema sig",
"Show posts" => "Mostrar mensajes",
"Monitor" => "Suscribirse",
"Insert New Item" => "Insertar item",
"Edit Fields" => "Editar campos",
"View inserted item" => "Ver ítem insertado",
"Insert new item" => "Insertar item",
"Tracker Item:" => "Ítem de Tracker:",
"View Item" => "Ver item",
"Filter Tracker Items" => "Filtrar Ítems de Tracker",
"Add a Comment" => "Añadir comentario",
"Items list" => "Lista de ítems",
"Special Operations" => "Operaciones Especiales",
"close" => "cerrar",
"Show All" => "Mostrar todo",
"Clip" => "clip",
"Back To Mailbox" => "volver a buzón de correo",
"Full Headers" => "ver cabeceras",
"Normal Headers" => "cabeceras normales",
"Reply To All" => "responder a todos",
"Forward" => "enviar",
"Select from address book" => "elegir desde libreta de direcciones",
"Use HTML mail" => "Usar correo HTML",
"The following addresses are not in your address book" => "Las siguientes direcciones no están en su libreta de direcciones",
"Add Contacts" => "Añadir contactos",
"Attachment 1" => "Adjunto 1",
"Attachment 2" => "Adjunto 2",
"Attachment 3" => "Adjunto 3",
"Address book" => "Libreta de direcciones",
"page id" => "id de página",
"3d browser" => "navegador 3d",
"Show/Hide Left Column" => "Mostrar/Ocultar Menús de la Izquierda",
"Show/Hide Right Column" => "Mostrar/Ocultar Menús de la Derecha",
"as Creator &amp; Last Editor" => "cómo Creador &amp; Último Editor",
"no (disabled)" => "no (desactivado)",
"Save Minor Edit" => "Menor",
"Enable/disable Tiki features here, but configure them elsewhere" => "Active/Desactive características de Tiki aquí, pero configurelas en otro lugar",
"General preferences and settings" => "Configuraciones y preferencias generales",
"User registration, login and authentication" => "Registro de usuario, entrada y autenticación",
"Wiki settings" => "Configuraciones para el Wiki",
"Wiki Attachments" => "Adjuntos al Wiki",
"Article/CMS settings" => "Artículo/CMS configuración",
"Poll comments settings" => "Configuración de los comentarios para votaciones",
"Configuration options for all blogs on your site" => "Opciones de configuración para todos los blogs de su sitio",
"Forums settings" => "Configuración de foros",
"FAQ comments settings" => "Configuracion de comentarios de FAQ",
"Trackers settings" => "Configuracion de Trackers",
"Directory settings" => "Configuracion de Directorio",
"Maps configuration" => "Configuración de Mapas",
"Meta Tags settings" => "Configuracion de Meta Tags",
"Search settings" => "Configuración de búsqueda",
"Score settings" => "Configuracion de Puntuación",
"Community settings" => "Configuracion de Comunidad",
"Calendar settings" => "Configuración de Calendarios",
"Help on \$admintitle Config" => "Ayuda sobre config \$admintitle ",
"Category can`t be parent of itself" => "Categoría no puede ser superior a si misma",
"Upload failed" => "Subida errónea",
"All posted" => "Todos los mensajes",
"Queue anonymous posts" => "Encolar mensajes anónimos",
"Queue all posts" => "Encolar todos los mensajes",
"No attachments" => "Sin adjuntos",
"Everybody can attach" => "Todos pueden adjuntar",
"Only users with attach permission" => "Solo usuarios con permiso de adjuntar",
"Moderators and admin can attach" => "Moderadores y admin pueden adjuntar",
"Date (desc)" => "Fecha (desc)",
"Date (asc)" => "Fecha (asc)",
"Score (desc)" => "Puntos (desc)",
"Replies (desc)" => "Respuestas (desc)",
"Reads (desc)" => "Lecturas (desc)",
"You have to provide a hotword and a URL" => "Tiene que proveer una palabra clave y una URL",
"Owner" => "Dueño",
"Detected, Version:" => "Detectado, Versión:",
"Not detected." => "No detectada.",
"Your admin password has been changed" => "Su contraseña de admin ha sido cambiada",
"All Fields except gdaltindex must be filled" => "Todos los campos excepto gdaltindex deben ser completados",
"No valid gdaltindex executable" => "Ejecutable gdaltindex no válido",
"Tag already exists" => "La etiqueta ya existe",
"Tag not found" => "Etiqueta no encontrada",
"Repository name can't be an empty" => "El nombre del repositorio no puede estar vacío",
"Requested action is not supported on repository" => "Acción requerida no está soportada por el repositorio",
"No repository" => "Sin repositorio",
"Search is mandatory field" => "Buscar es un campo requerido",
"File not found " => "Archivo no encontrado ",
"Requested action in not supported on repository" => "Acción requerida no esta soportada en el repositorio",
"Non-existent link" => "Enlace inexistente",
"Mail-in account %s incorrect" => "Cuenta de Mail-in %s incorrecta",
"Mail-in account %s saved" => "Cuenta de mail-in %s guardada",
"Frequency should be a positive integer!" => "¡Frecuencia debe de ser un entero positivo!",
"Mail-in accounts set to be checked every %s minutes" => "Las cuentas de mail-in configuradas para chequear cada %s minutos",
"Automatic Mail-in accounts checking disabled" => "Chequeo automático de cuentas Mail-in desactivado",
"No menu indicated" => "No se indica menú",
"No newsletter indicated" => "No se indica boletín",
"A user registers" => "Un usuario se registra",
"Any wiki page is changed" => "Cualquier página wiki es cambiada",
"Any wiki page is changed, even minor changes" => "Cualquier página wiki es cambiada, aún cambios menores",
"No poll indicated" => "No se indica votación",
"unsafe" => "inseguro",
"register_globals should be off by default. See the php manual for details." => "register_globals debería estar desactivado por defecto. Vea el manual de php por detalles.",
"safe" => "seguro",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid debería estar desactivado por defecto. Vea el manual de php por detalles.",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "No puedo ccomprobar si  upload_tmp_dir es accesible via navegador. Para estar seguro debe chequear la configuración de su servidor web.",
"setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "Activar la opción xbithack es inseguro. Dependiendo del manejo de archivos de su servidor y su configuración de tiki, puede ser posible que un atacante suba scripts a su galería de archivos y los ejecute",
"The Path to store files in the filegallery should be outside the tiki root directory" => "El camino para guardar archivos en la galería de archivos deberia estar fuera de la raiz del directorio de tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "El camino para guardar archivos en la galería de imágenes debe estar fuera del directorio raiz de tiki",
"File is not readable. Unable to check." => "Archivo no legible, incapaz de comprobar.",
"You have to provide a word" => "Debe proveer una palabra",
"Permission denied. You cannot view this page." => "No tiene permiso para acceder a la página",
"Permission denied you cannot edit this page" => "No se puede editar esta página",
"You must specify a page name, it will be created if it doesn't exist." => "Debe especificar un nombre de página, será creada si no existe.",
"page not added (Exists)" => "página no añadida (Existe)",
"No survey indicated" => "No se indica encuesta",
"You don't have permission to use this feature" => "No tiene permiso para usar esta función",
"No Errors detected" => "No se detectaron errores",
"No tracker indicated" => "No se indica tracker",
"Group already exists" => "El grupo ya existe",
"User doesn't exist" => "El usuario no existe",
"No records were found. Check the file please!" => "No se encontraron registros. ¡Compruebe el archivo por favor!",
"User login is required" => "Login de usuario requerido",
"Password is required" => "Contraseña es requerida",
"Email is required" => "Correo es requerido",
"User is duplicated" => "El usuario está duplicado",
"Created account %s <%s>" => "Creada cuenta %s <%s>",
"Assigned %s in group %s" => "Asignado %s a grupo %s",
"User %s already exists" => "Usuario %s ya existe",
"New %s created with %s %s." => "Nuevo %s creado con %s %s.",
"Impossible to create new %s with %s %s." => "Imposible crear nuevo %s con %s %s.",
"%s %s successfully deleted." => "%s %s exitosamente borrado.",
"%s %s removed from %s %s." => "%s %s eliminado desde %s %s.",
"%s changed from %s to %s" => "%s cambiado de %s a %s",
"Impossible to change %s from %s to %s" => "Imposible cambiar %s de %s a %s",
"%s modified successfully." => "%s modificado exitosamente.",
"password" => "contraseña",
"%s modification failed." => "falló modificación de %s.",
"rss feed disabled" => "rss feed desactivado",
"Tiki RSS feed for articles" => "Tiki RSS feed para artículos",
"Last articles." => "Últimos artículos.",
"Unknown group" => "Grupo desconocido",
"Group doesn't exist" => "El grupo no existe",
"You have to indicate a group" => "Debe indicar un grupo",
"This group is invalid" => "Este grupo no es válido",
"Permission denied you cannot view backlinks for this page" => "Permiso denegado no puede ver backlinks hacia esta página",
"The page cannot be found" => "La página no pudo ser encontrada",
"Image Galleries Admin Panel" => "Panel de Admin de Galería de Imágenes",
"Could not read image %s." => "No puedo leer imagen %s.",
"Image %s upload failed." => "Fallo subida de imagen %s.",
"Image %s uploaded successfully." => "Imagen %s subida exitosamente.",
"Image %s removed from Batch directory." => "Imagen %s borrada de directorio por lotes.",
"Impossible to remove image %s from Batch directory." => "Imposible borrar imagen%s de directorio por lotes.",
"Permission denied you cannot use the batch directory loading" => "Permiso denegado, no puede usar la carga en lotes por directorio",
"Incorrect directory chosen for batch upload of images." => "Directorio incorrecto elegido para subida en lote de imágenes.",
"Please setup that dir on " => "Por favor configure ese directorio en ",
"Please contact the website administrator." => "Por favor contáctese con el administrador del sitio web.",
"Invalid directory name" => "Nombre de directorio no válido",
"It isn't possible to post in any blog. You may need to create a blog first." => "No puede postear, deberia crear un blog antes",
"Permission denied you cannot post" => "No tiene permiso para postear",
"Permission denied you cannot edit this post" => "No puede editar este post",
"Top visited blogs" => "Blogs mas visitados",
"Last posts" => "Últimos posts",
"Top active blogs" => "Blogs más activos",
"Tiki RSS feed for blog: " => "Tiki RSS feed para blog: ",
"No blogId specified" => "No se especificó blogId",
"Tiki RSS feed for weblogs" => "Tiki RSS feed para weblogs",
"Last posts to weblogs." => "Últimos posts en weblogs.",
"Permission denied you cannot access this gallery" => "No tiene permisos para acceder a esta galería o la galería no existe",
"No gallery indicated" => "No se indica la galería",
"Permission denied you can not view this section" => "Permiso denegado no puede ver esta sección",
"Permission denied you cannot remove images from this gallery" => "No tiene permiso para quitar imágenes de la galería",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Permiso denegado no puede reconstruir miniaturas en esta galería",
"Permission denied you cannot rotate images in this gallery" => "Permiso denegado no puede rotar imágenes en esta galería",
"No image indicated" => "No se indica imagen",
"Permission denied you cannot move images from this gallery" => "No tiene permisos para mover imágenes de esta galería",
"Permission denied you cannot view the calendar" => "Permiso denegado no puede ver el calendario",
"event without name" => "evento sin nombre",
"Access Denied" => "Acceso Denegado",
"Mo" => "Lu",
"Tu" => "Ma",
"We" => "Mi",
"Th" => "Ju",
"Fr" => "Vi",
"Su" => "Do",
"You can not use the same password again" => "No puede usar la misma contraseña otra vez",
"Top authors" => "Principales autores",
"Message sent to" => "Mensaje enviado a",
"You need to change chmod 'whelp' manually to 777" => "Debe cambiar chmod 'whelp' manualmente a 777",
"This feature has been disabled" => "Esta sección ha sido deshabilitada",
"Tiki RSS feed for directory sites" => "Tiki RSS feed para directorio de sitios",
"Last sites." => "Últimos sitios.",
"Must enter a name to add a site. " => "Debe ingresar un nombre para añadir un sitio. ",
"Must enter a url to add a site. " => "Debe ingresar una URL para añadir un sitio. ",
"URL already added to the directory. Duplicate site? " => "La URL ya había sido añadida al directorio. ¿Duplicar sitio? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "La URL no puede ser accedida URL incorrecta o sitio fuera de línea y no puede ser añadido al directorio. ",
"Must select a category. " => "Debe elegir una categoría. ",
"Must enter a name to add a site" => "Debe introducir un nombre para añadir un sitio",
"Must enter a url to add a site" => "Debe introducir una URL para añadir un sitio",
"URL already added to the directory. Duplicate site?" => "URL ya añadida al directorio. ¿Duplicar sitio?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "La URL no puede ser accedida: URL incorrecta o sitio fuera de línea y no puede añadirse al directorio",
"Must select a category" => "Debe elegir una categoría",
"No site indicated" => "No se indicó sitio",
"No parent specified" => "No se especificó superior",
"Article not found" => "Artículo no encontrado",
"Permission denied you cannot edit this article" => "No tiene permiso para editar el artículo",
"The language can't be changed as its set of translations has already this language" => "El lenguage no puede ser cambiado ya que su conjunto de traducciones ya tiene ese lenguaje",
"You do not have permissions to edit banners" => "No tiene permiso para editar banners",
"Banner not found" => "Banner no encontrado",
"You do not have permission to edit this banner" => "No tiene permiso para editar este banner",
"Permission denied you cannot create or edit blogs" => "No tiene permiso para crear o editar blogs",
"Permission denied you cannot edit this blog" => "No tiene permiso para editar este blog",
"You do not have permission to write the style sheet" => "No tiene permiso para escribir la hoja de estilo",
"Invalid request to edit an image" => "No puede editar esta imagen",
"Permission denied you cannot edit images" => "No puede editar imágenes",
"Permission denied you can edit images but not in this gallery" => "No puede editar imágenes de esta galería",
"Failed to edit the image" => "Error al editar imagen",
"Permission denied to use this feature" => "No tiene permiso para acceder a esta característica",
"Shortname must be 2 Characters" => "Nombre corto debe de ser de 2 caracteres",
"You must provide a longname" => "Debe dar un nombre largo",
"Language created" => "Lenguaje creado",
"No content id indicated" => "No se indica bloque de contenido a editar",
"No question indicated" => "No se indica pregunta",
"No quiz indicated" => "No se indica cuestionario",
"No structure indicated" => "No se indicó estructura",
"Invalid structure_id or page_ref_id" => "structure_id o page_ref_id no válidas",
"Permission denied you cannot send submissions" => "No tiene permiso para enviar colaboraciones",
"Permission denied you cannot edit submissions" => "No tiene permiso para editar colaboraciones",
"You have to create a topic first" => "Tiene que crear un tema primero",
"You do not have permission to do that" => "No tiene permisos",
"You do not have permission to read the template" => "No tiene permiso para leer la plantilla",
"No topic id specified" => "No se especificó id de tema",
"Invalid topic id specified" => "Id de tema especificado no válido",
"No object indicated" => "No se indicó objeto",
"No type indicated" => "No se indicó tipo",
"page imported" => "página importada",
"created from import" => "creada desde importación",
"Can't import remote HTML page" => "No puedo importar página HTML remota",
"The SandBox is disabled" => "El SandBox esta deshabilitado",
"Cannot edit page because it is locked" => "No se puede editar la página pues se encuentra bloqueada",
"No questions group indicated" => "No se indicó grupo de preguntas",
"Permission denied you cannot edit this file" => "Permiso denegado no puede editar este archivo",
"Permission denied you cannot remove files from this gallery" => "Permiso rechazado no puede eliminar archivos de esta galería",
"Top visited file galleries" => "Galerías más visitadas",
"Most downloaded files" => "Archivos más descargados",
"Last files" => "Últimos archivos",
"Tiki RSS feed for file galleries" => "Tiki RSS feed para galerías de archivos",
"Last files uploaded to the file galleries." => "Últimos archivos subidos a las galerías de archivos.",
"No galleryId specified" => "No se especificó galleryId",
"Tiki RSS feed for the file gallery: " => "Tiki RSS feed para la galería de archivos: ",
"No forum indicated" => "No se indica foro",
"Last forum topics" => "Últimos temas en foros",
"Top topics" => "Top temas",
"Forum posts" => "Mensajes de Foros",
"No forumId specified" => "No se especificó forumId",
"Tiki RSS feed for forum: " => "Tiki RSS feed para foro: ",
"Tiki RSS feed for forums" => "Tiki RSS feed para foros",
"Last topics in forums." => "Últimos temas en foros.",
"Accepted friendship request from %s" => "Aceptado pedido de amistad de %s",
"Refused friendship request from %s" => "Rehusado pedido de amistad de %s",
"Broke friendship with %s" => "Romper amistad con %s",
"I have broken our friendship!" => "¡He roto nuestra amistad!",
"You must be logged in to use this feature" => "Debe estar identificado para usar esta función",
"Friendship request sent to %s" => "Solicitud de Amistad enviada a %s",
"You're already friend of %s" => "Ya era amigo de %s",
"I have accepted your friendship request!" => "¡Acepté su pedido de amistad!",
"first uploaded image" => "primera imagen subida",
"last uploaded image" => "última imagen subida",
"first image" => "primera imagen",
"last image" => "última imagen",
"random image" => "imagen aletoria",
"Permission denied you cannot create galleries and so you cant edit them" => "Permiso rechazado, no puede crear galerías ni editar galerías",
"Permission denied you cannot edit this gallery" => "No tiene permiso para editar esta galería",
"Permission denied you cannot remove this gallery" => "No puede quitar esta galería",
"Permission denied you cannot make the map of this gallery" => "Permiso denegado no puede hacer el mapa para esta galería",
"Top images" => "Principales imágenes",
"Last images" => "Últimas imágenes",
"Tiki RSS feed for image galleries" => "Tiki RSS feed para galerías de imágenes",
"Last images uploaded to the image galleries." => "Últimas imágenes subidas a las galerías de imágenes.",
"Tiki RSS feed for the image gallery: " => "Tiki RSS feed para la galería de imágenes: ",
"overwriting old page" => "sobrescribiendo vieja página",
"updated from structured text import" => "actualizado desde importación de texto estructurado",
"page created" => "página creada",
"created from structured text import" => "creado desde importación de texto estructurado",
"No name indicated for wiki page" => "No se indicó nombre para la página wiki",
"No repository given" => "No se dió repositorio",
"Permission denied. You cannot view pages like this page" => "No tiene permiso para ver páginas similares a ésta",
"Permission denied you cannot remove articles" => "No tiene permiso para eliminar el artículo",
"Permission denied you cannot remove banners" => "Permiso denegado no puede eliminar banners",
"Permission denied you cannot remove this blog" => "No puede quitar este blog",
"Non-existent gallery" => "Galería inexistente",
"Permission denied you can upload files but not to this file gallery" => "No puede subir archivos a esta galería",
"Could not upload the file" => "No puedo subir el archivo",
"Could not find the file requested" => "No puedo encontrar el archivo pedido",
"File update was successful" => "Actualización de archivo exitosa",
"Permission denied you can't upload files so you can't edit them" => "Permiso denegado no puede subir archivos así que no puede editarlos",
"You cannot admin blogs" => "No tiene permiso para administrar blogs",
"Permission denied you cannot remove submissions" => "No tiene permiso para eliminar colaboraciones",
"Permission denied you cannot approve submissions" => "No tiene permisos para aprobar colaboraciones",
"You have to enable cookies to be able to login to this site" => "Tiene que activar cookies para poder loguearse en este sitio",
"Tiki mail-in auto-reply" => "Tiki mail-in auto-respuesta",
"Sorry, you can't use this feature." => "Lo siento, no puede usar esta característica.",
"You do not have permissions to view the maps" => "No tiene permiso para ver los mapas",
"Maps feature is not correctly setup : Maps path is missing." => "La función de Mapas no esta correctamente configurada: falta directorio para los mapas.",
"mapfile name incorrect" => "Nombre de mapa incorrecto",
"This mapfile already exists" => "Este mapa ya existe",
"You do not have permission to write to the mapfile" => "No tiene permiso para escribir en el mapa",
"You do not have permission to delete the mapfile" => "No tiene permiso para borrar el mapa",
"I could not make a copy" => "No puedo hacer una copia",
"You do not have permission to read the mapfile" => "No tiene permiso para leer el mapa",
"You dont have permission to do that" => "No tiene permiso para hacer eso",
"Tiki RSS feed for maps" => "Tiki RSS feed para mapas",
"List of maps available." => "Lista de mapas disponibles.",
"You do not have permissions to view the layers" => "No tiene permisos para ver las capas",
"You do not have permissions to delete a file" => "No tiene permiso para borrar archivos",
"File not found" => "Archivo no encontrado",
"You do not have permissions to create a directory" => "No tiene permiso para crear directorios",
"The Directory is not empty" => "El Directorio no está vacío",
"You do not have permissions to delete a directory" => "No tiene permisos para borrar directorios",
"You do not have permissions to create an index file" => "No tiene permisos para crear archivos de índice",
"Invalid file name" => "Nombre de archivo no válido",
"Invalid files to index" => "Archivos no válidos a indexar",
"I do not know where is gdaltindex. Set correctly the Map feature" => "No se donde se encuentra gdaltindex. Configure correctamente la función de Mapas",
"I could not create the index file" => "No puedo crear el archivo de índice",
"Must be logged to use this feature" => "Debe estar conectado para usar esa función",
"Welcome at Hawiki" => "Bienvenido a Hawiki",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Este sitio Tikiwiki está preparado para acceso desde una gran varidadad de dispositivos móviles, ej teléfonos WAP, PDAs, dispositivos i-mode, etc.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Puede navegar este sitio con su dispositivo móvil dirigiendo su navegador hacia la siguiente URL en este sitio:",
"About" => "Acerca de",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Debe correr setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuarios comunes de Apache son www-data, apache or nobody",
"Your PHP installation does not have zlib enabled." => "Su instalación de PHP no tiene zlib habilitado.",
"You must log in to use this feature" => "Debe estar conectado para usar esta característica",
"You do not have permission to view other users data" => "No tiene permiso para ver datos de otros usuarios",
"You must be logged in to subscribe to newsletters" => "Debe estar conectado para poder suscribirse a boletines",
"No note indicated" => "No se indicó nota",
"merged note:" => "nota combinada:",
"File is too big" => "Archivo demasiado grande",
"No item indicated" => "No se indicó item",
"created from notepad" => "creado desde el bloc de notas",
"Page already exists" => "Página ya existe",
"Not enough information to display this page" => "No hay información suficiente para mostrar esta página",
"Permission denied you cannot browse this page history" => "No tiene permiso para acceder al historial de la página",
"No article indicated" => "No se indica un artículo",
"Article is not published yet" => "El artículo no ha sido publicado",
"No post indicated" => "No indica post",
"Blog not found" => "No se encuentra el blog",
"No pages indicated" => "No se indican páginas",
"You don't have permission to edit quizzes." => "No tiene permiso para editar cuestionarios.",
"No result indicated" => "No se indica resultado",
"The passwords don't match" => "Las contraseñas no coinciden",
"Invalid or unknown username" => "Nombre de usuario no válido o desconocido",
"Unable to send mail. User has not configured email" => "No se puede enviar correo. El usuario no configuró su correo electrónico",
"to the registered email address for" => "a la dirección registrada de correo para",
"last version" => "última versión",
"Permission denied you cannot remove versions from this page" => "No puede eliminar versiones de esta página",
"Permission denied you cannot rename this page" => "Permiso denegado no puede renombrar esta página",
"Cannot rename page because the new name begins with reserved prefix" => "No puede renombrar página porque el nuevo nombre comienza con un prefijo reservado",
"Cannot rename page maybe new page already exists" => "No puedo renombrar página tal vez la nueva página ya existe",
"Non-existent version" => "Versión inexistente",
"Permission denied you cannot rollback this page" => "No tiene permiso para restablecer una versión anterior de la página",
"Error Message" => "Mensaje de Error",
"Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Mensaje de Error: \$errmsg",
"No newsletters available." => "No hay boletines disponibles.",
"successfully sent" => "exitosamente enviada",
"not sent" => "no enviado",
"Page must be defined inside a structure to use this feature" => "La página debe estar definida dentro de una estructura para usar esa función",
"You cannot take this quiz twice" => "No puede rellenar el cuestionario dos veces",
"Quiz time limit exceeded quiz cannot be computed" => "Se excedió el tiempo límite",
"You cannot take this survey twice" => "No puede volver a responder la encuesta",
"Please create a category first" => "Por favor cree una categoría primero",
"Tracker item:" => "Ítem de Tracker:",
"empty" => "vacío",
"No trackerId specified" => "No se especificó trackerId",
"No permission to upload zipped file packages" => "No tiene permiso para subir paquetes de archivos zipeados",
"Error processing zipped image package" => "Error procesando paquete de imágenes zipeado",
"No permission to upload zipped image packages" => "Sin permiso para subir paquete de imágenes zipeado",
"The uploaded file ist not recognized as a image" => "El archivo subido no es reconocido como una imagen",
"Permission denied you cannot upload images" => "No tiene permisos para subir imágenes",
"Permission denied you can upload images but not to this gallery" => "Tiene permisos para subir imágenes pero no a esta galería",
"Cannot get image from URL" => "No se pudo leer imagen a partir de la URL",
"That is not an image (or you have php < 4.0.5)" => "Esta no es una imagen (o tiene php < 4.0.5)",
"Usage" => "Uso",
"No url indicated" => "No se indica url",
"Unknown user" => "Usuario desconocido",
"You are not logged in and no user indicated" => "No esta conectado y no hay usuario indicado",
"The user has chosen to make his information private" => "El usuario eligió hacer su información privada",
"Email is set to %s" => "Correo esta configurado a %s",
"The passwords did not match" => "Las contraseñas no coinciden",
"was moved into trash" => "fue movido a la papelera",
"trashed by" => "borrado por",
"open / in process" => "abierta / en proceso",
"Public for group" => "Publica para grupo",
"Rights by creator" => "Derechos por creador",
"END" => "FIN",
"Percentage" => "Porcentaje",
"Task accepted by creator" => "Tarea aceptada por creador",
"Task accepted by task user" => "Tarea aceptada por usuario de tarea",
"Task NOT accepted by creator" => "Tarea NO aceptada por creador",
"Task NOT accepted by task user" => "Tarea NO aceptada por usuario de tarea",
"Sorry this task does not exist or you have no rights to view this task" => "Lo siento esta tarea no existe o usted no tiene derecho a ver esa tarea",
"Task entries:" => "Entradas de tareas:",
"Changes:" => "Cambios:",
"Info message" => "Mensaje de Info message",
"NEW Task" => "NUEVA Tarea",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Lo siento usted no tiene permitido enviar tareas a otros usuarios, ¡o el usuario no tiene permitido recibirlas!",
"Changes on Task" => "Cambios en Tareas",
"You received a new task" => "Usted recibió una nueva tarea",
"The priority is" => "La prioridad es",
"very low" => "muy baja",
"low" => "baja",
"high" => "alta",
"very high" => "muy alta",
"You've to start your work at least on" => "Usted debe empezar su trabajo al menos en",
"You've to finish your work on" => "Debe terminar su trabajo en",
"Login and click the link below" => "Identifíquese y cliquee el enlace siguiente",
"Please read the task and work on it!" => "¡Por favor lea la tarea y trabaje en ella!",
"Sorry, there was an error while trying to write data into the database" => "Lo siento, hubo un error intentando escribir datos en la base de datos",
"Cannot upload this file not enough quota" => "No puede subir este archivo, cuota insuficiente",
"No user indicated" => "No se indica usuario",
"Non-existent user" => "Usuario inexistente",
"No banner indicated" => "No se indica un banner",
"No blog indicated" => "No se indica un blog",
"Permission denied you cannot remove the post" => "No tiene permiso para eliminar este post",
"No cache information available" => "No hay información en el caché disponible",
"No faq indicated" => "No se indica faq",
"You are not permitted to remove someone else\\'s post!" => "¡No tiene permitido borrar el post de otro usuario!",
"No thread indicated" => "No se indica mensaje",
"A SheetId is required." => "Es requerido un SheetId.",
"That tracker don't use extras." => "Este tracker no usa extras.",
"Aborted" => "Abortado",
"Top pages" => "Principales páginas",
"Last pages" => "Últimas páginas",
"Tiki RSS feed for the wiki pages" => "Tiki RSS feed para las páginas wiki",
"Last modifications to the Wiki." => "Últimas modificaciones para el Wiki.",
"###end###"=>"###end###");
