<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"categorize" => "categorizar",
"Set prefs" => "Definir preferências",
"creation date" => "data de criação",
"last modification time" => "data da última modificação",
"Articles listing configuration" => "Configuração da listagem de artigos",
"PHPOpenTracker" => "PHPOpenTracker",
"Set home forum" => "Definir o fórum inicial",
"enable/disable" => "activar/desactivar",
"Max number of items" => "Número máximo de itens",
"Set feeds" => "Definir fontes",
"Create TAR dump" => "Criar exportação TAR",
"Create HTML dump" => "Criar exportação HTML",
"Download last TAR dump" => "Descarregar a última exportação TAR",
"Access HTML dump" => "Aceder à exportação HTML",
"Wiki Page Names" => "Nomes de páginas Wiki",
"strict" => "restrito",
"Cache wiki pages" => "Fazer cache das páginas Wiki",
"\n for rows" => "\n para linhas",
"Enable watch by default for author" => "Activar \"monitorização\" para o autor",
"Enable watches when I am the editor" => "Activar \"monitorização\" quando eu for o editor",
"assign_perms" => "atribuir permissões",
"assign group" => "atribuir grupo",
"view info" => "ver informações",
"Users can vote only one item from this chart per period" => "Os utilizadores só podem votar num item deste gráfico por período",
"Prevent users from voting same item more than one time" => "Evitar que os utilizadores votem mais do que uma vez no mesmo item",
"half a second" => "meio segundo",
"Forward messages to this forum to this email" => "Reencaminhar as mensagens destinadas a este fórum para o seguinte e-mail",
"Admin HTML page dynamic zones" => "Administrar zonas dinâmicas da página HTML",
"use dynamic content" => "utilizar conteúdo dinâmico",
"Users can subscribe any email addresss" => "Utilizadores podem subscrever qualquer endereço de email",
"create new empty structure" => "Criar uma estrutura nova vazia",
"Create structure from tree" => "Criar estrutura a partir de árvore",
"Options (separated by commas used in dropdowns only)" => "Opções (separadas por vírgula, apenas em caixas de selecção)",
"Click here to create a new backup" => "Clique aqui para criar uma nova cópia de segurança",
"Note: if you want to use images please save the post first and you will be able to edit/post images. Use the <img> snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor" => "Nota: se  deseja usar imagens, por favor guarde a mensagem antes e poderá editar/submeter imagens. Use o código <img> para incluir imagens carregadas na caixa de texto ou use o endereço da imagem para incluir imagens usando o editor WYSIWYG",
"Click to enlarge" => "Clique para aumentar",
"Navigation Panel" => "Painel de Navegação",
"Hide Panels" => "Esconder Painéis",
"hide from display" => "esconder",
"Tiki Calendars" => "Calendários Tiki",
"browse by" => "navegar por",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "Se alterar a selecção de calendário, por favor actualize a página para obter a lista apropriada nas categorias, Locais e Pessoas (se aplicável para o calendário seleccionado).",
"from the list" => "da lista",
"choose" => "escolher",
"with role" => "com perfil",
"You should first ask that a calendar is created, so you can create events attached to it." => "Deve criar um calendário para poder criar eventos anexados ao mesmo.",
"Use (:name:) for smileys" => "Utilize (:nome:) para smileys",
"Type help to get list of available commands" => "Digite help para obter uma lista de comandos disponíveis",
"Publish/Event Date" => "Publicação/Data de Evento",
"Displays preformated text/code; no Wiki processing is done inside these sections" => "Mostra texto/código-fonte pré-formatado; nenhum processamento wiki é realizado dentro destas secções",
"wiki link" => "link Wiki",
"heading" => "cabeçalho",
"horizontal ruler" => "linha horizontal",
"center" => "centralizar",
"img nc" => "img nc",
"In parent page" => "Na página-pai",
"Newss from" => "News de",
"Assign permissions to this page" => "Atribuir permissões para esta página",
"You can include the image in an HTML/Tiki page using" => "Pode incluir a imagem numa página HTML/Tiki usando",
"Tiki forums" => "Fóruns do Tiki",
"Show Post Form" => "Mostrar Formulário de Envio",
"Hide Post Form" => "Esconder Formulário de Envio",
"smileys" => "smileys",
"mot" => "mot",
"Mark as Flagged" => "Marcar como Seleccionada",
"Wiki Import dump" => "Importar arq. exp. Wiki",
"Top Files" => "Ficheiros mais populares",
"xx" => "xx",
"xxx" => "xxx",
"No such forum" => "Fórum inexistente",
"No image uploaded" => "Nenhuma imagem carregada",
"Permission denied you cannot browse this gallery" => "Permissão negada: não pode visualizar esta galeria",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "Endereço não pode ser acedido e adicionado ao directório: URL incorrecta ou site off-line",
"Anonymous users cannot edit pages" => "Utilizadores anónimos não podem editar páginas",
"Invalid password. You current password is required to change your email address." => "Palavra-passe inválida. A sua Palavra-passe actual é necessária para alterar seu endereço de email.",
"Current page:" => "Página actual:",
"version %s" => "versão %s",
"last modified on %s" => "última modificação em %s",
"by %s" => "por %s",
"Archived page:" => "Página arquivada:",
"Diff of %s." => "Diferenças de %s.",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Exibe um trecho de código-fonte.\nDefina o parâmetro opcional -+ln+- com o valor 1 se desejar numeração de linhas.",
"Split a page into columns" => "Dividir a página em colunas",
"column" => "coluna",
"Renders a graph" => "Desenha um gráfico",
"There is an error in the plugin data" => "Há um erro nos dados do plug-in",
"note: those parameters are exclusive" => "nota: estes parâmetros são exclusivos",
"Insert articles into a wikipage" => "Inserir artigos numa página wiki",
"the number of hops the graph follows\n" => "o número de degraus no gráfico seguem\n",
"the title of the map\n" => "o título do mapa\n",
"the space beetween nodes\n" => "o espaço entre nós\n",
"Left to Right, the direction of graph\n" => "Esquerda para a Direita, a direcção do gráfico\n",
"the background color, use #rrvvbb color types.\n" => "a cor de fundo, use tipos de cor #rrvvaa.\n",
"nothing there, unlimited size. use 5,3 type sizes in inches\n" => "nada lá, tamanho ilimitado. usar tipos de tamanhos 5,3 em polegadas\n",
"the font size in pts presumably\n" => "o tamanho da fonte presumido em pontos\n",
"the name of the font used for labels\n" => "o nome da fonte usada para rótulos\n",
"the shape of a node. can be " => "a forma de um nó pode ser ",
"plaintext ellipse circle egg triangle box diamond trapezium parallelogram house hexagon octagon\n" => "texto elipse circular ovo triângulo caixa diamante trapézio paralelogramo casa hexagonal octogonal\n",
"style for drawing nodes.\n" => "estilo para desenhar nós.\n",
"color of the border\n" => "cor do limite\n",
"background color of the node\n" => "cor de fundo do nó\n",
"same mystery as above\n" => "mesmo mistério como acima\n",
"color for links (called edges here)\n" => "cor para hiperligações (chamados limites aqui)\n",
"shape of the arrow that come with the link\n" => "forma da seta que vem com a hiperligação\n",
"Quiz time limit excedeed quiz cannot be computed" => "Tempo do teste excedeu o limite e não pode ser calculado",
"Security check failed!" => "Verificação de segurança falhou!",
"Unexistant link" => "Hiperligação inexistente",
"Unexistant gallery" => "Galeria inexistente",
"Unexistant version" => "Versão inexistente",
"Unexistant user" => "Utilizador inexistente",
"You are not permitted to edit someone else\\'s post!" => "Não tem permissão para editar as publicações de outros!",
"Only an admin can remove a thread." => "Somente um administrador pode remover uma sequência.",
"Invalid password.  You current password is required to change your email address." => "Palavra-passe inválida.  A sua palavra-passe actual é necessária para alterar seu endereço de e-mail.",
"The user has choosen to make his information private" => "O utilizador escolheu manter suas informações privadas",
"Are you sure you want to delete this directory?" => "Tem certeza que deseja remover este directório?",
"Are you sure you want to delete this file?" => "Tem certeza que deseja remover este ficheiro?",
"file galleries tpl" => "galerias de ficheiros TPL",
"You can view the page following this link:" => "Pode ver a página com a seguinte hiperligação:",
"Are you sure you want to delete this repository?" => "Tem certeza que deseja eliminar este repositório?",
"Click here to delete this repository" => "Clique aqui para eliminar este repositório",
"admin forums tpl" => "admin fórums tpl",
"Are you sure you want to delete this forum?" => "Tem certeza que deseja eliminar este fórum?",
"tiki admin quicktags tpl" => "admin tiki quicktags tpl",
"Reduce area width" => "Reduzir a largura de área",
"Enlarge area width" => "Ampliar a largura de área",
"Delete item from category?" => "Remover item da categoria?",
"Are you sure you want to delete this category?" => "Tem certeza que deseja eliminar esta categoria?",
"Are you sure you want to delete this tracker?" => "Tem certeza que deseja remover este tracker?",
"Click here to delete this tracker" => "Clique aqui para remover este tracker",
"admin newsletters tpl" => "admin Circulares tpl",
"compose message tpl" => "compor messagem tpl",
"admin RSSmodules tpl" => "admin RSSmodules tpl",
"Webmail Doc tpl" => "Webmail Doc tpl",
"Are you sure you want to delete this contact?" => "Tem certeza que deseja eliminar este contacto?",
"Click here to delete this contact" => "Clique aqui para remover este contacto",
"Are you sure you want to delete this attachment?" => "Você tem certeza que deseja remover este anexo?",
"Click here to delete this attachment" => "Clique aqui para eliminar este anexo",
"admin notifications tpl" => "admin notificações TPL",
"Click here to unassign this module" => "Clique aqui para remover este módulo",
"Click here to edit this menu" => "Clique aqui para editar este menu",
"Click here to edit this comment" => "Clique aqui para editar este comentário",
"Are you sure you want to delete this comment?" => "Você tem certeza que deseja remover este comentário?",
"Click here to delete this comment" => "Clique aqui para remover este comentário",
"Are you sure you want to delete this rule?" => "Você tem certeza que deseja remover esta regra?",
"Click here to delete this rule" => "Clique aqui para remover esta regra",
"For more information, please see <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>." => "Para maiores informações, por favor veja <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\nno <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>.",
"(Dropdown options : list of items separated with commas)" => "(Opções de dropdown : lista de itens separada por vírgulas)",
"(Image options : xSize,ySize indicated in pixels)" => "(Opções de imagens : xTamanho,yTamanho indicados em pixels)",
"Are you sure you want to delete this drawing?" => "Você tem certeza que deseja remover este desenho?",
"Click here to delete this drawing" => "Clique aqui para remover este desenho",
"Are you sure you want to delete this HTML page?" => "Você tem certeza que deseja remover esta página HTML?",
"Are you sure you want to delete this copyright?" => "Você tem certeza que deseja remover este copyright?",
"Click here to delete this copyright" => "Clique aqui para remover este copyright",
"Are you sure you want to delete this template?" => "Você tem certeza que deseja remover este modelo?",
"Click here to delete this template" => "Clique aqui para remover este modelo",
"Are you sure you want to delete this menu?" => "Você tem certeza que deseja remover este menu?",
"Click here to delete this menu" => "Clique aqui para remover este menu",
"Are you sure you want to delete this group?" => "Você tem certeza que deseja remover este grupo?",
"Are you sure you want to delete this external wiki?" => "Você tem certeza que deseja remover este wiki externo?",
"Thankyou for installing Tikiwiki" => "Obrigado por instalar o Tikiwiki",
"Click here to configure this menu" => "Clique aqui para configurar este menu",
"Are you sure you want to delete this dsn?" => "Você tem certeza que deseja remover este DSN?",
"Are you sure you want to delete this cookie?" => "Você tem certeza que deseja remover este cookie?",
"Click here to delete this cookie" => "Clique aqui para remover este cookie",
"Events Panel" => "Painel de Eventos",
"MyTikiDoc" => "MeuTikiDoc",
"Klick to enlarge" => "Clique para ampliar",
"Reply to parent comment" => "Responder ao comentário pai",
"Are you sure you want to delete this hotword?" => "Você tem certeza que deseja remover esta palavra-chave?",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "A Sandbox é a página onde você pode praticar suas edições. Use a funcionalidade de pré-visualização para ver a aparência da página editada. Nenhuma versão da página é armazenada.",
"Go \r\n                    back" => "Ir \r\n                    voltar",
"Return to home \r\n                    page" => "Retornar para início \r\n                    página",
"Confirmation required" => "Confirmação requerida",
"Are you sure you want to delete this channel?" => "Você tem certeza que deseja remover este canal?",
"Click here to delete this channel" => "Clique aqui para remover este canal",
"LDAP Group Atribute" => "Atributo de Grupo LDAP",
"Email Encoding" => "Codificação do E-mail",
"Are you sure you want to delete this calendar?" => "Você tem certeza que deseja remover este calendário?",
"admin polls tpl" => "admin sondagens TPL",
"The cord" => "The cord",
"Comm" => "Comm",
"Cms" => "Cms",
"Ranking" => "Ranking",
"AdminDSN" => "AdminDSN",
"-1m" => "-1m",
"-7d" => "-7d",
"-1d" => "-1d",
"+1d" => "+1d",
"+7d" => "+7d",
"+1m" => "+1m",
"ChatAdmin" => "ChatAdmin",
"op" => "op",
"ver" => "ver",
"Wiki page" => "Página Wiki",
"New message arrived from " => "Nova mensagem de ",
"Welcome to " => "Bem-vindo(a) a ",
" at " => " em ",
"Bye bye from " => "Saudações de ",
"New article submitted at " => "Novo artigo enviado em ",
"Upload was not successful (maybe a duplicate file)" => "Upload interrompido com falha (possivelmente o ficheiro está duplicado)",
"Your Tiki account information for" => "Informações da sua conta Tiki para",
"A new password has been sent " => "Uma nova palavra-passe foi enviada ",
"pageviews" => "visitas",
" new topic:" => " novo tópico:",
"topic:" => "tópico:",
"forum topic" => "tópico do fórum",
"updated by the phpwiki import process" => "actualizada pelo processo de importação do phpwiki",
"created from phpwiki import" => "criada pela importação phpwiki",
"You can edit the page following this link:" => "Você pode editar a página seguindo este link:",
"Diff:" => "Difer:",
"The new page content is:" => "O conteúdo da nova página é:",
"someone from" => "alguém de",
"Threads can be voted" => "Sequências podem ser votadas",
"Directory (include trailing slash)" => "Directório (incluir barra invertida final)",
"checked" => "marcado",
"unchecked" => "desmarcado",
"You can include the image in an HTML or Tiki page using" => "Você pode incluir a imagem em uma página HTML ou Tiki usando",
"Show status when listing tracker items?" => "Exibir estado na lista de itens de acompanhamento?",
"remove bookmark" => "remover bookmark",
"Control by Object" => "Controlar por objecto",
"use square brackets for an" => "utilize parêntesis rectos para um",
"link_description" => "descricão_do_link",
"Prevents parsing data" => "Evita a interpretação de dados",
"File gals" => "Gal. Ficheiros",
"Image gals" => "Gal. Imagens",
"ExtWikis" => "WikisExternos",
"assgn" => "definir",
"CMS settings" => "Configuração de CMS",
"admin HtmlPages" => "administrar HtmlPages",
"Warn on edit" => "Avisar na edição",
"In blog listing show user as" => "Na listagem de Blog mostrar o utilizador como",
"All tasks" => "Todas as tarefas",
"mark as done" => "marcar como realizada",
"open tasks" => "tarefas em aberto",
"Add or edit a task" => "Adicionar ou editar uma tarefa",
"Add New Group" => "Adicionar Novo Grupo",
"Edit this group:" => "Editar este grupo:",
"admin ExternalWiki" => "administrar WikiExterno",
"Return to messages" => "Retornar para mensagens",
"Unflagg" => "Desmarcar",
"MyTiki (click!)" => "MeuTiki (clique!)",
"Admin (click!)" => "Administração (clique!)",
"More info about" => "Mais informação sobre",
"idle" => "ocioso",
"act status" => "estado da activ",
"running" => "em execução",
"Calendars Panel" => "Painel de Calendários",
"today" => "hoje",
"parent" => "pai",
"Posted comments" => "Comentários enviados",
"reply to this" => "responder",
"use filename" => "utilizar o nome do ficheiro",
"Add scaled images size X x Y" => "Adicionar imagens em escala X por Y",
"Control by category" => "Controlar por categoria",
"Show chart for the last " => "Mostrar o gráfico para os últimos ",
"days (0=all)" => "dias (0=todos)",
"Time Zone" => "Fuso horário",
"Server time zone" => "Fuso horário do servidor",
"Time Zone Map" => "Mapa de fuso horário",
"Admin structures" => "Admin estruturas",
"this post was reported" => "esta mensagem foi assinalada",
"report this post" => "assinalar esta publicação",
"Import pages from a PHPWiki Dump" => "Importar páginas de uma exportação PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Caminho para os ficheiros de dados (relativo ao directório-base Tiki, com barra terminadora; ex: dump/)",
"Use dbl click to edit pages" => "Usar duplo clique para editar páginas",
"Change your email" => "Alterar o seu email",
"change email" => "alterar endereço",
"Configure this page" => "Configurar esta página",
"FAQ Questions" => "Perguntas do FAQ",
"FAQ Answers" => "Respostas do FAQ",
"Show suggested questions/suggest a question" => "Exibir perguntas sugeridas/sugerir uma pergunta",
"Hide suggested questions" => "Esconder perguntas sugeridas",
"Send Objects" => "Enviar Objectos",
"save a custom copy" => "salvar uma cópia personalizada",
"Add all your site users to this newsletter (broadcast)" => "Adicionar todos utilizadores do seu site a esta circular",
"Add users" => "Adicionar utilizadores",
"Reuse question" => "Reutilizar a pergunta",
"WebMail accounts" => "Contas de WebMail",
"Create New Survey:" => "Criar uma Nova Consulta:",
"stat" => "estatísticas",
"Publisher" => "Publisher",
"perm" => "perm",
"You do not have permission to use this feature." => "Você não possui permissão para usar esta funcionalidade.",
"no description" => "sem descrição",
"requested a reminder of the password for the" => "requisitar um lembrete da palavra-passe para a",
"since this is your registered email address we inform that the" => "uma vez que este é o seu endereço de email registrado informamos que a",
"password for this account is" => "palavra-passe para esta conta é",
"Information:" => "Informações:",
"New blog post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova mensagem de blog: {\$mail_title} por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at\n{\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi alterada por {\$mail_user} em\n{\$mail_date|tiki_short_datetime}",
"You can view the page by following this link:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}" => "Pode ver a página com a seguinte hiperligação:\n    {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}",
"You can edit the page by following this link:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}" => "Pode editar a página com a seguinte hiperligação:\n    {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}",
"You can view a diff back to the previous version by following\nthis link:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}" => "Pode ver as diferenças de uma versão anterior com a seguinte hiperligação\n:\n    {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}",
"Click the :: option on the menu for more options." => "Clique na opção :: no menu para mais opções.",
"Please also see" => "Por favor, veja também",
"Admin->Modules" => "Admin->Módulos",
"Please" => "Por favor",
"log in" => "registe-se",
"to access full functionalities" => "para aceder a todas as funcionalidades",
"Blog settings" => "Configurações do Blog",
"FAQs settings" => "Configurações de FAQs",
"FAQ comments" => "Comentários de FAQ",
"Create a group for each user <br />(with the same\nname as the user)" => "Criar um grupo para cada utilizador <br />(com o mesmo \nnome do utilizador)",
"Remind passwords by email" => "Lembrar palavras-passe por e-mail",
"Poll settings" => "Configurações de Votação",
"Append CSS file to feed urls" => "Adicionar ficheiro CSS para o campo de URLs",
"Create a tag for the current wiki" => "Criar uma tag para o Wiki actual",
"Restore the wiki" => "Restaurar o Wiki",
"Wiki comments settings" => "Configurações de comentários Wiki",
"Wiki page list configuration" => "Configuração de lista de páginas Wiki",
"Like pages" => "Páginas similares",
"List Calendars" => "Listar Calendários",
"admin Drawings" => "administrar Desenhos",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Utilize {literal}{{/literal}ed id=nome} ou literal}{{/literal}ted id=nome} para inserir zonas dinâmicas",
"search category" => "procurar categoria",
"deep" => "profundo",
"Add Calendar Item" => "Adicionar Item ao Calendário",
"Textheight" => "Altura do texto",
"Height of top Heading" => "Altura do cabeçalho superior",
"Height of mid Heading" => "Altura do cabeçalho intermediário",
"Height of inner Heading" => "Altura do cabeçalho interno",
"tbheight" => "tbaltura",
"Automatic Page Breaks" => "Quebra de Páginas Automática",
"Emphasis" => "Ênfase",
"italics" => "itálico",
"both" => "ambos",
"use ...page... to separate pages" => "utilize ...página... para separar páginas",
"make_headings" => "criar_cabecalhos",
"underlines text" => "sublinhar texto",
"Simple box" => "Caixa simples",
"Will display using the indicated HTML color" => "Será exibido com a cor HTML indicada",
"Will display the text centered" => "Exibirá o texto centralizado",
"Edit Submissions" => "Editar Submissões",
"Activs" => "actividades",
"Ins" => "Inst",
"time" => "hora",
"Wiki quick help" => "Ajuda rápida Wiki",
"Quicklinks" => "Links Rápidos",
"Comparing versions" => "Comparando versões",
"Actual_version" => "Versão_real",
"Diff to version" => "Diferença para a versão",
"admin DynamicContent" => "administrar DynamicContent",
"Editing tracker item" => "Editando item de acompanhamento",
"The passwords dont match" => "As palavras-passe não coincidem",
"You do not have permission to write the template" => "Permissão negada: você não pode guardar o modelo",
"You have to type a searchword" => "Deve digitar uma palavra de procura",
"You have to provide a name to the image" => "Você deve fornecer um nome para a imagem",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"admin Webmail" => "admin Webmail",
"uploaded by" => "carregado por",
"not specified" => "não especificado",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d de %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d de %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d de %b, %Y[%H:%M %Z]",
"stop monitoring this blog" => "não monitorizar mais este blog",
"delete selected" => "apagar seleccionados",
"new reply" => "nova resposta",
"stop monitoring this map" => "parar de monitorizar este mapa",
"register" => "registar-se",
"standard" => "padrão",
"secure" => "seguro",
"stay in ssl mode" => "permanecer no modo seguro",
"cached" => "em cache",
"last changes" => "últimas alterações",
"list pages" => "listar páginas",
"back to homepage" => "voltar à página inicial",
"No attachments for this page" => "Nenhum anexo para esta página",
"Skip to navigation" => "Pular para a navegação",
"HomePage" => "Página Inicial",
"images" => "imagens",
"Server name (for absolute URIs)" => "Nome do servidor (para URIs absolutas)",
"Wiki_Tiki_Title" => "Título_Wiki_Tiki",
"Validate email address (may not work)" => "Validar endereço de e-mail (pode não funcionar)",
"Require HTTP Basic authentication" => "Exigir autenticação básica HTTP",
"HTTP server name" => "Nome do servidor HTTP",
"HTTP URL prefix" => "Prefixo de URL HTTP",
"HTTPS server name" => "Nome do servidor HTTPS",
"HTTPS URL prefix" => "Prefixo de URL HTTPS",
"Only for users" => "Apenas para utilizadores",
"Users and admins" => "Utilizadores e administradores",
"Full Text Search" => "Procura completa (todo o texto)",
"full" => "completo",
"Enable Feature" => "Habilitar Funcionalidade",
"admin content templates" => "administrar padrões de conteúdo",
"admin FortuneCookie" => "administrar FortuneCookie",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Nota 1</b>: Se você permitir aos utilizadores configurar módulos, os módulos configurados não serão\nactualizados na tela até que você os configure\nem MeuTiki->módulos.<br />\n<b>Nota 2</b>: Se você atribuir módulos a grupos certifique-se de ter desligado\na opção 'Módulos acessíveis por todos grupos'\nem Admin->Geral.\n",
"use dynamic  content" => "usar conteúdo dinâmico",
"edit this survey" => "editar esta pesquisa",
"admin surveys" => "administrar pesquisas",
"admin groups" => "administrar grupos",
"Assign user" => "Atribuir utilizador",
"admin backups" => "administrar backups",
"permission" => "permissão",
"remove page" => "remover página",
"browse" => "explorar",
"related" => "relacionados",
"add a site" => "adicionar um site",
"create zone" => "criar zona",
"save the banner" => "salvar o banner",
"create page" => "criar página",
"admin processes" => "administrar processos",
"admin activities" => "administrar actividades",
"admin roles" => "administrar perfis",
"edit this process" => "editar este processo",
"edit repository" => "editar repositório",
"admin cache" => "administrar cache",
"browse gallery" => "explorar galeria",
"Flash binary (.sqf or .dcr)" => "Ficheiro Flash (.sqf ou .dcr)",
"wiki create" => "criar wiki",
"wiki overwrite" => "sobrescrever wiki",
"Assign permissions to page" => "Definir permissões para a página",
"Current permissions for this page" => "Permissões actuais para esta página",
"remove from this page" => "remover desta página",
"remove from this structure" => "remover desta estrutura",
"this page" => "esta página",
"Send email notifications when this page changes to" => "Enviar notificações por email sobre alterações nesta página para",
"add email" => "adicionar endereço de email",
"Notifications" => "Notificações",
"galleries" => "galerias",
"blog posts" => "mensagens de blogs",
"send answers" => "enviar as respostas",
"view faq" => "ver faq",
"DATE-of" => "de",
"You cannot edit this page because it is a user personal page" => "Você não pode editar esta página porque ela é a página pessoal de alguém",
"Permission denied you cannot assign permissions for this page" => "Permissão negada: você não pode definir permissões para esta página",
"You do not have permission to edit messages" => "Você não possui permissão para editar mensagens",
"Cannot read file" => "Impossível ler do ficheiro",
"Permission denied you cannot upload files" => "Permissão negada: você não pode carregar ficheiros",
"cannot process upload" => "impossível processar upload",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Seu endereço de email foi removido da lista de monitoramento deste acompanhamento",
"Your email address has been added to the list of addresses monitoring this tracker" => "Seu endereço de email foi adicionado à lista de monitoramento deste acompanhamento",
"Cancel monitoring" => "Não monitorizar mais",
"Your email address has been removed from the list of addresses monitoring this item" => "Seu endereço de email foi removido da lista de monitoramento deste tem",
"Your email address has been added to the list of addresses monitoring this item" => "Seu endereço de email foi adicionado à lista de monitoramento deste tem",
"Thank you for you registration. You may log in now." => "Obrigado por registar-se. Você pode ser logar a partir de agora.",
"please read" => "por favor, leia",
"Click here for more details." => "Clique aqui para mais detalhes.",
"Print Wiki Pages" => "Imprimir Páginas Wiki",
"You can include the file in an HTML/Tiki page using" => "Você pode incluir este ficheiro em uma página HTML/Tiki usando",
"field is not numeric" => "campo não é numérico",
"select all" => "Seleccionar todos",
"browse category" => "procurar na categoria",
"with checked" => "com selecção",
"Assign:" => "Atribuir:",
"older version" => "versão mais antiga",
"Language :" => "Idioma :",
"Admin->Features" => "Administrar->Funcionalidades",
"Don't forget: to use feature you will need to enable it on" => "Não se esqueça: para utilizar determinada funcionalidade, é necessário activá-la em ",
"This text can be used as a variable" => "Este texto poderá ser utilizado como uma variável",
"Custom Code" => "Código Personalizado",
"Site breadcrumbs" => "<i>Migalhas</i> do site",
"Prefix breadcrumbs with 'Location:' label?" => "Prefixar migalhas com 'Localização:' etiqueta?",
"Site Search" => "Pesquisa do Site",
"Site search bar" => "Barra de Pesquisa do Site",
"Site logo" => "Logótipo do site",
"Site logo source" => "Nome do ficheiro",
"Site ads and banners" => "Anúncios e banners",
"Site Menu" => "Menu do Site",
"Note: This feature also requires phplayers to be turned on in Admin->Features" => "Nota: Esta funcionalidade requer a activação do phplayers, em Admin->Funcionalidades",
"participants" => "participantes",
"subscription" => "subscrição",
"perso" => "pessoal",
"To use menus in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu. To use <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "Para usar menus num <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">módulo</a>, <a class=\"rbox-link\" href=\"tiki-admin.php?page=siteid\">Identidade do Site</a> ou template, use {literal}{menu id=x}{/literal}, onde x deverá ser o ID do menu. Para usar o <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, poderá utilizar uma das três seguintes sintaxes:",
"send newsletter" => "enviar newsletter",
"archives" => "arquivo",
"edit account settings" => "Edit definições de conta",
"remove users and their userpages" => "remover utilizadores e respectivas páginas",
"manage group assignments" => "gerir competências de grupo",
"set default groups" => "definir grupos por omissão",
"assign to groups" => "atribuir a grupos",
"advanced feature" => "funcionalidade avançada",
"show" => "mostrar",
"hide" => "esconder",
"list galleries" => "listar galerias",
"monitor this gallery" => "monitorizar esta galeria",
"stop monitoring this gallery" => "parar de monitorizar esta galeria",
"add item" => "adicionar item",
"change focus" => "alterar foco",
"quarter" => "trimestre",
"semester" => "semestre",
"calendar view" => "Ver como calendário",
"list view" => "ver como lista",
"save_to" => "guardar_para",
"Your time" => "O seu tempo",
"HTML editor help" => "Ajuda de HTML",
"n" => "n",
"To display the objects you created or contributed to to:" => "Para mostrar os objectos em que participa:",
"Mandatory category in the category tree" => "Categoria mandatória, na árvore de categorias",
"Reinforce categories" => "Impor categorias",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/tiki-index.php?page=Features'>evaluation of each feature</a> on Tiki's developer site." => "Por favor leia uma <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/tiki-index.php?page=Features'>avaliação de cada funcionalidade</a> no site de desenvolvimento do Tiki",
"tikiwiki.org help" => "Ajuda tikiwiki.org",
"Site Logo and Identity" => "Logo e Personalização do Site",
"Propose a Fullscreen mode" => "Propôr modo fullscreen",
"Lightbox" => "Lightbox",
"Lightbox (Javascript modern visual effects on images)" => "Lightbox (Efeitos visuais modernos nas imagens com Javascript",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Utilizar plugin Quote no lugar de citações com &ldquo;>&rdquo;",
"Force galleries image size per default" => "Impôr tamanho por omissão nas imagens de galerias",
"Size of all thumbnails" => "Tamanho das miniaturas",
"Tikiwiki release" => "Versão do Tikiwiki",
"Best Language" => "Detectar o idioma mais apropriado",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Esta página permite configurar os feeds RSS gerados/exportados pelo Tiki. Para ler/importar fontes RSS, procure a opção \"módulos RSS\" no menu de aplicação, ou",
"Feed for directories" => "Fonte para directorias",
"Feed for individual tracker items" => "Fonte para itens individuais do tracker",
"Feed for tracker items" => "Fonte para itens do tracker",
"Feed for upcoming calendar events" => "Fonte para futuros eventos do calendário",
"Caching time :" => "Duração da cache :",
"Only enable caching if all syndicated content is public (visible to everyone) or private documents might leak out. Cache ignores existing permissions." => "Habilite caching se todo o conteúdo publicado for publico (visível para todos) ou correrá o risco de publicar conteúdos privados. A cache desconhece o sistema de permissões.",
"Parsed the result (can be slow)" => "Remover formatações do resultado (pode tornar-se lento)",
"Don't forget: to use the feature you will need to enable it on" => "Não esquecer: para usar a funcionalidade, terá que activá-la",
"Please also see:" => "Por favor, veja também:",
"Change style only" => "Alterar estilo apenas",
"IP not displayed in history" => "Não mostrar IPs no histórico",
"Statistic" => "Estatística",
"or PageName Surrounding by (( ))" => "ou nome de página delimitada por (( ))",
"Note 1" => "Nota 1",
"When you allowed users to configure modules via " => "Quando habilita os utilizadores de configurar os módulos via  ",
" then make sure you select " => " certifique-se que seleccionou ",
"Only that way you can be sure users will notice new modules you assign later" => "Só dessa forma poderá assegurar que os utilizadores se apercebam dos novos módulos que adicionar no futuro",
"Note 2" => "Nota 2",
"If you assign modules to groups make sure that you\nhave turned off the option " => "Se atribuiu módulos a grupos, certifique-se que desactivou a opção ",
"wiki pages" => "págs. Wiki",
"Add a new group" => "Adicionar um novo grupo",
"List all members" => "Listar todos os membros",
"watch only this category" => "Monitorizar apenas esta categoria",
"watch this category and their descendants" => "Monitorizar esta categoria e suas descendentes",
"stop watching only this category" => "Parar de monitorizar apenas esta categoria",
"stop watching this category and their descendants" => "Parar de monitorizar esta categoria e suas descendentes",
"lastMod" => "última Modificação",
"creator" => "criador",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods</a>." => "Para aprender mais sobre os <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods</a>.",
"Hold down CTRL to select multiple" => "Mantenha a tecla CTRL pressionada para seleccionar múltiplos",
"rollback to this version" => "reverter para esta versão",
"add structure" => "adicionar estrutura",
"You can include the file in an HTML page using" => "Você pode incluir este ficheiro em uma página HTML usando",
"Site Identity features" => "Funcionalidades Identidade do Site",
"downloads" => "downloads",
"Dls" => "Dls",
"pdf" => "pdf",
"loc" => "loc",
"cat" => "cat",
"lang" => "lang",
"prio" => "prio",
"dsn" => "dsn",
"coms" => "coms",
"ppd" => "ppd",
"cache" => "cache",
"perms" => "perms",
"admin Trackers tpl" => "admin Trackers tpl",
"ok" => "ok",
"admin" => "admin",
"admin quizzes tpl" => "admin quizzes tpl",
"slides" => "slides",
"proc" => "proc",
"list faqs tpl" => "list faqs tpl",
"adm" => "adm",
"Com" => "Com",
"Vers" => "Vers",
"admin live support tpl" => "admin live support tpl",
"site" => "site",
"UTC" => "UTC",
"pos" => "pos",
"emot" => "emot",
"pop" => "pop",
"sites" => "sites",
"new image uploaded by" => "nova imagem carregada por",
"new subscriptions" => "nova assinatura",
"new item in tracker" => "novo item no acompanhamento",
"message" => "mensagem",
"Include an article" => "Incluir um artigo",
"filter" => "filtro",
"no such file" => "ficheiro inexistente",
"attach" => "anexar",
"monitor this blog" => "monitorizar este blog",
"hide categories" => "Esconder categorias",
"Admin categories" => "Administrar categorias",
"monitor this topic" => "monitorizar este tópico",
"move selected files" => "mover os ficheiros seleccionados",
"from\nthe mapfile:" => "de\no ficheiro de mapa:",
"compare" => "comparar",
"diff" => "difer",
"for more setup details." => "para mais detalhes de configuração.",
"You can remove this module in" => "Você pode remover este módulo em",
"entire site" => "Todo o site",
"del" => "elimin",
"Create pdf" => "Criar pdf",
"1 file attached" => "1 ficheiro anexado",
"categories" => "categorias",
"List pages where I am a creator" => "Listar páginas onde eu sou um autor",
"by creator" => "por autor",
"List pages where I am a modificator" => "Listar páginas onde eu sou um modificador",
"by modificator" => "por modificador",
"at tracker" => "no acompanhamento",
"show categories" => "exibir categorias",
"check / uncheck all" => "marcar / desmarcar todos",
"save" => "guardar",
"delete" => "apagar",
"permissions" => "permissões",
"yes" => "sim",
"admin categories" => "administrar categorias",
"admin categories tpl" => "admin categorias TPL",
"create new" => "criar nova",
"add" => "adicionar",
"update" => "actualizar",
"create" => "criar",
"refresh" => "actualizar",
"use in cms" => "usar no CMS",
"use in wiki" => "usar no Wiki",
"use in newsletters" => "Usar em comunicados",
"use in HTML pages" => "usar em páginas HTML",
"last modif" => "última modif",
"sections" => "secções",
"upload" => "carregar",
"extwiki" => "wikiext",
"author" => "autor",
"flag" => "marca",
"posts" => "mensagens",
"user level" => "nível de utilizador",
"online" => "on-line",
"topics" => "assuntos",
"age" => "idade",
"last post" => "última mensagem",
"Click here to delete this forum" => "Clique aqui para eliminar este fórum",
"admin hotwords" => "administrar 'Hotwords'",
"edit template" => "editar modelo",
"admin HTML page dynamic zones" => "administrar páginas HTML com zonas dinâmicas",
"Refresh rate (if dynamic) [secs]" => "Taxa de actualização (se dinâmica) [em segundos]",
"list repositories" => "listar repositórios",
"new repository" => "novo repositório",
"view repository" => "ver repositório",
"configure repositories" => "configurar repositórios",
"configure this repository" => "configurar este repositório",
"view this repository" => "ver este repositório",
"new rule" => "nova regra",
"copy rules" => "copiar regras",
"admin featured links" => "administrar links oferecidos",
"position" => "posição",
"set" => "definir",
"admin menu builder" => "administrar construtor de menus",
"options" => "opções",
"admin modules" => "administrar módulos",
"assign module" => "atribuir novo módulo",
"left modules" => "módulos da esquerda",
"right modules" => "módulos da direita",
"edit/create" => "editar/criar",
"clear cache" => "limpar a cache",
"assign" => "atribuir",
"left" => "esquerda",
"right" => "direita",
"order" => "ordem",
"up" => "subir",
"down" => "descer",
"create/edit" => "criar/editar",
"use poll" => "Utilizar a sondagem",
"use gallery" => "usar a galeria",
"use rss module" => "utilizar módulo rss",
"use menu" => "utilizar o menu",
"tree" => "árvore",
"use phplayermenu" => "usar phplayermenu",
"use banner zone" => "Utilizar zona de banner",
"use" => "usar",
"list newsletters" => "listar comunicados",
"send newsletters" => "enviar comunicados",
"Create/edit newsletters" => "Criar/editar comunicados",
"editions" => "edições",
"last sent" => "última enviada",
"subscriptions" => "assinaturas",
"admin Email Notifications" => "administrar notificações e-mail",
"use admin email" => "usar o endereço do admin",
"event" => "evento",
"admin polls" => "administrar sondagens",
"Create/edit Polls" => "Criar/editar Votações",
"admin QuickTags" => "administrar QuickTags",
"label" => "rótulo",
"admin RSS Modules" => "administrar módulos RSS",
"Rss channels" => "Canais RSS",
"show pubdate" => "mostrar pubdate",
"export pages" => "exportar páginas",
"dump tree" => "despejar árvore",
"create webhelp" => "criar webhelp",
"view webhelp" => "ver webhelp",
"create new structure" => "criar nova estrutura",
"list surveys" => "listar consultas",
"survey stats" => "estatísticas das pesquisas",
"questions" => "perguntas",
"files" => "ficheiros",
"View this tracker items" => "Ver itens",
"items" => "itens",
"fields" => "campos",
"Create/edit trackers" => "Criar/editar acompanhamentos",
"version" => "versão",
"admin users" => "admin utilizadores",
"Add a new user" => "Adicionar novo utilizador",
"Added users" => "Utilizadores adicionados",
"Edit item" => "Editar item",
"all" => "todos",
"List of available backups" => "Lista de backups disponíveis",
"Restoring a backup" => "Restaurando um backup",
"Warning!" => "Atenção!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Restaurar um backup destrói todos os dados no seu banco de dados Tiki. Todas suas tabelas serão sobrescritas com os dados do backup.",
"Click here to confirm restoring" => "Clique aqui para confirmar a restauração",
"Create new backup" => "Criar um novo backup",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "A criação de backups pode levar muito tempo. Se o processo não for concluído, você verá uma tela em branco. Se isto acontecer, você precisa aumentar o tempo máximo de execução de scripts em seu ficheiro php.ini",
"Upload a backup" => "Carregar um backup",
"Upload backup" => "Carregar backup",
"view blog" => "ver o blog",
"list blogs" => "listar os blogs",
"Note: if you want to use images please save the post first and you\nwill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\nor use the image URL to include images using the WYSIWYG editor. " => "Nota: Se deseja usar imagens, por favor, guarde a publicação antes \ne poderá editar/publicar imagens. Utilize a tag &lt;img&gt; para incluir imagens carregadas na caixa de texto\nou utilize o URL da imagem para incluir imagens utilizando o editor WYSIWYG. ",
"save and exit" => "salvar e sair",
"edit gallery" => "editar galeria",
"rebuild thumbnails" => "recriar miniaturas",
"upload image" => "carregar uma imagem",
"list gallery" => "listar a galeria",
"original size" => "tamanho original",
"add comment" => "adicionar um comentário",
"return to gallery" => "retornar à galeria",
"edit image" => "editar imagem",
"smaller" => "menor",
"bigger" => "maior",
"prev image" => "imagem anterior",
"popup window" => "janela de popup",
"next image" => "próxima imagem",
"stop" => "parar",
"imagescale" => "escaladeimagem",
"move" => "mover",
"click to navigate" => "clique para navegar",
"details" => "detalhes",
"or create a new category" => "ou crie uma nova categoria",
"or create a new location" => "ou crie uma novo local",
"comma separated usernames" => "nomes de utilizador separados por vírgula",
"comma separated username:role" => "nome de utilizador:papel, separados por vírgula",
"with roles" => "com papéis",
"Chair" => "Cadeira",
"Optional" => "Opcional",
"go" => "procura",
"Add or edit a site" => "Adicionar ou editar um site",
"search" => "pesquisar",
"validate" => "validar",
"list articles" => "listar artigos",
"view articles" => "ver artigos",
"Use ...page... to separate pages in a multi-page article" => "Utilize ...página... para separar páginas em artigos multi-página",
"try" => "experimentar",
"display" => "exibir",
"list quizzes" => "listar testes",
"quiz stats" => "estats. teste",
"results" => "resultados",
"this quiz stats" => "estatísticas deste teste",
"edit this quiz" => "editar este teste",
"admin quizzes" => "administrar testes",
"list submissions" => "listar envios",
"rename" => "renomear",
"unlock" => "desbloquear",
"lock" => "bloquear",
"history" => "histórico",
"similar" => "similares",
"undo" => "anular",
"export" => "exportar",
"discuss" => "discutir",
"cancel edit" => "cancelar edição",
"Admin ephemerides" => "Administrar efemérides",
"All ephemerides" => "Todas efemérides",
"new question" => "nova pergunta",
"Edit FAQ questions" => "Editar perguntas do FAQ",
"answer" => "resposta",
"approve" => "aprovar",
"configure listing" => "configurar a listagem",
"Edit this file gallery:" => "Editar esta galeria de ficheiros:",
"create new gallery" => "criar uma nova galeria",
"icon" => "ícone",
"Other users can upload files to this gallery" => "Outros utilizadores podem carregar ficheiros nesta galeria",
"Available File Galleries" => "Galerias de Ficheiros Disponíveis",
"topic" => "assunto",
"save and approve" => "salvar e aprovar",
"new topic" => "novo assunto",
"reject" => "rejeitar",
"visits" => "visitas",
"accept" => "aceitar",
"start" => "início",
"end" => "fim",
"switch" => "alternar",
"roles" => "perfis",
"Add role" => "Adicionar perfil",
"add new" => "adicionar novo",
"add role" => "adicionar perfil",
"active process" => "processo activo",
"invalid" => "inválido",
"invalid process" => "processo inválido",
"valid process" => "processo válido",
"activities" => "actividades",
"graph" => "gráfico",
"new minor" => "novo secundário",
"new major" => "novo principal",
"aborted" => "abortado",
"value" => "valor",
"monitor" => "monitorizar",
"send instance" => "enviar instância",
"activate" => "ativar",
"result" => "resultado",
"rollback" => "restaurar",
"source" => "fonte",
"edit new article" => "editar um novo artigo",
"admin Banners" => "administrar Banners",
"create new blog" => "criar um novo blog",
"post" => "enviar",
"Create or edit content block" => "Criar ou editar um bloco de conteúdo",
"create new block" => "criar um novo bloco",
"Listing Gallery" => "Listando a Galeria",
"upload file" => "carregar um ficheiro",
"Edit a file using this form" => "Editar um ficheiro usando esta forma",
"Gallery Files" => "Ficheiros da Galeria",
"delete selected files" => "apagar os ficheiros seleccionados",
"edit blog" => "editar blog",
"edit new submission" => "editar nova mensagem",
"stats" => "estats",
"Last ver" => "Última versão",
"set as operator" => "definir como operador",
"add topic" => "adicionar assunto",
"admin newsletters" => "admin circulares",
"Subscribe to newsletter" => "Assine o comunicado",
"Add or edit a news server" => "Adicionar ou editar um servidor de news",
"wiki help" => "ajuda wiki",
"attach file" => "anexar um ficheiro",
"reads" => "leituras",
"view comments" => "ver comentários",
"print" => "imprimir",
"clear stats" => "limpar estatísticas",
"Edit received page" => "Editar uma página recebida",
"admin Referer stats" => "admin Estatísticas de Referência",
"last" => "último",
"send me my password" => "me envie minha palavra-passe",
"searched" => "pesquisadas",
"send" => "enviar",
"cancel" => "cancelar",
"path" => "caminho",
"add page" => "adicionar página",
"clear" => "limpar",
"add article" => "adicionar um artigo",
"admin Tiki Shoutbox" => "administrar Quadro Negro Tiki",
"backlinks" => "referências",
"create pdf" => "criar pdf",
"monitor this page" => "monitorizar esta página",
"stop monitoring this page" => "não monitorizar mais esta página",
"attachments" => "anexos",
"last modification" => "última modificação em",
"section" => "secção",
"move to right column" => "mover para a coluna direita",
"unassign" => "desatribuir",
"move to left column" => "mover para a coluna esquerda",
"remove folder" => "remover pasta",
"refresh cache" => "actualizar cache",
"Add or edit folder" => "Adicionar ou editar pasta",
"Add or edit a URL" => "Adicionar ou editar um endereço",
"private" => "privada",
"priority" => "prioridade",
"no comments" => "sem comentários",
"edit chart" => "editar gráfico",
"edit items" => "editar itens",
"list charts" => "listar gráficos",
"last chart" => "último gráfico",
"previous chart" => "gráfico anterior",
"next chart" => "próximo gráfico",
"pre" => "ant",
"item" => "ítem",
"avg" => "méd",
"monitor this forum" => "monitorizar este fórum",
"stop monitoring this forum" => "para de monitorizar este fórum",
"post new comment" => "publicar novo comentário",
"HTML tags are not allowed inside comments" => "Tags HTML não são permitidos dentro dos comentários",
"moderator actions" => "acções de moderador",
"move selected topics" => "mover os tópicos seleccionados",
"unlock selected topics" => "desbloquear os tópicos seleccionados",
"lock selected topics" => "bloquear os tópicos seleccionados",
"delete selected topics" => "eliminar os tópicos seleccionados",
"merge" => "fundir",
"merge selected topics" => "fundir os tópicos seleccionados",
"reported messages:" => "mensagens assinaladas:",
"queued messages:" => "mensagens em fila:",
"replies" => "respostas",
"topics in this forum" => "tópicos neste fórum",
"stop monitoring this topic" => "para de monitorizar  este tópico",
"reply" => "responder",
"send email to user" => "enviar email ao utilizador",
"score" => "pontuação",
"Comments below your current threshold" => "Comentários abaixo do seu limite actual",
"Edit this tracker" => "Editar",
"back" => "voltar",
"View item" => "Visualizar item",
"Add a comment" => "Adicionar um comentário",
"account" => "conta",
"add contacts" => "adicionar contactos",
"Tiki sections and features" => "Secções e funcionalidades de Tiki",
"Feed</b>" => "Campo",
"Feed for Articles" => "Fonte para Artigos",
"Feed for Weblogs" => "Fonte para Weblogs",
"Feed for Image Galleries" => "Fonte para Galerias de Imagens",
"Feed for File Galleries" => "Fonte para Galerias de Ficheiros",
"Feed for the Wiki" => "Fonte para Wiki",
"Feed for individual Image Galleries" => "Fonte para Galerias individuais de Imagens",
"Feed for individual File Galleries" => "Fonte para Galerias individuais de Ficheiros",
"Feed for individual weblogs" => "Fonte para Weblogs individuais",
"Feed for individual forums" => "Fonte para fóruns individuais",
"Feed for mapfiles" => "Campo para ficheiros de mapas",
"PDF generation" => "Geração de PDF",
"Use in CMS" => "Usar no CMS",
"Use in Wiki" => "Usar no Wiki",
"Use in newsletters" => "Usar em comunicados",
"Use in HTML pages" => "Usar em páginas HTML",
"Use Admin Email" => "Usar o endereço do admin",
"Edit or add poll options" => "Editar ou adicionar opções de sondagens",
"Admin tracker" => "Administrar",
"Edit tracker fields" => "Editar campos",
"Group Default Category" => "Categoria do grupo por omissão",
"Popup Window" => "Janela de popup",
"No individual permissions global permissions apply" => "Nenhuma permissão individual, permissões globais em efeito",
"Welcome to the Tiki Chat Rooms" => "Bem-vindo(a) às salas de chat",
"Please select a chat channel" => "Por favor, seleccione uma sala ",
"enter chat room" => "entrar na sala de chat",
"There are no channels setup, please contact a site admin" => "Não existem canais configurados. Por favor contate um administrador do site",
"Chatroom" => "Sala de chat",
"Active Channels" => "Canais activos",
"Users in this channel" => "Utilizadores neste canal",
"Channel Information" => "Informações sobre o canal",
"Channel" => "Canal",
"Ratio" => "Taxa",
"Use :nickname:message for private messages" => "Utilize :apelido:mensagem para mensagens particulares",
"Use [URL|description] or [URL] for links" => "Utilize [URL|descrição] ou [URL] para hiperligações",
"Use (:smileyname:) for smileys" => "Usar (:emoticons:) for emoticons",
"Create PDF" => "Criar PDF",
"PDF Settings" => "Configurações PDF",
"Select Wiki Pages" => "Seleccionar Páginas Wiki",
"Remove Page" => "Remover página",
"cool sites" => "sites legais",
"Create Zone" => "Criar zona",
"translate" => "traduzir",
"Create or edit content" => "Criar ou editar conteúdo",
"exceptions" => "excepções",
"Total threads" => "Número total de sequências",
"Average threads per topic" => "Média de sequências por tópico",
"Now enter the file URL" => "Agora digite o endereço para o ficheiro",
" or upload a local file from your disk" => " ou carregue um ficheiro local do seu disco",
"Post New Comment" => "Publicar novo comentário",
"Group doesnt exist" => "O grupo não existe",
"User doesnt exist" => "O utilizador não existe",
"Event without Name" => "Evento sem nome",
"Invalid old password" => "Senha antiga inválida",
"No channel indicated" => "Nenhum canal indicado",
"No nickname indicated" => "Nenhum apelido indicado",
"Permision denied" => "Permissão negada",
"As leaves in the category tree" => "Como folhas da árvore de categorias",
"Only if you enabled" => "Requer activação da opção",
"Force to use uppercase and downcase chars and nums in passwords" => "Obrigar a utilização de letras maiúsculas, minúsculas e dígitos nas palavras-passe",
"Password must contain uppercase and downcase letters and numbers" => "A palavra-passe deve ser composta de letras maiúsculas, minúsculas e algarismos",
"Renamed" => "Renomeada",
"Posted" => "Afixado",
"Downloaded" => "Descarregado",
"Viewed" => "Visualizado",
"Updated" => "Actualizado",
"sheet" => "folha",
"Upload a new file in this folder" => "Carregar um ficheiro nesta pasta",
"Resource Type" => "Tipo do recurso",
"Create New Folder" => "Criar uma pasta",
"clip" => "clip",
"cc" => "cc",
"sender" => "remetente",
"subject" => "assunto",
"date" => "data",
"flagged" => "seleccionada",
"mark" => "marca",
"Click" => "Clique",
"posted by" => "enviada por",
"email this post" => "enviar por email",
"Tag name" => "Nome da Tag",
"Name length" => "Tamanho do nome",
"Anonymous editors must input anti-bot code" => "Obrigar Anónimos a introduzir código anti-bot",
"Edit idle timeout" => "Temporizador para edição",
"Use page description" => "Usar descrição de página",
"Show page title" => "Exibir título da página",
"Show page ID" => "Mostrar ID da página",
"Users can lock pages (if perm)" => "Utilizadores podem travar páginas (se perm)",
"Use WikiWords" => "Usar WikiWords",
"Use Wiki paragraph formatting" => "Usar formatação Wiki para parágrafos",
"Create webhelp from structure" => "Criar sistema de ajuda a partir de estrutura",
"Use external link icons" => "Usar ícones para links externos",
"User's Page" => "Página de Utilizador",
"UserPage prefix" => "Prefixo de Página de Utilizador",
"Import Page" => "Importar Página",
"When viewing a page, if it doesn't exist and has one like page, automatic redirection to this like page" => "Durante a visualização de uma página, se não existir e tiver uma página parecida, redireccionar automaticamente para a página parecida",
"Show/hide heading icon displayed before the heading" => "Mostrar/Esconder ícone de cabeçalho mostrado antes do cabeçalho",
"Print Page" => "Imprimir Página",
"Show page version" => "Mostrar versão de página",
"Page navigation bar position (displayed when page break '...page...' are used)" => "Posição da barra de navegação (mostrada quando a quebra de página '...página...' é utilizada)",
"Maximum number of versions for history" => "Número máximo de versões para histórico",
"Never delete versions younger than days" => "Nunca apagar versões mais novas que (dias)",
"Diff style" => "Estilo do Diff",
"This will work well (or not!) depending on your theme. To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "Esta funcionalidade poderá não trabalhar correctamente, dependendo do seu tema. Para aprender mais sobre <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">temas</a>",
"Old vers" => "Versão ant.",
"Add or edit event" => "Adicionar ou editar evento",
"merge selected notes into" => "combinar notas seleccionadas em",
"Faq Stats" => "Estatísticas de FAQ",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "Sua mensagem está aguardando aprovação, a mensagem pode ser postada depois\nque um moderador aprová-la.",
"Webmail Doc" => "Documento Webmail",
"settings" => "configurações",
"mailbox" => "correio",
"compose" => "escrever",
"contacts" => "contactos",
"back to mailbox" => "retornar à lista de mensagens",
"full headers" => "cabeçalhos completos",
"normal headers" => "cabeçalhos comuns",
"reply all" => "responder a todos",
"forward" => "remeter",
"select from address book" => "seleccionar da agenda de endereços",
"Admin Webmail" => "Admin Webmail",
"Admin Directory Sites tpl" => "Admin Directory Sites tpl",
"ImportingPagesPhpWikiPageAdmin" => "ImportingPagesPhpWikiPageAdmin",
"hist" => "hist",
"new submissions" => "novas submissões",
"new sites" => "novos sites",
"new calendar events" => "novos eventos",
"Message Broadcast" => "Mensagem Global",
"database queries used" => "consultas de base de dados utilizadas",
"{\$atts_cnt} files attached" => "{\$atts_cnt} ficheiros anexados",
"pass" => "Palavra-passe",
"Page generated in" => "Página gerada em",
"sent" => "enviada",
"Favorites" => "Favoritos",
"Back to Homepage" => "Voltar à página inicial",
"Edit Summary" => "Sumário de edição",
"Minor" => "Menor",
"Content Features" => "Funcionalidades de Conteúdo",
"Contact Us (Anonymous)" => "Contacte-nos (Anónimo)",
"Prevent automatic/robot registration" => "Evitar registo automático/robot",
"Site Logo" => "Logótipo",
"Create/edit Calendars" => "Criar/editar Calendários",
"Admin Categories tpl" => "Admin categorias tpl",
"charts" => "gráficos",
"Chat Administration" => "Administração do chat",
"Create/edit channel" => "Criar/editar canal",
"Half a second" => "Meio segundo",
"second" => "segundo",
"Chat channels" => "Canais de chat",
"Admin Featured Links" => "Administrar links oferecidos",
"Admin Menu Builder" => "Administrar construtor de menus",
"Assign Module" => "Atribuir novo módulo",
"subscribed" => "subscrita",
"Edit survey questions" => "Editar as perguntas da pesquisa",
"system admin" => "administração do sistema",
"Admin Tracker" => "Administrar",
"Warning: changing the username will require the user to change his password" => "Aviso: a alteração do nome de utilizado obrigará o utilizador a alterar a sua password",
"Again" => "Novamente",
"User must change his password at first login" => "Forçar a mudança de password na primeira autenticação",
"Assign permissions to group" => "Definir permissões para o grupo",
"Browsing Gallery" => "A explorar a Galeria",
"Config Calendars" => "Configurar Calendários",
"Admin Directory Related" => "Administrar directórios Relacionados",
"Admin Directory Sites" => "Administrar Sites do directório",
"Validate Sites" => "Validar Sites",
"directory validate sites tpl" => "Directório validar sites tpl",
"Edit Article" => "Editar Artigo",
"Show Plugins Help" => "Exibir Auxílio para Plugins",
"Show Text Formatting Rules" => "Exibir Regras de Formatação de Texto",
"Program dynamic content for block" => "Programar conteúdo dinâmico para o bloco",
"Admin quizzes" => "Administrar testes",
"Admin Quizzes tpl" => "Admin quizzes tpl",
"EditTemplates" => "EditarModelos",
"Message queue for" => "Mensagem na fila para",
"back to forum" => "retornar ao fórum",
"Reported messages for" => "Mensagens assinaladas para",
"Admin Cache" => "Administrar cache",
"List FAQs Tpl" => "List faqs tpl",
"Admin Live Support tpl" => "Admin live support tpl",
"back to admin" => "voltar à admin",
"Subscribe to This Newsletter" => "Inscrever-se",
"Stats for quiz" => "Estats para a pesquisa",
"Received Articles" => "Artigos Recebidos",
"Rename page" => "Renomear a página",
"to_version" => "versão_desejada",
"Stats for survey" => "Estatísticas para a Consulta",
"Theme Control Center: categories" => "Centro de Controlo de Temas: categorias",
"ThemeControl" => "ControloDeTemas",
"ThemeControl Objects" => "Objectos ThemeControl",
"Theme Control Center: sections" => "Centro de Controlo de Temas: secções",
"File Title" => "Título do Ficheiro",
"Unzip all zip files" => "Descomprimir todos os ficheiros ZIP",
"User Assigned Modules" => "Módulos Atribuídos pelo Utilizador",
"IRC log" => "Log de IRC",
"Add new mail account" => "Adicionar nova conta de e-mail",
"User accounts" => "Contas de utilizadores",
"View All" => "Ver Todas",
"Msg" => "Mnsg",
"Can't parse remote HTML page" => "Não é possível analisar página HTML remota",
"Permission denied you cannot remove pages" => "Permissão negada: você não pode remover páginas",
"MyTiki Home" => "MyTiki Home",
"Swffix" => "Swffix",
"Meta Keywords" => "Meta Keywords",
"Meta Description" => "Meta Description",
"Meta Author" => "Meta Author",
"Geourl" => "Geourl",
"meta robots" => "meta robots",
"revisit after" => "revisit after",
"Cannot write to this file" => "Não foi possível escrever neste ficheiro",
"Missing title or body when trying to post a comment" => "Tentativa de envio de comentário sem título ou corpo",
"\\n for rows" => "\\n para linhas",
"Consider we are in always in HTTPS, but do not check" => "Assumir HTTPS, mas sem verificar",
"Newsletter subscription information at " => "Assinatura de comunicado em ",
"Changes" => "Alterações",
"Hold down CTRL to select multiple categories" => "Mantenha a tecla CTRL para seleccionar múltiplas categorias",
"categorize this object" => "categorizar este objecto",
"Uncheck the above checkbox to uncategorize this page/object" => "Desseleccione a caixa acima para remover a categoria desta página/objecto",
"Syntax highlighting" => "Colorização de sintaxe",
"My Files" => "Meus ficheiros",
"Mini calendar" => "Mini calendário",
"Dump" => "Exportação",
"Send Pages" => "Enviar páginas",
"Received pages" => "Páginas recebidas",
"New Article" => "Novo artigo",
"Admin Posts" => "Administrar mensagens",
"Submit a New Link" => "Enviar um novo link",
"Browse directory" => "Navegar directório",
"Admin Directory" => "Administrar directório",
"Layer Management" => "Gestão de camadas",
"List quizzes" => "Listar testes",
"List trackers" => "Listar todos",
"Debugger console" => "Console de debug",
"I forgot my pass" => "Esqueci a palavra-passe",
"Send trackback pings to:" => "Enviar pings de retorno para:",
"(comma separated list of URIs)" => "(lista de URIs separadas por vírgula)",
"This is" => "Este é o",
"by the" => "criado pela",
"Tiki community" => "comunidade Tiki",
"Use categories to regroup various Tiki objects" => "Use as categorias para reagrupar os vários objectos do Tiki",
"Link to" => "Link para",
"User identity features" => "Funcionalidades sobre identidade de utilizadores",
"Users sort order" => "Ordenação dos utilizadores",
"Use URI as Home Page" => "Utilizar URI como página inicial",
"OS" => "Sistema Operativo",
"Log SQL:" => "Registo SQL:",
"Default charset for sending mail:" => "Charset para envio de mail:",
"Mail end of line:" => "Fim de linha para Mail:",
"Disallow access to the site (except for those with permission)" => "Desabilitar o acesso ao site (exceto para quem tem permissão)",
"Message to display when site is closed" => "Mostrar mensagem quando o site estiver fechado",
"Disallow access when load is above the threshold (except for those with permission)" => "Desabilitar o acesso quando a carga do servidor está acima do seu limiar (exceto para quem possui permissão)",
"Max average server load threshold in the last minute" => "Média máxima carregada no último minuto",
"Message to display when server is too busy" => "Mostrar mensagem quando o servidor estiver muito ocupado",
"Use cache for external images" => "Usar Cache para imagens externas",
"Use gzipped output" => "Output comprimido (gzip)",
"output compression is active." => "Compressão do output está activa.",
"compression is handled by" => "compressão gerida por",
"Sender Email" => "Remetente (e-mail)",
"Allow anonymous users to \"Contact Us\"" => "Permitir que anónimos usem o \"Contacte-nos\"",
"contact feature disabled" => "Funcionalidade contacto desactivada",
"Session lifetime in minutes" => "Tempo de vida das sessões em minutos",
"Proxy Host" => "Host do Proxy",
"Please expect not found help-pages with the default-URL." => "Pode ocorrer que a página de ajuda não esteja disponível ainda.",
"Any help with the documentation is welcome." => "Procuramos ajuda para escrever a documentação.",
"When possible, show the real user name instead of login:" => "Mostrar o nome real do utilizador em lugar do login, sempre que possível:",
"Locations separator" => "Separador de localizações",
"Choices separator" => "Separador de opções",
"User registration and login" => "Registo e login de utilizador",
"Use WebServer authentication for Tiki" => "Utilizar autenticação do servidor Web para o Tiki",
"... but need admin validation" => "... mas requerem validação pelo admin",
"Create a group for each user <br />(with the same name as the user)" => "Criar um grupo para cada utilizador<br />(com o mesmo nome que o utilizador)",
"Use tracker for more user information" => "Usar tracker para mais informações sobre utilizadores",
"Use tracker for more group information" => "Usar tracker para mais informações sobre grupos",
"Request passcode to register" => "Exigir código secreto para registo",
"Use login as email" => "Usar login como email",
"Validate users by email" => "Validar utilizadores por e-mail",
"Validate user email server" => "Validar servidor de email do utilizador",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Recuperação de passwords por e-mail (se opção \",Guardar passwords como texto simples\" estiver activada). Caso contrário, reinicia as passwords por email",
"Store plaintext passwords" => "Armazenar palavras-passe sem criptografia",
"Crypt passwords method" => "Método de codificação de passwords",
"Reg users can change password" => "Utilizadores reg. podem alterar password",
"Reg users can change language" => "Utilizadores registados podem alterar idioma",
"Restrict available languages" => "Restringir idiomas disponíveis",
"Available languages:" => "Idiomas disponíveis:",
"Minimum username length" => "Tamanho mínimo do nome de utilizador",
"Maximum username length" => "Tamanho máximo do nome de utilizador",
"Force lowercase username" => "Forçar nomes de utilizador em letras minúsculas",
"Force to use chars and nums in passwords" => "Obrigar a utilização de letras e números nas palavras-passe",
"Minimum password length" => "Comprimento mínimo para palavras-passe",
"Password invalid after days" => "Invalidar palavras-passe após dias",
"-1 for never" => "-1 para nunca",
"Re-validate user by email after days" => "Revalidar utilizador por email após estes dias",
"Re-validate user by email after unsuccessful logins" => "Revalidar utilizadores por email após este número de tentativas de login",
"Remember me feature" => "Funcionalidade Lembre-me",
"Remember me name" => "Nome Lembre-me",
"Remember me domain" => "Lembre-me o domínio",
"Remember me path" => "Lembre-me o caminho",
"Protect against CSRF with a confirmation step" => "Protecção contra CSRF com passo de confirmação",
"Highlight Group" => "Destaque de Grupo",
"User can choose beyond these groups at registration time" => "Utilizador poderá escolher de entre estes grupos aquando do registo",
"Specify the fields that will be asked in admin->groups" => "Indicar quais os campos solicitados em admin->grupos",
"Displays user's contribution in the user information page" => "Mostrar contribuições do utilizador na sua página de informação",
"Displays UserTracker information in user information page. Format: trackerId, fieldId1, fieldId2, …" => "Mostrar informação do UserTracker na sua página de informação:Format: trackerId, campoId1, campoId2, …",
"Deactivate login autocomplete (do not remember login and password)" => "Desactivar 'completar automaticamente' no login (não memorizar login e password)",
"Create user if not in Tiki?" => "Criar utilizador se não estiver no Tiki?",
"Create user if not in Auth?" => "Criar utilizador se não estiver no Auth?",
"Just use Tiki auth for admin?" => "Utilizar apenas autenticação do Tiki para admin?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "URL LDAP<br />(se activo, terá prevalência sobre Host e Porto)",
"LDAP Host" => "Host LDAP",
"LDAP Port" => "Porta LDAP",
"LDAP Scope" => "Escopo LDAP",
"LDAP Base DN" => "Base DN do LDAP",
"LDAP User DN" => "Utilizador DN do LDAP",
"LDAP User Attribute" => "Atributo do utilizador do LDAP",
"LDAP User OC" => "OC do utilizador do LDAP",
"LDAP Group DN" => "DN do Grupo do LDAP",
"LDAP Group Attribute" => "Atributo do Grupo do LDAP",
"LDAP Group OC" => "OC do grupo do LDAP",
"LDAP Member Attribute" => "Atributo do Membro do LDAP",
"LDAP Member Is DN" => "Membro do LDAP é DN",
"LDAP Admin User" => "Utilizador de Admin LDAP",
"LDAP Admin Pwd" => "Palavra-passe de Admin LDAP",
"LDAP Version" => "Versão LDAP",
"LDAP Realname Attribute" => "Atributo Nome Real LDAP",
"CAS server hostname" => "Servidor CAS",
"CAS server port" => "Porto CAS",
"CAS server path" => "Caminho CAS",
"Change CAS preferences" => "Alterar preferências CAS",
"Valid Affiliations (separated by commas)" => "Filiações Válidas (separadas por vírgula)",
"Create with default group?" => "Criar com grupo por omissão?",
"Default group: " => "Grupo por omissão: ",
"Change Shibboleth preferences" => "Alterar preferências Shibboleth",
"Users Defaults" => "Valores por omissão para utilizadores",
"Change users defaults" => "Alterar valores por omissão",
"Note: This feature also requires PHPLayers to be turned on in " => "Nota: Esta funcionalidade requer a activação do PHPLayers ",
"Allow Smileys" => "Permitir Smileys",
"Show quicktags over textareas (instead on left side)" => "Mostrar quicktags sobre as áreas de texto (em oposição ao lado esquerdo)",
"Use File Galleries for images inclusion" => "Utilizar Galerias de Ficheiros para inclusão de imagens",
"Hotwords in New Windows" => "'Hotwords' em novas janelas",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Para adicionar/editar páginas wiki facilmente, adicione o módulo <i>quick edit</i> via \"Módulos\" no menu de aplicação, ou",
"Create a Tag for the Current Wiki" => "Crie uma Tag para o Wiki actual",
"Restore the Wiki" => "Restaurar o Wiki",
"restore" => "restaurar",
"Remove a Tag" => "Remover a Tag",
"Wiki Comments Settings" => "Configurações dos Comentários do Wiki",
"Wiki Administration" => "Administração do Wiki",
"Wiki Home Page" => "Página Inicial do Wiki",
"Wiki Discussion" => "Discussão Wiki",
"Wiki Link Format" => "Formato de Link Wiki",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Detecção de links Wiki usando dois parêntesis como sintaxe Wiki <i>((nome da página))</i>.",
"Page name display stripper: choose a character that will be used as a delimiter to strip a final part of the page name (only concerns display)" => "Truncador de nome de página: escolha um caracter a ser utilizado como delimitador para remover a parte final do nome de uma página (apenas para visualização)",
"Wiki Page List Configuration" => "Configuração de lista de páginas Wiki",
"Wiki Features" => "Funcionalidades Wiki",
"Wiki History" => "Histórico Wiki",
"History only for data, description, comment change" => "Histórico apenas para dados, descrição, alterações de comentários",
"Wiki Watch" => "Notificação Wiki",
"More Links" => "Mais Ligações",
"Admin Charts" => "Admin gráficos",
"Add new rule" => "Adicionar nova regra",
"EMail notifications" => "Notificações por email",
"Edit this RSS module:" => "Editar este módulo RSS:",
"Create new RSS module" => "Criar um novo módulo RSS",
"Tikiwiki settings" => "Configurações Tikiwiki",
"Create/edit questions for survey" => "Criar/editar perguntas para a pesquisa",
"Active?" => "Ativo?",
"Create/Edit Trackers" => "Criar/editar acompanhamentos",
"Create item" => "Criar item",
"Assign to Groups" => "Atribuir a Grupos",
"show help" => "mostrar ajuda",
"Delete this type" => "Apagar este tipo",
"level configuration" => "nível de configuração",
"Browse gallery" => "Visualizar galeria",
"Upload from disk" => "Carregar do disco",
"Browsing Image" => "A ver a Imagem",
"Duplicate to" => "Duplicar para",
"Again please" => "Novamente, por favor",
"Admin category relationships" => "Administrar relacionamentos de categorias",
"Validate links" => "Validar hiperligações",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Ficheiros com nomes terminados em -{\$user} são modificáveis, os demais são apenas duplicáveis e podem ser utilizados como modelos.",
"Im- Export Languages" => "Importar/Exportar Línguas",
"Create a file gallery" => "Criar uma galeria de ficheiros",
"Support tickets" => "Bilhete de suporte",
"Return to HomePage" => "Retornar à página inicial",
"Stats for this survey Questions " => "Estatísticas para as perguntas desta Consulta ",
"Batch upload" => "Upload em lote",
"Minor Edit" => "Menor",
"You can not download files" => "Você não pode baixar ficheiros",
"Please wait 2 minutes between posts" => "Por favor, aguarde dois minutos entre mensagens",
"hr" => "hr",
"Show Categories" => "Exibir categorias",
"Hide Categories" => "Esconder categorias",
"Blog features" => "Funcionalidade de Blog",
"Blog level comments" => "Comentários de nível de Blog",
"Post level comments" => "Comentários de nível de Envio",
"Spellchecking" => "Correção ortográfica",
"Default ordering for blog listing" => "Ordem por omissão para listagem de Blog",
"Blog listing configuration (when listing available blogs)" => "Configuração de listagem de Blog (listando Blogs disponíveis)",
"Last modification time" => "Última hora de modificação",
"Blog comments settings" => "Configurações de comentários de Blog",
"Group calendar sticky popup" => "Sticky popup do calendário para grupos",
"Group calendar item view tab" => "Separador de itens de calendário para grupos",
"Calendar manual selection of time/date" => "Selecção manual de hora/data no calendário",
"First year in the dropdown, either year number, or relative to current year (+/- N)" => "Primeiro ano na combobox, quer o número do ano, ou um ano relativo ao actual (+/- N)",
"if no jscalendar" => "se não for jscalendar",
"Last year in the dropdown, either year number, or relative to current year (+/- N)" => "Último ano na combobox, quer o número do ano, ou um ano relativo ao actual (+/- N)",
"Show Category Path" => "Exibir o caminho das Categorias",
"Show Category Objects" => "Exibir objectos das Categorias",
"Search may show forbidden results. Much better performance though." => "A Pesquisar poderá mostrar resultados proibidos, mas consegue-se melhor performance.",
"Categories browse uses PhpLayers" => "Navegador de categorias usa PhpLayers",
"The feature must be activated" => "Requer activação do PHPLayers",
"CMS features" => "Funcionalidades de CMS",
"Use templates" => "Usar padrões",
"Print article" => "Imprimir artigo",
"Can specify notification emails when creating an article" => "Permitir indicar emails de notificação enquanto cria um artigo",
"Settings for page articles home" => "Definições para página inicial de artigos",
"Maximum number of articles in home" => "Número máximo de artigos na página inicial",
"Article comments settings" => "Configurações de comentários de artigos",
"Fields to display on page" => "Campos para mostrar na página",
"Expire Date" => "Data de Expiração",
"Copyright Management" => "Gestão de Copyright",
"License Page" => "Página de Licença",
"Submit Notice" => "Nota de Submissão",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Para adicionar/remover galerias de ficheiros, utilize a opção \"Galerias de Ficheiros\" no menu de aplicação, ou",
"File author" => "Autor do ficheiro",
"For not registered author" => "Para autor não registado",
"PodCast directory (must be web accessible):" => "Directoria PodCast (deverá estar acessível na web):",
"Uploaded filenames cannot match regex" => "Ficheiros carregados não podem seguir a expressão regular",
"File galleries comments settings" => "Configurações de comentários de galerias de ficheiros",
"File galleries search indexing" => "Indexação de pesquisas em Galerias de Ficheiros",
"Leave command blank to delete handler" => "Deixe a caixa do comando em branco para remover",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Utilizar %1 quando desejar indicar o nome do ficheiro (exemplo: \"strings %1\" para converter o ficheiro para texto utilizando o comando UNIX 'strings')",
"Enable auto indexing on file upload or change" => "Activar indexação automática aquando do upload ou alteração do ficheiro",
"System command" => "Comando de sistema",
"Forum quick jumps" => "Navegação rápida no fórum",
"Ordering for forums in the forum listing" => "Ordenação para fóruns na listagem de fóruns",
"Forum listing configuration" => "Configuração da listagem de fóruns",
"I18n setup" => "Configuração i18n",
"Show Babelfish Translation URLs" => "Mostrar URLs de tradução do Babelfish",
"Show Babelfish Translation Logo" => "Mostrar Logo de tradução Babelfish",
"Right &amp; left boxes" => "Caixas da direita &amp; esquerda:",
"Show Module Controls" => "Mostrar Controlo de Módulos",
"Users can Configure Modules" => "Utilizadores podem Configurar Módulos",
"Users can Shade Modules" => "Utilizadores podem compactar módulos",
"module decides" => "módulo decide",
"seconds (0 = cache inactive)" => "segundos (0 = cache inactiva)",
"Database Search using MySQL 'Full-Text' Feature" => "Pesquisa na Base de Dados utilizando a funcionalidade 'Full-Text' do MySQL",
"Activate MySQL Full-Text feature" => "Activar funcionalidade Full-Text do MySQL",
"Activate MySQL 'Full-Text' feature" => "Activar funcionalidade Full-Text do MySQL",
"Performance issues" => "Parâmetros de performance",
"Database Independent Full Text Search or Tiki Search" => "Pesquisa Full Text ou Pesquisa Tiki independente da Base de Dados",
"This is activated by default if MySQL 'Full-Text' feature is not activated above" => "Activa por omissão se a funcionalidade 'Full-Text' do MySQL não estiver activada mais acima",
"Search features" => "Funcionalidades da Pesquisa",
"SearchStats" => "Estatísticas de Pesquia",
"Settings for searching content" => "Configurações para pesquisas de conteúdo",
"Search refresh mode" => "Modo de actualização da Pesquisa",
"Search refresh rate" => "Taxa de actualização de pesquisas",
"0 for no refresh" => "0 para não-actualização",
"this survey stats" => "estatísticas desta pesquisa",
"bold" => "negrito",
"italic" => "itálico",
"underline" => "sublinhado",
"To learn more about <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>." => "Para aprender mais sobre os <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">temas</a>.",
"unread private messages" => "mensagens privadas não lidas",
"chat" => "chat",
"WfMenu" => "WfMenu",
"rankings" => "rankings",
"Backups" => "Backups",
"(unchanged)" => "(inalterado)",
"you or someone registered this email address at" => "alguém (possivelmente você) registrou este endereço de email em",
"Your Tiki information registration" => "Instruções para registo no Tiki",
"Your registration" => "Instruções para registo no Tiki",
"left/right" => "esquerdo/direito",
"Unassign module" => "Módulo não associado",
"home" => "Página Inicial",
"contact us" => "contacte-nos",
"debugger console" => "consola de depuração",
"MyMenu" => "MeuMenu",
"User menu" => "Menu do utilizador",
"WikiMenu" => "MenuWiki",
"dump" => "exportação",
"orphan pages" => "páginas-órfãs",
"sandbox" => "caixa de areia",
"received pages" => "páginas recebidas",
"structures" => "estruturas",
"GalMenu" => "MenuGal",
"Articles Home" => "Página principal de Artigos",
"Send articles" => "Enviar artigos",
"Create/Edit Blog" => "Criar/Editar Blog",
"ForMenu" => "MenuFor",
"DirMenu" => "MenuDir",
"Browse Directory" => "Explorar directório",
"FileGalMenu" => "MenuGalArq",
"Admin FAQs" => "Administrar FAQs",
"Edit mapfiles" => "Editar ficheiros de mapas",
"QuizMenu" => "MenuTeste",
"Admin quiz" => "Administrar teste",
"TrkMenu" => "MenuAcomp",
"Admin trackers" => "Administrar",
"SrvMenu" => "MenuPesq",
"Send newsletters" => "Enviar comunicados",
"EphMenu" => "MenuCurios",
"Ephemerides" => "Curiosidades",
"ChartMenu" => "MenuGraf",
"AdmMenu" => "MenuAdm",
"Edit languages" => "Editar línguas",
"External wikis" => "Wikis externos",
"UsrMenu" => "MenuUtilizador",
"Click here to manage your personal menu" => "Clique aqui para editar seu menu pessoal",
"Quick edit a Wiki page" => "Edição rápida (Wiki)",
"Language: " => "Idioma: ",
"Sort posts by:" => "Ordenar mensagens por:",
"read more" => "ler mais",
"For more information, please see <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "Para mais informações, consulte <a href=\"{\$prefs.helpurl}Wiki Page Editor\">Editor de Páginas Wiki</a>",
"Pass" => "Palavra-passe",
"HTTPS login" => "Login HTTPS",
"System Admin" => "Administração do Sistema",
"Misc" => "Misc",
"some text" => "algum texto",
"Creates a box with the data" => "Cria uma caixa com os dados",
"creates a title bar" => "Cria uma barra de título",
"creates a table" => "cria uma tabela",
"makes a horizontal rule" => "criar uma linha horizontal",
"page|desc" => "página|desc",
"displays an image" => "exibe uma imagem",
"Non cacheable images" => "Imagens não armazenáveis em cache",
"height width desc link and align are optional" => "height, width, desc, link e align são opcionais",
"displays rss feed with id=n maximum=m items" => "exibe fonte rss com itens id=n maximum=m",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Será substituído pelo valor real do bloco de conteúdo dinâmico com id=n",
"Quicktags" => "Quicktags",
"QuickTags" => "QuickTags",
"Menu" => "Menu",
"Mootools" => "Mootools",
"Workflow" => "Workflow",
"Unix" => "Unix",
"Windows" => "Windows",
"(standard)" => "(standard)",
"PEAR::Auth" => "PEAR::Auth",
"Editor" => "Editor",
"Webmaster" => "Webmaster",
"Ranks" => "Ranks",
"Ver" => "Ver",
"phpLayersMenus" => "phpLayersMenus",
"tagline" => "tagline",
"Int" => "Int",
"Manual" => "Manual",
"inter" => "inter",
"val" => "val",
"ver:" => "ver:",
"If:SetNextact" => "If:SetNextact",
"Proc" => "Proc",
"auto" => "auto",
"int" => "int",
"Newsgroup" => "Newsgroup",
"eek" => "eek",
"Dif" => "Dif",
"Fatal error: cannot execute automatic activity \$activityId" => "Erro fatal: não é possível executar a acctividade automática \$activityId",
"Fatal error: setting next activity to an unexisting activity" => "Erro fatal: a definir a próxima acctividade para uma acctividade inexistente",
"Fatal error: trying to send an instance to an activity but no transition found" => "Erro fatal: a tentar enviar uma instância a acctividade mas nenhuma transição foi encontrada",
"Process does not have a start activity" => "Processo não possui uma acctividade inicial",
"Process does not have exactly one end activity" => "Processo não possui exactamente uma acctividade final",
"End activity is not reachable from start activity" => "Acctividade final não pode ser atingida a partir da acctividade inicial",
"is interactive but has no role assigned" => "é interactivo mas não tem um papel atribuído",
"is non-interactive and non-autorouted but has no role assigned" => "é não-interactiva e não-encaminhada mas não tem um papel atribuído",
"is standalone but has transitions" => "é autónoma mas tem transições",
"Role" => "Perfil",
"is not mapped" => "não está mapeado",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "Acctividade '.\$res['name'].' é autónoma e está a utilizar o objecto \$instance",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "Acctividade '.\$res['name'].' é interactiva deve então usar o método \$instance->complete()",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "Acctividade '.\$res['name'].' é não-interativa não deve então usar o método \$instance->complete()",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "Acctividade '.\$res['name'].' é interruptor deve então usar o método \$instance->setNextActivity(\$actname)",
"Process %d has been activated" => "Processo %d foi activado",
"Process %d has been deactivated" => "Processo %d foi desactivado",
"Process %s %s imported" => "Processo %s %s importado",
"Process %s removed" => "Processo %s removido",
"Process %s has been updated" => "Processo %s foi actualizado",
"Process %s has been created" => "Processo %s foi criado",
"on left side" => "do lado esquerdo",
"on center" => "no centro",
"on right side" => "do lado direito",
"<return> for rows" => "\n para linhas",
"Any 2 versions" => "Quaisquer 2 versões",
"latin" => "latim",
"english" => "inglês",
"Report all errors except notices" => "Todos erros excepto notices",
"1 day" => "1 dia",
"1 week" => "1 semana",
"1 month" => "1 mês",
"Just Tiki" => "Apenas Tiki",
"Tiki and PEAR::Auth" => "Tiki e PEAR::Auth",
"choose a group ..." => "escolha um grupo ...",
"%s enabled" => "%s activado/a",
"%s disabled" => "%s desactivado/a",
"Charts" => "Gráficos",
"Forums last topics" => "Tópicos recentes nos fóruns",
"games" => "jogos",
"drawing not found" => "desenho não encontrado",
"heads and cells separated by ~|~" => "cabeçalhos e células separadas por ~|~",
"any file" => "qualquer ficheiro",
"Listing configuration" => "Configuração de listagem",
"Perhaps you were looking for:" => "Talvez esteja à procura de:",
"Tiki email notification" => "Notificação de email Tiki",
"TikiWiki Assistant" => "Assistente do Tikiwiki",
"Recently visited pages" => "Páginas recentemente visitadas",
"Last `\$module_rows` Sites" => "Últimos `\$module_rows` Sites",
"Last Sites" => "Últimos Sites",
"Directory Stats" => "Estatísticas do directório",
"Sites to validate" => "Sites a validar",
"Visited links" => "Links visitados",
"Top \$module_rows Sites" => "Melhores \$module_rows Sites",
"Top Sites" => "Sites mais visitados",
"Top `\$module_rows` topics" => "Melhores `\$module_rows` tópicos",
"Last `\$module_rows` forum topics" => "Últimos `\$module_rows` tópicos em fóruns",
"Last `\$module_rows` articles" => "Últimos `\$module_rows` artigos",
"Last articles" => "Últimos artigos",
"Last `\$module_rows` blog posts" => "Últimas  `\$module_rows` mensagens em blogs",
"Last `\$module_rows` Created blogs" => "Últimos `\$module_rows` Blogs criados",
"Last `\$module_rows` Created FAQs" => "Últimas `\$module_rows` FAQs Criadas",
"Last `\$module_rows` Created Quizzes" => "Últimos `\$module_rows` Testes Criados",
"Last `\$module_rows` modified file galleries" => "Últimas `\$module_rows` galerias de ficheiros modificadas",
"Last `\$module_rows` Files" => "Últimos `\$module_rows` Ficheiros",
"Last `\$module_rows` galleries" => "Últimas `\$module_rows` galerias",
"Last galleries" => "Últimas galerias",
"Last `\$module_rows` changes" => "Últimas `\$module_rows` alterações",
"Last `\$module_rows` Modified Items" => "Últimos `\$module_rows` itens Modificados",
"Last `\$module_rows` Modified blogs" => "Últimos `\$module_rows` Blogs modificados",
"Last `\$module_rows` submissions" => "Últimas `\$module_rows` submissões",
"Last `\$module_rows` Items" => "Últimos `\$module_rows` itens",
"New Messages" => "Mensagens novas",
"New Message" => "Mensagem nova",
"Top `\$module_rows` articles" => "`\$module_rows` melhores artigos",
"Top `\$module_rows` File Galleries" => "`\$module_rows` Melhores Galerias de Ficheiros",
"Top `\$module_rows` files" => "Melhores `\$module_rows` ficheiros",
"Top `\$module_rows` games" => "Melhores `\$module_rows` jogos",
"Top games" => "Jogos mais populares",
"Top `\$module_rows` galleries" => "`\$module_rows` melhores galerias",
"Top `\$module_rows` Images" => "`\$module_rows` melhores imagens",
"Top `\$module_rows` Pages" => "Melhores `\$module_rows` Páginas",
"Top `\$module_rows` Quizzes" => "Melhores `\$module_rows` Testes",
"Most `\$module_rows` visited blogs" => "`\$module_rows` Blogs mais visitados",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` FAQs mais visitadas",
"Whats related" => "O que está relacionado",
"Last `\$module_rows` wiki comments" => "Últimos `\$module_rows` comentários no wiki",
"on page" => "na página",
"show structures" => "mostrar estruturas",
"hide structures" => "esconder estruturas",
"Creation date" => "Data de criação",
"Number of columns per page when listing categories" => "Número de colunas por página quando listar categorias",
"enable cool sites" => "Activar Cool Sites",
"Action log setting" => "Definição do registo de actividade",
"Featured Help" => "Ajuda oferecido",
"Copyright System" => "Sistema de Direitos de Autor",
"Copyright system" => "Sistema de Direitos de Autor",
"JsCalendar" => "Calendário Java Script",
"PhpLayers Dynamic menus" => "Menus dinâmicos PhpLayers",
"HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "Purificador de HTML(Conteúdo é convertido para XHTML 1.1 Strict a cada salvamento)",
"Drawings" => "Desenhos",
"Games" => "Jogos",
"Administration Features" => "Funcionalidades de administração",
"Banning System" => "Sistema de Banição",
"User Features" => "Funcionalidades de Utilizador",
"Newsreader" => "Notícias",
"Workflow engine" => "Motor de Workflow",
"Unknown/Other" => "Desconhecido/Outro",
"(some Unix MTA)" => "(alguns MTAs Unix)",
"PHP error reporting level:" => "Nível de reporte de erros PHP:",
"Tikiwiki.org help" => "Ajuda Tikiwiki.org",
"Store session data in database" => "Armazenar sessões no banco de dados",
"Default timezone" => "Fuso horário por omissão",
"Long date format" => "Formato longo para datas",
"Short date format" => "Formato curto para datas",
"Long time format" => "Formato longo para horas",
"Short time format" => "Formato curto para horas",
"Fields display order" => "Ordem de visualização dos campos",
"New password" => "Nova palavra-passe",
"Text Area" => "Área de Texto",
"HTTP port" => "Porta HTTP",
"HTTPS port" => "Porta HTTPS",
"PAM service" => "Serviço PAM",
"CAS server version" => "Versão de servidor CAS ",
"Reg users can change theme" => "Utilizadores registados podem alterar tema",
"Slideshows theme" => "Tema para slideshow",
"Site logo source (image path)" => "Origem do Logo do Site (caminho da imagem)",
"Site logo background color" => "Cor de fundo",
"Site logo alignment" => "Alinhamento do Logo do Site",
"Site logo title (on mouse over)" => "Texto mouseover",
"Site Breadcrumbs" => "<i>Migalhas</i> do site",
"at top of page" => "no topo da página",
"at top of center column" => "no topo do centro",
"entire location" => "toda a localização",
"page name" => "nome da página",
"Default RDF version" => "Versão RDF padrão",
"hits" => "visitas",
"Individual cache" => "Armazenamento individual",
"Regex search and replace" => "Suporte de expressões regulares (regex) na Procura e Substituição",
"Toolbar content" => "Conteúdo da barra de ferramentas",
"Assign permissions automatically" => "Atribuir permissões automaticamente",
"recommended for best performance" => "recomendado para melhor desempenho",
"image gal" => "gal. imagem",
"file gal" => "gal. ficheiro",
"Admin chart items" => "Administrar Itens de gráficos",
"Edit Chart" => "Editar gráfico",
"Chart items" => "Itens de Gráficos",
"No items defined yet" => "Nenhum item foi definido ainda",
"Add or edit a chart" => "Adicionar ou editar um gráfico",
"Users can vote for only one item from this chart per period" => "Utilizadores podem votar em um único item por período",
"Prevent users from voting for the same item more than once" => "Previne que utilizadores votem no mesmo item mais de uma vez",
"Users can suggest new items" => "Utilizadores podem sugerir novos itens",
"Auto validate user suggestions" => "Validar automaticamente sugestões de utilizadores",
"Ranking shows" => "Posições exibe",
"All items" => "Todos os itens",
"Top 10 items" => "10 itens superiores",
"Top 20 items" => "20 itens superiores",
"Top 40 items" => "40 itens superiores",
"Top 50 items" => "50 itens superiores",
"Top 100 items" => "100 itens superiores",
"Top 250 items" => "250 itens superiores",
"Voting system" => "Sistema de votação",
"Vote items" => "Itens de voto",
"Rank 1..5" => "Posição 1..5",
"Rank 1..10" => "Posição 1..10",
"Ranking frequency" => "Frequência de posição",
"Realtime" => "Tempo real",
"Each 5 minutes" => "A cada 5 minutos",
"Show Average" => "Exibir a Média",
"Show Votes" => "Exibir Votos",
"Use Cookies for unregistered users" => "Utilizar cookies para utilizadores não registados",
"Users can vote again after" => "Utilizadores podem votar novamente após",
"Anytime" => "A qualquer hora",
"No charts defined yet" => "Nenhum gráfico ainda definido",
"Admin drawings" => "Administrar desenhos",
"Available drawings" => "Desenhos disponíveis",
"no display" => "não mostrar",
"Available polls" => "Sondagens disponíveis",
"Random image from" => "Imagem aleatória a partir de",
"Dynamic content blocks" => "Blocos de conteúdo dinâmico",
"Banner zones" => "Zonas de Banner",
"Admin Quicktags" => "Admininstrar Quicktags",
"Create/Edit QuickTags" => "Criar/Editar QuickTags",
"Insert (use 'text' for figuring the selection)" => "Inserir (utilizar 'text' para determinar a selecção)",
"Path to the tag icon" => "Caminho para o ícone de tag",
"Admin RSS Modules" => "Administrar módulos RSS",
"show feed title" => "mostrar título da fonte",
"show publish date" => "mostrar data de publicação",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Nota: Terá que importar informação de segurança via processo de instalação (<a href=\"tiki-install.php\">tiki-install.php</a>). Importe os ficheiros de actualização *secdb* na sua base de dados.",
"Templates compiler" => "Compilador de templates",
"Compile" => "Compilar",
"Group Homepage" => "Homepage de Grupo",
"Group Theme" => "Tema para o grupo",
"Members List" => "Lista de membros",
"Rejected users" => "Utilizadores rejeitados",
"Edit Account Settings" => "Editar parâmetros da conta",
"Assign User {\$assign_user} to Groups" => "Atribuir grupos ao utilizador {\$assign_user}",
"Default Group" => "Grupo Padrão",
"Old password" => "Palavra-passe antiga",
"Parent category" => "Categoria-Pai",
"Most visited sub-categories" => "Sub-categorias mais visitadas",
"Category description" => "Descrição da categoria",
"Random sub-categories" => "Sub-categorias aleatórias",
"Allow sites in this category" => "Permitir sites nesta categoria",
"Show number of sites in this category" => "Mostrar número de sites nesta categoria",
"Subcategories" => "Sub-categorias",
"Admin related categories" => "Administrar categorias relacionadas",
"Add a related category" => "Adicionar uma categoria relacionada",
"Related categories" => "Categorias relacionadas",
"Add a Category" => "Adicionar Categoria",
"in current category" => "na categoria actual",
"Total categories" => "Total de categorias",
"creates the editable drawing foo" => "cria o desenho editável foo",
"table" => "tabela",
"table new" => "nova tabela",
"external link" => "link externo",
"heading1" => "cabeçalho1",
"title bar" => "barra de título",
"box" => "caixa",
"rss feed" => "fonte rss",
"dynamic content" => "conteúdo dinâmico",
"center text" => "centralizar texto",
"colored text" => "texto colorido",
"dynamic variable" => "variável dinâmica",
"special chars" => "carac especiais",
"special characters" => "caracteres especiais",
"Questions per page" => "Perguntas por página",
"Activity completed" => "Actividade terminada",
"Admin process activities" => "Administrar actividades do processo",
"Add or edit an activity" => "Adicionar ou editar uma actividade",
"activity" => "actividade",
"split" => "dividir",
"join" => "unir",
"standalone" => "independente",
"interactive" => "interactiva",
"auto routed" => "encaminhado automaticamente",
"Add transitions" => "Adicionar transições",
"Add transition from:" => "Adicionar uma transição de:",
"Add transition to:" => "Adicionar uma transição para:",
"No roles associated to this activity" => "Não há um perfil associado a esta actividade",
"Add Role" => "Adicionar perfil",
"Add New" => "Adicionar novo",
"Process activities" => "Actividades do processo",
"Routing" => "Encaminhamento",
"Interactive" => "Interactivo",
"Automatic" => "Automático",
"Auto routed" => "Encaminhado automaticamente",
"route" => "rota",
"(no roles)" => "(sem perfil)",
"No activities defined yet" => "Nenhuma actividade definida ainda",
"Process Transitions" => "Transições do Processo",
"List of transitions" => "Lista de transições",
"Origin" => "Origem",
"No transitions defined yet" => "Nenhuma transição definida ainda",
"Add a transition" => "Adicionar uma transição",
"This process is invalid" => "Este processo é inválido",
"List of processes" => "Lista de processos",
"Inactive" => "Inactivo",
"Active Process" => "Processo activo",
"Invalid Process" => "Processo inválido",
"Valid Process" => "Processo válido",
"Activities" => "Actividades",
"New Minor" => "Novo secundário",
"New Major" => "Novo principal",
"No processes defined yet" => "Nenhum processo definido ainda",
"Admin instance" => "Administrar instância",
"Process:" => "Processo:",
"Instance" => "Instância",
"Workitems" => "itens de trabalho",
"exception" => "excepção",
"completed" => "completado",
"Send all to" => "Enviar todos para",
"Don't move" => "Não mover",
"Act status" => "Estado da Actvd",
"Property" => "Propriedade",
"Add property" => "Adicionar propriedade",
"run instance" => "executar instância",
"Admin processes" => "Administrar processos",
"Galaxia Admin Processes" => "Administrar Processos do Galaxia",
"Add or edit a process" => "Adicionar ou editar um processo",
"Process Name" => "Nome do Processo",
"is active?" => "Activo?",
"Or upload a process using this form" => "Ou carregue um processo usando este formulário",
"Admin process roles" => "Administrar Papéis de processo",
"Add or edit a role" => "Adicionar ou editar um Papel",
"Process roles" => "Papéis de processo",
"No roles defined yet" => "Nenhum Papel definido ainda",
"Map users to roles" => "Associar utilizadores a perfis",
"map" => "associar",
"Map groups to roles" => "Associar grupos a Papéis",
"Operation" => "Operação",
"No roles are defined yet so no roles can be mapped" => "Nenhuma regra definida, associação impossível",
"List of mappings" => "Lista de associações",
"No mappings defined yet" => "Nenhuma associação definida ainda",
"Admin process sources" => "Administrar fontes de processo",
"select source" => "seleccionar a fonte",
"Shared code" => "Código compartilhado",
"Set next user" => "Definir próximo utilizador",
"Get property" => "Obter propriedade",
"Set property" => "Definir propriedade",
"Process form" => "Formulário de processamento",
"Set Next act" => "Definir próxima acção",
"Switch construct" => "Alternar diagrama",
"Map process roles" => "Associar perfis do processo",
"Admin Processes" => "Administrar processos",
"Admin Activities" => "Administrar atividades",
"Admin Roles" => "Administrar perfis",
"Edit this Process" => "Editar este processo",
"Monitor Activities" => "Monitorizar actividades",
"Galaxia Monitor Activities" => "Monitoramento de Actividades do Galaxia",
"Galaxia Monitor Activities tpl" => "Monitor Actividades Galaxia tpl",
"List of activities" => "Lista de actividades",
"routing" => "encaminhamento",
"Instances" => "Instâncias",
"run" => "executar",
"run activity" => "executar actividade",
"monitor processes" => "monitorizar processos",
"monitor activities" => "monitorizar actividades",
"monitor instances" => "monitorizar instâncias",
"monitor workitems" => "monitorizar itens de trabalho",
"Monitor Instances" => "Monitorizar instâncias",
"Galaxia Monitor Instances" => "Monitorização de Instâncias do Galaxia",
"List of instances" => "Lista de instâncias",
"No instances created yet" => "Nenhuma instância criada ainda",
"Monitor Processes" => "Monitorizar processos",
"Galaxia Monitor Processes" => " Processos do Monitor do Galaxia",
"processes" => "processos",
"being run" => "sendo executados",
"Exceptions" => "Excepções",
"Monitor workitems" => "Monitorizar itens de trabalho",
"List of workitems" => "Lista de itens de trabalho",
"instance" => "instância",
"exception instance" => "instância excepção",
"exceptions instance" => "instância excepções",
"Send Instance" => "Enviar instância",
"abort instance" => "abortar instância",
"grab instance" => "obter instância",
"release instance" => "libertar instância",
"User Activities" => "actividades de Utilizador",
"Galaxia User Activities" => "actividades de Utilizador do Galaxia",
"process" => "processo",
"user processes" => "processos de utilizadores",
"user activities" => "actividades de utilizadores",
"user instances" => "instâncias de utilizadores",
"User Instances" => "Instâncias de utilizadores",
"Galaxia User Instances" => "Instâncias de Utilizadores do Galaxia",
"Inst Status" => "Estado da inst",
"No instances defined yet" => "Nenhuma instância definida ainda",
"User Processes" => "Processos de utilizador",
"Galaxia User Processes" => "Processos de Utilizador do Galaxia",
"Browsing Workitem" => "Visualizando item de Trabalho",
"Workitem information" => "Informação do item de trabalho",
"Use cache for external pages" => "Usar Cache para páginas externas",
"All games are from" => "Todos os jogos são de",
"visit the site for more games and fun" => "visite o site para mais jogos e divertimento",
"Upload a game" => "Carregar um jogo",
"Upload a new game" => "Carregar um novo jogo",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Miniatura (se o jogo se chamar foo.swf a miniatura deve se chamar foo.swf.gif ou foo.swf.png ou foo.swf.jpg)",
"Edit game" => "Editar o jogo",
"Played" => "Jogado",
"If you can't see the game then you need a flash plugin for your browser" => "Se consegue visualizar o jogo então precisa instalar o plugin Flash no seu browser",
"Accepted requests" => "Aceitar requisições",
"since" => "desde",
"Assigned items" => "Itens atribuídos",
"Select news group" => "seleccionar grupo de news",
"Back to servers" => "Voltar aos servidores",
"Msgs" => "Mens",
"News from" => "Novidades de",
"Back to groups" => "Voltar aos grupos",
"Save position" => "Gravar a posição",
"Reading article from" => "Lendo artigo de",
"Back to list of articles" => "Voltar à lista de artigos",
"Configure news servers" => "Configurar servidores de news",
"Configure Newsreader" => "Configurar Newsreader",
"Select a news server to browse" => "seleccione um servidor de news para explorar",
"server" => "servidor",
"News server" => "Servidor de news",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "Para editar as permissões globais <a class=\"rbox-link\" href=\"tiki-admingroups.php\">clique aqui</a>.",
"Current permissions for this object" => "Permissões actuais para este objecto",
"No individual permissions, category permissions apply" => "Sem permissões individuais, aplicam-se as permissões de categoria",
"Current permissions for categories that this object belongs to" => "Permissões actuais para as categorias a que este objecto pertence",
"These permissions do not apply. Special permissions apply." => "Estas permissões não se aplicam. Apenas se aplicam permissões especiais.",
"No category permissions; global permissions apply" => "Sem permissões para a categoria. Aplicam-se as permissões globais",
"No category permissions; special permissions apply" => "Sem permissões para a categoria. Aplicam-se as permissões especiais",
"and also to all pages of the sub-structure:" => "e também a todas as páginas da sub-estrutura:",
"Perms Help" => "Ajuda sobre permissões",
"Tiki Shoutbox" => "Quadro Negro Tiki",
"Click to Navigate" => "Clique para navegar",
"Focus:" => "Foco:",
"big grin" => "grande sorriso",
"cry" => "chorando",
"evil" => "demónio",
"lol" => "engraçado",
"mr green" => "sr. verde",
"razz" => "insultuoso",
"redface" => "cara vermelha",
"rolleyes" => "olhos enrolados",
"smile" => "sorriso",
"surprised" => "surpreso",
"twisted" => "torcido",
"arrow" => "seta",
"Note: Maximum image size is limited to" => "Nota: Tamanho máximo da imagem está limitado a",
"Current folder" => "Pasta actual",
"Your personal Wiki Page" => "Sua página pessoal Wiki",
"Edit Items" => "Editar ítens",
"List Charts" => "Listar gráficos",
"Last Chart" => "último gráfico",
"Previous Chart" => "Gráfico anterior",
"Chart created" => "Gráfico criado",
"Next Chart" => "Próximo gráfico",
"Permanency" => "Permanência",
"chg" => "alt",
"Avg" => "Méd",
"info/vote" => "info/votar",
"Next chart will be generated on" => "Próximo gráfico será gerado em",
"View or vote items not listed in the chart" => "Ver ou votar em itens não listados no gráfico",
"Select something to vote on" => "seleccione uma votação",
"Item information" => "Informação do Item",
"Best Position" => "Melhor Posição",
"Vote this item" => "Votar neste item",
"Highest" => "Maior",
"RSS settings" => "Definições RSS",
"No chart indicated" => "Nenhum gráfico indicado",
"No process indicated" => "Nenhum processo indicado",
"Activity name already exists" => "Nome repetido para a actividade",
"indicates if the process is active. Invalid processes cant be active" => "indica se o processo está activo. Processos inválidos não podem ser acctivados",
"No instance indicated" => "Nenhuma instância indicada",
"No activity indicated" => "Nenhuma actividade editada",
"The process name already exists" => "Nome repetido para o processo",
"Process already exists" => "Processo já existente",
"You cant execute this activity" => "Você não pode editar esta actividade",
"The thumbnail name must be" => "O nome da miniatura deve ser",
"No server indicated" => "Nenhum servidor indicado",
"Cannot connect to" => "Impossível conectar-se a",
"Missing information to read news (server,port,username,password,group) required" => "A informação necessária para ler news (servidor, porta, username, palavra-passe, grupo) não foi fornecida",
"Cannot get messages" => "Impossível baixar as mensagens",
"Chat" => "Chat",
"Tiki Calendar" => "Calendário Tiki",
"Admin Menu" => "Administrar Menu",
"RSS Modules" => "Módulos RSS",
"Import PHPWiki Dump" => "Importar PHPWiki",
"Current events" => "Eventos",
"Tiki Logo" => "Logótipo Tiki",
"Email This Post" => "enviar por email",
"RSS feeds" => "Fontes RSS",
"Use titles in blog posts" => "Utilizar títulos nas mensagens do blog",
"Send blog post" => "Enviar mensagem blog",
"A link to this post was sent to the following addresses:" => "Um link para esta mensagem foi enviada para os seguintes endereços:",
"Send post to this addresses" => "Enviar a mensagem para estes endereços",
"List of email addresses separated by commas" => "Lista de endereços de email separados por vírgulas",
"Compose Message" => "Compor mensagem",
"Post recommendation at" => "Envie recomendações em",
"Prevent flooding" => "Prevenir-se contra sobrecarga",
"Minimum time between posts" => "Tempo mínimo entre mensagens",
"Moderator user" => "Utilizador moderador",
"Moderator group" => "Grupo moderador",
"Send this forums posts to this email" => "Enviar as mensagens deste fórum para o seguinte e-mail",
"Prune unreplied messages after" => "Mensagens não respondidas expiram após",
"Prune old messages after" => "Mensagens antigas expiram após",
"POP3 server" => "Servidor POP3",
"Max attachment size (bytes)" => "Tamanho máximo para ficheiro anexado (bytes)",
"Default ordering for topics" => "Ordenação padrão para os assuntos",
"Topics per page" => "Assuntos por página",
"Default ordering for threads" => "Ordenação padrão para as sequências",
"Includes" => "Inclusões",
"Assign Perms to this Group" => "Atribuir permissões a este grupo",
"Assign permissions to category" => "Atribuir permissões à categoria",
"Current permissions for this category" => "Permissões actuais para esta categoria",
"Assign permissions" => "Atribuir permissões",
"to group" => "ao grupo",
"this category &amp; all its children" => "esta categoria &amp; todos os filhos",
"this category only" => "esta categoria apenas",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Recomenda-se atribuir permissões para <b>todos os filhos</b> para melhor desempenho.",
"Your registration code:" => "Seu código de registo:",
"Registration code" => "Código de registo",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "For you to vote, cookies must be allowed" => "For you to vote, cookies must be allowed",
// "This forum is flat and doesn't allow replies to other replies" => "This forum is flat and doesn't allow replies to other replies",
// "Copyright management" => "Copyright management",
// "Tiki was unable to retrieve login data from the database " => "Tiki was unable to retrieve login data from the database ",
// "The following error message was returned" => "The following error message was returned",
// "Things to check" => "Things to check",
// "Are your database login credentials correct" => "Are your database login credentials correct",
// "Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Did you complete the <a href='tiki-install.php' >Tiki Installer",
// "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information",
// "This feature is for admins only" => "This feature is for admins only",
// "Last editor" => "Last editor",
// "Explorer" => "Explorer",
// "Slideshow" => "Slideshow",
// "Default View" => "Default View",
// "Afghanistan" => "Afghanistan",
// "Aland Islands" => "Aland Islands",
// "Albania" => "Albania",
// "Algeria" => "Algeria",
// "American Samoa" => "American Samoa",
// "Andorra" => "Andorra",
// "Angola" => "Angola",
// "Anguilla" => "Anguilla",
// "Antigua" => "Antigua",
// "Argentina" => "Argentina",
// "Armenia" => "Armenia",
// "Aruba" => "Aruba",
// "Australia" => "Australia",
// "Austria" => "Austria",
// "Azerbaijan" => "Azerbaijan",
// "Bahamas" => "Bahamas",
// "Bahrain" => "Bahrain",
// "Bangladesh" => "Bangladesh",
// "Barbados" => "Barbados",
// "Belarus" => "Belarus",
// "Belgium" => "Belgium",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bermuda" => "Bermuda",
// "Bhutan" => "Bhutan",
// "Bolivia" => "Bolivia",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "Brazil" => "Brazil",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "Brunei" => "Brunei",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cameroon" => "Cameroon",
// "Canada" => "Canada",
// "Cape Verde" => "Cape Verde",
// "Catalan Countries" => "Catalan Countries",
// "Cayman Islands" => "Cayman Islands",
// "Central African Republic" => "Central African Republic",
// "Chad" => "Chad",
// "Chile" => "Chile",
// "China" => "China",
// "Christmas Island" => "Christmas Island",
// "Cocos Islands" => "Cocos Islands",
// "Colombia" => "Colombia",
// "Comoros" => "Comoros",
// "Congo" => "Congo",
// "Congo Democratic" => "Congo Democratic",
// "Cook Islands" => "Cook Islands",
// "Costa Rica" => "Costa Rica",
// "Croatia" => "Croatia",
// "Cuba" => "Cuba",
// "Cyprus" => "Cyprus",
// "Czech Republic" => "Czech Republic",
// "Denmark" => "Denmark",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Dominican Republic" => "Dominican Republic",
// "Ecuador" => "Ecuador",
// "Egypt" => "Egypt",
// "El Salvador" => "El Salvador",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Eritrea" => "Eritrea",
// "Estonia" => "Estonia",
// "Ethiopia" => "Ethiopia",
// "Europe" => "Europe",
// "Falkland Islands" => "Falkland Islands",
// "Faroe Islands" => "Faroe Islands",
// "Federated States of Micronesia" => "Federated States of Micronesia",
// "Fiji" => "Fiji",
// "Finland" => "Finland",
// "France" => "France",
// "French Guiana" => "French Guiana",
// "French Polynesia" => "French Polynesia",
// "French Southern Territories" => "French Southern Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Germany" => "Germany",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greece" => "Greece",
// "Greenland" => "Greenland",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guam" => "Guam",
// "Guatemala" => "Guatemala",
// "Guernsey" => "Guernsey",
// "Guinea" => "Guinea",
// "Guinea Bissau" => "Guinea Bissau",
// "Guyana" => "Guyana",
// "Haiti" => "Haiti",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Honduras" => "Honduras",
// "Hong Kong" => "Hong Kong",
// "Hungary" => "Hungary",
// "Iceland" => "Iceland",
// "India" => "India",
// "Indonesia" => "Indonesia",
// "Iran" => "Iran",
// "Iraq" => "Iraq",
// "Ireland" => "Ireland",
// "Isle of Man" => "Isle of Man",
// "Israel" => "Israel",
// "Italy" => "Italy",
// "Ivory Coast" => "Ivory Coast",
// "Jamaica" => "Jamaica",
// "Japan" => "Japan",
// "Jersey" => "Jersey",
// "Jordan" => "Jordan",
// "Kazakstan" => "Kazakstan",
// "Kenya" => "Kenya",
// "Kiribati" => "Kiribati",
// "Kuwait" => "Kuwait",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Latvia" => "Latvia",
// "Lebanon" => "Lebanon",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Lithuania" => "Lithuania",
// "Luxemburg" => "Luxemburg",
// "Macao" => "Macao",
// "Macedonia" => "Macedonia",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
// "Malaysia" => "Malaysia",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Malta" => "Malta",
// "Marshall Islands" => "Marshall Islands",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mauritius" => "Mauritius",
// "Mayotte" => "Mayotte",
// "Mexico" => "Mexico",
// "Moldova" => "Moldova",
// "Monaco" => "Monaco",
// "Mongolia" => "Mongolia",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Morocco" => "Morocco",
// "Mozambique" => "Mozambique",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
// "Nepal" => "Nepal",
// "Netherlands" => "Netherlands",
// "Netherlands Antilles" => "Netherlands Antilles",
// "New Caledonia" => "New Caledonia",
// "New Zealand" => "New Zealand",
// "Nicaragua" => "Nicaragua",
// "Niger" => "Niger",
// "Nigeria" => "Nigeria",
// "Niue" => "Niue",
// "Norfolk Island" => "Norfolk Island",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "North Korea" => "North Korea",
// "Norway" => "Norway",
// "Oman" => "Oman",
// "Pakistan" => "Pakistan",
// "Palau" => "Palau",
// "Palestine" => "Palestine",
// "Panama" => "Panama",
// "Papua New Guinea" => "Papua New Guinea",
// "Paraguay" => "Paraguay",
// "Peru" => "Peru",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Poland" => "Poland",
// "Portugal" => "Portugal",
// "Puerto Rico" => "Puerto Rico",
// "Quatar" => "Quatar",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Reunion" => "Reunion",
// "Romania" => "Romania",
// "Russia" => "Russia",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "Samoa" => "Samoa",
// "San Marino" => "San Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Saudi Arabia" => "Saudi Arabia",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "Singapore" => "Singapore",
// "Slovakia" => "Slovakia",
// "Slovenia" => "Slovenia",
// "Solomon Islands" => "Solomon Islands",
// "Somalia" => "Somalia",
// "South Africa" => "South Africa",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "South Korea" => "South Korea",
// "Spain" => "Spain",
// "Sri Lanka" => "Sri Lanka",
// "St Vincent Grenadines" => "St Vincent Grenadines",
// "Sudan" => "Sudan",
// "Surinam" => "Surinam",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Swaziland" => "Swaziland",
// "Sweden" => "Sweden",
// "Switzerland" => "Switzerland",
// "Syria" => "Syria",
// "Taiwan" => "Taiwan",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Thailand" => "Thailand",
// "Timor-Leste" => "Timor-Leste",
// "Togo" => "Togo",
// "Tokelau" => "Tokelau",
// "Tonga" => "Tonga",
// "Trinidad Tobago" => "Trinidad Tobago",
// "Tunisia" => "Tunisia",
// "Turkey" => "Turkey",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Tuvalu" => "Tuvalu",
// "Uganda" => "Uganda",
// "Ukraine" => "Ukraine",
// "United Arab Emirates" => "United Arab Emirates",
// "United Kingdom" => "United Kingdom",
// "United Nations Organization" => "United Nations Organization",
// "United States" => "United States",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "Uruguay" => "Uruguay",
// "US Virgin Islands" => "US Virgin Islands",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
// "Vatican" => "Vatican",
// "Venezuela" => "Venezuela",
// "Viet Nam" => "Viet Nam",
// "Wales" => "Wales",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Western Sahara" => "Western Sahara",
// "World" => "World",
// "Yemen" => "Yemen",
// "Yugoslavia" => "Yugoslavia",
// "Zambia" => "Zambia",
// "Zimbabwe" => "Zimbabwe",
// "MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Requires MySQL 4.1+",
// "MySQL classic (mysql)" => "MySQL classic (mysql)",
// "PostgreSQL" => "PostgreSQL",
// "Email address not valid, test mail not sent" => "Email address not valid, test mail not sent",
// "Email address empty and \"copy\" checkbox not set, test mail not sent" => "Email address empty and \"copy\" checkbox not set, test mail not sent",
// "Test mail from Tiki installer " => "Test mail from Tiki installer ",
// "Tiki version" => "Tiki version",
// "PHP version" => "PHP version",
// "Server" => "Server",
// "Sent" => "Sent",
// "Congratulations!\n\nYour server can send emails.\n\n" => "Congratulations!\n\nYour server can send emails.\n\n",
// "Slovene" => "Slovene",
// "Arabic" => "Arabic",
// "Catalan" => "Catalan",
// "English British" => "English British",
// "Farsi" => "Farsi",
// "Finnish" => "Finnish",
// "Fijian" => "Fijian",
// "Galician" => "Galician",
// "Croatian" => "Croatian",
// "Korean" => "Korean",
// "Hungarian" => "Hungarian",
// "Português" => "Português",
// "Pijin Solomon" => "Pijin Solomon",
// "Serbian Latin" => "Serbian Latin",
// "Tuvaluan" => "Tuvaluan",
// "Ukrainian" => "Ukrainian",
// "Template %s not registered" => "Template %s not registered",
// "Error line: %d" => "Error line: %d",
// "All Day" => "All Day",
// "(not registered)" => "(not registered)",
// "You have mistyped the anti-bot verification code; please try again" => "You have mistyped the anti-bot verification code; please try again",
// "Please wait %d seconds between posts" => "Please wait %d seconds between posts",
// "A contribution is mandatory" => "A contribution is mandatory",
// "Invalid Email" => "Invalid Email",
// "This forum is locked" => "This forum is locked",
// "This thread is locked" => "This thread is locked",
// "Those comments are locked" => "Those comments are locked",
// "Line" => "Line",
// "Lines" => "Lines",
// "Newsletter subscription information at" => "Newsletter subscription information at",
// "Cannot open this file" => "Cannot open this file",
// "The global quota has been reached" => "The global quota has been reached",
// "The quota has been reached in" => "The quota has been reached in",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transfered to the database" => "Number of files transfered to the database",
// "Number of files transfered to the file system" => "Number of files transfered to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "This is an approximation based on your server memory limit" => "This is an approximation based on your server memory limit",
// "This is the value of your server's PHP '%s' setting" => "This is the value of your server's PHP '%s' setting",
// "You are alerted by the server " => "You are alerted by the server ",
// "You can check the modifications at : " => "You can check the modifications at : ",
// "You are alerted of a change on " => "You are alerted of a change on ",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Contributions" => "Contributions",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "File %s not found" => "File %s not found",
// "File %s is not a valid archive" => "File %s is not a valid archive",
// "Impossible to open %s : %s" => "Impossible to open %s : %s",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No box" => "No box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Perspective" => "Perspective",
// "Only display the module if in one of the listed perspectives. Semi-colon separated" => "Only display the module if in one of the listed perspectives. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "section edit" => "section edit",
// "This poll is closed" => "This poll is closed",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Default number per page" => "Default number per page",
// "Default Ordering" => "Default Ordering",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and PAM" => "Tiki and PAM",
// "Tiki and LDAP" => "Tiki and LDAP",
// "CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
// "Shibboleth" => "Shibboleth",
// "Available languages" => "Available languages",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Blogues" => "Blogues",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Exclude these categories" => "Exclude these categories",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Spell checking" => "Spell checking",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "Default charset for sending mail" => "Default charset for sending mail",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "'),\n\t\t\t'type' => 'flag" => "'),\n\t\t\t'type' => 'flag",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "'),\n\t\t\t'type' => 'text" => "'),\n\t\t\t'type' => 'text",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "Faqs" => "Faqs",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Enables searching for content on the website" => "Enables searching for content on the website",
// "Freetags" => "Freetags",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Multilingual" => "Multilingual",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Quizzes " => "Quizzes ",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "Multimedia" => "Multimedia",
// "The applet is designed to read MP3 or FLV file" => "The applet is designed to read MP3 or FLV file",
// "Experimental. This feature is not actively maintained" => "Experimental. This feature is not actively maintained",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Tell a Friend" => "Tell a Friend",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "HTML pages" => "HTML pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Minichat" => "Minichat",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation " => "Comments Moderation ",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments Locking" => "Comments Locking",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow posting of comments as Anonymous" => "Allow posting of comments as Anonymous",
// "Permit anonymous visitors to add a comment without needing to create an account" => "Permit anonymous visitors to add a comment without needing to create an account",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page title" => "Display page title",
// "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header" => "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "JavaScript popup date selector" => "JavaScript popup date selector",
// "Output should be HTMLPurified" => "Output should be HTMLPurified",
// "This enable HTPMPurifier on outputs to filter remaining security problems like XSS" => "This enable HTPMPurifier on outputs to filter remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "Allow users to activate fullscreen mode" => "Allow users to activate fullscreen mode",
// "Css Menus" => "Css Menus",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Shadowbox" => "Shadowbox",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "Intertiki" => "Intertiki",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "Search engine friendly url" => "Search engine friendly url",
// "SpreadSheet" => "SpreadSheet",
// "Ajax auto-save" => "Ajax auto-save",
// "Save draft" => "Save draft",
// "Requires AJAX (experimental)" => "Requires AJAX (experimental)",
// "Kaltura" => "Kaltura",
// "Friendship Network" => "Friendship Network",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Action calendar" => "Action calendar",
// "Redirect to a similar wiki page if an exact match is not found" => "Redirect to a similar wiki page if an exact match is not found",
// "Group Watches" => "Group Watches",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
// "Group Alert" => "Group Alert",
// "TikiTests" => "TikiTests",
// "Use Minified Scripts" => "Use Minified Scripts",
// "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions" => "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions",
// "Check for updates automatically" => "Check for updates automatically",
// "TikiWiki will check for updates when you access the main Administration page" => "TikiWiki will check for updates when you access the main Administration page",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "External link icon" => "External link icon",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Category path" => "Category path",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Screencasts" => "Screencasts",
// "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share" => "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share",
// "Screencasts upload location" => "Screencasts upload location",
// "Local path or webdav path to the file upload location" => "Local path or webdav path to the file upload location",
// "Trailing slash required" => "Trailing slash required",
// "Screencasts HTTP prefix" => "Screencasts HTTP prefix",
// "Prefix to use for the files when generating a link to it" => "Prefix to use for the files when generating a link to it",
// "Screencast upload type" => "Screencast upload type",
// "Mode used to upload files. WebDav is used to upload to remote servers" => "Mode used to upload files. WebDav is used to upload to remote servers",
// "Webdav" => "Webdav",
// "Screencasts authentication user" => "Screencasts authentication user",
// "When using webdav to upload files, used as the username of the authentication credentials" => "When using webdav to upload files, used as the username of the authentication credentials",
// "Screencasts authentication password" => "Screencasts authentication password",
// "When using webdav to upload files, used as the password of the authentication credentials" => "When using webdav to upload files, used as the password of the authentication credentials",
// "Screencasts max file size" => "Screencasts max file size",
// "Maximum file size used for screencasts" => "Maximum file size used for screencasts",
// "Value provided in bytes" => "Value provided in bytes",
// "Page List" => "Page List",
// "The pagelist feature allows to maintain lists of pages and their associated score and priority" => "The pagelist feature allows to maintain lists of pages and their associated score and priority",
// "Database search" => "Database search",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
// "Last modified date" => "Last modified date",
// "Blog-level" => "Blog-level",
// "Batch uploading" => "Batch uploading",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Forum name search" => "Forum name search",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Admins can search for features in the admin panels" => "Admins can search for features in the admin panels",
// "Encryption method" => "Encryption method",
// "tikihash (old)" => "tikihash (old)",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "Podcast directory" => "Podcast directory",
// "Required for podcasts" => "Required for podcasts",
// "Prevent download if score becomes negative" => "Prevent download if score becomes negative",
// "Allow download limit per file" => "Allow download limit per file",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for illimitted)" => "(0 for illimitted)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Description length" => "Description length",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Default ordering" => "Default ordering",
// "Creation Date (asc)" => "Creation Date (asc)",
// "Threads (desc)" => "Threads (desc)",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Default language" => "Default language",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "The default help system may not be complete. You can help with the TikiWiki documentation" => "The default help system may not be complete. You can help with the TikiWiki documentation",
// "License page" => "License page",
// "Submit notice" => "Submit notice",
// "Full path to ogr2ogr" => "Full path to ogr2ogr",
// "Map Zone" => "Map Zone",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Url to go when clicking on a username" => "Url to go when clicking on a username",
// "Default: " => "Default: ",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Verify for available translations in the database" => "Verify for available translations in the database",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Log SQL" => "Log SQL",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Mail end of line" => "Mail end of line",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache flags" => "Memcache flags",
// "Configuration switches for memcache connection" => "Configuration switches for memcache connection",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Allow users to define icons for menus entries" => "Allow users to define icons for menus entries",
// "Default path for the icons" => "Default path for the icons",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID" => "One domain per line. Comma separated with perspective ID",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "Show categories" => "Show categories",
// "Show objects" => "Show objects",
// "Host" => "Host",
// "Proxy host" => "Proxy host",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Parse the results" => "Parse the results",
// "Sender email" => "Sender email",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes" => "Value provided in minutes",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "After" => "After",
// "Before" => "Before",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Check frequency" => "Check frequency",
// "Each day" => "Each day",
// "Each week" => "Each week",
// "Each month" => "Each month",
// "Minify javascript" => "Minify javascript",
// "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared" => "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared",
// "Use Jquery autocomplete user selector for better performance when number of users exceed" => "Use Jquery autocomplete user selector for better performance when number of users exceed",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Module decides" => "Module decides",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Unlimited" => "Unlimited",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Wiki link format" => "Wiki link format",
// "Character set used when detecting wiki links within pages" => "Character set used when detecting wiki links within pages",
// "Latin" => "Latin",
// "Display by default only pages in current language" => "Display by default only pages in current language",
// "In Wiki page lists, display by default only pages in current language" => "In Wiki page lists, display by default only pages in current language",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "Page last modified on" => "Page last modified on",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line location" => "Wiki top line location",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per page" => "Allow comments per page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Spring (connection) size" => "Spring (connection) size",
// "Enable plugin %0" => "Enable plugin %0",
// "Inline plugin %0 (hide plugin edit icon)" => "Inline plugin %0 (hide plugin edit icon)",
// "When inlined, the plugin edit icon will not appear" => "When inlined, the plugin edit icon will not appear",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Default" => "Default",
// "Office 2003" => "Office 2003",
// "Silver" => "Silver",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "User %0 was added to %1" => "User %0 was added to %1",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "Forums last posts" => "Forums last posts",
// "The passwords do not match" => "The passwords do not match",
// "The registration mail can't be sent. Contact the administrator" => "The registration mail can't be sent. Contact the administrator",
// "uploaded the file" => "uploaded the file",
// "changes" => "changes",
// "No changes" => "No changes",
// "Yesterday" => "Yesterday",
// "and" => "and",
// "more changes of the same type.." => "more changes of the same type..",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "onto" => "onto",
// "removed the picture" => "removed the picture",
// "edited the wikipage" => "edited the wikipage",
// "this history" => "this history",
// "all history" => "all history",
// "edited the file gallery" => "edited the file gallery",
// "removed the file" => "removed the file",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
// "edited the category" => "edited the category",
// "removed the article" => "removed the article",
// "created the article" => "created the article",
// "edited the article" => "edited the article",
// "replied to the blog" => "replied to the blog",
// "created the topic" => "created the topic",
// "at forum" => "at forum",
// "to the topic" => "to the topic",
// "Nothing has happened" => "Nothing has happened",
// "Feed provided by %s. Click to visit" => "Feed provided by %s. Click to visit",
// "See other users' profiles" => "See other users' profiles",
// "Have your profile seen" => "Have your profile seen",
// "Make friends" => "Make friends",
// "Receive message" => "Receive message",
// "Read an article" => "Read an article",
// "Publish an article" => "Publish an article",
// "Have your article read" => "Have your article read",
// "Create new file gallery" => "Create new file gallery",
// "Upload new file to gallery" => "Upload new file to gallery",
// "Download other user's file" => "Download other user's file",
// "Have your file downloaded" => "Have your file downloaded",
// "Create a new image gallery" => "Create a new image gallery",
// "Upload new image to gallery" => "Upload new image to gallery",
// "See other users' galleries" => "See other users' galleries",
// "See other users' images" => "See other users' images",
// "Have your gallery seen by other users" => "Have your gallery seen by other users",
// "Have your image seen" => "Have your image seen",
// "Create new blog" => "Create new blog",
// "Post in a blog" => "Post in a blog",
// "Read other users' blogs" => "Read other users' blogs",
// "Have your blog read" => "Have your blog read",
// "Create a new wiki page" => "Create a new wiki page",
// "Edit an existing page" => "Edit an existing page",
// "Wiki Comment" => "Wiki Comment",
// "Calendar item" => "Calendar item",
// "Tracker item" => "Tracker item",
// "Simple" => "Simple",
// "Advanced" => "Advanced",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "First {\$params['itemname']}" => "First {\$params['itemname']}",
// "Last {\$params['itemname']}" => "Last {\$params['itemname']}",
// "Next {\$params['itemname']}" => "Next {\$params['itemname']}",
// "Prev {\$params['itemname']}" => "Prev {\$params['itemname']}",
// "tip" => "tip",
// "warning" => "warning",
// "note" => "note",
// "errors" => "errors",
// "information" => "information",
// "Tab View" => "Tab View",
// "No Tabs" => "No Tabs",
// "If you want the saved version instead of this autosaved one" => "If you want the saved version instead of this autosaved one",
// "AutoSave" => "AutoSave",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "Your edit session has expired" => "Your edit session has expired",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Help page" => "Help page",
// "The text is" => "The text is",
// "character(s) too long - please edit it" => "character(s) too long - please edit it",
// "phplayers are not available on this site" => "phplayers are not available on this site",
// "Preference name not specified" => "Preference name not specified",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "Invert Sort" => "Invert Sort",
// "No rows found" => "No rows found",
// "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "sec" => "sec",
// "Text cut here" => "Text cut here",
// "Task" => "Task",
// "End date" => "End date",
// "Friend" => "Friend",
// "Gender" => "Gender",
// "km" => "km",
// "Last seen on" => "Last seen on",
// "(idle for %s seconds)" => "(idle for %s seconds)",
// "User information - Click for more info" => "User information - Click for more info",
// "More info about \$other_user" => "More info about \$other_user",
// "(idle for \$idletime seconds)" => "(idle for \$idletime seconds)",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string",
// "Use this tree to copy the structure" => "Use this tree to copy the structure",
// "Table of contents" => "Table of contents",
// "You have to make %d choice(s) for the question" => "You have to make %d choice(s) for the question",
// "You have to make at least %d choice(s) for the question" => "You have to make at least %d choice(s) for the question",
// "You have to make less than %d choice(s) for the question" => "You have to make less than %d choice(s) for the question",
// "You have to choose at least %d choice(s) for the question" => "You have to choose at least %d choice(s) for the question",
// "Foo" => "Foo",
// "Sample plugin" => "Sample plugin",
// "Face" => "Face",
// "Font family to use" => "Font family to use",
// "As defined by CSS" => "As defined by CSS",
// "unknown error" => "unknown error",
// "Page '%0' cannot be found" => "Page '%0' cannot be found",
// "For the security of your password direct access to the feed is only available via https" => "For the security of your password direct access to the feed is only available via https",
// "Help link" => "Help link",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "arts" => "arts",
// "Edit Plugin" => "Edit Plugin",
// "Edit Section" => "Edit Section",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "The file you are trying upload was only partially uploaded" => "The file you are trying upload was only partially uploaded",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Flash player not available" => "Flash player not available",
// "%d points" => "%d points",
// "__WARNING__: Plugin disabled \$plugin" => "__WARNING__: Plugin disabled \$plugin",
// "__WARNING__: No such module \$plugin" => "__WARNING__: No such module \$plugin",
// "Create page" => "Create page",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed" => "Non-parsed",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif" => "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif",
// "Block Quote" => "Block Quote",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "Unordered List" => "Unordered List",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif" => "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "Background Color" => "Background Color",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "External Link" => "External Link",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "Table Builder" => "Table Builder",
// "pics/icons/find.png" => "pics/icons/find.png",
// "Find Text" => "Find Text",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full Screen Edit" => "Full Screen Edit",
// "pics/icons/arrow_in.png" => "pics/icons/arrow_in.png",
// "pics/icons/arrow_out.png" => "pics/icons/arrow_out.png",
// "Choose or upload images" => "Choose or upload images",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Admin Toolbars" => "Admin Toolbars",
// "Upload was not successful. Duplicate file content " => "Upload was not successful. Duplicate file content ",
// "View the tracker item at" => "View the tracker item at",
// "Field is not a link to mp3 in the gallery" => "Field is not a link to mp3 in the gallery",
// "Field is not a link to FLV in the gallery" => "Field is not a link to FLV in the gallery",
// "Field is not a link to FLV or MP3 in the gallery" => "Field is not a link to FLV or MP3 in the gallery",
// "prepend" => "prepend",
// "append" => "append",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "numeric field" => "numeric field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "country selector" => "country selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "jscalendar" => "jscalendar",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "header" => "header",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "item link" => "item link",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "items list" => "items list",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "multimedia" => "multimedia",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "The administrator has not yet validated your account. Please wait" => "The administrator has not yet validated your account. Please wait",
// "You must validate your account first. An email has been sent to you" => "You must validate your account first. An email has been sent to you",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Personal Phone" => "Personal Phone",
// "Personal Mobile" => "Personal Mobile",
// "Personal Fax" => "Personal Fax",
// "Work Phone" => "Work Phone",
// "Work Mobile" => "Work Mobile",
// "Work Fax" => "Work Fax",
// "Company" => "Company",
// "Organization" => "Organization",
// "Department" => "Department",
// "Division" => "Division",
// "Job Title" => "Job Title",
// "Street Address" => "Street Address",
// "City" => "City",
// "State" => "State",
// "Zip Code" => "Zip Code",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "User-Agent Info" => "User-Agent Info",
// "Displays various information about the client" => "Displays various information about the client",
// "Info" => "Info",
// "Info required - IP|SVRSW|BROWSER" => "Info required - IP|SVRSW|BROWSER",
// "Displays browser client info" => "Displays browser client info",
// "Anchor Link" => "Anchor Link",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor" => "The name of the wiki page containing the anchor",
// "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor",
// "linktext" => "linktext",
// "Anchor Name" => "Anchor Name",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "The name of the anchor" => "The name of the anchor",
// "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor",
// "Image Annotation" => "Image Annotation",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tikiwiki root" => "Absolute URL to the image or relative path from tikiwiki root",
// "Width" => "Width",
// "Image width" => "Image width",
// "Height" => "Height",
// "Image height" => "Image height",
// "Alignment" => "Alignment",
// "Image alignment. Possible values: left, right, center" => "Image alignment. Possible values: left, right, center",
// "Save changes to annotations" => "Save changes to annotations",
// "Image annotations changed" => "Image annotations changed",
// "Creates an annotation block for an image" => "Creates an annotation block for an image",
// "Displays an image and enables users to define zones to highlight information on the image" => "Displays an image and enables users to define zones to highlight information on the image",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "Article List" => "Article List",
// "Inserts a list of articles in the page" => "Inserts a list of articles in the page",
// "Articles displayed" => "Articles displayed",
// "The number of articles to display in the list" => "The number of articles to display in the list",
// "Topics expression" => "Topics expression",
// "Topic ID expression" => "Topic ID expression",
// "Type expression" => "Type expression",
// "Category ID" => "Category ID",
// "The ID of the category to list from" => "The ID of the category to list from",
// "The article language to list" => "The article language to list",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles" => "Whether to not report when there are no articles",
// "Title only" => "Title only",
// "Whether to only show the title of the articles" => "Whether to only show the title of the articles",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "Bullets" => "Bullets",
// "Inline" => "Inline",
// "Number" => "Number",
// "Show icon" => "Show icon",
// "No such attachment on this page" => "No such attachment on this page",
// "Displays an attachment or a list of them" => "Displays an attachment or a list of them",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "The wiki page the avatar will link to" => "The wiki page the avatar will link to",
// "Float" => "Float",
// "left|right" => "left|right",
// "Displays a link that allows to go back in the browser history" => "Displays a link that allows to go back in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed information" => "Displayed information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "1|0" => "1|0",
// "No Header" => "No Header",
// "Banner" => "Banner",
// "Insert a banner" => "Insert a banner",
// "Target" => "Target",
// "missing parameter" => "missing parameter",
// "Blog List" => "Blog List",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "Numeric value" => "Numeric value",
// "Maximum number of entries to list" => "Maximum number of entries to list",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Box" => "Box",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Float Position" => "Float Position",
// "for box with width less than 100%, make text wrap around the box" => "for box with width less than 100%, make text wrap around the box",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar filter" => "Calendar filter",
// "If set to a calendar identifier, restricts the events displayed to those in the specified calendar" => "If set to a calendar identifier, restricts the events displayed to those in the specified calendar",
// "View type" => "View type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "View the navigation bar" => "View the navigation bar",
// "Decide or not to show the navigation bar" => "Decide or not to show the navigation bar",
// "Includes a calendar" => "Includes a calendar",
// "~np~{CALENDAR(calendarId=>1)}{CALENDAR}" => "~np~{CALENDAR(calendarId=>1)}{CALENDAR}",
// "Id is optional. If not given, all calendars viewable by default are used" => "Id is optional. If not given, all calendars viewable by default are used",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
// "Sort Order" => "Sort Order",
// "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle",
// "Split" => "Split",
// "And" => "And",
// "With sub-categories" => "With sub-categories",
// "Show object name" => "Show object name",
// "Show type" => "Show type",
// "Incorrect param" => "Incorrect param",
// "Category Orphans" => "Category Orphans",
// "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
// "Category Path" => "Category Path",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display top category" => "Display top category",
// "yes|no, default to no" => "yes|no, default to no",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels" => "Labels",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Enable word wrapping on the code to avoid breaking the layout",
// "Colors" => "Colors",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Line numbers" => "Line numbers",
// "0|1, may not be used with colors" => "0|1, may not be used with colors",
// "Wiki syntax" => "Wiki syntax",
// "0|1, parse wiki syntax within the code snippet" => "0|1, parse wiki syntax within the code snippet",
// "Right to left" => "Right to left",
// "0|1, switch the text display from left to right to right to left" => "0|1, switch the text display from left to right to right to left",
// "Content is HTML" => "Content is HTML",
// "0|1, display the content as is instead of escaping HTML special chars" => "0|1, display the content as is instead of escaping HTML special chars",
// "note: colors and ln are exclusive" => "note: colors and ln are exclusive",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Also known as fortune cookies or taglines" => "Also known as fortune cookies or taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "on|off" => "on|off",
// "Items to show" => "Items to show",
// "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "left|right|center|justify" => "left|right|center|justify",
// "Justify" => "Justify",
// "Float position" => "Float position",
// "left|right, for box with width less than 100%, make text wrap around the box" => "left|right, for box with width less than 100%, make text wrap around the box",
// "Determine how other elements can wrap around the element" => "Determine how other elements can wrap around the element",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Creates a fancy-looking list" => "Creates a fancy-looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading row" => "Heading row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS class" => "Heading CSS class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header horizontal align" => "Header horizontal align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header vertical align" => "Header vertical align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column sort" => "Column sort",
// "Pre-sorted columns" => "Pre-sorted columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column widths" => "Column widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell horizontal align" => "Cell horizontal align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell vertical align" => "Cell vertical align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "heads and cells separated by |" => "heads and cells separated by |",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows ID" => "Shows ID",
// "Shows Icon" => "Shows Icon",
// "Shows Name" => "Shows Name",
// "Shows Filename" => "Shows Filename",
// "Shows Size" => "Shows Size",
// "Shows Description" => "Shows Description",
// "Shows Creation Date" => "Shows Creation Date",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Modification Date" => "Shows Modification Date",
// "Shows Author" => "Shows Author",
// "Shows Creator" => "Shows Creator",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Displays a Flash (.swf) file in the wiki page" => "Displays a Flash (.swf) file in the wiki page",
// "Movie URL" => "Movie URL",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "Default width: 425" => "Default width: 425",
// "Default height: 350" => "Default height: 350",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "file name" => "file name",
// "Ftp Server Name" => "Ftp Server Name",
// "Ftp User name" => "Ftp User name",
// "Ftp password" => "Ftp password",
// "Download button label" => "Download button label",
// "missing parameters" => "missing parameters",
// "Connection failed" => "Connection failed",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "current value (REQUIRED)" => "current value (REQUIRED)",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "Missing parameter" => "Missing parameter",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "GroupMailCore" => "GroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "operator Field Id" => "operator Field Id",
// "subject Field Id" => "subject Field Id",
// "message Field Id" => "message Field Id",
// "content Field Id" => "content Field Id",
// "account Field Id" => "account Field Id",
// "datetime Field Id" => "datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "Groups separated by " => "Groups separated by ",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Displays some stat about group belonging" => "Displays some stat about group belonging",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "Iframe" => "Iframe",
// "Frame title" => "Frame title",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 5.0)" => " (experimental - possible successor to img in 5.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)" => "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required" => "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery images when thumbnail is clicked" => "Download dialog box will appear for file gallery images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class" => "CSS class",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load" => "Alternate text that displays when image does not load",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin)" => "Default configuration settings (usually set by admin)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin)" => "Mandatory configuration settings (usually set by admin)",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, attId, id, or src.''",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Invite" => "Invite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including group" => "Including group",
// "Default group" => "Default group",
// "Group from the item group selector / creator field" => "Group from the item group selector / creator field",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Email address" => "Email address",
// "Jabber" => "Jabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Kaltura video" => "Kaltura video",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry Id" => "Kaltura Entry Id",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "List wiki pages" => "List wiki pages",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Number of results displayed in the list" => "Number of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Progress" => "List Progress",
// "Indicates the internationalization progress of the page list" => "Indicates the internationalization progress of the page list",
// "List Name" => "List Name",
// "Name of the list as configured in the page list admin panel" => "Name of the list as configured in the page list admin panel",
// "Limit" => "Limit",
// "Maximum amount of results to display" => "Maximum amount of results to display",
// "Filter to apply to the page list" => "Filter to apply to the page list",
// "Score Limit" => "Score Limit",
// "Value used as the denominator for the score" => "Value used as the denominator for the score",
// "List Directory" => "List Directory",
// "Lists files in a directory" => "Lists files in a directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Displays a map" => "Displays a map",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%" => "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Member List" => "Member List",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by UI" => "Displays a module inline in a wiki page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Background color of the popup" => "Background color of the popup",
// "'),\n\t\t\t\t'filter' => 'striptags" => "'),\n\t\t\t\t'filter' => 'striptags",
// "Text color in the popup" => "Text color in the popup",
// "Padding" => "Padding",
// "Effect" => "Effect",
// "Effect speed" => "Effect speed",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Days" => "Days",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "List pages part of a named list" => "List pages part of a named list",
// "Offset" => "Offset",
// "Pagination start element" => "Pagination start element",
// "list parameter missing or doesn\\'t exist" => "list parameter missing or doesn\\'t exist",
// "%" => "%",
// "% of page hits" => "% of page hits",
// "Page Hits" => "Page Hits",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Information" => "Information",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Poll ID" => "Poll ID",
// "Displays the output of a poll, fields are indicated with numeric ids" => "Displays the output of a poll, fields are indicated with numeric ids",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "wrote" => "wrote",
// "Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Quote text by surrounding the text with a box, like the [QUOTE] BBCode",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Exclude" => "Exclude",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "y|n Show close button (default y)" => "y|n Show close button (default y)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Number of results displayed" => "Number of results displayed",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect" => "RSS Id incorrect",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "Screencast" => "Screencast",
// "Display a screencast uploaded on the page" => "Display a screencast uploaded on the page",
// "Label to use as a replacement to the default text" => "Label to use as a replacement to the default text",
// "ID as provided automatically during the upload" => "ID as provided automatically during the upload",
// "Insert Screencast" => "Insert Screencast",
// "Screencast ID wasn't specified or doesn't exist" => "Screencast ID wasn't specified or doesn't exist",
// "Watch a video of these instructions" => "Watch a video of these instructions",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Sheet Heading" => "Sheet Heading",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "TikiSheet" => "TikiSheet",
// "Edit Sheet" => "Edit Sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Last modified by" => "Last modified by",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "Missing url parameter for SNARF plugin" => "Missing url parameter for SNARF plugin",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Stat" => "Stat",
// "Displays some stats" => "Displays some stats",
// "separated by " => "separated by ",
// "Parent Id" => "Parent Id",
// "Added last hour" => "Added last hour",
// "Added last 24 hours" => "Added last 24 hours",
// "Added since the beginning of the day" => "Added since the beginning of the day",
// "Added(a) or viewed(v) since the beginning of the day" => "Added(a) or viewed(v) since the beginning of the day",
// "Added last 7 days" => "Added last 7 days",
// "Added(a) or viewed(v) last 7 days" => "Added(a) or viewed(v) last 7 days",
// "Added since the beginning of the week" => "Added since the beginning of the week",
// "Added(a) or viewed(v) since the beginning of the week" => "Added(a) or viewed(v) since the beginning of the week",
// "Added last month" => "Added last month",
// "Added(a) or viewed(v) last month" => "Added(a) or viewed(v) last month",
// "Added since the beginning of the month" => "Added since the beginning of the month",
// "Added(a) or viewed(v) since the beginning of the month" => "Added(a) or viewed(v) since the beginning of the month",
// "Added last year" => "Added last year",
// "Added(a) or viewed(v) last year" => "Added(a) or viewed(v) last year",
// "Added since the beginning of the year" => "Added since the beginning of the year",
// "Added(a) or viewed(v) since the beginning of the year" => "Added(a) or viewed(v) since the beginning of the year",
// "Subscript" => "Subscript",
// "Displays text in subscript" => "Displays text in subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Show subscribe box" => "Show subscribe box",
// "Show default setting and buttons" => "Show default setting and buttons",
// "Show group description" => "Show group description",
// "Colon separated list of groups" => "Colon separated list of groups",
// "After changing default" => "After changing default",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Tabs" => "Tabs",
// "Provides tabs built using the smarty tabset block" => "Provides tabs built using the smarty tabset block",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset name" => "Tabset name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab titles" => "Tab titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Displays text between HTML tags" => "Displays text between HTML tags",
// "Displays the thumbnail for an image" => "Displays the thumbnail for an image",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited" => "Maximum number of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "URL used for the field links" => "URL used for the field links",
// "Url target" => "Url target",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "Reset" => "Reset",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Fields marked with a * are mandatory" => "Fields marked with a * are mandatory",
// "Display List" => "Display List",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "Wiki text" => "Wiki text",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Displays the output of a tracker content, fields are indicated with numeric ids" => "Displays the output of a tracker content, fields are indicated with numeric ids",
// "Notice" => "Notice",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Show Item Rank" => "Show Item Rank",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Maximum number of items" => "Maximum number of items",
// "Show pagination" => "Show pagination",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More" => "More",
// "More URL" => "More URL",
// "More Url" => "More Url",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Show nothing if no items" => "Show nothing if no items",
// "incorrect filterfield" => "incorrect filterfield",
// "Error in tracker ID" => "Error in tracker ID",
// "No field indicated" => "No field indicated",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Start Date" => "Start Date",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "End Date" => "End Date",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Group name" => "Group name",
// "User List" => "User List",
// "Displays a list of registered users" => "Displays a list of registered users",
// "Display the user\\'s real name instead of login name" => "Display the user\\'s real name instead of login name",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Lists ''wanted'' Wiki pages: " => "Lists ''wanted'' Wiki pages: ",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "empty string" => "empty string",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Wanted Page" => "Wanted Page",
// "Referenced By Page" => "Referenced By Page",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "URL to the Youtube video" => "URL to the Youtube video",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Removed last version" => "Removed last version",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "Sent box is full. Archive or delete some sent messages first if you want to send more messages" => "Sent box is full. Archive or delete some sent messages first if you want to send more messages",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "User %s can not receive messages, mailbox is full" => "User %s can not receive messages, mailbox is full",
// "User %s can not receive messages" => "User %s can not receive messages",
// "Invalid user: %s" => "Invalid user: %s",
// "Archive is full. Delete some messages from archive first" => "Archive is full. Delete some messages from archive first",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "Category filter" => "Category filter",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Not set by default" => "Not set by default",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values" => "Example values",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "No date" => "No date",
// "If set to \"y\", the date at which comments were posted is not displayed in the module box" => "If set to \"y\", the date at which comments were posted is not displayed in the module box",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum length" => "Maximum length",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Example value" => "Example value",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Last forum posts" => "Last forum posts",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Freetags editor" => "Freetags editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Similar freetags" => "Similar freetags",
// "Shows wiki pages with similar freetags" => "Shows wiki pages with similar freetags",
// "Similar pages" => "Similar pages",
// "Most popular tags" => "Most popular tags",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Last actions" => "Last actions",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "no object here yet" => "no object here yet",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "Last Images" => "Last Images",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last modified events" => "Last modified events",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Number of characters to display" => "Number of characters to display",
// "Last Visitors" => "Last Visitors",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "List by month" => "List by month",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Search Box" => "Search Box",
// "Advanced search (for wiki, articles, blogs etc)" => "Advanced search (for wiki, articles, blogs etc)",
// "Search Box (new)" => "Search Box (new)",
// "Search Wiki Page" => "Search Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Search Wiki Page (new)" => "Search Wiki Page (new)",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Please wait.." => "Please wait..",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Since your last visit.." => "Since your last visit..",
// "updated tracker items" => "updated tracker items",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Top Forum Posters" => "Top Forum Posters",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Top Objects" => "Top Objects",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Page translation" => "Page translation",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "The task title must have at least 3 characters" => "The task title must have at least 3 characters",
// "Public tasks" => "Public tasks",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Top users" => "Top users",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "Subject Field Id" => "Subject Field Id",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "Message Field Id" => "Message Field Id",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "Content Field Id" => "Content Field Id",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "Account Field Id" => "Account Field Id",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "Operator Field Id" => "Operator Field Id",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Wiki Page" => "Wiki Page",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Videos on YouTube" => "Videos on YouTube",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin the cms" => "Can admin the cms",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submited links are valid" => "Submited links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submited links" => "Can validate submited links",
// "Can use the directory" => "Can use the directory",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Can admin users" => "Can admin users",
// "Can access site when closed" => "Can access site when closed",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin external feeds" => "Can admin external feeds",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referer stats" => "Can view referer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can create file galleries" => "Can create file galleries",
// "Can download files" => "Can download files",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can list file galleries" => "Can list file galleries",
// "Can upload files" => "Can upload files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can view file galleries" => "Can view file galleries",
// "Can admin forums" => "Can admin forums",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Auto approve forum posts" => "Auto approve forum posts",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can admin freetags" => "Can admin freetags",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload images" => "Can upload images",
// "Can browse freetags" => "Can browse freetags",
// "Can view image galleries" => "Can view image galleries",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can list newsletters" => "Can list newsletters",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can change tracker pending items" => "Can change tracker pending items",
// "Can change tracker closed items" => "Can change tracker closed items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view trackers closed items" => "Can view trackers closed items",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit pages" => "Can edit pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view page/pages" => "Can view page/pages",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments to wiki pages" => "Can admin attachments to wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view wiki history" => "Can view wiki history",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can delete comments" => "Can delete comments",
// "Can vote comments" => "Can vote comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can list registered users" => "Can list registered users",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "Can invite user in groups" => "Can invite user in groups",
// "Can delete his own account" => "Can delete his own account",
// "Can use the Tiki Importer" => "Can use the Tiki Importer",
// "Can admin categories" => "Can admin categories",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories on the object" => "Can change the categories on the object",
// "Can add objects in the category" => "Can add objects in the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can upload screencasts to wiki pages" => "Can upload screencasts to wiki pages",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki dft list pages lang to current" => "wiki dft list pages lang to current",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "feature pagelist" => "feature pagelist",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin listprogress" => "wikiplugin listprogress",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin pagelist" => "wikiplugin pagelist",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin screencast" => "wikiplugin screencast",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline listprogress" => "wikiplugininline listprogress",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline pagelist" => "wikiplugininline pagelist",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline screencast" => "wikiplugininline screencast",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "tracker jquery user selector threshold" => "tracker jquery user selector threshold",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature search preferences" => "feature search preferences",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "title rss forums" => "title rss forums",
// "title rss forum" => "title rss forum",
// "title rss directories" => "title rss directories",
// "title rss articles" => "title rss articles",
// "title rss blogs" => "title rss blogs",
// "title rss image galleries" => "title rss image galleries",
// "title rss file galleries" => "title rss file galleries",
// "title rss wiki" => "title rss wiki",
// "title rss image gallery" => "title rss image gallery",
// "title rss file gallery" => "title rss file gallery",
// "title rss blog" => "title rss blog",
// "title rss tracker" => "title rss tracker",
// "title rss trackers" => "title rss trackers",
// "title rss calendar" => "title rss calendar",
// "title rss mapfiles" => "title rss mapfiles",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom html head content" => "feature custom html head content",
// "users prefs theme" => "users prefs theme",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature wiki screencasts" => "feature wiki screencasts",
// "feature wiki screencasts base" => "feature wiki screencasts base",
// "feature wiki screencasts httpbase" => "feature wiki screencasts httpbase",
// "feature wiki screencasts upload type" => "feature wiki screencasts upload type",
// "feature wiki screencasts user" => "feature wiki screencasts user",
// "feature wiki screencasts pass" => "feature wiki screencasts pass",
// "feature wiki screencasts max size" => "feature wiki screencasts max size",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache flags" => "memcache flags",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "feature use minified scripts" => "feature use minified scripts",
// "tiki minify javascript" => "tiki minify javascript",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Anti-Bot verification code" => "Anti-Bot verification code",
// "Enter the code you see above" => "Enter the code you see above",
// "more info" => "more info",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "Select Categories" => "Select Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
// "Report this post" => "Report this post",
// "Group Monitor" => "Group Monitor",
// "Watched by categories" => "Watched by categories",
// "Errors" => "Errors",
// "Comments Locked" => "Comments Locked",
// "below your current threshold" => "below your current threshold",
// "Comments are locked" => "Comments are locked",
// "Note" => "Note",
// "Reply to the selected post" => "Reply to the selected post",
// "required" => "required",
// "Maximum size" => "Maximum size",
// "Enter your name" => "Enter your name",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Reply to parent post" => "Reply to parent post",
// "Post new reply" => "Post new reply",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Post as Anonymous" => "Post as Anonymous",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "Posting replies" => "Posting replies",
// "Type of contribution" => "Type of contribution",
// "Contributors" => "Contributors",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "File gallery" => "File gallery",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Quota" => "Quota",
// "Used" => "Used",
// "Min" => "Min",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Display Properties" => "Display Properties",
// "Descending" => "Descending",
// "Ascending" => "Ascending",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "Perhaps you are looking for" => "Perhaps you are looking for",
// "Go to Login Page" => "Go to Login Page",
// "Close Window" => "Close Window",
// "Private Gallery" => "Private Gallery",
// "Active Perms" => "Active Perms",
// "Archives" => "Archives",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Show as a column" => "Show as a column",
// "Show an icon in a column" => "Show an icon in a column",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "any language" => "any language",
// "not in" => "not in",
// "Clear Filter" => "Clear Filter",
// "Show php error messages" => "Show php error messages",
// "Folksonomy Tags" => "Folksonomy Tags",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Tags" => "Tags",
// "Translate tags" => "Translate tags",
// "Images Galleries" => "Images Galleries",
// "RSS Wiki" => "RSS Wiki",
// "RSS Blogs" => "RSS Blogs",
// "RSS Articles" => "RSS Articles",
// "RSS Image Galleries" => "RSS Image Galleries",
// "RSS File Galleries" => "RSS File Galleries",
// "RSS Forums" => "RSS Forums",
// "RSS Maps" => "RSS Maps",
// "RSS Directories" => "RSS Directories",
// "RSS Calendars" => "RSS Calendars",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Are you sure you want to delete the selected files" => "Are you sure you want to delete the selected files",
// "Download the zip" => "Download the zip",
// "Other Sorts" => "Other Sorts",
// "No Additionnal Sort" => "No Additionnal Sort",
// "No information" => "No information",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "A new topic was posted to forum" => "A new topic was posted to forum",
// "New topic" => "New topic",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "Page not found" => "Page not found",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
// "To validate that account, please follow the link" => "To validate that account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "Report for" => "Report for",
// "Last Report sent on" => "Last Report sent on",
// "Changes in detail" => "Changes in detail",
// "New article submitted at %s" => "New article submitted at %s",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Tracker was modified at" => "Tracker was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "IP" => "IP",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "View the article at" => "View the article at",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "New" => "New",
// "updated" => "updated",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "File Name" => "File Name",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "Posted by" => "Posted by",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "A file was attached to %s" => "A file was attached to %s",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "an anonymous user" => "an anonymous user",
// "Wiki page renamed" => "Wiki page renamed",
// "Old name" => "Old name",
// "Thank you for your registration. You may log in now" => "Thank you for your registration. You may log in now",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Zoom out" => "Zoom out",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "from the mapfile" => "from the mapfile",
// "hits last 7 days" => "hits last 7 days",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
// "Message Archive" => "Message Archive",
// "messages" => "messages",
// "Archive is full" => "Archive is full",
// "Confirmation" => "Confirmation",
// "Please Confirm" => "Please Confirm",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "No messages to download" => "No messages to download",
// "Mailbox is full! Delete or archive some messages if you want to receive more messages" => "Mailbox is full! Delete or archive some messages if you want to receive more messages",
// "is reply to" => "is reply to",
// "Find replied message" => "Find replied message",
// "Archive" => "Archive",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
// "Return to mailbox" => "Return to mailbox",
// "Unflag" => "Unflag",
// "Return to archive" => "Return to archive",
// "Return to outbox" => "Return to outbox",
// "Sent Messages" => "Sent Messages",
// "Not replied" => "Not replied",
// "move to archive" => "move to archive",
// "receiver" => "receiver",
// "opp side" => "opp side",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "More.." => "More..",
// "Thank you for installing Tikiwiki" => "Thank you for installing Tikiwiki",
// "To configure your Tiki" => "To configure your Tiki",
// "Admin Home" => "Admin Home",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "Add event" => "Add event",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Apply" => "Apply",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "List everything tagged" => "List everything tagged",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "No records to display" => "No records to display",
// "insert original" => "insert original",
// "insert thumbnail" => "insert thumbnail",
// "No avatar" => "No avatar",
// "You" => "You",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Switch user" => "Switch user",
// "Login through CAS" => "Login through CAS",
// "Login through Shibboleth" => "Login through Shibboleth",
// "CapsLock is on" => "CapsLock is on",
// "local account" => "local account",
// "OpenID Login" => "OpenID Login",
// "What is OpenID" => "What is OpenID",
// "Wiki feed" => "Wiki feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "Calendars" => "Calendars",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Shout date" => "Shout date",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Site Language" => "Site Language",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "TikiTests Menu" => "TikiTests Menu",
// "List Tests" => "List Tests",
// "Create Test" => "Create Test",
// "There are no translations of this page" => "There are no translations of this page",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Better translations" => "Better translations",
// "update from it" => "update from it",
// "None match your" => "None match your",
// "Set your preferred languages" => "Set your preferred languages",
// "preferred languages" => "preferred languages",
// "Equivalent translations" => "Equivalent translations",
// "Translations that need improvement" => "Translations that need improvement",
// "update it" => "update it",
// "select" => "select",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "User does not accept messages" => "User does not accept messages",
// "Send a message" => "Send a message",
// "More Videos" => "More Videos",
// "Changes that need to be reproduced are highlighted below" => "Changes that need to be reproduced are highlighted below",
// "[-]" => "[-]",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "Requires" => "Requires",
// "You need to set" => "You need to set",
// "Send Newsletter" => "Send Newsletter",
// "Insert/Edit an internal wiki link" => "Insert/Edit an internal wiki link",
// "Wiki Link insert" => "Wiki Link insert",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "Insert an image" => "Insert an image",
// "Switch to normal (wiki) editor" => "Switch to normal (wiki) editor",
// "By" => "By",
// "Read more" => "Read more",
// "Do not group by item" => "Do not group by item",
// "Group by item" => "Group by item",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User resistration, remember me cookie settings and authentication methods" => "User resistration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Profiles" => "Profiles",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Look & Feel" => "Look & Feel",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Editing and Plugins" => "Editing and Plugins",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Meta Tags" => "Meta Tags",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Connect" => "Connect",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "?" => "?",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Webservices" => "Webservices",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Kaltura video configuration" => "Kaltura video configuration",
// "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or",
// "Create a blog" => "Create a blog",
// "Requires a separate download" => "Requires a separate download",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Manual selection of time/date" => "Manual selection of time/date",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Admin topics" => "Admin topics",
// "Admin types" => "Admin types",
// "Title of articles home page" => "Title of articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "User features" => "User features",
// "Highlight group" => "Highlight group",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "Show user's information on mouseover" => "Show user's information on mouseover",
// "Requires user's information to be public" => "Requires user's information to be public",
// "Real name" => "Real name",
// "Feature is disabled" => "Feature is disabled",
// "Enable now" => "Enable now",
// "Default user preferences" => "Default user preferences",
// "Character set for mail" => "Character set for mail",
// "Detect user timezone if browser allows, otherwise site default" => "Detect user timezone if browser allows, otherwise site default",
// "User messages" => "User messages",
// "Notify sender when reading mail" => "Notify sender when reading mail",
// "Auto-archive read messages after x days" => "Auto-archive read messages after x days",
// "My forum topics" => "My forum topics",
// "My forum replies" => "My forum replies",
// "Select which items to display when listing users" => "Select which items to display when listing users",
// "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to TikiWiki.org" => "To submit your site to TikiWiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright allows to determine a copyright for all the objects of tikiwiki",
// "Enable copyright management for" => "Enable copyright management for",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "Programmer" => "Programmer",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Experimental" => "Experimental",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Need polish" => "Need polish",
// "These features are generally known to have issues, and/or need admin help and/or user patience to work" => "These features are generally known to have issues, and/or need admin help and/or user patience to work",
// "Feedbacks" => "Feedbacks",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Create a Gallery" => "Create a Gallery",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Score is disabled" => "Score is disabled",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Search Indexing" => "Search Indexing",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or",
// "Create a forum" => "Create a forum",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "When listing forums" => "When listing forums",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser" => "3D Tag Browser",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Graph appearance" => "Graph appearance",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "No Gallery exists" => "No Gallery exists",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "pixels" => "pixels",
// "Release Check" => "Release Check",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Check for updates now" => "Check for updates now",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences",
// "Mail" => "Mail",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "SMTP Server" => "SMTP Server",
// "Authentication" => "Authentication",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Logging and Reporting" => "Logging and Reporting",
// "Visible to admin only" => "Visible to admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Spam protection" => "Spam protection",
// "MultiDomain" => "MultiDomain",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Miscellaneous" => "Miscellaneous",
// "Use TikiWiki feature as homepage" => "Use TikiWiki feature as homepage",
// "Use different URL as home page" => "Use different URL as home page",
// "Redirects" => "Redirects",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Site Access" => "Site Access",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details",
// "Google Maps API Key" => "Google Maps API Key",
// "Defaults" => "Defaults",
// "Default x for map center" => "Default x for map center",
// "Default y from map center" => "Default y from map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "max zoom" => "max zoom",
// "Edit or export/import Languages" => "Edit or export/import Languages",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Syntax error" => "Syntax error",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// "as master" => "as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
// "Kaltura Registration" => "Kaltura Registration",
// "If you don't have a Kaltura Partner Id, " => "If you don't have a Kaltura Partner Id, ",
// "to register" => "to register",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Partner Id" => "Partner Id",
// "User Secret" => "User Secret",
// "Admin Secret" => "Admin Secret",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "KDP UI Configuration Id" => "KDP UI Configuration Id",
// "KDP Widget Id" => "KDP Widget Id",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "KCW UI Configuration Id" => "KCW UI Configuration Id",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Kaltura Simple Editor UI Configuration Id" => "Kaltura Simple Editor UI Configuration Id",
// "Kaltura Advance Editor UI Configuration Id" => "Kaltura Advance Editor UI Configuration Id",
// "Validate by email" => "Validate by email",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Url a user is redirected after account validation" => "Url a user is redirected after account validation",
// "Account validated successfully" => "Account validated successfully",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "LDAP Bind settings" => "LDAP Bind settings",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: userattr=username,UserDN,BaseDN" => "Default: userattr=username,UserDN,BaseDN",
// "userattr=username,BaseDN" => "userattr=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Synchronize user attributes to tiki everytime the user logs in" => "Synchronize user attributes to tiki everytime the user logs in",
// "LDAP Group" => "LDAP Group",
// "Synchronize group attributes to tiki everytime the user logs in" => "Synchronize group attributes to tiki everytime the user logs in",
// "Note: this enables the usage of LDAP groups" => "Note: this enables the usage of LDAP groups",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "Group attribute in group entry" => "Group attribute in group entry",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "Themes" => "Themes",
// "Theme options" => "Theme options",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "Each group can have its theme" => "Each group can have its theme",
// "Slideshow theme" => "Slideshow theme",
// "View Templates" => "View Templates",
// "Custom HTML &lt;head&gt; Content" => "Custom HTML &lt;head&gt; Content",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users",
// "Site Logo and Title" => "Site Logo and Title",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Site title" => "Site title",
// "Subtitle" => "Subtitle",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar" => "Top Bar",
// "Requires CSS Menus or PHPLayers" => "Requires CSS Menus or PHPLayers",
// "Display current Tiki version" => "Display current Tiki version",
// "Custom Center Column Header" => "Custom Center Column Header",
// "only if module" => "only if module",
// "Prefix breadcrumbs with &quot;Location : &quot" => "Prefix breadcrumbs with &quot;Location : &quot",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Entire location" => "Entire location",
// "Custom End of &lt;body&gt; Code" => "Custom End of &lt;body&gt; Code",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave <strong>blank</strong> to use the default sender email" => "Leave <strong>blank</strong> to use the default sender email",
// "Email this page" => "Email this page",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "UI Effects" => "UI Effects",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "Tooltips" => "Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "Autocomplete" => "Autocomplete",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "Superfish" => "Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "Reflection" => "Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery UI Theme" => "JQuery UI Theme",
// "JQuery UI Theme: Themes for look and feel of JQuery UI widgets" => "JQuery UI Theme: Themes for look and feel of JQuery UI widgets",
// "For future use" => "For future use",
// "Cycle" => "Cycle",
// "slideshow" => "slideshow",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules" => "Effect for modules",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Main JQuery effect" => "Main JQuery effect",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Direction" => "Direction",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (&nbsp;,&nbsp;)" => "Separate multiple elements with a comma (&nbsp;,&nbsp;)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Favicon" => "Favicon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Separators" => "Separators",
// "Generate User Map" => "Generate User Map",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "Save Preferences" => "Save Preferences",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Sending" => "Sending",
// "Waiting" => "Waiting",
// "TikiWiki Profiles" => "TikiWiki Profiles",
// "The following list of changes has been applied" => "The following list of changes has been applied",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Profile tester" => "Profile tester",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feed for articles" => "Feed for articles",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "You can see users rank by score in the module users_rank, for that go to" => "You can see users rank by score in the module users_rank, for that go to",
// "Admin modules" => "Admin modules",
// "Expiration" => "Expiration",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "The indexation is always updated" => "The indexation is always updated",
// "Tiki search" => "Tiki search",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "Plugins" => "Plugins",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Storage" => "Storage",
// "Switch storage" => "Switch storage",
// "No records" => "No records",
// "Change all to db" => "Change all to db",
// "Change all to file" => "Change all to file",
// "Trackers with mirror tables" => "Trackers with mirror tables",
// "Use trackers with mirror tables" => "Use trackers with mirror tables",
// "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on" => "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on",
// "Validate choice" => "Validate choice",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Allow override per page" => "Allow override per page",
// "Not Installed" => "Not Installed",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "Polls are disabled" => "Polls are disabled",
// "Similar" => "Similar",
// "like pages" => "like pages",
// "Make structure from page" => "Make structure from page",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "Wiki watch" => "Wiki watch",
// "Watch minor edits" => "Watch minor edits",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Page Listings" => "Page Listings",
// "Pages not in structure" => "Pages not in structure",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Camera settings" => "Camera settings",
// "Upload Type" => "Upload Type",
// "Data location" => "Data location",
// "HTTP Prefix" => "HTTP Prefix",
// "WebDav username" => "WebDav username",
// "WebDav password" => "WebDav password",
// "Change" => "Change",
// "Development Notice" => "Development Notice",
// "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default" => "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
// "disabled" => "disabled",
// "enabled" => "enabled",
// "preference" => "preference",
// "preference name" => "preference name",
// "Shoutbox Words" => "Shoutbox Words",
// "TikiCache/System" => "TikiCache/System",
// "Edit Languages" => "Edit Languages",
// "External Pages Cache" => "External Pages Cache",
// "External Wikis" => "External Wikis",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "View Calendar" => "View Calendar",
// "Create / Edit Calendar" => "Create / Edit Calendar",
// "Create/Edit Calendars" => "Create/Edit Calendars",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Red" => "Red",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Let me select my own colors" => "Let me select my own colors",
// "Ex" => "Ex",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
// "Current Category ID" => "Current Category ID",
// "Use the Administration page of each enabled feature to allow the use of content templates" => "Use the Administration page of each enabled feature to allow the use of content templates",
// "Use in" => "Use in",
// "No features are configured to use templates" => "No features are configured to use templates",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Admin External Wikis" => "Admin External Wikis",
// "tiki admin external wikis template" => "tiki admin external wikis template",
// "Duplicate forum" => "Duplicate forum",
// "View this forum" => "View this forum",
// "Import forums" => "Import forums",
// ".." => "..",
// "Create/Edit Forums" => "Create/Edit Forums",
// "Only allow replies to the first message (flat forum)" => "Only allow replies to the first message (flat forum)",
// "Posts can be rated" => "Posts can be rated",
// "Send mails even when the post is generated by inbound mail" => "Send mails even when the post is generated by inbound mail",
// "Append a reply link to outbound mails" => "Append a reply link to outbound mails",
// "Set topics preferences" => "Set topics preferences",
// "Show topics preferences" => "Show topics preferences",
// "hide topics preferences" => "hide topics preferences",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "Duplicate perms" => "Duplicate perms",
// "Duplicate" => "Duplicate",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Mail-in accounts" => "Mail-in accounts",
// "Account" => "Account",
// "Add new Mail-in account" => "Add new Mail-in account",
// "Edit Mail-in account" => "Edit Mail-in account",
// "article-put" => "article-put",
// "Article Topic" => "Article Topic",
// "Article Type" => "Article Type",
// "Allow anonymous acces" => "Allow anonymous acces",
// "Allow attachments" => "Allow attachments",
// "Discard to the end from" => "Discard to the end from",
// "Check Mail-in accounts" => "Check Mail-in accounts",
// "Check automatically" => "Check automatically",
// "mn" => "mn",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Use Ctrl+Click to select multiple groups" => "Use Ctrl+Click to select multiple groups",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "Export CSV data" => "Export CSV data",
// "Import CSV data" => "Import CSV data",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Active Permissions" => "Active Permissions",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "Assign/Edit modules" => "Assign/Edit modules",
// "assign_name\">Module Name" => "assign_name\">Module Name",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "Display Modules to All Groups" => "Display Modules to All Groups",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Edit Newsletter" => "Edit Newsletter",
// "You can add several email addresses by separating them with commas" => "You can add several email addresses by separating them with commas",
// "Add email" => "Add email",
// "Add user" => "Add user",
// "Group users" => "Group users",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation mail" => "Don't send confirmation mail",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Batch e-mail subscribe" => "Batch e-mail subscribe",
// "txt file, one e-mail per line" => "txt file, one e-mail per line",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Subscribe group" => "Subscribe group",
// "Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Create Newsletter" => "Create Newsletter",
// "Drafts" => "Drafts",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Admin page lists" => "Admin page lists",
// "Current lists" => "Current lists",
// "Edit this list" => "Edit this list",
// "Remove this list" => "Remove this list",
// "Edit list" => "Edit list",
// "Add list" => "Add list",
// "Seed with pages from a category" => "Seed with pages from a category",
// "Add page" => "Add page",
// "Page priority" => "Page priority",
// "Page score" => "Page score",
// "Edit {\$list.name|escape}" => "Edit {\$list.name|escape}",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "0 for no limit" => "0 for no limit",
// "Add poll to pages" => "Add poll to pages",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Lock the pages" => "Lock the pages",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "Admin Shoutbox Words" => "Admin Shoutbox Words",
// "Add Banned Word" => "Add Banned Word",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "Edit structure" => "Edit structure",
// "View structure" => "View structure",
// "PDF" => "PDF",
// "XML Zip" => "XML Zip",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Create/Edit Surveys" => "Create/Edit Surveys",
// "Create New Survey" => "Create New Survey",
// "Closed" => "Closed",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "Exterminator of cached content" => "Exterminator of cached content",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
// "List Trackers" => "List Trackers",
// "Searchable" => "Searchable",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "New tracker field" => "New tracker field",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Field is mandatory" => "Field is mandatory",
// "Multilingual content" => "Multilingual content",
// "Column is searchable" => "Column is searchable",
// "Field is hidden" => "Field is hidden",
// "not hidden" => "not hidden",
// "editable by admin only" => "editable by admin only",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Error message" => "Error message",
// "Import/Export Trackers Fields" => "Import/Export Trackers Fields",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit This Tracker's Fields" => "Edit This Tracker's Fields",
// "with" => "with",
// "Edit Tracker" => "Edit Tracker",
// "Create Tracker" => "Create Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Auto create corresponding categories" => "Auto create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "Use \"explicit\" names in the mirror table" => "Use \"explicit\" names in the mirror table",
// "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL",
// "Show status" => "Show status",
// "Default status displayed in list mode" => "Default status displayed in list mode",
// "Show status to tracker admin only" => "Show status to tracker admin only",
// "Send copies of all activity in this tracker to this e-mail address" => "Send copies of all activity in this tracker to this e-mail address",
// "Use simplified e-mail format" => "Use simplified e-mail format",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "New items are created with status" => "New items are created with status",
// "Authoritative status for modified items" => "Authoritative status for modified items",
// "No change" => "No change",
// "Item creator can modify his items" => "Item creator can modify his items",
// "The tracker needs a user field with the option 1" => "The tracker needs a user field with the option 1",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP field with the option 1" => "The tracker needs a user or IP field with the option 1",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "The tracker needs a group field with the option 1" => "The tracker needs a group field with the option 1",
// "Format if not the default short one" => "Format if not the default short one",
// "Show creation date when viewing tracker item" => "Show creation date when viewing tracker item",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Show lastModif date when viewing tracker item" => "Show lastModif date when viewing tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "What field is used for default sort" => "What field is used for default sort",
// "LastModif" => "LastModif",
// "ItemId" => "ItemId",
// "What is default sort order in list" => "What is default sort order in list",
// "Tracker items allow ratings" => "Tracker items allow ratings",
// "with values" => "with values",
// "and display rating results in listing" => "and display rating results in listing",
// "and display comments in listing" => "and display comments in listing",
// "and display last comment user/date" => "and display last comment user/date",
// "and display attachments in listing" => "and display attachments in listing",
// "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)",
// "Filetype" => "Filetype",
// "LongDesc" => "LongDesc",
// "Items can be created only during a certain time" => "Items can be created only during a certain time",
// "Do not show empty fields in item view" => "Do not show empty fields in item view",
// "Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Show these fields (ID comma separated) in a popup on item link when listing tracker items",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "Import/Export" => "Import/Export",
// "Import/export trackers" => "Import/export trackers",
// "Date Format" => "Date Format",
// "timestamp" => "timestamp",
// "Charset encoding" => "Charset encoding",
// "UTF-8" => "UTF-8",
// "ISO-8859-1" => "ISO-8859-1",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Manage permissions" => "Manage permissions",
// "Inherits Permissions from" => "Inherits Permissions from",
// "User Choice" => "User Choice",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Selected groups only. Use Ctrl+Click to select more than one" => "Selected groups only. Use Ctrl+Click to select more than one",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
// "choose a users tracker .." => "choose a users tracker ..",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Remove from Group" => "Remove from Group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "CSV File" => "CSV File",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "Feedback" => "Feedback",
// "Updated users" => "Updated users",
// "Registered" => "Registered",
// "ago" => "ago",
// "Need to validate email" => "Need to validate email",
// "Assign to group" => "Assign to group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Confirm user email" => "Confirm user email",
// "Invalid email" => "Invalid email",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Tip: Hold down CTRL to select multiple" => "Tip: Hold down CTRL to select multiple",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Lowercase only" => "Lowercase only",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "User tracker item : {\$usersitemid}" => "User tracker item : {\$usersitemid}",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2" => "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2",
// "Overwrite but keep the previous login if the login exists in another case" => "Overwrite but keep the previous login if the login exists in another case",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "New attachments" => "New attachments",
// "Old attachments" => "Old attachments",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Source" => "Source",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "The person who submits an article of this type can edit it" => "The person who submits an article of this type can edit it",
// "Actions on this article type" => "Actions on this article type",
// "Classified" => "Classified",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Directory batch upload" => "Directory batch upload",
// "available images" => "available images",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. ",
// "Mark entry as private" => "Mark entry as private",
// "Report to Webmaster" => "Report to Webmaster",
// "Powered by" => "Powered by",
// "Wiki RSS" => "Wiki RSS",
// "Blogs RSS" => "Blogs RSS",
// "Articles RSS" => "Articles RSS",
// "Image Galleries RSS" => "Image Galleries RSS",
// "File Galleries RSS" => "File Galleries RSS",
// "Forums RSS" => "Forums RSS",
// "Maps RSS" => "Maps RSS",
// "The TikiWiki Community" => "The TikiWiki Community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "database queries used in " => "database queries used in ",
// "Last update from SVN" => "Last update from SVN",
// "Admin the Category System" => "Admin the Category System",
// "Trackers Items" => "Trackers Items",
// "Sheets" => "Sheets",
// "Browse related tags" => "Browse related tags",
// "Network of Tags related to" => "Network of Tags related to",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "More Popular Tags" => "More Popular Tags",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "\$feature_label" => "\$feature_label",
// "results found" => "results found",
// "List Galleries" => "List Galleries",
// "Directory Batch" => "Directory Batch",
// "Monitor this Gallery" => "Monitor this Gallery",
// "Stop Monitoring this Gallery" => "Stop Monitoring this Gallery",
// "subgallery" => "subgallery",
// "Subgallery" => "Subgallery",
// "Hit" => "Hit",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using one of these lines" => "You can include the gallery's image in an HTML page using one of these lines",
// "Slideshow Forward" => "Slideshow Forward",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal degrees)",
// "Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal degrees)",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Browsing Video" => "Browsing Video",
// "Edit Video" => "Edit Video",
// "First Video" => "First Video",
// "Prev Video" => "Prev Video",
// "Next Video" => "Next Video",
// "Last Video" => "Last Video",
// "Video Title" => "Video Title",
// "Move video" => "Move video",
// "You can view this video in your browser using" => "You can view this video in your browser using",
// "You can include the video in a tiki page using one of these lines" => "You can include the video in a tiki page using one of these lines",
// "Admin Calendar" => "Admin Calendar",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Delete event" => "Delete event",
// "All-Day" => "All-Day",
// "Website" => "Website",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Events cannot end before they start" => "Events cannot end before they start",
// "No description" => "No description",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Calendar import" => "Calendar import",
// "Calendar has been updated" => "Calendar has been updated",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Click here to send us an email" => "Click here to send us an email",
// "Send another message" => "Send another message",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "You cannot add sites until Directory Categories are setup" => "You cannot add sites until Directory Categories are setup",
// "Please contact the Site Administrator" => "Please contact the Site Administrator",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "Directory Categories" => "Directory Categories",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Parent directory category" => "Parent directory category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Directory Subcategories" => "Directory Subcategories",
// "cType" => "cType",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "Perform action with selected" => "Perform action with selected",
// "Add a Directory Category" => "Add a Directory Category",
// "in current directory category" => "in current directory category",
// "Total directory categories" => "Total directory categories",
// "One of the email addresses you typed is invalid" => "One of the email addresses you typed is invalid",
// "Image caption" => "Image caption",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Create Blog" => "Create Blog",
// "A category is mandatory" => "A category is mandatory",
// "Show user avatar" => "Show user avatar",
// "The file will be saved in" => "The file will be saved in",
// "Wiki Syntax" => "Wiki Syntax",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Also available here" => "Also available here",
// "Plugins help" => "Plugins help",
// "Bold text" => "Bold text",
// "Italic text" => "Italic text",
// "single quotes" => "single quotes",
// "Underlined text" => "Underlined text",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "Headings" => "Headings",
// "Show/Hide" => "Show/Hide",
// "show/hide heading section. + (shown) or - (hidden) by default" => "show/hide heading section. + (shown) or - (hidden) by default",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "Horizontal rule" => "Horizontal rule",
// "Text box" => "Text box",
// "Centered text" => "Centered text",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "Square Brackets" => "Square Brackets",
// "Use [[foo] to show [foo]" => "Use [[foo] to show [foo]",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "row" => "row",
// "col" => "col",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "Line break" => "Line break",
// "(very useful especially in tables)" => "(very useful especially in tables)",
// "to separate pages" => "to separate pages",
// "Prevents wiki parsing of the enclosed data" => "Prevents wiki parsing of the enclosed data",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Block Preformatting" => "Block Preformatting",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Browse Images" => "Browse Images",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "Im-Export Languages" => "Im-Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Immediate feedback" => "Immediate feedback",
// "Show correct answers" => "Show correct answers",
// "Shuffle questions" => "Shuffle questions",
// "Shuffle answers" => "Shuffle answers",
// "Passing Percentage" => "Passing Percentage",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Input" => "Input",
// "Edit quiz results" => "Edit quiz results",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Move in this structure" => "Move in this structure",
// "Move to another structure" => "Move to another structure",
// "at the beginning" => "at the beginning",
// "at the end" => "at the end",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "<b>*</b>=optional" => "<b>*</b>=optional",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
// "Submit Article" => "Submit Article",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
// "You must specify the object language" => "You must specify the object language",
// "The object doesn't exist" => "The object doesn't exist",
// "The object doesn't have a language" => "The object doesn't have a language",
// "The object has already a translation for this language" => "The object has already a translation for this language",
// "The object is already in the set of translations" => "The object is already in the set of translations",
// "Language of newly translated page" => "Language of newly translated page",
// "Unspecified" => "Unspecified",
// "Name of newly translated page" => "Name of newly translated page",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Or" => "Or",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Manage existing translations of this page" => "Manage existing translations of this page",
// "detach" => "detach",
// "Change language for this page" => "Change language for this page",
// "Select from available options.." => "Select from available options..",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Edit Video Information" => "Edit Video Information",
// "Browse Videos" => "Browse Videos",
// "The following video was successfully edited" => "The following video was successfully edited",
// "You can include the video in an HTML page using one of these lines" => "You can include the video in an HTML page using one of these lines",
// "View object" => "View object",
// "Preview your changes" => "Preview your changes",
// "Save the page" => "Save the page",
// "Cancel the edit, you will lose your changes" => "Cancel the edit, you will lose your changes",
// "This edit session will expire in" => "This edit session will expire in",
// "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "Edit wiki page" => "Edit wiki page",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Edit page" => "Edit page",
// "Edit Comment" => "Edit Comment",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Monitor this page" => "Monitor this page",
// "Add another image" => "Add another image",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Tools" => "Tools",
// "Lock this page" => "Lock this page",
// "Allow comments on this page" => "Allow comments on this page",
// "Regex search " => "Regex search ",
// "Replace with" => "Replace with",
// "Case Insensitivity" => "Case Insensitivity",
// "Upload Screencast" => "Upload Screencast",
// "Incorrect file extension was used for your flash screencast, expecting .swf or .flv" => "Incorrect file extension was used for your flash screencast, expecting .swf or .flv",
// "An unexpected error occurred while uploading your flash screencast" => "An unexpected error occurred while uploading your flash screencast",
// "Incorrect file extension was used for your Ogg screencast, expecting .ogg" => "Incorrect file extension was used for your Ogg screencast, expecting .ogg",
// "A flash screencast is mandatory" => "A flash screencast is mandatory",
// "An unexpected error occurred while uploading your Ogg screencast" => "An unexpected error occurred while uploading your Ogg screencast",
// "Preview not possible" => "Preview not possible",
// "Flash video (required)" => "Flash video (required)",
// "Ogg video (optional)" => "Ogg video (optional)",
// "Add another screencast" => "Add another screencast",
// "Manage structures" => "Manage structures",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Use rating" => "Use rating",
// "There is no available poll template" => "There is no available poll template",
// "You should ask an admin to create them" => "You should ask an admin to create them",
// "an existing poll" => "an existing poll",
// "Translation request" => "Translation request",
// "Send urgent translation request" => "Send urgent translation request",
// "List Sheets" => "List Sheets",
// "Graph" => "Graph",
// "Export to file" => "Export to file",
// "Format" => "Format",
// "Autodetect" => "Autodetect",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "Edit FAQ question" => "Edit FAQ question",
// "Add FAQ question" => "Add FAQ question",
// "File Archive" => "File Archive",
// "File Galleries tpl" => "File Galleries tpl",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Search by name" => "Search by name",
// "Search in content" => "Search in content",
// "Configure Forum" => "Configure Forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Set language" => "Set language",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
// "Refuse" => "Refuse",
// "Waiting requests" => "Waiting requests",
// "Cancel friendship request" => "Cancel friendship request",
// "Your friends" => "Your friends",
// "break friendship" => "break friendship",
// "Geographic" => "Geographic",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "Make Map" => "Make Map",
// "Google Map Locator" => "Google Map Locator",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "body" => "body",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "here" => "here",
// "Importer log" => "Importer log",
// "Tiki installer" => "Tiki installer",
// "Welcome" => "Welcome",
// "Welcome to the Tiki installation and upgrade script" => "Welcome to the Tiki installation and upgrade script",
// "Use this script to install a new Tiki database or upgrade your existing database to release" => "Use this script to install a new Tiki database or upgrade your existing database to release",
// "For the latest information about this release, please read the" => "For the latest information about this release, please read the",
// "Release Notes" => "Release Notes",
// "For complete documentation, please visit" => "For complete documentation, please visit",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Select your language" => "Select your language",
// "Read the License" => "Read the License",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>",
// "Review the System Requirements" => "Review the System Requirements",
// "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "This installer will perform some basic checks automatically" => "This installer will perform some basic checks automatically",
// "Memory" => "Memory",
// "Success" => "Success",
// "Tiki has not detected your PHP memory_limit" => "Tiki has not detected your PHP memory_limit",
// "This probably means you have no set limit (all is well)" => "This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Send Test Message" => "Send Test Message",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review your mail log for details" => "Review your mail log for details",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Image Processing" => "Image Processing",
// "Tiki detected" => "Tiki detected",
// "Tiki was not able to detect the GD library" => "Tiki was not able to detect the GD library",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Set the Database Connection" => "Set the Database Connection",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "You must create the database and user <em>before</em> completing this page" => "You must create the database and user <em>before</em> completing this page",
// "Tiki cannot find a database connection" => "Tiki cannot find a database connection",
// "This is normal for a new installation" => "This is normal for a new installation",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Use Existing Connection" => "Use Existing Connection",
// "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Database information" => "Database information",
// "Enter your database connection information" => "Enter your database connection information",
// "Database type" => "Database type",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Host name" => "Host name",
// "Enter the host name or IP for your database" => "Enter the host name or IP for your database",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "Database name" => "Database name",
// "Enter the name of the database that Tiki will use" => "Enter the name of the database that Tiki will use",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "Database user" => "Database user",
// "Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
// "User name" => "User name",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Install" => "Install",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Reinstall the database" => "Reinstall the database",
// "This will destroy your current database" => "This will destroy your current database",
// "Reinstall" => "Reinstall",
// "Upgrade" => "Upgrade",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them" => "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please login with your admin password to continue" => "Please login with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Review the Installation" => "Review the Installation",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Login" => "Secure Login",
// "Administrator" => "Administrator",
// "Admin email" => "Admin email",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Enter Your Tiki" => "Enter Your Tiki",
// "The installation is complete" => "The installation is complete",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "Installation" => "Installation",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "MultiTiki" => "MultiTiki",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "Database Connection" => "Database Connection",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Install Profile" => "Install Profile",
// "Configure the General Settings" => "Configure the General Settings",
// "Tiki Icon" => "Tiki Icon",
// "TikiWiki Project Web Site" => "TikiWiki Project Web Site",
// "Support Forums" => "Support Forums",
// "TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware Project",
// "Powered by TikiWiki" => "Powered by TikiWiki",
// "Interactive translator" => "Interactive translator",
// "has been updated" => "has been updated",
// "Close this window" => "Close this window",
// "Go Back" => "Go Back",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Upload to Kaltura" => "Upload to Kaltura",
// "List Entries" => "List Entries",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Views" => "Views",
// "Plays" => "Plays",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
// "v" => "v",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "Max Clicks" => "Max Clicks",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "Rejected" => "Rejected",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Current Value" => "Current Value",
// "Future vers" => "Future vers",
// "SlideShow" => "SlideShow",
// "Keep gallery window open" => "Keep gallery window open",
// "Your comment" => "Your comment",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Media Entries" => "Media Entries",
// "Mix Entries" => "Mix Entries",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "Browse Entries" => "Browse Entries",
// "Additional Info" => "Additional Info",
// "Media Type" => "Media Type",
// "No entries" => "No entries",
// "No media entries found. " => "No media entries found. ",
// "Click here " => "Click here ",
// "to upload" => "to upload",
// "No mix entries found. " => "No mix entries found. ",
// "to create a new mix" => "to create a new mix",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "If an object is not in the special section, then only the default perms are on" => "If an object is not in the special section, then only the default perms are on",
// "Special" => "Special",
// "Take Survey" => "Take Survey",
// "users registered" => "users registered",
// "Distance (km)" => "Distance (km)",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Page aliases found" => "Page aliases found",
// "Last modification" => "Last modification",
// "Page creator" => "Page creator",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "Perform action with checked" => "Perform action with checked",
// "Xml Zip" => "Xml Zip",
// "offline" => "offline",
// "Live support:User window" => "Live support:User window",
// "Request live support" => "Request live support",
// "Request support" => "Request support",
// "Open a support ticket instead" => "Open a support ticket instead",
// "Back to admin" => "Back to admin",
// "operator" => "operator",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Thank you" => "Thank you",
// "Mail-in feature" => "Mail-in feature",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Tikiwiki Mods" => "Tikiwiki Mods",
// "Republish all" => "Republish all",
// "Publish all" => "Publish all",
// "Unpublish all" => "Unpublish all",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "Display only this type" => "Display only this type",
// "Unpublish" => "Unpublish",
// "Republish" => "Republish",
// "licence" => "licence",
// "Tikiwiki Mods Configuration" => "Tikiwiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
// "Package Config" => "Package Config",
// "Records" => "Records",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
// "User forum topics" => "User forum topics",
// "Forum topics" => "Forum topics",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
// "Forum replies" => "Forum replies",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "MyInfo" => "MyInfo",
// "Contacts Preferences" => "Contacts Preferences",
// "Sent Edition" => "Sent Edition",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Available Newsletters" => "Available Newsletters",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "Edit Permissions" => "Edit Permissions",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign global permissions" => "Assign global permissions",
// "Reset to Global Perms" => "Reset to Global Perms",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>" => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Preview of version" => "Preview of version",
// "(current)" => "(current)",
// "Source of version" => "Source of version",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "no avatar" => "no avatar",
// "icons" => "icons",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Any" => "Any",
// "Items found" => "Items found",
// "Rank" => "Rank",
// "atts" => "atts",
// "List Attachments" => "List Attachments",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Plugin" => "Plugin",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No pages" => "No pages",
// "Add Page" => "Add Page",
// "Add Structure Pages" => "Add Structure Pages",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Edit quiz" => "Edit quiz",
// "General Options" => "General Options",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prologue" => "Prologue",
// "Epilogue" => "Epilogue",
// "time taken" => "time taken",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "star" => "star",
// "half star" => "half star",
// "Send a link" => "Send a link",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "A valid email is mandatory to register" => "A valid email is mandatory to register",
// "Select your group" => "Select your group",
// "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter",
// "You don't have permission to use this feature" => "You don't have permission to use this feature",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Last Version" => "Last Version",
// "Back to page" => "Back to page",
// "to version" => "to version",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "Calendar Items" => "Calendar Items",
// "octets" => "octets",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Save as Draft" => "Save as Draft",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send a structure" => "Send a structure",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Create a sheet" => "Create a sheet",
// "Edit this sheet" => "Edit this sheet",
// "Create New Sheet" => "Create New Sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Header Rows" => "Header Rows",
// "Footer Rows" => "Footer Rows",
// "Create new Sheet" => "Create new Sheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Available Sheets" => "Available Sheets",
// "Location : " => "Location : ",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "TOC" => "TOC",
// "Child" => "Child",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "page: %0/%1" => "page: %0/%1",
// "Last edited by" => "Last edited by",
// "based on work by" => "based on work by",
// "Contributors to this page" => "Contributors to this page",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Clean" => "Clean",
// "Params" => "Params",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Tiki Logs" => "Tiki Logs",
// "Clean logs older than" => "Clean logs older than",
// "months" => "months",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "Author, if different from the Creator" => "Author, if different from the Creator",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Add File" => "Add File",
// "Maximum file size is around" => "Maximum file size is around",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "For image files" => "For image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "No gallery available" => "No gallery available",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Default view" => "Default view",
// "Manage Fields" => "Manage Fields",
// "Basic Data" => "Basic Data",
// "User Icon" => "User Icon",
// "(non public)" => "(non public)",
// "Homepage" => "Homepage",
// "Users HomePage" => "Users HomePage",
// "This user is your friend " => "This user is your friend ",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Request friendship from this user" => "Request friendship from this user",
// "Additional Information" => "Additional Information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Forum comments" => "Forum comments",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
// "Personal Information" => "Personal Information",
// "Male" => "Male",
// "Female" => "Female",
// "Use Google Map locator" => "Use Google Map locator",
// "Your personal tracker information" => "Your personal tracker information",
// "View extra information" => "View extra information",
// "Unavailable - please set your e-mail below" => "Unavailable - please set your e-mail below",
// "Your preferred language" => "Your preferred language",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
// "Select language.." => "Select language..",
// "Display info tooltip on mouseover for every user who allows his/her information to be public" => "Display info tooltip on mouseover for every user who allows his/her information to be public",
// "Notify sender when reading his mail" => "Notify sender when reading his mail",
// "My user items" => "My user items",
// "My level" => "My level",
// "Account Information" => "Account Information",
// "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Leave \"New password\" and \"Confirm new password\" fields blank to keep current password",
// "Confirm new password" => "Confirm new password",
// "Current password (required)" => "Current password (required)",
// "Change administrative info" => "Change administrative info",
// "Account Deletion" => "Account Deletion",
// "Are you really sure you want to delete your account " => "Are you really sure you want to delete your account ",
// "Check this box if you really want to delete your account" => "Check this box if you really want to delete your account",
// "Delete my account" => "Delete my account",
// "New task" => "New task",
// "Task list" => "Task list",
// "Admin mode off" => "Admin mode off",
// "Admin mode on" => "Admin mode on",
// "Task help" => "Task help",
// "Empty Trash" => "Empty Trash",
// "Received task" => "Received task",
// "You received this task, please read and execute it" => "You received this task, please read and execute it",
// "Send task" => "Send task",
// "You send this task to a other user" => "You send this task to a other user",
// "Shared task" => "Shared task",
// "This task is public to a special group" => "This task is public to a special group",
// "Accepted by Task User and Creator" => "Accepted by Task User and Creator",
// "Accepted User and Creator" => "Accepted User and Creator",
// "Task is accepted by user and creator" => "Task is accepted by user and creator",
// "Not Accepted by One User" => "Not Accepted by One User",
// "Not Accepted User" => "Not Accepted User",
// "Task is rejected by one user" => "Task is rejected by one user",
// "Waiting for Me" => "Waiting for Me",
// "Task is not accepted by you, read the task and accept or reject it" => "Task is not accepted by you, read the task and accept or reject it",
// "Waiting for Other User" => "Waiting for Other User",
// "Task is not accepted/rejected by other user" => "Task is not accepted/rejected by other user",
// "Admin Mode" => "Admin Mode",
// "Edit task" => "Edit task",
// "NOT accept" => "NOT accept",
// "Remove from Trash" => "Remove from Trash",
// "Move into Trash" => "Move into Trash",
// "Task saved" => "Task saved",
// "Edit Task" => "Edit Task",
// "View Task" => "View Task",
// "Open a new task" => "Open a new task",
// "taskId" => "taskId",
// "Task user" => "Task user",
// "Only the creator can delete this task" => "Only the creator can delete this task",
// "Use start date and time" => "Use start date and time",
// "Use end date and time" => "Use end date and time",
// "Open / In Process" => "Open / In Process",
// "Waiting / Not Started" => "Waiting / Not Started",
// "Shared for Group" => "Shared for Group",
// "Accepted by User" => "Accepted by User",
// "No / Rejected" => "No / Rejected",
// "Accepted by Creator" => "Accepted by Creator",
// "This message will be send to users if you are makeing changes of assigned tasks" => "This message will be send to users if you are makeing changes of assigned tasks",
// "Send message with changes" => "Send message with changes",
// "Modified by" => "Modified by",
// "Marked as deleted" => "Marked as deleted",
// "Inform task user by email" => "Inform task user by email",
// "You can only view this task" => "You can only view this task",
// "%m/%d/%Y [%H:%M]" => "%m/%d/%Y [%H:%M]",
// "Select One" => "Select One",
// "Undo Trash" => "Undo Trash",
// "Received" => "Received",
// "Submitted" => "Submitted",
// "Shared" => "Shared",
// "All Shared Tasks" => "All Shared Tasks",
// "completed (100%)" => "completed (100%)",
// "Public for group" => "Public for group",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in witch you want to get the reports" => "Interval in witch you want to get the reports",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "Reports are disabled, only standard reporting is available" => "Reports are disabled, only standard reporting is available",
// "Sites you are watching" => "Sites you are watching",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user submits a blog post" => "A user submits a blog post",
// "A user posts a forum thread" => "A user posts a forum thread",
// "A user posts a forum topic" => "A user posts a forum topic",
// "A user edited a wiki page" => "A user edited a wiki page",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "Insert Row" => "Insert Row",
// "Insert Column" => "Insert Column",
// "Remove Row" => "Remove Row",
// "Remove Column" => "Remove Column",
// "Merge Cells" => "Merge Cells",
// "Restore Cells" => "Restore Cells",
// "Copy Calculation" => "Copy Calculation",
// "Format Cell" => "Format Cell",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Answers" => "Answers",
// "Add Suggestion" => "Add Suggestion",
// "Manage Message Queue" => "Manage Message Queue",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Editing" => "Editing",
// "Post New" => "Post New",
// "Watch for replies" => "Watch for replies",
// "Send me an e-mail when someone replies to my topic" => "Send me an e-mail when someone replies to my topic",
// "Don't send me any e-mails" => "Don't send me any e-mails",
// "Editing posts" => "Editing posts",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Archived" => "Archived",
// "Topic List" => "Topic List",
// "The post has been reported and will be reviewed by a moderator" => "The post has been reported and will be reviewed by a moderator",
// "Print this page only" => "Print this page only",
// "Print all pages" => "Print all pages",
// "Stop Monitor" => "Stop Monitor",
// "Edit Fields" => "Edit Fields",
// "Pending" => "Pending",
// "View inserted item" => "View inserted item",
// "Tracker Item" => "Tracker Item",
// "Filter Tracker Items" => "Filter Tracker Items",
// "Edit/Delete" => "Edit/Delete",
// "Items list" => "Items list",
// "Special Operations" => "Special Operations",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Part" => "Part",
// "page id" => "page id",
// "View edit icons" => "View edit icons",
// "3d browser" => "3d browser",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Fullscreen" => "Fullscreen",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Show/Hide Left Column" => "Show/Hide Left Column",
// "Show/Hide Right Column" => "Show/Hide Right Column",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Leave" => "Leave",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Last Month" => "Last Month",
// "Last Year" => "Last Year",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Save the page, but do not send notifications and do not count it as new content to be translated" => "Save the page, but do not send notifications and do not count it as new content to be translated",
// "Save the page as a draft" => "Save the page as a draft",
// "Save Draft" => "Save Draft",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new major release branch is available" => "A new major release branch is available",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Wiki Attachments" => "Wiki Attachments",
// "Configuration options for all blogs on your site" => "Configuration options for all blogs on your site",
// "Trackers settings" => "Trackers settings",
// "Feeds settings" => "Feeds settings",
// "Maps configuration" => "Maps configuration",
// "Score settings" => "Score settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Customize look and feel of your Tiki" => "Customize look and feel of your Tiki",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Kaltura settings" => "Kaltura settings",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Object doesn't exists" => "Object doesn't exists",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "No display" => "No display",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "You cannot have a blank password" => "You cannot have a blank password",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "You cannot mix old and new trackers" => "You cannot mix old and new trackers",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Error opening uploaded file" => "Error opening uploaded file",
// "Any wiki page is changed, even minor changes" => "Any wiki page is changed, even minor changes",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "PHP error" => "PHP error",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The list name must be specified" => "The list name must be specified",
// "Sorry, your list could not be added. Please check that it doesn\\'t already exist" => "Sorry, your list could not be added. Please check that it doesn\\'t already exist",
// "Sorry, your list could not be updated. Please check that it already exists" => "Sorry, your list could not be updated. Please check that it already exists",
// "register_globals should be off by default. See the php manual for details" => "register_globals should be off by default. See the php manual for details",
// "off" => "off",
// "session.use_trans_sid should be off by default. See the php manual for details" => "session.use_trans_sid should be off by default. See the php manual for details",
// "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "You have to provide a word" => "You have to provide a word",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "JavaScript is required for this page" => "JavaScript is required for this page",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "Group name can not be empty" => "Group name can not be empty",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "New %s created with %s %s" => "New %s created with %s %s",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "%s %s successfully deleted" => "%s %s successfully deleted",
// "Deleted account %s" => "Deleted account %s",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "%s modification failed" => "%s modification failed",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Permission denied you cannot use the batch directory loading" => "Permission denied you cannot use the batch directory loading",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Tiki RSS feed for blog: " => "Tiki RSS feed for blog: ",
// "Last modifications to the blog" => "Last modifications to the blog",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Last posts to weblogs" => "Last posts to weblogs",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Calendar event : " => "Calendar event : ",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Access Denied" => "Access Denied",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "Su" => "Su",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl" => "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Last sites" => "Last sites",
// "No parent specified" => "No parent specified",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "No object indicated" => "No object indicated",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "No type indicated" => "No type indicated",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "The file you selected is too large to upload" => "The file you selected is too large to upload",
// "Incorrect file extension was used for your 0gg screencast, expecting .ogg" => "Incorrect file extension was used for your 0gg screencast, expecting .ogg",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Last files uploaded to the file galleries" => "Last files uploaded to the file galleries",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Last topics in forums" => "Last topics in forums",
// "Not supported yet" => "Not supported yet",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "You must be logged in to use this feature" => "You must be logged in to use this feature",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Permission denied you cannot make the map of this gallery" => "Permission denied you cannot make the map of this gallery",
// "Back to preferences" => "Back to preferences",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "updated from structured text import" => "updated from structured text import",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "Page saved (version %d)" => "Page saved (version %d)",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Permission denied: You cannot upload videos" => "Permission denied: You cannot upload videos",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Permission denied: You cannot remix videos" => "Permission denied: You cannot remix videos",
// "Permission denied: You cannot change video version" => "Permission denied: You cannot change video version",
// "Permission denied: You cannot delete kaltura video" => "Permission denied: You cannot delete kaltura video",
// "Permission denied: You cannot download kaltura video" => "Permission denied: You cannot download kaltura video",
// "Permission denied: You cannot edit video information" => "Permission denied: You cannot edit video information",
// "Permission denied: You cannot view video" => "Permission denied: You cannot view video",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Could not find the file requested" => "Could not find the file requested",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "This gallery does not exist" => "This gallery does not exist",
// "Permission denied: You cannot view this page" => "Permission denied: You cannot view this page",
// "Invalid action" => "Invalid action",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Invalid password" => "Invalid password",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "Maps feature is not correctly setup : Maps path is missing" => "Maps feature is not correctly setup : Maps path is missing",
// "I could not make a copy" => "I could not make a copy",
// "map edit" => "map edit",
// "You dont have permission to do that" => "You dont have permission to do that",
// "Tiki RSS feed for maps" => "Tiki RSS feed for maps",
// "List of maps available" => "List of maps available",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled" => "Your PHP installation does not have zlib enabled",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Note not found" => "Note not found",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Pageviews" => "Pageviews",
// "You don't have permission to edit quizzes" => "You don't have permission to edit quizzes",
// "You are already logged in" => "You are already logged in",
// "You must choose a group" => "You must choose a group",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Permission denied you cannot rename this page" => "Permission denied you cannot rename this page",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "Error Message" => "Error Message",
// "Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "No newsletters available" => "No newsletters available",
// "invalid email" => "invalid email",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Clean the sql logs" => "Clean the sql logs",
// "Report to the webmaster" => "Report to the webmaster",
// "empty" => "empty",
// "No trackerId specified" => "No trackerId specified",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Incorrect file extension" => "Incorrect file extension",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "Your screencast has been uploaded successfully" => "Your screencast has been uploaded successfully",
// "Your screencasts have been uploaded successfully" => "Your screencasts have been uploaded successfully",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "Email is set to %s" => "Email is set to %s",
// "was moved into trash" => "was moved into trash",
// "trashed by" => "trashed by",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task accepted by creator" => "Task accepted by creator",
// "Task accepted by task user" => "Task accepted by task user",
// "Task NOT accepted by creator" => "Task NOT accepted by creator",
// "Task NOT accepted by task user" => "Task NOT accepted by task user",
// "Sorry this task does not exist or you have no rights to view this task" => "Sorry this task does not exist or you have no rights to view this task",
// "Task entries" => "Task entries",
// "Info message" => "Info message",
// "NEW Task" => "NEW Task",
// "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks",
// "Changes on Task" => "Changes on Task",
// "You received a new task" => "You received a new task",
// "The priority is" => "The priority is",
// "very low" => "very low",
// "low" => "low",
// "high" => "high",
// "very high" => "very high",
// "You've to start your work at least on" => "You've to start your work at least on",
// "You've to finish your work on" => "You've to finish your work on",
// "Login and click the link below" => "Login and click the link below",
// "Please read the task and work on it" => "Please read the task and work on it",
// "Sorry, there was an error while trying to write data into the database" => "Sorry, there was an error while trying to write data into the database",
// "A new page is created in a language" => "A new page is created in a language",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "A SheetId is required" => "A SheetId is required",
// "That tracker don't use extras" => "That tracker don't use extras",
// "There are a problem connecting to that account" => "There are a problem connecting to that account",
// "There are a problem deleting that mail" => "There are a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There are a problem deleting mails" => "There are a problem deleting mails",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Last modifications to the Wiki" => "Last modifications to the Wiki",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// "The page is empty" => "The page is empty",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"ID" => "ID",
"Wiki" => "Wiki",
"Blogs" => "Blogs",
"FAQs" => "FAQs",
"blog" => "blog",
"faq" => "faq",
"newsletter" => "newsletter",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: failed",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"Link" => "Link",
"Blog" => "Blog",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Banners" => "Banners",
"FAQ" => "FAQ",
"Copyright" => "Copyright",
"PHPLayers" => "PHPLayers",
"Ajax" => "Ajax",
"Webmail" => "Webmail",
"Mail-in" => "Mail-in",
"Rankings" => "Rankings",
"Local" => "Local",
"Mb" => "Mb",
"geo.position" => "geo.position",
"geo.region" => "geo.region",
"geo.placename" => "geo.placename",
"Normal" => "Normal",
"Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
"Field of view" => "Field of view",
"Downloads" => "Downloads",
"Login" => "Login",
"Trackeritem" => "Trackeritem",
"min" => "min",
"wiki" => "wiki",
"faqs" => "faqs",
"blogs" => "blogs",
"Item" => "Item",
"Avatar" => "Avatar",
"Cookie" => "Cookie",
"Desc" => "Desc",
"Download" => "Download",
"Id" => "Id",
"Original" => "Original",
"id" => "id",
"desc" => "desc",
"posts:" => "posts:",
"Copyrights" => "Copyrights",
"exec" => "exec",
"Total" => "Total",
"Perms" => "Perms",
"d=diff" => "d=diff",
"Menus" => "Menus",
"login" => "login",
"Bookmarks" => "Bookmarks",
"Cache" => "Cache",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"avatar" => "avatar",
"E-mail" => "E-mail",
"Mover" => "Mover",
"LDAP" => "LDAP",
"URL:" => "URL:",
"PAM" => "PAM",
"image/png" => "image/png",
"image/bmp" => "image/bmp",
"image/x-icon" => "image/x-icon",
"Robots" => "Robots",
"AutoLinks" => "AutoLinks",
"dls" => "dls",
"Links" => "Links",
"SysLogs" => "SysLogs",
"phpinfo" => "phpinfo",
"Mods" => "Mods",
"Look & feel" => "Look & feel",
"Cookies" => "Cookies",
"DSN" => "DSN",
"bytes" => "bytes",
"x" => "x",
"Loc" => "Loc",
"Cat" => "Cat",
"Prio" => "Prio",
"h" => "h",
"CMS" => "CMS",
"cookie" => "cookie",
"Coms" => "Coms",
"Regex" => "Regex",
"Admin layout" => "Admin layout",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"bcc" => "bcc",
"powered by" => "powered by",
"RSS" => "RSS",
"popup" => "popup",
"+" => "+",
"Sites" => "Sites",
"editor" => "editor",
"hits (desc)" => "hits (desc)",
"hits (asc)" => "hits (asc)",
"normal" => "normal",
"Imgs" => "Imgs",
"Img" => "Img",
"msgs" => "msgs",
"Prefs" => "Prefs",
"Slides" => "Slides",
"Site" => "Site",
"tikiwiki.org" => "tikiwiki.org",
"auto-link urls" => "auto-link urls",
"pvs" => "pvs",
"Weblogs" => "Weblogs",
"#" => "#",
"Pos" => "Pos",
"Emot" => "Emot",
"pts" => "pts",
"CC" => "CC",
"BCC" => "BCC",
"TOP" => "TOP",
"%H:%M %Z" => "%H:%M %Z",
"tiki-mobile.php" => "tiki-mobile.php",
"unicode" => "unicode",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Esta funcionalidade está desabilitado",
"Permission denied. You cannot view pages" => "Permissão negada: você não pode ver páginas",
"This script cannot be called directly" => "Este script não pode ser chamado directamente",
"The copyright management feature is not enabled." => "A funcionalidade de gestão de direitos de autor está desabilitada.",
"No page indicated" => "Nenhuma página indicada",
"You must supply all the information, including title and year." => "Você precisa fornecer toda a informação, incluindo título e ano.",
"You do not have permission to use this feature" => "Você não possui permissão para usar esta funcionalidade",
"Type" => "Tipo",
"Name" => "Nome",
"Description" => "Descrição",
"Size" => "Tamanho",
"Created" => "Criado em",
"Uploaded" => "Carregado",
"Last Modified" => "Última Modificação",
"Creator" => "Criador",
"Author" => "Autor",
"Comment" => "Comentário",
"Files" => "Ficheiros",
"Hits" => "Visitas",
"Locked by" => "Travada por",
"Path" => "Caminho",
"None" => "Nenhum",
"Other" => "Outros",
"Simplified Chinese" => "Chinês Simplificado",
"Chinese" => "Chinês",
"Czech" => "Checo",
"Danish" => "Holandês",
"German" => "Alemão",
"English" => "Inglês",
"Spanish" => "Espanhol",
"Greek" => "Grego",
"French" => "Francês",
"Hebrew" => "Hebreu",
"Italian" => "Italiano",
"Japanese" => "Japonês",
"Dutch" => "Dinamarquês",
"Norwegian" => "Norueguês",
"Polish" => "Polaco",
"Brazilian Portuguese" => "Português do Brasil",
"Russian" => "Russo",
"Slovak" => "Eslovaco",
"Serbian" => "Sérvio",
"Swedish" => "Sueco",
"Traditional Chinese" => "Chinês Tradicional",
"Permission denied" => "Permissão negada",
"The file is not a CSV file or has not a correct syntax" => "O ficheiro não é um ficheiro CSV ou não possui o formato correcto",
"locked" => "travada",
"locked by" => "travada por",
"Administration:" => "Administração:",
"in" => "em",
"continued" => "continuação",
"New Image Uploaded by" => "Nova imagem carregada por",
"New Subscriptions" => "Nova assinatura",
"New Item in Tracker" => "Novo item no acompanhamento",
"tracker" => "Tracker",
"by" => "por",
"Image Gallery" => "Galeria: Imagens",
"Articles" => "Artigos",
"Forums" => "Fóruns",
"Directory" => "Directório",
"File Gallery" => "Galeria: Ficheiros",
"Quizzes" => "Testes",
"Trackers" => "Acompanhamentos",
"Survey" => "Pesquisa",
"Newsletter" => "Comunicado",
"article" => "artigo",
"directory" => "directório",
"file gallery" => "galeria de ficheiros",
"forum" => "fórum",
"image gallery" => "galeria de imagens",
"poll" => "sondagem",
"quiz" => "teste",
"survey" => "sondagem",
"wiki page" => "pág. wiki",
"image" => "imagem",
"calendar" => "calendário",
"Invalid filename (using filters for filenames)" => "Nome inválido de ficheiro (usando filtros para nomes de ficheiros)",
"Cannot upload this file - maximum upload size exceeded" => "Impossível carregar este ficheiro: tamanho máximo para ficheiro atingido",
"Anonymous" => "Anónimo",
"Wrong password. Cannot post comment" => "Senha incorrecta. Impossível enviar comentário",
"You have to enter a title and text" => "Tem que introduzir um título e um texto",
"Your message has been queued for approval and will be posted after a moderator approves it." => "A mensagem está em fila para aprovação. A mensagem será publicada após aprovação por um moderador.",
"Tiki Link - Insert internal link" => "Tiki Link - Inserir link interno",
"Select a Wiki page to link to:" => "Seleccione uma página Wiki a lincar:",
"Find" => "Procurar",
"find" => "procurar",
"prev" => "ant",
"Page" => "Página",
"next" => "próx",
"Page name" => "Nome da página",
"File Galleries" => "Galerias de Ficheiros",
"Wiki Home" => "Página Inicial Wiki",
"Home" => "Página Inicial",
"previous page" => "página anterior",
"next page" => "página posterior",
"posted on" => "enviado em",
"Continue" => "Continuar",
"By:" => "Por:",
"Read" => "Lida",
"List articles" => "Listar artigos",
"Last post" => "Última mensagem",
"Invalid imagename (using filters for filenames)" => "Nome inválido de imagem (usando filtros para nomes de ficheiros)",
"Errors detected" => "Erros detectados",
"Upload was not successful" => "Upload interrompido com falha",
"No image yet, sorry." => "Sinto muito, sem nenhuma imagem ainda.",
"unknown" => "desconhecido",
"NONE" => "NENHUM",
"Language" => "Idioma",
"Section" => "Secção",
"Theme" => "Tema",
"Rows" => "Linhas",
"Users accept internal messages by default" => "Utilizadores aceitam mensagens por omissão",
"Users can opt-out internal messages" => "Utilizadores podem cancelar mensagens internas",
"Title" => "Título",
"Title length" => "Tamanho do Título",
"Topic" => "Assunto",
"Visible" => "Visível",
"Rating" => "Nota",
"Reads" => "Leituras",
"Images" => "Imagens",
"Newest first" => "Mais novos primeiro",
"Oldest first" => "Mais antigos primeiro",
"Points" => "Pontos",
"Authentication method" => "Método de autenticação",
"Web Server" => "Servidor Web",
"Creation date (desc)" => "Data de criação (desc)",
"Last modification date (desc)" => "última data de modificação (desc)",
"Blog title (asc)" => "Título do Blog (asc)",
"Number of posts (desc)" => "Número de mensagens (desc)",
"Visits (desc)" => "Visitas (desc)",
"Activity (desc)" => "Actividade (desc)",
"Disabled" => "Desactivado",
"Plain text" => "Texto não formatado",
"Link to user information" => "Link para informações do utilizador",
"User avatar" => "Avatar do utilizador",
"Contact user" => "Utilizador para contacto",
"Count admin pageviews" => "Contabilizar pageviews de admin",
"default mapfile" => "ficheiro de mapa padrão",
"Show Country Flag" => "Mostrar a Bandeira do País",
"Validate URLs" => "Validar Endereços",
"Links per page" => "Links por página",
"Method to open directory links" => "Abrindo links do directório",
"replace current window" => "substituir a janela actual",
"new window" => "nova janela",
"inline frame" => "frame interno",
"No error reporting" => "Sem reporte de erros",
"Report all PHP errors" => "Todos os erros PHP",
"Default number of comments per page" => "Número de comentários por página por omissão",
"Comments default ordering" => "Ordenação padrão para comentários",
"Polls" => "Sondagens",
"Newsletters" => "Comunicados",
"Calendar" => "Calendário",
"Category" => "Categoria",
"Score" => "Nota",
"Search" => "Pesquisar",
"Action Log" => "Registo de Actividade",
"Surveys" => "Pesquisas",
"Featured links" => "Links oferecidos",
"Shoutbox" => "Quadro Negro",
"Maps" => "Mapas",
"Live support system" => "Sistema de auxílio on-line",
"Contact Us" => "Contacte-nos",
"HTML Purifier" => "Purificador de HTML",
"Mobile" => "Mobilidade",
"Morcego 3D browser" => "Browser 3D Morcego",
"Wysiwyg editor" => "Editor WYSIWYG",
"Banning system" => "Sistema de banição",
"Stats" => "Estatísticas",
"Referer Stats" => "Estatísticas de Referências",
"Redirect On Error" => "Redireccionar em caso de erro",
"Communications (send/receive objects)" => "Comunicação (enviar/receber objectos)",
"Custom Home" => "Página Inicial Personalizada",
"Mini Calendar" => "Mini-Calendário",
"User Preferences Screen" => "Quadro de Preferências do Utilizador",
"User Notepad" => "Bloco de Notas do Utilizador",
"User Bookmarks" => "Bookmarks do Utilizador",
"User Contacts" => "Contactos de Utilizador",
"User Watches" => "Notificações do Utilizador",
"User Watches Translations" => "Monitorização de Traduções por Utilizadores",
"User Menu" => "Menu do Utilizador",
"User Tasks" => "Tarefas do Utilizador",
"User Messages" => "Mensagens do Utilizador",
"User Files" => "Ficheiros do Utilizador",
"User Levels" => "Níveis de Utilizador",
"Integrator" => "Integrador",
"XMLRPC API" => "API de XMLRPC",
"Debugger Console" => "Consola de depuração",
"Protect against CSRF with a ticket" => "Protecção contra CSRF com ticket",
"Detect browser language" => "Detectar idioma do browser",
"Help System" => "Sistema de Ajuda",
"Smileys" => "Emoticons",
"Dynamic Content System" => "Sistema de Conteúdo Dinâmico",
"Display menus as folders" => "Exibir menus como pastas",
"Protect email against spam" => "Proteger email contra SPAM",
"Activate" => "Activar",
"Comments" => "Comentários",
"Submissions" => "Artigos submetidos",
"Content templates" => "Padrões de conteúdo",
"Print" => "Imprimir",
"Ignore category viewing restrictions" => "Ignorar restrições nas categorias",
"List pages" => "Listar páginas",
"Last changes" => "Últimas alterações",
"Orphan pages" => "Páginas órfãs",
"Referer Search Highlighting" => "Destaque da origem da procura",
"Search stats" => "Estatísticas de procura",
"Ignore individual object permissions" => "Ignorar permissões individuais dos objectos",
"Visits" => "Visitas",
"Accept wiki syntax" => "Aceitar sintaxe Wiki",
"Display 'MyTiki' in the application menu" => "Mostrar 'MeuTiki' no menu de aplicação",
"The server must be able to read/write the directory." => "O servidor terá que ter permissões para escrever/ler na directoria.",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Se activar o Carregamento em Lote, terá que configurar uma directoria com permissões de escrita para o servidor web (recomenda-se que seja fora do espaço web). De seguida, deverá pensar numa forma de carregar ficheiros para essa directoria, utilizando p.e. SCP, FTP, ou outros protocolos",
"The server must be able to read the directory." => "O servidor terá que conseguir ler da directoria.",
"The directory can be outside the web space." => "A directoria poderá ser fora do espaço web.",
"Allow same file to be uploaded more than once" => "Permitir upload do mesmo ficheiro múltiplas vezes",
"Never" => "Nunca",
"Yes, even in the same gallery" => "Sim, mesmo que na mesma galeria",
"Only in different galleries" => "Apenas se a galeria for diferente",
"Uploaded filenames must match regex" => "Ficheiros carregados devem seguir a expressão regular",
"Plain" => "Simples",
"Threaded" => "Por tópico",
"Headers Only" => "Cabeçalhos apenas",
"Title (desc)" => "Título (desc)",
"Title (asc)" => "Título (asc)",
"Topics" => "Tópicos",
"Posts" => "Mensagens",
"Posts per day" => "Publicações por dia",
"Creation Date (desc)" => "Data de criação (desc)",
"Topics (desc)" => "Assuntos (desc)",
"Last post (desc)" => "Última mensagem (desc)",
"Name (desc)" => "Nome (desc)",
"Name (asc)" => "Nome (asc)",
"Browser title" => "Título do Browser",
"Home page" => "Página inicial",
"Use group homepages" => "Usar grupo de páginas",
"Go to group homepage only if login from default homepage" => "Ir para página de grupo apenas se logar desde a homepage por omissão",
"Temporary directory" => "Directório temporário",
"Help URL" => "URL de Ajuda",
"Open external links in new window" => "Hiperligações externas numa nova janela",
"Full path to gdaltindex" => "Caminho completo para o gdaltindex",
"Display modules to all groups always" => "Mostrar sempre módulos a todos grupos",
"Hide anonymous-only modules from registered users" => "Esconder módulos de somente-anónimo de utilizadores registados",
"Content" => "Conteúdo",
"Use database for translation" => "Usar base de dados para tradução",
"full path to mapfiles" => "caminho completo para os ficheiros de mapas",
"Wiki Page for Help" => "Página Wiki para Ajuda",
"Wiki Page for Comments" => "Página Wiki para Comentários",
"Maximum mailbox size (messages, 0=unlimited)" => "Tamanho máximo da caixa de correio (mensagens, 0=ilimitado)",
"Maximum mail archive size (messages, 0=unlimited)" => "Tamanho máximo do arquivo de correio (mensagens, 0=ilimitado)",
"Maximum sent box size (messages, 0=unlimited)" => "Tamanho máximo da caixa de Enviados (mensagens, 0=ilimtado)",
"Port" => "Porta",
"Proxy port" => "Porta do Proxy",
"Record untranslated strings" => "Gravar sem tradução",
"Refresh rate" => "Taxa de actualização",
"Minimum length of search word" => "Tamanho mínimo da palavra de pesquisa",
"Max. number of words containing a syllable" => "Número máximo de palavras contendo uma sílaba",
"Max. age in hours of syllable search cache" => "Tempo máximo em horas de pesquisas de sílabas armazenadas",
"LRU list purging rate" => "Taxa de limpeza da lista LRU",
"LRU list length" => "Tamanho da lista LRU",
"Database" => "Banco de dados",
"Publish" => "Publicar",
"Use proxy" => "Usar proxy",
"Always" => "Sempre",
"Allow viewing HTML mails?" => "Permitir visualizar de correio em HTML?",
"Maximum size for each attachment" => "Tamanho máximo para cada anexo",
"Complete" => "Completo",
"Business style" => "Estilo empresarial",
"Collaborative style" => "Estilo colaborativo",
"Top" => "Topo",
"Both" => "Ambos",
"Cache wiki pages (global)" => "Armazenamento de páginas wiki (global)",
"no cache" => "sem cache",
"minute" => "minuto",
"minutes" => "minutos",
"hour" => "hora",
"hours" => "horas",
"Disable" => "Desactiva",
"Enable wiki 3D browser" => "Habilitar wiki 3D browser",
"Load page on navigation" => "Carregar página na navegação",
"Browser height" => "Altura do browser",
"Navigation depth" => "Profundidade de navegação",
"Node size" => "Tamanho do nodo",
"Text size" => "Tamanho do texto",
"Existing page node color" => "Cor do nodo de página existente",
"Missing page node color" => "Cor do nodo de página inexistente",
"Camera distance" => "Distância da câmara",
"Feed animation interval (milisecs)" => "Intervalço de animação para feeds (milisegs)",
"Friction constant" => "Constante de fricção",
"Elastic constant" => "Constante de elasticidade",
"Eletrostatic constant" => "Constante de Electroestática",
"Node mass" => "Massa do nodo",
"Node charge" => "Carga do nodo",
"Wysiwyg Editor is optional" => "Editor WYSIWYG é opcional",
"... and is displayed by default" => "... e é mostrado por omissão",
"Content is parsed like wiki page" => "Conteúdo é processado como uma página wiki",
"Content is partially parsed" => "Conteúdo é parcialmente processado",
"Toolbar skin" => "Skin da barra de ferramentas",
"Wiki top pages" => "Páginas Wiki mais populares",
"Most relevant pages" => "Páginas mais relevantes",
"Relevance" => "Relevância",
"Wiki last pages" => "Páginas Wiki recentes",
"Modified" => "Modificado",
"Topic date" => "Data do tópico",
"Forums most read topics" => "Tópicos mais lidos nos fóruns",
"Forums best topics" => "Melhores tópicos nos fóruns",
"Forums most visited forums" => "Fóruns mais visitados",
"Forums with most posts" => "Fóruns com mais mensagens",
"Wiki top galleries" => "Galerias Wiki mais populares",
"Wiki top file galleries" => "Galerias de ficheiros mais populares",
"Wiki top images" => "Imagens mais populares",
"Wiki top files" => "Ficheiros mais populares",
"Wiki last images" => "Imagens mais recentes",
"Upload date" => "Data de upload",
"Wiki last files" => "Ficheiros recentes",
"Wiki top articles" => "Artigos mais populares",
"Most visited blogs" => "Blogs mais visitados",
"Most active blogs" => "Blogs mais activos",
"Activity" => "Acctividade",
"Blogs last posts" => "Últimas mensagens em blogs",
"Post date" => "Data de envio",
"Wiki top authors" => "Autores de Wiki mais produtivos",
"Pages" => "Páginas",
"Top article authors" => "Autores de artigos mais produtivos",
"User already exists" => "O utilizador já existe",
"Wrong registration code" => "Código de registo incorrecto",
"Invalid username" => "Utilizador inválido",
"Username is too long" => "Identificador de utilizador muito longo",
"Username cannot contain whitespace" => "Identificador de utilizador não pode conter espaços",
"Wrong passcode. You need to know the passcode to register at this site" => "Código de registo incorrecto; você precisa fornecer um código válido para registar-se neste site",
"Invalid email address. You must enter a valid email address" => "Endereço de email inválido. Você precisa fornecer um endereço de email válido",
"change" => "alterar",
"Today" => "Hoje",
"from" => "de",
"replied" => "respondida",
"Send message" => "Enviar mensagem",
"Attach file" => "Anexar ficheiro",
"Gallery" => "Galeria",
"Image" => "Imagem",
"Forum" => "Fórum",
"Article" => "Artigo",
"Blog post" => "Mensagem de blog",
"Tracker" => "Acompanhamento",
"Unknown" => "Desconhecido",
"Directory category" => "Categoria de directório",
"Prev" => "Ant",
"Next" => "Próx",
"comment" => "comentário",
"Click Here" => "Clique aqui",
"Edit Template" => "Editar modelo",
"Admin Feature" => "Administrar Funcionalidade",
"Hide" => "Esconder",
"help" => "auxílio",
"All" => "Todos",
"Date Selector" => "Seletor de Data",
"Select All" => "Seleccionar todos",
"days" => "dias",
"day" => "dia",
"mins" => "min",
"secs" => "s",
"done" => "pronto",
"for" => "para",
"Priority" => "Prioridade",
"Yes" => "Sim",
"No" => "Não",
"created from structure" => "criar a partir de estrutura",
"text" => "texto",
"You are not logged in" => "Você não está logado(a)",
"Page cannot be found" => "A página não foi encontrada",
"Permission denied. You cannot view this section" => "Permissão negada: você não pode ver esta secção",
"Help" => "Ajuda",
"You are banned from" => "Você foi banido(a) de",
"quizzes" => "testes",
"forums" => "fóruns",
"Click to edit dynamic variable" => "Clique para editar a variável dinâmica",
"Update variables" => "Actualizar variáveis",
"index" => "índice",
"Show" => "Mostrar",
"sad" => "triste",
"confused" => "confuso",
"cool" => "legal",
"mad" => "furioso",
"Removed" => "Removido(a)",
"at" => "em",
"new" => "novo",
"Unknown language" => "Idioma desconhecido",
"Click here to confirm your action" => "Clique aqui para confirmar sua acção",
"Sea Surfing (CSRF) detected. Operation blocked." => "Detectado tentativa de Sea Surfing (CSRF). Operação bloqueada.",
"Heading" => "Cabeçalho",
"Reduce area height" => "Reduzir a altura de área",
"Enlarge area height" => "Ampliar a altura de área",
"Wiki Help" => "Ajuda wiki",
"Item Modification" => "Modificação do Item",
"Item creation" => "Criação do Item",
"Subject" => "Assunto",
"Tracker was modified at " => "Tracker foi modificado em ",
"Field is not numeric" => "Campo não é numérico",
"text field" => "campo texto",
"half column" => "meia coluna",
"size" => "tamanho",
"max" => "máx",
"textarea" => "caixa de texto",
"checkbox" => "caixa de marcação",
"drop down" => "caixa de selecção",
"user selector" => "seleccionador de utilizador",
"group selector" => "seleccionador de grupo",
"date and time" => "data e hora",
"action" => "acção",
"category" => "categoria",
"email" => "E-mail",
"url" => "endereço",
"system" => "sistema",
"attachment" => "anexo",
"open" => "aberto",
"pending" => "pendente",
"closed" => "fechado",
"Message" => "Mensagem",
"child categories" => "categorias-filhas",
"objects in category" => "objectos nesta categoria",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PONTO)",
"Password should be at least" => "A palavra-passe deveria ter no mínimo",
"characters long" => "caracteres",
"Password must contain both letters and numbers" => "A palavra-passe deve ser composta de letras e algarismos",
"Country" => "País",
"No subject" => "Sem assunto",
"Location" => "Localização",
"Field" => "Campo",
"Start date" => "Data de início",
"Attachment" => "Anexo",
"File" => "Ficheiro",
"Show description" => "Exibir descrição",
"Displays the user Avatar" => "Exibe o avatar do utilizador",
"username" => "utilizador",
"Back" => "Voltar",
"Backlinks" => "Referências",
"List all pages that link to specific pages" => "Listar todas as páginas com hiperligação para páginas especificadas",
"No pages links to" => "Nenhuma página com hiperligação para",
"One page links to" => "Uma página com hiperligação para",
"pages link to" => "páginas com hiperligação para",
"Zone" => "Zona",
"Items" => "Itens",
"Insert theme-styled box on wiki page" => "Inserir caixa com estilo do tema na página wiki",
"Insert list of items with the current/given category in the wiki page" => "Inserir uma lista de itens para a categoria actual/fornecida na página wiki",
"Categories are disabled" => "Categorias estão desabilitadas",
"Display Tiki objects that have not been categorized" => "Exibir objectos Tiki que não foram categorizados",
"Objects" => "Itens",
"Insert the full category path for each category that this wiki page belongs to" => "Inserir o caminho completo para cada categoria a que esta página wiki pertence",
"Center" => "Centralizar",
"Centers the plugin content in the wiki page" => "Centraliza o conteúdo de plugin na página wiki",
"Chart" => "Gráfico",
"title" => "título",
"Code" => "Código",
"Displays a snippet of code" => "Mostrar um pedaço de código",
"code" => "código",
"Dynamic Content" => "Conteúdo dinâmico",
"Insert copyright notices" => "Inserir informações de copyright",
"Example" => "Exemplo",
"seconds" => "segundos",
"Pre" => "Ant",
"Right" => "Direita",
"Left" => "Esquerda",
"Clear" => "Limpar",
"Creates a definition list" => "Criar uma lista de definições",
"term" => "termo",
"definition" => "definição",
"one definition per line" => "uma definição por linha",
"Events" => "Eventos",
"Upcoming events" => "Próximos eventos",
"Label" => "Rótulo",
"Displays the data using the Tikiwiki odd/even table style" => "Exibe os dados usando o estilo de tabelas par/ímpar do Tikiwiki",
"cells" => "células",
"sort" => "ordenar",
"failed" => "falhou",
"description" => "descrição",
"Value" => "Valor",
"Displays a graphical GAUGE" => "Exibe um medidor gráfico",
"type" => "tipo",
"Group" => "Grupo",
"groups" => "grupos",
"HTML code" => "Código HTML",
"URL" => "Endereço",
"name" => "nome",
"Image ID" => "ID da Imagem",
"Image size" => "Tamanho da imagem",
"Thumbnail" => "Miniatura",
"Browse" => "Navegar",
"Include" => "Incluir",
"Start" => "Início",
"Stop" => "Parar",
"Include a page" => "Incluir uma página",
"Displays the text only if the language matchs" => "Mostrar o texto somente se o idioma coincidir",
"Last Modification" => "última modificação em",
"List Pages" => "Listar páginas",
"Sort" => "Ordenar",
"or" => "ou",
"Filter" => "Filtrar",
"complete" => "completo",
"articles" => "artigos",
"Map" => "Associar",
"Feature disabled" => "Funcionaliade desabilitada",
"Template" => "Padrão",
"Style" => "Estilo",
"Groups" => "Grupos",
"Module Name" => "Nome do Módulo",
"Please choose a module" => "Por favor, seleccione um módulo",
"to be used as argument" => "para ser utilizado como argumento",
"Displays a module inline in a wiki page" => "Exibe um módulo embutido na página",
"Sorry, no such module" => "Sinto muito, módulo inexistente",
"Font" => "Tipo de Letra",
"Displays the data using a monospace font" => "Exibe os dados usando uma fonte monospace",
"Text" => "Texto",
"Sticky" => "Persistente",
"data" => "dados",
"Object" => "Objecto",
"Status" => "Estado",
"Picture" => "Imagem",
"picture not found" => "imagem não encontrada",
"Displays a list of plugins available in this wiki." => "Fornece uma lista de plugins neste wiki.",
"No version indicated" => "Nenhuma versão indicada",
"No arguments indicated" => "Nenhum argumento indicado",
"Poll" => "Sondagem",
"Preferences" => "Preferências",
"User Information" => "Informações do Utilizador",
"one data per line" => "um dado por linha",
"Icon" => "Ícone",
"Close" => "Fechar",
"Date" => "Data",
"Automatically creates a link to the appropriate SourceForge object" => "Criar automaticamente uma hiperligação para o objecto apropriado no SourceForge",
"Display" => "Mostrar",
"Action" => "Acção",
"Sorts the plugin content in the wiki page" => "Ordena o conteúdo do plugin na página wiki",
"Order" => "Ordem",
"Split a page into rows and columns" => "Dividir uma página em linhas e colunas",
"First" => "Primeiro",
"Edit" => "Editar",
"row1col1" => "linha1col1",
"row1col2" => "linha1col2",
"row2col1" => "linha2col1",
"row2col2" => "linha2col2",
"Run a sql query" => "Executar uma consulta SQL",
"sql query" => "consulta SQL",
"Missing db param" => "Parâmetro de banco de dados ausente",
"Subscribe" => "Inscrever-se",
"Url" => "URL",
"Tag Name" => "Nome da tag",
"Search the titles of all pages in this wiki" => "Procurar os títulos de todas as páginas deste wiki",
"No pages found for title search" => "Nenhuma página encontrada para a procura de título",
"One page found for title search" => "Uma página encontrada para a procura de título",
"pages found for title search" => "páginas encontradas para a procura de título",
"Structure ID" => "ID de Estrutura",
"Public" => "Público",
"Translate" => "Traduzir",
"Fields" => "Campos",
"Email" => "E-mail",
"to" => "até",
"template" => "padrão",
"Preview" => "Pré-visualização",
"preview" => "pré-visualização",
"View" => "Ver",
"Error" => "Erro",
"Filters" => "Filtros",
"Test" => "Teste",
"Mode" => "Modo",
"Delete" => "Apagar",
"Links to a translated content" => "Hiperligação para conteúdo traduzido",
"Flag" => "Marca",
"Displays the number of registered users" => "Mostrar o número de utilizadores registados",
"Real Name" => "Nome verdadeiro",
"users" => "utilizadores",
"Versions" => "Versões",
"Vote" => "Votar",
"Table" => "Tabela",
"Level" => "Nível",
"^Parameters: key=>value,...\n" => "^Parâmetros: chave=>valor,...\n",
"__key__ | __default__ | __comments__\n" => "__chave__ | __omissão__ | __comentários__\n",
"External Wiki" => "Wiki Externo",
"valid" => "válida",
"width" => "largura",
"height" => "altura",
"Removed version \$version" => "Versão \$version removida",
"ERROR: Either the subject or body must be non-empty" => "ERRO: Ou o assunto ou o corpo tem que ser preenchido",
"ERROR: No valid users to send the message" => "ERRO: Nenhum destinatário válido para a mensagem",
"Invalid user" => "Utilizador inválido",
"Message will be sent to: " => "A mensagem será enviada para: ",
"No more messages" => "Nenhuma outra mensagem",
"Categories" => "Categorias",
"Categorize" => "Categorização",
"Unassign" => "Desatribuir",
"Assign" => "Atribuir",
"Received objects" => "Objectos recebidos",
"File galleries" => "Galerias de Ficheiros",
"Topics only" => "Apenas os assuntos",
"Most commented forums" => "Fóruns mais comentados",
"Most read topics" => "Tópicos mais lidos",
"Most visited forums" => "Fóruns mais visitados",
"Google Search" => "Procura no Google",
"Last blog posts" => "Últimas mensagens para blogs",
"Last Created blogs" => "Últimos Blogs Criados",
"Last Created FAQs" => "Últimos FAQs Criados",
"Last Created Quizzes" => "Últimos Testes Criados",
"Last modified file galleries" => "Últimas galerias de ficheiros modificadas",
"Last Files" => "Ficheiros Recentes",
"Last Modified blogs" => "Últimos Blogs Modificados",
"Last submissions" => "Últimos artigos enviados",
"Last Items" => "Últimos itens",
"Last Modified Items" => "Últimos itens Modificados",
"Live support" => "Suporte On-line",
"Messages" => "Mensagens",
"Waiting Submissions" => "Artigos Pendentes",
"Old articles" => "Artigos antigos",
"Create/Edit" => "Criar/editar",
"Quick Edit a Wiki Page" => "Edição rápida de página Wiki",
"Random Pages" => "Páginas aleatórias",
"New user registration" => "Registo de novo utilizador",
"Post" => "Enviar",
"Since your last visit" => "Desde a sua última visita",
"Changes since" => "Alterações desde",
"new comments" => "novos comentários",
"new posts" => "novos posts",
"wiki pages changed" => "páginas Wiki alteradas",
"new articles" => "novos artigos",
"new FAQs" => "novas FAQs",
"new blogs" => "novos blogs",
"new blog posts" => "novos posts de blog",
"new image galleries" => "novas galerias de imagem",
"new images" => "novas imagens",
"new file galleries" => "novas galerias de ficheiros",
"new files" => "novos ficheiros",
"new polls" => "novos inquéritos",
"new users" => "novos utilizadores",
"new tracker items" => "novos trackers",
"Most Active blogs" => "Blogs mais ativos",
"Top articles" => "Artigos mais lidos",
"Top File Galleries" => "Galerias de Ficheiros mais visitadas",
"Top files" => "Melhores ficheiros",
"Top Images" => "Imagens mais populares",
"Top Pages" => "Páginas mais visitadas",
"Top Quizzes" => "Testes mais visitados",
"Top Visited FAQs" => "FAQs mais visitados",
"User Blogs" => "Blogs de Utilizadores",
"My blogs" => "Meus Blogs",
"User bookmarks" => "Bookmarks de utilizadores",
"My galleries" => "Minhas galerias",
"User Pages" => "Páginas de Utilizadores",
"My Pages" => "Minhas Páginas",
"User tasks" => "Tarefas do utilizador",
"Online users" => "Utilizadores on-line",
"Last wiki comments" => "Últimos comentários no wiki",
"Invalid username or password" => "Utilizador ou palavra-passe inválidos",
"change password" => "alterar palavra-passe",
"smarty notice reporting" => "Report dos notices do Smarty",
"country" => "país",
"theme" => "tema",
"Random Image" => "Imagem Aleatória",
"List of attached files" => "Lista de ficheiros anexados",
"uploaded" => "carregado",
"Remove" => "Remover",
"Upload file" => "Carregar ficheiro",
"Attach" => "Anexar",
"Attach a file to this item" => "Anexar um ficheiro a este item",
"Version" => "Versão",
"Attachments" => "Ficheiros anexados",
"No attachments for this item" => "Sem ficheiros anexados a este item",
"debug" => "depuração",
"Fatal error" => "Erro crítico",
"Created by" => "Criada por",
"on" => "ligado",
"Activity=" => "Acctividade=",
"Actions" => "Acções",
"Properties" => "Propriedades",
"No records found" => "Nenhum registo encontrado",
"Admin Categories" => "Administrar categorias",
"No categories defined" => "Nenhuma categoria definida",
"Browse Category" => "Procurar na categoria",
"stars" => "estrelas",
"User Level" => "Nível de utilizador",
"private message" => "mensagem privada",
"Send eMail to User" => "Enviar email ao utilizador",
"user online" => "utilizador online",
"user offline" => "utilizador offline",
"top of page" => "topo da página",
"Reply" => "Responder",
"Approve" => "Aprovar",
"Reject" => "Rejeitar",
"Save to notepad" => "Salvar no bloco de notas",
"Monitor this Topic" => "Monitorizar este tópico",
"Stop Monitoring this Topic" => "Para de monitorizar  este tópico",
"Moderator actions" => "acções de moderador",
"reported:" => "assinaladas:",
"queued:" => "em fila:",
"Move to topic:" => "Mover para o tópico:",
"Move" => "Mover",
"Delete Selected" => "Apagar seleccionados",
"Unlock" => "Desbloquear",
"Lock" => "Bloquear",
"Threshold" => "Limite",
"Set" => "Definir",
"Replies" => "Respostas",
"New Reply" => "Nova resposta",
"Editing reply" => "Editando resposta",
"Post new message" => "Afixar nova mensagem",
"Editing comment" => "A editar comentário",
"Comment on the selected post" => "Comentário no post seleccionado",
"Post new comment" => "Publicar novo comentário",
"Toolbars" => "Quicktags",
"optional" => "opcional",
"Cancel" => "Cancelar",
"Posting comments" => "Publicar comentários",
"Add Comment" => "Adicionar um comentário",
"1 comment" => "1 comentário",
"Go back" => "Voltar atrás",
"Return to home page" => "Voltar à página inicial",
"Year" => "Ano",
"Authors" => "Autores",
"Add" => "Adicionar",
"Tiki Debugger Console" => "Consola de Depuração Tiki",
"Current URL" => "URL actual",
"Command" => "Comando",
"Type <code>help</code> to get list of available commands" => "Digite <code>help</code> para obter uma lista de comandos",
"Syntax" => "Formato",
"Page generation debugging log" => "Registo de depuração de geração de página",
"Features state" => "Estado de funcionalidades",
"features matched" => "funcionalidades seleccionadas",
"Watchlist" => "Lista de Notificações",
"Duplicate File Gallery" => "Duplicar Galeria de Ficheiros",
"duplicate" => "duplicar",
"There are individual permissions set for this file gallery" => "Existem permissões individuais definidas para esta galeria de ficheiros",
"Save" => "Guardar",
"System" => "Sistema",
"Use" => "Usar",
"unlimited" => "ilimitado",
"none" => "nenhum",
"Parent gallery" => "Galeria-pai",
"Owner of the gallery" => "Dono da galeria",
"Default sort order" => "Ordenação por omissão",
"Max description display size" => "Tamanho máximo para descrição",
"Please login" => "Autenticação necessária",
"There are no wiki pages similar to '{\$page}'" => "Não existem páginas Wiki semelhantes a '{\$page}'",
"Create this page" => "Criar esta página",
"(page will be orphaned)" => "(a página ficará órfã)",
"Go to" => "Ir para",
"Replace" => "Trocar",
"List" => "Lista",
"Name-filename" => "Nome-nome de ficheiro",
"Filename only" => "Apenas nome de ficheiro",
"Show in popup box" => "Mostrar no popup",
"Exact&nbsp;match" => "Coincidência&nbsp;exacta",
"any type" => "qualquer tipo",
"all topic" => "todos os tópicos",
"any category" => "qualquer categoria",
"Number of displayed rows" => "Número de linhas mostradas",
"in:" => "em:",
"Go" => "Procura",
"Perform action with checked:" => "Realizar com a selecção:",
"Move Selected Files" => "Mover os ficheiros seleccionados",
"Assign Permissions" => "Atribuir Permissões",
"Move to" => "Mover para",
"Filename" => "Nome do ficheiro",
"Hi {\$mail_user} has sent you this link:" => "Olá! O utilizador {\$mail_user} enviou este link para você:",
"Blog post:" => "Mensagem de blog:",
"at:" => "em:",
"Somebody or you tried to subscribe this email address at our site:" => "Alguém (possivelmente você) tentou registrar este endereço de email no nosso site:",
"To the newsletter:" => "Para o comunicado:",
"Description:" => "Descrição:",
"In order to confirm your subscription you must access the following URL:" => "Para confirmar esta assinatura, aceda o seguinte endereço:",
"User:" => "Utilizador:",
"A new message was posted to forum" => "Uma nova mensagem foi enviada ao fórum",
"Tiki mail-in instructions" => "Instruções para mail-in Tiki",
"Hi," => "Olá,",
"A new message was posted to you at {\$mail_machine}" => "Uma nova mensagem foi enviada para você a partir de {\$mail_machine}",
"From" => "De",
"Hi" => "Olá",
"Enjoy the site!" => "Esperamos que você aprecie o site!",
"The user" => "O utilizador",
"registered at your site" => "registou-se no seu site",
"Bye bye!" => "Até logo!",
"This email address has been removed to the list of subscriptors of:" => "Este endereço de email foi removido da lista de assinantes de:",
"Newsletter:" => "Comunicado:",
"You can unsubscribe from this newsletter following this link" => "Você pode cancelar sua assinatura deste comunicado seguindo o link",
"Welcome to our newsletter!" => "Bem-vindo(a) ao nosso comunicado!",
"This email address has been added to the list of subscriptors of:" => "Este endereço de email foi adicionado à lista de assinantes de:",
"You can always cancel your subscription using:" => "Você pode cancelar sua assinatura a qualquer momento usando:",
"Email notification" => "Notificação de email Tiki",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Um novo artigo foi enviado por \$mail_user} para {\$mail_site} em {\$mail_date|tiki_short_datetime}",
"You can edit the submission following this link:" => "Você pode editar este artigo editando este link:",
"Title:" => "Título:",
"Heading:" => "Cabeçalho:",
"Body:" => "Corpo:",
"You or someone registered this email address at" => "alguém (possivelmente você) registrou este endereço de email em",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Se você deseja ser um utilizador registado neste site, utilize o seguinte link para logar-se pela primeira vez:",
"Your registration confirmation" => "Instruções para registo no Tiki",
"You will receive an email with information to login for the first time into this site" => "Você receberá um email com instruções sobre como logar-se pela primeira vez neste site",
"If you don't want to receive these notifications follow this link:" => "Se você não deseja receber estas notificações siga este link:",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "Nova mensagem de blog: {\$mail_title}, \", por {\$mail_user|username} em {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "Veja o blog em:",
"changed" => "alterada",
"created" => "criação",
"File Description" => "Descrição do Ficheiro",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "O mapa {\$mail_page} foi alterado por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Pode ver o mapa actualizado pelo com a seguinte hiperligação:",
"You can edit the map following this link:" => "Pode editar o mapa com a seguinte hiperligação:",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi alterada por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"Comment:" => "Comentário:",
"The new page content follows below." => "O conteúdo da nova página está abaixo.",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi comentada por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"New name" => "Novo nome",
"click on the map to zoom or pan, do not drag" => "clique no mapa para zoom, não para arrastar",
"Scale" => "Escala",
"Query" => "Consulta",
"Redraw" => "Redesenhar",
"select zoom/pan/query and image size" => "seleccione zoom/pan/consulta e tamanho da imagem",
"Click on the map or click redraw" => "Clique no mapa ou clique em redesenhar",
"Last modification date" => "Data da última modificação",
"Overview" => "Visão geral",
"Legend" => "Legenda",
"Layer Manager" => "Gestor de Camadas",
"Layer" => "Camada",
"On" => "Ligado",
"Download Layer" => "Descarregar Camada",
"you have requested to download the layer:" => "pediu para descarregar a camada:",
"Here are the files to download, do not forget to rename them:" => "Aqui estão os ficheiros para descarregar, não se esqueça de os renomear:",
"Mapfiles" => "Ficheiros de Mapas",
"Mapfile" => "Ficheiro de Mapa",
"Available mapfiles" => "Ficheiros de Mapas disponíveis",
"monitor this map" => "monitorizar este mapa",
"Stop Monitoring this Map" => "Parar de monitorizar este mapa",
"Create a new mapfile" => "Criar um novo ficheiro de mapa",
"Create" => "Criar",
"Mapfile listing" => "Listagem de ficheiros de mapas",
"Reload" => "Recarregar",
"History" => "Histórico",
"You can view this map in your browser using" => "Pode ver este mapa no seu browser usando",
"of" => "de",
"Compare" => "Comparar",
"Version:" => "Versão:",
"Current" => "Actual",
"Versions are identical" => "As versões são idênticas",
"Legend:" => "Legenda:",
"v=view" => "v=ver",
"c=compare" => "c=comparar",
"Full side-by-side diff" => "diff lado-a-lado completo",
"Unified diff" => "diff unificado",
"Side-by-side view" => "ver lado-a-lado",
"User" => "Utilizador",
"Ip" => "IP",
"Diff" => "Difer",
"Older Version" => "Versão mais antiga",
"Directories" => "Directórios",
"back to" => "voltar para",
"Upload From Disk:" => "Carregar a partir do Disco:",
"Upload Files" => "Carregar Ficheiros",
"Bytes maximum" => "Máximo de bytes",
"Create Directory:" => "Criar directório:",
"index file (.shp):" => "ficheiro índice (.shp):",
"files to index (regexp):" => "ficheiros para índice (regexp):",
"Unread" => "Não lida",
"Flagged" => "Seleccionada",
"Unflagged" => "Não seleccionada",
"Containing" => "Conteúdo",
"Sender" => "remetente",
"No messages to display" => "Nenhuma mensagem a exibir",
"Broadcast message" => "Enviar mensagem global",
"OK" => "Ok",
"All users" => "Todos os utilizadores",
"Lowest" => "Mínima",
"Low" => "Baixa",
"High" => "Alta",
"Very High" => "Máxima",
"Send" => "Enviar",
"Compose message" => "Escreva mensagem",
"Invalid" => "Inválido",
"Mark as read" => "Marcar como lida",
"Mark as unread" => "Marcar como não lida",
"Mark as flagged" => "Marcar como seleccionada",
"Mark as unflagged" => "Marcar como não seleccionada",
"Mark" => "marca",
"Mailbox" => "Caixa de entrada",
"Compose" => "Escrever",
"Broadcast" => "Enviar para todos",
"Read message" => "Ler mensagem",
"replyall" => "responder a todos",
"Flag this message" => "Marcar esta mensagem",
"From:" => "De:",
"Replied" => "Respondido",
"'name' parameter for tikimodule missed" => "parâmetro 'nome' para tikimodule está em falta",
"Move module up" => "Mover módulo para cima",
"Up" => "Acima",
"Move module down" => "Mover módulo para baixo",
"Down" => "Abaixo",
"Move module to opposite side" => "Mover módulo para o lado oposto",
"Unassign this module" => "Remover este módulo",
"Are you sure you want to unassign this module?" => "Tem certeza que deseja atribuir este módulo?",
"Select" => "seleccionar",
"Admin" => "Administrar",
"Admin Modules" => "Administrar Módulos",
"Modules" => "Módulos",
"Admin Menus" => "Administrar Menus",
"Pages:" => "Páginas:",
"Categories:" => "Categorias:",
"more" => "mais",
"Register" => "Registrar-se",
"Open operator console" => "Abrir o console de operador",
"Logged in as" => "Autenticado como",
"Logout" => "Finalizar a sessão",
"Switch User" => "Alternar Utilizador",
"Switch" => "Alternar",
"Login as admin" => "Autenticar-se como admin",
"Login as" => "Autenticar-se como",
"eMail" => "E-mail",
"Password" => "Senha",
"Remember me" => "Lembrar palavra-passe entre sessões ",
"week" => "semana",
"month" => "mês",
"year" => "ano",
"Click here to register" => "Clique aqui para registar",
"Click here if you've forgotten your password" => "Clique aqui se você esqueceu sua palavra-passe",
"I forgot my password" => "Esqueci minha palavra-passe",
"Click here to login using the default security protocol" => "Clique aqui para se autenticar usando o protocolo por omissão",
"Standard" => "Padrão",
"Click here to login using a secure protocol" => "Clique aqui para se autenticar usando um protocolo seguro",
"Secure" => "Seguro",
"Stay in ssl Mode" => "Permanecer no modo seguro",
"You have" => "Você possui",
"new messages" => "mensagens novas",
"new message" => "mensagem nova",
"You have 0 new messages" => "Você possui 0 mensagens novas",
"We have" => "Existem",
"submissions waiting to be examined" => "Artigos com aprovação pendente",
"Feed" => "Fonte",
"Image Galleries" => "Galerias de Imagens",
"Entire Site" => "Todo o Site",
"Wiki Pages" => "Páginas Wiki",
"Image Gals" => "Galerias: Imagens",
"Blog Posts" => "Mensagens de Blogs",
"Search Wiki PageName" => "Pesquisar Nome de Página Wiki",
"Read More" => "Ler Mais",
"Since your last visit on" => "Desde a sua última visita em",
"New Images" => "Novas imagens",
"Wiki Pages Changed" => "Páginas Wiki alteradas",
"New Files" => "Novos ficheiros",
"New Comments" => "Novos comentários",
"New Tracker Items" => "Novos items do tracker",
"New Calendar Events" => "Novos eventos do calendário",
"New Users" => "Novos utilizadores",
"click to edit" => "clique para editar",
"Nothing has changed" => "Não houve alterações",
"Site default" => "Omissão para o Site",
"Top galleries" => "Galerias mais visitadas",
"view" => "ver",
"click to view" => "clique para visualizar",
"Done" => "pronto",
"Del" => "Elimin",
"Refresh" => "Actualizar",
"online users" => "utilizadores on-line",
"online user" => "utilizador on-line",
"on host" => "no host",
"Send a message to" => "Enviar uma mensagem para",
"vote" => "votar",
"Warning" => "Aviso",
"Users" => "Utilizadores",
"Tiki Image - Insert an image" => "Tiki Image - Inserir uma imagem",
"RSS feed" => "Fonte RSS",
"Edit blog" => "Editar blog",
"Monitor this Blog" => "Monitorizar este blog",
"Stop Monitoring this Blog" => "Não monitorizar mais este blog",
"Find:" => "Localizar:",
"pages" => "páginas",
"To edit the copyright notices" => "Para editar as mensagens de diretos autorais",
"The content on this page is licensed under the terms of the" => "O conteúdo desta página é licenciado sob os termos do",
"Permalink" => "Link permanente",
"comments" => "comentários",
"First page" => "Primeira página",
"Previous page" => "Página anterior",
"page" => "página",
"Next page" => "Próxima página",
"Last page" => "Última página",
"referenced by" => "referenciado por",
"references" => "referências",
"View Comments" => "Ver comentários",
"Blog name" => "Nome do blog",
"Calendar View" => "Ver como calendário",
"List View" => "Vista em Lista",
"Tools Calendars" => "Calendários de Ferramentas",
"Check / Uncheck All" => "Marcar / desmarcar todos",
"Tip" => "Dica",
"Cancel Edit" => "Cancelar edição",
"Change preferences" => "Alterar preferências",
"Site Ads and Banners" => "Anúncios e Banners do Site",
"General" => "Geral",
"Features" => "Funcionalidades",
"Community" => "Comunidade",
"Module" => "Módulo",
"Security" => "Segurança",
"User files" => "Ficheiros do utilizador",
"General Settings" => "Configurações Gerais",
"Home Blog (main blog)" => "Blog Inicial (Blog principal)",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Para adicionar/remover calendários, procure \"Calendário\" sob \"Admin\" no menu de aplicação, ou",
"Change settings" => "Alterar definições",
"Default view mode" => "Mode de visualização por omissão",
"Day" => "Dia",
"Week" => "Semana",
"Month" => "Mês",
"Quarter" => "Trimestre",
"Semester" => "Semestre",
"First day of the week" => "Primeiro dia da semana",
"Saturday" => "Sábado",
"Sunday" => "Domingo",
"Monday" => "Segunda-feira",
"Depends user language" => "Depende do idioma do utilizador",
"Split hours in periods of" => "Dividir horas em períodos de",
"1 minute" => "1 minuto",
"5 minutes" => "5 minutos",
"10 minutes" => "10 minutos",
"15 minutes" => "15 minutos",
"30 minutes" => "30 minutos",
"Browse categories" => "Navegar nas categorias",
"Administer categories" => "Administrar categorias",
"Permissions" => "Permissões",
"Look under \"Articles\" on the application menu for links to" => "Procure por \"Artigos\" no menu de aplicação para ligações para ",
"Import CSV file" => "Importar ficheiro CSV",
"Batch upload (CSV file)" => "Upload em lote (ficheiro CSV)",
"Import" => "Importar",
"Admin Groups" => "Administrar grupos",
"Admin Users" => "Admin utilizadores",
"Number of friends" => "Número de amigos",
"Last login" => "Último login",
"Distance" => "Distância",
"Users Default Preferences" => "Preferências por omissão para utilizadores",
"default" => "omissão",
"Number of visited pages to remember" => "Número de páginas visitadas a lembrar",
"Displayed time zone" => "Fuso horário exibido",
"User information" => "Informação do Utilizador",
"Private" => "Privada",
"public" => "pública",
"Use double-click to edit pages" => "Usar duplo-clique para editar páginas",
"Show user's info on mouseover" => "Mostrar info sobre utilizador com mouseover",
"Tasks per page" => "Tarefas por página",
"Messages per page" => "Mensagens por página",
"Allow messages from other users" => "Permitir mensagens de outros utilizadores",
"Send me an email for messages with priority equal or greater than" => "Envie-me um email para mensagens com prioridade igual ou maior que",
"never" => "nunca",
"My Tiki" => "O meu Tiki",
"My pages" => "As minhas páginas",
"My messages" => "As minhas mensagens",
"My tasks" => "As minhas tarefas",
"My items" => "Os meus itens",
"Score ascending" => "Pontuação ascendente",
"Score descending" => "Pontuação descendente",
"Name ascending" => "Nome ascendente",
"Name descending" => "Nome descendente",
"Login ascending" => "Login ascendente",
"Login descending" => "Login descendente",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Para configurar o seu directório, procure a opção \"Admin directório\" sob \"Directório\" no menu de aplicação, ou",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Para adicionar/remover FAQs, procure por \"Admin FAQs\" sob \"FAQs\" no menu de aplicação, ou",
"Settings" => "Configurações",
"Watches" => "Notificações",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Se decidir guardar os ficheiros numa directoria, deverá assegurar-se que os utilizadores não terão acesso directo.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Para consegui-lo, tem duas opções::<br /><ul><li>Utilizar uma directoria for da raiz do espaço web, assegurando que os seus scripts PHP conseguem ler e escrever para ela</li><li>Usar uma directoria dentro do espaço web juntamente com o ficheiro .htaccess para prevenir e controlar o acesso</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Os nomes de directorias devem usar o estilo de caminhos UNIX, por exemplo files/ ou c:/foo/files ou /www/files/",
"Home Gallery (main gallery)" => "Galeria Inicial (galeria principal)",
"MIME Type" => "Tipo MIME",
"Reindex all files for search" => "Reindexar todos os ficheiros para pesquisa",
"Home Forum (main forum)" => "Fórum Inicial (fórum principal)",
"Searches" => "Procurar",
"Browser width" => "Largura do browser",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Para adicionar/remover galerias de imagens, dirija-se a \"Galerias de Imagem\" no menu de aplicação, ou",
"You can upload images of a size of " => "Poderá fazer upload de imagens até um tamanho de ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altere as variáveis file_uploads, upload_max_filesize, post_max_size no php.ini e as variáveis do sistema de base de dados (max_allowed_packet para mysql) para alterar este valor",
"Home Gallery" => "Galeria Inicial",
"Galleries features" => "Funcionalidades das Galerias",
"Uses Slideshow" => "Usar Slideshow",
"Use database to store images" => "Utilizar base de dados para armazenar imagens",
"Use a directory to store images" => "Utilizar um directório para armazenar imagens",
"Directory path" => "Caminho do directório",
"Library to use for processing images" => "Biblioteca a utilizar para processamento de imagens",
"Uploaded image names must match regex" => "Imagens carregadas devem seguir a expressão regular",
"Uploaded image names cannot match regex" => "Imagens carregadas não podem seguir a expressão regular",
"Directory Batch Loading" => "Carregamento em Lote a partir de directoria",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Se activar esta funcionalidade, terá que configurar uma directoria com permissões de leitura pelo servidor web (recomenda-se que seja fora do seu espaço web). Depois, configure uma forma de fazer upload para essa directoria, seja com scp, ftp, ou outros protocolos",
"Enable directory batch loading" => "Permitir carregamento em lote por directoria",
"Batch loading directory" => "Directoria para carregamento em lote",
"Display image informations in a mouseover box" => "Mostrar informações da imagem numa caixa mouseover",
"yes, and don't display those informations under the image" => "sim, e não mostrar essas informações abaixo da imagem",
"Max Rows per page" => "Máximo de linhas por página",
"Images per row" => "Imagens por linha",
"Thumbnails size X" => "Largura das miniaturas",
"Thumbnails size Y" => "Altura das miniaturas",
"Set features" => "Definir funcionalidades",
"Exterminator" => "Limpeza da cache",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Remover da galeria do sistema imagens que não estão a ser utilizadas em páginas Wiki, artigos ou mensagens de Blog",
"Move images from database storage to filesystem storage" => "Mover imagens da base de dados para o sistema de ficheiros",
"Move images from filesystem storage to database storage" => "Mover imagens do sistema de ficheiros para a base de dados",
"All galleries" => "Todas as galerias",
"System Gallery" => "Galeria do sistema",
"Move images from old filesystem store to new directory" => "Mover imagens do sistema de ficheiros para uma nova directoria",
"Moved" => "Movidas",
"Gallery listing configuration" => "Configuração da listagem de galeria",
"Parent" => "Pai",
"Last modified" => "Última modificação em",
"Change configuration" => "Alterar configuração",
"Image galleries comments settings" => "Configurações de comentários para galerias de imagens",
"General Preferences" => "Preferências gerais",
"Site Identity" => "Identidade do Site",
"Username" => "Utilizador",
"Contact" => "Contacto",
"Home Page" => "Página Principal",
"Custom home" => "Página inicial personalizada",
"Date and Time Formats" => "Formatos de Data e Hora",
"Date and Time Format Help" => "Ajuda para formatos de Data e Hora",
"Change admin password" => "Alterar a palavra-passe de admin",
"Change password" => "Alterar palavra-passe",
"Internationalization" => "Internacionalização",
"port" => "porta",
"click here" => "clique aqui",
"Enable/disable Tiki features in " => "Active/desactive funcionalidades em ",
", but configure them elsewhere" => ". A configuração será noutra página.",
"Wysiwyg" => "WYSIWYG",
"Tiki and HTTP Auth" => "Tiki e autenticação HTTP",
"Registration" => "Registo",
"Users can register" => "Utilizadores podem se registar-se",
"Use challenge/response authentication" => "Utilizar autenticação desafio/resposta",
"Allow secure (https) login" => "Permitir login seguro (https)",
"Encourage secure (https) login" => "Encourajar login seguro (HTTPS)",
"Consider we are always in HTTPS, but do not check" => "Assumir HTTPS, mas sem verificar",
"Require secure (https) login" => "Exigir login seguro (https)",
"Users can choose to stay in SSL mode after an HTTPS login" => "Utilizadores podem escolher continuar em SSL após autenticação por HTTPS",
"Users can switch between secured or standard mode at login" => "Utilizadores podem alternar entre modo seguro ou standard após autenticação",
"User's choice" => "Opção do utilizador",
"Duration:" => "Duração:",
"Currently unused" => "Não utilizado actualmente",
"Shibboleth Authentication " => "Autenticação Shibboleth",
"You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/." => "Será necessário fazer upload da <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">biblioteca phpCAS</a> separadamente para lib/phpcas/.",
"Version 1.0" => "Versão 1.0",
"Version 2.0" => "Versão 2.0",
"Users can change theme" => "Utilizadores registados podem alterar tema",
"Restrict available themes" => "Restringir temas disponíveis",
"Available styles:" => "Estilos disponíveis:",
"Edit CSS" => "Editar CSS",
"Theme Control" => "Controlo de temas",
"Tiki Template Viewing" => "Visualização de Modelos Tiki",
"Edit Templates" => "Editar Modelos",
"General Layout options" => "Opções gerais de Layout",
"Custom Site Header" => "Personalização do cabeçalho do Site",
"logged as" => "Logado como",
"Examples" => "Exemplos",
"Alt. description (e.g. for text browsers)" => "Descrição alternativa (p.e. para browsers em modo-texto)",
"Site menu bar" => "Barra de menu do Site",
"Menu ID" => "ID do Menu",
"Custom code" => "Código personalizado",
"Left column" => "Coluna da esquerda",
"always" => "sempre",
"user decides" => "utilizador decide",
"Users can Flip Columns" => "Utilizadores podem alternar colunas",
"Right column" => "Coluna da direita",
"Site location bar" => "Localização da barra",
"Larger font for" => "Aumentar fonte para",
"Use page description:" => "Usar descrição da página:",
"Custom Site Footer" => "Personalização do rodapé do Site",
"Bottom bar" => "Barra inferior",
"Bottom bar icons" => "Ícones da barra inferior",
"Bottom bar debug" => "Debugging na barra inferior",
"Maximum number of records in listings" => "Número máximo de registos em listagens",
"Use direct pagination links" => "Hiperligações de paginação directa",
"Use Tabs" => "Usar Separadores",
"Layout per section" => "Layout por sessão",
"Admin layout per section" => "Administrar layout por sessão",
"Favicon icon file name:" => "Nome do ficheiro Favicon:",
"Favicon icon MIME type:" => "Tipo MIME do Favicon:",
"Last update" => "Última actualização",
"Image galleries" => "Galerias de imagens",
"Feed for forums" => "Fonte para fóruns",
"Specification" => "Especificação",
"Refresh wiki search index now" => "Actualizar o índice de pesquisa da wiki agora",
"Refresh trackers search index now" => "Actualizar agora o índice de pesquisa dos trackers",
"Refresh tracker search index now" => "Actualizar o índice de pesquisa do tracker agora",
"Text area (that apply throughout many features)" => "As definições sobre as caixas de texto aplicam-se a várias funcionalidades",
"Automonospaced text" => "Texto auto-monospace",
"Tables syntax" => "Sintaxe de tabelas",
"|| for rows" => "|| para linhas",
"Hotwords" => "Palavras-chaves",
"rows" => "linhas",
"Enable" => "Activa",
"Required" => "Obrigatório",
"Parameters" => "Parâmetros",
"Use database to store files" => "Utilizar o banco de dados para armazenar ficheiros",
"Use a directory to store files" => "Utilizar um directório para armazenar ficheiros",
"Quota (Mb)" => "Cota (Mb)",
"Use database to store userfiles" => "Utilizar o banco de dados para armazenar ficheiros dos utilizadores",
"Use a directory to store userfiles" => "Utilizar um directório para armazenar ficheiros dos utilizadores",
"Create New" => "Criar nova",
"List authors" => "Listar autores",
"Warn on edit conflict" => "Avisar de conflito de edição",
"Undo" => "Desfazer",
"Footnotes" => "Notas de rodapé",
"Permission" => "Permissão",
"Allow HTML" => "Permitir HTML",
"Sandbox" => "Bancada de Testes",
"Manage attachments" => "Gerir anexos",
"Dumps" => "Exportações",
"Remove a tag" => "Remover uma tag",
"Generate dump" => "Gerar exportação",
"Download last dump" => "Download última exportação",
"Pictures" => "Figuras",
"Remove unused pictures" => "Remover imagens não utilizadas",
"Export" => "Exportar",
"Export Wiki Pages" => "Exportar páginas Wiki",
"Accept dashes and underscores in WikiWords" => "Aceitar barras e sublinhados nas WikiWords",
"Link plural WikiWords to their singular forms" => "Conectar plurais de WikiWords para as suas formas singulares",
"Only with last version" => "Apenas com a última versão",
"Side-by-side diff" => "diff lado-a-lado",
"Discuss pages on forums" => "Discutir páginas nos fóruns",
"View source" => "Ver código",
"Structures" => "Estruturas",
"Open page as structure" => "Abrir página como estrutura",
"Categorize structure pages together" => "Categorizar páginas de estrutura juntas",
"Import HTML" => "Importar HTML",
"Page creators are admin of their pages" => "Autores são admins de suas páginas",
"MultiPrint" => "MultiImpressão",
"Create watch for author on page creation" => "Criar notificações para autor na criação da página",
"Enable watch events when I am the editor" => "Habilitar notificações de eventos quando eu for o editor",
"Enable watches on comments" => "Habilitar notificações em comentários",
"Categories path" => "Caminho de categorias",
"Wiki 3D Browser Configuration" => "Configurações do Browser Wiki 3D",
"Wiki attachments" => "Ficheiros anexados Wiki",
"Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "WYSIWYG é um acrónimo para <i>What You See Is What You Get</i> (o que vê é o que obtém), e é providenciado no Tikiwiki pelo <a href=\"http://fckeditor.net\">FCKeditor</a>",
"Wysiwyg Editor Features" => "Funcionalidades do Editor WYSIWYG",
"Crosslinks to other features and settings" => "Crosslinks para outras funcionalidades e configurações",
"Other sections" => "Outras secções",
"Spreadsheet" => "Folha de cálculo",
"Live Support" => "Suporte on-line",
"Contact us" => "Entre em contacto",
"Administration features" => "Funcionalidades de administração",
"Banning" => "Banimento",
"Transversal features" => "Funcionalidades transversais",
"which apply to more than one section" => "que se aplicam a mais de uma secção",
"Mail Notifications" => "Notificações por E-mail",
"Navigation features" => "Funcionalidades de navegação",
"themes" => "temas",
"Text area features" => "Funcionalidades das caixas de texto",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "funcionalidades que podem ser utilizadas em todas as caixas de texto, como páginas wiki, blogs, artigos, fóruns, etc",
"Content Templates" => "Modelos de Conteúdo",
"Stats &amp; banners" => "Estatísticas &amp; banners",
"Search Stats" => "Estatísticas de pesquisa",
"Report" => "Relatório",
"Please select some actions to view." => "Por favor seleccione as acções que deseja visualizar.",
"Edit Action" => "Editar Acção",
"Save Action" => "Guardar Acção",
"Statistics" => "Estatísticas",
"Volumes are equally distributed on each contributors/author" => "Os volumes são equidistribuídos por cada contribuinte/autor",
"Weeks" => "Semanas",
"Setting" => "Valor",
"recorded" => "registada",
"viewed" => "visualizada",
"Wiki page actions except viewed will always be recorded but can be not reported" => "Todas as acções relacionadas com pág. Wiki, excepto a visualização, são sempre registadas mas não podem constar no relatório",
"Add or edit a rule" => "Adicionar ou editar uma regra",
"Rule title" => "Título da regra",
"Username regex matching" => "Identificar username através expressão regular",
"IP regex matching" => "Expressão regular para IP",
"Banned from sections" => "Banido(a) das secções",
"Rule activated by dates" => "Regra activada por datas",
"Rule active from" => "Regra activa de",
"Rule active until" => "Regra activa até",
"Custom message to the user" => "Mensagem personalizada para o utilizador",
"Rules" => "Regras",
"User/IP" => "Utilizador/IP",
"Sections" => "Secções",
"Admin Calendars" => "Administrar Calendários",
"List of Calendars" => "Lista de Calendários",
"Participants" => "Participantes",
"Lang" => "Idioma",
"Subscription" => "Subscrição",
"Perso" => "Pessoal",
"Add Event" => "Adicionar Evento",
"Custom Locations" => "Localizações Personalizadas",
"Custom Participants" => "Personalizar participantes",
"Custom Categories" => "Categorias Personalizadas",
"Custom Languages" => "Idiomas Personalizados",
"Custom URL" => "URL personalizado",
"Custom Subscription List" => "Personalizar subscrições",
"Custom Priorities" => "Prioridades Personalizadas",
"Personal Calendar" => "Calendário pessoal",
"Start of day" => "Início do dia",
"End of day" => "Final do dia",
"Custom foreground color" => "Cor de texto personalizada",
"Custom background color" => "Cor de fundo personalizada",
"Current category" => "Categoria actual",
"Child categories" => "Categorias-filhas",
"Edit permissions for this category" => "Editar permissões para esta categoria",
"Edit this category:" => "Editar esta categoria:",
"Add new category" => "Adicionar uma nova categoria",
"Batch upload (CSV file):" => "Upload em lote (ficheiro CSV):",
"Objects in category" => "Objectos na categoria",
"Remove from this Category" => "Remover desta categoria",
"Add objects to category" => "Adicionar objectos à categoria",
"Admin templates" => "Administrar padrões",
"Edit this template:" => "Editar este padrão:",
"Create new template" => "Criar um novo padrão",
"Use wysiwyg editor" => "Usar editor WYSIWYG",
"Use normal editor" => "Usar editor normal",
"HTML Pages" => "Páginas HTML",
"Templates" => "Padrões",
"Admin cookies" => "Administrar cookies",
"Create/edit cookies" => "Criar/editar cookies",
"Upload Cookies from textfile" => "Carregar Cookies a partir de ficheiro texto",
"Upload from disk:" => "Carregar do disco:",
"Upload" => "Carregar",
"Remove all cookies" => "Remover todos cookies",
"Admin dsn" => "Administrar DSN",
"Create/edit dsn" => "Criar/editar DSN",
"Admin external wikis" => "Administrar Wikis externos",
"View template" => "Ver templates (layout)",
"Edit template" => "Editar modelo",
"Create/Edit External Wiki" => "Criar/editar Wiki Externo",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "Endereço (use \$page para substituir pelo nome da página na URl. Exemplo: http://www.exemplo.com.br/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar Fóruns",
"Create new forum" => "Criar novo fórum",
"List forums" => "Listar fóruns",
"Age" => "Idade",
"PPD" => "Ppd",
"Edit this Forum:" => "Editar este Fórum:",
"Create New Forum" => "Criar um Novo Fórum",
"There are individual permissions set for this forum" => "Existem permissões individuais definidas para este fórum",
"Name:" => "Nome:",
"Create new" => "Criar nova",
"Password protected" => "Protegido por palavra-passe",
"Forum password" => "Senha do fórum",
"Topic list configuration" => "Configuração da lista de assuntos",
"Display last post titles" => "Mostrar os títulos das últimas publicações",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Reencaminhar mensagens deste fórum para este endereço de e-mail, num formato que possa ser usado para enviar mensagens de volta a este fórum",
"Originating e-mail address for mails from this forum" => "Endereço de e-mail de origem para mensagens deste fórum",
"Add messages from this email to the forum" => "Adicionar mensagens do seguinte e-mail para este fórum",
"Use topic smileys" => "Usar emoticons nos assuntos",
"Show topic summary" => "Exibir sumário dos assuntos",
"User information display" => "Exibição de informações dos utilizadores",
"Online" => "On-line",
"Approval type" => "Tipo de aprovação",
"Store attachments in:" => "Armazenar ficheiros anexados em:",
"Admin Hotwords" => "Administrar 'Hotwords'",
"Add Hotword" => "Adicionar 'Hotword'",
"Word" => "Palavra",
"Admin HTML pages" => "Administrar páginas HTML",
"Edit this page" => "Editar esta página",
"View page" => "Ver página",
"Edit zone" => "Editar zona",
"Dynamic zones" => "Zonas dinâmicas",
"zone" => "zona",
"content" => "conteúdo",
"Mass update" => "Actualização em massa",
"Create new HTML page" => "Criar nova página HTML",
"Edit this HTML page:" => "Editar esta página HTML:",
"Apply template" => "Aplicar um modelo",
"Dynamic" => "Dinâmica",
"Static" => "Estática",
"Last Modif" => "última modif",
"Edit Repository:" => "Editar Repositório:",
"Create New Repository" => "Criar Novo Repositório",
"List Repositories" => "Listar repositórios",
"New Repository" => "Novo repositório",
"View Repository" => "Ver repositório",
"Human readable repository name" => "Nome de repositório humanamente legível",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Caminho do repositório (sistema de ficheiros local: relativo/absoluto, remoto: com prefixo 'http://')",
"File name of start page" => "Nome do ficheiro da página de início",
"Start page" => "Página de início",
"CSS file to load when browse this repository" => "Ficheiro CSS a carregar quando navegar neste repositório",
"CSS file" => "Ficheiro CSS",
"Is repository visible to users" => "O repositório é visível aos utilizadores",
"Can files from repository be cached" => "Ficheiros do repositório podem ser armazenados em 'cache'",
"Cacheable" => "Armazenáveis em 'cache'",
"Are files from repository can be cached" => "Ficheiros do repositório podem ser armazenados em 'cache'",
"Clear all cached pages of this repository" => "Limpar todas as páginas armazenadas em 'cache' deste repositório",
"Clear cache" => "Limpar cache",
"Seconds count 'till cached page will be expired" => "Segundos até o armazenamento em 'cache' de páginas expirar",
"Cache expiration" => "Validade da cache",
"Human readable text description of repository" => "Descrição humanamente legível do repositório",
"Available Repositories" => "Repositórios disponíveis",
"CSS File" => "Ficheiro CSS",
"Edit rules" => "Edit regras",
"Edit Rules for Repository:" => "Editar Regras para o Repositório:",
"Configure Repositories" => "Configurar repositórios",
"Configure this Repository" => "Configurar este repositório",
"View this Repository" => "Ver este repositório",
"New Rule" => "Nova regra",
"Copy Rules" => "Copiar regras",
"view/hide copy rules dialog" => "ver/esconder copiar diálogo de regras",
"Source repository" => "Repositório de origem",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "De acordo com esta ordem de regras pode ser aplicada ('0' ou vazio = auto)",
"Rule order" => "Ordenação de regra",
"Text to search for" => "Texto a procurar",
"Text to replace" => "Texto para trocar",
"Is this regular expression or simple search/replacer" => "É uma expressão regular ou procura simples/alteração",
"Is case sensitive (for simple replacer)" => "É sensível a maiúsculas e minúsculas (para troca simples)",
"Case sensitive" => "Sensível a caixa",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunto de caracteres: imsxeADSXUu, os quais a expressão regular modifica",
"Regex modifiers" => "Modificadores de Regex",
"Human readable text description of rule" => "Texto humanamente legível de descrição de regra",
"Check to enable this rule" => "seleccione para habilitar esta regra",
"Enabled" => "Habilitado",
"Preview options" => "Pré-visualizar opções",
"Apply all rules or just this to generate preview" => "Aplicar todas as regras ou somente esta para gerar a pré-visualização",
"Apply all rules" => "Aplicar todas as regras",
"View source code after rules applied" => "Ver o código-fonte depois que as regras foram aplicadas",
"Code preview" => "Pré-visualização de código",
"Generate HTML preview" => "Gerar pré-visualização HTML",
"HTML preview" => "Pré-visualização HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Testar ficheiro do repositório para gerar pré-visualização para (vazio = página de início configurada)",
"Preview Results" => "Resultados de Pré-visualização",
"Rules List" => "Lista de Regras",
"Case" => "Caixa",
"Configure/Options" => "Configurar/Opções",
"Theme control" => "Controlo de temas",
"layout options" => "opções de layout",
"Top bar" => "Barra superior",
"Generate positions by hits" => "Gerar posições por número de acessos",
"List of featured links" => "Lista de links oferecidos",
"Position" => "Posição",
"Add Featured Link" => "Adicionar Link Oferecido",
"Edit this Featured Link:" => "Editar este Link Oferecido:",
"Create new Featured Link" => "Criar um novo Link Oferecido",
"disables the link" => "desabilita este link",
"Link type" => "Tipo de link",
"replace current page" => "substituir a página actual",
"framed" => "em frame",
"open new window" => "abrir em nova janela",
"Account name" => "Nome da conta",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "Servidor SMTP requer autenticação",
"Admin Topics" => "Administrar Assuntos",
"Admin Types" => "Administrar Tipos de Artigos",
"Active" => "Ativo",
"Frequency" => "Frequência",
"List menus" => "Listar menus",
"Edit this menu" => "Editar este menu",
"Edit menu options" => "Editar opções do menu",
"Show Quick Urls" => "Mostrar URLs rápidos",
"Some useful URLs" => "Alguns endereços úteis",
"Hide Quick Urls" => "Esconder URLs rápidos",
"option" => "opções",
"section level 0" => "secção de nível 0",
"section level 1" => "secção de nível 1",
"section level 2" => "secção de nível 2",
"section level 3" => "secção de nível 3",
"sorted section level 0" => "secção ordenada de nível 0",
"separator" => "separador",
"Choose" => "Escolha",
"Home Blog" => "Blog Principal",
"Home Image Gal" => "Gal. Imgs Principal",
"Home Image Gallery" => "Galeria de Imagens Principal",
"Home File Gal" => "Gal. Arqs Principal",
"Home File Gallery" => "Galeria de Ficheiros Principal",
"User preferences" => "Preferências do utilizador",
"User prefs" => "Preferências",
"List galleries" => "Listar galerias",
"List image galleries" => "Listar galerias de imagens",
"Upload image" => "Carregar imagem",
"Gallery Rankings" => "Rankings de Galerias",
"Browse a gallery" => "Navegar por uma galeria",
"Articles home" => "Página de Artigos",
"All articles" => "Todos artigos",
"Submit" => "Submeter",
"List Blogs" => "Listar Blogs",
"Create blog" => "Criar blog",
"View a forum" => "Exibir um fórum",
"View a thread" => "Exibir uma sequência",
"View a FAQ" => "Exibir um FAQ",
"Take a quiz" => "Fazer um teste",
"Quiz stats" => "Estats. Teste",
"Stats for a Quiz" => "Estatísticas de um teste",
"Preview menu" => "Pré-visualização do menu",
"Menu options" => "Opções de menus",
"Options" => "Opções",
"Edit this Menu:" => "Editar este Menu:",
"Create new Menu" => "Criar um novo Menu",
"dynamic collapsed" => "contraído dinamicamente",
"dynamic extended" => "expandido dinamicamente",
"fixed" => "fixo",
"Clear Cache" => "Limpar a cache",
"Assigned Modules" => "Módulos Atribuídos",
"Left Modules" => "Módulos da Esquerda",
"Move Up" => "Para cima",
"Move Down" => "Para baixo",
"Move to Right Column" => "Mover para a coluna direita",
"Right Modules" => "Módulos da Direita",
"Move to Left Column" => "Mover para a coluna esquerda",
"Assign new module" => "Atribuir novo módulo",
"Edit this assigned module:" => "Editar este módulo atribuído:",
"Cache Time" => "Tempo de Cache",
"Visibility" => "Visibilidade",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrando agora para todos os utilizadores elegíveis com módulos pessoais designados",
"Displayed for the eligible users with no personal assigned modules" => "Mostrado para os utilizadores elegíveis sem módulos pessoais designados",
"Displayed now, can't be unassigned" => "Mostrando agora, pode não estar designado",
"Not displayed until a user chooses it" => "Não mostrar até um utilizador escolher isto",
"User Modules" => "Módulos de Utilizador",
"Create new user module" => "Criar um novo módulo de utilizador",
"Edit this user module:" => "Editar este módulo de utilizador:",
"Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site." => "Crie o seu novo módulo personalizado abaixo. Certifique-se que o testa com a pré-visualização e que tudo está OK antes de <a href=\"#assign\">atribuí-lo</a>. Se usar HTML não terá problemas; no entanto, se usar sintaxe Wiki ou código Smarty de maneira incorrecta, poderá bloquear o site.",
"Must be wiki parsed" => "Interpretar como página Wiki",
"Objects that can be included" => "Objectos que podem ser incluídos",
"Random active poll" => "Sondagem activa aleatória",
"Random current poll" => "Sondagem actual aleatória",
"Use Poll" => "Utilizar a sondagem",
"Use Gallery" => "Usar a galeria",
"Use Dynamic Content" => "Usar conteúdo dinâmico",
"Use RSS Module" => "Utilizar módulo rss",
"Use Menu" => "Utilizar o menu",
"Use phplayermenu" => "Usar phplayermenu",
"Use Banner Zone" => "Utilizar zona de banner",
"Structures:" => "Estruturas:",
"Use Wiki Structure" => "Usar Estrutura Wiki",
"Data" => "Dados",
"Admin newsletter subscriptions" => "Admin subscrições circulares",
"List Newsletters" => "Listar comunicados",
"Admin Newsletters" => "Admin circulares",
"Send Newsletters" => "Enviar Circulares",
"Add a subscription newsletters" => "Adicionar uma subscrição em circular",
"Email:" => "E-mail:",
"Subscriptions" => "Subscrições",
"Valid" => "Válido",
"Subscribed" => "subscrita",
"Admin newsletters" => "Administrar comunicados",
"Editions" => "Edições",
"Last Sent" => "última enviada",
"Create/Edit Newsletters" => "Criar/editar comunicados",
"There are individual permissions set for this newsletter" => "Existem permissões individuais definidos para este comunicado",
"Users can subscribe/unsubscribe to this list" => "Utilizadores podem subscrever/anular subscrição nesta lista",
"Users can subscribe any email address" => "Utilizadores podem subscrever qualquer endereço de e-mail",
"Add unsubscribe instructions to each newsletter" => "Adicionar instruções para anular subscrição em cada circular",
"Validate email addresses" => "Validar endereços de e-mail",
"Add notification" => "Adicionar notificação",
"Event" => "Evento",
"edit" => "editar",
"remove" => "remover",
"Update" => "Actualizar",
"List polls" => "Listar sondagens",
"Edit this poll" => "Editar esta sondagem",
"Preview poll" => "Pre-visualizar sondagem",
"Poll options" => "Opções de Sondagens",
"Votes" => "Votos",
"Admin Polls" => "Administrar Sondagens",
"Set last poll as current" => "Definir a última sondagem como actual",
"Close all polls but last" => "Fechar todas as sondagens excepto a última",
"Activate all polls" => "Activar todas as sondagens",
"active" => "ativo",
"current" => "actual",
"object" => "objecto",
"PublishDate" => "Data de Publicação",
"Results" => "Resultados",
"Wiki pages" => "Wiki",
"Content for the feed" => "Conteúdo para a fonte",
"Security Admin" => "Admin de Segurança",
"To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>." => "Para <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">reportar problemas de segurança</a>.",
"PHP settings" => "Configurações do PHP",
"PHP variable" => "Variáveis PHP",
"Risk Factor" => "Factor de Risco",
"Explanation" => "Explicação",
"Tiki variable" => "Variável Tiki",
"Check all tiki files" => "Verificar todos os ficheiros tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Note que esta opção poderá demorar muito tempo. Deverá confirmar no seu php.ini o valor de max_execution_time.",
"File checks" => "Verificações de ficheiros",
"user" => "Utilizador",
"group" => "grupo",
"sticky" => "persistente",
"Destroy the structure leaving the wiki pages" => "Destruir a estrutura mantendo as páginas Wiki",
"Destroy the structure and remove the pages" => "Destruir a estrutura e remover as páginas",
"Export Pages" => "Exportar páginas",
"Dump Tree" => "Despejar árvore",
"Create WebHelp" => "Criar WebHelp",
"View WebHelp" => "Ver webhelp",
"Create new structure" => "Criar uma nova estrutura",
"Alias" => "Nome",
"Tree" => "árvore",
"Use single spaces to indent structure levels" => "Usar espaços simples para indentar níveis de estrutura",
"Create New Structure" => "Criar nova estrutura",
"List surveys" => "Listar pesquisas",
"Survey Stats" => "Estatísticas das pesquisas",
"Edit this Survey" => "Editar esta pesquisa",
"Admin Surveys" => "Administrar pesquisas",
"Question" => "Pergunta",
"One choice" => "Uma opção",
"Multiple choices" => "Múltipla escolha",
"Short text" => "Texto curto",
"Rate (1..5)" => "Nota (1..5)",
"Rate (1..10)" => "Nota (1..10)",
"Rate" => "Classificação",
"Options (if apply)" => "Opções (se for o caso)",
"Questions" => "Perguntas",
"Admin surveys" => "Administrar pesquisas",
"List Surveys" => "Listar Consultas",
"Edit this Survey:" => "Editar esta Consulta:",
"There are individual permissions set for this survey" => "Existem permissões individuais definidas para esta consulta",
"Open" => "Aberto",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Se o interface estiver a comportar-se de maneira estranha, experimente limpar a cache através das opções abaixo. Recomenda-se a limpeza da cache após upgrades (se necessário utilize FTP ou SSH).",
"Empty" => "Esvaziar",
"All user prefs sessions" => "Todas as preferências de sessões de utilizadores",
"Advanced feature" => "Funcionalidade avançada",
"Fix UTF-8 Errors in Tables" => "Corrigir erros de UTF-8 nas tabelas",
"Warning: Make a backup of your Database before using this function!" => "Atenção: Faça backup da base de dados antes de utilizar esta função!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Atenção: Se precisar converter tabelas grandes, aumente o tempo de execução permitido no seu php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Esta função converte as cadeias de texto das suas tabelas codificadas como ISO-8859-1 para UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Poderá ser necessário utilizar esta ferramenta caso tenha criado conteúdo com uma versão do tiki anterior à 1.8.4 e o parâmetro Default Charset do servidor web definido como ISO-8859-1",
"UTF-8 Errors fixed" => "Errors UTF-8 corrigido",
"Investigate" => "Investigar",
"Fix it" => "Corrigir",
"Create a new topic" => "Criar um novo assunto",
"Topic Name" => "Nome do Assunto",
"Upload Image" => "Carregar uma Imagem",
"List of topics" => "Lista de assuntos",
"Articles (subs)" => "Artigos (assinaturas)",
"topic image" => "imagem do assunto",
"Deactivate" => "Desactivar",
"Remove with articles" => "Remover com artigos",
"Admin Trackers" => "Administrar",
"Edit This Tracker" => "Editar",
"View This Tracker's Items" => "Ver itens",
"Tracker fields" => "Campos do acompanhamento",
"Mandatory" => "Mandatório",
"Is column visible when listing tracker items?" => "Visível durante listagem de itens do acompanhamento?",
"Tbl vis" => "Tab visiv",
"Column links to edit/view item?" => "Clique na coluna para editar/visualizar o item?",
"isMain" => "Clique",
"Hidden" => "Escondido",
"Edit tracker field" => "Editar campos",
"visible to admin only" => "Visível apenas para o admin",
"Found" => "Encontrado",
"trackers" => "acompanhamentos",
"There are individual permissions set for this tracker" => "Estas são as permissões individuais para este acompanhamento",
"No individual permissions. Global permissions apply." => "Nenhuma permissão individual, permissões globais em efeito",
"Show creation date when listing tracker items?" => "Exibir data de criação na lista de itens de acompanhamento?",
"Show lastModif date when listing tracker items?" => "Exibir data da última alteração na lista de itens de acompanhamento?",
"ascending" => "ascendente",
"descending" => "descendente",
"Tracker items allow comments?" => "itens de acompanhamento podem ser comentados?",
"Tracker items allow attachments?" => "itens de acompanhamento permitem ficheiros anexados?",
"Filesize" => "Tamanho",
"Admin groups" => "Administrar grupos",
"Admin users" => "Administrar utilizadores",
"Add new group" => "Adicionar novo grupo",
"List of existing groups" => "Lista de grupos existentes",
"Edit group" => "Editar grupo",
"Add a New Group" => "Adicionar um novo grupo",
"Use wiki page name or full URL" => "Indique o nome da página wiki, ou um URL completo",
"Edit Item" => "Editar item",
"Members" => "Membros",
"users in group" => "utilizadores no grupo",
"Add a New User" => "Adicionar novo utilizador",
"Reason" => "Motivo",
"More Criteria" => "Mais critérios",
"Group (direct)" => "Grupo (directo)",
"to groups" => "aos grupos",
"Edit Included Group" => "Editar grupos incluídos",
"Remove Users and their Userpages" => "Remover utilizadores e suas páginas",
"Manage Group Assignments" => "Gerir competências de grupo",
"Set Default Groups" => "Definir grupos por omissão",
"Assign selected to" => "Atribuir selecção a",
"Remove selected from" => "Remover selecção de",
"the following groups:" => "os seguintes grupos:",
"Edit user" => "Editar utilizador",
"Use the email as username" => "Usar email como nome de utilizador",
"No password is required" => "Não é necessária password",
"Generate a password" => "Gerar uma palavra-passe",
"Overwrite" => "Substituir",
"Don't overwrite" => "Não sobrescrever",
"Overwrite groups:" => "Sobrescrever grupos:",
"Loading..." => "Carregando...",
"Admin Article Types" => "Administrar Tipos de Artigos",
"List of types" => "Lista de tipos",
"Shows up in the drop down list of article types" => "Aparece na lista drop down de tipos de artigos",
"Allow ratings by the author" => "Permite classificação pelo autor",
"Show before publish date" => "Mostrar antes da data de publicação",
"non-admins can view before the publish date" => "Não-admins podem visualizar antes da data de publicação",
"Show after expire date" => "Mostrar depois da data de validade",
"non-admins can view after the expire date" => "Não-admins podem visualizar após data de validade",
"Heading only" => "Somente cabeçalho",
"No article body, heading only" => "Sem corpo do artigo, apenas o cabeçalho",
"Allow comments for this type" => "Permitir comentários para este tipo",
"Comment Can Rate Article" => "Comentário pode classificar artigo",
"Allow comments to include a rating value" => "Permitir incluir classificação com o comentário",
"Show image" => "Mostrar imagem",
"Show topic or own image" => "Mostrar imagem própria ou do assunto",
"Show avatar" => "Mostrar avatar",
"Show author's avatar" => "Mostrar avatar do autor",
"Show author" => "Mostrar autor",
"Show author name" => "Mostrar nome do autor",
"Show publish date" => "Mostrar data de publicação",
"Show expire date" => "Mostrar data de validade",
"Show reads" => "Mostrar lidas",
"Show the number of times the article was read" => "Mostrar nº de visualizações do artigo",
"Show size" => "Mostrar tamanho",
"Show the size of the article" => "Mostrar tamanho do artigo",
"Show topline" => "Mostrar primeira linha",
"Show a small title over the title" => "Mostrar um pequeno título sobre o título",
"Show subtitle" => "Mostrar subtítulo",
"Show the subtitle" => "Mostra o subtítulo",
"Show source" => "Mostrar fonte",
"Show link to source after article body" => "Mostrar link para a fonte a seguir ao corpo do artigo",
"Show Image Caption" => "Mostrar legenda da imagem",
"Show a legend under the image" => "Mostra uma legenda abaixo da imagem",
"Show Language" => "Mostrar idioma",
"Show the language" => "Mostra o idioma",
"Creator can edit" => "Criador pode editar",
"Show lang" => "Mostrar idioma",
"Review" => "Rever",
"Create a new type" => "Criar um novo tipo",
"Group Information" => "Informações do Grupo",
"level" => "nível",
"inherited from" => "herdada de",
"inherited" => "herdada",
"Create level" => "Criar nível",
"all permissions in level" => "todas as permissões no nível",
"Assign User to Group" => "Atribuir utilizador a grupo",
"backlinks to" => "hiperligado de",
"No backlinks to this page" => "Não há hiperligações para esta página",
"Browse Gallery" => "Explorar galeria",
"Upload From Disk" => "Carregar do disco",
"Process" => "Processo",
"Edit Post" => "Editar Mensagem",
"View Blog" => "Ver o blog",
"Use ...page... to separate pages in a multi-page post" => "Utilize ...página... para separar as páginas em uma mensagem multi-página",
"Body" => "Corpo",
"Upload image for this post" => "Carregar uma imagem para esta mensagem",
"Trash" => "Lixeira",
"Spellcheck" => "Verificação ortográfica",
"Save and Exit" => "Salvar e sair",
"Made with" => "Criado com",
"Execution time" => "Tempo de execução",
"Memory usage" => "Memória utilizada",
"Server load" => "Carga do servidor",
"Watch Only This Category" => "Monitorizar apenas esta categoria",
"Watch This Category and Their Descendants" => "Monitorizar esta categoria e suas descendentes",
"Stop Watching Only This Category" => "Parar de monitorizar apenas esta categoria",
"Stop Watching This Category and Their Descendants" => "Parar de monitorizar esta categoria e suas descendentes",
"Admin Category" => "Admin Categorias",
"Browse in" => "Procurar em",
"in the current category - and its subcategories: " => "na directoria actual - e suas subcategorias: ",
"Hide subcategories objects" => "Esconder objectos de subcategorias",
"Show subcategories objects" => "Mostrar objectos de subcategorias",
"Upper level" => "Nível superior",
"Edit Gallery" => "Editar galeria",
"Rebuild Thumbnails" => "Recricar miniaturas",
"List Gallery" => "Listar a galeria",
"All Images" => "Todas as imagens",
"Sort Images by" => "Ordenar imagens por",
"Original Size" => "Tamanho original",
"rotate right" => "rodar para a direita",
"rotate" => "rodar",
"Details" => "Detalhes",
"You can include the image in a tiki page using one of these lines" => "Poderá incluir a imagem numa página tiki usando uma destas linhas",
"Return to Gallery" => "Retornar à galeria",
"Edit Image" => "Editar Imagem",
"First Image" => "Primeira imagem",
"Prev Image" => "Imagem anterior",
"Smaller" => "Menor",
"Bigger" => "Maior",
"Popup window" => "Janela de popup",
"Next Image" => "Próxima imagem",
"Last Image" => "última imagem",
"Image Name" => "Nome da Imagem",
"Image Scale" => "Escaladeimagem",
"Move image" => "Mover a imagem",
"Stop Monitoring this Page" => "Não monitorizar mais esta página",
"Monitor this Page" => "Monitorizar esta página",
"Visible Calendars" => "Calendários Visíveis",
"Click to select visible calendars" => "Clique para seleccionar os calendários visíveis",
"Group Calendars" => "Agrupar Calendários",
"Edit event" => "Editar evento",
"View event" => "Ver evento",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmada",
"Cancelled" => "Cancelada",
"Change Focus" => "Alterar foco",
"Calendar Item" => "Item de calendário",
"Edit Calendar" => "Editar Calendário",
"New event" => "Novo evento",
"Edit Calendar Item" => "Editar o Item de Calendário",
"New Calendar Item" => "Novo Item no Calendário",
"Tuesday" => "Terça-feira",
"Wednesday" => "Quarta-feira",
"Thursday" => "Quinta-feira",
"Friday" => "Sexta-feira",
"January" => "Janeiro",
"February" => "Fevereiro",
"March" => "Março",
"April" => "Abril",
"May" => "Maio",
"June" => "Junho",
"July" => "Julho",
"August" => "Agosto",
"September" => "Setembro",
"October" => "Outubro",
"November" => "Novembro",
"December" => "Dezembro",
"times" => "vezes",
"End" => "Fim",
"Duration" => "Duração",
"Date and time of end" => "Data e hora do fim",
"or new" => "ou novo",
"Organized by" => "Ordenado por",
"Roles" => "Perfis",
"import" => "importar",
"Change password enforced" => "Alteração obrigatória da palavra-passe",
"Change your password" => "Alterar a sua palavra-passe",
"Send a message to us" => "Envie-nos uma mensagem!",
"Contact us by email" => "Entre em contato por email",
"Contacts" => "Contactos",
"Create/edit contacts" => "Criar/editar contactos",
"First Name" => "Nome",
"Last Name" => "Sobrenome",
"Nickname" => "Nome curto",
"You can browse the generated WebHelp here" => "Você pode navegar o WebHelp gerado aqui",
"Structure" => "Estrutura",
"Top page" => "Página de Topo",
"Add a new site" => "Adicionar um novo site",
"Site added" => "Site adicionado",
"Directory Administration" => "Administração do directório",
"There are" => "Existem",
"invalid sites" => "sites inválidos",
"valid sites" => "sites válidos",
"Users have visited" => "Utilizadores visitaram",
"sites from the directory" => "sites do directório",
"Users have searched" => "Utilizadores procuraram",
"times from the directory" => "tempos a partir do directório",
"Related" => "Relacionados",
"Validate" => "Validar",
"Admin directory categories" => "Administrar categorias de directório",
"Add a directory category" => "Adicionar uma nova categoria de directório",
"Edit this directory category" => "Editar esta categoria deste directório",
"Children type" => "Tipos de filhos",
"Maximum number of children to show" => "Número máximo de filhos a mostrar",
"Editor group" => "Grupo do editor",
"allow" => "permitir",
"count" => "contagem",
"relate" => "relacionar",
"Mutual" => "Mútuo",
"Admin sites" => "Administrar sites",
"Is valid" => "É válido",
"New Sites" => "Novos sites",
"Cool Sites" => "Sites legais",
"Add a Site" => "Adicionar um site",
"any" => "qualquer",
"in entire directory" => "em todo o directório",
"Sort by" => "Ordenar por",
"name (desc)" => "nome (desc)",
"name (asc)" => "nome (asc)",
"creation date (desc)" => "data de criação (desc)",
"creation date (asc)" => "data de criação (asc)",
"last updated (desc)" => "última actualização em (desc)",
"last updated (asc)" => "última actualização em (asc)",
"Added" => "Adicionado em",
"Last updated" => "Última actualização em",
"Total links" => "Total de links",
"Links to validate" => "Links a validar",
"Searches performed" => "Pesquisas realizadas",
"Total links visited" => "Links visitados totais",
"Directory ranking" => "Ranking de directórios",
"Search results" => "Resultados da pesquisa",
"Validate sites" => "Sites validados",
"Edit article" => "Editar artigo",
"List Articles" => "Listar Artigos",
"View Articles" => "Ver artigos",
"Topline" => "Linha de topo",
"Author Name" => "Nome do Autor",
"Own Image" => "Imagem própria",
"Article image" => "Imagem do artigo",
"Use own image" => "Usar imagem própria",
"Float text around image" => "Texto flutuante à volta da imagem",
"Own image size x" => "Largura da imagem própria",
"Own image size y" => "Altura da imagem própria",
"Publish Date" => "Data de Publicação",
"Expiration Date" => "Validade",
"Edit or create banners" => "Editar ou criar banners",
"List banners" => "Listar banners",
"URL to link the banner" => "Endereço para ligar ao banner",
"Client" => "Cliente",
"Max impressions" => "Impressões (máx)",
"Show the banner only between these dates" => "Exibir o banner apenas entre estas datas",
"From date" => "Do dia",
"To date" => "Ao dia",
"Use dates" => "Utilizar datas",
"Show the banner only in this hours" => "Exibir o banner apenas entre estas horas",
"Show the banner only on" => "Exibir o banner apenas às",
"Mon" => "Seg",
"Tue" => "Ter",
"Wed" => "Qua",
"Thu" => "Qui",
"Fri" => "Sex",
"Sat" => "Sáb",
"Sun" => "Dom",
"Select ONE method for the banner" => "seleccione UM método para o banner",
"Use HTML" => "Usar HTML",
"Use image" => "Usar a imagem",
"Image:" => "Imagem:",
"Current Image" => "Imagem actual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Usar a imagem gerada pelo endereço (a imagem será requisitada no endereço para cada impressão)",
"Use text" => "Utilizar texto",
"Save the Banner" => "Salvar o banner",
"Remove Zones (you lose entered info for the banner)" => "Remover Zonas (informações editadas para o banner serão perdidas)",
"Current heading" => "Cabeçalho actual",
"There are individual permissions set for this blog" => "Existem permissões individuais definidas para este blog",
"Number of posts to show" => "Número de publicações a exibir",
"Allow other user to post in this blog" => "Permitir a outros utilizadores publicar neste blog",
"Allow search" => "Permitir procura",
"Allow comments" => "Permitir comentários",
"Blog heading" => "Cabeçalho do Blog",
"Edit Style Sheet" => "Editar Folha de Estilo",
"Style Sheet" => "Folha de Estilo",
"choose a stylesheet" => "escolha uma folha de estilo",
"Try" => "Experimentar",
"Colored text" => "Texto colorido",
"Box content" => "Conteúdo da caixa",
"Dynamic variables" => "Variáveis dinâmicas",
"Inserts an editable variable" => "Inserir uma variável editável",
"External links" => "Links externos",
"Wiki References" => "Referências Wiki",
"JoinCapitalizedWords or use" => "UnirPalavrasComMaiusculas ou use",
"page|description" => "página|desc",
"for wiki references" => "para referências Wiki",
"SomeName" => "AlgumNome",
"prevents referencing" => "prevenir referência",
"Lists" => "Listas",
"for bullet lists" => "para listas de itens",
"for numbered lists" => "para listas numeradas",
"for definiton lists" => "para listas de definições",
"Tables" => "Tabelas",
"Title bar" => "Barra de título",
"Multi-page pages" => "Páginas multi-página",
"Non parsed sections" => "Secções não interpretadas",
"Preformated sections" => "Secções pré-formatadas",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines." => "Uma vez que a funcionalidade de formatação de parágrafos na Wiki está activa, os grupos de linhas que não estejam em branco serão agrupadas em parágrafos. As linhas podem ser de qualquer comprimento, e serão continuadas na linha seguinte juntamente com a linha seguinte. Os parágrafos serão, portanto, separados através de linhas em branco.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Uma vez que a funcionalidade de formatação de parágrafos Wiki está desactivada, cada linha será representada como a escrever, o que significa que, se deseja que os parágrafos sejam separados devidamente, todo o texto que o compõem deverá estar na mesma linha.",
"No description available" => "Descrição não disponível",
"Edit successful!" => "Edição bem-sucedida!",
"The following image was successfully edited" => "A seguinte imagem foi editada com sucesso",
"Image Description" => "Descrição da Imagem",
"You can view this image in your browser using" => "Você pode visualizar esta imagem em seu navegador usando",
"You can include the image in an HTML page using one of these lines" => "Poderá incluir a imagem numa página HTML usando uma destas linhas",
"Edit or ex/import Languages" => "Editar ou importar/exportar Línguas",
"Edit and create Languages" => "Editar e criar Línguas",
"Edit and create languages" => "Editar e criar línguas",
"Create Language" => "Criar Língua",
"Shortname" => "Nome Abreviado",
"like" => "como",
"Longname" => "Nome Completo",
"Select the language to edit" => "seleccione uma língua a editar",
"Add a translation" => "Adicionar uma tradução",
"Edit translations" => "Editar traduções",
"Translate recorded" => "Tradução registada",
"Translation" => "Tradução",
"reset table" => "reinicializar",
"Create New Block" => "Criar um novo bloco",
"Return to block listing" => "Retornar à listagem de blocos",
"Block description: " => "Descrição do bloco: ",
"You are editing block:" => "Está editando o bloco:",
"Publishing date" => "Data de publicação",
"Publishing Date" => "Data de Publicação",
"Edit question options" => "Editar opções da pergunta",
"List Quizzes" => "Listar Testes",
"Quiz Stats" => "Estatísticas de testes",
"This Quiz Stats" => "Estatísticas deste teste",
"Edit this Quiz" => "Editar este teste",
"Admin Quizzes" => "Administrar testes",
"Create/edit options for question" => "Criar/editar opções para a pergunta",
"Option" => "Opções",
"points" => "pontos",
"Quiz" => "Teste",
"canRepeat" => "podeRepetir",
"timeLimit" => "tempoLimite",
"Create/edit quizzes" => "Criar/editar testes",
"There are individual permissions set for this quiz" => "Existem permissões individuais para este teste",
"Quiz can be repeated" => "Teste pode ser repetido",
"Store quiz results" => "Armazenar resultados do teste",
"Quiz is time limited" => "Tempo-limite para o teste",
"Maximum time" => "Tempo máximo",
"Edit quiz questions" => "Editar perguntas do teste",
"Create/edit questions for quiz" => "Criar/editar perguntas do teste",
"maxScore" => "notaMaxima",
"From Points" => "Pontos Mínimos",
"To Points" => "Pontos Máximos",
"Answer" => "Resposta",
"Modify Structure" => "Modificar Estrutura",
"You will remove" => "Irá remover",
"and its subpages from the structure, now you have two options:" => "e suas sub-páginas da estrutura, agora possuí duas opções:",
"Remove only from structure" => "Remover apenas da estrutura",
"Remove from structure and remove page too" => "Remover da estrutura e remover a página também",
"Structure Layout" => "Estrutura de Layout",
"Promote" => "Promover",
"Demote" => "Demover",
"Previous" => "Anterior",
"Current Node" => "Nó actual",
"Page alias" => "Apelido da Página",
"Add pages to current node" => "Adicionar páginas ao nó actual",
"After page" => "Após a página",
"Create Page" => "Criar página",
"Use pre-existing page" => "Utilizar uma página pré-existente",
"Submit article" => "Enviar artigo",
"List Submissions" => "Listar envios",
"Edit templates" => "Editar modelos",
"Template listing" => "Listagem de modelos",
"Available templates" => "Modelos disponíveis",
"Edit a topic" => "Editar um tópico",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "A Sandbox é uma página onde pode praticar as suas técnicas de edição, utilize a funcionalidade de pré-visualização para visualizar a página final, nenhuma versão é armazenada para esta página.",
"Upload picture" => "Carregar uma imagem",
"Admin Content Templates" => "Administrar padrões de conteúdo",
"Try to convert HTML to wiki" => "Tentar converter HTML para wiki",
"Import page" => "Importar página",
"export all versions" => "exportar todas as versões",
"Year:" => "Ano:",
"Authors:" => "Autores:",
"License" => "Licença",
"Important" => "Importante",
"My Footnotes" => "Notas de rodapé",
"or use" => "ou use",
"votes" => "votos",
"status" => "estado",
"lastModif" => "ultimaModif",
"Admin FAQ" => "Administrar FAQ",
"List FAQs" => "Listar FAQs",
"View FAQ" => "Visualizar FAQ",
"Edit this FAQ" => "Editar este FAQ",
"New Question" => "Nova pergunta",
"Use a question from another FAQ" => "Utilizar uma pergunta de outro FAQ",
"FAQ questions" => "Perguntas do FAQ",
"Suggested questions" => "Perguntas sugeridas",
"No suggested questions" => "Sem perguntas sugeridas",
"Upload File" => "Carregar ficheiro",
"View tpl" => "Ver tpl",
"Create New File Gallery" => "Criar Galeria de Ficheiros",
"You can access the file gallery using the following URL" => "Você pode aceder a galeria de ficheiros pelo seguinte endereço",
"Admin forums" => "Administrar fóruns",
"Edit queued message" => "Editar mensagem na fila",
"make this a thread of" => "transformar em uma sequência de",
"None, this is a thread message" => "Nenhuma, esta é uma mensagem de uma sequência",
"summary" => "sumário",
"announce" => "anúncio",
"hot" => "quente",
"no feeling" => "insensível",
"frown" => "muxoxo",
"exclaim" => "exclamação",
"idea" => "ideia",
"neutral" => "neutro",
"question" => "pergunta",
"happy" => "feliz",
"wink" => "piscadela",
"Save and Approve" => "Salvar e aprovar",
"convert to topic" => "converter em um assunto",
"List of messages" => "Lista de mensagens",
"New Topic" => "Novo assunto",
"no summary" => "sem sumário",
"No messages queued yet" => "Nenhuma mensagem na fila",
"Last Post" => "última mensagem",
"Reported by" => "Assinaldo por",
"Accept" => "Aceitar",
"Galleries" => "Galerias",
"Create New Gallery" => "Criar uma nova galeria",
"Create a gallery" => "Criar uma galeria",
"Edit this gallery:" => "Editar esta galeria:",
"There are individual permissions set for this gallery" => "Existem permissões individuais definidas para esta galeria",
"Gallery is visible to non-admin users?" => "Galeria visível para utilizadores não administradores?",
"Fields to show during browsing the gallery" => "Campos a mostrar durante a navegação pela categoria",
"Creation Date" => "Data da criação",
"XY-Size" => "Tamanho XY",
"Gallery Image" => "Imagem da galeria",
"Available scales" => "Escalas disponíveis",
"default scale" => "Escala por omissão",
"No scales available" => "Nenhuma escala disponível",
"Original image is default scale" => "Imagem original tem escala por omissão",
"Add scaled images with bounding box of square size" => "Adicionar imagens com caixa de limites de dimensão quadrada",
"Other users can upload images to this gallery" => "Outros utilizadores podem carregar imagens nesta galeria",
"You can access the gallery using the following URL" => "Pode aceder esta galeria pelo seguinte URL",
"Available Galleries" => "Galerias Disponíveis",
"Choose a filter" => "Escolha um filtro",
"To" => "Para",
"Im- Export languages" => "Importar/exportar línguas",
"Select the language to Import" => "seleccione a língua para importar",
"Select the language to Export" => "seleccione a língua para exportar",
"Overwrite existing pages if the name is the same" => "Substituir páginas com mesmo nome",
"Previously remove existing page versions" => "Remover previamente versões existentes da página",
"excerpt" => "trecho",
"Result" => "Resultado",
"Locked" => "Travada",
"Configure General Settings" => "Configurações Gerais",
"Documentation" => "Documentação",
"Clear cached version and refresh cache" => "Limpar versão em cache e recarregar a cache",
"configure rules" => "configurar regras",
"Edit Repository" => "Editar repositório",
"Last Changes" => "Últimas Alterações",
"Search by Date" => "Pesquisar por Data",
"LastChanges" => "ÚltimasAlterações",
"Rollback" => "Restaurar",
"Pages like" => "Páginas semelhantes",
"No pages found" => "Nenhuma página encontrada",
"Edit New Article" => "Editar um novo artigo",
"View Submissions" => "Ver artigos enviados",
"ExpireDate" => "Data de Expiração",
"AuthorName" => "Nome do Autor",
"Create banner" => "Criar um banner",
"Method" => "Método",
"Use Dates?" => "Usar datas?",
"Max Impressions" => "Máx. Exibições",
"Impressions" => "Exibições",
"Clicks" => "Cliques",
"Create New Blog" => "Criar um novo blog",
"Dynamic content system" => "Sistema de conteúdo dinâmico",
"Available content blocks" => "Blocos de conteúdo disponíveis",
"Current ver" => "Versão actual",
"Next ver" => "Próxima vers.",
"Program" => "Programa",
"Available FAQs" => "FAQs disponíveis",
"Edit/Create" => "Editar/Criar",
"Edit this FAQ:" => "Editar este FAQ:",
"Create new FAQ" => "Criar um novo FAQ",
"Create New FAQ:" => "Criar um novo FAQ:",
"Users can suggest questions" => "Utilizadores podem sugerir perguntas",
"Create a File Gallery" => "Criar uma galeria de ficheiros",
"Gallery Images" => "Imagens da Galeria",
"Edit Blog" => "Editar Blog",
"Blog Title" => "Título do Blog",
"Edit New Submission" => "Editar nova mensagem",
"Survey stats" => "Estatísticas da pesquisa",
"List Movies" => "Listar filmes",
"Choose a movie" => "Escolha um filme",
"Last mod" => "Última alteração",
"Last author" => "Último autor",
"Last version" => "Última versão",
"unlocked" => "destravada",
"Open client window" => "Abrir a janela de cliente",
"Generate HTML" => "Gerar HTML",
"Transcripts" => "Transcrição",
"Online operators" => "Operadores on-line",
"Operator" => "Operador",
"transcripts" => "transcrição",
"Offline operators" => "Operadores offline",
"Add an operator to the system" => "Adicionar um operador ao sistema",
"Operators must be tiki users" => "Operadores devem ser utilizadores Tiki",
"Set as Operator" => "Definir como operador",
"Chat started" => "Chat iniciado",
"Operator:" => "Operador:",
"Your request is being processed" => "O seu pedido está a ser processado",
"cancel request and exit" => "cancelar o pedido e sair",
"cancel request and leave a message" => "cancelar o pedido e deixar uma mensagem",
"Live support:Console" => "Suporte on-line:Console",
"be online" => "ficar on-line",
"be offline" => "ficar offline",
"Support requests" => "Requisições de suporte",
"Requested" => "Requisitou",
"Join" => "Juntar-se",
"Support chat transcripts" => "Suporte para transcrições do chat",
"started" => "iniciou",
"reason" => "motivo",
"Transcript" => "Transcrição",
"Daily" => "Diariamente",
"Weekly" => "Semanalmente",
"Remove old events" => "Remover eventos antigos",
"duration" => "duração",
"Mini Calendar: Preferences" => "Mini-Calendário: Preferências",
"Calendar Interval in daily view" => "Intervalo do calendário na visão diária",
"Start hour for days" => "Hora inicial para os dias",
"End hour for days" => "Hora final para os dias",
"Reminders" => "Lembretes",
"no reminders" => "sem lembretes",
"Or enter path or URL" => "Ou entre o caminho ou endereço",
"Add Topic" => "Adicionar assunto",
"Mods Configuration" => "Configuração dos Mods",
"Update remote index" => "Actualizar o índice remoto",
"Rebuild local list" => "Reconstruir a lista local",
"Attention" => "Atenção",
"all types" => "todos os tipos",
"y" => "s",
"User Galleries" => "Galerias de Utilizador",
"Unread Messages" => "Mensagens não lidas",
"Tasks" => "Tarefas",
"MyTiki" => "MeuTiki",
"Notepad" => "Bloco de Notas",
"MyFiles" => "Os meus Ficheiros",
"My Watches" => "Minhas notificações",
"Sent editions" => "Edições enviadas",
"The newsletter was sent to {\$sent} email addresses" => "A Circular foi enviada para endereços de email de {\$sent}",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Obrigado por sua assinatura. Você receberá um email em breve para confirmar sua assinatura. Nenhum comunicado será enviado até que sua inscrição seja confirmada.",
"Your email address was removed from the list of subscriptors." => "Seu endereço de email foi removido da lista de assinantes.",
"Subscription confirmed!" => "Assinatura confirmada!",
"Subscribe to Newsletter" => "Assine o comunicado",
"Subscribe to this Newsletter" => "Inscrever-se",
"Notes" => "Notas",
"Write a note" => "Escrever uma nota",
"quota" => "cota",
"No notes yet" => "Sem notas ainda",
"Merge selected notes into" => "combinar notas seleccionadas em",
"Reading note:" => "Lendo nota:",
"List notes" => "Listar notas",
"Write note" => "Escrever nota",
"Wiki Create" => "Criar wiki",
"Wiki Overwrite" => "Sobrescrever wiki",
"Assign permissions to " => "Definir permissões a ",
"Assign permissions to this object" => "Definir permissões para este objecto",
"These permissions override any global permissions or category permissions affecting this object." => "Estas permissões sobrepõem-se a quaisquer permissões globais ou de categoria que afectem este objecto.",
"Published" => "Publicado",
"Passcode to register (not your user password)" => "Código para registo (não é sua palavra-passe pessoal)",
"Orphan Pages" => "Páginas Órfãs",
"Browser not supported" => "Navegador não suportado",
"Rename" => "Renomear",
"Make Structure" => "Criar Estrutura",
"Discuss" => "Discutir",
"Attach File" => "Anexar um ficheiro",
"1 File Attached" => "1 ficheiro anexado",
"Rollback to this version" => "Reverter para esta versão",
"s=source" => "s=fonte",
"b=rollback" => "b=reverter",
"Pick your avatar" => "seleccione seu avatar",
"User Preferences" => "Preferências do Utilizador",
"Your current avatar" => "Seu avatar actual",
"reset" => "reiniciar",
"Pick avatar from the library" => "seleccionar um avatar da biblioteca",
"Pick user Avatar" => "Escolher Avatar do Utilizador",
"Hide all" => "Esconder todos",
"Show all" => "Exibir todos",
"Avatar Image" => "Imagem do Avatar",
"random" => "aleatório",
"Upload your own avatar" => "Carregar seu próprio avatar",
"Insert" => "Inserir",
"Average" => "Média",
"View Results" => "Ver Resultados",
"Vote poll" => "Votar na sondagem",
"Other Polls" => "Outras Votações",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Nota: Lembre-se que está a pré-visualizar esta página, e que esta ainda não foi guardada ",
"on:" => "em:",
"Topic image" => "Imagem do assunto",
"Viewing blog post" => "Visualizando mensagem do blog",
"Return to blog" => "Retornar ao blog",
"The original document is available at" => "O documento original pode ser encontrado em",
"Print multiple pages" => "Imprimir múltiplas páginas",
"No structures" => "Nenhuma estrutura",
"Add Pages" => "Adicionar Páginas",
"Add Pages from Structures" => "Adicionar Páginas a partir de estruturas",
"Current Version" => "Versão actual",
"Quiz result stats" => "Estatísticas de resultados do Teste",
"Time" => "Tempo",
"User answers" => "Respostas do utilizador",
"Stats for quizzes" => "Estatísticas para testes",
"taken" => "feitos",
"Av score" => "Pontuação méd.",
"Av time" => "Tempo méd.",
"Clear Stats" => "Limpar estatísticas",
"Stats for this quiz Questions " => "Estatísticas para as perguntas deste teste ",
"Top 10" => "10 Mais",
"Top 20" => "20 Mais",
"Top 50" => "50 Mais",
"Top 100" => "100 Mais",
"Received articles" => "Artigos recebidos",
"Edit received article" => "Editar o artigo recebido",
"Use Image" => "Usar Imagem",
"Image x size" => "Largura da imagem",
"Image y size" => "Altura da imagem",
"Image name" => "Nome da imagem",
"Accept Article" => "Aceitar o Artigo",
"Received Pages" => "Páginas Recebidas",
"Referer stats" => "Estatísticas de referência",
"Last" => "Última",
"Your email could not be validated; make sure you email is correct and click register below." => "Seu endereço de email não pôde ser validado; certifique-se de que está correto e clique em registrar-se abaixo.",
"Register as a new user" => "registar-se como novo utilizador",
"Repeat password" => "Confirmação de palavra-passe",
"Tiki site registered" => "Site Tiki registado",
"The following site was added and validation by admin may be needed before appearing on the lists" => "O site a seguir foi adicionado mas a validação pelo administrador pode ser necessária antes que apareça nas listas",
"Please register." => "Por favor registe-se.",
"Register this site at tikiwiki.org" => "registar este site no tikiwiki.org",
"Read this first!" => "Leia isto em primeiro!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "Nesta página você pode fazer com que seu site seja conhecido no tikiwiki.org. Ele será mostrado em uma lista de sites tiki conhecidos.",
"Registering is voluntary." => "O registo é voluntário.",
"Registering does not give you any benefits except one more link to your site." => "O registo não lhe dá nenhum benefício excepto o link para seu site.",
"You don't get any emails, we don't sell the data about your site." => "Você não pode pegar nenhum e-mail, nós não vendemos os dados sobre seu site.",
"Registering is just for us to get an overview of Tiki's usage." => "O registo é somente para obtermos uma amostragem do uso do Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Se o seu site é privado ou está dentro de sua intranet, você não deve se registar!",
"Information about your site" => "Informação sobre seu site",
"Send me my Password" => "Me envie minha palavra-passe",
"Remove page" => "Remover a página",
"You are about to remove the page" => "Você está prestes a remover a página",
"permanently" => "permanentemente",
"Remove all versions of this page" => "Remover todas as versões desta página",
"Rollback page" => "Restaurar versão da página",
"Searched" => "Buscadas",
"Search in" => "Pesquisar em",
"Simple search" => "Procura simples",
"No pages matched the search criteria" => "Nenhuma página atendeu aos seus critérios de pesquisa",
"This newsletter will be sent to {\$subscribers} email addresses." => "Esta Circular será enviada para endereços de email de {\$subscribers} .",
"Prepare a newsletter to be sent" => "Preparar uma Circular para envio",
"Apply content template" => "Aplicar modelo de conteúdo",
"Send objects" => "Enviar objectos",
"Transmission results" => "Resultados da transmissão",
"Send Wiki Pages" => "Enviar Páginas Wiki",
"Send Articles" => "Enviar Artigos",
"Add Article" => "Adicionar um artigo",
"Send objects to this site" => "Enviar objectos para este site",
"Change shoutbox general settings" => "Alterar configurações gerais do quadro negro",
"Post or edit a message" => "Enviar ou editar uma mensagem",
"Parent page" => "Página pai",
"Most viewed objects" => "Mais visualizados",
"Most viewed objects in the last 7 days" => "Mais visualizados nos últimos 7 dias",
"Site Stats" => "Estatísticas do Site",
"Started" => "Iniciado",
"Days online" => "Dias on-line",
"Total pageviews" => "Total de visualizações de páginas",
"Average pageviews per day" => "Média de visualizações de páginas diárias",
"Best day" => "Melhor dia",
"Worst day" => "Pior dia",
"Wiki Stats" => "Estatísticas Wiki",
"Size of Wiki Pages" => "Tamanho das Páginas Wiki",
"Average page length" => "Tamanho médio das páginas",
"Average versions per page" => "Média de versões por página",
"Visits to wiki pages" => "Visitas a páginas Wiki",
"Average links per page" => "Média de hiperligações por página",
"Image galleries Stats" => "Estatísticas de galerias de imagens",
"Average images per gallery" => "Número médio de imagens por galeria",
"Total size of images" => "Tamanho total das imagens",
"Average image size" => "Tamanho médio das imagens",
"Visits to image galleries" => "Visitas as galerias de imagens",
"File galleries Stats" => "Estatísticas das galerias de ficheiros",
"Average files per gallery" => "Número médio de ficheiros por galeria",
"Total size of files" => "Tamanho total dos ficheiros",
"Average file size" => "Tamanho médio dos ficheiros",
"Visits to file galleries" => "Visitas as galerias de ficheiros",
"CMS Stats" => "Estatísticas de CMS",
"Total reads" => "Total de leituras",
"Average reads per article" => "Média de leituras por artigos",
"Total articles size" => "Tamanho total dos artigos",
"Average article size" => "Tamanho médio dos artigos",
"Forum Stats" => "Estatísticas dos fóruns",
"Total topics" => "Total de tópicos",
"Average topics per forums" => "Média de tópicos por fórum",
"Visits to forums" => "Visitas aos fóruns",
"Blog Stats" => "Estatísticas de Blogs",
"Total posts" => "Total de publicações",
"Average posts per weblog" => "Média de publicações por weblog",
"Total size of blog posts" => "Tamanho total das publicações em blogs",
"Average posts size" => "Tamanho médio das publicações",
"Visits to weblogs" => "Visitas aos weblogs",
"Poll Stats" => "Estatísticas das votações",
"Total votes" => "Total de votos",
"Average votes per poll" => "Média de votos por sondagem",
"Total questions" => "Total de perguntas",
"Average questions per FAQ" => "Média de perguntas por FAQ",
"User Stats" => "Estatísticas de utilizadores",
"Average bookmarks per user" => "Média de bookmarks por utilizador",
"Average questions per quiz" => "Média de perguntas por teste",
"Quizzes taken" => "Testes realizados",
"Average quiz score" => "Pontuação média nos testes",
"Average time per quiz" => "Tempo médio por teste",
"Usage chart" => "Gráfico de utilização",
"Usage chart image" => "Imagem do gráfico de utilização",
"Daily Usage" => "Utilizacao diaria",
"Stats for surveys" => "Estatísticas de consultas",
"Last taken" => "Última realização em",
"Time Left" => "Tempo restante",
"Send Answers" => "Enviar as respostas",
"Your email was sent" => "Seu email foi enviado",
"Theme is selected as follows" => "Um tema é seleccionado da seguinte forma",
"If a theme is assigned to the individual object that theme is used." => "Se um tema for atribuído a um objecto individual o tema é utilizado",
"If not then if a theme is assigned to the object's category that theme is used" => "Senão, então se um tema for atribuído à categoria do objecto o tema é utilizado",
"If not then a theme for the section is used" => "Senão, um tema para a secção é utilizado",
"If none of the above was selected the user theme is used" => "Se nenhum dos itens acima for seleccionado, o tema do utilizador é utilizado",
"Finally if the user didn't select a theme the default theme is used" => "Finalmente, se o utilizador não seleccionou um tema o tema padrão é utilizado",
"Control by Objects" => "Controlar por objecto",
"Control by Sections" => "Controlar por secções",
"Assign themes to categories" => "Atribuir temas a categorias",
"Assigned categories" => "Categorias atribuídas",
"Theme Control Center: Objects" => "Centro de Controlo de Temas: Objectos",
"Control by Categories" => "Controlo por Categorias",
"Assign themes to objects" => "Atribuir temas a objectos",
"Assigned objects" => "Objectos atribuídos",
"Assign themes to sections" => "Atribuir temas a secções",
"Assigned sections" => "Secções atribuídas",
"The following file was successfully uploaded" => "O seguinte ficheiro foi carregado com sucesso",
"You can download this file using" => "Você pode baixar este ficheiro usando",
"You can display an image in a Wiki page using" => "Você pode incluir este ficheiro em uma página HTML usando",
"required field for podcasts" => "campos mandatórios para podcasts",
"Batch Upload Results" => "Resultado do Upload em Lote",
"Upload successful!" => "Carregamento bem-sucedido!",
"The following image was successfully uploaded" => "A seguinte imagem foi carregada com sucesso",
"Image ID thumb" => "ID da miniatura da imagem",
"You can include the image in an Wiki page using" => "Você pode incluir a imagem em uma página Wiki usando",
"or use filename" => "ou nome do ficheiro",
"Now enter the image URL" => "Agora introduza o endereço (URL) da imagem",
"or upload a local image from your disk" => "ou carregue uma imagem do seu disco",
"Batch Upload" => "Upload em lote",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatura (opcional, anula a miniatura automaticamente gerada)",
"You have to create a gallery first!" => "Você precisa criar uma galeria antes de prosseguir!",
"User assigned modules" => "Módulos atribuídos pelo Utilizador",
"Restore defaults" => "Restaurar padrões",
"act" => "activ",
"Assign module" => "Atribuir módulo",
"Column" => "Coluna",
"top" => "topo",
"Folders" => "Pastas",
"Folder in" => "Pasta em",
"Remove Folder" => "Remover pasta",
"Refresh Cache" => "Atualizar cache",
"Admin folders and bookmarks" => "Administrar pastas e bookmarks",
"Send me a message" => "Envie-me uma mensagem",
"Assign Group" => "Atribuir Grupo",
"Change user preferences" => "Alterar preferências de utilizador",
"Personal Wiki Page" => "Página Pessoal Wiki",
"Is email public? (uses scrambling to prevent spam)" => "Endereço de email público? (utilizar ofuscação para evitar spam)",
"Does your mail reader need a special charset" => "Se o seu leitor de correio necessita de uma codificação de caracteres específica",
"Percentage completed" => "Percentagem de realização",
"Completed" => "Realizada",
"No tasks entered" => "Nenhuma tarefa cadastrada",
"Status:" => "Estado:",
"Monthly" => "Mensalmente",
"Add Watch" => "Adicionar notificação",
"A user submits an article" => "Um utilizador submeteu um artigo",
"May need to refresh twice to see changes" => "Pode ser necessário actualizar duas vezes para ver as alterações",
"Add top level bookmarks to menu" => "Adicionar bookmarks de nível superior ao menu",
"Add or edit an item" => "Adicionar ou editar um item",
"New Window" => "Nova janela",
"replace window" => "substituir a janela",
"User_versions_for" => "Versões_de_utilizador_para",
"This page is being edited by" => "Esta página está a ser editada por",
"Proceed at your own peril" => "Prossiga por conta",
"expires:" => "expira:",
"Banner stats" => "Estatísticas de Banner",
"Create new banner" => "Criar um novo banner",
"Banner Information" => "Informação do Banner",
"Click ratio" => "Taxa de cliques",
"Hours" => "Horas",
"Weekdays" => "Dias de semana",
"mon" => "seg",
"tue" => "ter",
"wed" => "qua",
"thu" => "qui",
"fri" => "sex",
"sat" => "sáb",
"sun" => "dom",
"Banner raw data" => "Dados em bruto do Banner",
"Cached" => "Em cache",
"This is a cached version of the page." => "Esta é uma versão em cache da página.",
"Click here to view the Google cache of the page instead." => "Clique aqui para ver, ao invés, a cache do Google.",
"Forum List" => "Lista de Fóruns",
"Edit Forum" => "Editar Fórum",
"Summary" => "Sumário",
"for links" => "para hiperligações",
"HTML tags are not allowed inside posts" => "Não são permitidas HTML tags dentro de posts",
"Moderator Actions" => "Acções de moderador",
"Move Selected Topics" => "Mover os tópicos selecionados",
"Unlock Selected Topics" => "Desbloquear os tópicos selecionados",
"Lock Selected Topics" => "Bloquear os tópicos selecionados",
"Delete Selected Topics" => "Eliminar os tópicos selecionados",
"Merge" => "Fundir",
"Merge Selected Topics" => "Fundir os tópicos selecionados",
"Reported Messages:" => "Mensagens assinaladas:",
"Queued Messages:" => "Mensagens em fila:",
"Merge into topic" => "Fundir no tópico",
"Announce" => "Anúncio",
"Hot" => "Quente",
"No topics yet" => "Nenhum tópico criado",
"Jump to forum" => "Saltar para o fórum",
"All posts" => "Todas as mensagens",
"Last hour" => "Última hora",
"Last 24 hours" => "Últimas 24 horas",
"Last 48 hours" => "Últimas 48 horas",
"prev topic" => "tópico anterior",
"next topic" => "próximo tópico",
"Show posts" => "Exibir publicações",
"Monitor" => "Monitorizar",
"Insert New Item" => "Inserir novo item",
"Tracker Items" => "itens do acompanhamento",
"Insert new item" => "Inserir novo item",
"View Item" => "Visualizar item",
"Add a Comment" => "Adicionar um comentário",
"close" => "fechar",
"Show All" => "Mostrar Tudo",
"Clip" => "clip",
"Back To Mailbox" => "retornar à lista de mensagens",
"Full Headers" => "cabeçalhos completos",
"Normal Headers" => "cabeçalhos comuns",
"Reply To All" => "responder a todos",
"Forward" => "remeter",
"Cc" => "CC",
"Select from address book" => "seleccionar da agenda de endereços",
"Use HTML mail" => "Usar e-mail HTML",
"The following addresses are not in your address book" => "Os seguintes endereços não estão na sua agenda de endereços",
"Add Contacts" => "Adicionar contatos",
"Attachment 1" => "Anexo 1",
"Attachment 2" => "Anexo 2",
"Attachment 3" => "Anexo 3",
"Address book" => "Agenda de endereços",
"as Creator &amp; Last Editor" => "como Criador &amp; Último Editor",
"no (disabled)" => "Não (desactivado)",
"Save Minor Edit" => "Menor",
"Administration" => "Administração",
"Enable/disable Tiki features here, but configure them elsewhere" => "Active/desactive funcionalidades do Tiki aqui. A configuração será noutra página.",
"General preferences and settings" => "Configurações e definições gerais",
"User registration, login and authentication" => "Registo de utilizadores, login e autenticação",
"Wiki settings" => "Configurações Wiki",
"Article/CMS settings" => "Definições de Artigos/CMS",
"Poll comments settings" => "Configurações de comentários de Votação",
"Forums settings" => "Configurações de fóruns",
"FAQ comments settings" => "Definições dos comentários nas FAQs",
"Directory settings" => "Definições do Directório",
"Meta Tags settings" => "Configuração das Meta Tags",
"Search settings" => "Configurações de pesquisa",
"Community settings" => "Definições da Comunidade",
"Calendar settings" => "Definições do Calendário",
"Text area" => "Caixas de texto",
"Upload failed" => "O upload falhou",
"All posted" => "Todas as mensagens enviadas",
"Queue anonymous posts" => "Enfileirar mensagens anónimas",
"Queue all posts" => "Enfileirar todas as mensagens",
"No attachments" => "Sem ficheiros anexados",
"Everybody can attach" => "Todos podem anexar",
"Only users with attach permission" => "Apenas utilizadores com permissão de anexar",
"Moderators and admin can attach" => "Moderadores e admin podem anexar",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Nota (desc)",
"Replies (desc)" => "Respostas (desc)",
"Reads (desc)" => "Leituras (desc)",
"You have to provide a hotword and a URL" => "Deve fornecer uma <<hotword>> e uma URL",
"Owner" => "Dono",
"Detected, Version:" => "Detectado, Versão:",
"Not detected." => "Não detectado.",
"Your admin password has been changed" => "A sua palavra-passe de administrador foi alterada",
"All Fields except gdaltindex must be filled" => "Todos os campos excepto gdaltindex devem ser preenchidos",
"Tag already exists" => "O tag já existe",
"Tag not found" => "Tag não encontrado",
"Repository name can't be an empty" => "Nome do Repositório não pode ser vazio",
"Requested action is not supported on repository" => "A acção solicitada não é suportada em repositórios",
"No repository" => "Sem repositório",
"Search is mandatory field" => "Procura é um campo obrigatório",
"File not found " => "Ficheiro não encontrado ",
"Requested action in not supported on repository" => "acção de pedido não é suportada no repositório",
"Non-existent link" => "Link inexistente",
"No menu indicated" => "Nenhum menu foi indicado",
"No newsletter indicated" => "Nenhum comunicado foi indicado",
"A user registers" => "Um utilizador se registou",
"Any wiki page is changed" => "Qualquer página wiki é alterada",
"No poll indicated" => "Nenhuma sondagem foi indicada",
"unsafe" => "inseguro",
"safe" => "seguro",
"risky" => "arriscado",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "Impossível verificar se upload_tmp_dir é acessível pelo servidor web. Verifique as configurações do seu servidor web.",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen poderá ser utilizado para fazer upload de dados remotos ou mesmo scripts. Se não utiliza a funcionalidade de blogs, poderá desactivar esta opção.",
"This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "Este ficheiro não pertence ao Tikiwiki. Verifique se o ficheiro foi carregado por upload e se representa perigo.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Este ficheiro foi modificado. Foi impossível verificar a versão. Assegure-se de que não representa perigo.",
"This file is from another Tikiwiki version: " => "Este ficheiro pertence a uma versão diferente do Tikiwiki: ",
"Permission denied. You cannot view this page." => "Permissão negada, você não pode ver esta página",
"Permission denied you cannot edit this page" => "Permissão negada: você não pode editar esta página",
"You must specify a page name, it will be created if it doesn't exist." => "Deve especificar um nome de página, será criada se não existir.",
"page not added (Exists)" => "página não adicionada (pré-existente)",
"No survey indicated" => "Nenhuma pesquisa foi indicada",
"No Errors detected" => "Não foram detectados erros",
"No tracker indicated" => "Nenhum acompanhamento foi indicado",
"Group already exists" => "Grupo já existente",
"User doesn't exist" => "O utilizador não existe",
"No records were found. Check the file please!" => "Nenhum registo encontrado. Por favor, verifique o ficheiro.",
"User login is required" => "O login do utilizador é obrigatório",
"Password is required" => "A palavra-passe é obrigatória",
"Email is required" => "O endereço de e-mail é obrigatório",
"User is duplicated" => "Utilizador duplicado",
"Created account %s <%s>" => "Conta criada %s <%s>",
"Assigned %s in group %s" => "Atribuído %s ao grupo %s",
"User %s already exists" => "Utilizador %s já existe",
"User login contains invalid characters" => "Nome de utilizador contém caracteres inválidos",
"%s modified successfully." => "%s alterada com êxito.",
"password" => "palavra-passe",
"rss feed disabled" => "campo rss desactivado",
"Last articles." => "Últimos artigos.",
"Unassign perm %s from group %s" => "Remover permissão %s do grupo %s",
"Unknown group" => "Grupo desconhecido",
"Group doesn't exist" => "O grupo não existe",
"You have to indicate a group" => "Tem que indicar um grupo",
"This group is invalid" => "Este grupo é inválido",
"Permission denied you cannot view backlinks for this page" => "Permissão negada: você não pode ver referências a esta página",
"The page cannot be found" => "A página não pôde ser encontrada",
"Invalid directory name" => "Nome de directório inválido",
"It isn't possible to post in any blog. You may need to create a blog first." => "Você não pode escrever em nenhum blog: talvez você deva criar um blog antes",
"Permission denied you cannot post" => "Permissão negada: você não pode enviar mensagens",
"Permission denied you cannot edit this post" => "Permissão negada: você não pode editar esta mensagem",
"Top visited blogs" => "Blogs mais visitados",
"Last posts" => "Últimas mensagens",
"Top active blogs" => "Blogs mais ativos",
"No blogId specified" => "Nenhum ID de blog especificado",
"Permission denied you cannot access this gallery" => "Permissão negada: você não pode aceder esta galeria",
"No gallery indicated" => "Nenhuma galeria foi indicada",
"Permission denied you can not view this section" => "Permissão negada: você não pode ver esta secção",
"Permission denied you cannot remove images from this gallery" => "Permissão negada: você não pode remover imagens desta galeria",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Permissão negada: você não pode recriar miniaturas nesta galeria",
"Permission denied you cannot rotate images in this gallery" => "Permissão negada: você não pode rodar imagens nesta galeria",
"No image indicated" => "Nenhuma imagem foi indicada",
"Permission denied you cannot move images from this gallery" => "Permissão negada: você não pode mover imagens desta galeria",
"Permission denied you cannot view the calendar" => "Permissão negada: você não pode visualizar o calendário",
"event without name" => "evento sem nome",
"You can not use the same password again" => "Esta palavra-passe não pode ser novamente utilizada",
"Top authors" => "Autores mais produtivos",
"Message sent to" => "Mensagem enviada para",
"This feature has been disabled" => "Esta funcionalidade foi desabilitada",
"Must enter a name to add a site. " => "Deve introduzir um nome para adicionar um site. ",
"Must enter a url to add a site. " => "Deve introduzir um URL para adicionar um site. ",
"URL already added to the directory. Duplicate site? " => "O URL já existe no directório. Duplicar o site? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "O URL não pode ser acedida. URL errada ou o site está offline e não pode ser adicionado ao directório. ",
"Must select a category. " => "Seleccione uma categoria. ",
"Must enter a name to add a site" => "Digite um nome para o site",
"Must enter a url to add a site" => "Digite um endereço para o site",
"URL already added to the directory. Duplicate site?" => "URL já presente no directório. Site duplicado?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL não pode ser acedida: URL errada ou o site está offline e não pode ser adicionado ao directório",
"Must select a category" => "É preciso seleccionar uma categoria",
"No site indicated" => "Nenhum site indicado",
"Article not found" => "Artigo não encontrado",
"Permission denied you cannot edit this article" => "Permissão negada: você não pode editar este artigo",
"You do not have permissions to edit banners" => "Você não possui permissão de editar banners",
"Banner not found" => "Banner não encontrado",
"You do not have permission to edit this banner" => "Você não possui a permissão para editar este banner",
"Permission denied you cannot create or edit blogs" => "Permissão negada: você não pode criar ou editar blogs",
"Permission denied you cannot edit this blog" => "Permissão negada: você não pode editar este blog",
"You do not have permission to write the style sheet" => "Você não tem permissão para editar a style sheet",
"Invalid request to edit an image" => "Requisição inválida para editar uma imagem",
"Permission denied you cannot edit images" => "Permissão negada: você não pode editar imagens",
"Permission denied you can edit images but not in this gallery" => "Permissão negada: você pode editar imagens, mas não nesta galeria",
"Failed to edit the image" => "Falha ao tentar editar a imagem",
"Permission denied to use this feature" => "Permissão negada para usar esta funcionalidade.",
"Shortname must be 2 Characters" => "O nome abreviado deve ter 2 caracteres",
"You must provide a longname" => "Você tem que fornecer um nome completo",
"Language created" => "Língua criada",
"No content id indicated" => "Não foi indicado um id de conteúdo",
"No question indicated" => "Nenhuma questão indicada",
"No quiz indicated" => "Nenhum teste indicado",
"No structure indicated" => "Nenhuma estrutura indicada",
"Invalid structure_id or page_ref_id" => "structure_id inválida ou page_ref_id",
"Permission denied you cannot send submissions" => "Permissão negada: você não pode enviar artigos",
"Permission denied you cannot edit submissions" => "Permissão negada: você não pode editar artigos pendentes",
"You have to create a topic first" => "Você deve criar um tópico antes de prosseguir",
"You do not have permission to do that" => "Você não possui a permissão necessária",
"You do not have permission to read the template" => "Você não possui a permissão de ler o padrão",
"No topic id specified" => "Nenhum ID de tópico especificado",
"Invalid topic id specified" => "ID de tópico especificado inválido",
"page imported" => "página importada",
"created from import" => "criada a partir de uma importação",
"Can't import remote HTML page" => "Não é possível importar página HTML remota",
"The SandBox is disabled" => "A Sandbox está desabilitada",
"Cannot edit page because it is locked" => "A página não pode ser editada enquanto estiver travada",
"Permission denied you cannot edit this file" => "Permissão negada: você não pode editar este ficheiro",
"Permission denied you cannot remove files from this gallery" => "Permissão negada: você não pode remover ficheiros desta galeria",
"Top visited file galleries" => "Galerias de ficheiro mais visitadas",
"Most downloaded files" => "Ficheiros mais baixados",
"Last files" => "Ficheiros recentes",
"No galleryId specified" => "Nenhum ID de galeria especificado",
"No forum indicated" => "Nenhum fórum indicado",
"Last forum topics" => "Últimos tópicos de fóruns",
"Top topics" => "Tópicos mais discutidos",
"Forum posts" => "Mensagens do Fórum",
"No forumId specified" => "Nenhum ID de fórum especificado",
"first uploaded image" => "primeira imagem carregada",
"last uploaded image" => "última imagem carregada",
"first image" => "primeira imagem",
"last image" => "última imagem",
"random image" => "imagem aleatória",
"Permission denied you cannot create galleries and so you cant edit them" => "Permissão negada: você não pode criar galerias ou editá-las",
"Permission denied you cannot edit this gallery" => "Permissão negada: você não pode editar esta galeria",
"Permission denied you cannot remove this gallery" => "Permissão negada: você não pode remover esta galeria",
"Top images" => "Imagens mais populares",
"Last images" => "Imagens recentes",
"Last images uploaded to the image galleries." => "Últimas imagens carregadas para as galerias de imagem",
"overwriting old page" => "sobrescrevendo página antiga",
"page created" => "página criada",
"No name indicated for wiki page" => "Nome não indicado para a página Wiki",
"No repository given" => "Nenhum repositório assinalado",
"Permission denied. You cannot view pages like this page" => "Permissão negada: você não pode ver páginas como esta",
"Permission denied you cannot remove articles" => "Permissão negada: você não pode remover artigos",
"Permission denied you cannot remove banners" => "Permissão negada: você não pode remover banners",
"Permission denied you cannot remove this blog" => "Permissão negada: você não pode remover este blog",
"Non-existent gallery" => "Galeria inexistente",
"Permission denied you can upload files but not to this file gallery" => "Permissão negada: você pode carregar ficheiros mas não nesta galeria de ficheiros",
"Could not upload the file" => "Não é possível carregar o ficheiro",
"Permission denied you can't upload files so you can't edit them" => "Permissão negada: você não pode carregar ficheiros, de modo que não pode editá-los",
"You cannot admin blogs" => "Você não pode administrar blogs",
"Permission denied you cannot remove submissions" => "Permissão negada: você não pode remover assinaturas",
"Permission denied you cannot approve submissions" => "Permissão negada: você não pode aprovar assinaturas",
"You have to enable cookies to be able to login to this site" => "Deve activar os cookies para se autenticar neste site",
"You do not have permissions to view the maps" => "Não possui permissões para ver os mapas",
"mapfile name incorrect" => "nome do ficheiro de mapa incorrecto",
"This mapfile already exists" => "Este ficheiro de mapa já existe",
"You do not have permission to write to the mapfile" => "Não tem permissão para escrever no ficheiro de mapa",
"You do not have permission to delete the mapfile" => "Não tem permissão para remover o ficheiro de mapa",
"You do not have permission to read the mapfile" => "Não tem permissão para ler o ficheiro de mapa",
"You do not have permissions to view the layers" => "Não tem permissão para ver as camadas",
"You do not have permissions to delete a file" => "Não tem permissão para remover o ficheiro",
"File not found" => "Ficheiro não encontrado",
"You do not have permissions to create a directory" => "Não tem permissão para criar um directório",
"The Directory is not empty" => "O directório não está vazio",
"You do not have permissions to delete a directory" => "Não tem permissão para remover um directório",
"You do not have permissions to create an index file" => "Não tem permissão para criar um ficheiro índice",
"Invalid file name" => "Nome de ficheiro inválido",
"Invalid files to index" => "Ficheiros inválidos para índice",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Eu não sei onde está o gdaltindex. Configure correctamente a funcionalidade de mapa",
"I could not create the index file" => "Não consigo criar o ficheiro de índice",
"Must be logged to use this feature" => "Você deve se logar para usar esta funcionalidade",
"Welcome at Hawiki" => "Bem-vindo(a) a Hawiki",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Este site Tikiwiki está preparado para ser acessado de uma gama de dispositivos móveis, como celulares WAP, PDAs, dispositivos i-mode e muitos outros.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Você pode navegar neste site com seu dispositivo móvel apontando o browser dele para o seguinte endereço deste site:",
"About" => "Sobre",
"You must log in to use this feature" => "Você deve se logar para usar esta funcionalidade",
"You do not have permission to view other users data" => "Você não possui permissão para ver dados de outros utilizadores",
"You must be logged in to subscribe to newsletters" => "Você precisa se logar para assinar os comunicados",
"No note indicated" => "Nenhuma nota indicada",
"merged note:" => "nota composta:",
"File is too big" => "O ficheiro é grande demais",
"No item indicated" => "Nenhum item indicado",
"created from notepad" => "criado a partir do Bloco de Notas",
"Page already exists" => "Página já existe",
"Not enough information to display this page" => "Informações insuficientes para exibir esta página",
"Permission denied you cannot browse this page history" => "Permissão negada: você não pode visualizar o histórico desta página",
"No article indicated" => "Nenhum artigo indicado",
"Article is not published yet" => "Artigo ainda não foi publicado",
"No post indicated" => "Nenhuma mensagem indicada",
"Blog not found" => "Blog não encontrado",
"No pages indicated" => "Nenhuma página indicada",
"No result indicated" => "Nenhum resultado indicado",
"The passwords don't match" => "A palavra-passe não confere",
"Invalid or unknown username" => "Utilizador desconhecido ou inválido",
"A password reminder email has been sent " => "Um lembrete da palavra-passe foi enviado",
"to the registered email address for" => "para o endereço de email registrado para",
"last version" => "última versão",
"Permission denied you cannot remove versions from this page" => "Permissão negada: você não pode remover versões desta página",
"Cannot rename page maybe new page already exists" => "Impossível renomear a página: talvez já exista uma página com este nome",
"Non-existent version" => "Versão inexistente",
"Permission denied you cannot rollback this page" => "Permissão negada: você não pode restaurar esta página",
"successfully sent" => "enviada com sucesso",
"not sent" => "não enviada",
"Error: " => "Erro: ",
"Notice: this variable may not be empty:" => "Aviso: esta variável tem de ser preenchida:",
"Notice: invalid variable value:" => "Aviso: valor de variável inválido:",
"Page must be defined inside a structure to use this feature" => "A página tem que ser definida dentro de uma estrutura para o uso desta funcionalidade",
"You cannot take this quiz twice" => "Você não pode fazer este teste mais de uma vez",
"Quiz time limit exceeded quiz cannot be computed" => "Limite de tempo do teste atingido: o teste não será calculado",
"You cannot take this survey twice" => "Você não pode responder a esta pesquisa mais de uma vez",
"Please create a category first" => "Por favor, seleccione antes uma categoria",
"No permission to upload zipped file packages" => "Sem permissão para carregar ficheiros zipados",
"Error processing zipped image package" => "Erro tentando processar ficheiro zipado de imagem",
"No permission to upload zipped image packages" => "Sem permissão para carregar ficheiros zipados de imagem",
"Permission denied you cannot upload images" => "Permissão negada: você não pode carregar imagens",
"Permission denied you can upload images but not to this gallery" => "Permissão negada: você pode carregar imagens mas não nesta galeria",
"Cannot get image from URL" => "Impossível obter a imagem a partir do endereço",
"That is not an image (or you have php < 4.0.5)" => "Isto não é uma imagem (ou tem o PHP < 4.0.5)",
"Usage" => "Utilizacao",
"No url indicated" => "Nenhum endereço indicado",
"Unknown user" => "Utilizador desconhecido",
"You are not logged in and no user indicated" => "Você não está logado e nenhum utilizador foi indicado",
"The user has chosen to make his information private" => "O utilizador decidiu manter sua informação privada",
"The passwords did not match" => "As palavras-passe não coincidem",
"no" => "não",
"Cannot upload this file not enough quota" => "Impossível carregar este ficheiro: cota máxima atingida",
"No user indicated" => "Nenhum utilizador indicado",
"Non-existent user" => "Utilizador inexistente",
"No banner indicated" => "Nenhum banner indicado",
"No blog indicated" => "Nenhum blog indicado",
"Permission denied you cannot remove the post" => "Permissão negada: você não pode remover a mensagem",
"No cache information available" => "Informação de cache não disponível",
"No faq indicated" => "Nenhum faq indicado",
"You are not permitted to remove someone else\\'s post!" => "Não tem permissão para remover as publicações de outros!",
"No thread indicated" => "Nenhuma sequência indicada",
"Aborted" => "Abortado",
"Top pages" => "Páginas mais populares",
"Last pages" => "Páginas recentes",
"###end###"=>"###end###");
