<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"Links/Commands" => "Ссылки/Команды",
"create tag" => "создать метку",
"Anonymous users can edit pages" => "Гостям можно редактировать страницы",
"User versions" => "Пользовательские версии",
"TextFormattingRules" => "ПравилаФорматированияТекста",
"References" => "Ссылки",
"JoinCapitalizedWords" => "СлепитьСловаСЗаглавнойБуквы",
"or use square brackets for an" => "или используйте квадратные скобки для",
"link_description" => "описание_ссылки",
"Title_bar" => "Заголовок",
"img" => "img",
"printable" => "для печати",
"History of" => "История для",
"current_version" => "текущая_версия",
"All pages" => "Все страницы",
"Rollback_page" => "Страницы_отката",
"last_login" => "последний_вход",
"assign group" => "назначить группу",
"Create or edit a gallery using this form" => "Создайте или измените галерею с помощью этой формы",
"versions" => "версии",
"Perm" => "Права",
"No individual permissions global permissions to all pages apply" => "Нет индивидуальных прав доступа. На всех страницах имеют силу общие права доступа.",
"Assign permissions to this page" => "Назначить права доступа к этой странице",
"ranking" => "Рейтинг",
"list_pages" => "Список_страниц",
"my galleries" => "Мои галереи",
"You can include the image in an HTML/Tiki page using" => "Вы можете включить изображение в HTML/Tiki страницу с помощью",
"modules" => "модули",
"links" => "ссылки",
"system gallery" => "системная галерея",
"Anonymous users cannot edit pages" => "Анонимные посетители не имеют права редактировать страницы",
"Permission denied you cannot browse this gallery" => "У Вас недостаточно прав для просмотра этой галереи",
"view info" => "просмотр инфо",
"HasImg" => "HasImg",
"UseImg" => "UseImg",
"User preferences screen" => "Экран пользовательских настроек",
"The SandBox is a page where you can practice your editing skills, use the preview feature\nto preview the appearance of the page, no versions are stored for this page." => "Песочница - это страница,\nгде Вы можете попрактиковаться в создании реальных страниц. Для Песочницы не сохраняются версии и не\nконтролируются права доступа.",
"Configure this page" => "Настроить эту страницу",
"hotwords" => "горячие слова",
"user preferences" => "личные настройки",
"No image uploaded" => "Изображение не загружено",
"Current version" => "Текущая версия",
"Next version" => "Следующая версия",
"Programmed versions" => "Запрограммированные версии",
"Old versions" => "Старые версии",
"Edit desc" => "Правка описания",
"Index page" => "Страница индекса",
"Set prefs" => "Установка параметров",
">Remove Zones (you lose entered info for the banner)" => ">Удалить Области (будет потеряна введённая информация о баннере)",
">Block description: " => ">Описание блока: ",
"Admin content" => "Админ. содержимое",
"Warn on edit" => "Предупреждать при редактировании",
"Show comments" => "Показать комментарии",
"Hide comments" => "Скрыть комментарии",
"reply to this" => "ответить на это",
"Create or edit a file gallery using this form" => "Создайте или измените файловую галерею используя эту форму",
"Top Files" => "Лучшие файлы",
"Cannot get file from URL" => "Не удалось получить файл по URL",
"You cant download files" => "У Вас недостаточно прав для скачивания файлов",
"No file" => "Файл не существует",
"Create/edit Forums" => "Создание/правка Форумов",
"Moderator" => "Модератор",
"Cms" => "Cms",
"There are inddividual permissions set for this gallery" => "Для этой галереи заданы индивидуальные права доступа",
" modified" => " изменено",
"Show Post Form" => "Показать форму отправки сообщения",
"Hide Post Form" => "Скрыть форму отправки сообщения",
"smileys" => "смайлики",
"Edit or add category" => "Добавить/изменить категорию",
"sub categories" => "подкатегории",
"There are inddividual permissions set for this blog" => "Для этого блога заданы индивидуальные права доступа",
"Layout options" => "Расположение на странице",
"polls" => "опросы",
"features" => "возможности",
"cms" => "управление контентом",
"CMS settings" => "Настройки CMS",
"image galleries" => "фотогалереи",
"general" => "общие",
"Set home forum" => "Задать главный форум",
"file galleries" => "файловые галереи",
"rss" => "rss",
"Set feeds" => "Установить потоки",
"There are inddividual permissions set for this file gallery" => "Для этой файловой галереи были заданы индивидуальные права доступа",
"half a second" => "пол-секунды",
"Create/edit RSS module" => "Создать/изменить RSS модуль",
"Create/edit Menus" => "Создать/изменить меню",
"Admin chat" => "Управлять чатом",
"Permission denied you cant view this section" => "У Вас недостаточно прав для просмотра этой секции",
"use square brackets for an" => "используйте квадратные скобки для",
"Allowed HTML:" => "Позволено HTML:",
"Configure modules" => "Параметры модулей",
"to insert a random tagline" => "для вставки случайной приписки",
"Use (:name:) for smileys" => "Используйте (:название:) для смайликов",
"Restoring a backup destoys all the data in your Tiki database.\nAll your tables will be replaced with the information in the backup." => "Восстановление из резервной копии уничтожит все данные в Вашей базе.\nВсе таблицы будут заменены информацией из резервной копии",
"Creating backups may take a long time. If the process is not completed you will\nsee a blank screen. If so you need to increment the maximum script execution time\nfrom your php.ini file" => "Создание резервной копии займет некоторое время. Если процесс не будет успешно завершён, вы увидите\nпустой экран. В таком случае вам потребуется увеличить максимальное время исполнения скрипта\nв вашем php.ini файле",
"Click here to create a new backup" => "Нажмите здесь для создания новой резервной копии",
"Create/edit Faq" => "Создать/редактировать ЧаВо",
"FAQ Questions" => "Вопросы ЧаВо",
"FAQ Answers" => "Ответы ЧаВо",
">I forgot my password" => ">Я забыл пароль",
"column" => "колонка",
"Show chart for the last " => "Показать график за последние ",
"days (0=all)" => "дней (0=показать все)",
"dispay" => "показать",
"Average posts pero weblog" => "В среднем сообщений на 1 блог",
"user bookmarks" => "закладки",
"Admin Cookies" => "Настройка Cookies",
"Entire site" => "Весь сайт",
"content templates" => "шаблоны содержимого",
"shoutbox" => "кричалка",
"drawings" => "рисунки",
"assigned" => "назначено",
"Hotwords in new window" => "Ключевые слова в новом окне",
"Allow smileys" => "Позволить смайлики",
"Reuse question" => "Использовать вопрос повторно",
"suggested" => "предложенный",
"wiki link" => "wiki ссылка",
"heading2" => "заголовок 2",
"heading3" => "заголовок 3",
"Show suggested questions/suggest a question" => "Показать предложенные вопросы/продложить вопрос",
"Hide suggested questions" => "Скрыть предложенные вопросы",
"Create/edit templates" => "Создавать/редактировать шаблоны",
"categorize" => "задать категорию",
"Create/edit HTML pages" => "Создать/редактировать HTML страницы",
"Admin HTML page dynamic zones" => "Управлять динамическими зонами HTML страницы",
"Edit this HTML page" => "Редактировать HTML страницу",
"Wiki Import dump" => "Дамп импорта Wiki",
"trckrs" => "трекеры",
"frms" => "форумы",
"gral" => "общ",
"feat" => "возм",
"Server time zone" => "Часовая зона сервера",
"Wiki Page Names" => "Имена страниц Wiki",
"strict" => "строгие",
"file gls" => "файл.гал.",
"img gls" => "фотогал.",
"webmail" => "вебпочта",
"Allow viwing HTML mails?" => "Позволить просмотр HTML писем?",
"Add users" => "Добавить пользователей",
"Users can subscribe any email addresss" => "Пользователи могут подписывать любой адрес",
"Create/edit surveys" => "Создать/изменить анкеты",
"Options (separated by commas used in dropdowns only)" => "Опции (через запятую, только для выпадающих списков)",
"There are inddividual permissions set for this tracker" => "Для этого трекера заданы особые права доступа",
"Show status when listing tracker items?" => "Показывать статус при выводе элементов трекера?",
"Prevents parsing data" => "Запрещает разбор анализатором Ваших данных",
"b" => "b",
"i" => "i",
"ul" => "ul",
"tbl" => "tbl",
"a" => "a",
"h1" => "h1",
"h2" => "h2",
"h3" => "h3",
"dcs" => "dcs",
"center" => "center",
"img nc" => "img nc",
"chars" => "симв.",
"In parent page" => "На родительской странице",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "Песочница - это страница, где Вы можете попрактиковаться в создании достойных страниц. Для Песочницы не сохраняются версии и не контролируются права доступа.",
"Path to where the dumped files are" => "Путь, куда свалить дамп",
"Thanks for your subscription. You will receive an email soon to confirm your subscription.\nNo newsletters will be sent to you until the subscription is confirmed." => "Спасибо, что подписались на рассылку. Вы должны получить email с просьбой подтвердить подписку.\nВы не получите ни одной рассылки, пока не подтвердите своё желание в ней участвовать.",
"checked" => "отмеченные",
"unchecked" => "неотмеченные",
"Mark as Flagged" => "Отметить флажками",
"Add or edit a category" => "Добавить/редактировать категорию",
"You cant use the same password again" => "Вы не можете использовать тот же пароль, его следует сейчас сменить",
"You have to provide a name to the file" => "Следует указать имя файла",
"parent" => "родитель",
"userfiles" => "файлы пользователя",
"Cache wiki pages" => "Кешировать страницы Wiki",
"Users can save pages to notepad" => "Пользователи могут сохранять страницы в блокнот",
"\n for rows" => "\n для строк",
"Forum settings" => "Настройки форума",
"Allow wiki markup" => "Включить разметку wiki",
"Describe topics in listing" => "Описывать темы в перечне",
"Allow viewing HTML mails" => "Включить просмотр HTML писем",
"subs" => "subs",
"objs" => "объекты",
"Admin content templates" => "Управлять шаблонами содержимого",
"Edit drawings &amp; pictures" => "Редактировать рисунки и изображения",
"Edit/Create user module" => "Создать/редактировать пользовательский модуль",
"assign_perms" => "дать права",
"rotate left" => "сдвинуть влево",
"Klick to enlarge" => "Нажмите чтобы увеличить",
"use filename" => "использовать имя файла",
"Use dbl click to edit pages" => "Двойное нажатие на страницу переходит в редактор",
"Mailin accounts" => "Учётные записи по приёму почты",
"Return to messages" => "Вернуться к сообщениям",
"Unflagg" => "Снять флажок",
"Newss from" => "Новости из",
"Control by Object" => "Управление по объектам",
"Control by category" => "Управлять по категории",
"Create/edit extwiki" => "Создать/редактировать внешние Wiki",
"URL (use  to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=)" => "URL (Используйте  чтобы заменить именем страницы URL пример: http://www.example.com/tiki-index.php?page=)",
"Admin (click!)" => "Админ (нажми!)",
"Mus enter a name to add a site" => "Следует ввести название, чтобы добавить сайт",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "URL недоступен - неверный URL или сайт не подключен к интернету - проверьте опечатки и попробуйте позже",
"Users can vote only one item from this chart per period" => "Пользователи могут голосовать только один раз за период",
"Prevent users from voting same item more than one time" => "Не позволять пользователем голосовать больше одного раза по одному и тому же пункту",
"You will receive an email with your password soon" => "Скоро вы получите письмо с вашим паролем",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Отображает участок кода.\nУстановите необязательный параметр -+ln+- в 1 для отображения номеров строк.",
"Renders a graph" => "Сформировать график",
"PluginsHelp" => "Помощь по плагинам",
"create new empty structure" => "создать новую пустую структуру",
"Create structure from tree" => "создать структуру из дерева",
"Admin structures" => "Административная структура",
"Click twice if once is not enough !" => "Кликните дважды если одного раза недостаточно !",
"Toggle display of comment zone" => "Включить отображение комментариев",
"In blog listing show user as" => "В блогах показывать пользователя как",
"creation date" => "дата создания",
"last modification time" => "время последнего изменения",
"Articles listing configuration" => "Настройка списка статей",
"Edit css" => "Редактировать css",
"Use PHPOpenTracker" => "Использовать PHPOpenTracker",
"User watches" => "Пользовательские метки",
"PDF Export" => "PDF экспорт",
"Edit drawings" => "Редактировать рисунок",
"Threads can be voted" => "Голосование за ветвь обсуждения",
"Forward messages to this forum to this email" => "Перенаправлять сообщения в форуме на этот email",
"Directory (include trailing slash)" => "Directory (include trailing slash)",
"stat" => "стат.",
"Calendars Panel" => "Панель календарей",
"Navigation Panel" => "Панель навигации",
"Hide Panels" => "Прятать панели",
"hide from display" => "прятать с экрана",
"Tiki Calendars" => "Календари Tiki",
"browse by" => "просмотреть за",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose).",
"from the list" => "из списка",
"choose" => "выберите",
"You should first ask that a calendar is created, so you can create events attached to it." => "Прежде чем можно будет создавать в нем события, убедитесь, что календарь создан.",
"save a custom copy" => "сохранить свою копию",
"heading" => "заголовок",
"horizontal ruler" => "горизонтальная линия",
"acvtivate" => "активировать",
"op" => "оп",
"remove bookmark" => "удалить закладку",
"Tiki forums" => "Форумы Tiki",
"mot" => "mot",
"this post was reported" => "this post was reported",
"report this post" => "report this post",
"someone from" => "кто-то с",
"since this is our registered email address we inform that the" => "т.к. этот адрес зарегистрирован у нас, мы высылаем на него уведомление о том, что",
"If you want to be a registered user in this site you will have to use" => "Если вы желаете зарегистрироваться на этом сайте, используйте",
"the following link to login for the first time" => "следующую ссылку для входа в систему в первый раз",
"More info about" => "Подробнее о",
"idle" => "idle",
"MyTiki (click!)" => "MyTiki (click!)",
"blog_ranking_top_blogs" => "blog_ranking_top_blogs",
"blog_ranking_last_posts" => "blog_ranking_last_posts",
"blog_ranking_top_active_blogs" => "blog_ranking_top_active_blogs",
"filegal_ranking_top_galleries" => "filegal_ranking_top_galleries",
"filegal_ranking_top_files" => "filegal_ranking_top_files",
"filegal_ranking_last_files" => "filegal_ranking_last_files",
"gal_ranking_top_galleries" => "gal_ranking_top_galleries",
"gal_ranking_top_images" => "gal_ranking_top_images",
"gal_ranking_last_images" => "gal_ranking_last_images",
"Your Tiki account information for" => "Ваша информация об аккаунте Tiki",
"A new password has been sent " => "Новый пароль был отправлен ",
" new topic:" => " новая тема:",
"topic:" => "тема:",
"Current page:" => "Текущая страница:",
"version %s" => "версия %s",
"last modified on %s" => "последнее изменение %s",
"by %s" => "%s",
"Archived page:" => "Архивная страница:",
"Diff of %s." => "Diff of %s.",
" tags. Example: {tr}The newsletter was sent to {\$sent} email addresses" => " tags. Example: {tr}The newsletter was sent to {\$sent} email addresses",
"New article submitted at " => "Новая статья на ",
"Welcome to " => "Добро пожаловать в ",
" at " => " на ",
"Bye bye from " => "Bye bye from ",
"There is an error in the plugin data" => "Ошибка в данных расширения",
"Change your email" => "Сменить email",
"Could not create user.mif in data directory" => "Невозможно создать user.mif в директории данных",
"Could not create user.mid in data directory" => "Невозможно создать user.mid в директории данных",
"ExtWikis" => "ExtWikis",
"Wiki page" => "Страница Wiki",
"forum topic" => "тема форума",
"updated by the phpwiki import process" => "обновлено процедурой импорта phpwiki",
"created from phpwiki import" => "создано при помощи phpwiki импорта",
"File gals" => "Файл.галереи",
"Image gals" => "Фотогалереи",
"Comm" => "Комментарии",
"comm" => "комментарии",
"assgn" => "назнач.",
"Ranking" => "Рейтинг",
"Add scaled images size X x Y" => "Добавить отмасштабированные изображения размером X x Y",
"Import pages from a PHPWiki Dump" => "Импортировать страницы из дампа PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Путь к файлам дампа (относительно базовой папки Tiki обязательно со слешем в конце, например dump/)",
"ver" => "Версия",
"+1d" => "+1d",
"+7d" => "+7d",
"+1m" => "+1m",
"running" => "running",
"today" => "сегодня",
"act status" => "статус акт",
"All tasks" => "Все задачи",
"mark as done" => "отметить как выполненные",
"open tasks" => "открыть задачи",
"Add or edit a task" => "Добавить или изменить задачу",
"Calendrier" => "Calendrier",
"Height of top Heading" => "Height of top Heading",
"Height of mid Heading" => "Height of mid Heading",
"Height of inner Heading" => "Height of inner Heading",
"tbheight" => "tbheight",
"Ins" => "Ins",
"perm" => "perm",
"You do not have permission to use this feature." => "У вас недостаточно прав для использования этой возможности.",
" line " => " строка ",
"Error: No" => "Ошибка: Нет",
"permission." => "разрешения.",
"Error: Invalid" => "Ошибка: Необоснованный",
"Error: Call to hw_page_fetch_by_id failed!" => "Ошибка: Вызов к hw_page_fetch_by_id не удался!",
"no description" => "без описания",
"Updated" => "Обновленно",
"requested a reminder of the password for the" => "попросил напомнить пароль на",
"password for this account is" => "текущий пароль для аккаунта",
"Blog settings" => "Настройки блога",
"FAQs settings" => "Настройки ЧаВо",
"FAQ comments" => "Комментарии в ЧаВо",
"Remind passwords by email" => "Напоминать пароли по email",
"Poll settings" => "Настройки опросов",
"Create a tag for the current wiki" => "Дать метку текущему wiki",
"Restore the wiki" => "Восстановить wiki",
"Wiki comments settings" => "Настройки комментирования Wiki",
"Wiki page list configuration" => "Настройка списков страниц Wiki",
"Like pages" => "Подобные страницы",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Использовать {literal}{{/literal}ed id=name} или {literal}{{/literal}ted id=name} для внесения динамических зон",
"Added users" => "Добавленные пользователи",
"search category" => "Поиск по категории",
"deep" => "рекурсивно",
"Emphasis" => "Ударение",
"italics" => "курсив",
"both" => "оба",
"use ...page... to separate pages" => "используйте ...page... для разделения страниц",
"make_headings" => "создать_заголовки",
"underlines text" => "подчёркивает текст",
"Simple box" => "Простой прямоугольник",
"Will display using the indicated HTML color" => "Выведет текст используя указанный HTML цвет",
"Will display the text centered" => "Изобразит текст по центру строки",
"Activs" => "Активн",
"time" => "время",
"Wiki quick help" => "Быстрая помощь по Wiki",
"Quicklinks" => "Быстрые ссылки",
"Comparing versions" => "Сравнение версий",
"Actual_version" => "Фактическая_версия",
"Diff to version" => "Отличия от версии",
"Editing tracker item" => "Редактирование элемента трекера",
"The passwords dont match" => "Пароли не совпадают",
"The passwords didn't match" => "Пароли не совпали",
"You do not have permission to write the template" => "У Вас недостаточно прав для записи шаблона",
"specified." => "определения.",
"You have to provide a name to the image" => "Следует дать имя изображению",
"The file you are trying to upload is too big." => "The file you are trying to upload is too big.",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"switch" => "switch",
"ppd" => "ppd",
"add role" => "add role",
"new minor" => "new minor",
"new major" => "new major",
"send instance" => "send instance",
"item" => "item",
"uploaded by" => "закачано",
"not specified" => "не указано",
"There was a problem with your upload." => "Проблема с трансфером.",
"The file you are trying to upload was only partially uploaded." => "Файл, который вы пытаетесь отправить, был отправлен только частично.",
"You must select a file for upload." => "Вы должны выбрать файл для отправки.",
"delete" => "удалить",
"post" => "Новое сообщение",
"stop monitoring this blog" => "прекратить наблюдение",
"posts" => "сообщений",
"visits" => "посещений",
"show categories" => "вывести категории",
"author" => "автор",
"user level" => "уровень пользователя",
"send email to user" => "отослать e-mail пользователю",
"score" => "рейтинг",
"delete selected" => "удалить выбранные",
"move" => "переместить",
"set" => "запомнить",
"replies" => "ответы",
"cancel" => "отмена",
"up" => "выше",
"down" => "ниже",
"add" => "добавить",
"create" => "создать",
"save" => "сохранить",
"send" => "отослать",
"register" => "регистрация",
"standard" => "обычный",
"secure" => "безопасный",
"stay in ssl mode" => "оставаться в безопасном ssl режиме",
"go" => "перейти",
"cache" => "кеш",
"use" => "использовать",
"refresh" => "обновить",
"print" => "печать",
"create pdf" => "создать pdf",
"monitor this page" => "наблюдать за страницей",
"stop monitoring this page" => "остановить наблюдение",
"backlinks" => "обратные ссылки",
"rename" => "переименовать",
"unlock" => "убрать блок",
"lock" => "блокировать",
"perms" => "права",
"history" => "история",
"similar" => "подобные",
"undo" => "откат",
"slides" => "слайды",
"export" => "экспорт",
"discuss" => "обсудить",
"last modification" => "последнее изменение",
"attachments" => "вложения",
"stats" => "стат",
"last changes" => "Последние правки",
"list pages" => "Список страниц",
"cancel edit" => "отменить правку",
"No attachments for this page" => "К данной странице файлы не приложены",
"view blog" => "просмотр блога",
"list blogs" => "список блогов",
"save and exit" => "сохранить и выйти",
"reads" => "прочтений",
"view comments" => "комментарии",
"flag" => "флаг",
"HomePage" => "Домашняя Страница",
"ok" => "да",
"images" => "изображениях",
"Server name (for absolute URIs)" => "Имя сервера (для абсолютных ссылок)",
"Wiki_Tiki_Title" => "Описание Wiki Tiki",
"Require HTTP Basic authentication" => "Требовать HTTP Basic авторизацию",
"HTTP server name" => "Имя веб сервера",
"HTTP URL prefix" => "HTTP приставка к URL",
"HTTPS server name" => "Имя HTTPS сервера",
"HTTPS URL prefix" => "HTTPS приставка к URL",
"Only for users" => "Только для пользователей",
"Users and admins" => "Для пользователей и админов",
"Full Text Search" => "Полнотекстовый поиск",
"full" => "полные",
"Enable Feature" => "Разрешить свойство",
"loc" => "разм.",
"cat" => "кат.",
"lang" => "язык",
"prio" => "приор.",
"permissions" => "права",
"edit chart" => "редактировать чарт",
"update" => "обновить",
"use in cms" => "использовать в cms",
"use in wiki" => "использовать в wiki",
"use in newsletters" => "использовать в рассылке",
"use in HTML pages" => "использовать в HTML страницах",
"last modif" => "посл. правка",
"sections" => "секции",
"upload" => "закачать",
"dsn" => "DSN",
"extwiki" => "внеш.wiki",
"online" => "онлайн",
"topics" => "темы",
"coms" => "комментариев",
"age" => "возраст",
"last post" => "посл. сообщ.",
"position" => "позиция",
"section" => "секция",
"options" => "параметры",
"assign module" => "назначить модуль",
"left modules" => "модули слева",
"right modules" => "модули справа",
"edit/create" => "правка/создание",
"clear cache" => "очистить кеш",
"\n<b>Note 1</b>: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.<br />\n<b>Note 2</b>: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\n<b>Примечание 1</b>: если Вы позволяете пользователям настраивать модули то\nназначенные модули не будут отображены на экране, пока Вы не настроите их\nиз меню MyTiki->Модули.<br />\n<b>Примечание 2</b>: Если Вы назначаете модули для групп, убедитесь, что Вы выключили опцию 'показывать модули для всех групп всегда' в меню\nАдмин->Общие",
"assign" => "назначение",
"left" => "слева",
"right" => "справа",
"order" => "порядок",
"create/edit" => "создание/правка",
"use poll" => "использовать опрос",
"use gallery" => "использовать галерею",
"use dynamic  content" => "использовать динам. содержимое",
"use rss module" => "использовать модуль rss",
"use menu" => "использовать меню",
"use banner zone" => "использовать область",
"list newsletters" => "Список рассылок",
"send newsletters" => "Отослать письма",
"editions" => "редакций",
"last sent" => "последняя отправка",
"use admin email" => "использовать адрес администратора",
"event" => "событие",
"survey stats" => "статистика анкетирования",
"edit this survey" => "правка анкеты",
"admin surveys" => "настройки анкет",
"list surveys" => "список анкет",
"questions" => "вопросов",
"files" => "файлы",
"items" => "элементы",
"version" => "версия",
"admin" => "админ",
"all" => "все",
"Assign user" => "Назначить пользователя",
"List of available backups" => "Список доступных резервных копий",
"Restoring a backup" => "Восстановление резервной копии",
"Warning!" => "Внимание!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Востановление из резервной копии разрушит все данные в Вашей базе данных. Все Ваши таблицы будут заменены данными из резервной копии.",
"Click here to confirm restoring" => "Нажмите здесь для подтверждения восстановления",
"Create new backup" => "Создать новую резервную копию",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "Создание резервной копии может занять продолжительное время. Пока процесс сохранения не завершился, Вы будете видеть чистый экран. Если резервное сохранение прерывается автоматически, Вам может потребоваться увеличить максимальное время работы скрипта в файле php.ini",
"Upload a backup" => "Загрузить резерв",
"Upload backup" => "Загрузить резерв",
"edit gallery" => "правка галереи",
"rebuild thumbnails" => "перестроить иконки",
"upload image" => "Закачать изображение",
"list gallery" => "содержимое галереи",
"original size" => "оригинальный размер",
"return to gallery" => "вернуться в галерею",
"edit image" => "редактировать изображение",
"smaller" => "меньше",
"bigger" => "больше",
"prev image" => "пред. картинка",
"popup window" => "всплывающее окно",
"next image" => "след. картинка",
"stop" => "остановить",
"or create a new category" => "или создайте новую категорию",
"or create a new location" => "или создайте новое расположение",
"comma separated usernames" => "имена пользователей, разделенные запятыми",
"comma separated username:role" => "имя пользователя:статус, разделенные запятыми",
"with roles" => "со статусом",
"Chair" => "Председатель",
"Optional" => "Опционально",
"permission" => "доступ",
"browse" => "просмотр",
"related" => "по теме",
"validate" => "проверить",
"add a site" => "добавить сайт",
"search" => "поиск",
"list articles" => "перечень статей",
"view articles" => "Просмотр статей",
"create zone" => "создать область",
"save the banner" => "сохранить баннер",
"display" => "вывести",
"create new block" => "создать новый блок",
"list quizzes" => "список тестов",
"quiz stats" => "статистика теста",
"edit this quiz" => "редактировать тест",
"admin quizzes" => "Управлять тестами",
"results" => "результаты",
"list submissions" => "Список поступлений",
"new question" => "новый вопрос",
"approve" => "утвердить",
"configure listing" => "настройка списка",
"topic" => "тема",
"save and approve" => "одобрить и сохранить",
"new topic" => "новая тема",
"reject" => "отклонить",
"accept" => "принять",
"add new" => "добавить новую",
"admin processes" => "настройка процессов",
"admin activities" => "настройка активностей",
"admin roles" => "настройка ролей",
"edit this process" => "изменить процесс",
"monitor" => "мониторинг",
"create new gallery" => "создать новую галерею",
"result" => "результат",
"source" => "исходный текст",
"create new blog" => "создать новый блог",
"upload file" => "закачать файл",
"Edit a file using this form" => "Редактировать файл используя форму",
"delete selected files" => "удалить выбранные файлы",
"browse gallery" => "просмотр галереи",
"Flash binary (.sqf or .dcr)" => "Shockwave Flash двоичный (.swf или .dcr)",
"edit blog" => "редактировать блог",
"edit new submission" => "Редактировать новое поступление",
"adm" => "адм",
"set as operator" => "назначить оператором",
"add topic" => "добавить тему",
"wiki create" => "создать wiki",
"wiki overwrite" => "обновить wiki",
"back" => "назад",
"Assign permissions to page" => "Назначить права доступа к странице",
"Current permissions for this page" => "Текущие права доступа к странице",
"Send email notifications when this page changes to" => "Если эта страница изменится, отослать уведомление на адрес",
"add email" => "добавить адрес",
"Notifications" => "Уведомления",
"clear stats" => "очистить статистику",
"Edit received page" => "Редактировать полученную страницу",
"last" => "последн.",
"send me my password" => "отправьте мне мой пароль",
"searched" => "произведён поиск",
"galleries" => "галереях",
"blog posts" => "сообщениях блогов",
"wiki pages" => "wiki страницы",
"clear" => "очистить",
"send answers" => "отослать ответы",
"move to right column" => "переместить в правую колонку",
"unassign" => "снять назначение",
"move to left column" => "переместить в левую колонку",
"remove folder" => "удалить папку",
"refresh cache" => "обновить кеш",
"edit items" => "изменить содержимое",
"list charts" => "список чартов",
"last chart" => "последний чарт",
"monitor this forum" => "наблюдать за этим форумом",
"stop monitoring this forum" => "прекратить наблюдение за форумом",
"delete selected topics" => "удалить отмеченные темы",
"stop monitoring this topic" => "прекратить наблюдение",
"Comments below your current threshold" => "Комментарии ниже Вашего порога видимости",
"add contacts" => "добавить контакты",
"DATE-of" => "/",
"You cannot edit this page because it is a user personal page" => "Нельзя редактировать эту страницу - это личная страница пользователя",
"Permission denied you cannot assign permissions for this page" => "У Вас недостаточно прав для назначения прав доступа к этой странице",
"You do not have permission to edit messages" => "У Вас недостаточно прав для редактирования сообщения",
"Cannot read file" => "Невозможно прочитать файл",
"Permission denied you cannot upload files" => "Отказано в доступе, Вы не можете закачивать файлы",
"cannot process upload" => "не могу обработать загрузку данных",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Ваш email был удален из списка адресов наблюдения за этим трекером",
"Your email address has been added to the list of addresses monitoring this tracker" => "Ваш email был добавлен в список адресов наблюдения за этим трекером",
"Cancel monitoring" => "Отменить наблюдение",
"Your email address has been removed from the list of addresses monitoring this item" => "Ваш email был удален из списка адресов наблюдения за этим объектом",
"Your email address has been added to the list of addresses monitoring this item" => "Ваш email был добавлен в список адресов наблюдения за этим объектом",
"pdf" => "pdf",
"icon" => "icon",
"proc" => "proc",
"Com" => "Com",
"Vers" => "Верс.",
"pre" => "pre",
"queued messages:" => "сообщений в очереди:",
"pop" => "pop",
"new image uploaded by" => "новое изображение закачано",
"new subscriptions" => "новые подписки",
"new item in tracker" => "новый объект в трекере",
"message" => "сообщение",
"filter" => "фильтр",
"no such file" => "нет такого файла",
"downloads" => "загрузки",
"attach" => "вложение",
"monitor this blog" => "наблюдать за блогом",
"hide categories" => "скрыть категории",
"Admin categories" => "Управлять категориями",
"reply" => "ответить",
"monitor this topic" => "наблюдать за этой темой",
"with checked" => "с отмеченными",
"Dls" => "Скачано",
"move selected files" => "переместить выбранные файлы",
"Thank you for you registration. You may log in now." => "Спасибо за регистрацию. Теперь вы можете залогиниться.",
"compare" => "сравнить",
"diff" => "разница",
"del" => "удалить",
"Create pdf" => "Создать pdf",
"categories" => "категории",
"at tracker" => "в трекере",
"check / uncheck all" => "отметить / очистить все",
"Tiki sections and features" => "Разделы и возможности Tiki",
"please read" => "пожалуйста прочитайте",
"yes" => "да",
"private" => "личное",
"<b>Feed</b>" => "<b>Поток</b>",
"<b>enable/disable</b>" => "<b>разрешить/запретить</b>",
"<b>Max number of items</b>" => "<b>Максимальное число элементов</b>",
"Feed for Articles" => "Поток статей",
"Feed for Weblogs" => "Поток веблогов",
"Feed for Image Galleries" => "Поток фотогалерей",
"Feed for File Galleries" => "Поток файловых галерей",
"Feed for the Wiki" => "Поток для Wiki",
"Feed for individual Image Galleries" => "Поток личных фотогалерей",
"Feed for individual File Galleries" => "Поток личных файловых галерей",
"Feed for individual weblogs" => "Поток личных веблогов",
"Feed for individual forums" => "Поток данных для личных форумов",
"PDF generation" => "Создание PDF",
"Use in CMS" => "Использовать в cms",
"Use in Wiki" => "Использовать в wiki",
"Use in newsletters" => "Использовать в рассылке",
"Use in HTML pages" => "Использовать в HTML страницах",
"Refresh rate (if dynamic) [secs]" => "Частота обновления (если динамическая) [сек]",
"Create/edit newsletters" => "Создать/редактировать рассылки",
"subscriptions" => "подписки",
"Use Admin Email" => "Использовать адрес администратора",
"Edit or add poll options" => "Добавить/изменить параметры опроса",
"Create/edit Polls" => "Создать/изменить опрос",
"Rss channels" => "Rss каналы",
"activate" => "активировать",
"Admin tracker" => "Управлять трекером",
"Edit this tracker" => "Редактировать этот трекер",
"View this tracker items" => "Показать содержимое трекера",
"Edit tracker fields" => "Редактировать поля трекера",
"fields" => "поля",
"Create/edit trackers" => "Создать/редактировать трекеры",
"Add a new group" => "Добавить новую группу",
"Edit item" => "Редактировать",
"Add a new user" => "Добавить пользователя",
"Popup Window" => "Всплывающее окно",
"details" => "подробнее",
"No individual permissions global permissions apply" => "Никаких индивидуальных прав доступа, здесь только глобальные",
"Welcome to the Tiki Chat Rooms" => "Добро пожаловать в Чат-комнаты Tiki",
"Please select a chat channel" => "Пожалуйста, выберите канал",
"enter chat room" => "войти в комнату чата",
"Chatroom" => "Комната",
"Active Channels" => "Активные каналы",
"Users in this channel" => "Пользователи на этом канале",
"Channel Information" => "Информация о канале",
"Channel" => "Канал",
"Ratio" => "Соотношение",
"Use :nickname:message for private messages" => "Используйте :имя:текст для личных сообщений",
"Use [URL|description] or [URL] for links" => "Используйте [URL|описание] или [URL] для создания ссылок",
"Add or edit a site" => "Добавить или редактировать сайт",
"sites" => "сайты",
"cool sites" => "классные сайты",
"Use ...page... to separate pages in a multi-page article" => "Используйте ...page... для разделения страниц в многостраничной статье",
"Create Zone" => "создать область",
"translate" => "перевести",
"Create or edit content" => "Создать или изменить содержимое",
"this quiz stats" => "статистика по этому тесту",
"answer" => "ответ",
"graph" => "граф",
"Edit FAQ questions" => "Редактировать вопросы",
"Other users can upload files to this gallery" => "Другие пользователи могут пополнять галерею",
"Available File Galleries" => "Доступные файловые галереи",
"start" => "начать",
"end" => "конец",
"roles" => "роли",
"Add role" => "Добавить роль",
"active process" => "активный процесс",
"invalid" => "неверно",
"invalid process" => "неверный процесс",
"valid process" => "корректный процесс",
"activities" => "активности",
"aborted" => "отменённые",
"value" => "значение",
"exceptions" => "исключения",
"rollback" => "откат",
"Create or edit content block" => "Создать или редактировать блок содержимого",
"Listing Gallery" => "Содержимое Галереи",
"Gallery Files" => "Галерея Файлов",
"Last ver" => "Последняя версия",
"Subscribe to newsletter" => "Подписаться на рассылку",
"Add or edit a news server" => "Добавить/редактировать сервер новостей",
"Print Wiki Pages" => "Печать страниц Wiki",
"add page" => "добавить страница",
"Total threads" => "Всего веток обсуждения",
"Average threads per topic" => "Среднее число веток на 1 тему",
"You can include the file in an HTML/Tiki page using" => "Вы можете включить этот файл в HTML/Tiki страницу, используя",
"Now enter the file URL" => "Теперь введите URL файла",
" or upload a local file from your disk" => " или закачайте локальный файл с Вашего диска",
"Add or edit folder" => "Добавить или редактировать папку",
"Add or edit a URL" => "Добавить или редактировать URL",
"priority" => "приоритет",
"previous chart" => "предыдущий чарт",
"next chart" => "следующий чарт",
"pos" => "поз",
"avg" => "средне",
"post new comment" => "комментировать",
"Post New Comment" => "комментировать",
"HTML tags are not allowed inside comments" => "HTML теги не позволяются внутри комментариев",
"moderator actions" => "действия модератора",
"move selected topics" => "переместить отмеченные темы",
"unlock selected topics" => "разблокировать отмеченные темы",
"lock selected topics" => "заблокировать отмеченные темы",
"merge" => "объединить",
"merge selected topics" => "объединить отмеченные темы",
"View item" => "Просмотр",
"Add a comment" => "Добавить комментарий",
"account" => "учётная запись",
"Group doesnt exist" => "Группа не существует",
"User doesnt exist" => "Пользователь не существует",
"Event without Name" => "событие без имени",
"Invalid old password" => "Старый пароль не подошёл",
"No channel indicated" => "Канал не указан",
"No nickname indicated" => "Имя не указано",
"Permision denied" => "Доступ запрещён",
"sender" => "отправитель",
"subject" => "тема",
"date" => "дата",
"mark" => "пометка",
"posted by" => "создано",
"email this post" => "отправить по эл.почте",
"Use page description" => "Использовать описание страницы",
"Show page title" => "Показывать заголовок страницы",
"Users can lock pages (if perm)" => "Пользователи могут блокировать страницы (согл. прав доступа)",
"Maximum number of versions for history" => "Хранить версий в истории не более",
"Never delete versions younger than days" => "Никогда не удалять версии моложе дней",
"Old vers" => "Старые версии",
"Add or edit event" => "Добавить или редактировать событие",
"merge selected notes into" => "объединить выбранные заметки в",
"Faq Stats" => "Статистика ЧаВо",
"settings" => "настройки",
"mailbox" => "почтовый ящик",
"compose" => "создать",
"contacts" => "контакты",
"back to mailbox" => "вернуться в почтовый ящик",
"full headers" => "полные заголовки",
"normal headers" => "обычный вид",
"reply all" => "ответить всем",
"forward" => "переслать",
"select from address book" => "выбрать из адр.книги",
"cc" => "копия (cc)",
"Message queue for" => "Message queue for",
"Reported messages for" => "Reported messages for",
"new sites" => "новые сайты",
"pass" => "пароль",
"Page generated in" => "Страница создана за",
"sent" => "отправлено",
"Minor" => "Мелочь",
"Prevent automatic/robot registration" => "Предотвращать автоматическую регистрацию",
"Create/edit Calendars" => "Создать/редактировать календари",
"Chat Administration" => "Управление чатом",
"Create/edit channel" => "Создать/изменить канал",
"second" => "секунда",
"Chat channels" => "Каналы чата",
"Assign Module" => "назначить модуль",
"Edit survey questions" => "Редактировать вопросы анкеты",
"Admin Tracker" => "Управлять трекером",
"Again" => "Снова",
"Assign permissions to group" => "Назначить права для группы",
"Browsing Gallery" => "Просмотр Галереи",
"Program dynamic content for block" => "Программировать динамическое содержимое блока",
"Admin quizzes" => "Настройка тестов",
"back to forum" => "вернуться в форум",
"hist" => "история",
"back to admin" => "назад в управление",
"Subscribe to This Newsletter" => "Подписаться",
"Stats for quiz" => "Статистика теста",
"Rename page" => "Переименовать страницу",
"to_version" => "к_версии",
"Theme Control Center: categories" => "Центр управления темами: категории",
"Theme Control Center: sections" => "Центр управления темами: Секции",
"File Title" => "Название файла",
"IRC log" => "IRC лог",
"Add new mail account" => "Новая учётная запись почты",
"User accounts" => "Учётные записи",
"View All" => "Показать все",
"Msg" => "Сообщ",
"Permission denied you cannot remove pages" => "Отказано в доступе, Вы не можете удалять страницы",
"Send trackback pings to:" => "Send trackback pings to:",
"LDAP Scope" => "LDAP Scope",
"LDAP Base DN" => "LDAP Base DN",
"LDAP User DN" => "LDAP User DN",
"LDAP User OC" => "LDAP User OC",
"LDAP Group DN" => "LDAP Group DN",
"LDAP Group OC" => "LDAP Group OC",
"LDAP Member Attribute" => "LDAP Member Attribute",
"LDAP Member Is DN" => "LDAP Member Is DN",
"LDAP Admin User" => "LDAP Admin User",
"LDAP Admin Pwd" => "LDAP Admin Pwd",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model.",
"Cannot write to this file" => "Запись в этот файл невозможна",
"Missing title or body when trying to post a comment" => "Вы забыли ввести заголовок или текст комментария",
"Newsletter subscription information at " => "Информация о подписке на ",
"categorize this object" => "задать категорию объекта",
"Syntax highlighting" => "Подсветка синтаксиса",
"My Files" => "Файлы",
"Mini calendar" => "Мини-календарь",
"Dump" => "Дамп",
"Received pages" => "Полученные страницы",
"Admin Posts" => "Управлять сообщениями",
"Submit a New Link" => "Предложить новую ссылку",
"Submit a new link" => "Предложить новую ссылку",
"Admin Directory" => "Управлять каталогом",
"List trackers" => "Список трекеров",
"I forgot my pass" => "Я забыл пароль",
"(comma separated list of URIs)" => "(URIs разделенные запятыми)",
"This is" => "Это",
"by the" => "автор",
"Use URI as Home Page" => "Использовать URI как домашнюю страницу",
"OS" => "Операционная система",
"Use cache for external images" => "Кешировать внешние изображения",
"Use gzipped output" => "Использовать сжатый вывод страниц",
"Sender Email" => "Эл.адрес отправителя",
"contact feature disabled" => "возможность связи отключена",
"User registration and login" => "Регистрация и вход",
"Use WebServer authentication for Tiki" => "Исплользовать WebServer аутентификацию для Tiki",
"Request passcode to register" => "Требовать секретный код для регистрации",
"Validate users by email" => "Проверять пользователей через email",
"Store plaintext passwords" => "Хранить пароли незашифрованные",
"Reg users can change language" => "Пользователи могут выбирать язык",
"Force to use chars and nums in passwords" => "Заставить использовать буквы с цифрами в паролях",
"Minimum password length" => "Пароль не должен быть короче",
"Password invalid after days" => "Пароль устареет через, дней",
"Remember me feature" => "Возможность Запомни меня",
"Create user if not in Tiki?" => "Создать пользователя, если он не в Tiki?",
"Create user if not in Auth?" => "Создать пользователя, если он не в  Auth?",
"Just use Tiki auth for admin?" => "Использовать только аутентификацию Tiki для админа?",
"LDAP Host" => "LDAP Хост",
"LDAP Port" => "LDAP Порт",
"LDAP User Attribute" => "LDAP Пользовательские Аттрибуты",
"LDAP Group Attribute" => "LDAP Групповые Аттрибуты",
"restore" => "восстановить",
"Wiki Home Page" => "Домашняя страница Wiki",
"Wiki Discussion" => "Обсуждение Wiki",
"Wiki Features" => "Возможности Wiki",
"Wiki History" => "История Wiki",
"Admin Charts" => "Настройка чартов",
"Create/edit questions for survey" => "Создать/изменить вопросы анкеты",
"Active?" => "Активно?",
"Create/Edit Trackers" => "Создать/редактировать трекеры",
"Browse gallery" => "Просмотр галереи",
"Upload from disk" => "Закачать с диска",
"Browsing Image" => "Просмотр изображения",
"Again please" => "Ещё раз пожалуйста",
"Admin category relationships" => "Управлять отношениями в категориях",
"Validate links" => "Проверить ссылки",
"Im- Export Languages" => "Испорт/экспорт языков",
"Support tickets" => "Квитанции поддержки",
"Return to HomePage" => "Вернуться на домашнюю страницу",
"Batch upload" => "Пакетная закачка",
"Minor Edit" => "Мелочь",
"You can not download files" => "Вы не можете скачивать файлы",
"Please wait 2 minutes between posts" => "Пожалуйста подождите 2 минуты между сообщениями",
"italic" => "italic",
"Show Categories" => "вывести категории",
"Hide Categories" => "скрыть категории",
"Blog features" => "Возможности блога",
"Blog level comments" => "Комментарии к блогу",
"Post level comments" => "Комментарии к сообщению",
"Spellchecking" => "Правописание",
"Default ordering for blog listing" => "Сортировка блога по умолчанию",
"Blog listing configuration (when listing available blogs)" => "Настройка списка блогов (при просмотре доступных блогов)",
"Blog comments settings" => "Комментарии в блогах",
"CMS features" => "Возможности CMS",
"Use templates" => "Использовать шаблоны",
"Maximum number of articles in home" => "Максимальное число статей в домашней папке",
"Article comments settings" => "Комментарии статей",
"Copyright Management" => "Управление авторскими правами",
"License Page" => "Лицензионное соглашение",
"Submit Notice" => "Комментарий при отправке",
"Uploaded filenames cannot match regex" => "Имена файлов НЕ должны совпадать с regex",
"File galleries comments settings" => "Комментарии в файловых галереях",
"Forum quick jumps" => "Быстрое перемещение по форуму",
"Ordering for forums in the forum listing" => "Упорядочивание форумов в списке",
"Forum listing configuration" => "Настройка списка форума",
"this survey stats" => "статистика этой анкеты",
"bold" => "жирный",
"underline" => "подчеркнуть",
"hr" => "разделитель",
"unread private messages" => "непрочтённые личные сообщения",
"you or someone registered this email address at" => "Вы или кто-то другой зарегистрировал этот адрес на",
"Your Tiki information registration" => "Ваша регистрационная информация Tiki",
"home" => "в начало",
"chat" => "чат",
"contact us" => "свяжитесь с нами",
"User menu" => "Меню пользователя",
"dump" => "Дамп",
"rankings" => "Рейтинги",
"orphan pages" => "Страницы-сироты",
"sandbox" => "песочница",
"received pages" => "Полученные страницы",
"structures" => "структуры",
"Articles Home" => "Главная статья",
"Send articles" => "Отправить статьи",
"Create/Edit Blog" => "Создать/Изменить Блог",
"Browse Directory" => "Просмотр каталога",
"Admin FAQs" => "Управление ЧаВо",
"Admin quiz" => "Управлять тестом",
"Admin trackers" => "Управлять трекерами",
"Send newsletters" => "Отослать письма",
"Ephemerides" => "События",
"Backups" => "Резервные копии",
"Edit languages" => "Редактировать языки",
"External wikis" => "Внешние wikis",
"Quick edit a Wiki page" => "Редактировать страницу",
"Sort posts by:" => "Сортировать сообщения по:",
"read more" => "подробнее",
"Pass" => "Пароль",
"some text" => "какой-то текст",
"Creates a box with the data" => "Создаёт прямоугольник с содержимым",
"creates a title bar" => "создаёт полосу заголовка",
"creates a table" => "создаёт таблицу",
"makes a horizontal rule" => "создаёт горизонтальный разделитель",
"page|desc" => "стр.|описание",
"displays an image" => "показывает изображение",
"Non cacheable images" => "Некешируемые изображения",
"height width desc link and align are optional" => "высота ширина описание ссылка и выравнивание не обязательны",
"displays rss feed with id=n maximum=m items" => "выводит rss раздачу от другого сервера с id=n не более=m элементов",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Будет заменено настоящим значением блока динамического содержимого с id=n",
"Misc" => "Разное",
"Tiki is unable to connect to the database " => "Tiki не может подключиться к базе данных ",
"Tiki was unable to retrieve login data from the database " => "Tiki не смог получить регистрационные данные из базы данных ",
"The following error message was returned" => "Получено следующее сообщение об ошибке",
"Things to check" => "Что необходимо проверить",
"Is your database up and running" => "Работает ли ваша база данных",
"Are your database login credentials correct" => "Корректны ли ваши регистрационные данные",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Завершена ли <a href='tiki-install.php' >Инсталляция Tiki ",
"Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Пожалуйста, см. <a href=\"http://doc.tikiwiki.org/\">документацию</a> для получения дополнительной информации",
"Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter" => "Должна быть установлена библиотека Text_Wiki. Детали смотрите на http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter",
"PostgeSQL 7.2+" => "PostgeSQL 7.2+",
"Oracle" => "Oracle",
"Sybase" => "Sybase",
"SQLLite" => "SQLLite",
"MSSQL" => "MSSQL",
"Tiki version" => "Tiki версия",
"PHP version" => "PHP версия",
"on left side" => "слева",
"on center" => "по центру",
"on right side" => "справа",
"Any 2 versions" => "Любые 2 версии",
"latin" => "latin",
"english" => "english",
"Report all errors except notices" => "Выводить полный отчет исключая предупреждения",
"1 hour" => "1 час",
"2 hours" => "2 час",
"10 hours" => "10 часов",
"20 hours" => "20 часов",
"1 year" => "1 год",
"crypt-md5" => "crypt-md5",
"crypt-des" => "crypt-des",
"OpenID and Tiki" => "OpenID и Tiki",
"choose a group .." => "выберите группу ..",
"Admins" => "Администраторы",
"No forums" => "Нет форумов",
"%s enabled" => "%s включено",
"\$feature is turned on" => "\$feature включено",
"%s disabled" => "%s отключено",
"\$feature is turned off" => "\$feature выключено",
"You have mistyped the anti-bot verification code; please try again" => "Ошибка в коде верификации; пожалуйста, повторите попытку",
"Your message has been queued for approval and will be posted after a moderator approves it" => "Ваше сообщение помещено в очередь на утверждение. Сообщение будет добавлено после подтверждения модератором",
"Sample plugin" => "Пример плагина",
"Font family to use" => "Семейство шрифтов",
"As defined by CSS" => "Как указано в CSS",
"Lines" => "Линии",
"Select a Wiki page to link to" => "Выберите Wiki страницу для создания ссылки",
"Cannot open this file" => "Не удается открыть этот файл",
"This is an approximation based on your server memory limit" => "Это приблизительная оценка с учетом объема памяти на вашем сервере",
"layer" => "уровень",
"Record" => "Запись",
"This poll is closed" => "Этот опрос закрыт",
"You need either JQuery or MooTools enabled for this feature" => "Чтобы использовать эту возможность, Вам необходимо включить JQuery или MooTools",
"Help page" => "Помощь",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using TikiWiki with an incorrect database version usually causes errors" => "Ваша база требует обновления в соответствии с текущей версией TikiWiki. Пожалуйста, перейдите на <a href=\"tiki-install.php\"> страницу установки </a>. Использование Tiki с неверной версией базы данных, как правило, приводит к ошибкам",
"You are not allowed to upload this type of file" => "Вам не разрешено загружать данный тип файлов",
"The file you are trying upload was only partially uploaded" => "Файл был загружен частично",
"You must select a file" => "Выберите файл",
"Flash player not available" => "Flash player не доступен",
"Altering database table failed" => "Изменение таблицы базы данных не удалось",
"__WARNING__: Plugin disabled \$plugin" => "__ВНИМАНИЕ____: Плагин отключен \$plugin",
"The administrator has not yet validated your account. Please wait" => "Администратор еще не проверил Вашу учетную запись.  Подождите",
"Displays various information about the client" => "Отображает различную информацию о клиенте",
"Image alignment. Possible values: left, right, center" => "Выравнивание изображения. Возможные значения: left, right, center",
"Image annotations changed" => "Аннотация к изображению изменена",
"Creates an annotation block for an image" => "Создает аннотационный блок для изображения",
"Displays an image and enables users to define zones to highlight information on the image" => "Отображает изображения и позволяет пользователям определять зоны для выделения информации об изображении",
"List of colors to use" => "Список цветов",
"List of styles to use" => "Список стилей",
"Code snippet label" => "Заголовок для фрагмента кода",
"0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Разрешить перенос слов в коде для соблюдения разметки страницы",
"Includes content from the dynamic content system" => "Добавить динамическое содержимое",
"Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
"One of" => "Один из",
"Default: #F5F5F5" => "По умолчанию: #F5F5F5",
"Includes random content from the dynamic content system" => "Добавить случайное динамическое содержимое",
"sheet" => "эл.лист",
"File is not an image" => "Файл не является изображением",
"Content of the field" => "Содержимое поля",
"Please wait.." => "Подождите..",
"Since your last visit.." => "Пока вас не было..",
"New Article" => "Новая статья",
"Autovalidate suggestions" => "Автоматическая проверка предложений",
"Can abort a process instance" => "Остановить процесс",
"Can admin charts" => "Управление графиками",
"Can admin drawings" => "Управление чертежами",
"Can admin games" => "Управление играми",
"Can admin quicktags" => "Управление панелью инструментов",
"Can admin rss modules" => "Управление модулями rss",
"Can admin workflow processes" => "Управление системой бизнес процессов",
"Can declare an instance as exception" => "Объявление экземпляра в качестве исключения",
"Can edit drawings" => "Редактирование чертежей",
"Can edit items in categories" => "Редактирование элементов в категориях",
"Can execute workflow activities" => "Запускать бизнес процессы",
"Can rate wiki pages" => "Принимать участие в рейтинге wiki страниц",
"Can play games" => "Играть в игры",
"Can search on objects of this category" => "Поиск объектов в категории",
"Can suggest items" => "Предлагать записи",
"Can use dsn " => "Использование dsn ",
"Can use the newsreader" => "Использовать систему чтения новостей",
"Can view categories" => "Просмотр категорий",
"Can view categorized items" => "Просмотр объектов в категории",
"Can view charts" => "Просмотр графиков",
"Can vote" => "Разрешить голосовать",
"Quicktags" => "Панель инструментов",
"Please note that the preview does not keep the attached file which you will have to choose before posting" => "Обращаем внимание, что режим предпросмотра не сохраняет файл, который вы выбрали для вложения в сообщение",
"Your comment will have to be approved by the moderator before it is displayed" => "Ваш комментарий должен быть одобрен модератором, прежде чем он отобразиться",
"Type of contribution" => "Вид взноса",
"any file" => "любой файл",
"podcast (audio)" => "подкаст (звук)",
"podcast (video)" => "подкаст (видео)",
"This Gallery is Public" => "Публичная галерея",
"Perhaps you were looking for" => "Возможно вы ищете",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together" => "Пишите метки разделяя их пробелом. Метку из нескольких слов пишите слитно.",
"You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page" => "Вы собираетесь покинуть эту страницу. Если вы сделали какие-либо изменения без сохранения, изменения будут потеряны. Вы уверены, что хотите выйти",
"Loading" => "Идет загрузка",
"Are you sure you want to delete the selected files" => "Вы уверены что хотите удалить выбранные файлы",
"New topic" => "Новая тема",
"successfully" => "успешно",
"deleted" => "удален(о)",
"QuickTags" => "Панель инструментов",
"quicktags" => "панель инструментов",
"More.." => "Еще..",
"Tikiwiki Assistant" => "Помощник Tikiwiki",
"Last `\$module_rows` blog comments" => "`\$module_rows` последних комментариев в блоге",
"Last blog comments" => "Последние комментарии в блоге",
"Last `\$module_rows` Sites" => "`\$module_rows` последних сайтов",
"Top \$module_rows Sites" => "\$module_rows популярных сайтов",
"Top `\$module_rows` topics" => "`\$module_rows` популярных тем",
"Last `\$module_rows` forum posts" => "`\$module_rows` последних ответов на форуме",
"Last `\$module_rows` forum topics" => "`\$module_rows` последних тем на форуме",
"More Like This" => "Показать похожие",
"My prefered tags" => "Мои любимые тэги",
"Last `\$module_rows` actions" => "`\$module_rows` действий",
"Last `\$module_rows` articles" => "`\$module_rows` статей",
"Last articles" => "Последние статьи",
"Last `\$module_rows` blog posts" => "`\$module_rows` записей в блогах",
"\$type" => "\$type",
"Last `\$module_rows` Created blogs" => "`\$module_rows` созданных блогов",
"Last `\$module_rows` Created FAQs" => "`\$module_rows` созданных ЧаВо",
"Last `\$module_rows` Created Quizzes" => "`\$module_rows` созданных опросов",
"Last `\$module_rows` modified file galleries" => "`\$module_rows` измененных файловых галерей",
"Last `\$module_rows` Files" => "`\$module_rows` файлов",
"Last `\$module_rows` galleries" => "`\$module_rows` галерей",
"Last `\$module_rows` Images" => "`\$module_rows` изображений",
"Last `\$module_rows` modified events" => "`\$module_rows` измененных событий",
"Last modifed events" => "Последние измененные события",
"Last `\$module_rows` changes" => "`\$module_rows` изменений",
"Last `\$module_rows` Modified Items" => "`\$module_rows` измененных объектов",
"Last `\$module_rows` Modified blogs" => "`\$module_rows` измененных блогов",
"Last `\$module_rows` submissions" => "`\$module_rows` представлений",
"Last `\$module_rows` Modified Comments" => "`\$module_rows` измененных комментариев",
"Last Modified Comments" => "Последние измененные комментарии",
"Last `\$module_rows` Items" => "`\$module_rows` объектов",
"CapsLock is on" => "CapsLock включен",
"What is OpenID" => "Что такое OpenID",
"Random Images" => "Случайные изображения",
"Your email could not be validated; make sure you email is correct and click register below" => "Ваш электронный адрес не прошел проверку; убедитесь в корректости написания адреса и пройтите регистрацию ниже",
"maps" => "Карты",
"Are you sure you want to delete this shout" => "Вы уверены, что хотите удалить эту запись",
"Site Language" => "Язык системы",
"Top `\$module_rows` articles" => "`\$module_rows` популярных статей",
"Top `\$module_rows` File Galleries" => "`\$module_rows` популярных файловых галерей",
"Top `\$module_rows` files" => "`\$module_rows` популярных файлов",
"Top `\$module_rows` Forum Posters" => "`\$module_rows` популярных писателей на форуме",
"Top `\$module_rows` games" => "`\$module_rows` популярных игр",
"Top `\$module_rows` galleries" => "`\$module_rows` популярных галерей",
"Top `\$module_rows` Images" => "`\$module_rows` популярных изображений",
"Top `\$module_rows` Objects" => "`\$module_rows` популярных объектов",
"Top `\$module_rows` Pages" => "`\$module_rows` популярных страниц",
"Top `\$module_rows` Quizzes" => "`\$module_rows` популярных опросов",
"Most `\$module_rows` visited blogs" => "`\$module_rows` наиболее посещяемых блогов",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` наиболее посещяемых ЧаВо",
"There are no translations of this page" => "Для данной страницы перевод отсутствует",
"Up-to-date-ness" => "Up-to-date-ness",
"Better translations" => "Лучшие переводы",
"Set your preferred languages" => "Укажите Ваши языковые предпочтения",
"Equivalent translations" => "Одинаковые переводы",
"Translations that need improvement" => "Переводы, нуждающиеся в улучшении",
"Upcoming `\$module_rows` events" => "`\$module_rows` грядущих событий",
"The Next Event" => "Следующее событие",
"No Upcoming Events" => "Нет грядущих событий",
"Last `\$module_rows` wiki comments" => "`\$module_rows` последних wiki комментариев",
"on page" => "на странице",
"show structures" => "показать структуры",
"hide structures" => "спрятать структуры",
"community" => "сообщество",
"freetags" => "метки",
"Blogs Listing" => "Список блогов",
"Creation date" => "Дата создания",
"Users Listing" => "Список пользователей",
"My workflow" => "Мой бизнес-процесс",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Подробное описание cмотрите в <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>документации по функциям</a> на сайте Tiki",
"No tabs" => "Убрать закладки",
"Main" => "Основные",
"Global Features" => "Глобальные настройки",
"More Functionality" => "Дополнительный функционал",
"UI Enhancements" => "Усовершенствования UI",
"Main Features" => "Основные настройки",
"Site Global Features" => "Настройки сайта",
"Action log setting" => "Настройки протокола",
"Additional Features" => "Дополнительные возможности",
"Featured Help" => "Настройка справки",
"html pages" => "страницы html",
"Comments Moderation" => "Модерация комментариев",
"User interface enhancement features" => "Расширенные возможности UI",
"JavaScript popup date selector" => "Всплывающий выбор даты на JavaScript",
"Allow users to activate fullscreen mode" => "Разрешить пользователям включать полноэкранный режим",
"Floating help aka the Big Blue Help Icon" => "Помощь в виде плавающего синего знака вопроса",
"Experimental Features" => "Экспериментальные возможности",
"Seem ok" => "Должны работать",
"Tiki Sheet" => "Tiki Лист",
"Malfunctioning" => "Несрабатывание",
"These features have critical faults - not recommended" => "Функции имеют критические замечания - не рекомендуются",
"Magic Admin Panel" => "Панель администратора",
"Neglected" => "Не развиваются",
"Old features no longer maintained" => "Не поддерживаемые старые функции",
"Friendship" => "Дружба",
"Used to embed Flash content in wiki pages, banners etc" => "Используется для встраивания Flash содержимого в вики-страницы, баннеров и т.д.",
"Administration Features" => "Административные возможности",
"Banning System" => "Система запретов и блокировок",
"Action Calendar" => "Календарь событий",
"Tiki action calendar" => "Календарь событий Tiki",
"User Features" => "Возможности пользователя",
"Programmer Features" => "Особенности для программиста",
"tikitests" => "tiki тесты",
"requires PHP5 or more" => "необходим PHP5 или выше",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory" => "Если вы решили хранить файлы в директории, необходимо убедиться, что пользователь не может получить доступ непосредственно к каталогу",
"Gallery Listing" => "Список галерей",
"The server must be able to read/write the directory" => "Сервер должен иметь возможность чтения / записи в каталог",
"The directory can be outside the web space" => "Каталог может быть за пределами сайта",
"Pixels Default" => "Пиксели по умолчанию",
"Admin Password" => "Пароль администратора",
"Use TikiWiki feature as homepage" => "Установить домашней страницей",
"Server OS" => "Серверная ОС",
"(standard)" => "(стандарт)",
"(some Unix MTA)" => "(некоторые Unix MTA)",
"Default timezone" => "Временная зона по умолчанию",
"Sample" => "Пример",
"Fields display order" => "Показывать в порядке",
"Use Ctrl+Click to select multiple languages" => "Используйте Ctrl+Click для выбора нескольких языков",
"Available styles" => "Доступные стили",
"page name" => "имя страницы",
"Default RDF version" => "RDF версия по умолчанию",
"Editor" => "Редактор",
"Webmaster" => "Вебмастер",
"The following list of changes has been applied" => "Были выполнены следующие изменения",
"preference name" => "имя параметра",
"Kb" => "Кб",
"Ex" => "Пример",
"Delete events older than" => "Удалять события старше",
"Current Category ID" => "ID выбранной категории",
"Edit this category" => "Редактировать категорию",
"Perms inherited from closest parent if possible or from global perms" => "Права унаследуются от ближайшей родительской категории или из глобальных настроек",
"Assign permissions automatically" => "Назначить доступ автоматически",
"recommended for best performance" => "рекомендуется для лучшего быстродействия",
"Edit this template" => "Редактировать шаблон",
"Use the Administration page of each enabled feature to allow the use of content templates" => "Возможность использования шаблонов включается в каждой отдельной секции на странице \"Адмнистрирование системы\"",
"No features are configured to use templates" => "Ни в одной секции не разрешено использование шаблонов",
"Edit this Forum" => "Редактировать форум",
"no display" => "не показывать",
"List Forums" => "Список форумов",
".." => "..",
"Use Ctrl+Click to select multiple groups" => "Используйте Ctrl+Click для выбора нескольких групп",
"setting will override your selection of specific groups" => "отменит Вашу настройку на определенные группы",
"Edit this user module" => "Изменить этот пользовательский модуль",
"You can add several email addresses by separating them with commas" => "Вы можете указать несколько эл.адресов через запятую",
"Add email" => "Добавить эл.адрес",
"Add user" => "Добавить пользователя",
"mail notifications" => "почтовые уведомления",
"Admin Quicktags" => "Администрирование Панели инструментов",
"Create/Edit QuickTags" => "Создать/Редактировать кнопку",
"Answer is mandatory" => "Ответ является обязательным",
"Number of required answers (for multiple choices)" => "Кол-во обязательных ответов (для множественного выбора)",
"Min" => "Мин",
"For a rate, you can give the maximum value" => "Для оценки, Вы можете задать максимальное значение",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)" => "Если ваш Tiki ведет себя странно, первым делом очистите кеш. Это необходимо делать и после каждого обновления",
"Full Path to the Zip File" => "Полный путь к архивному файлу",
"Templates compiler" => "Компилятор шаблонов",
"Compile" => "Компилировать",
"Warning: Make a backup of your Database before using this function" => "Внимание: Создайте резервную копию вашей базы данных перед тем как использовать эту функцию",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini" => "Внимание: Если вы хотите  конвертировать большие таблицы, необходимо увеличить время исполнения в php.ini (секция Resource Limits, параметр max_execution_time)",
"Select list items that will be displayed" => "Выберите пункты из списка для отображения",
"Column is searchable" => "Поиск по столбцу",
"Field is hidden" => "Скрытое поле",
"Field is mandatory" => "Обязательное поле",
"Description text is wiki-parsed" => "Описание в стиле wiki",
"Error message" => "Сообщение об ошибке",
"Item creator can modify his items" => "Создатель может вносить изенения в свои записи",
"Member of the default group of creator can modify items" => "Члены одной группы могут вносить изменения в свои записи",
"Format if not the default short one" => "Указать особенный формат даты",
"Show creation date when viewing tracker item" => "Показывать дату создания",
"Show lastModif date when viewing tracker item" => "Показывать дату последнего изменения",
"What field is used for default sort" => "По умолчанию сортировать по полю",
"What is default sort order in list" => "Направление сортировки по умолчанию",
"Tracker items allow ratings" => "Включить рейтинг для записей",
"and display rating results in listing" => "показывать рейтинг в списке",
"and display comments in listing" => "показывать комментарии в списке",
"and display last comment user/date" => "показывать автора и дату последнего комментария",
"and display attachments in listing" => "показывать вложения в списке",
"Do not show empty fields in item view" => "Не показать пустые поля в просмотре",
"Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Показать эти поля (ID разделенные запятой) во всплывающем окне при просмотре списка трекера",
"Edit Account Settings" => "Редактировать настройки учетной записи",
"Edit Group" => "Редактировать Группу",
"Validate user" => "Проверить пользователя",
"Repeat Password" => "Пароль повторно",
"Must Change Password" => "Запросить сменить пароль",
"Last Login" => "Последний вход",
"Overwrite groups" => "Перезаписать группы",
"Loading.." => "Загрузка..",
"Approve page changes in staging" => "Утвердить изменения страницы в постановке",
"Assign User {\$assign_user} to Groups" => "Назначить пользователя {\$assign_user} в Группы",
"Default Group" => "Группа по умолчанию",
"available files" => "доступные файлы",
"Mark entry as private" => "Отметить как личное",
"Assigning permissions for <b>all children</b> is recommended for best performance" => "Назначение прав на <b>все вложенные</b> рекомендуется для быстродействия",
"You cannot add sites until Directory Categories are setup" => "Вы не можете добавить ссылку. Ведутся работы по настройке каталога ссылок",
"<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Добавить категорию</a>",
"The following site was added, but may require validation by the admin before appearing on the lists" => "Предложенные сайты добавлены, но они еще должны пройти проверку администратором",
"Use Ctrl+Click to select multiple categories" => "Используйте Ctrl+Click для выбора нескольких категорий",
"Perform action with selected" => "Выполнить над выделенными",
"Add a Category" => "Добавить категорию",
"Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Будет отображаться с использованием указанного HTML номера или имени цвета. Можно использовать два имени цвета через запятую. В этом случае первый цвет - цвет текста, второй - цвет фона",
"Use [[foo] to show [foo]" => "Пишите [[foo] для отображения [foo]",
"and its subpages from the structure, now you have two options" => "и все ее подкатегории, выберите что необходимо сделать",
"Preview your changes" => "Предпросмотр ваших изменений",
"Save the page" => "Сохранить страницу",
"Cancel the edit, you will lose your changes" => "Отмена редактирования с потерей выполненных изменений",
"Perhaps you are looking for" => "Похожие сраницы по названию",
"This edit session will expire in {\$edittimeout} minutes" => "Сессия закончится через {\$edittimeout} минут",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer" => "Выполните <strong>Предпросмотр</strong> или <strong>Сохранить</strong> для обновления сессии",
"Switch to WYSIWYG editor" => "Использовать WYSIWYG редактор",
"There is no available poll template" => "Нет доступных шаблонов опроса",
"You should ask an admin to create them" => "Попросите администратора создать их",
"Send urgent translation request" => "Отправить срочный запрос на перевод",
"List TikiSheets" => "Список эл.таблиц Tiki",
"Use Ctrl+Click to select multiple fields" => "Используйте Ctrl+Click для выбора нескольких полей",
"Years" => "Года",
"Months" => "Месяцы",
"Minutes" => "Минуты",
"Edit Tpl" => "Редактировать шаблон (Tpl)",
"Not Defined" => "Не определено",
"Not Interactive" => "Не интерактивно",
"Not Ended" => "Не завершено",
"Executed" => "Запущено",
"erase" => "стереть",
"Edit this gallery" => "Редактировать эту галерею",
"Create New FAQ" => "Создать новый ЧаВо",
"My Contacts" => "Мои контакты",
"My Wiki Pages" => "Мои Wiki страницы",
"My Galleries" => "Мои галереи",
"My Tracker Items" => "Мои трекер-записи",
"My Messages" => "Мои сообщения",
"My Tasks" => "Мои задачи",
"View Permissions" => "Просмотр прав доступа",
"These permissions override any global permissions or category permissions affecting this object" => "Указанные права доступа перекрывают любые глобальные права или права доступа от категории объекта",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>" => "Для установки глобальных прав доступа <a class=\"rbox-link\" href=\"tiki-admingroups.php\">нажмите здесь</a>",
"No individual permissions, category permissions apply" => "Индивидуальных прав доступа нет, применяются права доступа от категории",
"Current permissions for categories that this object belongs to" => "Текущие права доступа от категории объекта",
"These permissions do not apply. Special permissions apply" => "Эти права доступа не применяются. Только специальные права",
"No category permissions; global permissions apply" => "У категории нет особых прав доступа; применяются глобальные права",
"No category permissions; special permissions apply" => "У категории нет особых прав доступа; применяются специальные права",
"and also to all pages of the sub-structure" => "и для всех страниц дочерней стуктуры",
"Perms Help" => "Помощь по правам доступа",
"Preview of version" => "Посмотреть версию",
"Source of version" => "Источник версии",
"Note: Remember that this is only a preview, and has not yet been saved" => "Внимание: вы находитесь в режиме предпросмотра, страница не сохранена",
"Prologue" => "Пролог",
"Epilogue" => "Эпилог",
"Send Pages" => "Отправленные страницы",
"The highlight pages already exist" => "Выделенные страницы уже существуют",
"Please, change the name if you want the page to be uploaded" => "Измените имя если хотите загрузить страницу",
"Enter your username or email" => "Введите ваше имя и эл.адрес",
"Enter your email" => "Введите ваш эл.адрес",
"Data HTML" => "Содержимое в HTML",
"Data Txt" => "Содержимое обычным текстом",
"You will not see the latest queries" => "Вы не увидите последние запросы",
"Stats for survey" => "Статистика анкеты",
"Maximum amount of downloads" => "Максимальное количество загрузок",
"Maximum file size is limited to" => "Максимальный размер файла не более",
"No gallery available" => "Нет доступной галереи",
"Uploading file.." => "Загрузка файла..",
"No File to Upload.." => "Нет файла для загрузки..",
"Note: Maximum image size is limited to" => "Примечание: Максимальный размер файла",
"a URL" => "закладку",
"This user is your friend" => "Это пользователь ваш друг",
"Your personal tracker information" => "Ваша личная информация трекера",
"Your preferred language" => "Ваш язык",
"Can you read more languages" => "Вы можете читать и на других языках",
"Other languages you can read (select on the left to add to the list on the right)" => "Другие языки (выберите слева, чтобы добавить в список справа)",
"Select language.." => "Выбор языка..",
"Confirm new password" => "Подтвердите новый пароль",
"Current password (required)" => "Текущий пароль (обязательно)",
"Use \"watches\" to monitor wiki pages or other objects" => "Используйте \"Наблюдения\" чтобы следить за изменением страниц или других объектов системы",
"Watch new items by clicking the {icon _id=eye} button on specific pages" => "Чтобы начать наблюдение за объектом достаточно нажать {icon _id=eye} на его странице",
"Used space" => "Использованное пространство",
"expires" => "истекает",
"No articles yet" => "Статей пока нет",
"Click here to view the Google cache of the page instead" => "Нажмите здесь, чтобы посмотреть страницу в кеше Google",
"There are no questions in this FAQ" => "Пока в этом ЧаВо вопросов нет",
"The post has been reported and will be reviewed by a moderator" => "Ответ отправлен на рассмотрение модератору",
"Tracker Item" => "Запись трекера",
"Save the page, but do not send notifications and do not count it as new content to be translated" => "Сохранить страницу, но не отправлять уведомления об изменении и не считать как новую версию для перевода",
"Save the page as a draft" => "Сохранить страницу как черновик",
"Unassign module" => "Убрать модуль",
"%s modified successfully" => "%s изменили успешно",
"%s modification failed" => "%s не изменили",
"Page saved (version %d)" => "Страница сохранена (версия %d)",
"Account validated successfully" => "Учетная запись подтверждена",
"Are you sure you want to delete this note" => "Действительно ли Вы хотите удалить эту заметку?",
"Changes" => "Изменения",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks" => "Вы не можете назначать задания другим, или этот пользователь отказался их принимать",
"Please read the task and work on it" => "Прочитайте задачу и примите решение по ней",
"Workflow" => "Процессы",
"workflow" => "процессы",
"Unix" => "Unix",
"Windows" => "Windows",
"PEAR::Auth" => "PEAR::Auth",
"auto routed" => "auto routed",
"Auto routed" => "Auto routed",
"Origin" => "Origin",
"Instance" => "Instance",
"Workitems" => "Workitems",
"run instance" => "run instance",
"ver:" => "ver:",
"Admin process sources" => "Admin process sources",
"select source" => "select source",
"Shared code" => "Shared code",
"Set next user" => "Set next user",
"If:SetNextact" => "If:SetNextact",
"Switch construct" => "Switch construct",
"auto" => "auto",
"int" => "int",
"routing" => "routing",
"Instances" => "Instances",
"monitor instances" => "monitor instances",
"monitor workitems" => "monitor workitems",
"Monitor Instances" => "Monitor Instances",
"List of instances" => "List of instances",
"No instances created yet" => "No instances created yet",
"Monitor workitems" => "Monitor workitems",
"List of workitems" => "List of workitems",
"instance" => "instance",
"exception instance" => "exception instance",
"exceptions instance" => "exceptions instance",
"abort instance" => "abort instance",
"grab instance" => "grab instance",
"release instance" => "release instance",
"user instances" => "user instances",
"User Instances" => "User Instances",
"Inst Status" => "Inst Status",
"No instances defined yet" => "No instances defined yet",
"Browsing Workitem" => "Browsing Workitem",
"Workitem information" => "Workitem information",
"since" => "since",
"Permanency" => "Permanency",
"chg" => "chg",
"No chart indicated" => "No chart indicated",
"No instance indicated" => "No instance indicated",
"Role" => "Роль",
"<return> for rows" => "\n для строк",
"1 day" => "1 день",
"1 week" => "1 неделя",
"1 month" => "1 месяц",
"Just Tiki" => "Только Tiki",
"Tiki and PEAR::Auth" => "Tiki и PEAR::Auth",
"Charts" => "Графики",
"charts" => "графики",
"Forums last topics" => "Последние темы в форуме",
"Faq" => "ЧаВо",
"An error occured in a database query!" => "Произошла ошибка в запросе к базе данных!",
"games" => "игры",
"Dynamic content" => "Динамическое содержимое",
"drawing not found" => "рисунок не найден",
"Listing configuration" => "Настройка листинга",
"Tiki email notification" => "Уведомление Tiki по эл.почте",
"menus" => "меню",
"Recently visited pages" => "Последние посещённые страницы",
"Feb" => "Февр",
"Apr" => "Апр",
"Jun" => "Июнь",
"Jul" => "Июль",
"Aug" => "Авг",
"Sep" => "Сент",
"Oct" => "Окт",
"Nov" => "Нояб",
"Dec" => "Дек",
"Last Sites" => "Последние сайты",
"Directory Stats" => "Статистика по каталогу",
"Sites to validate" => "Сайты на проверку",
"Visited links" => "Посещённые ссылки",
"Top Sites" => "Лучшие сайты",
"Last galleries" => "Последние галереи",
"Menu" => "Меню",
"New Messages" => "Новые сообщения",
"New Message" => "Новое сообщение",
"Top games" => "Лучшие игры",
"Number of columns per page when listing categories" => "Число колонок на странице при выводе категорий",
"newsletters" => "рассылки",
"Support" => "Поддержка",
"support" => "поддержка",
"surveys" => "анкетирование",
"Drawings" => "Рисунки",
"Games" => "Игры",
"Newsreader" => "Чтение новостей",
"Workflow engine" => "Механизм выполнения",
"Unknown/Other" => "Не знаю/другая",
"Long date format" => "Длинный формат даты",
"Short date format" => "Короткий формат даты",
"Long time format" => "Длинный формат времени",
"Short time format" => "Короткий формат времени",
"New password" => "Новый пароль",
"HTTP port" => "Порт веб сервера",
"HTTPS port" => "Порт HTTPS сервера",
"Reg users can change theme" => "Пользователи могут менять цветовую тему",
"Slideshows theme" => "Тема для слайд-шоу",
"hits" => "просмотры",
"image gal" => "фотогал",
"file gal" => "файл.гал",
"Edit Chart" => "редактировать чарт",
"Add or edit a chart" => "Добавление/редактирование чарта",
"Users can suggest new items" => "Пользователи могут предлагать новые пункты",
"Auto validate user suggestions" => "Автоматом проверять предложения пользователей",
"Ranking shows" => "Показ рейтинга",
"All items" => "Все пункты",
"Top 10 items" => "Лучшие 10",
"Top 20 items" => "Лучшие 20",
"Top 40 items" => "Лучшие 40",
"Top 50 items" => "Лучшие 50",
"Top 100 items" => "Лучшие 100",
"Top 250 items" => "Лучшие 250",
"Voting system" => "Система голосования",
"Vote items" => "Пункты голосования",
"Rank 1..5" => "Рейтинг 1..5",
"Rank 1..10" => "Рейтинг 1..10",
"Ranking frequency" => "Обновление рейтинга",
"Realtime" => "Реальное время",
"Each 5 minutes" => "Каждые 5 минут",
"Show Average" => "Показать среднее",
"Show Votes" => "Показать гослосования",
"Use Cookies for unregistered users" => "Использовать cookies для незарегистрированных пользователей",
"Users can vote again after" => "Пользователи могут голосовать снова после",
"Anytime" => "В любое время",
"Ranks" => "Рейтинг",
"No charts defined yet" => "Чарты еще не определены",
"Admin drawings" => "Управлять рисунками",
"Available drawings" => "Доступные рисунки",
"Ver" => "Вер.",
"Available polls" => "Доступные опросы",
"Random image from" => "Случайное изображение из",
"Dynamic content blocks" => "Блоки динамического содержимого",
"Banner zones" => "Области для баннеров",
"Admin RSS Modules" => "Управлять RSS модулями",
"Rejected users" => "Пропущенные пользователи",
"Old password" => "Старый пароль",
"Parent category" => "Родительская категория",
"Subcategories" => "Подкатегории",
"Admin related categories" => "Управлять родственными категориями",
"Add a related category" => "Добавить родственную категорию",
"Related categories" => "Родственные категории",
"in current category" => "в текущей категории",
"Total categories" => "Всего категорий",
"creates the editable drawing foo" => "создаёт редактируемый рисунок Х",
"table" => "таблица",
"external link" => "внешних ссылок",
"heading1" => "заголовок 1",
"title bar" => "строка заглавия",
"box" => "рамка",
"rss feed" => "rss поток",
"dynamic content" => "динамическое содержимое",
"tagline" => "подпись",
"center text" => "центрировать текст",
"colored text" => "цветной текст",
"quote" => "цитировать",
"special chars" => "другие символы",
"special characters" => "специальные символы",
"Questions per page" => "Число вопросов на лист",
"Activity completed" => "Активность выполнена",
"Admin process activities" => "Управление активностью",
"Add or edit an activity" => "Добавить/изменить активность",
"activity" => "активность",
"split" => "разделение",
"join" => "объединение",
"standalone" => "независимая",
"interactive" => "интерактивная",
"Add transitions" => "Добавить переход",
"Add transition from:" => "Добавить переход из:",
"Add transition to:" => "Добавить переход к:",
"No roles associated to this activity" => "Нет ролей для данной активности",
"Add Role" => "Добавить роль",
"Add New" => "Добавить новую",
"Process activities" => "Активности процесса",
"Int" => "Инт",
"Routing" => "Маршрутизация",
"Interactive" => "Интерактивные",
"Automatic" => "Автоматические",
"Manual" => "Вручную",
"inter" => "интер",
"route" => "маршрут",
"(no roles)" => "(нет ролей)",
"No activities defined yet" => "Активности ещё не назначены",
"Process Transitions" => "Переход процесса",
"List of transitions" => "Список переходов",
"No transitions defined yet" => "Переходы ещё не определены",
"Add a transition" => "Добавить переход",
"This process is invalid" => "Этот процесс неверный",
"List of processes" => "Список процессов",
"Inactive" => "Неактивно",
"val" => "знач",
"Active Process" => "активный процесс",
"Invalid Process" => "неверный процесс",
"Valid Process" => "корректный процесс",
"Activities" => "Активности",
"New Minor" => "new minor",
"New Major" => "new major",
"No processes defined yet" => "Процессы ещё не определены",
"Admin instance" => "Настроить instance",
"Process:" => "Процесс:",
"exception" => "исключение",
"completed" => "выполнено",
"Send all to" => "Отправить все в",
"Don't move" => "Не перемещать",
"Act status" => "Статус акт",
"Property" => "Свойство",
"Add property" => "Добавить свойство",
"Admin processes" => "Настроить процессы",
"Add or edit a process" => "Добавить/изменить процесс",
"Process Name" => "Имя процесса",
"is active?" => "активен?",
"Or upload a process using this form" => "Или закачать процесс через форму",
"Admin process roles" => "Настроить роли процесса",
"Add or edit a role" => "Добавить/изменить роль",
"Process roles" => "Роли процесса",
"No roles defined yet" => "Роли не определены",
"Map users to roles" => "Присвоить роли пользователям",
"map" => "присвоить",
"Map groups to roles" => "Присвоить роли группам",
"Operation" => "Операция",
"No roles are defined yet so no roles can be mapped" => "Роли ещё не определены, поэтому не могут быть назначены",
"List of mappings" => "Список назначений",
"No mappings defined yet" => "Роли ещё не присвоены",
"Get property" => "Прочитать свойство",
"Set property" => "Установить свойство",
"Process form" => "Форма процесса",
"Set Next act" => "Установить след. акт",
"Map process roles" => "Назначить роли процеса",
"Admin Processes" => "Настройка процессов",
"Admin Activities" => "Настройка активностей",
"Admin Roles" => "Настройка ролей",
"Edit this Process" => "Изменить процесс",
"Monitor Activities" => "Мониторинг активности",
"List of activities" => "Перечень активностей",
"Proc" => "Proc",
"run" => "запуск",
"run activity" => "запуск активности",
"monitor processes" => "мониторинг процессов",
"monitor activities" => "мониторинг активности",
"Monitor Processes" => "Мониторинг процессов",
"processes" => "процессы",
"being run" => "работающие",
"Exceptions" => "Исключения",
"User Activities" => "Активности пользователей",
"user processes" => "процессы пользователей",
"user activities" => "активности пользователей",
"User Processes" => "Процессы пользователей",
"Use cache for external pages" => "Кешировать внешние страницы",
"All games are from" => "Все игры взяты с",
"visit the site for more games and fun" => "посетите сайт для остальных игр",
"Upload a game" => "Залить игру",
"Upload a new game" => "Залить новую игру",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Иконка (если игра называется foo.swf иконка должна иметь имя файла foo.swf.gif или foo.swf.png или foo.swf.jpg)",
"Edit game" => "Редактировать игру",
"Played" => "Посетители сыграли",
"If you can't see the game then you need a flash plugin for your browser" => "Если Вы не видите игры, Вам, возможно, понадобится Flash-плагин для Вашего браузера",
"Accepted requests" => "Принятые запросы",
"Assigned items" => "Назначенные объекты",
"Select news group" => "Выберите группу новостей",
"Back to servers" => "Вернуться к серверам",
"Msgs" => "Сообщ",
"Back to groups" => "Вернуться к группам",
"Reading article from" => "Читаем статью из",
"Back to list of articles" => "Вернуться к списку статей",
"Newsgroup" => "Группа новостей",
"Configure news servers" => "Настроить сервера новостей",
"Select a news server to browse" => "Выберите сервер новостей для просмотра",
"server" => "сервер",
"News server" => "Сервер новостей",
"Current permissions for this object" => "Текущие права доступа для объекта",
"Tiki Shoutbox" => "Tiki Кричалка",
"Current folder" => "Текущая папка",
"Your personal Wiki Page" => "Ваша Личная Wiki Страница",
"Edit Items" => "изменить содержимое",
"List Charts" => "список чартов",
"Last Chart" => "последний чарт",
"Previous Chart" => "предыдущий чарт",
"Chart created" => "Чарт создан",
"Next Chart" => "следующий чарт",
"Avg" => "средне",
"info/vote" => "инфо/голос",
"Next chart will be generated on" => "Следующий чарт будет сгенерирован",
"View or vote items not listed in the chart" => "Смотреть или голосовать за пункты, не указанные в чарте",
"Select something to vote on" => "Выберите предмет голосования",
"Item information" => "Информация о пункте",
"Dif" => "Разн.",
"Best Position" => "Лучшая Позиция",
"Vote this item" => "Голосовать за пункт",
"Highest" => "Высший",
"Q" => "В",
"A" => "О",
"No process indicated" => "Нет процессов для отображения",
"Activity name already exists" => "Название активности уже существует",
"indicates if the process is active. Invalid processes cant be active" => "показывает активен ли процесс. Неверные процессы не могут быть активны",
"No activity indicated" => "Нет активностей для отображения",
"The process name already exists" => "Название процесса уже существует",
"Process already exists" => "Процесс уже существует",
"You cant execute this activity" => "Вы не можете запустить эту активность",
"The thumbnail name must be" => "Имя иконки должно быть",
"No server indicated" => "Сервер не указан",
"Cannot connect to" => "Не могу подключиться к",
"Missing information to read news (server,port,username,password,group) required" => "Недостаточно информации для чтения новостей, требуется (сервер,порт,имя пользователя,пароль,группа)",
"Cannot get messages" => "Невозможно получить сообщения",
"Tiki Calendar" => "Календарь Tiki",
"Admin Menu" => "Управлять меню",
"RSS Modules" => "Модули RSS",
"Chat" => "Чат",
"Tiki Cache/Sys Admin" => "Кеш Tiki",
"Current events" => "Текущие события",
"Last `\$module_rows` visitors" => "`\$module_rows` посетителей",
"Tiki Logo" => "Tiki логотип",
"RSS Feeds" => "RSS Каналы",
"User informations" => "Информация пользователя",
"Group informations" => "Информация группы",
"Email This Post" => "Отправить по эл.почте",
"RSS feeds" => "RSS раздачи",
"Use titles in blog posts" => "Использовать заголовки в записях блогов",
"Send blog post" => "Отослать ссылку на заметку",
"A link to this post was sent to the following addresses:" => "Ссылка на эту заметку блога была отправлена следующим адресатам:",
"Send post to this addresses" => "Отправить заметку по этим адресам",
"List of email addresses separated by commas" => "Список e-mail адресов, разделённых запятыми",
"Post recommendation at" => "Отправить рекомендацию на",
"Prevent flooding" => "Защита от наплыва сообщений",
"Minimum time between posts" => "Минимальное время между сообщениями",
"Moderator user" => "Модератор",
"Moderator group" => "Группа модератора",
"Only allow replies to the first message (flat forum)" => "Разрешить ответы только на первое сообщение (плоский форум)",
"Send this forums posts to this email" => "Копировать сообщения форума на email",
"Prune unreplied messages after" => "Удалять неотвеченные после",
"Prune old messages after" => "Удалять старые сообщения после",
"POP3 server" => "POP3 сервер",
"Max attachment size (bytes)" => "Максимальный размер вложения (в байтах)",
"Default ordering for topics" => "Сортировка тем по умолчанию",
"Topics per page" => "Число тем на страницу",
"Default ordering for threads" => "Сортировка потоков по умолчанию",
"Default style for threads" => "Настройки ответов по умолчанию",
"Includes" => "Добавления",
"Only directly included" => "Только включенные напрямую",
"Assign Perms to this Group" => "Назначить права этой Группе",
"Assign permissions to category" => "Назначить права на категорию",
"Current permissions for this category" => "Установленные права для этой категории",
"Remove from this Category Only" => "Удалить только из этой категории",
"Remove from this Category &amp; all its Children" => "Удалить из этой категории &amp; все вложенные",
"Assign permissions" => "Назначить права",
"to group" => "в группу",
"this category &amp; all its children" => "эта категория &amp; все вложенные",
"this category only" => "только эта категория",
"Your registration code:" => "Ваш код регистрации:",
"Registration code" => "Код регистрации",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "PostgreSQL" => "PostgreSQL",
// "Slovene" => "Slovene",
// "Pijin Solomon" => "Pijin Solomon",
// "The global quota has been reached" => "The global quota has been reached",
// "The quota has been reached in" => "The quota has been reached in",
// "File gallery quota exceeded" => "File gallery quota exceeded",
// "Number of files transfered to the database" => "Number of files transfered to the database",
// "Number of files transfered to the file system" => "Number of files transfered to the file system",
// "Cannot read to this file" => "Cannot read to this file",
// "The uploaded file exceeds the upload_max_filesize directive in php.ini" => "The uploaded file exceeds the upload_max_filesize directive in php.ini",
// "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form" => "The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form",
// "The uploaded file was only partially uploaded. Please try again" => "The uploaded file was only partially uploaded. Please try again",
// "No file was uploaded" => "No file was uploaded",
// "Missing a temporary folder" => "Missing a temporary folder",
// "Failed to write file to disk" => "Failed to write file to disk",
// "File upload stopped by extension" => "File upload stopped by extension",
// "Invalid file mime type" => "Invalid file mime type",
// "XML file does not validate against the Mediawiki XML schema" => "XML file does not validate against the Mediawiki XML schema",
// "Query point" => "Query point",
// "No valid ogr2ogr executable" => "No valid ogr2ogr executable",
// "Could not create \$tdo.mif in data directory" => "Could not create \$tdo.mif in data directory",
// "Could not create \$tdo.mid in data directory" => "Could not create \$tdo.mid in data directory",
// "unknown" => "unknown",
// "User Map Generated in" => "User Map Generated in",
// "Image Map Generated in" => "Image Map Generated in",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Description not available" => "Description not available",
// "Module Title" => "Module Title",
// "Title to display at the top of the box" => "Title to display at the top of the box",
// "No box" => "No box",
// "Show only the content" => "Show only the content",
// "Decorations" => "Decorations",
// "Show module decorations" => "Show module decorations",
// "No title" => "No title",
// "Show module title" => "Show module title",
// "Perspective" => "Perspective",
// "Only display the module if in one of the listed perspectives. Semi-colon separated" => "Only display the module if in one of the listed perspectives. Semi-colon separated",
// "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons" => "Module only applicable for the specified languages. Languages are defined as two character language codes. Multiple values can be separated by semi-colons",
// "Module only applicable for the specified sections. Multiple values can be separated by semi-colons" => "Module only applicable for the specified sections. Multiple values can be separated by semi-colons",
// "Page filter" => "Page filter",
// "Module only applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module only applicable on the specified page names. Multiple values can be separated by semi-colons",
// "No Page" => "No Page",
// "Module not applicable on the specified page names. Multiple values can be separated by semi-colons" => "Module not applicable on the specified page names. Multiple values can be separated by semi-colons",
// "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons" => "Module enabled or disabled depending on the theme. Specified themes can be either included or excluded. Theme names prefixed by \\\"!\\\" are in the exclusion list. Multiple values can be separated by semi-colons",
// "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only creators (y) or only non-creators (n) will see the module",
// "Contributor" => "Contributor",
// "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module" => "Module only available based on the relationship of the user with the wiki page. Either only contributors (y) or only non-contributors (n) will see the module",
// "Flip" => "Flip",
// "Users can shade module" => "Users can shade module",
// "No numbers" => "No numbers",
// "If set to \"y\", the module will not number list items" => "If set to \"y\", the module will not number list items",
// "Number of rows, or items, to display" => "Number of rows, or items, to display",
// "Default: 10" => "Default: 10",
// "section edit" => "section edit",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Users can opt-out internal messages" => "Users can opt-out internal messages",
// "Title length" => "Title length",
// "Publication date" => "Publication date",
// "Expiration date" => "Expiration date",
// "Visible" => "Visible",
// "Default article image width" => "Default article image width",
// "0 for original image size" => "0 for original image size",
// "Default article image height" => "Default article image height",
// "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database" => "Multiple authentication backends are supported by Tikiwiki. The default value is to use the internal user database",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Tiki and LDAP" => "Tiki and LDAP",
// "Shibboleth" => "Shibboleth",
// "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset" => "By default, all languages supported by tikiwiki are available on multilingual sites. This option allows to limit the languages to a subset",
// "Blogues" => "Blogues",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Exclude these categories" => "Exclude these categories",
// "Users can change site language" => "Users can change site language",
// "Allow users to change the language of the menus and labels" => "Allow users to change the language of the menus and labels",
// "Allow anonymous visitors to use the \"Contact Us\" feature" => "Allow anonymous visitors to use the \"Contact Us\" feature",
// "default mapfile" => "default mapfile",
// "Article RSS Description" => "Article RSS Description",
// "Description to be published as part of the RSS feed for articles" => "Description to be published as part of the RSS feed for articles",
// "Show the country flag" => "Show the country flag",
// "Enable cool sites" => "Enable cool sites",
// "'),\n\t\t\t'type' => 'flag" => "'),\n\t\t\t'type' => 'flag",
// "Number of columns per page when listing directory categories" => "Number of columns per page when listing directory categories",
// "6" => "6",
// "'),\n\t\t\t'type' => 'text" => "'),\n\t\t\t'type' => 'text",
// "Method to Open Directory Links" => "Method to Open Directory Links",
// "PHP errors visible to admin only" => "PHP errors visible to admin only",
// "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators" => "For development purposes, it\\'s better to display errors for all users. However, in production settings, they should only be displayed to administrators",
// "PHP Error reporting level" => "PHP Error reporting level",
// "Level from which errors should be reported" => "Level from which errors should be reported",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Report all PHP errors except notices" => "Report all PHP errors except notices",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Faqs" => "Faqs",
// "Collaboratively authored documents with history of changes" => "Collaboratively authored documents with history of changes",
// "Online diaries or journals" => "Online diaries or journals",
// "Collections of graphic images for viewing or downloading (photo album)" => "Collections of graphic images for viewing or downloading (photo album)",
// "Machine Translation (by Google Translate)" => "Machine Translation (by Google Translate)",
// "Uses Google Translate to translate the content of wiki pages to other languages" => "Uses Google Translate to translate the content of wiki pages to other languages",
// "Experimental. This feature is still under development" => "Experimental. This feature is still under development",
// "Database & form generator" => "Database & form generator",
// "Online discussions on a variety of topics. Threaded or flat" => "Online discussions on a variety of topics. Threaded or flat",
// "Computer files, videos or software for downloading. With check-in & check-out (lock)" => "Computer files, videos or software for downloading. With check-in & check-out (lock)",
// "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"" => "Articles can be used for date-specific news and announcements. You can configure articles to automatically publish and expire at specific times or to require that submissions be approved before becoming \"live.\"",
// "Brief list of votable options; appears in module (left or right column)" => "Brief list of votable options; appears in module (left or right column)",
// "Content mailed to registered users" => "Content mailed to registered users",
// "Events calendar with public, private and group channels" => "Events calendar with public, private and group channels",
// "Insert, track, and manage advertising banners" => "Insert, track, and manage advertising banners",
// "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions" => "Global category system. Items of different types (wiki pages, articles, tracker items, etc) can be added to one or many categories. Categories can have permissions",
// "Score is a game to motivate participants to increase their contribution by comparing to other users" => "Score is a game to motivate participants to increase their contribution by comparing to other users",
// "Enables searching for content on the website" => "Enables searching for content on the website",
// "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns" => "Allows to set tags on pages and various objects within the website and generate tag cloud navigation patterns",
// "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis" => "Allows to keep track of what users are doing and produce reports on a per-user or per-category basis",
// "Contribution" => "Contribution",
// "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports" => "Allows users to specify the type of contribution they are making while editing objects. The contributions are then displayed as color-coded in history and other reports",
// "Enables internationalization features and multilingual support for then entire site" => "Enables internationalization features and multilingual support for then entire site",
// "Frequently asked questions and answers" => "Frequently asked questions and answers",
// "Questionnaire with multiple choice or open ended question" => "Questionnaire with multiple choice or open ended question",
// "User-submitted Web links" => "User-submitted Web links",
// "Quizzes " => "Quizzes ",
// "Timed questionnaire with recorded scores" => "Timed questionnaire with recorded scores",
// "Simple menu system which can optionally add an external web page in an iframe" => "Simple menu system which can optionally add an external web page in an iframe",
// "The Copyright Management System (or ©MS) is a way of licensing your content" => "The Copyright Management System (or ©MS) is a way of licensing your content",
// "The applet is designed to read MP3 or FLV file" => "The applet is designed to read MP3 or FLV file",
// "Experimental. This feature is not actively maintained" => "Experimental. This feature is not actively maintained",
// "Quick comment (graffiti) box. Like a group chat, but not in real time" => "Quick comment (graffiti) box. Like a group chat, but not in real time",
// "Navigable, interactive maps with user-selectable layers" => "Navigable, interactive maps with user-selectable layers",
// "Requires mapserver" => "Requires mapserver",
// "Google Maps" => "Google Maps",
// "Interactive use of Google Maps" => "Interactive use of Google Maps",
// "One-on-one chatting with customer" => "One-on-one chatting with customer",
// "Add a link \"Email this page\" in all the pages" => "Add a link \"Email this page\" in all the pages",
// "Static and dynamic HTML content" => "Static and dynamic HTML content",
// "HTML can be used in wiki pages. This is a separate feature" => "HTML can be used in wiki pages. This is a separate feature",
// "Basic form from visitor to admin" => "Basic form from visitor to admin",
// "Real-time group text chatting" => "Real-time group text chatting",
// "Comments Moderation " => "Comments Moderation ",
// "An admin must validate a comment before it is visible" => "An admin must validate a comment before it is visible",
// "Comments can be closed (no new comments)" => "Comments can be closed (no new comments)",
// "Allow posting of comments as Anonymous" => "Allow posting of comments as Anonymous",
// "Permit anonymous visitors to add a comment without needing to create an account" => "Permit anonymous visitors to add a comment without needing to create an account",
// "Display page description" => "Display page description",
// "Display the page description below the heading when viewing the page" => "Display the page description below the heading when viewing the page",
// "Display page title" => "Display page title",
// "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header" => "Display the page name at the top of each page. If not enabled, the content must be structured to contain a header",
// "Display page ID" => "Display page ID",
// "Display the internal page ID when viewing the page" => "Display the internal page ID when viewing the page",
// "Individual wiki cache" => "Individual wiki cache",
// "Allow users to change the duration of the cache on a per-page basis" => "Allow users to change the duration of the cache on a per-page basis",
// "JS Calendar" => "JS Calendar",
// "PHPLayers" => "PHPLayers",
// "PhpLayers Dynamic menus" => "PhpLayers Dynamic menus",
// "Output should be HTMLPurified" => "Output should be HTMLPurified",
// "This enable HTPMPurifier on outputs to filter remaining security problems like XSS" => "This enable HTPMPurifier on outputs to filter remaining security problems like XSS",
// "Full Screen" => "Full Screen",
// "Css Menus" => "Css Menus",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Quick Permission Assignment" => "Quick Permission Assignment",
// "Quickperms allow to define classes of privileges and grant them to roles on objects" => "Quickperms allow to define classes of privileges and grant them to roles on objects",
// "HTML Purifier" => "HTML Purifier",
// "Ajax" => "Ajax",
// "Mobile" => "Mobile",
// "Morcego 3D browser" => "Morcego 3D browser",
// "Intertiki" => "Intertiki",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "Search engine friendly url" => "Search engine friendly url",
// "SpreadSheet" => "SpreadSheet",
// "Save draft" => "Save draft",
// "Requires AJAX (experimental)" => "Requires AJAX (experimental)",
// "Kaltura" => "Kaltura",
// "Users can identify other users as their friends" => "Users can identify other users as their friends",
// "Neglected feature" => "Neglected feature",
// "Action calendar" => "Action calendar",
// "Redirect to a similar wiki page if an exact match is not found" => "Redirect to a similar wiki page if an exact match is not found",
// "Daily Reports for User Watches" => "Daily Reports for User Watches",
// "User Watches Translations" => "User Watches Translations",
// "Use Minified Scripts" => "Use Minified Scripts",
// "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions" => "These JavaScript files have been previously minified and are stable. They make pages quicker to load than their non-minified versions",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "Protect against CSRF with a ticket" => "Protect against CSRF with a ticket",
// "Lookup the user\\'s preferred language through browser preferences" => "Lookup the user\\'s preferred language through browser preferences",
// "Show pages in user\\'s preferred language" => "Show pages in user\\'s preferred language",
// "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page" => "When accessing a page which has an equivalent in the user\\'s preferred language, favor the translated page",
// "Changing the page language also changes the site language" => "Changing the page language also changes the site language",
// "Translation assistant" => "Translation assistant",
// "Track translation operations between pages" => "Track translation operations between pages",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users" => "Allow to flag changes as urgent, leading translations to be marked with a notice visible to all users",
// "Incomplete translation notice" => "Incomplete translation notice",
// "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete" => "When a page is translated to a new language, a notice will be automatically be inserted into the page to indicate that the translation is not yet complete",
// "Multilingual structures" => "Multilingual structures",
// "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures" => "Structures to lookup equivalent pages in other languages. May cause performance problems on larger structures",
// "Display all languages in a single page" => "Display all languages in a single page",
// "List all languages as a language option in the page language drop list to see all languages at once" => "List all languages as a language option in the page language drop list to see all languages at once",
// "GZip output" => "GZip output",
// "Help System" => "Help System",
// "Translation URLs" => "Translation URLs",
// "Show clickable URLs to translate the page to another language using Babel Fish website" => "Show clickable URLs to translate the page to another language using Babel Fish website",
// "Translation icons" => "Translation icons",
// "Show clickable icons to translate the page to another language using Babelfish website" => "Show clickable icons to translate the page to another language using Babelfish website",
// "Also known as emoticons" => "Also known as emoticons",
// "Bloc of content which can be reused and programmed (timed)" => "Bloc of content which can be reused and programmed (timed)",
// "Use File Galleries to store pictures" => "Use File Galleries to store pictures",
// "External link icon" => "External link icon",
// "Semantic links" => "Semantic links",
// "Going beyond Backlinks, allows to define some semantic relationships between wiki pages" => "Going beyond Backlinks, allows to define some semantic relationships between wiki pages",
// "Web Services" => "Web Services",
// "Can consume webservices in JSON or YAML" => "Can consume webservices in JSON or YAML",
// "Breadcrumbs" => "Breadcrumbs",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Show module controls" => "Show module controls",
// "Perspectives" => "Perspectives",
// "Permits to override preferences" => "Permits to override preferences",
// "Search and replace" => "Search and replace",
// "Permits find and replace of content in the edit box" => "Permits find and replace of content in the edit box",
// "Specify notification emails when creating articles" => "Specify notification emails when creating articles",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "Ignore category viewing restrictions" => "Ignore category viewing restrictions",
// "Screencasts" => "Screencasts",
// "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share" => "Allow to upload screencasts from wiki edit. Screencasts can be uploaded locally or on a WebDAV share",
// "Screencasts upload location" => "Screencasts upload location",
// "Local path or webdav path to the file upload location" => "Local path or webdav path to the file upload location",
// "Trailing slash required" => "Trailing slash required",
// "Screencasts HTTP prefix" => "Screencasts HTTP prefix",
// "Prefix to use for the files when generating a link to it" => "Prefix to use for the files when generating a link to it",
// "Screencast upload type" => "Screencast upload type",
// "Mode used to upload files. WebDav is used to upload to remote servers" => "Mode used to upload files. WebDav is used to upload to remote servers",
// "Local" => "Local",
// "Webdav" => "Webdav",
// "Screencasts authentication user" => "Screencasts authentication user",
// "When using webdav to upload files, used as the username of the authentication credentials" => "When using webdav to upload files, used as the username of the authentication credentials",
// "Screencasts authentication password" => "Screencasts authentication password",
// "When using webdav to upload files, used as the password of the authentication credentials" => "When using webdav to upload files, used as the password of the authentication credentials",
// "Screencasts max file size" => "Screencasts max file size",
// "Maximum file size used for screencasts" => "Maximum file size used for screencasts",
// "Value provided in bytes" => "Value provided in bytes",
// "Page List" => "Page List",
// "The pagelist feature allows to maintain lists of pages and their associated score and priority" => "The pagelist feature allows to maintain lists of pages and their associated score and priority",
// "Database search" => "Database search",
// "Referer Search Highlighting" => "Referer Search Highlighting",
// "Ignore individual object permissions" => "Ignore individual object permissions",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Pertinence" => "Pertinence",
// "Object type" => "Object type",
// "Last modified date" => "Last modified date",
// "Blog-level" => "Blog-level",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Forum name search" => "Forum name search",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Store password as plain text" => "Store password as plain text",
// "Admins can search for features in the admin panels" => "Admins can search for features in the admin panels",
// "Encryption method" => "Encryption method",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Add a Powered by Tiki link on your site's footer" => "Add a Powered by Tiki link on your site's footer",
// "The server must be able to read the directory" => "The server must be able to read the directory",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Quota for all the files and archives" => "Quota for all the files and archives",
// "(0 for illimitted)" => "(0 for illimitted)",
// "Quota can be defined for each file gallery" => "Quota can be defined for each file gallery",
// "Default quota for each new gallery" => "Default quota for each new gallery",
// "Show quota bar in the list page" => "Show quota bar in the list page",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Display thread configuration bar only when number of posts exceed" => "Display thread configuration bar only when number of posts exceed",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Description length" => "Description length",
// "Do not prefix messages titles by 'Re: '" => "Do not prefix messages titles by 'Re: '",
// "Multilingual tags" => "Multilingual tags",
// "Permits translation management of tags" => "Permits translation management of tags",
// "Label visible in the browser\\'s title bar on all pages. Also appears in search engines" => "Label visible in the browser\\'s title bar on all pages. Also appears in search engines",
// "Validate new user registrations by email" => "Validate new user registrations by email",
// "Upon registration, the new user will receive an email containing a link to confirm validity" => "Upon registration, the new user will receive an email containing a link to confirm validity",
// "Landing page used for the wiki when no page is specified. The page will be created if it does not exist" => "Landing page used for the wiki when no page is specified. The page will be created if it does not exist",
// "Site language used when no other language is specified by the user" => "Site language used when no other language is specified by the user",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "Help URL" => "Help URL",
// "The default help system may not be complete. You can help with the TikiWiki documentation" => "The default help system may not be complete. You can help with the TikiWiki documentation",
// "Full path to gdaltindex" => "Full path to gdaltindex",
// "Full path to ogr2ogr" => "Full path to ogr2ogr",
// "Map Zone" => "Map Zone",
// "[-180 180]" => "[-180 180]",
// "[0 360]" => "[0 360]",
// "Hide anonymous-only modules from registered users" => "Hide anonymous-only modules from registered users",
// "Maximum number of articles on articles home page" => "Maximum number of articles on articles home page",
// "Url to go when clicking on a username" => "Url to go when clicking on a username",
// "Default: " => "Default: ",
// "Remind/forgot password" => "Remind/forgot password",
// "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user" => "If passwords <em>are not</em> plain text, reset instructions will be emailed to the user",
// "If passwords <em>are stored</em> as plain text, the password will be emailed to the user" => "If passwords <em>are stored</em> as plain text, the password will be emailed to the user",
// "Verify for available translations in the database" => "Verify for available translations in the database",
// "Language inclusion threshold" => "Language inclusion threshold",
// "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages" => "When the number of languages is restricted on the site, and is below this number, all languages will be added to the preferred language list, even if unspecified by the user. However, priority will be given to the specified languages",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "Log queries using more than (seconds)" => "Log queries using more than (seconds)",
// "This may impact performance" => "This may impact performance",
// "Mail end of line" => "Mail end of line",
// "full path to mapfiles" => "full path to mapfiles",
// "Wiki Page for Help" => "Wiki Page for Help",
// "Wiki Page for Comments" => "Wiki Page for Comments",
// "Memcache" => "Memcache",
// "Enable connection to memcached servers to store temporary information" => "Enable connection to memcached servers to store temporary information",
// "Requires the PHP memcache extension" => "Requires the PHP memcache extension",
// "Memcache flags" => "Memcache flags",
// "Configuration switches for memcache connection" => "Configuration switches for memcache connection",
// "Memcache servers" => "Memcache servers",
// "Server list which may be accessed. For each server, the address, port and weight must be specified" => "Server list which may be accessed. For each server, the address, port and weight must be specified",
// "One per line. address:port (weight)" => "One per line. address:port (weight)",
// "Memcache key prefix" => "Memcache key prefix",
// "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts" => "When the memcache cluster is used by multiple applications, using unique prefixes for each of them helps avoiding conflicts",
// "Memcache expiration" => "Memcache expiration",
// "Duration for which the data will be kept" => "Duration for which the data will be kept",
// "Cache wiki data in memcache" => "Cache wiki data in memcache",
// "Cache wiki output in memcache" => "Cache wiki output in memcache",
// "Cache forum output in memcache" => "Cache forum output in memcache",
// "Allow users to define icons for menus entries" => "Allow users to define icons for menus entries",
// "Default path for the icons" => "Default path for the icons",
// "Maximum mailbox size (messages, 0=unlimited)" => "Maximum mailbox size (messages, 0=unlimited)",
// "Maximum mail archive size (messages, 0=unlimited)" => "Maximum mail archive size (messages, 0=unlimited)",
// "Maximum sent box size (messages, 0=unlimited)" => "Maximum sent box size (messages, 0=unlimited)",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Use individual page description for Wiki pages instead" => "Use individual page description for Wiki pages instead",
// "geo.position" => "geo.position",
// "geo.region" => "geo.region",
// "geo.placename" => "geo.placename",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "Multi-domain" => "Multi-domain",
// "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance" => "Allows to map domain names to perspectives and simulate multiple domains hosted on the same instance",
// "Multi-domain Configuration" => "Multi-domain Configuration",
// "Comma-separated values mapping the domain name to the perspective ID" => "Comma-separated values mapping the domain name to the perspective ID",
// "One domain per line. Comma separated with perspective ID" => "One domain per line. Comma separated with perspective ID",
// "Wiki buttons" => "Wiki buttons",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Top " => "Top ",
// "Bottom" => "Bottom",
// "Neither" => "Neither",
// "Host" => "Host",
// "Proxy host" => "Proxy host",
// "Proxy port" => "Proxy port",
// "Quantify change size" => "Quantify change size",
// "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page" => "In addition to tracking the changes, track the change size and display the approximate up-to-date-ness of the page",
// "Keep track of the unsuccessful attemps to translate strings" => "Keep track of the unsuccessful attemps to translate strings",
// "Restrict supported languages" => "Restrict supported languages",
// "Limit the languages made available on the site" => "Limit the languages made available on the site",
// "Refresh mode" => "Refresh mode",
// "Random" => "Random",
// "Minimum length of search word" => "Minimum length of search word",
// "Max. number of words containing a syllable" => "Max. number of words containing a syllable",
// "Max. age in hours of syllable search cache" => "Max. age in hours of syllable search cache",
// "LRU list purging rate" => "LRU list purging rate",
// "LRU list length" => "LRU list length",
// "Parse the results" => "Parse the results",
// "Email address that will be used as the sender for outgoing emails" => "Email address that will be used as the sender for outgoing emails",
// "Session storage location" => "Session storage location",
// "Select where the session information should be stored. Memcache sessions require memcache to be configured" => "Select where the session information should be stored. Memcache sessions require memcache to be configured",
// "Default (from php.ini)" => "Default (from php.ini)",
// "Session lifetime" => "Session lifetime",
// "Value provided in minutes" => "Value provided in minutes",
// "Silent session" => "Silent session",
// "Do not automatically start sessions" => "Do not automatically start sessions",
// "Session cookie name" => "Session cookie name",
// "Session cookie name used instead of the PHP default configuration" => "Session cookie name used instead of the PHP default configuration",
// "Display available translations" => "Display available translations",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Site title location" => "Site title location",
// "Location of the site title in the browser title bar relative to the current page\\'s descriptor" => "Location of the site title in the browser title bar relative to the current page\\'s descriptor",
// "Browser title display mode" => "Browser title display mode",
// "When breadcrumbs are used, method in which the browser title should be displayed" => "When breadcrumbs are used, method in which the browser title should be displayed",
// "Most specific first" => "Most specific first",
// "Least specific first (site)" => "Least specific first (site)",
// "Current only" => "Current only",
// "Include smarty notices in PHP error report" => "Include smarty notices in PHP error report",
// "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur" => "In most cases, smarty notices can be safely ignored. However, they may be useful in the development process when strange issues occur",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Minify javascript" => "Minify javascript",
// "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared" => "Compress javascript files used in the page into a single file to be distributed statically. Changes to javascript files will require cache to be cleared",
// "Use Jquery autocomplete user selector for better performance when number of users exceed" => "Use Jquery autocomplete user selector for better performance when number of users exceed",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Use proxy" => "Use proxy",
// "Show user\\'s real name instead of login (when possible)" => "Show user\\'s real name instead of login (when possible)",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Users can shade modules" => "Users can shade modules",
// "Always" => "Always",
// "Module decides" => "Module decides",
// "Maximum size for each attachment" => "Maximum size for each attachment",
// "500Kb" => "500Kb",
// "1Mb" => "1Mb",
// "1.5Mb" => "1.5Mb",
// "2Mb" => "2Mb",
// "2.5Mb" => "2.5Mb",
// "3Mb" => "3Mb",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Wiki link format" => "Wiki link format",
// "Character set used when detecting wiki links within pages" => "Character set used when detecting wiki links within pages",
// "Latin" => "Latin",
// "Display by default only pages in current language" => "Display by default only pages in current language",
// "In Wiki page lists, display by default only pages in current language" => "In Wiki page lists, display by default only pages in current language",
// "Display page version" => "Display page version",
// "Display the page version information when viewing the page" => "Display the page version information when viewing the page",
// "Page name display stripper" => "Page name display stripper",
// "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed" => "Character to use as a delimiter in the page name. The portion of the name after this character will not be displayed",
// "Wiki author list style" => "Wiki author list style",
// "Changes the list format used to display the authors of the page" => "Changes the list format used to display the authors of the page",
// "Creator & Author" => "Creator & Author",
// "none (disabled)" => "none (disabled)",
// "Specify wiki author list style per page" => "Specify wiki author list style per page",
// "Allows to modify the style in which the author list is displayed on a per-page basis" => "Allows to modify the style in which the author list is displayed on a per-page basis",
// "Wiki action bar location" => "Wiki action bar location",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Wiki navigation bar location" => "Wiki navigation bar location",
// "Wiki top line location" => "Wiki top line location",
// "Cache wiki pages (global)" => "Cache wiki pages (global)",
// "Enable page cache globally for wiki pages" => "Enable page cache globally for wiki pages",
// "Allow comments per page" => "Allow comments per page",
// "Enable control for comments on wiki pages individually" => "Enable control for comments on wiki pages individually",
// "Enable (default On)" => "Enable (default On)",
// "Enable (default Off)" => "Enable (default Off)",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "Permits editing of a plugin, via a popup form, without needing to edit the whole page" => "Permits editing of a plugin, via a popup form, without needing to edit the whole page",
// "Enable wiki 3D browser" => "Enable wiki 3D browser",
// "Load page on navigation" => "Load page on navigation",
// "Browser height" => "Browser height",
// "Navigation depth" => "Navigation depth",
// "Node size" => "Node size",
// "Text size" => "Text size",
// "Spring (connection) size" => "Spring (connection) size",
// "Existing page node color" => "Existing page node color",
// "Missing page node color" => "Missing page node color",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Camera distance" => "Camera distance",
// "Field of view" => "Field of view",
// "Feed animation interval (milisecs)" => "Feed animation interval (milisecs)",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Eletrostatic constant" => "Eletrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Enable plugin %0" => "Enable plugin %0",
// "Inline plugin %0 (hide plugin edit icon)" => "Inline plugin %0 (hide plugin edit icon)",
// "When inlined, the plugin edit icon will not appear" => "When inlined, the plugin edit icon will not appear",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "... and is displayed by default" => "... and is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Office 2003" => "Office 2003",
// "Silver" => "Silver",
// "Nothing was changed, please check profile for errors" => "Nothing was changed, please check profile for errors",
// "An error occurred: " => "An error occurred: ",
// "Applying profile" => "Applying profile",
// "Added (or modified)" => "Added (or modified)",
// "Preference set" => "Preference set",
// "Group changed (or modified)" => "Group changed (or modified)",
// "User %0 was added to %1" => "User %0 was added to %1",
// "No name" => "No name",
// "Bad object" => "Bad object",
// "uploaded the file" => "uploaded the file",
// "changes" => "changes",
// "No changes" => "No changes",
// "Yesterday" => "Yesterday",
// "more changes of the same type.." => "more changes of the same type..",
// "changed the picture gallery" => "changed the picture gallery",
// "uploaded the picture" => "uploaded the picture",
// "onto" => "onto",
// "removed the picture" => "removed the picture",
// "edited the wikipage" => "edited the wikipage",
// "this history" => "this history",
// "all history" => "all history",
// "edited the file gallery" => "edited the file gallery",
// "removed the file" => "removed the file",
// "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category" => "added the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"to the category",
// "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category" => "removed the \".\$change['data']['objectType']).\" <a href=\"\$tikiUrl/\".\$change['data']['objectUrl'].\"\">\".\$change['data']['objectName'].\"</a> \".tra(\"from the category",
// "created the subcategory" => "created the subcategory",
// "removed the subcategory" => "removed the subcategory",
// "edited the category" => "edited the category",
// "removed the article" => "removed the article",
// "created the article" => "created the article",
// "edited the article" => "edited the article",
// "replied to the blog" => "replied to the blog",
// "created the topic" => "created the topic",
// "at forum" => "at forum",
// "replied" => "replied",
// "to the topic" => "to the topic",
// "Nothing has happened" => "Nothing has happened",
// "Feed provided by %s. Click to visit" => "Feed provided by %s. Click to visit",
// "Have your profile seen" => "Have your profile seen",
// "You are not in group of friends to have the content of this block displayed for you" => "You are not in group of friends to have the content of this block displayed for you",
// "Smarty block.display.php: Missing error param" => "Smarty block.display.php: Missing error param",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "tip" => "tip",
// "warning" => "warning",
// "note" => "note",
// "errors" => "errors",
// "Tab View" => "Tab View",
// "No Tabs" => "No Tabs",
// "If you want the saved version instead of this autosaved one" => "If you want the saved version instead of this autosaved one",
// "Your edit session will expire in" => "Your edit session will expire in",
// "You must PREVIEW or SAVE your work now, to avoid losing your edits" => "You must PREVIEW or SAVE your work now, to avoid losing your edits",
// "Your edit session has expired" => "Your edit session has expired",
// "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page" => "You are about to leave this page. Changes since your last save will be lost. Are you sure you want to exit this page",
// "Preference name not specified" => "Preference name not specified",
// "Preference %0 is not defined" => "Preference %0 is not defined",
// "No rows found" => "No rows found",
// "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxColumnIndex doesn not match items in _checkbox",
// "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox" => "{treetable}: Number of items in _checkboxTitles doesn not match items in _checkbox",
// "Toggle sections" => "Toggle sections",
// "Permission denied: the specified wiki page cannot be used as Smarty template resource" => "Permission denied: the specified wiki page cannot be used as Smarty template resource",
// "First day of week: Sunday (its ID is 0) - translators you need to localize this string" => "First day of week: Sunday (its ID is 0) - translators you need to localize this string",
// "Face" => "Face",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "arts" => "arts",
// "smiling" => "smiling",
// "grinning" => "grinning",
// "confused" => "confused",
// "crying" => "crying",
// "frightened" => "frightened",
// "evil stuff" => "evil stuff",
// "exclamation mark " => "exclamation mark ",
// "frowning" => "frowning",
// "light bulb" => "light bulb",
// "idea " => "idea ",
// "LOL" => "LOL",
// "laughing out loud " => "laughing out loud ",
// "mr. green laughing" => "mr. green laughing",
// "The file was uploaded with success" => "The file was uploaded with success",
// "No file was uploaded. Was a file selected " => "No file was uploaded. Was a file selected ",
// "A temporary folder is missing" => "A temporary folder is missing",
// "Unknown error" => "Unknown error",
// "Sea Surfing (CSRF) detected. Operation blocked" => "Sea Surfing (CSRF) detected. Operation blocked",
// "Bold" => "Bold",
// "pics/icons/text_bold.png" => "pics/icons/text_bold.png",
// "Italic" => "Italic",
// "pics/icons/text_italic.png" => "pics/icons/text_italic.png",
// "Strikethrough" => "Strikethrough",
// "pics/icons/text_strikethrough.png" => "pics/icons/text_strikethrough.png",
// "Non-parsed" => "Non-parsed",
// "pics/icons/noparse.png" => "pics/icons/noparse.png",
// "Align Center" => "Align Center",
// "pics/icons/text_align_center.png" => "pics/icons/text_align_center.png",
// "Horizontal Bar" => "Horizontal Bar",
// "pics/icons/page.png" => "pics/icons/page.png",
// "Page Break" => "Page Break",
// "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif" => "lib/fckeditor_tiki/fckeditor-icons/Pagebreak.gif",
// "Block Quote" => "Block Quote",
// "pics/icons/box.png" => "pics/icons/box.png",
// "pics/icons/book.png" => "pics/icons/book.png",
// "Unordered List" => "Unordered List",
// "pics/icons/text_list_bullets.png" => "pics/icons/text_list_bullets.png",
// "Ordered List" => "Ordered List",
// "pics/icons/text_list_numbers.png" => "pics/icons/text_list_numbers.png",
// "Special Characters" => "Special Characters",
// "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif" => "lib/fckeditor_tiki/fckeditor-icons/Specialchar.gif",
// "img/smiles/icon_smile.gif" => "img/smiles/icon_smile.gif",
// "Foreground color" => "Foreground color",
// "pics/icons/palette.png" => "pics/icons/palette.png",
// "pics/icons/palette_bg.png" => "pics/icons/palette_bg.png",
// "Wiki Link" => "Wiki Link",
// "pics/icons/page_link.png" => "pics/icons/page_link.png",
// "External Link" => "External Link",
// "pics/icons/world_link.png" => "pics/icons/world_link.png",
// "pics/icons/table.png" => "pics/icons/table.png",
// "Table Builder" => "Table Builder",
// "pics/icons/find.png" => "pics/icons/find.png",
// "Find Text" => "Find Text",
// "pics/icons/text_replace.png" => "pics/icons/text_replace.png",
// "Text Replace" => "Text Replace",
// "Full Screen Edit" => "Full Screen Edit",
// "pics/icons/arrow_in.png" => "pics/icons/arrow_in.png",
// "pics/icons/arrow_out.png" => "pics/icons/arrow_out.png",
// "Wiki Help" => "Wiki Help",
// "Choose or upload images" => "Choose or upload images",
// "pics/icons/pictures.png" => "pics/icons/pictures.png",
// "Switch Editor (wiki or WYSIWYG)" => "Switch Editor (wiki or WYSIWYG)",
// "pics/icons/pencil_go.png" => "pics/icons/pencil_go.png",
// "Admin Toolbars" => "Admin Toolbars",
// "Upload was not successful. Duplicate file content " => "Upload was not successful. Duplicate file content ",
// "Item Modification" => "Item Modification",
// "Item creation" => "Item creation",
// "View the tracker item at" => "View the tracker item at",
// "Field is not numeric" => "Field is not numeric",
// "Field is not a link to mp3 in the gallery" => "Field is not a link to mp3 in the gallery",
// "Field is not a link to FLV in the gallery" => "Field is not a link to FLV in the gallery",
// "Field is not a link to FLV or MP3 in the gallery" => "Field is not a link to FLV or MP3 in the gallery",
// "half column" => "half column",
// "prepend" => "prepend",
// "append" => "append",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max,autocomplete</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[autocomplete]</strong> if y autocomplete while typing;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>toolbars,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[toolbars]</strong> enables toolbars if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>",
// "numeric field" => "numeric field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "radio buttons" => "radio buttons",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "IP selector" => "IP selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "country selector" => "country selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "jscalendar" => "jscalendar",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example:\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "header" => "header",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "item link" => "item link",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "items list" => "items list",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an url in a wiki syntax.\n\t\t\t\t</dl>",
// "multimedia" => "multimedia",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "system" => "system",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u|m] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its size (n), the username of the uploader (u), or the mediaplayer plugin(m);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "in group" => "in group",
// "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows to display if a item user is in a group and when he was assigned to the group (needs a user selector field)\n\t\t\t\t<dt>Usage: <strong>groupName,date</strong>\n\t\t\t\t<dt>Example: Members,date\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>GroupName</strong> Group to test. <strong>date</strong> displays the date the user was assigned in the group (if known), otherwise will display yes/no.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "No extra information for that attached file. " => "No extra information for that attached file. ",
// "The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "The registration mail can't be sent because there is no server email address set, and this feature is disabled",
// "The user email confirmation can't be sent. Contact the administrator" => "The user email confirmation can't be sent. Contact the administrator",
// "Mailbox uninitialised??" => "Mailbox uninitialised??",
// "No mail body found" => "No mail body found",
// "Info required - IP|SVRSW|BROWSER" => "Info required - IP|SVRSW|BROWSER",
// "Displays browser client info" => "Displays browser client info",
// "Anchor Link" => "Anchor Link",
// "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin",
// "Anchor link label" => "Anchor link label",
// "The anchor name as defined in the ANAME plugin" => "The anchor name as defined in the ANAME plugin",
// "The name of the wiki page containing the anchor" => "The name of the wiki page containing the anchor",
// "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor" => "Creates a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which specifies the location and name of the anchor",
// "linktext" => "linktext",
// "Anchor Name" => "Anchor Name",
// "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin",
// "The name of the anchor" => "The name of the anchor",
// "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor" => "Creates an anchor in a wiki page. Use in conjunction with the ALINK plugin, which specifies a link to the anchor",
// "Autogenerated content. Leave blank initially" => "Autogenerated content. Leave blank initially",
// "Absolute URL to the image or relative path from tikiwiki root" => "Absolute URL to the image or relative path from tikiwiki root",
// "Includes an article\\'s content within the page" => "Includes an article\\'s content within the page",
// "Field" => "Field",
// "The article field to display. Default field is Heading" => "The article field to display. Default field is Heading",
// "Article ID" => "Article ID",
// "The article to display. If no value is provided, most recent article will be used" => "The article to display. If no value is provided, most recent article will be used",
// "Includes an article" => "Includes an article",
// "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
// "Id is optional. If not given, last article is used. Default field is heading" => "Id is optional. If not given, last article is used. Default field is heading",
// "Article List" => "Article List",
// "Inserts a list of articles in the page" => "Inserts a list of articles in the page",
// "Articles displayed" => "Articles displayed",
// "The number of articles to display in the list" => "The number of articles to display in the list",
// "Topics expression" => "Topics expression",
// "Topic ID expression" => "Topic ID expression",
// "Type expression" => "Type expression",
// "Category ID" => "Category ID",
// "The ID of the category to list from" => "The ID of the category to list from",
// "The article language to list" => "The article language to list",
// "Sort order" => "Sort order",
// "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")" => "The column and order of the sort in columnName_asc or columnName_desc format. Defaults to \"publishDate_desc\" (other column examples are \"title\", \"lang\", \"authorName\" & \"topicName\")",
// "Quiet" => "Quiet",
// "Whether to not report when there are no articles" => "Whether to not report when there are no articles",
// "Title only" => "Title only",
// "Whether to only show the title of the articles" => "Whether to only show the title of the articles",
// "Show body" => "Show body",
// "Whether to only show the body of the articles or just the heading" => "Whether to only show the body of the articles or just the heading",
// "Starting article" => "Starting article",
// "The article number that the list should start with" => "The article number that the list should start with",
// "Earliest date to select articles from" => "Earliest date to select articles from",
// "Latest date to select articles from" => "Latest date to select articles from",
// "Override Dates" => "Override Dates",
// "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings" => "Whether obey article type\\'s \"show before publish\" and \"show after expiry\" settings",
// "Container class" => "Container class",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_articles\")",
// "Includes articles listing into a wiki page" => "Includes articles listing into a wiki page",
// "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
// "Bullets" => "Bullets",
// "Inline" => "Inline",
// "Number" => "Number",
// "Show icon" => "Show icon",
// "Displays an attachment or a list of them" => "Displays an attachment or a list of them",
// "Gives the name of the attached file to link to" => "Gives the name of the attached file to link to",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Makes the text between the {ATTACH} tags the link text instead of the file name or description" => "Makes the text between the {ATTACH} tags the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "The wiki page the avatar will link to" => "The wiki page the avatar will link to",
// "Float" => "Float",
// "left|right" => "left|right",
// "Displays a link that allows to go back in the browser history" => "Displays a link that allows to go back in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed information" => "Displayed information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "1|0" => "1|0",
// "No Header" => "No Header",
// "List all pages that link to specific pages" => "List all pages that link to specific pages",
// "No pages links to" => "No pages links to",
// "One page links to" => "One page links to",
// "pages link to" => "pages link to",
// "Banner" => "Banner",
// "Insert a banner" => "Insert a banner",
// "Target" => "Target",
// "missing parameter" => "missing parameter",
// "Blog List" => "Blog List",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "Numeric value" => "Numeric value",
// "Maximum number of entries to list" => "Maximum number of entries to list",
// "Simple list" => "Simple list",
// "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)" => "Show simple list of date, title and author (default=y) or formatted list of blog posts (n)",
// "Earliest date to select posts from" => "Earliest date to select posts from",
// "Latest date to select posts from" => "Latest date to select posts from",
// "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")" => "CSS Class to add to the container DIV.article. (Default=\"wikiplugin_bloglist\")",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Box" => "Box",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Float Position" => "Float Position",
// "for box with width less than 100%, make text wrap around the box" => "for box with width less than 100%, make text wrap around the box",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Includes a calendar and/or a list of calendar events" => "Includes a calendar and/or a list of calendar events",
// "Calendar filter" => "Calendar filter",
// "If set to a calendar identifier, restricts the events displayed to those in the specified calendar" => "If set to a calendar identifier, restricts the events displayed to those in the specified calendar",
// "View type" => "View type",
// "Determines how to show events" => "Determines how to show events",
// "Possible values" => "Possible values",
// "\"table\" shows events in a calendar" => "\"table\" shows events in a calendar",
// "Default value" => "Default value",
// "Calendar view type time span" => "Calendar view type time span",
// "If in calendar (or \"table\") view type, determines the time span displayed by the calendar" => "If in calendar (or \"table\") view type, determines the time span displayed by the calendar",
// "View the navigation bar" => "View the navigation bar",
// "Decide or not to show the navigation bar" => "Decide or not to show the navigation bar",
// "Includes a calendar" => "Includes a calendar",
// "~np~{CALENDAR(calendarId=>1)}{CALENDAR}" => "~np~{CALENDAR(calendarId=>1)}{CALENDAR}",
// "Id is optional. If not given, all calendars viewable by default are used" => "Id is optional. If not given, all calendars viewable by default are used",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
// "Sort Order" => "Sort Order",
// "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle",
// "Split" => "Split",
// "With sub-categories" => "With sub-categories",
// "Show object name" => "Show object name",
// "Show type" => "Show type",
// "Insert list of items with the current/given category in the wiki page" => "Insert list of items with the current/given category in the wiki page",
// "Categories are disabled" => "Categories are disabled",
// "Category Orphans" => "Category Orphans",
// "Display Tiki objects that have not been categorized" => "Display Tiki objects that have not been categorized",
// "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
// "Category Path" => "Category Path",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display top category" => "Display top category",
// "yes|no, default to no" => "yes|no, default to no",
// "Insert the full category path for each category that this wiki page belongs to" => "Insert the full category path for each category that this wiki page belongs to",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Line numbers" => "Line numbers",
// "0|1, may not be used with colors" => "0|1, may not be used with colors",
// "Wiki syntax" => "Wiki syntax",
// "0|1, parse wiki syntax within the code snippet" => "0|1, parse wiki syntax within the code snippet",
// "Right to left" => "Right to left",
// "0|1, switch the text display from left to right to right to left" => "0|1, switch the text display from left to right to right to left",
// "Content is HTML" => "Content is HTML",
// "0|1, display the content as is instead of escaping HTML special chars" => "0|1, display the content as is instead of escaping HTML special chars",
// "note: colors and ln are exclusive" => "note: colors and ln are exclusive",
// "Content ID" => "Content ID",
// "Also known as fortune cookies or taglines" => "Also known as fortune cookies or taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "Items to show" => "Items to show",
// "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown" => "Select: d=days, h=hours, m=minuts, s=seconds. Enter multiple values as: dhms. If blank, all items are shown",
// "Show time since event" => "Show time since event",
// "If y, will display amount of time since the event (default). If n will simply display that the event is over" => "If y, will display amount of time since the event (default). If n will simply display that the event is over",
// "since " => "since ",
// "until " => "until ",
// " is over" => " is over",
// "Data Channel" => "Data Channel",
// "Displays a form to trigger data channels" => "Displays a form to trigger data channels",
// "List of fields to display. One field per line. Comma delimited: fieldname,label" => "List of fields to display. One field per line. Comma delimited: fieldname,label",
// "Channel Name" => "Channel Name",
// "Name of the channel as registered by the administrator" => "Name of the channel as registered by the administrator",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "div|span|pre|b|i|tt|p|blockquote" => "div|span|pre|b|i|tt|p|blockquote",
// "Span" => "Span",
// "Teletype" => "Teletype",
// "Paragraph" => "Paragraph",
// "Block quote" => "Block quote",
// "left|right|center|justify" => "left|right|center|justify",
// "Right" => "Right",
// "Justify" => "Justify",
// "Float position" => "Float position",
// "left|right, for box with width less than 100%, make text wrap around the box" => "left|right, for box with width less than 100%, make text wrap around the box",
// "Left" => "Left",
// "Determine how other elements can wrap around the element" => "Determine how other elements can wrap around the element",
// "Apply custom CSS class to the div" => "Apply custom CSS class to the div",
// "HTML id" => "HTML id",
// "Sets the div\\'s id attribute, as defined by HTML" => "Sets the div\\'s id attribute, as defined by HTML",
// "Insert a division block, span, blockquote or other text formatting on wiki page" => "Insert a division block, span, blockquote or other text formatting on wiki page",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Creates a definition list" => "Creates a definition list",
// "one definition per line" => "one definition per line",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Events" => "Events",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label" => "Label",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class for the fancylist" => "CSS class for the fancylist",
// "Creates a fancy-looking list" => "Creates a fancy-looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases" => "Rows separated by >> in the header; for the table body, one row per line. Cells separated by | in both cases",
// "Heading row" => "Heading row",
// "Header rows of the table. Use >> to separate multiple rows" => "Header rows of the table. Use >> to separate multiple rows",
// "Heading CSS class" => "Heading CSS class",
// "CSS class to apply to the heading row" => "CSS class to apply to the heading row",
// "Header horizontal align" => "Header horizontal align",
// "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify" => "Horizonatal alignments for header cells separated by |. Choices: left, right, center, justify",
// "Header vertical align" => "Header vertical align",
// "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline" => "Vertical alignments for header cells separated by |. Choices: top, middle, bottom, baseline",
// "Column sort" => "Column sort",
// "Pre-sorted columns" => "Pre-sorted columns",
// "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]" => "Bracketed numbers for column number and sort direction (0 = ascending, 1 = descending), for example: [0,0],[1,0]",
// "Column widths" => "Column widths",
// "Column widths followed by px for pixels or % for percentages. Each column separated by |" => "Column widths followed by px for pixels or % for percentages. Each column separated by |",
// "Cell horizontal align" => "Cell horizontal align",
// "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify" => "Table body column horizonatal alignments separated by |. Choices: left, right, center, justify",
// "Cell vertical align" => "Cell vertical align",
// "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline" => "Table body column vertical alignments separated by |. Choices: top, middle, bottom, baseline",
// "The feature must be activated" => "The feature must be activated",
// "Displays the data using the Tikiwiki odd/even table style" => "Displays the data using the Tikiwiki odd/even table style",
// "cells" => "cells",
// "heads and cells separated by |" => "heads and cells separated by |",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Displays a Flash (.swf) file in the wiki page" => "Displays a Flash (.swf) file in the wiki page",
// "Movie URL" => "Movie URL",
// "Complete URL to the movie to include. e.g. files/test.swf" => "Complete URL to the movie to include. e.g. files/test.swf",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Missing parameter movie to the plugin flash" => "Missing parameter movie to the plugin flash",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes in the wiki page" => "Inserts a section for collected footnotes in the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "Download button label" => "Download button label",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "Missing parameter" => "Missing parameter",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example: pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed User Friends" => "Allowed User Friends",
// "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo" => "Pipe separated list of users whose friends are allowed to view the block. ex: admin|johndoe|foo",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "Display wiki text if user is in one of listed groups or group of friends" => "Display wiki text if user is in one of listed groups or group of friends",
// "Display wiki text if user is in one of listed groups" => "Display wiki text if user is in one of listed groups",
// "GroupMailCore" => "GroupMailCore",
// "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile" => "Displays GroupMail functions on a wiki page. Usually set up using a plugin alias created by the GroupMail profile",
// "From Email" => "From Email",
// "Email address to report" => "Email address to report",
// "Tracker Id" => "Tracker Id",
// "Id of GroupMail Logs tracker (set up in alias by profile)" => "Id of GroupMail Logs tracker (set up in alias by profile)",
// "From Field Id" => "From Field Id",
// "Id of GroupMail Logs tracker field (usually set up in alias by profile)" => "Id of GroupMail Logs tracker field (usually set up in alias by profile)",
// "operator Field Id" => "operator Field Id",
// "subject Field Id" => "subject Field Id",
// "message Field Id" => "message Field Id",
// "content Field Id" => "content Field Id",
// "account Field Id" => "account Field Id",
// "datetime Field Id" => "datetime Field Id",
// "Displays GroupMail functions on a wiki page" => "Displays GroupMail functions on a wiki page",
// "Group Stats" => "Group Stats",
// "Groups separated by " => "Groups separated by ",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Displays some stat about group belonging" => "Displays some stat about group belonging",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "Iframe" => "Iframe",
// "Frame title" => "Frame title",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 5.0)" => " (experimental - possible successor to img in 5.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image ID" => "Image ID",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Image size" => "Image size",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)" => "CSS styling to apply to the plugin (usually used in configuration rather than on individual images)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Display images" => "Display images",
// "Image source" => "Image source",
// "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required" => "Full URL to the image to display. \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Attachment ID" => "Attachment ID",
// "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required" => "Numeric ID of an image attached to a wiki page (or comma-separated list). \"id\", \"fileId\", \"attId\" or \"src\" required",
// "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery" => "Makes the image a thumbnail that enlarges to full size when clicked or moused over (unless \"link\" is set to another target). \"browse\" and \"browsepopup\" only work with image gallery and \"download\" only works with file gallery",
// "Full size image appears when thumbnail is clicked" => "Full size image appears when thumbnail is clicked",
// "Mouseover" => "Mouseover",
// "Full size image will pop up while cursor is over the thumbnail (and disappear when not)" => "Full size image will pop up while cursor is over the thumbnail (and disappear when not)",
// "Mouseover (Sticky)" => "Mouseover (Sticky)",
// "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup" => "Full size image will pop up once cursor passes over thumbnail and will remain up unless cursor passes over full size popup",
// "Popup" => "Popup",
// "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked" => "Full size image will open in a separate winow or tab (depending on browser settings) when thumbnail is clicked",
// "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery" => "Image gallery browse window for the image will open when the thumbnail is clicked if the image is in a Tiki image gallery",
// "Browse Popup" => "Browse Popup",
// "Same as \"browse\" except that the page opens in a new window or tab" => "Same as \"browse\" except that the page opens in a new window or tab",
// "Download dialog box will appear for file gallery images when thumbnail is clicked" => "Download dialog box will appear for file gallery images when thumbnail is clicked",
// "Enlarge button" => "Enlarge button",
// "Button for enlarging image" => "Button for enlarging image",
// "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting" => "Enter a url to the address the image should link to. Not needed if thumb parameter is set; overrides thumb setting",
// "Link relation" => "Link relation",
// "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation" => "Enter \"box\" for colorbox effect (like shadowbox and lightbox) or appropriate syntax for link relation",
// "Image map" => "Image map",
// "Maximum image size" => "Maximum image size",
// "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings" => "Maximum height or width in pixels (largest dimension is scaled). Overrides height and width settings",
// "Align image" => "Align image",
// "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box" => "Aligns the image itself. If the image is inside a box (because of other settings), use the align parameter to align the box",
// "Image style" => "Image style",
// "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border around the image. Otherwise enter CSS styling syntax for other style effects",
// "Align image block" => "Align image block",
// "Aligns the box containing the image" => "Aligns the box containing the image",
// "Image block style" => "Image block style",
// "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects" => "Enter \"border\" to place a dark gray border frame around the image. Otherwise enter CSS styling syntax for other style effects",
// "Description style" => "Description style",
// "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects" => "Enter \"right\" or \"left\" to align text accordingly. Otherwise enter CSS styling syntax for other style effects",
// "Wrapping control" => "Wrapping control",
// "Control how other items wrap around the image" => "Control how other items wrap around the image",
// "CSS class" => "CSS class",
// "CSS class to apply to the image" => "CSS class to apply to the image",
// "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description" => "Image caption. \"desc\" or \"name\" for tiki images, \"idesc\" or \"ititle\" for iptc data, otherwise enter your own description",
// "Alternate text" => "Alternate text",
// "Alternate text that displays when image does not load" => "Alternate text that displays when image does not load",
// "Default config settings" => "Default config settings",
// "Default configuration settings (usually set by admin)" => "Default configuration settings (usually set by admin)",
// "Mandatory admin setting" => "Mandatory admin setting",
// "Mandatory configuration settings (usually set by admin)" => "Mandatory configuration settings (usually set by admin)",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''" => "''No image specified. Either the fileId, attId, id, or src parameter must be specified.''",
// "''Use one and only one of the following parameters: fileId, attId, id, or src.''" => "''Use one and only one of the following parameters: fileId, attId, id, or src.''",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Include a page" => "Include a page",
// "Invite" => "Invite",
// "Invite an email in groups" => "Invite an email in groups",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Including group" => "Including group",
// "Group from the item group selector / creator field" => "Group from the item group selector / creator field",
// "Following mandatory fields are missing" => "Following mandatory fields are missing",
// "Jabber" => "Jabber",
// "Runs a Java applet to access a local Jabber service" => "Runs a Java applet to access a local Jabber service",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "Kaltura video" => "Kaltura video",
// "Displays a KALTURA video on the wiki page" => "Displays a KALTURA video on the wiki page",
// "Kaltura Entry Id" => "Kaltura Entry Id",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Displays the text only if the language matchs" => "Displays the text only if the language matchs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Number of results displayed in the list" => "Number of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Progress" => "List Progress",
// "Indicates the internationalization progress of the page list" => "Indicates the internationalization progress of the page list",
// "List Name" => "List Name",
// "Name of the list as configured in the page list admin panel" => "Name of the list as configured in the page list admin panel",
// "Limit" => "Limit",
// "Maximum amount of results to display" => "Maximum amount of results to display",
// "Filter to apply to the page list" => "Filter to apply to the page list",
// "Score Limit" => "Score Limit",
// "Value used as the denominator for the score" => "Value used as the denominator for the score",
// "List Directory" => "List Directory",
// "Lists files in a directory" => "Lists files in a directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "could not be opened because it doesn't exist or permission was denied" => "could not be opened because it doesn't exist or permission was denied",
// "Displays a map" => "Displays a map",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Mayan Calendars Info" => "Mayan Calendars Info",
// "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count" => "Convert date from Gregorian to Mayan Calendars: Tzolkin, Haab, Long Count",
// "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%" => "You must use the variable substitution.<br/>'.\n                             'LongCount: %baktun%, %katun%, %tun%, %winal%, %kin%;<br/>'.\n                             'Tzolkin: %tzolkin13%, %tzolkin20%, %tzolkin20name%;<br/>'.\n                             'Haab: %haabkin%, %haabwinal%, %haabwinalname%;<br/>'.\n                             'Misc: %longkin%, %julianday%.<br/><br/>'.\n                             'Example: template \"%baktun%.%katun%.%tun%.%winal%.%kin%, %tzolkin13% %tzolkin20name%, %haabkin% %haabwinalname%\" for 22.05.2009 will return 12.19.16.6.11, 8 CHUEN, 9 SIP.<br/>'.\n                             'Default template: %baktun%.%katun%.%tun%.%winal%.%kin% %tzolkin13% %tzolkin20name% %haabkin% %haabwinalname%",
// "Gregorian date" => "Gregorian date",
// "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date" => "Gregorian date for convert. Format: DD.MM.YYYY. Default: Today date",
// "Mayan Calendars" => "Mayan Calendars",
// " is not a valid date format. should be dd.mm.yyyy" => " is not a valid date format. should be dd.mm.yyyy",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "Member List" => "Member List",
// "Lists the members of selected groups and allows to add or remove members if permissions are granted" => "Lists the members of selected groups and allows to add or remove members if permissions are granted",
// "List of groups to handle through the interface. Colon separated" => "List of groups to handle through the interface. Colon separated",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inline in a wiki page. More parameters can be added, not supported by UI" => "Displays a module inline in a wiki page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font" => "Font",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Displays the data using a monospace font" => "Displays the data using a monospace font",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when mouseover text is clicked. Use http:// for external links" => "Destination link when mouseover text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouseover box width. Default: 400px" => "Mouseover box width. Default: 400px",
// "Mouseover box height. Default: 200px" => "Mouseover box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified number of pixels relative to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px" => "Shifts the overlay lower by the specified number of pixels relative to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Background color of the popup" => "Background color of the popup",
// "'),\n\t\t\t\t'filter' => 'striptags" => "'),\n\t\t\t\t'filter' => 'striptags",
// "Text color in the popup" => "Text color in the popup",
// "Padding" => "Padding",
// "Effect" => "Effect",
// "Effect speed" => "Effect speed",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a MySpace Flash mp3 playlist in the wiki page" => "Displays a MySpace Flash mp3 playlist in the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Displays object hit info by object and days" => "Displays object hit info by object and days",
// "List pages part of a named list" => "List pages part of a named list",
// "Offset" => "Offset",
// "Pagination start element" => "Pagination start element",
// "list parameter missing or doesn\\'t exist" => "list parameter missing or doesn\\'t exist",
// "%" => "%",
// "% of page hits" => "% of page hits",
// "Page Hits" => "Page Hits",
// "Picture" => "Picture",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Displays a list of plugins available in this wiki" => "Displays a list of plugins available in this wiki",
// "No arguments indicated" => "No arguments indicated",
// "Poll ID" => "Poll ID",
// "Displays the output of a poll, fields are indicated with numeric ids" => "Displays the output of a poll, fields are indicated with numeric ids",
// "missing poll ID for plugin POLL" => "missing poll ID for plugin POLL",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes cast. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "wrote" => "wrote",
// "Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Quote text by surrounding the text with a box, like the [QUOTE] BBCode",
// "User List (showing Real Name)" => "User List (showing Real Name)",
// " (experimental, should be merged with UserList in Tiki5)" => " (experimental, should be merged with UserList in Tiki5)",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Exclude" => "Exclude",
// "Displays a list of users showing their real name" => "Displays a list of users showing their real name",
// "Displays a list of registered users showing their Real Names" => "Displays a list of registered users showing their Real Names",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "one data per line" => "one data per line",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Takes regex expressions and parses the content between the REGEX tags and replaces the text" => "Takes regex expressions and parses the content between the REGEX tags and replaces the text",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon" => "Icon",
// "Icon ID" => "Icon ID",
// "y|n Show close button (default y)" => "y|n Show close button (default y)",
// "Width (e.g. 100% or 250px - default \"\")" => "Width (e.g. 100% or 250px - default \"\")",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Number of results displayed" => "Number of results displayed",
// "You need to specify a RSS Id" => "You need to specify a RSS Id",
// "RSS Id incorrect" => "RSS Id incorrect",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "Screencast" => "Screencast",
// "Display a screencast uploaded on the page" => "Display a screencast uploaded on the page",
// "Label to use as a replacement to the default text" => "Label to use as a replacement to the default text",
// "ID as provided automatically during the upload" => "ID as provided automatically during the upload",
// "Insert Screencast" => "Insert Screencast",
// "Screencast ID wasn't specified or doesn't exist" => "Screencast ID wasn't specified or doesn't exist",
// "Watch a video of these instructions" => "Watch a video of these instructions",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "Automatically creates a link to the appropriate SourceForge object" => "Automatically creates a link to the appropriate SourceForge object",
// "Insert a ShareThis button from www.sharethis.com" => "Insert a ShareThis button from www.sharethis.com",
// "sharethis" => "sharethis",
// "Display a social networking tool" => "Display a social networking tool",
// "Send services" => "Send services",
// "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services" => "By default, email, aim and sms are available. Input one or two of the services separated by a | to limit the choice of send services",
// "First post services shown" => "First post services shown",
// "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget" => "Input a list of post services (like facebook, myspace, digg, etc.) separated by a | to customize the services that are shown in the opening panel of the widget",
// "Rotate image" => "Rotate image",
// "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping" => "A value of y will cause the button icon to rotate every 3 seconds between a few icons, cycling through twice before stopping",
// "Button text" => "Button text",
// "Custom link text for the button" => "Custom link text for the button",
// "Header title" => "Header title",
// "Optional header title text for the widget" => "Optional header title text for the widget",
// "Header background" => "Header background",
// "HTML color code (not color name) for the background color for the header if an optional header title is used" => "HTML color code (not color name) for the background color for the header if an optional header title is used",
// "Header text color" => "Header text color",
// "HTML color code (not color name) for the header text if an optional header title is used" => "HTML color code (not color name) for the header text if an optional header title is used",
// "Link text color for services" => "Link text color for services",
// "HTML color code (not color name) for the link text for all send and post services shown in the widget" => "HTML color code (not color name) for the link text for all send and post services shown in the widget",
// "Pop-up" => "Pop-up",
// "A value of true will cause the widget to show in a pop-up window" => "A value of true will cause the widget to show in a pop-up window",
// "Embedded elements" => "Embedded elements",
// "A value of true will allow embedded elements (like flash) to be seen while iframe is loading" => "A value of true will allow embedded elements (like flash) to be seen while iframe is loading",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Sheet Heading" => "Sheet Heading",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "Display" => "Display",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "This data is put in a CODE caption" => "This data is put in a CODE caption",
// "Missing url parameter for SNARF plugin" => "Missing url parameter for SNARF plugin",
// "Sorts the plugin content in the wiki page" => "Sorts the plugin content in the wiki page",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Split a page into rows and columns" => "Split a page into rows and columns",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Stat" => "Stat",
// "Displays some stats" => "Displays some stats",
// "separated by " => "separated by ",
// "Parent Id" => "Parent Id",
// "Added last hour" => "Added last hour",
// "Added last 24 hours" => "Added last 24 hours",
// "Added since the beginning of the day" => "Added since the beginning of the day",
// "Added(a) or viewed(v) since the beginning of the day" => "Added(a) or viewed(v) since the beginning of the day",
// "Added last 7 days" => "Added last 7 days",
// "Added(a) or viewed(v) last 7 days" => "Added(a) or viewed(v) last 7 days",
// "Added since the beginning of the week" => "Added since the beginning of the week",
// "Added(a) or viewed(v) since the beginning of the week" => "Added(a) or viewed(v) since the beginning of the week",
// "Added last month" => "Added last month",
// "Added(a) or viewed(v) last month" => "Added(a) or viewed(v) last month",
// "Added since the beginning of the month" => "Added since the beginning of the month",
// "Added(a) or viewed(v) since the beginning of the month" => "Added(a) or viewed(v) since the beginning of the month",
// "Added last year" => "Added last year",
// "Added(a) or viewed(v) last year" => "Added(a) or viewed(v) last year",
// "Added since the beginning of the year" => "Added since the beginning of the year",
// "Added(a) or viewed(v) since the beginning of the year" => "Added(a) or viewed(v) since the beginning of the year",
// "Subscript" => "Subscript",
// "Displays text in subscript" => "Displays text in subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Show subscribe box" => "Show subscribe box",
// "Show default setting and buttons" => "Show default setting and buttons",
// "Show group description" => "Show group description",
// "Colon separated list of groups" => "Colon separated list of groups",
// "After changing default" => "After changing default",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Tabs" => "Tabs",
// "Provides tabs built using the smarty tabset block" => "Provides tabs built using the smarty tabset block",
// "Tabs content separated by /////" => "Tabs content separated by /////",
// "Tabset name" => "Tabset name",
// "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs" => "Unique tabset name (if you want it to remember its last state). Ex: user_profile_tabs",
// "Tab titles" => "Tab titles",
// "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3" => "Pipe separated list of tab titles. Ex: tab 1|tab 2|tab 3",
// "Displays a set of tabs" => "Displays a set of tabs",
// "No tab title specified. At least one has to be set to make the tabs appear" => "No tab title specified. At least one has to be set to make the tabs appear",
// "Tag" => "Tag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent to the style attribute of an HTML tag" => "Equivalent to the style attribute of an HTML tag",
// "Displays text between HTML tags" => "Displays text between HTML tags",
// "Displays the thumbnail for an image" => "Displays the thumbnail for an image",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Pipe-separated list of page names to exclude from results" => "Pipe-separated list of page names to exclude from results",
// "Search the titles of all pages in this wiki" => "Search the titles of all pages in this wiki",
// "No pages found for title search" => "No pages found for title search",
// "One page found for title search" => "One page found for title search",
// "pages found for title search" => "pages found for title search",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum number of levels to display. On very large structures, this should be limited" => "Maximum number of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "List top-scoring users" => "List top-scoring users",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Translate a string" => "Translate a string",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "URL used for the field links" => "URL used for the field links",
// "Url target" => "Url target",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "Label for the reset button, to return all fields to their default values" => "Label for the reset button, to return all fields to their default values",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Following fields are incorrect" => "Following fields are incorrect",
// "Displays an input form for tracker submit" => "Displays an input form for tracker submit",
// "You do not have permission to insert an item" => "You do not have permission to insert an item",
// "You do not have permission to modify an item" => "You do not have permission to modify an item",
// "Fields marked with a * are mandatory" => "Fields marked with a * are mandatory",
// "Display List" => "Display List",
// "Tracker Filter" => "Tracker Filter",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Filters the items of a tracker, fields are indicated with numeric ids" => "Filters the items of a tracker, fields are indicated with numeric ids",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Displays the output of a tracker content, fields are indicated with numeric ids" => "Displays the output of a tracker content, fields are indicated with numeric ids",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Show Item Rank" => "Show Item Rank",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Maximum number of items" => "Maximum number of items",
// "Show pagination" => "Show pagination",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More URL" => "More URL",
// "More Url" => "More Url",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "Show nothing if no items" => "Show nothing if no items",
// "incorrect filterfield" => "incorrect filterfield",
// "Error in tracker ID" => "Error in tracker ID",
// "No field indicated" => "No field indicated",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Tracker Stats" => "Tracker Stats",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Start Date" => "Start Date",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "End Date" => "End Date",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "Links to a translated content" => "Links to a translated content",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "Display the user\\'s real name instead of login name" => "Display the user\\'s real name instead of login name",
// "Userpref" => "Userpref",
// "Display wiki text if user has a pref set to a value" => "Display wiki text if user has a pref set to a value",
// "Split the text in parts visible only under some conditions" => "Split the text in parts visible only under some conditions",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "^Parameters: key=>value,...\n" => "^Parameters: key=>value,...\n",
// "__key__ | __default__ | __comments__\n" => "__key__ | __default__ | __comments__\n",
// "empty string" => "empty string",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "possible values: " => "possible values: ",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "ignored" => "ignored",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "End of debug output" => "End of debug output",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "Display youtube video in a wiki page" => "Display youtube video in a wiki page",
// "URL to the Youtube video" => "URL to the Youtube video",
// "width" => "width",
// "height" => "height",
// "quality" => "quality",
// "Missing parameter movie to the youtube plugin" => "Missing parameter movie to the youtube plugin",
// "Cannot create aliased page" => "Cannot create aliased page",
// "You attempted to create the following page" => "You attempted to create the following page",
// "That page is an alias for the following pages" => "That page is an alias for the following pages",
// "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this" => "If you want to create the page, you must first edit each the pages above, and remove the alias link it may contain. This link should look something like this",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "Removed version \$version" => "Removed version \$version",
// "rollback version " => "rollback version ",
// "Changed actual version to \$version" => "Changed actual version to \$version",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Page locked" => "Page locked",
// "Page unlocked" => "Page unlocked",
// "Removed last version" => "Removed last version",
// "User %s does not have the permission" => "User %s does not have the permission",
// "The message has been sent to" => "The message has been sent to",
// "The message will be sent to" => "The message will be sent to",
// "User %s does not want to receive messages" => "User %s does not want to receive messages",
// "Sent box is full. Archive or delete some sent messages first if you want to send more messages" => "Sent box is full. Archive or delete some sent messages first if you want to send more messages",
// "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'",
// "User %s can not receive messages, mailbox is full" => "User %s can not receive messages, mailbox is full",
// "User %s can not receive messages" => "User %s can not receive messages",
// "Invalid user: %s" => "Invalid user: %s",
// "Archive is full. Delete some messages from archive first" => "Archive is full. Delete some messages from archive first",
// "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page" => "Displays a calendar of system events, such as wiki page modifications, forum posts and article publications. Days with events show links to the action calendar page",
// "Item types filter" => "Item types filter",
// "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes" => "If set to a list of item types, restricts the items displayed to those of one of these types. Each set is a comma-separated list of item type codes",
// "Possible item type values" => "Possible item type values",
// "Google AdSense" => "Google AdSense",
// "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code" => "Displays a text/image Google AdSense advertisement. This module should be updated to support new Google code",
// "Advertisement channel, as optionally provided by Google" => "Advertisement channel, as optionally provided by Google",
// "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"" => "As provided by Google. Format: \"pub-xxxxxxxxxxxxxxxx\"",
// "Global banner format as provided by Google. For example: \"display=468*60_as\"" => "Global banner format as provided by Google. For example: \"display=468*60_as\"",
// "Background color, as optionally provided by Google" => "Background color, as optionally provided by Google",
// "Border color, as optionally provided by Google" => "Border color, as optionally provided by Google",
// "Link color, as optionally provided by Google" => "Link color, as optionally provided by Google",
// "Text color, as optionally provided by Google" => "Text color, as optionally provided by Google",
// "URL color, as optionally provided by Google" => "URL color, as optionally provided by Google",
// "Article archives" => "Article archives",
// "Shows links to the published articles for each month" => "Shows links to the published articles for each month",
// "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More...\" that links to a paginated view of the selected articles",
// "Default: \"n\"" => "Default: \"n\"",
// "Category filter" => "Category filter",
// "If set to a category identifier, only consider the articles in the specified category" => "If set to a category identifier, only consider the articles in the specified category",
// "Example value: 13" => "Example value: 13",
// "Not set by default" => "Not set by default",
// "Topic filter (by names)" => "Topic filter (by names)",
// "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic names separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values" => "Example values",
// "Topic filter (by identifiers)" => "Topic filter (by identifiers)",
// "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered" => "If set to a list of article topic identifiers separated by plus signs, only consider the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not considered",
// "Example values: 13, !13, 1+3, !1+5+7" => "Example values: 13, !13, 1+3, !1+5+7",
// "Types filter" => "Types filter",
// "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered" => "If set to a list of article type names separated by plus signs, only consider the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not considered",
// "Example values: Event, !Event, Event+Review, !Event+Classified+Article" => "Example values: Event, !Event, Event+Review, !Event+Classified+Article",
// "Language filter" => "Language filter",
// "If set to a language code, only consider the articles in the specified language" => "If set to a language code, only consider the articles in the specified language",
// "Article Topics" => "Article Topics",
// "Lists all article topics with links to their articles" => "Lists all article topics with links to their articles",
// "Lists the specified number of published articles in the specified order" => "Lists the specified number of published articles in the specified order",
// "Show publication time" => "Show publication time",
// "If set to \"y\", article publication times are shown" => "If set to \"y\", article publication times are shown",
// "Show creation time" => "Show creation time",
// "If set to \"y\", article creation times are shown" => "If set to \"y\", article creation times are shown",
// "Show rating selector" => "Show rating selector",
// "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating" => "If set to \"y\", offers the user to filter articles based on a minimum and a maximum rating",
// "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image" => "If set, displays an image for each article if one applies, with the given width (in pixels). The article\\'s own image is used, with a fallback to the article\\'s topic image",
// "If set to a category identifier, only lists the articles in the specified category" => "If set to a category identifier, only lists the articles in the specified category",
// "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic names separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed" => "If set to a list of article topic identifiers separated by plus signs, only lists the articles in the specified article topics. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles in the specified article topics are not listed",
// "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed" => "If set to a list of article type names separated by plus signs, only lists the articles of the specified types. If the string is preceded by an exclamation mark (\"!\"), the effect is reversed, i.e. articles of the specified article types are not listed",
// "If set to a language code, only lists the articles in the specified language" => "If set to a language code, only lists the articles in the specified language",
// "Specifies how the articles should be sorted" => "Specifies how the articles should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date" => "Possible values include created and created_asc (equivalent), created_desc, author, rating, topicId, lang and title. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on article creation date",
// "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead" => "If set to an integer, offsets the articles list by the given number. For example, if the module was otherwise set to list the 10 articles most recently published, setting the offset to 10 would make the module list the 11th to 20th articles in descending order of publication time instead",
// "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles" => "If set to \"y\", displays a button labelled \"More\" that links to a paginated view of the selected articles",
// "Absolute URL" => "Absolute URL",
// "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example" => "If set to \"y\", some of the links use an absolute URL instead of a relative one. This can avoid broken links if the module is to be sent in a newsletter, for example",
// "TikiWiki assistant" => "TikiWiki assistant",
// "Displays an assistant to guide new Tiki admins" => "Displays an assistant to guide new Tiki admins",
// "Last blog post comments" => "Last blog post comments",
// "Displays the specified number of the blog post comments most recently added" => "Displays the specified number of the blog post comments most recently added",
// "More in tooltips" => "More in tooltips",
// "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the post on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "No date" => "No date",
// "If set to \"y\", the date at which comments were posted is not displayed in the module box" => "If set to \"y\", the date at which comments were posted is not displayed in the module box",
// "Last visited pages" => "Last visited pages",
// "Displays the last Wiki pages visited by the user" => "Displays the last Wiki pages visited by the user",
// "Maximum length" => "Maximum length",
// "Maximum number of characters in page names allowed before truncating" => "Maximum number of characters in page names allowed before truncating",
// "Includes a calendar or a list of calendar events" => "Includes a calendar or a list of calendar events",
// "Displayed month (relative)" => "Displayed month (relative)",
// "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span" => "Distance in month to the month to display. A distance of -1 would display the previous month. Setting this option implies a calendar view type with a month time span",
// "Displays links to categories as a tree" => "Displays links to categories as a tree",
// "Object type filter" => "Object type filter",
// "Object type filter to apply when accessing a linked category. Example values" => "Object type filter to apply when accessing a linked category. Example values",
// "Deep" => "Deep",
// "Show subcategories objects when accessing a linked category. Possible values: on (default), off" => "Show subcategories objects when accessing a linked category. Possible values: on (default), off",
// "PHP Layers menu style" => "PHP Layers menu style",
// "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree" => "Sets the menu style if PHP Layers is enabled. Possible values: tree (default), vert, horiz, plain, phptree",
// "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)" => "Limits displayed categories to a subtree of categories starting with the category with the given ID. Example value: 11. Default: 0 (don\\'t limit display)",
// "Category Transitions" => "Category Transitions",
// "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules" => "Displays controls to trigger category transitions and change the page\\'s state according to predefined rules",
// "Change Category" => "Change Category",
// "Enables to categorize an object" => "Enables to categorize an object",
// "Category identifier" => "Category identifier",
// "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier" => "Changes the root of the displayed categories from default \"TOP\" to the category with the given identifier",
// "Note that the root category is not displayed" => "Note that the root category is not displayed",
// "Defaults to 0 (root)" => "Defaults to 0 (root)",
// "No top" => "No top",
// "In non-detailed view, disallow uncategorizing. Example value: 1" => "In non-detailed view, disallow uncategorizing. Example value: 1",
// "Display path" => "Display path",
// "Instead of category names, diplay their path in the category tree starting from the category root defined" => "Instead of category names, diplay their path in the category tree starting from the category root defined",
// "Example value: 1" => "Example value: 1",
// "Multiple categories" => "Multiple categories",
// "If set to \"n\", only allows categorizing in one category (from those displayed)" => "If set to \"n\", only allows categorizing in one category (from those displayed)",
// "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize" => "String to display on the button to submit new categories, when multiple categories is enabled. Default value: Categorize",
// "Shy" => "Shy",
// "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default" => "If set to \"y\", the module is not shown on pages which are not already categorized.' . \" \" . tra('Not set by default",
// "Detailed" => "Detailed",
// "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list" => "If set to \"y\", shows a list of categories in which the object is. If deletion is not disabled, it is done with the list",
// "If set to \"n\", the detailed list of categories will not offer to unassign a category" => "If set to \"n\", the detailed list of categories will not offer to unassign a category",
// "If set to \"y\", allow to assign new categories" => "If set to \"y\", allow to assign new categories",
// "Example values: y, n" => "Example values: y, n",
// "Default value: y" => "Default value: y",
// "Default value: n" => "Default value: n",
// "Image URL not in category" => "Image URL not in category",
// "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category" => "Very particular parameter. If both this and \"Image URL in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is not in the category",
// "Example value" => "Example value",
// "Image URL in category" => "Image URL in category",
// "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category" => "Very particular parameter. If both this and \"Image URL not in the category\" are set and the root category contains a single child category, the module only displays an image with this URL if the object is in the category",
// "Categorize %s" => "Categorize %s",
// "Categorize %s in %s" => "Categorize %s in %s",
// "Displays the number of pages received (via Communications)" => "Displays the number of pages received (via Communications)",
// "Last directory sites" => "Last directory sites",
// "Displays the specified number of the directory sites most recently added" => "Displays the specified number of the directory sites most recently added",
// "Directory category identifier" => "Directory category identifier",
// "If set to a directory category identifier, only displays the sites in the specified directory category" => "If set to a directory category identifier, only displays the sites in the specified directory category",
// "If set to \"y\", displays a button labelled \"More\" that links to the directory" => "If set to \"y\", displays a button labelled \"More\" that links to the directory",
// "Directory statistics" => "Directory statistics",
// "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links" => "Displays statistics about the directory, including the number of sites validated and to validate, the number of categories, of searches and of visited links",
// "Top directory sites" => "Top directory sites",
// "Displays the specified number of the directory sites from most visited to least visited" => "Displays the specified number of the directory sites from most visited to least visited",
// "Displays the site\\'s first featured links" => "Displays the site\\'s first featured links",
// "Displays links to file galleries" => "Displays links to file galleries",
// "Best rated topics" => "Best rated topics",
// "Displays the specified number of the forum topics with the best ratings" => "Displays the specified number of the forum topics with the best ratings",
// "Displays the latest forum posts" => "Displays the latest forum posts",
// "If set to \"y\", only displays topics" => "If set to \"y\", only displays topics",
// "Displays the specified number of the forums with the most comments" => "Displays the specified number of the forums with the most comments",
// "Displays the specified number of the forum topics with the most reads" => "Displays the specified number of the forum topics with the most reads",
// "Displays the specified number of the forums with the most visits" => "Displays the specified number of the forums with the most visits",
// "Freetags editor" => "Freetags editor",
// "Shows current freetags and enables to add and remove some if permissions allow" => "Shows current freetags and enables to add and remove some if permissions allow",
// "Freetags Wiki" => "Freetags Wiki",
// "Displays current freetags on wiki pages and enables to add tags if permissions allow" => "Displays current freetags on wiki pages and enables to add tags if permissions allow",
// "Similar freetags" => "Similar freetags",
// "Shows wiki pages with similar freetags" => "Shows wiki pages with similar freetags",
// "Similar pages" => "Similar pages",
// "Shows the most popular freetags. More popularity is indicated by a larger font" => "Shows the most popular freetags. More popularity is indicated by a larger font",
// "Display type" => "Display type",
// "If set to \"cloud\", links are displayed as a cloud" => "If set to \"cloud\", links are displayed as a cloud",
// "Default: \"list\"" => "Default: \"list\"",
// "Maximum elements" => "Maximum elements",
// "If set to a number, limits the number of tags displayed" => "If set to a number, limits the number of tags displayed",
// "User preferred tags" => "User preferred tags",
// "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font" => "Displays to registered users the freetags they prefer, based on the number of objects they added the tag to. More preference is indicated by a larger font",
// "My preferred tags" => "My preferred tags",
// "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site" => "Displays a simple form to search on Google. By default, search results are limited to those on the Tiki site",
// "Groups emulation" => "Groups emulation",
// "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site" => "Enables temporarily changing one\\'s group memberships to see how users in fewer groups experience the site",
// "Emulate Groups" => "Emulate Groups",
// "Displays the specified number of last actions" => "Displays the specified number of last actions",
// "Show user" => "Show user",
// "If set to \"y\", user names are displayed in the module box" => "If set to \"y\", user names are displayed in the module box",
// "Show date" => "Show date",
// "If set to \"y\", action dates are displayed in the module box" => "If set to \"y\", action dates are displayed in the module box",
// "Maximum number of characters in action descriptions before truncating" => "Maximum number of characters in action descriptions before truncating",
// "Lists the specified number of blogs posts from newest to oldest" => "Lists the specified number of blogs posts from newest to oldest",
// "If set to \"y\", the date of posts is not displayed in the module box" => "If set to \"y\", the date of posts is not displayed in the module box",
// "Blog identifier" => "Blog identifier",
// "If set to a blog identifier, restricts the blog posts to those in the identified blog" => "If set to a blog identifier, restricts the blog posts to those in the identified blog",
// "Last category objects" => "Last category objects",
// "Lists the specified number of objects of the given type in the given category, starting from the most recently created" => "Lists the specified number of objects of the given type in the given category, starting from the most recently created",
// "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed" => "Identifier of the category from which objects are listed. Objects merely in child categories will not be displayed",
// "Maximum number of characters in object names allowed before truncating" => "Maximum number of characters in object names allowed before truncating",
// "Type of the objects to list. Example values" => "Type of the objects to list. Example values",
// "Displays the specified number of blogs from newest to oldest" => "Displays the specified number of blogs from newest to oldest",
// "Displays the specified number of FAQs from newest to oldest" => "Displays the specified number of FAQs from newest to oldest",
// "Displays the specified number of quizzes from newest to oldest" => "Displays the specified number of quizzes from newest to oldest",
// "Displays the specified number of file galleries, starting from the most recently modified" => "Displays the specified number of file galleries, starting from the most recently modified",
// "List the specified number of files, starting from the most recently added" => "List the specified number of files, starting from the most recently added",
// "Gallery identifiers" => "Gallery identifiers",
// "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers" => "If set to a set of file gallery identifiers, restricts the files to those in the identified galleries. The value is a colon-separated sequence of integers",
// "Example value: 13, 2:13, 1:2:3:5:6" => "Example value: 13, 2:13, 1:2:3:5:6",
// "Last modified image galleries" => "Last modified image galleries",
// "Displays the specified number of image galleries, starting from the most recently modified" => "Displays the specified number of image galleries, starting from the most recently modified",
// "List the specified number of images, starting from the most recently added" => "List the specified number of images, starting from the most recently added",
// "Gallery identifier" => "Gallery identifier",
// "If set to an image gallery identifier, restricts the images to those in the identified gallery" => "If set to an image gallery identifier, restricts the images to those in the identified gallery",
// "Link content" => "Link content",
// "Display the links as image names or thumbnails" => "Display the links as image names or thumbnails",
// "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"" => "Possible values: \"names\" or \"thumbnails\". Default value: \"names\"",
// "Last modified events" => "Last modified events",
// "Displays the specified number of calendar events, starting from the most recently modified" => "Displays the specified number of calendar events, starting from the most recently modified",
// "Calendar identifier" => "Calendar identifier",
// "If set to a calendar identifier, restricts the events to those in the identified calendar" => "If set to a calendar identifier, restricts the events to those in the identified calendar",
// "Maximum number of characters in event names allowed before truncating" => "Maximum number of characters in event names allowed before truncating",
// "Lists the specified number of pages, starting from the most recently modified" => "Lists the specified number of pages, starting from the most recently modified",
// "Link target" => "Link target",
// "Target URL of the \"...more\" link at the bottom of the module" => "Target URL of the \"...more\" link at the bottom of the module",
// "Displays the specified number of blogs, starting from the most recently modified" => "Displays the specified number of blogs, starting from the most recently modified",
// "Lists the specified number of article submissions from newest to oldest" => "Lists the specified number of article submissions from newest to oldest",
// "Last tracker comments" => "Last tracker comments",
// "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted" => "Lists the specified number of tracker comments (optionally restricting to those in a specific tracker or tracker item) starting from the most recently posted",
// "Tracker identifier" => "Tracker identifier",
// "If set to a tracker identifier, only displays the comments on the given tracker" => "If set to a tracker identifier, only displays the comments on the given tracker",
// "Item identifier" => "Item identifier",
// "If set to an item identifier, only displays the comments on the given item" => "If set to an item identifier, only displays the comments on the given item",
// "Last tracker items" => "Last tracker items",
// "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required" => "Displays the value of a field of the specified number of tracker items. If the specified tracker has no main field, either Field name or Field identifier is required",
// "Identifier of the tracker from which items are listed" => "Identifier of the tracker from which items are listed",
// "Field identifier" => "Field identifier",
// "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored" => "Identifier of the field from which values are listed. If Field name is set, this parameter is ignored",
// "Field name" => "Field name",
// "Name of the field from which values are listed" => "Name of the field from which values are listed",
// "Example value: age" => "Example value: age",
// "Specifies how the items should be sorted" => "Specifies how the items should be sorted",
// "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date" => "Possible values include created and created_asc (equivalent), created_desc, status, lastModif, createdBy and lastModifBy. Unless \"_desc\" is specified, the sort is ascending. \"created\" sorts on item creation date. \"lastModif\" sorts on the last modification date of items. \"lastModif_desc\" sorts in descending order of last modification date",
// "Status filter" => "Status filter",
// "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values" => "If set, limits the listed items to those with the given statuses. Values are combinations of \"o\" (open), \"p\" (pending) and \"c\" (closed). Possible values",
// "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set" => "Unable to determine which field to show. Tracker identifier may be invalid, or the tracker has no main field and neither Field identifier nor Field name were set",
// "You do not have permission to view this tracker" => "You do not have permission to view this tracker",
// "Last Validated FAQs Questions" => "Last Validated FAQs Questions",
// "Displays the specified number of validated questions FAQs from newest to oldest" => "Displays the specified number of validated questions FAQs from newest to oldest",
// "Faq identifier" => "Faq identifier",
// "If set to a faq identifier, restricts the chosen questions to those in the identified faq" => "If set to a faq identifier, restricts the chosen questions to those in the identified faq",
// "Number of characters to display" => "Number of characters to display",
// "Displays information about the specified number of users in decreasing order of last login time" => "Displays information about the specified number of users in decreasing order of last login time",
// "Show avatars" => "Show avatars",
// "If set to \"y\", show user avatars" => "If set to \"y\", show user avatars",
// "Maximum number of characters in user names allowed before truncating" => "Maximum number of characters in user names allowed before truncating",
// "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console" => "Tells users whether a live support operator is present and allows them to request support if possible. If the user is an operator, links to the operator console",
// "Login box" => "Login box",
// "Input size" => "Input size",
// "Number of characters for username and password input fields" => "Number of characters for username and password input fields",
// "Logo" => "Logo",
// "Site logo, title and subtitle" => "Site logo, title and subtitle",
// "Menu page" => "Menu page",
// "Displays a Wiki page" => "Displays a Wiki page",
// "Page to display in the menu. Example value: HomePage" => "Page to display in the menu. Example value: HomePage",
// "Unread inter-user messages" => "Unread inter-user messages",
// "Displays to users their number of new inter-user messages and a link to their message box" => "Displays to users their number of new inter-user messages and a link to their message box",
// "Small live chat box" => "Small live chat box",
// "Channels" => "Channels",
// "List of chat channels. Channel names are separated by a comma (\",\")" => "List of chat channels. Channel names are separated by a comma (\",\")",
// "By default, a single channel named \"default\" exists" => "By default, a single channel named \"default\" exists",
// "Months links" => "Months links",
// "Links to the objects of a given type for the current month and those preceding it" => "Links to the objects of a given type for the current month and those preceding it",
// "Type of objects to link to" => "Type of objects to link to",
// "\"blogs\" for blog posts, \"cms\" for published articles" => "\"blogs\" for blog posts, \"cms\" for published articles",
// "Object identifier" => "Object identifier",
// "Identifier of an object with children to link to" => "Identifier of an object with children to link to",
// "This is required for the blog Object type" => "This is required for the blog Object type",
// "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3" => "For example, an identifier of 3 and a blogs Object type will show links to the blog posts in the blog with identifier 3",
// "Displays the number of article submissions waiting examination and a link to the list" => "Displays the number of article submissions waiting examination and a link to the list",
// "Displays the specified number of old articles (which do not show on articles home page anymore)" => "Displays the specified number of old articles (which do not show on articles home page anymore)",
// "Enables to change current perspective" => "Enables to change current perspective",
// "Quick Edit" => "Quick Edit",
// "Enables to quickly create or edit Wiki pages" => "Enables to quickly create or edit Wiki pages",
// "Template identifier" => "Template identifier",
// "If set to a template identifier, the specified template is used for creating new Wiki pages" => "If set to a template identifier, the specified template is used for creating new Wiki pages",
// "If set, send the form to the given location (relative to Tiki\\'s root) for processing" => "If set, send the form to the given location (relative to Tiki\\'s root) for processing",
// "SUBMIT label" => "SUBMIT label",
// "The label on the button to submit the form" => "The label on the button to submit the form",
// "Size attribute (horizontal, in characters) of the text input field for page names" => "Size attribute (horizontal, in characters) of the text input field for page names",
// "Optional heading to display at the top of the module\\'s content" => "Optional heading to display at the top of the module\\'s content",
// "If set to a category identifier, pages created through the module are automatically categorized in the specified category" => "If set to a category identifier, pages created through the module are automatically categorized in the specified category",
// "Random image" => "Random image",
// "Displays a random image" => "Displays a random image",
// "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery" => "If set to an image gallery identifier, restricts the chosen images to those in the identified gallery",
// "Show link" => "Show link",
// "If set to \"n\", the image thumbnail does not link to the image" => "If set to \"n\", the image thumbnail does not link to the image",
// "Default: \"y\"" => "Default: \"y\"",
// "Show name" => "Show name",
// "If set to \"y\", the name of the image is displayed" => "If set to \"y\", the name of the image is displayed",
// "If set to \"y\", the description of the image is displayed" => "If set to \"y\", the description of the image is displayed",
// "Displays the specified number of random wiki pages" => "Displays the specified number of random wiki pages",
// "New user registrationmore tiki-re" => "New user registrationmore tiki-re",
// "Feeds List" => "Feeds List",
// "List of feeds available on this site" => "List of feeds available on this site",
// "Search Box" => "Search Box",
// "Advanced search (for wiki, articles, blogs etc)" => "Advanced search (for wiki, articles, blogs etc)",
// "Search Box (new)" => "Search Box (new)",
// "Search Wiki Page" => "Search Wiki Page",
// "Search for a wiki page by name" => "Search for a wiki page by name",
// "Search Wiki Page (new)" => "Search Wiki Page (new)",
// "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from" => "Lists the relationships known for the Wiki page displayed. For each relation type contained in the page, it lists all the pages it links to or gets linked from",
// "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages" => "The shoutbox is a quick messaging tool. Messages reload each time the page changes. Anyone with the right permission can see all messages. Another permission allows to send messages",
// "Tooltip" => "Tooltip",
// "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content" => "If set to \"1\", displays message post dates and times as tooltips instead of showing directly in the module content",
// "Label on the button to post a message" => "Label on the button to post a message",
// "Wait label" => "Wait label",
// "Label on the button to post a message when the message is being posted if AJAX is enabled" => "Label on the button to post a message when the message is being posted if AJAX is enabled",
// "Maximum messages shown" => "Maximum messages shown",
// "Number of messages to display" => "Number of messages to display",
// "Since last visit (simple)" => "Since last visit (simple)",
// "Displays to logged in users the number of new or updated objects since their last login date and time" => "Displays to logged in users the number of new or updated objects since their last login date and time",
// "Since last visit" => "Since last visit",
// "Displays to logged in users new or updated objects since a point in time, by default their last login date and time" => "Displays to logged in users new or updated objects since a point in time, by default their last login date and time",
// "Show users" => "Show users",
// "If set to \"n\", do not show new users" => "If set to \"n\", do not show new users",
// "Show trackers" => "Show trackers",
// "If set to \"n\", do not show tracker changes" => "If set to \"n\", do not show tracker changes",
// "Calendar focus" => "Calendar focus",
// "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar" => "Unless set to \"ignore\", the module changes the reference point in time from the user\\'s last login date and time to a day where users browse to using the calendar",
// "Switch Language" => "Switch Language",
// "Displays a language picker to change the language of the site" => "Displays a language picker to change the language of the site",
// "Display mode" => "Display mode",
// "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist" => "Changes how the list of languages is displayed. Possible values are droplist, flags and words. Defaults to droplist",
// "Prefix" => "Prefix",
// "Changes the default displayed prefix from \\\"Site Language:\\\"" => "Changes the default displayed prefix from \\\"Site Language:\\\"",
// "Switch theme" => "Switch theme",
// "Enables to quickly change the theme" => "Enables to quickly change the theme",
// "Terminology" => "Terminology",
// "Support for multilingual terminology" => "Support for multilingual terminology",
// "Tiki Tests" => "Tiki Tests",
// "Tiki test suite helper" => "Tiki test suite helper",
// "Displays the specified number of blogs with links to them, from the most active one to the least" => "Displays the specified number of blogs with links to them, from the most active one to the least",
// "Blog activity measurement can be more or less accurate" => "Blog activity measurement can be more or less accurate",
// "Lists the specified number of articles with links to them, from the most visited one to the least" => "Lists the specified number of articles with links to them, from the most visited one to the least",
// "Displays the specified number of file galleries with links to them, starting with the one with most hits" => "Displays the specified number of file galleries with links to them, starting with the one with most hits",
// "Displays the specified number of files with links to them, starting with the one with most hits" => "Displays the specified number of files with links to them, starting with the one with most hits",
// "Displays the specified number of users who posted to forums, starting with the one having most posts" => "Displays the specified number of users who posted to forums, starting with the one having most posts",
// "Top image galleries" => "Top image galleries",
// "Displays the specified number of image galleries with links to them, starting with the one with most hits" => "Displays the specified number of image galleries with links to them, starting with the one with most hits",
// "Displays the specified number of images with links to them, from the most visited one to the least" => "Displays the specified number of images with links to them, from the most visited one to the least",
// "Displays the specified number of objects, starting with the one having the most hits" => "Displays the specified number of objects, starting with the one having the most hits",
// "Displays the specified number of wiki pages with links to them, starting with the one having the most hits" => "Displays the specified number of wiki pages with links to them, starting with the one having the most hits",
// "Displays the specified number of quizzes with links to them, starting with the one having the most hits" => "Displays the specified number of quizzes with links to them, starting with the one having the most hits",
// "Displays the specified number of blogs with links to them, from the most visited one to the least" => "Displays the specified number of blogs with links to them, from the most visited one to the least",
// "Displays the specified number of FAQs with links to them, from the most visited one to the least" => "Displays the specified number of FAQs with links to them, from the most visited one to the least",
// "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed" => "Links to versions of the wiki page being viewed in other languages, distinguishing between better, equivalent or worse translations. Optionally displays the up-to-dateness of the translation being viewed",
// "Reference language" => "Reference language",
// "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed" => "If set to a language code, restricts the localized pages shown to the reference page, unless that page is being displayed",
// "Lists the specified number of calendar events, ordered by their start date" => "Lists the specified number of calendar events, ordered by their start date",
// "Calendars filter" => "Calendars filter",
// "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")" => "If set to a list of calendar identifiers, restricts the events to those in the identified calendars. Identifiers are separated by vertical bars (\"|\"), commas (\",\") or colons (\":\")",
// "Maximum days in the future" => "Maximum days in the future",
// "Maximum distance to event start dates in days (looking forward)" => "Maximum distance to event start dates in days (looking forward)",
// "Maximum days in the past" => "Maximum days in the past",
// "Maximum distance to event end dates in days (looking backward)" => "Maximum distance to event end dates in days (looking backward)",
// "cellpadding" => "cellpadding",
// "cellspacing" => "cellspacing",
// "If set to \"y\", event descriptions are displayed" => "If set to \"y\", event descriptions are displayed",
// "Show end date and time" => "Show end date and time",
// "If set to \"y\", event end dates and times are displayed, when appropriate" => "If set to \"y\", event end dates and times are displayed, when appropriate",
// "Use custom calendar background colors" => "Use custom calendar background colors",
// "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)" => "If set to \"y\", events are displayed with their calendar\\'s custom background color (if one is set)",
// "Show information in tooltips" => "Show information in tooltips",
// "If set to \"n\", event tooltips will not display event information" => "If set to \"n\", event tooltips will not display event information",
// "Date format" => "Date format",
// "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>" => "Format to use for most dates. See <a href=\"http://www.php.net/manual/en/function.strftime.php\">strftime() documentation</a>",
// "site preference for short date format followed by site preference for short time format" => "site preference for short date format followed by site preference for short time format",
// "If set to an integer, event names are allowed that number of characters as a maximum before being truncated" => "If set to an integer, event names are allowed that number of characters as a maximum before being truncated",
// "Displays to registered users their blogs" => "Displays to registered users their blogs",
// "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed" => "Lightweight interface to user bookmarks, enabling to view them concisely, do some manipulations and bookmark the page being viewed",
// "User image galleries" => "User image galleries",
// "Displays to registered users their image galleries" => "Displays to registered users their image galleries",
// "Displays to registered users the specified number of wiki pages which they were the last to edit" => "Displays to registered users the specified number of wiki pages which they were the last to edit",
// "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations" => "Lightweight interface to user tasks, enabling to view them concisely and do some manipulations",
// "Lists the public user tasks of a chosen group, with links to tasks" => "Lists the public user tasks of a chosen group, with links to tasks",
// "User-Group Tracker" => "User-Group Tracker",
// "User and Group tracker links" => "User and Group tracker links",
// "Displays the specified number of users and their score, starting from the one with the highest score" => "Displays the specified number of users and their score, starting from the one with the highest score",
// "Webmail Inbox" => "Webmail Inbox",
// "Displays Webmail Inbox" => "Displays Webmail Inbox",
// "Account Id" => "Account Id",
// "Webmail account identifier (if not set uses user\\'s current account)" => "Webmail account identifier (if not set uses user\\'s current account)",
// "GroupMail: Group (e.g. \"Help Team\")" => "GroupMail: Group (e.g. \"Help Team\")",
// "GroupMail: Tracker Id (to store GroupMail activity)" => "GroupMail: Tracker Id (to store GroupMail activity)",
// "GroupMail: From Field (Id of field in tracker to store email From header)" => "GroupMail: From Field (Id of field in tracker to store email From header)",
// "Subject Field Id" => "Subject Field Id",
// "GroupMail: Subject Field (Id of field in tracker to store email Subject header)" => "GroupMail: Subject Field (Id of field in tracker to store email Subject header)",
// "Message Field Id" => "Message Field Id",
// "GroupMail: Message Field (Id of field in tracker to store email message identifier)" => "GroupMail: Message Field (Id of field in tracker to store email message identifier)",
// "Content Field Id" => "Content Field Id",
// "GroupMail: Content Field (Id of field in tracker to store email message body content)" => "GroupMail: Content Field (Id of field in tracker to store email message body content)",
// "Account Field Id" => "Account Field Id",
// "GroupMail: Account Field (Id of field in tracker to store Webmail account name)" => "GroupMail: Account Field (Id of field in tracker to store Webmail account name)",
// "DateTime Field Id" => "DateTime Field Id",
// "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)" => "GroupMail: Date Time Field (Id of field in tracker to store email sent timestamp)",
// "Operator Field Id" => "Operator Field Id",
// "GroupMail: Operator Field (Id of field in tracker to store operator name (username))" => "GroupMail: Operator Field (Id of field in tracker to store operator name (username))",
// "Maximum number of characters in subjects allowed before truncating" => "Maximum number of characters in subjects allowed before truncating",
// "Webmail error" => "Webmail error",
// "No accounts set up (or no current account set)" => "No accounts set up (or no current account set)",
// "Wiki Page" => "Wiki Page",
// "What is related" => "What is related",
// "Lists objects which share a category with the viewed object" => "Lists objects which share a category with the viewed object",
// "Displays information about users currently logged in" => "Displays information about users currently logged in",
// "Content to display" => "Content to display",
// "Display the number of users logged in, the list of users logged in, or both" => "Display the number of users logged in, the list of users logged in, or both",
// "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"" => "Possible values: \"count\", \"list\" or \"both\". Default value: \"both\"",
// "Cluster mode" => "Cluster mode",
// "If set to \"1\", separate users based on which host/server they logged on" => "If set to \"1\", separate users based on which host/server they logged on",
// "Last comments" => "Last comments",
// "Lists the specified number of comments starting from the most recently posted" => "Lists the specified number of comments starting from the most recently posted",
// "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip" => "If set to \"y\", the name of the object on which a comment is made is not displayed in the module box, but instead moved in the item\\'s tooltip",
// "Type of the objects from which comments will be listed. Possible values" => "Type of the objects from which comments will be listed. Possible values",
// "Last article comments" => "Last article comments",
// "YouTube" => "YouTube",
// "Displays YouTube videos and/or a link to a YouTube user\\'s page" => "Displays YouTube videos and/or a link to a YouTube user\\'s page",
// "Video identifiers" => "Video identifiers",
// "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")" => "List of YouTube videos identifiers to display. Identifiers are separated by a comma (\",\")",
// "YouTube user identifier" => "YouTube user identifier",
// "If set to a YouTube user identifier, display a link to the videos of this user" => "If set to a YouTube user identifier, display a link to the videos of this user",
// "Width of each video in pixels" => "Width of each video in pixels",
// "Height of each video in pixels" => "Height of each video in pixels",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Can admin external feeds" => "Can admin external feeds",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can list newsletters" => "Can list newsletters",
// "Can admin toolbars" => "Can admin toolbars",
// "Can change tracker pending items" => "Can change tracker pending items",
// "Can change tracker closed items" => "Can change tracker closed items",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can invite user in groups" => "Can invite user in groups",
// "Can delete his own account" => "Can delete his own account",
// "Can use the Tiki Importer" => "Can use the Tiki Importer",
// "Can see the category in a listing" => "Can see the category in a listing",
// "Can change the categories on the object" => "Can change the categories on the object",
// "Can add objects in the category" => "Can add objects in the category",
// "Can remove objects from the category" => "Can remove objects from the category",
// "Can create new categories" => "Can create new categories",
// "Can view the perspective" => "Can view the perspective",
// "Can view the group" => "Can view the group",
// "Can view the group members" => "Can view the group members",
// "Can add group members" => "Can add group members",
// "Can remove group members" => "Can remove group members",
// "Can join or leave the group" => "Can join or leave the group",
// "Can trigger the transition between two states" => "Can trigger the transition between two states",
// "Can admin kaltura feature" => "Can admin kaltura feature",
// "Can upload video on kaltura server" => "Can upload video on kaltura server",
// "Can edit information of kaltura entry" => "Can edit information of kaltura entry",
// "Can create kaltura remix video" => "Can create kaltura remix video",
// "Can delete kaltura entry" => "Can delete kaltura entry",
// "Can download kaltura entry" => "Can download kaltura entry",
// "Can list kaltura entries" => "Can list kaltura entries",
// "Can view kaltura entry" => "Can view kaltura entry",
// "Can upload screencasts to wiki pages" => "Can upload screencasts to wiki pages",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "groups are emulated" => "groups are emulated",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature listorphanStructure" => "feature listorphanStructure",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki dft list pages lang to current" => "wiki dft list pages lang to current",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki comments allow per page" => "wiki comments allow per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit icons toggle" => "wiki edit icons toggle",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "feature pagelist" => "feature pagelist",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin calendar" => "wikiplugin calendar",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin datachannel" => "wikiplugin datachannel",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin groupmailcore" => "wikiplugin groupmailcore",
// "wikiplugin groupstat" => "wikiplugin groupstat",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin invite" => "wikiplugin invite",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin listprogress" => "wikiplugin listprogress",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mcalendar" => "wikiplugin mcalendar",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin memberlist" => "wikiplugin memberlist",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin pagelist" => "wikiplugin pagelist",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin realnamelist" => "wikiplugin realnamelist",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin screencast" => "wikiplugin screencast",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin stat" => "wikiplugin stat",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin tabs" => "wikiplugin tabs",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin userpref" => "wikiplugin userpref",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline calendar" => "wikiplugininline calendar",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline datachannel" => "wikiplugininline datachannel",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline groupmailcore" => "wikiplugininline groupmailcore",
// "wikiplugininline groupstat" => "wikiplugininline groupstat",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline invite" => "wikiplugininline invite",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline listprogress" => "wikiplugininline listprogress",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mcalendar" => "wikiplugininline mcalendar",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline memberlist" => "wikiplugininline memberlist",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline pagelist" => "wikiplugininline pagelist",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline realnamelist" => "wikiplugininline realnamelist",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline screencast" => "wikiplugininline screencast",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline stat" => "wikiplugininline stat",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline tabs" => "wikiplugininline tabs",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline userpref" => "wikiplugininline userpref",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature webservices" => "feature webservices",
// "feature semantic" => "feature semantic",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal root id" => "fgal root id",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastModif" => "fgal list lastModif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "fgal quota" => "fgal quota",
// "fgal quota per fgal" => "fgal quota per fgal",
// "fgal quota default" => "fgal quota default",
// "fgal quota show" => "fgal quota show",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings threshold" => "forum thread user settings threshold",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list rating" => "art list rating",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "article image size x" => "article image size x",
// "article image size y" => "article image size y",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "trackerCreatorGroupName" => "trackerCreatorGroupName",
// "tracker jquery user selector threshold" => "tracker jquery user selector threshold",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "change password" => "change password",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "users prefs mailCurrentAccount" => "users prefs mailCurrentAccount",
// "validateRegistration" => "validateRegistration",
// "validator emails" => "validator emails",
// "url after validation" => "url after validation",
// "urlOnUsername" => "urlOnUsername",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature search preferences" => "feature search preferences",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "feature cal manual time" => "feature cal manual time",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "title rss forums" => "title rss forums",
// "title rss forum" => "title rss forum",
// "title rss directories" => "title rss directories",
// "title rss articles" => "title rss articles",
// "title rss blogs" => "title rss blogs",
// "title rss image galleries" => "title rss image galleries",
// "title rss file galleries" => "title rss file galleries",
// "title rss wiki" => "title rss wiki",
// "title rss image gallery" => "title rss image gallery",
// "title rss file gallery" => "title rss file gallery",
// "title rss blog" => "title rss blog",
// "title rss tracker" => "title rss tracker",
// "title rss trackers" => "title rss trackers",
// "title rss calendar" => "title rss calendar",
// "title rss mapfiles" => "title rss mapfiles",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupnameatr" => "auth ldap groupnameatr",
// "auth ldap groupdescatr" => "auth ldap groupdescatr",
// "auth ldap usergroupattr" => "auth ldap usergroupattr",
// "auth ldap groupgroupattr" => "auth ldap groupgroupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "ldap create user tiki" => "ldap create user tiki",
// "ldap create user ldap" => "ldap create user ldap",
// "ldap skip admin" => "ldap skip admin",
// "auth ldap permit tiki users" => "auth ldap permit tiki users",
// "auth ldap debug" => "auth ldap debug",
// "auth ldap ssl" => "auth ldap ssl",
// "auth ldap starttls" => "auth ldap starttls",
// "auth ldap type" => "auth ldap type",
// "auth ldap syncuserattr" => "auth ldap syncuserattr",
// "auth ldap syncgroupattr" => "auth ldap syncgroupattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "category jail" => "category jail",
// "expanded category jail" => "expanded category jail",
// "expanded category jail key" => "expanded category jail key",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "feature translation incomplete notice" => "feature translation incomplete notice",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "language inclusion threshold" => "language inclusion threshold",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag pagedesc" => "metatag pagedesc",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature custom html head content" => "feature custom html head content",
// "users prefs theme" => "users prefs theme",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "main shadow start" => "main shadow start",
// "main shadow end" => "main shadow end",
// "header shadow start" => "header shadow start",
// "header shadow end" => "header shadow end",
// "middle shadow start" => "middle shadow start",
// "middle shadow end" => "middle shadow end",
// "center shadow start" => "center shadow start",
// "center shadow end" => "center shadow end",
// "footer shadow start" => "footer shadow start",
// "footer shadow end" => "footer shadow end",
// "box shadow start" => "box shadow start",
// "box shadow end" => "box shadow end",
// "feature custom center column header" => "feature custom center column header",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "site title location" => "site title location",
// "site title breadcrumb" => "site title breadcrumb",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "section comments parse" => "section comments parse",
// "toolbar global" => "toolbar global",
// "toolbar global comments" => "toolbar global comments",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "feature kaltura" => "feature kaltura",
// "wikiplugin kaltura" => "wikiplugin kaltura",
// "wikiplugininline kaltura" => "wikiplugininline kaltura",
// "default kaltura editor" => "default kaltura editor",
// "partnerId" => "partnerId",
// "secret" => "secret",
// "adminSecret" => "adminSecret",
// "kdpUIConf" => "kdpUIConf",
// "kdpWidget" => "kdpWidget",
// "kcwUIConf" => "kcwUIConf",
// "kseUIConf" => "kseUIConf",
// "kaeUIConf" => "kaeUIConf",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty notice reporting" => "smarty notice reporting",
// "smarty security" => "smarty security",
// "feature htmlpurifier output" => "feature htmlpurifier output",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature machine translation" => "feature machine translation",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature perspective" => "feature perspective",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature daily report watches" => "feature daily report watches",
// "feature quick object perms" => "feature quick object perms",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session storage" => "session storage",
// "session lifetime" => "session lifetime",
// "session silent" => "session silent",
// "session cookie name" => "session cookie name",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "page n times in a structure" => "page n times in a structure",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "menus items icons" => "menus items icons",
// "menus items icons path" => "menus items icons path",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery ui theme" => "feature jquery ui theme",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature wiki screencasts" => "feature wiki screencasts",
// "feature wiki screencasts base" => "feature wiki screencasts base",
// "feature wiki screencasts httpbase" => "feature wiki screencasts httpbase",
// "feature wiki screencasts upload type" => "feature wiki screencasts upload type",
// "feature wiki screencasts user" => "feature wiki screencasts user",
// "feature wiki screencasts pass" => "feature wiki screencasts pass",
// "feature wiki screencasts max size" => "feature wiki screencasts max size",
// "feature tikitests" => "feature tikitests",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "memcache enabled" => "memcache enabled",
// "memcache flags" => "memcache flags",
// "memcache servers" => "memcache servers",
// "memcache expiration" => "memcache expiration",
// "memcache prefix" => "memcache prefix",
// "memcache wiki data" => "memcache wiki data",
// "memcache wiki output" => "memcache wiki output",
// "memcache forum output" => "memcache forum output",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "zend mail handler" => "zend mail handler",
// "zend mail smtp server" => "zend mail smtp server",
// "zend mail smtp auth" => "zend mail smtp auth",
// "zend mail smtp user" => "zend mail smtp user",
// "zend mail smtp pass" => "zend mail smtp pass",
// "zend mail smtp port" => "zend mail smtp port",
// "zend mail smtp security" => "zend mail smtp security",
// "feature group transition" => "feature group transition",
// "feature category transition" => "feature category transition",
// "terminology profile installed" => "terminology profile installed",
// "multidomain active" => "multidomain active",
// "multidomain config" => "multidomain config",
// "feature use minified scripts" => "feature use minified scripts",
// "tiki minify javascript" => "tiki minify javascript",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "mailCurrentAccount" => "mailCurrentAccount",
// "Anti-Bot verification code" => "Anti-Bot verification code",
// "Random Image" => "Random Image",
// "Enter the code you see above" => "Enter the code you see above",
// "debug" => "debug",
// "Click Here to Insert in Wiki Syntax" => "Click Here to Insert in Wiki Syntax",
// "Report this post" => "Report this post",
// "Group Monitor" => "Group Monitor",
// "Watched by categories" => "Watched by categories",
// "Toolbars" => "Toolbars",
// "optional" => "optional",
// "System error" => "System error",
// "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue" => "Database is not currently up to date! Visit <a href=\"tiki-install.php\">Tiki Installer</a> to resolve this issue",
// "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation" => "If you have shell (SSH) access, you can also use the following, on the command line, from the root of your Tiki installation",
// "The query was" => "The query was",
// "The built query was likely" => "The built query was likely",
// "Stacktrace" => "Stacktrace",
// "Tiki Debugger Console" => "Tiki Debugger Console",
// "Command" => "Command",
// "exec" => "exec",
// "Page generation debugging log" => "Page generation debugging log",
// "Features state" => "Features state",
// "features matched" => "features matched",
// "Watchlist" => "Watchlist",
// "File gallery" => "File gallery",
// "Duplicate permissions" => "Duplicate permissions",
// "View inserted gallery" => "View inserted gallery",
// "Any file" => "Any file",
// "Podcast (audio)" => "Podcast (audio)",
// "Podcast (video)" => "Podcast (video)",
// "Gallery is visible to non-admin users" => "Gallery is visible to non-admin users",
// "Gallery is public" => "Gallery is public",
// "Any user with permission (not only the gallery owner) can upload files" => "Any user with permission (not only the gallery owner) can upload files",
// "Files can be locked at download" => "Files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "unlimited" => "unlimited",
// "Owner of the gallery" => "Owner of the gallery",
// "Quota" => "Quota",
// "Used" => "Used",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Display Properties" => "Display Properties",
// "Max rows per page" => "Max rows per page",
// "Select which items to display when listing galleries" => "Select which items to display when listing galleries",
// "The checkbox is disabled because this preference is disabled globally" => "The checkbox is disabled because this preference is disabled globally",
// "Please, enable the preference globally first" => "Please, enable the preference globally first",
// "You can ask your site Admin to enable the preference" => "You can ask your site Admin to enable the preference",
// "Start the Slideshow" => "Start the Slideshow",
// "Pause the Slideshow" => "Pause the Slideshow",
// "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together or enclose them with double quotes",
// "Hi {\$mail_user} has sent you this link" => "Hi {\$mail_user} has sent you this link",
// "To validate your account and login to the site, please click on the following link" => "To validate your account and login to the site, please click on the following link",
// "The administrator approved your account" => "The administrator approved your account",
// "Confirm your email at %s" => "Confirm your email at %s",
// "A new topic was posted to forum" => "A new topic was posted to forum",
// "You are invited by" => "You are invited by",
// "You join this group" => "You join this group",
// "Join me on %s" => "Join me on %s",
// "You sent a request with the subject" => "You sent a request with the subject",
// "Use the subject to indicate the operation to apply" => "Use the subject to indicate the operation to apply",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "Page not found" => "Page not found",
// "A new message was posted to you at {\$mail_machine}" => "A new message was posted to you at {\$mail_machine}",
// "New message arrived from %s" => "New message arrived from %s",
// "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now" => "Your account registration request for {\$mail_site} was validated by the site admin and your account is active now",
// "To login with your username and password, please follow this link" => "To login with your username and password, please follow this link",
// "User Account Activated" => "User Account Activated",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "has requested an account on" => "has requested an account on",
// "To validate that account, please follow the link" => "To validate that account, please follow the link",
// "Assign to a group" => "Assign to a group",
// "Best regards" => "Best regards",
// "User Tracker" => "User Tracker",
// "User Registration Request" => "User Registration Request",
// "Go to your friendship network to accept or refuse this request" => "Go to your friendship network to accept or refuse this request",
// "You're invited to join my network of friends" => "You're invited to join my network of friends",
// "Bye bye from %s at %s" => "Bye bye from %s at %s",
// "Welcome to %s at %s" => "Welcome to %s at %s",
// "Email notification" => "Email notification",
// "Someone" => "Someone",
// "requested a reminder of the password for your account" => "requested a reminder of the password for your account",
// "requested password reset for your account" => "requested password reset for your account",
// "Since this is your registered email address we inform that the password for this account is" => "Since this is your registered email address we inform that the password for this account is",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "Important: Username & password are CaSe SenSitiVe" => "Important: Username & password are CaSe SenSitiVe",
// "Important: The old password remains active if you don't click the link above" => "Important: The old password remains active if you don't click the link above",
// "Your account information for %s" => "Your account information for %s",
// "Report for" => "Report for",
// "Last Report sent on" => "Last Report sent on",
// "Changes in detail" => "Changes in detail",
// "A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}",
// "You can edit the submission following this link" => "You can edit the submission following this link",
// "New article submitted at %s" => "New article submitted at %s",
// "Look at this link" => "Look at this link",
// "A friend sends you a link from: " => "A friend sends you a link from: ",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Tracker was modified at" => "Tracker was modified at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Last attempt" => "Last attempt",
// "IP" => "IP",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "If you want to be a registered user in this site you will have to use the following link to login for the first time" => "If you want to be a registered user in this site you will have to use the following link to login for the first time",
// "Your account request has been stored and will be activated by the admin as soon as possible" => "Your account request has been stored and will be activated by the admin as soon as possible",
// "You'll receive email notification once your account is activated" => "You'll receive email notification once your account is activated",
// "Please do not attempt to login until you receive the email notification" => "Please do not attempt to login until you receive the email notification",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "View the article at" => "View the article at",
// "If you don't want to receive these notifications follow this link" => "If you don't want to receive these notifications follow this link",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}",
// "View the blog at" => "View the blog at",
// "New blog post at %s" => "New blog post at %s",
// "View item calendar at" => "View item calendar at",
// "Modified calendar item" => "Modified calendar item",
// "New calendar item" => "New calendar item",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "Removed by" => "Removed by",
// "removed" => "removed",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "updated" => "updated",
// "File Gallery %s changed" => "File Gallery %s changed",
// "A file was removed from the file gallery" => "A file was removed from the file gallery",
// "File Name" => "File Name",
// "A new file was posted to file gallery" => "A new file was posted to file gallery",
// "Posted by" => "Posted by",
// "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum topic in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "Image Gallery {\$galleryName} changed" => "Image Gallery {\$galleryName} changed",
// "A new file was posted to image gallery" => "A new file was posted to image gallery",
// "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "You can view the updated map following this link" => "You can view the updated map following this link",
// "You can edit the map following this link" => "You can edit the map following this link",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "Structure modified" => "Structure modified",
// "A new file have been attached to page" => "A new file have been attached to page",
// "File name" => "File name",
// "New attachment on %s, page" => "New attachment on %s, page",
// "A file was attached to {\$mail_page}" => "A file was attached to {\$mail_page}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "You can view the page by following this link" => "You can view the page by following this link",
// "You can view a diff back to the previous version by following this link" => "You can view a diff back to the previous version by following this link",
// "The changes in this version follow below, followed after by the current full page text" => "The changes in this version follow below, followed after by the current full page text",
// "-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Lines: {\$oldd} changed to +Lines: {\$newd}",
// "The old page content follows below" => "The old page content follows below",
// "The new page content follows below" => "The new page content follows below",
// "A file was attached to %s" => "A file was attached to %s",
// "Thank you for your registration. You may log in now" => "Thank you for your registration. You may log in now",
// "click on the map to zoom or pan, do not drag" => "click on the map to zoom or pan, do not drag",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "Scale" => "Scale",
// "Zoom out" => "Zoom out",
// "Pan" => "Pan",
// "Zoom in" => "Zoom in",
// "Redraw" => "Redraw",
// "select zoom/pan/query and image size" => "select zoom/pan/query and image size",
// "View the Map Only" => "View the Map Only",
// "Reset Map" => "Reset Map",
// "Click on the map or click redraw" => "Click on the map or click redraw",
// "Overview" => "Overview",
// "Legend" => "Legend",
// "Layer Manager" => "Layer Manager",
// "Layer" => "Layer",
// "On" => "On",
// "Download Layer" => "Download Layer",
// "This layer has been set by the maps administrator to not be downloadable" => "This layer has been set by the maps administrator to not be downloadable",
// "you have requested to download the layer" => "you have requested to download the layer",
// "from the mapfile" => "from the mapfile",
// "Here are the files to download, do not forget to rename them" => "Here are the files to download, do not forget to rename them",
// "Mapfiles" => "Mapfiles",
// "Mapfile" => "Mapfile",
// "Available mapfiles" => "Available mapfiles",
// "hits last 7 days" => "hits last 7 days",
// "monitor this map" => "monitor this map",
// "Stop Monitoring this Map" => "Stop Monitoring this Map",
// "Create a new mapfile" => "Create a new mapfile",
// "Mapfile listing" => "Mapfile listing",
// "You can view this map in your browser using" => "You can view this map in your browser using",
// "Zoom out x2" => "Zoom out x2",
// "Zoom in x2" => "Zoom in x2",
// "Mapfile History" => "Mapfile History",
// "Comparing version {\$old.version} with version {\$new.version}" => "Comparing version {\$old.version} with version {\$new.version}",
// "v=view" => "v=view",
// "c=compare" => "c=compare",
// "d=diff" => "d=diff",
// "Full side-by-side diff" => "Full side-by-side diff",
// "Unified diff" => "Unified diff",
// "Side-by-side view" => "Side-by-side view",
// "Older Version" => "Older Version",
// "Directories" => "Directories",
// "back to" => "back to",
// "Bytes maximum" => "Bytes maximum",
// "Create Directory" => "Create Directory",
// "index file (.shp)" => "index file (.shp)",
// "files to index (regexp)" => "files to index (regexp)",
// "Message Archive" => "Message Archive",
// "messages" => "messages",
// "Archive is full" => "Archive is full",
// "Confirmation" => "Confirmation",
// "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences" => "If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences",
// "ERROR" => "ERROR",
// "No messages to download" => "No messages to download",
// "Mailbox is full! Delete or archive some messages if you want to receive more messages" => "Mailbox is full! Delete or archive some messages if you want to receive more messages",
// "Find replied message" => "Find replied message",
// "Auto-archive age for read messages" => "Auto-archive age for read messages",
// "Unflag" => "Unflag",
// "'name' parameter for tikimodule missed" => "'name' parameter for tikimodule missed",
// "Move module up" => "Move module up",
// "Move module down" => "Move module down",
// "Move module to opposite side" => "Move module to opposite side",
// "opp side" => "opp side",
// "Unassign this module" => "Unassign this module",
// "Are you sure you want to unassign this module" => "Are you sure you want to unassign this module",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "Toggle Vertically" => "Toggle Vertically",
// "Display type unknown, you have to enter the banner type" => "Display type unknown, you have to enter the banner type",
// "You forgot your Google ad_client number " => "You forgot your Google ad_client number ",
// "from the menu" => "from the menu",
// "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>",
// "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies",
// "To remove this module" => "To remove this module",
// "and remove the assistant module" => "and remove the assistant module",
// "You can also add other modules" => "You can also add other modules",
// "To customize the menu" => "To customize the menu",
// "and edit menu ID 42" => "and edit menu ID 42",
// "Or, create your own menu and add it to a module" => "Or, create your own menu and add it to a module",
// "To begin configuring Tiki, please" => "To begin configuring Tiki, please",
// "as admin" => "as admin",
// "The Tikiwiki Community" => "The Tikiwiki Community",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "Tikiwiki Documentation" => "Tikiwiki Documentation",
// "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "Missing %0 of the following categories" => "Missing %0 of the following categories",
// "%0 extra of the following categories" => "%0 extra of the following categories",
// "Unknown comparison" => "Unknown comparison",
// "Impossible condition, %0 of" => "Impossible condition, %0 of",
// "Assign into category" => "Assign into category",
// "Unassign category" => "Unassign category",
// "Tags This Page Has" => "Tags This Page Has",
// "List everything tagged" => "List everything tagged",
// "All Groups" => "All Groups",
// "Your Groups" => "Your Groups",
// "Emulated Groups" => "Emulated Groups",
// "Switch to Groups" => "Switch to Groups",
// "Simulate" => "Simulate",
// "No records to display" => "No records to display",
// "Enter user name and click 'Switch'.<br />Useful for testing permissions" => "Enter user name and click 'Switch'.<br />Useful for testing permissions",
// "Wiki feed" => "Wiki feed",
// "Feed" => "Feed",
// "Blogs feed" => "Blogs feed",
// "Articles feed" => "Articles feed",
// "Image Galleries feed" => "Image Galleries feed",
// "File Galleries feed" => "File Galleries feed",
// "Forums feed" => "Forums feed",
// "Maps feed" => "Maps feed",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Shout date" => "Shout date",
// "Find term" => "Find term",
// "If not found, you will be given a chance to create it" => "If not found, you will be given a chance to create it",
// "None match your" => "None match your",
// "Group information" => "Group information",
// "You need to activate user and/or group trackers" => "You need to activate user and/or group trackers",
// "Webmail inbox" => "Webmail inbox",
// "Refresh (non-ajax)" => "Refresh (non-ajax)",
// "TAKE" => "TAKE",
// "View contact" => "View contact",
// "User does not accept messages" => "User does not accept messages",
// "Changes that need to be reproduced are highlighted below" => "Changes that need to be reproduced are highlighted below",
// "[-]" => "[-]",
// "Use Ctrl+Click to select multiple options" => "Use Ctrl+Click to select multiple options",
// "Requires" => "Requires",
// "You need to set" => "You need to set",
// "Insert/Edit an internal wiki link" => "Insert/Edit an internal wiki link",
// "Wiki Link insert" => "Wiki Link insert",
// "Please make a selection of text in order to create a link" => "Please make a selection of text in order to create a link",
// "Insert an image" => "Insert an image",
// "Tiki Image - Insert an image" => "Tiki Image - Insert an image",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "Site Ads and Banners" => "Site Ads and Banners",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Global site configuration, date formats, admin password etc" => "Global site configuration, date formats, admin password etc",
// "Switches for major features" => "Switches for major features",
// "User resistration, remember me cookie settings and authentication methods" => "User resistration, remember me cookie settings and authentication methods",
// "User specific features and settings" => "User specific features and settings",
// "Repository configuration, browse and apply profiles" => "Repository configuration, browse and apply profiles",
// "Theme selection, layout settings and UI effect controls" => "Theme selection, layout settings and UI effect controls",
// "i18n" => "i18n",
// "Internationalization and localization - mulitlingual features" => "Internationalization and localization - mulitlingual features",
// "Text editing settings applicable to many areas. Plugin activation and plugin alias management" => "Text editing settings applicable to many areas. Plugin activation and plugin alias management",
// "Module appearance settings" => "Module appearance settings",
// "Information to include in the header of each page" => "Information to include in the header of each page",
// "Performance" => "Performance",
// "Server performance settings" => "Server performance settings",
// "Site security settings" => "Site security settings",
// "Feeds" => "Feeds",
// "Web feeds" => "Web feeds",
// "Connect" => "Connect",
// "Wiki page settings and features" => "Wiki page settings and features",
// "Defaults and configuration for file galleries" => "Defaults and configuration for file galleries",
// "Settings for blogs" => "Settings for blogs",
// "Defaults and configuration for image galleries (will be phased out in favour of file galleries)" => "Defaults and configuration for image galleries (will be phased out in favour of file galleries)",
// "Settings and features for articles" => "Settings and features for articles",
// "Settings and features for forums" => "Settings and features for forums",
// "Settings and features for trackers" => "Settings and features for trackers",
// "Settings and features for polls" => "Settings and features for polls",
// "Settings and features for calendars" => "Settings and features for calendars",
// "Settings and features for categories" => "Settings and features for categories",
// "Values of actions for users rank score" => "Values of actions for users rank score",
// "Settings and features for freetags" => "Settings and features for freetags",
// "Search configuration" => "Search configuration",
// "Settings and features for FAQs" => "Settings and features for FAQs",
// "Settings and features for directory of links" => "Settings and features for directory of links",
// "Settings and features for maps" => "Settings and features for maps",
// "Defaults and API key for Google Maps" => "Defaults and API key for Google Maps",
// "?" => "?",
// "Site-wide copyright information" => "Site-wide copyright information",
// "Message settings" => "Message settings",
// "User files settings" => "User files settings",
// "Webmail settings" => "Webmail settings",
// "Options for WYSIWYG editor" => "Options for WYSIWYG editor",
// "InterTiki" => "InterTiki",
// "Set up links between Tiki servers" => "Set up links between Tiki servers",
// "Manage semantic wiki links" => "Manage semantic wiki links",
// "Register and manage web services" => "Register and manage web services",
// "Sef URL" => "Sef URL",
// "Search Engine Friendly URLs" => "Search Engine Friendly URLs",
// "Kaltura video configuration" => "Kaltura video configuration",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Split hours in periods of" => "Split hours in periods of",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Look under \"Articles\" on the application menu for links to" => "Look under \"Articles\" on the application menu for links to",
// "Admin topics" => "Admin topics",
// "Title of articles home page" => "Title of articles home page",
// "Article properties" => "Article properties",
// "Give only one value (width or height) to keep the image proportions" => "Give only one value (width or height) to keep the image proportions",
// "File format: title,authorName,heading,body,lang,user" => "File format: title,authorName,heading,body,lang,user",
// "Articles Listing" => "Articles Listing",
// "Select which items to display when listing articles" => "Select which items to display when listing articles",
// "User features" => "User features",
// "Highlight group" => "Highlight group",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Users can choose to show their gender" => "Users can choose to show their gender",
// "Requires User Preferences feature" => "Requires User Preferences feature",
// "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU" => "TikiWiki CMS/Groupware is Free and Open Source Software (FOSS). It is a community-driven project which exists and improves thanks to the participation of people just like YOU",
// "Join the community" => "Join the community",
// "Promote your site" => "Promote your site",
// "To submit your site to TikiWiki.org" => "To submit your site to TikiWiki.org",
// "Submit site" => "Submit site",
// "Help Tiki spread" => "Help Tiki spread",
// "Help improve Tiki" => "Help improve Tiki",
// "To submit a feature request or to report a bug" => "To submit a feature request or to report a bug",
// "Click here to go to our development site" => "Click here to go to our development site",
// "To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or",
// "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or",
// "Global features" => "Global features",
// "Main feature" => "Main feature",
// "Additional" => "Additional",
// "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application" => "These features are relatively new, or recently underwent major renovations. You should expect growing pains and possibly a lack of up to date documentation, as you would of a version 1.0 application",
// "Will be phased out" => "Will be phased out",
// "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology" => "These features generally work but will probably be phased out in the future, because they are superseded by other features or because of evolution in Web technology",
// "Seem ok but.." => "Seem ok but..",
// "These features are not reported to be broken, but they are not actively developed and/or widely used" => "These features are not reported to be broken, but they are not actively developed and/or widely used",
// "Need polish" => "Need polish",
// "These features are generally known to have issues, and/or need admin help and/or user patience to work" => "These features are generally known to have issues, and/or need admin help and/or user patience to work",
// "Feedbacks" => "Feedbacks",
// "Move files from database to directory" => "Move files from database to directory",
// "Move files from directory to database" => "Move files from directory to database",
// "Upload Regex" => "Upload Regex",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "MIME Type" => "MIME Type",
// "System Command" => "System Command",
// "Reindex all files for search" => "Reindex all files for search",
// "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or",
// "Create a forum" => "Create a forum",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "When listing forums" => "When listing forums",
// "Forums Listing" => "Forums Listing",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Number of Tags to show in Tag Suggestions" => "Number of Tags to show in Tag Suggestions",
// "Valid characters pattern" => "Valid characters pattern",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "basic" => "basic",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Cleanup unused tags" => "Cleanup unused tags",
// "3D Tag Browser" => "3D Tag Browser",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Browser width" => "Browser width",
// "Graph appearance" => "Graph appearance",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Physics engine" => "Physics engine",
// "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "To add/remove image galleries, go to \"Image Galleries\" on the application menu, or",
// "You can upload images of a size of " => "You can upload images of a size of ",
// "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value",
// "Home Gallery" => "Home Gallery",
// "No Gallery exists" => "No Gallery exists",
// "Uses Slideshow" => "Uses Slideshow",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Directory Batch Loading" => "Directory Batch Loading",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols",
// "Enable directory batch loading" => "Enable directory batch loading",
// "Batch loading directory" => "Batch loading directory",
// "Display image informations in a mouseover box" => "Display image informations in a mouseover box",
// "yes, and don't display those informations under the image" => "yes, and don't display those informations under the image",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Default scale size" => "Default scale size",
// "Exterminator" => "Exterminator",
// "Mover" => "Mover",
// "Move images from database storage to filesystem storage" => "Move images from database storage to filesystem storage",
// "Move images from filesystem storage to database storage" => "Move images from filesystem storage to database storage",
// "Move images from old filesystem store to new directory" => "Move images from old filesystem store to new directory",
// "Moved" => "Moved",
// "Mail" => "Mail",
// "Mail Sender" => "Mail Sender",
// "Sendmail" => "Sendmail",
// "SMTP" => "SMTP",
// "SMTP Server" => "SMTP Server",
// "Authentication" => "Authentication",
// "These values will be stored in plain text in the database" => "These values will be stored in plain text in the database",
// "Logging and Reporting" => "Logging and Reporting",
// "Visible to admin only" => "Visible to admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Spam protection" => "Spam protection",
// "MultiDomain" => "MultiDomain",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Changing this feature will immediately log you out when you save this preference" => "Changing this feature will immediately log you out when you save this preference",
// "Redirects" => "Redirects",
// "If a requested page doesn't exist, redirect to a similarly named page" => "If a requested page doesn't exist, redirect to a similarly named page",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Site Access" => "Site Access",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Minimum {\$prefs.min_pass_length} characters long" => "Minimum {\$prefs.min_pass_length} characters long",
// "Change password" => "Change password",
// "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details" => "To use Google Maps, you must generate a Google Maps API Key for your web site. See <a href=\"http://www.google.com/apis/maps/signup.html\">http://www.google.com/apis/maps/signup.html</a> for details",
// "Google Maps API Key" => "Google Maps API Key",
// "Default x for map center" => "Default x for map center",
// "Default y from map center" => "Default y from map center",
// "Default zoom level" => "Default zoom level",
// "whole earth" => "whole earth",
// "country size" => "country size",
// "city size" => "city size",
// "max zoom" => "max zoom",
// "Edit or export/import Languages" => "Edit or export/import Languages",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Syntax error" => "Syntax error",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "Warning: overrides manually registered local users" => "Warning: overrides manually registered local users",
// "as master" => "as master",
// "Import user preferences" => "Import user preferences",
// "Import user groups" => "Import user groups",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "host" => "host",
// "Add new server" => "Add new server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Key" => "Key",
// "Kaltura Registration" => "Kaltura Registration",
// "If you don't have a Kaltura Partner Id, " => "If you don't have a Kaltura Partner Id, ",
// "to register" => "to register",
// "Kaltura Partner Settings" => "Kaltura Partner Settings",
// "Partner Id" => "Partner Id",
// "User Secret" => "User Secret",
// "Admin Secret" => "Admin Secret",
// "Kaltura Dynamic Player" => "Kaltura Dynamic Player",
// "KDP UI Configuration Id" => "KDP UI Configuration Id",
// "KDP Widget Id" => "KDP Widget Id",
// "Kaltura Contribution Wizard" => "Kaltura Contribution Wizard",
// "KCW UI Configuration Id" => "KCW UI Configuration Id",
// "Kaltura Remix Editors" => "Kaltura Remix Editors",
// "Kaltura Simple Editor UI Configuration Id" => "Kaltura Simple Editor UI Configuration Id",
// "Kaltura Advance Editor UI Configuration Id" => "Kaltura Advance Editor UI Configuration Id",
// "Enable/disable Tiki features in " => "Enable/disable Tiki features in ",
// ", but configure them elsewhere" => ", but configure them elsewhere",
// "Wysiwyg" => "Wysiwyg",
// "Registration" => "Registration",
// "Validate by email" => "Validate by email",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a>",
// "Validate user's email server" => "Validate user's email server",
// "Require validation by Admin" => "Require validation by Admin",
// "Validator emails (separated by comma) if different than the sender email" => "Validator emails (separated by comma) if different than the sender email",
// "Require passcode to register" => "Require passcode to register",
// "Passcode" => "Passcode",
// "Users must enter this code to register" => "Users must enter this code to register",
// "Use CAPTCHA to prevent automatic/robot registrations" => "Use CAPTCHA to prevent automatic/robot registrations",
// "Requires PHP GD library" => "Requires PHP GD library",
// "Include &quot;Generate Password&quot; option on registration form" => "Include &quot;Generate Password&quot; option on registration form",
// "Users can select a group to join at registration" => "Users can select a group to join at registration",
// "By default, new users automatically join the Registered group" => "By default, new users automatically join the Registered group",
// "Url a user is redirected after account validation" => "Url a user is redirected after account validation",
// "Use tracker to collect more user information" => "Use tracker to collect more user information",
// "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display",
// "Use tracker to collect more group information" => "Use tracker to collect more group information",
// "Re-validate user by email after" => "Re-validate user by email after",
// "Use <strong>-1</strong> for never" => "Use <strong>-1</strong> for never",
// "unsuccessful login attempts" => "unsuccessful login attempts",
// "Create a new group for each user" => "Create a new group for each user",
// "The group will be named identical to the user's username" => "The group will be named identical to the user's username",
// "Disable browser's autocomplete feature for username and password fields" => "Disable browser's autocomplete feature for username and password fields",
// "Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirm that the Admin account has a valid email address or you will not be permitted to login",
// "Use HTTPS login" => "Use HTTPS login",
// "Users can choose to stay in SSL mode after an HTTPS login" => "Users can choose to stay in SSL mode after an HTTPS login",
// "Users can switch between secured or standard mode at login" => "Users can switch between secured or standard mode at login",
// "User's choice" => "User's choice",
// "Cookie name" => "Cookie name",
// "Use email as username" => "Use email as username",
// "Minimum length" => "Minimum length",
// "Force lowercase" => "Force lowercase",
// "Username pattern" => "Username pattern",
// "Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Store passwords in plain text is activated. You should never set this unless you know what you are doing",
// "Users can change their password" => "Users can change their password",
// "Require characters and numerals" => "Require characters and numerals",
// "Password expires after" => "Password expires after",
// "LDAP" => "LDAP",
// "You must change the Authentication Method to LDAP for these changes to take effect" => "You must change the Authentication Method to LDAP for these changes to take effect",
// "Create user if not in Tiki" => "Create user if not in Tiki",
// "Create user if not in LDAP" => "Create user if not in LDAP",
// "Use Tiki authentication for Admin login" => "Use Tiki authentication for Admin login",
// "Use Tiki authentication for users created in tiki" => "Use Tiki authentication for users created in tiki",
// "LDAP Bind settings" => "LDAP Bind settings",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Write LDAP debug Information in Tiki Logs" => "Write LDAP debug Information in Tiki Logs",
// "Use SSL (ldaps)" => "Use SSL (ldaps)",
// "Use TLS" => "Use TLS",
// "LDAP Bind Type" => "LDAP Bind Type",
// "Default: userattr=username,UserDN,BaseDN" => "Default: userattr=username,UserDN,BaseDN",
// "userattr=username,BaseDN" => "userattr=username,BaseDN",
// "Active Directory (username@domain)" => "Active Directory (username@domain)",
// "Plain Username" => "Plain Username",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Synchronize user attributes to tiki everytime the user logs in" => "Synchronize user attributes to tiki everytime the user logs in",
// "LDAP Group" => "LDAP Group",
// "Synchronize group attributes to tiki everytime the user logs in" => "Synchronize group attributes to tiki everytime the user logs in",
// "Note: this enables the usage of LDAP groups" => "Note: this enables the usage of LDAP groups",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group description attribute" => "Group description attribute",
// "Group OC" => "Group OC",
// "LDAP Group Member - if group membership can be found in group attributes" => "LDAP Group Member - if group membership can be found in group attributes",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP User Group - if group membership can be found in user attributes" => "LDAP User Group - if group membership can be found in user attributes",
// "Group attribute in group entry" => "Group attribute in group entry",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "PAM" => "PAM",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "PAM service" => "PAM service",
// "Currently unused" => "Currently unused",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "CAS" => "CAS",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/" => "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/",
// "CAS server version" => "CAS server version",
// "Version 1.0" => "Version 1.0",
// "Version 2.0" => "Version 2.0",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "Themes" => "Themes",
// "Theme options" => "Theme options",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme Screenshot" => "Theme Screenshot",
// "Users can change theme" => "Users can change theme",
// "Restrict available themes" => "Restrict available themes",
// "Each group can have its theme" => "Each group can have its theme",
// "Slideshow theme" => "Slideshow theme",
// "Tiki Template Viewing" => "Tiki Template Viewing",
// "View Templates" => "View Templates",
// "Custom HTML &lt;head&gt; Content" => "Custom HTML &lt;head&gt; Content",
// "Custom Site Header" => "Custom Site Header",
// "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users" => "The Custom Site Header will display for the Admin only. Select <strong>Publish</strong> to display the content for </em>all<em> users",
// "Site Logo and Title" => "Site Logo and Title",
// "Logo source (image path)" => "Logo source (image path)",
// "Logo background color" => "Logo background color",
// "Examples" => "Examples",
// "Logo background style" => "Logo background style",
// "Logo alignment" => "Logo alignment",
// "Logo title (on mouse over)" => "Logo title (on mouse over)",
// "Alt. description (e.g. for text browsers)" => "Alt. description (e.g. for text browsers)",
// "Site title" => "Site title",
// "Subtitle" => "Subtitle",
// "Search Bar" => "Search Bar",
// "Login Bar" => "Login Bar",
// "Top Bar" => "Top Bar",
// "Site menu bar" => "Site menu bar",
// "Requires CSS Menus or PHPLayers" => "Requires CSS Menus or PHPLayers",
// "Menu ID" => "Menu ID",
// "Display current Tiki version" => "Display current Tiki version",
// "Custom code" => "Custom code",
// "Custom Center Column Header" => "Custom Center Column Header",
// "only if module" => "only if module",
// "user decides" => "user decides",
// "Users can Flip Columns" => "Users can Flip Columns",
// "Prefix breadcrumbs with &quot;Location : &quot" => "Prefix breadcrumbs with &quot;Location : &quot",
// "Site location bar" => "Site location bar",
// "Top of page" => "Top of page",
// "Top of center column" => "Top of center column",
// "Larger font for" => "Larger font for",
// "Entire location" => "Entire location",
// "Custom Site Footer" => "Custom Site Footer",
// "Custom End of &lt;body&gt; Code" => "Custom End of &lt;body&gt; Code",
// "Bottom bar icons" => "Bottom bar icons",
// "Bottom bar debug" => "Bottom bar debug",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Leave <strong>blank</strong> to use the default sender email" => "Leave <strong>blank</strong> to use the default sender email",
// "Shadow layer" => "Shadow layer",
// "Additional layers for shadows, rounded corners or other decorative styling" => "Additional layers for shadows, rounded corners or other decorative styling",
// "Main shadow start" => "Main shadow start",
// "Main shadow end" => "Main shadow end",
// "Header shadow start" => "Header shadow start",
// "Header shadow end" => "Header shadow end",
// "Middle shadow start" => "Middle shadow start",
// "Middle shadow end" => "Middle shadow end",
// "Center shadow start" => "Center shadow start",
// "Center shadow end" => "Center shadow end",
// "Footer shadow start" => "Footer shadow start",
// "Footer shadow end" => "Footer shadow end",
// "Module (box) shadow start" => "Module (box) shadow start",
// "Module (box) shadow end" => "Module (box) shadow end",
// "Pagination links" => "Pagination links",
// "Use relative (next / previous) pagination links" => "Use relative (next / previous) pagination links",
// "Max. number of links around the current item" => "Max. number of links around the current item",
// "Max. number of links after the first or before the last item" => "Max. number of links after the first or before the last item",
// "Display 'First' and 'Last' links" => "Display 'First' and 'Last' links",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "Use Icons" => "Use Icons",
// "UI Effects" => "UI Effects",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "Tooltips" => "Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "Autocomplete" => "Autocomplete",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "Superfish" => "Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "Reflection" => "Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery UI Theme" => "JQuery UI Theme",
// "JQuery UI Theme: Themes for look and feel of JQuery UI widgets" => "JQuery UI Theme: Themes for look and feel of JQuery UI widgets",
// "For future use" => "For future use",
// "Cycle" => "Cycle",
// "slideshow" => "slideshow",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules" => "Effect for modules",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Main JQuery effect" => "Main JQuery effect",
// "Speed" => "Speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Direction" => "Direction",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Use Tabs" => "Use Tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "CSS selectors to be fixed" => "CSS selectors to be fixed",
// "Separate multiple elements with a comma (&nbsp;,&nbsp;)" => "Separate multiple elements with a comma (&nbsp;,&nbsp;)",
// "HTMLDomElements to be fixed" => "HTMLDomElements to be fixed",
// "Favicon" => "Favicon",
// "Favicon icon file name" => "Favicon icon file name",
// "Favicon icon MIME type" => "Favicon icon MIME type",
// "image/png" => "image/png",
// "image/bmp" => "image/bmp",
// "image/x-icon" => "image/x-icon",
// "Context Menus" => "Context Menus",
// "Currently used in File Galleries only" => "Currently used in File Galleries only",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Separators" => "Separators",
// "Generate User Map" => "Generate User Map",
// "Meta tags" => "Meta tags",
// "Geo URL" => "Geo URL",
// "Robots" => "Robots",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Hint: If you lose your login module, use tiki-login_scr.php to be able to login" => "Hint: If you lose your login module, use tiki-login_scr.php to be able to login",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "Save Preferences" => "Save Preferences",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Flash Length" => "Flash Length",
// "Flash Heigth" => "Flash Heigth",
// "Video Length" => "Video Length",
// "Video Heigth" => "Video Heigth",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Performance'>Performance page</a> on Tiki's developer site",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>" => "Many search options impact performance. Please see <a href=\"tiki-admin.php?page=search\">Search admin panel</a>",
// "Loading profile" => "Loading profile",
// "Are you sure you want to apply the profile" => "Are you sure you want to apply the profile",
// "Sending" => "Sending",
// "TikiWiki Profiles" => "TikiWiki Profiles",
// "Apply Profiles" => "Apply Profiles",
// "A Friendly Warning" => "A Friendly Warning",
// "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles" => "Some of your Profiles Repositories are not connecting. This may prevent you from applying certain profiles",
// "Option 1: Quick Filter" => "Option 1: Quick Filter",
// "Option 2: Manual Filter" => "Option 2: Manual Filter",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Profile" => "Profile",
// "Repository" => "Repository",
// "applied" => "applied",
// "Profile repository" => "Profile repository",
// "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again" => "Javascript must be turned <b>ON</b> in order to apply Profiles. Please enable your javascript and try again",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "Profile tester" => "Profile tester",
// "This will run the profile and make potentially unrecoverable changes in your database" => "This will run the profile and make potentially unrecoverable changes in your database",
// "Test Profile Name" => "Test Profile Name",
// "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or" => "Use this page to configure the feeds generated by Tiki. To syndicate feeds from other sites, use the <strong>Admin</strong> &gt; <strong>External Feeds</strong> menu option, or",
// "External feeds" => "External feeds",
// "Feed for articles" => "Feed for articles",
// "Maximum number of items to display" => "Maximum number of items to display",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for blogs" => "Feed for blogs",
// "Individual blogs" => "Individual blogs",
// "Feed for image galleries" => "Feed for image galleries",
// "Individual image galleries" => "Individual image galleries",
// "Feed for file galleries" => "Feed for file galleries",
// "Individual file galleries" => "Individual file galleries",
// "Feed for wiki" => "Feed for wiki",
// "Individual forums" => "Individual forums",
// "Individual trackers items" => "Individual trackers items",
// "Calendar events" => "Calendar events",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public" => "Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public",
// "You can see users rank by score in the module users_rank, for that go to" => "You can see users rank by score in the module users_rank, for that go to",
// "Admin modules" => "Admin modules",
// "Expiration" => "Expiration",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search type" => "Search type",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "The indexation is always updated" => "The indexation is always updated",
// "Tiki search" => "Tiki search",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "The Tiki search indexes must be refreshed if you turn the Tiki search on" => "The Tiki search indexes must be refreshed if you turn the Tiki search on",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh wiki search index now" => "Refresh wiki search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Search Results" => "Search Results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site" => "Please see the <a class='rbox-link' target='tikihelp' href='http://dev.tikiwiki.org/Security'>Security page</a> on Tiki's developer site",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file" => "SEFURL will not work unless Tiki specific directives are deployed to the .htaccess file. You will need to execute htaccess.sh or manually configure the .htaccess file",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "Parse wiki syntax in comments in all sections apart from Forums" => "Parse wiki syntax in comments in all sections apart from Forums",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "AutoLinks" => "AutoLinks",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Plugin disabled" => "Plugin disabled",
// "Forum reply" => "Forum reply",
// "External links and images" => "External links and images",
// "External links will be identified with" => "External links will be identified with",
// "Plugins" => "Plugins",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "Plugin Aliases" => "Plugin Aliases",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "Tracker attachments" => "Tracker attachments",
// "Storage" => "Storage",
// "Switch storage" => "Switch storage",
// "Change all to db" => "Change all to db",
// "Change all to file" => "Change all to file",
// "Trackers with mirror tables" => "Trackers with mirror tables",
// "Use trackers with mirror tables" => "Use trackers with mirror tables",
// "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on" => "Do not use this feature as it is very buggy and unmaintained. It will be pulled out of the code base later on",
// "Validate choice" => "Validate choice",
// "Create New" => "Create New",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Page display" => "Page display",
// "List authors" => "List authors",
// "Allow override per page" => "Allow override per page",
// "Warn on edit conflict" => "Warn on edit conflict",
// "Edit idle timeout" => "Edit idle timeout",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Toggle display of section and plugin edit icons" => "Toggle display of section and plugin edit icons",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Manage attachments" => "Manage attachments",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "WikiWords" => "WikiWords",
// "Accept dashes and underscores in WikiWords" => "Accept dashes and underscores in WikiWords",
// "Link plural WikiWords to their singular forms" => "Link plural WikiWords to their singular forms",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "Side-by-side diff" => "Side-by-side diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "History all instead of only page data, description, and change comment" => "History all instead of only page data, description, and change comment",
// "Forums are disabled" => "Forums are disabled",
// "Forum for discussion" => "Forum for discussion",
// "Polls are disabled" => "Polls are disabled",
// "Open page as structure" => "Open page as structure",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "A page can occur multiple times in a structure" => "A page can occur multiple times in a structure",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "UserPage prefix" => "UserPage prefix",
// "Users can lock pages" => "Users can lock pages",
// "Wiki watch" => "Wiki watch",
// "Create watch for author on page creation" => "Create watch for author on page creation",
// "Enable watch events when I am the editor" => "Enable watch events when I am the editor",
// "Enable watches on comments" => "Enable watches on comments",
// "Watch minor edits" => "Watch minor edits",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Use wiki page staging and approval" => "Use wiki page staging and approval",
// "Force bounce of editing of approved pages to staging" => "Force bounce of editing of approved pages to staging",
// "Delete staging pages at approval" => "Delete staging pages at approval",
// "If not in the group, edit is always redirected to the staging page edit" => "If not in the group, edit is always redirected to the staging page edit",
// "Unique page name prefix to indicate staging copy" => "Unique page name prefix to indicate staging copy",
// "Hide page name prefix" => "Hide page name prefix",
// "Staging" => "Staging",
// "Approved" => "Approved",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Out-of-sync" => "Out-of-sync",
// "Categorize approved pages with categories of staging copy on approval" => "Categorize approved pages with categories of staging copy on approval",
// "Freetags are disabled" => "Freetags are disabled",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Page Listings" => "Page Listings",
// "Pages not in structure" => "Pages not in structure",
// "Configuration" => "Configuration",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Categories path" => "Categories path",
// "Wiki 3D Browser Configuration" => "Wiki 3D Browser Configuration",
// "Camera settings" => "Camera settings",
// "Upload Type" => "Upload Type",
// "Data location" => "Data location",
// "HTTP Prefix" => "HTTP Prefix",
// "WebDav username" => "WebDav username",
// "WebDav password" => "WebDav password",
// "Change" => "Change",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Development Notice" => "Development Notice",
// "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default" => "Unless a significant amount of preferences are documented and use dynamic preferences before the 4.0 release, this search feature will become disabled by default",
// "Database Version Problem" => "Database Version Problem",
// "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors",
// "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "A new version of Tikiwiki, <b>{\$prefs.tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
// "Shoutbox Words" => "Shoutbox Words",
// "Live Support" => "Live Support",
// "External Pages Cache" => "External Pages Cache",
// "Search Stats" => "Search Stats",
// "Please select some actions to view" => "Please select some actions to view",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "See Statistics" => "See Statistics",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "Edit Action" => "Edit Action",
// "Save Action" => "Save Action",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Total number of users" => "Total number of users",
// "Number of actions per object" => "Number of actions per object",
// "Total number of objects" => "Total number of objects",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "recorded" => "recorded",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Create / Edit Calendar" => "Create / Edit Calendar",
// "Admin Contributions" => "Admin Contributions",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Admin External Wikis" => "Admin External Wikis",
// "tiki admin external wikis template" => "tiki admin external wikis template",
// "Create/Edit Forums" => "Create/Edit Forums",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Edit zone" => "Edit zone",
// "Dynamic zones" => "Dynamic zones",
// "zone" => "zone",
// "Mass update" => "Mass update",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "Edit Repository" => "Edit Repository",
// "Create New Repository" => "Create New Repository",
// "List Repositories" => "List Repositories",
// "New Repository" => "New Repository",
// "View Repository" => "View Repository",
// "Human readable repository name" => "Human readable repository name",
// "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')",
// "File name of start page" => "File name of start page",
// "CSS file to load when browse this repository" => "CSS file to load when browse this repository",
// "Is repository visible to users" => "Is repository visible to users",
// "Can files from repository be cached" => "Can files from repository be cached",
// "Cacheable" => "Cacheable",
// "Are files from repository can be cached" => "Are files from repository can be cached",
// "Clear all cached pages of this repository" => "Clear all cached pages of this repository",
// "Seconds count 'till cached page will be expired" => "Seconds count 'till cached page will be expired",
// "Cache expiration" => "Cache expiration",
// "Human readable text description of repository" => "Human readable text description of repository",
// "Available Repositories" => "Available Repositories",
// "Edit rules" => "Edit rules",
// "Edit Rules for Repository" => "Edit Rules for Repository",
// "Configure Repositories" => "Configure Repositories",
// "Configure this Repository" => "Configure this Repository",
// "View this Repository" => "View this Repository",
// "New Rule" => "New Rule",
// "Copy Rules" => "Copy Rules",
// "view/hide copy rules dialog" => "view/hide copy rules dialog",
// "Source repository" => "Source repository",
// "Copy" => "Copy",
// "According this order rules will be applied ('0' or empty = auto)" => "According this order rules will be applied ('0' or empty = auto)",
// "Rule order" => "Rule order",
// "Text to search for" => "Text to search for",
// "Text to replace" => "Text to replace",
// "Is this regular expression or simple search/replacer" => "Is this regular expression or simple search/replacer",
// "Regex" => "Regex",
// "Is case sensitive (for simple replacer)" => "Is case sensitive (for simple replacer)",
// "Case sensitive" => "Case sensitive",
// "subset of chars: imsxeADSXUu, which is regex modifiers" => "subset of chars: imsxeADSXUu, which is regex modifiers",
// "Regex modifiers" => "Regex modifiers",
// "Human readable text description of rule" => "Human readable text description of rule",
// "Check to enable this rule" => "Check to enable this rule",
// "Enabled" => "Enabled",
// "Preview options" => "Preview options",
// "Apply all rules or just this to generate preview" => "Apply all rules or just this to generate preview",
// "Apply all rules" => "Apply all rules",
// "View source code after rules applied" => "View source code after rules applied",
// "Code preview" => "Code preview",
// "Generate HTML preview" => "Generate HTML preview",
// "HTML preview" => "HTML preview",
// "Test file from repository to generate preview for (empty = configured start page)" => "Test file from repository to generate preview for (empty = configured start page)",
// "Preview Results" => "Preview Results",
// "Rules List" => "Rules List",
// "Case" => "Case",
// "Configure/Options" => "Configure/Options",
// "Admin layout" => "Admin layout",
// "layout options" => "layout options",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "Edit this Featured Link" => "Edit this Featured Link",
// "Create new Featured Link" => "Create new Featured Link",
// "Mail-in accounts" => "Mail-in accounts",
// "Account" => "Account",
// "Add new Mail-in account" => "Add new Mail-in account",
// "Edit Mail-in account" => "Edit Mail-in account",
// "article-put" => "article-put",
// "Article Topic" => "Article Topic",
// "Article Type" => "Article Type",
// "Allow anonymous acces" => "Allow anonymous acces",
// "Allow attachments" => "Allow attachments",
// "Discard to the end from" => "Discard to the end from",
// "Check Mail-in accounts" => "Check Mail-in accounts",
// "Check automatically" => "Check automatically",
// "Frequency" => "Frequency",
// "mn" => "mn",
// "Show Quick Urls" => "Show Quick Urls",
// "Hide Quick Urls" => "Hide Quick Urls",
// "For wiki page, use ((PageName))" => "For wiki page, use ((PageName))",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed" => "If the url is ((PageName)), you do not need to put the groups, the option will be displayed only if the page can be displayed",
// "sorted section level 0" => "sorted section level 0",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'" => "To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'",
// "Create/Edit Menu" => "Create/Edit Menu",
// "Edit this Menu" => "Edit this Menu",
// "Create new Menu" => "Create new Menu",
// "Icons" => "Icons",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "Configure icons for menu entries" => "Configure icons for menu entries",
// "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu" => "To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=look\">Look and Feel</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu",
// "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes" => "To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes",
// "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>",
// "To use a menu in a tiki format" => "To use a menu in a tiki format",
// "To use menu in a css/suckerfish format" => "To use menu in a css/suckerfish format",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "The following required parameters are missing" => "The following required parameters are missing",
// "assign_name\">Module Name" => "assign_name\">Module Name",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "Visibility" => "Visibility",
// "Displayed now for all eligible users even with personal assigned modules" => "Displayed now for all eligible users even with personal assigned modules",
// "Displayed for the eligible users with no personal assigned modules" => "Displayed for the eligible users with no personal assigned modules",
// "Displayed now, can't be unassigned" => "Displayed now, can't be unassigned",
// "Not displayed until a user chooses it" => "Not displayed until a user chooses it",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Random active poll" => "Random active poll",
// "Random current poll" => "Random current poll",
// "phpLayersMenus" => "phpLayersMenus",
// "Use phplayermenu" => "Use phplayermenu",
// "Edit Newsletter" => "Edit Newsletter",
// "Group users" => "Group users",
// "Group subscription also subscribes included groups" => "Group subscription also subscribes included groups",
// "Don't send confirmation mail" => "Don't send confirmation mail",
// "The user email will be refreshed at each newsletter sending" => "The user email will be refreshed at each newsletter sending",
// "Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
// "Create Newsletter" => "Create Newsletter",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "Preload Admin Account" => "Preload Admin Account",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Admin page lists" => "Admin page lists",
// "Current lists" => "Current lists",
// "Edit this list" => "Edit this list",
// "Remove this list" => "Remove this list",
// "Edit list" => "Edit list",
// "Add list" => "Add list",
// "Seed with pages from a category" => "Seed with pages from a category",
// "Add page" => "Add page",
// "Page priority" => "Page priority",
// "Page score" => "Page score",
// "Edit {\$list.name|escape}" => "Edit {\$list.name|escape}",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "This menu shows only Polls with 'status': \"template\"" => "This menu shows only Polls with 'status': \"template\"",
// "Admin External Feeds" => "Admin External Feeds",
// "Tips" => "Tips",
// "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or" => "This page is to configure settings of external feeds read/imported by Tiki. To generate/export feeds, look for \"Feeds\" on the admin panel, or",
// "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed" => "To use feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the feed",
// "Edit this feed" => "Edit this feed",
// "Create new external feed" => "Create new external feed",
// "show feed title" => "show feed title",
// "show publish date" => "show publish date",
// "Show Date" => "Show Date",
// "View feed" => "View feed",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>",
// "PHP settings" => "PHP settings",
// "PHP variable" => "PHP variable",
// "Risk Factor" => "Risk Factor",
// "Explanation" => "Explanation",
// "PHP functions" => "PHP functions",
// "Function" => "Function",
// "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini" => "To disallow a function, add a disable_functions=exec,passthru for instance in your php.ini",
// "TikiWiki settings" => "TikiWiki settings",
// "Tiki variable" => "Tiki variable",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "Check all tiki files" => "Check all tiki files",
// "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini" => "Note, that this can take a very long time. You should check your max_execution_time setting in php.ini",
// "File checks" => "File checks",
// "Check file permissions" => "Check file permissions",
// "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments" => "This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "other" => "other",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "Admin Shoutbox Words" => "Admin Shoutbox Words",
// "Add Banned Word" => "Add Banned Word",
// "Are you sure you want to delete this word" => "Are you sure you want to delete this word",
// "XML Zip Import" => "XML Zip Import",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Destroy the structure leaving the wiki pages" => "Destroy the structure leaving the wiki pages",
// "Destroy the structure and remove the pages" => "Destroy the structure and remove the pages",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "XML Zip" => "XML Zip",
// "Create/Edit Surveys" => "Create/Edit Surveys",
// "This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1",
// "Investigate" => "Investigate",
// "View mode" => "View mode",
// "Wiki and WYSIWYG" => "Wiki and WYSIWYG",
// "Wiki only" => "Wiki only",
// "WYSIWYG only" => "WYSIWYG only",
// "Load" => "Load",
// "Reset to Global" => "Reset to Global",
// "Reset to defaults" => "Reset to defaults",
// "Auto Reloading" => "Auto Reloading",
// "Row" => "Row",
// "Formatting Tools" => "Formatting Tools",
// "Plugin Tools" => "Plugin Tools",
// "Edit tool" => "Edit tool",
// "Wysiwyg Token" => "Wysiwyg Token",
// "Plugin name" => "Plugin name",
// "Custom Tools" => "Custom Tools",
// "Add a new custom tool" => "Add a new custom tool",
// "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save" => "To configure the toolbars on the various text editing areas select the section, and optionally check the comments checkbox, you want to edit and drag the icons from the left hand box to the toolbars on the right.<br />\nDrag icons back from the toolbar rows onto the full list to remove them.<br />\nIcons with <strong>bold</strong> labels are for wiki text areas, those that are <em>italic</em> are for WYSIWYG mode, and those that are <strong><em>bold and italic</em></strong> are for both.<br />\nTo save the current set use the dropdown (and optionally check the comments checkbox) at the bottom of the page to set where you want these toolbars to appear, and click Save",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Groups will include" => "Groups will include",
// "Creator is assigned to the group" => "Creator is assigned to the group",
// "and it becomes his default group" => "and it becomes his default group",
// "and it becomes the new item group creator" => "and it becomes the new item group creator",
// "But copy the default group in this fiedlId before updating the group" => "But copy the default group in this fiedlId before updating the group",
// "Use \"explicit\" names in the mirror table" => "Use \"explicit\" names in the mirror table",
// "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique for a tracker and they must be valid in SQL",
// "User can take ownership of item created by anonymous" => "User can take ownership of item created by anonymous",
// "Member of the creator group can modify items" => "Member of the creator group can modify items",
// "Identify creation user in tracker item" => "Identify creation user in tracker item",
// "Identify lastModif user in tracker item" => "Identify lastModif user in tracker item",
// "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)",
// "Manage permissions" => "Manage permissions",
// "Inherits Permissions from" => "Inherits Permissions from",
// "Inherit permissions directly from following groups" => "Inherit permissions directly from following groups",
// "Selected groups only. Use Ctrl+Click to select more than one" => "Selected groups only. Use Ctrl+Click to select more than one",
// "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)" => "Also inheriting permissions from the following groups (indirect inheritance through the groups selected above)",
// "Group Homepage" => "Group Homepage",
// "Use wiki page name or full URL" => "Use wiki page name or full URL",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Group Theme" => "Group Theme",
// "Use site default" => "Use site default",
// "Group Information Tracker" => "Group Information Tracker",
// "choose a group tracker .." => "choose a group tracker ..",
// "choose a field .." => "choose a field ..",
// "Users Information Tracker" => "Users Information Tracker",
// "choose a users tracker .." => "choose a users tracker ..",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Users are automatically unassigned from the group after" => "Users are automatically unassigned from the group after",
// "0 or empty for never" => "0 or empty for never",
// "Assign group <em>management</em> permissions" => "Assign group <em>management</em> permissions",
// "Group tracker item : {\$groupitemid}" => "Group tracker item : {\$groupitemid}",
// "Group tracker item not found" => "Group tracker item not found",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Members List" => "Members List",
// "Remove from Group" => "Remove from Group",
// "users in group" => "users in group",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "Updated users" => "Updated users",
// "Group (direct)" => "Group (direct)",
// "Edit Included Group" => "Edit Included Group",
// "Confirm user email" => "Confirm user email",
// "Invalid email" => "Invalid email",
// "Manage Group Assignments" => "Manage Group Assignments",
// "Set Default Groups" => "Set Default Groups",
// "Send a wiki page by Email" => "Send a wiki page by Email",
// "Assign selected to" => "Assign selected to",
// "Remove selected from" => "Remove selected from",
// "the following groups" => "the following groups",
// "Tip: Hold down CTRL to select multiple" => "Tip: Hold down CTRL to select multiple",
// "Set the default group of the selected users to" => "Set the default group of the selected users to",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "Tikiwiki is configured to delegate the password managment to LDAP" => "Tikiwiki is configured to delegate the password managment to LDAP",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "You do not have permission to edit this user" => "You do not have permission to edit this user",
// "CSV file layout" => "CSV file layout",
// "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2" => "login,password,email<br />user1,pass1,email1<br />user2,pass2,email2",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Shows up in the drop down list of article types" => "Shows up in the drop down list of article types",
// "Allow ratings by the author" => "Allow ratings by the author",
// "Show before publish date" => "Show before publish date",
// "non-admins can view before the publish date" => "non-admins can view before the publish date",
// "Show after expire date" => "Show after expire date",
// "non-admins can view after the expire date" => "non-admins can view after the expire date",
// "Heading only" => "Heading only",
// "No article body, heading only" => "No article body, heading only",
// "Allow comments for this type" => "Allow comments for this type",
// "Comment Can Rate Article" => "Comment Can Rate Article",
// "Allow comments to include a rating value" => "Allow comments to include a rating value",
// "Show a small title over the title" => "Show a small title over the title",
// "Show subtitle" => "Show subtitle",
// "Show the subtitle" => "Show the subtitle",
// "Show source" => "Show source",
// "Show link to source after article body" => "Show link to source after article body",
// "Show Image Caption" => "Show Image Caption",
// "Show a legend under the image" => "Show a legend under the image",
// "Creator can edit" => "Creator can edit",
// "The person who submits an article of this type can edit it" => "The person who submits an article of this type can edit it",
// "Actions on this article type" => "Actions on this article type",
// "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems" => "This page will be replaced with the Object Permissions page although currently it does not support the \"advanced\" mode of this page.<br />Please try it out and feedback with any improvements or problems",
// "Click this button to try it now" => "Click this button to try it now",
// "Global object permissions" => "Global object permissions",
// "Assign User {\$assign_user|escape} to Groups" => "Assign User {\$assign_user|escape} to Groups",
// "Directory batch upload" => "Directory batch upload",
// "Remove File Extension from Image Name" => "Remove File Extension from Image Name",
// "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Select a Gallery" => "Select a Gallery",
// "Browse File Gallery" => "Browse File Gallery",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Available Files" => "Available Files",
// "Select a File Gallery" => "Select a File Gallery",
// "Process files" => "Process files",
// "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. ",
// "Powered by" => "Powered by",
// "Made with" => "Made with",
// "powered by" => "powered by",
// "The TikiWiki Community" => "The TikiWiki Community",
// "TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
// "database queries used in " => "database queries used in ",
// "Admin the Category System" => "Admin the Category System",
// "Directory Batch" => "Directory Batch",
// "Hit" => "Hit",
// "Slideshow Forward" => "Slideshow Forward",
// "Cyclic" => "Cyclic",
// "Click to zoom" => "Click to zoom",
// "Image Scale" => "Image Scale",
// "Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal degrees)",
// "Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal degrees)",
// "Include the image in a tiki page using the following syntax" => "Include the image in a tiki page using the following syntax",
// "To include the image in an HTML page" => "To include the image in an HTML page",
// "To link to this page from another tiki page" => "To link to this page from another tiki page",
// "Browsing Video" => "Browsing Video",
// "Edit Video" => "Edit Video",
// "First Video" => "First Video",
// "Prev Video" => "Prev Video",
// "Next Video" => "Next Video",
// "Last Video" => "Last Video",
// "Video Title" => "Video Title",
// "Move video" => "Move video",
// "You can view this video in your browser using" => "You can view this video in your browser using",
// "You can include the video in a tiki page using one of these lines" => "You can include the video in a tiki page using one of these lines",
// "Website" => "Website",
// "Change Focus" => "Change Focus",
// "o" => "o",
// "New Calendar Item" => "New Calendar Item",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Calendar import" => "Calendar import",
// "Calendar has been updated" => "Calendar has been updated",
// "D" => "D",
// "W" => "W",
// "M" => "M",
// "%d/%m" => "%d/%m",
// "%m/%d" => "%m/%d",
// "Advanced parameters for iCal export" => "Advanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "You can browse the generated WebHelp here" => "You can browse the generated WebHelp here",
// "Top page" => "Top page",
// "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a directory category now</a>",
// "Directory Categories" => "Directory Categories",
// "Use Ctrl+Click to select multiple directory categories" => "Use Ctrl+Click to select multiple directory categories",
// "Parent directory category" => "Parent directory category",
// "Most visited directory sub-categories" => "Most visited directory sub-categories",
// "Directory Category description" => "Directory Category description",
// "Random directory sub-categories" => "Random directory sub-categories",
// "Maximum number of children to show" => "Maximum number of children to show",
// "Allow sites in this directory category" => "Allow sites in this directory category",
// "Show number of sites in this directory category" => "Show number of sites in this directory category",
// "Editor group" => "Editor group",
// "Directory Subcategories" => "Directory Subcategories",
// "cType" => "cType",
// "allow" => "allow",
// "count" => "count",
// "relate" => "relate",
// "Admin related directory categories" => "Admin related directory categories",
// "Add a related directory category" => "Add a related directory category",
// "Directory Category" => "Directory Category",
// "Related directory categories" => "Related directory categories",
// "Add a Directory Category" => "Add a Directory Category",
// "in current directory category" => "in current directory category",
// "Total directory categories" => "Total directory categories",
// "Topline" => "Topline",
// "Article image" => "Article image",
// "Image caption" => "Image caption",
// "Expiration Date" => "Expiration Date",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "-1 for unlimited" => "-1 for unlimited",
// "Max impressions for a user" => "Max impressions for a user",
// "Max clicks" => "Max clicks",
// "Or, create a new zone" => "Or, create a new zone",
// "Use Flash" => "Use Flash",
// "Movie Size" => "Movie Size",
// "FlashPlugin min version" => "FlashPlugin min version",
// "ex" => "ex",
// "Remove Zones (you lose entered info for the banner)" => "Remove Zones (you lose entered info for the banner)",
// "Create Blog" => "Create Blog",
// "A category is mandatory" => "A category is mandatory",
// "Show user avatar" => "Show user avatar",
// "Edit Style Sheet" => "Edit Style Sheet",
// "Style Sheet" => "Style Sheet",
// "The file will be saved in" => "The file will be saved in",
// "choose a stylesheet" => "choose a stylesheet",
// "Try" => "Try",
// "For more information, please see" => "For more information, please see",
// "Wiki Page Editor" => "Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "Also available here" => "Also available here",
// "Plugins help" => "Plugins help",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus (useful in list to continue at the same level)" => "Creates an indentation for each plus (useful in list to continue at the same level)",
// "Prevents wiki parsing of the enclosed data" => "Prevents wiki parsing of the enclosed data",
// "Preformated sections" => "Preformated sections",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Block Preformatting" => "Block Preformatting",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt" => "Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt",
// "More help here" => "More help here",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "Upload from disk to change the image" => "Upload from disk to change the image",
// "Save and Go Next" => "Save and Go Next",
// "You can include the image in an HTML page using one of these lines" => "You can include the image in an HTML page using one of these lines",
// "Im-Export Languages" => "Im-Export Languages",
// "Toggle interactive translation off" => "Toggle interactive translation off",
// "Toggle interactive translation on" => "Toggle interactive translation on",
// "Immediate feedback" => "Immediate feedback",
// "Show correct answers" => "Show correct answers",
// "Shuffle questions" => "Shuffle questions",
// "Shuffle answers" => "Shuffle answers",
// "Passing Percentage" => "Passing Percentage",
// "Edit quiz questions" => "Edit quiz questions",
// "Question Type" => "Question Type",
// "Import questions from text" => "Import questions from text",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Input" => "Input",
// "Edit quiz results" => "Edit quiz results",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "<b>*</b>=optional" => "<b>*</b>=optional",
// "<b>Topline</b>=small line above Title" => "<b>Topline</b>=small line above Title",
// "<b>Subtitle</b>=small line below Title" => "<b>Subtitle</b>=small line below Title",
// "<b>Source</b>=URL to article source" => "<b>Source</b>=URL to article source",
// "Auto-Approve Article" => "Auto-Approve Article",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look & Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Save Only in the Theme" => "Save Only in the Theme",
// "Delete the copy in the theme" => "Delete the copy in the theme",
// "Edit a topic" => "Edit a topic",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
// "You must specify the object language" => "You must specify the object language",
// "The object doesn't exist" => "The object doesn't exist",
// "The object doesn't have a language" => "The object doesn't have a language",
// "The object has already a translation for this language" => "The object has already a translation for this language",
// "The object is already in the set of translations" => "The object is already in the set of translations",
// "Language of newly translated page" => "Language of newly translated page",
// "Unspecified" => "Unspecified",
// "Name of newly translated page" => "Name of newly translated page",
// "Create translation" => "Create translation",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "\"The page already exists. It was selected in the list below.\"" => "\"The page already exists. It was selected in the list below.\"",
// "Or" => "Or",
// "Add existing page as a translation of this page" => "Add existing page as a translation of this page",
// "Manage existing translations of this page" => "Manage existing translations of this page",
// "detach" => "detach",
// "Change language for this page" => "Change language for this page",
// "Select from available options.." => "Select from available options..",
// "Change Language" => "Change Language",
// "No language is assigned to this page" => "No language is assigned to this page",
// "Please select a language before performing translation" => "Please select a language before performing translation",
// "Set Current Page's Language" => "Set Current Page's Language",
// "Edit Video Information" => "Edit Video Information",
// "Browse Videos" => "Browse Videos",
// "The following video was successfully edited" => "The following video was successfully edited",
// "You can include the video in an HTML page using one of these lines" => "You can include the video in an HTML page using one of these lines",
// "View object" => "View object",
// "This edit session will expire in" => "This edit session will expire in",
// "Update '{\$page|escape}'" => "Update '{\$page|escape}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Draft written on" => "Draft written on",
// "Warning: new versions of this page have been made after this draft" => "Warning: new versions of this page have been made after this draft",
// "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page" => "The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page",
// "Edit wiki page" => "Edit wiki page",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Edit page" => "Edit page",
// "Edit comment: Enter some text to describe the changes you are currently making" => "Edit comment: Enter some text to describe the changes you are currently making",
// "Tools" => "Tools",
// "Allow comments on this page" => "Allow comments on this page",
// "Regex search " => "Regex search ",
// "Upload Screencast" => "Upload Screencast",
// "Incorrect file extension was used for your flash screencast, expecting .swf or .flv" => "Incorrect file extension was used for your flash screencast, expecting .swf or .flv",
// "An unexpected error occurred while uploading your flash screencast" => "An unexpected error occurred while uploading your flash screencast",
// "Incorrect file extension was used for your Ogg screencast, expecting .ogg" => "Incorrect file extension was used for your Ogg screencast, expecting .ogg",
// "A flash screencast is mandatory" => "A flash screencast is mandatory",
// "An unexpected error occurred while uploading your Ogg screencast" => "An unexpected error occurred while uploading your Ogg screencast",
// "Preview not possible" => "Preview not possible",
// "Flash video (required)" => "Flash video (required)",
// "Ogg video (optional)" => "Ogg video (optional)",
// "Add another screencast" => "Add another screencast",
// "Authors' style" => "Authors' style",
// "Description (used for metatags)" => "Description (used for metatags)",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "All fields" => "All fields",
// "These fields" => "These fields",
// "File Archive" => "File Archive",
// "File Galleries tpl" => "File Galleries tpl",
// "Create New File Gallery" => "Create New File Gallery",
// "Size (width x height)" => "Size (width x height)",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "Pending requests" => "Pending requests",
// "Request Time" => "Request Time",
// "Refuse" => "Refuse",
// "Waiting requests" => "Waiting requests",
// "Cancel friendship request" => "Cancel friendship request",
// "Your friends" => "Your friends",
// "break friendship" => "break friendship",
// "Geographic" => "Geographic",
// "Fields to show during browsing the gallery" => "Fields to show during browsing the gallery",
// "Creation Date" => "Creation Date",
// "XY-Size" => "XY-Size",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "Original image is default scale" => "Original image is default scale",
// "Add scaled images with bounding box of square size" => "Add scaled images with bounding box of square size",
// "Make Map" => "Make Map",
// "Google Map Locator" => "Google Map Locator",
// "enter address" => "enter address",
// "Find address" => "Find address",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Select Graphic Type" => "Select Graphic Type",
// "Pie Chart" => "Pie Chart",
// "Multiline" => "Multiline",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Landscape" => "Landscape",
// "Portrait" => "Portrait",
// "Independant Scale" => "Independant Scale",
// "Horizontal Scale" => "Horizontal Scale",
// "Vertical Scale" => "Vertical Scale",
// "Series" => "Series",
// "Wiki plug-in" => "Wiki plug-in",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "Calendar Import" => "Calendar Import",
// "ICal File" => "ICal File",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "Import From File" => "Import From File",
// "Grab Wiki Tables" => "Grab Wiki Tables",
// "Import pages from a Structured Text Dump" => "Import pages from a Structured Text Dump",
// "Name of the dump file (it has to be in dump/)" => "Name of the dump file (it has to be in dump/)",
// "body" => "body",
// "If you are NOT running a new Tiki installation, make a backup of your database before using this importer" => "If you are NOT running a new Tiki installation, make a backup of your database before using this importer",
// "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode" => "Your PHP is running with safe mode enabled. This might cause problems to the import process as safe mode limits the possibly to change in run time some PHP settings (like max_execution_time). It is recommended to run this script without safe mode",
// "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)" => "Depending on the size of the file from the source software, the import process may take a while to complete. This might be a problem according to your PHP and web server settings. This script tries to change the relevant settings but there are some settings that the script cannot change. So, if you are having problems with the script, please try to increase the value of the following PHP settings: max_input_time, max_execution_time (this setting is limited by the web server setting, if you are running Apache also change its Timeout setting), post_max_size, upload_max_filesize, memory_limit. It is recommended that you run this script on a server where you can change the values of those settings (if needed)",
// "Select the software to import from" => "Select the software to import from",
// "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button" => "WARNING: make sure to have a backup before running the script. If you do not have a backup this is the last chance to cancel the importer by clicking on the cancel button",
// "Congratulations! You have successful imported your data to Tikiwiki" => "Congratulations! You have successful imported your data to Tikiwiki",
// "pages imported from a total of" => "pages imported from a total of",
// "You can see the list of wiki pages in your site" => "You can see the list of wiki pages in your site",
// "here" => "here",
// "Importer log" => "Importer log",
// "Tiki installer" => "Tiki installer",
// "Welcome" => "Welcome",
// "Welcome to the Tiki installation and upgrade script" => "Welcome to the Tiki installation and upgrade script",
// "Use this script to install a new Tiki database or upgrade your existing database to release" => "Use this script to install a new Tiki database or upgrade your existing database to release",
// "For the latest information about this release, please read the" => "For the latest information about this release, please read the",
// "Release Notes" => "Release Notes",
// "For complete documentation, please visit" => "For complete documentation, please visit",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Select your language" => "Select your language",
// "Read the License" => "Read the License",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>",
// "Review the System Requirements" => "Review the System Requirements",
// "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/Requirements\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "This installer will perform some basic checks automatically" => "This installer will perform some basic checks automatically",
// "Memory" => "Memory",
// "Success" => "Success",
// "Tiki has not detected your PHP memory_limit" => "Tiki has not detected your PHP memory_limit",
// "This probably means you have no set limit (all is well)" => "This probably means you have no set limit (all is well)",
// "Tiki has detected your PHP memory limit at" => "Tiki has detected your PHP memory limit at",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver",
// "Tiki has detected your PHP memory_limit at" => "Tiki has detected your PHP memory_limit at",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Send Test Message" => "Send Test Message",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki was not able to send a test message" => "Tiki was not able to send a test message",
// "Review your mail log for details" => "Review your mail log for details",
// "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)",
// "If your host requires SMTP authentication, additional configuration may be necessary" => "If your host requires SMTP authentication, additional configuration may be necessary",
// "Image Processing" => "Image Processing",
// "Tiki detected" => "Tiki detected",
// "Tiki was not able to detect the GD library" => "Tiki was not able to detect the GD library",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Set the Database Connection" => "Set the Database Connection",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "You must create the database and user <em>before</em> completing this page" => "You must create the database and user <em>before</em> completing this page",
// "Tiki cannot find a database connection" => "Tiki cannot find a database connection",
// "This is normal for a new installation" => "This is normal for a new installation",
// "Tiki found an existing database connection in your local.php file" => "Tiki found an existing database connection in your local.php file",
// "Use Existing Connection" => "Use Existing Connection",
// "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Database information" => "Database information",
// "Enter your database connection information" => "Enter your database connection information",
// "Database type" => "Database type",
// "Select the type of database to use with Tiki" => "Select the type of database to use with Tiki",
// "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension",
// "Host name" => "Host name",
// "Enter the host name or IP for your database" => "Enter the host name or IP for your database",
// "Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Use <strong>localhost</strong> if the database is running on the same machine as Tiki",
// "Database name" => "Database name",
// "Enter the name of the database that Tiki will use" => "Enter the name of the database that Tiki will use",
// "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names",
// "Database user" => "Database user",
// "Enter a database user with administrator permission for the Database" => "Enter a database user with administrator permission for the Database",
// "User name" => "User name",
// "Install &amp; Upgrade" => "Install &amp; Upgrade",
// "Install" => "Install",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "This install will populate (or upgrade) the database" => "This install will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "A new install will populate the database" => "A new install will populate the database",
// "Reinstall the database" => "Reinstall the database",
// "This will destroy your current database" => "This will destroy your current database",
// "Reinstall" => "Reinstall",
// "Upgrade" => "Upgrade",
// "Warning: Category Permissions Will Not Be Upgraded" => "Warning: Category Permissions Will Not Be Upgraded",
// "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them" => "Category permissions have been revamped in version 4. If you have been using category permissions, note that they may not work properly after upgrading to version 4, and it will be necessary to reconfigure them",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "This site has an admin account configured" => "This site has an admin account configured",
// "Please login with your admin password to continue" => "Please login with your admin password to continue",
// "Review the Upgrade" => "Review the Upgrade",
// "Review the Installation" => "Review the Installation",
// "Upgrade complete" => "Upgrade complete",
// "Installation complete" => "Installation complete",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "If this is your first install, your admin password is <strong>admin</strong>" => "If this is your first install, your admin password is <strong>admin</strong>",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "SQL queries" => "SQL queries",
// "Database was left unchanged" => "Database was left unchanged",
// "Failed" => "Failed",
// "Operations failed" => "Operations failed",
// "Display details" => "Display details",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "Configure General Settings" => "Configure General Settings",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Login" => "Secure Login",
// "HTTPS login" => "HTTPS login",
// "Administrator" => "Administrator",
// "Admin email" => "Admin email",
// "This is the email address for your administrator account" => "This is the email address for your administrator account",
// "Enter Your Tiki" => "Enter Your Tiki",
// "The installation is complete" => "The installation is complete",
// "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an open source project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/Develop+Tiki' target='_blank'>develop Tiki</a>",
// "Installation" => "Installation",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Recommended" => "Recommended",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "MultiTiki" => "MultiTiki",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Restart the installer" => "Restart the installer",
// "Database Connection" => "Database Connection",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Install Profile" => "Install Profile",
// "Configure the General Settings" => "Configure the General Settings",
// "Tiki Icon" => "Tiki Icon",
// "TikiWiki Project Web Site" => "TikiWiki Project Web Site",
// "Support Forums" => "Support Forums",
// "TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware Project",
// "Powered by TikiWiki" => "Powered by TikiWiki",
// "Clear cached version and refresh cache" => "Clear cached version and refresh cache",
// "configure rules" => "configure rules",
// "Interactive translator" => "Interactive translator",
// "has been updated" => "has been updated",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Upload to Kaltura" => "Upload to Kaltura",
// "List Entries" => "List Entries",
// "Upload Successful" => "Upload Successful",
// "You have successfully added {\$count} new entry/entries" => "You have successfully added {\$count} new entry/entries",
// "Change Details" => "Change Details",
// "Remix" => "Remix",
// "Advanced Editor" => "Advanced Editor",
// "Simple Editor" => "Simple Editor",
// "Views" => "Views",
// "Plays" => "Plays",
// "v" => "v",
// "ExpireDate" => "ExpireDate",
// "AuthorName" => "AuthorName",
// "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone" => "To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone",
// "Max Clicks" => "Max Clicks",
// "The cache is used by" => "The cache is used by",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Future vers" => "Future vers",
// "Edit/Create" => "Edit/Create",
// "SlideShow" => "SlideShow",
// "Modifications" => "Modifications",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "Media Entries" => "Media Entries",
// "Mix Entries" => "Mix Entries",
// "Kaltura Remix Entries" => "Kaltura Remix Entries",
// "Kaltura Media Entries" => "Kaltura Media Entries",
// "Loads" => "Loads",
// "Browse Entries" => "Browse Entries",
// "Additional Info" => "Additional Info",
// "Media Type" => "Media Type",
// "No entries" => "No entries",
// "No media entries found. " => "No media entries found. ",
// "Click here " => "Click here ",
// "to upload" => "to upload",
// "No mix entries found. " => "No mix entries found. ",
// "to create a new mix" => "to create a new mix",
// "Playlist Type" => "Playlist Type",
// "No playlists found. " => "No playlists found. ",
// "to create a playlist" => "to create a playlist",
// "Object Permissions List" => "Object Permissions List",
// "Manage Permissions" => "Manage Permissions",
// "If an object is not in the special section, then only the default perms are on" => "If an object is not in the special section, then only the default perms are on",
// "Special" => "Special",
// "users registered" => "users registered",
// "Distance (km)" => "Distance (km)",
// "List Movies" => "List Movies",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Choose a movie" => "Choose a movie",
// "Page aliases found" => "Page aliases found",
// "Last modification" => "Last modification",
// "Page creator" => "Page creator",
// "Status of the page" => "Status of the page",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// "Page size" => "Page size",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "However, some page aliases fitting the query were found (see Aliases section above)" => "However, some page aliases fitting the query were found (see Aliases section above)",
// "offline" => "offline",
// "Live support:User window" => "Live support:User window",
// "Back to admin" => "Back to admin",
// "operator" => "operator",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "Mail-in feature" => "Mail-in feature",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Tikiwiki Mods" => "Tikiwiki Mods",
// "Mods Configuration" => "Mods Configuration",
// "Update remote index" => "Update remote index",
// "Rebuild local list" => "Rebuild local list",
// "Republish all" => "Republish all",
// "Publish all" => "Publish all",
// "Unpublish all" => "Unpublish all",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "all types" => "all types",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "Display only this type" => "Display only this type",
// "Unpublish" => "Unpublish",
// "Republish" => "Republish",
// "licence" => "licence",
// "Tikiwiki Mods Configuration" => "Tikiwiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
// "Package Config" => "Package Config",
// "y" => "y",
// "Records" => "Records",
// "To display the objects you created or contributed to" => "To display the objects you created or contributed to",
// "Sent Edition" => "Sent Edition",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "Currently editing Global permissions" => "Currently editing Global permissions",
// "This object's direct permissions override any global permissions or category permissions affecting this object" => "This object's direct permissions override any global permissions or category permissions affecting this object",
// "This category's direct permissions override any global permissions affecting objects in it" => "This category's direct permissions override any global permissions affecting objects in it",
// "To edit global permissions" => "To edit global permissions",
// "No permissions yet applied to this object but category permissions affect this object and are displayed below" => "No permissions yet applied to this object but category permissions affect this object and are displayed below",
// "To edit category permissions" => "To edit category permissions",
// "No direct permissions yet applied to this object. Global permissions apply" => "No direct permissions yet applied to this object. Global permissions apply",
// "Currently inherited permissions displayed" => "Currently inherited permissions displayed",
// "Assign global permissions" => "Assign global permissions",
// "Reset to Global Perms" => "Reset to Global Perms",
// "Reset Perms" => "Reset Perms",
// "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit any category permissions that are set, or the global sitewide permissions",
// "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions" => "This will remove all the settings here and permissions will be reset to inherit the global sitewide permissions",
// "Permissions Clipboard" => "Permissions Clipboard",
// "Copy the permissions set here" => "Copy the permissions set here",
// "Paste" => "Paste",
// "Paste copied permissions from " => "Paste copied permissions from ",
// "Assign or remove permissions on <em>all</em> child categories" => "Assign or remove permissions on <em>all</em> child categories",
// "Are you sure you want to effect all child categories?\\nThere is no undo" => "Are you sure you want to effect all child categories?\\nThere is no undo",
// "Assign or remove permissions on all pages of the sub-structure" => "Assign or remove permissions on all pages of the sub-structure",
// "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo" => "Are you sure you want to effect all pages in this sub-structure?\\nThere is no undo",
// "Select groups" => "Select groups",
// "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for" => "Some of your groups have been automatically hidden.<br /> Select the groups below to assign permissions for",
// "Select all" => "Select all",
// "Select features" => "Select features",
// "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for" => "Some of your features have been automatically hidden.<br /> Select the features below to assign permissions for",
// "Show permissions for disabled features" => "Show permissions for disabled features",
// "Feature name" => "Feature name",
// "Quick Permissions" => "Quick Permissions",
// "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>" => "To edit global permissions <a class=\"rbox-link\" href=\"tiki-objectpermissions.php?objectType=global\">click here</a>",
// "Assign Quick-Permissions to this object" => "Assign Quick-Permissions to this object",
// "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)" => "A couple of userdefined permissions are currently assigned (See tab Assign Permissions)",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "Make Structure" => "Make Structure",
// "(current)" => "(current)",
// "s=source" => "s=source",
// "b=rollback" => "b=rollback",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "Update Translation" => "Update Translation",
// "Hide translation history" => "Hide translation history",
// "Show translation history" => "Show translation history",
// "no avatar" => "no avatar",
// "reset" => "reset",
// "icons" => "icons",
// "Show all" => "Show all",
// "Avatar Image" => "Avatar Image",
// "random" => "random",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "View Details" => "View Details",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Insert" => "Insert",
// "Any" => "Any",
// "Items found" => "Items found",
// "atts" => "atts",
// "List Attachments" => "List Attachments",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups" => "For security, grant the <strong>tiki_p_plugin_approve</strong> permission only to trusted user groups",
// "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins" => "Use the <a href=\"tiki-admin.php?page=textarea\">Admin: Text Area page</a> to deactivate potentially risky plugins",
// "This page lists the plugins that require validation, the first time they are encountered" => "This page lists the plugins that require validation, the first time they are encountered",
// "Each plugin contains a unique <em>signature</em> that is preserved" => "Each plugin contains a unique <em>signature</em> that is preserved",
// "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list" => "If a plugin is no longer in use (for example, it has been removed from the wiki page), use <strong>Clear</strong> to remove it from this list",
// "The plugin will automatically be added if it is encountered" => "The plugin will automatically be added if it is encountered",
// "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin" => "Plugins can be individually previewed, approved, or rejected from the particular location that contains the plugin",
// "For security, you should review each plugin to ensure it is safe to approve" => "For security, you should review each plugin to ensure it is safe to approve",
// "Plugin" => "Plugin",
// "Added By" => "Added By",
// "Signature" => "Signature",
// "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "Wiki page: <a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page" => "<a href=\"%0#{\$plugin.fingerprint}\" title=\"{tr}View this page",
// "Approve all pending plugins" => "Approve all pending plugins",
// "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins" => "Using <strong>Approve</strong> or <strong>Approve All</strong> will approve and activate the pending plugins",
// "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe" => "Use this feature <strong>only</strong> if you have verified that all the pending plugins are safe",
// "No plugins pending approval" => "No plugins pending approval",
// "View Results" => "View Results",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Topic image" => "Topic image",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "The original document is available at" => "The original document is available at",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "No pages" => "No pages",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Add Structure Pages" => "Add Structure Pages",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "Edit quiz" => "Edit quiz",
// "Current Version" => "Current Version",
// "General Options" => "General Options",
// "Publication Date" => "Publication Date",
// "at " => "at ",
// "Use " => "Use ",
// "randomly selected questions" => "randomly selected questions",
// "Test-time Options" => "Test-time Options",
// "Limit questions displayed per page to " => "Limit questions displayed per page to ",
// "&nbsp question(s)" => "&nbsp question(s)",
// "Impose a time limit of " => "Impose a time limit of ",
// "Allow students to store partial results and return to quiz" => "Allow students to store partial results and return to quiz",
// "Allow students to retake this quiz " => "Allow students to retake this quiz ",
// "Grading and Feedback" => "Grading and Feedback",
// "Grading method " => "Grading method ",
// "Show students their score " => "Show students their score ",
// "Show students the correct answers " => "Show students the correct answers ",
// "Publish statistics " => "Publish statistics ",
// "Extra Options" => "Extra Options",
// "Solicit additional questions from students" => "Solicit additional questions from students",
// "Link quiz to forum named: " => "Link quiz to forum named: ",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\t\t\t\t\t\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "A valid email is mandatory to register" => "A valid email is mandatory to register",
// "Select your group" => "Select your group",
// "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter" => "Make sure to whitelist this domain to prevent registration emails being canned by your spam filter",
// "Tiki site registered" => "Tiki site registered",
// "You don't have permission to use this feature" => "You don't have permission to use this feature",
// "Please register" => "Please register",
// "Register this site at tikiwiki.org" => "Register this site at tikiwiki.org",
// "Read this first" => "Read this first",
// "On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites" => "On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites",
// "Registering is voluntary" => "Registering is voluntary",
// "Registering does not give you any benefits except one more link to your site" => "Registering does not give you any benefits except one more link to your site",
// "You don't get any emails, we don't sell the data about your site" => "You don't get any emails, we don't sell the data about your site",
// "Registering is just for us to get an overview of Tiki's usage" => "Registering is just for us to get an overview of Tiki's usage",
// "If your site is private or inside your intranet, you should not register" => "If your site is private or inside your intranet, you should not register",
// "tikiwiki.org" => "tikiwiki.org",
// "Information about your site" => "Information about your site",
// "to version" => "to version",
// "Simple search" => "Simple search",
// "Date Search" => "Date Search",
// "Calendar Items" => "Calendar Items",
// "octets" => "octets",
// "Reply To Email" => "Reply To Email",
// "if not" => "if not",
// "Save your changes" => "Save your changes",
// "Save any changes and send to all subscribers" => "Save any changes and send to all subscribers",
// "Send objects" => "Send objects",
// "Transmission results" => "Transmission results",
// "Send Wiki Pages" => "Send Wiki Pages",
// "Send a structure" => "Send a structure",
// "Add Article" => "Add Article",
// "Send objects to this site" => "Send objects to this site",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "Create a sheet" => "Create a sheet",
// "Edit this sheet" => "Edit this sheet",
// "Create New Sheet" => "Create New Sheet",
// "There are individual permissions set for this sheet" => "There are individual permissions set for this sheet",
// "Class Name" => "Class Name",
// "Header Rows" => "Header Rows",
// "Footer Rows" => "Footer Rows",
// "Create new Sheet" => "Create new Sheet",
// "You can access the sheet using the following URL" => "You can access the sheet using the following URL",
// "Available Sheets" => "Available Sheets",
// "Change shoutbox general settings" => "Change shoutbox general settings",
// "auto-link urls" => "auto-link urls",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "This text was automatically translated by Google Translate from the following page: " => "This text was automatically translated by Google Translate from the following page: ",
// "based on work by" => "based on work by",
// "Contributors to this page" => "Contributors to this page",
// "Most viewed objects" => "Most viewed objects",
// "Most viewed objects in the last 7 days" => "Most viewed objects in the last 7 days",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "Average posts per weblog" => "Average posts per weblog",
// "FAQ Stats" => "FAQ Stats",
// "Most viewed objects in period" => "Most viewed objects in period",
// "Usage chart image" => "Usage chart image",
// "Daily Usage" => "Daily Usage",
// "Thank you for your submission" => "Thank you for your submission",
// "Send a link to a friend" => "Send a link to a friend",
// "The link was sent to the following addresses" => "The link was sent to the following addresses",
// "Friend's email" => "Friend's email",
// "Separate multiple email addresses with a comma" => "Separate multiple email addresses with a comma",
// "Your name" => "Your name",
// "Your email" => "Your email",
// "I found an interesting page that I thought you would like" => "I found an interesting page that I thought you would like",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "Delete this link" => "Delete this link",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Control by Objects" => "Control by Objects",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "Edit File" => "Edit File",
// "Advanced mode" => "Advanced mode",
// "Retry" => "Retry",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You can link to the file from a Wiki page using" => "You can link to the file from a Wiki page using",
// "You can display an image in a Wiki page using" => "You can display an image in a Wiki page using",
// "Or using as a thumbnail with ShadowBox" => "Or using as a thumbnail with ShadowBox",
// "You can link to the file from an HTML page using" => "You can link to the file from an HTML page using",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "File title" => "File title",
// "required field for podcasts" => "required field for podcasts",
// "File description" => "File description",
// "Unzip zip files" => "Unzip zip files",
// "Author, if different from the Creator" => "Author, if different from the Creator",
// "Maximum number of downloads" => "Maximum number of downloads",
// "Maximum file size is around" => "Maximum file size is around",
// " Syntax tips" => " Syntax tips",
// "Link to file from a Wiki page" => "Link to file from a Wiki page",
// "For image files" => "For image files",
// "To display in a Wiki page" => "To display in a Wiki page",
// "Display thumbnail that enlarges" => "Display thumbnail that enlarges",
// "Image ID thumb" => "Image ID thumb",
// "Folder in" => "Folder in",
// "a bookmark" => "a bookmark",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "Basic Data" => "Basic Data",
// "User Icon" => "User Icon",
// "This user is your friend " => "This user is your friend ",
// "Additional Information" => "Additional Information",
// "User Contribution" => "User Contribution",
// "has contributed to the following content" => "has contributed to the following content",
// "has not contributed to any content yet" => "has not contributed to any content yet",
// "Send Me A Message" => "Send Me A Message",
// "Send me a message " => "Send me a message ",
// "The following message will be sent to user" => "The following message will be sent to user",
// "Message Body" => "Message Body",
// "Toggle" => "Toggle",
// "Toggle options" => "Toggle options",
// "Account Deletion" => "Account Deletion",
// "Are you really sure you want to delete your account " => "Are you really sure you want to delete your account ",
// "Check this box if you really want to delete your account" => "Check this box if you really want to delete your account",
// "Delete my account" => "Delete my account",
// "User Watches and preferences" => "User Watches and preferences",
// "You need to set your email to receive email notifications" => "You need to set your email to receive email notifications",
// "Report Preferences" => "Report Preferences",
// "You are not allowed to remove this notification " => "You are not allowed to remove this notification ",
// "Use reports to summarise notifications about objects you are watching" => "Use reports to summarise notifications about objects you are watching",
// "Use reports" => "Use reports",
// "Interval in witch you want to get the reports" => "Interval in witch you want to get the reports",
// "Short report" => "Short report",
// "Detailed report" => "Detailed report",
// "HTML-Email" => "HTML-Email",
// "Send me an email also if nothing happened" => "Send me an email also if nothing happened",
// "Reports are disabled, only standard reporting is available" => "Reports are disabled, only standard reporting is available",
// "Sites you are watching" => "Sites you are watching",
// "Reported Messages" => "Reported Messages",
// "Filter Tracker Items" => "Filter Tracker Items",
// "Items list" => "Items list",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Incoming servers (used in this order)" => "Incoming servers (used in this order)",
// "IMAP server" => "IMAP server",
// "Mbox filepath" => "Mbox filepath",
// "Maildir mail directory" => "Maildir mail directory",
// "Use SSL" => "Use SSL",
// "Outgoing server" => "Outgoing server",
// "Account details" => "Account details",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "This is the active account" => "This is the active account",
// "IMAP" => "IMAP",
// "Mbox" => "Mbox",
// "Maildir" => "Maildir",
// "POP3" => "POP3",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Auto refresh set for every \$autoRefresh seconds" => "Auto refresh set for every \$autoRefresh seconds",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Clip" => "Clip",
// "Part" => "Part",
// "View edit icons" => "View edit icons",
// "3d browser" => "3d browser",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Cancel Fullscreen" => "Cancel Fullscreen",
// "Show/Hide Left Column" => "Show/Hide Left Column",
// "Show/Hide Right Column" => "Show/Hide Right Column",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Remove Image" => "Remove Image",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Character Limit Exceeded" => "Character Limit Exceeded",
// "Character Count" => "Character Count",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Number of votes" => "Number of votes",
// "Your rating" => "Your rating",
// "You did not vote yet" => "You did not vote yet",
// "My rating" => "My rating",
// "Click to vote for this value" => "Click to vote for this value",
// "Clik to delete your vote" => "Clik to delete your vote",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "friends" => "friends",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Use this thread to discuss the page" => "Use this thread to discuss the page",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Email address the person you want to invite" => "Email address the person you want to invite",
// "Set in these groups" => "Set in these groups",
// "Leave" => "Leave",
// "Undecided" => "Undecided",
// "Last Day" => "Last Day",
// "Last Week" => "Last Week",
// "Last Month" => "Last Month",
// "Last Year" => "Last Year",
// "Your default group" => "Your default group",
// "Change default group" => "Change default group",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Creator &amp; Last Editor" => "Creator &amp; Last Editor",
// "Save the page as a partial translation" => "Save the page as a partial translation",
// "Partial Translation" => "Partial Translation",
// "Save the page as a completed translation" => "Save the page as a completed translation",
// "Complete Translation" => "Complete Translation",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%0 enabled" => "%0 enabled",
// "%0 disabled" => "%0 disabled",
// "%0 set" => "%0 set",
// "%0 unset" => "%0 unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Current version is up to date : <b>%0</b>" => "Current version is up to date : <b>%0</b>",
// "A new major release branch is available" => "A new major release branch is available",
// "A new %0 major release branch is available" => "A new %0 major release branch is available",
// "Wiki Attachments" => "Wiki Attachments",
// "Article/CMS settings" => "Article/CMS settings",
// "Configuration options for all blogs on your site" => "Configuration options for all blogs on your site",
// "FAQ comments settings" => "FAQ comments settings",
// "Trackers settings" => "Trackers settings",
// "Feeds settings" => "Feeds settings",
// "Directory settings" => "Directory settings",
// "Maps configuration" => "Maps configuration",
// "Meta Tags settings" => "Meta Tags settings",
// "Search settings" => "Search settings",
// "Score settings" => "Score settings",
// "Community settings" => "Community settings",
// "Calendar settings" => "Calendar settings",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Kaltura settings" => "Kaltura settings",
// "Help on \$admintitle Config" => "Help on \$admintitle Config",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "white" => "white",
// "gray" => "gray",
// "silver" => "silver",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "darkgrey" => "darkgrey",
// "Object doesn't exists" => "Object doesn't exists",
// "Click here to delete the category" => "Click here to delete the category",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "Category can`t be parent of itself" => "Category can`t be parent of itself",
// "No display" => "No display",
// "You have to provide a hotword and a URL" => "You have to provide a hotword and a URL",
// "You must specify a directory" => "You must specify a directory",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Detected, Version" => "Detected, Version",
// "Test Image" => "Test Image",
// "Not detected" => "Not detected",
// "Your admin password has been changed" => "Your admin password has been changed",
// "You cannot have a blank password" => "You cannot have a blank password",
// "All Fields except gdaltindex must be filled" => "All Fields except gdaltindex must be filled",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "No valid gdaltindex executable" => "No valid gdaltindex executable",
// "You cannot mix old and new trackers" => "You cannot mix old and new trackers",
// "Repository name can't be an empty" => "Repository name can't be an empty",
// "Requested action is not supported on repository" => "Requested action is not supported on repository",
// "No repository" => "No repository",
// "Search is mandatory field" => "Search is mandatory field",
// "File not found " => "File not found ",
// "Requested action in not supported on repository" => "Requested action in not supported on repository",
// "Mail-in account %s incorrect" => "Mail-in account %s incorrect",
// "Mail-in account %s saved" => "Mail-in account %s saved",
// "Frequency should be a positive integer" => "Frequency should be a positive integer",
// "Mail-in accounts set to be checked every %s minutes" => "Mail-in accounts set to be checked every %s minutes",
// "Automatic Mail-in accounts checking disabled" => "Automatic Mail-in accounts checking disabled",
// "Cannot create or update module: You need to specify a name to the module" => "Cannot create or update module: You need to specify a name to the module",
// "Cannot create or update module: You cannot leave the data field empty" => "Cannot create or update module: You cannot leave the data field empty",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "The list name must be specified" => "The list name must be specified",
// "Sorry, your list could not be added. Please check that it doesn\\'t already exist" => "Sorry, your list could not be added. Please check that it doesn\\'t already exist",
// "Sorry, your list could not be updated. Please check that it already exists" => "Sorry, your list could not be updated. Please check that it already exists",
// "unsafe" => "unsafe",
// "register_globals should be off by default. See the php manual for details" => "register_globals should be off by default. See the php manual for details",
// "safe" => "safe",
// "risky" => "risky",
// "off" => "off",
// "session.use_trans_sid should be off by default. See the php manual for details" => "session.use_trans_sid should be off by default. See the php manual for details",
// "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser",
// "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config" => "cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off" => "allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off",
// "The Path to store files in the filegallery should be outside the tiki root directory" => "The Path to store files in the filegallery should be outside the tiki root directory",
// "The Path to store files in the imagegallery should be outside the tiki root directory" => "The Path to store files in the imagegallery should be outside the tiki root directory",
// "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code" => "The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "SQL injection" => "SQL injection",
// "SQL injection by authenticated user" => "SQL injection by authenticated user",
// "SQL injection by authenticated user with special privileges" => "SQL injection by authenticated user with special privileges",
// "SQL injection without authentication" => "SQL injection without authentication",
// "PHP command injection" => "PHP command injection",
// "PHP command injection by authenticated user" => "PHP command injection by authenticated user",
// "PHP command injection by authenticated user with special privileges" => "PHP command injection by authenticated user with special privileges",
// "PHP command injection without authentication" => "PHP command injection without authentication",
// "File upload" => "File upload",
// "File is not readable. Unable to check" => "File is not readable. Unable to check",
// "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous" => "This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous",
// "This is a modified File. Cannot check version. Check if it is dangerous" => "This is a modified File. Cannot check version. Check if it is dangerous",
// "This file is from another Tikiwiki version: " => "This file is from another Tikiwiki version: ",
// "You have to provide a word" => "You have to provide a word",
// "You must specify a page name, it will be created if it doesn't exist" => "You must specify a page name, it will be created if it doesn't exist",
// "No Errors detected" => "No Errors detected",
// "Are you sure you want to delete this custom tool" => "Are you sure you want to delete this custom tool",
// "JavaScript is required for this page" => "JavaScript is required for this page",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove group: " => "Remove group: ",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "Group name can not be empty" => "Group name can not be empty",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "Invalid or unknown email" => "Invalid or unknown email",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "Created account %s <%s>" => "Created account %s <%s>",
// "Assigned %s in group %s" => "Assigned %s in group %s",
// "Email validation requested but email address not set" => "Email validation requested but email address not set",
// "Password not set" => "Password not set",
// "User %s already exists" => "User %s already exists",
// "User login contains invalid characters" => "User login contains invalid characters",
// "New %s created with %s %s" => "New %s created with %s %s",
// "Impossible to create new %s with %s %s" => "Impossible to create new %s with %s %s",
// "%s %s successfully deleted" => "%s %s successfully deleted",
// "Deleted account %s" => "Deleted account %s",
// "%s %s removed from %s %s" => "%s %s removed from %s %s",
// "%s %s assigned to %s %s" => "%s %s assigned to %s %s",
// "group %s set as the default group of user %s" => "group %s set as the default group of user %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "%s changed from %s to %s" => "%s changed from %s to %s",
// "Impossible to change %s from %s to %s" => "Impossible to change %s from %s to %s",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "rss feed disabled" => "rss feed disabled",
// "Tiki RSS feed for articles" => "Tiki RSS feed for articles",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "You have to indicate a group" => "You have to indicate a group",
// "This group is invalid" => "This group is invalid",
// "Image Galleries Admin Panel" => "Image Galleries Admin Panel",
// "Could not read image %s" => "Could not read image %s",
// "Image %s upload failed" => "Image %s upload failed",
// "Image %s uploaded successfully" => "Image %s uploaded successfully",
// "Image %s removed from Batch directory" => "Image %s removed from Batch directory",
// "Impossible to remove image %s from Batch directory" => "Impossible to remove image %s from Batch directory",
// "Permission denied you cannot use the batch directory loading" => "Permission denied you cannot use the batch directory loading",
// "Incorrect directory chosen for batch upload of images" => "Incorrect directory chosen for batch upload of images",
// "Please setup that dir on " => "Please setup that dir on ",
// "Please contact the website administrator" => "Please contact the website administrator",
// "Invalid directory name" => "Invalid directory name",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Tiki RSS feed for blog: " => "Tiki RSS feed for blog: ",
// "Last modifications to the blog" => "Last modifications to the blog",
// "No blogId specified" => "No blogId specified",
// "Tiki RSS feed for weblogs" => "Tiki RSS feed for weblogs",
// "Last posts to weblogs" => "Last posts to weblogs",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "Calendar event : " => "Calendar event : ",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Access Denied" => "Access Denied",
// "Mo" => "Mo",
// "Tu" => "Tu",
// "We" => "We",
// "Th" => "Th",
// "Fr" => "Fr",
// "Sa" => "Sa",
// "Su" => "Su",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Invalid username or activation code. Maybe this code has already been used" => "Invalid username or activation code. Maybe this code has already been used",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl" => "This feature is disabled'.\$prefs['validateUsers']));\n\t\$smarty->display('error.tpl",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field" => "ERROR: you must include a subject or a message. You must also make sure to have a valid e-mail in the FROM field",
// "You need to change chmod 'whelp' manually to 777" => "You need to change chmod 'whelp' manually to 777",
// "Tiki RSS feed for directory sites" => "Tiki RSS feed for directory sites",
// "Last sites" => "Last sites",
// "Must enter a name to add a site. " => "Must enter a name to add a site. ",
// "Must enter a url to add a site. " => "Must enter a url to add a site. ",
// "URL already added to the directory. Duplicate site? " => "URL already added to the directory. Duplicate site? ",
// "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. ",
// "Must select a category. " => "Must select a category. ",
// "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory",
// "No parent specified" => "No parent specified",
// "Last sites of directory \" . \$rc[\"name\"] . \" " => "Last sites of directory \" . \$rc[\"name\"] . \" ",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "The language can't be changed as its set of translations has already this language" => "The language can't be changed as its set of translations has already this language",
// "Invalid structure_id or page_ref_id" => "Invalid structure_id or page_ref_id",
// "No topic id specified" => "No topic id specified",
// "Invalid topic id specified" => "Invalid topic id specified",
// "No object indicated" => "No object indicated",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Translation of this page is incomplete" => "Translation of this page is incomplete",
// "No type indicated" => "No type indicated",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Override lock and carry on with edit" => "Override lock and carry on with edit",
// "Page is currently being edited" => "Page is currently being edited",
// "This page is being edited by " => "This page is being edited by ",
// "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. ",
// "Can't import remote HTML page" => "Can't import remote HTML page",
// "The file you selected is too large to upload" => "The file you selected is too large to upload",
// "Incorrect file extension was used for your 0gg screencast, expecting .ogg" => "Incorrect file extension was used for your 0gg screencast, expecting .ogg",
// "Page already exists. Go back and choose a different name" => "Page already exists. Go back and choose a different name",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "No questions group indicated" => "No questions group indicated",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Top visited file galleries" => "Top visited file galleries",
// "Most downloaded files" => "Most downloaded files",
// "Last files" => "Last files",
// "Tiki RSS feed for file galleries" => "Tiki RSS feed for file galleries",
// "Last files uploaded to the file galleries" => "Last files uploaded to the file galleries",
// "No galleryId specified" => "No galleryId specified",
// "Tiki RSS feed for the file gallery: " => "Tiki RSS feed for the file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "No forumId specified" => "No forumId specified",
// "Tiki RSS feed for forum: " => "Tiki RSS feed for forum: ",
// "Tiki RSS feed for forums" => "Tiki RSS feed for forums",
// "Last topics in forums" => "Last topics in forums",
// "Not supported yet" => "Not supported yet",
// "Accepted friendship request from %s" => "Accepted friendship request from %s",
// "Refused friendship request from %s" => "Refused friendship request from %s",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "Broke friendship with %s" => "Broke friendship with %s",
// "I have broken our friendship" => "I have broken our friendship",
// "You must be logged in to use this feature" => "You must be logged in to use this feature",
// "Friendship request sent to %s" => "Friendship request sent to %s",
// "You're already friend of %s" => "You're already friend of %s",
// "I have accepted your friendship request" => "I have accepted your friendship request",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "first uploaded image" => "first uploaded image",
// "last uploaded image" => "last uploaded image",
// "random image" => "random image",
// "Permission denied you cannot make the map of this gallery" => "Permission denied you cannot make the map of this gallery",
// "Top images" => "Top images",
// "Last images" => "Last images",
// "Back to preferences" => "Back to preferences",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "No sheet specified" => "No sheet specified",
// "You must select a renderer" => "You must select a renderer",
// "Invalid Series for current graphic" => "Invalid Series for current graphic",
// "Tiki RSS feed for image galleries" => "Tiki RSS feed for image galleries",
// "Last images uploaded to the image galleries" => "Last images uploaded to the image galleries",
// "Tiki RSS feed for the image gallery: " => "Tiki RSS feed for the image gallery: ",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "updated from structured text import" => "updated from structured text import",
// "created from structured text import" => "created from structured text import",
// "Operations executed successfully" => "Operations executed successfully",
// "Invalid software name" => "Invalid software name",
// "You have requested that this page be machine translated" => "You have requested that this page be machine translated",
// "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it" => "However, the Machine Translation feature is not enabled. Please enable this feature, or ask a site admin to do it",
// "No repository given" => "No repository given",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Permission denied: You cannot upload videos" => "Permission denied: You cannot upload videos",
// "You need to set your Kaltura account details: " => "You need to set your Kaltura account details: ",
// "Could not establish Kaltura session. Try again" => "Could not establish Kaltura session. Try again",
// "Permission denied: You cannot remix videos" => "Permission denied: You cannot remix videos",
// "Permission denied: You cannot change video version" => "Permission denied: You cannot change video version",
// "Permission denied: You cannot delete kaltura video" => "Permission denied: You cannot delete kaltura video",
// "Permission denied: You cannot download kaltura video" => "Permission denied: You cannot download kaltura video",
// "Permission denied: You cannot edit video information" => "Permission denied: You cannot edit video information",
// "Permission denied: You cannot view video" => "Permission denied: You cannot view video",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Quota too big" => "Quota too big",
// "Quota too small" => "Quota too small",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Could not upload the file" => "Could not upload the file",
// "Could not find the file requested" => "Could not find the file requested",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "File update was successful" => "File update was successful",
// "This gallery does not exist" => "This gallery does not exist",
// "Permission denied: You cannot view this page" => "Permission denied: You cannot view this page",
// "Invalid action" => "Invalid action",
// "You have to enable cookies to be able to login to this site" => "You have to enable cookies to be able to login to this site",
// "Unable to contact remote server" => "Unable to contact remote server",
// "XMLRPC Error: " => "XMLRPC Error: ",
// "Unable to create login" => "Unable to create login",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Resend" => "Resend",
// "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email" => "You should have received an email. Check your mailbox and your spam box.Otherwise click on the button to resend the email",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Sorry, you can't use this feature" => "Sorry, you can't use this feature",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files" => "Please create a directory named ' . \$prefs['map_path'] . ' to hold your map files",
// "You do not have permissions to view the maps" => "You do not have permissions to view the maps",
// "Maps feature is not correctly setup : Maps path is missing" => "Maps feature is not correctly setup : Maps path is missing",
// "mapfile name incorrect" => "mapfile name incorrect",
// "This mapfile already exists" => "This mapfile already exists",
// "You do not have permission to write to the mapfile" => "You do not have permission to write to the mapfile",
// "You do not have permission to delete the mapfile" => "You do not have permission to delete the mapfile",
// "I could not make a copy" => "I could not make a copy",
// "You do not have permission to read the mapfile" => "You do not have permission to read the mapfile",
// "map edit" => "map edit",
// "You dont have permission to do that" => "You dont have permission to do that",
// "Tiki RSS feed for maps" => "Tiki RSS feed for maps",
// "List of maps available" => "List of maps available",
// "You do not have permissions to view the layers" => "You do not have permissions to view the layers",
// "You do not have permissions to delete a file" => "You do not have permissions to delete a file",
// "You do not have permissions to create a directory" => "You do not have permissions to create a directory",
// "The Directory is not empty" => "The Directory is not empty",
// "You do not have permissions to delete a directory" => "You do not have permissions to delete a directory",
// "You do not have permissions to create an index file" => "You do not have permissions to create an index file",
// "Invalid file name" => "Invalid file name",
// "Invalid files to index" => "Invalid files to index",
// "I do not know where is gdaltindex. Set correctly the Map feature" => "I do not know where is gdaltindex. Set correctly the Map feature",
// "I could not create the index file" => "I could not create the index file",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Welcome at Hawiki" => "Welcome at Hawiki",
// "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more" => "This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more",
// "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site" => "You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site",
// "tiki-mobile.php" => "tiki-mobile.php",
// "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody",
// "Your PHP installation does not have zlib enabled" => "Your PHP installation does not have zlib enabled",
// "Note not found" => "Note not found",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Pageviews" => "Pageviews",
// "You don't have permission to edit quizzes" => "You don't have permission to edit quizzes",
// "You are already logged in" => "You are already logged in",
// "You must choose a group" => "You must choose a group",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "The passwords don't match" => "The passwords don't match",
// "Username cannot contain uppercase letters" => "Username cannot contain uppercase letters",
// "Username must be at least" => "Username must be at least",
// "Username cannot contain more than" => "Username cannot contain more than",
// "characters" => "characters",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "Missing User Name" => "Missing User Name",
// "User Already Exists" => "User Already Exists",
// "Valid User Name" => "Valid User Name",
// "Missing Email" => "Missing Email",
// "Valid Email" => "Valid Email",
// "Unable to send mail. User has not configured email" => "Unable to send mail. User has not configured email",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "The mail can't be sent. Contact the administrator" => "The mail can't be sent. Contact the administrator",
// "An email with a link to reset your password has been sent " => "An email with a link to reset your password has been sent ",
// "to the email" => "to the email",
// "last version" => "last version",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Permission denied you cannot rename this page" => "Permission denied you cannot rename this page",
// "Cannot rename page because the new name begins with reserved prefix" => "Cannot rename page because the new name begins with reserved prefix",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "Error Message" => "Error Message",
// "Tiki RSS Feed Error Message: \$errmsg" => "Tiki RSS Feed Error Message: \$errmsg",
// "A problem occured during file uploading" => "A problem occured during file uploading",
// "File which was causing trouble was at rank" => "File which was causing trouble was at rank",
// "The error was" => "The error was",
// "No newsletters available" => "No newsletters available",
// "invalid email" => "invalid email",
// "Error: " => "Error: ",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Report to the webmaster" => "Report to the webmaster",
// "empty" => "empty",
// "No trackerId specified" => "No trackerId specified",
// "Tiki RSS feed for individual trackers: " => "Tiki RSS feed for individual trackers: ",
// "You must lock the file before editing it" => "You must lock the file before editing it",
// "Batch file processed" => "Batch file processed",
// "Incorrect file extension" => "Incorrect file extension",
// "The uploaded file ist not recognized as a image" => "The uploaded file ist not recognized as a image",
// "That is not an image (or you have php < 4.0.5)" => "That is not an image (or you have php < 4.0.5)",
// "Your screencast has been uploaded successfully" => "Your screencast has been uploaded successfully",
// "Your screencasts have been uploaded successfully" => "Your screencasts have been uploaded successfully",
// "Usage" => "Usage",
// "Password has been changed" => "Password has been changed",
// "Invalid password. Your current password is required to change administrative information" => "Invalid password. Your current password is required to change administrative information",
// "Email is set to %s" => "Email is set to %s",
// "unicode" => "unicode",
// "open / in process" => "open / in process",
// "Rights by creator" => "Rights by creator",
// "END" => "END",
// "Percentage" => "Percentage",
// "Task entries" => "Task entries",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "You are not permitted to remove someone else\\'s post" => "You are not permitted to remove someone else\\'s post",
// "Incorrect thread" => "Incorrect thread",
// "A SheetId is required" => "A SheetId is required",
// "That tracker don't use extras" => "That tracker don't use extras",
// "There are a problem connecting to that account" => "There are a problem connecting to that account",
// "There are a problem deleting that mail" => "There are a problem deleting that mail",
// "Mail ID" => "Mail ID",
// "There are a problem deleting mails" => "There are a problem deleting mails",
// "Are you sure you want to delete this account" => "Are you sure you want to delete this account",
// "Taking" => "Taking",
// "Putting back" => "Putting back",
// "Checking" => "Checking",
// "Tiki RSS feed for the wiki pages" => "Tiki RSS feed for the wiki pages",
// "Last modifications to the Wiki" => "Last modifications to the Wiki",
// "Plugin modified by editor" => "Plugin modified by editor",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "You are about to delete a TikiTest file, do you want to continue " => "You are about to delete a TikiTest file, do you want to continue ",
// "Error deleting the file" => "Error deleting the file",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Requires MySQL 4.1+",
"MySQL classic (mysql)" => "MySQL classic (mysql)",
"Wiki" => "Wiki",
"WikiDiff::_check: failed" => "WikiDiff::_check: failed",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"CAS (Central Authentication Service)" => "CAS (Central Authentication Service)",
"utf-8" => "utf-8",
"iso-8859-1" => "iso-8859-1",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Mail-in" => "Mail-in",
"Banning system" => "Banning system",
"Category path" => "Category path",
"_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
"You are banned from" => "You are banned from",
"wiki" => "wiki",
"user selector" => "user selector",
"url" => "url",
"(AT)" => "(AT)",
"(DOT)" => "(DOT)",
"Code" => "Code",
"code" => "code",
"Cookie" => "Cookie",
"SQL" => "SQL",
"Id" => "Id",
"id" => "id",
"reported:" => "reported:",
"queued:" => "queued:",
"RSS Wiki" => "RSS Wiki",
"Tiki mail-in instructions" => "Tiki mail-in instructions",
"`\$module_params.prefix`" => "`\$module_params.prefix`",
"RSS feed" => "RSS feed",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"MultiPrint" => "MultiPrint",
"Cookies" => "Cookies",
"DSN" => "DSN",
"x" => "x",
"CMS" => "CMS",
"cookie" => "cookie",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"Valid" => "Valid",
"PDF" => "PDF",
"Tbl vis" => "Tbl vis",
"isMain" => "isMain",
"LongDesc" => "LongDesc",
"timestamp" => "timestamp",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"Wiki RSS" => "Wiki RSS",
"\$feature_label" => "\$feature_label",
"RSS" => "RSS",
"popup" => "popup",
"Click to select visible calendars" => "Click to select visible calendars",
"+" => "+",
"Organized by" => "Organized by",
"Children type" => "Children type",
"Float text around image" => "Float text around image",
"col" => "col",
"canRepeat" => "canRepeat",
"timeLimit" => "timeLimit",
"maxScore" => "maxScore",
"Edit queued message" => "Edit queued message",
"exclaim" => "exclaim",
"wink" => "wink",
"No messages queued yet" => "No messages queued yet",
"Reported by" => "Reported by",
"LastChanges" => "LastChanges",
"Xml Zip" => "Xml Zip",
"#" => "#",
"Summary" => "Summary",
"Emot" => "Emot",
"%H:%M %Z" => "%H:%M %Z",
"No name indicated for wiki page" => "No name indicated for wiki page",
"merged note:" => "merged note:",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Эта возможность заблокирована",
"Permission denied. You cannot view pages" => "У Вас недостаточно прав для просмотра страниц",
"For you to vote, cookies must be allowed" => "Для голосования должны быть разрешены Cookies",
"This forum is flat and doesn't allow replies to other replies" => "Этот форум является плоским и не позволяет ответы на ответы",
"This script cannot be called directly" => "Этот сценарий не может быть вызван напрямую",
"The copyright management feature is not enabled." => "Возможность управления авторскими правами не включена.",
"Copyright management" => "Управление авторскими правами",
"No page indicated" => "Страница не указана",
"You must supply all the information, including title and year." => "Вы должны указать всю информацию, включая название и год.",
"You do not have permission to use this feature" => "У Вас недостаточно прав, чтобы воспользоваться этой возможностью",
"This feature is for admins only" => "Эта возможность зарезервирована для администраторов",
"ID" => "Id",
"Type" => "Вид",
"Name" => "Имя",
"Description" => "Описание",
"Size" => "Размер",
"Created" => "Создано",
"Uploaded" => "Загружено",
"Last Modified" => "Последние Изменения",
"Creator" => "Создатель",
"Author" => "Автор",
"Last editor" => "Последний редактор",
"Comment" => "Комментарий",
"Files" => "Файлы",
"Hits" => "Запросы",
"Locked by" => "заблокировано",
"Explorer" => "Проводник",
"Path" => "Путь",
"Slideshow" => "Слайд-шоу",
"Default View" => "Стандартный вид",
"Afghanistan" => "Афганистан",
"Aland Islands" => "Аландские острова",
"Albania" => "Албания",
"Algeria" => "Алгерия",
"American Samoa" => "Американский Самоа",
"Andorra" => "Андорра",
"Angola" => "Ангола",
"Anguilla" => "Ангилья",
"Antigua" => "Антигуа",
"Argentina" => "Аргентина",
"Armenia" => "Армения",
"Aruba" => "Аруба",
"Australia" => "Австралия",
"Austria" => "Австрия",
"Azerbaijan" => "Азербайджан",
"Bahamas" => "Багамские острова",
"Bahrain" => "Бахрейн",
"Bangladesh" => "Бангладеш",
"Barbados" => "Барбадос",
"Belarus" => "Беларусь",
"Belgium" => "Бельгия",
"Belize" => "Белиз",
"Benin" => "Бенин",
"Bermuda" => "Бермудские острова",
"Bhutan" => "Бутан",
"Bolivia" => "Боливия",
"Bosnia and Herzegovina" => "Босния и Герцеговина",
"Botswana" => "Ботсвана",
"Bouvet Island" => "Остров Буве",
"Brazil" => "Бразилия",
"British Indian Ocean Territory" => "Британская территория в Индийском океане",
"British Virgin Islands" => "Британские Виргинские острова",
"Brunei" => "Бруней",
"Bulgaria" => "Болгария",
"Burkina Faso" => "Буркина-Фасо",
"Burundi" => "Бурунди",
"Cambodia" => "Камбодже",
"Cameroon" => "Камерун",
"Canada" => "Канада",
"Cape Verde" => "Кабо-Верде",
"Catalan Countries" => "Каталански Страны",
"Cayman Islands" => "Каймановы острова",
"Central African Republic" => "Центрально-Африканская Республика",
"Chad" => "Чад",
"Chile" => "Чили",
"China" => "Китай",
"Christmas Island" => "Остров Рождества",
"Cocos Islands" => "Кокосовые острова",
"Colombia" => "Колумбия",
"Comoros" => "Коморские острова",
"Congo" => "Конго",
"Congo Democratic" => "Конго Демократическая",
"Cook Islands" => "Острова Кука",
"Costa Rica" => "Коста-Рика",
"Croatia" => "Хорватию",
"Cuba" => "Куба",
"Cyprus" => "Кипр",
"Czech Republic" => "Чехия",
"Denmark" => "Дания",
"Djibouti" => "Джибути",
"Dominica" => "Доминик",
"Dominican Republic" => "Доминиканская Республика",
"Ecuador" => "Эквадор",
"Egypt" => "Египет",
"El Salvador" => "Сальвадор",
"Equatorial Guinea" => "Экваториальная Гвинея",
"Eritrea" => "Эритрея",
"Estonia" => "Эстония",
"Ethiopia" => "Эфиопия",
"Europe" => "Европа",
"Falkland Islands" => "Фолклендские острова",
"Faroe Islands" => "Фарерские острова",
"Federated States of Micronesia" => "Федеративные Штаты Микронезии",
"Fiji" => "Фиджи",
"Finland" => "Финляндия",
"France" => "Франция",
"French Guiana" => "Французская Гвиана",
"French Polynesia" => "Французская Полинезия",
"French Southern Territories" => "Французские Южные территории",
"Gabon" => "Габон",
"Gambia" => "Гамбия",
"Georgia" => "Грузия",
"Germany" => "Германия",
"Ghana" => "Гана",
"Gibraltar" => "Гибралтар",
"Greece" => "Греция",
"Greenland" => "Гренландия",
"Grenada" => "Гренада",
"Guadeloupe" => "Гваделупе",
"Guam" => "Гуам",
"Guatemala" => "Гватемале",
"Guernsey" => "Гернси",
"Guinea" => "Гвинея",
"Guinea Bissau" => "Гвинея-Бисау",
"Guyana" => "Гайана",
"Haiti" => "Гаити",
"Heard Island and McDonald Islands" => "Острова Херд и Макдональд",
"Honduras" => "Гондурас",
"Hong Kong" => "Гонконг",
"Hungary" => "Венгрия",
"Iceland" => "Исландия",
"India" => "Индия",
"Indonesia" => "Индонезия",
"Iran" => "Иран",
"Iraq" => "Ирак",
"Ireland" => "Ирландия",
"Isle of Man" => "Остров Мэн",
"Israel" => "Израиль",
"Italy" => "Италия",
"Ivory Coast" => "Берег Слоновой Кости",
"Jamaica" => "Ямайка",
"Japan" => "Япония",
"Jersey" => "Джерси",
"Jordan" => "Иордания",
"Kazakstan" => "Казахстан",
"Kenya" => "Кения",
"Kiribati" => "Кирибати",
"Kuwait" => "Кувейт",
"Kyrgyzstan" => "Кыргызстан",
"Laos" => "Лаос",
"Latvia" => "Латвия",
"Lebanon" => "Ливан",
"Lesotho" => "Лесото",
"Liberia" => "Либерия",
"Libya" => "Ливия",
"Liechtenstein" => "Лихтенштейн",
"Lithuania" => "Литва",
"Luxemburg" => "Люксембург",
"Macao" => "Макао",
"Macedonia" => "Македония",
"Madagascar" => "Мадагаскар",
"Malawi" => "Малави",
"Malaysia" => "Малайзия",
"Maldives" => "Мальдивы",
"Mali" => "Мали",
"Malta" => "Мальта",
"Marshall Islands" => "Маршалловы острова",
"Martinique" => "Мартиника",
"Mauritania" => "Мавритания",
"Mauritius" => "Маврикий",
"Mayotte" => "Майотта",
"Mexico" => "Мексика",
"Moldova" => "Молдова",
"Monaco" => "Монако",
"Mongolia" => "Монголия",
"Montenegro" => "Черногория",
"Montserrat" => "Монтсеррат",
"Morocco" => "Марокко",
"Mozambique" => "Мозамбик",
"Myanmar" => "Мьянма",
"Namibia" => "Намибия",
"Nauru" => "Науру",
"Nepal" => "Непал",
"Netherlands" => "Нидерланды",
"Netherlands Antilles" => "Нидерландские Антильские острова",
"New Caledonia" => "Новая Каледония",
"New Zealand" => "Новая Зеландия",
"Nicaragua" => "Никарагуа",
"Niger" => "Нигер",
"Nigeria" => "Нигерия",
"Niue" => "Ниуэ",
"None" => "Ничего",
"Norfolk Island" => "Норфолк",
"Northern Mariana Islands" => "Северные Марианские острова",
"North Korea" => "Северная Корея",
"Norway" => "Норвегия",
"Oman" => "Оман",
"Other" => "Другие",
"Pakistan" => "Пакистан",
"Palau" => "Палау",
"Palestine" => "Палестина",
"Panama" => "Панама",
"Papua New Guinea" => "Папуа-Новая Гвинея",
"Paraguay" => "Парагвай",
"Peru" => "Перу",
"Philippines" => "Филиппины",
"Pitcairn" => "Питкэрн",
"Poland" => "Польша",
"Portugal" => "Португалия",
"Puerto Rico" => "Пуэрто-Рико",
"Quatar" => "Катар",
"Republic of Macedonia" => "Республика Македония",
"Reunion" => "Воссоединение",
"Romania" => "Румыния",
"Russia" => "Россия",
"Rwanda" => "Руанда",
"Saint Helena" => "Святая Елена",
"Saint Kitts and Nevis" => "Сент-Китс и Невис",
"Saint Lucia" => "Сент-Люсии",
"Saint Pierre and Miquelon" => "Сен-Пьер и Микелон",
"Samoa" => "Самоа",
"San Marino" => "Сан-Марино",
"Sao Tome and Principe" => "Сан-Томе и Принсипи",
"Saudi Arabia" => "Саудовская Аравия",
"Senegal" => "Сенегал",
"Serbia" => "Сербия",
"Seychelles" => "Сейшельские острова",
"Sierra Leone" => "Сьерра-Леоне",
"Singapore" => "Сингапур",
"Slovakia" => "Словакия",
"Slovenia" => "Словения",
"Solomon Islands" => "Соломоновы острова",
"Somalia" => "Сомали",
"South Africa" => "Южная Африка",
"South Georgia and South Sandwich Islands" => "Южная Георгия и Южные Сандвичевы острова",
"South Korea" => "Южная Корея",
"Spain" => "Испания",
"Sri Lanka" => "Шри-Ланка",
"St Vincent Grenadines" => "Сент-Винсент Гренадин",
"Sudan" => "Судан",
"Surinam" => "Суринам",
"Svalbard and Jan Mayen" => "Шпицберген и Ян-Майен",
"Swaziland" => "Свазиленд",
"Sweden" => "Швеция",
"Switzerland" => "Швейцария",
"Syria" => "Сирия",
"Taiwan" => "Тайвань",
"Tajikistan" => "Таджикистан",
"Tanzania" => "Танзания",
"Thailand" => "Таиланд",
"Timor-Leste" => "Восточный Тимор",
"Togo" => "Того",
"Tokelau" => "Токелау",
"Tonga" => "Тонга",
"Trinidad Tobago" => "Тринидад Тобаго",
"Tunisia" => "Тунис",
"Turkey" => "Турция",
"Turkmenistan" => "Туркменистан",
"Turks and Caicos Islands" => "Острова Теркс и Кайкос",
"Tuvalu" => "Тувалу",
"Uganda" => "Уганда",
"Ukraine" => "Украина",
"United Arab Emirates" => "Объединенные Арабские Эмираты",
"United Kingdom" => "Великобритания",
"United Nations Organization" => "Организация Объединенных Наций",
"United States" => "США",
"United States Minor Outlying Islands" => "Внешние малые острова",
"Uruguay" => "Уругвай",
"US Virgin Islands" => "Американские Виргинские острова",
"Uzbekistan" => "Узбекистан",
"Vanuatu" => "Вануату/Фиджи",
"Vatican" => "Ватикан",
"Venezuela" => "Венесуэла",
"Viet Nam" => "Вьетнам",
"Wales" => "Уэльс",
"Wallis and Futuna" => "Уоллис и Футуна",
"Western Sahara" => "Западная Сахара",
"World" => "Мир",
"Yemen" => "Йемен",
"Yugoslavia" => "Югославия",
"Zambia" => "Замбия",
"Zimbabwe" => "Зимбабве",
"Email address not valid, test mail not sent" => "Эл.адрес не корректный, тестовое письмо не отправлено",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "Эл.адрес не задан и флаг \"копировать\" не установлен, тестовое письмо не отправлено",
"Test mail from Tiki installer " => "Тестовое письмо инсталляции Tiki",
"Congratulations!\n\nYour server can send emails.\n\n" => "Поздравляем!\n\nВаш сервер умеет рассылать письма.\n\n",
"Arabic" => "Арабский",
"Catalan" => "Каталонский",
"Simplified Chinese" => "Упрощенный китайский",
"Chinese" => "Китайский",
"Czech" => "Чешский",
"Danish" => "Датский",
"German" => "Немецкий",
"English" => "Английский",
"English British" => "Английский британский",
"Spanish" => "Испанский",
"Greek" => "Греческий",
"Farsi" => "Персидский",
"Finnish" => "Финский",
"Fijian" => "Фиджи",
"French" => "французский",
"Galician" => "Галицкий",
"Hebrew" => "Иврит",
"Croatian" => "Хорватский",
"Italian" => "Итальянский",
"Japanese" => "Японский",
"Korean" => "Корейский",
"Hungarian" => "Венгерский",
"Dutch" => "Голландский",
"Norwegian" => "Норвежский",
"Polish" => "Польский",
"Português" => "Португальский",
"Brazilian Portuguese" => "Бразильский португальский",
"Russian" => "Русский",
"Slovak" => "Словацкий",
"Serbian" => "Сербский",
"Serbian Latin" => "Сербский латиница",
"Swedish" => "Шведский",
"Tuvaluan" => "Тувалу",
"Traditional Chinese" => "Традиционный китайский",
"Ukrainian" => "Украинский",
"Permission denied" => "Доступ запрещён",
"Template %s not registered" => "Шаблон %s не зарегистрирован",
"The file is not a CSV file or has not a correct syntax" => "Файл не является CSV файлом или имеет неправильный синтаксис",
"Error line: %d" => "Ошибка в строке: %d",
"locked" => "закрыто",
"locked by" => "заблокировано",
"All Day" => "Весь день",
"in" => "в",
"continued" => "продолжено",
"New Image Uploaded by" => "новое изображение закачано",
"New Subscriptions" => "новые подписки",
"New Item in Tracker" => "новый объект в трекере",
"tracker" => "трекер",
"by" => "автор",
"Image Gallery" => "Фотогалерея",
"Articles" => "Статьи",
"Blogs" => "Блоги",
"Forums" => "Форумы",
"Directory" => "Каталог ссылок",
"File Gallery" => "Файловая Галерея",
"FAQs" => "ЧаВо",
"Quizzes" => "Тесты",
"Trackers" => "Трекеры",
"Survey" => "Анкета",
"Newsletter" => "Рассылка",
"article" => "статья",
"blog" => "блог",
"directory" => "каталог",
"faq" => "чаво",
"file gallery" => "файловая галерея",
"forum" => "форум",
"image gallery" => "галерея изображений",
"newsletter" => "новости",
"poll" => "опрос",
"quiz" => "тест",
"survey" => "опрос",
"wiki page" => "wiki страница",
"image" => "изображение",
"calendar" => "календарь",
"Invalid filename (using filters for filenames)" => "Недействительное имя файла (с использованием фильтров для файлов)",
"Cannot upload this file - maximum upload size exceeded" => "Невозможно закачать файл, превышен допустимый размер",
"(not registered)" => "(не зарегистрирован)",
"Anonymous" => "Аноним",
"Please wait %d seconds between posts" => "Подождите %d секунд между сообщениями",
"Wrong password. Cannot post comment" => "Неверный пароль. Невозможно отправить комментарий",
"A contribution is mandatory" => "Вклад является обязательным",
"You have to enter a title and text" => "Необходимо ввести заголовок и текст",
"Invalid Email" => "Не корректный эл.адрес",
"This forum is locked" => "Этот форум заблокирован",
"This thread is locked" => "Эта нить заблокирована",
"Those comments are locked" => "Эти замечания заблокированы",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: количество строк различно: %s != %s",
"Newsletter subscription information at" => "Информация о подписке на новости",
"Tiki Link - Insert internal link" => "Tiki ссылка - Вставка внутренней ссылки",
"Find" => "Найти",
"find" => "найти",
"prev" => "пред.",
"Page" => "Страница",
"next" => "след.",
"Link" => "Линк",
"Page name" => "Название страницы",
"File Galleries" => "Файловые Галереи",
"This is the value of your server's PHP '%s' setting" => "Это значение переменной '%s' в PHP на сервере",
"You are alerted by the server " => "Изменения на сервере: ",
"You can check the modifications at : " => "Вы можете проверить изменения: ",
"You are alerted of a change on " => "Кое что изменилось: ",
"Wiki Home" => "Начальная страница Wiki",
"Home" => "Начало",
"Blog" => "Блог",
"previous page" => "страница назад",
"next page" => "страница вперёд",
"posted on" => "размещено",
"Continue" => "Продолжить",
"By:" => "Кем:",
"Read" => "Читать",
"List articles" => "Список статей",
"Last post" => "Последнее сообщение",
"Invalid imagename (using filters for filenames)" => "Неверное имя изображения (используются фильтры для имен файлов)",
"Errors detected" => "Обнаружены ошибки",
"Upload was not successful" => "Закачка не прошла",
"No image yet, sorry." => "Изображений пока нет, извините.",
"unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "неизвестный каталог назначения. Проверьте настройки <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
"unlink failed" => "Не удалось удалить",
"Contributions" => "Взносы",
"menu" => "меню",
"NONE" => "НЕТ",
"File %s not found" => "Файл %s не найден",
"File %s is not a valid archive" => "Файл %s не является корректным архивом",
"Impossible to open %s : %s" => "Невозможно открыть %s : %s",
"Can't chdir to '%s'" => "Не могу перейти в '%s'",
"%s impossible to remove" => "%s невозможно удалить",
"Language" => "Язык",
"Section" => "Секция",
"Theme" => "Тема",
"Rows" => "Строки",
"Title" => "Заголовок",
"Topic" => "Тема",
"Rating" => "Рейтинг",
"Reads" => "Прочтений",
"Images" => "Изображения",
"Default number per page" => "Количество на странице",
"Default Ordering" => "Сортировка по умолчанию",
"Newest first" => "Новые вперед",
"Oldest first" => "Старые вперед",
"Points" => "Очки",
"Authentication method" => "Метод аутентификации",
"Tiki and PAM" => "Tiki и PAM",
"Web Server" => "Web Сервер",
"Available languages" => "Доступные языки",
"Creation date (desc)" => "Дата создания (убывание)",
"Last modification date (desc)" => "Дата изменения (убывание)",
"Blog title (asc)" => "Заголовок блога (возрастание)",
"Number of posts (desc)" => "Число сообщений (убывание)",
"Visits (desc)" => "Посещения (по убыванию)",
"Activity (desc)" => "Активность (убывание)",
"Disabled" => "Отключено",
"Plain text" => "Обыкновенный текст",
"Link to user information" => "Информация о пользователе",
"User avatar" => "Аватара пользователя",
"Spell checking" => "Проверка правописания",
"Contact user" => "Связаться с пользователем",
"Count admin pageviews" => "Считать просмотры страниц админом",
"Default charset for sending mail" => "Кодировка по умолчанию для отправки эл.писем",
"Show Country Flag" => "Показывать флаг страны",
"Validate URLs" => "Проверять URL",
"Links per page" => "Ссылок на странице",
"Method to open directory links" => "Способ открытия ссылок",
"replace current window" => "в текущем окне",
"new window" => "в новом окне",
"inline frame" => "во вложенном фрейме",
"No error reporting" => "Не выводить отчет об ошибках",
"Report all PHP errors" => "Выводить полный отчет об ошибках PHP",
"Default number of comments per page" => "Комментариев на странице",
"Comments default ordering" => "Сортировка комментариев",
"Q and A" => "Я и А",
"Question ID" => "ID вопроса",
"Polls" => "Опросы",
"Newsletters" => "Рассылки",
"Calendar" => "Календарь",
"Banners" => "Баннеры",
"Category" => "Категория",
"Score" => "Рейтинг",
"Search" => "Поиск",
"Freetags" => "Метки",
"Action Log" => "Протоколирование",
"Multilingual" => "Многоязычность",
"FAQ" => "ЧаВо",
"Surveys" => "Анкетирование",
"Featured links" => "Рекомендуемые ссылки",
"Copyright" => "Авторское право",
"Multimedia" => "Мультимедиа",
"Shoutbox" => "Кричалка",
"Maps" => "Карты",
"Live support system" => "Система быстрой поддержки",
"Tell a Friend" => "Расскажи другу",
"HTML pages" => "Страницы HTML",
"Contact Us" => "Связаться с нами",
"Minichat" => "Мини Чат",
"Comments Locking" => "Блокировка комментариев",
"Shadowbox" => "Отбрасывать тень",
"Webmail" => "Вебпочта",
"Wysiwyg editor" => "Визуальный (wysiwyg) редактор",
"Ajax auto-save" => "Автосохранение Ajax",
"Friendship Network" => "Дружеская сеть",
"Stats" => "Статистика",
"Referer Stats" => "Статистика по Referer",
"Redirect On Error" => "Перенаправление в случае ошибки",
"Communications (send/receive objects)" => "Связь (отправить/принять объекты)",
"Custom Home" => "Своя Домашняя Страница",
"Mini Calendar" => "Мини-календарь",
"User Preferences Screen" => "Страница настройки пользователя",
"User Notepad" => "Блокнот",
"User Bookmarks" => "Личные закладки",
"User Contacts" => "Контакты пользователя",
"User Watches" => "Наблюдения пользователя",
"Group Watches" => "Наблюдения группы",
"User Menu" => "Ваше меню",
"User Tasks" => "Задачи",
"User Messages" => "Сообщения пользователя",
"User Files" => "Ваши файлы",
"User Levels" => "Уровни пользователя",
"Group Alert" => "Групповое оповещение",
"Integrator" => "Интегратор",
"XMLRPC API" => "Доступ к системе через XMLRPC",
"Debugger Console" => "Консоль ошибок",
"TikiTests" => "Tiki Тесты",
"Check for updates automatically" => "Проверять наличие обновлений автоматически",
"TikiWiki will check for updates when you access the main Administration page" => "TikiWiki будет проверять наличие обновлений при входе на страницу Адмнистрирования системы",
"Detect browser language" => "Определять язык браузера",
"Smileys" => "Смайлики",
"Dynamic Content System" => "Система управления динамическим содержимым",
"Display menus as folders" => "Отображать меню как папки",
"Activate" => "Активировать",
"Anonymous voting" => "Разрешить голосовать анонимно",
"Allow re-voting" => "Разрешить голосовать повторно",
"Comments" => "Комментарии",
"Submissions" => "Поступления",
"Rankings" => "Рейтинги",
"Content templates" => "Шаблоны содержимого",
"Print" => "Печать",
"List pages" => "Список страниц",
"Last changes" => "Последние изменения",
"Orphan pages" => "Страницы-сироты",
"Search stats" => "Поиск по статистике",
"Visits" => "Посещений",
"Batch uploading" => "Пакетная загрузка",
"Accept wiki syntax" => "Принять синтаксис wiki",
"tikihash (old)" => "tikihash (устаревшее)",
"Display 'MyTiki' in the application menu" => "Отображать меню 'Мой Tiki'",
"Podcast directory" => "Подкаст каталог",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "Если вы используете пакетную заугрузку, вам необходимо настроить доступный для чтения каталог (лучше если он будет вне сайта). И обеспечить возможность загрузки  файлов в этот каталог через scp, ftp, или любой другой протокол.",
"Prevent download if score becomes negative" => "Запрет на скачивание при отрицательной оценке",
"Allow download limit per file" => "Разрешить ограничения на загрузку файлов",
"Allow same file to be uploaded more than once" => "Разрешить загружать один и тот же файл несколько раз",
"Never" => "Никогда",
"Yes, even in the same gallery" => "Да, даже в той же галерее",
"Only in different galleries" => "Только в разных галереях",
"Mb" => "Мб",
"Uploaded filenames must match regex" => "Имена файлов должны совпадать с regex",
"Default style" => "Стиль по умолчанию",
"Plain" => "Плоский",
"Threaded" => "Нитевидный",
"Headers Only" => "Только заголовки",
"Default sort mode" => "Режим сортировки по умолчанию",
"Title (desc)" => "Название (по убыванию)",
"Title (asc)" => "Название (по возрастанию)",
"Topics" => "Темы",
"Posts" => "Сообщений",
"Posts per day" => "Сообщений в день",
"Default ordering" => "Сортировка",
"Creation Date (asc)" => "По дате создания (asc)",
"Creation Date (desc)" => "Дата создания (по убыванию)",
"Topics (desc)" => "Число тем (по убыванию)",
"Threads (desc)" => "Число веток (по убыванию)",
"Last post (desc)" => "Последнее сообщение (по убыванию)",
"Name (desc)" => "Имя (по убыванию)",
"Name (asc)" => "Имя (по возрастанию)",
"Browser title" => "Заголовок браузера",
"Home page" => "Домашняя страница",
"Use group homepages" => "Домашняя страница для группы",
"Go to group homepage only if login from default homepage" => "Переход на страницу для группы только с главной домашней страницы",
"Default language" => "Язык по умолчанию",
"Temporary directory" => "Временная папка",
"Open external links in new window" => "Открывать внешние ссылки в новом окне",
"License page" => "Страница с лицензией",
"Submit notice" => "Отправить уведомление",
"Display modules to all groups always" => "Всегда показывать модули всем группам",
"Content" => "Содержимое",
"Use database for translation" => "Использовать базу данных для перевода",
"Log SQL" => "Протокол SQL",
"CRLF (standard)" => "CRLF (стандарт)",
"LF (some Unix MTA)" => "LF (Unix системы)",
"Show categories" => "Показывать категории",
"Show objects" => "Показывать объекты",
"Port" => "Порт",
"Record untranslated strings" => "Запись не переведена",
"Normal" => "Обычный",
"Refresh rate" => "Частота обновления",
"Sender email" => "Эл.адрес отправителя",
"Database" => "База данных",
"After" => "После",
"Before" => "До",
"Publish" => "Публиковать",
"Check frequency" => "Проверять",
"Each day" => "Ежедневно",
"Each week" => "Еженедельно",
"Each month" => "Ежемесячно",
"Users can configure modules" => "Пользователи могут настраивать модули",
"Unlimited" => "Неограничено",
"Complete" => "Выполнено",
"Business style" => "Бизнес стиль",
"Collaborative style" => "Совместный стиль",
"Page last modified on" => "Последние изменения страницы ",
"Top" => "Начало",
"Both" => "Оба",
"When using the ...page... page break wiki syntax" => "Использование ...page... для разделения страниц разрывает wiki синтаксис",
"no cache" => "нет кеша",
"minute" => "минута",
"minutes" => "минут",
"hour" => "час",
"hours" => "часов",
"Disable" => "Отключить",
"Default" => "По умолчанию",
"Created by profile installer" => "Создано автоматически при установке профиля",
"Page updated by profile installer" => "Страница обновлена автоматически при установке профиля",
"Wiki top pages" => "Лучшие страницы Wiki",
"Most relevant pages" => "Наиболее значимые страницы",
"Relevance" => "Отношение к теме",
"Wiki last pages" => "Последние страницы Wiki",
"Modified" => "Модифицировано",
"Forums last posts" => "Последние сообщения на форумах",
"Topic date" => "Дата темы",
"Forums most read topics" => "Наиболее читаемые темы форумов",
"Forums best topics" => "Лучшие темы форума",
"Forums most visited forums" => "Наиболее посещаемые темы форумов",
"Forums with most posts" => "Форумы с наибольшим количеством сообщений",
"Wiki top galleries" => "Лучшие галереи Wiki",
"Wiki top file galleries" => "Лучшие галереи файлов Wiki",
"Wiki top images" => "Лучшие картинки Wiki",
"Wiki top files" => "Лучшие файлы Wiki",
"Downloads" => "Закачки",
"Wiki last images" => "Последние картинки Wiki",
"Upload date" => "Дата закачки",
"Wiki last files" => "Последние файлы Wiki",
"Wiki top articles" => "Лучшие статьи Wiki",
"Most visited blogs" => "Самые посещаемые блоги",
"Most active blogs" => "Самые активные блоги",
"Activity" => "Активность",
"Blogs last posts" => "Последние обновления в блогах",
"Post date" => "Дата обновления",
"Wiki top authors" => "Лучшие авторы Wiki",
"Pages" => "Страницы",
"Top article authors" => "Лучшие авторы статей",
"The passwords do not match" => "Пароли не совпадают",
"User already exists" => "Пользователь уже существует",
"Wrong registration code" => "Неверный код регистрации",
"Invalid username" => "Неверное имя пользователя",
"Username is too long" => "Логин слишком длинный",
"Username cannot contain whitespace" => "Логин не должен содержать пробел",
"Wrong passcode. You need to know the passcode to register at this site" => "Неверный секретный код. Для регистрации Вам нужно знать этот код.",
"Invalid email address. You must enter a valid email address" => "Неверный адрес email. Пожалуйста введите настоящий работающий адрес email.",
"The registration mail can't be sent. Contact the administrator" => "Письмо с регистрацией не может быть отправлено. Обратитесь к администратору",
"change" => "изменить",
"Today" => "Сегодня",
"and" => "и",
"from" => "от",
"Login" => "Вход",
"See other users' profiles" => "См. другой пользовательский профиль",
"Make friends" => "Подружится",
"Receive message" => "Прием сообщений",
"Send message" => "Отправить сообщение",
"Read an article" => "Читать статью",
"Publish an article" => "Опубликовать статью",
"Have your article read" => "Читали ли вашу статью",
"Create new file gallery" => "Создать новую файловую галерею",
"Upload new file to gallery" => "Отправить новый файл в галерею",
"Download other user's file" => "Скачать файл другого пользователя",
"Have your file downloaded" => "Скачать свой файл",
"Create a new image gallery" => "Создать новую картинную галерею",
"Upload new image to gallery" => "Закачать новое фото в галерею",
"See other users' galleries" => "Просмотреть галерею другого пользователя",
"See other users' images" => "Просмотреть фото другого пользователя",
"Have your gallery seen by other users" => "Предложить другому пользователю просмотреть вашу галерею",
"Have your image seen" => "Предложить просмотр вашего фото",
"Create new blog" => "Создать блог",
"Post in a blog" => "Послать в блог",
"Read other users' blogs" => "Прочитать блог другого пользователя",
"Have your blog read" => "Предложить свой блог для чтения",
"Create a new wiki page" => "Создать новую wiki страницу",
"Edit an existing page" => "Отредактировать существующею страницу",
"Attach file" => "Добавить файл",
"Wiki Comment" => "Wiki комментарий",
"Calendar item" => "Запись календаря",
"Gallery" => "Галерея",
"Image" => "Изображение",
"Forum" => "Форум",
"Article" => "Статья",
"Blog post" => "Заметка блога",
"Tracker item" => "Запись трекера",
"Tracker" => "Трекер",
"Unknown" => "Неизвестный",
"Trackeritem" => "Запись трекера",
"Directory category" => "Категория каталога",
"Simple" => "Простой",
"Advanced" => "Продвинутый",
"<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin не активен: feature_jquery отключен -->",
"Prev" => "Предыдущий",
"Next" => "Следующий",
"First {\$params['itemname']}" => "Первый {\$params['itemname']}",
"Last {\$params['itemname']}" => "Последний {\$params['itemname']}",
"Next {\$params['itemname']}" => "Следующий {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Предыдущий {\$params['itemname']}",
"comment" => "комментарий",
"information" => "информация",
"Click Here" => "Нажмите здесь",
"AutoSave" => "Автосохранение",
"Edit Template" => "Редактировать шаблон",
"Admin Feature" => "Функции администратора",
"Hide" => "Скрыть",
"help" => "помощь",
"All" => "Все",
"The text is" => "Текст превышает предельный размер на",
"character(s) too long - please edit it." => "букв(у/ы) - пожалуйста, отредактируйте.",
"Date Selector" => "Выбор даты",
"phplayers are not available on this site" => "phplayers не доступны на этом сайте",
"Select All" => "Выбрать все",
"Invert Sort" => "Обратная сортировка",
"days" => "дней",
"day" => "день",
"mins" => "мин.",
"min" => "мин",
"secs" => "сек",
"sec" => "сек",
"done" => "готово",
"Text cut here" => "Вырежьте текст здесь",
"Task" => "Задача",
"for" => "для",
"Priority" => "Приоритет",
"Friend" => "Друг",
"km" => "км",
"Last seen on" => "Последнее посещение",
"(idle for %s seconds)" => "(простой %s секунд)",
"User information - Click for more info" => "Информация о пользователе - Подробности",
"More info about \$other_user" => "Дополнительная информация о пользователе \$other_user",
"(idle for \$idletime seconds)" => "(простой \$idletime секунд)",
"Yes" => "Да",
"No" => "Нет",
"Use this tree to copy the structure" => "Используйте это дерево, чтобы скопировать структуру",
"created from structure" => "создано по структуре",
"Table of contents" => "Содержание",
"You have to make %d choice(s) for the question" => "Вы должны дать %d ответ(ов) на вопрос",
"You have to make at least %d choice(s) for the question" => "Вы должны дать не менее %d ответа(ов) на вопрос",
"You have to make less than %d choice(s) for the question" => "Вы должны дать меньше %d ответа(ов) на вопрос",
"You have to choose at least %d choice(s) for the question" => "Вы должны выбрать не менее %d ответа(ов) на вопрос",
"Foo" => "Некто",
"text" => "текст",
"unknown error" => "неизвестная ошибка",
"You are not logged in" => "Вы не вошли под своим логином",
"Page cannot be found" => "Страница не найдена",
"Page '%0' cannot be found" => "Страница '%0' не найдена",
"Permission denied. You cannot view this section" => "У Вас недостаточно прав для просмотра этой секции",
"For the security of your password direct access to the feed is only available via https" => "Для безопасности вашего пароля прямой доступ на канал доступен только через HTTPS",
"Help link" => "Помощь",
"Help" => "Помощь",
"faqs" => "чаво",
"quizzes" => "тесты",
"blogs" => "блогах",
"forums" => "форумы",
"Edit Plugin" => "Редактировать плагин",
"Click to edit dynamic variable" => "Щёлкните, чтобы отредактировать динамическую переменную",
"Update variables" => "Обновить переменные",
"Edit Section" => "Редактировать раздел",
"index" => "индекс",
"Show" => "Показать",
"sad" => "печальный",
"cool" => "классно",
"mad" => "чокнутый",
"%d points" => "%d очков",
"Removed" => "Удаленно",
"__WARNING__: No such module \$plugin!" => "__ВНИМАНИЕ__: Модуль \$plugin! не существует!",
"at" => "в",
"new" => "новый",
"Create page:" => "Создать страницу:",
"Unknown language" => "Неизвестный язык",
"Click here to confirm your action" => "Нажмите сюда, чтобы подтвердить ваши действия",
"Heading" => "Шапка",
"Background Color" => "Цвет фона",
"Reduce area height" => "Уменьшить высоту области",
"Enlarge area height" => "Увеличить высоту области",
"Item" => "Пункт",
"Subject" => "Тема",
"Tracker was modified at " => "Трекер был обновлен ",
"text field" => "текстовое поле",
"size" => "размер",
"max" => "макс",
"textarea" => "многострочный текст",
"checkbox" => "галочка",
"drop down" => "выпадающий список",
"group selector" => "выбор группы",
"date and time" => "дата и время",
"action" => "действие",
"category" => "категория",
"email" => "эл.адрес",
"attachment" => "вложение",
"open" => "открыт",
"pending" => "на рассмотрении",
"closed" => "закрыт",
"Message" => "Сообщение",
"child categories" => "дочерняя категория",
"objects in category" => "объекты в категории",
"You must validate your account first. An email has been sent to you" => "Вы должны подтвердить свою учетную запись. Вам было отправлено письмо",
"Password should be at least" => "Пароль должен быть не короче",
"characters long" => "символов",
"Password must contain both letters and numbers" => "Пароль должен содержать буквы и цифры",
"Personal Phone" => "Личный номер",
"Personal Mobile" => "Личный моб.номер",
"Personal Fax" => "Личный факс",
"Work Phone" => "Рабочий номер",
"Work Mobile" => "Рабочий моб.номер",
"Work Fax" => "Рабочий факс",
"Company" => "Компания",
"Organization" => "Организация",
"Department" => "Департамент",
"Division" => "Подразделение",
"Job Title" => "Должность",
"Street Address" => "Улица",
"City" => "Город",
"State" => "Штат",
"Zip Code" => "Код адреса",
"Country" => "Страна",
"No subject" => "Нет темы",
"User-Agent Info" => "User-Agent информация",
"Info" => "Информация",
"Image Annotation" => "Аннотация к изображению",
"Location" => "Расположение",
"Width" => "Ширина",
"Height" => "Высота",
"Alignment" => "Выравнивание",
"Save changes to annotations" => "Сохранить изменения в аннотации",
"Start date" => "Дата начала",
"End date" => "Конечная дата",
"Attachment" => "Вложение",
"File" => "Файл",
"Show description" => "Показать описание",
"No such attachment on this page" => "Не найден вложенный файл",
"Avatar" => "Аватара",
"Displays the user Avatar" => "Показать пользователя Avatar",
"username" => "логин",
"Back" => "Назад",
"Backlinks" => "Ссылки на данную страницу",
"Zone" => "Область",
"Items" => "Пункты",
"Insert theme-styled box on wiki page" => "Вставить тематически-стилевой блок в страницу wiki",
"And" => "И",
"Objects" => "Объекты",
"Center" => "По центру",
"Centers the plugin content in the wiki page" => "Центрировать содержимое плагина на странице wiki",
"Chart" => "Чарт",
"Styles" => "Стили",
"Labels" => "Метки",
"title" => "заголовок",
"Chart as PDF" => "Диаграмма в PDF",
"Chart as PostScript" => "Диаграмма в PostScript",
"Displays a snippet of code" => "Показывает фрагмент кода",
"Caption" => "Заголовок",
"Word Wrap" => "Перенос слов",
"Colors" => "Цвета",
"Dynamic Content" => "Динамическое содержимое",
"Insert copyright notices" => "Вставить сообщение об авторских правах",
"on|off" => "вкл|выкл",
"Example" => "Пример",
"seconds" => "с.",
"Pre" => "pre",
"Clear" => "Очистить",
"term" => "термин",
"definition" => "определение",
"Desc" => "Описание",
"Upcoming events" => "Грядущие события",
"sort" => "сорт",
"Shows ID" => "Показывает ID",
"Shows Icon" => "Показывает иконку",
"Shows Name" => "Показывает имя",
"Shows Filename" => "Показывает имя файла",
"Shows Size" => "Показывает размер",
"Shows Description" => "Показывает описание",
"Shows Creation Date" => "Показывает дату создания",
"Shows Modification Date" => "Показывает дату изменения",
"Shows Author" => "Показывает автора",
"Shows Creator" => "Показывает создателя",
"Default width: 425" => "Стандартная ширина: 425",
"Default height: 350" => "Стандартная высота: 350",
"Quality" => "Качество",
"file name" => "имя файла",
"Ftp Server Name" => "Имя Ftp сервера",
"Ftp User name" => "Имя пользователя Ftp",
"Ftp password" => "Пароль Ftp",
"missing parameters" => "пропущены параметры",
"Connection failed" => "Соединение не удалось",
"Incorrect param" => "Не корректный параметр",
"failed" => "не удался",
"description" => "описание",
"Value" => "Значение",
"current value (REQUIRED)" => "Текущее значение (ОБЯЗАТЕЛЬНО)",
"Maximum Value" => "Максимальное значение",
"Maximum possible value. Default: 100" => "Максимально возможное значение. По умолчанию: 100",
"Color" => "Цвет",
"Displays a graphical GAUGE" => "Показть графический GAUGE",
"type" => "вид",
"Group" => "Группа",
"groups" => "группы",
"HTML code" => "HTML код",
"URL" => "Ссылка",
"name" => "имя",
"Image height" => "Высота изображения",
"Image width" => "Ширина изображения",
"Default configuration" => "Конфигурация по умолчанию",
"Thumbnail" => "Иконка",
"Browse" => "Просмотр",
"Download" => "Скачать",
"Include" => "Добавить",
"Start" => "Начало",
"Stop" => "Остановить",
"Default group" => "Группа по умолчанию",
"Email address" => "Адрес эл.почты",
"Default Color" => "Цвет по умолчанию",
"JQuery Code" => "Код JQuery",
"Last Modification" => "последнее изменение",
"List Pages" => "Список страниц",
"Show Name Only" => "Показывать только имя",
"Exact Match" => "Точное соответствие",
"Sort" => "Сортировка",
"or" => "или",
"Filter" => "Фильтр",
"complete" => "завершен(о)",
"articles" => "статьях",
"Map" => "Карта",
"Feature disabled" => "Возможность заблокирована",
"Template" => "Шаблон",
"Style" => "Стиль",
"Groups" => "Группы",
"Tracker ID" => "Id трекера",
"Module Name" => "Название Модуля",
"Max" => "Макс",
"Please choose a module" => "Пожалуйста, выберите модуль",
"to be used as argument" => "будет использован как аргумент",
"Displays a module inline in a wiki page" => "Показывать module встроенный в страницу",
"Sorry, no such module" => "Извините, такого модуля нет",
"Text" => "Текст",
"Sticky" => "Закреплено",
"data" => "данные",
"Object" => "Объект",
"Days" => "Дни",
"Status" => "Статус",
"picture not found" => "рисунок не найден",
"Information" => "Информация",
"No version indicated" => "Версия не указана",
"Poll" => "Опрос",
"Random Dynamic Content" => "Случайное динамическое содержимое",
"Maximum" => "Максимум",
"Preferences" => "Настройки",
"User Information" => "Личная Информация",
"Redirect" => "Перенаправление",
"Close" => "Закрыть",
"Date" => "Дата",
"Sheet" => "Эл.лист",
"Create new sheet" => "Создать новую эл.таблицу",
"TikiSheet" => "Эл.таблица Tiki",
"Edit Sheet" => "Редактировать эл.таблицу",
"Show Pages" => "Показать страницы",
"List wiki pages" => "Список wiki страниц",
"Search criteria" => "Условие поиска",
"Last modified by" => "Последнее изменение",
"Action" => "Действие",
"Order" => "Порядок",
"First" => "Первый лист",
"Edit" => "Правка",
"row1col1" => "строка1столбец1",
"row1col2" => "строка1столбец2",
"row2col1" => "строка2столбец1",
"row2col2" => "строка2столбец2",
"Run a sql query" => "Выполнить sql запрос",
"sql query" => "sql запрос",
"Missing db param" => "Отсутствует параметр db",
"Subscribe Group" => "Подписать группу",
"Group Name" => "Название группы",
"Subscribe" => "Подписаться",
"Url" => "Ссылка",
"Tag Name" => "Метка",
"Maximum Size" => "Максимальный размер",
"Original" => "Оригинал",
"Structure ID" => "Id структуры",
"Public" => "Общие",
"Translate" => "Перевести",
"Fields" => "Поля",
"Email" => "Эл.адрес",
"to" => "до",
"template" => "шаблон",
"Preview" => "Предпросмотр",
"preview" => "предпросмотр",
"Reset" => "Сбросить",
"View" => "Смотреть",
"user|page" => "пользователь|страница",
"New Status" => "Новый статус",
"Error" => "Ошибка",
"Filters" => "Фильтры",
"Line" => "Линия",
"notice" => "заметка",
"Wiki text" => "Wiki текст",
"Test" => "Тест",
"Notice" => "Заметка",
"Show Creation Date" => "Показать дату создания",
"More" => "Еще",
"Mode" => "Режим",
"Delete" => "Удалить",
"Field 1" => "Поле 1",
"Value 1" => "Значение 1",
"Field 2" => "Поле 2",
"Value 2" => "Значение 2",
"Field 3" => "Поле 3",
"Value 3" => "Значение 3",
"Field 4" => "Поле 4",
"Value 4" => "Значение 4",
"Field 5" => "Поле 5",
"Value 5" => "Значение 5",
"Flag" => "Флаг",
"User Count" => "Количество пользователей",
"Displays the number of registered users" => "Показать количество зарегистрированных пользователей",
"Group name" => "Имя группы",
"User List" => "Список пользователей",
"Displays a list of registered users" => "Показать список зарегистрированных пользователей",
"Real Name" => "Настоящее Имя",
"users" => "пользователи",
"Versions" => "Версии",
"This is the default text" => "Это текст по умолчанию",
"(version 3)" => "(версия 3)",
"This is version 3 info" => "Это информация 3 версии",
"(version 2)" => "(версия 2)",
"This is version 2 info" => "Это информация 2 версии",
"(version 1)" => "(версия 1)",
"This is version 1 info" => "Это информация 1 версии",
"Vote" => "Голосование",
"Show Stats" => "Показать статистику",
"Show Stats After" => "Показать статистику после",
"Show Creator" => "Показать создателя",
"Wanted Pages" => "Требуется описание страниц",
"Table" => "Таблица",
"Level" => "Уровень",
"Lists ''wanted'' Wiki pages: " => "Список ''требуемых'' Wiki страниц: ",
"External Wiki" => "Внешний Wiki",
"valid" => "действителен",
"Wanted Page" => "Требуется описание страницы",
"Referenced By Page" => "Ссылка на странице",
"ERROR: Either the subject or body must be non-empty" => "ОШИБКА: Тема либо тело сообщения должны быть заполнены",
"ERROR: No valid users to send the message" => "Ошибка: Нет пользователей для отправки сообщения",
"Invalid user" => "Пользователя не существует",
"Message will be sent to: " => "Сообщение будет отправлено: ",
"No more messages" => "Сообщений больше нет",
"Categories" => "Категории",
"Categorize" => "Задать категорию",
"Unassign" => "снять назначение",
"Assign" => "Назначение",
"Received objects" => "Полученные объекты",
"File galleries" => "Файловые галереи",
"Last forum posts" => "Последние ответы на форуме",
"Topics only" => "Только темы",
"Most commented forums" => "Самые комментируемые форумы",
"Most read topics" => "Самые читаемые темы",
"Most visited forums" => "Самые посещаемые форумы",
"Most popular tags" => "Облако тэгов",
"Google Search" => "Поиск по Google",
"Last actions" => "Последние действия",
"Last blog posts" => "Последние сообщения блога",
"no object here yet" => "здесь пока ничего нет",
"Last Created blogs" => "Последние созданные блоги",
"Last Created FAQs" => "Последние созданные ЧаВо",
"Last Created Quizzes" => "Последние созданные тесты",
"Last modified file galleries" => "Последние изменённые файловые галереи",
"Last Files" => "Последние файлы",
"Last Images" => "Последние изображения",
"Last Modified blogs" => "Последние изменённые блоги",
"Last submissions" => "Последние поступления",
"Last Items" => "Последние элементы",
"Last Modified Items" => "Последние изменённые элементы",
"Last Visitors" => "Последние посетители",
"Live support" => "Онлайн поддержка",
"Messages" => "Сообщения",
"List by month" => "Список по месяцам",
"Waiting Submissions" => "Ожидающие поступления",
"Old articles" => "Старые статьи",
"Create/Edit" => "Создание/Правка",
"Quick Edit a Wiki Page" => "Редактировать страницу",
"Random Pages" => "Случайные страницы",
"New user registration" => "Регистрация нового пользователя",
"Post" => "Сказать",
"Since your last visit" => "С Вашего последнего визита",
"Changes since" => "Изменения с момента",
"new comments" => "новые комментарии",
"new posts" => "новые записи",
"wiki pages changed" => "wiki страницы изменились",
"new articles" => "новые статьи",
"new FAQs" => "новые ЧаВо",
"new blogs" => "новые блоги",
"new blog posts" => "новые записи в блогах",
"new image galleries" => "новые галереи изображений",
"new images" => "новые изображения",
"new file galleries" => "новые файловые галереи",
"new files" => "новые файлы",
"new polls" => "новые опросы",
"new users" => "новые пользователи",
"new tracker items" => "новые записи в трекере",
"updated tracker items" => "обновленные записи в трекере",
"Most Active blogs" => "Самые активные блоги",
"Top articles" => "Лучшие статьи",
"Top File Galleries" => "Лучшие галереи",
"Top files" => "Популярные файлы",
"Top Forum Posters" => "Популярные писатели форума",
"Top Images" => "Лучшие изображения",
"Top Objects" => "Популярные объекты",
"Top Pages" => "Лучшие страницы",
"Top Quizzes" => "Лучшие тесты",
"Top Visited FAQs" => "Наиболее популярные ЧаВо",
"Page translation" => "Перевод страницы",
"User Blogs" => "Ваши блоги",
"My blogs" => "Мои блоги",
"User bookmarks" => "Личные закладки",
"My galleries" => "Мои галереи",
"User Pages" => "Ваши страницы",
"My Pages" => "Мои страницы",
"User tasks" => "Мои задания",
"The task title must have at least 3 characters" => "Заголовок задачи должен быть длиннее 3 символов",
"Public tasks" => "Общедоступные задачи",
"Top users" => "Лучшие пользователи",
"Online users" => "Пользователи онлайн",
"Last wiki comments" => "Последние комментарии wiki",
"Videos on YouTube" => "Видео на YouTube",
"Invalid server key" => "Неверный ключ сервера",
"Invalid username or password" => "Неверное имя пользователя или пароль",
"Cookie not found" => "Cookie не найдены",
"Can create/admin calendars" => "Создание/управление календарями",
"Can add events in the calendar" => "Добавление событий в календарь",
"Can change events in the calendar" => "Изменение событий в календаре",
"Can browse the calendar" => "Просмотр календаря",
"Can view events details" => "Просмотр деталей события",
"Administrator, can create channels remove channels etc" => "Администратор может создать канал, удалить каналы и т.д.",
"Can use the chat system" => "Использовать систему чата",
"Can admin the cms" => "Управление cms",
"Can approve submissions" => "Подтверждение поступлений",
"Can admin article topics" => "Управление темами статей",
"Can admin article types" => "Управление типами статей",
"Can read article headings" => "Чтение заголовков статей",
"Submited articles automatically approved" => "Размещенные статьи подтверждаются автоматически",
"Can edit articles" => "Редактирование статей",
"Can edit submissions" => "Редактирование поступлений",
"Can read articles" => "Чтение статей",
"Can remove articles" => "Удаление статей",
"Can remove submissions" => "Удаление поступлений",
"Can submit articles" => "Отправлять статьи",
"Can read a topic (Applies only to individual topic perms)" => "Чтение темы (применяется только к индивидуальным правам на тему)",
"Can admin contributions" => "Управление взносами",
"Can admin the directory" => "Управление каталогом ссылок",
"Can admin directory categories" => "Управление категориями в каталоге ссылок",
"Can admin directory sites" => "Управление ссылками в каталоге ссылок",
"Submited links are valid" => "Размещенные ссылки считать корректными",
"Can submit sites to the directory" => "Размещение ссылки в каталоге ссылок",
"Can validate submited links" => "Подтверждать предложенные ссылки",
"Can use the directory" => "Использовать каталог ссылок",
"Can admin faqs" => "Управление ЧаВо",
"Can suggest faq questions" => "Предлагать вопрос в ЧаВо",
"Can view faqs" => "Просмотр ЧаВо",
"Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Администратор может управлять группами пользователей и правами доступа, горячими словами и всеми возможностями протоколов",
"Can admin users" => "Управление пользователями",
"Can access site when closed" => "Доступ к сайту даже если он закрыт",
"Administrator, can admin banners" => "Администратор может управлять баннерами",
"Can ban users or ips" => "Запрет на пользователя или на IP адрес",
"Can admin the dynamic content system" => "Управление системой динамического содержимого",
"Can admin integrator repositories and rules" => "Управление интегратором хранилищ и правил",
"Can admin mail-in accounts" => "Управление учетными записями mail-in",
"Can edit object permissions" => "Редактирование прав доступа к объекту",
"Can clean cache" => "Очищение кэша",
"Can create new css suffixed with -user" => "Создание нового стиля с суфиксом -user",
"Can remove association between two pages in a translation set" => "Удаление ассоциации между страницами в разных переводах",
"Can admin cookies" => "Управление cookies",
"Can edit translations and create new languages" => "Редактирование переводов и создание новых",
"Can edit menu" => "Редактирование меню",
"Can edit menu option" => "Редактирование опции меню",
"Can edit site templates" => "Редактирование шаблонов сайта",
"Can search" => "Поиск",
"Can report a link to the webmaster" => "Отправка ссылки вебмастеру",
"Can subscribe to groups" => "Входить в группу",
"Can send a link to a friend" => "Отправка ссылки другу",
"Can use HTML in pages" => "Использовать HTML на страницах",
"Can view action log" => "Просмотр протокола событий",
"Can view action log for users of his own groups" => "Просмотр протокола событий группы для пользователя этой группы",
"Can view referer stats" => "Просмотр статистики реферала",
"Can view site stats" => "Просмотр статистики сайта",
"Can view site templates" => "Просмотр шаблона сайта",
"Can admin blogs" => "Управление блогами",
"Can assign perms to blog" => "Назначение прав на блог",
"Can post to a blog" => "Оставлять сообщения в блоге",
"Can create a blog" => "Создание блога",
"Can read blogs" => "Чтение блогов",
"Can admin file galleries" => "Управление файловыми галереями",
"Can assign perms to file gallery" => "Назначение прав на файловую галерею",
"Can use Directory Batch Load" => "Использовать пакетную загрузку в каталог ссылок",
"Can upload zip files with files" => "Загружать архивные файлы с файлами",
"Can create file galleries" => "Создание файловых галерей",
"Can download files" => "Скачивание файлов",
"Can edit a gallery file" => "Редактирование файла в галереи",
"Can list file galleries" => "Просмотр списка файловых галерей",
"Can upload files" => "Загружать файлы",
"Can view file galleries explorer" => "Просмотр проводника файловых галерей",
"Can view file galleries path" => "Просмотр пути файловых галерей",
"Can view file galleries" => "Просмотр файловых галерей",
"Can admin forums" => "Управление форумами",
"Can attach to forum posts" => "Присоединение к темам на форуме",
"Auto approve forum posts" => "Автоматическое подтверждение сообщений на форуме",
"Can edit own forum posts" => "Редактирование своих записей на форуме",
"Can post in forums" => "Оставлять сообщения на форумах",
"Can start threads in forums" => "Создавать обсуждения на форумах",
"Can read forums" => "Чтение форумов",
"Can report msgs to moderator" => "Отправка сообщений модератору",
"Can vote comments in forums" => "Разрешить голосовать за комментарии на форумах",
"Can admin freetags" => "Управление метками",
"Can admin Image Galleries" => "Управление галереями изображений",
"Can assign perms to image gallery" => "Назначение прав на галерею изображений",
"Can upload zip files with images" => "Загружать архивные файлы с изображениями",
"Can create image galleries" => "Создание галерей изображений",
"Can tag objects" => "Устанавливать метки на объекты",
"Can list image galleries" => "Просмотр списка галерей изображений",
"Can unassign tags from an object" => "Убирать метки с объектов",
"Can upload images" => "Загружать изображения",
"Can browse freetags" => "Просмотр меток",
"Can view image galleries" => "Просмотр галерей изображений",
"Can admin newsletters" => "Управление рассылками новостей",
"Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Подписывать несколько эл.адресов сразу (необходимы права tiki_p_subscribe_email)",
"Can send newsletters" => "Отправка новостных рассылок",
"Can subscribe any email to newsletters" => "Подписывать любой эл.адрес на новостную рассылку",
"Can subscribe to newsletters" => "Подписаться на новостную рассылку",
"Can admin polls" => "Управление опросами",
"Can view poll results" => "Просмотр результатов опроса",
"Can vote polls" => "Разрешить голосовать за опросы",
"Can view poll voters" => "Просмотр участников опроса",
"Can admin quizzes" => "Управление тестами",
"Can take quizzes" => "Принимать участие в тестах",
"Can view quiz stats" => "Просмотр статистики теста",
"Can view user quiz results" => "Просмотр пользовательских результатов теста",
"Can admin sheet" => "Управление эл.таблицами",
"Can create and edit sheets" => "Создание и редактирование эл.таблиц",
"Can view sheet" => "Просмотр эл.таблицы",
"Can view sheet history" => "Просмотр истории эл.таблицы",
"Can admin shoutbox (Edit/remove msgs)" => "Управление кричалкой (редактировать/удалять сообщения)",
"Can post messages in shoutbox" => "Оставлять сообщения в кричалке",
"Can view shoutbox" => "Просмотр кричалки",
"Can admin surveys" => "Управление анкетами",
"Can take surveys" => "Принимать участие в опросах",
"Can view survey stats" => "Просмотр статистики опроса",
"Can admin trackers" => "Управление трекерами",
"Can attach files to tracker items" => "Присоединение файлов в трекерах",
"Can insert comments for tracker items" => "Добавлять комментарии в записях трекера",
"Can view tracker items comments" => "Просмотр комментариев в записи трекера",
"Can create new items for trackers" => "Создание новых объектов для трекеров",
"Can list trackers" => "Просмотр списка трекеров",
"Can change tracker items" => "Изменение записей в трекере",
"Can view rating result for tracker items" => "Просмотр рейтинга для записи в трекере",
"Can vote a rating for tracker items" => "Разрешить выставлять рейтинг записям в трекере",
"Can view trackers" => "Просмотр трекеров",
"Can view trackers closed items" => "Просмотр закрытых записей в трекере",
"Can view trackers pending items" => "Просмотр записей на рассмотрении в трекере",
"Can watch tracker" => "Просмотр трекера",
"Can export tracker items" => "Экспортировать записи трекера",
"Can admin the wiki" => "Управление системой wiki",
"Can assign perms to wiki pages" => "Назначение прав на страницы wiki",
"Can edit pages" => "Редактирование страниц",
"Can edit copyright notices" => "Редактирование уведомлений об авторских правах",
"Can edit dynamic variables" => "Редактирование динамических переменных",
"Can create and edit structures" => "Создание и редактирование структур",
"Can export wiki pages using the export feature" => "Экспортировать wiki страницы через опцию экспорта",
"Can lock pages" => "Блокировка страниц",
"Can save as minor edit" => "Сохранять как мелочь",
"Can remove" => "Удаление",
"Can rename pages" => "Переименование страниц",
"Can rollback pages" => "Откат изменений на страницах",
"Can upload pictures to wiki pages" => "Загружать изображения на страницы wiki",
"Can use the page as a tracker template" => "Использовать страницу как шаблон для трекера",
"Can view page/pages" => "Просмотр страницы/страниц",
"Can watch structure" => "Просмотр структуры",
"Can admin attachments to wiki pages" => "Управление вложениями на страницах wiki",
"Can add and change ratings on wiki pages" => "Добавление и правка рейтинга на странице wiki",
"Can attach files to wiki pages" => "Присоединение файлов на страницах wiki",
"Can view wiki attachments and download" => "Просмотр вложений и загрузок",
"Can view wiki comments" => "Просмотр wiki комментариев",
"Can view wiki history" => "Просмотр wiki истории",
"Can view rating of wiki pages" => "Просмотр рейтинга страницы wiki",
"Can view source of wiki pages" => "Просмотр источника страницы wiki",
"Can admin received articles" => "Управление полученными статьями",
"Can admin received pages" => "Управление полученными страницами",
"Can send articles to other sites" => "Отправка статей на другие сайты",
"Can send articles to this site" => "Отправка статей на этот сайт",
"Can send pages to this site" => "Отправлять страницы на этот сайт",
"Can send pages to other sites" => "Отправлять страницы на другие сайты",
"Can admin the TikiTests" => "Управление тестами Tiki",
"Can edit TikiTests" => "Редактирование тестов Tiki",
"Can replay the TikiTests" => "Повторное прохождение тестов Tiki",
"Can cache user bookmarks" => "Кэширование закладок пользователей",
"Can configure modules" => "Настройка модулей",
"Can create user bookmarks" => "Создание пользовательских закладок",
"Can use the mini event calendar" => "Использовать мини календарь событий",
"Can use the notepad" => "Использовать блокнот",
"Can admin public tasks" => "Управление общими задачами",
"Can use tasks" => "Использовать задачи",
"Can receive tasks from other users" => "Получение заданий от других пользователей",
"Can send tasks to other users" => "Назначать задания другим пользователям",
"Can upload personal files" => "Загружать персональные файлы",
"Can create items in personal menu" => "Создание пунктов в персональном меню",
"Can broadcast messages to all user" => "Отправлять сообщения на всех пользователей",
"Can broadcast messages to groups" => "Отправлять сообщения на все группы",
"Can use the messaging system" => "Использовать систему сообщений",
"Can admin comments" => "Управление комментариями",
"Can edit all comments" => "Редактирование всех комментариев",
"Can post new comments" => "Оставлять новые комментарии",
"Can read comments" => "Чтение комментариев",
"Can delete comments" => "Удаление комментарий",
"Can vote comments" => "Разрешить голосовать за комментарии",
"Can admin content templates" => "Управление шаблонами содержимого",
"Can edit content templates" => "Редактирование шаблонов содержимого",
"Can use content templates" => "Использовать шаблоны содержимого",
"Can edit HTML pages" => "Редактирование HTML страниц",
"Can view HTML pages" => "Просмотр HTML страниц",
"Can list registered users" => "Просмотр списка зарегистрированных пользователей",
"Admin live support system" => "Администрирование системы живой поддержки",
"Can use live support system" => "Использовать систему живой поддержки",
"Can create new mapfile" => "Создание нового файла-карты",
"Can delete mapfiles" => "Удаление файла-карты",
"Can edit mapfiles" => "Редактирование файла-карты",
"Can view mapfiles" => "Просмотр файлов-карт",
"Can view contents of mapfiles" => "Просмотр содержимого файлов-карт",
"Can use webmail" => "Использовать web-почту",
"Can use group webmail" => "Использовать групповые учетные записи в web-почте",
"Can administrate group webmail accounts" => "Управление групповыми учетными записями в web-почте",
"Can use personal webmail accounts" => "Использовать персональные учетные записи в web-почте",
"Can administrate personal webmail accounts" => "Управление персональныим учетными записями в web-почте",
"Can view unapproved plugin details" => "Просмотр деталей не подтвержденных плагинов",
"Can execute unapproved plugin" => "Запускать не подтвержденные плагины",
"Can approve plugin execution" => "Подтверждение использования плагина",
"Trust all user inputs (no security checks)" => "Доверять вводимой пользователем информации (отменить проверки безопасности)",
"View page backlinks" => "Просмотр обрытных ссылок на страницу",
"Can admin mail notifications" => "Управление почтовыми уведомлениями",
"Can admin categories" => "Управление категориями",
"country" => "страна",
"theme" => "тема",
"List of attached files" => "Список вложенных файлов",
"desc" => "описание",
"uploaded" => "закачано",
"Remove" => "Удалить",
"Upload file" => "Закачать файл",
"Attach" => "Вложение",
"Attach a file to this item" => "Приложить файл",
"Version" => "Версия",
"Attachments" => "Вложения",
"more info" => "еще информация",
"No attachments for this item" => "К этому элементу файлы не приложены",
"Fatal error" => "Неисправимая ошибка",
"Created by" => "Создано",
"on" => "в",
"Activity=" => "Активность=",
"Actions" => "Действия",
"Properties" => "Свойства",
"No records found" => "Нет записей",
"Select Categories" => "Выбор категорий",
"Admin Categories" => "Редактировать категории",
"Select/deselect all categories" => "Отметить/снять все категории",
"No categories defined" => "Категории не определены",
"Browse Category" => "Просмотр категорий",
"stars" => "звезды",
"User Level" => "Уровень пользователя",
"private message" => "личное сообщение",
"Send eMail to User" => "Отослать e-mail пользователю",
"user online" => "пользователь в сети",
"user offline" => "пользователь offline",
"top of page" => "наверх",
"Reply" => "Ответ",
"Approve" => "Подтвердить",
"Reject" => "Отклонить",
"Save to notepad" => "Сохранить в блокноте",
"Monitor this Topic" => "Наблюдать за этой темой",
"Stop Monitoring this Topic" => "Прекратить наблюдение",
"Errors" => "Ошибки",
"Moderator actions" => "Действия модератора",
"Move to topic:" => "Переместить в тему:",
"Move" => "Переместить",
"Delete Selected" => "Удалить выбранные",
"Comments Locked" => "Комментарии заблокированы",
"Unlock" => "Убрать блок",
"Lock" => "Блокировать",
"Threshold" => "Порог видимости комментариев",
"Set" => "Записать",
"Replies" => "Ответы",
"below your current threshold" => "ниже текущего порога",
"Comments are locked" => "Комментарии заблокированы",
"Note" => "Примечание",
"New Reply" => "Новый ответ",
"Editing reply" => "Редактирование ответа",
"Reply to the selected post" => "Ответить на выбранное сообщение",
"Post new message" => "Написать новое сообщение",
"Editing comment" => "Правка комментария",
"Comment on the selected post" => "Комментировать выбранное сообщение",
"Post new comment" => "Прокомментировать",
"required" => "обязательный",
"Enter your name" => "Введите ваше имя",
"If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "Если вы хотите получать уведомления о новых сообщениях в этой теме<br />оставьте нам свой электронный адрес",
"Reply to parent post" => "Ответить на предыдущее сообщение",
"Post new reply" => "Отправить новый ответ",
"Post as Anonymous" => "Отправить ответ анонимно",
"Cancel" => "Отмена",
"Posting replies" => "Отправка ответов",
"Posting comments" => "Размещение комментариев",
"Add Comment" => "Добавить комментарий",
"1 comment" => "1 комментарий",
"Go back" => "Назад",
"Return to home page" => "Вернуться на главную",
"Contributors" => "Авторы",
"Copyrights" => "Авторские права",
"Year" => "Год",
"Authors" => "Авторы",
"Add" => "Добавить",
"Current URL" => "Текущий URL",
"Type <code>help</code> to get list of available commands" => "Наберите <code>help</code> для получения списка возможных команд",
"Syntax" => "Синтаксис",
"Total" => "Всего",
"Duplicate File Gallery" => "Продублировать файловую галерею",
"Duplicate categories" => "Продублировать категории",
"duplicate" => "дубликат",
"There are individual permissions set for this file gallery" => "Для этой файловой галереи заданы индивидуальные права доступа",
"Save" => "Сохранить",
"Required for podcasts" => "Требуется для подкастов",
"System" => "Система",
"Use" => "Применить",
"none" => "нет",
"Parent gallery" => "Родительская галерея",
"Default sort order" => "Сортировка по умолчанию",
"Descending" => "По убіванию",
"Ascending" => "По возрастанию",
"Max description display size" => "Максимальный размер описаний на экране",
"Please login" => "Пройдите регистрацию",
"There are no wiki pages similar to '{\$page}'" => "Страниц похожих на '{\$page}' нет",
"Go to Login Page" => "Перейти к странице регистрации",
"Create this page" => "Создать эту страницу",
"(page will be orphaned)" => "(страница станет сиротой)",
"Close Window" => "Закрыть окно",
"Go to" => "Перейти",
"Private Gallery" => "Закрытая галерея",
"Active Perms" => "Активные права",
"Perms" => "Права",
"Archives" => "Архивы",
"Upload New Version" => "Загрузить новую версию",
"Replace" => "Замена",
"Download and lock" => "Скачать и заблокировать",
"List" => "Список",
"Name-filename" => "Имя-Имя файла",
"Filename only" => "Только имя файла",
"Show as a column" => "Показать как столбец",
"Show in popup box" => "Показать во всплывающем окне",
"Show an icon in a column" => "Показывать значок в столбце",
"Exact&nbsp;match" => "Точное&nbsp;совпадение",
"any type" => "любой тип",
"all topic" => "все темы",
"any language" => "любой язык",
"not in" => "не включая",
"any category" => "любая категория",
"Number of displayed rows" => "Строк на странице",
"in:" => "в:",
"Go" => "Вперед",
"Clear Filter" => "Очистить фильтр",
"Show php error messages" => "Показать ошибки php",
"Folksonomy Tags" => "Свободные метки",
"Tags" => "Метки",
"Translate tags" => "Перевести метки",
"Images Galleries" => "Галереи изображений",
"RSS Blogs" => "RSS блогов",
"RSS Articles" => "RSS статей",
"RSS Image Galleries" => "RSS галерей изображений",
"RSS File Galleries" => "RSS файловых галерей",
"RSS Forums" => "RSS форумов",
"RSS Maps" => "RSS карт",
"RSS Directories" => "RSS директорий",
"RSS Calendars" => "RSS календарей",
"Show Tree" => "Показать дерево",
"Hide Tree" => "Спрятать дерево",
"Move Selected Files" => "переместить выбранные файлы",
"Download the zip" => "Загрузить zip архив",
"Assign Permissions" => "Назначить права",
"Move to" => "Переместить в",
"Filename" => "Имя файла",
"Other Sorts" => "Другие виды сортировки",
"No Additionnal Sort" => "Нет дополнительных сортировок",
"No information" => "Нет информации",
"Somebody or you tried to subscribe this email address at our site:" => "Кто-то либо Вы сами подали заявку на подписку с нашего сайта:",
"To the newsletter:" => "На список рассылки:",
"Description:" => "Описание:",
"In order to confirm your subscription you must access the following URL:" => "Для подверждения заявки Вам нужно посетить следующий URL:",
"User:" => "Пользователь:",
"A new message was posted to forum" => "Новое сообщение отослано на форум",
"From" => "От",
"Hi" => "Привет",
"Enjoy the site!" => "Наслаждайтесь сайтом!",
"The user" => "Пользователь",
"registered at your site" => "зарегистрировался на вашем сайте",
"Bye bye!" => "Пока пока!",
"This email address has been removed to the list of subscriptors of:" => "Этот почтовый адрес был удален из списка рассылки:",
"Newsletter:" => "Список рассылки:",
"You can unsubscribe from this newsletter following this link" => "Вы можете отписаться от новостей перейдя по этой ссылке",
"Welcome to our newsletter!" => "Добро пожаловать!",
"This email address has been added to the list of subscriptors of:" => "Этот почтовый адрес был добавлен в список рассылки:",
"You can always cancel your subscription using:" => "Вы всегда можете отменить подписку через:",
"You or someone registered this email address at" => "Вы или кто-то другой зарегистрировал этот адрес на",
"Your registration confirmation" => "Ваша регистрационная информация Tiki",
"You will receive an email with information to login for the first time into this site" => "Вы получите письмо с информацией о том, как зайти на сайт под своим аккаунтом в первый раз",
"changed" => "изменено",
"created" => "создано",
"New" => "Новый",
"File Description" => "Описание файла",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} создана {\$mail_user} {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} удалена {\$mail_user} {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Страница {\$mail_page} изменена {\$mail_user} {\$mail_date|tiki_short_datetime}",
"Wiki page %s created by {\$mail_user}" => "Страница %s создана {\$mail_user}",
"Wiki page %s deleted by {\$mail_user}" => "Страница %s удалена {\$mail_user}",
"Wiki page %s changed by {\$mail_user}" => "Страница %s отредактирована {\$mail_user}",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "На страницу {\$mail_page} {\$mail_date|tiki_short_datetime} был добавлен комментарий от {\$mail_user}",
"Wiki page %s was commented on by" => "На страницу %s был добавлен комментарий от",
"an anonymous user" => "анонимный пользователь",
"Wiki page renamed" => "Страница переименована",
"Old name" => "Бывшее наименование",
"New name" => "Новое название",
"Query" => "Запрос",
"Last modification date" => "Время последней правки",
"Create" => "Создать",
"Reload" => "Обновить",
"History" => "История",
"of" => "/",
"Compare" => "Сравнить",
"Current" => "Текущий",
"Versions are identical" => "Версии совпадают",
"User" => "Пользователь",
"Ip" => "IP",
"Diff" => "Разница",
"Upload Files" => "Закачать файлы",
"Unread" => "Непрочитанные",
"Flagged" => "Отмеченные флажком",
"Unflagged" => "Без отметки флажком",
"Containing" => "Содержит",
"Sender" => "Отправитель",
"No messages to display" => "Нет сообщений для вывода",
"Broadcast message" => "Широковещательное сообщение",
"OK" => "да",
"Please Confirm" => "Пожалуйста подтвердите",
"All users" => "Все пользователи",
"Lowest" => "Низший",
"Low" => "Низкий",
"High" => "Высокий",
"Very High" => "Высший",
"Send" => "Отослать",
"Compose message" => "Создать сообщение",
"Invalid" => "Неправильный",
"is reply to" => "это ответ на",
"Archive" => "Архив",
"Mark as read" => "Отметить как прочтённые",
"Mark as unread" => "Как непрочтённые",
"Mark as flagged" => "Отметить флажком",
"Mark as unflagged" => "Снять отметку",
"Mark" => "Пометка",
"Mailbox" => "Почтовый ящик",
"Compose" => "Создать",
"Broadcast" => "Широковещание",
"Sent" => "Отправлено",
"Read message" => "Прочесть сообщение",
"Return to mailbox" => "Возврат в почтовый ящик",
"replyall" => "ответить всем",
"Flag this message" => "Отметить флажком",
"From:" => "От:",
"Return to archive" => "Возврат в архив",
"Return to outbox" => "Возврат в отправленные",
"Sent Messages" => "Отправленные",
"Replied" => "С ответом",
"Not replied" => "Без ответа",
"move to archive" => "перенести в архив",
"receiver" => "получатель",
"Up" => "Выше",
"Down" => "Ниже",
"Thank you for installing Tikiwiki" => "Спасибо за использование Tikiwiki",
"To configure your Tiki" => "Настройка Tiki",
"Select" => "Выбрать",
"Admin Home" => "Администрирование системы",
"Admin" => "Админ",
"Admin Modules" => "Модули Администрирования",
"Modules" => "Модули",
"Admin Menus" => "Управлять меню",
"Menus" => "Меню",
"login" => "вход",
"Add event" => "Добавить событие",
"Apply" => "Применить",
"Pages:" => "Страницы:",
"Add tags" => "Добавить тэги",
"insert original" => "вставить оригинал",
"insert thumbnail" => "вставить предпросмотр",
"more" => "еще",
"No avatar" => "Нет аватара",
"Register" => "Регистрация",
"You" => "Вы",
"Open operator console" => "Открыть консоль оператора",
"Logged in as" => "Вошли как",
"Logout" => "Завершить работу",
"Switch User" => "Сменить Пользователя",
"Switch" => "switch",
"Switch user" => "Сменить пользователя",
"Login through CAS" => "Войти через CAS",
"Login as admin" => "Войти как админ",
"Login through Shibboleth" => "Войти через Shibboleth",
"Login as" => "Войти как",
"eMail" => "эл.адрес",
"Password" => "Пароль",
"Remember me" => "Запомнить меня",
"week" => "нед.",
"month" => "месяц",
"year" => "год",
"Click here to register" => "Нажмите здесь для регистрации",
"Click here if you've forgotten your password" => "Нажмите здесь если Вы забыли свой пароль",
"I forgot my password" => "Я забыл мой пароль",
"Click here to login using the default security protocol" => "Нажмите здесь для входа через протокол по умолчанию",
"Standard" => "Обычный",
"Click here to login using a secure protocol" => "Нажмите здесь для входа через защищенный протокол",
"Secure" => "Безопасный",
"Stay in ssl Mode" => "Оставаться в безопасном ssl режиме",
"local account" => "локальная учетная запись",
"OpenID Login" => "OpenID Вход",
"You have" => "Вам",
"new messages" => "новые сообщения",
"new message" => "новое сообщение",
"You have 0 new messages" => "У Вас 0 новых сообщений",
"We have" => "",
"submissions waiting to be examined" => "поступлений, ожидающих оценки",
"Image Galleries" => "Галереи изображений",
"Calendars" => "Календари",
"Entire Site" => "Весь сайт",
"Wiki Pages" => "Wiki страницы",
"Image Gals" => "Фотогалереи",
"Blog Posts" => "Сообщения в блоге",
"Search Wiki PageName" => "Найти страницу",
"Page Relations" => "Зависимости страницы",
"Delete this shout" => "Удалить эту запись",
"Edit this shout" => "Редактировать эту запись",
"Read More" => "Читать ещё",
"Since your last visit on" => "С Вашего последнего визита",
"New Images" => "Новые изображения",
"Wiki Pages Changed" => "wiki страницы изменились",
"New Files" => "Новые файлы",
"New Comments" => "Новые комментарии",
"New Tracker Items" => "Новые записи в трекере",
"New Calendar Events" => "Новые события в календаре",
"New Users" => "Новые пользователи",
"click to edit" => "жми для правки",
"Nothing has changed" => "Ничего не изменилось",
"Site default" => "Умолачение системы",
"TikiTests Menu" => "Меню TikiTests",
"List Tests" => "Список тестов",
"Create Test" => "Создать тест",
"Top galleries" => "Лучшие Галереи",
"update from it" => "обновить отсюда",
"view" => "просмотр",
"preferred languages" => "языковые предпочтения",
"update it" => "обновить здесь",
"click to view" => "нажмите для просмотра",
"Bookmarks" => "Закладки",
"Cache" => "Кеш",
"Done" => "Готово",
"Del" => "Удалить",
"select" => "выбор",
"Refresh" => "Обновить",
"online users" => "народу онлайн",
"online user" => "пользователь в сети",
"on host" => "на сервере",
"Send a message to" => "Отправить сообщение для",
"Send a message" => "Отослать письмо",
"More Videos" => "Еще Видео",
"vote" => "голос",
"Warning" => "Внимание",
"Users" => "Пользователи",
"Send Newsletter" => "Отправить новость",
"Switch to normal (wiki) editor" => "Использовать простой (wiki) редактор",
"By" => "Автор",
"Edit blog" => "Редактировать блог",
"Monitor this Blog" => "наблюдать за блогом",
"Stop Monitoring this Blog" => "прекратить наблюдение",
"Find:" => "Поиск:",
"Read more" => "Читать дальше",
"pages" => "страницы",
"To edit the copyright notices" => "Для редактирования авторских прав",
"The content on this page is licensed under the terms of the" => "Содержимое этой страницы находится под защитой лицензии",
"Permalink" => "Постоянная ссылка",
"comments" => "коммент.",
"First page" => "Первая страница",
"Previous page" => "Предыдущая страница",
"page" => "стр.",
"Next page" => "Следующая страница",
"Last page" => "Последняя страница",
"referenced by" => "упоминается",
"references" => "ссылается на",
"View Comments" => "комментарии",
"Blog name" => "Название блога",
"Do not group by item" => "Не группировать по типу",
"Group by item" => "Группировать по типу",
"Calendar View" => "Смотреть как календарь",
"List View" => "Смотреть как список",
"Tiki Action Calendar" => "Календарь событий Tiki",
"Tools Calendars" => "Календари инструментов",
"Check / Uncheck All" => "отметить / очистить все",
"Tip" => "Подсказка",
"Cancel Edit" => "Отменить правку",
"Change preferences" => "Изменить настройки",
"General" => "Общие",
"Features" => "Возможности",
"Community" => "Сообщество",
"Profiles" => "Профили",
"Look & Feel" => "Внешний вид",
"Editing and Plugins" => "Редактирование и плагины",
"Module" => "Модуль",
"Meta Tags" => "Метатеги",
"Security" => "Безопасность",
"User files" => "Файлы пользователя",
"Webservices" => "Web сервисы",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Чтобы добавить или удалить блоги, используйте \"Создать/Изменить Блог\" в меню \"Блоги\", или",
"General Settings" => "Общие настройки",
"Home Blog (main blog)" => "Начальный блог (основной)",
"Create a blog" => "Создать блог",
"Requires a separate download" => "Требует отдельного скачивания",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Чтобы добавить или удалить календари, используйте \"Календарь\" в меню \"Админ\", или",
"Change settings" => "Изменить параметры",
"General settings" => "Общие параметры",
"Default calendars to display" => "Календари для отображения по умолчанию",
"All calendars" => "Все календари",
"A subset of available calendars" => "Подмножество имеющихся календарей",
"Create calendar" => "Создать календарь",
"Default view mode" => "Ркжим просмотра по умолчанию",
"Day" => "День",
"Week" => "Неделя",
"Month" => "Месяц",
"Quarter" => "Квартал",
"Semester" => "Семестр",
"First day of the week" => "Первый день недели",
"Saturday" => "Суббота",
"Sunday" => "Воскресенье",
"Monday" => "Понедельник",
"Depends user language" => "В зависимости от языка пользователя",
"1 minute" => "1 минута",
"5 minutes" => "5 минут",
"10 minutes" => "10 минут",
"15 minutes" => "15 минут",
"30 minutes" => "30 минут",
"Manual selection of time/date" => "Выбор даты/времени вручную",
"JS calendar" => "JS календарь",
"Browse categories" => "Просмотр категорий",
"Administer categories" => "Администрирование категорий",
"Permissions" => "Права доступа",
"Admin types" => "Настройка типов",
"Import CSV file" => "Импортировать CSV файл",
"Batch upload (CSV file)" => "Пакетная закачка (CSV файл)",
"Import" => "Импорт",
"Admin Groups" => "Настройка групп",
"Admin Users" => "Настройка пользователей",
"Show user's information on mouseover" => "Показывать информацию о пользователе при наведении указателя мышки",
"Requires user's information to be public" => "Требует публичности пользовательской информации",
"Real name" => "Настоящее имя",
"Gender" => "Пол",
"avatar" => "аватара",
"Number of friends" => "Кол-во друзей",
"Feature is disabled" => "Функция отключена",
"Enable now" => "Включить",
"E-mail" => "Эл.адрес",
"Last login" => "Последний Вход",
"Distance" => "Расстояние",
"Default user preferences" => "Настройки пользователя по умолчанию",
"Users Default Preferences" => "Предпочтения пользователей по умолчанию",
"Character set for mail" => "Кодировка для писем",
"default" => "по умолчанию",
"Number of visited pages to remember" => "Число посещённых страниц для запоминания",
"Displayed time zone" => "Часовой пояс",
"Detect user timezone if browser allows, otherwise site default" => "Определить автоматически. В противном случае взять установки сайта",
"User information" => "Информация о пользователе",
"Private" => "Личное",
"public" => "общедоступная",
"Use double-click to edit pages" => "Использовать двойной клик для редактирования страниц",
"Show user's info on mouseover" => "Показывать информацию о пользователе при наведении указателя мышки",
"Tasks per page" => "Число заданий на лист",
"User messages" => "Сообщения пользователя",
"Messages per page" => "Число сообщений на лист",
"Allow messages from other users" => "Принимать сообщения от других пользователей",
"Notify sender when reading mail" => "Уведомить отправителя при прочтении письма",
"Send me an email for messages with priority equal or greater than" => "Выслать мне письмо для сообщений с приоритетом не менее",
"Auto-archive read messages after x days" => "Архивировать прочитанные сообщения после x дней",
"never" => "никогда",
"My Tiki" => "Мой Tiki",
"My pages" => "Мои страницы",
"My messages" => "Мои сообщения",
"My tasks" => "Мои задачи",
"My forum topics" => "Мои темы на форуме",
"My forum replies" => "Мои ответы на форуме",
"My items" => "Мои объекты",
"Select which items to display when listing users" => "Выберите пункты для отображения при просмотре списка пользователей",
"Score ascending" => "По возрастанию оценки",
"Score descending" => "По убыванию оценки",
"Name ascending" => "По имени",
"Name descending" => "По имени в обратном порядке",
"Login ascending" => "По логину",
"Login descending" => "По логину в обратном порядке",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright позволяет определить авторские права для всех объектов TikiWiki",
"Enable copyright management for" => "Включить управление авторскими правами для",
"Settings" => "Настройки",
"Watches" => "Наблюдения",
"Programmer" => "Для программиста",
"Experimental" => "Экспериментальные возможности",
"To create or remove file galleries, select" => "Для создания или удаления файловой галереи выберите",
"from the application menu" => "из меню приложения",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "У вас есть два варианта для достижения этой цели: <br /> <ul> <li> Использовать каталог за пределами вашего сайта, но при этом необходимо убедиться, что ваш PHP-скрипт может читать и записывать в этот каталог. </li> <li> Использование каталога внутри сайта с использованием ограничения доступа через файл .htaccess.</li></ ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "При настройки путей используйте UNIX стандарт записи. Например files/ или c:/foo/files или /www/files/",
"Home Gallery (main gallery)" => "Начальная галерея (главная)",
"Create a Gallery" => "Создать галерею",
"Store in database" => "Хранить в базе данных",
"Store in directory" => "Хранить в папке на диске",
"Score is disabled" => "Подсчет баллов отключен",
"Search Indexing" => "Индексированный поиск",
"Home Forum (main forum)" => "Главный Форум",
"Searches" => "Поиски",
"Galleries features" => "Свойства галерей",
"Use database to store images" => "Хранить изображения в базе данных",
"Use a directory to store images" => "Хранить изображения в папке",
"Directory path" => "Путь к папке",
"Library to use for processing images" => "Библиотека для обработки изображений",
"Uploaded image names must match regex" => "Имена картинок должны совпадать с regex",
"Uploaded image names cannot match regex" => "Имена картинок НЕ должны совпадать с regex",
"Max Rows per page" => "Строк на странице не более",
"Images per row" => "Картинок в строке не более",
"Thumbnails size X" => "Размер иконок X",
"Thumbnails size Y" => "Размер иконок Y",
"pixels" => "пиксели",
"Set features" => "Задать свойства",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Удалить изображения в каталоге системы, которые не использованы в страницах Wiki, статьях или сообщениях блогов",
"All galleries" => "Все галереи",
"System Gallery" => "Системная галерея",
"Gallery listing configuration" => "Настройка списка галерей",
"Parent" => "Родитель",
"Last modified" => "Последние изменения",
"Change configuration" => "Изменить конфигурацию",
"Image galleries comments settings" => "Комментарии в фотогалереях",
"General Preferences" => "Основные настройки",
"Release Check" => "Проверка обновлений",
"Reset or upgrade your database" => "Сбросить или обновить базу данных",
"Check for updates now" => "Проверить обновления сейчас",
"Site Identity" => "Наименование сайта",
"Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look & Feel</strong></a> section for additional site related customization preferences" => "На странице <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Внешний вид</strong></a> вы можете установить дополнительные настройки",
"Username" => "Имя пользователя",
"Server" => "Сервер",
"Contact" => "Связаться",
"Miscellaneous" => "Разное",
"Home Page" => "Домашняя страница",
"Custom home" => "Своя домашняя страница",
"Use different URL as home page" => "Указать вручную URL для домашней страницы",
"Date and Time Formats" => "Формат даты и времени",
"Date and Time Format Help" => "Помощь по формату даты и времени",
"Change admin password" => "Пароль администратора",
"Defaults" => "Умолчания",
"Internationalization" => "Международные настройки",
"port" => "порт",
"click here" => "нажмите здесь",
"Tiki and HTTP Auth" => "Tiki и HTTP Auth",
"Users can register" => "Можно регистрироваться",
"Use challenge/response authentication" => "Использовать авторизацию вопрос/ответ",
"Allow secure (https) login" => "Позволять безопасный (https) вход",
"Encourage secure (https) login" => "Разрешить защищенный (https) вход",
"Consider we are always in HTTPS, but do not check" => "Считать соединение всегда защищенным (HTTPS), но не проверять",
"Require secure (https) login" => "Требовать безопасный (https) вход",
"Duration:" => "Длительность:",
"Edit CSS" => "Редактировать CSS",
"Theme Control" => "Управление темами",
"Edit Templates" => "Правка шаблонов",
"General Layout options" => "Параметры общего расположения",
"logged as" => "Вы вошли как",
"Left column" => "Левая колонка",
"always" => "всегда",
"Right column" => "Правая колонка",
"Bottom bar" => "Нижняя полоса",
"Email this page" => "Отправить страницу почтой",
"Maximum number of records in listings" => "Показывать записей в списках не более",
"Use direct pagination links" => "Использовать прямые ссылки на страницы",
"Layout per section" => "Расположение по секции",
"Admin layout per section" => "Управлять расположением в секции",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Чтобы добавить или удалить опросы, используйте \"Опросы\" в меню \"Админ\", или",
"Waiting" => "Ожидание",
"Last update" => "Последнее обновление",
"More information" => "Еще Информации",
"Image galleries" => "Фотогалереи",
"Feed for forums" => "Поток данных для форумов",
"Specification" => "Спецификация",
"Automonospaced text" => "Автомоноширинный текст",
"Tables syntax" => "Синтаксис таблиц",
"|| for rows" => "|| для строк",
"Hotwords" => "Горячие слова",
"Default size" => "Размер по умолчанию",
"rows" => "строки",
"Comments " => "Комментарии ",
"Required" => "Обязателен",
"Parameters" => "Параметры",
"Default Value" => "Значение по умолчанию",
"Use database to store files" => "Хранить файлы в базе данных",
"Use a directory to store files" => "Хранить файлы в папке",
"dls" => "скачано",
"No records" => "Нет записей",
"Quota (Mb)" => "Квота (Мбайт)",
"Use database to store userfiles" => "Хранить файлы пользователей в базе данных",
"Use a directory to store userfiles" => "Хранить файлы пользователей на диске",
"Page ID" => "ID страницы",
"Page version" => "Версия страницы",
"Not Installed" => "Не установлено",
"Undo" => "Откат",
"Footnotes" => "Примечания",
"Permission" => "Доступ",
"Allow HTML" => "Позволять HTML",
"Sandbox" => "Песочница",
"Dumps" => "Дампы",
"Remove a tag" => "Удалить отметку",
"Generate dump" => "Создать дамп",
"Download last dump" => "Скачать последний дамп",
"Pictures" => "Изображения",
"Remove unused pictures" => "Удалить неиспользуемые изображения",
"Export" => "Экспорт",
"Export Wiki Pages" => "Экспорт страниц Wiki",
"Only with last version" => "Только с последней версией",
"Discuss pages on forums" => "Обсудить страницы на форуме",
"View source" => "Просмотр источника",
"Similar" => "Подобные",
"like pages" => "подобные страницы",
"Structures" => "Структуры",
"Import HTML" => "Импорт HTML",
"Import pages" => "Импорт страниц",
"Page creators are admin of their pages" => "Создатели - администраторы своих страниц",
"Links" => "Ссылки",
"Maximum size" => "Максимальный размер",
"Wiki attachments" => "Приложение файлов к страницам Wiki",
"disabled" => "отключено",
"enabled" => "включено",
"preference" => "параметр",
"Crosslinks to other features and settings" => "Ссылки на другие функции и настройки",
"Other sections" => "Другие разделы",
"Spreadsheet" => "Электронная таблица",
"Contact us" => "Свяжитесь с нами",
"Administration features" => "Функции администрирования",
"TikiCache/System" => "Кеш Tiki",
"SysLogs" => "Протоколы системы",
"phpinfo" => "Настройки PHP",
"Mods" => "Модули",
"Banning" => "Блокировки",
"Edit Languages" => "Редактировать языки",
"Transversal features" => "Трансверсальные функции",
"which apply to more than one section" => "которые применяются в более чем одном разделе",
"Mail Notifications" => "Уведомления почтой",
"Navigation features" => "Навигационные функции",
"Look & feel" => "Внешний вид",
"themes" => "темы",
"Text area features" => "Текстовые функции",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "используются во всех полях для ввода текста. Например wiki страницы, блоги, статьи, форумы, и т.д.",
"Content Templates" => "Шаблоны содержимого",
"External Wikis" => "Внешние Wiki",
"Stats &amp; banners" => "Статистика и баннеры",
"Report" => "Отчет",
"bytes" => "байт",
"kb" => "кб",
"Statistics" => "Статистика",
"Weeks" => "Недели",
"Setting" => "Установка",
"viewed" => "просмотров",
"Add or edit a rule" => "Добавить или редактировать правило",
"Rule title" => "Заголовок правила",
"Username regex matching" => "Regex на имя пользователя",
"IP regex matching" => "Regex на IP",
"Banned from sections" => "Закрыт доступ в разделы",
"Rule activated by dates" => "Правило активируется по датам",
"Rule active from" => "Правило активно от",
"Rule active until" => "Правило активно до",
"Custom message to the user" => "Индивидуальное сообщение пользователю",
"Rules" => "Правила",
"User/IP" => "Пользователь/IP",
"Sections" => "Секции",
"Admin Calendars" => "Настройка календарей",
"Create Calendar" => "Создать календарь",
"View Calendars" => "Просмотр календарей",
"List of Calendars" => "Список календарей",
"Loc" => "Разм.",
"Participants" => "Участники",
"Cat" => "Кат.",
"Lang" => "Язык",
"Prio" => "Приор.",
"Subscription" => "Подписка",
"Perso" => "Персон.",
"View Calendar" => "Просмотр календаря",
"Add Event" => "Добавить событие",
"Create/Edit Calendars" => "Создать/Изменить календари",
"Custom Locations" => "Свои места назначения",
"Custom Participants" => "Свои участники",
"Custom Categories" => "Свои категории",
"Custom Languages" => "Свои языки",
"Custom URL" => "Свой URL",
"Custom Subscription List" => "Свои подписчики",
"Custom Priorities" => "Свои приоритеты",
"Personal Calendar" => "Персональный календарь",
"Start of day" => "Начало дня",
"h" => "час",
"End of day" => "Конец дня",
"Standard Colors" => "Стандартные цвета",
"Green" => "Зеленый",
"Blue" => "Синий",
"Purple" => "Розовый",
"Red" => "Красный",
"Orange" => "Оранжевый",
"Yellow" => "Желтый",
"Let me select my own colors" => "Выбор собственного цвета",
"Custom foreground color" => "Выбрать цвет",
"Custom background color" => "Выбрать цвет фона",
"Default event status" => "Статус события по умолчанию",
"Show in calendar view" => "Смотреть как календарь",
"Group of users alerted when calendar event is modified" => "Оповещать группу пользователей при изменении календаря",
"Browse the category system" => "Просмотр категорий",
"Current category" => "Текущая категория",
"Child categories" => "Подчинённые категории",
"Edit permissions for this category" => "Назначить права доступа к категории",
"Add new category" => "Добавить новую категорию",
"Objects in category" => "Объекты в категории",
"Remove from this Category" => "Удалить из этой категории",
"Add objects to category" => "Добавить объекты в категорию",
"Admin templates" => "Управлять шаблонами",
"Create new template" => "Создать новый шаблон",
"Use wysiwyg editor" => "Использовать редактор типа wysiwyg",
"Use normal editor" => "Использовать нормальный редактор",
"Use in" => "Разрешено в секции",
"HTML Pages" => "HTML страницы",
"Templates" => "Шаблоны",
"Visible in no sections" => "Скрыто в секциях",
"Remove section" => "Удалить секцию",
"Admin cookies" => "Настройка cookies",
"Create/edit cookies" => "Создание/правка cookies",
"Upload Cookies from textfile" => "Закачать Cookies из текстового файла",
"Upload from disk:" => "Выбрать и закачать с диска:",
"Upload" => "Закачать",
"Remove all cookies" => "Убрать все cookies",
"Admin dsn" => "Управлять DSN",
"Create/edit dsn" => "Создать/редактировать DSN",
"Admin external wikis" => "Управлять внешними Wiki",
"View template" => "Просмотр шаблона",
"Edit template" => "Редактирование шаблона",
"Create/Edit External Wiki" => "Создать/Редактировать внешние Wiki",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "URL (Используйте  чтобы заменить именем страницы URL пример: http://www.example.com/tiki-index.php?page=)",
"ExtWiki" => "внеш.wiki",
"Admin Forums" => "Управлять форумами",
"Create new forum" => "Создать новый форум",
"Duplicate forum" => "Создать копию форума",
"View this forum" => "Просмотр форума",
"Import forums" => "Импорт форумов",
"List forums" => "Список форумов",
"Coms" => "Комментариев",
"Age" => "Возраст",
"PPD" => "ppd",
"Create New Forum" => "Создать новый форум",
"There are individual permissions set for this forum" => "Нет индивидуального набора прав доступа для этого форума",
"Create new" => "Создать новое",
"Password protected" => "Защищено паролем",
"Forum password" => "Пароль на форум",
"Topic list configuration" => "Конфигурация списка тем",
"Posts can be rated" => "Оценивать сообщения",
"Display last post titles" => "Показывать заголовки последних ответов",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Пересылать сообщения на этом форуме по этому адресу электронной почты, в формате, который может быть использован для отправки обратно",
"Send mails even when the post is generated by inbound mail" => "Отправлять почту даже если ответ был получен входящим письмом",
"Append a reply link to outbound mails" => "Добавить ссылку на ответ в исходящую почту",
"Originating e-mail address for mails from this forum" => "Отправитель электронной почты для писем с этого форума",
"Add messages from this email to the forum" => "Добавлять сообщения от этого email в форум",
"Use topic smileys" => "Использовать смайлики тем",
"Show topic summary" => "Показать сводку темы",
"User information display" => "Показывать информацию о пользователе",
"Online" => "онлайн",
"Approval type" => "Тип подтверждения",
"Store attachments in:" => "Сохранять вложения:",
"Set topics preferences" => "Настройки тем",
"Show topics preferences" => "Показать настройки",
"hide topics preferences" => "Убрать настройки",
"Set thread preferences" => "Настройки ответов",
"Show threads preferences" => "Показать настройки",
"hide threads preferences" => "Убрать настройки",
"Duplicate Forum" => "Создать копию форума",
"Duplicate perms" => "Продублировать права",
"Duplicate" => "Создать копию",
"Admin Hotwords" => "Поучения Администратора",
"Add Hotword" => "Новое ключевое слово",
"Word" => "Слово",
"Admin HTML pages" => "Управлять HTML страницами",
"Edit this page" => "Редактировать страницу",
"View page" => "Просмотр страницы",
"content" => "содержимое",
"Create new HTML page" => "Создать новую HTML страницу",
"Apply template" => "Применить шаблон",
"Dynamic" => "Динамическая",
"Static" => "Статическая",
"Last Modif" => "Посл. правка",
"Start page" => "Стартовая страница",
"CSS file" => "CSS файл",
"Clear cache" => "Очистить кеш",
"CSS File" => "CSS Файл",
"Theme control" => "Управление темами",
"Top bar" => "Верхняя полоса",
"Generate positions by hits" => "Выстроить положение по количеству запросов",
"List of featured links" => "Список рекомендуемых ссылок",
"Position" => "Положение",
"Add Featured Link" => "Добавить рекомендуемую ссылку",
"disables the link" => "запрещает ссылку",
"Link type" => "Вид ссылки",
"replace current page" => "заменить эту страницу",
"framed" => "в рамке",
"open new window" => "новое окно",
"Account name" => "Название учётной записи",
"POP server" => "POP сервер для приёма почты",
"SMTP server" => "SMTP сервер для отправки почты",
"SMTP requires authentication" => "SMTP требует ввода пароля",
"Admin Topics" => "Администрирование тем",
"Admin Types" => "Настройка типов",
"Active" => "Активный",
"List menus" => "Список меню",
"Edit this menu" => "Редактировать это меню",
"Edit menu options" => "Параметры меню",
"Some useful URLs" => "Некоторые полезные URL",
"option" => "параметр",
"section level 0" => "раздел 0 уровня",
"section level 1" => "раздел 1 уровня",
"section level 2" => "раздел 2 уровня",
"section level 3" => "раздел 3 уровня",
"separator" => "разделитель",
"Choose" => "Выбор",
"Home Blog" => "Домашний блог",
"Home Image Gal" => "Домашняя фотогал.",
"Home Image Gallery" => "Домашняя фотогалерея",
"Home File Gal" => "Домашняя файл.галерея",
"Home File Gallery" => "Домашняя файловая галерея",
"User preferences" => "Личные настройки",
"User prefs" => "Личные настройки",
"List galleries" => "Список галерей",
"List image galleries" => "Список фотогалерей",
"Upload image" => "Закачать изображение",
"Gallery Rankings" => "Рейтинги галерей",
"Browse a gallery" => "Просмотреть галерею",
"Articles home" => "Заглавная",
"All articles" => "Все статьи",
"Submit" => "Отправить",
"List Blogs" => "Список блогов",
"Create blog" => "Создать блог",
"View a forum" => "Просмотр форума",
"View a thread" => "Просмотр ветки обсуждения",
"View a FAQ" => "Просмотреть ЧаВо",
"Take a quiz" => "Пройти тест",
"Quiz stats" => "Статистика теста",
"Stats for a Quiz" => "Статистика для теста",
"Preview menu" => "Предосмотр меню",
"Menu options" => "Опции меню",
"Export CSV data" => "Экспорт данных в CSV",
"Import CSV data" => "Импорт данных в CSV",
"Options" => "Параметры",
"Active Permissions" => "Установленные права",
"dynamic collapsed" => "динамическое свёрнутое",
"dynamic extended" => "динамическое раскрытое",
"fixed" => "фиксированное",
"Clear Cache" => "Очистить кеш",
"Assign/Edit modules" => "Назначить/Редактировать модули",
"Assigned Modules" => "Назначенные модули",
"Left Modules" => "Модули слева",
"Move Up" => "Вверх",
"Move Down" => "Вниз",
"Move to Right Column" => "переместить в правую колонку",
"Right Modules" => "Модули справа",
"Move to Left Column" => "переместить в левую колонку",
"Assign new module" => "Назначить новый модуль",
"Edit this assigned module:" => "Редактировать назначенный модуль:",
"Cache Time" => "Время кеширования",
"The" => "Опция",
"Display Modules to All Groups" => "Показывать модули всем группам",
"User Modules" => "Пользовательские модули",
"Create new user module" => "Создать новый пользовательский модуль",
"Must be wiki parsed" => "Wiki синтаксис",
"Objects that can be included" => "Объекты, которые можно добавить",
"Use Poll" => "Использовать опрос",
"Use Gallery" => "Использовать галерею",
"Use Dynamic Content" => "Использовать динам. содержимое",
"Use RSS Module" => "Использовать модуль rss",
"Use Menu" => "Использовать меню",
"Use Banner Zone" => "Использовать область",
"Use Wiki Structure" => "Использовать Wiki структуру",
"Data" => "Данные",
"Admin newsletter subscriptions" => "Управлять подписками на рассылки",
"List Newsletters" => "Список рассылок",
"Admin Newsletters" => "Управлять рассылками",
"Send Newsletters" => "Отправить письма",
"Add a subscription newsletters" => "Добавить подписку на рассылки",
"Email:" => "Ваш эл.адрес:",
"Batch e-mail subscribe" => "Пакетная подписка эл.адресов",
"txt file, one e-mail per line" => "текстовый файл, один эл.адрес на строку",
"Export Subscriber Emails" => "Экспорт эл.адресов подписчиков",
"Subscribe group" => "Подписка группы",
"Add subscribers of another newsletter" => "Добавить подписчиков из другой рассылки",
"Subscriptions" => "Подписки",
"Subscribed" => "Подписка",
"Admin newsletters" => "Управлять рассылкой",
"Editions" => "Редакций",
"Drafts" => "Черновики",
"Last Sent" => "Последняя отправка",
"Create/Edit Newsletters" => "Создать/редактировать рассылки",
"There are individual permissions set for this newsletter" => "Для этой рассылки заданы особые права доступа",
"Users can subscribe/unsubscribe to this list" => "Пользователи могут самостоятельно управлять подпиской",
"Users can subscribe any email address" => "Пользователи могу подписать любой адрес",
"Add unsubscribe instructions to each newsletter" => "Добавлять в письмо инструкцию по отказу от рассылки",
"Validate email addresses" => "Проверять адреса электронной почты",
"Allow customized text message to be sent with the html version" => "Разрешить настройку текстового сообщения, которое будет отправлено в HTML-версии",
"Mail notifications" => "Почтовые уведомления",
"Add notification" => "Добавить уведомление",
"Event" => "Событие",
"User / Group" => "Пользователь / Группа",
"edit" => "правка",
"remove" => "удалить",
"Update" => "Обновить",
"List polls" => "Список опросов",
"Edit this poll" => "Редактировать опрос",
"Preview poll" => "Предосмотр опроса",
"Poll options" => "Параметры голосования",
"Votes" => "Голоса",
"Admin Polls" => "Управлять голосованиями",
"Set last poll as current" => "Установить последнее голосование текущим",
"Close all polls but last" => "Закрыть все голосования кроме последнего",
"Activate all polls" => "Открыть все голосования",
"Create poll" => "Создать опрос",
"Edit poll" => "Редактировать опрос",
"active" => "активный",
"current" => "текущий",
"object" => "объект",
"PublishDate" => "Опубликовано",
"Votes older than these days are no more considered" => "Лимит в днях, позже которого ответы не учитываются",
"0 for no limit" => "0 - без лимита",
"Results" => "Результаты",
"Add poll to pages" => "Добавить опрос к страницам",
"Wiki pages" => "Wiki страницы",
"Lock the pages" => "Заблокировать страницы",
"Content for the feed" => "Содержимое для потока",
"Security Admin" => "Безопасность",
"user" => "логин",
"group" => "группа",
"sticky" => "закреплено",
"Edit structure" => "Редактирование структуры",
"View structure" => "Просмотр структуры",
"Export Pages" => "Экспорт страниц",
"Dump Tree" => "Выгрузить дерево",
"Create WebHelp" => "Создать WebHelp",
"View WebHelp" => "Просмотр WebHelp",
"Create new structure" => "Создать новую структуру",
"Alias" => "Псевдоним",
"Tree" => "Дерево",
"Use single spaces to indent structure levels" => "Используйте одинарный пробел для нового уровня в структуре",
"Create New Structure" => "Создать новую структуру",
"Add a New Question" => "Добавить новый вопрос",
"List surveys" => "Список анкет",
"Survey Stats" => "Статистика анкетирования",
"This survey stats" => "Статистика анкеты",
"Edit this Survey" => "Правка анкеты",
"Admin Surveys" => "Настройки",
"Edit Survey Question" => "Редактировать вопросы анкеты",
"Add a New Question to this survey" => "Добавить новый вопрос в анкету",
"Question" => "Вопрос",
"One choice" => "Один вариант",
"Multiple choices" => "Несколько вариантов",
"Multiple choices of thumbnails from a file gallery" => "Множественный выбор эскизов из файловой галереи",
"Short text" => "Короткий текст",
"Wiki textarea" => "Текстовая область Wiki",
"Rate (1..5)" => "Оценить (1..5)",
"Rate (1..10)" => "Оценить (1..10)",
"Rate" => "Оценка",
"For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "Для множественного ответа на вопрос используйте запятую в качестве разделителя. Например: один,два,три,много",
"For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "Для множественного выбора эскизов из файловой галереи, необходимо указать ID галереи. Например: 4",
"Options (if apply)" => "Варианты (если есть смысл)",
"Questions" => "Вопросы",
"Admin surveys" => "Настройки",
"List Surveys" => "Список анкет",
"Create New Survey" => "Новое анкетирование",
"There are individual permissions set for this survey" => "Для данного опроса установлен индивидуальный доступ",
"Open" => "Открыт",
"Closed" => "Закрыт",
"Tiki Cache/System Admin" => "Кеш Tiki",
"Exterminator of cached content" => "Список кешей",
"Directory to exterminate" => "Каталоги кеша",
"Clear all Tiki caches" => "Очистить все кеши Tiki",
"Empty" => "Пусто",
"All user prefs sessions" => "Все пользовательские настройки сессий",
"Directories to save" => "Каталоги для возможного сохранения",
"Generate a zip of those directories" => "Создать архив указанных каталогов",
"A zip has been written to {\$zipPath}" => "Архив записан в {\$zipPath}",
"Directory is not writeable" => "Каталог не доступен для записи",
"Advanced feature" => "Расширенные возможности",
"Fix UTF-8 Errors in Tables" => "Корректировка ошибок в кодировке UTF-8",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Эта функция приведет к смене кодировки строк в таблицах из ISO-8859-1 в UTF-8",
"UTF-8 Errors fixed" => "Ошибки UTF-8 исправлены",
"Fix it" => "Исправить",
"Create a new topic" => "Создать новую тему",
"Topic Name" => "Название темы",
"Upload Image" => "Закачать изображение",
"List of topics" => "Перечень тем",
"Articles (subs)" => "Статьи (subs)",
"topic image" => "изображение для темы",
"Inactive - Click to Activate" => "Отключено - нажмите чтобы включить",
"Deactivate" => "Деактивировать",
"Active - Click to Deactivate" => "Включено - нажмите чтобы выключить",
"Remove with articles" => "Удалить эти статьи",
"List Trackers" => "Список трекеров",
"Admin Trackers" => "Управлять трекерами",
"Edit This Tracker" => "Редактировать этот трекер",
"View This Tracker's Items" => "Показать содержимое трекера",
"Tracker fields" => "Поля трекера",
"Mandatory" => "Обязательное",
"Is column visible when listing tracker items?" => "Видно ли колонку в списке элементов трекера?",
"Column links to edit/view item?" => "Колонка ссылается на правку/просмотр элемента?",
"Searchable" => "Поиск",
"Field is public? (viewed in trackerlist plugin)" => "Публичное поле? (возможен просмотр в trackerlist плагине)",
"Hidden" => "Скрыт",
"New tracker field" => "Новое поле",
"Edit tracker field" => "Редактировать поля трекера",
"Multilingual content" => "Многоязычное содержимое",
"not hidden" => "не скрытое",
"visible to admin only" => "видимость только администратору",
"editable by admin only" => "редактирование только администратором",
"visible by creator &amp; admin only" => "видимость только автору &amp; администратору",
"Import/Export Trackers Fields" => "Импорт/Экспорт полей трекера",
"Edit This Tracker's Fields" => "Редактировать поля трекера",
"Found" => "Найдено",
"trackers" => "трекеры",
"with" => "с",
"Edit Tracker" => "Редактировать трекер",
"Create Tracker" => "Создать трекер",
"Create/Edit Tracker" => "Создать/Редактировать трекер",
"There are individual permissions set for this tracker" => "Для этого трекера заданы индивидуальные права доступа",
"No individual permissions. Global permissions apply." => "Никаких индивидуальных прав доступа, здесь только глобальные",
"Auto create corresponding categories" => "Автоматическое создание соответствующей категории",
"Create a group for each item" => "Создать группу для каждого пункта",
"Show status" => "Показывать статус",
"Default status displayed in list mode" => "Статус по умолчанию в режиме списка",
"Show status to tracker admin only" => "Показывать статус только администратору трекера",
"Send copies of all activity in this tracker to this e-mail address" => "Отправлять письма на указанный эл.адрес при любой активности в трекере",
"Use simplified e-mail format" => "Использовать простой формат эл.письма",
"The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "В письме будут заполнены только поля Тема и Отправитель",
"New items are created with status" => "Статус для новых записей",
"Authoritative status for modified items" => "Новый статус для обновленных записей",
"No change" => "Без изменений",
"The tracker needs a user field with the option 1" => "Необходимо наличие поля \"Пользователь\" с опцией 1",
"Only one item per user or IP" => "Один IP адрес - одна запись",
"The tracker needs a user or IP field with the option 1" => "Необходимо наличие поля \"Пользователь\" или поля \"IP\" с опцией 1",
"The tracker needs a group field with the option 1" => "Необходимо наличие поля \"Группа\" с опцией 1",
"Show creation date when listing tracker items?" => "Показывать дату создания при выводе элементов трекера?",
"Show lastModif date when listing tracker items?" => "Показывать дату правки при выводе элементов трекера?",
"LastModif" => "Последняя модификация",
"ItemId" => "Id записи",
"ascending" => "по возрастанию",
"descending" => "по убыванию",
"with values" => "использовать значения",
"Tracker items allow comments?" => "Позволить комментировать элементы трекера?",
"Tracker items allow attachments?" => "Позволить добавлять файлы?",
"Filesize" => "Размер файла",
"Filetype" => "Тип файла",
"Items can be created only during a certain time" => "Ограничить создание новых записей по времени",
"Group of users alerted when tracker is modified" => "Уведомить группу о модификации трекера",
"Import/Export" => "Импорт/Экспорт",
"Import/export trackers" => "Импорт/Экспорт трекера",
"Date Format" => "Формат даты",
"Charset encoding" => "Кодировка",
"Duplicate Tracker" => "Создать копию трекера",
"Admin groups" => "Управлять группами",
"Admin users" => "Управлять пользователями",
"Add new group" => "Добавить новую группу",
"List of existing groups" => "Список существующих групп",
"User Choice" => "Выбор пользователя",
"Edit group" => "Изменить группу",
"Add a New Group" => "Добавить новую группу",
"Edit Item" => "Редактировать",
"Members" => "Участники",
"CSV File" => "CSV Файл",
"Add a New User" => "Добавить пользователя",
"Feedback" => "Обратная связь",
"Reason" => "Причина",
"More Criteria" => "Больше условий фильтрации",
"Registered" => "Зарегистрированные",
"ago" => "раньше",
"Need to validate email" => "Требуется проверка эл.адреса",
"Assign to group" => "Назначить в группу",
"to groups" => "в группы",
"Remove Users and their Userpages" => "Удалить пользователей и их личные страницы",
"Template wiki page" => "Шаблон wiki страницы",
"bcc" => "скрытая копия (bcc)",
"Edit user" => "Редактировать пользователя",
"Assign user to Groups" => "Добавить пользователя в группы",
"Use the email as username" => "Использование электронной почты в качестве имени пользователя",
"Lowercase only" => "Только в нижнем регистре",
"Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Внимание: смена имени пользователя может потребовать смену пароля (для пользователей зарегистрированных в старом tikiwiki&lt;=1.8)",
"No password is required" => "Пароль не требуется",
"Generate a password" => "Создать пароль",
"User must change password at first login" => "Пользователь должен сменить пароль при первом входе",
"User tracker item : {\$usersitemid}" => "Пользовательская запись в трекере : {\$usersitemid}",
"Overwrite" => "Перезаписать",
"Overwrite but keep the previous login if the login exists in another case" => "Перезаписать, но сохранить старый логин если такой уже существует",
"Don't overwrite" => "Не перезаписывать",
"You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "Вы можете выгрузить пользователей любой группы на странице <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
"Page has been approved" => "Страница была одобрена",
"New attachments" => "Новые вложения",
"Old attachments" => "Старые вложения",
"Source" => "Источник",
"Admin Article Types" => "Настройка типов статей",
"List of types" => "Список типов",
"Show Help" => "Помощь",
"Article type" => "Тип статьи",
"Show image" => "Показывать картинки",
"Show topic or own image" => "Показать темы или их изображения",
"Show avatar" => "Показывать Аватар",
"Show author's avatar" => "Показывать Аватар автора",
"Show author" => "Показывать автора",
"Show author name" => "Показывать имя автора",
"Show publish date" => "Показывать дату публикации",
"Show expire date" => "Показывать дату окончания",
"Show reads" => "Количество прочтений",
"Show the number of times the article was read" => "Показывать сколько раз статья была прочитана",
"Show size" => "Показывать размер",
"Show the size of the article" => "Показывать размер статьи",
"Show topline" => "Показать Topline",
"Show Language" => "Язык",
"Show the language" => "Показывать язык",
"Show lang" => "Язык",
"Review" => "Обзор",
"Classified" => "Объявления",
"Create a new type" => "Создать новый тип",
"Group Information" => "Информация о группе",
"level" => "уровень",
"inherited from" => "унаследованы от",
"inherited" => "унаследованный",
"Level configuration" => "Уровень конфигурации",
"Create level" => "Создать уровень",
"all permissions in level" => "все права доступа на уровне",
"Assign User to Group" => "Назначить пользователя в группу",
"backlinks to" => "обратные ссылки на",
"No backlinks to this page" => "На эту страницу нет обратных ссылок",
"Browse Gallery" => "Просмотр галереи",
"Upload From Disk" => "Закачать с диска",
"available images" => "доступные изображения",
"Process" => "Процесс",
"Edit Post" => "Правка сказанного",
"View Blog" => "Просмотр блога",
"Use ...page... to separate pages in a multi-page post" => "Используйте ...page... для создания нескольких страниц",
"Body" => "Тело документа",
"Upload image for this post" => "Закачать изображение",
"Trash" => "Корзина",
"Spellcheck" => "Правописание",
"Save and Exit" => "Сохранить и выйти",
"Report to Webmaster" => "Написать вебмастеру",
"Blogs RSS" => "RSS Блогов",
"Articles RSS" => "RSS Статей",
"Image Galleries RSS" => "RSS галерей изображений",
"File Galleries RSS" => "RSS файловых галерей",
"Forums RSS" => "RSS Форумов",
"Maps RSS" => "RSS Карт",
"Execution time" => "Время выполнения",
"Memory usage" => "Загрузка памяти",
"Server load" => "Загрузка сервера",
"Last update from SVN" => "Последнее обновление из SVN",
"Watch Only This Category" => "Просмотр только этой категории",
"Watch This Category and Their Descendants" => "Смотреть эту категорию и ее потомков",
"Stop Watching Only This Category" => "Прекратить просмотр этой категории",
"Stop Watching This Category and Their Descendants" => "Прекратить просмотр этой категории и ее потомков",
"Admin Category" => "Администрирование Категорий",
"Browse in" => "Просмотр в объектах",
"Trackers Items" => "Записей в трекерах",
"Sheets" => "Эл.таблицы",
"in the current category - and its subcategories: " => "в текущей категории и в ее подкатегориях",
"Hide subcategories objects" => "Скрыть объекты из подкатегории",
"Show subcategories objects" => "Показать объекты из подкатегории",
"Upper level" => "Верхний уровень",
"Browse related tags" => "Обзор связанной метки",
"Network of Tags related to" => "Все объекты с меткой",
"With all selected tags" => "Все указанные метки",
"With one selected tag" => "С одной из указанных меток",
"With last selected tag" => "С последней указанной меткой",
"More Popular Tags" => "Популярные метки",
"Alphabetically" => "По алфавиту",
"By Size" => "По размеру",
"Cloud" => "Облако",
"results found" => "объекта(ов) наейдено",
"List Galleries" => "Список галерей",
"Edit Gallery" => "Правка галереи",
"Rebuild Thumbnails" => "Перестроить иконки",
"List Gallery" => "Содержимое галереи",
"All Images" => "Все изображения",
"Monitor this Gallery" => "Наблюдать за галереей",
"Stop Monitoring this Gallery" => "Прекратить наблюдение за галереей",
"Sort Images by" => "Сортировать изображения по",
"subgallery" => "подгалерея",
"Subgallery" => "Подгалерея",
"Original Size" => "Оригинальный размер",
"rotate right" => "сдвинуть вправо",
"rotate" => "повернуть",
"Details" => "Детали",
"You can view this gallery's configured image (first, random, etc.) in your browser using" => "Просмотреть галерею вы можете набрав прямую ссылку на нее",
"You can include the gallery's image in an HTML page using one of these lines" => "Для доступа к изображениям галереи в HTML страницах используйте такую ссылку",
"You can include the image in a tiki page using one of these lines" => "Для доступа к галереи на Tiki страницах используйте короткую ссылку",
"Return to Gallery" => "Вернуться в галерею",
"Edit Image" => "Редактировать изображение",
"First Image" => "Первая картинка",
"Prev Image" => "Пред. картинка",
"Smaller" => "Меньше",
"Bigger" => "Больше",
"Popup window" => "Всплывающее окно",
"Next Image" => "След. картинка",
"Last Image" => "Последняя картинка",
"Image Name" => "Название",
"Move image" => "Переместить изображение",
"Stop Monitoring this Page" => "Остановить наблюдение",
"Monitor this Page" => "Наблюдать за страницей",
"Admin Calendar" => "Администрирование календаря",
"Export Calendars" => "Экспорт Календарей",
"Click to export calendars" => "Нажмите для экспорта календарей",
"Visible Calendars" => "Видимые календари",
"Group Calendars" => "Группа календарей",
"Export calendars" => "Экспорт календарей",
"advanced parameters" => "дополнительные параметры",
"Edit event" => "Редактировать событие",
"Delete event" => "Удалить событие",
"View event" => "Просмотр события",
"All-Day" => "Полный день",
"Tentative" => "Проба",
"Confirmed" => "Подтверждено",
"Cancelled" => "Отменено",
"View this Week" => "Просмотр текущей недели",
"View this Day" => "Просмотр текущего дня",
"Calendar Item" => "Событие календаря",
"Edit Calendar" => "Редактировать календарь",
"New event" => "Новое событие",
"Edit Calendar Item" => "Редактировать сообщение календаря",
"Tuesday" => "Вторник",
"Wednesday" => "Среда",
"Thursday" => "Четверг",
"Friday" => "Пятница",
"January" => "Январь",
"February" => "Февраль",
"March" => "Март",
"April" => "Апрель",
"May" => "Май",
"June" => "Июнь",
"July" => "Июль",
"August" => "Август",
"September" => "Сентябрь",
"October" => "Октябрь",
"November" => "Ноябрь",
"December" => "Декабрь",
"times" => "раз",
"End" => "Конец",
"Duration" => "Длительность",
"No description" => "Без описания",
"Roles" => "Роли",
"default role" => "роль по умолчанию",
"import" => "Импорт",
"Change password enforced" => "Требуется срочная смена пароля",
"Change your password" => "Сменить Ваш пароль",
"Send a message to us" => "Отправьте нам сообщение",
"Contact us by email" => "Свяжитесь с нами по почте",
"Click here to send us an email" => "Нажмите здесь чтобы отправить нам эл.письмо",
"Send another message" => "Еще отправить сообщение",
"Contacts" => "Контакты",
"Create/edit contacts" => "Создать/редактировать контакты",
"First Name" => "Имя",
"Last Name" => "Фамилия",
"Nickname" => "Ник",
"Structure" => "Структура",
"Add a new site" => "Добавить сайт",
"Please contact the Site Administrator" => "Обратитесь к Администратору",
"Site added" => "Сайт добавлен",
"Edit a site" => "Редактировать сайт",
"Add a site" => "Добавить сайт",
"Directory Administration" => "Управление каталогом",
"There are" => "Есть в наличии",
"invalid sites" => "ошибочные сайты",
"valid sites" => "проверенных сайтов",
"Users have visited" => "Посетители прошли на",
"sites from the directory" => "сайтов из каталога",
"Users have searched" => "Посетители искали",
"times from the directory" => "раз по каталогу",
"Related" => "По теме",
"Sites" => "Сайты",
"Validate" => "Проверить",
"Admin directory categories" => "Администрирование категорий",
"Add a directory category" => "Добавить категорию",
"Edit this directory category" => "Редактировать категорию",
"editor" => "редактор",
"Mutual" => "Взаимные",
"Admin sites" => "Управлять сайтами",
"Is valid" => "Проверено, работает",
"New Sites" => "Новые сайты",
"Cool Sites" => "Классные сайты",
"Add a Site" => "Добавить сайт",
"any" => "все",
"in entire directory" => "во всём каталоге",
"Sort by" => "Сортировка по",
"name (desc)" => "по имени (по убыванию)",
"name (asc)" => "по имени (по возрастанию)",
"hits (desc)" => "число хитов (по убыванию)",
"hits (asc)" => "число хитов (по возрастанию)",
"creation date (desc)" => "дата создания (по убыванию)",
"creation date (asc)" => "дата создания (по возрастанию)",
"last updated (desc)" => "последние изменения (по убыванию)",
"last updated (asc)" => "последние изменения (по возрастанию)",
"Added" => "Добавлено",
"Last updated" => "Последняя правка",
"Total links" => "Всего ссылок",
"Links to validate" => "Ссылки для проверки",
"Searches performed" => "Выполнено запросов на поиск",
"Total links visited" => "Число посещённых ссылок",
"Directory ranking" => "Рейтинг каталога",
"Search results" => "Результаты поиска",
"Validate sites" => "Проверить сайты",
"Edit article" => "Правка статьи",
"List Articles" => "Список статей",
"View Articles" => "Просмотр статей",
"One of the email addresses you typed is invalid" => "Один из адресов электронной почты который вы ввели недействительный",
"Author Name" => "Имя Автора",
"Own Image" => "Собственное изображение",
"Use own image" => "Использовать своё изображение",
"Own image size x" => "Размер своего изображения x",
"Own image size y" => "Размер своего изображения y",
"Publish Date" => "Дата публикации",
"Edit or create banners" => "Создать или отредактировать баннер",
"List banners" => "Список баннеров",
"URL to link the banner" => "URL для ссылки от баннера",
"Client" => "Клиент",
"Max impressions" => "Максимум показов",
"Show the banner only between these dates" => "Показывать баннер только в промежутке времени",
"From date" => "От даты",
"To date" => "До даты",
"Use dates" => "Использовать даты",
"Show the banner only in this hours" => "Показывать баннер только в указанные часы",
"Show the banner only on" => "Показывать баннер только в",
"Mon" => "Пн",
"Tue" => "Вт",
"Wed" => "Ср",
"Thu" => "Чт",
"Fri" => "Пт",
"Sat" => "Сб",
"Sun" => "Вс",
"Select ONE method for the banner" => "Использовать ОДИН метод для баннера",
"Use HTML" => "Использовать HTML",
"Use image" => "Использовать изображение",
"Image:" => "Изображение:",
"Current Image" => "Текущее изображение",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Использовать изображение, взятое с URL (изображение будет перечитано с URL при каждом показе)",
"Use text" => "Использовать текст",
"Save the Banner" => "сохранить баннер",
"Current heading" => "Текущий заголовок",
"There are individual permissions set for this blog" => "Для этого блога заданы индивидуальные права доступа",
"Number of posts to show" => "Число сообщений для показа",
"Allow other user to post in this blog" => "Позволить другим размещать сообщения",
"Allow search" => "Разрешить поиск",
"Allow comments" => "Разрешить комментарии",
"Blog heading" => "Название блога",
"Wiki Syntax" => "Wiki синтаксис",
"The syntax system used for creating pages in TikiWiki" => "Используйте систему синтаксиса TikiWiki для создания страниц",
"Bold text" => "Жирный",
"Italic text" => "Курсив",
"single quotes" => "одинарные кавычки",
"Underlined text" => "Подчеркнутый",
"Colored text" => "Цветной текст",
"Deleted text" => "Удаленный",
"2 dashes" => "двойное тире",
"Headings" => "Заголовки",
"Show/Hide" => "Показать/Спрятать",
"show/hide heading section. + (shown) or - (hidden) by default" => "развернуть/свернуть секцию заголовка. + (развернутая) или - (свернутая) по умолчанию",
"Autonumbered Headings" => "Автонумерация заголовков",
"Horizontal rule" => "Горизонтальная полоса",
"Text box" => "Текстовое поле",
"Box content" => "Содержимое в прямоугольнике",
"Centered text" => "По центру",
"Dynamic variables" => "Динамические переменные",
"Inserts an editable variable" => "Вставить динамическую переменную",
"External links" => "Внешние ссылки",
"Square Brackets" => "Квадратные скобки",
"Wiki References" => "Ссылки Wiki",
"JoinCapitalizedWords or use" => "СоединяйтеСловаСБольшойБуквы или используйте",
"page|description" => "стр.|описание",
"for wiki references" => "для ссылок внутри Wiki",
"SomeName" => "ЧьёТоИмя",
"prevents referencing" => "запрещает создание ссылки",
"Lists" => "Списки",
"for bullet lists" => "для ненумерованных списков",
"for numbered lists" => "для нумерованных списков",
"for definiton lists" => "для списков определений",
"Tables" => "Таблицы",
"row" => "строка",
"Title bar" => "Заголовок",
"Monospace font" => "Моноширинный шрифт",
"Code sample" => "Пример кода",
"Line break" => "Перевод строки",
"(very useful especially in tables)" => "(особенно удобно в таблицах)",
"Multi-page pages" => "Комбинированные страницы",
"to separate pages" => "для разделения страниц",
"Non parsed sections" => "Не разбираемые анализатором области",
"No description available" => "Описание недоступно",
"Browse Images" => "Просмотр изображений",
"Edit successful!" => "Редактирование успешно!",
"The following image was successfully edited" => "Следующий файл успешно отредактирован",
"Image Description" => "Описание изображения",
"You can view this image in your browser using" => "Вы сможете увидеть это изображение, используя",
"Edit or ex/import Languages" => "Редактировать или экс/импортировать языки",
"Edit and create Languages" => "Редактировать и создавать языки",
"Edit and create languages" => "Редактировать и создавать языки",
"Create Language" => "Создать язык",
"Shortname" => "Короткое имя",
"like" => "как",
"Longname" => "Длинное имя",
"Select the language to edit" => "Выберите язык для редактирования",
"Add a translation" => "Добавить перевод",
"Edit translations" => "Редактировать переводы",
"Translate recorded" => "Перевод запомнен",
"Translation" => "Перевод",
"reset table" => "сбросить таблицу",
"Create New Block" => "создать новый блок",
"Return to block listing" => "Вернуться к списку блоков",
"Block description: " => "Описание блока: ",
"You are editing block:" => "Вы редактируете блок:",
"Publishing date" => "Дата публикации",
"Publishing Date" => "Дата Публикации",
"Edit question options" => "Изменить параметры вопроса",
"List Quizzes" => "Список тестов",
"Quiz Stats" => "Статискика теста",
"This Quiz Stats" => "статистика по этому тесту",
"Edit this Quiz" => "редактировать тест",
"Admin Quizzes" => "Управлять тестами",
"Create/edit options for question" => "Создать/редактировать ответы на вопрос",
"Option" => "Параметр",
"points" => "точки",
"Quiz" => "Тест",
"Create/edit quizzes" => "Создать/редактировать тесты",
"There are individual permissions set for this quiz" => "Для этого теста заданы индивидуальные права доступа",
"Quiz can be repeated" => "Тест может быть пройден повторно",
"Store quiz results" => "Хранить результаты теста",
"Quiz is time limited" => "Тест ограничен по времени",
"Maximum time" => "Время не более",
"Create/edit questions for quiz" => "Создать/редактировать вопросы для теста",
"From Points" => "От очков",
"To Points" => "До очков",
"Answer" => "Ответ",
"Modify Structure" => "Изменение структуры",
"You will remove" => "Вы хотите удалить",
"and its subpages from the structure" => "и все ее подкатегории из структуры",
"Remove only from structure" => "Удалить только из структуры",
"Remove from structure and remove page too" => "Удалить из структуры и удалить страницу",
"Structure Layout" => "Макет структуры",
"Promote" => "На уровень выше",
"Demote" => "На уровень ниже",
"Previous" => "Раньше",
"Current Node" => "Выбран узел",
"Page alias" => "Псевдоним страницы",
"Move in this structure" => "Переместить в структуру",
"Move to another structure" => "Перенести в другую структуру",
"at the beginning" => "в начале",
"at the end" => "в конце",
"Add pages to current node" => "Добавить страницу к текущему узлу",
"After page" => "После страницы",
"Create Page" => "Создать страницу",
"Use pre-existing page" => "Использовать существующую странцу",
"Submit article" => "Разместить статью",
"List Submissions" => "Список поступлений",
"Submit Article" => "Разместить статью",
"Edit templates" => "Правка шаблонов",
"Template listing" => "Список шаблонов",
"Available templates" => "Доступные шаблоны",
"Edit Comment" => "Комментарий",
"Monitor this page" => "Наблюдать за страницей",
"Upload picture" => "Закачать картинку",
"Add another image" => "Добавить изображение",
"Categories will be inherited from the structure top page" => "Категории будут унаследованы от структуры наверх",
"Admin Content Templates" => "Управлять шаблонами содержимого",
"Lock this page" => "Заблокировать страницу",
"Replace with" => "Заменить на",
"Case Insensitivity" => "Любой размер букв",
"Try to convert HTML to wiki" => "Конвертировать HTML в wiki",
"Import page" => "Импорт страницы",
"export all versions" => "Экспорт всех версий",
"Manage structures" => "Управление структурами",
"License" => "Лицензия",
"Important" => "Важно",
"My Footnotes" => "Мои сноски",
"Use rating" => "Использовать рейтинг",
"or use" => "или используйте",
"an existing poll" => "существующий опрос",
"votes" => "голоса",
"Translation request" => "Запрос на перевод",
"List Sheets" => "Список эл.таблиц",
"Graph" => "График",
"Export to file" => "Экспорт в файл",
"Format" => "Формат",
"Autodetect" => "Автоопределение",
"Export Tracker Items" => "Экспорт записей трекера",
"Delimitors" => "Разделители",
"Carriage Return inside Field Value" => "Перевод строки внутри поля",
"Parse as Wiki Text" => "Обрабатывать как текст Wiki",
"status" => "состояние",
"lastModif" => "посл.правка",
"Admin FAQ" => "Настроить ЧаВо",
"List FAQs" => "Список ЧаВо",
"View FAQ" => "Просмотр ЧаВо",
"Edit this FAQ" => "Редактировать ЧаВо",
"New Question" => "Новый вопрос",
"Edit FAQ question" => "Редактировать вопрос",
"Add FAQ question" => "Добавить вопрос",
"Use a question from another FAQ" => "Взять вопрос из другого ЧаВо",
"FAQ questions" => "Вопросы ЧаВо",
"Suggested questions" => "Предложенные вопросы",
"No suggested questions" => "Нет предложеных вопросов",
"Upload File" => "Закачать файл",
"View tpl" => "Просмотр шаблона",
"Be careful to set the right permissions on the files you link to" => "Обратите внимание на установленные права доступа к файлам",
"You can access the file gallery using the following URL" => "Доступ к галерее можно получить через следующий URL",
"Admin forums" => "Управлять форумами",
"Back to forum" => "Назад в форум",
"make this a thread of" => "начать отсюда ветвь",
"None, this is a thread message" => "Нет, сообщение в потоке",
"summary" => "обзор",
"normal" => "обычный",
"announce" => "объявление",
"hot" => "горячая новость",
"no feeling" => "без чувств",
"frown" => "хмурый",
"idea" => "идея",
"neutral" => "спокойный",
"question" => "вопрос",
"happy" => "счастливый",
"Save and Approve" => "Одобрить и сохранить",
"convert to topic" => "превратить в тему",
"List of messages" => "Список сообщений",
"New Topic" => "Новая тема",
"no summary" => "нет обзора",
"Search by name" => "Поиск по названию",
"Search in content" => "Поиск по содержимому",
"Last Post" => "Посл. сообщ.",
"Configure Forum" => "Настроить форум",
"Set language" => "Установить язык",
"Accept" => "Принять",
"Galleries" => "Галереи",
"Create New Gallery" => "Создать новую галерею",
"Create a gallery" => "Создать галерею",
"There are individual permissions set for this gallery" => "Для этой галереи заданы индивидуальные права доступа",
"Gallery is visible to non-admin users?" => "Видят ли галерею не-администраторы?",
"Gallery Image" => "Изображение галереи",
"Available scales" => "Доступные масштабы",
"default scale" => "масштаб по умолчанию",
"No scales available" => "Масштабы недоступны",
"Other users can upload images to this gallery" => "Закачка изображений в галерею доступна и другим",
"You can access the gallery using the following URL" => "Вы можете получить доступ к галерее по следующему адресу",
"Available Galleries" => "Доступные Галереи",
"Choose a filter" => "Выберите фильтр",
"Imgs" => "Изображений",
"To" => "Кому",
"Im- Export languages" => "Импорт/экспорт языков",
"Select the language to Import" => "Выберите язык для импорта",
"Select the language to Export" => "Выберите язык для экспорта",
"Overwrite existing pages if the name is the same" => "Перезаписать существующий файл если имя такое же",
"Previously remove existing page versions" => "Заранее удалить существующие версии страницы",
"excerpt" => "цитата",
"Result" => "Результат",
"Locked" => "Закрыто",
"Documentation" => "Документация",
"Close this window" => "Закрыть это окно",
"Go Back" => "Возврат",
"Last Changes" => "Последние изменения",
"Last 2 days" => "За 2 дня",
"Last 3 days" => "За 3 дня",
"Last 5 days" => "За 5 ней",
"Last week" => "За неделю",
"Last 2 weeks" => "За 2 недели",
"Last month" => "За месяц",
"Search by Date" => "Поиск по дате",
"Rollback" => "Откат",
"Pages like" => "Подобные страницы",
"No pages found" => "Страницы не найдены",
"Edit New Article" => "Редактировать новую статью",
"View Submissions" => "Просмотр поступлений",
"Img" => "Изобр.",
"Create banner" => "Создать баннер",
"Method" => "Метод",
"Use Dates?" => "Использовать даты?",
"Max Impressions" => "Максимальное число показов",
"Impressions" => "Показы",
"Clicks" => "Нажатия",
"Create New Blog" => "создать новый блог",
"Approval" => "Подтверждено",
"Rejected" => "Отказано",
"Dynamic content system" => "Система динамического содержимого",
"Available content blocks" => "Доступные блоки содержимого",
"Current Value" => "Текущее значение",
"Current ver" => "Текущая версия",
"Next ver" => "Следующая версия",
"Program" => "Программа",
"Available FAQs" => "Доступные ЧаВо",
"Create new FAQ" => "Создать новый ЧаВо",
"Users can suggest questions" => "Пользователи могут предлагать вопросы",
"Create a File Gallery" => "Создать файловую галерею",
"Keep gallery window open" => "Не закрывать окно с галереями",
"Your comment" => "Ваш комментарий",
"Gallery Images" => "Галерея Картинок",
"Edit Blog" => "Редактировать Блог",
"Blog Title" => "Заголовок Блога",
"Edit New Submission" => "Редактировать новое поступление",
"Survey stats" => "Статистика анкетирования",
"Take Survey" => "Ответить на анкету",
"Last mod" => "Последнее изменение",
"Last author" => "Последний автор",
"Last version" => "Последняя версия",
"unlocked" => "разблокировано",
"Perform action with checked" => "Выполнить операцию над выделенными",
"Open client window" => "Открыть окно поддержки",
"Generate HTML" => "Сгенерировать HTML",
"Transcripts" => "Расшифровка",
"Online operators" => "Online операторы",
"Operator" => "Оператор",
"transcripts" => "расшифровка",
"Offline operators" => "Offline операторы",
"Add an operator to the system" => "Добавить оператора в систему",
"Operators must be tiki users" => "Операторы должны быть пользователями tiki",
"Set as Operator" => "назначить оператором",
"Chat started" => "Чат запущен",
"Operator:" => "Оператор:",
"Request live support" => "Запрос online поддержки",
"Request support" => "Запросить поддержку",
"Open a support ticket instead" => "Получить квиток поддержки",
"Your request is being processed" => "Ваш запрос принят. Ждите.",
"cancel request and exit" => "отменить запрос и выйти",
"cancel request and leave a message" => "отменить запрос и оставить сообщение",
"Live support:Console" => "Live support:Консоль",
"be online" => "в онлайн",
"be offline" => "в оффлайн",
"Support requests" => "Запросы пользователей",
"Requested" => "Запрошено",
"Join" => "Войти",
"Support chat transcripts" => "Расшифровка чата поддержки",
"started" => "начало",
"reason" => "причина",
"msgs" => "сообщ",
"Transcript" => "Рашифровка",
"Thank you" => "Спасибо",
"Prefs" => "Опции",
"Daily" => "Ежедневно",
"Weekly" => "Еженедельно",
"Remove old events" => "Удалить старые события",
"duration" => "длительность",
"Mini Calendar: Preferences" => "Мини-календарь: Настройки",
"Calendar Interval in daily view" => "Интервал календаря в просмотре по дням",
"Start hour for days" => "День начинается в",
"End hour for days" => "День заканчивается в",
"Reminders" => "Напоминания",
"no reminders" => "нет напоминаний",
"Or enter path or URL" => "Или введите путь или URL",
"Add Topic" => "Добавить тему",
"Attention" => "Внимание",
"User Galleries" => "Ваши галереи",
"My Articles" => "Мои статьи",
"User Articles" => "Статьи пользователя",
"My User Items" => "Мои трекер записи",
"User Items" => "Объекты пользователя",
"Unread Messages" => "Непрочтённые сообщения",
"Tasks" => "Задачи",
"User forum topics" => "Темы пользователя на форуме",
"Forum topics" => "Темы форума",
"Date of post" => "Дата сообщения",
"User forum replies" => "Ответы пользователя на форуме",
"Forum replies" => "Ответы на форуме",
"MyTiki" => "Мой Tiki",
"MyInfo" => "Информация обо мне",
"Contacts Preferences" => "Настройки контактов",
"Notepad" => "Блокнот",
"MyFiles" => "Мои Файлы",
"My Watches" => "Наблюдения",
"Sent editions" => "Отправленные редакции",
"HTML version" => "HTML версия",
"Text version" => "Текстовая версия",
"The newsletter was sent to {\$sent} email addresses" => "Новость была отправлена на {\$sent} e-mail адреса",
"Delete errors" => "Удалить ошибки",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Спасибо, что подписались на рассылку. Вы должны получить email с просьбой подтвердить подписку. Вы не получите ни одной рассылки, пока не подтвердите своё желание в ней участвовать.",
"Your email address was removed from the list of subscriptors." => "Ваш адрес был удалён из списка подписчиков.",
"Subscription confirmed!" => "Подписка подтверждена!",
"Subscribe to Newsletter" => "Подписаться на рассылку",
"Subscribe to this Newsletter" => "Подписаться",
"Available Newsletters" => "Доступные рассылки",
"Notes" => "Примечания",
"Write a note" => "Написать записку",
"quota" => "лимит",
"No notes yet" => "Заметок нет",
"Merge selected notes into" => "Объединить выбранные заметки в",
"Reading note:" => "Читаем записку:",
"List notes" => "Перечень записок",
"Write note" => "Написать записку",
"Wiki Create" => "Создать wiki",
"Wiki Overwrite" => "Обновить wiki",
"Assign permissions to " => "Назначить права доступа для ",
"Edit Permissions" => "Редактирование прав доступа",
"Assign permissions to this object" => "Назначить права доступа к объекту",
"Published" => "Опубликовано",
"Passcode to register (not your user password)" => "Секретный код для регистрации (не Ваш личный пароль!)",
"Orphan Pages" => "Страницы-сироты",
"Browser not supported" => "Браузер не поддерживается",
"Rename" => "Переименовать",
"Slides" => "Слайды",
"Discuss" => "Обсудить",
"Attach File" => "Вложить файл",
"1 File Attached" => "1 файл во вложении",
"{\$atts|@count} files attached" => "{\$atts|@count} файлов во вложении",
"Rollback to this version" => "Вернуться к версии",
"Pick your avatar" => "Выберите аватару",
"User Preferences" => "Личные Настройки",
"Your current avatar" => "Ваша аватара",
"Pick avatar from the library" => "Выберите аватару из библиотеки",
"Pick user Avatar" => "Выберите аватару для пользователя",
"Hide all" => "Скрыть все",
"Upload your own avatar" => "Закачайте свою аватару на сервер",
"Rank" => "Место",
"Average" => "В среднем",
"Vote poll" => "Проголосовать",
"Other Polls" => "Другие опросы",
"on:" => "в:",
"Viewing blog post" => "Просмотр сообщения в блоге",
"Return to blog" => "Вернуться в блог",
"Print multiple pages" => "Печать нескольких страниц",
"Add Pages" => "Добавить страницы",
"Use Ctrl+Click to select multiple pages" => "Используйте Ctrl+Click для выбора нескольких страниц",
"Add Page" => "Добавить страницу",
"Quiz result stats" => "Статистика по результатам теста",
"Time" => "Время",
"User answers" => "Ответы пользователей",
"Stats for quizzes" => "Статистика для тестов",
"taken" => "пройден",
"Av score" => "Ср.очки",
"Av time" => "Ср.время",
"Clear Stats" => "Очистить статистику",
"time taken" => "потраченное время",
"P/F" => "П/Ф",
"Passed" => "Зачет",
"Stats for this quiz Questions " => "Статистика по вопросам этого теста ",
"Top 10" => "Лучшие 10",
"Top 20" => "Лучшие 20",
"Top 50" => "Лучшие 50",
"Top 100" => "Лучшие 100",
"star" => "звезда",
"half star" => "полузвезда",
"Send a link" => "Отправить ссылку",
"Received articles" => "Полученные статьи",
"Edit received article" => "Редактировать полученную статью",
"Use Image" => "Использовать изображение",
"Image x size" => "Размер изображения по горизонтали",
"Image y size" => "Размер изображения по вертикали",
"Image name" => "Наименование изображения",
"Accept Article" => "Подтвердить статью",
"Site" => "Сайт",
"Received Pages" => "Полученные страницы",
"Edit Received Page" => "Редактировать полученную страницу",
"Received Structures" => "Полученные структуры",
"Referer stats" => "Статистика по Referer",
"Last" => "Последние",
"Register as a new user" => "Зарегистрироваться, как новый пользователь",
"Use your email as login" => "Используйте свой эл.адрес как имя для входа",
"Repeat password" => "Снова",
"The following site was added and validation by admin may be needed before appearing on the lists" => "Следующий сайт был добавлен и может потребоваться проверка админом перед тем, как ссылка появится в списках",
"Send me my Password" => "Отправьте мне мой пароль",
"Request Password Reset" => "Запрос пароля",
"Remove page" => "Удалить страницу",
"Last Version" => "Последняя версия",
"Back to page" => "Вернуться к странице",
"You are about to remove the page" => "Вы собрались удалить страницу",
"permanently" => "навсегда",
"Remove all versions of this page" => "Удалить все версии этой страницы",
"Rollback page" => "Откат страницы",
"Searched" => "Произведён поиск",
"Search in" => "Искать в",
"No pages matched the search criteria" => "Ни одна страница не соответствует запросу",
"All dates" => "Все даты",
"This newsletter will be sent to {\$subscribers} email addresses." => "Новость будет отправлена на {\$subscribers} e-mail адреса.",
"Prepare a newsletter to be sent" => "Подготовьте письмо к отправке",
"Apply content template" => "Применить шаблон",
"Attached Files" => "Вложенные файлы",
"To add a file, click here" => "Нажмите здесь для добавления файла",
"Save as Draft" => "Сохранить как черновик",
"Send Articles" => "Отправить статьи",
"Post or edit a message" => "Разместить или изменить сообщение",
"Location : " => "Расположение : ",
"TOC" => "Содержимое",
"Parent page" => "Родительская страница",
"Child" => "Потомок",
"page: %0/%1" => "страница: %0/%1",
"Last edited by" => "Отредактировано",
"Page last modified on %0 by %1" => "Последнее изменение страницы %0 автор %1",
"Created by %0" => "Создано %0",
"Last Modification: %0 by %1" => "Последнее изменение: %0 автор %1",
"Clean" => "Очистить",
"Params" => "Параметры",
"Site Stats" => "Статистика сайта",
"Started" => "Запущено",
"Days online" => "Дней в онлайне",
"Total pageviews" => "Число просмотров",
"Average pageviews per day" => "В среднем за день просмотров",
"pvs" => "просмотров стр.",
"Best day" => "Лучший день",
"Worst day" => "Худший день",
"Wiki Stats" => "Статистика Wiki",
"Size of Wiki Pages" => "Размер страниц Wiki",
"Average page length" => "Средний размер страницы",
"Average versions per page" => "Среднее число версий на страницу",
"Visits to wiki pages" => "Посещения страниц Wiki",
"Average links per page" => "Среднее число ссылок на странице",
"Image galleries Stats" => "Статистика фотогалерей",
"Average images per gallery" => "Среднее число изображений на галерею",
"Total size of images" => "Общее число изображений",
"Average image size" => "Средний размер изображения",
"Visits to image galleries" => "Посещений в фотогалереях",
"File galleries Stats" => "Статистика файловых галерей",
"Average files per gallery" => "Среднее число файлов на галерею",
"Total size of files" => "Суммарный размер файлов",
"Average file size" => "Средний размер файла",
"Visits to file galleries" => "Число посещений галерей",
"CMS Stats" => "CMS статистика",
"Total reads" => "Общее число прочтений",
"Average reads per article" => "Среднее число прочтений на 1 статью",
"Total articles size" => "Суммарный размер статей",
"Average article size" => "Средний размер статьи",
"Forum Stats" => "Статистика форума",
"Total topics" => "Всего тем",
"Average topics per forums" => "Средне число тем на форуме",
"Visits to forums" => "Посещения форумов",
"Blog Stats" => "Статистика блогов",
"Weblogs" => "Веблоги",
"Total posts" => "Суммарное количество сообщений",
"Total size of blog posts" => "Суммарный размер всех сообщений",
"Average posts size" => "Средний размер сообщения",
"Visits to weblogs" => "Посещений веблогов",
"Poll Stats" => "Статистика опросов",
"Total votes" => "Всего отдано голосов",
"Average votes per poll" => "В среднем число голосов на опрос",
"Total questions" => "Всего вопросов",
"Average questions per FAQ" => "В среднем вопросов на 1 ЧаВо",
"User Stats" => "Статистика пользователей",
"Average bookmarks per user" => "Среднее число закладок на пользователя",
"Average questions per quiz" => "Среднее число вопросов на тест",
"Quizzes taken" => "Пройдено тестов",
"Average quiz score" => "Среднее число баллов на тест",
"Average time per quiz" => "Среднее время на прохождение теста",
"Usage chart" => "График использования",
"Stats for surveys" => "Статистика по анкетам",
"Last taken" => "Последний раз пройден",
"Tiki Logs" => "Протоколы Tiki",
"Clean logs older than" => "Удалить протоколы старше чем",
"months" => "месяцев",
"Time Left" => "Времени осталось",
"Send Answers" => "отослать ответы",
"Your email was sent" => "Ваш email был отправлен",
"Theme is selected as follows" => "Тема выбирается по следующему принципу",
"If a theme is assigned to the individual object that theme is used." => "Используется тема, назначенная к конкретному объекту, если есть.",
"If not then if a theme is assigned to the object's category that theme is used" => "Если такой нет, то используется тема, назначенная категории объекта.",
"If not then a theme for the section is used" => "В противном случае берётся тема для секции.",
"If none of the above was selected the user theme is used" => "Если ни одна из выше перечисленных не найдена, используется тема заданная пользователем.",
"Finally if the user didn't select a theme the default theme is used" => "И, наконец, если пользователь не выбирал свою тему, используется тема сайта по умолчанию",
"Control by Sections" => "Управление по секциям",
"Assign themes to categories" => "Назначить темы для категорий",
"Assigned categories" => "Назначенные категории",
"Theme Control Center: Objects" => "Центр управления темами: Объекты",
"Control by Categories" => "Управлять по категории",
"Assign themes to objects" => "Назначить тема к объектам",
"Assigned objects" => "Назначенные объекты",
"Assign themes to sections" => "Назначить темы секциям",
"Assigned sections" => "Назначенные секции",
"The following file was successfully uploaded" => "Файл был успешно закачан",
"You can download this file using" => "Вы можете скачать файл, используя",
"Add File" => "Добавить файл",
"Batch Upload Results" => "Результат пакетной закачки",
"Upload successful!" => "Закачка завершена!",
"The following image was successfully uploaded" => "Следующее изображение было успешно закачено",
"You can include the image in an Wiki page using" => "Ссылка для вставки изображения в Wiki страницах",
"or use filename" => "по имени файла",
"Now enter the image URL" => "Теперь введите URL изображения",
"or upload a local image from your disk" => "или закачайте изображение с Вашего диска",
"Batch Upload" => "Пакетная закачка",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Иконка (необязательная, заменяет автоматическую генерацию иконок)",
"You have to create a gallery first!" => "Сначала надо создать галерею!",
"User assigned modules" => "Назначенные пользователем модули",
"Restore defaults" => "Восстановить умолчания",
"The column is disabled" => "Столбец отключен",
"act" => "акт",
"Assign module" => "Назначить модуль",
"Column" => "Колонка",
"top" => "лучшие",
"Folders" => "Папки",
"Remove Folder" => "удалить папку",
"Refresh Cache" => "обновить кеш",
"Admin folders and bookmarks" => "Управление папками и закладками",
"a folder" => "папку",
"Default view" => "Вид по умолчанию",
"Send me a message" => "Написать письмо",
"Assign Group" => "Назначить группу",
"Change user preferences" => "Изменить предпочтения пользователя",
"(non public)" => "(приватный)",
"Homepage" => "Домашняя страница",
"Users HomePage" => "Пользовательские домашние страницы",
"Personal Wiki Page" => "Персональная Wiki страница",
"Create page" => "Создать страницу",
"The user requested friendship with you" => "Это пользователь хочет с вами дружить",
"Accept friendship from this user" => "Дружить с этим пользователем",
"Refuse friendship from this user" => "Отклонить приглашение в дружбе с этим пользователем",
"Currently waiting for user approval" => "Ожидаем подтверждения пользователя",
"Cancel friendship request towards this user" => "Запрос на отмену дружбы с этим пользователем",
"Request friendship from this user" => "Подружиться с этим пользователем",
"Forum comments" => "Комментарии на форуме",
"Personal Information" => "Личная информация",
"Male" => "Мужчина",
"Female" => "Женщина",
"Use Google Map locator" => "Используйте Google Map locator",
"View extra information" => "Просмотр дополнительной информации",
"Is email public? (uses scrambling to prevent spam)" => "Показывать e-mail? (используется скремблерование для защиты от спама)",
"Unavailable - please set your e-mail below" => "Недоступно - пожалуйста, введите адрес электронной почты ниже",
"Does your mail reader need a special charset" => "Установить специальную кодировку для писем",
"Display info tooltip on mouseover for every user who allows his/her information to be public" => "Отображать публичную информацию пользователя в всплывающем окне при наведении указателя мышки на его имя",
"Notify sender when reading his mail" => "Уведомить автора при прочтении письма",
"My user items" => "Мои пользовательские записи",
"My level" => "Мой уровень",
"Account Information" => "Информация об учетной записи",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Чтобы сохранить старый пароль, остаьте поля \"Новый пароль\" и \"Подтвердите новый пароль\" пустыми",
"Change administrative info" => "Изменение учетной информации",
"New task" => "Новая задача",
"Task list" => "Список задач",
"Admin mode off" => "Выкл.режим администратора",
"Admin mode on" => "Вкл.режим администратора",
"Task help" => "Помощь по задачам",
"Empty Trash" => "Очистить корзину",
"Received task" => "Внешняя задача",
"You received this task, please read and execute it" => "Вы получили эту задачу, пожалуйста, прочтите и выполните ее",
"Send task" => "Отправленная задача",
"You send this task to a other user" => "Вы отправили эту задачу другому пользователю",
"Shared task" => "Общая задача",
"This task is public to a special group" => "Эта задача является общей для специальной группы",
"Accepted by Task User and Creator" => "Принята участником и владельцем",
"Accepted User and Creator" => "Принята участником и владельцем",
"Task is accepted by user and creator" => "Задача принята участником и владельцем",
"Not Accepted by One User" => "Не принята одним из участников",
"Not Accepted User" => "Не принята участником",
"Task is rejected by one user" => "Задача не принята одним из участников",
"Waiting for Me" => "Ожидаем меня",
"Task is not accepted by you, read the task and accept or reject it" => "Задача не принята вами, прочтите и подтвердите или откажите ее",
"Waiting for Other User" => "Ожидаем другого участника",
"Task is not accepted/rejected by other user" => "Задача не принята или отвергнута другим участником",
"Admin Mode" => "Режим администратора",
"Edit task" => "Редактировать задачу",
"NOT accept" => "НЕ принято",
"Remove from Trash" => "Удалить из корзины",
"Move into Trash" => "Переместить в корзину",
"Task saved" => "Задача сохранена",
"Edit Task" => "Редактировать Задачу",
"View Task" => "Просмотр Задачи",
"Open a new task" => "Создать новую задачу",
"taskId" => "Id задачи",
"Task user" => "Участник задачи",
"Only the creator can delete this task" => "Только владелец может удалить эту задачу",
"Use start date and time" => "Установить дату и время начала",
"Use end date and time" => "Установить дату и время окончания",
"Open / In Process" => "Открыта / В процессе",
"Waiting / Not Started" => "Ожидание / Не начата",
"Percentage completed" => "Процент выполнения",
"Shared for Group" => "Общая для группы",
"Accepted by User" => "Принята участником",
"No / Rejected" => "Нет / Отказана",
"Accepted by Creator" => "Принята владельцем",
"This message will be send to users if you are makeing changes of assigned tasks" => "Это сообщение будет отправлено участникам если в задачи будут внесены изменения",
"Send message with changes" => "Отправлять сообщение с изменениями",
"Modified by" => "Изменено",
"Marked as deleted" => "Помечено к удалению",
"Inform task user by email" => "Уведомить участника по эл.почте",
"You can only view this task" => "Вы можете только просмотреть задачу",
"Completed" => "Завершено",
"%m/%d/%Y [%H:%M]" => "%d.%m.%Y [%H:%M]",
"No tasks entered" => "Задачи не определены",
"Select One" => "Сделайте выбор",
"Undo Trash" => "Вернуть из корзины",
"Received" => "Получено",
"Submitted" => "Подтверждено",
"Shared" => "Общее",
"All Shared Tasks" => "Все общие задачи",
"completed (100%)" => "выполнено (100%)",
"Monthly" => "Ежемесячно",
"Add Watch" => "Добавить наблюдение",
"Select event type" => "Тип события",
"All watched events" => "Все события",
"A user submits an article" => "Пользователь помещает статью",
"A user edited an article" => "Редактирование статьи",
"A user deleted an article" => "Удаление статьи",
"A user submits a blog post" => "Новая запись в блоге",
"A user posts a forum thread" => "Новый ответ в форуме",
"A user posts a forum topic" => "Новая тема в форуме",
"A user edited a wiki page" => "Редактирование страницы",
"A user created a wiki page in a language" => "Создание страницы на языке",
"A user edits an article" => "Пользователь редактирует статью",
"A user deletes an article" => "Пользователь удаляет статью",
"up to" => "до",
"no limit for admin" => "без ограничений для администратора",
"May need to refresh twice to see changes" => "Возможно потребуется обновить страницу дважды чтобы увидеть изменения",
"Add top level bookmarks to menu" => "Добавить закладки верхнего уровня в меню",
"Add or edit an item" => "Добавить или редактировать элемент",
"New Window" => "в новом окне",
"replace window" => "заменить окно",
"Pos" => "Позиция",
"User_versions_for" => "Версия_пользователя_для",
"This page is being edited by" => "Эта страница в настоящее время под редакцией",
"Proceed at your own peril" => "Продолжайте на свой страх и риск",
"Insert Row" => "Вставить строку",
"Insert Column" => "Вставить столбец",
"Remove Row" => "Убрать строку",
"Remove Column" => "Убрать столбец",
"Merge Cells" => "Объединить ячейки",
"Restore Cells" => "Восстановить ячейки",
"Copy Calculation" => "Копировать расчет",
"Format Cell" => "Формат ячейки",
"Add an article" => "Добавить статью",
"Banner stats" => "Баннер статистика",
"Create new banner" => "Создать новый баннер",
"Banner Information" => "Баннер информация",
"Click ratio" => "Процент нажатий",
"Hours" => "Часы",
"Weekdays" => "Дни недели",
"mon" => "пн",
"tue" => "вт",
"wed" => "ср",
"thu" => "чт",
"fri" => "пт",
"sat" => "сб",
"sun" => "вс",
"Banner raw data" => "Двоичные данные баннера",
"Cached" => "Кешируется",
"This is a cached version of the page." => "Это кешированная версия страницы.",
"Answers" => "Ответы",
"Add Suggestion" => "Добавить вопрос",
"Forum List" => "Список форумов",
"Edit Forum" => "Правка форума",
"Manage Message Queue" => "Управление очередью сообщений",
"Manage Reported Messages" => "Управление отмеченными сообщениями",
"Monitor Topics of this Forum" => "Следить за темами в этом форуме",
"Stop Monitoring Topics of this Forum" => "Отменить слежение за темами в этом форуме",
"Monitor Topics and Threads of this Forum" => "Следить за темами и обсуждениями в этом форуме",
"Stop Monitoring Topics and Threads of this Forum" => "Отменить слежение за темами и обсуждениями в этом форуме",
"Group Monitor Topics of this Forum" => "Групповое слежение за темами в этом форуме",
"Group Monitor Topics and Threads of this Forum" => "Групповое слежение за темами и обсуждениями в этом форуме",
"Editing" => "Редактирование",
"Post New" => "Создать новую",
"Watch for replies" => "Следить за ответами",
"Send me an e-mail when someone replies to my topic" => "Отправить сообщение по эл.почте",
"Don't send me any e-mails" => "Не отправлять сообщение по эл.почте",
"Editing posts" => "Редактирование ответов",
"for links" => "для ссылок",
"HTML tags are not allowed inside posts" => "HTML-теги не допускаются внутри сообщений",
"Moderator Actions" => "Действия модератора",
"Move Selected Topics" => "Переместить отмеченные темы",
"Unlock Selected Topics" => "Разблокировать отмеченные темы",
"Lock Selected Topics" => "Заблокировать отмеченные темы",
"Delete Selected Topics" => "Удалить отмеченные темы",
"Merge" => "Объединить",
"Merge Selected Topics" => "Объединить отмеченные темы",
"Queued Messages:" => "Сообщений в очереди:",
"Merge into topic" => "Объединить в тему",
"pts" => "очки",
"Announce" => "Объявление",
"Hot" => "Горячая новость",
"Forum Lock" => "Форум заблокирован",
"Unarchive" => "Разархивировать",
"No topics yet" => "Тем пока нет",
"posts in this forum" => "ответов на форуме",
"Filter Posts" => "Отфильтровать ответы",
"Jump to forum" => "Перейти в форум",
"Posts Filtering" => "Фильтр для сообщений",
"Last post date" => "Время",
"All posts" => "Все сообщения",
"Last hour" => "Последний час",
"Last 24 hours" => "Последние 24 часа",
"Last 48 hours" => "Последние 48 часов",
"Show archived posts" => "Показать заархивированные сообщения",
"Containing posts by" => "Автор",
"Me" => "Мои",
"Posts with no replies" => "Сообщения без ответов",
"Archived" => "Архив",
"Topic List" => "Список тем",
"prev topic" => "пред. тема",
"next topic" => "след. тема",
"Print this page only" => "Распечатать только эту страницу",
"Print all pages" => "Распечатать все страницы",
"Show posts" => "Показать сообщения",
"Monitor" => "Наблюдение",
"Stop Monitor" => "Остановить слежение",
"Insert New Item" => "Вставить новый элемент",
"Edit Fields" => "Редактировать поля",
"Tracker Items" => "Элементы Трекера",
"Pending" => "На рассмотрении",
"View inserted item" => "Просмотреть добавленную запись",
"Insert new item" => "Вставить новый элемент",
"View Item" => "Просмотр",
"Add a Comment" => "Добавить комментарий",
"Edit/Delete" => "Редактировать/Удалить",
"Special Operations" => "Специальные операции",
"close" => "закрыть",
"Add a new" => "Добавить новый",
"Show All" => "Показать все",
"Show Unread" => "Показать непрочтённые",
"Show Flagged" => "Показать отмеченные",
"Refresh now" => "Обновить сейчас",
"Back To Mailbox" => "Вернуться в почтовый ящик",
"Full Headers" => "Полные заголовки",
"Normal Headers" => "Обычный вид",
"Reply To All" => "Ответить всем",
"Forward" => "Переслать",
"Cc" => "Копия (СС)",
"Select from address book" => "Выбрать из адр.книги",
"CC" => "Копия (CC)",
"BCC" => "Скрытая копия (BCC)",
"Use HTML mail" => "Использовать HTML почту",
"The following addresses are not in your address book" => "Следующие адреса отсутствуют в вашей адресной книге",
"Add Contacts" => "добавить контакты",
"Attachment 1" => "Приложить файл 1",
"Attachment 2" => "Приложить файл 2",
"Attachment 3" => "Приложить файл 3",
"Address book" => "Адресная книга",
"page id" => "id страницы",
"Fullscreen" => "Во весь экран",
"as Creator &amp; Last Editor" => "как Автор &amp; Последний Редактор",
"no (disabled)" => "нет (отключено)",
"Save Minor Edit" => "Мелочь",
"Save Draft" => "Созранить черновик",
"Administration" => "Администрирование",
"Enable/disable Tiki features here, but configure them elsewhere" => "Здесь только включение / выключение функций Tiki. Настройка производится в других разделах",
"General preferences and settings" => "Общие настройки и предпочтения",
"User registration, login and authentication" => "Регистрация пользователей, настройка параметров входа и метода аутентификации",
"Wiki settings" => "Настройки Wiki",
"Poll comments settings" => "Комментарии в опросах",
"Forums settings" => "Настройки форумов",
"Customize look and feel of your Tiki" => "Настройте внешний вид вашего Tiki",
"Text area" => "Текстовые области",
"Upload failed" => "Закачка не удалась",
"All posted" => "Все опубликованные",
"Queue anonymous posts" => "Анонимные сообщения в очередь",
"Queue all posts" => "Все сообщения в очередь",
"No attachments" => "Нет вложений",
"Everybody can attach" => "Любой может сделать вложение",
"Only users with attach permission" => "Только пользователи с правами вложения",
"Moderators and admin can attach" => "Делать вложения могут модераторы и админы",
"Date (desc)" => "Дата (по убыванию)",
"Date (asc)" => "Дата (asc)",
"Score (desc)" => "Рейтинг (по убыванию)",
"Replies (desc)" => "Ответы (по убыванию)",
"Reads (desc)" => "Прочтено (по убыванию)",
"Owner" => "Владелец",
"Tag already exists" => "Метка уже существует",
"Tag not found" => "Метка не существует",
"Non-existent link" => "Ссылки не существует",
"No menu indicated" => "Меню не указано",
"No newsletter indicated" => "Не указано письмо рассылки",
"A user registers" => "Пользователь регистрируется",
"Any wiki page is changed" => "Изменение любой wiki страницы",
"Any wiki page is changed, even minor changes" => "Любые изменения любой wiki страницы",
"A comment in a wiki page is posted or edited" => "Добавление или изменение комментария на wiki странице",
"PHP error" => "ошибка PHP",
"No poll indicated" => "Опрос не указан",
"Permission denied. You cannot view this page." => "У Вас недостаточно прав для просмотра этой страницы",
"Permission denied you cannot edit this page" => "У Вас недостаточно прав для редактирования данной страницы",
"page not added (Exists)" => "страница не добавлена (Существует)",
"No survey indicated" => "Не указана анкета",
"No tracker indicated" => "Трекер не указан",
"Group already exists" => "Группа уже существует",
"User doesn't exist" => "Пользователь не существует",
"No records were found. Check the file please!" => "Записей не найдено. Проверьте пожалуйста файл!",
"User login is required" => "Логин пользователя обязателен",
"Password is required" => "Пароль обязателен",
"Email is required" => "Эл.адрес обязателен",
"User is duplicated" => "Пользователь скопирован",
"password" => "пароль",
"Unknown group" => "Неизвестная группа",
"Group doesn't exist" => "Группа не существует",
"Permission denied you cannot view backlinks for this page" => "Доступ запрещён. Вы не имеета прав для просмотра обратных ссылок на эту страницу",
"The page cannot be found" => "Страница не найдена",
"It isn't possible to post in any blog. You may need to create a blog first." => "Вы не можете размещать сообщения. Наверное, следует создать хотя бы один блог.",
"Permission denied you cannot post" => "У Вас недостаточно прав для размещения своего сообщения",
"Permission denied you cannot edit this post" => "У Вас недостаточно прав для редактирования данного сообщения",
"Top visited blogs" => "Лучшие блоги",
"Last posts" => "Последние сообщения",
"Top active blogs" => "Последние активные блоги",
"TOP" => "Верхний уровень",
"Permission denied you cannot access this gallery" => "У Вас недостаточно прав для доступа к этой галерее",
"No gallery indicated" => "Галерея не указана",
"Permission denied you can not view this section" => "Доступ закрыт, Вы не можете просматривать эту секцию",
"Permission denied you cannot remove images from this gallery" => "У Вас недостаточно прав для удаления изображений из этой галереи",
"Permission denied you cannot rebuild thumbnails in this gallery" => "У Вас недостаточно прав для перестройки иконок этой галереи",
"Permission denied you cannot rotate images in this gallery" => "У Вас недостаточно прав для прокручивания изображений этой галереи",
"No image indicated" => "Изображение не указано",
"Permission denied you cannot move images from this gallery" => "У Вас недостаточно прав для перемещения изображений из этой галереи",
"Permission denied you cannot view the calendar" => "Доступ закрыт, вы не можете просмотреть календарь",
"You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "Необходимо <a href=\"tiki-admin_calendars.php\">создать календарь</a>",
"event without name" => "событие без имени",
"You can not use the same password again" => "Не следует использовать один и тот же пароль дважды",
"Top authors" => "Лучшие авторы",
"Message sent to" => "Отправлено сообщение для",
"This feature has been disabled" => "Эта возможность была запрещена",
"Must enter a name to add a site" => "Следует ввести название, чтобы добавить сайт",
"Must enter a url to add a site" => "Следует ввести ссылку, чтобы добавить сайт",
"URL already added to the directory. Duplicate site?" => "Ссылка уже добавлена в каталог. Вы вводите дубликат?",
"Must select a category" => "Следует выбрать категорию",
"No site indicated" => "Сайт не указан",
"Article not found" => "Статья не найдена",
"Permission denied you cannot edit this article" => "У Вас недостаточно прав для редактирования этой статьи",
"You do not have permissions to edit banners" => "У Вас недостаточно прав для редактирования баннеров",
"Banner not found" => "Баннер не найден",
"You do not have permission to edit this banner" => "У Вас недостаточно прав для редактирования этого баннера",
"Permission denied you cannot create or edit blogs" => "У Вас недостаточно прав для создания или изменения блогов",
"Permission denied you cannot edit this blog" => "У Вас недостаточно прав для редактирования этого блога",
"You do not have permission to write the style sheet" => "У вас недостаточно прав для записи страницы стилей",
"Invalid request to edit an image" => "Неверный запрос на редактирование изображения",
"Permission denied you cannot edit images" => "У Вас недостаточно прав для редактирования изображений",
"Permission denied you can edit images but not in this gallery" => "У Вас есть права на редактирование изображений, но, увы, не в этой галерее",
"Failed to edit the image" => "Не удалось отредактировать изображение",
"Permission denied to use this feature" => "У Вас недостаточно прав для использования этой возможности",
"Shortname must be 2 Characters" => "Короткое имя должно быть 2 символа",
"You must provide a longname" => "Вы должны указать длинное имя",
"Language created" => "Язык создан",
"No content id indicated" => "Не указан id содержимого",
"No question indicated" => "Вопрос не указан",
"No quiz indicated" => "Тест не указан",
"No structure indicated" => "Структура не указана",
"Permission denied you cannot send submissions" => "У Вас недостаточно прав для отправки новых поступлений",
"Permission denied you cannot edit submissions" => "У Вас недостаточно прав для редактирования поступлений",
"You have to create a topic first" => "Сначала надо создать тему",
"You do not have permission to do that" => "У Вас недостаточно прав для этого действия",
"You do not have permission to read the template" => "У Вас недостаточно прав для чтения шаблона",
"page imported" => "страница импортирована",
"created from import" => "создано импортом",
"The SandBox is disabled" => "Пользование Песочницей запрещено",
"Cannot edit page because it is locked" => "Невозможно редактировать заблокированную страницу",
"Permission denied you cannot edit this file" => "Отказано в доступе, Вы не можете редактировать этот файл",
"Permission denied you cannot remove files from this gallery" => "У Вас недостаточно прав для удаления файлов из галереи",
"No forum indicated" => "Форум не указан",
"Last forum topics" => "Последние темы форума",
"Top topics" => "Лучшие темы",
"Forum posts" => "Число сообщений в форуме",
"first image" => "первая картинка",
"last image" => "последняя картинка",
"Permission denied you cannot create galleries and so you cant edit them" => "У Вас недостаточно прав для создания галерей и Вы не можете редактировать их",
"Permission denied you cannot edit this gallery" => "У Вас недостаточно прав для редактирования этой галереи",
"Permission denied you cannot remove this gallery" => "У Вас недостаточно прав для удаления этой галереи",
"overwriting old page" => "запись поверх старой страницы",
"page created" => "страница создана",
"Permission denied. You cannot view pages like this page" => "У Вас недостаточно прав для просмотра этой страниц, подобных этой",
"Permission denied you cannot remove articles" => "У Вас недостаточно прав для удаления статей",
"Permission denied you cannot remove banners" => "У Вас недостаточно прав для удаления баннеров",
"Permission denied you cannot remove this blog" => "У Вас недостаточно прав для удаления этого блога",
"Non-existent gallery" => "Галерея не существует",
"Permission denied you can upload files but not to this file gallery" => "Вам разрешено закачивать файлы, но, увы, не в эту галерею",
"Permission denied you can't upload files so you can't edit them" => "Отказано в доступе, Вы не можете закачивать файлы, поэтому не можете их редактировать",
"You cannot admin blogs" => "Вы не можете управлять блогами",
"Permission denied you cannot remove submissions" => "У Вас недостаточно прав для удаления поступлений",
"Permission denied you cannot approve submissions" => "У Вас недостаточно прав для приёмки поступивших данных",
"Invalid password" => "Неправильный пароль",
"Account disabled" => "Учетная запись отключена",
"File not found" => "Файл не найден",
"Must be logged to use this feature" => "Вам следует войти под своим логином для использования этой возможности",
"About" => "О нас",
"You must log in to use this feature" => "Следует войти под своим логином для этой возможности",
"You do not have permission to view other users data" => "У Вас недостаточно прав для просмотра данных других пользователей",
"You must be logged in to subscribe to newsletters" => "Для подписки на новости Вам следует войти под Вашими логином и паролем",
"No note indicated" => "Заметка не указана",
"File is too big" => "Файл слишком велик",
"No item indicated" => "Элемент не указан",
"created from notepad" => "создано в блокноте",
"Page already exists" => "Страница уже существует",
"Not enough information to display this page" => "Недостаточно информации для отображения этой страницы",
"Permission denied you cannot browse this page history" => "У Вас недостаточно прав для просмотра истории этой страницы",
"No article indicated" => "Статья не указана",
"Article is not published yet" => "Статья ещё не публиковалась",
"No post indicated" => "Сообщение не указано",
"Blog not found" => "Блог не найден",
"No pages indicated" => "Страницы не указаны",
"No result indicated" => "Результат не указан",
"Invalid or unknown username" => "Неизвестное или неверное имя пользователя",
"A password reminder email has been sent " => "Письмо с паролем было отправлено ",
"to the registered email address for" => "на зарегистрированный e-mail адрес для",
"Permission denied you cannot remove versions from this page" => "У Вас недостаточно прав для удаления версий этой страницы",
"Cannot rename page maybe new page already exists" => "Не удаётся переименовать страницу, возможно, новая странице уже существует",
"Non-existent version" => "Версия не существует",
"Permission denied you cannot rollback this page" => "У Вас недостаточно прав для отката изменений этой страницы",
"successfully sent" => "успешно отправлено",
"not sent" => "не отправлено",
"Page must be defined inside a structure to use this feature" => "Страница должна быть внутри структуры для использования этой возможности",
"Clean the sql logs" => "Очистка протоколов SQL запросов",
"You cannot take this quiz twice" => "Вы не можете пройти этот тест дважды",
"Quiz time limit exceeded quiz cannot be computed" => "Время прохождения теста истекло. Результаты рассчитываться не будут.",
"You cannot take this survey twice" => "Нельзя пройти этот опрос дважды",
"Please create a category first" => "Сначала надо создать категорию",
"No permission to upload zipped file packages" => "Нет прав для закачки zip пакетов с файлами",
"Error processing zipped image package" => "Ошибка обработки zip пакета изображений",
"No permission to upload zipped image packages" => "Нет прав для закачки zip пакетов с изображениями",
"Permission denied you cannot upload images" => "У Вас недостаточно прав для загрузки изображений",
"Permission denied you can upload images but not to this gallery" => "У Вас есть права на загрузку изображений, но, увы, не в эту галерею",
"Cannot get image from URL" => "Не получается извлечь изображение по указанному URL",
"No url indicated" => "URL не указан",
"Unknown user" => "Неизвестный пользователь",
"You are not logged in and no user indicated" => "Вы не вошли под своим логином, пользователь не указан",
"The user has chosen to make his information private" => "Пользователь пожелал оставить свои данные личными",
"The passwords did not match" => "Пароли не совпали",
"no" => "нет",
"was moved into trash" => "был(а) направлен(а) в корзину",
"trashed by" => "удалено",
"Public for group" => "Общая для группы",
"Task accepted by creator" => "Задача принята владельцем",
"Task accepted by task user" => "Задача принята участником",
"Task NOT accepted by creator" => "Задача НЕ принята владельцем",
"Task NOT accepted by task user" => "Задача НЕ принята участником",
"Sorry this task does not exist or you have no rights to view this task" => "Такой задачи не существует или у вас нет прав на участие в ней",
"Info message" => "Информационное сообщение",
"NEW Task" => "Новая задача",
"Changes on Task" => "Изменения в задаче",
"You received a new task" => "Вам поручили новую задачу",
"The priority is" => "Приоритет",
"very low" => "минимальный",
"low" => "низкий",
"high" => "высокий",
"very high" => "максимальный",
"You've to start your work at least on" => "Начало работ по задаче не позднее",
"You've to finish your work on" => "Окончание работ по задаче не позже",
"Login and click the link below" => "Войдите в систему и нажмите на ссылку",
"Sorry, there was an error while trying to write data into the database" => "Внимание, произошла ошибка при попытке записи в базу данных",
"A new page is created in a language" => "Создание перевода для страницы",
"Cannot upload this file not enough quota" => "Невозможно загрузить файл - превышена квота",
"No user indicated" => "Пользователь не указан",
"Non-existent user" => "Пользователь не существует",
"No banner indicated" => "Баннер не указан",
"No blog indicated" => "Блог не указан",
"Permission denied you cannot remove the post" => "У Вас недостаточно прав для удаления сообщения",
"No cache information available" => "Информация в кеше отсутствует",
"No faq indicated" => "ЧаВо не указан",
"No thread indicated" => "Ветка обсуждения не указана",
"Aborted" => "Отменённые",
"Top pages" => "Лучшие страницы",
"Last pages" => "Последние страницы",
"The page is empty" => "Страница пустая",
"###end###"=>"###end###");
